<div align="center">
    <picture>
        <source media="(prefers-color-scheme: dark)" srcset="https://github.com/JuliaManifolds/Manifolds.jl/raw/master/docs/src/assets/logo-text-readme-dark.png">
      <img alt="Manifolds.jl logo with text on the side" src="https://github.com/JuliaManifolds/Manifolds.jl/raw/master/docs/src/assets/logo-text-readme.png">
    </picture>
</div>

| **Documentation** | **Source** | **Citation** |
|:-----------------:|:----------------------:|:------------:|
| [![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliamanifolds.github.io/Manifolds.jl/stable/) | [![code style: runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl) | [![arXiv](https://img.shields.io/badge/arXiv%20CS.MS-2106.08777-blue.svg)](https://arxiv.org/abs/2106.08777) |
| [![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliamanifolds.github.io/Manifolds.jl/latest/) | [![CI](https://github.com/JuliaManifolds/Manifolds.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaManifolds/Manifolds.jl/actions?query=workflow%3ACI+branch%3Amaster) | [![DOI](https://zenodo.org/badge/190447542.svg)](https://zenodo.org/badge/latestdoi/190447542) |
| | [![codecov](https://codecov.io/gh/JuliaManifolds/Manifolds.jl/graph/badge.svg?token=yQYUnjAZZN)](https://codecov.io/gh/JuliaManifolds/Manifolds.jl) |

Package __Manifolds.jl__ aims to provide both a unified interface to define and
use manifolds as well as a library of manifolds to use for your projects.
This package is mostly stable, see https://github.com/JuliaManifolds/Manifolds.jl/issues/438 for planned upcoming changes.

## Getting started

To install the package just type

```julia
using Pkg; Pkg.add("Manifolds")
```

Then you can directly start, for example to stop half way from the north pole on the [`Sphere`](https://juliamanifolds.github.io/Manifolds.jl/stable/manifolds/sphere.html) to a point on the equator, you can generate the [`shortest_geodesic`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#ManifoldsBase.shortest_geodesic-Tuple{AbstractManifold,%20Any,%20Any}).
It internally employs [`exp`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#Base.exp-Tuple{AbstractManifold,%20Any,%20Any}) and [`log`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#Base.log-Tuple{AbstractManifold,%20Any,%20Any}).

```julia
using Manifolds
M = Sphere(2)
γ = shortest_geodesic(M, [0., 0., 1.], [0., 1., 0.])
γ(0.5)
```

## Ecosystem highlights

* A wide selection of Riemannian manifolds like spheres, hyperbolic spaces, Stiefel and Grassmann manifolds.
* Support for optimization on manifolds using [Manopt.jl](https://github.com/JuliaManifolds/Manopt.jl/).
* Support for many operations used in optimization and manifold-valued statistics with a focus on performance and ease of use.
* Connection manifolds.
* Lie groups.
* Atlases, charts and custom metrics (work in progress).
* A lightweight interface package: [ManifoldsBase.jl](https://github.com/JuliaManifolds/ManifoldsBase.jl).
* Differential equations on manifolds: [ManifoldDiffEq.jl](https://github.com/JuliaManifolds/ManifoldDiffEq.jl).
* Finite differences and automatic differentiation on manifolds using [ManifoldDiff.jl](https://github.com/JuliaManifolds/ManifoldDiff.jl) (work in progress).
* Integration and measures on manifolds: [ManifoldMeasures.jl](https://github.com/JuliaManifolds/ManifoldMeasures.jl) (work in progress).
* Functional manifolds: [FunManifolds.jl](https://github.com/JuliaManifolds/FunManifolds.jl) (work in progress).

## Support

If you have any questions regarding the Manifolds.jl ecosystem feel free to reach us using [Github discussion forums](https://github.com/JuliaManifolds/Manifolds.jl/discussions), [Julia Slack](https://julialang.org/slack/), [Julia Zulip](https://julialang.zulipchat.com/) or [Julia discourse](https://discourse.julialang.org/) forums. We are interested in new applications and methods on manifolds -- sharing your work is welcome!

## Citation

If you use `Manifolds.jl` in your work, please cite the following open access article

```biblatex
@article{AxenBaranBergmannRzecki:2023,
    AUTHOR    = {Axen, Seth D. and Baran, Mateusz and Bergmann, Ronny and Rzecki, Krzysztof},
    ARTICLENO = {33},
    DOI       = {10.1145/3618296},
    JOURNAL   = {ACM Transactions on Mathematical Software},
    MONTH     = {dec},
    NUMBER    = {4},
    TITLE     = {Manifolds.Jl: An Extensible Julia Framework for Data Analysis on Manifolds},
    VOLUME    = {49},
    YEAR      = {2023}
}
```

To refer to a certain version we recommend to also cite for example

```biblatex
@software{manifoldsjl-zenodo-mostrecent,
  Author = {Seth D. Axen and Mateusz Baran and Ronny Bergmann},
  Title = {Manifolds.jl},
  Doi = {10.5281/ZENODO.4292129},
  Url = {https://zenodo.org/record/4292129},
  Publisher = {Zenodo},
  Year = {2021},
  Copyright = {MIT License}
}
```

for the most recent version or a corresponding version specific DOI, see [the list of all versions](https://zenodo.org/search?page=1&size=20&q=conceptrecid:%224292129%22&sort=-version&all_versions=True).
Note that both citations are in [BibLaTeX](https://ctan.org/pkg/biblatex) format.

using Manifolds
using ManifoldsBase
using BenchmarkTools
using StaticArrays
using HybridArrays
using LinearAlgebra
using Random

# Define a parent BenchmarkGroup to contain our suite
SUITE = BenchmarkGroup()

Random.seed!(12334)

function add_manifold(
        M::AbstractManifold,
        pts,
        name;
        test_tangent_vector_broadcasting = true,
        retraction_methods = [],
        inverse_retraction_methods = [],
        point_distributions = [],
        tvector_distributions = [],
    )
    SUITE["manifolds"][name] = BenchmarkGroup()
    tv = log(M, pts[1], pts[2])
    tv1 = log(M, pts[1], pts[2])
    tv2 = log(M, pts[1], pts[3])
    p = similar(pts[1])
    SUITE["manifolds"][name]["similar"] = @benchmarkable similar($(pts[1]))
    SUITE["manifolds"][name]["log"] = @benchmarkable log($M, $(pts[1]), $(pts[2]))
    SUITE["manifolds"][name]["log!"] = @benchmarkable log!($M, $tv, $(pts[1]), $(pts[2]))
    for iretr in inverse_retraction_methods
        SUITE["manifolds"][name]["inverse_retract: " * string(iretr)] =
            @benchmarkable inverse_retract($M, $(pts[1]), $(pts[2]), $iretr)
        SUITE["manifolds"][name]["inverse_retract!: " * string(iretr)] =
            @benchmarkable inverse_retract!($M, $tv, $(pts[1]), $(pts[2]), $iretr)
    end
    SUITE["manifolds"][name]["exp"] = @benchmarkable exp($M, $(pts[1]), $tv1)
    SUITE["manifolds"][name]["exp!"] = @benchmarkable exp!($M, $p, $(pts[1]), $tv1)
    for retr in retraction_methods
        SUITE["manifolds"][name]["retract: " * string(retr)] =
            @benchmarkable retract($M, $(pts[1]), $tv1, $retr)
        SUITE["manifolds"][name]["retract!: " * string(retr)] =
            @benchmarkable retract!($M, $p, $(pts[1]), $tv1, $retr)
    end
    SUITE["manifolds"][name]["norm"] = @benchmarkable norm($M, $(pts[1]), $tv1)
    SUITE["manifolds"][name]["inner"] = @benchmarkable inner($M, $(pts[1]), $tv1, $tv2)
    SUITE["manifolds"][name]["distance"] = @benchmarkable distance($M, $(pts[1]), $(pts[2]))
    SUITE["manifolds"][name]["isapprox (pt)"] =
        @benchmarkable isapprox($M, $(pts[1]), $(pts[2]))
    SUITE["manifolds"][name]["isapprox (tv)"] =
        @benchmarkable isapprox($M, $(pts[1]), $tv1, $tv2)
    SUITE["manifolds"][name]["2 * tv1 + 3 * tv2"] = @benchmarkable 2 * $tv1 + 3 * $tv2
    SUITE["manifolds"][name]["tv = 2 * tv1 + 3 * tv2"] =
        @benchmarkable $tv = 2 * $tv1 + 3 * $tv2
    if test_tangent_vector_broadcasting
        SUITE["manifolds"][name]["tv = 2 .* tv1 .+ 3 .* tv2"] =
            @benchmarkable $tv = 2 .* $tv1 .+ 3 .* $tv2
        SUITE["manifolds"][name]["tv .= 2 .* tv1 .+ 3 .* tv2"] =
            @benchmarkable $tv .= 2 .* $tv1 .+ 3 .* $tv2
    end
    for pd in point_distributions
        distr_name = string(pd)
        distr_name = distr_name[1:min(length(distr_name), 50)]
        SUITE["manifolds"][name]["point distribution " * distr_name] =
            @benchmarkable rand($pd)
    end
    for tvd in point_distributions
        distr_name = string(tvd)
        distr_name = distr_name[1:min(length(distr_name), 50)]
        SUITE["manifolds"][name]["tangent vector distribution " * distr_name] =
            @benchmarkable rand($tvd)
    end
    return nothing
end

# General manifold benchmarks
function add_manifold_benchmarks()
    SUITE["manifolds"] = BenchmarkGroup()

    s2 = Manifolds.Sphere(2)
    array_s2 = ValidationManifold(s2)
    r2 = Manifolds.Euclidean(2)

    pts_r2 = [Size(2)([1.0, 1.0]), Size(2)([-2.0, 3.0]), Size(2)([3.0, -2.0])]

    add_manifold(r2, pts_r2, "Euclidean{2} -- SizedArray")

    add_manifold(
        r2,
        [
            MVector{2, Float64}([1.0, 1.0]),
            MVector{2, Float64}([-2.0, 3.0]),
            MVector{2, Float64}([3.0, -2.0]),
        ],
        "Euclidean{2} -- MVector",
    )

    ud_sphere = Manifolds.uniform_distribution(s2, Size(3)([1.0, 0.0, 0.0]))
    gtd_sphere = Manifolds.normal_tvector_distribution(s2, Size(3)([1.0, 0.0, 0.0]), 1.0)

    pts_s2 = [Size(3)([1.0, 0.0, 0.0]), Size(3)([0.0, 1.0, 0.0]), Size(3)([0.0, 0.0, 1.0])]

    add_manifold(
        s2,
        pts_s2,
        "Sphere{2} -- SizedArray";
        point_distributions = [ud_sphere],
        tvector_distributions = [gtd_sphere],
    )

    add_manifold(
        array_s2,
        [Size(3)([1.0, 0.0, 0.0]), Size(3)([0.0, 1.0, 0.0]), Size(3)([0.0, 0.0, 1.0])],
        "ValidationManifold{Sphere{2}} -- SizedArray";
        test_tangent_vector_broadcasting = false,
    )

    retraction_methods_rot = [Manifolds.PolarRetraction(), Manifolds.QRRetraction()]

    inverse_retraction_methods_rot =
        [Manifolds.PolarInverseRetraction(), Manifolds.QRInverseRetraction()]

    so2 = Manifolds.Rotations(2)
    angles = (0.0, π / 2, 2π / 3)
    add_manifold(
        so2,
        [Size(2, 2)([cos(ϕ) -sin(ϕ); sin(ϕ) cos(ϕ)]) for ϕ in angles],
        "Rotations(2) -- SizedArray",
        retraction_methods = retraction_methods_rot,
        inverse_retraction_methods = inverse_retraction_methods_rot,
    )

    so3 = Manifolds.Rotations(3)
    angles = (0.0, π / 2, 2π / 3)
    add_manifold(
        so3,
        [Size(3, 3)([cos(ϕ) -sin(ϕ) 0; sin(ϕ) cos(ϕ) 0; 0 0 1]) for ϕ in angles],
        "Rotations(3) -- SizedArray",
        retraction_methods = retraction_methods_rot,
        inverse_retraction_methods = inverse_retraction_methods_rot,
    )

    pts_prod_mpoints = [ArrayPartition(p[1], p[2]) for p in zip(pts_s2, pts_r2)]
    add_manifold(
        m_prod,
        pts_prod_mpoints,
        "ProductManifold with AbstractManifoldPoint";
        test_tangent_vector_broadcasting = false,
    )

    # vector spaces and bundles
    begin
        T = MVector{3, Float64}
        TB = TangentBundle(s2)

        pts_tb = [
            ArrayPartition(convert(T, [1.0, 0.0, 0.0]), convert(T, [0.0, -1.0, -1.0])),
            ArrayPartition(convert(T, [0.0, 1.0, 0.0]), convert(T, [2.0, 0.0, 1.0])),
            ArrayPartition(convert(T, [1.0, 0.0, 0.0]), convert(T, [0.0, 2.0, -1.0])),
        ]
        add_manifold(
            TB,
            pts_tb,
            "Tangent bundle of S² using MVectors, ArrayPartition";
            test_tangent_vector_broadcasting = false,
        )
    end

    # power manifolds
    begin
        Ms = Sphere(2)
        Ms1 = PowerManifold(Ms, 5)
        Ms2 = PowerManifold(Ms, 5, 7)
        Mr = Manifolds.Rotations(3)
        Mr1 = PowerManifold(Mr, 5)
        Mr2 = PowerManifold(Mr, 5, 7)

        types_s1 =
            (Array{Float64, 2}, HybridArray{Tuple{3, StaticArrays.Dynamic()}, Float64, 2})
        types_s2 = (
            Array{Float64, 3},
            HybridArray{Tuple{3, StaticArrays.Dynamic(), StaticArrays.Dynamic()}, Float64, 3},
        )

        types_r1 =
            (Array{Float64, 3}, HybridArray{Tuple{3, 3, StaticArrays.Dynamic()}, Float64, 3})
        types_r2 = (
            Array{Float64, 4},
            HybridArray{Tuple{3, 3, StaticArrays.Dynamic(), StaticArrays.Dynamic()}, Float64, 4},
        )

        retraction_methods =
            [Manifolds.PowerRetraction(ManifoldsBase.ExponentialRetraction())]
        inverse_retraction_methods =
            [Manifolds.InversePowerRetraction(ManifoldsBase.LogarithmicInverseRetraction())]

        sphere_dist = Manifolds.uniform_distribution(Ms, @SVector [1.0, 0.0, 0.0])
        power_s1_pt_dist =
            Manifolds.PowerPointDistribution(Ms1, sphere_dist, randn(Float64, 3, 5))
        power_s2_pt_dist =
            Manifolds.PowerPointDistribution(Ms2, sphere_dist, randn(Float64, 3, 5, 7))
        sphere_tv_dist =
            Manifolds.normal_tvector_distribution(Ms, (@MVector [1.0, 0.0, 0.0]), 1.0)
        power_s1_tv_dist = Manifolds.PowerFVectorDistribution(
            TangentSpace(Ms1, rand(power_s1_pt_dist)),
            sphere_tv_dist,
        )
        power_s2_tv_dist = Manifolds.PowerFVectorDistribution(
            TangentSpace(Ms2, rand(power_s2_pt_dist)),
            sphere_tv_dist,
        )

        id_rot = @SMatrix [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
        rotations_dist = Manifolds.normal_rotation_distribution(Mr, id_rot, 1.0)
        power_r1_pt_dist =
            Manifolds.PowerPointDistribution(Mr1, rotations_dist, randn(Float64, 3, 3, 5))
        power_r2_pt_dist = Manifolds.PowerPointDistribution(
            Mr2,
            rotations_dist,
            randn(Float64, 3, 3, 5, 7),
        )
        rotations_tv_dist = Manifolds.normal_tvector_distribution(Mr, MMatrix(id_rot), 1.0)
        power_r1_tv_dist = Manifolds.PowerFVectorDistribution(
            TangentSpace(Mr1, rand(power_r1_pt_dist)),
            rotations_tv_dist,
        )
        power_r2_tv_dist = Manifolds.PowerFVectorDistribution(
            TangentSpace(Mr2, rand(power_r2_pt_dist)),
            rotations_tv_dist,
        )

        trim(s::String) = s[1:min(length(s), 20)]

        for T in types_s1
            pts1 = [convert(T, rand(power_s1_pt_dist)) for _ in 1:3]
            add_manifold(
                Ms1,
                pts1,
                "power manifold S²^(5,), type $(trim(string(T)))";
                test_tangent_vector_broadcasting = true,
            )
        end
        for T in types_s2
            pts2 = [convert(T, rand(power_s2_pt_dist)) for _ in 1:3]
            add_manifold(
                Ms2,
                pts2,
                "power manifold S²^(5,7), type $(trim(string(T)))";
                test_tangent_vector_broadcasting = true,
            )
        end

        for T in types_r1
            pts1 = [convert(T, rand(power_r1_pt_dist)) for _ in 1:3]
            add_manifold(
                Mr1,
                pts1,
                "power manifold SO(3)^(5,), type $(trim(string(T)))";
                test_tangent_vector_broadcasting = true,
            )
        end
        for T in types_r2
            pts2 = [convert(T, rand(power_r2_pt_dist)) for _ in 1:3]
            add_manifold(
                Mr2,
                pts2,
                "power manifold SO(3)^(5,7), type $(trim(string(T)))";
                test_tangent_vector_broadcasting = true,
            )
        end

        types_spd = [Matrix{Float64}]
        TEST_STATIC_SIZED && push!(types_spd, MMatrix{3, 3, Float64, 9})

        A(α) = [1.0 0.0 0.0; 0.0 cos(α) sin(α); 0.0 -sin(α) cos(α)]
        pts_spd = [#
            [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1],
            [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1],
            A(π / 6) * [1.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1] * transpose(A(π / 6)),
        ]

        M_spd_1 = Manifolds.SymmetricPositiveDefinite(3)
        M_spd_2 = MetricManifold(
            Manifolds.SymmetricPositiveDefinite(3),
            Manifolds.AffineInvariantMetric(),
        )
        M_spd_3 = MetricManifold(
            Manifolds.SymmetricPositiveDefinite(3),
            Manifolds.LogCholeskyMetric(),
        )

        for T in types_spd
            pts = [convert(T, a) for a in pts_spd]
            for M in (M_spd_1, M_spd_2, M_spd_3)
                add_manifold(
                    M,
                    pts,
                    "SPD manifold $(trim(string(M))), type $(trim(string(T)))";
                    test_tangent_vector_broadcasting = true,
                )
            end
        end
    end
    return nothing
end

add_manifold_benchmarks()

@doc raw"""
    AbstractMultinomialDoublyStochastic <: AbstractDecoratorManifold{ℝ}

A common type for manifolds that are doubly stochastic, for example by direct constraint
[`MultinomialDoubleStochastic`](@ref) or by symmetry [`MultinomialSymmetric`](@ref),
or additionally by symmetric positive definiteness [`MultinomialSymmetricPositiveDefinite`](@ref)
as long as they are also modeled as [`IsometricallyEmbeddedManifoldType`](@extref `ManifoldsBase.IsometricallyEmbeddedManifoldType`).

That way they share the inner product (just by restriction), and even the Riemannian gradient
"""
abstract type AbstractMultinomialDoublyStochastic <: AbstractDecoratorManifold{ℝ} end

@doc raw"""
    representation_size(M::AbstractMultinomialDoublyStochastic)

return the representation size of doubly stochastic matrices, which are embedded
in the ``ℝ^{n×n}`` matrices and hence the answer here is ``
"""
function representation_size(M::AbstractMultinomialDoublyStochastic)
    n = get_parameter(M.size)[1]
    return (n, n)
end

@doc raw"""
    riemannian_gradient(M::AbstractMultinomialDoublyStochastic, p, Y; kwargs...)

Let ``Y`` denote the Euclidean gradient of a function ``\tilde f`` defined in the
embedding neighborhood of `M`, then the Riemannian gradient is given by
Lemma 1 [DouikHassibi:2019](@cite) as

```math
  \operatorname{grad} f(p) = \proj_{T_p\mathcal M}(Y⊙p)
```

where ``⊙`` denotes the Hadamard or elementwise product, and the projection
is the projection onto the tangent space of the corresponding manifold.

"""
riemannian_gradient(M::AbstractMultinomialDoublyStochastic, p, Y; kwargs...)

function riemannian_gradient!(M::AbstractMultinomialDoublyStochastic, X, p, Y; kwargs...)
    X .= p .* Y
    project!(M, X, p, X)
    return X
end

@doc raw"""
    MultinomialDoublyStochastic{T} <: AbstractMultinomialDoublyStochastic

The set of doubly stochastic multinomial matrices consists of all ``n×n`` matrices with
stochastic columns and rows, i.e.

````math
\begin{aligned}
\mathcal{DP}(n) \coloneqq \bigl\{p ∈ ℝ^{n×n}\ \big|\ &p_{i,j} > 0 \text{ for all } i=1,…,n, j=1,…,m,\\
& p\mathbf{1}_n = p^{\mathrm{T}}\mathbf{1}_n = \mathbf{1}_n
\bigr\},
\end{aligned}
````

where ``\mathbf{1}_n`` is the vector of length ``n`` containing ones.

The tangent space can be written as

````math
T_p\mathcal{DP}(n) \coloneqq \bigl\{
X ∈ ℝ^{n×n}\ \big|\ X = X^{\mathrm{T}} \text{ and }
X\mathbf{1}_n = X^{\mathrm{T}}\mathbf{1}_n = \mathbf{0}_n
\bigr\},
````

where ``\mathbf{0}_n`` is the vector of length ``n`` containing zeros.

More details can be found in Section III [DouikHassibi:2019](@cite).

# Constructor

    MultinomialDoubleStochastic(n::Int; parameter::Symbol=:type)

Generate the manifold of matrices ``ℝ^{n×n}`` that are doubly stochastic and symmetric.
"""
struct MultinomialDoubleStochastic{T} <: AbstractMultinomialDoublyStochastic
    size::T
end

function MultinomialDoubleStochastic(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return MultinomialDoubleStochastic{typeof(size)}(size)
end

@doc raw"""
    check_point(M::MultinomialDoubleStochastic, p)

Checks whether `p` is a valid point on the [`MultinomialDoubleStochastic`](@ref)`(n)` `M`,
i.e. is a  matrix with positive entries whose rows and columns sum to one.
"""
function check_point(M::MultinomialDoubleStochastic, p; kwargs...)
    n = get_parameter(M.size)[1]
    s = check_point(MultinomialMatrices(n, n), p; kwargs...)
    !isnothing(s) && return s
    s2 = check_point(MultinomialMatrices(n, n), p'; kwargs...)
    return s2
end

@doc raw"""
    check_vector(M::MultinomialDoubleStochastic p, X; kwargs...)

Checks whether `X` is a valid tangent vector to `p` on the [`MultinomialDoubleStochastic`](@ref) `M`.
This means, that `p` is valid, that `X` is of correct dimension and sums to zero along any
column or row.
"""
function check_vector(M::MultinomialDoubleStochastic, p, X; kwargs...)
    n = get_parameter(M.size)[1]
    s = check_vector(MultinomialMatrices(n, n), p, X; kwargs...)
    !isnothing(s) && return s
    s2 = check_vector(MultinomialMatrices(n, n), p, X'; kwargs...)
    return s2
end

function get_embedding(::MultinomialDoubleStochastic{TypeParameter{Tuple{n}}}) where {n}
    return MultinomialMatrices(n, n)
end
function get_embedding(M::MultinomialDoubleStochastic{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return MultinomialMatrices(n, n; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::MultinomialDoubleStochastic)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

"""
    is_flat(::MultinomialDoubleStochastic)

Return false. [`MultinomialDoubleStochastic`](@ref) is not a flat manifold.
"""
is_flat(M::MultinomialDoubleStochastic) = false

@doc raw"""
    manifold_dimension(M::MultinomialDoubleStochastic)

returns the dimension of the [`MultinomialDoubleStochastic`](@ref) manifold
namely
````math
\operatorname{dim}_{\mathcal{DP}(n)} = (n-1)^2.
````
"""
function manifold_dimension(M::MultinomialDoubleStochastic)
    n = get_parameter(M.size)[1]
    return (n - 1)^2
end

@doc raw"""
    project(M::MultinomialDoubleStochastic, p, Y)

Project `Y` onto the tangent space at `p` on the [`MultinomialDoubleStochastic`](@ref) `M`, return the result in `X`.
The formula reads

````math
    \operatorname{proj}_p(Y) = Y - (α\mathbf{1}_n^{\mathrm{T}} + \mathbf{1}_nβ^{\mathrm{T}}) ⊙ p,
````

where ``⊙`` denotes the Hadamard or elementwise product and ``\mathbb{1}_n`` is the vector of length ``n`` containing ones.
The two vectors ``α,β ∈ ℝ^{n×n}`` are computed as a solution (typically using the left pseudo inverse) of

````math
    \begin{pmatrix} I_n & p\\p^{\mathrm{T}} & I_n \end{pmatrix}
    \begin{pmatrix} α\\ β\end{pmatrix}
    =
    \begin{pmatrix} Y\mathbf{1}\\Y^{\mathrm{T}}\mathbf{1}\end{pmatrix},
````
where ``I_n`` is the ``n×n`` unit matrix and ``\mathbf{1}_n`` is the vector of length ``n`` containing ones.

"""
project(::MultinomialDoubleStochastic, ::Any, ::Any)

function project!(M::MultinomialDoubleStochastic, X, p, Y)
    n = get_parameter(M.size)[1]
    ζ = [I p; p' I] \ [sum(Y, dims = 2); sum(Y, dims = 1)'] # Formula (25) from 1802.02628
    return X .= Y .- (repeat(ζ[1:n], 1, n) .+ repeat(ζ[(n + 1):end]', n, 1)) .* p
end

@doc raw"""
    project(
        M::AbstractMultinomialDoublyStochastic,
        p;
        maxiter = 100,
        tolerance = eps(eltype(p))
    )

project a matrix `p` with positive entries applying Sinkhorn's algorithm.
Note that this project method – different from the usual case, accepts keywords.
"""
function project(M::AbstractMultinomialDoublyStochastic, p; kwargs...)
    q = allocate_result(M, project, p)
    project!(M, q, p; kwargs...)
    return q
end

function project!(
        ::AbstractMultinomialDoublyStochastic,
        q,
        p;
        maxiter::Int = 100,
        tolerance::Real = eps(eltype(p)),
    )
    any(p .<= 0) && throw(
        DomainError(
            "The matrix $p can not be projected, since it has nonpositive entries.",
        ),
    )
    iter = 0
    d1 = sum(p, dims = 1)
    d2 = 1 ./ (p * d1')
    row = d2' * p
    gap = 2 * tolerance
    while iter < maxiter && (gap >= tolerance)
        iter += 1
        row .= d2' * p
        gap = maximum(abs.(row .* d1 .- 1))
        d1 .= 1 ./ row
        d2 .= 1 ./ (p * d1')
    end
    q .= p .* (d2 * d1)
    return q
end

@doc raw"""
    rand(::MultinomialDoubleStochastic; vector_at=nothing, σ::Real=1.0, kwargs...)

Generate random points on the [`MultinomialDoubleStochastic`](@ref) manifold
or tangent vectors at the point `vector_at` if that is not `nothing`.

Let ``n×n`` denote the matrix dimension of the [`MultinomialDoubleStochastic`](@ref).

When `vector_at` is nothing, this is done by generating a random matrix`rand(n,n)`
with positive entries and projecting it onto the manifold. The `kwargs...` are
passed to this projection.

When `vector_at` is not `nothing`, a random matrix in the ambient space is generated
and projected onto the tangent space
"""
rand(::MultinomialDoubleStochastic; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::MultinomialDoubleStochastic,
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
        kwargs...,
    )
    rand!(rng, pX)
    pX .*= σ
    if vector_at === nothing
        project!(M, pX, pX; kwargs...)
    else
        project!(M, pX, vector_at, pX)
    end
    return pX
end

@doc raw"""
    retract(M::MultinomialDoubleStochastic, p, X, ::ProjectionRetraction)

compute a projection based retraction by projecting ``p\odot\exp(X⨸p)`` back onto the manifold,
where ``⊙,⨸`` are elementwise multiplication and division, respectively. Similarly, ``\exp``
refers to the elementwise exponentiation.
"""
retract(::MultinomialDoubleStochastic, ::Any, ::Any, ::ProjectionRetraction)

function ManifoldsBase.retract_project!(M::MultinomialDoubleStochastic, q, p, X)
    return project!(M, q, p .* exp.(X ./ p))
end
function ManifoldsBase.retract_project_fused!(
        M::MultinomialDoubleStochastic,
        q,
        p,
        X,
        t::Number,
    )
    return project!(M, q, p .* exp.(t .* X ./ p))
end

function Base.show(io::IO, ::MultinomialDoubleStochastic{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "MultinomialDoubleStochastic($(n))")
end
function Base.show(io::IO, M::MultinomialDoubleStochastic{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "MultinomialDoubleStochastic($(n); parameter=:field)")
end

include("../header.jl")

@testset "Graph AbstractManifold" begin
    M = Euclidean(2)
    x = [[1.0, 4.0], [2.0, 5.0], [3.0, 6.0]]
    y = [[4.0, 5.0], [6.0, 7.0], [8.0, 9.0]]
    z = [[6.0, 5.0], [4.0, 3.0], [2.0, 8.0]]
    @testset "Plain Graph" begin
        G = SimpleGraph(3)
        add_edge!(G, 1, 2)
        add_edge!(G, 2, 3)
        N = GraphManifold(G, M, VertexManifold())
        @test manifold_dimension(N) == manifold_dimension(M) * nv(G)
        @test manifold_dimension(GraphManifold(G, M, EdgeManifold())) ==
            manifold_dimension(M) * ne(G)
        @test is_point(N, x)
        @test !is_point(N, [x..., [0.0, 0.0]]) # an entry too much
        @test_throws DomainError is_point(N, [x..., [0.0, 0.0]]; error = :error)
        @test is_vector(N, x, log(N, x, y))
        @test !is_vector(N, x[1:2], log(N, x, y))
        @test_throws DomainError is_vector(N, x[1:2], log(N, x, y); error = :error)
        @test !is_vector(N, x[1:2], log(N, x, y)[1:2])
        @test_throws DomainError is_vector(N, x, log(N, x, y)[1:2]; error = :error)
        @test incident_log(N, x) == [x[2] - x[1], x[1] - x[2] + x[3] - x[2], x[2] - x[3]]

        pts = [x, y, z]
        Manifolds.test_manifold(N, pts; test_representation_size = false)
        @test sprint(show, "text/plain", N) == """
            GraphManifold
            Graph:
             {3, 2} undirected simple Int64 graph
            AbstractManifold on vertices:
             Euclidean(2; field=ℝ)"""

        NE = GraphManifold(G, M, EdgeManifold())
        @test is_point(NE, x[1:2])
        @test !is_point(NE, x) # an entry too much
        @test_throws DomainError is_point(NE, x; error = :error)
        @test is_vector(NE, x[1:2], log(N, x, y)[1:2])
        @test !is_vector(NE, x, log(N, x, y))
        @test_throws DomainError is_vector(NE, x, log(N, x, y); error = :error)
        @test !is_vector(N, x[1:2], log(N, x, y))
        @test_throws DomainError is_vector(NE, x[1:2], log(N, x, y); error = :error)

        Manifolds.test_manifold(
            NE,
            [x[1:2], y[1:2], z[1:2]];
            test_representation_size = false,
            test_inplace = true,
        )
        @test sprint(show, "text/plain", NE) == """
            GraphManifold
            Graph:
             {3, 2} undirected simple Int64 graph
            AbstractManifold on edges:
             Euclidean(2; field=ℝ)"""

        G2 = SimpleDiGraph(3)
        add_edge!(G2, 1, 2)
        add_edge!(G2, 2, 3)
        N2 = GraphManifold(G2, M, VertexManifold())
        @test incident_log(N2, x) == [x[2] - x[1], x[3] - x[2], [0.0, 0.0]]
    end
    @testset "Weighted Graph" begin
        G3 = SimpleWeightedGraph(3)
        add_edge!(G3, 1, 2, 1.5)
        add_edge!(G3, 2, 3, 0.5)
        N3 = GraphManifold(G3, M, VertexManifold())
        @test incident_log(N3, x) == [
            1.5 * (x[2] - x[1]),
            1.5 * (x[1] - x[2]) + 0.5 * (x[3] - x[2]),
            0.5 * (x[2] - x[3]),
        ]
    end
end

# A bit of duplication of tests in ManifoldDiff.jl but it ensures that it works here too.

using Manifolds:
    default_differential_backend,
    _derivative,
    _derivative!,
    differential,
    differential!,
    gradient,
    gradient!,
    _gradient,
    _gradient!,
    _jacobian,
    _jacobian!,
    set_default_differential_backend!

# differentiation
using Manifolds:
    AbstractDiffBackend,
    AbstractRiemannianDiffBackend,
    ExplicitEmbeddedBackend,
    TangentDiffBackend,
    RiemannianProjectionBackend

using ManifoldDiff

import ManifoldDiff: gradient

struct TestRiemannianBackend <: AbstractRiemannianDiffBackend end
function ManifoldDiff.gradient(::AbstractManifold, f, p, ::TestRiemannianBackend)
    return collect(1.0:length(p))
end

using ADTypes
using FiniteDifferences
using LinearAlgebra: Diagonal, dot

using ForwardDiff

@testset "Differentiation backend" begin
    fd51 = AutoFiniteDifferences(central_fdm(5, 1))
    @testset "default_differential_backend" begin
        @test default_differential_backend() isa AutoFiniteDifferences

        @test length(fd51.fdm.grid) == 5
        # check method order
        @test typeof(fd51.fdm).parameters[2] == 1
        fd71 = AutoFiniteDifferences(central_fdm(7, 1))
        @test set_default_differential_backend!(fd71) == fd71
        @test default_differential_backend() == fd71
    end

    @testset "gradient" begin
        set_default_differential_backend!(fd51)
        r2 = Euclidean(2)

        c1(t) = [sin(t), cos(t)]
        f1(x) = x[1] + x[2]^2
        function f1!(y, x)
            y .= x[1] + x[2]^2
            return y
        end
        f2(x) = 3 * x[1] * x[2] + x[2]^3
        @test _jacobian(c1, 0.0) ≈ [1.0; 0.0]

        @testset for backend in [fd51]
            set_default_differential_backend!(backend)
            @test _derivative(c1, 0.0) ≈ [1.0, 0.0]
            X = [-1.0, -1.0]
            @test _derivative!(c1, X, 0.0) === X
            @test isapprox(X, [1.0, 0.0])
        end
        @testset for backend in [fd51]
            set_default_differential_backend!(backend)
            X = [-1.0, -1.0]
            @test _gradient(f1, [1.0, -1.0]) ≈ [1.0, -2.0]
            @test _gradient!(f1, X, [1.0, -1.0]) === X
            @test X ≈ [1.0, -2.0]
        end
        set_default_differential_backend!(Manifolds.NoneDiffBackend())
        @testset for backend in [fd51]
            @test _derivative(c1, 0.0, backend) ≈ [1.0, 0.0]
            @test _gradient(f1, [1.0, -1.0], backend) ≈ [1.0, -2.0]
            @test _jacobian(c1, 0.0, backend) ≈ [1.0; 0.0]
            jac = [NaN; NaN]
            _jacobian!(c1, jac, 0.0, backend)
            @test jac ≈ [1.0; 0.0]
        end

        set_default_differential_backend!(fd51)
    end

    @testset "Hessian" begin
        r2 = Euclidean(2)
        f1(p) = norm(p - [1.0, -1.0])^2
        q = [2.0, 3.0]

        @test isapprox(Manifolds._hessian(f1, q), [2.0 0.0; 0.0 2.0])
    end
end

rb_onb_default = TangentDiffBackend(
    default_differential_backend(),
    Manifolds.ExponentialRetraction(),
    Manifolds.LogarithmicInverseRetraction(),
    DefaultOrthonormalBasis(),
    DefaultOrthonormalBasis(),
)

rb_onb_fd51 = TangentDiffBackend(AutoFiniteDifferences(central_fdm(5, 1)))

rb_onb_default2 = TangentDiffBackend(
    default_differential_backend();
    basis_arg = CachedBasis(
        DefaultOrthonormalBasis(),
        [[0.0, -1.0, 0.0], [sqrt(2) / 2, 0.0, -sqrt(2) / 2]],
    ),
    basis_val = CachedBasis(
        DefaultOrthonormalBasis(),
        [[0.0, -1.0, 0.0], [sqrt(2) / 2, 0.0, -sqrt(2) / 2]],
    ),
)

rb_proj = Manifolds.RiemannianProjectionBackend(default_differential_backend())

rb_onb_fwd_diff = TangentDiffBackend(AutoForwardDiff())

@testset "Riemannian differentials" begin
    s2 = Sphere(2)
    p = [0.0, 0.0, 1.0]
    q = [1.0, 0.0, 0.0]
    c1(t) = geodesic(s2, q, p, t)

    Xval = [-sqrt(2) / 2, 0.0, sqrt(2) / 2]
    @test isapprox(s2, c1(π / 4), differential(s2, c1, π / 4, rb_onb_default), Xval)
    X = similar(p)
    differential!(s2, c1, X, π / 4, rb_onb_default)
    @test isapprox(s2, c1(π / 4), X, Xval)

    @testset for backend in [rb_onb_fd51, rb_onb_fwd_diff]
        @test isapprox(s2, c1(π / 4), differential(s2, c1, π / 4, backend), Xval)
        X = similar(p)
        differential!(s2, c1, X, π / 4, backend)
        @test isapprox(s2, c1(π / 4), X, Xval)
    end
end

@testset "Riemannian gradients" begin
    s2 = Sphere(2)
    f1(p) = p[1]

    q = [sqrt(2) / 2, 0, sqrt(2) / 2]
    X = similar(q)
    for backend in [rb_onb_default, rb_proj]
        @test isapprox(s2, q, gradient(s2, f1, q, backend), [0.5, 0.0, -0.5])
        @test gradient!(s2, f1, X, q, backend) === X
        @test isapprox(s2, q, X, [0.5, 0.0, -0.5])
    end
    X = similar(q)
    for backend in [rb_onb_default, rb_proj]
        gradient!(s2, f1, X, q, backend)
        @test isapprox(s2, q, X, [0.5, 0.0, -0.5])
    end

    # Test the gradient fallback
    @test gradient(s2, f1, q, TestRiemannianBackend()) == [1.0, 2.0, 3.0]
    X = similar(q)
    @test gradient!(s2, f1, X, q, TestRiemannianBackend()) === X
    @test X == [1.0, 2.0, 3.0]
end

@testset "Riemannian Jacobians" begin
    s2 = Sphere(2)
    f1(p) = p

    q = [sqrt(2) / 2, 0, sqrt(2) / 2]
    X = similar(q)
    @test isapprox(
        s2,
        q,
        Manifolds.jacobian(s2, s2, f1, q, rb_onb_default),
        [1.0 0.0; 0.0 1.0],
    )

    q2 = [1.0, 0.0, 0.0]
    f2(X) = [0.0 0.0 0.0; 0.0 2.0 -1.0; 0.0 -3.0 1.0] * X
    Tq2s2 = TangentSpace(s2, q2)
    @test isapprox(
        Manifolds.jacobian(Tq2s2, Tq2s2, f2, zero_vector(s2, q2), rb_onb_default),
        [2.0 -1.0; -3.0 1.0],
    )

    q3 = [0.0, 1.0, 0.0]
    f3(X) = [0.0 2.0 1.0; 0.0 0.0 0.0; 0.0 5.0 1.0] * X
    Tq3s2 = TangentSpace(s2, q3)
    @test isapprox(
        Manifolds.jacobian(Tq2s2, Tq3s2, f3, zero_vector(s2, q2), rb_onb_default),
        [-2.0 -1.0; 5.0 1.0],
    )
end

@testset "Riemannian Hessian" begin
    s2 = Sphere(2)
    q = [sqrt(2) / 2, 0, sqrt(2) / 2]
    q2 = [0.0, 1.0, 0.0]

    f1(p) = distance(s2, q2, p)^2

    @test_broken isapprox(
        ManifoldDiff.hessian(s2, f1, q, rb_onb_fwd_diff),
        [2.0 0.0; 0.0 0.0],
    )
end

@testset "EmbeddedBackend" begin
    A = [1 0 0; 0 2 0; 0 0 3.0]
    p = 1 / sqrt(2.0) .* [1.0, 1.0, 0.0]

    cost = p -> p' * A * p # Euclidean cost of Rayleigh
    grad = (M, p) -> 2A * p
    grad! = (M, X, p) -> X .= 2A * p
    M = Euclidean(3)
    E = ExplicitEmbeddedBackend(M, gradient = grad, (gradient!) = grad!)
    S = Sphere(2)
    r_grad = (S, p) -> project(S, p, grad(M, p))
    Xt = r_grad(S, p)
    @test is_vector(S, p, Xt, true; atol = 1.0e-14)

    R = RiemannianProjectionBackend(E)
    X = gradient(S, cost, p, R)
    @test isapprox(S, p, X, Xt)
    gradient!(S, cost, X, p, R)
    @test isapprox(S, p, X, Xt)
    # Errors with empty gradient
    Ee = ExplicitEmbeddedBackend(M)
    Re = RiemannianProjectionBackend(Ee)
    @test_throws MissingException gradient(S, cost, p, Re)
    @test_throws MissingException gradient!(S, cost, X, p, Re)
end

using Manifolds, RecursiveArrayTools, OrdinaryDiffEq, DiffEqCallbacks, BoundaryValueDiffEq

using DifferentiationInterface, ForwardDiff

using Manifolds: TangentSpaceType

using LinearAlgebra

using CairoMakie

# space outside of a black hole with Schwarzschild radius rₛ
struct BlackHoleOutside <: AbstractManifold{ℝ}
    rₛ::Float64
end

struct SchwarzschildAtlas <: AbstractAtlas{ℝ} end

Manifolds.manifold_dimension(::BlackHoleOutside) = 4
Manifolds.representation_size(::BlackHoleOutside) = (4,)

function Manifolds.affine_connection!(M::BlackHoleOutside, Zc, A::SchwarzschildAtlas, i, a, Xc, Yc)
    return Manifolds.levi_civita_affine_connection!(M, Zc, A, i, a, Xc, Yc)
end

function Manifolds.check_chart_switch(::BlackHoleOutside, A::SchwarzschildAtlas, i, a)
    return false
end

function Manifolds.inner(M::BlackHoleOutside, ::SchwarzschildAtlas, i, a, Xc, Yc)
    t, r, θ, ϕ = a
    r_block = (1 - M.rₛ / r)
    # assuming c = 1
    #@show r_block, Xc, Yc, a
    return Xc[1] * r_block * Yc[1] - Xc[2] * Yc[2] / r_block - r^2 * (Xc[3] * Yc[3] + (sin(θ)^2) * Xc[4] * Yc[4])
end


function Manifolds.get_chart_index(::BlackHoleOutside, ::SchwarzschildAtlas, p)
    return nothing
end
function Manifolds.get_chart_index(::BlackHoleOutside, ::SchwarzschildAtlas, i, a)
    return nothing
end

function Manifolds.get_parameters!(M::BlackHoleOutside, x, ::SchwarzschildAtlas, i, p)
    x[1] = p[1] # t
    r = norm(p[2:4])
    x[2] = r
    x[3] = acos(p[4] / r) # θ
    x[4] = atan(p[3], p[2]) # ϕ
    return x
end

function Manifolds.get_point!(M::BlackHoleOutside, p, ::SchwarzschildAtlas, i, x)
    p[1] = x[1]
    p[2] = x[2] * sin(x[3]) * cos(x[4])
    p[3] = x[2] * sin(x[3]) * sin(x[4])
    p[4] = x[2] * cos(x[3])
    return p
end


# simulation
function sim()
    M = BlackHoleOutside(1.0)
    p0 = [0.0, 10.0, 0.0, 0.0]

    A = SchwarzschildAtlas()
    i = nothing

    X0 = [1.0, 0.0, 0.18, 0.0]
    a_p0 = get_parameters(M, A, i, p0)
    B = induced_basis(M, A, a_p0)
    c_X0 = get_coordinates(M, p0, X0, B)
    final_time = 5000.0
    sol = Manifolds.solve_chart_exp_ode(M, a_p0, c_X0, A, i; final_time = final_time, solver = Tsit5())

    sampled_solution = sol(range(0.0, final_time; length = 20000))

    x_min = -12.0
    x_max = 12.0
    y_min = -12.0
    y_max = 12.0

    ks_samples = 300
    ks_x = range(x_min, x_max; length = ks_samples)
    ks_y = range(y_min, y_max; length = ks_samples)
    function get_ks(a_x, a_y)
        if a_x^2 + a_y^2 > M.rₛ^2
            return Manifolds.kretschmann_scalar(M, A, i, get_parameters(M, A, i, [0.0, a_x, a_y, 0.0]))
        else
            return 0.0
        end
    end

    ks_vals = [log.(get_ks(a_x, a_y)) for a_x in ks_x, a_y in ks_y]

    # plotting
    x_values = [s[1][2] for s in sampled_solution]
    y_values = [s[1][3] for s in sampled_solution]

    fig = Figure(; size = (800, 800))
    ax = Axis(fig[1, 1]; title = "2D Plot of Sampled Solution", xlabel = "x", ylabel = "y", aspect = AxisAspect(1))

    xlims!(ax, x_min, x_max)
    ylims!(ax, y_min, y_max)

    hm = heatmap!(ax, ks_x, ks_y, ks_vals; colormap = :viridis) # show Kretschmann scalar

    Colorbar(fig[:, end + 1], hm, label = "log(Kretschmann scalar)")

    θ = range(0, 2π, length = 400)             # parameter for the circle
    xs = cos.(θ) .* 1.0                      # radius = 1
    ys = sin.(θ) .* 1.0

    poly!(ax, xs, ys, color = :black)        # filled polygon approximating the circle

    lines!(ax, x_values, y_values, color = :white, label = "movement")

    axislegend(ax)
    display(fig)
    return fig
end


using Observables

function anim()
    M = BlackHoleOutside(1.0)
    p0 = [0.0, 10.0, 0.0, 0.0]

    A = SchwarzschildAtlas()
    i = nothing

    X0 = [1.0, 0.0, 0.18, 0.0]
    a_p0 = get_parameters(M, A, i, p0)
    B = induced_basis(M, A, a_p0)
    c_X0 = get_coordinates(M, p0, X0, B)
    final_time = 5000.0
    sol = Manifolds.solve_chart_exp_ode(M, a_p0, c_X0, A, i; final_time = final_time, solver = Tsit5())

    sampled_solution = sol(range(0.0, final_time; length = 5000))

    # Extract x and y values for animation
    x_values = [s[1][2] for s in sampled_solution]
    y_values = [s[1][3] for s in sampled_solution]

    # Create figure and axis
    fig = Figure(; size = (800, 800))
    ax = Axis(fig[1, 1]; title = "Animated Sampled Solution", xlabel = "x", ylabel = "y", aspect = AxisAspect(1))

    # Observables to update during the animation
    path_x = Observable(x_values[1:1])
    path_y = Observable(y_values[1:1])
    current_x = Observable([x_values[1]])
    current_y = Observable([y_values[1]])

    # Draw Schwarzschild radius
    arc!(ax, Point2f(0), M.rₛ, -π, π; color = :black)

    # Plot line (path) and moving point
    lines!(ax, path_x, path_y; color = :blue, linewidth = 2)
    scatter!(ax, current_x, current_y; color = :red, markersize = 8)
    xlims!(ax, -20, 20)
    ylims!(ax, -20, 20)

    # Record animation
    nframes = length(x_values)
    record(fig, "black_hole_orbit.mp4", 1:nframes; framerate = 30) do frame
        # update observables for this frame
        path_x[] = x_values[1:frame]
        path_y[] = y_values[1:frame]
        current_x[] = [x_values[frame]]
        current_y[] = [y_values[frame]]
    end

    return println("Animation saved as black_hole_orbit.mp4")
end

# generic stuff

include("../header.jl")

@testset "Multinomial symmetric positive definite matrices" begin
    @testset "Basics" begin
        M = MultinomialSymmetricPositiveDefinite(3)
        Mf = MultinomialSymmetricPositiveDefinite(3; parameter = :field)
        @test repr(M) == "MultinomialSymmetricPositiveDefinite(3)"
        @test repr(Mf) == "MultinomialSymmetricPositiveDefinite(3; parameter=:field)"
        @test get_embedding(M) == MultinomialMatrices(3, 3)
        @test get_embedding(Mf) == MultinomialMatrices(3, 3; parameter = :field)
        #
        # Checks
        # (a) Points
        p = [0.6 0.2 0.2; 0.2 0.6 0.2; 0.2 0.2 0.6]
        @test is_point(M, p; error = :error)
        # Symmetric but does not sum to 1
        pf1 = zeros(3, 3)
        @test_throws ManifoldDomainError is_point(M, pf1; error = :error)
        #  in theory this is not spd since it has an EV 0 but numerically it is
        pf2 = [0.3 0.4 0.3; 0.4 0.2 0.4; 0.3 0.4 0.3]
        # Multinomial but not symmetric
        pf3 = [0.2 0.3 0.5; 0.4 0.2 0.4; 0.4 0.5 0.1]
        @test_throws ManifoldDomainError is_point(M, pf3; error = :error)
        # (b) Tangent vectors
        X = [1.0 -0.5 -0.5; -0.5 1.0 -0.5; -0.5 -0.5 1.0]
        @test is_vector(M, p, X; error = :error)
        Xf1 = ones(3, 3) # Symmetric but does not sum to zero
        @test_throws ManifoldDomainError is_vector(M, p, Xf1; error = :error)
        #sums to zero but not symmetric
        Xf2 = [-0.5 0.3 0.2; 0.2 -0.5 0.3; 0.3 0.2 -0.5]
        @test_throws ManifoldDomainError is_vector(M, p, Xf2; error = :error)
    end

    @testset "Random" begin
        q = zeros(3, 3)
        M = MultinomialSymmetricPositiveDefinite(3)
        @test is_point(M, rand!(MersenneTwister(), M, q); error = :error, atol = 5.0e-14)
    end
end

using Manifolds, Test

TEST_SET = get(ENV, "MANIFOLDS_TEST_SET", "all")

@info "=== Manifolds.jl Test Suite ===\n\n" *
    "Test set       $(TEST_SET)\n\n" *
    "These settings are stored in environment variables."

camel_to_snake(x) = lowercase(replace(string(x), r"(?<!^)(?=[A-Z])" => "_"))

function include_test(path)
    @info "Running $path"
    return @time include(path)  # show basic timing, (this will print a newline at end)
end

@testset "Manifolds.jl" begin
    (TEST_SET ∈ ["all", "utilities", "manifolds"]) && Test.@testset "Utilities" begin
        include_test("test_ambiguities.jl")
        include_test("test_deprecated.jl")
        include_test("test_differentiation.jl")
        include_test("test_notation.jl")
        include_test("test_utils.jl")
        include_test("test_metric.jl")
        include_test("test_statistics.jl")
    end
    if TEST_SET ∈ ["all", "integration"]
        include_test("approx_inverse_retraction.jl")
        # manifolds requiring ODE solvers
        include_test("manifolds-old/embedded_torus.jl")
        # If we are not on apple, test recipes
        Sys.isapple() || include_test("test_recipes.jl")
    end
    (TEST_SET ∈ ["all", "manifolds"]) && Test.@testset "Manifolds Test Suite" begin
        include_test("manifolds/test_centered_matrices.jl")
        include_test("manifolds/test_cholesky_space.jl")
        include_test("manifolds/test_circle.jl")
        include_test("manifolds/test_sphere.jl")
        include_test("manifolds/test_general_unitary.jl")
        include_test("manifolds/test_heisenberg_matrices.jl")
    end
    (TEST_SET ∈ ["all", "manifolds"]) && Test.@testset "Manifolds.jl Old Tests" begin
        # starting with tests of simple manifolds
        include_test("manifolds-old/determinant_one_matrices.jl")
        include_test("manifolds-old/elliptope.jl")
        include_test("manifolds-old/euclidean.jl")
        include_test("manifolds-old/fixed_rank.jl")
        include_test("manifolds-old/flag.jl")
        include_test("manifolds-old/generalized_grassmann.jl")
        include_test("manifolds-old/generalized_stiefel.jl")
        include_test("manifolds-old/grassmann.jl")
        include_test("manifolds-old/hamiltonian.jl")
        include_test("manifolds-old/hyperbolic.jl")
        include_test("manifolds-old/hyperrectangle.jl")
        include_test("manifolds-old/invertible_matrices.jl")
        include_test("manifolds-old/lorentz.jl")
        include_test("manifolds-old/multinomial_doubly_stochastic.jl")
        include_test("manifolds-old/multinomial_symmetric.jl")
        include_test("manifolds-old/multinomial_spd.jl")
        include_test("manifolds-old/positive_numbers.jl")
        include_test("manifolds-old/probability_simplex.jl")
        include_test("manifolds-old/projective_space.jl")
        include_test("manifolds-old/rotations.jl")
        include_test("manifolds-old/segre.jl")
        include_test("manifolds-old/shape_space.jl")
        include_test("manifolds-old/skewhermitian.jl")
        include_test("manifolds-old/spectrahedron.jl")
        include_test("manifolds-old/sphere_symmetric_matrices.jl")
        include_test("manifolds-old/stiefel.jl")
        include_test("manifolds-old/symmetric.jl")
        include_test("manifolds-old/symmetric_positive_definite.jl")
        include_test("manifolds-old/spd_fixed_determinant.jl")
        include_test("manifolds-old/symmetric_positive_semidefinite_fixed_rank.jl")
        include_test("manifolds-old/symplectic.jl")
        include_test("manifolds-old/symplecticgrassmann.jl")
        include_test("manifolds-old/symplecticstiefel.jl")
        include_test("manifolds-old/tucker.jl")
        include_test("manifolds-old/unitary_matrices.jl")

        include_test("manifolds-old/essential_manifold.jl")
        include_test("manifolds-old/multinomial_matrices.jl")
        include_test("manifolds-old/oblique.jl")
        include_test("manifolds-old/torus.jl")

        #meta manifolds
        include_test("manifolds-old/product_manifold.jl")
        include_test("manifolds-old/power_manifold.jl")
        include_test("manifolds-old/fiber_bundle.jl")
        include_test("manifolds-old/vector_bundle.jl")
        include_test("manifolds-old/graph.jl")
    end
end

@doc raw"""
    SymmetricMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  ``\operatorname{Sym}(n)`` consisting of the real- or complex-valued
symmetric matrices of size ``n×n``, i.e. the set

````math
\operatorname{Sym}(n) = \bigl\{p  ∈ 𝔽^{n×n}\ \big|\ p^{\mathrm{H}} = p \bigr\},
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transpose,
and the field ``𝔽 ∈ \{ ℝ, ℂ\}``. The dimension `n` is stored in either a field or within `T`

Though it is slightly redundant, usually the matrices are stored as ``n×n`` arrays.

Note that in this representation, the complex valued case has to have a real-valued diagonal,
which is also reflected in the [`manifold_dimension`](@ref manifold_dimension(::SymmetricMatrices)).

# Constructor

    SymmetricMatrices(n::Int, field::AbstractNumbers=ℝ)

Generate the manifold of ``n×n`` symmetric matrices.
"""
struct SymmetricMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SymmetricMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return SymmetricMatrices{field, typeof(size)}(size)
end

function allocation_promotion_function(
        ::SymmetricMatrices{ℂ},
        ::typeof(get_vector),
        args::Tuple,
    )
    return complex
end

@doc raw"""
    check_point(M::SymmetricMatrices{n,𝔽}, p; kwargs...)

Check whether `p` is a valid manifold point on the [`SymmetricMatrices`](@ref) `M`, i.e.
whether `p` is a symmetric matrix of size `(n,n)` with values from the corresponding
[`AbstractNumbers`](@extref ManifoldsBase number-system) `𝔽`.

The tolerance for the symmetry of `p` can be set using `kwargs...`.
"""
function check_point(M::SymmetricMatrices, p; kwargs...)
    if !isapprox(p, p'; kwargs...)
        return DomainError(
            norm(p - p'),
            "The point $(p) does not lie on $M, since it is not symmetric.",
        )
    end
    return nothing
end

"""
    check_vector(M::SymmetricMatrices{n,𝔽}, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`SymmetricMatrices`](@ref) `M`, i.e. `X` has to be a symmetric matrix of size `(n,n)`
and its values have to be from the correct [`AbstractNumbers`](@extref ManifoldsBase number-system).

The tolerance for the symmetry of `X` can be set using `kwargs...`.
"""
function check_vector(M::SymmetricMatrices, p, X; kwargs...)
    if !isapprox(X, X'; kwargs...)
        return DomainError(
            norm(X - X'),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not symmetric.",
        )
    end
    return nothing
end

embed(::SymmetricMatrices, p) = p
embed(::SymmetricMatrices, p, X) = X

function get_basis(M::SymmetricMatrices, p, B::DiagonalizingOrthonormalBasis)
    Ξ = get_basis(M, p, DefaultOrthonormalBasis()).data
    κ = zeros(real(eltype(p)), manifold_dimension(M))
    return CachedBasis(B, κ, Ξ)
end

function get_coordinates_orthonormal!(M::SymmetricMatrices{ℝ}, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(Y) == (dim,)
    @assert size(X) == (N, N)
    @assert dim == div(N * (N + 1), 2)
    k = 1
    for i in 1:N, j in i:N
        scale = ifelse(i == j, 1, sqrt(2))
        @inbounds Y[k] = X[i, j] * scale
        k += 1
    end
    return Y
end
function get_coordinates_orthonormal!(M::SymmetricMatrices{ℂ}, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(Y) == (dim,)
    @assert size(X) == (N, N)
    @assert dim == N * N
    k = 1
    for i in 1:N, j in i:N
        scale = ifelse(i == j, 1, sqrt(2))
        @inbounds Y[k] = real(X[i, j]) * scale
        k += 1
        if i != j # imag zero on the diagonal
            @inbounds Y[k] = imag(X[i, j]) * scale
            k += 1
        end
    end
    return Y
end

function get_embedding(::SymmetricMatrices{𝔽, TypeParameter{Tuple{N}}}) where {N, 𝔽}
    return Euclidean(N, N; field = 𝔽)
end
function get_embedding(M::SymmetricMatrices{𝔽, Tuple{Int}}) where {𝔽}
    N = get_parameter(M.size)[1]
    return Euclidean(N, N; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymmetricMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

function get_vector_orthonormal!(M::SymmetricMatrices{ℝ}, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(X) == (dim,)
    @assert size(Y) == (N, N)
    k = 1
    for i in 1:N, j in i:N
        scale = ifelse(i == j, 1, 1 / sqrt(2))
        @inbounds Y[i, j] = X[k] * scale
        @inbounds Y[j, i] = X[k] * scale
        k += 1
    end
    return Y
end
function get_vector_orthonormal!(M::SymmetricMatrices{ℂ}, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(X) == (dim,)
    @assert size(Y) == (N, N)
    k = 1
    for i in 1:N, j in i:N
        scale = ifelse(i == j, 1, 1 / sqrt(2))
        @inbounds Y[i, j] = (X[k] + (i == j ? 0 : X[k + 1] * 1im)) * scale
        @inbounds Y[j, i] = Y[i, j]
        k += (i == j ? 1 : 2)
    end
    return Y
end

"""
    is_flat(::SymmetricMatrices)

Return true. [`SymmetricMatrices`](@ref) is a flat manifold.
"""
is_flat(M::SymmetricMatrices) = true

@doc raw"""
    manifold_dimension(M::SymmetricMatrices{n,𝔽})

Return the dimension of the [`SymmetricMatrices`](@ref) matrix `M` over the number system
`𝔽`, i.e.

````math
\begin{aligned}
\dim \mathrm{Sym}(n,ℝ) &= \frac{n(n+1)}{2},\\
\dim \mathrm{Sym}(n,ℂ) &= 2\frac{n(n+1)}{2} - n = n^2,
\end{aligned}
````

where the last ``-n`` is due to the zero imaginary part for Hermitian matrices
"""
function manifold_dimension(M::SymmetricMatrices{𝔽}) where {𝔽}
    N = get_parameter(M.size)[1]
    return div(N * (N + 1), 2) * real_dimension(𝔽) - (𝔽 === ℂ ? N : 0)
end

@doc raw"""
    project(M::SymmetricMatrices, p)

Projects `p` from the embedding onto the [`SymmetricMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_{\operatorname{Sym}(n)}(p) = \frac{1}{2} \bigl( p + p^{\mathrm{H}} \bigr),
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SymmetricMatrices, ::Any)

function project!(::SymmetricMatrices, q, p)
    q .= (p .+ p') ./ 2
    return q
end

@doc raw"""
    project(M::SymmetricMatrices, p, X)

Project the matrix `X` onto the tangent space at `p` on the [`SymmetricMatrices`](@ref) `M`,

````math
\operatorname{proj}_p(X) = \frac{1}{2} \bigl( X + X^{\mathrm{H}} \bigr),
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SymmetricMatrices, ::Any, ::Any)

project!(::SymmetricMatrices, Y, p, X) = (Y .= (X .+ transpose(X)) ./ 2)

function Random.rand!(
        rng::AbstractRNG,
        M::SymmetricMatrices,
        pX;
        σ::Real = one(real(eltype(pX))),
        kwargs...,
    )
    rand!(rng, pX)
    pX .= (σ / (2 * norm(pX))) .* (pX + pX')
    return pX
end

function Base.show(io::IO, ::SymmetricMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "SymmetricMatrices($(n), $(𝔽))")
end
function Base.show(io::IO, M::SymmetricMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "SymmetricMatrices($(n), $(𝔽); parameter=:field)")
end

@doc raw"""
    Y = Weingarten(M::SymmetricMatrices, p, X, V)
    Weingarten!(M::SymmetricMatrices, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`SymmetricMatrices`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::SymmetricMatrices, p, X, V)

Weingarten!(::SymmetricMatrices, Y, p, X, V) = fill!(Y, 0)

@doc raw"""
    SphereSymmetricMatrices{𝔽, T} <: AbstractEmbeddedManifold{ℝ,TransparentIsometricEmbedding}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  consisting of the ``n×n`` symmetric matrices
of unit Frobenius norm, i.e.
````math
\mathcal{S}_{\text{sym}} :=\bigl\{p  ∈ 𝔽^{n×n}\ \big|\ p^{\mathrm{H}} = p, \lVert p \rVert = 1 \bigr\},
````
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transpose,
and the field ``𝔽 ∈ \{ ℝ, ℂ\}``.

# Constructor
    SphereSymmetricMatrices(n[, field=ℝ])

Generate the manifold of `n`-by-`n` symmetric matrices of unit Frobenius norm.
"""
struct SphereSymmetricMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SphereSymmetricMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return SphereSymmetricMatrices{field, typeof(size)}(size)
end

@doc raw"""
    check_point(M::SphereSymmetricMatrices, p; kwargs...)

Check whether the matrix is a valid point on the [`SphereSymmetricMatrices`](@ref) `M`,
i.e. is an `n`-by-`n` symmetric matrix of unit Frobenius norm.

The tolerance for the symmetry of `p` can be set using `kwargs...`.
"""
function check_point(
        M::SphereSymmetricMatrices,
        p::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(norm(p - p'), 0; atol = atol, kwargs...)
        return DomainError(
            norm(p - p'),
            "The point $(p) does not lie on $M, since it is not symmetric.",
        )
    end
    return nothing
end

"""
    check_vector(M::SphereSymmetricMatrices, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`SphereSymmetricMatrices`](@ref) `M`, i.e. `X` has to be a symmetric matrix of size `(n,n)`
of unit Frobenius norm.

The tolerance for the symmetry of `p` and `X` can be set using `kwargs...`.
"""
function check_vector(
        M::SphereSymmetricMatrices,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(norm(X - X'), 0; atol = atol, kwargs...)
        return DomainError(
            norm(X - X'),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not symmetric.",
        )
    end
    return nothing
end

embed(::SphereSymmetricMatrices, p) = p
embed(::SphereSymmetricMatrices, p, X) = X

function get_embedding(::SphereSymmetricMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return ArraySphere(n, n; field = 𝔽)
end
function get_embedding(M::SphereSymmetricMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return ArraySphere(n, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SphereSymmetricMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

"""
    is_flat(::SphereSymmetricMatrices)

Return false. [`SphereSymmetricMatrices`](@ref) is not a flat manifold.
"""
is_flat(M::SphereSymmetricMatrices) = false

@doc raw"""
    manifold_dimension(M::SphereSymmetricMatrices{<:Any,𝔽})

Return the manifold dimension of the [`SphereSymmetricMatrices`](@ref) `n`-by-`n` symmetric matrix `M` of unit
Frobenius norm over the number system `𝔽`, i.e.

````math
\begin{aligned}
\dim(\mathcal{S}_{\text{sym}})(n,ℝ) &= \frac{n(n+1)}{2} - 1,\\
\dim(\mathcal{S}_{\text{sym}})(n,ℂ) &= 2\frac{n(n+1)}{2} - n -1.
\end{aligned}
````
"""
function manifold_dimension(M::SphereSymmetricMatrices{𝔽}) where {𝔽}
    n = get_parameter(M.size)[1]
    return div(n * (n + 1), 2) * real_dimension(𝔽) - (𝔽 === ℂ ? n : 0) - 1
end

@doc raw"""
    project(M::SphereSymmetricMatrices, p)

Projects `p` from the embedding onto the [`SphereSymmetricMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_{\mathcal{S}_{\text{sym}}}(p) = \frac{1}{2} \bigl( p + p^{\mathrm{H}} \bigr),
````
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SphereSymmetricMatrices, ::Any)

function project!(M::SphereSymmetricMatrices, q, p)
    return project!(get_embedding(M), q, (p + p') ./ 2)
end

@doc raw"""
    project(M::SphereSymmetricMatrices, p, X)

Project the matrix `X` onto the tangent space at `p` on the [`SphereSymmetricMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_p(X) = \frac{X + X^{\mathrm{H}}}{2} - ⟨p, \frac{X + X^{\mathrm{H}}}{2}⟩p,
````
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SphereSymmetricMatrices, ::Any, ::Any)

function project!(M::SphereSymmetricMatrices, Y, p, X)
    return project!(get_embedding(M), Y, p, (X .+ X') ./ 2)
end

function representation_size(M::SphereSymmetricMatrices)
    n = get_parameter(M.size)[1]
    return (n, n)
end

function Base.show(io::IO, ::SphereSymmetricMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "SphereSymmetricMatrices($(n), $(𝔽))")
end
function Base.show(io::IO, M::SphereSymmetricMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "SphereSymmetricMatrices($(n), $(𝔽); parameter=:field)")
end

@doc raw"""
    SymplecticMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The symplectic manifold consists of all ``2n×2n`` matrices which preserve
the canonical symplectic form over ``𝔽^{2n×2n}×𝔽^{2n×2n}`` given by

```math
  \omega\colon 𝔽^{2n×2n}×𝔽^{2n×2n} → 𝔽,
  \quad \omega(x, y) = p^{\mathrm{T}} J_{2n} q, \  x, y \in 𝔽^{2n×2n},
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

The symplectic manifold consists of

```math
\mathrm{Sp}(2n, ℝ) = \bigl\{ p ∈ ℝ^{2n×2n} \, \big| \, p^{\mathrm{T}}J_{2n}p = J_{2n} \bigr\},
```

The tangent space at a point ``p`` is given by [BendokatZimmermann:2021](@cite)

```math
\begin{align*}
  T_p\mathrm{Sp}(2n)
    &= \{X \in ℝ^{2n×2n} \ |\ p^{T}J_{2n}X + X^{T}J_{2n}p = 0 \}, \\
    &= \{X = pJ_{2n}S \ \mid\ S ∈ R^{2n×2n}, S^{\mathrm{T}} = S \}.
\end{align*}
```

# Constructor

    SymplecticMatrices(2n, field=ℝ; parameter::Symbol=:type)

Generate the (real-valued) symplectic manifold of ``2n×2n`` symplectic matrices.
The constructor for the [`SymplecticMatrices`](@ref) manifold accepts the even column/row embedding
dimension ``2n`` for the real symplectic manifold, ``ℝ^{2n×2n}``.
"""
struct SymplecticMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SymplecticMatrices(two_n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    two_n % 2 == 0 || throw(
        ArgumentError(
            "The matrix size `2n` of the symplectic manifold must be even, but was $(two_n).",
        ),
    )
    size = wrap_type_parameter(parameter, (div(two_n, 2),))
    return SymplecticMatrices{field, typeof(size)}(size)
end

@doc raw"""
    RealSymplecticMetric <: RiemannianMetric

The canonical Riemannian metric on the symplectic manifold,
defined pointwise for ``p \in \mathrm{Sp}(2n)`` by [Fiori:2011](@cite)]

```math
\begin{align*}
  & g_p \colon T_p\mathrm{Sp}(2n)×T_p\mathrm{Sp}(2n) → ℝ, \\
  & g_p(Z_1, Z_2) = \operatorname{tr}((p^{-1}Z_1)^{\mathrm{T}} (p^{-1}Z_2)).
\end{align*}
```

This metric is also the default metric for the [`SymplecticMatrices`](@ref) manifold.
"""
struct RealSymplecticMetric <: RiemannianMetric end

@doc raw"""
    ExtendedSymplecticMetric <: AbstractMetric

The extension of the [`RealSymplecticMetric`](@ref) at a point ``p \in \mathrm{Sp}(2n)``
as an inner product over the embedding space ``ℝ^{2n×2n}``, i.e.

```math
    ⟨x, y⟩_p = ⟨p^{-1}x, p^{-1}⟩_{\mathrm{Fr}}
    = \operatorname{tr}(x^{\mathrm{T}}(pp^{\mathrm{T}})^{-1}y), \text{ for all } x, y \in ℝ^{2n×2n}.
```
"""
struct ExtendedSymplecticMetric <: AbstractMetric end

@doc raw"""
    SymplecticElement{T}

A lightweight structure to represent the action of the matrix
representation of the canonical symplectic form,

```math
J_{2n}(λ) = λ\begin{bmatrix}
0_n & I_n \\
 -I_n & 0_n
\end{bmatrix} ∈ ℝ^{2n×2n},
```

where we write ``J_{2n} = J_{2n}(1)`` for short.
The canonical symplectic form is represented by

```math
\omega_{2n}(x, y) = x^{\mathrm{T}}J_{2n}y, \quad x, y ∈ ℝ^{2n}.
```

The entire matrix is however not instantiated in memory, instead a scalar
``λ`` of type `T` is stored, which is used to keep track of scaling and transpose operations
applied  to each `SymplecticElement`.
This type acts similar to `I` from `LinearAlgeba`.

# Constructor

    SymplecticElement(λ=1)

Generate the sumplectic matrix with scaling ``1``.
"""
struct SymplecticElement{T}
    λ::T
end
SymplecticElement() = SymplecticElement(1)
SymplecticElement(λ::T) where {T <: Number} = SymplecticElement{T}(λ)

function SymplecticElement(arrays::Vararg{AbstractArray})
    TS = Base.promote_type(map(eltype, arrays)...)
    return SymplecticElement(one(TS))
end

@doc raw"""
    change_representer(::SymplecticMatrices, ::EuclideanMetric, p, X)
    change_representer!(::SymplecticMatrices, Y, ::EuclideanMetric, p, X)

Compute the representation of a tangent vector ``ξ ∈ T_p\mathrm{Sp}(2n, ℝ)`` s.t.
```math
  g_p(c_p(ξ), η) = ⟨ξ, η⟩^{\text{Euc}} \text{for all } η ∈ T_p\mathrm{Sp}(2n, ℝ).
```
with the conversion function

```math
  c_p : T_p\mathrm{Sp}(2n, ℝ) → T_p\mathrm{Sp}(2n, ℝ), \quad
  c_p(ξ) = \frac{1}{2} pp^{\mathrm{T}} ξ + \frac{1}{2} pJ_{2n} ξ^{\mathrm{T}} pJ_{2n},
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

Each of the terms ``c_p^1(ξ) = p p^{\mathrm{T}} ξ`` and ``c_p^2(ξ) = pJ_{2n} ξ^{\mathrm{T}} pJ_{2n}`` from the
above definition of ``c_p(η)`` are themselves metric compatible in the sense that

```math
    c_p^i : T_p\mathrm{Sp}(2n, ℝ) → ℝ^{2n×2n}\quad
    g_p^i(c_p(ξ), η) = ⟨ξ, η⟩^{\text{Euc}} \;∀\; η ∈ T_p\mathrm{Sp}(2n, ℝ),
```

for ``i \in {1, 2}``. However the range of each function alone is not confined to
  ``T_p\mathrm{Sp}(2n, ℝ)``, but the convex combination

```math
    c_p(ξ) = \frac{1}{2}c_p^1(ξ) + \frac{1}{2}c_p^2(ξ)
```

does have the correct range ``T_p\mathrm{Sp}(2n, ℝ)``.
"""
change_representer(::SymplecticMatrices, ::EuclideanMetric, p, X)

function change_representer!(::SymplecticMatrices, Y, ::EuclideanMetric, p, X)
    J = SymplecticElement(p, X) # J_{2n}
    pT_X = p' * X
    Y .= (1 / 2) .* p * (pT_X .+ J * pT_X' * J)
    return Y
end

@doc raw"""
    change_representer(MetMan::MetricManifold{<:Any, <:Euclidean, ExtendedSymplecticMetric},
                       EucMet::EuclideanMetric, p, X)
    change_representer!(MetMan::MetricManifold{<:Any, <:Euclidean, ExtendedSymplecticMetric},
                        Y, EucMet::EuclideanMetric, p, X)

Change the representation of a matrix ``ξ ∈ ℝ^{2n×2n}``
into the inner product space ``(ℝ^{2n×2n}, g_p)`` where the inner product
is given by
``g_p(ξ, η) = \langle p^{-1}ξ, p^{-1}η \rangle = \operatorname{tr}(ξ^{\mathrm{T}}(pp^{\mathrm{T}})^{-1}η)``,
as the extension of the [`RealSymplecticMetric`](@ref) onto the entire embedding space.

By changing the representation we mean to apply a mapping
````math
    c_p : ℝ^{2n×2n} → ℝ^{2n×2n},
````
defined by requiring that it satisfy the metric compatibility condition
````math
    g_p(c_p(ξ), η) = ⟨p^{-1}c_p(ξ), p^{-1}η⟩ = ⟨ξ, η⟩^{\text{Euc}}
        \;∀\; η ∈ T_p\mathrm{Sp}(2n, ℝ).
````
In this case, we compute the mapping
````math
    c_p(ξ) = pp^{\mathrm{T}} ξ.
````
"""
function change_representer(
        ::MetricManifold{<:Any, <:Euclidean, ExtendedSymplecticMetric},
        ::EuclideanMetric,
        p,
        X,
    )
    return p * p' * X
end

function change_representer!(
        ::MetricManifold{<:Any, <:Euclidean, ExtendedSymplecticMetric},
        Y,
        ::EuclideanMetric,
        p,
        X,
    )
    Y .= p * p' * X
    return Y
end

@doc raw"""
    check_point(M::SymplecticMatrices, p; kwargs...)

Check whether `p` is a valid point on the [`SymplecticMatrices`](@ref) `M`=$\mathrm{Sp}(2n)$,
i.e. that it has the right [`AbstractNumbers`](@extref ManifoldsBase number-system) type and ``p^{+}p`` is (approximately)
the identity, where ``A^+`` denotes the [`symplectic_inverse`](@ref).

The tolerance can be set with `kwargs...`.
"""
function check_point(
        M::SymplecticMatrices,
        p::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    # Perform check that the matrix lives on the real symplectic manifold:
    if !isapprox(inv(M, p) * p, LinearAlgebra.I; atol = atol, kwargs...)
        return DomainError(
            norm(inv(M, p) * p - LinearAlgebra.I),
            (
                "The point p does not lie on $(M) because its symplectic" *
                    " inverse composed with itself is not the identity."
            ),
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::SymplecticMatrices, p, X; kwargs...)

Checks whether `X` is a valid tangent vector at `p` on the [`SymplecticMatrices`](@ref)
`M`=``\mathrm{Sp}(2n)``, which requires that

```math
p^{T}J_{2n}X + X^{T}J_{2n}p = 0
```
holds (approximately), where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

The tolerance can be set with `kwargs...`
"""
check_vector(::SymplecticMatrices, ::Any...)

function check_vector(M::SymplecticMatrices, p, X::T; kwargs...) where {T}
    J = SymplecticElement(p, X)
    if !isapprox(X' * J * p, -p' * J * X; kwargs...)
        return DomainError(
            norm(X' * J * p + p' * J * X, 2),
            (
                "The matrix X is not in the tangent space at point p of the" *
                    " manifold $(M), as X'Jp + p'JX is not the zero matrix."
            ),
        )
    end
    return nothing
end

function ManifoldsBase.default_inverse_retraction_method(::SymplecticMatrices)
    return CayleyInverseRetraction()
end

metric(::SymplecticMatrices) = RealSymplecticMetric()

ManifoldsBase.default_retraction_method(::SymplecticMatrices) = CayleyRetraction()

@doc raw"""
    distance(M::SymplecticMatrices, p, q)

Compute an approximate geodesic distance between two Symplectic matrices
``p, q \in \mathrm{Sp}(2n)``, as done in [WangSunFiori:2018](@cite).

````math
  \operatorname{dist}(p, q)
    ≈ \lVert\operatorname{Log}(p^+q)\rVert_{\mathrm{Fr}},
````
where the ``\operatorname{Log}(⋅)`` operator is the matrix logarithm.

This approximation is justified by first recalling the Baker-Campbell-Hausdorf formula,

````math
\operatorname{Log}(\operatorname{Exp}(A)\operatorname{Exp}(B))
 = A + B + \frac{1}{2}[A, B] + \frac{1}{12}[A, [A, B]] + \frac{1}{12}[B, [B, A]]
    + \ldots \;.
````

Then we write the expression for the exponential map from ``p`` to ``q`` as

````math
    q =
    \operatorname{exp}_p(X)
    =
    p \operatorname{Exp}((p^{+}X)^{\mathrm{T}})
    \operatorname{Exp}([p^{+}X - (p^{+}X)^{\mathrm{T}}]),
    X \in T_p\mathrm{Sp},
````

and with the geodesic distance between ``p`` and ``q`` given by

```math
\operatorname{dist}(p, q) = \lVert X \rVert_p = \lVert p^+ X \rVert_{\mathrm{Fr}}
```

we see that

```math
  \begin{align*}
   \lVert\operatorname{Log}(p^+q)\rVert_{\mathrm{Fr}}
    &=\Bigl\lVert
        \operatorname{Log}\bigl(
            \operatorname{Exp}((p^{+}X)^{\mathrm{T}})
            \operatorname{Exp}(p^{+}X - (p^{+}X)^{\mathrm{T}})
        \bigr)
    \Bigr\rVert_{\mathrm{Fr}} \\
    &=\lVert p^{+}X + \frac{1}{2}[(p^{+}X)^{\mathrm{T}}, p^{+}X - (p^{+}X)^{\mathrm{T}}]
        + \ldots\lVert_{\mathrm{Fr}} \\
    &≈\lVert p^{+}X\rVert_{\mathrm{Fr}} = \operatorname{dist}(p, q).
  \end{align*}
```
"""
function distance(M::SymplecticMatrices, p, q)
    return norm(log(symplectic_inverse_times(M, p, q)))
end

embed(::SymplecticMatrices, p) = p
embed(::SymplecticMatrices, p, X) = X

@doc raw"""
    exp(M::SymplecticMatrices, p, X)
    exp!(M::SymplecticMatrices, q, p, X)

The Exponential mapping on the Symplectic manifold with the
[`RealSymplecticMetric`](@ref) Riemannian metric.

For the point ``p \in \mathrm{Sp}(2n)`` the exponential mapping along the tangent
vector ``X \in T_p\mathrm{Sp}(2n)`` is computed as [WangSunFiori:2018](@cite)
````math
    \operatorname{exp}_p(X) = p \operatorname{Exp}((p^{-1}X)^{\mathrm{T}})
                                \operatorname{Exp}(p^{-1}X - (p^{-1}X)^{\mathrm{T}}),
````
where ``\operatorname{Exp}(⋅)`` denotes the matrix exponential.
"""
exp(::SymplecticMatrices, ::Any, ::Any)

function exp!(M::SymplecticMatrices, q, p, X)
    p_star_X = symplectic_inverse_times(M, p, X)
    q .= p * exp(Array(p_star_X')) * exp(p_star_X - p_star_X')
    return q
end

function get_embedding(::SymplecticMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return Euclidean(2 * n, 2 * n; field = 𝔽)
end
function get_embedding(M::SymplecticMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return Euclidean(2 * n, 2 * n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymplecticMatrices)
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    gradient(M::SymplecticMatrices, f, p, backend::RiemannianProjectionBackend; extended_metric=true)
    gradient!(M::SymplecticMatrices, f, p, backend::RiemannianProjectionBackend; extended_metric=true)

Compute the manifold gradient ``\text{grad}f(p)`` of a scalar function
``f \colon \mathrm{Sp}(2n) → ℝ`` at
``p \in \mathrm{Sp}(2n)``.

The element ``\text{grad}f(p)`` is found as the Riesz representer of the differential
``\text{D}f(p) \colon T_p\mathrm{Sp}(2n) → ℝ`` with respect to
the Riemannian metric inner product at ``p`` [Fiori:2011](@cite)].
That is, ``\text{grad}f(p) \in T_p\mathrm{Sp}(2n)`` solves the relation

```math
    g_p(\text{grad}f(p), X) = \text{D}f(p) \quad\forall\; X \in T_p\mathrm{Sp}(2n).
```

The default behaviour is to first change the representation of the Euclidean gradient from
the Euclidean metric to the [`RealSymplecticMetric`](@ref) at ``p``, and then we projecting
the result onto the correct tangent tangent space ``T_p\mathrm{Sp}(2n, ℝ)``
w.r.t the Riemannian metric ``g_p`` extended to the entire embedding space.

# Arguments:
* `extended_metric = true`: If `true`, compute the gradient ``\text{grad}f(p)`` by
    first changing the representer of the Euclidean gradient of a smooth extension
    of ``f``, ``∇f(p)``, with respect to the [`RealSymplecticMetric`](@ref) at ``p``
    extended to the entire embedding space, before projecting onto the correct
    tangent vector space with respect to the same extended metric ``g_p``.
    If `false`, compute the gradient by first projecting ``∇f(p)`` onto the
    tangent vector space, before changing the representer in the tangent
    vector space to comply with the [`RealSymplecticMetric`](@ref).
"""
function ManifoldDiff.gradient(
        M::SymplecticMatrices,
        f,
        p,
        backend::RiemannianProjectionBackend;
        extended_metric = true,
    )
    Y = allocate_result(M, gradient, p)
    return gradient!(M, f, Y, p, backend; extended_metric = extended_metric)
end

function ManifoldDiff.gradient!(
        M::SymplecticMatrices,
        f,
        X,
        p,
        backend::RiemannianProjectionBackend;
        extended_metric = true,
    )
    _gradient!(f, X, p, backend.diff_backend)
    if extended_metric
        MetricM = MetricManifold(get_embedding(M), ExtendedSymplecticMetric())
        change_representer!(MetricM, X, EuclideanMetric(), p, X)
        return project!(MetricM, X, p, X)
    else
        project!(M, X, p, X)
        return change_representer!(M, X, EuclideanMetric(), p, X)
    end
end

@doc raw"""
    inner(::SymplecticMatrices{ℝ}, p, X, Y)

Compute the canonical Riemannian inner product [`RealSymplecticMetric`](@ref)
````math
    g_p(X, Y) = \operatorname{tr}((p^{-1}X)^{\mathrm{T}} (p^{-1}Y))
````
between the two tangent vectors ``X, Y \in T_p\mathrm{Sp}(2n)``.
"""
function inner(M::SymplecticMatrices{ℝ}, p, X, Y)
    p_star = inv(M, p)
    return dot((p_star * X), (p_star * Y))
end

@doc raw"""
    symplectic_inverse(A)

Given a matrix
```math
  A ∈ ℝ^{2n×2k},\quad
  A =
  \begin{bmatrix}
  A_{1,1} & A_{1,2} \\
  A_{2,1} & A_{2, 2}
  \end{bmatrix}
```

the symplectic inverse is defined as:

```math
A^{+} := J_{2k}^{\mathrm{T}} A^{\mathrm{T}} J_{2n},
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

The symplectic inverse of A can be expressed explicitly as:

```math
A^{+} =
  \begin{bmatrix}
    A_{2, 2}^{\mathrm{T}} & -A_{1, 2}^{\mathrm{T}} \\[1.2mm]
   -A_{2, 1}^{\mathrm{T}} &  A_{1, 1}^{\mathrm{T}}
  \end{bmatrix}.
```
"""
function symplectic_inverse(A::AbstractMatrix)
    N, K = size(A)
    @assert iseven(N) "The first matrix dimension of A ($N) has to be even"
    @assert iseven(K) "The second matrix dimension of A ($K) has to be even"
    n = div(N, 2)
    k = div(K, 2)
    Ai = similar(A')
    checkbounds(A, 1:(2n), 1:(2k))
    @inbounds for i in 1:k, j in 1:n
        Ai[i, j] = A[j + n, i + k]
    end
    @inbounds for i in 1:k, j in 1:n
        Ai[i + k, j] = -A[j + n, i]
    end
    @inbounds for i in 1:k, j in 1:n
        Ai[i, j + n] = -A[j, i + k]
    end
    @inbounds for i in 1:k, j in 1:n
        Ai[i + k, j + n] = A[j, i]
    end
    return Ai
end

@doc raw"""
    inv(::SymplecticMatrices, A)
    inv!(::SymplecticMatrices, A)

Compute the symplectic inverse ``A^+`` of matrix ``A ∈ ℝ^{2n×2n}``.
See [`symplectic_inverse`](@ref) for details.

"""
function Base.inv(::SymplecticMatrices{ℝ}, A)
    return symplectic_inverse(A)
end

function symplectic_inverse!(A)
    n = div(size(A, 1), 2)
    checkbounds(A, 1:(2n), 1:(2n))
    @inbounds for i in 1:n, j in 1:n
        A[i, j], A[j + n, i + n] = A[j + n, i + n], A[i, j]
    end
    @inbounds for i in 1:n, j in i:n
        if i == j
            A[i, j + n] = -A[i, j + n]
        else
            A[i, j + n], A[j, i + n] = -A[j, i + n], -A[i, j + n]
        end
    end
    @inbounds for i in 1:n, j in i:n
        if i == j
            A[i + n, j] = -A[i + n, j]
        else
            A[i + n, j], A[j + n, i] = -A[j + n, i], -A[i + n, j]
        end
    end
    return A
end

@doc raw"""
    inv!(M::SymplecticMatrices, A)

Compute the [`symplectic_inverse`](@ref) of a square matrix A in place of A
"""
function inv!(M::SymplecticMatrices{ℝ}, A)
    return symplectic_inverse!(A)
end

@doc raw"""
    inverse_retract(M::SymplecticMatrices, p, q, ::CayleyInverseRetraction)

Compute the Cayley Inverse Retraction ``X = \mathcal{L}_p^{\mathrm{Sp}}(q)``
such that the Cayley Retraction from ``p`` along ``X`` lands at ``q``, i.e.
``\mathcal{R}_p(X) = q`` [BendokatZimmermann:2021](@cite).

For ``p, q ∈ \mathrm{Sp}(2n, ℝ)`` then, we can define the
inverse Cayley retraction as long as the following matrices exist.
````math
    U = (I + p^+ q)^{-1}, \quad V = (I + q^+ p)^{-1},
````

where ``(⋅)^+`` denotes the [`symplectic_inverse`](@ref).

Then inverse Cayley retraction at ``p`` applied to ``q`` is
```math
\mathcal{L}_p^{\mathrm{Sp}}(q)
  = 2p\bigl(V - U\bigr) + 2\bigl((p + q)U - p\bigr) ∈ T_p\mathrm{Sp}(2n).
```
"""
inverse_retract(::SymplecticMatrices, p, q, ::CayleyInverseRetraction)

function inverse_retract_cayley!(M::SymplecticMatrices, X, p, q)
    U_inv = lu(add_scaled_I!(symplectic_inverse_times(M, p, q), 1))
    V_inv = lu(add_scaled_I!(symplectic_inverse_times(M, q, p), 1))

    X .= 2 .* ((p / V_inv .- p / U_inv) .+ ((p + q) / U_inv) .- p)
    return X
end

"""
    is_flat(::SymplecticMatrices)

Return false. [`SymplecticMatrices`](@ref) is not a flat manifold.
"""
is_flat(M::SymplecticMatrices) = false

@doc raw"""
    manifold_dimension(::SymplecticMatrices)

Returns the dimension of the symplectic manifold
embedded in ``ℝ^{2n×2n}``, i.e.
```math
  \operatorname{dim}(\mathrm{Sp}(2n)) = (2n + 1)n.
```
"""
function manifold_dimension(M::SymplecticMatrices)
    n = get_parameter(M.size)[1]
    return (2n + 1) * n
end

@doc raw"""
    project(::SymplecticMatrices, p, A)
    project!(::SymplecticMatrices, Y, p, A)

Given a point ``p \in \mathrm{Sp}(2n)``,
project an element ``A \in ℝ^{2n×2n}`` onto
the tangent space ``T_p\mathrm{Sp}(2n)`` relative to
the euclidean metric of the embedding ``ℝ^{2n×2n}``.

That is, we find the element ``X \in T_p\operatorname{Sp}(2n)``
which solves the constrained optimization problem
````math
    \operatorname{min}_{X \in ℝ^{2n×2n}} \frac{1}{2}\lVert X - A\rVert^2, \quad
    \text{such that}\;
    h(X) := X^{\mathrm{T}} J_{2n} p + p^{\mathrm{T}} J_{2n} X = 0,
````
where ``h: ℝ^{2n×2n} → \operatorname{skew}(2n)`` denotes
the restriction of ``X`` onto the tangent space ``T_p\operatorname{SpSt}(2n, 2k)``
and ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).
"""
project(::SymplecticMatrices, p, A)

function project!(::SymplecticMatrices, Y, p, A)
    J = SymplecticElement(Y, p, A)
    Jp = J * p

    function h(X)
        XtJp = X' * Jp
        return XtJp .- XtJp'
    end

    # Solve for Λ (Lagrange mutliplier):
    pT_p = p' * p  # (2k×2k)
    Λ = sylvester(pT_p, pT_p, h(A) ./ 2)

    Y[:, :] = A .- Jp * (Λ .- Λ')
    return Y
end

@doc raw"""
    project!(::MetricManifold{𝔽,<:Euclidean,ExtendedSymplecticMetric}, Y, p, X) where {𝔽}

Compute the projection of ``X ∈ R^{2n×2n}`` onto ``T_p\mathrm{Sp}(2n, ℝ)`` with respect to
the [`RealSymplecticMetric`](@ref) ``g``.

The closed form projection mapping is given by [GaoSonAbsilStykel:2021](@cite)

````math
  \operatorname{P}^{T_p\mathrm{Sp}(2n)}_{g_p}(X) = pJ_{2n}\operatorname{sym}(p^{\mathrm{T}}J_{2n}^{\mathrm{T}}X),
````

where ``\operatorname{sym}(A) = \frac{1}{2}(A + A^{\mathrm{T}})`` and and ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).
"""
function project!(::MetricManifold{<:Any, <:Euclidean, ExtendedSymplecticMetric}, Y, p, X)
    J = SymplecticElement(p, X)

    pTJTX = p' * J' * X
    sym_pTJTX = (1 / 2) .* (pTJTX + pTJTX')
    Y .= p * J * (sym_pTJTX)
    return Y
end

@doc raw"""
    project_normal!(::MetricManifold{𝔽,<:Euclidean,ExtendedSymplecticMetric}, Y, p, X)

Project onto the normal of the tangent space ``(T_p\mathrm{Sp}(2n))^{\perp_g}`` at
a point ``p ∈ \mathrm{Sp}(2n)``, relative to the riemannian metric
``g`` [`RealSymplecticMetric`](@ref).

That is,

````math
(T_p\mathrm{Sp}(2n))^{\perp_g}
 = \{Y ∈ ℝ^{2n×2n} : g_p(Y, X) = 0 \test{ for all } X \in T_p\mathrm{Sp}(2n)\}.
````

The closed form projection operator onto the normal space is given by [GaoSonAbsilStykel:2021](@cite)

````math
\operatorname{P}^{(T_p\mathrm{Sp}(2n))\perp}_{g_p}(X) = pJ_{2n}\operatorname{skew}(p^{\mathrm{T}}J_{2n}^{\mathrm{T}}X),
````

where ``\operatorname{skew}(A) = \frac{1}{2}(A - A^{\mathrm{T}})``
and ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

This function is not exported.
"""
function project_normal!(
        ::MetricManifold{𝔽, <:Euclidean, ExtendedSymplecticMetric},
        Y,
        p,
        X,
    ) where {𝔽}
    J = SymplecticElement(p, X)
    pTJTX = p' * J' * X
    skew_pTJTX = (1 / 2) .* (pTJTX .- pTJTX')
    Y .= p * J * skew_pTJTX
    return Y
end

@doc raw"""
    rand(::SymplecticMatrices; vector_at=nothing, σ::Real=1.0)

Generate a random point on ``\mathrm{Sp}(2n)`` or a random
tangent vector ``X \in T_p\mathrm{Sp}(2n)`` if `vector_at` is set to
a point ``p \in \mathrm{Sp}(2n)``.

A random point on ``\mathrm{Sp}(2n)`` is constructed by generating a
random Hamiltonian matrix ``Ω \in \mathfrak{sp}(2n,F)`` with norm `σ`,
and then transforming it to a symplectic matrix by applying the Cayley transform

```math
  \operatorname{cay}: \mathfrak{sp}(2n,F) → \mathrm{Sp}(2n),
  \ \Omega \mapsto (I - \Omega)^{-1}(I + \Omega).
```

To generate a random tangent vector in ``T_p\mathrm{Sp}(2n)``, this code employs the
second tangent vector space parametrization of [`SymplecticMatrices`](@ref).
It first generates a random symmetric matrix ``S`` by `S = randn(2n, 2n)`
and then symmetrizes it as `S = S + S'`.
Then ``S`` is normalized to have Frobenius norm of `σ`
and `X = pJS` is returned, where `J` is the [`SymplecticElement`](@ref).
"""
rand(SymplecticMatrices; σ::Real = 1.0, kwargs...)

function Random.rand!(
        rng::AbstractRNG,
        M::SymplecticMatrices,
        pX;
        vector_at = nothing,
        σ::Real = 1.0,
    )
    n = get_parameter(M.size)[1]
    if vector_at === nothing
        rand!(rng, HamiltonianMatrices(2n), pX; σ = σ)
        pX .= (I - pX) \ (I + pX)
        return pX
    else
        random_vector!(M, pX, vector_at; σ = σ)
        return pX
    end
end

function random_vector!(M::SymplecticMatrices, X, p; σ::Real = 1.0)
    n = get_parameter(M.size)[1]
    # Generate random symmetric matrix:
    randn!(X)
    X .= 0.5 * (X + X')
    X .*= σ / norm(X)
    lmul!(SymplecticElement(p), X)
    X .= p * X
    return X
end

@doc raw"""
    retract(::SymplecticMatrices, p, X, ::CayleyRetraction)
    retract!(::SymplecticMatrices, q, p, X, ::CayleyRetraction)

Compute the Cayley retraction on ``p ∈ \mathrm{Sp}(2n, ℝ)`` in
the direction of tangent vector ``X ∈ T_p\mathrm{Sp}(2n, ℝ)``,
as defined in by Birtea et al in proposition 2 [BirteaCaşuComănescu:2020](@cite).

Using the [`symplectic_inverse`](@ref) ``A^+`` of a matrix ``A \in ℝ^{2n×2n}``
the retraction ``\mathcal{R}: T\mathrm{Sp}(2n) → \mathrm{Sp}(2n)``
is defined pointwise as
````math
\begin{align*}
\mathcal{R}_p(X) &= p \operatorname{cay}\left(\frac{1}{2}p^{+}X\right), \\
                 &= p \operatorname{exp}_{1/1}(p^{+}X), \\
                 &= p (2I - p^{+}X)^{-1}(2I + p^{+}X).
\end{align*}
````
Here
``\operatorname{exp}_{1/1}(z) = (2 - z)^{-1}(2 + z)``
denotes the Padé (1, 1) approximation to ``\operatorname{exp}(z)``.
"""
retract(M::SymplecticMatrices, p, X)

function ManifoldsBase.retract_cayley!(M::SymplecticMatrices, q, p, X)
    return ManifoldsBase.retract_cayley_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_cayley_fused!(M::SymplecticMatrices, q, p, X, t::Number)
    p_star_X = symplectic_inverse_times(M, p, t * X)

    divisor = lu(2 * I - p_star_X)
    q .= p * (divisor \ add_scaled_I!(p_star_X, 2.0))
    return q
end

@doc raw"""
    riemannian_gradient(M::SymplecticMatrices, p, Y)

Given a gradient ``Y = \operatorname{grad} \tilde f(p)`` in the embedding ``ℝ^{2n×2n}`` or at
least around the [`SymplecticMatrices`](@ref) `M` where `p` (the embedding of) a point on `M`,
we restrict ``\tilde f`` to the manifold and denote that by ``f``.
Then the Riemannian gradient ``X = \operatorname{grad} f(p)`` is given by

```math
  X = Yp^{\mathrm{T}}p + J_{2n}pY^{\mathrm{T}}J_{2n}p,
```

where ``J_{2n}`` denotes the [`SymplecticElement`](@ref).
"""
function riemannian_gradient(::SymplecticMatrices, p, Y; kwargs...)
    J = SymplecticElement(p)
    return Y * p' * p .+ (J * p) * Y' * (J * p)
end

function riemannian_gradient!(M::SymplecticMatrices, X, p, Y; kwargs...)
    J = SymplecticElement(p, X)
    X .= Y * p'p .+ (J * p) * Y' * (J * p)
    return X
end

function Base.show(io::IO, ::SymplecticMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "SymplecticMatrices($(2n), $(𝔽))")
end
function Base.show(io::IO, M::SymplecticMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "SymplecticMatrices($(2n), $(𝔽); parameter=:field)")
end

@doc raw"""
    symplectic_inverse_times(::SymplecticMatrices, p, q)
    symplectic_inverse_times!(::SymplecticMatrices, A, p, q)

Directly compute the symplectic inverse of ``p \in \mathrm{Sp}(2n)``,
multiplied with ``q \in \mathrm{Sp}(2n)``.
That is, this function efficiently computes
``p^+q = (J_{2n}p^{\mathrm{T}}J_{2n})q ∈ ℝ^{2n×2n}``,
where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

"""
function symplectic_inverse_times(M::SymplecticMatrices, p, q)
    A = similar(p)
    return symplectic_inverse_times!(M, A, p, q)
end

function symplectic_inverse_times!(M::SymplecticMatrices, A, p, q)
    n = get_parameter(M.size)[1]
    # we write p = [p1 p2; p3 p4] (and q, too), then
    p1 = @view(p[1:n, 1:n])
    p2 = @view(p[1:n, (n + 1):(2n)])
    p3 = @view(p[(n + 1):(2n), 1:n])
    p4 = @view(p[(n + 1):(2n), (n + 1):(2n)])
    q1 = @view(q[1:n, 1:n])
    q2 = @view(q[1:n, (n + 1):(2n)])
    q3 = @view(q[(n + 1):(2n), 1:n])
    q4 = @view(q[(n + 1):(2n), (n + 1):(2n)])
    A1 = @view(A[1:n, 1:n])
    A2 = @view(A[1:n, (n + 1):(2n)])
    A3 = @view(A[(n + 1):(2n), 1:n])
    A4 = @view(A[(n + 1):(2n), (n + 1):(2n)])
    mul!(A1, p4', q1) # A1 = p4'q1
    mul!(A1, p2', q3, -1, 1) # A1 -= p2'p3
    mul!(A2, p4', q2) # A2 = p4'q2
    mul!(A2, p2', q4, -1, 1) #A2 -= p2'q4
    mul!(A3, p1', q3) #A3 = p1'q3
    mul!(A3, p3', q1, -1, 1) # A3 -= p3'q1
    mul!(A4, p1', q4) # A4 = p1'q4
    mul!(A4, p3', q2, -1, 1) #A4 -= p3'q2
    return A
end

ndims(J::SymplecticElement) = 2
copy(J::SymplecticElement) = SymplecticElement(copy(J.λ))
Base.eltype(::SymplecticElement{T}) where {T} = T
function Base.convert(::Type{SymplecticElement{T}}, J::SymplecticElement) where {T}
    return SymplecticElement(convert(T, J.λ))
end

function Base.show(io::IO, J::SymplecticElement)
    s = "$(J.λ)"
    if occursin(r"\w+\s*[\+\-]\s*\w+", s)
        s = "($s)"
    end
    return print(io, typeof(J), "(): $(s)*[0 I; -I 0]")
end

(Base.:-)(J::SymplecticElement) = SymplecticElement(-J.λ)

function (Base.:^)(J::SymplecticElement, n::Integer)
    return ifelse(
        n % 2 == 0,
        UniformScaling((-1)^(div(n, 2)) * (J.λ)^n),
        SymplecticElement((-1)^(div(n - 1, 2)) * (J.λ)^n),
    )
end

(Base.:*)(x::Number, J::SymplecticElement) = SymplecticElement(x * J.λ)
(Base.:*)(J::SymplecticElement, x::Number) = SymplecticElement(x * J.λ)
function (Base.:*)(J::SymplecticElement, K::SymplecticElement)
    return LinearAlgebra.UniformScaling(-J.λ * K.λ)
end

Base.transpose(J::SymplecticElement) = -J
Base.adjoint(J::SymplecticElement) = SymplecticElement(-conj(J.λ))
Base.inv(J::SymplecticElement) = SymplecticElement(-(1 / J.λ))

(Base.:+)(J::SymplecticElement, K::SymplecticElement) = SymplecticElement(J.λ + K.λ)
(Base.:-)(J::SymplecticElement, K::SymplecticElement) = SymplecticElement(J.λ - K.λ)

(Base.:+)(J::SymplecticElement, p::AbstractMatrix) = p + J
function (Base.:+)(p::AbstractMatrix, J::SymplecticElement)
    # When we are adding, the Matrices must match in size:
    two_n, two_k = size(p)
    if (two_n % 2 != 0) || (two_n != two_k)
        throw(
            ArgumentError(
                "'p' must be square with even row and dimension, " *
                    "was: ($(two_n), $(two_k)) != (2n, 2n).",
            ),
        )
    end
    n = div(two_n, 2)

    # Allocate new memory:
    TS = typeof(one(eltype(p)) + one(eltype(J)))
    out = copyto!(similar(p, TS), p)

    add_scaled_I!(view(out, 1:n, (n + 1):(2n)), J.λ)
    add_scaled_I!(view(out, (n + 1):(2n), 1:n), -J.λ)
    return out
end

# Binary minus:
(Base.:-)(J::SymplecticElement, p::AbstractMatrix) = J + (-p)
(Base.:-)(p::AbstractMatrix, J::SymplecticElement) = p + (-J)

function (Base.:*)(J::SymplecticElement, p::AbstractVecOrMat)
    two_n = size(p)[1]
    if two_n % 2 != 0
        throw(ArgumentError("'p' must have even row dimension, was: $(two_n) != 2n."))
    end
    n = div(two_n, 2)

    # Allocate new memory:
    TS = typeof(one(eltype(p)) + one(eltype(J)))
    Jp = similar(p, TS)

    # Perform left mulitply by λ*J:
    mul!((@inbounds view(Jp, 1:n, :)), J.λ, @inbounds view(p, (n + 1):lastindex(p, 1), :))
    mul!((@inbounds view(Jp, (n + 1):lastindex(Jp, 1), :)), -J.λ, @inbounds view(p, 1:n, :))

    return Jp
end

function (Base.:*)(p::AbstractMatrix, J::SymplecticElement)
    two_k = size(p)[2]
    if two_k % 2 != 0
        throw(ArgumentError("'p' must have even column dimension, was: $(two_k) != 2k."))
    end
    k = div(two_k, 2)

    # Allocate new memory:
    TS = typeof(one(eltype(p)) + one(eltype(J)))
    pJ = similar(p, TS)

    # Perform right mulitply by λ*J:
    mul!((@inbounds view(pJ, :, 1:k)), -J.λ, @inbounds view(p, :, (k + 1):lastindex(p, 2)))
    mul!((@inbounds view(pJ, :, (k + 1):lastindex(pJ, 2))), J.λ, @inbounds view(p, :, 1:k))
    return pJ
end

function LinearAlgebra.lmul!(J::SymplecticElement, p::AbstractVecOrMat)
    # Perform left multiplication by a symplectic matrix,
    # overwriting the matrix p in place:
    two_n = size(p)[1]
    if two_n % 2 != 0
        throw(ArgumentError("'p' must have even row dimension, was: $(two_n) != 2n."))
    end
    n = div(two_n, 2)

    half_row_p = copy(@inbounds view(p, 1:n, :))
    mul!((@inbounds view(p, 1:n, :)), J.λ, @inbounds view(p, (n + 1):lastindex(p, 1), :))
    mul!((@inbounds view(p, (n + 1):lastindex(p, 1), :)), -J.λ, @inbounds view(half_row_p, :, :))
    return p
end

function LinearAlgebra.rmul!(p::AbstractMatrix, J::SymplecticElement)
    # Perform right multiplication by a symplectic matrix,
    # overwriting the matrix p in place:
    two_k = size(p)[2]
    if two_k % 2 != 0
        throw(ArgumentError("'p' must have even column dimension, was: $(two_k) != 2k."))
    end
    k = div(two_k, 2)

    half_col_p = copy(@inbounds view(p, :, 1:k))
    mul!((@inbounds view(p, :, 1:k)), -J.λ, @inbounds view(p, :, (k + 1):lastindex(p, 2)))
    mul!((@inbounds view(p, :, (k + 1):lastindex(p, 2))), J.λ, @inbounds view(half_col_p, :, :))
    return p
end

function LinearAlgebra.mul!(A::AbstractVecOrMat, J::SymplecticElement, p::AbstractVecOrMat)
    size_p = size(p)
    two_n = size_p[1]
    if two_n % 2 != 0
        throw(ArgumentError("'p' must have even row dimension, was: $(two_n) != 2n."))
    end
    n = div(two_n, 2)
    k = length(size_p) == 1 ? 0 : div(size_p[2], 2)

    # k == 0 means we're multiplying with a vector:
    @boundscheck k == 0 ? checkbounds(A, 1:(2n), 1) : checkbounds(A, 1:(2n), 1:(2k))

    # Perform left multiply by λ*J:
    mul!((@inbounds view(A, 1:n, :)), J.λ, @inbounds view(p, (n + 1):lastindex(p, 1), :))
    mul!((@inbounds view(A, (n + 1):lastindex(A, 1), :)), -J.λ, @inbounds view(p, 1:n, :))
    return A
end

function LinearAlgebra.mul!(A::AbstractVecOrMat, p::AbstractMatrix, J::SymplecticElement)
    two_n, two_k = size(p)
    if two_k % 2 != 0
        throw(ArgumentError("'p' must have even col dimension, was: $(two_k) != 2k."))
    end
    n = div(two_n, 2)
    k = div(two_k, 2)

    # n == 0 means we're multiplying with a vector:
    @boundscheck n == 0 ? checkbounds(A, 1, 1:(2k)) : checkbounds(A, 1:(2n), 1:(2k))

    # Perform right multiply by λ*J:
    mul!((@inbounds view(A, :, 1:k)), -J.λ, @inbounds view(p, :, (k + 1):lastindex(p, 2)))
    mul!((@inbounds view(A, :, (k + 1):lastindex(A, 2))), J.λ, @inbounds view(p, :, 1:k))
    return A
end

function add_scaled_I!(A::AbstractMatrix, λ::Number)
    LinearAlgebra.checksquare(A)
    @inbounds for i in axes(A, 1)
        A[i, i] += λ
    end
    return A
end

include("../header.jl")

using RecursiveArrayTools: ArrayPartition

@testset "Product manifold" begin
    @test_throws MethodError ProductManifold()
    M1 = Sphere(2)
    M2 = Euclidean(2)
    @test (@inferred ProductManifold(M1, M2)) isa ProductManifold
    Mse = ProductManifold(M1, M2)
    @test Mse == M1 × M2
    @test !is_flat(Mse)
    @test Mse == ProductManifold(M1) × M2
    @test Mse == ProductManifold(M1) × ProductManifold(M2)
    @test Mse == M1 × ProductManifold(M2)
    @test Mse[1] == M1
    @test Mse[2] == M2
    @test injectivity_radius(Mse) ≈ π
    @test injectivity_radius(
        Mse,
        ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
    ) ≈ π
    @test injectivity_radius(Mse, ExponentialRetraction()) ≈ π
    @test injectivity_radius(
        Mse,
        ArrayPartition([0.0, 1.0, 0.0], [0.0, 0.0]),
        ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
    ) ≈ π
    @test injectivity_radius(
        Mse,
        ArrayPartition([0.0, 1.0, 0.0], [0.0, 0.0]),
        ExponentialRetraction(),
    ) ≈ π
    @test is_default_metric(Mse, ProductMetric())

    @test Manifolds.number_of_components(Mse) == 2
    # test that arrays are not points
    @test_throws DomainError is_point(Mse, [1, 2]; error = :error)
    @test check_point(Mse, [1, 2]) isa DomainError
    @test_throws DomainError is_vector(Mse, 1, [1, 2]; error = :error, check_base_point = false)
    @test check_vector(Mse, 1, [1, 2]; check_base_point = false) isa DomainError
    #default fallbacks for check_size, Product not working with Arrays
    @test Manifolds.check_size(Mse, zeros(2)) isa DomainError
    @test Manifolds.check_size(Mse, zeros(2), zeros(3)) isa DomainError
    types = [Vector{Float64}]

    retraction_methods = [
        ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
        ExponentialRetraction(),
    ]
    inverse_retraction_methods = [
        InverseProductRetraction(
            LogarithmicInverseRetraction(),
            LogarithmicInverseRetraction(),
        ),
        LogarithmicInverseRetraction(),
    ]

    @testset "arithmetic" begin
        Mee = ProductManifold(Euclidean(3), Euclidean(2))
        p1 = ArrayPartition([0.0, 1.0, 0.0], [0.0, 1.0])
        p2 = ArrayPartition([1.0, 2.0, 0.0], [2.0, 3.0])

        @test isapprox(Mee, p1 + p2, ArrayPartition([1.0, 3.0, 0.0], [2.0, 4.0]))
        @test isapprox(Mee, p1 - p2, ArrayPartition([-1.0, -1.0, 0.0], [-2.0, -2.0]))
        @test isapprox(Mee, -p1, ArrayPartition([0.0, -1.0, 0.0], [0.0, -1.0]))
        @test isapprox(Mee, p1 * 2, ArrayPartition([0.0, 2.0, 0.0], [0.0, 2.0]))
        @test isapprox(Mee, 2 * p1, ArrayPartition([0.0, 2.0, 0.0], [0.0, 2.0]))
        @test isapprox(Mee, p1 / 2, ArrayPartition([0.0, 0.5, 0.0], [0.0, 0.5]))
    end

    M3 = Rotations(2)
    Mser = ProductManifold(M1, M2, M3)

    @test submanifold(Mser, 2) == M2
    @test (@inferred submanifold(Mser, Val((1, 3)))) == M1 × M3
    @test submanifold(Mser, 2:3) == M2 × M3
    @test submanifold(Mser, [1, 3]) == M1 × M3

    pts_sphere = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]]
    pts_r2 = [[0.0, 0.0], [1.0, 0.0], [0.0, 0.1]]
    angles = (0.0, π / 2, 2π / 3)
    pts_rot = [[cos(ϕ) sin(ϕ); -sin(ϕ) cos(ϕ)] for ϕ in angles]
    pts = [ArrayPartition(p[1], p[2], p[3]) for p in zip(pts_sphere, pts_r2, pts_rot)]
    Manifolds.test_manifold(
        Mser,
        pts,
        test_injectivity_radius = false,
        is_tangent_atol_multiplier = 1,
        exp_log_atol_multiplier = 1,
        test_inplace = true,
        test_rand_point = true,
        test_rand_tvector = true,
        test_representation_size = false,
    )

    @testset "manifold tests (static size)" begin
        Ts = SizedVector{3, Float64}
        Tr2 = SizedVector{2, Float64}
        pts_sphere = [
            convert(Ts, [1.0, 0.0, 0.0]),
            convert(Ts, [0.0, 1.0, 0.0]),
            convert(Ts, [0.0, 0.0, 1.0]),
        ]
        pts_r2 =
            [convert(Tr2, [0.0, 0.0]), convert(Tr2, [1.0, 0.0]), convert(Tr2, [0.0, 0.1])]

        pts = [ArrayPartition(p[1], p[2]) for p in zip(pts_sphere, pts_r2)]
        basis_types = (
            DefaultOrthonormalBasis(),
            ProjectedOrthonormalBasis(:svd),
            get_basis(Mse, pts[1], DefaultOrthonormalBasis()),
            DiagonalizingOrthonormalBasis(
                ArrayPartition(SizedVector{3}([0.0, 1.0, 0.0]), SizedVector{2}([1.0, 0.0])),
            ),
        )
        distr_M1 = Manifolds.uniform_distribution(M1, pts_sphere[1])
        distr_M2 = Manifolds.projected_distribution(
            M2,
            Distributions.MvNormal(zero(pts_r2[1]), 1.0 * I),
        )
        @test injectivity_radius(Mse, pts[1]) ≈ π
        @test injectivity_radius(Mse) ≈ π
        @test injectivity_radius(Mse, pts[1], ExponentialRetraction()) ≈ π
        @test injectivity_radius(Mse, ExponentialRetraction()) ≈ π

        @test ManifoldsBase.allocate_coordinates(
            Mse,
            pts[1],
            Float64,
            number_of_coordinates(Mse, DefaultOrthogonalBasis()),
        ) isa Vector{Float64}

        Y = allocate(pts[1])
        inverse_retract!(Mse, Y, pts[1], pts[2], default_inverse_retraction_method(Mse))
        @test isapprox(
            Mse,
            pts[1],
            Y,
            inverse_retract(Mse, pts[1], pts[2], default_inverse_retraction_method(Mse)),
        )

        Mse_point_distributions = []
        Mse_tvector_distributions = []

        if VERSION >= v"1.9"
            distr_tv_M1 = Manifolds.normal_tvector_distribution(M1, pts_sphere[1], 1.0)
            distr_tv_M2 = Manifolds.normal_tvector_distribution(M2, pts_r2[1], 1.0)

            ProductPointDistribution =
                Base.get_extension(
                Manifolds,
                :ManifoldsDistributionsExt,
            ).ProductPointDistribution
            push!(Mse_point_distributions, ProductPointDistribution(distr_M1, distr_M2))

            ProductFVectorDistribution =
                Base.get_extension(
                Manifolds,
                :ManifoldsDistributionsExt,
            ).ProductFVectorDistribution
            push!(
                Mse_tvector_distributions,
                ProductFVectorDistribution(distr_tv_M1, distr_tv_M2),
            )

            MPointSupport =
                Base.get_extension(Manifolds, :ManifoldsDistributionsExt).MPointSupport
            FVectorSupport =
                Base.get_extension(Manifolds, :ManifoldsDistributionsExt).FVectorSupport

            Test.@test Distributions.support(Mse_point_distributions[1]) isa MPointSupport
            Test.@test Distributions.support(Mse_tvector_distributions[1]) isa
                FVectorSupport
        end

        Manifolds.test_manifold(
            Mse,
            pts;
            point_distributions = Mse_point_distributions,
            tvector_distributions = Mse_tvector_distributions,
            test_injectivity_radius = true,
            test_musical_isomorphisms = true,
            musical_isomorphism_bases = [DefaultOrthonormalBasis()],
            test_tangent_vector_broadcasting = true,
            test_project_tangent = true,
            test_project_point = true,
            test_mutating_rand = true,
            retraction_methods = retraction_methods,
            inverse_retraction_methods = inverse_retraction_methods,
            test_riesz_representer = true,
            test_default_vector_transport = true,
            test_rand_point = true,
            test_rand_tvector = true,
            vector_transport_methods = [
                ProductVectorTransport(ParallelTransport(), ParallelTransport()),
                ProductVectorTransport(SchildsLadderTransport(), SchildsLadderTransport()),
                ProductVectorTransport(PoleLadderTransport(), PoleLadderTransport()),
            ],
            basis_types_vecs = (basis_types[1], basis_types[3], basis_types[4]),
            basis_types_to_from = basis_types,
            is_tangent_atol_multiplier = 1,
            exp_log_atol_multiplier = 1,
            test_representation_size = false,
        )
        @test number_eltype(pts[1]) === Float64

        @test (@inferred ManifoldsBase._get_vector_cache_broadcast(pts[1])) === Val(false)
    end

    @testset "vee/hat" begin
        M1 = Rotations(3)
        M2 = Euclidean(3)
        M = M1 × M2

        e = Matrix{Float64}(I, 3, 3)
        p = ArrayPartition(exp(M1, e, hat(M1, e, [1.0, 2.0, 3.0])), [1.0, 2.0, 3.0])
        X = [0.1, 0.2, 0.3, -1.0, 2.0, -3.0]

        Xc = hat(M, p, X)
        X2 = vee(M, p, Xc)
        @test isapprox(X, X2)
    end

    @testset "empty allocation" begin
        p = allocate_result(Mse, Manifolds.uniform_distribution)
        @test isa(p, ArrayPartition)
        @test size(p[Mse, 1]) == (3,)
        @test size(p[Mse, 2]) == (2,)
    end

    @testset "Uniform distribution" begin
        Mss = ProductManifold(Sphere(2), Sphere(2))
        p = rand(Manifolds.uniform_distribution(Mss))
        @test is_point(Mss, p)
        @test is_point(Mss, rand(Manifolds.uniform_distribution(Mss, p)))
    end

    @testset "Atlas & Induced Basis" begin
        M = ProductManifold(Euclidean(2), Euclidean(2))
        p = ArrayPartition(zeros(2), ones(2))
        X = ArrayPartition(ones(2), 2 .* ones(2))
        A = RetractionAtlas()
        a = get_parameters(M, A, p, p)
        p2 = get_point(M, A, p, a)
        @test all(submanifold_components(p2) .== submanifold_components(p))
    end

    @testset "metric conversion" begin
        M = SymmetricPositiveDefinite(3)
        N = ProductManifold(M, M)
        e = EuclideanMetric()
        p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]
        q = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
        P = ArrayPartition(p, q)
        X = ArrayPartition(log(M, p, q), log(M, q, p))
        Y = change_metric(N, e, P, X)
        Yc = ArrayPartition(
            change_metric(M, e, p, log(M, p, q)),
            change_metric(M, e, q, log(M, q, p)),
        )
        @test norm(N, P, Y - Yc) ≈ 0
        Z = change_representer(N, e, P, X)
        Zc = ArrayPartition(
            change_representer(M, e, p, log(M, p, q)),
            change_representer(M, e, q, log(M, q, p)),
        )
        @test norm(N, P, Z - Zc) ≈ 0
    end

    @testset "default retraction, inverse retraction and VT" begin
        Mstb = ProductManifold(M1, TangentBundle(M1))
        T_p_ap = ArrayPartition{
            Float64,
            Tuple{
                Matrix{Float64},
                ArrayPartition{Float64, Tuple{Matrix{Float64}, Matrix{Float64}}},
            },
        }
        @test Manifolds.default_retraction_method(Mstb) === ProductRetraction(
            ExponentialRetraction(),
            Manifolds.FiberBundleProductRetraction(),
        )
        @test Manifolds.default_retraction_method(Mstb, T_p_ap) === ProductRetraction(
            ExponentialRetraction(),
            Manifolds.FiberBundleProductRetraction(),
        )

        @test Manifolds.default_inverse_retraction_method(Mstb) ===
            Manifolds.InverseProductRetraction(
            LogarithmicInverseRetraction(),
            Manifolds.FiberBundleInverseProductRetraction(),
        )
        @test Manifolds.default_inverse_retraction_method(Mstb, T_p_ap) ===
            Manifolds.InverseProductRetraction(
            LogarithmicInverseRetraction(),
            Manifolds.FiberBundleInverseProductRetraction(),
        )

        @test Manifolds.default_vector_transport_method(Mstb) === ProductVectorTransport(
            ParallelTransport(),
            Manifolds.FiberBundleProductVectorTransport(
                ParallelTransport(),
                ParallelTransport(),
            ),
        )
        @test Manifolds.default_vector_transport_method(Mstb, T_p_ap) ===
            ProductVectorTransport(
            ParallelTransport(),
            Manifolds.FiberBundleProductVectorTransport(
                ParallelTransport(),
                ParallelTransport(),
            ),
        )
        @test Manifolds.default_vector_transport_method(Mstb, T_p_ap) ===
            ProductVectorTransport(
            ParallelTransport(),
            Manifolds.FiberBundleProductVectorTransport(
                ParallelTransport(),
                ParallelTransport(),
            ),
        )
    end

    @testset "ManifoldDiff" begin
        p = ArrayPartition([0.0, 1.0, 0.0], [2.0, 3.0])
        q = ArrayPartition([1.0, 0.0, 0.0], [-2.0, 3.0])
        X = ArrayPartition([1.0, 0.0, 0.0], [2.0, 3.0])
        # ManifoldDiff
        @test ManifoldDiff.adjoint_Jacobi_field(
            Mse,
            p,
            q,
            0.5,
            X,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) == ArrayPartition([0.5, 0.0, 0.0], [1.0, 1.5])
        X2 = allocate(X)
        ManifoldDiff.adjoint_Jacobi_field!(
            Mse,
            X2,
            p,
            q,
            0.5,
            X,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        )
        @test X2 == ArrayPartition([0.5, 0.0, 0.0], [1.0, 1.5])
        @test ManifoldDiff.jacobi_field(
            Mse,
            p,
            q,
            0.5,
            X,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) == ArrayPartition([0.3535533905932738, -0.35355339059327373, 0.0], [1.0, 1.5])
        X2 = allocate(X)
        ManifoldDiff.jacobi_field!(
            Mse,
            X2,
            p,
            q,
            0.5,
            X,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        )
        @test X2 ==
            ArrayPartition([0.3535533905932738, -0.35355339059327373, 0.0], [1.0, 1.5])
    end
    @testset "gradient conversion" begin
        M = ProbabilitySimplex(3)
        p = [
            0.011143450837652447,
            0.0010060921724131108,
            0.41619787908924166,
            0.571652577900693,
        ]
        X_e = [
            0.062102217532734615,
            0.04344131268205693,
            0.4262317935277549,
            -0.5317753237425427,
        ]
        X_r = riemannian_gradient(M, p, X_e)

        N = M × M

        p_2 = ArrayPartition(p, p)
        X_e_2 = ArrayPartition(X_e, X_e)
        X_r_2 = riemannian_gradient(N, p_2, X_e_2)
        @test isapprox(X_r_2, ArrayPartition(X_r, X_r))

        Y_r_2 = similar(X_r_2)
        riemannian_gradient!(N, Y_r_2, p_2, X_e_2)
        @test isapprox(Y_r_2, ArrayPartition(X_r, X_r))
    end
    @testset "Hessian conversion" begin
        M = Sphere(2)
        N = M × M
        p = ArrayPartition([1.0, 0.0, 0.0], [0.0, 0.0, 1.0])
        q = 1 / sqrt(2) * ArrayPartition([1.0, 1.0, 0.0], [0.0, 1.0, 1.0])
        q = 1 / sqrt(2) * ArrayPartition([0.0, 1.0, 1.0], [1.0, 1.0, 0.0])
        r = 1 / sqrt(3) * ArrayPartition([1.0, 1.0, 1.0], [1.0, 1.0, 1.0])
        X = log(M, p, q)
        Y = log(M, p, r)
        Z = -X
        H1 = riemannian_Hessian(N, p, Y, Z, X)
        H2 = ArrayPartition(
            [riemannian_Hessian(M, p.x[i], Y.x[i], Z.x[i], X.x[i]) for i in 1:2]...,
        )
        @test H1 == H2
        V = ArrayPartition([0.2, 0.0, 0.0], [0.0, 0.0, 0.3])
        W1 = Weingarten(N, p, X, V)
        W2 = ArrayPartition([Weingarten(M, p.x[i], X.x[i], V.x[i]) for i in 1:2]...)
        @test W1 == W2
    end
    @testset "Manifold volume" begin
        MS2 = Sphere(2)
        MS3 = Sphere(3)
        PM = ProductManifold(MS2, MS3)
        @test manifold_volume(PM) ≈ manifold_volume(MS2) * manifold_volume(MS3)
        p1 = [-0.9171596991960276, 0.39792260844341604, -0.02181017790481868]
        p2 = [
            -0.5427653626654726,
            5.420303965772687e-5,
            -0.8302022885580579,
            -0.12716099333369416,
        ]
        X1 = [-0.35333565579879633, -0.7896159441709865, 0.45204526334685574]
        X2 = [
            -0.33940201562492356,
            0.8092470417550779,
            0.18290591742514573,
            0.2548785571950708,
        ]
        @test volume_density(PM, ArrayPartition(p1, p2), ArrayPartition(X1, X2)) ≈
            volume_density(MS2, p1, X1) * volume_density(MS3, p2, X2)
    end
end

include("../header.jl")

@testset "Isochoric matrices" begin
    M = SPDFixedDeterminant(2, 1.0)
    @test repr(M) == "SPDFixedDeterminant(2, 1.0)"
    p = [1.0 0.0; 0.0 1.0]
    @test is_point(M, p)
    # Determinant is 4
    @test !is_point(M, 2.0 .* p)
    @test_throws DomainError is_point(M, 2.0 .* p; error = :error)
    #
    X = [0.0 0.1; 0.1 0.0]
    @test is_vector(M, p, X)
    Y = [1.0 0.1; 0.1 1.0]
    @test !is_vector(M, p, Y)
    @test_throws DomainError is_vector(M, p, Y; error = :error)

    @test project(M, 2.0 .* p) == p
    @test project(M, p, Y) == X

    @test embed(M, p) == p
    @test embed(M, p, X) == X
    q = zero(p)
    @test embed!(M, q, p) == p
    @test p == q
    Y = zero(X)
    @test embed!(M, Y, p, X) == X
    @test Y == X

    @test manifold_dimension(M) == 2

    q = exp(M, p, X)
    @test det(q) ≈ 1
    @test distance(M, q, exp(get_embedding(M), p, X)) ≈ 0 atol = 6.0e-16
    @test norm(M, p, log(M, p, q) - X) ≈ 0 atol = 3.0e-16
    @test norm(M, p, log(get_embedding(M), p, q) - X) ≈ 0 atol = 3.0e-16

    @testset "field parameter" begin
        M = SPDFixedDeterminant(2, 1.0; parameter = :field)
        @test repr(M) == "SPDFixedDeterminant(2, 1.0; parameter=:field)"
        @test get_embedding(M) == SymmetricPositiveDefinite(2; parameter = :field)
    end
end

"""
    Manifolds.Test

The module `Manifolds.Test` contains functions to test functions from `Manifolds.jl`.
Most functionality is provided only when `Test.jl` is loaded as well, i.e. populated
with methods by the extension.

The test functions provided are mean to verify that the defined functions
on a specific manifold behave as expected, for example that
an allocating and in-place version of a function give the same result,
or that for example the exponential map computes a point on the manifold,
and calling the logarithmic map on the result yields the original tangent vector again,
for tangent vectors within the injectivity radius.

In general for every function defined in the API for manifolds,
this module shall provide a test function with
* the same name prefixed by `test_`
* the same function arguments as the original function
* keyword arguments to control which tests to perform
"""
module Test
using ..Manifolds

"""
    AbstractExpectation

An abstract type for expectations in tests.
"""
abstract type AbstractExpectation end

"""
    Expect{T} <: AbstractExpectation

A struct to hold expected values for tests of type `T`.

# Fields
*  `value::T` the expected value

# Constructor

    Expect(value::T)
"""
struct Expect{T} <: AbstractExpectation
    value::T
end
Expect(e::Expect) = e

"""
    NoExcpectation <: AbstractExpectation

A struct to indicate that no expectation is provided for a test.
"""
struct NoExpectation <: AbstractExpectation end

Expect(ne::NoExpectation) = ne

isexpected(e::Expect) = true
isexpected(value) = true
isexpected(e::NoExpectation) = false
"""
    expected(e::Union{Expect, NoExpectation})

Check if an expectation is provided.
"""
isexpected(e::Union{Expect, NoExpectation})

expect(e::Expect{T}) where {T} = e.value
expect(value) = value
expect(e::NoExpectation) = error("No expectation provided.")
"""
    expect(e::Union{Expect{T}, NoExpectation}) where T

Get the expected value if provided, error otherwise.
"""
expect(e::Union{Expect, NoExpectation})

#
#
# Dummy Types
struct DummyMatrixType <: Manifolds.AbstractMatrixType end

const _ALL_FUNCTIONS = [
    copy,
    copyto!,
    default_inverse_retraction_method,
    default_retraction_method,
    default_vector_transport_method,
    distance,
    embed,
    embed_project,
    exp,
    flat,
    geodesic,
    get_basis,
    get_coordinates,
    get_embedding,
    get_vector,
    get_vectors,
    injectivity_radius,
    inner,
    inverse_retract,
    is_default_metric,
    is_flat,
    is_point,
    is_vector,
    log,
    manifold_dimension,
    manifold_volume,
    mid_point,
    norm,
    parallel_transport_direction,
    parallel_transport_to,
    project,
    rand,
    repr,
    representation_size,
    retract,
    sectional_curvature,
    sharp,
    shortest_geodesic,
    vector_transport_direction,
    vector_transport_to,
    volume_density,
    Weingarten,
    zero_vector,
]
all_functions() = _ALL_FUNCTIONS
#
#
# the overall global interface
function test_manifold end
#
#
# the small functions per single API function
function test_copy end
function test_copyto end
function test_default_retraction end
function test_default_inverse_retraction end
function test_default_vector_transport_method end
function test_distance end
function test_embed end
function test_embed_project end
function test_exp end
function test_flat end
function test_geodesic end
function test_get_basis end
function test_get_coordinates end
function test_get_embedding end
function test_get_vector end
function test_get_vectors end
function test_injectivity_radius end
function test_inner end
function test_inverse_retract end
function test_is_default_metric end
function test_is_flat end
function test_is_point end
function test_is_vector end
function test_log end
function test_manifold_dimension end
function test_manifold_volume end
function test_mid_point end
function test_norm end
function test_parallel_transport end
function test_project end
function test_sectional_curvature end
function test_sharp end
function test_shortest_geodesic end
function test_rand end
function test_repr end
function test_representation_size end
function test_retract end
function test_vector_transport end
function test_volume_density end
function test_Weingarten end
function test_zero_vector end
#
#
# For now not yet part of the test suite, mainly because testing them is not that easy to do
# generically.
# Please test these individually
# How to test is is approx ok?
function test_estimated_sectional_curvature_matrix end
# What to exactly test on this?
function test_sectional_curvature_matrix end
function test_affine_connection end
function test_get_atlas end
function test_get_parameters end
function test_get_point end
function test_transition_map end
function test_transition_map_diff end
function test_induced_basis end
function test_check_chart_switch end
function test_get_chart_index end
# add second variant inner(M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc)
# add second variant norm(M::AbstractManifold, A::AbstractAtlas, i, a, Xc)

# How approximate is ok?
function test_mean end
function test_median end
end

@doc raw"""
    LogCholeskyMetric <: RiemannianMetric

The Log-Cholesky metric imposes a metric based on the Cholesky decomposition as
introduced by [Lin:2019](@cite).
"""
struct LogCholeskyMetric <: RiemannianMetric end

cholesky_to_spd(x, W) = (x * x', W * x' + x * W')

tangent_cholesky_to_tangent_spd!(x, W) = (W .= W * x' + x * W')

spd_to_cholesky(p, X) = spd_to_cholesky(p, cholesky(p).L, X)

function spd_to_cholesky(p, x, X)
    w = inv(x) * X * inv(transpose(x))
    # strictly lower triangular plus half diagonal
    return (x, x * (LowerTriangular(w) - Diagonal(w) / 2))
end

@doc raw"""
    distance(M::MetricManifold{SymmetricPositiveDefinite,LogCholeskyMetric}, p, q)

Compute the distance on the manifold of [`SymmetricPositiveDefinite`](@ref)
nmatrices, i.e. between two symmetric positive definite matrices `p` and `q`
with respect to the [`LogCholeskyMetric`](@ref). The formula reads

````math
d_{\mathcal P(n)}(p,q) = \sqrt{
 \lVert ⌊ x ⌋ - ⌊ y ⌋ \rVert_{\mathrm{F}}^2
 + \lVert \log(\operatorname{diag}(x)) - \log(\operatorname{diag}(y))\rVert_{\mathrm{F}}^2 }\ \ ,
````

where ``x`` and ``y`` are the Cholesky factors of ``p`` and ``q``, respectively,
``⌊⋅⌋`` denbotes the strictly lower triangular matrix of its argument,
and ``\lVert⋅\rVert_{\mathrm{F}}`` the Frobenius norm.
"""
function distance(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric}, p, q)
    N = get_parameter(M.manifold.size)[1]
    return distance(
        CholeskySpace(N; parameter = get_parameter_type(M.manifold)),
        cholesky(p).L,
        cholesky(q).L,
    )
end

@doc raw"""
    exp(M::MetricManifold{SymmetricPositiveDefinite,LogCholeskyMetric}, p, X)

Compute the exponential map on the [`SymmetricPositiveDefinite`](@ref) `M` with
[`LogCholeskyMetric`](@ref) from `p` into direction `X`. The formula reads

````math
\exp_p X = (\exp_y W)(\exp_y W)^\mathrm{T}
````

where ``\exp_xW`` is the exponential map on [`CholeskySpace`](@ref), ``y`` is the Cholesky
decomposition of ``p``, ``W = y(y^{-1}Xy^{-\mathrm{T}})_\frac{1}{2}``,
and ``(⋅)_\frac{1}{2}``
denotes the lower triangular matrix with the diagonal multiplied by ``\frac{1}{2}``.
"""
exp(::MetricManifold{ℝ, SymmetricPositiveDefinite, LogCholeskyMetric}, ::Any, ::Any)

function exp!(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric}, q, p, X)
    N = get_parameter(M.manifold.size)[1]
    (y, W) = spd_to_cholesky(p, X)
    z = exp(CholeskySpace(N; parameter = get_parameter_type(M.manifold)), y, W)
    return copyto!(q, z * z')
end
function exp_fused!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric},
        q,
        p,
        X,
        t::Number,
    )
    return exp!(M, q, p, t * X)
end

function get_coordinates_orthonormal!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric},
        Xⁱ,
        p,
        X,
        rn::RealNumbers,
    )
    N = get_parameter(M.manifold.size)[1]
    MC = CholeskySpace(N; parameter = get_parameter_type(M.manifold))
    (y, W) = spd_to_cholesky(p, X)
    get_coordinates_orthonormal!(MC, Xⁱ, y, W, rn)
    return Xⁱ
end

function get_vector_orthonormal!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric},
        X,
        p,
        Xⁱ,
        rn::RealNumbers,
    )
    N = get_parameter(M.manifold.size)[1]
    MC = CholeskySpace(N; parameter = get_parameter_type(M.manifold))
    y = cholesky(p).L
    get_vector_orthonormal!(MC, X, y, Xⁱ, rn)
    tangent_cholesky_to_tangent_spd!(p, X)
    return X
end

@doc raw"""
    inner(M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogCholeskyMetric}, p, X, Y)

Compute the inner product of two matrices `X`, `Y` in the tangent space of `p`
on the [`SymmetricPositiveDefinite`](@ref) manifold `M`, as
a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with [`LogCholeskyMetric`](@ref). The formula reads

````math
    g_p(X,Y) = ⟨a_z(X),a_z(Y)⟩_z,
````

where ``⟨⋅,⋅⟩_x`` denotes inner product on the [`CholeskySpace`](@ref),
``z`` is the Cholesky factor of ``p``,
``a_z(W) = z (z^{-1}Wz^{-\mathrm{T}})_{\frac{1}{2}}``, and ``(⋅)_\frac{1}{2}``
denotes the lower triangular matrix with the diagonal multiplied by ``\frac{1}{2}``
"""
function inner(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric}, p, X, Y)
    N = get_parameter(M.manifold.size)[1]
    (z, Xz) = spd_to_cholesky(p, X)
    (z, Yz) = spd_to_cholesky(p, z, Y)
    return inner(CholeskySpace(N; parameter = get_parameter_type(M.manifold)), z, Xz, Yz)
end

"""
    is_flat(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogCholeskyMetric})

Return true. [`SymmetricPositiveDefinite`](@ref) with [`LogCholeskyMetric`](@ref)
is a flat manifold. See Proposition 8 of [Lin:2019](@cite).
"""
is_flat(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric}) = true

@doc raw"""
    log(M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogCholeskyMetric}, p, q)

Compute the logarithmic map on [`SymmetricPositiveDefinite`](@ref) `M` with
respect to the [`LogCholeskyMetric`](@ref) emanating from `p` to `q`.
The formula can be adapted from the [`CholeskySpace`](@ref) as
````math
\log_p q = xW^{\mathrm{T}} + Wx^{\mathrm{T}},
````
where ``x`` is the Cholesky factor of ``p`` and ``W=\log_x y`` for ``y`` the Cholesky factor
of ``q`` and the just mentioned logarithmic map is the one on [`CholeskySpace`](@ref).
"""
log(::MetricManifold{ℝ, SymmetricPositiveDefinite, LogCholeskyMetric}, ::Any...)

function log!(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric}, X, p, q)
    N = get_parameter(M.manifold.size)[1]
    x = cholesky(p).L
    y = cholesky(q).L
    log!(CholeskySpace(N; parameter = get_parameter_type(M.manifold)), X, x, y)
    return tangent_cholesky_to_tangent_spd!(x, X)
end

@doc raw"""
    vector_transport_to(
        M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogCholeskyMetric},
        p,
        X,
        q,
        ::ParallelTransport,
    )

Parallel transport the tangent vector `X` at `p` along the geodesic to `q` with respect to
the [`SymmetricPositiveDefinite`](@ref) manifold `M` and [`LogCholeskyMetric`](@ref).
The parallel transport is based on the parallel transport on [`CholeskySpace`](@ref):
Let ``x`` and ``y`` denote the Cholesky factors of `p` and `q`, respectively and
``W = x(x^{-1}Xx^{-\mathrm{T}})_\frac{1}{2}``, where ``(⋅)_\frac{1}{2}`` denotes the lower
triangular matrix with the diagonal multiplied by ``\frac{1}{2}``. With ``V`` the parallel
transport on [`CholeskySpace`](@ref) from ``x`` to ``y``. The formula hear reads

````math
\mathcal P_{q←p}X = yV^{\mathrm{T}} + Vy^{\mathrm{T}}.
````
"""
parallel_transport_to(
    ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric},
    ::Any,
    ::Any,
    ::Any,
)

function parallel_transport_to!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogCholeskyMetric},
        Y,
        p,
        X,
        q,
    )
    N = get_parameter(M.manifold.size)[1]
    y = cholesky(q).L
    (x, W) = spd_to_cholesky(p, X)
    parallel_transport_to!(
        CholeskySpace(N; parameter = get_parameter_type(M.manifold)),
        Y,
        x,
        W,
        y,
    )
    return tangent_cholesky_to_tangent_spd!(y, Y)
end

function allocate_coordinates(::ProductManifold, p, T, n::Int)
    return allocate(submanifold_component(p, 1), T, n)
end

function adjoint_Jacobi_field!(M::ProductManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    map(
        adjoint_Jacobi_field!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, q),
        ntuple(_ -> t, length(M.manifolds)),
        submanifold_components(M, X),
        ntuple(_ -> β, length(M.manifolds)),
    )
    return Y
end

metric(::ProductManifold) = ProductMetric()

@doc raw"""
    flat(M::ProductManifold, p, X::FVector{TangentSpaceType})

use the musical isomorphism to transform the tangent vector `X` from the tangent space at
`p` on the [`ProductManifold`](@extref `ManifoldsBase.ProductManifold`)
`M` to a cotangent vector. This can be done elementwise for every entry of `X` (with respect
to the corresponding entry in `p`) separately.
"""
flat(::ProductManifold, ::Any...)

function jacobi_field!(M::ProductManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    map(
        jacobi_field!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, q),
        ntuple(_ -> t, length(M.manifolds)),
        submanifold_components(M, X),
        ntuple(_ -> β, length(M.manifolds)),
    )
    return Y
end

"""
    manifold_volume(M::ProductManifold)

Return the volume of [`ProductManifold`](@extref `ManifoldsBase.ProductManifold`)
`M`, i.e. product of volumes of the manifolds `M` is constructed from.
"""
manifold_volume(M::ProductManifold) = mapreduce(manifold_volume, *, M.manifolds)

function riemannian_gradient!(M::ProductManifold, Y, p, X)
    map(
        riemannian_gradient!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return Y
end

@doc raw"""
    Y = riemannian_Hessian(M::ProductManifold, p, G, H, X)
    riemannian_Hessian!(M::ProductManifold, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

On a product manifold, this decouples and can be computed elementwise.
"""
riemannian_Hessian(M::ProductManifold, p, G, H, X)

function riemannian_Hessian!(M::ProductManifold, Y, p, G, H, X)
    map(
        riemannian_Hessian!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, G),
        submanifold_components(M, H),
        submanifold_components(M, X),
    )
    return Y
end

@doc raw"""
    sharp(M::ProductManifold, p, ξ::FVector{CotangentSpaceType})

Use the musical isomorphism to transform the cotangent vector `ξ` from the tangent space at
`p` on the [`ProductManifold`](@extref `ManifoldsBase.ProductManifold`)
`M` to a tangent vector. This can be done elementwise for every entry of `ξ` (and `p`)
separately
"""
sharp(::ProductManifold, ::Any...)

@doc raw"""
    volume_density(M::ProductManifold, p, X)

Return volume density on the [`ProductManifold`](@extref `ManifoldsBase.ProductManifold`)
`M`, i.e. product of constituent volume densities.
"""
function volume_density(M::ProductManifold, p, X)
    dens = map(
        volume_density,
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return prod(dens)
end

module ManifoldsTestExt

using Manifolds
using ManifoldsBase
using Test
using Manifolds.Test: AbstractExpectation, Expect, NoExpectation, isexpected, expect

get_expectation(g::Dict, key, default = NoExpectation()) = Expect(get(g, key, default))

"""
    test_manifold(G::AbstractManifold, properties::Dict, expectations::Dict)

Test the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`) ``\\mathcal M``
based on a `Dict` of properties and a `Dict` of `expectations`.

Three functions are expected to be defined (without explicitly being passed in the `properties`):
`is_point(M, p)`, `is_vector(M, p, X)`, and `isapprox(M, p, q)` / `isapprox(M, p, X, Y)`,
since these are essential for verifying results.

From the following properties, the two often expected to be defined are `:Points` and `:Vectors`,
which should contain at least two points and two tangent vectors, respectively.

Possible properties are

* `:Aliased` is a boolean (same as `:Mutating` by default) whether to test the mutating variants with aliased input
* `:Bases` is a vector of bases, which can be used to test basis related functions, one basis for each entry in `:Coordinates`
* `:Covectors` is a vector of covectors, which should be in the cotangent space of the correspondinig point entry in `:Points`
* `:Coordinates` is a vector of coordinates, which can be used to test coordinate related functions, one coordinate vector for each entry in `:Bases`
* `:EmbeddedPoints` is a vector of points in the embedding space of `M`, to test `project`
* `:EmbeddedVectors` is a vector of tangent vectors in the embedding space of `M`, to test `project`
* `:Functions` is a vector of all defined functions for `M`
  note a test is activated by the function (like `exp`), adding the mutating function (like `exp!`) overwrites the
  global default (see `:Mutating`) to true.
* `:GeodesicMaxTime` is a real number indicating the time parameter to use when testing `geodesic`
* `:GeodesicSamples` is an integer indicating the number of samples to use when testing `geodesic` (defaults to 10)
* `:InvalidPoints` is a vector of points that are not on `M`, e.g. to test `is_point`
* `:InvalidVectors` is a vector of tangent vectors that are not in the tangent space of the first point from `:Points`
* `:InverseRetractionMethods` is a vector of inverse retraction methods to test on `M`
  these should have the same order as `:RetractionMethods` (use `missing` for skipping one)
* `:Mutating` is a boolean (`true` by default) whether to test the mutating variants of functions or not.
  when setting this to false, you can still activate single functions mutation checks by
  adding the mutating function to `:Functions`
* `:Name` is a name of the test. If not provided, defaults to `"\$M"`
* `:NormalVectors` is a vector of normal vectors, where each should be in the normal space of the corresponding point entries in `:Points`
* `:Points` is a vector of at least 2 points on `M`, which should not be the same point
* `:RetractionMethods` is a vector of retraction methods to test on `M`
  these should have the same order as `:InverseRetractionMethods` (use `missing` for skipping one)
* `:Rng` is a random number generator to use for generating random points/vectors if needed
* `:Seed` is a seed to use for generating random points/vectors if needed
* `:Vectors` is a vector of at least 2 tangent vectors, which should be in the tangent space of the correspondinig point entries in `:Points`
* `:VectorTransportMethods` is a vector of vector transport methods to test on `M`
* `:TestMidpointSymmetry` is a boolean (`true` by default) whether to test the symmetry property of the midpoint function
* `:TestInfo` is a boolean (`true` by default) whether to test that whether `error=:info` in verification functions issues info messages.
* `:TestWarn` is a boolean (`true` by default) whether to test that whether `error=:warn` in verification functions issues warning.

Possible entries of the `expectations` dictionary are

* any function tested to provide their expected resulting value, e.g. `exp => p` for the result of `exp(M, p, X)`
* for retractions, inverse retractions, and vector transports, the key is a tuple of the function and the method, e.g. `(retract, method) => q`
* for `embed`, and `project`, the key is a tuple of the function and `:Point` or `:Vector`, e.g. `(embed, :Point) of expected (embedded) points or vectors,
  omitting that symbol is interpreted as the expected point.
* for `get_basis`, the key is a tuple of the function and the basis, e.g. `(get_basis, B) => ...` to the expexted basis
* for `get_coordinates` the key is a tuple of the function and the basis, e.g. `(get_coordinates, B) => c`
* for `get_vector` the key is a tuple of the function, the coordinate vector, and the basis, e.g. `(get_vector, c, B) => X`
* for `get_vectors` the key is a tuple of the function and the basis, e.g. `(get_vectors, B) => :Symbol` where
  * `:Orthogonal` tests for orthogonality
  * `:Orthonormal` tests additionally to the previous for unit length
  For any basis this test calls `get_basis` on any provided basis, if that function is available.
* for `is_default_metric`, the value is the default metric
* `:atol => 0.0` a global absolute tolerance
* `:atols -> Dict()` a dictionary `function -> atol` for tolerances of specific function tested.
* `:Types` -> Dict() a dictionary `function -> Type` for specifying expected types of results of specific functions, for example `manifold_dimension => Int`.
*  `:IsPointErrors` is a vector of expected error types for each invalid point provided in `:InvalidPoints`, use `missing` to skip testing for errors for a specific point.
*  `:IsVectorErrors` is a vector of expected error types for each invalid vector provided in `:InvalidVectors`, use `missing` to skip testing for errors for a specific vector.
*  `:IsVectorBasepointError` is an expected error type when the base point is invalid e.g. for `is_vector`
"""
function Manifolds.Test.test_manifold(M::AbstractManifold, properties::Dict, expectations::Dict = Dict())
    atol = get(expectations, :atol, 0.0)
    mutating = get(properties, :Mutating, true)
    aliased = get(properties, :Aliased, mutating)
    functions = get(properties, :Functions, Function[])
    points = get(properties, :Points, [])
    vectors = get(properties, :Vectors, [])
    covectors = get(properties, :Covectors, [])
    normals = get(properties, :NormalVectors, [])
    bases = get(properties, :Bases, [])
    coordinates = get(properties, :Coordinates, [])
    test_name = get(properties, :Name, "Manifolds.Test suite for $M")
    test_warn = get(properties, :TestWarn, true)
    test_info = get(properties, :TestInfo, true)
    function_atols = get(expectations, :atols, Dict())
    result_types = get(expectations, :Types, Dict())
    retraction_methods = get(properties, :RetractionMethods, [])
    inverse_retraction_methods = get(properties, :InverseRetractionMethods, [])
    vector_transport_methods = get(properties, :VectorTransportMethods, [])
    t = Test.@testset "$test_name" begin # COV_EXCL_LINE
        n_points = length(points)
        n_vectors = length(vectors)
        if (copy in functions)
            Manifolds.Test.test_copy(
                M, points[1], vectors[1];
                name = "copy(M, p) & copy(M, p, X)",
            )
        end
        if (copyto! in functions)
            Manifolds.Test.test_copyto(
                M, points[1], vectors[1];
                name = "copyto!(M, q, p) & copyto!(M, Y, p, X)",
            )
        end
        if (default_inverse_retraction_method in functions)
            Manifolds.Test.test_default_inverse_retraction(
                M;
                expected_value = get_expectation(expectations, default_inverse_retraction_method),
                name = "default_inverse_retraction_method(M)",
            )
            Manifolds.Test.test_default_inverse_retraction(
                M, typeof(points[1]);
                expected_value = get_expectation(expectations, default_inverse_retraction_method),
                name = "default_inverse_retraction_method(M, P)",
            )
        end
        if (default_retraction_method in functions)
            Manifolds.Test.test_default_retraction(
                M;
                expected_value = get_expectation(expectations, default_retraction_method),
                name = "default_retraction_method(M)",
            )
            Manifolds.Test.test_default_retraction(
                M, typeof(points[1]);
                expected_value = get_expectation(expectations, default_retraction_method),
                name = "default_retraction_method(M, P)",
            )
        end
        if (default_vector_transport_method in functions)
            Manifolds.Test.test_default_vector_transport_method(
                M;
                expected_value = get_expectation(expectations, default_vector_transport_method),
                name = "default_vector_transport_method(M)",
            )
            Manifolds.Test.test_default_vector_transport_method(
                M, typeof(points[1]);
                expected_value = get_expectation(expectations, default_vector_transport_method),
                name = "default_vector_transport_method(M, P)",
            )
        end
        if (distance in functions)
            Manifolds.Test.test_distance(
                M, points[1], points[2];
                available_functions = functions,
                expected_value = get_expectation(expectations, distance),
                name = "distance(M, p, q)", # shorten name within large suite
                atol = get(function_atols, distance, atol),
            )
        end
        if (embed in functions)
            ep = get_expectation(expectations, embed)
            ep = isexpected(ep) ? ep : get_expectation(expectations, (embed, :Point))
            Manifolds.Test.test_embed(
                M, points[1], n_vectors ≥ 1 ? vectors[1] : NoExpectation();
                available_functions = functions,
                expected_point = ep,
                expected_vector = get_expectation(expectations, (embed, :Vector)),
                test_aliased = aliased,
                test_mutating = (embed! in functions) ? true : mutating,
                name = "embed(M, p) & embed(M, p, X)", # shorten name within large suite
                atol = get(function_atols, embed, atol),
            )
        end
        if (embed_project in functions)
            approx_p = get(properties, :EmbeddedPoints, [points[1]])[1]
            approx_X = get(properties, :EmbeddedVectors, [vectors[1]])[1]
            Manifolds.Test.test_embed_project(
                M, approx_p, approx_X;
                available_functions = functions,
                expected_point = points[1],
                expected_vector = vectors[1],
                test_aliased = aliased,
                test_mutating = (embed_project! in functions) ? true : mutating,
                atol = get(function_atols, embed_project, atol),
                name = "embed_project(M, q) & embed_project(M, q, Y)", # shorten name within large suite
            )
        end
        if (exp in functions)
            Manifolds.Test.test_exp(
                M, points[1], vectors[1];
                available_functions = functions,
                expected_value = get_expectation(expectations, exp),
                test_aliased = aliased,
                test_mutating = (exp! in functions) ? true : mutating,
                atol = get(function_atols, exp, atol),
                name = "exp(M, p, X)", # shorten name within large suite
            )
        end
        if (flat in functions)
            expected_flat = get_expectation(expectations, flat)
            Manifolds.Test.test_flat(
                M, points[1], vectors[1];
                available_functions = functions,
                expected_value = expected_flat,
                name = "flat(M, p, X)", # shorten name within large suite
                atol = get(function_atols, flat, atol),
            )
        end
        if (get_basis in functions)
            for B in bases
                expected_basis = get_expectation(expectations, (get_basis, B))
                Manifolds.Test.test_get_basis(
                    M, points[1], B;
                    available_functions = functions,
                    expected_value = expected_basis,
                    name = "get_basis(M, p, $B)", # shorten name within large suite
                )
            end
        end
        if (get_coordinates in functions)
            expected_coordinates = get_expectation(expectations, get_coordinates)
            for B in bases
                expected_coordinates_B = get_expectation(expectations, (get_coordinates, B), expected_coordinates)
                Manifolds.Test.test_get_coordinates(
                    M, points[1], vectors[1], B;
                    available_functions = functions,
                    expected_value = expected_coordinates_B,
                    test_mutating = (get_coordinates! in functions) ? true : mutating,
                    name = "get_coordinates(M, p, X, $B)", # shorten name within large suite
                )
            end
        end
        if (get_embedding in functions)
            expected_embed = get_expectation(expectations, get_embedding)
            Manifolds.Test.test_get_embedding(
                # check the global one if this point type does not have an expected embedding
                M, missing;
                expected_value = expected_embed,
                name = "get_embedding(M)", # shorten name within large suite
            )
            if length(points) >= 1
                expected_embed_P = get_expectation(expectations, (get_embedding, typeof(points[1])))
                Manifolds.Test.test_get_embedding(
                    # check the global one if this point type does not have an expected embedding
                    M, typeof(points[1]);
                    expected_value = expected_embed,
                    expected_type = expected_embed_P,
                    name = "get_embedding(M, p)", # shorten name within large suite
                )
            end
        end
        if (get_vector in functions)
            for (c, B) in zip(coordinates, bases)
                expected_vector = get_expectation(expectations, (get_vector, c, B))
                Manifolds.Test.test_get_vector(
                    M, points[1], c, B;
                    available_functions = functions,
                    expected_value = expected_vector,
                    test_mutating = (get_vector! in functions) ? true : mutating,
                    name = "get_vector(M, p, c, $B)", # shorten name within large suite
                    atol = get(function_atols, get_vector, atol),
                )
            end
        end
        if (get_vectors in functions)
            for B in bases
                expected_vectors_symbol = expect(get_expectation(expectations, (get_vectors, B), :default))
                Manifolds.Test.test_get_vectors(
                    M, points[1], (get_basis in functions) ? get_basis(M, points[1], B) : B;
                    available_functions = functions,
                    test_orthogonality = expected_vectors_symbol in (:Orthogonal, :Orthonormal),
                    test_normality = (expected_vectors_symbol === :Orthonormal),
                    name = "get_vectors(M, p, $B)", # shorten name within large suite
                    atol = get(function_atols, get_vectors, atol),
                )
            end
        end
        if (geodesic in functions)
            expected_geod = get_expectation(expectations, geodesic)
            t = get(properties, :GeodesicMaxTime, 1.0)
            Manifolds.Test.test_geodesic(
                M, points[1], vectors[1], t;
                available_functions = functions,
                atol = get(function_atols, geodesic, atol),
                expected_value = expected_geod,
                N = get(properties, :GeodesicSamples, 100),
                name = "geodesic(M, p, X, $t)", # shorten name within large suite
            )
        end
        if (injectivity_radius in functions)
            expected = get_expectation(expectations, (injectivity_radius, points[1]))
            expected_global = get_expectation(expectations, injectivity_radius)
            Manifolds.Test.test_injectivity_radius(
                M, missing;
                expected_value = expected_global,
                name = "injectivity_radius(M, p)", # shorten name within large suite
            )
            Manifolds.Test.test_injectivity_radius(
                M, points[1];
                expected_value = expected,
                expected_global_value = expected_global,
                name = "injectivity_radius(M, p)", # shorten name within large suite
            )
            for rm in retraction_methods
                ismissing(rm) && continue
                expected_rm = get_expectation(expectations, (injectivity_radius, points[1], rm))
                expected_rm_global = get_expectation(expectations, (injectivity_radius, rm))
                Manifolds.Test.test_injectivity_radius(
                    M, points[1];
                    expected_value = expected_rm,
                    expected_global_value = expected_rm_global,
                    retraction_method = rm,
                    name = "injectivity_radius(M, p, $rm)", # shorten name within large suite
                )
            end

        end
        if (inner in functions)
            expected_inner = get_expectation(expectations, inner)
            Manifolds.Test.test_inner(
                M, points[1], vectors[1], vectors[2];
                available_functions = functions,
                expected_value = expected_inner,
                name = "inner(M, p, X, Y)", # shorten name within large suite
                atol = get(function_atols, inner, atol),
            )
        end
        if (inverse_retract in functions)
            for (irm, rm) in zip(inverse_retraction_methods, retraction_methods)
                ismissing(irm) && continue
                expected_inv_retract = get_expectation(expectations, (inverse_retract, irm))
                Manifolds.Test.test_inverse_retract(
                    M, points[1], points[2], irm;
                    available_functions = functions,
                    expected_value = expected_inv_retract,
                    retraction_method = rm,
                    test_mutating = (inverse_retract! in functions) ? true : mutating,
                    atol = get(function_atols, inverse_retract, atol),
                    name = "inverse_retract(M, p, q, $irm)", # shorten name within large suite
                )
            end
        end
        if (is_default_metric in functions)
            m = get_expectation(expectations, is_default_metric, NoExpectation())
            Manifolds.Test.test_is_default_metric(
                M, m;
                name = "is_default_metric(M$(isexpected(m) ? ", $(expect(m))" : ""))",
            )
        end
        if (is_flat in functions)
            Manifolds.Test.test_is_flat(
                M; expected_value = get_expectation(expectations, is_flat), name = "is_flat(M)",
            )
        end
        if (is_point in functions)
            qs = get(properties, :InvalidPoints, [])
            # lets not wrap these in expectations
            errs = get(expectations, :IsPointErrors, [])
            Manifolds.Test.test_is_point(
                M, points[1], qs...;
                errors = errs,
                name = "is_point on M for $(typeof(points[1])) points",
                test_warn = test_warn,
                test_info = test_info,
                atol = get(function_atols, is_point, atol),
            )
        end
        if (is_vector in functions)
            Ys = get(properties, :InvalidVectors, [])
            # lets not wrap these in expectations
            errs = get(expectations, :IsVectorErrors, [])
            Manifolds.Test.test_is_vector(
                M, points[1], vectors[1], Ys...;
                basepoint_error = get_expectation(expectations, :IsVectorBasepointError),
                errors = errs,
                name = "is_vector(M, p, X)",
                test_warn = test_warn,
                test_info = test_info,
                q = get(properties, :InvalidPoints, [NoExpectation()])[1],
                atol = get(function_atols, is_vector, atol),
            )
        end
        if (log in functions)
            expected_log = get_expectation(expectations, :log)
            Manifolds.Test.test_log(
                M, points[1], points[2];
                available_functions = functions,
                expected_value = expected_log,
                test_mutating = (log! in functions) ? true : mutating,
                atol = get(function_atols, log, atol),
                name = "log(M, p, q)", # shorten name within large suite
            )
        end
        if (manifold_dimension in functions)
            expected_dim = get_expectation(expectations, manifold_dimension)
            Manifolds.Test.test_manifold_dimension(
                M; expected_value = expected_dim, expected_type = get(result_types, manifold_dimension, Int),
                name = "manifold_dimension(M)",
            )
        end
        if (manifold_volume in functions)
            expected_vol = get_expectation(expectations, manifold_volume)
            Manifolds.Test.test_manifold_volume(
                M;
                expected_value = expected_vol,
                name = "manifold_volume(M)",
            )
        end
        if (mid_point in functions)
            expected_mid = get_expectation(expectations, mid_point)
            Manifolds.Test.test_mid_point(
                M, points[1], points[2];
                available_functions = functions,
                expected_value = expected_mid,
                test_aliased = aliased,
                test_mutating = (mid_point! in functions) ? true : mutating,
                test_symmetry = get(properties, :TestMidpointSymmetry, true),
                atol = get(function_atols, mid_point, atol),
                name = "mid_point(M, p, q)", # shorten name within large suite
            )
        end
        if (norm in functions)
            expected_norm = get_expectation(expectations, norm)
            Manifolds.Test.test_norm(
                M, points[1], vectors[1];
                available_functions = functions,
                expected_value = expected_norm,
                name = "norm(M, p, X)", # shorten name within large suite
                atol = get(function_atols, norm, atol),
            )
        end
        if (parallel_transport_to in functions)
            expected_pt = get_expectation(expectations, parallel_transport_to)
            expected_ptd = get_expectation(expectations, parallel_transport_direction)
            Manifolds.Test.test_parallel_transport(
                M, points[1], vectors[1], points[2];
                available_functions = functions,
                expected_value = expected_pt,
                expected_value_direction = expected_ptd,
                test_aliased = aliased,
                test_mutating = (parallel_transport_to! in functions) ? true : mutating,
                atol = get(function_atols, parallel_transport_to, atol),
                name = "parallel_transport_to(M, p, X, q)", # shorten name within large suite
            )
        end
        if (project in functions)
            Q = get(properties, :EmbeddedPoints, missing)
            q = ismissing(Q) ? missing : Q[1]
            Ys = get(properties, :EmbeddedVectors, missing)
            Y = ismissing(Ys) ? missing : Ys[1]
            ep = get_expectation(expectations, project)
            ep = isexpected(ep) ? ep : get_expectation(expectations, (project, :Point))
            eX = get_expectation(expectations, (project, :Vector))
            ismissing(q) && error("To test `project`, at least one `:EmbeddedPoints` must be provided.")
            Manifolds.Test.test_project(
                M, q, Y;
                available_functions = functions,
                expected_point = ep,
                expected_vector = eX,
                test_aliased = aliased,
                test_mutating = (project! in functions) ? true : mutating,
                atol = get(function_atols, project, atol),
                name = "project(M, q) & project(M, q, Y)", # shorten name within large suite
            )
        end
        if (rand in functions)
            rng = get(properties, :Rng, missing)
            seed = get(properties, :Seed, missing)
            Manifolds.Test.test_rand(
                M;
                seed = seed,
                rng = rng,
                vector_at = points[1],
                test_mutating = (rand! in functions) ? true : mutating,
                name = "rand(M)",
                atol = get(function_atols, rand, atol),
            )
        end
        if (repr in functions)
            expected_repr = get_expectation(expectations, repr)
            Manifolds.Test.test_repr(
                M;
                expected_value = expected_repr,
                name = "repr(M)",
            )
        end
        if (representation_size in functions)
            expected_repr_size = get_expectation(expectations, representation_size)
            Manifolds.Test.test_representation_size(
                M;
                expected_value = expected_repr_size,
                name = "representation_size(M)", # shorten name within large suite
            )
        end
        if (retract in functions)
            for (rm, irm) in zip(retraction_methods, inverse_retraction_methods)
                ismissing(rm) && continue
                expected_retract = get_expectation(expectations, (retract, rm))
                Manifolds.Test.test_retract(
                    M, points[1], vectors[1], rm;
                    available_functions = functions,
                    expected_value = expected_retract,
                    inverse_retraction_method = irm,
                    test_aliased = aliased,
                    test_mutating = (retract! in functions) ? true : mutating,
                    atol = get(function_atols, retract, atol),
                    name = "retract(M, p, X, $rm)", # shorten name within large suite
                )
            end
        end
        if (sectional_curvature in functions)
            expected_sec_curv = get_expectation(expectations, sectional_curvature)
            expected_sec_curv_min = get_expectation(expectations, sectional_curvature_min)
            expected_sec_curv_max = get_expectation(expectations, sectional_curvature_max)
            Manifolds.Test.test_sectional_curvature(
                M, points[1], vectors[1], vectors[2];
                available_functions = functions,
                expected_value = expected_sec_curv,
                expected_value_min = expected_sec_curv_min,
                expected_value_max = expected_sec_curv_max,
                name = "sectional_curvature(M, p, X, Y)", # shorten name within large suite
                atol = get(function_atols, sectional_curvature, atol),
            )
        end
        if (sharp in functions)
            expected_sharp = get_expectation(expectations, sharp)
            Manifolds.Test.test_sharp(
                M, points[1], covectors[1];
                available_functions = functions,
                expected_value = expected_sharp,
                name = "sharp(M, p, ξ)", # shorten name within large suite
                atol = get(function_atols, sharp, atol),
            )
        end
        if (shortest_geodesic in functions)
            expected_geod = get_expectation(expectations, shortest_geodesic)
            t = get(properties, :ShortestGeodesicTime, 1.0)
            Manifolds.Test.test_shortest_geodesic(
                M, points[1], points[2], t;
                available_functions = functions,
                atol = get(function_atols, shortest_geodesic, atol),
                expected_value = expected_geod,
                N = get(properties, :GeodesicSamples, 100),
                name = "shortest_geodesic(M, p, X, $t)", # shorten name within large suite
            )
        end
        if (vector_transport_to in functions)
            for vtm in vector_transport_methods
                expected_vt = get_expectation(expectations, (vector_transport_to, vtm))
                expected_vtd = get_expectation(expectations, (vector_transport_direction, vtm))
                Manifolds.Test.test_vector_transport(
                    M, points[1], vectors[1], points[2], vtm;
                    available_functions = functions,
                    expected_value = expected_vt,
                    expected_value_direction = expected_vtd,
                    test_aliased = aliased,
                    test_mutating = (vector_transport_to! in functions) ? true : mutating,
                    atol = get(function_atols, vector_transport_to, atol),
                    name = "vector_transport_to(M, p, X, q, $vtm)", # shorten name within large suite
                )
            end
        end
        if (volume_density in functions)
            expected_vol_density = get_expectation(expectations, volume_density)
            Manifolds.Test.test_volume_density(
                M, points[1], vectors[1];
                expected_value = expected_vol_density,
                name = "volume_density(M, p, X)", # shorten name within large suite
                atol = get(function_atols, volume_density, atol),
            )
        end
        if (Weingarten in functions)
            Manifolds.Test.test_Weingarten(
                M, points[1], vectors[1], normals[1];
                available_functions = functions,
                expected_value = get_expectation(expectations, Weingarten),
                test_mutating = (Weingarten! in functions) ? true : mutating,
                atol = get(function_atols, Weingarten, atol),
                name = "Weingarten(M, p, X, N)", # shorten name within large suite
            )
        end
        if (zero_vector in functions)
            Manifolds.Test.test_zero_vector(
                M, points[1];
                available_functions = functions,
                test_mutating = (zero_vector! in functions) ? true : mutating,
                atol = get(function_atols, zero_vector, atol),
                name = "zero_vector(M, p)", # shorten name within large suite
            )
        end
    end # end of test_manifold testset
    return t
end

# Single function tests
#
# ------------------------------------------------------------------------------------------
"""
    Manifolds.Test.test_copy(M, p, X;
        name = "copying on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test `copy(M, p)` and `copy(M, p, X)` on a manifold `M`.

* that the copied point/vector is a valid point/vector on the manifold / tangent space
* that the copied point/vector matches the original point/vector but is new memory
"""
function Manifolds.Test.test_copy(
        M::AbstractManifold, p, X;
        name = "copying on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        q = copy(M, p)
        Test.@test is_point(M, q; error = :error, kwargs...)
        Test.@test q == p
        Test.@test q !== p
        Y = copy(M, p, X)
        Test.@test is_vector(M, p, Y; error = :error, kwargs...)
        Test.@test Y == X
        Test.@test Y !== X

    end
    return nothing
end # end of Manifolds.Test.test_copy

"""
    Manifolds.Test.test_copyto(M, p, X;
        name = "copying on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test `copyto!(M, q, p)` and `copyto!(M, Y, p, X)` on a manifold `M`.

* that the copied point/vector is a valid point/vector on the manifold / tangent space
* that the copied point/vector matches the original point/vector and is the same memory

Note that since this function does not modify its input, is is called `test_copyto`.
"""
function Manifolds.Test.test_copyto(
        M::AbstractManifold, p, X;
        name = "copyto! on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        # Allocate memory for copyto!
        q = allocate_result(M, exp, p, X)
        q2 = copyto!(M, q, p)
        Test.@test q == p
        Test.@test q2 === q
        Y = allocate_result(M, exp, p, X)
        Y2 = copyto!(M, Y, p, X)
        Test.@test Y == X
        Test.@test Y2 === Y
    end
    return nothing
end

"""
    Manifolds.Test.test_default_inverse_retraction_method(
        M, T=missing;
        expected_value = NoExpectation(),
        expected_type = !isexpected(expected_value) ? NoExpectation() : typeof(expected_value),
        name = "default_inverse_retraction_method on \$M \$(ismissing(T) ? "" : "for type \$T")",
    )

Test the [`default_inverse_retraction_method`](@extref `ManifoldsBase.default_inverse_retraction_method-Tuple{AbstractManifold}`) on manifold `M`.
* that it returns an [`AbstractInverseRetractionMethod`](@extref `ManifoldsBase.AbstractInverseRetractionMethod`)
* that the result matches `expected_value`, if given
* that the result is of type `expected_type`, if given, defaults to the type of the value
"""
function Manifolds.Test.test_default_inverse_retraction(
        M::AbstractManifold, T = missing;
        expected_value = NoExpectation(),
        expected_type = !isexpected(expected_value) ? NoExpectation() : Expect(typeof(expect(expected_value))),
        name = "default_inverse_retraction_method on $M $(ismissing(T) ? "" : "for type $T")",
    )
    Test.@testset "$(name)" begin
        m = ismissing(T) ? default_inverse_retraction_method(M) : default_inverse_retraction_method(M, T)
        Test.@test m isa AbstractInverseRetractionMethod
        !isexpected(expected_value) || Test.@test m == expect(expected_value)
        !isexpected(expected_type) || Test.@test m isa expect(expected_type)
    end
    return nothing
end # Manifolds.Test.test_default_inverse_retraction

"""
    Manifolds.Test.test_default_retraction_method(
        M, T=missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "default_retraction_method on \$M \$(ismissing(T) ? "" : "for type \$T")",
    )

Test the [`default_retraction_method`](@extref `ManifoldsBase.default_retraction_method-Tuple{AbstractManifold}`) on manifold `M`.
* that it returns an [`AbstractRetractionMethod`](@extref `ManifoldsBase.AbstractRetractionMethod`)
* that the result matches `expected_value`, if given
* that the result is of type `expected_type`, if given, defaults to the type of the value
"""
function Manifolds.Test.test_default_retraction(
        M::AbstractManifold, T = missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "default_retraction_method on $M $(ismissing(T) ? "" : "for type $T")",
    )
    Test.@testset "$(name)" begin
        m = ismissing(T) ? default_retraction_method(M) : default_retraction_method(M, T)
        Test.@test m isa AbstractRetractionMethod
        ismissing(expected_value) || Test.@test m == expect(expected_value)
        ismissing(expected_type) || Test.@test m isa expect(expected_type)
    end
    return nothing
end # Manifolds.Test.test_default_retraction

"""
    Manifolds.Test.test_default_vector_transport_method(
        M, T=missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "default_vector_transport_method on \$M \$(ismissing(T) ? "" : "for type \$T")",
    )

Test the [`default_vector_transport_method`](@extref `ManifoldsBase.default_vector_transport_method-Tuple{AbstractManifold}`) on manifold `M`.
* that it returns an [`AbstractVectorTransportMethod`](@extref `ManifoldsBase.default_vector_transport_method-Tuple{AbstractManifold}`)
* that the result matches `expected_value`, if given
* that the result is of type `expected_type`, if given, defaults to the type of the value
"""
function Manifolds.Test.test_default_vector_transport_method(
        M::AbstractManifold, T = missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "default_vector_transport_method on $M $(ismissing(T) ? "" : "for type $T")",
    )
    Test.@testset "$(name)" begin
        m = ismissing(T) ? default_vector_transport_method(M) : default_vector_transport_method(M, T)
        Test.@test m isa AbstractVectorTransportMethod
        ismissing(expected_value) || Test.@test m == expect(expected_value)
        ismissing(expected_type) || Test.@test m isa expect(expected_type)
    end
    return nothing
end # Manifolds.Test.test_default_vector_transport

"""
    Manifolds.Test.test_distance(
        M, p, q;
        available_functions=[], expected_value=NoExpectation(),
        name = "Distance on \$M between \$(typeof(p)) points",
        kwargs...
    )

Test the distance function on manifold `M` between points `p` and `q`.

* that the result is a nonnegative number
* that the distance from `p` to `p` is zero
* that the distance is symmetric
* that the result matches `expected_value`, if given
* that the distance is equal to the norm of the logarithmic map (if `log` and `norm` are available)
    (only performed if either `injectivity_radius` is not available or the points are within)
"""
function Manifolds.Test.test_distance(
        M::AbstractManifold, p, q;
        available_functions = Function[], expected_value = NoExpectation(),
        name = "Distance on $M between $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        d = distance(M, p, q)
        Test.@test d ≥ 0.0
        d_pp = distance(M, p, p)
        Test.@test isapprox(d_pp, 0.0; kwargs...)
        d_qp = distance(M, q, p)
        Test.@test isapprox(d, d_qp; kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(d, expect(expected_value); kwargs...)
        if (log in available_functions) && (norm in available_functions)
            # Test only if inj is not available of points are within inj radius
            run_test = !((injectivity_radius in available_functions)) || (d ≤ injectivity_radius(M, p))
            run_test || (@warn("Skipping distance-norm-log test since norm of X ($(norm(M, p, X))) is outside injectivity radius ($(injectivity_radius(M, p)))"))
            Y = log(M, p, q)
            n = norm(M, p, Y)
            Test.@test isapprox(d, n; kwargs...) skip = !run_test
        end
    end
    return nothing
end # Manifolds.Test.test_distance

"""
    Manifolds.Test.test_embed(
        M, p, X=missing;
        available_functions=[],
        expected_point=NoExpectation(),
        expected_vector=NoExpectation(),
        test_aliased=true,
        test_mutating=true,
        name = "Embedding on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the [`embed`](@extref `ManifoldsBase.embed-Tuple{AbstractManifold, Any}`)`(M, p)` and [`embed`](@extref `ManifoldsBase.embed-Tuple{AbstractManifold, Any, Any}`)`(M, p, X)`
to embed points and tangent vectors (if not `missing`).

Besides a simple call of `embed` (for both variants) the following ones are prefoemd if [`get_embedding`](@extref `ManifoldsBase.get_embedding-Tuple{AbstractManifold}`) is available:

* that the embedded point is a valid point on the embedding manifold
* that the embedded vector is a valid tangent vector on the embedding manifold (if [`get_embedding`](@extref `ManifoldsBase.get_embedding-Tuple{AbstractManifold}`) is available and `X` is not `missing`)
* that the result matches `expected_point` and `expected_vector`, respectively, if given
* that the projection inverts the embedding (if `project` is available)
* that the mutating version `embed!` produces the same result(s) (if activated _and_ [`get_embedding`](@extref `ManifoldsBase.get_embedding-Tuple{AbstractManifold}`) is available)
* that `embed!` works on aliased input (`p=q` or `X=Y`) (if activated _and_ p/q or X/Y are of same type)
"""
function Manifolds.Test.test_embed(
        M::AbstractManifold, p, X = missing;
        available_functions = Function[],
        expected_point = NoExpectation(),
        expected_vector = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Embedding on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        E = get_embedding(M) isa AbstractManifold ? get_embedding(M) : missing
        # Test point embedding
        q = embed(M, p)
        if !ismissing(E)
            Test.@test is_point(E, q; error = :error, kwargs...)
            !isexpected(expected_point) || Test.@test isapprox(E, q, expect(expected_point); error = :error, kwargs...)
            if project in available_functions
                p2 = project(M, q)
                Test.@test isapprox(M, p, p2; error = :error, kwargs...)
            end
            if test_mutating
                q2 = copy(E, q)
                embed!(M, q2, p)
                Test.@test isapprox(E, q2, q; error = :error, kwargs...)
                if test_aliased && (typeof(p) == typeof(q))
                    q3 = copy(E, p)
                    embed!(M, q3, q3)  # aliased
                    Test.@test isapprox(E, q3, q; error = :error, kwargs...)
                end
                if project in available_functions
                    p3 = copy(M, p)
                    project!(M, p3, q2)
                    Test.@test isapprox(M, p, p3; error = :error, kwargs...)
                end
            end
        end
        # Test vector embedding
        if !ismissing(X)
            Y = embed(M, p, X)
            if !ismissing(E)
                Test.@test is_vector(E, q, Y; error = :error, kwargs...)
                !isexpected(expected_vector) || Test.@test isapprox(E, q, Y, expect(expected_vector); error = :error, kwargs...)
                if project in available_functions
                    X2 = project(M, q, Y)
                    Test.@test isapprox(M, p, X, X2; error = :error, kwargs...)
                end
                if test_mutating
                    Y2 = copy(E, q, Y)
                    embed!(M, Y2, p, X)
                    Test.@test isapprox(E, q, Y2, Y; error = :error, kwargs...)
                    if test_aliased
                        Y3 = copy(E, q, Y)
                        embed!(M, Y3, q, Y3)  # aliased
                        Test.@test isapprox(E, q, Y3, Y; error = :error, kwargs...)
                    end
                    if project in available_functions
                        X3 = copy(M, p, X)
                        project!(M, X3, q, Y2)
                        Test.@test isapprox(M, p, X, X3; error = :error, kwargs...)
                    end
                end
            end
        end
    end
    return nothing
end # Manifolds.Test.test_embed

"""
    Manifolds.Test.test_embed_project(
        M, ap, aX = missing;
        available_functions=[],
        expected_point=NoExpectation(),
        expected_vector=NoExpectation(),
        test_aliased=true,
        test_mutating=true,
        name = "Projection on \$M for \$(typeof(q)) points",
        kwargs...
    )

Test the `p=`[`embed_project`](@extref `ManifoldsBase.embed_project-Tuple{AbstractManifold, Any}`)`(M, ap)` and [`embed_project`](@extref `ManifoldsBase.embed_project-Tuple{AbstractManifold, Any, Any}`)`(M, p, aX)`
to project points and tangent vectors (if not `aX` is not `missing`) after embedding them.
Besides a simple call of `embed_project` (for both variants)  the following tests are performed

* that the projected point is a valid point on the manifold
* that the projected vector is a valid tangent vector on the manifold
* that the result matches `expected_point` and `expected_vector`, respectively, if given
* that the mutating version `embed_project!` produces the same result(s) (if activated)
* that `embed_project!` works on aliased input (`p=q` or `X=Y`) (if activated _and_ p/q or X/Y are of same type)
"""
function Manifolds.Test.test_embed_project(
        M::AbstractManifold, ap, aX = missing;
        available_functions = Function[],
        expected_point = NoExpectation(),
        expected_vector = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Embed-then-project on $M for $(typeof(ap)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        # Test point projection
        p = embed_project(M, ap)
        Test.@test is_point(M, p; error = :error, kwargs...)
        !isexpected(expected_point) || Test.@test isapprox(M, p, expect(expected_point); error = :error, kwargs...)
        if test_mutating
            p2 = copy(M, p)
            embed_project!(M, p2, ap)
            Test.@test isapprox(M, p2, p; error = :error, kwargs...)
            if test_aliased && (typeof(p) == typeof(ap))
                p3 = copy(M, ap)
                embed_project!(M, p3, p3)  # aliased
                Test.@test isapprox(M, p3, p; error = :error, kwargs...)
            end
        end
        # Test vector projection
        if !ismissing(aX)
            X = project(M, p, aX)
            Test.@test is_vector(M, p, X; error = :error, kwargs...)
            !isexpected(expected_vector) || Test.@test isapprox(M, p, X, expect(expected_vector); error = :error, kwargs...)
            if test_mutating
                X2 = copy(M, p, aX)
                project!(M, X2, p, aX)
                Test.@test isapprox(M, p, X2, X; error = :error, kwargs...)
                if test_aliased
                    X3 = copy(M, p, aX)
                    project!(M, X3, p, X3)  # aliased
                    Test.@test isapprox(M, p, X3, X; error = :error, kwargs...)
                end
            end
        end
    end
    return nothing
end # Manifolds.Test.test_embed_project

"""
    Manifolds.Test.test_exp(
        M, p, X, t=1.0;
        available_functions=[], expected_value=NoExpectation(), test_mutating=true,
        test_log = (log in available_functions),
        test_fused = true,
        test_injectivity_radius = (injectivity_radius in available_functions),
        name = "Exponential map on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the exponential map on manifold `M` at point `p` with tangent vector `X`.

* that the result is a valid point on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `exp!` matches the non-mutating version, (if activated)
* that `exp!` works on aliased in put (`p=q`) (if activated for mutating)
* that the logarithmic map inverts the exponential map (if activated)
(only performed if either `injectivity_radius` is not available or `X` is within)
* that the fused version `exp_fused(M, p, t, X)` matches the non-fused version (if activated)
"""
function Manifolds.Test.test_exp(
        M::AbstractManifold, p, X, t = 1.0;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_aliased = true,
        test_fused = true,
        test_log = (log in available_functions),
        test_injectivity_radius = (injectivity_radius in available_functions),
        test_mutating = true,
        name = "Exponential map on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        q = exp(M, p, X)
        Test.@test is_point(M, q; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, q, expect(expected_value); error = :error, kwargs...)
        if test_mutating
            q2 = copy(M, p)
            exp!(M, q2, p, X)
            Test.@test isapprox(M, q2, q; error = :error, kwargs...)
            if test_aliased
                q3 = copy(M, p)
                exp!(M, q3, q3, X)  # aliased
                Test.@test isapprox(M, q3, q; error = :error, kwargs...)
            end
        end
        if test_fused
            q4 = Manifolds.exp_fused(M, p, X, t)
            q5 = exp(M, p, t * X)
            Test.@test isapprox(M, q4, q5; error = :error, kwargs...)
            if test_mutating
                q6 = copy(M, p)
                Manifolds.exp_fused!(M, q6, p, X, t)
                Test.@test isapprox(M, q6, q5; error = :error, kwargs...)
                if test_aliased
                    q7 = copy(M, p)
                    Manifolds.exp_fused!(M, q7, q7, X, t)  # aliased
                    Test.@test isapprox(M, q7, q5; error = :error, kwargs...)
                end
            end
        end
        if test_log
            # Test only if inj is not available of X is within inj radius
            run_test = !test_injectivity_radius || norm(M, p, X) ≤ injectivity_radius(M, p)
            run_test || (@warn("Skipping log-exp test since norm of X ($(norm(M, p, X))) is outside injectivity radius ($(injectivity_radius(M, p)))"))
            Y = log(M, p, q)
            Test.@test isapprox(M, X, Y; error = :error, kwargs...) skip = !run_test
        end
    end
    return nothing
end # Manifolds.Test.test_exp

"""
    Manifolds.Test.test_flat(M, p, X;
        available_functions = [],
        expected_value= NoExpectation(),
        name = "Flat on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the flat operation on manifold `M` at point `p` with tangent vector `X`.
* (we can not yet test valid cotangent vectors)
* that the result matches `expected_value`, if given
* that [`sharp`](@ref) is the inverse
* that mutating version `flat!` matches non-mutating version (if activated)
"""
function Manifolds.Test.test_flat(
        M, p, X;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_mutating = true,
        name = "Flat on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        ξ = flat(M, p, X)
        !isexpected(expected_value) || Test.@test isapprox(M, ξ, expect(expected_value); error = :error, kwargs...)
        if (sharp in available_functions)
            X2 = sharp(M, p, ξ)
            Test.@test isapprox(M, X, X2; error = :error, kwargs...)
        end
        if test_mutating
            ξ2 = copy(M, p, ξ) # Improve once cotangents are first class citizens
            flat!(M, ξ2, p, X)
            Test.@test isapprox(M, ξ2, ξ; error = :error, kwargs...)
        end
    end
    return nothing
end

"""
    Manifolds.Test.test_geodesic(M, p, X, t=1.0;
        available_functions=[],
        expected_value = NoExpectation(),
        N = 10,
        name = "Geodesic on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the geodesic on manifold `M` at point `p` with tangent vector `X` at time `t`.
* that at time `0` the geodesic returns `p`
* that the function `γ = geodesic(M, p, X)` is consistent with evaluation at `0` and `t``
* that the result is a valid point on the manifold
* that the result matches `expected_value`, if given
* that the geodesic has constant speed (if activated) using `N` samples and each of the
  segments is of length equal to the average speed, i.e. `t*norm(M, p, X) / (N-1)`
"""
function Manifolds.Test.test_geodesic(
        M::AbstractManifold, p, X, t = 1.0;
        available_functions = Function[],
        expected_value = NoExpectation(),
        N = 10,
        name = "Geodesic on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        q = geodesic(M, p, X, t)
        Test.@test is_point(M, q; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, q, expect(expected_value); error = :error, kwargs...)
        p0 = geodesic(M, p, X, 0.0)
        Test.@test isapprox(M, p0, p; error = :error, kwargs...)
        γ = geodesic(M, p, X)
        qt = γ(t)
        Test.@test isapprox(M, qt, q; error = :error, kwargs...)
        # Since this test might exit early, it should always be the last test of this function
        if N > 0
            ts = range(0.0, t; length = N)
            points = [geodesic(M, p, X, ti) for ti in ts]
            if distance in available_functions
                dists = [distance(M, points[i], points[i + 1]) for i in 1:(length(points) - 1)]
                speeds = [d / (ts[i + 1] - ts[i]) for (i, d) in enumerate(dists)]
                avg_speed = sum(speeds) / length(speeds)
                for s in speeds
                    Test.@test isapprox(s, avg_speed; kwargs...)
                end
                Test.@test isapprox(avg_speed, t * norm(M, p, X); kwargs...)
            end
        end
    end
    return nothing
end # Manifolds.Test.test_geodesic

"""
    Manifolds.Test.test_get_coordinates(
        M, p, X, B;
        available_functions = [],
        expected_value = NoExpectation(),
        name = "get_coordinates on \$M at point \$(typeof(p))",
        test_mutating = true,
    )

Test the [`get_coordinates`](@extref `ManifoldsBase.get_coordinates`) on manifold `M` at point `p`
for a tangent vector `X` and a basis `B`.

* that the result is a valid coordinate vector, that is of correct length
* that the result matches `expected_value`, if given
* that the mutating version `get_coordinates!` matches the non-mutating version, (if activated)
* that [`get_vector`](@extref `ManifoldsBase.get_vector`) inverts `get_coordinates` (if activated)
"""
function Manifolds.Test.test_get_coordinates(
        M::AbstractManifold, p, X, B;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_mutating = true,
        name = "get_coordinates on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        c = get_coordinates(M, p, X, B)
        # TODO: Improve for complex manifolds and check for real of complex coordinates
        Test.@test length(c) == manifold_dimension(M)
        !isexpected(expected_value) || Test.@test isapprox(c, expect(expected_value); kwargs...)
        if test_mutating
            c2 = similar(c)
            get_coordinates!(M, c2, p, X, B)
            Test.@test isapprox(c2, c; kwargs...)
        end
        if (get_vector in available_functions)
            X2 = get_vector(M, p, c, B)
            Test.@test isapprox(M, p, X2, X; kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_get_coordinates

"""
    Manifolds.Test.test_get_basis(
        M, p, b::AbstractBasis;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : Expect(CachedBasis),
        name = "get_basis on \$M at point \$(typeof(p)) for basis \$(typeof(b))",
    )

Test the [`get_basis`](@extref `ManifoldsBase.get_basis`) on manifold `M` at point `p` for basis `b`.

* that it returns a basis of type `expected_type`, which defaults to [`CachedBasis`](@extref ManifoldsBase.CachedBasis).
* that the result matches `expected_value`, if given
"""
function Manifolds.Test.test_get_basis(
        M::AbstractManifold, p, b::AbstractBasis;
        available_functions = Function[],
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : Expect(CachedBasis),
        name = "get_basis on $M at point $(typeof(p)) for basis $(typeof(b))",
    )
    Test.@testset "$(name)" begin
        B = get_basis(M, p, b)
        Test.@test B isa AbstractBasis
        !isexpected(expected_type) || Test.@test B isa expect(expected_type)
        !isexpected(expected_value) || Test.@test B == expect(expected_value)
    end
    return nothing
end # Manifolds.Test.test_get_basis

"""
    Manifolds.Test.test_get_embedding(M, P=missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "get_embedding on \$M \$(ismissing(P) ? "" : "for type \$P")",
    )

Test the [`get_embedding`](@extref `ManifoldsBase.get_embedding-Tuple{AbstractManifold}`) on manifold `M`.

* that it returns an `AbstractManifold`.
* that its type matches `expected_type`, if given, defaults to the type of the expected value
* that the result matches `expected_value`, if given
"""
function Manifolds.Test.test_get_embedding(
        M::AbstractManifold, P::Union{Type, Missing} = missing;
        expected_value = NoExpectation(),
        expected_type = isexpected(expected_value) ? Expect(typeof(expect(expected_value))) : NoExpectation(),
        name = "get_embedding on $M $(ismissing(P) ? "" : "for type $P")",
    )
    Test.@testset "$(name)" begin
        E = ismissing(P) ? get_embedding(M) : get_embedding(M, P)
        Test.@test E isa AbstractManifold
        !isexpected(expected_type) || Test.@test E isa expect(expected_type)
        !isexpected(expected_value) || Test.@test E == expect(expected_value)
    end
    return nothing
end # Manifolds.Test.test_get_embedding

"""
    Manifolds.Test.test_get_vector(
        M, p, c, B;
        available_functions=[],
        expected_value = NoExpectation(),
        name = "get_vector on \$M at point \$(typeof(p))",
        test_mutating = true,
        kwargs...
    )

Test the [`get_vector`](@extref `ManifoldsBase.get_vector`) on manifold `M` at point `p`
for a vector of coordinates `c` in basis `B`.

* that the result is a valid tangent vector at `p` on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `get_vector!` matches the non-mutating version, (if activated)
* that [`get_coordinates`](@extref `ManifoldsBase.get_coordinates`) inverts `get_vector` (if activated)
"""
function Manifolds.Test.test_get_vector(
        M::AbstractManifold, p, c, B;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_mutating = true,
        name = "get_vector on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        X = get_vector(M, p, c, B)
        Test.@test is_vector(M, p, X; error = :error)
        !isexpected(expected_value) || Test.@test isapprox(M, p, X, expect(expected_value); error = :error)
        if test_mutating
            Y = copy(M, p, X)
            get_vector!(M, Y, p, c, B)
            Test.@test isapprox(M, p, Y, X; error = :error, kwargs...)
        end
        if (get_coordinates in available_functions)
            c2 = get_coordinates(M, p, X, B)
            Test.@test isapprox(c2, c; kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_get_vector

"""
    Manifolds.Test.test_get_vectors(
        M, p, b;
        available_functions=[],
        name = "get_vectors on \$M at point \$(typeof(p))",
        test_orthogonality = false,
        test_normality = false,
        kwargs...
    )

Test the [`get_vectors`](@extref `ManifoldsBase.get_vectors`) on manifold `M` at point `p` for basis `b`,
where the basis is assumed to come from a call to [`get_basis`](@extref `ManifoldsBase.get_basis`).

* that there are as many vectors as the manifold dimension (if available)
* that each vector is a valid tangent vector at `p` on the manifold
* that the vectors are orthogonal (if activated)
* that the vectors are normal (if activated)
"""
function Manifolds.Test.test_get_vectors(
        M::AbstractManifold, p, b::AbstractBasis;
        available_functions = Function[],
        test_orthogonality = false,
        test_normality = false,
        name = "get_vectors on $M at point $(typeof(p)) and $(typeof(b))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        Vs = get_vectors(M, p, b)
        n = length(Vs)
        if manifold_dimension in available_functions
            md = manifold_dimension(M)
            Test.@test n == md
        end
        for i in 1:n
            Test.@test is_vector(M, p, Vs[i]; error = :error, kwargs...)
            if test_orthogonality
                for j in (i + 1):n
                    ip = inner(M, p, Vs[i], Vs[j])
                    Test.@test isapprox(ip, 0.0; kwargs...)
                end
            end
            if test_normality
                nn = norm(M, p, Vs[i])
                Test.@test isapprox(nn, 1.0; kwargs...)
            end
        end
    end
    return nothing
end # Manifolds.Test.test_get_vectors

"""
    Manifolds.Test.test_injectority_radius(M, p = missing;
        expected_value = NoExpectation(),
        expected_global_value = NoExpectation(),
        retraction_method = missing,
        name = "Injectivity radius on \$M at point \$(ismissing(p) ? "" : "\$typeof(p)")) and \$(retraction_method)",
        kwargs...
    )

Test the injectivity radius on manifold `M` at point `p`.

* that the result is a nonnegative real number
* that the result matches `expected_value`, if given
* if a point `p` is given, that the result is larger or equal to the global injectivity radius
"""
function Manifolds.Test.test_injectivity_radius(
        M::AbstractManifold, p = missing;
        expected_value = NoExpectation(),
        expected_global_value = NoExpectation(),
        name = "Injectivity radius on $M at point $(ismissing(p) ? "" : "$(typeof(p))")",
        retraction_method = missing,
        kwargs...
    )
    Test.@testset "$(name)" begin
        r = if ismissing(p)
            ismissing(retraction_method) ? injectivity_radius(M) : injectivity_radius(M, retraction_method)
        else
            ismissing(retraction_method) ? injectivity_radius(M, p) : injectivity_radius(M, p, retraction_method)
        end
        Test.@test r ≥ 0.0
        !isexpected(expected_value) || Test.@test isapprox(r, expect(expected_value); kwargs...)
        if !ismissing(p)
            r_global = ismissing(retraction_method) ? injectivity_radius(M) : injectivity_radius(M, retraction_method)
            Test.@test r ≥ r_global
            !isexpected(expected_global_value) || Test.@test isapprox(r_global, expect(expected_global_value); kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_injectivity_radius

"""
    Manifolds.Test.test_inner(M, p, X, Y;
        available_functions=[], expected_value = NoExpectation(),
        name = "Inner product on \$M at point \$(typeof(p))",
        test_norm = (norm in available_functions),
        kwargs...
    )

Test the inner product on the manifold `M` at point `p` for tangent vectors `X` and `Y`.

* that the result is a real number
* that the result matches `expected_value`, if given
* that the inner product of `X` with itself is non negative
* that the inner product of `X` with itself is the same as its norm squared (if activated)
"""
function Manifolds.Test.test_inner(
        M::AbstractManifold, p, X, Y;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_norm = (norm in available_functions),
        name = "Inner product on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        v = inner(M, p, X, Y)
        Test.@test v isa (Real)
        !isexpected(expected_value) || Test.@test isapprox(v, expect(expected_value); kwargs...)
        w = inner(M, p, X, X)
        Test.@test w ≥ 0.0
        if test_norm
            n = norm(M, p, X)
            Test.@test isapprox(w, n^2; kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_inner

"""
    Manifolds.Test.test_inverse_retraction(
        M, p, q, m::AbstractInverseRetractionMethod;
        available_functions=[],
        expected_value = NoExpectation(),
        name = "Inverse retraction \$m on \$M at point \$(typeof(p))",
        retraction_method = missing,
        test_mutating = true,
        test_retraction = (retract in available_functions) && !ismissing(retraction_method),
        kwargs...
    )

Test the inverse retraction method `m` on manifold `M` at point `p` towards point `q`.

* that the result is a valid tangent vector at `p` on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `inverse_retract!` matches the non-mutating version, (if activated)
* that the retraction inverts the inverse retraction (if activated)
"""
function Manifolds.Test.test_inverse_retract(
        M, p, q, m::AbstractInverseRetractionMethod;
        available_functions = Function[],
        expected_value = NoExpectation(),
        name = "Inverse retraction $m on $M at point $(typeof(p))",
        retraction_method = missing,
        test_retraction = (retract in available_functions) && !ismissing(retraction_method),
        test_mutating = true,
        kwargs...
    )
    Test.@testset "$(name)" begin
        X = inverse_retract(M, p, q, m)
        Test.@test is_vector(M, p, X; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, p, X, expect(expected_value); error = :error, kwargs...)
        if test_mutating
            Y = copy(M, p, X)
            inverse_retract!(M, Y, p, q, m)
            Test.@test isapprox(M, p, Y, X; error = :error, kwargs...)
        end
        if test_retraction
            q2 = retract(M, p, X, retraction_method)
            Test.@test isapprox(M, q2, q; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_inverse_retraction

"""
    Manifolds.Test.test_is_default_metric(M, metric::AbstractMetric;
    name = "is_default_metric on \$M",
    )

Test the [`is_default_metric`](@extref ManifoldsBase.is_default_metric) on manifold `M`.

* that it returns true for the given `metric`
* that it returns false for all other provided metrics
"""
function Manifolds.Test.test_is_default_metric(
        M::AbstractManifold, metric::Union{AbstractMetric, AbstractExpectation};
        name = "is_default_metric on $M",
    )
    Test.@testset "$(name)" begin
        !isexpected(metric) || Test.@test is_default_metric(M, expect(metric))
    end
    return nothing
end # Manifolds.Test.test_default_metric

"""
    Manifolds.Test.test_is_flat(
    M;
    expected_value = NoExpectation(),
    name = "is_flat on \$M",
    )

Test the function [`is_flat`](@ref) on manifold `M`. Since it returns a boolean,
there is also only the check that it agrees with the `expected_value`, if given.
"""
function Manifolds.Test.test_is_flat(
        M::AbstractManifold;
        expected_value = NoExpectation(),
        name = "is_flat on $M",
    )
    Test.@testset "$(name)" begin
        v = is_flat(M)
        !isexpected(expected_value) || Test.@test v == expect(expected_value)
    end
    return nothing
end

"""
    Manifolds.Test.is_point(
        M, p qs...;
        errors = [],
        name = "is_point on \$M for \$(typeof(p)) points",
        test_warn = true,
        test_info = true,
        kwargs...
    )

Test the function [`is_point`](@ref) on  for point `p` on manifold `M`.

* that for `p` it returns `true`.
* that for each `q` in `qs` it
  * returns `false`
  * issues a warning (if activated)
  * isues an info message (if activated)
  * throws the corresponding error from `error_types` (if not `missing`)
"""
function Manifolds.Test.test_is_point(
        M::AbstractManifold, p, qs...;
        errors = [],
        name = "is_point on $M for $(typeof(p)) points",
        test_warn = true,
        test_info = true,
        kwargs...
    )
    Test.@testset "$(name)" begin
        Test.@test is_point(M, p; kwargs...)
        for (i, q) in enumerate(qs)
            Test.@test !is_point(M, q; kwargs...)
            (test_warn) && Test.@test_logs (:warn,) is_point(M, q; error = :warn, kwargs...)
            (test_info) && Test.@test_logs (:info,) is_point(M, q; error = :info, kwargs...)
            if length(errors) >= i && !ismissing(errors[i])
                Test.@test_throws (errors[i]) is_point(M, q; error = :error, kwargs...)
            end
        end
    end
    return nothing
end

"""
    Manifolds.Test.test_is_vector(
        M, p, X, Ys...;
        basepoint_error = missing,
        check_basepoint = true,
        errors = [],
        name = "is_vector on \$M for \$(typeof(p)) points",
        test_warn = true,
        test_info = true,
        q = missing,
        kwargs...
    )

Test the function [`is_vector`](@ref) on manifold `M` at point `p` for tangent vector `X`.

* that for `X` it returns `true`.
* that for each `Y` in `Ys` it
    * returns `false`
    * issues a warning (if activated)
    * isues an info message (if activated)
    * throws the corresponding error from `error_types` (if not `missing`)
* if `check_basepoint` is `true`, then it checks that
    * for `p` this still returns `true`
    * for the base point `q` it
      * returns `false`
      * issues a warning (if activated)
      * isues an info message (if activated)
      * throws the corresponding error from `error_basepoint` (if activated)
"""
function Manifolds.Test.test_is_vector(
        M::AbstractManifold, p, X, Ys...;
        check_basepoint = true,
        errors = [],
        basepoint_error = missing,
        name = "is_vector on $M for $(typeof(p)) points",
        test_warn = true,
        test_info = true,
        q = missing,
        kwargs...
    )
    Test.@testset "$(name)" begin
        Test.@test is_vector(M, p, X; kwargs...)
        for (i, Y) in enumerate(Ys)
            Test.@test !is_vector(M, p, Y; kwargs...)
            (test_warn) && Test.@test_logs (:warn,) is_vector(M, p, Y; error = :warn, kwargs...)
            (test_info) && Test.@test_logs (:info,) is_vector(M, p, Y; error = :info, kwargs...)
            if length(errors) >= i && !ismissing(errors[i])
                Test.@test_throws (errors[i]) is_vector(M, p, Y; error = :error, kwargs...)
            end
        end
        if check_basepoint
            Test.@test is_vector(M, p, X, true; kwargs...)
            if !ismissing(q) && isexpected(q)
                Test.@test !is_vector(M, q, X, true; kwargs...)
                (test_warn) && Test.@test_logs (:warn,) is_vector(M, q, X, true; error = :warn, kwargs...)
                (test_info) && Test.@test_logs (:info,) is_vector(M, q, X, true; error = :info, kwargs...)
                !isexpected(basepoint_error) || Test.@test_throws (basepoint_error) is_vector(M, q, X, true; error = :error, kwargs...)
            end
        end
    end
    return nothing
end

"""
    Manifolds.Test.test_log(
        M, p, q;
        available_functions=[], expected_value=NoExpectation(), test_mutating=true,
        test_exp = (exp in available_functions),
        test_injectivity_radius = (injectivity_radius in available_functions),
        name = "Logarithmic map on \$M for \$(typeof(p)) points",
        kwargs...
    )
    Test the logarithmic map on manifold `M` at point `p` towards q

    * that the result is a valid tangent vector at `p` on the manifold
    * that the result matches `expected_value`, if given
    * that the mutating version `log!` matches the non-mutating version, (if activated)
    * that the exponential map inverts the logarithmic map (if activated)
    (only performed if either `injectivity_radius` is not available or `X` is within)
"""
function Manifolds.Test.test_log(
        M::AbstractManifold, p, q;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_exp = (exp in available_functions),
        test_injectivity_radius = (injectivity_radius in available_functions),
        test_mutating = true,
        name = "Logarithmic map on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        X = log(M, p, q)
        Test.@test is_vector(M, p, X; error = :error, kwargs...)
        Z = log(M, p, p)
        Test.@test is_vector(M, p, Z; error = :error, kwargs...)
        Test.@test norm(M, p, Z) ≈ 0.0   # log
        !isexpected(expected_value) || Test.@test isapprox(M, p, X, expect(expected_value); error = :error, kwargs...)
        if test_mutating
            Y = copy(M, p, X)
            log!(M, Y, p, q)
            Test.@test isapprox(M, Y, X; error = :error, kwargs...)
        end
        if test_exp
            # Test only if inj is not available of X is within inj radius
            run_test = !test_injectivity_radius || norm(M, p, X) ≤ injectivity_radius(M, p)
            run_test || (@warn("Skipping exp-log test since norm of X ($(norm(M, p, X))) is outside injectivity radius ($(injectivity_radius(M, p)))"))
            q2 = exp(M, p, X)
            Test.@test isapprox(M, q2, q; error = :error, kwargs...) skip = !run_test
        end
    end
    return nothing
end # Manifolds.Test.test_log

"""
    test_manifold_dimension(
        M;
        expected_value = NoExpectation(),
        expected_type = Int,
        name = "Manifold dimension for \$M",
    )

Test that the dimension of the manifold `M` is consistent.

* that the dimension is nonnegative
* that it is an integer (of type `expected_type`, `Int` by default)
* that it matches the expected value (if provided)
"""
function Manifolds.Test.test_manifold_dimension(
        M;
        expected_value = NoExpectation(),
        expected_type = Int,
        name = "Manifold dimension for $M",
    )
    Test.@testset "$(name)" begin
        d = manifold_dimension(M)
        Test.@test d ≥ 0
        Test.@test isa(d, expected_type)
        !isexpected(expected_value) || (@test d == expect(expected_value))
    end
    return nothing
end # Manifolds.Test.test_manifold_dimension

"""
    Manifolds.Test.test_manifold_volume(
        M;
        expected_value = NoExpectation(),
        name = "Manifold volume for \$M",
    )

Test the volume of the manifold `M`.

* that the volume is nonnegative
* that it matches the expected value (if provided)
"""
function Manifolds.Test.test_manifold_volume(
        M;
        expected_value = NoExpectation(),
        name = "Manifold volume for $M",
    )
    Test.@testset "$(name)" begin
        v = manifold_volume(M)
        Test.@test v ≥ 0.0
        !isexpected(expected_value) || Test.@test isapprox(v, expect(expected_value))
    end
    return nothing
end # Manifolds.Test.test_manifold_volume

"""
    Manifolds.Test.test_mid_point(M, p, q;
        available_functions=[],
        expected_value = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        test_symmetry = true,
        name = "Mid-point on \$M between \$(typeof(p)) points",
        kwargs...
    )

Test the mid-point function on manifold `M` between points `p` and `q`.

* that the result is a valid point on the manifold
* that the result matches `expected_value`, if given
* that the mid-point is symmetric (if activated)
* that the distance from `p` and `q` to the mid-point is half the distance from `p` to `q` (if distance is present)
* that the mutating version `mid_point!` matches the non-mutating version (if activated)
* that `mid_point!` works on aliased in put (`r=p` or `r=q`) (if activated for mutating)
"""
function Manifolds.Test.test_mid_point(
        M, p, q;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        test_symmetry = true,
        name = "Mid-point on $M between $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        r = mid_point(M, p, q)
        Test.@test is_point(M, r; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, r, expect(expected_value); error = :error, kwargs...)
        r2 = mid_point(M, q, p)
        test_symmetry || Test.@test isapprox(M, r2, r; error = :error, kwargs...)
        if distance in available_functions
            d_pq = distance(M, p, q)
            d_pr = distance(M, p, r)
            d_qr = distance(M, q, r)
            Test.@test isapprox(d_pr, d_pq / 2; kwargs...)
            Test.@test isapprox(d_qr, d_pq / 2; kwargs...)
        end
        if test_mutating
            r3 = copy(M, p)
            mid_point!(M, r3, p, q)
            Test.@test isapprox(M, r3, r; error = :error, kwargs...)
            if test_aliased
                r4 = copy(M, p)
                mid_point!(M, r4, r4, q)  # aliased #1
                Test.@test isapprox(M, r4, r; error = :error, kwargs...)
                r5 = copy(M, q)
                mid_point!(M, r5, p, r5)  # aliased #2
                Test.@test isapprox(M, r5, r; error = :error, kwargs...)
            end
        end
    end
    return nothing
end # Manifolds.Test.test_mid_point

"""
    Manifolds.Test.test_norm(M, p, X;
        available_functions = [], expected_value = NoExpectation(),
        name = "Norm on \$M at point \$(typeof(p))",
        test_inner = (inner in available_functions),
        kwargs...
    )

Test the norm on the manifold `M` at point `p` for tangent vector `X`.

* that the result is a real number
* that the result matches `expected_value`, if given
* that the norm of `X` with itself is non negative
* that the inner product of `X` with itself is the same as its norm squared (if activated)
"""
function Manifolds.Test.test_norm(
        M::AbstractManifold, p, X;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_inner = (inner in available_functions),
        name = "Norm on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        v = norm(M, p, X)
        Test.@test v isa (Real)
        !isexpected(expected_value) || Test.@test isapprox(v, expect(expected_value); kwargs...)
        Test.@test v ≥ 0.0
        if test_inner
            w = inner(M, p, X, X)
            Test.@test isapprox(w, v^2; kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_norm

"""
    Manifolds.Test.test_parallel_transport(
        M, p, X, q;
        available_functions=[],
        direction = (log in available_functions) ? log(M, p, q) : missing,
        expected_value=NoExpectation(),
        expected_value_direction=NoExpectation(),
        name = "Parallel transport on \$M at point \$(typeof(p))",
        test_aliased = true,
        test_mutating = true,
        kwargs...
    )

Test the parallel transport on manifold `M` at point `p` with tangent vector `X` to a point `q`.

this defaults to testing `parallel_transport_to`, but can also be used to test `parallel_transport_direction`,
by passing that function to the `available_functions`, using the `direction` argument.
The `direction` has to be the one that transports `X` also to `q`.

* that the result is a valid tangent vector at `q` on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `parallel_transport!` matches the non-mutating version
* that `parallel_transport_to` works on aliased in put (`Y=X`) (if activated)
* that the direction of the transport is consistent with `expected_direction`, if given
* that the mutating version `parallel_transport_direction!` matches the non-mutating version (if activated)
* that `parallel_transport_direction` works on aliased in put (`Y=X` or `Y=d`) (if activated for mutating)
* that both functions are consistent
"""
function Manifolds.Test.test_parallel_transport(
        M, p, X, q;
        available_functions = [],
        direction = (log in available_functions) ? log(M, p, q) : missing,
        expected_value_direction = NoExpectation(),
        expected_value = NoExpectation(),
        name = "Parallel transport on $M at point $(typeof(p))",
        test_aliased = true,
        test_mutating = true,
        kwargs...
    )
    Test.@testset "$(name)" begin
        Y = parallel_transport_to(M, p, X, q)
        Test.@test is_vector(M, q, Y; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, p, Y, expect(expected_value); error = :error, kwargs...)
        if test_mutating
            Y2 = copy(M, p, X)
            parallel_transport_to!(M, Y2, p, X, q)
            Test.@test isapprox(M, q, Y2, Y; error = :error, kwargs...)
            if test_aliased
                Y3 = copy(M, p, X)
                parallel_transport_to!(M, Y3, p, Y3, q)  # aliased
                Test.@test isapprox(M, q, Y3, Y; error = :error, kwargs...)
            end
        end
        if (parallel_transport_direction in available_functions) && !ismissing(direction)
            Y4 = parallel_transport_direction(M, p, X, direction)
            !isexpected(expected_value_direction) || Test.@test isapprox(M, q, Y4, expect(expected_value_direction); error = :error, kwargs...)
            if test_mutating
                Y5 = copy(M, p, X)
                parallel_transport_direction!(M, Y5, p, X, direction)
                Test.@test isapprox(M, p, Y5, Y4; error = :error, kwargs...)
                if test_aliased
                    Y6 = copy(M, p, X)
                    parallel_transport_direction!(M, Y6, p, Y6, direction)  # aliased #1
                    Test.@test isapprox(M, p, Y6, Y4; error = :error, kwargs...)
                    Y7 = copy(M, p, direction)
                    parallel_transport_direction!(M, Y7, p, X, direction)  # aliased #2
                    Test.@test isapprox(M, p, Y7, Y4; error = :error, kwargs...)
                end
            end
            # consistency check
            Test.@test is_vector(M, q, Y4; error = :error, kwargs...)
            Test.@test isapprox(M, q, Y, Y4; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_parallel_transport

"""
    Manifolds.Test.test_project(
        M, q, Y = missing;
        available_functions = [],
        expected_point = NoExpectation(),
        expected_vector = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Projection on \$M for \$(typeof(q)) points",
        kwargs...
    )

Test the [`project`](@extref `ManifoldsBase.project-Tuple{AbstractManifold, Any}`)`(M, q)` and [`project`](@extref `ManifoldsBase.project-Tuple{AbstractManifold, Any, Any}`)`(M, q, Y)`
to project points and tangent vectors (if not `missing`).

Besides a simple call of `project` (for both variants)  the following tests are performed

* that the projected point is a valid point on the manifold
* that the projected vector is a valid tangent vector on the manifold
* that the result matches `expected_point` and `expected_vector`, respectively, if given
* that the mutating version `project!` produces the same result(s) (if activated)
* that `project!` works on aliased input (`p=q` or `X=Y`) (if activated _and_ p/q or X/Y are of same type)
"""
function Manifolds.Test.test_project(
        M::AbstractManifold, q, Y = missing;
        available_functions = Function[],
        expected_point = NoExpectation(),
        expected_vector = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Projection on $M for $(typeof(q)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        # Test point projection
        p = project(M, q)
        Test.@test is_point(M, p; error = :error, kwargs...)
        !isexpected(expected_point) || Test.@test isapprox(M, p, expect(expected_point); error = :error, kwargs...)
        if test_mutating
            p2 = copy(M, p)
            project!(M, p2, q)
            Test.@test isapprox(M, p2, p; error = :error, kwargs...)
            if test_aliased && (typeof(p) == typeof(q))
                p3 = copy(M, q)
                project!(M, p3, p3)  # aliased
                Test.@test isapprox(M, p3, p; error = :error, kwargs...)
            end
        end
        # Test vector projection
        if !ismissing(Y)
            X = project(M, q, Y)
            Test.@test is_vector(M, p, X; error = :error, kwargs...)
            !isexpected(expected_vector) || Test.@test isapprox(M, p, X, expect(expected_vector); error = :error, kwargs...)
            if test_mutating
                X2 = copy(M, p, X)
                project!(M, X2, q, Y)
                Test.@test isapprox(M, p, X2, X; error = :error, kwargs...)
                if test_aliased
                    X3 = copy(M, p, X)
                    project!(M, X3, q, X3)  # aliased
                    Test.@test isapprox(M, p, X3, X; error = :error, kwargs...)
                end
            end
        end
    end
    return nothing
end # Manifolds.Test.test_project

"""
    Manifolds.Test.test_repr(
        M;
        expected_value = NoExpectation(),
        name = "(String) repr_esentation of \$M",
    )

Test that the default `show` method works as expected by calling `repr(M)`.
"""
function Manifolds.Test.test_repr(
        M; expected_value = NoExpectation(), name = "(String) repr_esentation of \$M",
    )
    Test.@testset "$(name)" begin
        s = repr(M)
        !isexpected(expected_value) || Test.@test s == expect(expected_value)
    end
    return nothing
end # Manifolds.Test.test_repr

"""
    Manifolds.Test.test_rand(M;
        vector_at = missing,
        seed = missing,
        test_mutating = true,
        rng = missing,
        name = "Random sampling on \$M",
        kwargs...
    )

Test the random sampling functions `rand(M)` and `rand(M; vector_at=p` (if `vector_at` is given) on manifold `M`.

* that the result of `rand(M)` is a valid point on the manifold
* that the result of `rand(M; vector_at=p)` is a valid tangent vector at `p` on the manifold (if `vector_at` is given)
* that the mutating versions `rand!` match the non-mutating versions (if activated)
* that the four mentioned functions also work with a seed upfront.
"""
function Manifolds.Test.test_rand(
        M::AbstractManifold;
        vector_at = missing,
        seed = missing,
        test_mutating = true,
        rng = missing,
        name = "Random sampling on $M $(ismissing(vector_at) ? "" : "at points of type $(typeof(vector_at))")",
        kwargs...
    )
    Test.@testset "$(name)" begin
        ismissing(seed) || (ismissing(rng) ? Random.seed!(seed) : Random.seed!(rng, seed))
        # Test rand(M)
        p = ismissing(rng) ? rand(M) : rand(rng, M)
        Test.@test is_point(M, p; error = :error, kwargs...)
        if test_mutating
            p2 = copy(M, p)
            ismissing(rng) ? rand!(M, p2) : rand!(rng, M, p2)
            Test.@test is_point(M, p2; error = :error, kwargs...)
        end
        # Test rand(M; vector_at=p)
        q = ismissing(vector_at) ? p : vector_at
        X = ismissing(rng) ? rand(M; vector_at = vector_at) : rand(rng, M; vector_at = vector_at)
        Test.@test is_vector(M, q, X; error = :error, kwargs...)
        if test_mutating
            X2 = copy(M, vector_at, X)
            ismissing(rng) ? rand!(M, X2; vector_at = q) : rand!(rng, M, X2; vector_at = q)
            Test.@test is_vector(M, q, X2; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_rand

"""
    Manifolds.Test.test_representation_size(
        M;
        expected_value = NoExpectation(),
        name = "Representation size of \$M",
    )

Test the representation size of the manifold `M`.

* that the result is tuple of nonnegative integers or nothing (if there is no reasonable representation)
* that it matches the expected value (if provided)
"""
function Manifolds.Test.test_representation_size(
        M::AbstractManifold;
        expected_value = NoExpectation(),
        name = "Representation size of $M",
    )
    Test.@testset "$(name)" begin
        s = representation_size(M)
        if !isnothing(s)
            Test.@test all(x -> x ≥ 0 && x isa Int, s)
        end
        !isexpected(expected_value) || Test.@test s == expect(expected_value)
    end
    return nothing
end # Manifolds.Test.test_representation_size

"""
    Manifolds.test.test_retract(
        M, p, X, m::AbstractRetractionMethod;
        available_functions=[],
        expected_value = NoExpectation(),
        inverse_retraction_method = missing,
    name = "Retraction \$m on \$M at point \$(typeof(p))",
        t = 1.0
        test_mutating = true,
        test_mutating = true,
        test_inverse_retraction = (inverse_retraction in available_functions) && !ismissing(inverse_retraction_method),
        kwargs...
    )

Test the retraction method `m` on manifold `M` at point `p` with tangent vector `X`.

* that the result is a valid point on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `retract!` matches the non-mutating version, (if activated)
* that `retract!` works on aliased in put (`p=q`) (if activated for mutating)
* that the inverse retraction inverts the retraction (if activated)
* that the fused version `retract_fused(M, p, X, t, m)` matches the non-fused version (if activated)
"""
function Manifolds.Test.test_retract(
        M, p, X, m::AbstractRetractionMethod;
        t = 1.0,
        available_functions = Function[],
        expected_value = NoExpectation(),
        inverse_retraction_method = missing,
        name = "Retraction $m on $M at point $(typeof(p))",
        test_aliased = true,
        test_inverse_retraction = (inverse_retract in available_functions) && !ismissing(inverse_retraction_method),
        test_mutating = true,
        test_fused = true,
        kwargs...
    )
    Test.@testset "$(name)" begin
        q = retract(M, p, X, m)
        Test.@test is_point(M, q; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, q, expected(expected_value); error = :error, kwargs...)
        if test_mutating
            q2 = copy(M, p)
            retract!(M, q2, p, X, m)
            Test.@test isapprox(M, q2, q; error = :error, kwargs...)
            if test_aliased
                q3 = copy(M, p)
                retract!(M, q3, q3, X, m)  # aliased
                Test.@test isapprox(M, q3, q; error = :error, kwargs...)
            end
        end
        if test_fused
            q4 = Manifolds.retract_fused(M, p, X, t, m)
            q5 = retract(M, p, t * X, m)
            Test.@test isapprox(M, q4, q5; error = :error, kwargs...)
            if test_mutating
                q6 = copy(M, p)
                Manifolds.retract_fused!(M, q6, p, X, t, m)
                Test.@test isapprox(M, q6, q5; error = :error, kwargs...)
                if test_aliased
                    q7 = copy(M, p)
                    Manifolds.retract_fused!(M, q7, q7, X, t, m)  # aliased
                    Test.@test isapprox(M, q7, q5; error = :error, kwargs...)
                end
            end
        end
        if test_inverse_retraction
            X2 = inverse_retract(M, p, q, inverse_retraction_method)
            Test.@test isapprox(M, p, X2, X; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_retract

"""
    Manifolds.Test.test_sectional_curvature(
        M, p, X, Y;
        expected_value = NoExpectation(),
        expected_min = NoExpectation(),
        expected_max = NoExpectation(),
        name = "Sectional curvature on \$M at point \$(typeof(p))",
        kwargs...
    )

Test the sectional curvature on manifold `M` at point `p` for tangent vectors `X` and `Y`.
* that the result is a real number
* that the result matches `expected_value`, if given
* that the minimum sectional curvature at `p` is less than or equal to the sectional curvature
* that the maximum sectional curvature at `p` is greater than or equal to the sectional curvature
* that the minimum and maximum sectional curvatures match `expected_min` and `expected_max`, if given
"""
function Manifolds.Test.test_sectional_curvature(
        M, p, X, Y;
        expected_value = NoExpectation(),
        expected_min = NoExpectation(),
        expected_max = NoExpectation(),
        name = "Sectional curvature on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        k = sectional_curvature(M, p, X, Y)
        Test.@test k isa (Real)
        !isexpected(expected_value) || Test.@test isapprox(k, expected(expected_value); kwargs...)
        K_min = sectional_curvature_min(M)
        K_max = sectional_curvature_max(M)
        Test.@test K_min ≤ k
        Test.@test K_max ≥ k
        !isexpected(expected_min) || Test.@test isapprox(K_min, expected(expected_min); kwargs...)
        !isexpected(expected_max) || Test.@test isapprox(K_max, expected(expected_max); kwargs...)
    end
    return nothing
end # Manifolds.Test.test_sectional_curvature

"""
    Manifolds.Test.test_sharp(M, p, ξ;
        available_functions=[],
        expected_value = NoExpectation(),
        name = "Sharp on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the sharp operation on manifold `M` at point `p` with cotangent vector `ξ`.
* test that the result is a valid tangent vector at `p` on the manifold
* that the result matches `expected_value`, if given
* that [`flat`](@ref) is the inverse
* that mutating version `sharp!` matches non-mutating version (if activated)
"""
function Manifolds.Test.test_sharp(
        M, p, ξ;
        available_functions = Function[],
        expected_value = NoExpectation(),
        test_mutating = true,
        name = "Sharp on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        X = sharp(M, p, ξ)
        Test.@test is_vector(M, p, X; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, p, X, expected(expected_value); error = :error, kwargs...)
        if flat in available_functions
            ξ2 = flat(M, p, X)
            Test.@test isapprox(M, ξ2, ξ; error = :error, kwargs...)
        end
        if test_mutating
            X2 = copy(M, p, X)
            sharp!(M, X2, p, ξ)
            Test.@test isapprox(M, X2, X; error = :error, kwargs...)
        end
    end
    return nothing
end

"""
    Manifolds.Test.test_shortest_geodesic(M, p, q, t=1.0;
        available_functions=[],
        expected_value = NoExpectation(),
        N = 10,
        name = "Shortest geodesic on \$M for \$(typeof(p)) points",
        kwargs...
    )

Test the geodesic on manifold `M` at point `p` with tangent vector `X` at time `t`.
* that at time `0` the geodesic returns `p`, at time 2 it returns `q`
* that the function `γ = shortest_geodesic(M, p, X)` is consistent with evaluation at `0`, `1` and `t``
* that the result at `t` is a valid point on the manifold
* that the geodesic has constant speed (if activated) using `N` samples and the approximated
  derivative via finite differences
* that the geodesic is length minimizing, i.e. the sum of the segments is approximately equal to the distance from `p` to `q` (if activated)
"""
function Manifolds.Test.test_shortest_geodesic(
        M, p, q, t = 0.5;
        available_functions = Function[],
        expected_value = NoExpectation(),
        N = 10,
        name = "Shortest geodesic on $M for $(typeof(p)) points",
        kwargs...
    )
    Test.@testset "$(name)" begin
        p2 = shortest_geodesic(M, p, q, 0.0)
        Test.@test isapprox(M, p2, p; error = :error, kwargs...)
        q2 = shortest_geodesic(M, p, q, 1.0)
        Test.@test isapprox(M, q2, q; error = :error, kwargs...)
        qt = shortest_geodesic(M, p, q, t)
        Test.@test is_point(M, qt; error = :error, kwargs...)
        γ = shortest_geodesic(M, p, q)
        Test.@test isapprox(M, p2, γ(0.0); error = :error, kwargs...)
        Test.@test isapprox(M, q2, γ(1.0); error = :error, kwargs...)
        Test.@test isapprox(M, qt, γ(t); error = :error, kwargs...)
        # consistency
        @test isapprox(distance(M, p, q) * t, distance(M, p, qt); kwargs...)
        @test isapprox(distance(M, p, q) * (1 - t), distance(M, qt, q); kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, qt, expected(expected_value); error = :error, kwargs...)
        # Test constant speed
        if (distance in available_functions) && (norm in available_functions)
            ts = range(0.0, 1.0; length = N)
            points = [shortest_geodesic(M, p, q, ti) for ti in ts]
            dists = [distance(M, points[i], points[i + 1]) for i in 1:(length(points) - 1)]
            speeds = [d / (ts[i + 1] - ts[i]) for (i, d) in enumerate(dists)]
            avg_speed = mean(speeds)
            for s in speeds
                Test.@test isapprox(s, avg_speed; kwargs...)
            end
            # unit speed
            Test.@test isapprox(avg_speed, distance(M, p, q); kwargs...)
            # Test length minimizing
            total_length = sum(dists)
            d_pq = distance(M, p, q)
            Test.@test isapprox(total_length, d_pq; kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_shortest_geodesic

"""
    Manifolds.Test.test_vector_transport(
        M, p, X, q, default_vector_transport_method(M);
        available_functions=[],
        direction = inverse_retract(M, p, q, default_inverse_retraction_method(M)),
        expected_value = NoExpectation(),
        expected_value_direction = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Vector transport method \$(vector_transport_method) on \$M at point \$(typeof(p))",
        kwargs...
    )

Test the vector transport on manifold `M` at point `p` with tangent vector `X` to a point `q`.

this defaults to testing `vector_transport_to`, but can also be used to test `vector_transport_direction`,
by passing that function to the `available_functions`, using the `direction` argument.
The `direction` has to be the one that transports `X` also to `q`.

* that the result is a valid tangent vector at `q` on the manifold
* that the result matches `expected_value`, if given
* that the mutating version `vector_transport!` matches the non-mutating version
* that `vector_transport_to` works on aliased in put (`Y=X`) (if activated)
* that the direction of the transport is consistent with `expected_direction`, if given
* that the mutating version `vector_transport_direction!` matches the non-mutating version (if activated)
* that `vector_transport_direction` works on aliased in put (`Y=X` or `Y=d`) (if activated for mutating)
* that both functions are consistent
"""
function Manifolds.Test.test_vector_transport(
        M, p, X, q, m = default_vector_transport_method(M);
        available_functions = [],
        direction = inverse_retract(M, p, q, default_inverse_retraction_method(M)),
        expected_value_direction = NoExpectation(),
        expected_value = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Vector transport method $(vector_transport_method) on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        Y = vector_transport_to(M, p, X, q, m)
        Test.@test is_vector(M, q, Y; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, p, Y, expected(expected_value); error = :error, kwargs...)
        if test_mutating
            Y2 = copy(M, p, X)
            vector_transport_to!(M, Y2, p, X, q, m)
            Test.@test isapprox(M, q, Y2, Y; error = :error, kwargs...)
            if test_aliased
                Y3 = copy(M, p, X)
                vector_transport_to!(M, Y3, p, Y3, q)  # aliased
                Test.@test isapprox(M, p, Y3, Y; error = :error, kwargs...)
            end
        end
        if (vector_transport_direction in available_functions) && !isnothing(direction)
            Y4 = vector_transport_direction(M, p, X, direction, m)
            !isexpected(expected_value_direction) || Test.@test isapprox(M, p, Y4, expected(expected_value_direction); error = :error, kwargs...)
            if test_mutating
                Y5 = copy(M, p, X)
                vector_transport_direction!(M, Y5, p, X, direction, m)
                Test.@test isapprox(M, p, Y5, Y4; error = :error, kwargs...)
                if test_aliased
                    Y6 = copy(M, p, X)
                    vector_transport_direction!(M, Y6, p, Y6, direction, m)  # aliased #1
                    Test.@test isapprox(M, q, Y6, Y4; error = :error, kwargs...)
                    Y7 = copy(M, p, direction)
                    vector_transport_direction!(M, Y7, p, X, direction, m)  # aliased #2
                    Test.@test isapprox(M, q, Y7, Y4; error = :error, kwargs...)
                end
            end
            # consistency check
            Test.@test is_vector(M, q, Y4; error = :error, kwargs...)
            Test.@test isapprox(M, q, Y, Y4; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_vector_transport

"""
    Manifolds.Test.test_volume_density(
        M, p, X;
        expected_value = NoExpectation(),
        name = "Manifold volume density for \$M",
        kwargs...
    )

Test the [`volume_density`](@ref) of the manifold `M`.

* that it matches the expected value (if provided)
"""
function Manifolds.Test.test_volume_density(
        M, p, X;
        expected_value = NoExpectation(),
        name = "Manifold volume density for $M",
        kwargs...
    )
    Test.@testset "$(name)" begin
        v = volume_density(M, p, X)
        !isexpected(expected_value) || Test.@test isapprox(v, expect(expected_value); kwargs...)
    end
    return nothing
end # Manifolds.Test.test_volume_density

"""
    Manifolds.Test.Weingarten(
        M, p, X, V;
        expected_value = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Weingarten map on \$M at point \$(typeof(p))",
        kwargs...
    )

Test the Weingarten map on manifold `M` at point `p` for tangent vector `X` and normal vector `V`.

* that the result is a valid tangent vector at `p` on the manifold
* that the result matches `expected_value`, if given
* that the result is consistent with the mutating version `weingarten!` (if activated)
* that `Weingarten!` works on aliased in put (`Y=X`) (if activated for mutating)
"""
function Manifolds.Test.test_Weingarten(
        M, p, X, V;
        available_functions = [],
        expected_value = NoExpectation(),
        test_aliased = true,
        test_mutating = true,
        name = "Weingarten map on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        Y = Weingarten(M, p, X, V)
        Test.@test is_vector(M, p, Y; error = :error, kwargs...)
        !isexpected(expected_value) || Test.@test isapprox(M, p, Y, expect(expected_value); error = :error, kwargs...)
        if test_mutating
            Y2 = copy(M, p, X)
            Weingarten!(M, Y2, p, X, V)
            Test.@test isapprox(M, p, Y2, Y; error = :error, kwargs...)
            if test_aliased
                Y3 = copy(M, p, X)
                Weingarten!(M, Y3, p, Y3, V)  # aliased
                Test.@test isapprox(M, p, Y3, Y; error = :error, kwargs...)
            end
        end
    end
    return nothing
end # Manifolds.Test.test_Weingarten

"""
    Manifolds.Test.test_zero_vector(M, p;
        available_functions=[],
        test_mutating = true,
        test_norm = (norm in available_functions),
        name = "Zero vector test on \$M at point \$(typeof(p))",
    )

Test the zero vector on the manifold `M` at point `p`.
* verify that it is a valid tangent vector
* verify that its norm is zero (if provided)
* verify that the mutating version `zero_vector!` matches the non-mutating version (if activated)
"""
function Manifolds.Test.test_zero_vector(
        M::AbstractManifold, p;
        available_functions = Function[],
        test_mutating = true,
        test_norm = (norm in available_functions),
        name = "Zero vector on $M at point $(typeof(p))",
        kwargs...
    )
    Test.@testset "$(name)" begin
        Z = zero_vector(M, p)
        Test.@test is_vector(M, p, Z; error = :error, kwargs...)
        if test_norm
            n = norm(M, p, Z)
            Test.@test isapprox(n, 0.0; kwargs...)
        end
        if test_mutating
            Z2 = copy(M, p)
            zero_vector!(M, Z2, p)
            Test.@test isapprox(M, Z2, Z; error = :error, kwargs...)
        end
    end
    return nothing
end # Manifolds.Test.test_zero_vector

# Include the old tests for now as well
include("tests_general.jl")

end

include("../header.jl")

@testset "Stiefel" begin
    @testset "Real" begin
        M = Stiefel(3, 2)
        M2 = MetricManifold(M, EuclideanMetric())
        @testset "Basics" begin
            @test repr(M) == "Stiefel(3, 2, ℝ)"
            p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            @test is_default_metric(M, EuclideanMetric())
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 3
            @test injectivity_radius(M) == π
            @test injectivity_radius(M2) == π
            @test !is_flat(M)
            @test !is_flat(M2)
            @test is_flat(Stiefel(2, 1))
            base_manifold(M) === M
            @test_throws ManifoldDomainError is_point(M, [1.0, 0.0, 0.0, 0.0]; error = :error)
            @test_throws ManifoldDomainError is_point(
                M,
                1im * [1.0 0.0; 0.0 1.0; 0.0 0.0];
                error = :error,
            )
            @test !is_vector(M, p, [0.0, 0.0, 1.0, 0.0])
            @test_throws ManifoldDomainError is_vector(
                M,
                p,
                1 * im * zero_vector(M, p);
                error = :error,
            )
            @test default_retraction_method(M) === PolarRetraction()
            @test default_inverse_retraction_method(M) === PolarInverseRetraction()
            vtm = DifferentiatedRetractionVectorTransport(PolarRetraction())
            @test default_vector_transport_method(M) === vtm
        end
        @testset "Embedding and Projection" begin
            p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            q = similar(p)
            r = embed(M, p)
            @test r == p
            embed!(M, q, p)
            @test q == r
            a = [1.0 0.0; 0.0 2.0; 0.0 0.0]
            @test !is_point(M, a)
            b = similar(a)
            c = project(M, a)
            @test c == p
            project!(M, b, a)
            @test b == p
            X = [0.0 0.0; 0.0 0.0; -1.0 1.0]
            Y = similar(X)
            Z = embed(M, p, X)
            embed!(M, Y, p, X)
            @test Y == X
            @test Z == X
        end
        @testset "gradient and metric conversion" begin
            p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            X = [0.0 0.0; 0.0 0.0; -1.0 1.0]
            Y = change_metric(M, EuclideanMetric(), p, X)
            @test Y == X
            Z = change_representer(M, EuclideanMetric(), p, X)
            @test Z == X
            # In this case it stays as is
            @test riemannian_Hessian(M, p, Y, Z, X) == Z
            V = [1.0 1.0; 0.0 0.0; 0.0 0.0] # From T\bot_pM.
            @test Weingarten(M, p, X, V) == [0.0 0.0; 0.0 0.0; 1.0 1.0]
        end
        types = [Matrix{Float64}]

        @testset "Stiefel(2, 1) special case" begin
            M21 = Stiefel(2, 1)
            w = inverse_retract(
                M21,
                SMatrix{2, 1}([0.0, 1.0]),
                SMatrix{2, 1}([sqrt(2), sqrt(2)]),
                QRInverseRetraction(),
            )
            @test isapprox(M21, w, SMatrix{2, 1}([1.0, 0.0]))
        end

        @testset "inverse QR retraction cases" begin
            M43 = Stiefel(4, 3)
            p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0; 0.0 0.0 0.0]
            Xinit = [0.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0; 1.0 1.0 1.0]
            q = retract(M43, p, Xinit, QRRetraction())
            X1 = inverse_retract(
                M43,
                SMatrix{4, 3}(p),
                SMatrix{4, 3}(q),
                QRInverseRetraction(),
            )
            X2 = inverse_retract(M43, p, q, QRInverseRetraction())
            @test isapprox(M43, p, X1, X2)
            @test isapprox(M43, p, X1, Xinit)

            p2 = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            q2 = exp(M, p2, [0.0 0.0; 0.0 0.0; 1.0 1.0])

            X1 = inverse_retract(
                M,
                SMatrix{3, 2}(p2),
                SMatrix{3, 2}(q2),
                QRInverseRetraction(),
            )
            X2 = inverse_retract(M, p2, q2, QRInverseRetraction())
            @test isapprox(M43, p2, X1, X2)
        end

        @testset "Type $T" for T in types
            x = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            y = exp(M, x, [0.0 0.0; 0.0 0.0; 1.0 1.0])
            z = exp(M, x, [0.0 0.0; 0.0 0.0; -1.0 1.0])
            @test isapprox(
                M,
                retract(
                    M,
                    SMatrix{3, 2}(x),
                    SA[0.0 0.0; 0.0 0.0; -1.0 1.0],
                    PolarRetraction(),
                ),
                retract(M, x, [0.0 0.0; 0.0 0.0; -1.0 1.0], PolarRetraction()),
                atol = 1.0e-15,
            )
            pts = convert.(T, [x, y, z])
            v = inverse_retract(M, x, y, PolarInverseRetraction())
            @test !is_point(M, 2 * x)
            @test_throws DomainError !is_point(M, 2 * x; error = :error)
            @test !is_vector(M, 2 * x, v)
            @test_throws ManifoldDomainError !is_vector(M, 2 * x, v; error = :error)
            @test !is_vector(M, x, y)
            @test_throws DomainError is_vector(M, x, y; error = :error)
            Manifolds.test_manifold(
                M,
                pts,
                basis_types_to_from = (DefaultOrthonormalBasis(),),
                basis_types_vecs = (DefaultOrthonormalBasis(),),
                test_exp_log = true,
                default_inverse_retraction_method = PolarInverseRetraction(),
                test_injectivity_radius = false,
                test_is_tangent = true,
                test_project_tangent = true,
                test_default_vector_transport = false,
                point_distributions = [Manifolds.uniform_distribution(M, pts[1])],
                projection_atol_multiplier = 200.0,
                exp_log_atol_multiplier = 10.0,
                retraction_atol_multiplier = 10.0,
                is_tangent_atol_multiplier = 4 * 10.0^2,
                retraction_methods = [
                    PolarRetraction(),
                    QRRetraction(),
                    CayleyRetraction(),
                    PadeRetraction(2),
                    ProjectionRetraction(),
                ],
                inverse_retraction_methods = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                    ProjectionInverseRetraction(),
                ],
                vector_transport_methods = [
                    DifferentiatedRetractionVectorTransport(PolarRetraction()),
                    DifferentiatedRetractionVectorTransport(QRRetraction()),
                    ProjectionTransport(),
                ],
                vector_transport_retractions = [
                    PolarRetraction(),
                    QRRetraction(),
                    PolarRetraction(),
                ],
                vector_transport_inverse_retractions = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                    PolarInverseRetraction(),
                ],
                test_vector_transport_direction = [true, true, false],
                mid_point12 = nothing,
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
            )

            @testset "inner/norm" begin
                v1 = inverse_retract(M, pts[1], pts[2], PolarInverseRetraction())
                v2 = inverse_retract(M, pts[1], pts[3], PolarInverseRetraction())

                @test real(inner(M, pts[1], v1, v2)) ≈ real(inner(M, pts[1], v2, v1))
                @test imag(inner(M, pts[1], v1, v2)) ≈ -imag(inner(M, pts[1], v2, v1))
                @test imag(inner(M, pts[1], v1, v1)) ≈ 0

                @test norm(M, pts[1], v1) isa Real
                @test norm(M, pts[1], v1) ≈ sqrt(inner(M, pts[1], v1, v1))
            end
        end

        @testset "Distribution tests" begin
            usd_mmatrix = Manifolds.uniform_distribution(
                M, @MMatrix [
                    1.0 0.0
                    0.0 1.0
                    0.0 0.0
                ]
            )
            @test isa(rand(usd_mmatrix), MMatrix)
        end
    end

    @testset "Complex" begin
        M = Stiefel(3, 2, ℂ)
        @testset "Basics" begin
            @test repr(M) == "Stiefel(3, 2, ℂ)"
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 8
            @test !is_flat(M)
            @test Manifolds.allocation_promotion_function(M, exp!, (1,)) == complex
            @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0], [0.0, 0.0, 1.0, 0.0])
            x = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        end
        types = [Matrix{ComplexF64}]
        @testset "Type $T" for T in types
            x = [0.5 + 0.5im 0.5 + 0.5im; 0.5 + 0.5im -0.5 - 0.5im; 0.0 0.0]
            y = exp(M, x, [0.0 0.0; 0.0 0.0; 1.0 1.0])
            z = exp(M, x, [0.0 0.0; 0.0 0.0; -1.0 1.0])
            pts = convert.(T, [x, y, z])
            v = inverse_retract(M, x, y, PolarInverseRetraction())
            @test !is_point(M, 2 * x)
            @test_throws DomainError !is_point(M, 2 * x; error = :error)
            @test !is_vector(M, 2 * x, v)
            @test_throws ManifoldDomainError !is_vector(M, 2 * x, v; error = :error)
            @test !is_vector(M, x, y)
            @test_throws DomainError is_vector(M, x, y; error = :error)
            Manifolds.test_manifold(
                M,
                pts,
                test_exp_log = false,
                default_inverse_retraction_method = PolarInverseRetraction(),
                test_injectivity_radius = false,
                test_is_tangent = true,
                test_project_tangent = true,
                test_default_vector_transport = false,
                projection_atol_multiplier = 200.0,
                retraction_atol_multiplier = 10.0,
                is_tangent_atol_multiplier = 4 * 10.0^2,
                retraction_methods = [PolarRetraction(), QRRetraction()],
                inverse_retraction_methods = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                vector_transport_methods = [
                    DifferentiatedRetractionVectorTransport(PolarRetraction()),
                    DifferentiatedRetractionVectorTransport(QRRetraction()),
                    ProjectionTransport(),
                ],
                vector_transport_retractions = [
                    PolarRetraction(),
                    QRRetraction(),
                    PolarRetraction(),
                ],
                vector_transport_inverse_retractions = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                    PolarInverseRetraction(),
                ],
                test_vector_transport_direction = [true, true, false],
                mid_point12 = nothing,
                test_inplace = true,
                test_rand_point = true,
            )

            @testset "inner/norm" begin
                v1 = inverse_retract(M, pts[1], pts[2], PolarInverseRetraction())
                v2 = inverse_retract(M, pts[1], pts[3], PolarInverseRetraction())

                @test real(inner(M, pts[1], v1, v2)) ≈ real(inner(M, pts[1], v2, v1))
                @test imag(inner(M, pts[1], v1, v2)) ≈ -imag(inner(M, pts[1], v2, v1))
                @test imag(inner(M, pts[1], v1, v1)) ≈ 0

                @test norm(M, pts[1], v1) isa Real
                @test norm(M, pts[1], v1) ≈ sqrt(inner(M, pts[1], v1, v1))
            end
        end
    end

    @testset "Quaternion" begin
        M = Stiefel(3, 2, ℍ)
        @testset "Basics" begin
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 18
        end
    end

    @testset "Padé & Caley retractions and Caley based transport" begin
        M = Stiefel(3, 2)
        p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        X = [0.0 0.0; 0.0 0.0; 1.0 1.0]
        r1 = CayleyRetraction()
        @test r1 == PadeRetraction(1)
        @test repr(r1) == "CayleyRetraction()"
        q1 = retract(M, p, X, r1)
        @test is_point(M, q1)
        Y = vector_transport_direction(
            M,
            p,
            X,
            X,
            DifferentiatedRetractionVectorTransport(CayleyRetraction()),
        )
        @test is_vector(M, q1, Y; atol = 10^-15)
        Y2 = vector_transport_direction(
            M,
            p,
            X,
            X,
            DifferentiatedRetractionVectorTransport(CayleyRetraction()),
        )
        @test is_vector(M, q1, Y2; atol = 10^-15)
        r2 = PadeRetraction(2)
        @test repr(r2) == "PadeRetraction(2)"
        q2 = retract(M, p, X, r2)
        @test is_point(M, q2)
    end

    @testset "Canonical Metric" begin
        M3 = MetricManifold(Stiefel(3, 2), CanonicalMetric())
        p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        X = [0.0 0.0; 0.0 0.0; 1.0 1.0]
        q = exp(M3, p, X)
        Y = [0.0 0.0; 0.0 0.0; -1.0 1.0]
        r = exp(M3, p, Y)
        @test !is_flat(M3)
        @test isapprox(M3, p, log(M3, p, q), X)
        @test isapprox(M3, p, log(M3, p, r), Y)
        @test inner(M3, p, X, Y) == 0
        @test inner(M3, p, X, 2 * X + 3 * Y) == 2 * inner(M3, p, X, X)
        @test norm(M3, p, X) ≈ distance(M3, p, q)
        Z = [0.0 0.0; 0.0 0.0; -1.0 -1.0]
        @test riemannian_Hessian(M3, p, Y, Z, X) == [0.0 0.5; -0.5 0.0; -1.0 -1.0]
        # test default retraction on metric manifolds
        m = default_retraction_method(M3)
        r = similar(p)
        @test retract!(M3, r, p, X, m) == retract!(M3.manifold, r, p, X)
        # check on a higher dimensional manifold, that the iterations are actually used
        M4 = MetricManifold(Stiefel(10, 2), CanonicalMetric())
        p = Matrix{Float64}(I, 10, 2)
        Random.seed!(42)
        Z = project(base_manifold(M4), p, 0.2 .* randn(size(p)))
        s = exp(M4, p, Z)
        #test that retract falls back to exp as well
        m = ExponentialRetraction()
        s2 = retract(M4, p, Z, m)
        @test isapprox(M4, p, s, s2)
        s3 = similar(s)
        retract!(M4, s3, p, Z, m)
        @test isapprox(M4, p, s, s3)
        Z2 = log(M4, p, s)
        @test isapprox(M4, p, Z, Z2)
        Z3 = similar(Z2)
        log!(M4, Z3, p, s)
        @test isapprox(M4, p, Z2, Z3)
        # test that retract falls back to this log as well
        m = LogarithmicInverseRetraction()
        Z4 = inverse_retract(M4, p, s, m)
        @test isapprox(M4, p, Z, Z4)
        Z5 = similar(Z4)
        inverse_retract!(M4, Z5, p, s, m)
        @test isapprox(M4, p, Z4, Z5)
        M4 = MetricManifold(Stiefel(3, 3), CanonicalMetric())
        p = project(M4, randn(3, 3))
        X = project(M4, p, randn(3, 3))
        Y = project(M4, p, randn(3, 3))
        @test inner(M4, p, X, Y) ≈ tr(X' * (I - p * p' / 2) * Y)
    end

    @testset "StiefelSubmersionMetric" begin
        @testset "StiefelFactorization" begin
            n = 6
            @testset for k in [2, 3]
                M = MetricManifold(Stiefel(n, k), StiefelSubmersionMetric(rand()))
                p = project(M, randn(representation_size(M)))
                X = project(M, p, randn(representation_size(M)))
                X /= norm(M, p, X)
                q = exp(M, p, X)
                qfact = Manifolds.stiefel_factorization(p, q)
                @testset "basic properties" begin
                    @test qfact isa Manifolds.StiefelFactorization
                    @test qfact.U[1:n, 1:k] ≈ p
                    @test qfact.U'qfact.U ≈ I
                    @test qfact.U * qfact.Z ≈ q
                    @test is_point(Stiefel(2k, k), qfact.Z)

                    Xfact = Manifolds.stiefel_factorization(p, X)
                    @test Xfact isa Manifolds.StiefelFactorization
                    @test Xfact.U[1:n, 1:k] ≈ p
                    @test Xfact.U'Xfact.U ≈ I
                    @test Xfact.U * Xfact.Z ≈ X
                    @test is_vector(Rotations(k), I(k), Xfact.Z[1:k, 1:k])

                    pfact2 = Manifolds.stiefel_factorization(p, p)
                    @test pfact2 isa Manifolds.StiefelFactorization
                    @test pfact2.U[1:n, 1:k] ≈ p
                    @test pfact2.U'pfact2.U ≈ I
                    @test pfact2.Z ≈ [I(k); zeros(k, k)] atol = 1.0e-6
                end
                @testset "basic functions" begin
                    @test size(qfact) == (n, k)
                    @test eltype(qfact) === eltype(q)
                end
                @testset "similar" begin
                    qfact2 = similar(qfact)
                    @test qfact2.U === qfact.U
                    @test size(qfact2.Z) == size(qfact.Z)
                    @test eltype(qfact2.Z) === eltype(qfact.Z)

                    qfact3 = similar(qfact, Float32)
                    @test eltype(qfact3) === Float32
                    @test eltype(qfact3.U) === Float32
                    @test eltype(qfact3.Z) === Float32
                    @test qfact3.U ≈ qfact.U
                    @test size(qfact3.Z) == size(qfact.Z)

                    qfact4 = similar(qfact, Float32, (n, k))
                    @test eltype(qfact4) === Float32
                    @test eltype(qfact4.U) === Float32
                    @test eltype(qfact4.Z) === Float32
                    @test qfact4.U ≈ qfact.U
                    @test size(qfact4.Z) == size(qfact.Z)

                    @test_throws Exception similar(qfact, Float32, (n, k + 1))
                end
                @testset "copyto!" begin
                    qfact2 = similar(qfact)
                    copyto!(qfact2, qfact)
                    @test qfact2.U === qfact.U
                    @test qfact2.Z ≈ qfact.Z

                    q2 = similar(q)
                    copyto!(q2, qfact)
                    @test q2 ≈ q

                    qfact3 = similar(qfact)
                    copyto!(qfact3, q)
                    @test qfact3.U === qfact.U
                    @test qfact3.Z ≈ qfact.Z
                end
                @testset "dot" begin
                    Afact = similar(qfact)
                    Afact.Z .= randn.()
                    A = copyto!(similar(q), Afact)
                    Bfact = similar(qfact)
                    Bfact.Z .= randn.()
                    B = copyto!(similar(q), Bfact)
                    @test dot(Afact, Bfact) ≈ dot(A, B)
                end
                @testset "broadcast!" begin
                    rfact = similar(qfact)
                    @testset for f in [*, +, -]
                        rfact .= f.(qfact, 2.5)
                        @test rfact.U === qfact.U
                        @test rfact.Z ≈ f.(qfact.Z, 2.5)
                    end
                end
                @testset "project" begin
                    rfact = similar(qfact)
                    rfact.Z .= randn.()
                    r = copyto!(similar(q), rfact)
                    rfactproj = project(M, rfact)
                    @test rfactproj isa Manifolds.StiefelFactorization
                    @test copyto!(similar(r), rfactproj) ≈ project(M, r)

                    Yfact = similar(qfact)
                    Yfact.Z .= randn.()
                    Y = copyto!(similar(q), Yfact)
                    Yfactproj = project(M, rfact, Yfact)
                    @test Yfactproj isa Manifolds.StiefelFactorization
                    @test copyto!(similar(Y), Yfactproj) ≈ project(M, r, Y)
                end
                @testset "inner" begin
                    rfact = similar(qfact)
                    rfact.Z .= randn.()
                    rfact = project(M, rfact)

                    Yfact = similar(qfact)
                    Yfact.Z .= randn.()
                    Yfact = project(M, rfact, Yfact)

                    Zfact = similar(qfact)
                    Zfact.Z .= randn.()
                    Zfact = project(M, rfact, Zfact)

                    r, Z, Y = map(x -> copyto!(similar(q), x), (rfact, Zfact, Yfact))
                    @test inner(M, rfact, Yfact, Zfact) ≈ inner(M, r, Y, Z)
                end
                @testset "exp" begin
                    pfact = copyto!(similar(qfact), p)
                    Xfact = copyto!(similar(qfact), X)
                    rfact = exp(M, pfact, Xfact)
                    r = exp(M, p, X)
                    @test rfact isa Manifolds.StiefelFactorization
                    @test copyto!(similar(r), rfact) ≈ r
                end
            end
        end

        g = StiefelSubmersionMetric(1)
        @test g isa StiefelSubmersionMetric{Int}

        @testset for M in [Stiefel(3, 3), Stiefel(4, 3), Stiefel(4, 2)]
            Mcan = MetricManifold(M, CanonicalMetric())
            Meu = MetricManifold(M, EuclideanMetric())
            @testset "α=$α" for (α, Mcomp) in [(0, Mcan), (-1 // 2, Meu)]
                p = project(M, randn(representation_size(M)))
                X = project(M, p, randn(representation_size(M)))
                X ./= norm(Mcomp, p, X)
                Y = project(M, p, randn(representation_size(M)))
                MM = MetricManifold(M, StiefelSubmersionMetric(α))
                @test inner(MM, p, X, Y) ≈ inner(Mcomp, p, X, Y)
                q = exp(Mcomp, p, X)
                @test isapprox(MM, q, exp(Mcomp, p, X); error = :error)
                Mcomp === Mcan && isapprox(MM, p, log(MM, p, q), log(Mcomp, p, q))
                @test isapprox(MM, exp(MM, p, 0 * X), p; error = :error)
                @test isapprox(MM, p, log(MM, p, p), zero_vector(MM, p); error = :error, atol = 1.0e-6)
            end
            @testset "α=$α" for α in [-0.75, -0.25, 0.5]
                MM = MetricManifold(M, StiefelSubmersionMetric(α))
                p = project(MM, randn(representation_size(M)))
                X = project(MM, p, randn(representation_size(M)))
                X ./= norm(MM, p, X)
                q = exp(MM, p, X)
                @test is_point(MM, q; error = :error)
                @test isapprox(MM, p, log(MM, p, q), X; error = :error)
                @test isapprox(MM, exp(MM, p, 0 * X), p; error = :error)
                @test isapprox(MM, p, log(MM, p, p), zero_vector(MM, p); error = :error, atol = 1.0e-6)
            end
        end

        @testset "Hessian Conversion" begin
            M1 = MetricManifold(Stiefel(3, 2), StiefelSubmersionMetric(-0.5))
            M2 = Stiefel(3, 2)
            M2b = MetricManifold(Stiefel(3, 2), EuclideanMetric())
            M3 = MetricManifold(Stiefel(3, 2), StiefelSubmersionMetric(0.0))
            M4 = MetricManifold(Stiefel(3, 2), CanonicalMetric())
            p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            X = [0.0 0.0; 0.0 0.0; 1.0 1.0]
            Y = [0.0 0.0; 0.0 0.0; -1.0 1.0]
            Z = [0.0 0.0; 0.0 0.0; -1.0 -1.0]
            rH = riemannian_Hessian(M2, p, Y, Z, X)
            @test riemannian_Hessian(M1, p, Y, Z, X) == rH #Special case of submersion metric
            @test riemannian_Hessian(M2b, p, Y, Z, X) == rH # metric is default
            @test riemannian_Hessian(M3, p, Y, Z, X) == riemannian_Hessian(M4, p, Y, Z, X)

            V = [0.0 -1.0; 1.0 0.0; 0.0 0.0]
            W = zero_vector(M2, p)
            Weingarten!(M2, W, p, X, V)
            Wb = zero_vector(M2b, p)
            Weingarten!(M2b, Wb, p, X, V)
            @test W == Wb
        end
    end
    @testset "field parameter" begin
        M = Stiefel(3, 2; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "Stiefel(3, 2, ℝ; parameter=:field)"
    end
end

@doc raw"""
    Rotations{T} <: AbstractManifold{ℝ}

The manifold of rotation matrices of size ``n×n``, i.e.
real-valued orthogonal matrices with determinant ``+1``.

# Constructor

    Rotations(n::Int; parameter::Symbol=:type)

Generate the manifold of ``n×n`` rotation matrices.
"""
const Rotations{T} = GeneralUnitaryMatrices{ℝ, T, DeterminantOneMatrixType}

function Rotations(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return Rotations{typeof(size)}(size)
end

# TODO: Remove when removing GroupManifolds, since it is now
# defined 8and also used then in) LIeGroups.jl
@doc raw"""
    angles_4d_skew_sym_matrix(A)

The Lie algebra of [`Rotations(4)`](@ref) in ``ℝ^{4×4}``, ``𝔰𝔬(4)``, consists of ``4×4``
skew-symmetric matrices. The unique imaginary components of their eigenvalues are the
angles of the two plane rotations. This function computes these more efficiently than
`eigvals`.

By convention, the returned values are sorted in decreasing order
(corresponding to the same ordering of _angles_ as
[`cos_angles_4d_rotation_matrix`](@ref)).
"""
function angles_4d_skew_sym_matrix(A)
    @assert size(A) == (4, 4)
    @inbounds begin
        halfb = (A[1, 2]^2 + A[1, 3]^2 + A[2, 3]^2 + A[1, 4]^2 + A[2, 4]^2 + A[3, 4]^2) / 2
        c = (A[1, 2] * A[3, 4] - A[1, 3] * A[2, 4] + A[1, 4] * A[2, 3])^2
    end
    sqrtdisc = sqrt(halfb^2 - c)
    return sqrt(halfb + sqrtdisc), sqrt(halfb - sqrtdisc)
end

@doc raw"""
    change_representer(M::Rotations, ::EuclideanMetric, p, X)

Change `X` to the corresponding representer of a cotangent vector at `p`.
Since the [`Rotations`](@ref) manifold `M` is isometrically embedded, this is the identity.
"""
change_representer(::Rotations, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(M::Rotations, Y, ::EuclideanMetric, p, X)
    copyto!(M, Y, p, X)
    return Y
end

@doc raw"""
    change_metric(M::Rotations, ::EuclideanMetric, p, X)

Change `X` to the corresponding vector with respect to the metric of the [`Rotations`](@ref) `M`,
which is just the identity, since the manifold is isometrically embedded.
"""
change_metric(M::Rotations, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(::Rotations, Y, ::EuclideanMetric, p, X)
    copyto!(Y, X)
    return Y
end

default_vector_transport_method(::Rotations) = ParallelTransport()

# from https://github.com/JuliaManifolds/Manifolds.jl/issues/453#issuecomment-1046057557
function _get_tridiagonal_elements(trian)
    N = size(trian, 1)
    res = zeros(N)
    down = true
    for i in 1:N
        if i == N && down
            elem = 0
        else
            elem = trian[i + (down ? +1 : -1), i]
        end
        if elem ≈ 0
            res[i] = 0
        else
            res[i] = elem
            down = !down
        end
    end
    return res
end

function _ev_diagonal(tridiagonal_elements, unitary, evec, evals, fill_at; i)
    a = unitary[:, i]
    b = unitary[:, i + 1]
    evec[fill_at.x] = [-b a] * [a b]' ./ sqrt(2)
    evals[fill_at.x] = 0
    return fill_at.x += 1
end

function _ev_offdiagonal(tridiagonal_elements, unitary, evec, evals, fill_at; i, j)
    a = unitary[:, i]
    b = unitary[:, i + 1]
    c = unitary[:, j]
    d = unitary[:, j + 1]
    ref = hcat(a, b, c, d)' ./ 2

    evec[fill_at.x] = [-c -d a b] * ref
    evals[fill_at.x] = (tridiagonal_elements[i] - tridiagonal_elements[j])^2 / 4
    fill_at.x += 1
    evec[fill_at.x] = [-c d a -b] * ref
    evals[fill_at.x] = (tridiagonal_elements[i] + tridiagonal_elements[j])^2 / 4
    fill_at.x += 1
    evec[fill_at.x] = [-d -c b a] * ref
    evals[fill_at.x] = (tridiagonal_elements[i] + tridiagonal_elements[j])^2 / 4
    fill_at.x += 1
    evec[fill_at.x] = [d -c b -a] * ref
    evals[fill_at.x] = (tridiagonal_elements[i] - tridiagonal_elements[j])^2 / 4
    return fill_at.x += 1
end

function _ev_zero(tridiagonal_elements, unitary, evec, evals, fill_at; i)
    N = size(unitary, 1)
    ref = unitary[:, i]
    for idx in 1:(i - 1)
        rup = ref * unitary[:, idx]'
        evec[fill_at.x] = (rup - rup') ./ sqrt(2)
        evals[fill_at.x] = tridiagonal_elements[idx]^2 / 4
        fill_at.x += 1
    end
    return (values = evals, vectors = evec)
end

function get_basis_diagonalizing(M::Rotations, p, B::DiagonalizingOrthonormalBasis{ℝ})
    n = get_parameter(M.size)[1]
    decomp = schur(B.frame_direction)
    decomp = ordschur(decomp, map(v -> norm(v) > eps(eltype(p)), decomp.values))

    trian_elem = _get_tridiagonal_elements(decomp.T)
    unitary = decomp.Z
    evec = Vector{typeof(B.frame_direction)}(undef, manifold_dimension(M))
    evals = Vector{eltype(B.frame_direction)}(undef, manifold_dimension(M))
    i = 1
    fill_at = Ref(1)
    while i <= n
        if trian_elem[i] == 0
            evs = _ev_zero(trian_elem, unitary, evec, evals, fill_at; i = i)
            i += 1
        else
            evs = _ev_diagonal(trian_elem, unitary, evec, evals, fill_at, i = i)
            j = 1
            while j < i
                # the zero case should have been handled earlier
                @assert trian_elem[j] != 0
                evs = _ev_offdiagonal(trian_elem, unitary, evec, evals, fill_at, i = i, j = j)
                j += 2
            end
            i += 2
        end
    end
    return CachedBasis(B, evals, evec)
end

@doc raw"""
    injectivity_radius(M::Rotations, ::PolarRetraction)

Return the radius of injectivity for the [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`Rotations`](@ref) `M` which is ``\frac{π}{\sqrt{2}}``.
"""
injectivity_radius(::Rotations, ::PolarRetraction)
function _injectivity_radius(M::Rotations, ::PolarRetraction)
    n = get_parameter(M.size)[1]
    return n == 1 ? 0.0 : π / sqrt(2.0)
end

@doc raw"""
    inverse_retract(M, p, q, ::PolarInverseRetraction)

Compute a vector from the tangent space ``T_p\mathrm{SO}(n)``
of the point `p` on the [`Rotations`](@ref) manifold `M`
with which the point `q` can be reached by the
[`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) from the point `p` after time 1.

The formula reads
````math
\operatorname{retr}^{-1}_p(q)
= -\frac{1}{2}(p^{\mathrm{T}}qs - (p^{\mathrm{T}}qs)^{\mathrm{T}})
````

where ``s`` is the solution to the Sylvester equation

``p^{\mathrm{T}}qs + s(p^{\mathrm{T}}q)^{\mathrm{T}} + 2I_n = 0.``
"""
inverse_retract(::Rotations, ::Any, ::Any, ::PolarInverseRetraction)

@doc raw"""
    inverse_retract(M::Rotations, p, q, ::QRInverseRetraction)

Compute a vector from the tangent space ``T_p\mathrm{SO}(n)`` of the point `p` on the
[`Rotations`](@ref) manifold `M` with which the point `q` can be reached by the
[`QRRetraction`](@extref `ManifoldsBase.QRRetraction`) from the point `q` after time 1.
"""
inverse_retract(::Rotations, ::Any, ::Any, ::QRInverseRetraction)

function inverse_retract_polar!(M::Rotations, X, p, q)
    n = get_parameter(M.size)[1]
    A = transpose(p) * q
    Amat = A isa StaticMatrix ? A : convert(Matrix, A)
    H = copyto!(allocate(Amat), -2I)
    try
        B = lyap(A, H)
        mul!(X, A, B)
    catch e
        e2 = OutOfInjectivityRadiusError()
        isa(e, LinearAlgebra.LAPACKException) ? throw(e2) : rethrow()
    end
    return project!(SkewSymmetricMatrices(n), X, p, X)
end
function inverse_retract_qr!(M::Rotations, X, p, q)
    n = get_parameter(M.size)[1]
    A = transpose(p) * q
    R = zero(X)
    for i in 1:n
        b = zeros(i)
        b[end] = 1
        b[1:(end - 1)] = -transpose(R[1:(i - 1), 1:(i - 1)]) * A[i, 1:(i - 1)]
        R[1:i, i] = A[1:i, 1:i] \ b
    end
    mul!(X, A, R)
    return project!(SkewSymmetricMatrices(n), X, p, X)
end

@doc raw"""
    jacobian_exp_argument(M::Rotations{TypeParameter{Tuple{2}}}, p, X)

Compute Jacobian of the exponential map with respect to the argument `X` in orthonormal
coordinates on the [`Rotations`](@ref)`(2)` manifold. It is equal to matrix ``[1]``, see
[SolaDerayAtchuthan:2021](@cite), Appendix A.
"""
function jacobian_exp_argument(::Rotations{TypeParameter{Tuple{2}}}, p, X)
    return @SMatrix ones(eltype(X), 1, 1)
end
@doc raw"""
    jacobian_exp_argument(M::Rotations{TypeParameter{Tuple{3}}}, p, X)

Compute Jacobian of the exponential map with respect to the argument `X` in orthonormal
coordinates on the [`Rotations`](@ref)`(3)` manifold. The formula reads
````math
𝕀 + \frac{\cos(θ) - 1}{θ^2} X + \frac{θ - \sin(θ)}{θ^3} X^2,
````
where ``θ`` is the norm of `X`.
It is adapted from [Chirikjian:2012](@cite), Eq. (10.86), to `Manifolds.jl` conventions.
"""
function jacobian_exp_argument(M::Rotations{TypeParameter{Tuple{3}}}, p, X)
    J = allocate_jacobian(M, M, jacobian_exp_argument, p)
    return jacobian_exp_argument!(M, J, p, X)
end

function jacobian_exp_argument!(
        ::Rotations{TypeParameter{Tuple{2}}},
        J::AbstractMatrix,
        p,
        X,
    )
    J .= 1
    return J
end
function jacobian_exp_argument!(
        M::Rotations{TypeParameter{Tuple{3}}},
        J::AbstractMatrix,
        p,
        X,
    )
    θ = norm(M, p, X) / sqrt(2)
    copyto!(J, I)
    if θ ≉ 0
        a = (cos(θ) - 1) / θ^2
        b = (θ - sin(θ)) / θ^3
        J .+= a .* X .+ b .* (X^2)
    end
    return J
end

@doc raw"""
    normal_rotation_distribution(M::Rotations, p, σ::Real)

Return a random point on the manifold [`Rotations`](@ref) `M`
by generating a (Gaussian) random orthogonal matrix with determinant ``+1``. Let

```math
QR = A
```

be the QR decomposition of a random matrix ``A``, then the formula reads

```math
p = QD
```

where ``D`` is a diagonal matrix with the signs of the diagonal entries of ``R``,
i.e.

```math
D_{ij}=\begin{cases}
 \operatorname{sgn}(R_{ij}) & \text{if} \; i=j \\
 0 & \, \text{otherwise}
\end{cases}.
```

It can happen that the matrix gets -1 as a determinant. In this case, the first
and second columns are swapped.

The argument `p` is used to determine the type of returned points.
"""
function normal_rotation_distribution end

@doc raw"""
    project(M::Rotations, p; check_det = true)

Project `p` to the nearest point on manifold `M`.

Given the singular value decomposition ``p = U Σ V^\mathrm{T}``, with the
singular values sorted in descending order, the projection is

````math
\operatorname{proj}_{\mathrm{SO}(n)}(p) =
U\operatorname{diag}\left[1,1,…,\det(U V^\mathrm{T})\right] V^\mathrm{T}
````

The diagonal matrix ensures that the determinant of the result is ``+1``.
If `p` is expected to be almost special orthogonal, then you may avoid this
check with `check_det = false`.
"""
project(::Rotations, ::Any)

function project!(M::Rotations, q, p; check_det::Bool = true)
    n = get_parameter(M.size)[1]
    F = svd(p)
    mul!(q, F.U, F.Vt)
    if check_det && det(q) < 0
        d = similar(F.S)
        @inbounds fill!(view(d, 1:(n - 1)), 1)
        @inbounds d[n] = -1
        copyto!(q, F.U * Diagonal(d) * F.Vt)
    end
    return q
end

function Random.rand!(
        rng::AbstractRNG,
        M::Rotations,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)),
    )
    if vector_at === nothing
        # Special case: Rotations(1) is just zero-dimensional
        (manifold_dimension(M) == 0) && return fill!(pX, 1)
        A = randn(rng, representation_size(M))
        s = diag(sign.(qr(A).R))
        D = Diagonal(s)
        pX .= qr(A).Q * D
        if det(pX) < 0
            pX[:, [1, 2]] = pX[:, [2, 1]]
        end
    else
        # Special case: Rotations(1) is just zero-dimensional
        (manifold_dimension(M) == 0) && return fill!(pX, 0)
        A = σ .* randn(rng, representation_size(M))
        pX .= triu(A, 1) .- transpose(triu(A, 1))
    end
    return pX
end

"""
    _exp_half(::Rotations, d)

Calculate `exp(d / 2)`.
"""
_exp_half(::Rotations, d) = exp(d / 2)
"""
    _exp_half(::Rotations{TypeParameter{Tuple{3}}}, d)

Calculate `exp(d / 2)` for the manifold of `Rotations(3)` based on the Rodrigues' rotation
formula.
"""
function _exp_half(::Rotations{TypeParameter{Tuple{3}}}, d)
    θ = norm(d) / (2 * sqrt(2))
    if θ ≈ 0
        a = 1 - θ^2 / 6
        b = θ / 2
    else
        a = sin(θ) / θ
        b = (1 - cos(θ)) / θ^2
    end
    a /= 2
    b /= 4

    return I + a .* d .+ b .* (d^2)
end

@doc raw"""
    parallel_transport_direction(M::Rotations, p, X, d)

Compute parallel transport of vector `X` tangent at `p` on the [`Rotations`](@ref)
manifold in the direction `d`. The formula, provided in [Rentmeesters:2011](@cite), reads:

```math
\mathcal P_{q\gets p}X = q^\mathrm{T}p \operatorname{Exp}(d/2) X \operatorname{Exp}(d/2)
```
where ``q=\exp_p d``.

The formula simplifies to identity for 2-D rotations.
"""
parallel_transport_direction(::Rotations, p, X, d)
function parallel_transport_direction(M::Rotations, p, X, d)
    expdhalf = _exp_half(M, d)
    q = exp(M, p, d)
    return transpose(q) * p * expdhalf * X * expdhalf
end
parallel_transport_direction(::Rotations{TypeParameter{Tuple{2}}}, p, X, d) = X

function parallel_transport_direction!(M::Rotations, Y, p, X, d)
    expdhalf = _exp_half(M, d)
    q = exp(M, p, d)
    return copyto!(Y, transpose(q) * p * expdhalf * X * expdhalf)
end
function parallel_transport_direction!(::Rotations{TypeParameter{Tuple{2}}}, Y, p, X, d)
    return copyto!(Y, X)
end

function parallel_transport_to!(M::Rotations, Y, p, X, q)
    d = log(M, p, q)
    expdhalf = _exp_half(M, d)
    return copyto!(Y, transpose(q) * p * expdhalf * X * expdhalf)
end
function parallel_transport_to!(::Rotations{TypeParameter{Tuple{2}}}, Y, p, X, q)
    return copyto!(Y, X)
end
function parallel_transport_to!(M::Rotations{TypeParameter{Tuple{3}}}, Y, p, X, q)
    d = log(M, p, q)
    expdhalf = _exp_half(M, d)
    return copyto!(Y, transpose(q) * p * expdhalf * X * expdhalf)
end
function parallel_transport_to(M::Rotations, p, X, q)
    d = log(M, p, q)
    expdhalf = _exp_half(M, d)
    return transpose(q) * p * expdhalf * X * expdhalf
end
parallel_transport_to(::Rotations{TypeParameter{Tuple{2}}}, p, X, q) = X

function Base.show(io::IO, ::Rotations{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "Rotations($(n))")
end
function Base.show(io::IO, M::Rotations{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "Rotations($n; parameter=:field)")
end

@doc raw"""
    riemannian_Hessian(M::Rotations, p, G, H, X)

The Riemannian Hessian can be computed by adopting Eq. (5.6) [Nguyen:2023](@cite),
so very similar to the Stiefel manifold.
The only difference is, that here the tangent vectors are stored
in the Lie algebra, i.e. the update direction is actually ``pX`` instead of just ``X`` (in Stiefel).
and that means the inverse has to be applied to the (Euclidean) Hessian
to map it into the Lie algebra.
"""
riemannian_Hessian(::Rotations, p, G, H, X)

function riemannian_Hessian!(M::Rotations, Y, p, G, H, X)
    N = get_parameter(M.size)[1]
    symmetrize!(Y, G' * p)
    project!(SkewSymmetricMatrices(N), Y, p' * H - X * Y)
    return Y
end

@doc raw"""
    sectional_curvature_max(::Rotations)

Sectional curvature of [`Rotations`](@ref) `M` is equal to 0 for `Rotations(1)` and
`Rotations(2)`, less than or equal to 1/8 for `Rotations(3)` and less than or equal to 1/4
for higher-dimensional rotations manifolds.

For reference, see [Ge:2014](@cite), Lemma 2.5 and [CheegerEbin:2008](@cite), Corollary 3.19.
"""
function sectional_curvature_max(M::Rotations)
    N = manifold_dimension(M)
    if N <= 1
        return 0.0
    elseif N == 3
        return 1 / 8
    else
        return 1 / 4
    end
end

@doc raw"""
    sectional_curvature_min(M::Rotations)

Sectional curvature of [`Rotations`](@ref) `M` is greater than or equal to 0.
"""
function sectional_curvature_min(::Rotations)
    return 0.0
end

@doc raw"""
    Weingarten(M::Rotations, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Stiefel`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

The formula is due to [AbsilMahonyTrumpf:2013](@cite) given by

```math
\mathcal W_p(X,V) = -\frac{1}{2}p\bigl(V^{\mathrm{T}}X - X^\mathrm{T}V\bigr)
```
"""
Weingarten(::Rotations, p, X, V)

function Weingarten!(::Rotations, Y, p, X, V)
    Y .= V' * X
    Y .= -p * 1 / 2 * (Y - Y')
    return Y
end

@doc raw"""
    zero_vector(M::Rotations, p)

Return the zero tangent vector from the tangent space art `p` on the [`Rotations`](@ref)
as an element of the Lie group, i.e. the zero matrix.
"""
zero_vector(::Rotations, p) = zero(p)

zero_vector!(::Rotations, X, p) = fill!(X, 0)

include("../header.jl")

@testset "Symplectic Grassmann" begin
    M = SymplecticGrassmann(6, 4)
    Mf = SymplecticGrassmann(6, 4; parameter = :field)
    p = [
        0.0 0.0 -5.0 -1.0
        0.0 0.0 9.0 -2.0
        0.0 0.0 -2.0 1.0
        -2.0 -9.0 -3.0 6.0
        -3.0 -13.0 -21.0 9.0
        -8.0 -36.0 18.0 -6.0
    ]
    q = [
        0.0 0.0 -3.0 1.0
        0.0 0.0 8.0 -3.0
        0.0 0.0 -2.0 1.0
        -1.0 -4.0 -6.0 3.0
        -1.0 -3.0 -21.0 9.0
        -2.0 -6.0 18.0 -6.0
    ]
    X = [
        0.0 0.0 4.25 4.25
        0.0 0.0 0.125 0.125
        0.0 0.0 -1.125 -1.125
        3.625 18.125 -10.875 -10.875
        5.0 25.0 -9.0 -9.0
        13.5 67.5 4.5 4.5
    ]
    Y = [
        -0.0264806 0.00416977 0.01130802 0.01015956
        0.01718954 -0.00680433 0.02364406 -0.00083272
        0.00050392 0.00191916 -0.01035902 -0.00079734
        0.01811917 -0.02307032 -0.04297277 -0.05409099
        -0.02529516 0.00959934 -0.08594555 -0.06117803
        -0.02823014 0.00029946 -0.04196034 -0.04145413
    ]
    @testset "Basics" begin
        @test repr(M) == "SymplecticGrassmann(6, 4)"
        @test repr(Mf) == "SymplecticGrassmann(6, 4; parameter=:field)"
        @test manifold_dimension(M) == 4 * (6 - 4)
        for _M in [M, Mf]
            @test is_point(M, p)
            @test is_vector(_M, p, X)
        end
        @test get_embedding(M) == SymplecticStiefel(6, 4)
    end
    @testset "Embedding / Total Space" begin
        @test get_embedding(M) == SymplecticStiefel(6, 4)
        @test embed(M, p) == p
        pE = similar(p)
        embed!(M, pE, p)
        @test p == pE
        embed!(M, pE, StiefelPoint(p))
        @test p == pE
        @test embed(M, StiefelPoint(p)) == p
        @test embed(M, p, X) == X
        XE = similar(X)
        embed!(M, XE, p, X)
        @test XE == X
        embed!(M, XE, StiefelPoint(p), StiefelTangentVector(X))
        @test XE == X
        @test embed(M, StiefelPoint(p), StiefelTangentVector(X)) == X
    end
    @testset "Exponential and Retractions" begin
        @test inner(M, p, X, X) ≈ norm(M, p, X)^2
        N = get_embedding(M)
        @test isapprox(N, exp(M, p, X), exp(N, p, X))
        rtm = CayleyRetraction()
        r = retract(M, p, X, rtm)
        @test is_point(M, r)
        r = ManifoldsBase.retract_fused(M, p, X, 1.0, rtm)
        @test is_point(M, r)
        irtm = CayleyInverseRetraction()
        X2 = inverse_retract(M, p, r, irtm)
        @test isapprox(M, p, X, X2)
        @test is_vector(M, p, X2)
    end
    @testset "Riemannian Gradient conversion" begin
        A = Matrix{Float64}(I, 6, 6)[:, 1:4]
        Z = riemannian_gradient(M, p, A)
        Z2 = similar(Z)
        riemannian_gradient!(M, Z2, p, A)
        @test isapprox(M, Z2, Z)
        # How can we better test that this is a correct gradient?
        # Or what can we further test here?
    end
    @testset "Projector representation" begin
        # cf. Propo 4.3 BendokatZimmermann, φ and
        φ(p) = p * symplectic_inverse(p)
        #  for dφ the proof we keve to consider their Ω, hence the /p
        function dφ(p, X)
            # \bar Ω is Xp^+ + pX^+
            return X * symplectic_inverse(p) + p * symplectic_inverse(X)
        end
        pP = ProjectorPoint(φ(p))
        Xe = dφ(p, X)
        XP = ProjectorTangentVector(Xe)
        @test is_point(M, pP)
        # Fix
        @test is_vector(M, pP, XP; atol = 1.0e-9, error = :error)
        Pf1 = zeros(6, 6)
        Pf1[1, 2] = 1.0
        # No projector
        @test_throws DomainError is_point(M, ProjectorPoint(Pf1), true)
        Pf2 = zeros(6, 6)
        Pf2[1, 1] = 1.0
        # Pf2 not equal to its symplectic inverse
        @test_throws DomainError is_point(M, ProjectorPoint(Pf2), true)
        ps = p[:, [1, 3]] # This is on SpSt(6,2)
        Pf3 = φ(ps) # too low rank
        @test_throws DomainError is_point(M, ProjectorPoint(Pf3), true)

        # Not Hamiltonian
        Xf1 = ProjectorTangentVector(Matrix{Float64}(I, 6, 6))
        Xf1.value[1, 2] = 1.0 # tweak to not be Hamiltonian
        @test_throws DomainError is_vector(M, pP, Xf1; error = :error)
        # ``X^+ = X``, but ``Xp + pX`` not correct
        Xf2 = ProjectorTangentVector(0.5 .* (symplectic_inverse(X * X') + X * X'))
        @test_throws DomainError is_vector(M, pP, Xf2; error = :error)
        @test get_embedding(M, typeof(pP)) == Euclidean(6, 6)
        @test get_embedding(Mf, typeof(pP)) == Euclidean(6, 6; parameter = :field)
        @test embed(M, pP) == pP.value
        pE = zeros(6, 6)
        embed!(M, pE, pP)
        @test pE == pP.value
        @test embed(M, pP, XP) == XP.value
        embed!(M, pE, pP, XP)
        @test pE == XP.value
    end
end

include("../header.jl")

@testset "SkewSymmetricMatrices" begin
    @test SkewSymmetricMatrices(3) === SkewHermitianMatrices(3)
end

@testset "SkewHermitianMatrices" begin
    M = SkewHermitianMatrices(3, ℝ)
    A = [1 2 3; 4 5 6; 7 8 9]
    A_skewsym = [0 -2 -3; 2 0 1; 3 -1 0]
    A_skewsym2 = [0 -2 -3; 2 0 1; 3 -1 0]
    B_skewsym = [0 -2 -3; 2 0 -1; 3 1 0]
    M_complex = SkewHermitianMatrices(3, ℂ)
    A_skewsym_complex = [1.0im -2.0 -3.0; 2.0 0.0 1.0; 3.0 -1.0 0.0]
    B_skewsym_complex = [2.0im -2.0 - 2.0im -3.0; 2.0 - 2.0im 0.0 -1.0; 3.0 1.0 0.0]
    @test repr(M_complex) == "SkewHermitianMatrices(3, ℂ)"
    C = [0 -1 im; 1 0 -im; im -im 0]
    D = [1 0; 0 1]
    X = zeros(3, 3)
    @testset "Real Skew-Symmetric Matrices Basics" begin
        @test repr(M) == "SkewSymmetricMatrices(3)"
        @test representation_size(M) == (3, 3)
        @test base_manifold(M) === M
        @test is_flat(M)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, TypeParameter{Tuple{3, 3}}}
        @test check_point(M, B_skewsym) === nothing
        @test_throws DomainError is_point(M, A; error = :error)
        @test_throws ManifoldDomainError is_point(M, C; error = :error)
        @test_throws ManifoldDomainError is_point(M, D; error = :error)
        @test check_vector(M, B_skewsym, B_skewsym) === nothing
        @test_throws DomainError is_vector(M, B_skewsym, A; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, B_skewsym; error = :error)
        @test_throws ManifoldDomainError is_vector(M, B_skewsym, D; error = :error)
        @test_throws ManifoldDomainError is_vector(
            M,
            B_skewsym,
            1 * im * zero_vector(M, B_skewsym);
            error = :error,
        )
        @test manifold_dimension(M) == 3
        @test manifold_dimension(M_complex) == 9
        @test A_skewsym2 == project!(M, A_skewsym, A_skewsym)
        @test A_skewsym2 == project(M, A_skewsym, A_skewsym)
        A_sym3 = similar(A_skewsym)
        embed!(M, A_sym3, A_skewsym)
        A_sym4 = embed(M, A_skewsym)
        @test A_sym3 == A_skewsym
        @test A_sym4 == A_skewsym
    end
    types = [Matrix{Float64}]
    bases = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))
    for T in types
        pts = [convert(T, A_skewsym), convert(T, B_skewsym), convert(T, X)]
        @testset "Type $T" begin
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                basis_types_vecs = (
                    DiagonalizingOrthonormalBasis(log(M, pts[1], pts[2])),
                    bases...,
                ),
                basis_types_to_from = bases,
                is_tangent_atol_multiplier = 1,
                test_inplace = true,
                test_rand_point = true,
            )
        end
    end
    complex_types = [Matrix{ComplexF64}]
    for T in complex_types
        pts_complex =
            [convert(T, A_skewsym_complex), convert(T, B_skewsym_complex), convert(T, X)]
        @testset "Type $T" begin
            Manifolds.test_manifold(
                M_complex,
                pts_complex,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                basis_types_vecs = (DefaultOrthonormalBasis(ℂ),),
                basis_types_to_from = (DefaultOrthonormalBasis(ℂ),),
                is_tangent_atol_multiplier = 1,
                test_inplace = true,
                test_rand_point = true,
            )
            @test isapprox(
                -pts_complex[1],
                exp(M, pts_complex[1], log(M, pts_complex[1], -pts_complex[1])),
            )
        end # testset type $T
    end # for
    @testset "field parameter" begin
        M = SkewHermitianMatrices(3, ℝ; parameter = :field)
        Mc = SkewHermitianMatrices(3, ℂ; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "SkewSymmetricMatrices(3; parameter=:field)"
        @test repr(Mc) == "SkewHermitianMatrices(3, ℂ; parameter=:field)"
    end
end # test SymmetricMatrices

@doc raw"""
    CenteredMatrices{𝔽,T} <: AbstractDecoratorManifold{𝔽}

The manifold of ``m×n`` real-valued or complex-valued matrices whose columns sum to zero, i.e.
````math
\bigl\{ p ∈ 𝔽^{m×n}\ \big|\ [1 … 1] * p = [0 … 0] \bigr\},
````
where ``𝔽 ∈ \{ℝ,ℂ\}``.

# Constructor
    CenteredMatrices(m, n[, field=ℝ]; parameter::Symbol=:type)

Generate the manifold of `m`-by-`n` (`field`-valued) matrices whose columns sum to zero.

`parameter`: whether a type parameter should be used to store `m` and `n`. By default size
is stored in type. Value can either be `:field` or `:type`.
"""
struct CenteredMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function CenteredMatrices(m::Int, n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (m, n))
    return CenteredMatrices{field, typeof(size)}(size)
end

@doc raw"""
    check_point(M::CenteredMatrices, p; kwargs...)

Check whether the matrix is a valid point on the
[`CenteredMatrices`](@ref) `M`, i.e. is an `m`-by-`n` matrix whose columns sum to
zero.

The tolerance for the column sums of `p` can be set using `kwargs...`.
"""
function check_point(
        M::CenteredMatrices,
        p::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    m, n = get_parameter(M.size)
    if !isapprox(sum(p, dims = 1), zeros(1, n); atol = atol, kwargs...)
        return DomainError(
            p,
            string(
                "The point $(p) does not lie on $(M), since its columns do not sum to zero.",
            ),
        )
    end
    return nothing
end

"""
    check_vector(M::CenteredMatrices, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`CenteredMatrices`](@ref) `M`, i.e. that `X` is a matrix of size `(m, n)` whose columns
sum to zero and its values are from the correct [`AbstractNumbers`](@extref ManifoldsBase number-system).
The tolerance for the column sums of `p` and `X` can be set using `kwargs...`.
"""
function check_vector(
        M::CenteredMatrices,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    m, n = get_parameter(M.size)
    if !isapprox(sum(X, dims = 1), zeros(1, n); atol = atol, kwargs...)
        return DomainError(
            X,
            "The vector $(X) is not a tangent vector to $(p) on $(M), since its columns do not sum to zero.",
        )
    end
    return nothing
end

embed(::CenteredMatrices, p) = p
embed(::CenteredMatrices, p, X) = X

function get_embedding(::CenteredMatrices{𝔽, TypeParameter{Tuple{m, n}}}) where {m, n, 𝔽}
    return Euclidean(m, n; field = 𝔽)
end
function get_embedding(M::CenteredMatrices{𝔽, Tuple{Int, Int}}) where {𝔽}
    m, n = get_parameter(M.size)
    return Euclidean(m, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::CenteredMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

"""
    is_flat(::CenteredMatrices)

Return true. [`CenteredMatrices`](@ref) is a flat manifold.
"""
is_flat(M::CenteredMatrices) = true

@doc raw"""
    manifold_dimension(M::CenteredMatrices)

Return the manifold dimension of the [`CenteredMatrices`](@ref) `m`-by-`n` matrix `M` over the number system
`𝔽`, i.e.

````math
\dim(\mathcal M) = (m*n - n) \dim_ℝ 𝔽,
````
where ``\dim_ℝ 𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of `𝔽`.
"""
function manifold_dimension(M::CenteredMatrices{𝔽}) where {𝔽}
    m, n = get_parameter(M.size)
    return (m * n - n) * real_dimension(𝔽)
end

@doc raw"""
    project(M::CenteredMatrices, p)

Projects `p` from the embedding onto the [`CenteredMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_{\mathcal M}(p) = p - \begin{bmatrix}
1\\
⋮\\
1
\end{bmatrix} * [c_1 \dots c_n],
````
where ``c_i = \frac{1}{m}\sum_{j=1}^m p_{j,i}`` for ``i = 1, \dots, n``.
"""
project(::CenteredMatrices, ::Any)

project!(::CenteredMatrices, q, p) = copyto!(q, p .- mean(p, dims = 1))

@doc raw"""
    project(M::CenteredMatrices, p, X)

Project the matrix `X` onto the tangent space at `p` on the [`CenteredMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_p(X) = X - \begin{bmatrix}
1\\
⋮\\
1
\end{bmatrix} * [c_1 \dots c_n],
````
where ``c_i = \frac{1}{m}\sum_{j=1}^m x_{j,i}``  for ``i = 1, \dots, n``.
"""
project(::CenteredMatrices, ::Any, ::Any)

project!(::CenteredMatrices, Y, p, X) = (Y .= X .- mean(X, dims = 1))

representation_size(M::CenteredMatrices) = get_parameter(M.size)

function Base.show(io::IO, ::CenteredMatrices{𝔽, TypeParameter{Tuple{m, n}}}) where {m, n, 𝔽}
    return print(io, "CenteredMatrices($(m), $(n), $(𝔽))")
end
function Base.show(io::IO, M::CenteredMatrices{𝔽, Tuple{Int, Int}}) where {𝔽}
    m, n = get_parameter(M.size)
    return print(io, "CenteredMatrices($(m), $(n), $(𝔽); parameter=:field)")
end

@doc raw"""
    Y = Weingarten(M::CenteredMatrices, p, X, V)
    Weingarten!(M::CenteredMatrices, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`CenteredMatrices`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::CenteredMatrices, p, X, V)

Weingarten!(::CenteredMatrices, Y, p, X, V) = fill!(Y, 0)

include("../header.jl")

using RecursiveArrayTools

@testset "fiber bundle" begin
    M = Stiefel(3, 2)
    vm = default_vector_transport_method(M)
    @test Manifolds.FiberBundleProductVectorTransport(M) ==
        Manifolds.FiberBundleProductVectorTransport(vm, vm)
end

include("../header.jl")

@testset "Lorentz Manifold" begin
    M = Lorentz(3)
    @testset "Minkowski Metric" begin
        N = MetricManifold(Euclidean(3), MinkowskiMetric())
        @test N == M
        @test local_metric(M, zeros(3)) == Diagonal([1.0, 1.0, -1.0])
        # check minkowski metric is called
        p = zeros(3)
        X = [1.0, 2.0, 3.0]
        Y = [2.0, 3.0, 4.0]
        @test minkowski_metric(X, Y) == -4
        @test inner(M, p, X, Y) == minkowski_metric(X, Y)
    end
end

"""
    ArrayPowerRepresentation

Representation of points and tangent vectors on a power manifold using multidimensional
arrays where first dimensions are equal to [`representation_size`](@ref) of the
wrapped manifold and the following ones are equal to the number of elements in each
direction.

[`Torus`](@ref) uses this representation.
"""
struct ArrayPowerRepresentation <: AbstractPowerRepresentation end

@doc raw"""
    PowerMetric <: AbstractMetric

Represent the [`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`)
on an `AbstractPowerManifold`, i.e. the inner
product on the tangent space is the sum of the inner product of each elements
tangent space of the power manifold.
"""
struct PowerMetric <: AbstractMetric end

function ManifoldsBase.PowerManifold(
        M::AbstractManifold{𝔽},
        size::Integer...;
        parameter::Symbol = :field,
    ) where {𝔽}
    size_w = wrap_type_parameter(parameter, size)
    return PowerManifold{𝔽, typeof(M), typeof(size_w), ArrayPowerRepresentation}(M, size_w)
end

const PowerManifoldMultidimensional =
    AbstractPowerManifold{𝔽, <:AbstractManifold{𝔽}, ArrayPowerRepresentation} where {𝔽}

Base.:^(M::AbstractManifold, n) = PowerManifold(M, n...)

function allocate(::PowerManifoldNestedReplacing, x::AbstractArray{<:SArray})
    return similar(x)
end

for PowerRepr in [PowerManifoldNested, PowerManifoldNestedReplacing]
    @eval begin
        function allocate_result(::$PowerRepr, ::typeof(get_point), a)
            return error("Operation unsupported")
        end
        function allocate_result(M::$PowerRepr, f::typeof(get_parameters), p)
            return invoke(
                allocate_result,
                Tuple{AbstractManifold, typeof(get_parameters), Any},
                M,
                f,
                p,
            )
        end
    end
end

@doc raw"""
    flat(M::AbstractPowerManifold, p, X)

use the musical isomorphism to transform the tangent vector `X` from the tangent space at
`p` on an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  `M` to a cotangent vector.
This can be done elementwise for each entry of `X` (and `p`).
"""
flat(::AbstractPowerManifold, ::Any...)

function flat!(M::AbstractPowerManifold, ξ::RieszRepresenterCotangentVector, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        p_i = _read(M, rep_size, p, i)
        flat!(
            M.manifold,
            RieszRepresenterCotangentVector(M.manifold, p_i, _write(M, rep_size, ξ.X, i)),
            p_i,
            _read(M, rep_size, X, i),
        )
    end
    return ξ
end

Base.@propagate_inbounds function Base.getindex(
        p::AbstractArray,
        M::PowerManifoldMultidimensional,
        I::Integer...,
    )
    return collect(get_component(M, p, I...))
end
Base.@propagate_inbounds function Base.getindex(
        p::AbstractArray{T, N},
        M::PowerManifoldMultidimensional,
        I::Vararg{Integer, N},
    ) where {T, N}
    return get_component(M, p, I...)
end

@doc raw"""
    manifold_volume(M::PowerManifold)

Return the manifold volume of an [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) `M`.
"""
function manifold_volume(M::PowerManifold)
    size = get_parameter(M.size)
    return manifold_volume(M.manifold)^prod(size)
end

Base.@propagate_inbounds @inline function _read(
        ::PowerManifoldMultidimensional,
        rep_size::Tuple,
        x::AbstractArray,
        i::Tuple,
    )
    return view(x, rep_size_to_colons(rep_size)..., i...)
end
Base.@propagate_inbounds @inline function _read(
        ::PowerManifoldMultidimensional,
        rep_size::Tuple{},
        x::AbstractArray,
        i::NTuple{N, Int},
    ) where {N}
    return x[i...]
end

function Base.view(
        p::AbstractArray,
        M::PowerManifoldMultidimensional,
        I::Union{Integer, Colon, AbstractVector}...,
    )
    rep_size = representation_size(M.manifold)
    return _write(M, rep_size, p, I...)
end

function representation_size(M::PowerManifold)
    return (representation_size(M.manifold)..., get_parameter(M.size)...)
end

@doc raw"""
    Y = riemannian_Hessian(M::AbstractPowerManifold, p, G, H, X)
    riemannian_Hessian!(M::AbstractPowerManifold, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

On an abstract power manifold, this decouples and can be computed elementwise.
"""
riemannian_Hessian(M::AbstractPowerManifold, p, G, H, X)

function riemannian_Hessian!(M::AbstractPowerManifold, Y, p, G, H, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        riemannian_Hessian!(
            M.manifold,
            _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i),
            _read(M, rep_size, G, i),
            _read(M, rep_size, H, i),
            _read(M, rep_size, X, i),
        )
    end
    return Y
end

@doc raw"""
    sharp(M::AbstractPowerManifold, p, ξ::RieszRepresenterCotangentVector)

Use the musical isomorphism to transform the cotangent vector `ξ` from the tangent space at
`p` on an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  `M` to a tangent vector.
This can be done elementwise for every entry of `ξ` (and `p`).
"""
sharp(::AbstractPowerManifold, ::Any...)

function sharp!(M::AbstractPowerManifold, X, p, ξ::RieszRepresenterCotangentVector)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        p_i = _read(M, rep_size, p, i)
        sharp!(
            M.manifold,
            _write(M, rep_size, X, i),
            p_i,
            RieszRepresenterCotangentVector(M.manifold, p_i, _read(M, rep_size, ξ.X, i)),
        )
    end
    return X
end

function Base.show(
        io::IO,
        M::PowerManifold{𝔽, TM, TypeParameter{TSize}, ArrayPowerRepresentation},
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize}
    return print(
        io,
        "PowerManifold($(M.manifold), $(join(TSize.parameters, ", ")), parameter=:type)",
    )
end
function Base.show(
        io::IO,
        M::PowerManifold{𝔽, TM, <:Tuple, ArrayPowerRepresentation},
    ) where {𝔽, TM <: AbstractManifold{𝔽}}
    size = get_parameter(M.size)
    return print(io, "PowerManifold($(M.manifold), $(join(size, ", ")))")
end

@doc raw"""
    volume_density(M::PowerManifold, p, X)

Return volume density on the [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) `M`, i.e. product of constituent
volume densities.
"""
function volume_density(M::PowerManifold, p, X)
    density = one(float(eltype(X)))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        p_i = _read(M, rep_size, p, i)
        X_i = _read(M, rep_size, X, i)
        density *= volume_density(M.manifold, p_i, X_i)
    end
    return density
end

@inline function _write(
        ::PowerManifoldMultidimensional,
        rep_size::Tuple,
        x::AbstractArray,
        i::Tuple,
    )
    return view(x, rep_size_to_colons(rep_size)..., i...)
end

@doc raw"""
    det_local_metric(M::AbstractManifold, p, B::AbstractBasis)

Return the determinant of local matrix representation of the metric tensor ``g``, i.e. of the
matrix ``G(p)`` representing the metric in the tangent space at ``p`` with as a matrix.

See also [`local_metric`](@ref)
"""
function det_local_metric(M::AbstractManifold, p, B::AbstractBasis)
    @warn "`det_local_metric(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `det_local_metric(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    return det(local_metric(M, p, B))
end

"""
    einstein_tensor(M::AbstractManifold, p, B::AbstractBasis; backend::AbstractDiffBackend = diff_badefault_differential_backendckend())

Compute the Einstein tensor of the manifold `M` at the point `p`, see [https://en.wikipedia.org/wiki/Einstein_tensor](https://en.wikipedia.org/wiki/Einstein_tensor)
"""
function einstein_tensor(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    @warn "`einstein_tensor(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `einstein_tensor(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    Ric = ricci_tensor(M, p, B; backend = backend)
    g = local_metric(M, p, B)
    Ginv = inverse_local_metric(M, p, B)
    S = sum(Ginv .* Ric)
    G = Ric - g .* S / 2
    return G
end
@trait_function einstein_tensor(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)


@doc raw"""
    inverse_local_metric(M::AbstractManifold{𝔽}, p, B::AbstractBasis)

Return the local matrix representation of the inverse metric (cometric) tensor
of the tangent space at `p` on the [`AbstractManifold`](https://juliamanifolds.github.io/Manifolds.jl/latest/interface.html#ManifoldsBase.AbstractManifold) `M` with respect
to the [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`) basis `B`.

The metric tensor (see [`local_metric`](@ref)) is usually denoted by ``G = (g_{ij}) ∈ 𝔽^{d×d}``,
where ``d`` is the dimension of the manifold.

Then the inverse local metric is denoted by ``G^{-1} = g^{ij}``.
"""
inverse_local_metric(::AbstractManifold, ::Any, ::AbstractBasis)
function inverse_local_metric(M::AbstractManifold, p, B::AbstractBasis)
    @warn "`inverse_local_metric(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `inverse_local_metric(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    return inv(local_metric(M, p, B))
end
@trait_function inverse_local_metric(M::AbstractDecoratorManifold, p, B::AbstractBasis)


@doc raw"""
    local_metric(M::AbstractManifold{𝔽}, p, B::AbstractBasis)

Return the local matrix representation at the point `p` of the metric tensor ``g`` with
respect to the [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`) `B` on the [`AbstractManifold`](https://juliamanifolds.github.io/Manifolds.jl/latest/interface.html#ManifoldsBase.AbstractManifold) `M`.
Let ``d``denote the dimension of the manifold and $b_1,\ldots,b_d$ the basis vectors.
Then the local matrix representation is a matrix ``G\in 𝔽^{n×n}`` whose entries are
given by ``g_{ij} = g_p(b_i,b_j), i,j\in\{1,…,d\}``.

This yields the property for two tangent vectors (using Einstein summation convention)
``X = X^ib_i, Y=Y^ib_i \in T_p\mathcal M`` we get ``g_p(X, Y) = g_{ij} X^i Y^j``.
"""
local_metric(::AbstractManifold, ::Any, ::AbstractBasis)

function local_metric(M::MetricManifold, p, B::AbstractBasis)
    @warn "`local_metric(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `local_metric(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    (metric(M.manifold) == M.metric) && (return local_metric(M.manifold, p, B))
    return invoke(local_metric, Tuple{AbstractManifold, Any, AbstractBasis}, M, p, B)
end

@doc raw"""
    local_metric_jacobian(M::AbstractManifold, p, B::AbstractBasis;
        backend::AbstractDiffBackend,
    )

Get partial derivatives of the local metric of `M` at `p` in basis `B` with respect to the
coordinates of `p`, ``\frac{∂}{∂ p^k} g_{ij} = g_{ij,k}``. The
dimensions of the resulting multi-dimensional array are ordered ``(i,j,k)``.
"""
local_metric_jacobian(::AbstractManifold, ::Any, B::AbstractBasis)
function local_metric_jacobian(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    @warn "`local_metric_jacobian(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `christoffel_symbols_second(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    n = size(p, 1)
    ∂g = reshape(_jacobian(q -> local_metric(M, q, B), copy(M, p), backend), n, n, n)
    return ∂g
end

@doc raw"""
    log_local_metric_density(M::AbstractManifold, p, B::AbstractBasis)

Return the natural logarithm of the metric density ``ρ`` of `M` at `p`, which
is given by ``ρ = \log \sqrt{|\det [g_{ij}]|}`` for the metric tensor expressed in basis `B`.
"""
log_local_metric_density(::AbstractManifold, ::Any, ::AbstractBasis)
function log_local_metric_density(M::AbstractManifold, p, B::AbstractBasis)
    @warn "`log_local_metric_density(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `log_local_metric_density(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    return log(abs(det_local_metric(M, p, B))) / 2
end

function norm(M::MetricManifold, p, X::TFVector)
    return sqrt(dot(X.data, local_metric(M, p, X.basis) * X.data))
end

@doc raw"""
    ricci_curvature(M::AbstractManifold, p, B::AbstractBasis; backend::AbstractDiffBackend = default_differential_backend())

Compute the Ricci scalar curvature of the manifold `M` at the point `p` using basis `B`.
The curvature is computed as the trace of the Ricci curvature tensor with respect to
the metric, that is ``R=g^{ij}R_{ij}`` where ``R`` is the scalar Ricci curvature at `p`,
``g^{ij}`` is the inverse local metric (see [`inverse_local_metric`](@ref)) at `p` and
``R_{ij}`` is the Ricci curvature tensor, see [`ricci_tensor`](@ref). Both the tensor and
inverse local metric are expressed in local coordinates defined by `B`, and the formula
uses the Einstein summation convention.
"""
ricci_curvature(::AbstractManifold, ::Any, ::AbstractBasis)
function ricci_curvature(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    @warn "`ricci_curvature(M::AbstractManifold, p, B::AbstractBasis)` is deprecated. Consider using `ricci_curvature(M::AbstractManifold, A::AbstractAtlas, i, a)` instead"  maxlog = 1
    Ginv = inverse_local_metric(M, p, B)
    Ric = ricci_tensor(M, p, B; backend = backend)
    S = sum(Ginv .* Ric)
    return S
end
ManifoldsBase.@trait_function ricci_curvature(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)
for mf in [
        christoffel_symbols_second_jacobian,
        local_metric_jacobian,
    ]
    @eval is_metric_function(::typeof($mf)) = true
end

@doc raw"""
    Stiefel{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The Stiefel manifold consists of all ``n×k``, ``n ≥ k`` unitary matrices, i.e.

````math
\operatorname{St}(n,k) = \bigl\{ p ∈ 𝔽^{n×k}\ \big|\ p^{\mathrm{H}}p = I_k \bigr\},
````

where ``𝔽 ∈ \{ℝ, ℂ\}``,
``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or Hermitian, and
``I_k ∈ ℝ^{k×k}`` denotes the ``k×k`` identity matrix.

The tangent space at a point ``p ∈ \mathcal M`` is given by

````math
T_p \mathcal M = \{ X ∈ 𝔽^{n×k} : p^{\mathrm{H}}X + X^{\mathrm{H}}p = 0_k\},
````

where ``0_k`` is the ``k×k`` zero matrix.

This manifold is modelled as an embedded manifold to the [`Euclidean`](@ref), i.e.
several functions like the [`inner`](@ref inner(::Euclidean, ::Any...)) product and the
[`zero_vector`](@ref zero_vector(::Euclidean, ::Any...)) are inherited from the embedding.

The manifold is named after
[Eduard L. Stiefel](https://en.wikipedia.org/wiki/Eduard_Stiefel) (1909–1978).

# Constructor
    Stiefel(n, k, field=ℝ; parameter::Symbol=:type)

Generate the (real-valued) Stiefel manifold of ``n×k`` dimensional orthonormal matrices.
"""
struct Stiefel{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function Stiefel(n::Int, k::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return Stiefel{field, typeof(size)}(size)
end

function allocation_promotion_function(::Stiefel{ℂ}, ::Any, ::Tuple)
    return complex
end

@doc raw"""
    change_representer(M::Stiefel, ::EuclideanMetric, p, X)

Change `X` to the corresponding representer of a cotangent vector at `p`.
Since the [`Stiefel`](@ref) manifold `M`, is isometrically embedded, this is the identity
"""
change_representer(::Stiefel, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(M::Stiefel, Y, ::EuclideanMetric, p, X)
    copyto!(M, Y, p, X)
    return Y
end

@doc raw"""
    change_metric(M::Stiefel, ::EuclideanMetric, p X)

Change `X` to the corresponding vector with respect to the metric of the [`Stiefel`](@ref) `M`,
which is just the identity, since the manifold is isometrically embedded.
"""
change_metric(M::Stiefel, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(::Stiefel, Y, ::EuclideanMetric, p, X)
    copyto!(Y, X)
    return Y
end

@doc raw"""
    check_point(M::Stiefel, p; kwargs...)

Check whether `p` is a valid point on the [`Stiefel`](@ref) `M`=``\operatorname{St}(n,k)``, i.e. that it has the right
[`AbstractNumbers`](@extref ManifoldsBase number-system) type and ``p^{\mathrm{H}}p`` is (approximately) the identity, where ``⋅^{\mathrm{H}}`` is the
complex conjugate transpose. The settings for approximately can be set with `kwargs...`.
"""
function check_point(M::Stiefel, p; kwargs...)
    cks = check_size(M, p)
    (cks === nothing) || return cks
    c = p' * p
    if !isapprox(c, one(c); kwargs...)
        return DomainError(
            norm(c - one(c)),
            "The point $(p) does not lie on $(M), because p'p is not the unit matrix.",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::Stiefel, p, X; kwargs...)

Checks whether `X` is a valid tangent vector at `p` on the [`Stiefel`](@ref)
`M`=``\operatorname{St}(n,k)``, i.e. the [`AbstractNumbers`](@extref ManifoldsBase number-system) fits and
it (approximately) holds that ``p^{\mathrm{H}}X + X^{\mathrm{H}}p = 0``.
The settings for approximately can be set with `kwargs...`.
"""
function check_vector(M::Stiefel, p, X; kwargs...)
    n, k = get_parameter(M.size)
    cks = check_size(M, p, X)
    cks === nothing || return cks
    if !isapprox(p' * X, -conj(X' * p); kwargs...)
        return DomainError(
            norm(p' * X + conj(X' * p)),
            "The matrix $(X) is does not lie in the tangent space of $(p) on the Stiefel manifold of dimension ($(n),$(k)), since p'X + X'p is not the zero matrix.",
        )
    end
    return nothing
end

"""
    default_inverse_retraction_method(M::Stiefel)

Return [`PolarInverseRetraction`](@extref `ManifoldsBase.PolarInverseRetraction`) as the default inverse retraction for the
[`Stiefel`](@ref) manifold.
"""
default_inverse_retraction_method(::Stiefel) = PolarInverseRetraction()

metric(::Stiefel) = EuclideanMetric()

"""
    default_retraction_method(M::Stiefel)

Return [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) as the default retraction for the [`Stiefel`](@ref) manifold.
"""
default_retraction_method(::Stiefel) = PolarRetraction()

"""
    default_vector_transport_method(M::Stiefel)

Return the [`DifferentiatedRetractionVectorTransport`](@extref `ManifoldsBase.DifferentiatedRetractionVectorTransport`) of the [`PolarRetraction`]([`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`)
as the default vector transport method for the [`Stiefel`](@ref) manifold.
"""
function default_vector_transport_method(::Stiefel)
    return DifferentiatedRetractionVectorTransport(PolarRetraction())
end

embed(::Stiefel, p) = p
embed(::Stiefel, p, X) = X

function get_embedding(::Stiefel{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return Euclidean(n, k; field = 𝔽)
end
function get_embedding(M::Stiefel{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return Euclidean(n, k; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Stiefel)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

@doc raw"""
    inverse_retract(M::Stiefel, p, q, ::PolarInverseRetraction)

Compute the inverse retraction based on a singular value decomposition
for two points `p`, `q` on the [`Stiefel`](@ref) manifold `M`.
This follows the following approach: From the Polar retraction we know that

````math
\operatorname{retr}_p^{-1}q = qs - t
````

if such a symmetric positive definite ``k×k`` matrix exists. Since ``qs - t``
is also a tangent vector at ``p`` we obtain

````math
p^{\mathrm{H}}qs + s(p^{\mathrm{H}}q)^{\mathrm{H}} + 2I_k = 0,
````
which can either be solved by a Lyapunov approach or a continuous-time
algebraic Riccati equation.

This implementation follows the Lyapunov approach.
"""
inverse_retract(::Stiefel, ::Any, ::Any, ::PolarInverseRetraction)

@doc raw"""
    inverse_retract(M::Stiefel, p, q, ::QRInverseRetraction)

Compute the inverse retraction based on a qr decomposition
for two points `p`, `q` on the [`Stiefel`](@ref) manifold `M` and return
the resulting tangent vector in `X`. The computation follows Algorithm 1
in [KanekoFioriTanaka:2013](@cite).
"""
inverse_retract(::Stiefel, ::Any, ::Any, ::QRInverseRetraction)

function _stiefel_inv_retr_qr_mul_by_r_generic!(M::Stiefel, X, q, R, A)
    n, k = get_parameter(M.size)
    @inbounds for i in 1:k
        b = zeros(eltype(R), i)
        b[i] = 1
        b[1:(end - 1)] = -transpose(R[1:(i - 1), 1:(i - 1)]) * A[i, 1:(i - 1)]
        R[1:i, i] = A[1:i, 1:i] \ b
    end
    #TODO: replace with this once it's supported by StaticArrays
    #return mul!(X, q, UpperTriangular(R))
    return mul!(X, q, R)
end

function _stiefel_inv_retr_qr_mul_by_r!(
        ::Stiefel{𝔽, TypeParameter{Tuple{n, 1}}},
        X,
        q,
        A,
        ::Type,
    ) where {𝔽, n}
    @inbounds R = SMatrix{1, 1}(inv(A[1, 1]))
    return mul!(X, q, R)
end
function _stiefel_inv_retr_qr_mul_by_r!(
        M::Stiefel{𝔽, TypeParameter{Tuple{n, 1}}},
        X,
        q,
        A::StaticArray,
        ::Type{ElT},
    ) where {𝔽, n, ElT}
    return invoke(
        _stiefel_inv_retr_qr_mul_by_r!,
        Tuple{
            Stiefel{𝔽, TypeParameter{Tuple{n, 1}}},
            typeof(X),
            typeof(q),
            AbstractArray,
            typeof(ElT),
        },
        M,
        X,
        q,
        A,
        ElT,
    )
end
function _stiefel_inv_retr_qr_mul_by_r!(
        ::Stiefel{𝔽, TypeParameter{Tuple{n, 2}}},
        X,
        q,
        A,
        ::Type{ElT},
    ) where {𝔽, n, ElT}
    R11 = inv(A[1, 1])
    @inbounds R =
        hcat(SA[R11, zero(ElT)], A[SOneTo(2), SOneTo(2)] \ SA[-R11 * A[2, 1], one(ElT)])

    #TODO: replace with this once it's supported by StaticArrays
    #return mul!(X, q, UpperTriangular(R))
    return mul!(X, q, R)
end
function _stiefel_inv_retr_qr_mul_by_r!(
        M::Stiefel{𝔽, TypeParameter{Tuple{n, 2}}},
        X,
        q,
        A::StaticArray,
        ::Type{ElT},
    ) where {𝔽, n, ElT}
    return invoke(
        _stiefel_inv_retr_qr_mul_by_r!,
        Tuple{
            Stiefel{𝔽, TypeParameter{Tuple{n, 2}}},
            typeof(X),
            typeof(q),
            AbstractArray,
            typeof(ElT),
        },
        M,
        X,
        q,
        A,
        ElT,
    )
end
function _stiefel_inv_retr_qr_mul_by_r!(
        M::Stiefel{𝔽, TypeParameter{Tuple{n, k}}},
        X,
        q,
        A::StaticArray,
        ::Type{ElT},
    ) where {𝔽, n, k, ElT}
    R = zeros(MMatrix{k, k, ElT})
    return _stiefel_inv_retr_qr_mul_by_r_generic!(M, X, q, R, A)
end
function _stiefel_inv_retr_qr_mul_by_r!(M::Stiefel, X, q, A, ::Type{ElT}) where {ElT}
    n, k = get_parameter(M.size)
    R = zeros(ElT, k, k)
    return _stiefel_inv_retr_qr_mul_by_r_generic!(M, X, q, R, A)
end

function inverse_retract_polar!(::Stiefel, X, p, q)
    A = p' * q
    H = -2 * one(p' * p)
    B = lyap(A, H)
    mul!(X, q, B)
    X .-= p
    return X
end
function inverse_retract_qr!(M::Stiefel, X, p, q)
    n, k = get_parameter(M.size)
    A = p' * q
    @boundscheck size(A) === (k, k)
    ElT = typeof(one(eltype(p)) * one(eltype(q)))
    _stiefel_inv_retr_qr_mul_by_r!(M, X, q, A, ElT)
    X .-= p
    return X
end

function _isapprox(M::Stiefel, p, X, Y; atol = sqrt(max_eps(X, Y)), kwargs...)
    return isapprox(norm(M, p, X - Y), 0; atol = atol, kwargs...)
end

"""
    is_flat(M::Stiefel)

Return true if [`Stiefel`](@ref) `M` is one-dimensional.
"""
is_flat(M::Stiefel) = manifold_dimension(M) == 1

@doc raw"""
    manifold_dimension(M::Stiefel)

Return the dimension of the [`Stiefel`](@ref) manifold `M`=``\operatorname{St}(n,k,𝔽)``.
The dimension is given by

````math
\begin{aligned}
\dim \mathrm{St}(n, k, ℝ) &= nk - \frac{1}{2}k(k+1)\\
\dim \mathrm{St}(n, k, ℂ) &= 2nk - k^2\\
\dim \mathrm{St}(n, k, ℍ) &= 4nk - k(2k-1)
\end{aligned}
````
"""
function manifold_dimension(M::Stiefel{ℝ})
    n, k = get_parameter(M.size)
    return n * k - div(k * (k + 1), 2)
end
function manifold_dimension(M::Stiefel{ℂ})
    n, k = get_parameter(M.size)
    return 2 * n * k - k * k
end
function manifold_dimension(M::Stiefel{ℍ})
    n, k = get_parameter(M.size)
    return 4 * n * k - k * (2k - 1)
end

@doc raw"""
    rand(::Stiefel; vector_at=nothing, σ::Real=1.0)

When `vector_at` is `nothing`, return a random (Gaussian) point `x` on the [`Stiefel`](@ref)
manifold `M` by generating a (Gaussian) matrix with standard deviation `σ` and return the
orthogonalized version, i.e. return the Q component of the QR decomposition of the random
matrix of size ``n×k``.

When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_{vector\_at}\mathrm{St}(n,k)`` with mean zero and standard deviation `σ` by projecting a
random Matrix onto the tangent vector at `vector_at`.
"""
rand(::Stiefel; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::Stiefel{𝔽},
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
    ) where {𝔽}
    n, k = get_parameter(M.size)
    if vector_at === nothing
        A = σ * randn(rng, 𝔽 === ℝ ? Float64 : ComplexF64, n, k)
        pX .= Matrix(qr(A).Q)
    else
        Z = σ * randn(rng, eltype(pX), size(pX))
        project!(M, pX, vector_at, Z)
        normalize!(pX)
    end
    return pX
end

@doc raw"""
    retract(::Stiefel, p, X, ::CayleyRetraction)

Compute the retraction on the [`Stiefel`](@ref) that is based on the Cayley transform[Zhu:2016](@cite).
Using
````math
  W_{p,X} = \operatorname{P}_pXp^{\mathrm{H}} - pX^{\mathrm{H}}\operatorname{P_p}
  \quad\text{where}
  \operatorname{P}_p = I - \frac{1}{2}pp^{\mathrm{H}}
````
the formula reads
````math
    \operatorname{retr}_pX = \Bigl(I - \frac{1}{2}W_{p,X}\Bigr)^{-1}\Bigl(I + \frac{1}{2}W_{p,X}\Bigr)p.
````

It is implemented as the case ``m=1`` of the `PadeRetraction`.
"""
retract(::Stiefel, ::Any, ::Any, ::CayleyRetraction)

@doc raw"""
    retract(M::Stiefel, p, X, ::PadeRetraction{m})

Compute the retraction on the [`Stiefel`](@ref) manifold `M` based on the Padé approximation of order ``m`` [ZhuDuan:2018](@cite).
Let ``p_m`` and ``q_m`` be defined for any matrix ``A ∈ ℝ^{n×x}`` as

````math
  p_m(A) = \sum_{k=0}^m \frac{(2m-k)!m!}{(2m)!(m-k)!}\frac{A^k}{k!}
````

and

````math
  q_m(A) = \sum_{k=0}^m \frac{(2m-k)!m!}{(2m)!(m-k)!}\frac{(-A)^k}{k!}
````

respectively. Then the Padé approximation (of the matrix exponential ``\exp(A)``) reads

````math
  r_m(A) = q_m(A)^{-1}p_m(A)
````

Defining further

````math
  W_{p,X} = \operatorname{P}_pXp^{\mathrm{H}} - pX^{\mathrm{H}}\operatorname{P_p}
  \quad\text{where }
  \operatorname{P}_p = I - \frac{1}{2}pp^{\mathrm{H}}
````

the retraction reads

````math
  \operatorname{retr}_pX = r_m(W_{p,X})p
````
"""
retract(::Stiefel, ::Any, ::Any, ::PadeRetraction)

@doc raw"""
    retract(M::Stiefel, p, X, ::PolarRetraction)

Compute the SVD-based retraction [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`Stiefel`](@ref) manifold `M`. With ``USV = p + X`` the retraction reads

````math
\operatorname{retr}_p X = U\bar{V}^\mathrm{H}.
````
"""
retract(::Stiefel, ::Any, ::Any, ::PolarRetraction)

@doc raw"""
    retract(M::Stiefel, p, X, ::QRRetraction)

Compute the QR-based retraction [`QRRetraction`](@extref `ManifoldsBase.QRRetraction`) on the
[`Stiefel`](@ref) manifold `M`. With ``QR = p + X`` the retraction reads

````math
\operatorname{retr}_p X = QD,
````

where ``D`` is a ``n×k`` matrix with

````math
D = \operatorname{diag}\bigl(\operatorname{sgn}(R_{ii}+0,5)_{i=1}^k \bigr),
````

where ``\operatorname{sgn}(p) = \begin{cases}
1 & \text{ for } p > 0,\\
0 & \text{ for } p = 0,\\
-1& \text{ for } p < 0.
\end{cases}``
"""
retract(::Stiefel, ::Any, ::Any, ::QRRetraction)

_qrfac_to_q(qrfac) = Matrix(qrfac.Q)
_qrfac_to_q(qrfac::StaticArrays.QR) = qrfac.Q

function ManifoldsBase.retract_pade!(M::Stiefel, q, p, X, m::PadeRetraction)
    return ManifoldsBase.retract_pade_fused!(M, q, p, X, one(eltype(p)), m)
end

function ManifoldsBase.retract_pade_fused!(
        ::Stiefel,
        q,
        p,
        X,
        t::Number,
        ::PadeRetraction{m},
    ) where {m}
    tX = t * X
    Pp = I - 1 // 2 * p * p'
    WpX = Pp * tX * p' - p * tX' * Pp
    pm = zeros(eltype(WpX), size(WpX))
    qm = zeros(eltype(WpX), size(WpX))
    WpXk = similar(WpX)
    copyto!(WpXk, factorial(m) / factorial(2 * m) * I) # factorial factor independent of k
    for k in 0:m
        # incrementally build (2m-k)!/(m-k)!(k)! for k > 0, i.e.
        # remove factor (2m-k+1) in the nominator, (m-k+1) in the denominator and multiply by 1/k
        WpXk .*= (k == 0 ? 2 : (m - k + 1) / ((2 * m - k + 1) * k))
        pm .+= WpXk
        if k % 2 == 0
            qm .+= WpXk
        else
            qm .-= WpXk
        end
        WpXk *= WpX
    end
    return copyto!(q, (qm \ pm) * p)
end

function ManifoldsBase.retract_polar!(M::Stiefel, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_polar_fused!(::Stiefel, q, p, X, t::Number)
    q .= p .+ t .* X
    s = svd(q)
    return mul!(q, s.U, s.Vt)
end

function ManifoldsBase.retract_qr!(M::Stiefel, q, p, X)
    return ManifoldsBase.retract_qr_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_qr_fused!(::Stiefel, q, p, X, t::Number)
    q .= p .+ t .* X
    qrfac = qr(q)
    d = diag(qrfac.R)
    D = Diagonal(sign.(sign.(d .+ 1 // 2)))
    return mul!(q, _qrfac_to_q(qrfac), D)
end

@doc raw"""
    representation_size(M::Stiefel)

Returns the representation size of the [`Stiefel`](@ref) `M`=``\operatorname{St}(n,k)``,
i.e. `(n,k)`, which is the matrix dimensions.
"""
representation_size(M::Stiefel) = get_parameter(M.size)

function Base.show(io::IO, ::Stiefel{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return print(io, "Stiefel($(n), $(k), $(𝔽))")
end
function Base.show(io::IO, M::Stiefel{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return print(io, "Stiefel($(n), $(k), $(𝔽); parameter=:field)")
end

@doc raw"""
    vector_transport_direction(::Stiefel, p, X, d, ::DifferentiatedRetractionVectorTransport{CayleyRetraction})

Compute the vector transport given by the differentiated retraction of the [`CayleyRetraction`](@extref `ManifoldsBase.CayleyRetraction`), cf. [Zhu:2016](@cite) Equation (17).

The formula reads
````math
\operatorname{T}_{p,d}(X) =
\Bigl(I - \frac{1}{2}W_{p,d}\Bigr)^{-1}W_{p,X}\Bigl(I - \frac{1}{2}W_{p,d}\Bigr)^{-1}p,
````
with
````math
  W_{p,X} = \operatorname{P}_pXp^{\mathrm{H}} - pX^{\mathrm{H}}\operatorname{P_p}
  \quad\text{where }
  \operatorname{P}_p = I - \frac{1}{2}pp^{\mathrm{H}}
````

Since this is the differentiated retraction as a vector transport, the result will be in the
tangent space at ``q=\operatorname{retr}_p(d)`` using the [`CayleyRetraction`](@extref `ManifoldsBase.CayleyRetraction`).
"""
vector_transport_direction(
    M::Stiefel,
    p,
    X,
    d,
    ::DifferentiatedRetractionVectorTransport{CayleyRetraction},
)

@doc raw"""
    vector_transport_direction(M::Stiefel, p, X, d, DifferentiatedRetractionVectorTransport{PolarRetraction})

Compute the vector transport by computing the push forward of
[`retract(::Stiefel, ::Any, ::Any, ::PolarRetraction)`](@ref) Section 3.5 of [Zhu:2016](@cite):

```math
T_{p,d}^{\text{Pol}}(X) = q*Λ + (I-qq^{\mathrm{T}})X(1+d^\mathrm{T}d)^{-\frac{1}{2}},
```

where ``q = \operatorname{retr}^{\mathrm{Pol}}_p(d)``, and ``Λ`` is the unique solution of the Sylvester equation

```math
    Λ(I+d^\mathrm{T}d)^{\frac{1}{2}} + (I + d^\mathrm{T}d)^{\frac{1}{2}} = q^\mathrm{T}X - X^\mathrm{T}q
```
"""
vector_transport_direction(
    ::Stiefel,
    ::Any,
    ::Any,
    ::Any,
    ::DifferentiatedRetractionVectorTransport{PolarRetraction},
)

@doc raw"""
    vector_transport_direction(M::Stiefel, p, X, d, DifferentiatedRetractionVectorTransport{QRRetraction})

Compute the vector transport by computing the push forward of the
[`retract(::Stiefel, ::Any, ::Any, ::QRRetraction)`](@ref),
See  [AbsilMahonySepulchre:2008](@cite), p. 173, or Section 3.5 of [Zhu:2016](@cite).
```math
T_{p,d}^{\text{QR}}(X) = q*\rho_{\mathrm{s}}(q^\mathrm{T}XR^{-1}) + (I-qq^{\mathrm{T}})XR^{-1},
```
where ``q = \operatorname{retr}^{\mathrm{QR}}_p(d)``, ``R`` is the ``R`` factor of the QR
decomposition of ``p + d``, and
```math
\bigl( \rho_{\mathrm{s}}(A) \bigr)_{ij}
= \begin{cases}
A_{ij}&\text{ if } i > j\\
0 \text{ if } i = j\\
-A_{ji} \text{ if } i < j.\\
\end{cases}
```
"""
vector_transport_direction(
    ::Stiefel,
    ::Any,
    ::Any,
    ::Any,
    ::DifferentiatedRetractionVectorTransport{QRRetraction},
)

function vector_transport_direction_diff!(::Stiefel, Y, p, X, d, ::CayleyRetraction)
    Pp = I - 1 // 2 * p * p'
    Wpd = Pp * d * p' - p * d' * Pp
    WpX = Pp * X * p' - p * X' * Pp
    q1 = I - 1 // 2 * Wpd
    return copyto!(Y, (q1 \ WpX) * (q1 \ p))
end

function vector_transport_direction_diff!(M::Stiefel, Y, p, X, d, ::PolarRetraction)
    q = retract(M, p, d, PolarRetraction())
    Iddsqrt = sqrt(I + d' * d)
    Λ = sylvester(Iddsqrt, Iddsqrt, -q' * X + X' * q)
    return copyto!(Y, q * Λ + (X - q * (q' * X)) / Iddsqrt)
end
function vector_transport_direction_diff!(M::Stiefel, Y, p, X, d, ::QRRetraction)
    q = retract(M, p, d, QRRetraction())

    # use the QR factorization with positive diagonal of R
    pdR = qr(p + d).R
    s = sign.(diag(pdR))
    s[s .== 0] .= 1
    rf = UpperTriangular(Diagonal(s)' * pdR)

    Xrf = X / rf
    qtXrf = q' * Xrf
    return copyto!(
        Y,
        q * (UpperTriangular(qtXrf) - UpperTriangular(qtXrf)') + Xrf - q * qtXrf,
    )
end

@doc raw"""
    vector_transport_to(M::Stiefel, p, X, q, DifferentiatedRetractionVectorTransport{PolarRetraction})

Compute the vector transport by computing the push forward of the
[`retract(M::Stiefel, ::Any, ::Any, ::PolarRetraction)`](@ref), see
Section 4 of [HuangGallivanAbsil:2015](@cite) or  Section 3.5 of [Zhu:2016](@cite):

```math
T_{q\gets p}^{\text{Pol}}(X) = q*Λ + (I-qq^{\mathrm{T}})X(1+d^\mathrm{T}d)^{-\frac{1}{2}},
```

where ``d = \bigl( \operatorname{retr}^{\mathrm{Pol}}_p\bigr)^{-1}(q)``,
and ``Λ`` is the unique solution of the Sylvester equation

```math
    Λ(I+d^\mathrm{T}d)^{\frac{1}{2}} + (I + d^\mathrm{T}d)^{\frac{1}{2}} = q^\mathrm{T}X - X^\mathrm{T}q
```
"""
vector_transport_to(
    ::Stiefel,
    ::Any,
    ::Any,
    ::Any,
    ::DifferentiatedRetractionVectorTransport{PolarRetraction},
)

@doc raw"""
    vector_transport_to(M::Stiefel, p, X, q, DifferentiatedRetractionVectorTransport{QRRetraction})

Compute the vector transport by computing the push forward of the
[`retract(M::Stiefel, ::Any, ::Any, ::QRRetraction)`](@ref),
see  [AbsilMahonySepulchre:2008](@cite), p. 173, or Section 3.5 of [Zhu:2016](@cite).

```math
T_{q \gets p}^{\text{QR}}(X) = q*\rho_{\mathrm{s}}(q^\mathrm{T}XR^{-1}) + (I-qq^{\mathrm{T}})XR^{-1},
```
where ``d = \bigl(\operatorname{retr}^{\mathrm{QR}}\bigr)^{-1}_p(q)``, ``R`` is the ``R`` factor of the QR
decomposition of ``p+X``, and
```math
\bigl( \rho_{\mathrm{s}}(A) \bigr)_{ij}
= \begin{cases}
A_{ij}&\text{ if } i > j\\
0 \text{ if } i = j\\
-A_{ji} \text{ if } i < j.\\
\end{cases}
```
"""
vector_transport_to(
    ::Stiefel,
    ::Any,
    ::Any,
    ::Any,
    ::DifferentiatedRetractionVectorTransport{QRRetraction},
)

@doc raw"""
    vector_transport_to(M::Stiefel, p, X, q, ::ProjectionTransport)

Compute a vector transport by projection, i.e. project `X` from the tangent space at `p` by
projection it onto the tangent space at `q`.
"""
vector_transport_to(::Stiefel, ::Any, ::Any, ::Any, ::ProjectionTransport)

function vector_transport_to_diff!(M::Stiefel, Y, p, X, q, ::PolarRetraction)
    d = inverse_retract(M, p, q, PolarInverseRetraction())
    Iddsqrt = sqrt(I + d' * d)
    Λ = sylvester(Iddsqrt, Iddsqrt, -q' * X + X' * q)
    return copyto!(Y, q * Λ + (X - q * (q' * X)) / Iddsqrt)
end
function vector_transport_to_diff!(M::Stiefel, Y, p, X, q, ::QRRetraction)
    d = inverse_retract(M, p, q, QRInverseRetraction())

    # use the QR factorization with positive diagonal of R
    pdR = qr(p + d).R
    s = sign.(diag(pdR))
    s[s .== 0] .= 1
    rf = UpperTriangular(Diagonal(s)' * pdR)
    Xrf = X / rf
    qtXrf = q' * Xrf
    return copyto!(
        Y,
        q * (UpperTriangular(qtXrf) - UpperTriangular(qtXrf)') + Xrf - q * qtXrf,
    )
end

using Manifolds, Test

Test.@testset "Centered Matrices" begin

    M = CenteredMatrices(3, 2)

    p1 = [1 2; 4 5; -5 -7]
    p2 = [0 0; 1 -1; -1 1]
    p3 = [0.5 1; -1 -0.7; 0.5 -0.3]
    q1 = [1 2 3; 4 5 6; -5 -7 -9]    #wrong dimensions
    q2 = [-3 -im; 2 im; 1 0]         #complex
    q3 = [1.0 2; 3 4; 5 6]             #not centered

    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                embed,
                get_embedding,
                is_point, is_vector, is_flat,
                manifold_dimension,
                project,
                repr, representation_size,
            ],
            :Points => [p1, p2, p3],
            :Vectors => [p1],
            :EmbeddedPoints => [p1],
            :InvalidPoints => Matrix[q1, q2, q3], #To avoid implicit conversion to complex matrices
            :InvalidVectors => Matrix[q1, q2, q3],
        ),
        Dict(
            :IsPointErrors => [ManifoldDomainError, ManifoldDomainError, DomainError],
            :IsVectorErrors => [ManifoldDomainError, ManifoldDomainError, DomainError],
            is_flat => true,
            get_embedding => Euclidean(3, 2),
            manifold_dimension => 4,
            repr => "CenteredMatrices(3, 2, ℝ)",
            representation_size => (3, 2),
        )
    )
    Mf = CenteredMatrices(3, 2; parameter = :field)
    Manifolds.Test.test_manifold(
        Mf,
        Dict(:Functions => [repr, get_embedding]),
        Dict(
            repr => "CenteredMatrices(3, 2, ℝ; parameter=:field)",
            get_embedding => Euclidean(3, 2; parameter = :field),
        )
    )

    Mc = CenteredMatrices(3, 2, ℂ)
    p4 = q2
    p5 = [1.0 1.0im; -1.0im 0.0; -1.0 + 1.0im -1.0im]
    p6 = [1.0im 0.0; -2.0im 1.0im; 1.0im -1.0im]
    # Complex case
    Manifolds.Test.test_manifold(
        Mc,
        Dict(
            :Functions => [
                embed,
                get_embedding,
                is_point, is_vector, is_flat,
                manifold_dimension,
                project,
                repr, representation_size,
            ],
            :Points => [p4, p5, p6],
            :Vectors => [p4],
            :EmbeddedPoints => [p4],
        ),
        Dict(
            :IsPointErrors => [ManifoldDomainError, ManifoldDomainError, ManifoldDomainError],
            is_flat => true,
            get_embedding => Euclidean(3, 2; field = ℂ),
            manifold_dimension => 8,
            repr => "CenteredMatrices(3, 2, ℂ)",
            representation_size => (3, 2),
        )
    )

end

using Manifolds, Random, Test, LinearAlgebra

@testset "Invertible Matrices of Determinant one" begin
    @testset "Real case" begin
        M = DeterminantOneMatrices(2)
        # is det 1 and inv
        p = [1.0 0.0; 0.0 1.0]
        @test is_point(M, p; error = :error)
        # det 1 but for example not Rotation
        @test is_point(M, [10.0 0.0; 0.0 0.1]; error = :error)
        # Not invertible
        @test_throws DomainError is_point(M, [10.0 0.0; 0.0 0.0]; error = :error)
        # Det(2)
        pf = [2.0 0.0; 0.0 1.0]
        @test_throws DomainError is_point(M, pf; error = :error)
        @test is_point(M, project(M, pf); error = :error)
        Random.seed!(42)
        p = rand(M)
        @test is_point(M, p)
        X = rand(M; vector_at = p)
        @test is_vector(M, p, X)
        # not trace 0
        Xf = [1.0 1.1; 1.2 0.0]
        @test_throws DomainError is_vector(M, p, Xf; error = :error)
        @test is_vector(M, p, project(M, p, Xf); error = :error)
        @test get_embedding(M) == Euclidean(2, 2)
        p = [1.0 0.0; 0.0 1.0]
        @test embed(M, p) == p
        @test embed(M, p, p) == p
        @test manifold_dimension(M) == 3
        @test manifold_dimension(DeterminantOneMatrices(2; parameter = :field)) == 3
        @test repr(M) == "DeterminantOneMatrices(2, ℝ)"
    end
    @testset "Complex case" begin
        M = DeterminantOneMatrices(2, ℂ)
        # is det 1 and inv
        @test is_point(M, [1.0im 0.0; 0.0 -1.0im], true)
        # det 1 but for example not Rotation
        @test is_point(M, [10.0im 0.0; 0.0 -0.1im], true)
        # Not invertible
        @test_throws DomainError is_point(M, [10.0 0.0; 0.0 0.0], true)
        # Det(2)
        @test_throws DomainError is_point(M, [2.0 0.0; 0.0 1.0], true)
        Random.seed!(42)
        p = rand(M)
        @test is_point(M, p)
        X = rand(M; vector_at = p)
        @test is_vector(M, p, X)
        Xf = [1.0 + 2.0im 1.1 + 0.1im; 1.2 0.0]
        @test_throws DomainError is_vector(M, p, Xf; error = :error)
        @test repr(M) == "DeterminantOneMatrices(2, ℂ)"
    end

    @testset "Field parameter" begin
        M = DeterminantOneMatrices(2; parameter = :field)
        @test repr(M) == "DeterminantOneMatrices(2, ℝ; parameter=:field)"
    end
    @testset "rng test" begin
        M = DeterminantOneMatrices(2)
        pX = zeros(2, 2)
        Manifolds._ensure_nonzero_rng_determinant!(
            Random.default_rng(),
            get_embedding(M),
            pX,
        )
        @test abs(det(pX)) > 1.0e-8
    end
end

include("../header.jl")

using RecursiveArrayTools

struct TestVectorSpaceType <: VectorSpaceType end

@testset "spaces at point" begin
    M = Sphere(2)
    @testset "tangent and cotangent space" begin
        p = [1.0, 0.0, 0.0]
        t_p = TangentSpace(M, p)
        ct_p = CotangentSpace(M, p)
        t_ps = sprint(show, "text/plain", t_p)
        sp = sprint(show, "text/plain", p)
        sp = replace(sp, '\n' => "\n ")
        t_ps_test = "Tangent space to the manifold $(M) at point:\n $(sp)"
        @test t_ps == t_ps_test
        @test base_manifold(t_p) == M
        @test base_manifold(ct_p) == M
        @test t_p.manifold == M
        @test ct_p.manifold == M
        @test t_p.fiber_type == TangentSpaceType()
        @test ct_p.fiber_type == CotangentSpaceType()
        @test t_p.point == p
        @test ct_p.point == p
        @test injectivity_radius(t_p) == Inf
        @test representation_size(t_p) == representation_size(M)
        X = [0.0, 0.0, 1.0]
        @test embed(t_p, X) == X
        @test embed(t_p, X, X) == X
    end
end

include("../header.jl")

using RecursiveArrayTools

struct TestVectorSpaceType <: VectorSpaceType end

@testset "Vector bundle" begin
    M = Sphere(2)
    TB = TangentBundle(M)
    m_prod_retr = Manifolds.FiberBundleProductRetraction()
    m_prod_invretr = Manifolds.FiberBundleInverseProductRetraction()
    m_sasaki = SasakiRetraction(5)

    @testset "Nice access to vector bundle components" begin
        @testset "ArrayPartition" begin
            p = ArrayPartition([1.0, 0.0, 0.0], [0.0, 2.0, 4.0])
            @test p[TB, :point] === p.x[1]
            @test p[TB, :vector] === p.x[2]
            p[TB, :vector] = [0.0, 3.0, 1.0]
            @test p.x[2] == [0.0, 3.0, 1.0]
            p[TB, :point] = [0.0, 1.0, 0.0]
            @test p.x[1] == [0.0, 1.0, 0.0]
            @test_throws DomainError p[TB, :error]
            @test_throws DomainError p[TB, :error] = [1, 2, 3]

            @test view(p, TB, :point) === p.x[1]
            @test view(p, TB, :vector) === p.x[2]
            view(p, TB, :point) .= [2.0, 3.0, 5.0]
            @test p.x[1] == [2.0, 3.0, 5.0]
            view(p, TB, :vector) .= [-2.0, -3.0, -5.0]
            @test p.x[2] == [-2.0, -3.0, -5.0]
            @test_throws DomainError view(p, TB, :error)
        end
    end

    @testset "basic tests" begin
        @test injectivity_radius(TB) == 0
        @test sprint(show, TB) == "TangentBundle(Sphere(2))"
        @test base_manifold(TB) == M
        @test manifold_dimension(TB) == 2 * manifold_dimension(M)
        @test !is_flat(TB)
        @test representation_size(TB) === nothing
        @test default_inverse_retraction_method(TB) === m_prod_invretr
        @test default_retraction_method(TB) == m_prod_retr
        @test default_vector_transport_method(TB) isa
            Manifolds.FiberBundleProductVectorTransport
        CTB = CotangentBundle(M)
        @test sprint(show, CTB) == "CotangentBundle(Sphere(2))"
        @test sprint(show, FiberBundle(TestVectorSpaceType(), M)) ==
            "FiberBundle(TestVectorSpaceType(), Sphere(2), Manifolds.FiberBundleProductVectorTransport{ParallelTransport, ParallelTransport}(ParallelTransport(), ParallelTransport()))"

        @test Manifolds.fiber_dimension(M, ManifoldsBase.CotangentSpaceType()) == 2
        @test base_manifold(TangentBundle(M)) == M
    end

    types = [Vector{Float64}]

    for T in types
        p = convert(T, [1.0, 0.0, 0.0])
        TpM = TangentSpace(M, p)
        @test is_flat(TpM)

        @testset "Type $T" begin
            pts_tb = [
                ArrayPartition(convert(T, [1.0, 0.0, 0.0]), convert(T, [0.0, -1.0, -1.0])),
                ArrayPartition(convert(T, [0.0, 1.0, 0.0]), convert(T, [2.0, 0.0, 1.0])),
                ArrayPartition(convert(T, [1.0, 0.0, 0.0]), convert(T, [0.0, 2.0, -1.0])),
            ]
            for pt in pts_tb
                @test bundle_projection(TB, pt) ≈ pt.x[1]
            end
            X12_prod = inverse_retract(TB, pts_tb[1], pts_tb[2], m_prod_invretr)
            X13_prod = inverse_retract(TB, pts_tb[1], pts_tb[3], m_prod_invretr)
            basis_types = (
                DefaultOrthonormalBasis(),
                get_basis(TB, pts_tb[1], DefaultOrthonormalBasis()),
            )
            Manifolds.test_manifold(
                TB,
                pts_tb,
                default_inverse_retraction_method = m_prod_invretr,
                default_retraction_method = m_prod_retr,
                inverse_retraction_methods = [m_prod_invretr],
                retraction_methods = [m_prod_retr, m_sasaki],
                test_exp_log = false,
                test_injectivity_radius = false,
                test_tangent_vector_broadcasting = true,
                test_project_tangent = true,
                test_project_point = true,
                test_default_vector_transport = true,
                vector_transport_methods = [],
                basis_types_vecs = basis_types,
                projection_atol_multiplier = 4,
                test_inplace = true,
                test_representation_size = false,
                test_rand_point = true,
                test_rand_tvector = true,
            )

            Xir = allocate(pts_tb[1])
            inverse_retract!(TB, Xir, pts_tb[1], pts_tb[2], m_prod_invretr)
            @test isapprox(TB, pts_tb[1], Xir, X12_prod)
            F = Fiber(M, pts_tb[1][TB, :point], TangentSpaceType())
            @test isapprox(distance(F, pts_tb[1][TB, :vector], [0.0, 2.0, 3.0]), 5.0)
            Xir2 = allocate(pts_tb[1])
            vector_transport_to!(
                TB,
                Xir2,
                pts_tb[1],
                Xir,
                pts_tb[2],
                Manifolds.FiberBundleProductVectorTransport(),
            )
            @test is_vector(TB, pts_tb[2], Xir2)

            # tangent space at point
            pts_TpM = map(
                p -> convert(T, p),
                [[0.0, 0.0, 1.0], [0.0, 2.0, 0.0], [0.0, -1.0, 1.0]],
            )
            basis_types = (
                DefaultOrthonormalBasis(),
                get_basis(TpM, pts_TpM[1], DefaultOrthonormalBasis()),
            )
            @test get_basis(TpM, pts_TpM[1], basis_types[2]) === basis_types[2]
            Manifolds.test_manifold(
                TpM,
                pts_TpM,
                test_injectivity_radius = true,
                test_tangent_vector_broadcasting = true,
                test_project_tangent = true,
                test_project_point = true,
                test_default_vector_transport = true,
                basis_types_vecs = basis_types,
                projection_atol_multiplier = 4,
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
            )

            @test Manifolds.bundle_transport_to(
                TB,
                p,
                convert(T, [0.0, -1.0, -1.0]),
                convert(T, [0.0, 1.0, 0.0]),
            ) ≈ convert(T, [1.0, 0.0, -1.0])
        end
    end

    @test TangentBundle{ℝ, Sphere{ℝ, 2}} ==
        VectorBundle{ℝ, Manifolds.TangentSpaceType, Sphere{ℝ, 2}}
    @test CotangentBundle{ℝ, Sphere{ℝ, 2}} ==
        VectorBundle{ℝ, Manifolds.CotangentSpaceType, Sphere{ℝ, 2}}

    @testset "tensor product" begin
        TT = Manifolds.TensorProductType(TangentSpaceType(), TangentSpaceType())
        @test sprint(show, TT) ==
            "TensorProductType(TangentSpaceType(), TangentSpaceType())"
        @test vector_space_dimension(Sphere(2), TT) == 4
        @test vector_space_dimension(Sphere(3), TT) == 9
        @test base_manifold(Fiber(Sphere(2), [1.0, 0.0, 0.0], TT)) == M
        @test sprint(show, Fiber(Sphere(2), [1.0, 0.0, 0.0], TT)) ==
            "VectorSpaceFiber{ℝ, Sphere{ℝ, TypeParameter{Tuple{2}}}, Manifolds.TensorProductType{Tuple{TangentSpaceType, TangentSpaceType}}, Vector{Float64}}(Sphere(2), [1.0, 0.0, 0.0], TensorProductType(TangentSpaceType(), TangentSpaceType()))"
    end

    @testset "Error messages" begin
        vbf = Fiber(Euclidean(3), [1.0, 0.0, 0.0], TestVectorSpaceType())
        @test_throws MethodError inner(vbf, [1, 2, 3], [1, 2, 3], [1, 2, 3])
        @test_throws MethodError project!(vbf, [1, 2, 3], [1, 2, 3], [1, 2, 3])
        @test_throws MethodError zero_vector!(vbf, [1, 2, 3], [1, 2, 3])
        @test_throws MethodError vector_space_dimension(vbf)
    end

    @testset "product retraction and inverse retraction on tangent bundle for power and product manifolds" begin
        M = PowerManifold(Circle(ℝ), 2)
        N = TangentBundle(M)
        p1 = ArrayPartition([0.0, 0.0], [0.0, 0.0])
        p2 = ArrayPartition([-1.047, -1.047], [0.0, 0.0])
        X1 = inverse_retract(N, p1, p2, m_prod_invretr)
        @test isapprox(N, p2, retract(N, p1, X1, m_prod_retr))
        @test isapprox(N, p2, ManifoldsBase.retract_fused(N, p1, X1, 1.0, m_prod_retr))
        p3 = deepcopy(p1)
        retract!(N, p3, p1, X1, m_prod_retr)
        @test isapprox(N, p2, p3)
        ManifoldsBase.retract_fused!(N, p3, p1, X1, 1.0, m_prod_retr)
        @test isapprox(N, p2, p3)
        @test is_vector(N, p2, vector_transport_to(N, p1, X1, p2))

        M2 = ProductManifold(Circle(ℝ), Euclidean(2))
        N2 = TangentBundle(M2)
        p1_2 = ArrayPartition(
            ArrayPartition([0.0], [0.0, 0.0]),
            ArrayPartition([0.0], [0.0, 0.0]),
        )
        p2_2 = ArrayPartition(
            ArrayPartition([-1.047], [1.0, 0.0]),
            ArrayPartition([-1.047], [0.0, 1.0]),
        )
        @test isapprox(
            N2,
            p2_2,
            retract(N2, p1_2, inverse_retract(N2, p1_2, p2_2, m_prod_invretr), m_prod_retr),
        )

        ppt = ParallelTransport()
        tbvt = Manifolds.FiberBundleProductVectorTransport(ppt, ppt)
        @test TangentBundle(M, tbvt).vector_transport === tbvt
        @test CotangentBundle(M, tbvt).vector_transport === tbvt
        @test TangentBundle(M, tbvt).vector_transport === tbvt
    end

    @testset "Extended flatness tests" begin
        M = TangentBundle(Euclidean(3))
        @test is_flat(M)
        @test injectivity_radius(M) == Inf
    end
end

@doc raw"""
    OrthogonalPoint <: AbstractManifoldPoint

A type to represent points on a manifold [`Flag`](@ref) in the orthogonal coordinates
representation, i.e. a rotation matrix.
"""
struct OrthogonalPoint{T <: AbstractMatrix} <: AbstractManifoldPoint
    value::T
end

@doc raw"""
    OrthogonalTangentVector <: AbstractTangentVector

A type to represent tangent vectors to points on a [`Flag`](@ref) manifold  in the
orthogonal coordinates representation.
"""
struct OrthogonalTangentVector{T <: AbstractMatrix} <: AbstractTangentVector
    value::T
end

ManifoldsBase.@manifold_vector_forwards OrthogonalTangentVector value
ManifoldsBase.@manifold_element_forwards OrthogonalPoint value

Base.eltype(p::OrthogonalPoint) = eltype(p.value)
Base.eltype(X::OrthogonalTangentVector) = eltype(X.value)

"""
    ZeroTuple

Internal structure for representing shape of a [`Flag`](@ref) manifold. Behaves like
a normal tuple, except at index zero returns value 0.
"""
struct ZeroTuple{TupT}
    x::TupT
end

ZeroTuple(x::Tuple) = ZeroTuple{typeof(x)}(x)

function Base.getindex(t::ZeroTuple, i::Int)
    if i == 0
        return 0
    else
        return t.x[i]
    end
end

@doc raw"""
    Flag{T,d} <: AbstractDecoratorManifold{ℝ}

Flag manifold of ``d`` subspaces of ``ℝ^N`` [YeWongLim:2021](@cite). By default the manifold uses
the Stiefel coordinates representation, embedding it in the [`Stiefel`](@ref) manifold.
The other available representation is an embedding in [`OrthogonalMatrices`](@ref).
It can be utilized using [`OrthogonalPoint`](@ref) and [`OrthogonalTangentVector`](@ref) wrappers.

Tangent space is represented in the block-skew-symmetric form.

# Constructor

    Flag(N, n1, n2, ..., nd; parameter::Symbol=:type)

Generate the manifold ``\operatorname{Flag}(n_1, n_2, ..., n_d; N)`` of subspaces
```math
𝕍_1 ⊆ 𝕍_2 ⊆ ⋯ ⊆ V_d, \quad \operatorname{dim}(𝕍_i) = n_i
```
where ``𝕍_i`` for ``i ∈ 1, 2, …, d`` are subspaces of ``ℝ^N`` of dimension
``\operatorname{dim} 𝕍_i = n_i``.

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in type. Value can either be `:field` or `:type`.
"""
struct Flag{T, dp1} <: AbstractDecoratorManifold{ℝ}
    subspace_dimensions::ZeroTuple{NTuple{dp1, Int}}
    size::T
end

function Flag(N::Int, ns::Vararg{Int, I}; parameter::Symbol = :type) where {I}
    if ns[1] <= 0
        error(
            "First dimension in the sequence ns must be strictly positive, but is $(ns[1]).",
        )
    end
    for i in 1:(length(ns) - 1)
        if ns[i] >= ns[i + 1]
            error("Sequence of dimensions must be strictly increasing, received $ns")
        end
    end
    if ns[end] >= N
        error(
            "Last dimension in sequence (given: $(ns[end])) must be strictly lower than N (given: $N).",
        )
    end
    size = wrap_type_parameter(parameter, (N,))
    return Flag{typeof(size), I + 1}(ZeroTuple(tuple(ns..., N)), size)
end

"""
    get_embedding(M::Flag)

Get the embedding of the [`Flag`](@ref) manifold `M`, i.e. the [`Stiefel`](@ref) manifold.
"""
function get_embedding(M::Flag{Tuple{Int}, dp1}) where {dp1}
    return Stiefel(M.size[1], M.subspace_dimensions[dp1 - 1]; parameter = :field)
end
function get_embedding(M::Flag{TypeParameter{Tuple{N}}, dp1}) where {N, dp1}
    return Stiefel(N, M.subspace_dimensions[dp1 - 1])
end

function ManifoldsBase.get_embedding_type(::Flag)
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    injectivity_radius(M::Flag)
    injectivity_radius(M::Flag, p)

Return the injectivity radius on the [`Flag`](@ref) `M`, which is $\frac{π}{2}$.
"""
injectivity_radius(::Flag) = π / 2
injectivity_radius(::Flag, p) = π / 2
injectivity_radius(::Flag, ::AbstractRetractionMethod) = π / 2
injectivity_radius(::Flag, p, ::AbstractRetractionMethod) = π / 2

function Base.isapprox(M::Flag, p, X, Y; atol = sqrt(max_eps(X, Y)), kwargs...)
    return isapprox(norm(M, p, X - Y), 0; atol = atol, kwargs...)
end
function Base.isapprox(M::Flag, p, q; atol = sqrt(max_eps(p, q)), kwargs...)
    X = inverse_retract(M, p, q, PolarInverseRetraction())
    return isapprox(norm(M, p, X), 0; atol = atol, kwargs...)
end

@doc raw"""
    manifold_dimension(M::Flag)

Return dimension of flag manifold ``\operatorname{Flag}(n_1, n_2, ..., n_d; N)``.
The formula reads ``\sum_{i=1}^d (n_i-n_{i-1})(N-n_i)``.
"""
function manifold_dimension(M::Flag{<:Any, dp1}) where {dp1}
    N = get_parameter(M.size)[1]
    dim = 0
    for i in 1:(dp1 - 1)
        dim +=
            (M.subspace_dimensions[i] - M.subspace_dimensions[i - 1]) *
            (N - M.subspace_dimensions[i])
    end
    return dim
end

function Base.show(io::IO, M::Flag{TypeParameter{Tuple{N}}}) where {N}
    print(io, "Flag($(N)")
    for d_i in M.subspace_dimensions.x[1:(end - 1)]
        print(io, ", $d_i")
    end
    return print(io, ")")
end
function Base.show(io::IO, M::Flag{Tuple{Int}})
    N = get_parameter(M.size)[1]
    print(io, "Flag($(N)")
    for d_i in M.subspace_dimensions.x[1:(end - 1)]
        print(io, ", $d_i")
    end
    return print(io, "; parameter=:field)")
end

"""
    convert(::Type{AbstractMatrix}, M::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector)

Convert tangent vector from [`Flag`](@ref) manifold `M` from orthogonal representation to
Stiefel representation.
"""
function convert(
        ::Type{AbstractMatrix},
        M::Flag,
        p::OrthogonalPoint,
        X::OrthogonalTangentVector,
    )
    (N, k) = representation_size(M)
    return p.value * X.value[:, 1:k]
end

"""
    convert(::Type{OrthogonalTangentVector}, M::Flag, p::AbstractMatrix, X::AbstractMatrix)

Convert tangent vector from [`Flag`](@ref) manifold `M` from Stiefel representation to
orthogonal representation.
"""
function convert(
        ::Type{OrthogonalTangentVector},
        M::Flag,
        p::AbstractMatrix,
        X::AbstractMatrix,
    )
    (N, k) = representation_size(M)
    out = similar(X, N, N)
    fill!(out, 0)

    p_ortho = convert(OrthogonalPoint, M, p)
    pX = p_ortho.value' * X

    out[:, 1:k] = pX
    out[1:k, (k + 1):N] = -transpose(view(pX, (k + 1):N, 1:k))

    return OrthogonalTangentVector(out)
end

"""
    convert(::Type{AbstractMatrix}, M::Flag, p::OrthogonalPoint)

Convert point `p` from [`Flag`](@ref) manifold `M` from orthogonal representation to
Stiefel representation.
"""
function convert(::Type{AbstractMatrix}, M::Flag, p::OrthogonalPoint)
    (N, k) = representation_size(M)
    return p.value[:, 1:k]
end

"""
    convert(::Type{OrthogonalPoint}, M::Flag, p::AbstractMatrix)

Convert point `p` from [`Flag`](@ref) manifold `M` from Stiefel representation to
orthogonal representation.
"""
function convert(::Type{OrthogonalPoint}, M::Flag, p::AbstractMatrix)
    (N, k) = representation_size(M)
    out = similar(p, N, N)
    fill!(out, 0)
    out[:, 1:k] = p
    out[:, (k + 1):N] = nullspace(p')
    return OrthogonalPoint(out)
end

using Manifolds, Test, Random, LinearAlgebra, FiniteDifferences

@testset "Segre Manifold" begin
    # Manifolds to test
    Ms = [
        Segre(10),
        Segre(7, 2),
        Segre(7, 9, 9),
        Segre(9, 3, 6, 6),
        MetricManifold(Segre(10), WarpedMetric(1.2)),
        MetricManifold(Segre(2, 9), WarpedMetric(1.13)),
        MetricManifold(Segre(9, 6, 10), WarpedMetric(0.87)),
        MetricManifold(Segre(9, 3, 8, 10), WarpedMetric(1.4)),
    ]

    # Vs[i] is the valence of Ms[i]
    Vs = [(10,), (7, 2), (7, 9, 9), (9, 3, 6, 6), (10,), (2, 9), (9, 6, 10), (9, 3, 8, 10)]

    # n ≥ k, for same n,k X is in TpM and can be scaled by l
    unit_p(n, k) = 1 / sqrt(k) .* [ones(k)..., zeros(n - k)...]
    unit_X(n, k; l = 1.0) = l / sqrt(n - k) .* [zeros(k)..., ones(n - k)...]
    unit_c(n, k) = normalize([mod(k * i^i, 31) - 30 / 2 for i in 1:n]) # pseudo-rng

    # ps[i] is a point on Ms[i]
    ps = [
        [[0.5], unit_p(10, 4)],
        [[0.6], unit_p(7, 3), unit_p(2, 1)],
        [[0.7], unit_p(7, 3), unit_p(9, 5), unit_p(9, 4)],
        [[0.8], unit_p(9, 3), unit_p(3, 1), unit_p(6, 4), unit_p(6, 3)],
        [[0.9], unit_p(10, 4)],
        [[1.0], unit_p(2, 1), unit_p(9, 5)],
        [[1.1], unit_p(9, 3), unit_p(6, 5), unit_p(10, 4)],
        [[1.2], unit_p(9, 3), unit_p(3, 1), unit_p(8, 4), unit_p(10, 4)],
    ]

    # qs[i] is a point on Ms[i] that is connected to ps[i] by a geodesic and uses the closest representative to ps[i]
    # (tricked by only switching only one entry to zero)
    qs = [
        [[0.1], unit_p(10, 3)],
        [[0.2], unit_p(7, 2), unit_p(2, 2)],
        [[0.3], unit_p(7, 2), unit_p(9, 4), unit_p(9, 3)],
        [[0.4], unit_p(9, 3), unit_p(3, 1), unit_p(6, 3), unit_p(6, 2)],
        [[0.5], unit_p(10, 3)],
        [[0.6], unit_p(2, 2), unit_p(9, 5)],
        [[0.7], unit_p(9, 2), unit_p(6, 4), unit_p(10, 3)],
        [[0.8], unit_p(9, 2), unit_p(3, 2), unit_p(8, 3), unit_p(10, 3)],
    ]

    # Xs[i] is a tangent vector to Ms[i] at ps[i]
    Xs = [
        [[0.5], unit_X(10, 4)],
        [[0.6], unit_X(7, 3), unit_X(2, 1)],
        [[0.7], unit_X(7, 3), unit_X(9, 5), unit_X(9, 4)],
        [[0.8], unit_X(9, 3), unit_X(3, 1), unit_X(6, 4), unit_X(6, 3)],
        [[0.9], unit_X(10, 4)],
        [[1.0], unit_X(2, 1), unit_X(9, 5)],
        [[1.1], unit_X(9, 3), unit_X(6, 5), unit_X(10, 4)],
        [[1.2], unit_X(9, 3), unit_X(3, 1), unit_X(8, 4), unit_X(10, 4)],
    ]

    # Ys[i] is a tangent vector to Ms[i] at ps[i] such that exp(Ms[i], ps[i], t * vs[i]) is the closes representative to ps[i] for t in [-1, 1]
    Ys = [
        [[0.5], unit_X(10, 5)],
        [[0.6], unit_X(7, 4), unit_X(2, 1)],
        [[0.7], unit_X(7, 4), unit_X(9, 6), unit_X(9, 5)],
        [[0.8], unit_X(9, 4), unit_X(3, 1), unit_X(6, 5), unit_X(6, 4)],
        [[0.9], unit_X(10, 5)],
        [[1.0], unit_X(2, 1), unit_X(9, 6)],
        [[1.1], unit_X(9, 4), unit_X(6, 5), unit_X(10, 5)],
        [[1.2], unit_X(9, 4), unit_X(3, 1), unit_X(8, 5), unit_X(10, 5)],
    ]

    # cs[i] is coordinates for a tangent vector at ps[i]
    cs = [
        unit_c(10, 1),
        unit_c(8, 2),
        unit_c(23, 3),
        unit_c(21, 4),
        unit_c(10, 5),
        unit_c(10, 6),
        unit_c(23, 7),
        unit_c(27, 8),
    ]

    # When testing that exp(Ms[i], ps[i], t * Xs[i]) is an extremum of the length functional, we take a directional derivative along dcs[i]
    dcs = [
        unit_c(3 * 10, 9),
        unit_c(3 * 8, 10),
        unit_c(3 * 23, 11),
        unit_c(3 * 21, 12),
        unit_c(3 * 10, 13),
        unit_c(3 * 10, 14),
        unit_c(3 * 23, 15),
        unit_c(3 * 27, 16),
    ]

    for (M, V, p, q, X, Y, c, dc) in zip(Ms, Vs, ps, qs, Xs, Ys, cs, dcs)
        @testset "Manifold $M" begin
            @testset "Segre" begin
                get_manifold(::Segre{ℝ, V}) where {V} = Segre{ℝ, V}()
                get_manifold(::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}) where {V, A} =
                    Segre{ℝ, V}()
                @test Segre(V...) == get_manifold(M)
            end

            @testset "manifold_dimension" begin
                @test manifold_dimension(M) == 1 + sum(V .- 1)
            end

            @testset "is_point" begin
                @test is_point(M, p)
                @test is_point(M, q)
                @test_throws DomainError is_point(
                    M,
                    [[1.0, 0.0], p[2:end]...];
                    error = :error,
                )
                @test_throws DomainError is_point(
                    M,
                    [p[1], [1.0], p[3:end]...];
                    error = :error,
                )
                @test_throws DomainError is_point(M, [[-1.0], p[2:end]...]; error = :error)
                @test_throws DomainError is_point(M, [p[1], 2 * p[2:end]...]; error = :error)
            end

            @testset "is_vector" begin
                @test is_vector(M, p, X; error = :error)
                @test is_vector(M, p, Y; error = :error)
                @test_throws DomainError is_vector(
                    M,
                    [[1.0, 0.0], p[2:end]...],
                    X,
                    false,
                    true,
                )
                @test_throws DomainError is_vector(
                    M,
                    p,
                    [[1.0, 0.0], X[2:end]...],
                    false,
                    true,
                )
                @test_throws DomainError is_vector(M, p, p, false, true)
            end

            @testset "connected_by_geodesic" begin
                @test connected_by_geodesic(M, p, q)
            end

            Random.seed!(1)
            @testset "rand" begin
                @test is_point(M, rand(M))
                @test is_vector(M, p, rand(M, vector_at = p))
            end

            @testset "get_embedding" begin
                @test get_embedding(M) == Euclidean(prod(V))
            end

            @testset "embed!" begin
                # points
                p_ = zeros(prod(V))
                p__ = zeros(prod(V))
                embed!(M, p_, p)
                embed!(M, p__, [p[1], [-x for x in p[2:end]]...])
                @test is_point(get_embedding(M), p_)
                @test isapprox(p_, (-1)^length(V) * p__)

                # vectors
                X_ = zeros(prod(V))
                embed!(M, X_, p, X)
                @test is_vector(get_embedding(M), p_, X_)
            end

            @testset "get_coordinates" begin
                @test isapprox(X, get_vector(M, p, get_coordinates(M, p, X)))
                @test isapprox(c, get_coordinates(M, p, get_vector(M, p, c)))

                # Coordinates are ON
                @test isapprox(
                    dot(c, get_coordinates(M, p, X)),
                    inner(M, p, X, get_vector(M, p, c)),
                )
            end

            @testset "exp" begin
                # Zero vector
                p_ = exp(M, p, zeros.(size.(X)))
                @test is_point(M, p_)
                @test isapprox(p, p_; atol = 1.0e-5)

                # Tangent vector in the scaling direction
                p_ = exp(M, p, [X[1], zeros.(size.(X[2:end]))...])
                @test is_point(M, p_)
                @test isapprox([p[1] + X[1], p[2:end]...], p_; atol = 1.0e-5)

                # Generic tangent vector
                p_ = exp(M, p, X)
                @test is_point(M, p)

                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), -1.0)
                @test isapprox(geodesic_speed, -norm(M, p, X); atol = 1.0e-5)
                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), -0.811)
                @test isapprox(geodesic_speed, -norm(M, p, X); atol = 1.0e-5)
                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), -0.479)
                @test isapprox(geodesic_speed, -norm(M, p, X); atol = 1.0e-5)
                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), 0.181)
                @test isapprox(geodesic_speed, norm(M, p, X); atol = 1.0e-5)
                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), 0.703)
                @test isapprox(geodesic_speed, norm(M, p, X); atol = 1.0e-5)
                geodesic_speed =
                    central_fdm(3, 1)(t -> distance(M, p, exp(M, p, t * X)), 1.0)
                @test isapprox(geodesic_speed, norm(M, p, X); atol = 1.0e-5)

                # Geodesics are (locally) length-minizing. So let B_a be a one-parameter
                # family of curves such that B_0 is a geodesic. Then the derivative of
                # length(B_a) at a = 0 should be 0, and the second derivative should be
                # nonnegative.

                n = manifold_dimension(M)
                c0 = 0.0 * c
                c1 = 0.25 * c
                c2 = 0.5 * c
                c3 = 0.75 * c
                c4 = 1.0 * c

                function curve_length(d::Vector{Float64})
                    @assert(length(d) == 3 * n)

                    # Control points
                    d1 = d[1:n]
                    d2 = d[(n + 1):(2 * n)]
                    d3 = d[(2 * n + 1):(3 * n)]

                    # Bezier curve from 0 to v with control points y1, ..., y4
                    function b(t)
                        return (
                            (1 - t)^4 * c0 +
                                4 * t * (1 - t)^3 * (c1 + d1) +
                                6 * t^2 * (1 - t)^2 * (c2 + d2) +
                                4 * t^3 * (1 - t) * (c3 + d3) +
                                t^4 * c4
                        )
                    end

                    # Length of curve on manifold
                    ps_ = [exp(M, p, get_vector(M, p, b(t))) for t in 0.0:1.0e-3:1.0]
                    ds = [
                        distance(M, p1, p2) for
                            (p1, p2) in zip(ps_[1:(end - 1)], ps_[2:end])
                    ]
                    return sum(ds)
                end

                f = a -> curve_length(a * dc)
                @test isapprox(central_fdm(3, 1)(f, 0.0), 0.0; atol = 1.0e-5)
                @test central_fdm(3, 2)(f, 0.0) >= 0.0
            end

            @testset "log" begin
                # Same point
                X_ = log(M, p, p)
                @test is_vector(M, p, X_)
                @test isapprox(zeros.(size.(X)), X_; atol = 1.0e-5)

                # Scaled point
                X_ = log(M, p, [q[1], p[2:end]...])
                @test is_vector(M, p, X_)
                @test isapprox(X_, [q[1] - p[1], zeros.(size.(q[2:end]))...]; atol = 1.0e-5)

                # Generic tangent vector
                X_ = log(M, p, q)
                @test is_vector(M, p, X_)
            end

            @testset "norm" begin
                @test isapprox(norm(M, p, log(M, p, q)), distance(M, p, q))
            end

            @testset "sectional_curvature" begin
                # Test that sectional curvature is difference between circumference
                # and 2 pi r for small circles.

                # Orthonormalize
                X_ = X / norm(M, p, X)
                Y_ = Y - inner(M, p, X_, Y) * X_
                Y_ = Y_ / norm(M, p, Y_)

                r = 1.0e-2
                ps_ = [
                    exp(M, p, r * (cos(theta) * X_ + sin(theta) * Y_)) for
                        theta in 0.0:1.0e-3:(2 * pi)
                ]
                ds = [distance(M, p1, p2) for (p1, p2) in zip(ps_, [ps_[2:end]..., ps_[1]])]
                C = sum(ds)
                K = 3 * (2 * pi * r - C) / (pi * r^3) # https://en.wikipedia.org/wiki/Bertrand%E2%80%93Diguet%E2%80%93Puiseux_theorem

                @test isapprox(K, sectional_curvature(M, p, X, Y); rtol = 1.0e-2, atol = 1.0e-2)
            end

            @testset "riemann_tensor" begin
                @test isapprox(
                    sectional_curvature(M, p, X, Y),
                    inner(M, p, riemann_tensor(M, p, X, Y, Y), X) /
                        (inner(M, p, X, X) * inner(M, p, Y, Y) - inner(M, p, X, Y)^2),
                )
            end
        end
    end

    # Test a point that does not use the closest representative
    @testset "log" begin
        M = Ms[4]
        p = ps[4]
        q = qs[4]
        q_ = [q[1], q[2], q[3], q[4], -q[5]]
        @test is_vector(M, p, log(M, p, q_))

        M = Ms[8]
        p = ps[8]
        q = qs[8]
        q_ = [q[1], q[2], q[3], q[4], -q[5]]
        @test is_vector(M, p, log(M, p, q_))
    end

    # Test the formulas for sectional curvature stated in the docs
    @testset "sectional_curvature" begin
        M = Segre(3, 3)
        p = [[1.3], [1.0, 0.0, 0.0], [1.0, 0.0, 0.0]]
        X = [[0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 0.0]]
        Y = [[0.0], [0.0, 0.0, 1.0], [0.0, 0.0, 0.0]]
        Z = [[0.0], [0.0, 0.0, 0.0], [0.0, 1.0, 0.0]]
        V = [[1.0], [0.0, 0.0, 0.0], [0.0, 0.0, 0.0]]
        @test isapprox(0.0, sectional_curvature(M, p, X, Y))
        @test isapprox(-1 / p[1][1]^2, sectional_curvature(M, p, X, Z))
        @test isapprox(0.0, sectional_curvature(M, p, X, V))

        M = MetricManifold(Segre(3, 3, 3), WarpedMetric(1.23))
        @test isapprox((1.23^(-2) - 1) / p[1][1]^2, sectional_curvature(M, p, X, Y))
        @test isapprox(-1 / p[1][1]^2, sectional_curvature(M, p, X, Z))
        @test isapprox(0.0, sectional_curvature(M, p, X, V))
    end
end

include("../header.jl")

@testset "Elliptope" begin
    M = Elliptope(4, 2)
    @test repr(M) == "Elliptope(4, 2)"
    @test manifold_dimension(M) == 3
    @test !is_flat(M)
    @test get_embedding(M) == Euclidean(4, 2)
    @test representation_size(M) == (4, 2)
    q = [1.0 0.0; 0.0 1.0; 1 / sqrt(2) -1 / sqrt(2); 1 / sqrt(2) 1 / sqrt(2)]
    @test is_point(M, q, true; atol = 10^-15)
    @test base_manifold(M) === M
    qN = [2.0 0.0; 0.0 1.0; 1 / sqrt(2) -1 / sqrt(2); 1 / sqrt(2) 1 / sqrt(2)]
    @test_throws DomainError is_point(M, qN; error = :error)
    Y = [0.0 1.0; 1.0 0.0; 0.0 0.0; 0.0 0.0]
    @test is_vector(M, q, Y; error = :error)
    YN = [0.1 1.0; 1.0 0.1; 0.0 0.0; 0.0 0.0]
    @test_throws DomainError is_vector(M, q, YN; error = :error)
    qE = similar(q)
    embed!(M, qE, q)
    qE2 = embed(M, q)
    @test qE == q
    @test qE2 == q
    q2 = [4.0 / 5 3.0 / 5; 3.0 / 5.0 -4.0 / 5.0; 1.0 0.0; 0.0 1.0]
    q3 = [12.0 / 13.0 5.0 / 13.0; 1.0 0.0; -12.0 / 13.0 5.0 / 13.0; 0.0 1.0]
    @test is_vector(
        M,
        q2,
        vector_transport_to(M, q, Y, q2, ProjectionTransport());
        atol = 10^-15,
    )

    types = [Matrix{Float64}]

    for T in types
        pts = [convert(T, q), convert(T, q2), convert(T, q3)]
        @testset "Type $T" begin
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_project_point = true,
                test_exp_log = false,
                default_inverse_retraction_method = nothing,
                default_retraction_method = ProjectionRetraction(),
                is_tangent_atol_multiplier = 1,
                test_inplace = true,
            )
        end
    end
    @testset "field parameter" begin
        M = Elliptope(4, 2; parameter = :field)
        @test repr(M) == "Elliptope(4, 2; parameter=:field)"
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
    end
end

include("../header.jl")
using FiniteDifferences
using Manifolds: RiemannianProjectionBackend
using ManifoldDiff

@testset "SymplecticMatrices" begin
    M = SymplecticMatrices(2)
    @test metric(M) == RealSymplecticMetric()
    Metr_Sp_2 = MetricManifold(M, RealSymplecticMetric())

    p_2 = [0.0 1.0 / 2.0; -2.0 -2.0]
    X1 = [
        -0.121212 0.121212
        0.969697 -1.0
    ]
    X2 = [
        0.0 0.0
        0.0 -1.0
    ]

    Sp_6 = SymplecticMatrices(6)
    points = [
        [
            1.0 1.0 3.0 0.0 0.0 0.0
            -1.0 -2.0 -4.0 0.0 0.0 0.0
            3.0 0.0 7.0 0.0 0.0 0.0
            3.0 4.0 10.0 14.0 5.0 -6.0
            -5.0 -9.0 -19.0 7.0 2.0 -3.0
            0.0 0.0 0.0 -2.0 -1.0 1.0
        ],
        [
            0.0 0.0 0.0 -2.0 1.0 5.0
            0.0 0.0 0.0 0.0 -1.0 -2.0
            0.0 0.0 0.0 -1.0 -2.0 -3.0
            -1.0 2.0 -1.0 9.0 -4.0 -21.0
            -7.0 11.0 -5.0 -2.0 10.0 24.0
            3.0 -4.0 2.0 -2.0 -7.0 -13.0
        ],
        [
            6.0 -1.0 11.0 -10.0 8.0 6.0
            2.0 0.0 3.0 23.0 -14.0 -14.0
            -3.0 0.0 -5.0 -1.0 5.0 1.0
            0.0 0.0 0.0 0.0 -1.0 0.0
            0.0 0.0 0.0 5.0 -3.0 -3.0
            0.0 0.0 0.0 3.0 -4.0 -2.0
        ],
        [
            2.0 -1.0 5.0 -4.0 4.0 2.0
            2.0 0.0 3.0 11.0 -6.0 -6.0
            -1.0 0.0 -2.0 -4.0 7.0 3.0
            0.0 0.0 0.0 0.0 -1.0 0.0
            0.0 0.0 0.0 2.0 -1.0 -1.0
            0.0 0.0 0.0 3.0 -4.0 -2.0
        ],
    ]

    large_tr_norm_points = [
        [
            0.0 -3.0 -5.0 0.0 0.0 0.0
            -2.0 -3.0 4.0 0.0 0.0 0.0
            -3.0 -5.0 5.0 0.0 0.0 0.0
            11.0 27.0 -5.0 5.0 -2.0 1.0
            -37.0 -29.0 117.0 40.0 -15.0 9.0
            22.0 30.0 -47.0 -27.0 10.0 -6.0
        ],
        [
            0.0 0.0 0.0 7.0 -2.0 1.0
            0.0 0.0 0.0 19.0 -5.0 3.0
            0.0 0.0 0.0 -6.0 2.0 -1.0
            -1.0 1.0 8.0 -14.0 4.0 -2.0
            0.0 -1.0 -2.0 -94.0 26.0 -15.0
            -1.0 -2.0 3.0 45.0 -11.0 7.0
        ],
    ]

    @testset "Basics" begin
        @test repr(M) == "SymplecticMatrices($(2), ℝ)"
        @test_throws ArgumentError SymplecticMatrices(3)
        @test representation_size(M) == (2, 2)
        @test !is_flat(M)

        @test is_point(M, p_2)
        @test_throws DomainError is_point(M, p_2 + I; error = :error)

        @test is_vector(M, p_2, X1; atol = 1.0e-6)
        @test is_vector(M, p_2, X2; atol = 1.0e-12)
        @test is_vector(M, p_2, X1 + X2; atol = 1.0e-6)
        @test_throws DomainError is_vector(M, p_2, X1 + [0.1 0.1; -0.1 0.1]; error = :error)
    end
    @testset "Symplectic Inverse" begin
        I_2n = Array(I, 2, 2)
        @test Manifolds.symplectic_inverse_times(M, p_2, p_2) == I_2n
        @test Manifolds.symplectic_inverse_times!(M, copy(p_2), p_2, p_2) == I_2n
        @test inv(M, p_2) * p_2 == I_2n
        @test inv!(M, copy(p_2)) * p_2 == I_2n
    end
    @testset "Embedding" begin
        x = [0.0 1.0 / 2.0; -2.0 -2.0]
        y = similar(x)
        z = embed(M, x)
        @test z == x

        Y = similar(X1)
        embed!(M, Y, p_2, X1)
        @test Y == X1
    end
    @testset "Retractions and Exponential Mapping" begin
        q_exp = [
            -0.0203171 0.558648
            -1.6739 -3.19344
        ]
        @test isapprox(exp(M, p_2, X2), q_exp; atol = 1.0e-5)
        @test isapprox(retract(M, p_2, X2, ExponentialRetraction()), q_exp; atol = 1.0e-5)

        q_cay = [
            0.0 0.5
            -2.0 -3.0
        ]
        @test retract(M, p_2, X2) == q_cay
        @test retract(M, p_2, X2, CayleyRetraction()) == q_cay

        X_inv_cayley_retraction = inverse_retract(M, p_2, q_cay)
        X_inv_cayley_retraction_2 =
            inverse_retract(M, p_2, q_cay, CayleyInverseRetraction())
        @test X_inv_cayley_retraction == X_inv_cayley_retraction_2
        @test X_inv_cayley_retraction ≈ X2
    end
    @testset "Riemannian metric" begin
        X1_p_norm = 0.49259905148939337
        @test norm(M, p_2, X1) == X1_p_norm
        @test norm(M, p_2, X1) == √(inner(M, p_2, X1, X1))

        X2_p_norm = 1 / 2
        @test norm(M, p_2, X2) == X2_p_norm
        @test norm(M, p_2, X2) == √(inner(M, p_2, X2, X2))

        q_2 = retract(M, p_2, X2, ExponentialRetraction())
        approximate_p_q_geodesic_distance = 0.510564444555605
        @test isapprox(distance(M, p_2, q_2), approximate_p_q_geodesic_distance; atol = 1.0e-14)

        # Project tangent vector into (T_pSp)^{\perp}:
        Extended_Sp_2 = MetricManifold(get_embedding(M), ExtendedSymplecticMetric())
        proj_normal_X2 = Manifolds.project_normal!(Extended_Sp_2, copy(X2), p_2, X2)
        @test isapprox(proj_normal_X2, zero(X2); atol = 1.0e-16)

        # Project Project matrix A ∈ ℝ^{2×2} onto (T_pSp):
        A_2 = [5.0 -21.5; 3.14 14.9]
        A_2_proj = similar(A_2)
        project!(Extended_Sp_2, A_2_proj, p_2, A_2)
        @test is_vector(M, p_2, A_2_proj; atol = 1.0e-16)

        # Change representer of A onto T_pSp:
        @testset "Change Representer" begin
            A_2_representer = change_representer(
                MetricManifold(get_embedding(M), ExtendedSymplecticMetric()),
                EuclideanMetric(),
                p_2,
                A_2,
            )
            @test isapprox(inner(M, p_2, A_2_representer, X1), tr(A_2' * X1); atol = 1.0e-12)
            @test isapprox(inner(M, p_2, A_2_representer, X2), tr(A_2' * X2); atol = 1.0e-12)
            @test isapprox(inner(M, p_2, A_2_representer, A_2), norm(A_2)^2; atol = 1.0e-12)
        end
    end
    @testset "Generate random points/tangent vectors" begin
        M_big = SymplecticMatrices(20)
        Random.seed!(49)
        p_big = rand(M_big)
        @test is_point(M_big, p_big; error = :error, atol = 1.0e-9)
        X_big = rand(M_big; vector_at = p_big)
        @test is_vector(M_big, p_big, X_big; error = :error, atol = 1.0e-9)
    end
    @testset "test_manifold(SymplecticMatrices(6))" begin
        Manifolds.test_manifold(
            Sp_6,
            cat(points, large_tr_norm_points; dims = 1);
            retraction_methods = [CayleyRetraction(), ExponentialRetraction()],
            default_retraction_method = CayleyRetraction(),
            default_inverse_retraction_method = CayleyInverseRetraction(),
            test_inplace = true,
            is_point_atol_multiplier = 1.0e8,
            is_tangent_atol_multiplier = 1.0e6,
            retraction_atol_multiplier = 1.0e4,
            test_project_tangent = true,
            test_injectivity_radius = false,
            test_exp_log = false,
            test_representation_size = true,
        )
    end
    @testset "Gradient Computations" begin
        test_f(p) = tr(p)
        J = SymplecticElement(points[1])
        analytical_grad_f(p) = (1 / 2) * (p * J * p * J + p * p')

        p_grad = points[1]
        fd_diff = RiemannianProjectionBackend(AutoFiniteDifferences(central_fdm(5, 1)))

        @test isapprox(
            Manifolds.gradient(Sp_6, test_f, p_grad, fd_diff),
            analytical_grad_f(p_grad);
            atol = 1.0e-9,
        )
        @test isapprox(
            Manifolds.gradient(Sp_6, test_f, p_grad, fd_diff; extended_metric = false),
            analytical_grad_f(p_grad);
            atol = 1.0e-9,
        )

        grad_f_p = similar(p_grad)
        Manifolds.gradient!(Sp_6, test_f, grad_f_p, p_grad, fd_diff)
        @test isapprox(grad_f_p, analytical_grad_f(p_grad); atol = 1.0e-9)

        Manifolds.gradient!(Sp_6, test_f, grad_f_p, p_grad, fd_diff; extended_metric = false)
        @test isapprox(grad_f_p, analytical_grad_f(p_grad); atol = 1.0e-9)

        X = riemannian_gradient(Sp_6, p_grad, one(p_grad))
        X2 = similar(X)
        riemannian_gradient!(Sp_6, X2, p_grad, one(p_grad))
        @test isapprox(Sp_6, p_grad, X, X2)
    end
    @testset "SymplecticElement" begin
        @test SymplecticElement() == SymplecticElement(1)
        Sp_4 = SymplecticMatrices(4)
        pQ_1 = [
            0.0 0 -2.0 3.0
            0.0 0.0 1.0 -1.0
            -1.0 -1.0 0.0 0.0
            -3.0 -2.0 4.0 -4.0
        ]
        pQ_2 = [
            0.0 0.0 -2.0 5.0
            0.0 0.0 1.0 -2.0
            -2.0 -1.0 0.0 0.0
            -5.0 -2.0 4 -8.0
        ]
        p_odd_row = [
            0.0 0.0 -1.0 3.0
            0.0 0.0 1.0 0.0
            -2.0 -1.0 0.0 0.0
        ]
        p_odd_col = [
            0.0 -2.0 5.0
            0.0 1.0 -2.0
            -1.0 0.0 0.0
            -2.0 4.0 -8.0
        ]
        Q = SymplecticElement(pQ_1, pQ_2)
        Q2 = SymplecticElement(1.0)

        @testset "Type Basics" begin
            @test Q == Q2
            @test ndims(Q) == 2
            @test copy(Q) == Q
            @test eltype(SymplecticElement(1 // 1)) == Rational{Int64}
            @test convert(SymplecticElement{Float64}, Q) == SymplecticElement(1.0)
            @test "$Q" == "SymplecticElement{Float64}(): 1.0*[0 I; -I 0]"
            @test (
                "$(SymplecticElement(1 + 2im))" ==
                    "SymplecticElement{Complex{Int64}}(): (1 + 2im)*[0 I; -I 0]"
            )
        end

        @testset "Matrix Operations" begin
            @test -Q == SymplecticElement(-1.0)
            @test (2 * Q) * (5 / 6) == SymplecticElement(5 / 3)

            @testset "Powers" begin
                @test inv(Q) * Q == I
                @test (
                    inv(SymplecticElement(-4.0 + 8im)) * SymplecticElement(-4.0 + 8im) ==
                        UniformScaling(1.0 + 0.0im)
                )
                @test Q * Q == -I
                @test Q^2 == -I
                @test Q^3 == -Q
                @test Q^4 == I
            end
            @testset "Addition (subtraction)" begin
                @test Q + Q == 2 * Q
                @test Q - SymplecticElement(1.0) == SymplecticElement(0.0)
                @test Q + pQ_1 == [
                    0.0 0.0 -1.0 3.0
                    0.0 0.0 1.0 0.0
                    -2.0 -1.0 0.0 0.0
                    -3.0 -3.0 4.0 -4.0
                ]
                @test Q - pQ_1 == [
                    0.0 0.0 3.0 -3.0
                    0.0 0.0 -1.0 2.0
                    0.0 1.0 0.0 0.0
                    3.0 1.0 -4.0 4.0
                ]
                @test pQ_1 - Q == [
                    0.0 0.0 -3.0 3.0
                    0.0 0.0 1.0 -2.0
                    0.0 -1.0 0.0 0.0
                    -3.0 -1.0 4.0 -4.0
                ]
                @test (pQ_1 + Q) == (Q + pQ_1)

                @test_throws ArgumentError Q + p_odd_row
            end
            @testset "Transpose-Adjoint" begin
                @test Q' == SymplecticElement(-1.0)
                @test transpose(SymplecticElement(10.0)) == SymplecticElement(-10.0)
                @test transpose(SymplecticElement(1 - 2.0im)) ==
                    SymplecticElement(-1 + 2.0im)
                @test adjoint(Q) == -Q
                @test adjoint(SymplecticElement(1 - 2.0im)) == SymplecticElement(-1 - 2.0im)
                @test adjoint(SymplecticElement(-1im)) == SymplecticElement(-1im)
                @test adjoint(SymplecticElement(2.0)) == SymplecticElement(-2.0)
            end
            @testset "Inplace mul!" begin
                z1 = [1 + 2im; 1 - 2im]
                @test lmul!(Q, copy(z1)) == Q * z1
                @test lmul!(Q, copy(p_odd_col)) == [
                    -1 0 0.0
                    -2 4 -8.0
                    0 2 -5.0
                    0 -1 2.0
                ]
                @test_throws ArgumentError lmul!(Q, copy(p_odd_row))

                @test rmul!(copy(z1'), Q) == z1' * Q
                @test rmul!(copy(p_odd_row), Q) == [
                    1 -3 0 0.0
                    -1 0 0 0.0
                    0 0 -2 -1.0
                ]
                @test_throws ArgumentError rmul!(copy(p_odd_col), Q)

                z1_copy = copy(z1)
                mul!(z1_copy, Q, z1)
                @test z1_copy == Q * z1

                @test_throws ArgumentError mul!(copy(p_odd_row), Q, p_odd_row)
                @test_throws ArgumentError mul!(copy(p_odd_row), p_odd_col, Q)

                @test_throws ArgumentError Q * p_odd_row
                @test_throws ArgumentError p_odd_col * Q

                mul!(z1_copy', z1', Q)
                @test z1_copy' == (z1' * Q)
            end
        end

        @testset "Symplectic Inverse Ops." begin
            @test ((Q' * pQ_1' * Q) * pQ_1 - I) == zeros(eltype(pQ_1), size(pQ_1)...)
        end
    end
    @testset "Symplectic inverse" begin
        M = SymplecticMatrices(4)
        p = [1.0 0.0 2.0 0.0; 0.0 1.0 0.0 2.0; 0.0 0.0 1.0 0.0; 0.0 0.0 0.0 1.0]
        @test is_point(M, p; error = :error)
        q = inv(M, p)
        @test is_point(M, q; error = :error)
        q2 = Manifolds.symplectic_inverse(p)
        @test q2 == q
        q3 = copy(M, p)
        inv!(M, q3)
        @test q3 == q
    end
    @testset "field parameter" begin
        M = SymplecticMatrices(2; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "SymplecticMatrices(2, ℝ; parameter=:field)"
    end
end

include("../header.jl")

@testset "Symmetric Positive Semidefinite Matrices of Fixed Rank" begin
    @testset "Real Matrices" begin
        M = SymmetricPositiveSemidefiniteFixedRank(4, 2)
        @test repr(M) == "SymmetricPositiveSemidefiniteFixedRank(4, 2, ℝ)"
        @test manifold_dimension(M) == 7
        @test !is_flat(M)
        q = [1.0 0.0; 0.0 1.0; 0.0 0.0; 0.0 0.0]
        @test is_point(M, q)
        Y = [1.0 0.0; 0.0 0.0; 0.0 0.0; 0.0 0.0]
        @test_throws DomainError is_point(M, Y; error = :error)
        @test is_vector(M, q, Y)
        q2 = [2.0 1.0; 0.0 0.0; 0.0 1.0; 0.0 0.0]
        q3 = [0.0 0.0; 1.0 0.0; 0.0 1.0; 0.0 0.0]
        X = log(M, q, q2)
        X3 = vector_transport_to(M, q, X, q3, ProjectionTransport())
        X3t = project(M, q3, X)
        @test is_vector(M, q3, X3)
        @test isapprox(M, q3, X3, X3t)

        types = [Matrix{Float64}]
        for T in types
            pts = [convert(T, q), convert(T, q2), convert(T, q3)]
            @testset "Type $T" begin
                Manifolds.test_manifold(
                    M,
                    pts,
                    exp_log_atol_multiplier = 5,
                    is_tangent_atol_multiplier = 5,
                    test_project_tangent = true,
                    test_inplace = true,
                    test_injectivity_radius = false,
                )
            end
        end
    end
    @testset "Complex Matrices" begin
        M = SymmetricPositiveSemidefiniteFixedRank(4, 2, ℂ)
        @test repr(M) == "SymmetricPositiveSemidefiniteFixedRank(4, 2, ℂ)"
        @test manifold_dimension(M) == 12
    end
    @testset "field parameter" begin
        M = SymmetricPositiveSemidefiniteFixedRank(4, 2; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "SymmetricPositiveSemidefiniteFixedRank(4, 2, ℝ; parameter=:field)"
    end
end

@doc raw"""
    Segre{𝔽,V} <: AbstractManifold{𝔽}

The Segre manifold

````math
\mathcal{S} = \operatorname{Seg}(𝔽^{n_1} \times \dots \times 𝔽^{n_d})
````

is the set of rank-one tensors in ``𝔽^{n_1} \otimes \dots \otimes 𝔽^{n_d}``.

When ``𝔽 = ℝ``, the Segre manifold is a normal Riemannian covering of

````math
\mathcal{P} = ℝ^{+} \times \mathbb{S}^{n_1 - 1} \times \dots \times \mathbb{S}^{n_d - 1}
````

equipped with a [warped product metric](https://en.wikipedia.org/wiki/Warped_product). The tuple ``(n_1, \dots, n_d)`` is called the _valence_ of the manifold.

The geometry of the Segre manifold is summarized in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite). It is named after [Corrado Segre](https://en.wikipedia.org/wiki/Corrado_Segre)(1863–1924).

# Constructor
    Segre(n::Int...; field::AbstractNumbers=ℝ)

Generate a valence `(n, ...)` Segre manifold.
`Segre(n)` is the same as ``\mathbb{R}^{n} \setminus \{ 0 \}``.
"""
struct Segre{𝔽, V} <: AbstractManifold{𝔽} end

function Segre(n::Int...; field::AbstractNumbers = ℝ)
    return Segre{field, (n...,)}()
end

function check_size(M::Segre{𝔽, V}, p) where {𝔽, V}
    p_size = only.(size.(p))
    M_size = [1, V...]

    if p_size != M_size
        return DomainError(
            p_size,
            "The point $(p) can not belong to the manifold $(M), since its size $(p_size) is not equal to the manifolds representation size ($(M_size)).",
        )
    end

    return nothing
end

function check_size(M::Segre{𝔽, V}, p, X) where {𝔽, V}
    p_size = only.(size.(p))
    X_size = only.(size.(X))
    M_size = [1, V...]

    if p_size != M_size
        return DomainError(
            p_size,
            "The point $(p) can not belong to the manifold $(M), since its size $(p_size) is not equal to the manifolds representation size ($(M_size)).",
        )
    end

    if X_size != M_size
        return DomainError(
            X_size,
            "The vector $(X) can not belong to the manifold $(M), since its size $(X_size) is not equal to the manifolds representation size ($(M_size)).",
        )
    end

    return nothing
end

@doc raw"""
    closest_representative!(M::Segre{ℝ, V}, p, q)

``\mathcal{S}`` is a ``2^d``-sheeted Riemannian covering of

````math
\mathcal{P} = ℝ^{+} \times \mathbb{S}^{n_1 - 1} \times \dots \times \mathbb{S}^{n_d - 1}
````

with a warped product metric.
Every equivalence class ``q \in \mathcal{S}`` has ``2^d`` representatives in ``\mathcal{P}``.
`closest_representative!(M, q, p)` changes representative of `q` to the one that is closest to `p` in ``\mathcal{P}``.
"""
function closest_representative!(M::Segre{ℝ, V}, q, p) where {V}

    # Find closest representation by flipping an even number of signs.
    ds = [distance(Sphere(n - 1), x, y) for (n, x, y) in zip(V, p[2:end], q[2:end])]
    flips = [false, (ds .> (pi / 2))...]
    nbr_flips = sum(flips)

    # This code is pretty ugly.
    if isodd(nbr_flips)
        if nbr_flips == length(V)
            flips[argmin(ds) + 1] = false
        else
            is = sortperm(ds; rev = true)

            flips1 = deepcopy(flips)
            flips1[is[nbr_flips] + 1] = false
            q1 = deepcopy(q)
            q1[flips1] = -q1[flips1]

            flips2 = deepcopy(flips)
            flips2[is[nbr_flips + 1] + 1] = true
            q2 = deepcopy(q)
            q2[flips2] = -q2[flips2]

            spherical_angle_sum(M, p, q1) < spherical_angle_sum(M, p, q2) ? flips = flips1 :
                flips = flips2
        end
    end

    return q[flips] = -q[flips]
end

@doc raw"""
    connected_by_geodesic(M::Segre{ℝ, V}, p, q)

``\mathcal{S}`` is not a complete manifold, i.e. not every pair `p` and `q` of points are connected by a geodesic in ``\mathcal{S}``.
`connected_by_geodesic(M, p, q)` returns `true` if two points, `p` and `q`, are connected by a geodesic, and otherwise returns `false`.
"""
function connected_by_geodesic(M::Segre{ℝ, V}, p, q) where {V}
    closest_representative!(M, q, p)
    return spherical_angle_sum(M, p, q) < pi
end

@doc raw"""
    embed(M::Segre{𝔽, V}, p)
    embed!(M::Segre{𝔽, V}, q, p)

Embed ``p ≐ (λ, x_1, …, x_d)`` in ``𝔽^{n_1 ×⋯× n_d}`` using the Kronecker product

````math
(λ, x_1, …, x_d) ↦ λ x_1 ⊗⋯⊗ x_d.
````
"""
embed(::Segre, p)

function embed!(M::Segre, q, p)
    return q = kron(p...)
end

@doc raw"""
    embed!(M::Segre{𝔽, V}, p, X)

Embed tangent vector ``X = (ν, u_1, …, u_d)`` at ``p ≐ (λ, x_1, …, x_d)`` in ``𝔽^{n_1 ×⋯× n_d}`` using the Kronecker product

````math
    (ν, u_1, …, u_d) ↦ ν x_1 ⊗⋯⊗ x_d + λ u_1 ⊗ x_2 ⊗⋯⊗ x_d + … + λ x_1 ⊗⋯⊗ x_{d - 1} ⊗ u_d.
````
"""
function embed!(::Segre{𝔽, V}, u, p, X) where {𝔽, V}
    # Product rule
    return u = sum(
        [
            kron([i == j ? xdot : x for (j, (x, xdot)) in enumerate(zip(p, X))]...) for
                (i, _) in enumerate(p)
        ]
    )
end

"""
    is_point(M::Segre{ℝ, V}, p; kwargs...)

Check whether `p` is a valid point on `M`, i.e. `p[1]` is a singleton containing a positive number and `p[i + 1]` is a point on `Sphere(V[i])`.
The tolerance can be set using the `kwargs...`.
"""
is_point(M::Segre{ℝ, V}, p; kwargs...) where {V}

function check_point(M::Segre{ℝ, V}, p; atol = 1.4901161193847656e-8, kwargs...) where {V}
    if p[1][1] <= 0.0
        return DomainError(p[1][1], "$(p) has non-positive modulus.")
    end

    for (x, n) in zip(p[2:end], V)
        e = check_point(Sphere(n - 1)::AbstractSphere, x; atol = atol, kwargs...)
        if !isnothing(e)
            return e
        end
    end
    return
end

"""
    is_vector(M::Segre{ℝ, V}, p, X, kwargs...)

Check whether `X` is a tangent vector to `p` on `M`, i.e. `X` has to be of same dimension as `p` and orthogonal to `p`.
The tolerance can be set using the `kwargs...`.
"""
is_vector(M::Segre{ℝ, V}, p, v; kwargs...) where {V}

function check_vector(M::Segre{ℝ, V}, p, X; atol = 1.4901161193847656e-8, kwargs...) where {V}
    for (x, xdot, n) in zip(p[2:end], X[2:end], V)
        e = check_vector(Sphere(n - 1)::AbstractSphere, x, xdot; atol = atol, kwargs...)
        if !isnothing(e)
            return e
        end
    end
    return
end

@doc raw"""
    distance(M::Segre{ℝ, V}, p, q)

Riemannian distance between two points `p` and `q` on the Segre manifold.

Assume ``p ≐ (λ, x_1, …, x_d)``, ``q ≐ (μ, y_1, …, y_d) ∈ \mathcal{S}`` are connected by a geodesic. Let

````math
    m = \sqrt{\sphericalangle(x_1, y_1)^2 + … + \sphericalangle(x_d, y_d)^2}
````

and assume ``(μ, y_1, …, y_d)`` is the representation of ``q`` that minimizes ``m``. Then

````math
    \operatorname{dist}_{\mathcal{S}}(p, q) = \sqrt{λ^2 - 2 λμ\cos(m) + μ^2}.
````
"""
function distance(M::Segre{ℝ, V}, p, q) where {V}
    closest_representative!(M, q, p)
    m = spherical_angle_sum(M, p, q)
    return sqrt((p[1][1] - q[1][1])^2 + 4 * p[1][1] * q[1][1] * sin(m / 2)^2)
    # Equivalent to sqrt(p[1][1]^2 + q[1][1]^2 - 2 * p[1][1] * q[1][1] * cos(m)) but more stable for small m
end

@doc raw"""
    exp(M::Segre{ℝ, V}, p, X)

Exponential map on the Segre manifold.

Let ``p ≐ (λ, x_1, …, x_d) ∈ \mathcal{S}`` and ``X = (ν, u_1, …, u_d) ∈ T_p \mathcal{S}``.
The exponential map is given by

````math
    \operatorname{exp}_p(X) ≐
    \left(
        \sqrt{(λ + ν)^2 + (λ m)^2},\\
        x_1 \cos\mathopen{\Big(} \frac{f \lVert u_1 \rVert_{x_1}}{m} \mathclose{\Big)} + \frac{u_1}{\lVert u_1 \rVert_{x_1}} \sin\mathopen{\Big(} \frac{f \lVert u_1 \rVert_{x_1}}{m} \mathclose{\Big)},\\
        …,\\
        x_d \cos\mathopen{\Big(} \frac{f \lVert u_d \rVert_{x_d}}{m} \mathclose{\Big)} + \frac{u_d}{\lVert u_d \rVert_{x_d}} \sin\mathopen{\Big(} \frac{f \lVert u_d \rVert_{x_d}}{m} \mathclose{\Big)}
    \right),
````

where

````math
    \begin{aligned}
        f &= \frac{\pi}{2} - \tan^{-1}\mathopen{\Big(} \frac{λ + ν}{λ m} \mathclose{\Big)},\\
        m &= \sqrt{\lVert u_1 \rVert_{x_1}^2 + … + \lVert u_d \rVert_{x_d}^2}.
    \end{aligned}
````

If ``m = 0`` and ``-λ < ν``, then ``\operatorname{exp}_p(v) = p + X``.

The formula is derived in proposition 3.1 in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite).
"""
exp(M::Segre{ℝ, V}, p, X) where {V}

function exp!(::Segre{ℝ, V}, q, p, X) where {V}
    m = sqrt(
        sum(
            [
                norm(Sphere(n - 1), x, xdot)^2 for (n, x, xdot) in zip(V, p[2:end], X[2:end])
            ]
        ),
    )

    q[1][1] = sqrt((p[1][1] + X[1][1])^2 + (p[1][1] * m)^2)

    f = pi / 2 - atan((p[1][1] + X[1][1]) / (p[1][1] * m))
    if m == 0
        for (x, y) in zip(p[2:end], q[2:end])
            y .= x
        end
    else
        for (n, x, y, xdot) in zip(V, p[2:end], q[2:end], X[2:end])
            a = norm(Sphere(n - 1), x, xdot)
            y .= x * cos(a * f / m) .+ xdot * (f / m) * sinc(a * f / (m * pi))
        end
    end

    return q
end

@doc raw"""
    get_coordinates(M::Segre{𝔽, V}, p, X, ::DefaultOrthonormalBasis; kwargs...)

Get coordinates of `X` in the tangent space
``T_{(λ, x_1, …, x_d)} \mathcal{S} = \mathbb{R} × T_{x_1} \mathbb{S}^{n_1 - 1} ×…× T_{x_d} \mathbb{S}^{n_d - 1}``
using a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`) on each factor.
"""
get_coordinates(M::Segre, p, X, ::DefaultOrthonormalBasis; kwargs...)

function get_coordinates_orthonormal!(
        M::Segre{ℝ, V},
        c,
        p,
        X,
        ::RealNumbers;
        kwargs...,
    ) where {V}
    return c = vcat(
        X[1],
        p[1][1] * [
            get_coordinates(Sphere(n - 1), x, xdot, DefaultOrthonormalBasis(); kwargs...) for (n, x, xdot) in zip(V, p[2:end], X[2:end])
        ]...,
    )
end

@doc raw"""
    get_embedding(M::Segre{𝔽,V})

Return the embedding of the [`Segre`](@ref) manifold ``\mathcal{S}``, which is ``𝔽^{n_1 ×⋯× n_d}``.
"""
function get_embedding(::Segre{𝔽, V}) where {𝔽, V}
    return Euclidean(prod(V))
end

@doc raw"""
    get_vector( M::Segre{𝔽, V}, p, c, DefaultOrthonormalBasis; kwargs...)

Get tangent vector `X` from coordinates in the tangent space
``T_{(λ, x_1, …, x_d)} \mathcal{S} = \mathbb{R} × T_{x_1} \mathbb{S}^{n_1 - 1} ×⋯× T_{x_d} \mathbb{S}^{n_d - 1}``
using a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`) on each factor.
"""
get_vector(M::Segre, p, c, ::DefaultOrthonormalBasis; kwargs...)

function get_vector_orthonormal!(M::Segre{ℝ, V}, X, p, c, ::RealNumbers; kwargs...) where {V}
    c_ = deepcopy(c)
    X[1] = [c_[1]]
    c_ = c_[2:end]
    for (i, n) in enumerate(V)
        X[i + 1] =
            get_vector(
            Sphere(n - 1),
            p[i + 1],
            c_[1:(n - 1)],
            DefaultOrthonormalBasis();
            kwargs...,
        ) / p[1][1]
        c_ = c_[n:end]
    end
    return X
end

@doc raw"""
    inner(M::Segre{ℝ, V}, p, X, Y,)

Inner product between two tangent vectors ``X = (ν, u_1, …, u_d)`` and ``Y = (ξ, v_1, …, v_d)`` at ``p ≐ (λ, x_1, \dots, x_d)``.
This inner product is obtained by embedding the Segre manifold in the space of tensors equipped with the Euclidean metric:

````math
    \langle X, Y \rangle_{p} = \nu \xi + \lambda^2 (\langle u_1, v_1 \rangle_{x_1} + \dots + \langle u_d, v_d \rangle_{x_d}),
````

where ``ν, ξ ∈ T_{λ} ℝ^{+} = ℝ`` and ``u_i``, ``v_i ∈ T_{x_i} \mathbb{S}^{n_i - 1} ⊂ ℝ^{n_i}``.
"""
function inner(::Segre{ℝ}, p, X, Y)
    return X[1][1] * Y[1][1] + p[1][1]^2 * dot(X[2:end], Y[2:end])
end

@doc raw"""
    log(M::Segre{ℝ, V}, p, q)

Logarithmic map on the Segre manifold.

Let ``p ≐ (λ, x_1, …, x_d)``, ``q ≐ (μ, y_1, …, y_d) ∈ \mathcal{S}``.
Assume ``p`` and ``q`` are connected by a geodesic.

Let

````math
    m = \sqrt{\sphericalangle(x_1, y_1)^2 + … + \sphericalangle(x_d, y_d)^2}
````

and assume ``(μ, y_1, …, y_d)`` is the representative of ``q`` that minimizes ``m``. Then

````math
    \operatorname{log}_p(q) =
    \left(
        \mu \cos{m} - \lambda,
        (y_1 - ⟨x_1, y_1⟩ x_1) \frac{\mu \sphericalangle(x_1, y_1) \sin{m}}{\lambda m \sin{\sphericalangle(x_1, y_1)}},
        \dots,
        (y_d - ⟨x_d, y_d⟩ x_d) \frac{\mu \sphericalangle(x_d, y_d) \sin{m}}{\lambda m \sin{\sphericalangle(x_d, y_d)}}
    \right).
````

The formula is derived in theorem 4.4 in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite).
"""
log(M::Segre{ℝ, V}, p, q) where {V}

function log!(M::Segre{ℝ, V}, X, p, q) where {V}
    closest_representative!(M, q, p)
    m = spherical_angle_sum(M, p, q)

    X[1][1] = q[1][1] * cos(m) - p[1][1]
    for (n, xdot, x, y) in zip(V, X[2:end], p[2:end], q[2:end])
        a = distance(Sphere(n - 1), x, y)
        xdot .= (y - dot(x, y) * x) * (q[1][1] / p[1][1]) * sinc(m / pi) / sinc(a / pi)
    end

    return X
end

manifold_dimension(::Segre{𝔽, V}) where {𝔽, V} = (1 + sum(V .- 1))

@doc raw"""
    spherical_angle_sum(M::Segre{ℝ, V}, p, q)

Let ``p ≐ (λ, x_1, …, x_d)``, ``q ≐ (μ, y_1, …, y_d) ∈ \mathcal{S}``.
Then this is

````math
    \sqrt{\sphericalangle(x_1, y_1)^2 + … + \sphericalangle(x_d, y_d)^2},
````

where ``\sphericalangle(x_i, y_i)`` is the distance between ``x_i`` and ``y_i`` on the sphere ``\mathbb{S}^{n_i - 1}``.

"""
function spherical_angle_sum(::Segre{ℝ, V}, p, q) where {V}
    return sqrt(
        sum([distance(Sphere(n - 1), x, y)^2 for (n, x, y) in zip(V, p[2:end], q[2:end])]),
    )
end

@doc raw"""
    rand(M::Segre{ℝ, V}; vector_at=nothing)

If `vector_at` is `nothing`, return a random point on

````math
    ℝ^{+} × \mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}
````

from a log-normal distribution on ``ℝ^{+}`` and a uniform distribution on ``\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}``.

If `vector_at` is not `nothing`, return a random tangent vector from a normal distribution on the tangent space.
"""
Base.rand(M::Segre{ℝ, V}; vector_at = nothing, kwargs...) where {V}

function rand!(M::Segre{ℝ, V}, pX; vector_at = nothing, kwargs...) where {V}
    if isnothing(vector_at)
        rand!(PositiveArrays(1), pX[1]; kwargs...)
        for (n, x) in zip(V, pX[2:end])
            rand!(Sphere(n - 1), x; kwargs...)
        end
        return pX
    else
        p = vector_at
        rand!(PositiveArrays(1), pX[1]; vector_at = p[1], kwargs...)
        for (n, xdot, x) in zip(V, pX[2:end], p[2:end])
            rand!(Sphere(n - 1), xdot; vector_at = x, kwargs...)
        end
        return pX
    end
end

function ManifoldsBase.allocate_result(::Segre{ℝ, V}, ::typeof(rand)) where {V}
    return [zeros(1), [zeros(n) for n in V]...]
end

@doc raw"""
    riemann_tensor(M::Segre{ℝ, V}, p, X, Y, Z)

Riemann tensor of the Segre manifold at ``p``.

``\mathcal{S}`` is locally a warped product of ``ℝ^{+}`` and ``\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}``.
If ``p ≐ (λ, x_1, …, x_d) ∈ \mathcal{S}`` and ``X``, ``Y``, ``Z ∈ T_p (\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}) ⊂ T_p \mathcal{S}``, then

````math
    R_{\mathcal{S}}(X, Y) Z = R_{\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}}(X, Y) Z + λ^{-2}(⟨X, Z⟩_p Y - ⟨Y, Z⟩_p X).
````

``R_{\mathcal{S}}`` is zero in the remaining (orthogonal) directions.
"""
function riemann_tensor(M::Segre{ℝ, V}, p, X, Y, Z) where {V}
    return [
        [0.0],
        [
            riemann_tensor(Sphere(n - 1), x, xdot1, xdot2, xdot3) for
                (n, x, xdot1, xdot2, xdot3) in zip(V, p[2:end], X[2:end], Y[2:end], Z[2:end])
        ]...,
    ] +
        (1 / p[1][1]^2) * (
        inner(M, p, [[0.0], X[2:end]...], [[0.0], Z[2:end]...]) * [[0.0], Y[2:end]...] -
            inner(M, p, [[0.0], Y[2:end]...], [[0.0], Z[2:end]...]) * [[0.0], X[2:end]...]
    )
end

@doc raw"""
    sectional_curvature(M::Segre{ℝ, V}, p, u, v)

Sectional curvature of the Segre manifold at ``p``.

``\mathcal{S}`` is locally a warped product of ``ℝ^{+}`` and ``\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}``
If ``p ≐ (λ, x_1, …, x_d) ∈ \mathcal{S}``, ``u_i ∈ T_{x_i} \mathbb{S}^{n_i - 1}``, and ``v_j ∈ T_{x_j} \mathbb{S}^{n_j - 1}``, then

````math
    K_{\mathcal{S}}(u_i, v_j) = \frac{\delta_{i j} - 1}{\lambda^2}.
````

``K_{\mathcal{S}}`` is zero in the remaining (orthogonal) directions.
"""
function sectional_curvature(M::Segre{ℝ, V}, p, X, Y) where {V}
    return inner(M, p, riemann_tensor(M, p, X, Y, Y), X) /
        (inner(M, p, X, X) * inner(M, p, Y, Y) - inner(M, p, X, Y)^2)
end

function Base.show(io::IO, ::Segre{𝔽, V}) where {𝔽, V}
    return print(io, "Segre($(join(V, ", ")); field=$(𝔽))")
end

@doc raw"""
    KendallsPreShapeSpace{T} <: AbstractSphere{ℝ}

Kendall's pre-shape space of ``k`` landmarks in ``ℝ^n`` represented by n×k matrices.
In each row the sum of elements of a matrix is equal to 0. The Frobenius norm of the matrix
is equal to 1 [Kendall:1984](@cite)[Kendall:1989](@cite).

The space can be interpreted as tuples of ``k`` points in ``ℝ^n`` up to simultaneous
translation and scaling of all points, so this can be thought of as a quotient manifold.

# Constructor

    KendallsPreShapeSpace(n::Int, k::Int; parameter::Symbol=:type)

# See also
[`KendallsShapeSpace`](@ref), esp. for the references
"""
struct KendallsPreShapeSpace{T} <: AbstractSphere{ℝ}
    size::T
end

function KendallsPreShapeSpace(n::Int, k::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return KendallsPreShapeSpace{typeof(size)}(size)
end

representation_size(M::KendallsPreShapeSpace) = get_parameter(M.size)

"""
    check_point(M::KendallsPreShapeSpace, p; atol=sqrt(max_eps(X, Y)), kwargs...)

Check whether `p` is a valid point on [`KendallsPreShapeSpace`](@ref), i.e. whether
each row has zero mean. Other conditions are checked via embedding in [`ArraySphere`](@ref).
"""
function check_point(
        M::KendallsPreShapeSpace,
        p;
        atol::Real = sqrt(eps(float(eltype(p)))),
        kwargs...,
    )
    for p_row in eachrow(p)
        if !isapprox(mean(p_row), 0; atol = atol, kwargs...)
            return DomainError(
                mean(p_row),
                "The point $(p) does not lie on the $(M) since one of the rows does not have zero mean.",
            )
        end
    end
    return nothing
end

"""
    check_vector(M::KendallsPreShapeSpace, p, X; kwargs... )

Check whether `X` is a valid tangent vector on [`KendallsPreShapeSpace`](@ref), i.e. whether
each row has zero mean. Other conditions are checked via embedding in [`ArraySphere`](@ref).
"""
function check_vector(
        M::KendallsPreShapeSpace,
        p,
        X;
        atol::Real = sqrt(eps(float(eltype(X)))),
        kwargs...,
    )
    for X_row in eachrow(X)
        if !isapprox(mean(X_row), 0; atol = atol, kwargs...)
            return DomainError(
                mean(X_row),
                "The vector $(X) is not a tangent vector to $(p) on $(M), since one of the rows does not have zero mean.",
            )
        end
    end
    return nothing
end

embed(::KendallsPreShapeSpace, p) = p
embed(::KendallsPreShapeSpace, p, X) = X

"""
    get_embedding(M::KendallsPreShapeSpace)

Return the space [`KendallsPreShapeSpace`](@ref) `M` is embedded in, i.e. [`ArraySphere`](@ref)
of matrices of the same shape.
"""
get_embedding(::KendallsPreShapeSpace)

function get_embedding(::KendallsPreShapeSpace{TypeParameter{Tuple{n, k}}}) where {n, k}
    return ArraySphere(n, k)
end
function get_embedding(M::KendallsPreShapeSpace{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return ArraySphere(n, k; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::KendallsPreShapeSpace)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

@doc raw"""
    manifold_dimension(M::KendallsPreShapeSpace)

Return the dimension of the [`KendallsPreShapeSpace`](@ref) manifold `M`. The dimension is
given by ``n(k - 1) - 1``.
"""
function manifold_dimension(M::KendallsPreShapeSpace)
    n, k = get_parameter(M.size)
    return n * (k - 1) - 1
end

"""
    project(M::KendallsPreShapeSpace, p)

Project point `p` from the embedding to [`KendallsPreShapeSpace`](@ref) by selecting
the right element from the orthogonal section representing the quotient manifold `M`.
See Section 3.7 of [SrivastavaKlassen:2016](@cite) for details.

The method computes the mean of the landmarks and moves them to make their mean zero;
afterwards the Frobenius norm of the landmarks (as a matrix) is normalised to fix the scaling.
"""
project(::KendallsPreShapeSpace, p)

function project!(::KendallsPreShapeSpace, q, p)
    q .= p .- mean(p, dims = 2)
    q ./= norm(q)
    return q
end

"""
    project(M::KendallsPreShapeSpace, p, X)

Project tangent vector `X` at point `p` from the embedding to [`KendallsPreShapeSpace`](@ref)
by selecting the right element from the tangent space to orthogonal section representing the
quotient manifold `M`. See Section 3.7 of [SrivastavaKlassen:2016](@cite) for details.
"""
project(::KendallsPreShapeSpace, p, X)

function project!(::KendallsPreShapeSpace, Y, p, X)
    Y .= X .- mean(X, dims = 2)
    Y .-= dot(p, Y) .* p
    return Y
end

function Random.rand!(
        rng::AbstractRNG,
        M::KendallsPreShapeSpace,
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if vector_at === nothing
        project!(M, pX, randn(rng, representation_size(M)))
    else
        n = σ * randn(rng, size(pX)) # Gaussian in embedding
        project!(M, pX, vector_at, n) #project to TpM (keeps Gaussianness)
    end
    return pX
end

function Base.show(io::IO, ::KendallsPreShapeSpace{TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "KendallsPreShapeSpace($n, $k)")
end
function Base.show(io::IO, M::KendallsPreShapeSpace{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "KendallsPreShapeSpace($n, $k; parameter=:field)")
end

module ManifoldsOrdinaryDiffEqDiffEqCallbacksExt

using Manifolds
using Manifolds:
    IntegratorTerminatorNearChartBoundary,
    affine_connection,
    get_chart_index,
    transition_map!,
    transition_map_diff!
import Manifolds: solve_chart_exp_ode, solve_chart_parallel_transport_ode
using ManifoldsBase

using DiffEqCallbacks
using OrdinaryDiffEq: OrdinaryDiffEq, SciMLBase, Rodas5, AutoVern9, ODEProblem, solve

using RecursiveArrayTools: ArrayPartition

"""
    (int_term::IntegratorTerminatorNearChartBoundary)(u, t, integrator)

Terminate integration when integrator goes too closely to chart boundary.
Closeness is determined by `ϵ` value of [`IntegratorTerminatorNearChartBoundary`](@ref)
`int_term`.

# Arguments:

- `int_term`: object containing keyword arguments for `check_chart_switch`, such as
  the desired maximum distance to boundary,
- `u`: parameters of a point at which the integrator is solving a differential equation.
- `t`: time parameter of the integrator
- `integrator`: state of the integrator. Internal parameters are expected to contained
  the manifold on which the equation is solved, the atlas and the current chart index.
"""
function (int_term::IntegratorTerminatorNearChartBoundary)(u, t, integrator)
    (M, A, i) = integrator.p
    if check_chart_switch(M, A, i, u.x[1]; int_term.check_chart_switch_kwargs...)
        # switch charts
        OrdinaryDiffEq.terminate!(integrator)
    end
    return u
end

@doc raw"""
    StitchedChartSolution{Prob,TM<:AbstractManifold,TA<:AbstractAtlas,TChart}

Solution of an ODE on a manifold `M` in charts of an [`AbstractAtlas`](@ref) `A`.

When `StitchedChartSolution{:Exp}` is used as a function with a number `t` as an argument, a
pair `(p, X)` is returned such that $p\in \mathcal{M}$ is the point at time `t` of the
geodesic and $X \in T_p \mathcal{M}$ is the velocity of the geodesic at that point.
Similarly, `StitchedChartSolution{:PT}` called with number `t` returns a triple `(p, X, Y)`
where `(p, X)` corresponds to the geodesic along which the vector is transported
and $Y\in T_p\mathcal{M}$ is the vector transported to `p`.
"""
struct StitchedChartSolution{Prob, TM <: AbstractManifold, TA <: AbstractAtlas, TChart}
    M::TM
    A::TA
    sols::Vector{Tuple{SciMLBase.AbstractODESolution, TChart}}
end

function StitchedChartSolution(
        M::AbstractManifold, A::AbstractAtlas, problem::Symbol, TChart
    )
    return StitchedChartSolution{problem, typeof(M), typeof(A), TChart}(M, A, [])
end

function (scs::StitchedChartSolution{:Exp})(t::Real)
    if t < scs.sols[1][1].t[1]
        throw(DomainError("Time $t is outside of the solution."))
    end
    for (sol, i) in scs.sols
        if t <= sol.t[end]
            B = induced_basis(scs.M, scs.A, i)
            solt = sol(t)
            p = get_point(scs.M, scs.A, i, solt.x[1])
            X = get_vector(scs.M, p, solt.x[2], B)
            return (p, X)
        end
    end
    throw(
        DomainError(
            "Time $t is outside of the solution (solution time range is [$(scs.sols[1][1].t[1]), $(scs.sols[end][1].t[end])]).",
        ),
    )
end
function (scs::StitchedChartSolution{:PT})(t::Real)
    if t < scs.sols[1][1].t[1]
        throw(DomainError("Time $t is outside of the solution."))
    end
    for (sol, i) in scs.sols
        if t <= sol.t[end]
            B = induced_basis(scs.M, scs.A, i)
            solt = sol(t)
            p = get_point(scs.M, scs.A, i, solt.x[1])
            X = get_vector(scs.M, p, solt.x[2], B)
            Y = get_vector(scs.M, p, solt.x[3], B)
            return (p, X, Y)
        end
    end
    throw(
        DomainError(
            "Time $t is outside of the solution (solution time range is [$(scs.sols[1][1].t[1]), $(scs.sols[end][1].t[end])]).",
        ),
    )
end

function (scs::StitchedChartSolution)(t::AbstractArray)
    return map(scs, t)
end

function chart_exp_problem(u, params, t)
    M, A, i = params
    a = u.x[1]
    dx = u.x[2]
    ddx = -affine_connection(M, A, i, a, dx, dx)
    return ArrayPartition(dx, ddx)
end

"""
    solve_chart_exp_ode(
        M::AbstractManifold, a, Xc, A::AbstractAtlas, i0;
        solver=AutoVern9(Rodas5()),
        final_time::Real=1.0,
        check_chart_switch_kwargs=NamedTuple(),
        kwargs...,
    )

Solve geodesic ODE on a manifold `M` from point of coordinates `a` in chart `i0` from an
[`AbstractAtlas`](@ref) `A` in direction of coordinates `Xc` in the induced basis.
The geodesic is solved up to time `final_time` (by default equal to 1).

## Chart switching

If the solution exceeds the domain of chart `i0` (which is detected using the
`check_chart_switch` function with additional keyword arguments `check_chart_switch_kwargs`),
a new chart is selected using `get_chart_index` on the final point in the old chart.

## Returned value

The function returns an object of type `StitchedChartSolution{:Exp}` to represent the
geodesic.
"""
function solve_chart_exp_ode(
        M::AbstractManifold, a, Xc, A::AbstractAtlas, i0;
        solver = AutoVern9(Rodas5()),
        final_time::Real = 1.0,
        check_chart_switch_kwargs = NamedTuple(),
        kwargs...,
    )
    u0 = ArrayPartition(copy(a), copy(Xc))
    cur_i = i0
    # callback stops solver when we get too close to chart boundary
    cb = FunctionCallingCallback(
        IntegratorTerminatorNearChartBoundary(check_chart_switch_kwargs); func_start = false
    )
    retcode = SciMLBase.ReturnCode.Terminated
    init_time = zero(final_time)
    sols = StitchedChartSolution(M, A, :Exp, typeof(i0))
    while retcode === SciMLBase.ReturnCode.Terminated && init_time < final_time
        params = (M, A, cur_i)
        prob =
            ODEProblem(chart_exp_problem, u0, (init_time, final_time), params; callback = cb)
        sol = solve(prob, solver; kwargs...)
        retcode = sol.retcode
        init_time = sol.t[end]::typeof(final_time)
        push!(sols.sols, (sol, cur_i))
        # here we switch charts
        a_final = sol.u[end].x[1]::typeof(a)
        new_i = get_chart_index(M, A, cur_i, a_final)
        if new_i !== cur_i
            transition_map!(M, u0.x[1], A, cur_i, new_i, a_final)
            transition_map_diff!(
                M, u0.x[2], A, cur_i, a_final, sol.u[end].x[2]::typeof(Xc), new_i
            )
            cur_i = new_i
        end
    end
    return sols
end

function chart_pt_problem(u, params, t)
    M, A, i = params
    a = u.x[1]
    dx = u.x[2]
    dY = u.x[3]

    ddx = -affine_connection(M, A, i, a, dx, dx)
    ddY = -affine_connection(M, A, i, a, dx, dY)
    return ArrayPartition(dx, ddx, ddY)
end

"""
    solve_chart_parallel_transport_ode(
        M::AbstractManifold, a, Xc, A::AbstractAtlas, i0, Yc;
        solver=AutoVern9(Rodas5()), check_chart_switch_kwargs=NamedTuple(), final_time=1.0,
        kwargs...
    )

Parallel transport vector with coordinates `Yc` along geodesic on a manifold `M` from point of
coordinates `a` in a chart `i0` from an [`AbstractAtlas`](@ref) `A` in direction of
coordinates `Xc` in the induced basis.
"""
function solve_chart_parallel_transport_ode(
        M::AbstractManifold, a, Xc, A::AbstractAtlas, i0, Yc;
        solver = AutoVern9(Rodas5()), final_time = 1.0, check_chart_switch_kwargs = NamedTuple(),
        kwargs...
    )
    u0 = ArrayPartition(copy(a), copy(Xc), copy(Yc))
    cur_i = i0
    # callback stops solver when we get too close to chart boundary
    cb = FunctionCallingCallback(
        IntegratorTerminatorNearChartBoundary(check_chart_switch_kwargs); func_start = false
    )
    retcode = SciMLBase.ReturnCode.Terminated
    init_time = zero(final_time)
    sols = StitchedChartSolution(M, A, :PT, typeof(i0))
    while retcode === SciMLBase.ReturnCode.Terminated && init_time < final_time
        params = (M, A, cur_i)
        prob =
            ODEProblem(chart_pt_problem, u0, (init_time, final_time), params; callback = cb)
        sol = solve(prob, solver; kwargs...)
        retcode = sol.retcode
        init_time = sol.t[end]::typeof(final_time)
        push!(sols.sols, (sol, cur_i))
        # here we switch charts
        a_final = sol.u[end].x[1]::typeof(a)
        new_i = get_chart_index(M, A, cur_i, a_final)
        transition_map!(M, u0.x[1], A, cur_i, new_i, a_final)
        transition_map_diff!(
            M, u0.x[2], A, cur_i, a_final, sol.u[end].x[2]::typeof(Xc), new_i
        )
        transition_map_diff!(
            M, u0.x[3], A, cur_i, a_final, sol.u[end].x[3]::typeof(Yc), new_i
        )
        cur_i = new_i
    end
    return sols
end

end

using ManifoldsBase: LinearAlgebra
include("../header.jl")

@testset "Tucker" begin
    n⃗ = (4, 5, 6)
    r⃗ = (2, 3, 4)
    r⃗_small = (2, 3, 3)
    M = Tucker(n⃗, r⃗)
    M_small = Tucker(r⃗, (2, 3, 3))

    types = [Float64]

    for T in types
        @testset "Type $T" begin
            U = ntuple(d -> Matrix{T}(LinearAlgebra.I, n⃗[d], r⃗[d]), 3)
            C₁ = reshape(
                T[
                    0.0 0.0 1.0 0.0
                    1.0 1 / √2 0.0 0.0
                    1.0 -1 / √2 0.0 0.0
                    0.0 0.0 0.0 0.0
                    0.0 0.0 0.0 1.0
                    0.0 0.0 0.0 0.0
                ],
                (2, 3, 4),
            )
            C₂ = reshape(
                T[
                    0.0 0.0 -1 / √2 1 / √2
                    -1 / √2 -0.5 0.0 0.0
                    1.0 -1 / √2 0.0 0.0
                    0.0 0.0 0.0 0.0
                    0.0 0.0 1 / √2 1 / √2
                    1 / √2 0.5 0.0 0.0
                ],
                (2, 3, 4),
            )
            C₃ = reshape(
                T[
                    1 / √2 0.5 1 / √2 0.0
                    1 / √2 0.5 -1 / √2 0.0
                    1 / √2 -0.5 0.0 0.0
                    -1 / √2 0.5 0.0 0.0
                    0.0 0.0 0.0 1 / √2
                    0.0 0.0 0.0 -1 / √2
                ],
                (2, 3, 4),
            )

            p = TuckerPoint(C₁, U...)
            p_small = TuckerPoint(C₂, r⃗_small)
            p_ambient = embed(M, p)

            U⊥ = ntuple(d -> nullspace(U[d]') * Matrix{Bool}(I, n⃗[d] - r⃗[d], r⃗[d]), 3)
            v = TuckerTangentVector(reshape(collect(1.0:prod(r⃗)), r⃗), U⊥)
            U⊥ = ntuple(d -> nullspace(U[d]') * Matrix{Bool}(I, n⃗[d] - r⃗[d], r⃗[d]), 3)
            w = TuckerTangentVector(reshape((1.0:prod(r⃗)) .^ 2, r⃗), U⊥)

            norm_v = norm(M, p, v)
            @test norm(M, p, 2 * v - v * 2) ≤ √eps(T) * norm_v
            @test norm(M, p, (v / 2) - (2 \ v)) ≤ eps(T) * norm_v
            @test norm(M, p, (v / 2) - 0.5v) ≤ eps(T) * norm_v
            @test +v == v

            @test embed(M, p) ≈ reshape(kron(reverse(U)...) * vec(C₁), n⃗)
            @test embed(M, TuckerPoint(p_ambient, r⃗)) ≈ p_ambient
            @test inner(M, p, v, w) ≈ dot(embed(M, p, v), embed(M, p, w))
            @test inner(M, p, v, v) ≈ norm(M, p, v)^2
            w_ambient = embed(M, p, w)
            @test inner(M, p, v, w_ambient) ≈ inner(M, p, v, w) ≈ inner(M, p, w_ambient, v)

            @test p ≈ TuckerPoint(p_ambient, r⃗)
            @test v == TuckerTangentVector(v.Ċ, v.U̇)

            @test manifold_dimension(M) ==
                prod(r⃗) + sum(ntuple(d -> r⃗[d] * (n⃗[d] - r⃗[d]), length(r⃗)))
            @test !is_flat(M)

            @test is_point(M_small, p_small)
            @test is_point(M, p)
            @test is_point(M, embed(M, p))
            @test !is_point(M, zeros(n⃗))
            @test !is_point(M, TuckerPoint(zeros(T, r⃗), U...))
            @test !is_point(M, TuckerPoint(C₁, map(rk -> Matrix{T}(I, rk, rk), r⃗)...))
            @test !is_point(M, p_small)
            @test !is_point(M, embed(M_small, p_small))
            @test !is_point(M_small, p)
            q = allocate(p)
            copyto!(q, p)
            q.hosvd.core .= 2 * p.hosvd.core
            @test !is_point(M, q)

            u = allocate(v)
            u .= v
            @test u == v
            u = allocate(v)
            copyto!(u, v)
            @test u == v

            # broadcasting
            @test axes(v) === ()
            u = copy(v)
            # test that the copy is equal to the original, but represented by
            # a new array
            @test u.U̇ !== v.U̇
            @test u.Ċ == v.Ċ
            x = u .+ v .* 2
            @test x isa TuckerTangentVector
            @test x == v + u * 2
            x .= 2 .* u .+ v
            @test x == 2 * u + v

            @test is_vector(M, p, v)
            @test !is_vector(M, p_small, v)
            @test !is_vector(
                M,
                p,
                TuckerTangentVector(ones(T, r⃗), map(u⊥ -> u⊥[:, 1:(end - 1)], U⊥)),
            )

            ℬ = get_basis(M, p, DefaultOrthonormalBasis())
            J = convert(Matrix, ℬ)
            @test J'J ≈ LinearAlgebra.I
            vectors = get_vectors(M, p, DefaultOrthonormalBasis())
            vectors_mtx = hcat(map(ξ -> vec(embed(M, p, ξ)), vectors)...)
            @test J ≈ vectors_mtx

            shiftprint(x) = replace(sprint(show, "text/plain", x), "\n" => "\n ")

            @test sprint(show, "text/plain", M) == "Tucker((4, 5, 6), (2, 3, 4), ℝ)"
            @test sprint(show, "text/plain", p) == """
                $(summary(p))
                U factor 1:
                 $(shiftprint(p.hosvd.U[1]))\n
                U factor 2:
                 $(shiftprint(p.hosvd.U[2]))\n
                U factor 3:
                 $(shiftprint(p.hosvd.U[3]))\n
                Core:
                 $(shiftprint(p.hosvd.core))"""

            @test sprint(show, "text/plain", v) == """
                $(summary(v))
                U̇ factor 1:
                 $(shiftprint(v.U̇[1]))\n
                U̇ factor 2:
                 $(shiftprint(v.U̇[2]))\n
                U̇ factor 3:
                 $(shiftprint(v.U̇[3]))\n
                Ċ factor:
                 $(shiftprint(v.Ċ))"""

            @test sprint(show, "text/plain", ℬ) == """
                $(summary(ℬ)) ≅ $(shiftprint(J))
                """

            pts = [
                p,
                TuckerPoint(C₂, U[1][[4, 2, 1, 3], :], U[2:end]...),
                TuckerPoint(C₃, U[1][[4, 3, 1, 2], :], U[2:end]...),
            ]
            Manifolds.test_manifold(
                M,
                pts;
                is_mutating = false, # avoid allocations of the wrong type
                basis_types_to_from = (DefaultOrthonormalBasis(),),
                basis_types_vecs = (DefaultOrthonormalBasis(),),
                test_exp_log = false,
                default_inverse_retraction_method = ProjectionInverseRetraction(),
                test_injectivity_radius = false,
                default_retraction_method = PolarRetraction(),
                test_is_tangent = false,
                test_project_tangent = false,
                test_default_vector_transport = false,
                test_vector_spaces = false,
                test_tangent_vector_broadcasting = true,
                test_representation_size = false,
                projection_atol_multiplier = 15,
                retraction_methods = [PolarRetraction()],
                inverse_retraction_methods = [ProjectionInverseRetraction()],
                mid_point12 = nothing,
            )
        end
    end
    @testset "field parameter" begin
        M = Tucker(n⃗, r⃗; parameter = :field)
        @test sprint(show, "text/plain", M) ==
            "Tucker((4, 5, 6), (2, 3, 4), ℝ; parameter=:field)"
    end
end

@doc raw"""
    SPDFixedDeterminant{T,D} <: AbstractDecoratorManifold{ℝ}

The manifold of symmetric positive definite matrices of fixed determinant ``d > 0``, i.e.

````math
\mathcal P_d(n) =
\bigl\{
p ∈ ℝ^{n×n} \ \big|\ a^\mathrm{T}pa > 0 \text{ for all } a ∈ ℝ^{n}\backslash\{0\}
  \text{ and } \det(p) = d
\bigr\}.
````

This manifold is modelled as a submanifold of [`SymmetricPositiveDefinite`](@ref)`(n)`,
see [`EmbeddedSubmanifoldType`](@extref `ManifoldsBase.EmbeddedSubmanifoldType`) for the implications,
but for example retractions and inverse retractions are all available

These matrices are sometimes also called [isochoric](https://en.wiktionary.org/wiki/isochoric), which refers to the interpretation of
the matrix representing an ellipsoid. All ellipsoids that represent points on this manifold have the same volume.

The tangent space is modelled the same as for [`SymmetricPositiveDefinite`](@ref)`(n)`
and consists of all symmetric matrices with zero trace
```math
    T_p\mathcal P_d(n) =
    \bigl\{
        X \in \mathbb R^{n×n} \big|\ X=X^\mathrm{T} \text{ and } \operatorname{tr}(X) = 0
    \bigr\},
```
since for a constant determinant we require that ``0 = D\det(p)[Z] = \det(p)\operatorname{tr}(p^{-1}Z)`` for all tangent vectors ``Z``.
Additionally we store the tangent vectors as ``X=p^{-1}Z``, i.e. symmetric matrices.

# Constructor

    SPDFixedDeterminant(n::Int, d::Real=1.0; parameter::Symbol=:type)

Generate the manifold $\mathcal P_d(n) \subset \mathcal P(n)$ of determinant ``d``,
which defaults to `1.0`.

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in type. Value can either be `:field` or `:type`.
"""
struct SPDFixedDeterminant{T, TD <: Real} <: AbstractDecoratorManifold{ℝ}
    size::T
    d::TD
end

function SPDFixedDeterminant(n::Int, d::F = 1.0; parameter::Symbol = :type) where {F <: Real}
    @assert d > 0 "The determinant has to be positive but was provided as $d."
    size = wrap_type_parameter(parameter, (n,))
    return SPDFixedDeterminant{typeof(size), F}(size, d)
end

@doc raw"""
    check_point(M::SPDFixedDeterminant, p; kwargs...)

Check whether `p` is a valid manifold point on the [`SPDFixedDeterminant`](@ref)`(n,d)` `M`, i.e.
whether `p` is a [`SymmetricPositiveDefinite`](@ref) matrix of size `(n, n)`

with determinant ``\det(p) = ```M.d`.

The tolerance for the determinant of `p` can be set using `kwargs...`.
"""
function check_point(M::SPDFixedDeterminant, p; kwargs...)
    if det(p) ≉ M.d
        return DomainError(
            det(p),
            "The point $(p) does not lie on $M, since it does not have a determinant $(M.d).",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::SPDFixedDeterminant, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`SPDFixedDeterminant`](@ref) `M`,
i.e. `X` has to be a tangent vector on [`SymmetricPositiveDefinite`](@ref), so a symmetric matrix,
and additionally fulfill ``\operatorname{tr}(X) = 0``.

The tolerance for the trace check of `X` can be set using `kwargs...`, which influences the `isapprox`-check.
"""
function check_vector(
        M::SPDFixedDeterminant,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(tr(X), 0; atol = atol, kwargs...)
        return DomainError(
            tr(X),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it does not have a zero trace.",
        )
    end
    return nothing
end

embed(M::SPDFixedDeterminant, p) = copy(M, p)
embed(M::SPDFixedDeterminant, p, X) = copy(M, X)
embed!(M::SPDFixedDeterminant, q, p) = copyto!(M, q, p)
embed!(M::SPDFixedDeterminant, Y, p, X) = copyto!(M, Y, p, X)

function get_embedding(::SPDFixedDeterminant{TypeParameter{Tuple{n}}}) where {n}
    return SymmetricPositiveDefinite(n)
end
function get_embedding(M::SPDFixedDeterminant{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return SymmetricPositiveDefinite(n; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SPDFixedDeterminant)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

@doc raw"""
    manifold_dimension(M::SPDFixedDeterminant)

Return the manifold dimension of the [`SPDFixedDeterminant`](@ref) manifold `M`
which is given by

````math
\dim \mathcal P_d(n) = \frac{n(n+1)}{2} - 1.
````
"""

function manifold_dimension(M::SPDFixedDeterminant)
    return manifold_dimension(get_embedding(M)) - 1
end

@doc raw"""
    q = project(M::SPDFixedDeterminant, p)
    project!(M::SPDFixedDeterminant, q, p)

Project the symmetric positive definite (s.p.d.) matrix `p` from the embedding onto the
(sub-)manifold of s.p.d. matrices of determinant `M.d` (in place of `q`).

The formula reads

```math
q = \Bigl(\frac{d}{\det(p)}\Bigr)^{\frac{1}{n}}p
```
"""
project(M::SPDFixedDeterminant, p)

function project!(M::SPDFixedDeterminant, q, p)
    n = get_parameter(M.size)[1]
    q .= (M.d / det(p))^(1 / n) .* p
    return
end

@doc raw"""
    Y = project(M::SPDFixedDeterminant, p, X)
    project!(M::SPDFixedDeterminant, Y, p, X)

Project the symmetric matrix `X` onto the tangent space at `p` of the
(sub-)manifold of s.p.d. matrices of determinant `M.d` (in place of `Y`),
by setting its diagonal (and hence its trace) to zero.
"""
project(M::SPDFixedDeterminant, p, X)

function project!(M::SPDFixedDeterminant, Y, p, X)
    copyto!(M, Y, p, X)
    fill!(view(Y, diagind(Y)), 0)
    return Y
end

function Base.show(io::IO, M::SPDFixedDeterminant{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "SPDFixedDeterminant($n, $(M.d))")
end
function Base.show(io::IO, M::SPDFixedDeterminant{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "SPDFixedDeterminant($n, $(M.d); parameter=:field)")
end

include("../header.jl")

@testset "Essential manifold" begin
    M = EssentialManifold()
    a = π / 6
    b = π / 6
    c = π / 6
    r1 = [1.0 0.0 0.0; 0.0 cos(a) -sin(a); 0.0 sin(a) cos(a)]
    r2 = [cos(b) 0.0 sin(b); 0.0 1.0 0.0; -sin(b) 0.0 cos(b)]
    r3 = [cos(c) -sin(c) 0.0; sin(c) cos(c) 0.0; 0.0 0.0 1.0]
    nr = [1.0 0.0 0.0; 0.0 0.0 -1.0; 0.0 -1.0 0.0]
    p1 = [r1, r2]
    p2 = [r1, r3]
    p3 = [r2, r2]
    @testset "Essential manifold Basics" begin
        @test M.manifold == Rotations(3)
        @test repr(M) == "EssentialManifold(true)"
        @test manifold_dimension(M) == 5
        @test !is_flat(M)
        np1 = [r1, nr]
        np2 = [nr, nr]
        np3 = [r1, r2, r3]
        @test !is_point(M, r1)
        # first two components of r1 are not rotations
        @test_throws DomainError is_point(M, r1; error = :error)
        @test_throws DomainError is_point(M, np3; error = :error)
        @test is_point(M, p1)
        @test_throws ComponentManifoldError is_point(M, np1; error = :error)
        @test_throws CompositeManifoldError is_point(M, np2; error = :error)
        @test !is_vector(M, p1, 0.0)
        @test_throws DomainError is_vector(
            M,
            p1,
            [0.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0];
            error = :error,
        )
        @test !is_vector(M, np1, [0.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0])
        @test !is_vector(M, p1, p2)
        # projection test
        @test is_vector(M, p1, project(M, p1, log(M, p1, p2)))
        @test is_vector(M, p1, project(M, p1, log(M, p2, p1)))
    end
    @testset "Signed Essential" begin
        Manifolds.test_manifold(
            M,
            [p1, p2, p3],
            test_vector_spaces = true,
            test_project_point = true,
            projection_atol_multiplier = 10,
            test_project_tangent = false, # since it includes vert_proj.
            test_musical_isomorphisms = false,
            test_default_vector_transport = true,
            test_representation_size = false,
            test_exp_log = true,
            mid_point12 = nothing,
            exp_log_atol_multiplier = 4,
            test_inplace = true,
            parallel_transport = true,
        )
    end
    @testset "Unsigned Essential" begin
        Manifolds.test_manifold(
            EssentialManifold(false),
            [p1, p2, p3],
            test_vector_spaces = true,
            test_project_point = true,
            projection_atol_multiplier = 10,
            test_project_tangent = false, # since it includes vert_proj.
            test_musical_isomorphisms = false,
            test_default_vector_transport = true,
            test_representation_size = false,
            test_exp_log = true,
            mid_point12 = nothing,
            exp_log_atol_multiplier = 4,
            parallel_transport = true,
        )
    end
end

include("../header.jl")

@testset "SphereSymmetricMatrices" begin
    M = SphereSymmetricMatrices(3)
    M_complex = SphereSymmetricMatrices(3, ℂ)
    A = [1 2 3; 2 4 -5; 3 -5 6] / norm([1 2 3; 2 4 -5; 3 -5 6])
    B = [1 2; 2 4] / norm([1 2; 2 4])                                     #wrong dimensions
    C = [-3 -im 4; im 5 im; 4 -im 0] / norm([-3 -im 4; im 5 im; 4 -im 0]) #complex
    D = [1 2 3; 4 5 6; 7 8 9] / norm([1 2 3; 4 5 6; 7 8 9])               #not symmetric
    E = [1 2 3; 2 4 -5; 3 -5 6]                                           #not of unit norm
    J = [1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0]
    K = [0.0 1.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0]
    @testset "Real Sphere Symmetric Matrices Basics" begin
        @test repr(M) == "SphereSymmetricMatrices(3, ℝ)"
        @test representation_size(M) == (3, 3)
        @test base_manifold(M) === M
        @test !is_flat(M)
        @test typeof(get_embedding(M)) === ArraySphere{ℝ, TypeParameter{Tuple{3, 3}}}
        @test check_point(M, A) === nothing
        @test_throws ManifoldDomainError is_point(M, B; error = :error)
        @test_throws ManifoldDomainError is_point(M, C; error = :error)
        @test_throws DomainError is_point(M, D; error = :error)
        @test_throws ManifoldDomainError is_point(M, E; error = :error)
        @test check_vector(M, A, zeros(3, 3)) === nothing
        @test_throws ManifoldDomainError is_vector(M, A, B; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, C; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, D; error = :error)
        @test_throws ManifoldDomainError is_vector(M, D, A; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, E; error = :error)
        @test_throws DomainError is_vector(M, J, K; error = :error)
        @test manifold_dimension(M) == 5
        A2 = similar(A)
        @test A == project!(M, A2, A)
        @test A == project(M, A)
        embed!(M, A2, A)
        A3 = embed(M, A)
        @test A2 == A
        @test A3 == A
        F = [2 4 -1; 4 9 7; -1 7 5] / norm([2 4 -1; 4 9 7; -1 7 5])
        G = [-10 9 -8; 9 7 6; -8 6 5] / norm([-10 9 -8; 9 7 6; -8 6 5])
        Manifolds.test_manifold(
            M,
            [A, F, G],
            test_injectivity_radius = false,
            test_vector_spaces = true,
            test_project_tangent = true,
            test_musical_isomorphisms = true,
            test_default_vector_transport = true,
            is_tangent_atol_multiplier = 2,
            test_inplace = true,
        )
    end
    @testset "Complex Sphere Symmetric Matrices Basics" begin
        @test repr(M_complex) == "SphereSymmetricMatrices(3, ℂ)"
        @test manifold_dimension(M_complex) == 8
        H =
            [7.0 -1.5im 0.0; 1.5im 3.0 -1.0im; 0.0 1.0im 4.5] /
            norm([7.0 -1.5im 0.0; 1.5im 3.0 -1.0im; 0.0 1.0im 4.5])
        I =
            [2.0 4.0 5.0im; 4.0 -1.0 -9.0; -5.0im -9.0 2.5] /
            norm([2.0 4.0 5.0im; 4.0 -1.0 -9.0; -5.0im -9.0 2.5])
        Manifolds.test_manifold(
            M_complex,
            [C, H, I],
            test_injectivity_radius = false,
            test_vector_spaces = true,
            test_project_tangent = true,
            test_musical_isomorphisms = true,
            test_default_vector_transport = true,
            is_tangent_atol_multiplier = 2,
            is_point_atol_multiplier = 2,
            projection_atol_multiplier = 2,
            exp_log_atol_multiplier = 2,
            test_inplace = true,
        )
    end
    @testset "field parameter" begin
        M = SphereSymmetricMatrices(3; parameter = :field)
        @test repr(M) == "SphereSymmetricMatrices(3, ℝ; parameter=:field)"
        @test typeof(get_embedding(M)) === ArraySphere{ℝ, Tuple{Int, Int}}
    end
end

include("../header.jl")

@testset "SymmetricMatrices" begin
    M = SymmetricMatrices(3, ℝ)
    A = [1 2 3; 4 5 6; 7 8 9]
    A_sym = [1 2 3; 2 5 -1; 3 -1 9]
    A_sym2 = [1 2 3; 2 5 -1; 3 -1 9]
    B_sym = [1 2 3; 2 5 1; 3 1 -1]
    M_complex = SymmetricMatrices(3, ℂ)
    @test repr(M_complex) == "SymmetricMatrices(3, ℂ)"
    @test Manifolds.allocation_promotion_function(M_complex, get_vector, ()) === complex
    C = [1 1 -im; 1 2 -im; im im -1]
    D = [1 0; 0 1]
    X = zeros(3, 3)
    @testset "Real Symmetric Matrices Basics" begin
        @test repr(M) == "SymmetricMatrices(3, ℝ)"
        @test representation_size(M) == (3, 3)
        @test base_manifold(M) === M
        @test is_flat(M)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, TypeParameter{Tuple{3, 3}}}
        @test check_point(M, B_sym) === nothing
        @test_throws DomainError is_point(M, A; error = :error)
        @test_throws ManifoldDomainError is_point(M, C; error = :error)
        @test_throws ManifoldDomainError is_point(M, D; error = :error) #embedding changes type
        @test check_vector(M, B_sym, B_sym) === nothing
        @test_throws DomainError is_vector(M, B_sym, A; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, B_sym; error = :error)
        @test_throws ManifoldDomainError is_vector(M, B_sym, D; error = :error)
        @test_throws ManifoldDomainError is_vector(
            M,
            B_sym,
            1 * im * zero_vector(M, B_sym);
            error = :error,
        )
        @test manifold_dimension(M) == 6
        @test manifold_dimension(M_complex) == 9
        @test A_sym2 == project!(M, A_sym, A_sym)
        @test A_sym2 == project(M, A_sym, A_sym)
        A_sym3 = similar(A_sym)
        embed!(M, A_sym3, A_sym)
        A_sym4 = embed(M, A_sym)
        @test A_sym3 == A_sym
        @test A_sym4 == A_sym
    end
    types = [Matrix{Float64}]

    bases = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))
    for T in types
        pts = [convert(T, A_sym), convert(T, B_sym), convert(T, X)]
        @testset "Type $T" begin
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                basis_types_vecs = (
                    DiagonalizingOrthonormalBasis(log(M, pts[1], pts[2])),
                    bases...,
                ),
                basis_types_to_from = bases,
                is_tangent_atol_multiplier = 1,
                test_inplace = true,
            )
            Manifolds.test_manifold(
                M_complex,
                pts,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                basis_types_vecs = (DefaultOrthonormalBasis(ℝ),),
                basis_types_to_from = (DefaultOrthonormalBasis(ℝ),),
                is_tangent_atol_multiplier = 1,
                test_inplace = true,
            )
            @test isapprox(-pts[1], exp(M, pts[1], log(M, pts[1], -pts[1])))
        end # testset type $T
    end # for
    @testset "field parameter" begin
        M = SymmetricMatrices(3, ℝ; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "SymmetricMatrices(3, ℝ; parameter=:field)"
    end
end # test SymmetricMatrices

@doc raw"""
    SymplecticGrassmann{𝔽, T} <: AbstractEmbeddedManifold{𝔽, DefaultIsometricEmbeddingType}

The symplectic Grassmann manifold consists of all symplectic subspaces of
``ℝ^{2n}`` of dimension ``2k``, ``n ≥ k``.

Points on this manifold can be represented as corresponding representers on the [`SymplecticStiefel`](@ref)

```math
\operatorname{SpGr}(2n,2k) = \bigl\{ \operatorname{span}(p)\ \big| \ p ∈ \operatorname{SpSt}(2n, 2k, ℝ)\},
```

or as projectors

```math
\operatorname{SpGr}(2n, 2k, ℝ) = \bigl\{ p ∈ ℝ^{2n×2n} \ \big| \ p^2 = p, \operatorname{rank}(p) = 2k, p^+=p \bigr\},
```

where ``⋅^+`` is the [`symplectic_inverse`](@ref).
See also [`ProjectorPoint`](@ref) and [`StiefelPoint`](@ref) for these two representations,
where arrays are interpreted as those on the Stiefel manifold.

With respect to the quotient structure, the canonical projection ``π = π_{\mathrm{SpSt},\mathrm{SpGr}}`` is given by

```math
π: \mathrm{SpSt}(2n2k) → \mathrm{SpGr}(2n,2k), p ↦ π(p) = pp^+.
```

The tangent space is either the tangent space from the symplectic Stiefel manifold, where
tangent vectors are representers of their corresponding congruence classes, or for the
representation as projectors, using a [`ProjectorTangentVector`](@ref) as

```math
  T_p\operatorname{SpGr}(2n, 2k, ℝ) =
  \bigl\{ [X,p] \ \mid\ X ∈ \mathfrak{sp}(2n,ℝ), Xp+pX = X \bigr\},
```

where ``[X,p] = Xp-pX`` denotes the matrix commutator and
``\mathfrak{sp}(2n,ℝ)`` is the Lie algebra of the symplectic group consisting of [`HamiltonianMatrices`](@ref).

The first representation is in [`StiefelPoint`](@ref)s and [`StiefelTangentVector`](@ref)s,
which both represent their symplectic Grassmann equivalence class. Arrays are interpreted
in this representation as well

For the representation in [`ProjectorPoint`](@ref) and [`ProjectorTangentVector`](@ref)s,
we use the representation from the surjective submersion

```math
ρ: \mathrm{SpSt}(2n,2k) → \mathrm{SpGr}(2n,2k),
\qquad
ρ(p) = pp^+
```

and its differential

```math
\mathrm{d}ρ(p,X) = Xp^+ + pX^+,
```

respectively.
The manifold was first introduced in [BendokatZimmermann:2021](@cite)

# Constructor

    SymplecticGrassmann(2n::Int, 2k::Int, field::AbstractNumbers=ℝ; parameter::Symbol=:type)

Generate the (real-valued) symplectic Grassmann manifold.
of  ``2k`` dimensional symplectic subspace of ``ℝ^{2n}``.
Note that both dimensions passed to this constructor have to be even.
"""
struct SymplecticGrassmann{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SymplecticGrassmann(two_n::Int, two_k::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (div(two_n, 2), div(two_k, 2)))
    return SymplecticGrassmann{ℝ, typeof(size)}(size)
end

# Define Stiefel as the array fallback
ManifoldsBase.@default_manifold_fallbacks SymplecticGrassmann StiefelPoint StiefelTangentVector value value

@doc raw"""
    manifold_dimension(::SymplecticGrassmann)

Return the dimension of the [`SymplecticGrassmann`](@ref)`(2n,2k)`, which is

````math
\operatorname{dim}\operatorname{SpGr}(2n, 2k) = 4(n-k)k,
````

see [BendokatZimmermann:2021](@cite), Section 4.
"""
function manifold_dimension(M::SymplecticGrassmann{ℝ})
    n, k = get_parameter(M.size)
    return 4 * (n - k) * k
end

function Base.show(io::IO, ::SymplecticGrassmann{ℝ, TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "SymplecticGrassmann($(2n), $(2k))")
end
function Base.show(io::IO, M::SymplecticGrassmann{ℝ, Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "SymplecticGrassmann($(2n), $(2k); parameter=:field)")
end

#
# Representer specific implementations in their corresponding subfiles
#
include("SymplecticGrassmannStiefel.jl")
include("SymplecticGrassmannProjector.jl")

include("../header.jl")

@testset "Hyperbolic Space" begin
    M = Hyperbolic(2)
    @testset "Hyperbolic Basics" begin
        @test repr(M) == "Hyperbolic(2)"
        @test base_manifold(M) == M
        @test manifold_dimension(M) == 2
        @test typeof(get_embedding(M)) == MetricManifold{ℝ, Euclidean{ℝ, TypeParameter{Tuple{3}}}, MinkowskiMetric}
        @test representation_size(M) == (3,)
        @test !is_flat(M)
        @test isinf(injectivity_radius(M))
        @test isinf(injectivity_radius(M, ExponentialRetraction()))
        @test isinf(injectivity_radius(M, [0.0, 0.0, 1.0]))
        @test isinf(injectivity_radius(M, [0.0, 0.0, 1.0], ExponentialRetraction()))
        @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
        @test !is_vector(M, [0.0, 0.0, 1.0], [0.0, 0.0, 1.0, 0.0])
        @test_throws DomainError is_point(M, [2.0, 0.0, 0.0]; error = :error)
        @test !is_point(M, [2.0, 0.0, 0.0])
        @test !is_vector(M, [1.0, 0.0, 0.0], [1.0, 0.0, 0.0])
        @test_throws ManifoldDomainError is_vector( # p is not a valid point
            M,
            [1.0, 0.0, 0.0],
            [1.0, 0.0, 0.0];
            error = :error,
        )
        @test !is_vector(M, [0.0, 0.0, 1.0], [1.0, 0.0, 1.0])
        @test_throws DomainError is_vector(
            M,
            [0.0, 0.0, 1.0],
            [1.0, 0.0, 1.0];
            error = :error,
        )
        @test is_default_metric(M, MinkowskiMetric())
        @test manifold_dimension(M) == 2

        for (P, T) in zip(
                [HyperboloidPoint, PoincareBallPoint, PoincareHalfSpacePoint],
                [
                    HyperboloidTangentVector,
                    PoincareBallTangentVector,
                    PoincareHalfSpaceTangentVector,
                ],
            )
            p = convert(P, [1.0, 0.0, sqrt(2.0)])
            X = convert(T, [1.0, 0.0, sqrt(2.0)], [0.0, 1.0, 0.0])
            @test number_eltype(p) == eltype(p.value)
            @test X * 2.0 == T(X.value * 2.0)
            @test 2 \ X == T(2 \ X.value)
            @test +X == T(+X.value)
            @test Manifolds.allocate_result_type(M, log, (p, p)) == T
            @test Manifolds.allocate_result_type(M, inverse_retract, (p, p)) == T
            convert(T, p, X) == X
            # copyto
            pC = allocate(p)
            copyto!(M, pC, p)
            @test pC.value == p.value
            XC = allocate(X)
            @test copyto!(M, XC, p, X) == X # does copyto return the right value?
            @test XC == X # does copyto store the right value?
            @test XC.value == X.value # another check
            @test zero_vector(M, p) isa T
        end
    end
    @testset "Hyperbolic Representation Conversion I" begin
        p = [0.0, 0.0, 1.0]
        pH = HyperboloidPoint(p)

        @test minkowski_metric(pH, pH) == minkowski_metric(p, p)
        @test convert(HyperboloidPoint, p).value == pH.value
        @test convert(AbstractVector, pH) == p
        X = [1.0, 0.0, 0.0]
        XH = HyperboloidTangentVector(X)

        @test convert(HyperboloidTangentVector, X).value == XH.value
        @test convert(AbstractVector, XH) == X
        @test convert(HyperboloidPoint, p).value == pH.value
        is_point(M, pH)
        pB = convert(PoincareBallPoint, p)
        @test pB.value == convert(PoincareBallPoint, pH).value
        @test is_point(M, pB)
        @test convert(AbstractVector, pB) == p # convert back yields again p
        @test convert(HyperboloidPoint, pB).value == pH.value
        @test_throws DomainError is_point(
            M,
            PoincareBallPoint([0.9, 0.0, 0.0]);
            error = :error,
        )
        @test_throws DomainError is_point(M, PoincareBallPoint([1.1, 0.0]); error = :error)

        @test is_vector(M, pB, PoincareBallTangentVector([2.0, 2.0]))
        @test_throws DomainError is_vector(
            M,
            pB,
            PoincareBallTangentVector([2.0, 2.0, 3.0]);
            error = :error,
        )
        pS = convert(PoincareHalfSpacePoint, p)
        pS2 = convert(PoincareHalfSpacePoint, pB)
        pS3 = convert(PoincareHalfSpacePoint, pH)

        @test_throws DomainError is_point(
            M,
            PoincareHalfSpacePoint([0.0, 0.0, 1.0]);
            error = :error,
        )
        @test_throws DomainError is_point(
            M,
            PoincareHalfSpacePoint([0.0, -1.0]);
            error = :error,
        )

        @test pS.value == pS2.value
        @test pS.value == pS3.value
        @test convert(AbstractVector, pS) == convert(HyperboloidPoint, pS).value
        @test convert(PoincareBallPoint, pS2).value == pB.value
    end
    @testset "PoincareHalfSpaceVector size test" begin
        M = Hyperbolic(2)
        p = PoincareHalfSpacePoint([1.0, 1.0])
        X = PoincareHalfSpaceTangentVector(zeros(3))
        @test_throws DomainError is_vector(M, p, X; error = :error)
    end
    @testset "Hyperbolic Representation Conversion II" begin
        M = Hyperbolic(2)
        pts = [[0.0, 0.0, 1.0], [1.0, 0.0, sqrt(2.0)]]
        X = log(M, pts[2], pts[1])
        # For HyperboloidTangentVector we can do a plain wrap/unwrap
        X1 = convert(HyperboloidTangentVector, X)
        @test convert(AbstractVector, X1) == X
        # Convert to types and back to Array
        for (P, T) in zip(
                [HyperboloidPoint, PoincareBallPoint, PoincareHalfSpacePoint],
                [
                    HyperboloidTangentVector,
                    PoincareBallTangentVector,
                    PoincareHalfSpaceTangentVector,
                ],
            )
            # convert to P,T
            p1 = convert(P, pts[2])
            X1 = convert(T, pts[2], X)
            (p2, X2) = convert(Tuple{P, T}, (pts[2], X))
            @test isapprox(M, p1, p2)
            @test isapprox(M, p1, X1, X2)
            # Test broadcast
            @test 2 .* X1 == T(2 .* X1.value)
            @test copy(X1) == X1
            @test copy(X1) !== X1
            X1s = similar(X1)
            X1s .= 2 .* X1
            @test X1s == 2 * X1
            X1s .= X1
            @test X1s == X1

            for (P2, T2) in zip(
                    [HyperboloidPoint, PoincareBallPoint, PoincareHalfSpacePoint],
                    [
                        HyperboloidTangentVector,
                        PoincareBallTangentVector,
                        PoincareHalfSpaceTangentVector,
                    ],
                )
                @test isapprox(M, convert(P2, p1), convert(P2, pts[2]))
                @test convert(T, p1, X1) == convert(T, pts[2], X)
                (p3, X3) = convert(Tuple{P2, T2}, (pts[2], X))
                (p3a, X3a) = convert(Tuple{P2, T2}, (p1, X1))
                @test isapprox(M, p3, p3a)
                @test isapprox(M, p3, X3, X3a)
                @test isapprox(M, convert(P2, p2), p3)
                @test isapprox(M, pts[2], convert(AbstractVector, p3))
                @test isapprox(M, p3, convert(T2, p2, X2), X3)
                # coupled conversion
                (pT, XT) = convert(Tuple{AbstractVector, AbstractVector}, (p2, X2))
                @test isapprox(M, pts[2], pT)
                @test isapprox(M, pts[2], X, XT)
            end
        end
    end

    types = [
        Vector{Float64},
        SizedVector{3, Float64},
        HyperboloidPoint,
        PoincareBallPoint,
        PoincareHalfSpacePoint,
    ]
    for T in types
        @testset "Type $T" begin
            is_plain_array =
                T ∉ [HyperboloidPoint, PoincareBallPoint, PoincareHalfSpacePoint]
            pts = [
                convert(T, [0.0, 0.0, 1.0]),
                convert(T, [1.0, 0.0, sqrt(2.0)]),
                convert(T, [0.0, 1.0, sqrt(2.0)]),
            ]
            Manifolds.test_manifold(
                M,
                pts,
                test_project_tangent = is_plain_array || T == HyperboloidPoint,
                test_musical_isomorphisms = is_plain_array,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                is_tangent_atol_multiplier = 10.0,
                exp_log_atol_multiplier = 10.0,
                retraction_methods = (ExponentialRetraction(),),
                test_tangent_vector_broadcasting = is_plain_array,
                test_vector_spaces = is_plain_array,
                test_inplace = true,
                test_rand_point = is_plain_array,
                test_rand_tvector = is_plain_array,
            )
        end
    end
    @testset "Embedding test" begin
        p = [0.0, 0.0, 1.0]
        X = [1.0, 1.0, 0.0]
        @test embed(M, p) == p
        q = similar(p)
        embed!(M, q, p)
        @test q == p
        @test embed(M, p, X) == X
        Y = similar(X)
        embed!(M, Y, p, X)
        @test Y == X
        p2 = HyperboloidPoint(p)
        X2 = HyperboloidTangentVector(X)
        q2 = HyperboloidPoint(similar(p))
        q3 = similar(p)
        @test embed(M, p2) == p2.value
        embed!(M, q2, p2)
        embed!(M, q3, p2)
        @test q2.value == p2.value
        @test q3 == p2.value
        @test embed(M, p2, X2) == X2.value
        Y2 = HyperboloidTangentVector(similar(X))
        Y3 = similar(X)
        embed!(M, Y2, p2, X2)
        @test Y2.value == X2.value
        embed!(M, Y3, p2, X2)
        @test Y3 == X2.value
        # check embed for PoincareBall
        p4 = convert(PoincareBallPoint, p)
        X4 = convert(PoincareBallTangentVector, p, X)
        q4 = embed(M, p4)
        @test isapprox(q4, zeros(2))
        q4b = similar(q4)
        embed!(M, q4b, p4)
        @test q4b == q4
        Y4 = embed(M, p4, X4)
        @test Y4 == X4.value
        Y4b = similar(Y4)
        embed!(M, Y4b, p4, X4)
        @test Y4 == Y4b
        # check embed for PoincareHalfSpace
        p5 = convert(PoincareHalfSpacePoint, p)
        X5 = convert(PoincareHalfSpaceTangentVector, p, X)
        q5 = embed(M, p5)
        @test isapprox(q5, [0.0; 1.0])
        q5b = similar(q5)
        embed!(M, q5b, p5)
        @test q5b == q5
        Y5 = embed(M, p5, X5)
        @test Y5 == X5.value
        Y5b = similar(Y5)
        embed!(M, Y5b, p5, X5)
        @test Y5 == Y5b
    end
    @testset "Hyperbolic mean test" begin
        pts = [
            [0.0, 0.0, 1.0],
            [1.0, 0.0, sqrt(2.0)],
            [-1.0, 0.0, sqrt(2.0)],
            [0.0, 1.0, sqrt(2.0)],
            [0.0, -1.0, sqrt(2.0)],
        ]
        ws = UnitWeights{Float64}(length(pts))
        @test isapprox(M, mean(M, pts), pts[1]; atol = 10^-4)
        @test isapprox(M, mean(M, pts, ws), pts[1]; atol = 10^-4)
        @test_throws DimensionMismatch mean(M, pts, UnitWeights{Float64}(length(pts) + 1))
    end
    @testset "Hyperbolic ONB test" begin
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize(M, [1.0, 0.0])
        B = get_basis(M, p, DefaultOrthonormalBasis())
        V = get_vectors(M, p, B)
        for v in V
            @test is_vector(M, p, v; error = :error)
            for b in [DefaultOrthonormalBasis(), DiagonalizingOrthonormalBasis(V[1])]
                @test isapprox(M, p, v, get_vector(M, p, get_coordinates(M, p, v, b), b))
            end
        end
        for v in V, w in V
            @test inner(M, p, v, w) ≈ (v == w ? 1 : 0)
        end
        X = 0.5 * V[1] + 1.0 .* V[2]
        @test is_vector(M, p, X)
        c = get_coordinates(M, p, X, B)
        @test c ≈ [0.5, 1.0]
        c2 = similar(c)
        get_coordinates!(M, c2, p, X, DefaultOrthonormalBasis())
        B2 = DiagonalizingOrthonormalBasis(X)
        V2 = get_vectors(M, p, get_basis(M, p, B2))
        @test V2[1] ≈ X ./ norm(M, p, X)
        @test inner(M, p, V2[1], V2[2]) ≈ 0.0 atol = 5.0e-16
        B3 = DiagonalizingOrthonormalBasis(-V[2])
        V3 = get_vectors(M, p, get_basis(M, p, B3))
        @test isapprox(M, p, V3[1], -V[2])
    end
    @testset "Hyperboloid Minkowski Metric tests" begin
        p = Manifolds._hyperbolize(M, [0.0, 1.0])
        X = [1.0, 0.0, 0.0]
        pH = HyperboloidPoint(p)
        XH = HyperboloidTangentVector(X)
        @test minkowski_metric(XH, pH) == minkowski_metric(X, p)
        @test minkowski_metric(pH, XH) == minkowski_metric(p, X)
        @test minkowski_metric(XH, XH) == minkowski_metric(X, X)
    end
    @testset "PoincareBall project tangent test" begin
        p = PoincareBallPoint([0.5, 0.0])
        X = PoincareBallTangentVector([0.2, 0.2])
        Y = PoincareBallTangentVector(allocate(X.value))
        project!(M, Y, p, X)
        @test Y == X
        Z = project(M, p, X)
        @test isa(Z, PoincareBallTangentVector)
        @test Z == X
        p2 = PoincareHalfSpacePoint([1.1, 1.1])
        X2 = PoincareHalfSpaceTangentVector([0.2, 0.2])
        Y2 = PoincareHalfSpaceTangentVector(allocate(X2.value))
        project!(M, Y2, p2, X2)
        @test Y2 == X2
        Z2 = project(M, p2, X2)
        @test isa(Z2, PoincareHalfSpaceTangentVector)
        @test Z2 == X2
    end
    @testset "Metric conversion on Hyperboloid" begin
        M = Hyperbolic(2)
        p = [1.0, 1.0, sqrt(3)]
        X = [1.0, 2.0, sqrt(3)]
        Y = change_representer(M, EuclideanMetric(), p, X)
        @test inner(M, p, X, Y) == inner(Euclidean(3), p, X, X)
        # change metric not possible from Euclidean, since the embedding is Lorenzian
        @test_throws ErrorException change_metric(M, EuclideanMetric(), p, X)
        # but if we come from the same metric, we have the identity
        @test change_metric(M, MinkowskiMetric(), p, X) == X
    end
    @testset "Metric conversion on Poincare Ball" begin
        M = Hyperbolic(2)
        p = convert(PoincareBallPoint, [1.0, 1.0, sqrt(3)])
        X = convert(PoincareBallTangentVector, [1.0, 1.0, sqrt(3)], [1.0, 2.0, sqrt(3)])
        Y = change_representer(M, EuclideanMetric(), p, X)
        @test inner(M, p, X, Y) == inner(Euclidean(3), p, X.value, X.value)
        α = 2 / (1 - norm(p.value)^2)
        @test Y.value == X.value ./ α^2
        Z = change_metric(M, EuclideanMetric(), p, X)
        @test Z.value == X.value ./ α
        A = change_metric(M, MinkowskiMetric(), p, X)
        @test A == X
    end
    @testset "other metric" begin
        M = Hyperbolic(2)
        p = [0.0, 0.0, -1.0]
        X = [-1.0, 0.0, 0.0]
        Y = [0.0, -1.0, 0.0]
        Z = [-0.5, -0.5, 0.0]
        @test riemann_tensor(M, p, X, Y, Z) == [0.5, -0.5, 0.0]
        Xout = [0.0, 0.0, 0.0]
        @test riemann_tensor!(M, Xout, p, X, Y, Z) === Xout
        @test Xout == [0.5, -0.5, 0.0]

        @test sectional_curvature(M, p, X, Y) == -1.0
        @test sectional_curvature_max(M) == -1.0
        @test sectional_curvature_min(M) == -1.0
        M1 = Hyperbolic(1)
        @test sectional_curvature(M1, p, X, Y) == 0.0
        @test sectional_curvature_max(M1) == 0.0
        @test sectional_curvature_min(M1) == 0.0
    end
    @testset "ManifoldDiff" begin
        # ManifoldDiff
        M = Hyperbolic(2)
        p = [1.0, 1.0, sqrt(3)]
        X = [1.0, 2.0, sqrt(3)]
        dpX = ManifoldDiff.diagonalizing_projectors(M, p, X)
        @test dpX[1][1] == 0.0
        @test dpX[1][2].X == 2 * normalize(X)
        @test dpX[2][1] == -1.0
        @test dpX[2][2].X == 2 * normalize(X)
    end
    @testset "Riemannian Hessian" begin
        M = Hyperbolic(2)
        p = [0.0, 0.0, 1.0]
        G = [1.0, 0.2, 0.3]
        H = [2.0, 0.3, 0.4]
        X = [0.3, 0.4, 0.0]
        D = diagm([1.0, 1.0, -1.0])
        rH = project(M, p, D * H + dot(p, D * G) .* X)
        @test riemannian_Hessian(M, p, G, H, X) == rH
    end
    @testset "Manifold volume" begin
        M = Hyperbolic(2)
        @test manifold_volume(M) == Inf
        p = [1.0, 1.0, sqrt(3)]
        X = [1.0, 2.0, sqrt(3)]
        @test volume_density(M, p, X) ≈ 2.980406103535168
        @test volume_density(M, p, [0.0, 0.0, 0.0]) ≈ 1.0
    end
    @testset "field parameter" begin
        M = Hyperbolic(2; parameter = :field)
        @test repr(M) == "Hyperbolic(2; parameter=:field)"
        @test typeof(get_embedding(M)) === Lorentz{Tuple{Int64}, MinkowskiMetric}

        for Tp in [PoincareBallPoint, PoincareHalfSpacePoint]
            p = convert(Tp, [1.0, 0.0, sqrt(2.0)])
            @test get_embedding(M, typeof(p)) === Euclidean(2; parameter = :field)
        end
    end
end

"""
`Manifolds.jl` provides a library of manifolds aiming for an easy-to-use and fast implementation.
"""
module Manifolds

import Base:
    ^,
    angle,
    copyto!,
    convert,
    foreach,
    identity,
    in,
    inv,
    isempty,
    length,
    ndims,
    show,
    showerror,
    size,
    transpose
import ManifoldsBase:
    _access_nested,
    _get_basis,
    _injectivity_radius,
    _inverse_retract,
    _inverse_retract!,
    _read,
    _retract,
    _retract!,
    _write,
    allocate,
    allocate_coordinates,
    allocate_result,
    allocate_result_embedding,
    allocate_result_type,
    allocation_promotion_function,
    base_manifold,
    canonical_project,
    canonical_project!,
    change_basis,
    change_basis!,
    change_metric,
    change_metric!,
    change_representer,
    change_representer!,
    check_point,
    check_size,
    check_vector,
    connection,
    copy,
    copyto!,
    default_approximation_method,
    default_inverse_retraction_method,
    default_retraction_method,
    default_vector_transport_method,
    decorated_manifold,
    distance,
    dual_basis,
    embed,
    embed!,
    embed_project,
    embed_project!,
    exp,
    exp!,
    exp_fused,
    exp_fused!,
    fiber_dimension,
    get_basis,
    get_basis_default,
    get_basis_diagonalizing,
    get_basis_orthogonal,
    get_basis_orthonormal,
    get_basis_vee,
    get_component,
    get_coordinates,
    get_coordinates!,
    get_coordinates_diagonalizing,
    get_coordinates_diagonalizing!,
    get_coordinates_orthogonal,
    get_coordinates_orthonormal,
    get_coordinates_orthogonal!,
    get_coordinates_orthonormal!,
    get_coordinates_vee!,
    get_embedding,
    get_iterator,
    get_total_space,
    get_vector,
    get_vector!,
    get_vector_diagonalizing,
    get_vector_diagonalizing!,
    get_vector_orthogonal,
    get_vector_orthonormal,
    get_vector_orthogonal!,
    get_vector_orthonormal!,
    get_vectors,
    gram_schmidt,
    has_components,
    hat,
    hat!,
    horizontal_component,
    horizontal_component!,
    horizontal_lift,
    horizontal_lift!,
    injectivity_radius,
    _injectivity_radius,
    injectivity_radius_exp,
    inner,
    internal_value,
    inverse_retract,
    inverse_retract!,
    _inverse_retract!,
    inverse_retract_cayley!,
    inverse_retract_embedded!,
    inverse_retract_pade!,
    inverse_retract_polar!,
    inverse_retract_project!,
    inverse_retract_qr!,
    inverse_retract_shooting!,
    inverse_retract_softmax!,
    isapprox,
    _isapprox,
    is_default_connection,
    is_default_metric,
    is_flat,
    is_metric_function,
    is_point,
    is_vector,
    log,
    log!,
    manifold_dimension,
    metric,
    mid_point,
    mid_point!,
    norm,
    number_eltype,
    number_of_coordinates,
    parallel_transport_direction,
    parallel_transport_direction!,
    parallel_transport_to,
    parallel_transport_to!,
    power_dimensions,
    project,
    project!,
    rand,
    rand!,
    representation_size,
    retract,
    retract!,
    retract_cayley!,
    retract_pade!,
    retract_polar!,
    retract_project!,
    retract_qr!,
    retract_sasaki!,
    retract_softmax!,
    retract_fused,
    retract_fused!,
    riemann_tensor,
    riemann_tensor!,
    sectional_curvature,
    sectional_curvature_max,
    sectional_curvature_min,
    set_component!,
    submanifold,
    submanifold_component,
    submanifold_components,
    vector_space_dimension,
    vector_transport_direction,
    vector_transport_direction!,
    vector_transport_direction_diff!,
    vector_transport_to,
    vector_transport_to!,
    vector_transport_to_diff!,
    vector_transport_to_project!, # some overwrite layer 2
    _vector_transport_direction,
    _vector_transport_direction!,
    _vector_transport_to,
    _vector_transport_to!,
    vertical_component,
    vertical_component!,
    vee,
    vee!,
    Weingarten,
    Weingarten!,
    zero_vector,
    zero_vector!
import ManifoldDiff:
    adjoint_Jacobi_field,
    adjoint_Jacobi_field!,
    diagonalizing_projectors,
    jacobi_field,
    jacobi_field!,
    jacobian_exp_argument,
    jacobian_exp_argument!,
    riemannian_gradient,
    riemannian_gradient!,
    riemannian_Hessian,
    riemannian_Hessian!

import Statistics: mean, mean!, median, median!, cov, var
import StatsBase: mean_and_var

using ADTypes:
    AbstractADType,
    AutoFiniteDiff,
    AutoFiniteDifferences,
    AutoForwardDiff,
    AutoReverseDiff,
    AutoZygote
import DifferentiationInterface as DI

using Base.Iterators: repeated
using Tullio: @einsum, @tullio
using Kronecker
using Graphs
using LinearAlgebra
using ManifoldsBase:
    ℝ,
    ℂ,
    ℍ,
    AbstractApproximationMethod,
    AbstractBasis,
    AbstractDecoratorManifold,
    AbstractInverseRetractionMethod,
    AbstractManifold,
    AbstractManifoldPoint,
    AbstractMetric,
    AbstractNumbers,
    AbstractOrthogonalBasis,
    AbstractOrthonormalBasis,
    AbstractPowerManifold,
    AbstractPowerRepresentation,
    AbstractRetractionMethod,
    AbstractVectorTransportMethod,
    AbstractLinearVectorTransportMethod,
    ApproximateInverseRetraction,
    ApproximateRetraction,
    CachedBasis,
    CayleyRetraction,
    CayleyInverseRetraction,
    ComplexNumbers,
    ComponentManifoldError,
    CompositeManifoldError,
    ConnectionManifold,
    CotangentSpace,
    CotangentSpaceType,
    CoTFVector,
    AbstractCotangentVector,
    CyclicProximalPointEstimation,
    DefaultBasis,
    DefaultMetric,
    DefaultOrthogonalBasis,
    DefaultOrthonormalBasis,
    DefaultOrDiagonalizingBasis,
    DiagonalizingBasisData,
    DiagonalizingOrthonormalBasis,
    DifferentiatedRetractionVectorTransport,
    EfficientEstimator,
    EmbeddedManifold,
    EuclideanMetric,
    ExponentialRetraction,
    ExtrinsicEstimation,
    Fiber,
    FiberType,
    FVector,
    GeodesicInterpolation,
    GeodesicInterpolationWithinRadius,
    GradientDescentEstimation,
    InverseProductRetraction,
    LeviCivitaConnection,
    LogarithmicInverseRetraction,
    ManifoldDomainError,
    ManifoldsBase,
    MetricManifold,
    NestedPowerRepresentation,
    NestedReplacingPowerRepresentation,
    NLSolveInverseRetraction,
    OutOfInjectivityRadiusError,
    PadeRetraction,
    PadeInverseRetraction,
    ParallelTransport,
    PolarInverseRetraction,
    PolarRetraction,
    PoleLadderTransport,
    PowerBasisData,
    PowerManifold,
    PowerManifoldNested,
    PowerManifoldNestedReplacing,
    ProductBasisData,
    ProductManifold,
    ProductMetric,
    ProductRetraction,
    ProductVectorTransport,
    ProjectedOrthonormalBasis,
    ProjectionInverseRetraction,
    ProjectionRetraction,
    ProjectionTransport,
    QuaternionNumbers,
    QRInverseRetraction,
    QRRetraction,
    RealNumbers,
    RiemannianMetric,
    SasakiRetraction,
    ScaledVectorTransport,
    SchildsLadderTransport,
    ShootingInverseRetraction,
    SoftmaxRetraction,
    SoftmaxInverseRetraction,
    StabilizedRetraction,
    StopForwardingType,
    TangentSpace,
    TangentSpaceType,
    TCoTSpaceType,
    TFVector,
    AbstractTangentVector,
    TypeParameter,
    ValidationCotangentVector,
    ValidationManifold,
    ValidationMPoint,
    ValidationTangentVector,
    VectorSpaceFiber,
    VectorSpaceType,
    VeeOrthogonalBasis,
    WeiszfeldEstimation,
    @invoke_maker,
    _euclidean_basis_vector,
    combine_allocation_promotion_functions,
    geodesic,
    geodesic!,
    get_parameter,
    @trait_function,
    number_of_components,
    number_system,
    real_dimension,
    rep_size_to_colons,
    shortest_geodesic,
    shortest_geodesic!,
    size_to_tuple,
    wrap_type_parameter,
    ziptuples
using ManifoldDiff: ManifoldDiff
using ManifoldDiff:
    allocate_jacobian,
    default_differential_backend,
    _derivative,
    _derivative!,
    differential,
    differential!,
    gradient,
    gradient!,
    _gradient,
    _gradient!,
    hessian,
    _hessian,
    jacobian,
    _jacobian,
    _jacobian!,
    set_default_differential_backend!
using ManifoldDiff:
    AbstractRiemannianDiffBackend,
    CoprojectorOntoVector,
    ExplicitEmbeddedBackend,
    IdentityProjector,
    NoneDiffBackend,
    ProjectorOntoVector,
    RiemannianProjectionBackend,
    TangentDiffBackend
using Markdown: @doc_str
using MatrixEquations: lyapc, sylvc
using Quaternions: Quaternions
using Random
using SimpleWeightedGraphs: AbstractSimpleWeightedGraph, get_weight
using SpecialFunctions
using StaticArrays
using Statistics
using StatsBase
using StatsBase: AbstractWeights

const AbstractDiffBackend = Any  # TODO: remove

include("utils.jl")

include("manifold_fallbacks.jl")

"""
    get_parameter_type(M::AbstractManifold)

Get `parameter` argument of the constructor of manifold `M`.
Returns either `:field` or `:type`.

# See also

`get_parameter`, `TypeParameter`
"""
get_parameter_type(::AbstractManifold)

"""
    projected_distribution(M::AbstractManifold, d, [p=rand(d)])

Wrap the standard distribution `d` into a manifold-valued distribution. Generated
points will be of similar type to `p`. By default, the type is not changed.
"""
function projected_distribution end

"""
    normal_tvector_distribution(M::AbstractManifold, p, σ)

Normal distribution in ambient space with standard deviation `σ`
projected to tangent space at `p`.
"""
function normal_tvector_distribution end

function uniform_distribution(M::AbstractManifold)
    return uniform_distribution(M, allocate_result(M, uniform_distribution))
end

# Main Meta Manifolds
include("manifolds/ConnectionManifold.jl")
include("manifolds/MetricManifold.jl")
include("manifolds/Fiber.jl")
include("manifolds/FiberBundle.jl")
include("manifolds/VectorFiber.jl")
include("manifolds/VectorBundle.jl")

# Features I: Extending Meta Manifolds
include("statistics.jl")

# Meta Manifolds II: Products
include("manifolds/ProductManifold.jl")

METAMANIFOLDS = [
    AbstractManifold,
    AbstractDecoratorManifold,
    AbstractPowerManifold,
    PowerManifoldNested,
    PowerManifoldNestedReplacing,
    ProductManifold,
    TangentSpace,
    ValidationManifold,
    VectorBundle,
]

# Features II: That require MetaManifolds
include("atlases.jl")
include("differentiation/ode_callback.jl")
include("cotangent_space.jl")

# Meta Manifolds II: Power Manifolds
include("manifolds/PowerManifold.jl")
include("manifolds/GraphManifold.jl")

#
# Manifolds
#
include("manifolds/Euclidean.jl")
include("manifolds/Lorentz.jl")

include("manifolds/CenteredMatrices.jl")
include("manifolds/CholeskySpace.jl")
include("manifolds/Circle.jl")
include("manifolds/DeterminantOneMatrices.jl")
include("manifolds/Elliptope.jl")
include("manifolds/EmbeddedTorus.jl")
include("manifolds/FixedRankMatrices.jl")
include("manifolds/Flag.jl")
include("manifolds/FlagOrthogonal.jl")
include("manifolds/FlagStiefel.jl")
include("manifolds/GeneralizedGrassmann.jl")
include("manifolds/GeneralizedStiefel.jl")
include("manifolds/HeisenbergMatrices.jl")
include("manifolds/Hyperbolic.jl")
include("manifolds/Hyperrectangle.jl")
include("manifolds/InvertibleMatrices.jl")
include("manifolds/MultinomialDoublyStochastic.jl")
include("manifolds/MultinomialSymmetric.jl")
include("manifolds/MultinomialSymmetricPositiveDefinite.jl")
include("manifolds/PositiveNumbers.jl")
include("manifolds/ProjectiveSpace.jl")
include("manifolds/Segre.jl")
include("manifolds/SegreWarpedMetric.jl")
include("manifolds/SkewHermitian.jl")
include("manifolds/Spectrahedron.jl")
include("manifolds/Stiefel.jl")
include("manifolds/StiefelEuclideanMetric.jl")
include("manifolds/StiefelCanonicalMetric.jl")
include("manifolds/StiefelSubmersionMetric.jl")
include("manifolds/Sphere.jl")
include("manifolds/SphereSymmetricMatrices.jl")
include("manifolds/Symmetric.jl")
include("manifolds/SymmetricPositiveDefinite.jl")
include("manifolds/SPDFixedDeterminant.jl")
include("manifolds/SymmetricPositiveDefiniteBuresWasserstein.jl")
include("manifolds/SymmetricPositiveDefiniteGeneralizedBuresWasserstein.jl")
include("manifolds/SymmetricPositiveDefiniteAffineInvariant.jl")
include("manifolds/SymmetricPositiveDefiniteLogCholesky.jl")
include("manifolds/SymmetricPositiveDefiniteLogEuclidean.jl")
include("manifolds/SymmetricPositiveSemidefiniteFixedRank.jl")
include("manifolds/Tucker.jl")
#
include("manifolds/ProbabilitySimplex.jl")
include("manifolds/ProbabilitySimplexEuclideanMetric.jl")
include("manifolds/GeneralUnitaryMatrices.jl")
include("manifolds/SpecialUnitary.jl")
include("manifolds/Unitary.jl")
include("manifolds/Rotations.jl")
include("manifolds/Orthogonal.jl")

# shape spaces require Sphere
include("manifolds/KendallsPreShapeSpace.jl")
include("manifolds/KendallsShapeSpace.jl")

# Introduce the quotient, Grassmann, only after Stiefel
include("manifolds/Grassmann.jl")

# Introduce Symplectic and so on manifolds only after Grassmann
# Since that defines the StiefelPoint, StiefelTangentVector
include("manifolds/Symplectic.jl")
include("manifolds/Hamiltonian.jl") # Hamiltonian requires symplectic
include("manifolds/SymplecticStiefel.jl")
include("manifolds/SymplecticGrassmann.jl") # Requires SymplecticStiefel

# Product or power based manifolds
include("manifolds/Torus.jl")
include("manifolds/Multinomial.jl")
include("manifolds/Oblique.jl")
include("manifolds/EssentialManifold.jl")

@doc raw"""
    Base.in(p, M::AbstractManifold; kwargs...)
    p ∈ M

Check, whether a point `p` is a valid point (i.e. in) a [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`.
This method employs [`is_point`](@extref `ManifoldsBase.is_point-Tuple{AbstractManifold, Any, Bool}`) deactivating the error throwing option.
"""
Base.in(p, M::AbstractManifold; kwargs...) = is_point(M, p, false; kwargs...)

@doc raw"""
    Base.in(p, TpM::TangentSpace; kwargs...)
    X ∈ TangentSpace(M, p)

Check whether `X` is a tangent vector from (in) the tangent space ``T_p\mathcal M``, i.e.
the [`TangentSpace`](@extref `ManifoldsBase.TangentSpace`)
at `p` on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`.
This method uses [`is_vector`](@extref `ManifoldsBase.is_vector-Tuple{AbstractManifold, Any, Any, Bool, Bool}`) deactivating the error throw option.
"""
function Base.in(X, TpM::TangentSpace; kwargs...)
    return is_vector(base_manifold(TpM), TpM.point, X, false; kwargs...)
end

@doc raw"""
    manifold_volume(M::AbstractManifold)

Volume of manifold `M` defined through integration of Riemannian volume element in a chart.
Note that for many manifolds there is no universal agreement over the exact ranges over
which the integration should happen. For details see [BoyaSudarshanTilma:2003](@cite).
"""
manifold_volume(::AbstractManifold)

@doc raw"""
    volume_density(M::AbstractManifold, p, X)

Volume density function of manifold `M`, i.e. determinant of the differential of exponential map
`exp(M, p, X)`. Determinant can be understood as computed in a basis, from the matrix
of the linear operator said differential corresponds to. Details are available in Section 4.1
of [ChevallierLiLuDunson:2022](@cite).

Note that volume density is well-defined only for `X` for which `exp(M, p, X)` is injective.
"""
volume_density(::AbstractManifold, p, X)

# functions populated with methods by extensions

function solve_chart_log_bvp end
function estimate_distance_from_bvp end

function solve_chart_exp_ode end
function solve_chart_parallel_transport_ode end

# TODO: Remove once the new interface is done
function find_eps end
function test_parallel_transport end
function test_manifold end
function test_atlases end
# / remove

function __init__()
    @static if isdefined(Base.Experimental, :register_error_hint) # COV_EXCL_LINE
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            if exc.f === solve_exp_ode
                print(io, "\nDid you forget to load OrdinaryDiffEq? For example: ")
                printstyled(io, "`using OrdinaryDiffEq`", color = :cyan)
            elseif exc.f === uniform_distribution
                print(
                    io,
                    "\nDid you forget to load Distributions and RecursiveArrayTools? For example: ",
                )
                printstyled(io, "`using Distributions, RecursiveArrayTools`", color = :cyan)
            end
        end
    end

    return nothing
end

include("deprecated.jl")

# Abstract main types
export AbstractCotangentVector,
    AbstractManifold, AbstractManifoldPoint, AbstractTangentVector
# Manifolds
export AbstractSphere, AbstractProjectiveSpace
export Euclidean,
    ArrayProjectiveSpace,
    ArraySphere,
    CenteredMatrices,
    CholeskySpace,
    Circle,
    DeterminantOneMatrices,
    Elliptope,
    EssentialManifold,
    FixedRankMatrices,
    Flag,
    GeneralizedGrassmann,
    GeneralizedStiefel,
    Grassmann,
    HamiltonianMatrices,
    HeisenbergMatrices,
    Hyperbolic,
    Hyperrectangle,
    InvertibleMatrices,
    KendallsPreShapeSpace,
    KendallsShapeSpace,
    Lorentz,
    MultinomialDoubleStochastic,
    MultinomialMatrices,
    MultinomialSymmetric,
    MultinomialSymmetricPositiveDefinite,
    Oblique,
    OrthogonalMatrices,
    PositiveArrays,
    PositiveMatrices,
    PositiveNumbers,
    PositiveVectors,
    ProbabilitySimplex,
    ProjectiveSpace,
    Rotations,
    Segre,
    SkewHermitianMatrices,
    SkewSymmetricMatrices,
    SpecialUnitaryMatrices,
    Spectrahedron,
    Sphere,
    SphereSymmetricMatrices,
    Stiefel,
    SymmetricMatrices,
    SymmetricPositiveDefinite,
    SPDFixedDeterminant,
    SymmetricPositiveSemidefiniteFixedRank,
    SymplecticGrassmann,
    SymplecticMatrices,
    SymplecticStiefel,
    SymplecticElement,
    Torus,
    Tucker,
    UnitaryMatrices
# Point representation types
export HyperboloidPoint,
    OrthogonalPoint,
    PoincareBallPoint,
    PoincareHalfSpacePoint,
    StiefelFactorization,
    StiefelPoint,
    SVDMPoint,
    TuckerPoint,
    ProjectorPoint,
    SPDPoint
# Tangent vector representation types
export HyperboloidTangentVector,
    OrthogonalTangentVector,
    PoincareBallTangentVector,
    PoincareHalfSpaceTangentVector,
    TuckerTangentVector,
    UMVTangentVector,
    ProjectorTangentVector,
    StiefelTangentVector
export AbstractNumbers, ℝ, ℂ, ℍ
export Hamiltonian
# decorator manifolds
export AbstractDecoratorManifold
export ValidationManifold,
    ValidationMPoint, ValidationTangentVector, ValidationCotangentVector
export Fiber, FiberBundle, CotangentBundle, CotangentSpace, FVector
export AbstractPowerManifold,
    AbstractPowerRepresentation,
    ArrayPowerRepresentation,
    NestedPowerRepresentation,
    NestedReplacingPowerRepresentation,
    PowerManifold
export ProductManifold, EmbeddedManifold
export GraphManifold, GraphManifoldType, VertexManifold, EdgeManifold
export TangentBundle
export TangentSpace, VectorSpaceFiber, VectorSpaceType, VectorBundle
export AbstractVectorTransportMethod,
    DifferentiatedRetractionVectorTransport, ParallelTransport
export PoleLadderTransport, SchildsLadderTransport
export ProductVectorTransport
export AbstractAffineConnection, ConnectionManifold, LeviCivitaConnection
export MetricManifold
# Metric types
export AbstractMetric,
    AffineInvariantMetric,
    BuresWassersteinMetric,
    CanonicalMetric,
    DefaultMetric,
    EuclideanMetric,
    ExtendedSymplecticMetric,
    FisherRaoMetric,
    GeneralizedBuresWassersteinMetric,
    LogCholeskyMetric,
    LogEuclideanMetric,
    LorentzMetric,
    MinkowskiMetric,
    PowerMetric,
    ProductMetric,
    RealSymplecticMetric,
    RiemannianMetric,
    StiefelSubmersionMetric,
    WarpedMetric
export AbstractAtlas, RetractionAtlas
# Vector transport types
export AbstractVectorTransportMethod, ParallelTransport, ProjectionTransport
# Retraction types
export AbstractRetractionMethod,
    CayleyRetraction,
    ExponentialRetraction,
    QRRetraction,
    PolarRetraction,
    ProjectionRetraction,
    SoftmaxRetraction,
    OrthographicRetraction,
    PadeRetraction,
    ProductRetraction,
    SasakiRetraction,
    StabilizedRetraction
# Inverse Retraction types
export AbstractInverseRetractionMethod,
    ApproximateInverseRetraction,
    ApproximateLogarithmicMap,
    CayleyInverseRetraction,
    LogarithmicInverseRetraction,
    QRInverseRetraction,
    OrthographicInverseRetraction,
    PolarInverseRetraction,
    ProjectionInverseRetraction,
    ShootingInverseRetraction,
    SoftmaxInverseRetraction
# Estimation methods for median and mean
export AbstractApproximationMethod,
    GradientDescentEstimation,
    CyclicProximalPointEstimation,
    EfficientEstimator,
    GeodesicInterpolation,
    GeodesicInterpolationWithinRadius,
    ExtrinsicEstimation
# Tangent space bases
export CachedBasis,
    DefaultBasis,
    DefaultOrthogonalBasis,
    DefaultOrthonormalBasis,
    DiagonalizingOrthonormalBasis,
    InducedBasis,
    ProjectedOrthonormalBasis
# Errors on Manifolds
export ComponentManifoldError, CompositeManifoldError, ManifoldDomainError
# Functions on Manifolds
export ×,
    ^,
    affine_connection,
    affine_connection!,
    allocate,
    allocate_result,
    base_manifold,
    bundle_projection,
    canonical_project,
    canonical_project!,
    change_basis,
    change_basis!,
    change_metric,
    change_metric!,
    change_representer,
    change_representer!,
    check_chart_switch,
    check_point,
    check_vector,
    christoffel_symbols_first,
    christoffel_symbols_second,
    christoffel_symbols_second_jacobian,
    connected_by_geodesic,
    convert,
    complex_dot,
    decorated_manifold,
    default_approximation_method,
    default_inverse_retraction_method,
    default_retraction_method,
    default_vector_transport_method,
    det_local_metric,
    distance,
    dual_basis,
    einstein_tensor,
    embed,
    embed!,
    embed_project,
    embed_project!,
    exp,
    exp!,
    flat,
    flat!,
    gaussian_curvature,
    geodesic,
    geodesic!,
    get_default_atlas,
    get_component,
    get_embedding,
    get_total_space,
    has_components,
    hat,
    hat!,
    horizontal_component,
    horizontal_component!,
    horizontal_lift,
    horizontal_lift!,
    induced_basis,
    incident_log,
    injectivity_radius,
    inner,
    inv,
    inv!,
    inverse_local_metric,
    inverse_retract,
    inverse_retract!,
    isapprox,
    is_default_connection,
    is_default_metric,
    is_flat,
    is_hamiltonian,
    is_point,
    is_vector,
    kurtosis,
    local_metric,
    local_metric_jacobian,
    log,
    log!,
    log_local_metric_density,
    manifold_dimension,
    manifold_volume,
    metric,
    mean,
    mean!,
    mean_and_var,
    mean_and_std,
    median,
    median!,
    mid_point,
    mid_point!,
    minkowski_metric,
    moment,
    norm,
    number_eltype,
    number_of_coordinates,
    one,
    power_dimensions,
    parallel_transport_direction,
    parallel_transport_direction!,
    parallel_transport_to,
    parallel_transport_to!,
    project,
    project!,
    rand,
    rand!,
    real_dimension,
    ricci_curvature,
    ricci_tensor,
    representation_size,
    retract,
    retract!,
    riemannian_gradient,
    riemannian_gradient!,
    riemannian_Hessian,
    riemannian_Hessian!,
    riemann_tensor,
    riemann_tensor!,
    sectional_curvature,
    sectional_curvature_matrix,
    sectional_curvature_max,
    sectional_curvature_min,
    set_component!,
    sharp,
    sharp!,
    shortest_geodesic,
    shortest_geodesic!,
    skewness,
    std,
    sym_rem,
    symplectic_inverse,
    symplectic_inverse!,
    symplectic_inverse_times,
    symplectic_inverse_times!,
    submanifold,
    submanifold_component,
    submanifold_components,
    var,
    vector_space_dimension,
    vector_transport_direction,
    vector_transport_direction!,
    vector_transport_to,
    vector_transport_to!,
    vee,
    vee!,
    vertical_component,
    vertical_component!,
    volume_density,
    Weingarten,
    Weingarten!,
    zero_vector,
    zero_vector!
# Orthonormal bases
export AbstractBasis,
    AbstractOrthonormalBasis,
    DefaultOrthonormalBasis,
    DiagonalizingOrthonormalBasis,
    ProjectedOrthonormalBasis,
    CachedBasis,
    DiagonalizingBasisData,
    ProductBasisData,
    PowerBasisData
export OutOfInjectivityRadiusError
export get_basis,
    get_coordinates, get_coordinates!, get_vector, get_vector!, get_vectors, number_system

# atlases and charts
export get_point, get_point!, get_parameters, get_parameters!

# Last (not least, but _after_ exports) include the test submodule
include("test.jl")

end # module

@doc raw"""
    Tucker{T, D, 𝔽} <: AbstractManifold{𝔽}

The manifold of ``N_1×\dots×N_D`` real-valued or complex-valued tensors of
fixed multilinear rank ``(R_1, \dots, R_D)`` . If ``R_1 = \dots = R_D = 1``, this is the
Segre manifold, i.e., the set of rank-1 tensors.

# Representation in HOSVD format

Let ``𝔽`` be the real or complex numbers.
Any tensor ``p`` on the Tucker manifold can be represented as a multilinear product in HOSVD
[DeLathauwerDeMoorVanderwalle:2000](@cite) form
```math
p = (U_1,\dots,U_D) ⋅ \mathcal{C}
```
where ``\mathcal C \in 𝔽^{R_1×\dots×R_D}`` and, for ``d=1,\dots,D``,
the matrix ``U_d \in 𝔽^{N_d×R_d}`` contains the singular vectors of the
``d``th unfolding of ``\mathcal{A}``

# Tangent space

The tangent space to the Tucker manifold at
``p = (U_1,\dots,U_D) ⋅ \mathcal{C}`` is [KochLubich:2010](@cite)
```math
T_p \mathcal{M} =
\bigl\{
(U_1,\dots,U_D) ⋅ \mathcal{C}^\prime
+ \sum_{d=1}^D \bigl(
    (U_1, \dots, U_{d-1}, U_d^\prime, U_{d+1}, \dots, U_D)
    ⋅ \mathcal{C}
\bigr)
\bigr\}
```
where ``\mathcal{C}^\prime`` is arbitrary, ``U_d^{\mathrm{H}}`` is the Hermitian adjoint of
``U_d``, and ``U_d^{\mathrm{H}} U_d^\prime = 0`` for all ``d``.

# Constructor

    Tucker(N::NTuple{D, Int}, R::NTuple{D, Int}[, field=ℝ]; parameter::Symbol=:type)

Generate the manifold of `field`-valued tensors of dimensions  `N[1] × … × N[D]` and
multilinear rank `R = (R[1], …, R[D])`.
"""
struct Tucker{𝔽, T, D} <: AbstractManifold{𝔽}
    size::T
end
function Tucker(
        n⃗::NTuple{D, Int},
        r⃗::NTuple{D, Int},
        field::AbstractNumbers = ℝ;
        parameter::Symbol = :type,
    ) where {D}
    @assert is_valid_mlrank(n⃗, r⃗)
    size = wrap_type_parameter(parameter, (n⃗, r⃗))
    return Tucker{field, typeof(size), D}(size)
end

#=
HOSVD{T, D}

Higher-order singular value decomposition of an order D tensor with eltype T
fields:
* U: singular vectors of the unfoldings
* core: core tensor
* σ : singular values of the unfoldings
=#
struct HOSVD{T, D}
    U::NTuple{D, Matrix{T}}
    core::Array{T, D}
    σ::NTuple{D, Vector{T}}
end

@doc raw"""
    TuckerPoint{T,D}

An order `D` tensor of fixed multilinear rank and entries of type `T`, which makes it a
point on the [`Tucker`](@ref) manifold. The tensor is represented in HOSVD form.

# Constructors:
    TuckerPoint(core::AbstractArray{T,D}, factors::Vararg{<:AbstractMatrix{T},D}) where {T,D}

Construct an order `D` tensor of element type `T` that can be represented as the
multilinear product `(factors[1], …, factors[D]) ⋅ core`.
It is assumed that the dimensions of the core are the multilinear
rank of the tensor and that the matrices `factors` each have full rank. No further
assumptions are made.

    TuckerPoint(p::AbstractArray{T,D}, mlrank::NTuple{D,Int}) where {T,D}

The low-multilinear rank tensor arising from the sequentially truncated the higher-order
singular value decomposition of the `D`-dimensional array `p` of type `T`. The singular
values are truncated to get a multilinear rank `mlrank`
[VannieuwenhovenVanderbrilMeerbergen:2012](@cite).
"""
struct TuckerPoint{T, D} <: AbstractManifoldPoint
    hosvd::HOSVD{T, D}
end
function TuckerPoint(
        core::AbstractArray{T, D},
        factors::Vararg{MtxT, D},
    ) where {T, D, MtxT <: AbstractMatrix{T}}
    # Take the QR decompositions of the factors and multiply the R factors into the core
    qrfacs = qr.(factors)
    Q = map(qrfac -> qrfac.Q, qrfacs)
    R = map(qrfac -> qrfac.R, qrfacs)
    core′ = reshape(Kronecker.:⊗(reverse(R)...) * vec(core), size(core))

    # Convert to HOSVD format by taking the HOSVD of the core
    decomp = st_hosvd(core′)
    factors′ = Q .* decomp.U
    return TuckerPoint(HOSVD{T, D}(factors′, decomp.core, decomp.σ))
end
function TuckerPoint(A::AbstractArray{T, D}, mlrank::NTuple{D, Int}) where {T, D}
    @assert is_valid_mlrank(size(A), mlrank)
    return TuckerPoint(st_hosvd(A, mlrank))
end

@doc raw"""
    TuckerTangentVector{T, D} <: AbstractTangentVector

Tangent vector to the `D`-th order [`Tucker`](@ref) manifold at
``p = (U_1,\dots,U_D) ⋅ \mathcal{C}``. The numbers are of type `T` and the vector is
represented as
````math
X =
(U_1,\dots,U_D) ⋅ \mathcal{C}^\prime +
\sum_{d=1}^D (U_1,\dots,U_{d-1},U_d^\prime,U_{d+1},\dots,U_D) ⋅ \mathcal{C}
````
where ``U_d^\mathrm{H} U_d^\prime = 0``.

# Constructor
    TuckerTangentVector(C′::Array{T,D}, U′::NTuple{D,Matrix{T}}) where {T,D}

Constructs a `D`th order [`TuckerTangentVector`](@ref) of number type `T` with ``C^\prime``
and ``U^\prime``, so that, together with a
[`TuckerPoint`](@ref) ``p`` as above, the tangent vector can be represented as ``X`` in the
above expression.
"""
struct TuckerTangentVector{T, D} <: AbstractTangentVector
    Ċ::Array{T, D}
    U̇::NTuple{D, Matrix{T}}
end

# An implicitly stored basis of the tangent space to the Tucker manifold. This is the basis
# from [Dewaele2021] and acts as the default orthonormal basis.
struct HOSVDBasis{T, D}
    point::TuckerPoint{T, D}
    U⊥::NTuple{D, Matrix{T}}
end
CachedHOSVDBasis{𝔽, T, D} =
    CachedBasis{𝔽, DefaultOrthonormalBasis{𝔽, TangentSpaceType}, HOSVDBasis{T, D}}

⊗ᴿ(a...) = Kronecker.:⊗(reverse(a)...)

Base.:*(s::Number, x::TuckerTangentVector) = TuckerTangentVector(s * x.Ċ, s .* x.U̇)
Base.:*(x::TuckerTangentVector, s::Number) = TuckerTangentVector(x.Ċ * s, x.U̇ .* s)
Base.:/(x::TuckerTangentVector, s::Number) = TuckerTangentVector(x.Ċ / s, x.U̇ ./ s)
Base.:\(s::Number, x::TuckerTangentVector) = TuckerTangentVector(s \ x.Ċ, s .\ x.U̇)
function Base.:+(x::TuckerTangentVector, y::TuckerTangentVector)
    return TuckerTangentVector(x.Ċ + y.Ċ, x.U̇ .+ y.U̇)
end
function Base.:-(x::TuckerTangentVector, y::TuckerTangentVector)
    return TuckerTangentVector(x.Ċ - y.Ċ, x.U̇ .- y.U̇)
end
Base.:-(x::TuckerTangentVector) = TuckerTangentVector(-x.Ċ, map(-, x.U̇))
Base.:+(x::TuckerTangentVector) = TuckerTangentVector(x.Ċ, x.U̇)
function Base.:(==)(x::TuckerTangentVector, y::TuckerTangentVector)
    return (x.Ċ == y.Ċ) && all(x.U̇ .== y.U̇)
end

allocate(p::TuckerPoint) = allocate(p, number_eltype(p))
function allocate(p::TuckerPoint{Tp, D}, ::Type{T}) where {T, Tp, D}
    @assert promote_type(Tp, T) == T
    return TuckerPoint(
        HOSVD(allocate(p.hosvd.U, T), allocate(p.hosvd.core, T), allocate(p.hosvd.σ, T)),
    )
end
allocate(x::TuckerTangentVector) = allocate(x, number_eltype(x))
function allocate(x::TuckerTangentVector, ::Type{T}) where {T}
    return TuckerTangentVector(allocate(x.Ċ, T), allocate(x.U̇, T))
end

# Tuple-like broadcasting of TuckerTangentVector
Base.axes(::TuckerTangentVector) = ()

function Broadcast.BroadcastStyle(::Type{TuckerTangentVector{T, D}}) where {T, D}
    return Broadcast.Style{TuckerTangentVector{Any, D}}()
end
function Broadcast.BroadcastStyle(
        ::Broadcast.AbstractArrayStyle{0},
        b::Broadcast.Style{<:TuckerTangentVector},
    )
    return b
end

function Broadcast.instantiate(
        bc::Broadcast.Broadcasted{Broadcast.Style{TuckerTangentVector{Any, D}}, Nothing},
    ) where {D}
    return bc
end
function Broadcast.instantiate(
        bc::Broadcast.Broadcasted{Broadcast.Style{TuckerTangentVector{Any, D}}},
    ) where {D}
    Broadcast.check_broadcast_axes(bc.axes, bc.args...)
    return bc
end

Broadcast.broadcastable(v::TuckerTangentVector) = v

Base.@propagate_inbounds function Broadcast._broadcast_getindex(
        v::TuckerTangentVector,
        ::Val{I},
    ) where {I}
    if I isa Symbol
        return getfield(v, I)
    else
        return getfield(v, I[1])[I[2]]
    end
end

@doc raw"""
    check_point(M::Tucker, p; kwargs...)

Check whether the multidimensional array or [`TuckerPoint`](@ref) `p` is a point on the
[`Tucker`](@ref) manifold, i.e. it is a `D`th order `N[1] × … × N[D]` tensor of multilinear
rank `(R[1], …, R[D])`. The keyword arguments are passed to the matrix rank function applied
to the unfoldings.
For a [`TuckerPoint`](@ref) it is checked that the point is in correct HOSVD form.
"""
function check_point(M::Tucker, x; kwargs...)
    N, R = get_parameter(M.size)
    s = "The point $(x) does not lie on $(M), "
    size(x) == N || return DomainError(size(x), s * "since its size is not $(N).")
    x_buffer = similar(x)
    for d in 1:ndims(x)
        r = rank(tensor_unfold!(x_buffer, x, d); kwargs...)
        r == R[d] || return DomainError(size(x), s * "since its rank is not $(R).")
    end
    return nothing
end
function check_point(M::Tucker, x::TuckerPoint; kwargs...)
    N, R = get_parameter(M.size)
    s = "The point $(x) does not lie on $(M), "
    U = x.hosvd.U
    ℭ = x.hosvd.core
    if size(ℭ) ≠ R
        return DomainError(
            size(x.hosvd.core),
            s * "since the size of the core is not $(R).",
        )
    end
    if size(x) ≠ N
        return DomainError(size(x), s * "since its dimensions are not $(N).")
    end
    for u in U
        if u' * u ≉ LinearAlgebra.I
            return DomainError(
                norm(u' * u - LinearAlgebra.I),
                s * "since its factor matrices are not unitary.",
            )
        end
    end
    ℭ_buffer = similar(ℭ)
    for d in 1:ndims(x.hosvd.core)
        ℭ⁽ᵈ⁾ = tensor_unfold!(ℭ_buffer, ℭ, d)
        gram = ℭ⁽ᵈ⁾ * ℭ⁽ᵈ⁾'
        if gram ≉ Diagonal(x.hosvd.σ[d])^2
            return DomainError(
                norm(gram - Diagonal(x.hosvd.σ[d])^2),
                s *
                    "since the unfoldings of the core are not diagonalised by" *
                    "the singular values.",
            )
        end
        if rank(Diagonal(x.hosvd.σ[d]); kwargs...) ≠ R[d]
            return DomainError(
                minimum(x.hosvd.σ[d]),
                s * "since the core does not have full multilinear rank.",
            )
        end
    end
    return nothing
end

@doc raw"""
    check_vector(M::Tucker{<:Any,D}, p::TuckerPoint{T,D}, X::TuckerTangentVector) where {T,D}

Check whether a [`TuckerTangentVector`](@ref) `X` is is in the tangent space to
the `D`th order [`Tucker`](@ref) manifold `M` at the `D`th order [`TuckerPoint`](@ref) `p`.
This
is the case when the dimensions of the factors in `X` agree with those of `p` and the factor
matrices of `X` are in the orthogonal complement of the HOSVD factors of `p`.
"""
function check_vector(
        M::Tucker{𝔽, <:Any, D},
        p::TuckerPoint{T, D},
        X::TuckerTangentVector,
    ) where {T, D, 𝔽}
    s = "The tangent vector $(X) is not a tangent vector to $(p) on $(M), "
    if size(p.hosvd.core) ≠ size(X.Ċ) || any(size.(X.U̇) .≠ size.(p.hosvd.U))
        return DomainError(
            size(X.Ċ),
            s * "since the array dimensons of $(p) and $(X)" * " do not agree.",
        )
    end
    for (U, U̇) in zip(p.hosvd.U, X.U̇)
        if norm(U' * U̇) ≥ √eps(eltype(U)) * √length(U)
            return DomainError(
                norm(U' * U̇),
                s *
                    "since the columns of x.hosvd.U are not" *
                    "orthogonal to those of X.U̇.",
            )
        end
    end
    return nothing
end

"""
    Base.convert(::Type{Matrix{T}}, basis::CachedBasis{𝔽,DefaultOrthonormalBasis{𝔽, TangentSpaceType},HOSVDBasis{T, D}}) where {𝔽, T, D}
    Base.convert(::Type{Matrix}, basis::CachedBasis{𝔽,DefaultOrthonormalBasis{𝔽, TangentSpaceType},HOSVDBasis{T, D}}) where {𝔽, T, D}

Convert a HOSVD-derived cached basis from [DewaeleBreidingVannieuwenhoven:2021](@cite) of the `D`th order
[`Tucker`](@ref) manifold with number type `T` to a matrix.
The columns of this matrix are the vectorisations of the
[`embed`](@ref)dings of the basis vectors.
"""
function Base.convert(::Type{Matrix{T}}, ℬ::CachedHOSVDBasis{𝔽, T, D}) where {𝔽, T, D}
    𝔄 = ℬ.data.point
    r⃗ = size(𝔄.hosvd.core)
    n⃗ = size(𝔄)
    ℳ = Tucker(n⃗, r⃗)

    J = Matrix{T}(undef, prod(n⃗), manifold_dimension(ℳ))
    # compute all possible ∂𝔄╱∂ℭ (in one go is quicker than one vector at a time)
    J[:, 1:prod(r⃗)] = ⊗ᴿ(𝔄.hosvd.U...)
    # compute all possible ∂𝔄╱∂U[d] for d = 1,...,D
    function fill_column!(i, vᵢ)
        Jᵢ_tensor = reshape(view(J, :, i), n⃗) # changes to this apply to J as well
        return embed!(ℳ, Jᵢ_tensor, 𝔄, vᵢ)
    end
    foreach(fill_column!, ℳ, 𝔄, ℬ, (prod(r⃗) + 1):manifold_dimension(ℳ))
    return J
end
function Base.convert(::Type{Matrix}, basis::CachedHOSVDBasis{𝔽, T, D}) where {𝔽, T, D}
    return convert(Matrix{T}, basis)
end

@inline function Base.copy(
        bc::Broadcast.Broadcasted{Broadcast.Style{TuckerTangentVector{Any, D}}},
    ) where {D}
    return TuckerTangentVector(
        @inbounds(Broadcast._broadcast_getindex(bc, Val(:Ċ))),                  # COV_EXCL_LINE
        ntuple(i -> @inbounds(Broadcast._broadcast_getindex(bc, Val((:U̇, i)))), Val(D)),
    )
end
Base.copy(x::TuckerTangentVector) = TuckerTangentVector(copy(x.Ċ), map(copy, x.U̇))

function Base.copyto!(q::TuckerPoint, p::TuckerPoint)
    for d in 1:ndims(q)
        copyto!(q.hosvd.U[d], p.hosvd.U[d])
        copyto!(q.hosvd.σ[d], p.hosvd.σ[d])
    end
    copyto!(q.hosvd.core, p.hosvd.core)
    return q
end
function Base.copyto!(y::TuckerTangentVector, x::TuckerTangentVector)
    for d in 1:ndims(y.Ċ)
        copyto!(y.U̇[d], x.U̇[d])
    end
    copyto!(y.Ċ, x.Ċ)
    return y
end
@inline function Base.copyto!(
        dest::TuckerTangentVector,
        bc::Broadcast.Broadcasted{Broadcast.Style{TuckerTangentVector{Any, D}}},
    ) where {D}
    # Performance optimization: broadcast!(identity, dest, A) is equivalent to copyto!(dest, A) if indices match
    if bc.f === identity && bc.args isa Tuple{TuckerTangentVector} # only a single input argument to broadcast!
        A = bc.args[1]
        return copyto!(dest, A)
    end
    bc′ = Broadcast.preprocess(dest, bc)
    copyto!(dest.Ċ, Broadcast._broadcast_getindex(bc′, Val(:Ċ)))
    for i in 1:D
        copyto!(dest.U̇[i], Broadcast._broadcast_getindex(bc, Val((:U̇, i))))
    end
    return dest
end

@doc raw"""
    embed(::Tucker, p::TuckerPoint)

Convert a [`TuckerPoint`](@ref) `p` on the rank `R` [`Tucker`](@ref) manifold to a full
`N[1] × … × N[D]`-array by evaluating the Tucker decomposition.
"""
embed(::Tucker, ::TuckerPoint)
@doc raw"""
    embed(::Tucker, p::TuckerPoint, X::TuckerTangentVector)

Convert a tangent vector `X` with base point `p` on the rank `R` [`Tucker`](@ref)
manifold to a full tensor, represented as an `N[1] × … × N[D]`-array.
"""
embed(::Tucker, p::TuckerPoint, X::TuckerTangentVector)

function embed!(::Tucker, q, p::TuckerPoint)
    return copyto!(q, reshape(⊗ᴿ(p.hosvd.U...) * vec(p.hosvd.core), size(p)))
end
function embed!(ℳ::Tucker, Y, 𝔄::TuckerPoint{T, D}, X::TuckerTangentVector) where {T, D}
    mul!(vec(Y), ⊗ᴿ(𝔄.hosvd.U...), vec(X.Ċ))
    𝔄_embedded = embed(ℳ, 𝔄)
    buffer = similar(𝔄_embedded)
    for k in 1:D
        U̇ₖUₖᵀ𝔄₍ₖ₎ = X.U̇[k] * (𝔄.hosvd.U[k]' * tensor_unfold!(buffer, 𝔄_embedded, k))
        Y .= Y + tensor_fold!(buffer, U̇ₖUₖᵀ𝔄₍ₖ₎, k)
    end
    return Y
end

@doc raw"""
    Base.foreach(f, M::Tucker, p::TuckerPoint, basis::AbstractBasis, indices=1:manifold_dimension(M))

Let `basis` be and [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`) at a point `p` on `M`. Suppose `f` is a function
that takes an index and a vector as an argument.
This function applies `f` to `i` and the `i`th basis vector sequentially for each `i` in
`indices`.
Using a [`CachedBasis`](@extref `ManifoldsBase.CachedBasis`) may speed up the computation.

**NOTE**: The i'th basis vector is overwritten in each iteration. If any information about
the vector is to be stored, `f` must make a copy.
"""
function Base.foreach(
        f,
        M::Tucker,
        p::TuckerPoint,
        basis::AbstractBasis,
        indices = 1:manifold_dimension(M),
    )
    # Use in-place variants to avoid superfluous allocation
    bᵢ = zero_vector(M, p)
    eᵢ = zeros(number_eltype(p), manifold_dimension(M))
    for i in indices
        eᵢ[i] = one(eltype(eᵢ))
        get_vector!(M, bᵢ, p, eᵢ, basis)
        eᵢ[i] = zero(eltype(eᵢ))
        f(i, bᵢ)
    end
    return
end

@doc raw"""
    get_basis(:: Tucker, p::TuckerPoint, basisType::DefaultOrthonormalBasis{𝔽, TangentSpaceType}) where 𝔽

An implicitly stored basis of the tangent space to the Tucker manifold.
Assume ``p = (U_1,\dots,U_D) ⋅ \mathcal{C}`` is in HOSVD format and that, for
``d=1,\dots,D``, the singular values of the
``d``'th unfolding are ``\sigma_{dj}``, with ``j = 1,\dots,R_d``.
The basis of the tangent space is as follows: [DewaeleBreidingVannieuwenhoven:2021](@cite)

````math
\bigl\{
(U_1,\dots,U_D) e_i
\bigr\} \cup \bigl\{
(U_1,\dots, \sigma_{dj}^{-1} U_d^{\perp} e_i e_j^T,\dots,U_D) ⋅ \mathcal{C}
\bigr\}
````

for all ``d = 1,\dots,D`` and all canonical basis vectors ``e_i`` and ``e_j``.
Every ``U_d^\perp`` is such that ``[U_d \quad U_d^{\perp}]`` forms an orthonormal basis
of ``ℝ^{N_d}``.
"""
function get_basis(
        ::Tucker,
        𝔄::TuckerPoint,
        basisType::DefaultOrthonormalBasis{𝔽, TangentSpaceType} = DefaultOrthonormalBasis(),
    ) where {𝔽}
    D = ndims(𝔄)
    n⃗ = size(𝔄)
    r⃗ = size(𝔄.hosvd.core)
    U = 𝔄.hosvd.U
    U⊥ = ntuple(d -> Matrix(qr(I - U[d] * U[d]', ColumnNorm()).Q)[:, 1:(n⃗[d] - r⃗[d])], D)
    basis = HOSVDBasis(𝔄, U⊥)
    return CachedBasis(basisType, basis)
end

#=
get_coordinates(::Tucker, A, X::TuckerTangentVector, b)

The coordinates of a tangent vector X at point A on the Tucker manifold with respect to the
basis b.
=#
function get_coordinates(::Tucker, 𝔄, X::TuckerTangentVector, ℬ::CachedHOSVDBasis)
    coords = vec(X.Ċ)
    for d in 1:length(X.U̇)
        coord_mtx = (ℬ.data.U⊥[d] \ X.U̇[d]) * Diagonal(𝔄.hosvd.σ[d])
        coords = vcat(coords, vec(coord_mtx'))
    end
    return coords
end
function get_coordinates(
        M::Tucker,
        𝔄,
        X,
        ℬ::DefaultOrthonormalBasis{𝔽, TangentSpaceType},
    ) where {𝔽}
    return get_coordinates(M, 𝔄, X, get_basis(M, 𝔄, ℬ))
end

#=
get_vector(::Tucker, A, x, b)

The tangent vector at a point A whose coordinates with respect to the basis b are x.
=#
function get_vector!(
        ::Tucker,
        y,
        𝔄::TuckerPoint,
        x::AbstractVector{T},
        ℬ::CachedHOSVDBasis,
    ) where {T}
    ξ = convert(Vector{promote_type(number_eltype(𝔄), eltype(x))}, x)
    ℭ = 𝔄.hosvd.core
    σ = 𝔄.hosvd.σ
    U⊥ = ℬ.data.U⊥
    D = ndims(ℭ)
    r⃗ = size(ℭ)
    n⃗ = size(𝔄)

    # split ξ into ξ_core and ξU so that vcat(ξ_core, ξU...) == ξ, but avoid copying
    ξ_core = view(ξ, 1:length(ℭ))
    ξU = Vector{typeof(ξ_core)}(undef, D)
    nextcolumn = length(ℭ) + 1
    for d in 1:D
        numcols = r⃗[d] * (n⃗[d] - r⃗[d])
        ξU[d] = view(ξ, nextcolumn:(nextcolumn + numcols - 1))
        nextcolumn += numcols
    end

    # Construct ∂U[d] by plugging in the definition of the orthonormal basis [Dewaele2021]
    # ∂U[d] = ∑ᵢⱼ { ξU[d]ᵢⱼ (σ[d]ⱼ)⁻¹ U⊥[d] 𝐞ᵢ 𝐞ⱼᵀ }
    #       = U⊥[d] * ∑ⱼ (σ[d]ⱼ)⁻¹ (∑ᵢ ξU[d]ᵢⱼ  𝐞ᵢ) 𝐞ⱼᵀ
    # ξU[d] = [ξ₁₁, ..., ξ₁ⱼ, ..., ξᵢ₁, ..., ξᵢⱼ, ..., ]
    # => turn these i and j into matrix indices and do matrix operations
    for d in 1:D
        grid = transpose(reshape(ξU[d], r⃗[d], n⃗[d] - r⃗[d]))
        mul!(y.U̇[d], U⊥[d], grid * Diagonal(1 ./ σ[d]))
    end

    y.Ċ .= reshape(ξ_core, size(y.Ċ))
    return y
end
function get_vector!(
        ℳ::Tucker,
        y,
        𝔄::TuckerPoint,
        x,
        ℬ::DefaultOrthonormalBasis{𝔽, TangentSpaceType},
    ) where {𝔽}
    return get_vector!(ℳ, y, 𝔄, x, get_basis(ℳ, 𝔄, ℬ))
end

function get_vectors(ℳ::Tucker, 𝔄::TuckerPoint{T, D}, ℬ::CachedHOSVDBasis) where {T, D}
    vectors = Vector{TuckerTangentVector{T, D}}(undef, manifold_dimension(ℳ))
    foreach((i, vᵢ) -> setindex!(vectors, copy(vᵢ), i), ℳ, 𝔄, ℬ)
    return vectors
end
function get_vectors(ℳ::Tucker, 𝔄::TuckerPoint, ℬ::DefaultOrthonormalBasis)
    return get_vectors(ℳ, 𝔄, get_basis(ℳ, 𝔄, ℬ))
end

"""
    inner(M::Tucker, p::TuckerPoint, X::TuckerTangentVector, Y::TuckerTangentVector)

The Euclidean inner product between tangent vectors `X` and `X` at the point `p` on
the Tucker manifold. This is equal to `embed(M, p, X) ⋅ embed(M, p, Y)`.

    inner(::Tucker, A::TuckerPoint, X::TuckerTangentVector, Y)
    inner(::Tucker, A::TuckerPoint, X, Y::TuckerTangentVector)

The Euclidean inner product between `X` and `Y` where `X` is a vector tangent to the Tucker
manifold at `p` and `Y` is a vector in the ambient space or vice versa. The vector in the
ambient space is represented as a full tensor, i.e., a multidimensional array.
"""
function inner(::Tucker, 𝔄::TuckerPoint, x::TuckerTangentVector, y::TuckerTangentVector)
    ℭ = 𝔄.hosvd.core
    dotprod = dot(x.Ċ, y.Ċ)
    ℭ_buffer = similar(ℭ)
    for k in 1:ndims(𝔄)
        ℭ₍ₖ₎ = tensor_unfold!(ℭ_buffer, ℭ, k)
        dotprod += dot(x.U̇[k] * ℭ₍ₖ₎, y.U̇[k] * ℭ₍ₖ₎)
    end
    return dotprod
end
inner(M::Tucker, 𝔄::TuckerPoint, x::TuckerTangentVector, y) = dot(embed(M, 𝔄, x), y)
inner(M::Tucker, 𝔄::TuckerPoint, x, y::TuckerTangentVector) = dot(x, embed(M, 𝔄, y))

"""
    inverse_retract(M::Tucker, p::TuckerPoint, q::TuckerPoint, ::ProjectionInverseRetraction)

The projection inverse retraction on the Tucker manifold interprets `q` as a point in the
ambient Euclidean space (see [`embed`](@ref)) and projects it onto the tangent space at
to `M` at `p`.
"""
inverse_retract(
    ::Tucker,
    ::Any,
    ::TuckerPoint,
    ::TuckerPoint,
    ::ProjectionInverseRetraction,
)

function inverse_retract_project!(ℳ::Tucker, X, 𝔄::TuckerPoint, 𝔅::TuckerPoint)
    diffVector = embed(ℳ, 𝔅) - embed(ℳ, 𝔄)
    return project!(ℳ, X, 𝔄, diffVector)
end

function isapprox(p::TuckerPoint, q::TuckerPoint; kwargs...)
    ℳ = Tucker(size(p), size(p.hosvd.core))
    return isapprox(embed(ℳ, p), embed(ℳ, q); kwargs...)
end
isapprox(::Tucker, p::TuckerPoint, q::TuckerPoint; kwargs...) = isapprox(p, q; kwargs...)
function _isapprox(
        M::Tucker,
        p::TuckerPoint,
        x::TuckerTangentVector,
        y::TuckerTangentVector;
        kwargs...,
    )
    return isapprox(embed(M, p, x), embed(M, p, y); kwargs...)
end

"""
    is_flat(::Tucker)

Return false. [`Tucker`](@ref) is not a flat manifold.
"""
is_flat(M::Tucker) = false

#=
Determines whether there are tensors of dimensions n⃗ with multilinear rank r⃗
=#
function is_valid_mlrank(n⃗, r⃗)
    return all(r⃗ .≥ 1) &&
        all(r⃗ .≤ n⃗) &&
        all(ntuple(i -> r⃗[i] ≤ prod(r⃗) ÷ r⃗[i], length(r⃗)))
end

@doc raw"""
    manifold_dimension(::Tucker)

The dimension of the manifold of ``N_1×\dots×N_D`` tensors of multilinear
rank ``(R_1, \dots, R_D)``, i.e.
````math
\mathrm{dim}(\mathcal{M}) = \prod_{d=1}^D R_d + \sum_{d=1}^D R_d (N_d - R_d).
````
"""
function manifold_dimension(M::Tucker)
    n⃗, r⃗ = get_parameter(M.size)
    return prod(r⃗) + sum(r⃗ .* (n⃗ .- r⃗))
end

@doc raw"""
    Base.ndims(p::TuckerPoint{T,D}) where {T,D}

The order of the tensor corresponding to the [`TuckerPoint`](@ref) `p`, i.e., `D`.
"""
Base.ndims(::TuckerPoint{T, D}) where {T, D} = D

number_eltype(::TuckerPoint{T, D}) where {T, D} = T
number_eltype(::TuckerTangentVector{T, D}) where {T, D} = T

"""
    project(M::Tucker, p::TuckerPoint, X)

The least-squares projection of a dense tensor `X` onto the tangent space to `M` at `p`.
"""
project(::Tucker, ::Any, ::TuckerPoint, ::Any)

function project!(ℳ::Tucker, Y, 𝔄::TuckerPoint, X)
    ℬ = get_basis(ℳ, 𝔄, DefaultOrthonormalBasis())
    coords = Vector{number_eltype(𝔄)}(undef, manifold_dimension(ℳ))
    f!(i, ℬᵢ) = setindex!(coords, inner(ℳ, 𝔄, ℬᵢ, X), i)
    foreach(f!, ℳ, 𝔄, ℬ)
    return get_vector!(ℳ, Y, 𝔄, coords, ℬ)
end

@doc raw"""
    retract(::Tucker, p::TuckerPoint, X::TuckerTangentVector, ::PolarRetraction)

The truncated HOSVD-based retraction [KressnerSteinlechnerVandereycken:2013](@cite) to the Tucker manifold, i.e.
the result is the sequentially truncated HOSVD approximation of ``p + X``.

In the exceptional case that the multilinear rank of ``p + X`` is lower than that of ``p``, this
retraction produces a boundary point, which is outside the manifold.
"""
retract(::Tucker, ::Any, ::Any, ::PolarRetraction)

function ManifoldsBase.retract_polar!(
        ::Tucker,
        q::TuckerPoint,
        p::TuckerPoint{T, D},
        x::TuckerTangentVector,
    ) where {T, D}
    U = p.hosvd.U
    V = x.U̇
    ℭ = p.hosvd.core
    𝔊 = x.Ċ
    r⃗ = size(ℭ)

    # Build the core tensor S and the factors [Uᵈ  Vᵈ]
    S = zeros(T, 2 .* size(ℭ))
    S[CartesianIndices(ℭ)] = ℭ + 𝔊
    UQ = Matrix{T}[]
    buffer = similar(ℭ)
    for k in 1:D
        # We make the following adaptation to Kressner2014:
        # Fix the i'th term of the sum and replace Vᵢ by Qᵢ Rᵢ.
        # We can absorb the R factor into the core by replacing Vᵢ by Qᵢ
        # and C (in the i'th term of the sum) by C ×ᵢ Rᵢ
        Q, R = qr(V[k])
        idxOffset = CartesianIndex(ntuple(i -> i == k ? r⃗[k] : 0, D))
        ℭ⨉ₖR = tensor_fold!(buffer, R * tensor_unfold!(buffer, ℭ, k), k)
        S[CartesianIndices(ℭ) .+ idxOffset] = ℭ⨉ₖR
        push!(UQ, hcat(U[k], Matrix(Q)))
    end

    #Convert to truncated HOSVD of p + x
    hosvd_S = st_hosvd(S, r⃗)
    factors = UQ .* hosvd_S.U
    for i in 1:D
        q.hosvd.U[i] .= factors[i]
        q.hosvd.σ[i] .= hosvd_S.σ[i]
    end
    q.hosvd.core .= hosvd_S.core
    return q
end

function Base.show(
        io::IO,
        ::MIME"text/plain",
        ::Tucker{𝔽, TypeParameter{Tuple{n, r}}, D},
    ) where {n, r, D, 𝔽}
    return print(io, "Tucker($(n), $(r), $(𝔽))")
end
function Base.show(io::IO, ::MIME"text/plain", M::Tucker{𝔽, <:Tuple, D}) where {D, 𝔽}
    n, r = get_parameter(M.size)
    return print(io, "Tucker($(n), $(r), $(𝔽); parameter=:field)")
end

function Base.show(io::IO, ::MIME"text/plain", 𝔄::TuckerPoint)
    pre = " "
    summary(io, 𝔄)
    for d in eachindex(𝔄.hosvd.U)
        println(io, string("\nU factor ", d, ":"))
        su = sprint(show, "text/plain", 𝔄.hosvd.U[d]; context = io, sizehint = 0)
        su = replace(su, '\n' => "\n$(pre)")
        println(io, pre, su)
    end
    println(io, "\nCore:")
    su = sprint(show, "text/plain", 𝔄.hosvd.core; context = io, sizehint = 0)
    su = replace(su, '\n' => "\n$(pre)")
    return print(io, pre, su)
end
function Base.show(io::IO, ::MIME"text/plain", x::TuckerTangentVector)
    pre = " "
    summary(io, x)
    for d in eachindex(x.U̇)
        println(io, string("\nU̇ factor ", d, ":"))
        su = sprint(show, "text/plain", x.U̇[d]; context = io, sizehint = 0)
        su = replace(su, '\n' => "\n$(pre)")
        println(io, pre, su)
    end
    println(io, "\nĊ factor:")
    su = sprint(show, "text/plain", x.Ċ; context = io, sizehint = 0)
    su = replace(su, '\n' => "\n$(pre)")
    return print(io, pre, su)
end
function Base.show(io::IO, ::MIME"text/plain", ℬ::CachedHOSVDBasis{𝔽, T, D}) where {𝔽, T, D}
    summary(io, ℬ)
    print(io, " ≅")
    su = sprint(show, "text/plain", convert(Matrix{T}, ℬ); context = io, sizehint = 0)
    su = replace(su, '\n' => "\n ")
    return println(io, " ", su)
end

"""
    Base.size(p::TuckerPoint)

The dimensions of a [`TuckerPoint`](@ref) `p`, when regarded as a full tensor
(see [`embed`](@ref)).
"""
Base.size(𝔄::TuckerPoint) = map(u -> size(u, 1), 𝔄.hosvd.U)

#=
Modification of the ST-HOSVD from [Vannieuwenhoven2012]
This is the HOSVD of an approximation of 𝔄, i.e. the core of this decomposition
is also in HOSVD format.
=#
function st_hosvd(𝔄, mlrank = size(𝔄))
    T = eltype(𝔄)
    D = ndims(𝔄)
    n⃗ = size(𝔄)
    # Add type assertions to U and σ for type stability
    U::NTuple{D, Matrix{T}} = ntuple(d -> Matrix{T}(undef, n⃗[d], mlrank[d]), D)
    σ::NTuple{D, Vector{T}} = ntuple(d -> Vector{T}(undef, mlrank[d]), D)
    # Initialise arrays to store successive truncations (𝔄′) and unfoldings (buffer)
    # so that the type remains constant at every truncation
    𝔄′ = reshape(view(𝔄, 1:length(𝔄)), n⃗)
    fold_buffer = reshape(view(similar(𝔄), 1:length(𝔄)), n⃗)
    unfold_buffer = view(similar(𝔄), 1:length(𝔄))

    for k in 1:D
        rₖ = mlrank[k]
        𝔄′₍ₖ₎ = tensor_unfold!(unfold_buffer, 𝔄′, k)
        # truncated SVD + incremental construction of the core
        UΣVᵀ = svd(𝔄′₍ₖ₎)
        U[k] .= UΣVᵀ.U[:, 1:rₖ]
        σ[k] .= UΣVᵀ.S[1:rₖ]
        𝔄′₍ₖ₎_trunc = Diagonal(σ[k]) * UΣVᵀ.Vt[1:rₖ, :]
        size𝔄′ = ntuple(i -> i ≤ k ? mlrank[i] : n⃗[i], D)
        fold_buffer = reshape(view(fold_buffer, 1:prod(size𝔄′)), size𝔄′)
        unfold_buffer = view(unfold_buffer, 1:prod(size𝔄′))
        𝔄′ = tensor_fold!(fold_buffer, 𝔄′₍ₖ₎_trunc, k)
    end
    core = Array(𝔄′)

    # Make sure the truncated core is in "all-orthogonal" HOSVD format
    if mlrank ≠ n⃗
        hosvd_core = st_hosvd(core, mlrank)
        U = U .* hosvd_core.U
        core = hosvd_core.core
        σ = hosvd_core.σ
    end

    return HOSVD{T, D}(U, core, σ)
end

# In-place inverse of the k'th unfolding of a size n₁ × ... × n_D tensor.
# The size of the reshaped tensor is determined by the size of 𝔄.
# The result is stored in 𝔄. The returned value uses the same address space as 𝔄.
function tensor_fold!(𝔄::AbstractArray{T, D}, 𝔄₍ₖ₎::AbstractMatrix{T}, k) where {T, D}
    @assert length(𝔄₍ₖ₎) == length(𝔄) && size(𝔄₍ₖ₎, 1) == size(𝔄, k)
    @assert pointer(𝔄) !== pointer(𝔄₍ₖ₎)
    # Caution: tuple operations can be type unstable if used incorrectly
    σ(i) = i == 1 ? k : i ≤ k ? i - 1 : i
    σ⁻¹(i) = i < k ? i + 1 : i == k ? 1 : i
    permuted_size = ntuple(i -> size(𝔄, σ(i)), D)
    return permutedims!(𝔄, reshape(𝔄₍ₖ₎, permuted_size), ntuple(σ⁻¹, D))
end

# In-place mode-k unfolding of the array 𝔄 of order D ≥ k.
# The argument buffer is an array of arbitrary dimensions of the same length as 𝔄.
# The returned value uses the same address space as the buffer.
function tensor_unfold!(buffer, 𝔄::AbstractArray{T, D}, k) where {T, D}
    @assert length(buffer) == length(𝔄)
    @assert pointer(𝔄) !== pointer(buffer)
    𝔄₍ₖ₎ = reshape(buffer, size(𝔄, k), :)
    # Caution: tuple operations can be type unstable if used incorrectly
    σ(i) = i == 1 ? k : i ≤ k ? i - 1 : i
    permuted_size = ntuple(i -> size(𝔄, σ(i)), D)
    permutedims!(reshape(𝔄₍ₖ₎, permuted_size), 𝔄, ntuple(σ, D))
    return 𝔄₍ₖ₎
end

@doc raw"""
    zero_vector(::Tucker, p::TuckerPoint)

The zero element in the tangent space to `p` on the [`Tucker`](@ref) manifold, represented
as a [`TuckerTangentVector`](@ref).
"""
zero_vector(::Tucker, ::TuckerPoint)

function zero_vector!(::Tucker, X::TuckerTangentVector, ::TuckerPoint)
    for U̇ in X.U̇
        fill!(U̇, zero(eltype(U̇)))
    end
    fill!(X.Ċ, zero(eltype(X.Ċ)))
    return X
end

# The standard implementation of allocate_result on vector-valued functions gives an element
# of the same type as the manifold point. We want a vector instead.
for fun in [:get_vector, :inverse_retract, :project, :zero_vector]
    @eval function ManifoldsBase.allocate_result(
            ::Tucker,
            ::typeof($(fun)),
            p::TuckerPoint,
            args...,
        )
        return TuckerTangentVector(allocate(p.hosvd.core), allocate(p.hosvd.U))
    end
end

function ManifoldsBase.allocate_result(M::Tucker, ::typeof(embed), p, args...)
    dims = get_parameter(M.size)[1]
    return Array{number_eltype(p), length(dims)}(undef, dims)
end

using LinearAlgebra, Manifolds, ManifoldsBase, Test, Random

@testset "Invertible matrices" begin
    M = InvertibleMatrices(3, ℝ)
    A = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    B = [0.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    Mc = InvertibleMatrices(3, ℂ)
    Ac = [1.0im 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    Bc = [0.0im 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    @testset "Real invertible matrices" begin
        @test repr(M) == "InvertibleMatrices(3, ℝ)"
        M2 = InvertibleMatrices(3, ℝ; parameter = :field)
        @test repr(M2) == "InvertibleMatrices(3, ℝ; parameter=:field)"
        @test check_point(M, A) == nothing
        @test_throws DomainError is_point(M, B; error = :error)
        @test_throws ManifoldDomainError is_point(M, Ac; error = :error)
        @test_throws ManifoldDomainError is_vector(M, A, Ac; error = :error)
        @test is_vector(M, A, A)
        @test is_flat(M)
        @test typeof(get_embedding(M)) ===
            Euclidean{ℝ, ManifoldsBase.TypeParameter{Tuple{3, 3}}}
        @test typeof(get_embedding(M2)) === Euclidean{ℝ, Tuple{Int64, Int64}}
        @test embed(M, A) === A
        @test embed(M, A, A) === A
        @test manifold_dimension(M) == 9
        @test Weingarten(M, A, A, A) == zero(A)

        @test is_point(M, rand(M))
        @test is_point(M, rand(Random.MersenneTwister(), M))
        @test is_vector(M, A, rand(M; vector_at = A))

        @test get_coordinates(M, A, A, DefaultOrthonormalBasis()) == vec(A)
        c = similar(vec(A))
        get_coordinates!(M, c, A, A, DefaultOrthonormalBasis())
        @test isapprox(c, vec(A))

        @test get_vector(M, A, vec(A), DefaultOrthonormalBasis()) == A
        D = similar(A)
        get_vector!(M, D, A, vec(A), DefaultOrthonormalBasis())
        @test isapprox(D, A)
    end
    @testset "Complex invertible matrices" begin
        @test repr(Mc) == "InvertibleMatrices(3, ℂ)"
        Mc2 = InvertibleMatrices(3, ℂ; parameter = :field)
        @test repr(Mc2) == "InvertibleMatrices(3, ℂ; parameter=:field)"
        @test manifold_dimension(Mc) == 2 * 3^2
        @test check_point(Mc, Ac) == nothing
        @test_throws DomainError is_point(Mc, Bc; error = :error)
        @test_throws DomainError is_point(Mc, B; error = :error)
        @test is_point(Mc, A; error = :error)
    end
end

include("../header.jl")

@testset "fixed Rank" begin
    M = FixedRankMatrices(3, 2, 2)
    M2 = FixedRankMatrices(3, 2, 1)
    Mc = FixedRankMatrices(3, 2, 2, ℂ)
    pE = [1.0 0.0; 0.0 1.0; 0.0 0.0]
    p = SVDMPoint(pE)
    p2 = SVDMPoint([1.0 0.0; 0.0 1.0; 0.0 0.0], 1)
    X = UMVTangentVector([0.0 0.0; 0.0 0.0; 1.0 1.0], [1.0 0.0; 0.0 1.0], zeros(2, 2))
    @test repr(M) == "FixedRankMatrices(3, 2, 2, ℝ)"
    @test repr(Mc) == "FixedRankMatrices(3, 2, 2, ℂ)"
    @test sprint(show, "text/plain", p) == """
        $(sprint(show, SVDMPoint{Matrix{Float64}, Vector{Float64}, Matrix{Float64}}))
        U factor:
         3×2 $(sprint(show, Matrix{Float64})):
          1.0  0.0
          0.0  1.0
          0.0  0.0
        singular values:
         2-element $(sprint(show, Vector{Float64})):
          1.0
          1.0
        Vt factor:
         2×2 $(sprint(show, Matrix{Float64})):
          1.0  0.0
          0.0  1.0"""
    @test sprint(show, "text/plain", X) == """
        $(sprint(show, UMVTangentVector{Matrix{Float64}, Matrix{Float64}, Matrix{Float64}}))
        U factor:
         3×2 $(sprint(show, Matrix{Float64})):
          0.0  0.0
          0.0  0.0
          1.0  1.0
        M factor:
         2×2 $(sprint(show, Matrix{Float64})):
          1.0  0.0
          0.0  1.0
        Vt factor:
         2×2 $(sprint(show, Matrix{Float64})):
          0.0  0.0
          0.0  0.0"""

    @test inner(M, p, X, X) == norm(M, p, X)^2
    @test p == SVDMPoint(p.U, p.S, p.Vt)
    @test X == UMVTangentVector(X.U, X.M, X.Vt)
    @testset "Fixed Rank Matrices – Basics" begin
        @test representation_size(M) == (3, 2)
        @test get_embedding(M) == Euclidean(3, 2; field = ℝ)
        @test representation_size(Mc) == (3, 2)
        @test manifold_dimension(M) == 6
        @test manifold_dimension(Mc) == 12
        @test metric(M) == EuclideanMetric()
        @test !is_flat(M)
        @test !is_flat(Mc)
        @test !is_point(M, SVDMPoint([1.0 0.0; 0.0 0.0], 2))
        @test_throws DomainError is_point(M, SVDMPoint([1.0 0.0; 0.0 0.0], 2); error = :error)
        @test is_point(M2, p2)
        @test_throws DomainError is_point(M2, [1.0 0.0; 0.0 1.0; 0.0 0.0]; error = :error)
        @test Manifolds.check_point(M2, [1.0 0.0; 0.0 1.0; 0.0 0.0]) isa DomainError

        @test default_retraction_method(M) === PolarRetraction()
        @test default_inverse_retraction_method(M) === PolarInverseRetraction()
        @test default_vector_transport_method(M) == ProjectionTransport()

        @test !is_vector(
            M,
            SVDMPoint([1.0 0.0; 0.0 1.0; 0.0 0.0]),
            UMVTangentVector(zeros(2, 1), zeros(1, 2), zeros(2, 2)),
        )
        @test !is_vector(M, SVDMPoint([1.0 0.0; 0.0 0.0], 2), X)
        @test_throws ManifoldDomainError is_vector(
            M,
            SVDMPoint([1.0 0.0; 0.0 0.0], 2),
            X;
            error = :error,
        )
        @test !is_vector(M, p, UMVTangentVector(p.U, X.M, p.Vt, 2))
        @test_throws DomainError is_vector(
            M,
            p,
            UMVTangentVector(p.U, X.M, p.Vt, 2);
            error = :error,
        )
        @test !is_vector(M, p, UMVTangentVector(X.U, X.M, p.Vt, 2))
        @test_throws DomainError is_vector(
            M,
            p,
            UMVTangentVector(X.U, X.M, p.Vt, 2);
            error = :error,
        )

        @test is_point(M, p)
        @test is_vector(M, p, X)

        q = embed(M, p)
        @test pE == q
        q2 = similar(q)
        embed!(M, q2, p)
        @test q == q2

        @test injectivity_radius(M2) == 0.0
    end
    types = [[Matrix{Float64}, Vector{Float64}, Matrix{Float64}]]

    for T in types
        @testset "Type $T" begin
            p2 = retract(M, p, X, PolarRetraction())
            p3 = SVDMPoint([1 / sqrt(2) 1 / sqrt(2); 1 / sqrt(2) -1 / sqrt(2); 0.0 0.0])
            pts = []
            for p in [p, p2, p3]
                push!(pts, SVDMPoint(convert.(T, [p.U, p.S, p.Vt])...))
            end
            for p in pts
                @test is_point(M, p)
            end
            @testset "SVD AbstractManifoldPoint Basics" begin
                s = svd(p.U * Diagonal(p.S) * p.Vt)
                x2 = SVDMPoint(s)
                x3 = SVDMPoint(s.U, s.S, s.Vt)
                @test SVDMPoint(p.U, p.S, p.Vt) == p
                @test p.S == x2.S
                @test p.U == x2.U
                @test p.Vt == x2.Vt
                @test p == x2
                @test x2.U == x3.U
                @test x2.S == x3.S
                @test x2.Vt == x3.Vt
                @test x2 == x3
                y = SVDMPoint([1.0 0.0; 0.0 0.0; 0.0 0.0], 1)
                s2 = svd([1.0 0.0; 0.0 0.0; 0.0 0.0])
                y2 = SVDMPoint(s2, 1)
                y3 = SVDMPoint(s2.U, s2.S, s2.Vt, 1)
                @test y.S == y2.S
                @test y.U == y2.U
                @test y.Vt == y2.Vt
                @test y == y2
                @test y2.U == y3.U
                @test y2.S == y3.S
                @test y2.Vt == y3.Vt
                @test y2 == y3

                @test is_point(M, p)
                xM = embed(M, p)
                @test is_point(M, xM)
                @test !is_point(M, xM[1:2, :])
                @test_throws DomainError is_point(M, xM[1:2, :]; error = :error)
                @test_throws DomainError is_point(
                    FixedRankMatrices(3, 2, 1),
                    p;
                    error = :error,
                )
                @test_throws DomainError is_point(
                    FixedRankMatrices(3, 2, 1),
                    xM;
                    error = :error,
                )
                xF1 = SVDMPoint(2 * p.U, p.S, p.Vt)
                @test !is_point(M, xF1)
                @test_throws DomainError is_point(M, xF1; error = :error)
                xF2 = SVDMPoint(p.U, p.S, 2 * p.Vt)
                @test !is_point(M, xF2)
                @test_throws DomainError is_point(M, xF2; error = :error)
                # copyto
                yC = allocate(y)
                copyto!(M, yC, y)
                @test yC.U == y.U
                @test yC.S == y.S
                @test yC.Vt == y.Vt
                # embed
                N = get_embedding(M)
                A = embed(M, p)
                @test isapprox(N, A, p.U * Diagonal(p.S) * p.Vt)
            end
            @testset "UMVTangentVector Basics" begin
                w = UMVTangentVector(X.U, 2 * X.M, X.Vt)
                @test X + w == UMVTangentVector(2 * X.U, 3 * X.M, 2 * X.Vt)
                @test X - w == UMVTangentVector(0 * X.U, -X.M, 0 * X.Vt)
                @test 2 * X == UMVTangentVector(2 * X.U, 2 * X.M, 2 * X.Vt)
                @test X * 2 == UMVTangentVector(X.U * 2, X.M * 2, X.Vt * 2)
                @test 2 \ X == UMVTangentVector(2 \ X.U, 2 \ X.M, 2 \ X.Vt)
                @test X / 2 == UMVTangentVector(X.U / 2, X.M / 2, X.Vt / 2)
                @test +X == X
                @test -X == UMVTangentVector(-X.U, -X.M, -X.Vt)
                w = UMVTangentVector(X.U, X.M, X.Vt)
                @test X == w
                w = allocate(X, number_eltype(X))
                zero_vector!(M, w, p)
                oneP = SVDMPoint(one(zeros(3, 3)), ones(2), one(zeros(2, 2)), 2)
                @test oneP == one(p)

                # copyto
                w2 = allocate(w)
                copyto!(M, w2, p, w)
                @test w.U == w2.U
                @test w.M == w2.M
                @test w.Vt == w2.Vt
                # broadcasting
                @test axes(w) === ()
                wc = copy(w)
                # test that the copy is equal to the original, but represented by
                # a new array
                @test wc.U !== w.U
                @test wc.U == w.U
                wb = w .+ X .* 2
                @test wb isa UMVTangentVector
                @test wb == w + X * 2
                @test (wb .= 2 .* w .+ X) == 2 * w + X
                @test wb == 2 * w + X
                wb .= w
                @test wb == w
                # embed/project
                N = get_embedding(M)
                B = embed(M, p, X)
                @test isapprox(N, p, B, p.U * X.M * p.Vt + X.U * p.Vt + p.U * X.Vt)
                BB = similar(B)
                embed!(M, BB, p, X)
                @test isapprox(M, p, B, BB)
                v2 = project(M, p, B)
                @test isapprox(M, p, X, v2)
            end
            @testset "Projection Retraction and Vector transport" begin
                X2 = vector_transport_to(M, p, X, p2, ProjectionTransport())
                X2t = project(M, p2, embed(M, p, X))
                @test isapprox(M, p, X2, X2t)
            end
            Manifolds.test_manifold(
                M,
                pts,
                test_exp_log = false,
                default_inverse_retraction_method = nothing,
                test_injectivity_radius = false,
                default_retraction_method = PolarRetraction(),
                test_is_tangent = false,
                test_default_vector_transport = false,
                test_vector_spaces = false,
                test_tangent_vector_broadcasting = true,
                projection_atol_multiplier = 15,
                retraction_methods = [PolarRetraction(), OrthographicRetraction()],
                inverse_retraction_methods = [OrthographicInverseRetraction()],
                vector_transport_methods = [ProjectionTransport()],
                vector_transport_retractions = [PolarRetraction()],
                vector_transport_inverse_retractions = [PolarInverseRetraction()],
                mid_point12 = nothing,
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
            )
        end
    end
    @testset "Riemannian Hessian" begin
        M = FixedRankMatrices(3, 2, 2)
        pE = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        p = SVDMPoint(pE)
        X = UMVTangentVector(
            [0.0 0.0; 0.0 0.0; 1.0 1.0],
            [1.0 0.0; 0.0 1.0],
            [1.0 0.0; 0.0 1.0],
        )
        G = [1.0 0.0; 0.0 2.0; 0.0 0.0]
        H = [0.0 3.0; 0.0 4.0; 0.0 1.0]
        @test is_vector(M, p, riemannian_Hessian(M, p, G, H, X))
    end
    @testset "field parameter" begin
        M = FixedRankMatrices(3, 2, 2; parameter = :field)
        @test repr(M) == "FixedRankMatrices(3, 2, 2, ℝ; parameter=:field)"
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
    end
end

@doc raw"""
    HeisenbergMatrices{T} <: AbstractDecoratorManifold{𝔽}

Heisenberg matrices `HeisenbergMatrices(n)` is the manifold of ``(n+2)×(n+2)`` matrices [BinzPods:2008](@cite)

```math
\begin{bmatrix} 1 & \mathbf{a} & c \\
\mathbf{0}_n & I_n & \mathbf{b} \\
0 & \mathbf{0}_n^\mathrm{T} & 1 \end{bmatrix}
```

where ``I_n`` is the ``n×n`` unit matrix, ``\mathbf{a}`` is a row vector of length ``n``,
``\mathbf{b}`` is a column vector of length ``n``, ``\mathbf{0}_n`` is the column zero vector
of length ``n``, and ``c`` is a real number.

It is a submanifold of [`Euclidean`](@ref)`(n+2, n+2)`.

# Constructor

    HeisenbergMatrices(n::Int; parameter::Symbol=:type)

Generate the manifold of ``(n+2)×(n+2)`` Heisenberg matrices.
"""
struct HeisenbergMatrices{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function HeisenbergMatrices(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return HeisenbergMatrices{typeof(size)}(size)
end

function _heisenberg_a_view(M::HeisenbergMatrices, p)
    n = get_parameter(M.size)[1]
    return view(p, 1, 2:(n + 1))
end
function _heisenberg_b_view(M::HeisenbergMatrices, p)
    n = get_parameter(M.size)[1]
    return view(p, 2:(n + 1), n + 2)
end

function check_point(M::HeisenbergMatrices, p; kwargs...)
    n = get_parameter(M.size)[1]
    if !isone(p[1, 1])
        return DomainError(
            p[1, 1],
            "The matrix $(p) does not lie on $(M), since p[1, 1] is not equal to 1.",
        )
    end
    if !isone(p[n + 2, n + 2])
        return DomainError(
            p[n + 2, n + 2],
            "The matrix $(p) does not lie on $(M), since p[n+2, n+2] is not equal to 1.",
        )
    end
    if !iszero(p[2:(n + 2), 1])
        return DomainError(
            norm(iszero(p[2:(n + 2), 1])),
            "The matrix $(p) does not lie on $(M), since p[2:(n + 2), 1] is not equal to 0.",
        )
    end
    if !iszero(p[n + 2, 1:(n + 1)])
        return DomainError(
            norm(iszero(p[n + 2, 1:(n + 1)])),
            "The matrix $(p) does not lie on $(M), since p[n + 2, 1:(n+1)] is not equal to 0.",
        )
    end
    if !isapprox(I, p[2:(n + 1), 2:(n + 1)])
        return DomainError(
            det(p[2:(n + 1), 2:(n + 1)] - I),
            "The matrix $(p) does not lie on $(M), since p[2:(n+1), 2:(n+1)] is not an identity matrix.",
        )
    end

    return nothing
end

function check_vector(M::HeisenbergMatrices, p, X; kwargs...)
    n = get_parameter(M.size)[1]
    if !iszero(X[1, 1])
        return DomainError(
            X[1, 1],
            "The matrix $(X) does not lie in the tangent space of $(M), since X[1, 1] is not equal to 0.",
        )
    end
    if !iszero(X[n + 2, n + 2])
        return DomainError(
            X[n + 2, n + 2],
            "The matrix $(X) does not lie in the tangent space of $(M), since X[n+2, n+2] is not equal to 0.",
        )
    end
    if !iszero(X[2:(n + 2), 1:(n + 1)])
        return DomainError(
            norm(X[2:(n + 2), 1:(n + 1)]),
            "The matrix $(X) does not lie in the tangent space of $(M), since X[2:(n + 2), 1:(n + 1)] is not a zero matrix.",
        )
    end
    return nothing
end

embed(::HeisenbergMatrices, p) = p
embed(::HeisenbergMatrices, p, X) = X

@doc raw"""
    get_coordinates(M::HeisenbergMatrices, p, X, ::DefaultOrthonormalBasis{ℝ,TangentSpaceType})

Get coordinates of tangent vector `X` at point `p` from the [`HeisenbergMatrices`](@ref) `M`.
Given a matrix
```math
\begin{bmatrix} 1 & \mathbf{a} & c \\
\mathbf{0} & I_n & \mathbf{b} \\
0 & \mathbf{0} & 1 \end{bmatrix}
```
the coordinates are concatenated vectors ``\mathbf{a}``, ``\mathbf{b}``, and number ``c``.
"""
get_coordinates(::HeisenbergMatrices, p, X, ::DefaultOrthonormalBasis{ℝ, TangentSpaceType})

function get_coordinates_orthonormal(M::HeisenbergMatrices, p, X, ::RealNumbers)
    n = get_parameter(M.size)[1]
    return vcat(_heisenberg_a_view(M, X), _heisenberg_b_view(M, X), X[1, n + 2])
end

function get_coordinates_orthonormal!(M::HeisenbergMatrices, Xⁱ, p, X, ::RealNumbers)
    n = get_parameter(M.size)[1]
    Xⁱ[1:n] .= _heisenberg_a_view(M, X)
    Xⁱ[(n + 1):(2 * n)] .= _heisenberg_b_view(M, X)
    Xⁱ[2 * n + 1] = X[1, n + 2]
    return Xⁱ
end

function get_embedding(::HeisenbergMatrices{TypeParameter{Tuple{n}}}) where {n}
    return Euclidean(n + 2, n + 2)
end
function get_embedding(M::HeisenbergMatrices{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return Euclidean(n + 2, n + 2; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::HeisenbergMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

@doc raw"""
    get_vector(M::HeisenbergMatrices, p, Xⁱ, ::DefaultOrthonormalBasis{ℝ,TangentSpaceType})

Get tangent vector with coordinates `Xⁱ` at point `p` from the [`HeisenbergMatrices`](@ref) `M`.
Given a vector of coordinates ``\begin{bmatrix}\mathbb{a} & \mathbb{b} & c\end{bmatrix}`` the tangent vector is equal to
```math
\begin{bmatrix} 1 & \mathbf{a} & c \\
\mathbf{0} & I_n & \mathbf{b} \\
0 & \mathbf{0} & 1 \end{bmatrix}
```
"""
get_vector(M::HeisenbergMatrices, p, c, ::DefaultOrthonormalBasis{ℝ, TangentSpaceType})

function get_vector_orthonormal(M::HeisenbergMatrices, p, Xⁱ, ::RealNumbers)
    n = get_parameter(M.size)[1]
    return [
        0 Xⁱ[1:n] Xⁱ[2 * n + 1]
        zeros(n, n + 1) Xⁱ[(n + 1):(2 * n)]'
        zeros(1, n + 2)
    ]
end

function get_vector_orthonormal!(M::HeisenbergMatrices, X, p, Xⁱ, ::RealNumbers)
    n = get_parameter(M.size)[1]
    fill!(X, 0)
    X[1, 2:(n + 1)] .= Xⁱ[1:n]
    X[2:(n + 1), n + 2] .= Xⁱ[(n + 1):(2 * n)]
    X[1, n + 2] = Xⁱ[2 * n + 1]
    return X
end

"""
    is_flat(::HeisenbergMatrices)

Return true. [`HeisenbergMatrices`](@ref) is a flat manifold.
"""
is_flat(M::HeisenbergMatrices) = true

"""
    manifold_dimension(M::HeisenbergMatrices)

Return the dimension of [`HeisenbergMatrices`](@ref)`(n)`, which is equal to ``2n+1``.
"""
manifold_dimension(M::HeisenbergMatrices) = 2 * get_parameter(M.size)[1] + 1

@doc raw"""
    Random.rand(M::HeisenbergMatrices; vector_at = nothing, σ::Real=1.0)

If `vector_at` is `nothing`, return a random point on the [`HeisenbergMatrices`](@ref) `M`
by sampling elements of the first row and the last column from the normal distribution with
mean 0 and standard deviation `σ`.

If `vector_at` is not `nothing`, return a random tangent vector from the tangent space of
the point `vector_at` on the [`HeisenbergMatrices`](@ref) by using a normal distribution with
mean 0 and standard deviation `σ`.
"""
rand(M::HeisenbergMatrices; vector_at = nothing, σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::HeisenbergMatrices,
        pX;
        σ::Real = one(eltype(pX)),
        vector_at = nothing,
    )
    n = ManifoldsBase.get_parameter(M.size)[1]
    if vector_at === nothing
        copyto!(pX, I)
        va = view(pX, 1, 2:(n + 2))
        randn!(rng, va)
        va .*= σ
        vb = view(pX, 2:(n + 1), n + 2)
        randn!(rng, vb)
        vb .*= σ
    else
        fill!(pX, 0)
        randn!(rng, view(pX, 1, 2:(n + 2)))
        randn!(rng, view(pX, 2:(n + 1), n + 2))
        pX .*= σ
    end
    return pX
end

function Base.show(io::IO, ::HeisenbergMatrices{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "HeisenbergMatrices($(n))")
end
function Base.show(io::IO, M::HeisenbergMatrices{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "HeisenbergMatrices($(n); parameter=:field)")
end

@doc raw"""
    Y = Weingarten(M::HeisenbergMatrices, p, X, V)
    Weingarten!(M::HeisenbergMatrices, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`HeisenbergMatrices`](@ref) `M`
with respect to the tangent vector ``X \in T_p\mathcal M`` and the normal vector
``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::HeisenbergMatrices, p, X, V)

Weingarten!(::HeisenbergMatrices, Y, p, X, V) = fill!(Y, 0)

module ManifoldsNLsolveExt

using Manifolds
using ManifoldsBase

using NLsolve: NLsolve

@doc raw"""
    inverse_retract(M, p, q method::NLSolveInverseRetraction; kwargs...)

Approximate the inverse of the retraction specified by `method.retraction` from `p` with
respect to `q` on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M` using NLsolve. This inverse retraction is
not guaranteed to succeed and probably will not unless `q` is close to `p` and the initial
guess `X0` is close.

If the solver fails to converge, an [`OutOfInjectivityRadiusError`](@extref `ManifoldsBase.OutOfInjectivityRadiusError`) is raised.
See [`NLSolveInverseRetraction`](@extref `ManifoldsBase.NLSolveInverseRetraction`) for configurable parameters.
"""
inverse_retract(::AbstractManifold, p, q, ::NLSolveInverseRetraction; kwargs...)

function ManifoldsBase.inverse_retract_nlsolve!(
        M::AbstractManifold, X, p, q, m::NLSolveInverseRetraction; kwargs...
    )
    X0 = m.X0 === nothing ? zero_vector(M, p) : m.X0
    res = _inverse_retract_nlsolve(M, p, q, m; kwargs...)
    return copyto!(X, res.zero)
end

function _inverse_retract_nlsolve(
        M::AbstractManifold, p, q, m::NLSolveInverseRetraction; kwargs...
    )
    X0 = m.X0 === nothing ? zero_vector(M, p) : m.X0
    function f!(F, X)
        m.project_tangent && project!(M, X, p, X)
        retract!(M, F, p, project(M, p, X), m.retraction; kwargs...)
        m.project_point && project!(M, q, q)
        F .-= q
        return F
    end
    res = NLsolve.nlsolve(f!, X0; m.nlsolve_kwargs...)
    if !res.f_converged
        @debug res
        throw(OutOfInjectivityRadiusError())
    end
    return res
end

end

"""
    default_inverse_retraction_method(M::Flag)

Return [`PolarInverseRetraction`](@extref `ManifoldsBase.PolarInverseRetraction`)
as the default inverse retraction for the [`Flag`](@ref) manifold.
"""
default_inverse_retraction_method(::Flag) = PolarInverseRetraction()

"""
    default_retraction_method(M::Flag)

Return [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`)
as the default retraction for the [`Flag`](@ref) manifold.
"""
default_retraction_method(::Flag) = PolarRetraction()

"""
    default_vector_transport_method(M::Flag)

Return the [`ProjectionTransport`](@extref `ManifoldsBase.ProjectionTransport`)
as the default vector transport method for the [`Flag`](@ref) manifold.
"""
default_vector_transport_method(::Flag) = ProjectionTransport()

function inner(
        M::Flag{<:Any, dp1},
        p::AbstractMatrix,
        X::AbstractMatrix,
        Y::AbstractMatrix,
    ) where {dp1}
    inner_prod = zero(eltype(X))
    pX = p' * X
    pY = p' * Y
    X_perp = X - p * pX
    Y_perp = Y - p * pY
    for i in 1:(dp1 - 1)
        for j in i:(dp1 - 1)
            block_X = _extract_flag(M, pX, j, i)
            block_Y = _extract_flag(M, pY, j, i)
            inner_prod += dot(block_X, block_Y)
        end
    end
    inner_prod += dot(X_perp, Y_perp)
    return inner_prod
end

@doc raw"""
    inverse_retract(M::Flag, p, q, ::PolarInverseRetraction)

Compute the inverse retraction for the [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`), on the
[`Flag`](@ref) manifold `M`.
"""
inverse_retract(::Flag, ::Any, ::Any, ::PolarInverseRetraction)

function inverse_retract_polar!(::Flag, X, p, q)
    return copyto!(X, q / (p' * q) - p)
end

function _extract_flag_stiefel(M::Flag, pX::AbstractMatrix, i::Int)
    range = (M.subspace_dimensions[i - 1] + 1):M.subspace_dimensions[i]
    return view(pX, :, range)
end

function check_point(M::Flag, p::AbstractMatrix)
    return check_point(get_embedding(M, typeof(p)), p)
end

@doc raw"""
    check_vector(M::Flag, p::AbstractMatrix, X::AbstractMatrix; kwargs... )

Check whether `X` is a tangent vector to point `p` on the [`Flag`](@ref) manifold `M`
``\operatorname{Flag}(n_1, n_2, ..., n_d; N)`` in the Stiefel representation,
i.e. that `X` is a matrix of the form
````math
X = \begin{bmatrix}
0                     & B_{1,2}               & ⋯ & B_{1,d} \\
-B_{1,2}^\mathrm{T}   & 0                     & ⋯ & B_{2,d} \\
\vdots                & \vdots                & ⋱ & \vdots  \\
-B_{1,d}^\mathrm{T}   & -B_{2,d}^\mathrm{T}   & ⋯ & 0       \\
-B_{1,d+1}^\mathrm{T} & -B_{2,d+1}^\mathrm{T} & ⋯ & -B_{d,d+1}^\mathrm{T}
\end{bmatrix}
````
where ``B_{i,j} ∈ ℝ^{(n_i - n_{i-1}) × (n_j - n_{j-1})}``, for  ``1 ≤ i < j ≤ d+1``.
"""
function check_vector(
        M::Flag{<:Any, dp1},
        p::AbstractMatrix,
        X::AbstractMatrix;
        atol = sqrt(eps(eltype(X))),
    ) where {dp1}
    for i in 1:(dp1 - 1)
        p_i = _extract_flag_stiefel(M, p, i)
        X_i = _extract_flag_stiefel(M, X, i)

        pTX_norm = norm(p_i' * X_i)
        if pTX_norm > atol
            return DomainError(
                pTX_norm,
                "Orthogonality condition check failed at subspace $i.",
            )
        end

        for j in i:(dp1 - 1)
            p_j = _extract_flag_stiefel(M, p, j)
            X_j = _extract_flag_stiefel(M, X, j)
            sum_norm = norm(p_i' * X_j + X_i' * p_j)
            if sum_norm > atol
                return DomainError(
                    sum_norm,
                    "Tangent vector condition check failed at subspaces ($i, $j)",
                )
            end
        end
    end
    return nothing
end

@doc raw"""
    project(::Flag, p, X)

Project vector `X` in the Euclidean embedding to the tangent space at point `p` on
[`Flag`](@ref) manifold. The formula reads [YeWongLim:2021](@cite):

```math
Y_i = X_i - (p_i p_i^{\mathrm{T}}) X_i + \sum_{j \neq i} p_j X_j^{\mathrm{T}} p_i
```
for ``i`` from 1 to ``d`` where the resulting vector is ``Y = [Y_1, Y_2, …, Y_d]`` and
``X = [X_1, X_2, …, X_d]``, ``p = [p_1, p_2, …, p_d]`` are decompositions into basis vector
matrices for consecutive subspaces of the flag.
"""
project(::Flag, p, X)

function project!(
        M::Flag{<:Any, dp1},
        Y::AbstractMatrix,
        p::AbstractMatrix,
        X::AbstractMatrix,
    ) where {dp1}
    Xc = X .- p * (p' * X) ./ 2
    for i in 1:(dp1 - 1)
        Y_i = _extract_flag_stiefel(M, Y, i)
        p_i = _extract_flag_stiefel(M, p, i)
        Xc_i = _extract_flag_stiefel(M, Xc, i)

        Y_i .= Xc_i .- p_i * (p_i' * Xc_i)
        for j in 1:(dp1 - 1)
            i == j && continue
            p_j = _extract_flag_stiefel(M, p, j)
            Xc_j = _extract_flag_stiefel(M, Xc, j)
            Y_i .-= p_j * Xc_j' * p_i
        end
    end

    return Y
end
function project!(M::Flag, q::AbstractMatrix, p::AbstractMatrix)
    return project!(get_embedding(M, typeof(p)), q, p)
end

function Random.rand!(rng::AbstractRNG, M::Flag, pX::AbstractMatrix; vector_at = nothing)
    EM = get_embedding(M)
    if vector_at === nothing
        rand!(rng, EM, pX)
    else
        rand!(rng, EM, pX; vector_at = vector_at)
        project!(M, pX, vector_at, pX)
    end
    return pX
end

@doc raw"""
    retract(M::Flag, p, X, ::PolarRetraction)

Compute the SVD-based retraction [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`Flag`](@ref) `M`. With $USV = p + X$ the retraction reads
````math
\operatorname{retr}_p X = UV^\mathrm{H},
````

where $\cdot^{\mathrm{H}}$ denotes the complex conjugate transposed or Hermitian.
"""
retract(::Flag, ::Any, ::Any, ::PolarRetraction)

function ManifoldsBase.retract_polar!(M::Flag, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end

function ManifoldsBase.retract_polar_fused!(::Flag, q, p, X, t::Number)
    s = svd(p .+ t .* X)
    return mul!(q, s.U, s.Vt)
end

@doc raw"""
    WarpedMetric{A} <: AbstractMetric

The ``A``-warped metric on the Segre manifold ``\mathcal{S}`` is a generalization of the Euclidean metric on ``\mathcal{S}``.
We denote this manifold by ``\mathcal{S}_A``.

Similarly to ``\mathcal{S}``, when ``𝔽 = ℝ``, ``\mathcal{S}_A`` is a normal Riemannian covering of the product manifold

````math
    ℝ^{+} × \mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}
````

with a [warped product metric](https://en.wikipedia.org/wiki/Warped_product), but the warping function now depends on the _warping factor_ ``A``.
``A = 1`` corresponds to the usual Segre manifold.
The Segre manifold is a cone in the sense that if ``p \in \mathcal{S}``, then ``r p \in \mathcal{S}`` for all ``r \neq 0``. The tangent subspace at ``p`` defined ``\mathrm{d} (r p) / \mathrm{d} r`` is called the _radial_ direction. ``A < 1`` puts less weight on the directions orthogonal to the radial direction compared to ``\mathcal{S}``, while ``A > 1`` puts more weight on those directions.

The geometry is summarized in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite).

# Constructor
    WarpedMetric(A::Real)

Generate a warped product metric with warping factor `A`.
"""
struct WarpedMetric{A} <: AbstractMetric end

function WarpedMetric(A::Real)
    return WarpedMetric{A}()
end

function connected_by_geodesic(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        p,
        q,
    ) where {V, A}
    return connected_by_geodesic(M.manifold, p, q)
end

function closest_representative!(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        q,
        p,
    ) where {V, A}
    return closest_representative!(M.manifold, q, p)
end

@doc raw"""
    distance(M::MetricManifold{ℝ, Segre{ℝ,V}, WarpedMetric{A}}, p, q)

Riemannian distance between two points `p` and `q` on the warped Segre manifold.

Assume ``p ≐ (λ, x_1,…, x_d)``, ``q ≐ (μ, y_1,…, y_d) ∈ \mathcal{S}_A`` are connected by a geodesic. Let

````math
    m = \sqrt{\sphericalangle(x_1, y_1)^2 +… + \sphericalangle(x_d, y_d)^2}
````

and assume ``(μ, y_1,…, y_d)`` is the representation of ``q`` that minimizes ``m``. Then

````math
    \operatorname{dist}_{\mathcal{S}_A}(p, q) = \sqrt{λ^2 - 2 λ μ \cos(A m) + μ^2}.
````
"""
function distance(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, q) where {V, A}
    closest_representative!(M, q, p)
    m = spherical_angle_sum(M, p, q)
    return sqrt((p[1][1] - q[1][1])^2 + 4 * p[1][1] * q[1][1] * sin(A * m / 2)^2)
    # Equivalent to sqrt(p[1][1]^2 + q[1][1]^2 - 2 * p[1][1] * q[1][1] * cos(A * m)) but more stable for small m
end

@doc raw"""
    exp(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, X)

Exponential map on the warped Segre manifold.

Let ``p ≐ (λ, x_1,…, x_d) ∈ \mathcal{S}_A`` and ``X = (ν, u_1,…, u_d) ∈ T_p \mathcal{S}_A``.
Then the exponential map is given by

````math
    \operatorname{exp}_p(X) ≐
    \left(
        \sqrt{(λ + ν)^2 + (λ A m)^2},\\
        x_1 \cos\mathopen{\Big(} \frac{f \lVert u_1 \rVert_{x_1}}{A m} \mathclose{\Big)} + \frac{u_1}{\lVert u_1 \rVert_{x_1}} \sin\mathopen{\Big(} \frac{f \lVert u_1 \rVert_{x_1}}{A m} \mathclose{\Big)},\\
        …,\\
        x_d \cos\mathopen{\Big(} \frac{f \lVert u_d \rVert_{x_d}}{A m} \mathclose{\Big)} + \frac{u_d}{\lVert u_d \rVert_{x_d}} \sin\mathopen{\Big(} \frac{f \lVert u_d \rVert_{x_d}}{A m} \mathclose{\Big)}
    \right),
````

where

````math
    \begin{aligned}
        f &= \frac{\pi}{2} - \tan^{-1}\mathopen{\Big(} \frac{λ + ν}{λ A m} \mathclose{\Big)},\\
        m &= \sqrt{\lVert u_1 \rVert_{x_1}^2 + … + \lVert u_d \rVert_{x_d}^2}.
    \end{aligned}
````

If ``m = 0`` and ``-λ < ν``, then ``\operatorname{exp}_p(v) = p + X``.

The formula is derived in proposition 3.1 in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite).
"""
exp(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, X) where {V, A}

function exp!(::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, q, p, X) where {V, A}
    m = sqrt(
        sum(
            [
                norm(Sphere(n - 1), x, xdot)^2 for (n, x, xdot) in zip(V, p[2:end], X[2:end])
            ]
        ),
    )

    q[1][1] = sqrt((p[1][1] + X[1][1])^2 + (p[1][1] * A * m)^2)

    f = pi / 2 - atan((p[1][1] + X[1][1]) / (p[1][1] * A * m))
    if m == 0
        for (x, y) in zip(p[2:end], q[2:end])
            y .= x
        end
    else
        for (n, x, y, xdot) in zip(V, p[2:end], q[2:end], X[2:end])
            a = norm(Sphere(n - 1), x, xdot)
            y .=
                x * cos(a * f / (A * m)) .+
                xdot * (f / (A * m)) * sinc(a * f / (A * m * pi))
        end
    end

    return q
end

@doc raw"""
    get_coordinates(M::Segre{𝔽, V}, p, v, ::DefaultOrthonormalBasis; kwargs...)

Get coordinates of `X` in the tangent space ``T_{(λ, x_1,…, x_d)} \mathcal{S}_A = \mathbb{R} × T_{x_1} \mathbb{S}^{n_1 - 1} ×⋯× T_{x_d} \mathbb{S}^{n_d - 1}`` using a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`) on each factor.
"""
get_coordinates(
    M::MetricManifold{𝔽, Segre{𝔽, V}, WarpedMetric{A}},
    p,
    X,
    ::DefaultOrthonormalBasis;
    kwargs...,
) where {𝔽, V, A}

function get_coordinates_orthonormal!(
        M::MetricManifold{𝔽, Segre{𝔽, V}, WarpedMetric{A}},
        c,
        p,
        X,
        ::RealNumbers;
        kwargs...,
    ) where {𝔽, V, A}
    return c = vcat(
        X[1],
        A *
            p[1][1] *
            [
            get_coordinates(Sphere(n - 1), x, xdot, DefaultOrthonormalBasis(); kwargs...) for (n, x, xdot) in zip(V, p[2:end], X[2:end])
        ]...,
    )
end

@doc raw"""
    get_vector(M::Segre{𝔽, V}, p, c, ::DefaultOrthonormalBasis; kwargs...)

Get tangent vector `X` from coordinates in the tangent space ``T_{(λ, x_1,…, x_d)} \mathcal{S}_A = \mathbb{R} × T_{x_1} \mathbb{S}^{n_1 - 1} ×⋯× T_{x_d} \mathbb{S}^{n_d - 1}`` using a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`) on each factor.
"""
get_vector(
    M::MetricManifold{𝔽, Segre{𝔽, V}, WarpedMetric{A}},
    p,
    c,
    ::DefaultOrthonormalBasis;
    kwargs...,
) where {V, A, 𝔽}

function get_vector_orthonormal!(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        X,
        p,
        c,
        ::RealNumbers;
        kwargs...,
    ) where {V, A}
    c_ = deepcopy(c)
    X[1] = [c_[1]]
    c_ = c_[2:end]
    for (i, n) in enumerate(V)
        X[i + 1] =
            get_vector(
            Sphere(n - 1),
            p[i + 1],
            c_[1:(n - 1)],
            DefaultOrthonormalBasis();
            kwargs...,
        ) / (A * p[1][1])
        c_ = c_[n:end]
    end

    return X
end

@doc raw"""
    inner(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, X, Y)

Inner product between two tangent vectors ``X = (ν, u_1,…, u_d)`` and ``Y = (ξ, v_1,…, v_d)`` at ``p \doteq (λ, x_1,…, x_d)``:
````math
    ⟨X, Y⟩_{p} = ν ξ + (A λ)^2 (⟨ u_1, v_1 ⟩_{x_1} +… + ⟨u_d, v_d⟩_{x_d}),
````
where ``ν``, ``ξ ∈ T_{λ} ℝ^{+} = ℝ`` and ``u_i``, ``v_i ∈ T_{x_i} \mathbb{S}^{n_i - 1} \subset ℝ^{n_i}``.
"""
function inner(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, X, Y) where {V, A}
    return X[1][1] * Y[1][1] + (A * p[1][1])^2 * dot(X[2:end], Y[2:end])
end

@doc raw"""
    log(M::MetricManifold{ℝ, Segre{ℝ,V}, WarpedMetric{A}}, p, q)

Logarithmic map on the warped Segre manifold.

Let ``p ≐ (λ, x_1,…, x_d)``, ``q ≐ (μ, y_1,…, y_d) ∈ \mathcal{S}_A``.
Assume ``p`` and ``q`` are connected by a geodesic.
Let

````math
    m = \sqrt{\sphericalangle(x_1, y_1)^2 +… + \sphericalangle(x_d, y_d)^2}
````

and assume ``(μ, y_1,…, y_d)`` is the representative of ``q`` that minimizes ``m``. Then

````math
    \operatorname{log}_p(q) =
    \left(
        \mu \cos{m} - \lambda,
        (y_1 - ⟨x_1, y_1⟩ x_1) \frac{\mu \sphericalangle(x_1, y_1) \sin(A m)}{\lambda A m \sin{\sphericalangle(x_1, y_1)}},
        \dots,
        (y_d - ⟨x_d, y_d⟩ x_d) \frac{\mu \sphericalangle(x_d, y_d) \sin(A m)}{\lambda A m \sin{\sphericalangle(x_d, y_d)}}
    \right).
````

The formula is derived in theorem 4.4 in [JacobssonSwijsenVandervekenVannieuwenhoven:2024](@cite).
"""
log(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, p, q) where {V, A}

function log!(M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}}, X, p, q) where {V, A}
    closest_representative!(M, q, p)
    m = spherical_angle_sum(M, p, q)

    X[1][1] = q[1][1] * cos(A * m) - p[1][1]
    for (n, xdot, x, y) in zip(V, X[2:end], p[2:end], q[2:end])
        a = distance(Sphere(n - 1), x, y)
        xdot .= (y - dot(x, y) * x) * (q[1][1] / p[1][1]) * sinc(A * m / pi) / sinc(a / pi)
    end

    return X
end

@doc raw"""
    riemann_tensor(M::MetricManifold{ℝ, Segre{ℝ,V}, WarpedMetric{A}}, p, X, Y)

Riemann tensor of the warped Segre manifold at ``p``.

``\mathcal{S}_A`` is locally a warped product of ``ℝ^{+}`` and ``\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}``. If ``p ≐ (λ, x_1,…, x_d) ∈ \mathcal{S}_A`` and ``X``, ``Y``, ``Z ∈ T_{(x_1,…, x_d)} (\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}) \subset T_p \mathcal{S}_A`` then
````math
    R_{\mathcal{S}_A}(X, Y) Z = R_{\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}}(X, Y) Z + λ^{-2}(⟨ X, Z ⟩_{p} Y - ⟨ Y, Z ⟩_{p} X).
````
``R_{\mathcal{S}_A}`` is zero in the remaining (orthogonal) directions.
"""
function riemann_tensor(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        p,
        X,
        Y,
        Z,
    ) where {V, A}
    return [
        [0.0],
        [
            riemann_tensor(Sphere(n - 1), x, xdot1, xdot2, xdot3) for
                (n, x, xdot1, xdot2, xdot3) in zip(V, p[2:end], X[2:end], Y[2:end], Z[2:end])
        ]...,
    ] +
        (1 / p[1][1]^2) * (
        inner(M, p, [[0.0], X[2:end]...], [[0.0], Z[2:end]...]) * [[0.0], Y[2:end]...] -
            inner(M, p, [[0.0], Y[2:end]...], [[0.0], Z[2:end]...]) * [[0.0], X[2:end]...]
    )
end

@doc raw"""
    sectional_curvature(M::MetricManifold{ℝ, Segre{ℝ,V}, WarpedMetric{A}}, p, X, Y)

Sectional curvature of the warped Segre manifold at ``p``.

``\mathcal{S}_A`` is locally a warped product of ``ℝ^{+}`` and ``\mathbb{S}^{n_1 - 1} ×⋯× \mathbb{S}^{n_d - 1}``
If ``p = (λ, x_1,…, x_d) ∈ \mathcal{S}``, ``u_i ∈ T_{x_i} \mathbb{S}^{n_i - 1}``, and ``v_j ∈ T_{x_j} \mathbb{S}^{n_j - 1}``, then
````math
    K_{\mathcal{S}_A}(u_i, v_j) = \frac{A^{-2} \delta_{i j} - 1}{λ^{2}}.
````
``K_{\mathcal{S}_A}`` is zero in the remaining (orthogonal) directions.
"""
function sectional_curvature(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        p,
        X,
        Y,
    ) where {V, A}
    return inner(M, p, riemann_tensor(M, p, X, Y, Y), X) /
        (inner(M, p, X, X) * inner(M, p, Y, Y) - inner(M, p, X, Y)^2)
end

function show(io::IO, ::WarpedMetric{A}) where {A}
    return print(io, "WarpedMetric($A)")
end

function spherical_angle_sum(
        M::MetricManifold{ℝ, Segre{ℝ, V}, WarpedMetric{A}},
        p,
        q,
    ) where {V, A}
    return spherical_angle_sum(M.manifold, p, q)
end

@doc raw"""
    Hyperbolic{T} <: AbstractDecoratorManifold{ℝ}

The hyperbolic space ``\mathcal H^n`` represented by ``n+1``-Tuples, i.e. embedded in the
[`Lorentz`](@ref)ian manifold equipped with the [`MinkowskiMetric`](@ref)
``⟨⋅,⋅⟩_{\mathrm{M}}``. The space is defined as

```math
\mathcal H^n = \Bigl\{p ∈ ℝ^{n+1}\ \Big|\ ⟨p,p⟩_{\mathrm{M}}= -p_{n+1}^2
  + \displaystyle\sum_{k=1}^n p_k^2 = -1, p_{n+1} > 0\Bigr\},.
```

The tangent space ``T_p \mathcal H^n`` is given by

````math
T_p \mathcal H^n := \bigl\{
X ∈ ℝ^{n+1} : ⟨p,X⟩_{\mathrm{M}} = 0
\bigr\}.
````
Note that while the [`MinkowskiMetric`](@ref) renders the [`Lorentz`](@ref) manifold (only)
pseudo-Riemannian, on the tangent bundle of the Hyperbolic space it induces a Riemannian
metric. The corresponding sectional curvature is ``-1``.

If `p` and `X` are `Vector`s of length `n+1` they are assumed to be
a [`HyperboloidPoint`](@ref) and a [`HyperboloidTangentVector`](@ref), respectively

Other models are the Poincaré ball model, see [`PoincareBallPoint`](@ref) and [`PoincareBallTangentVector`](@ref), respectively
and the Poincaré half space model, see [`PoincareHalfSpacePoint`](@ref) and [`PoincareHalfSpaceTangentVector`](@ref), respectively.

# Constructor

    Hyperbolic(n::Int; parameter::Symbol=:type)

Generate the Hyperbolic manifold of dimension `n`.
"""
struct Hyperbolic{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function Hyperbolic(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return Hyperbolic{typeof(size)}(size)
end

@doc raw"""
    HyperboloidPoint <: AbstractManifoldPoint

In the Hyperboloid model of the [`Hyperbolic`](@ref) ``\mathcal H^n`` points are represented
as vectors in ``ℝ^{n+1}`` with [`MinkowskiMetric`](@ref) equal to ``-1``.

This representation is the default, i.e. `AbstractVector`s are assumed to have this representation.
"""
struct HyperboloidPoint{TValue <: AbstractVector} <: AbstractManifoldPoint
    value::TValue
end

@doc raw"""
    HyperboloidTangentVector <: AbstractTangentVector

In the Hyperboloid model of the [`Hyperbolic`](@ref) ``\mathcal H^n`` tangent vctors are represented
as vectors in ``ℝ^{n+1}`` with [`MinkowskiMetric`](@ref) ``⟨p,X⟩_{\mathrm{M}}=0`` to their base
point ``p``.

This representation is the default, i.e. vectors are assumed to have this representation.
"""
struct HyperboloidTangentVector{TValue <: AbstractVector} <: AbstractTangentVector
    value::TValue
end

@doc raw"""
    PoincareBallPoint <: AbstractManifoldPoint

A point on the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` can be represented as a vector of norm
less than one in ``\mathbb R^n``.
"""
struct PoincareBallPoint{TValue <: AbstractVector} <: AbstractManifoldPoint
    value::TValue
end

@doc raw"""
    PoincareBallTangentVector <: AbstractTangentVector

In the Poincaré ball model of the [`Hyperbolic`](@ref) ``\mathcal H^n`` tangent vectors are represented
as vectors in ``ℝ^{n}``.
"""
struct PoincareBallTangentVector{TValue <: AbstractVector} <: AbstractTangentVector
    value::TValue
end

@doc raw"""
    PoincareHalfSpacePoint <: AbstractManifoldPoint

A point on the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` can be represented as a vector in the
half plane, i.e. ``x ∈ ℝ^n`` with ``x_d > 0``.
"""
struct PoincareHalfSpacePoint{TValue <: AbstractVector} <: AbstractManifoldPoint
    value::TValue
end

@doc raw"""
    PoincareHalfPlaneTangentVector <: AbstractTangentVector

In the Poincaré half plane model of the [`Hyperbolic`](@ref) ``\mathcal H^n`` tangent vectors are
represented as vectors in ``ℝ^{n}``.
"""
struct PoincareHalfSpaceTangentVector{TValue <: AbstractVector} <: AbstractTangentVector
    value::TValue
end

ManifoldsBase.@manifold_element_forwards HyperboloidPoint value
ManifoldsBase.@manifold_vector_forwards HyperboloidTangentVector value
ManifoldsBase.@default_manifold_fallbacks Hyperbolic HyperboloidPoint HyperboloidTangentVector value value

ManifoldsBase.@manifold_element_forwards PoincareBallPoint value
ManifoldsBase.@manifold_vector_forwards PoincareBallTangentVector value

ManifoldsBase.@manifold_element_forwards PoincareHalfSpacePoint value
ManifoldsBase.@manifold_vector_forwards PoincareHalfSpaceTangentVector value

include("HyperbolicHyperboloid.jl")
include("HyperbolicPoincareBall.jl")
include("HyperbolicPoincareHalfspace.jl")

_ExtraHyperbolicPointTypes = [PoincareBallPoint, PoincareHalfSpacePoint]
_ExtraHyperbolicTangentTypes = [PoincareBallTangentVector, PoincareHalfSpaceTangentVector]
_ExtraHyperbolicTypes = [_ExtraHyperbolicPointTypes..., _ExtraHyperbolicTangentTypes...]

_HyperbolicPointTypes = [HyperboloidPoint, _ExtraHyperbolicPointTypes...]
_HyperbolicTangentTypes = [HyperboloidTangentVector, _ExtraHyperbolicTangentTypes...]
_HyperbolicTypes = [_HyperbolicPointTypes..., _HyperbolicTangentTypes...]

for (P, T) in zip(_HyperbolicPointTypes, _HyperbolicTangentTypes)
    @eval allocate(p::$P, ::Type{$T}) = $T(allocate(p.value))
    @eval allocate_result_type(::Hyperbolic, ::typeof(log), ::Tuple{$P, $P}) = $T
    @eval allocate_result_type(::Hyperbolic, ::typeof(inverse_retract), ::Tuple{$P, $P}) = $T
end

@doc raw"""
    check_point(M::Hyperbolic, p; kwargs...)

Check whether `p` is a valid point on the [`Hyperbolic`](@ref) `M`.

For the [`HyperboloidPoint`](@ref) or plain vectors this means that, `p` is a vector of
length ``n+1`` with inner product in the embedding of -1, see [`MinkowskiMetric`](@ref).
The tolerance for the last test can be set using the `kwargs...`.

For the [`PoincareBallPoint`](@ref) a valid point is a vector ``p ∈ ℝ^n`` with a norm strictly
less than 1.

For the [`PoincareHalfSpacePoint`](@ref) a valid point is a vector from ``p ∈ ℝ^n`` with a positive
last entry, i.e. ``p_n>0``
"""
check_point(::Hyperbolic, ::Any)

@doc raw"""
    check_vector(M::Hyperbolic, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`Hyperbolic`](@ref) `M`, i.e.
after [`check_point`](@ref)`(M,p)`, `X` has to be of the same dimension as `p`.
The tolerance for the last test can be set using the `kwargs...`.

For a the hyperboloid model or vectors, `X` has to be  orthogonal to `p` with respect
to the inner product from the embedding, see [`MinkowskiMetric`](@ref).

For a the Poincaré ball as well as the Poincaré half plane model, `X` has to be a vector from ``ℝ^{n}``.
"""
check_vector(::Hyperbolic, ::Any, ::Any)

function check_vector(
        M::Hyperbolic,
        p,
        X::Union{PoincareBallTangentVector, PoincareHalfSpaceTangentVector};
        kwargs...,
    )
    n = get_parameter(M.size)[1]
    return check_point(Euclidean(n), X.value; kwargs...)
end

# Define self conversions
#
for (P, T) in zip(_HyperbolicPointTypes, _HyperbolicTangentTypes)
    @eval convert(::Type{$T}, p::$P, X::$T) = X
    @eval function convert(
            ::Type{Tuple{AbstractVector, AbstractVector}},
            (p, X)::Tuple{$P, $T},
        )
        return (convert(AbstractVector, p), convert(AbstractVector, p, X))
    end
end

metric(::Hyperbolic) = MinkowskiMetric()

function diagonalizing_projectors(M::Hyperbolic, p, X)
    X_norm = norm(M, p, X)
    X_normed = X / X_norm
    return (
        (zero(number_eltype(p)), ProjectorOntoVector(M, p, X_normed)),
        (-one(number_eltype(p)), CoprojectorOntoVector(M, p, X_normed)),
    )
end

function get_embedding(::Hyperbolic{TypeParameter{Tuple{n}}}) where {n}
    return Lorentz(n + 1, MinkowskiMetric())
end
function get_embedding(M::Hyperbolic{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return Lorentz(n + 1, MinkowskiMetric(); parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Hyperbolic)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end
function ManifoldsBase.get_embedding_type(::Hyperbolic, ::Type{<:HyperboloidPoint})
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

embed(::Hyperbolic, p::AbstractArray) = p
embed(::Hyperbolic, p::AbstractArray, X::AbstractArray) = X

@doc raw"""
    exp(M::Hyperbolic, p, X)

Compute the exponential map on the [`Hyperbolic`](@ref) space ``\mathcal H^n`` emanating
from `p` towards `X`. The formula reads

````math
\exp_p X = \cosh(\sqrt{⟨X,X⟩_{\mathrm{M}}})p
+ \sinh(\sqrt{⟨X,X⟩_{\mathrm{M}}})\frac{X}{\sqrt{⟨X,X⟩_{\mathrm{M}}}},
````

where ``⟨⋅,⋅⟩_{\mathrm{M}}`` denotes the [`MinkowskiMetric`](@ref) on the embedding, the [`Lorentz`](@ref)ian manifold,
see for example the extended version [BergmannPerschSteidl:2015:1](@cite) of the paper [BergmannPerschSteidl:2016:1](@cite).
"""
exp(::Hyperbolic, ::Any, ::Any)

for (P, T) in zip(_ExtraHyperbolicPointTypes, _ExtraHyperbolicTangentTypes)
    @eval begin
        function exp!(M::Hyperbolic, q::$P, p::$P, X::$T)
            q.value .=
                convert(
                $P,
                exp(M, convert(AbstractVector, p), convert(AbstractVector, p, X)),
            ).value
            return q
        end
        function exp_fused!(M::Hyperbolic, q::$P, p::$P, X::$T, t::Number)
            q.value .=
                convert(
                $P,
                exp_fused(
                    M,
                    convert(AbstractVector, p),
                    convert(AbstractVector, p, X),
                    t,
                ),
            ).value
            return q
        end
    end
end

@doc raw"""
    injectivity_radius(M::Hyperbolic)
    injectivity_radius(M::Hyperbolic, p)

Return the injectivity radius on the [`Hyperbolic`](@ref), which is ``∞``.
"""
injectivity_radius(::Hyperbolic) = Inf

for T in _ExtraHyperbolicPointTypes
    @eval function _isapprox(::Hyperbolic, p::$T, q::$T; kwargs...)
        return isapprox(p.value, q.value; kwargs...)
    end
end
for (P, T) in zip(_ExtraHyperbolicPointTypes, _ExtraHyperbolicTangentTypes)
    @eval function _isapprox(::Hyperbolic, ::$P, X::$T, Y::$T; kwargs...)
        return isapprox(X.value, Y.value; kwargs...)
    end
end

"""
    is_flat(::Hyperbolic)

Return false. [`Hyperbolic`](@ref) is not a flat manifold.
"""
is_flat(M::Hyperbolic) = false

@doc raw"""
    log(M::Hyperbolic, p, q)

Compute the logarithmic map on the [`Hyperbolic`](@ref) space ``\mathcal H^n``, the tangent
vector representing the [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) starting from `p`
reaches `q` after time 1. The formula reads for ``p ≠ q``

```math
\log_p q = d_{\mathcal H^n}(p,q)
\frac{q-⟨p,q⟩_{\mathrm{M}} p}{\lVert q-⟨p,q⟩_{\mathrm{M}} p \rVert_2},
```

where ``⟨⋅,⋅⟩_{\mathrm{M}}`` denotes the [`MinkowskiMetric`](@ref) on the embedding,
the [`Lorentz`](@ref)ian manifold. For ``p=q`` the logarithmic map is equal to the zero vector
For more details, see for example the extended version [BergmannPerschSteidl:2015:1](@cite) of the paper [BergmannPerschSteidl:2016:1](@cite).
"""
log(::Hyperbolic, ::Any...)

for (P, T) in zip(_ExtraHyperbolicPointTypes, _ExtraHyperbolicTangentTypes)
    @eval function log!(M::Hyperbolic, X::$T, p::$P, q::$P)
        X.value .=
            convert(
            $T,
            convert(AbstractVector, p),
            log(M, convert(AbstractVector, p), convert(AbstractVector, q)),
        ).value
        return X
    end
end

@doc raw"""
    manifold_dimension(M::Hyperbolic)

Return the dimension of the hyperbolic space manifold ``\mathcal H^n``, i.e. ``\dim(\mathcal H^n) = n``.
"""
manifold_dimension(M::Hyperbolic) = get_parameter(M.size)[1]

@doc raw"""
    manifold_dimension(M::Hyperbolic)

Return the volume of the hyperbolic space manifold ``\mathcal H^n``, i.e. infinity.
"""
manifold_volume(::Hyperbolic) = Inf

"""
    mean(
        M::Hyperbolic,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = CyclicProximalPointEstimation();
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` on the
[`Hyperbolic`](@ref) space using [`CyclicProximalPointEstimation`](@extref `ManifoldsBase.CyclicProximalPointEstimation`).
"""
mean(::Hyperbolic, ::Any...)

default_approximation_method(::Hyperbolic, ::typeof(mean)) = CyclicProximalPointEstimation()

@doc raw"""
    project(M::Hyperbolic, p, X)

Perform an orthogonal projection with respect to the Minkowski inner product of `X` onto
the tangent space at `p` of the [`Hyperbolic`](@ref) space `M`.

The formula reads
````math
Y = X + ⟨p,X⟩_{\mathrm{M}} p,
````
where ``⟨⋅, ⋅⟩_{\mathrm{M}}`` denotes the [`MinkowskiMetric`](@ref) on the embedding,
the [`Lorentz`](@ref)ian manifold.

!!! note

    Projection is only available for the (default) [`HyperboloidTangentVector`](@ref) representation,
    the others don't have such an embedding
"""
project(::Hyperbolic, ::Any, ::Any)

function Base.show(io::IO, ::Hyperbolic{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "Hyperbolic($(n))")
end
function Base.show(io::IO, M::Hyperbolic{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "Hyperbolic($(n); parameter=:field)")
end
for T in _HyperbolicTypes
    @eval Base.show(io::IO, p::$T) = print(io, "$($T)($(p.value))")
end

@doc raw"""
    parallel_transport_to(M::Hyperbolic, p, X, q)

Compute the parallel transport of the `X` from the tangent space at `p` on the
[`Hyperbolic`](@ref) space ``\mathcal H^n`` to the tangent at `q` along the [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`)
connecting `p` and `q`. The formula reads

````math
\mathcal P_{q←p}X = X - \frac{⟨\log_p q,X⟩_p}{d^2_{\mathcal H^n}(p,q)}
\bigl(\log_p q + \log_qp \bigr),
````
where ``⟨⋅,⋅⟩_p`` denotes the inner product in the tangent space at `p`.
"""
parallel_transport_to(::Hyperbolic, ::Any, ::Any, ::Any)

for (P, T) in zip(_ExtraHyperbolicPointTypes, _ExtraHyperbolicTangentTypes)
    @eval function parallel_transport_to!(M::Hyperbolic, Y::$T, p::$P, X::$T, q::$P)
        Y.value .=
            convert(
            $T,
            convert(AbstractVector, q),
            parallel_transport_to(
                M,
                convert(AbstractVector, p),
                convert(AbstractVector, p, X),
                convert(AbstractVector, q),
            ),
        ).value
        return Y
    end
    @eval zero_vector(::Hyperbolic, p::$P) = $T(zero(p.value))
    @eval zero_vector!(::Hyperbolic, X::$T, ::$P) = fill!(X.value, 0)
end

@doc raw"""
    riemann_tensor(M::Hyperbolic{n}, p, X, Y, Z)

Compute the Riemann tensor ``R(X,Y)Z`` at point `p` on [`Hyperbolic`](@ref) `M`.
The formula reads (see e.g., [Lee:2019](@cite) Proposition 8.36)

````math
R(X,Y)Z = - (\langle Z, Y \rangle X - \langle Z, X \rangle Y)
````
"""
riemann_tensor(::Hyperbolic, p, X, Y, Z)

function riemann_tensor!(M::Hyperbolic, W, p, X, Y, Z)
    W .= inner(M, p, Z, X) .* Y .- inner(M, p, Z, Y) .* X
    return W
end

@doc raw"""
    sectional_curvature(::Hyperbolic, p, X, Y)

Sectional curvature of [`Hyperbolic`](@ref) `M` is -1 if dimension is > 1 and 0 otherwise.
"""
function sectional_curvature(M::Hyperbolic, p, X, Y)
    if manifold_dimension(M) > 1
        return -1.0
    else
        return 0.0
    end
end

@doc raw"""
    sectional_curvature_max(::Hyperbolic)

Sectional curvature of [`Hyperbolic`](@ref) `M` is -1 if dimension is > 1 and 0 otherwise.
"""
function sectional_curvature_max(M::Hyperbolic)
    if manifold_dimension(M) > 1
        return -1.0
    else
        return 0.0
    end
end

@doc raw"""
    sectional_curvature_min(M::Hyperbolic)

Sectional curvature of [`Hyperbolic`](@ref) `M` is -1 if dimension is > 1 and 0 otherwise.
"""
function sectional_curvature_min(M::Hyperbolic)
    if manifold_dimension(M) > 1
        return -1.0
    else
        return 0.0
    end
end

@doc raw"""
    LogEuclideanMetric <: RiemannianMetric

The LogEuclidean Metric consists of the Euclidean metric applied to all elements after mapping them
into the Lie Algebra, i.e. performing a matrix logarithm beforehand.
"""
struct LogEuclideanMetric <: RiemannianMetric end

@doc raw"""
    distance(M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogEuclideanMetric}, p, q)

Compute the distance on the [`SymmetricPositiveDefinite`](@ref) manifold between
`p` and `q` as a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with [`LogEuclideanMetric`](@ref).
The formula reads

```math
    d_{\mathcal P(n)}(p,q) = \lVert \operatorname{Log} p - \operatorname{Log} q \rVert_{\mathrm{F}}
```

where $\operatorname{Log}$ denotes the matrix logarithm and
$\lVert⋅\rVert_{\mathrm{F}}$ denotes the matrix Frobenius norm.
"""
function distance(::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogEuclideanMetric}, p, q)
    return norm(log(Symmetric(p)) - log(Symmetric(q)))
end

"""
    is_flat(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,LogEuclideanMetric})

Return false. [`SymmetricPositiveDefinite`](@ref) with [`LogEuclideanMetric`](@ref)
is not a flat manifold.
"""
is_flat(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, LogEuclideanMetric}) = false

include("../header.jl")

@testset "Grassmann" begin
    @testset "Real" begin
        M = Grassmann(3, 2)
        @testset "Basics" begin
            @test repr(M) == "Grassmann(3, 2, ℝ)"
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 2
            @test get_total_space(M) == Stiefel(3, 2)
            @test !is_flat(M)
            @test is_flat(Grassmann(2, 1))
            @test default_retraction_method(M) == ExponentialRetraction()
            @test default_retraction_method(M, typeof(zeros(3, 2))) ==
                ExponentialRetraction()
            @test default_retraction_method(M, ProjectorPoint) == ExponentialRetraction()
            @test default_vector_transport_method(M) == ParallelTransport()
            @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0], [0.0, 0.0, 1.0, 0.0])
            @test_throws ManifoldDomainError is_point(
                M,
                [2.0 0.0; 0.0 1.0; 0.0 0.0];
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                [2.0 0.0; 0.0 1.0; 0.0 0.0],
                zeros(3, 2);
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                ones(3, 2);
                error = :error,
            )
            @test is_point(M, [1.0 0.0; 0.0 1.0; 0.0 0.0]; error = :error)
            @test_throws ManifoldDomainError is_point(
                M,
                1im * [1.0 0.0; 0.0 1.0; 0.0 0.0];
                error = :error,
            )
            @test is_vector(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                zero_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0]);
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                1im * zero_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0]);
                error = :error,
            )
            @test injectivity_radius(M) == π / 2
            @test injectivity_radius(M, ExponentialRetraction()) == π / 2
            @test injectivity_radius(M, [1.0 0.0; 0.0 1.0; 0.0 0.0]) == π / 2
            @test injectivity_radius(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                ExponentialRetraction(),
            ) == π / 2
        end
        types = [Matrix{Float64}]
        basis_types = (ProjectedOrthonormalBasis(:gram_schmidt),)
        @testset "Type $T" for T in types
            p1 = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            X = [0.0 0.0; 0.0 0.0; 0.0 1.0]
            p2 = exp(M, p1, X)
            Y = [0.0 1.0; -1.0 0.0; 1.0 0.0]
            p3 = exp(M, p1, Y)
            pts = convert.(T, [p1, p2, p3])
            Manifolds.test_manifold(
                M,
                pts,
                test_exp_log = true,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_project_point = true,
                test_default_vector_transport = true,
                vector_transport_methods = [ParallelTransport(), ProjectionTransport()],
                point_distributions = [Manifolds.uniform_distribution(M, pts[1])],
                test_rand_point = true,
                test_rand_tvector = true,
                retraction_methods = [PolarRetraction(), QRRetraction()],
                inverse_retraction_methods = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                #basis_types_vecs = basis_types,
                # investigate why this is so large on dev
                exp_log_atol_multiplier = 1.0,
                is_tangent_atol_multiplier = 20.0,
                is_point_atol_multiplier = 10.0,
                projection_atol_multiplier = 10.0,
                retraction_atol_multiplier = 10.0,
            )

            @testset "inner/norm" begin
                X1 = inverse_retract(M, pts[1], pts[2], PolarInverseRetraction())
                X2 = inverse_retract(M, pts[1], pts[3], PolarInverseRetraction())

                @test real(inner(M, pts[1], X1, X2)) ≈ real(inner(M, pts[1], X2, X1))
                @test imag(inner(M, pts[1], X1, X2)) ≈ -imag(inner(M, pts[1], X2, X1))
                @test imag(inner(M, pts[1], X1, X1)) ≈ 0

                @test norm(M, pts[1], X1) isa Real
                @test norm(M, pts[1], X1) ≈ sqrt(inner(M, pts[1], X1, X1))
            end
            @test riemann_tensor(M, p1, X, Y, 2 * X + Y) ≈ [0 -2; 0 1; 2 0]
            @testset "gradient and metric conversion" begin
                Y = change_metric(M, EuclideanMetric(), p1, X)
                @test Y == X
                Z = change_representer(M, EuclideanMetric(), p1, X)
                @test Z == X
            end
        end

        @testset "Distribution tests" begin
            ugd_mmatrix = Manifolds.uniform_distribution(
                M, @MMatrix [
                    1.0 0.0
                    0.0 1.0
                    0.0 0.0
                ]
            )
            @test isa(rand(ugd_mmatrix), MMatrix)
        end

        @testset "vector transport" begin
            p1 = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            X = [0.0 0.0; 0.0 0.0; 0.0 1.0]
            p2 = exp(M, p1, X)
            @test vector_transport_to(M, p1, X, p2, ProjectionTransport()) ==
                project(M, p2, X)
            @test is_vector(
                M,
                p2,
                vector_transport_to(M, p1, X, p2, ProjectionTransport());
                error = :error,
                atol = 10^-15,
            )
        end

        @testset "default_* functions" begin
            p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            pS = StiefelPoint(p)
            @test default_vector_transport_method(M, typeof(p)) == ParallelTransport()
            @test default_vector_transport_method(M, typeof(pS)) == ParallelTransport()
        end
    end

    @testset "Complex" begin
        M = Grassmann(3, 2, ℂ)
        @testset "Basics" begin
            @test repr(M) == "Grassmann(3, 2, ℂ)"
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 4
            @test !is_flat(M)
            @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0], [0.0, 0.0, 1.0, 0.0])
            @test Manifolds.allocation_promotion_function(M, exp!, (1,)) == complex
            @test_throws ManifoldDomainError is_point(
                M,
                [2.0 0.0; 0.0 1.0; 0.0 0.0];
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                [2.0 0.0; 0.0 1.0; 0.0 0.0],
                zeros(3, 2);
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                ones(3, 2);
                error = :error,
            )
            @test is_vector(
                M,
                [1.0 0.0; 0.0 1.0; 0.0 0.0],
                1im * zero_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0]),
            )
            @test is_point(M, [1.0 0.0; 0.0 1.0; 0.0 0.0])
            @test injectivity_radius(M) == π / 2
        end
        types = [Matrix{ComplexF64}]
        @testset "Type $T" for T in types
            p1 = [0.5 + 0.5im 0.5 + 0.5im; 0.5 + 0.5im -0.5 - 0.5im; 0.0 0.0]
            X = [0.0 0.0; 0.0 0.0; 0.0 1.0]
            p2 = exp(M, p1, X)
            Y = [0.0 1.0; -1.0 0.0; 1.0 0.0]
            p3 = exp(M, p1, Y)
            pts = convert.(T, [p1, p2, p3])
            Manifolds.test_manifold(
                M,
                pts,
                test_exp_log = true,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_project_point = true,
                test_default_vector_transport = false,
                retraction_methods = [PolarRetraction(), QRRetraction()],
                inverse_retraction_methods = [
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                exp_log_atol_multiplier = 10.0^4,
                is_point_atol_multiplier = 20.0,
                is_tangent_atol_multiplier = 20.0,
                projection_atol_multiplier = 10.0,
                retraction_atol_multiplier = 10.0,
                test_inplace = true,
                test_rand_point = true,
            )

            @testset "inner/norm" begin
                X1 = inverse_retract(M, pts[1], pts[2], PolarInverseRetraction())
                X2 = inverse_retract(M, pts[1], pts[3], PolarInverseRetraction())

                @test real(inner(M, pts[1], X1, X2)) ≈ real(inner(M, pts[1], X2, X1))
                @test imag(inner(M, pts[1], X1, X2)) ≈ -imag(inner(M, pts[1], X2, X1))
                @test isapprox(imag(inner(M, pts[1], X1, X1)), 0; atol = 1.0e-30)

                @test norm(M, pts[1], X1) isa Real
                @test norm(M, pts[1], X1) ≈ sqrt(inner(M, pts[1], X1, X1))
            end
        end
    end

    @testset "Complex and conjugate" begin
        G = Grassmann(3, 1, ℂ)
        p = reshape([im, 0.0, 0.0], 3, 1)
        @test is_point(G, p)
        X = reshape([-0.5; 0.5; 0], 3, 1)
        @test_throws ManifoldDomainError is_vector(G, p, X; error = :error)
        Y = project(G, p, X)
        @test is_vector(G, p, Y)
    end

    @testset "Projector representation" begin
        M = Grassmann(3, 2)
        p = ProjectorPoint([1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 0.0])
        X = ProjectorTangentVector([0.0 0.0 1.0; 0.0 0.0 1.0; 1.0 1.0 0.0])
        pS = StiefelPoint([1.0 0.0; 0.0 1.0; 0.0 0.0])
        Xs = StiefelTangentVector([0.0 1.0; -1.0 0.0; 0.0 0.0])
        @test representation_size(M, p) == (3, 3)

        q = embed(M, p)
        @test q == p.value
        q2 = similar(q)
        embed!(M, q2, p)
        @test q2 == p.value
        q3 = similar(q)
        embed!(M, q3, p.value)
        @test q3 == p.value
        Y = embed(M, p, X)
        @test Y == X.value
        Y2 = similar(Y)
        embed!(M, Y2, p, X)
        @test Y2 == X.value
        Y3 = similar(Y)
        embed!(M, Y3, p.value, X.value)
        @test Y3 == X.value

        pSe = similar(pS.value)
        embed!(M, pSe, pS)
        @test pSe == pS.value
        Xse = similar(Xs.value)
        embed!(M, Xse, pS, Xs)
        Xse == Xs.value

        p2 = ProjectorPoint(similar(p.value))
        pC = pS.value * pS.value'
        canonical_project!(M, p2, pS)
        @test p2.value == pC
        p3 = ProjectorPoint(similar(p.value))
        canonical_project!(M, p2, pS.value)
        @test p2.value == pC
        p3 = canonical_project(M, pS)
        @test p3.value == pC

        Y = ProjectorTangentVector(similar(X.value))
        Yc = Xs.value * pS.value' + pS.value * Xs.value'
        Manifolds.diff_canonical_project!(M, Y, pS, Xs)
        @test Y.value == Yc
        Y2 = ProjectorTangentVector(similar(X.value))
        Manifolds.diff_canonical_project!(M, Y2, pS.value, Xs.value)
        @test Y2.value == Yc

        @test horizontal_lift(Stiefel(3, 2), pS.value, X) == X.value[:, 1:2]

        exppx = exp(X.value * p.value - p.value * X.value)
        qc = exppx * p.value / exppx
        q = exp(M, p, X)
        @test qc == q.value

        d = -X
        edppd = exp(d.value * p.value - p.value * d.value)
        Yc2 = edppd * X.value / edppd
        Xp = parallel_transport_direction(M, p, X, d)
        @test Xp.value == Yc2
    end

    @testset "is_point & convert & show" begin
        M = Grassmann(3, 2)
        p = StiefelPoint([1.0 0.0; 0.0 1.0; 0.0 0.0])
        X = StiefelTangentVector([0.0 1.0; -1.0 0.0; 0.0 0.0])
        @test is_point(M, p; error = :error)
        @test is_vector(M, p, X; error = :error)
        @test repr(p) == "StiefelPoint($(p.value))"
        @test repr(X) == "StiefelTangentVector($(X.value))"
        M2 = Stiefel(3, 2)
        @test is_point(M2, p; error = :error)
        @test is_vector(M2, p, X; error = :error)

        p2 = convert(ProjectorPoint, p)
        @test is_point(M, p2; error = :error)
        p3 = convert(ProjectorPoint, p.value)
        @test p2.value == p3.value
        X2 = ProjectorTangentVector([0.0 0.0 1.0; 0.0 0.0 1.0; 1.0 1.0 0.0])
        @test is_vector(M, p2, X2)
        @test repr(p2) == "ProjectorPoint($(p2.value))"
        @test repr(X2) == "ProjectorTangentVector($(X2.value))"

        # rank just 1
        pF1 = ProjectorPoint([1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0])
        @test_throws DomainError is_point(M, pF1; error = :error)
        # not equal to its square
        pF2 = ProjectorPoint([1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 1.0 0.0])
        @test_throws DomainError is_point(M, pF2; error = :error)
        # not symmetric
        pF3 = ProjectorPoint([0.0 1.0 0.0; 0.0 1.0 0.0; 0.0 0.0 0.0])
        @test_throws DomainError is_point(M, pF3; error = :error)

        # not symmetric
        XF1 = ProjectorTangentVector([0.0 0.0 1.0; 0.0 0.0 1.0; 1.0 0.0 0.0])
        @test_throws DomainError is_vector(M, p2, XF1; error = :error)
        # XF2 is not p2*XF2 + XF2*p2
        XF2 = ProjectorTangentVector(ones(3, 3))
        @test_throws DomainError is_vector(M, p2, XF2; error = :error)

        # embed for Stiefel with its point
        M2 = Stiefel(3, 2)
        q = embed(M2, p)
        @test q == p.value
        q2 = similar(q)
        embed!(M2, q2, p)
        q3 = similar(q)
        @test q2 == p.value
        embed!(M2, q3, p.value)
        @test q3 == p.value
        Y = embed(M2, p, X)
        @test Y == X.value
        Y2 = similar(Y)
        embed!(M2, Y2, p, X)
        @test Y2 == X.value
        Y3 = similar(Y)
        embed!(M2, Y3, p.value, X.value)
        @test Y3 == X.value
    end

    @testset "small distance tests" begin
        n, k = 5, 3
        @testset for fT in (Float32, Float64), T in (fT, Complex{fT})
            𝔽 = T isa Complex ? ℂ : ℝ
            M = Grassmann(n, k, 𝔽)
            U = UnitaryMatrices(k, 𝔽)
            rT = real(T)
            atol = rtol = sqrt(eps(rT))
            @testset for t in (zero(rT), eps(rT)^(1 // 4) / 8, eps(rT)^(1 // 4)),
                    z in (I, rand(U))

                p = project(M, randn(T, representation_size(M)))
                X = project(M, p, randn(T, representation_size(M)))
                X ./= norm(M, p, X)
                project!(M, X, p, X)
                @test distance(M, p, exp(M, p, t * X) * z) ≈ t atol = atol rtol = rtol
            end
        end
    end
    @testset "Riemannian Hessian" begin
        M = Grassmann(3, 2)
        p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        X = [0.0 0.0; 0.0 0.0; 0.0 1.0]
        Y = [0.0 1.0; -1.0 0.0; 1.0 0.0]
        Z = [0.0 -1.0; 1.0 0.0; 1.0 0.0]
        @test riemannian_Hessian(M, p, Y, Z, X) == [0.0 0.0; 0.0 0.0; 2.0 0.0]
    end
    @testset "field parameter" begin
        M = Grassmann(3, 2; parameter = :field)
        @test repr(M) == "Grassmann(3, 2, ℝ; parameter=:field)"
        @test typeof(get_embedding(M)) === Stiefel{ℝ, Tuple{Int64, Int64}}
        @test typeof(get_total_space(M)) === Stiefel{ℝ, Tuple{Int64, Int64}}
        p = StiefelPoint([1.0 0.0; 0.0 1.0; 0.0 0.0])
        p2 = convert(ProjectorPoint, p)
        @test get_embedding(M, typeof(p2)) == Euclidean(3, 3; parameter = :field)
        @test get_total_space(M) == Stiefel(3, 2; parameter = :field)
    end
end

@doc raw"""
    KendallsShapeSpace{T} <: AbstractDecoratorManifold{ℝ}

Kendall's shape space, defined as quotient of a [`KendallsPreShapeSpace`](@ref)
(represented by n×k matrices) modulo column wise application of a single rotation.

The space can be interpreted as tuples of ``k`` points in ``ℝ^n`` up to simultaneous
translation and scaling and rotation of all points [Kendall:1984](@cite)[Kendall:1989](@cite).

# Constructor

    KendallsShapeSpace(n::Int, k::Int; parameter::Symbol=:type)

# References
"""
struct KendallsShapeSpace{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function KendallsShapeSpace(n::Int, k::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return KendallsShapeSpace{typeof(size)}(size)
end

#
# A small internal function, given two shapes p, q as matrices (n,k) with columns of points,
# find the best alignment (without mirroring) to rotate q to p; this is done by
# the closed form solution of the orthogonal Procrustes problem – and a carefull check to avoid that we mirror points.
#
function _optimal_alignment(::KendallsShapeSpace, p, q)
    Xmul = p * transpose(q)
    F = svd(Xmul)
    L = size(Xmul)[2]
    UVt = F.U * F.Vt
    Ostar = det(UVt) ≥ 0 ? UVt : F.U * Diagonal([i < L ? 1 : -1 for i in 1:L]) * F.Vt
    return convert(typeof(Xmul), Ostar)
end


@doc raw"""
    get_total_space(::KendallsShapeSpace)

Return the total space of the [`KendallsShapeSpace`](@ref) manifold, which is the
[`KendallsPreShapeSpace`](@ref) manifold.
"""
get_total_space(::KendallsShapeSpace)
function get_total_space(::KendallsShapeSpace{TypeParameter{Tuple{n, k}}}) where {n, k}
    return KendallsPreShapeSpace(n, k)
end
function get_total_space(M::KendallsShapeSpace{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return KendallsPreShapeSpace(n, k; parameter = :field)
end

function distance(M::KendallsShapeSpace, p, q)
    rot_q = _optimal_alignment(M, p, q) * q
    return distance(get_embedding(M), p, rot_q)
end

"""
    exp(M::KendallsShapeSpace, p, X)

Compute the exponential map on [`KendallsShapeSpace`](@ref) `M`.
See [GuiguiMaignantTroouvePennec:2021](@cite) for discussion about its computation.

"""
exp(M::KendallsShapeSpace, p, X)

function exp!(M::KendallsShapeSpace, q, p, X)
    Xh = horizontal_component(M, p, X)
    return exp!(get_embedding(M), q, p, Xh)
end

embed(::KendallsShapeSpace, p) = p
embed(::KendallsShapeSpace, p, X) = X

"""
    get_embedding(M::KendallsShapeSpace)

Get the manifold in which [`KendallsShapeSpace`](@ref) `M` is embedded, i.e.
[`KendallsPreShapeSpace`](@ref) of matrices of the same shape.
"""
get_embedding(::KendallsShapeSpace)

function get_embedding(::KendallsShapeSpace{TypeParameter{Tuple{n, k}}}) where {n, k}
    return KendallsPreShapeSpace(n, k)
end
function get_embedding(M::KendallsShapeSpace{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return KendallsPreShapeSpace(n, k; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::KendallsShapeSpace)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

"""
    horizontal_component(::KendallsShapeSpace, p, X)

Compute the horizontal component of tangent vector `X` at `p` on [`KendallsShapeSpace`](@ref)
`M`. See [GuiguiMaignantTroouvePennec:2021](@cite), Section 2.3 for details.
"""
horizontal_component(::KendallsShapeSpace, p, X)

function horizontal_component!(::KendallsShapeSpace, Y, p, X)
    B = p * transpose(p)
    C = X * transpose(p) - p * transpose(X)
    A = sylvc(B, B, C)
    Y .= X .- A * p
    return Y
end

function inner(M::KendallsShapeSpace, p, X, Y)
    Xh = horizontal_component(M, p, X)
    Yh = horizontal_component(M, p, Y)
    return inner(get_embedding(M), p, Xh, Yh)
end

function _isapprox(M::KendallsShapeSpace, p, X, Y; atol = sqrt(max_eps(X, Y)), kwargs...)
    return isapprox(norm(M, p, X - Y), 0; atol = atol, kwargs...)
end
function _isapprox(M::KendallsShapeSpace, p, q; atol = sqrt(max_eps(p, q)), kwargs...)
    return isapprox(distance(M, p, q), 0; atol = atol, kwargs...)
end

"""
    is_flat(::KendallsShapeSpace)

Return false. [`KendallsShapeSpace`](@ref) is not a flat manifold.
"""
is_flat(M::KendallsShapeSpace) = false

"""
    log(M::KendallsShapeSpace, p, q)

Compute the logarithmic map on [`KendallsShapeSpace`](@ref) `M`.
See the [`exp`](@ref exp(::KendallsShapeSpace, ::Any, ::Any)onential map for more details
"""
log(M::KendallsShapeSpace, p, q)

function log!(M::KendallsShapeSpace, X, p, q)
    rot_q = _optimal_alignment(M, p, q) * q
    return log!(get_embedding(M), X, p, rot_q)
end

@doc raw"""
    manifold_dimension(M::KendallsShapeSpace)

Return the dimension of the [`KendallsShapeSpace`](@ref) manifold `M`. The dimension is
given by ``n(k - 1) - 1 - n(n - 1)/2`` in the typical case where ``k \geq n+1``, and
``(k + 1)(k - 2) / 2`` otherwise, unless ``k`` is equal to 1, in which case the dimension
is 0. See [Kendall:1984](@cite) for a discussion of the over-dimensioned case.
"""
function manifold_dimension(M::KendallsShapeSpace)
    n, k = get_parameter(M.size)
    if k < n + 1 # over-dimensioned case
        if k == 1
            return 0
        else
            return div((k + 1) * (k - 2), 2)
        end
    else
        return n * (k - 1) - 1 - div(n * (n - 1), 2)
    end
end

function norm(M::KendallsShapeSpace, p, X)
    Xh = horizontal_component(M, p, X)
    return norm(get_embedding(M), p, Xh)
end

function project!(M::KendallsShapeSpace, q, p)
    return project!(get_embedding(M), q, p)
end

function project!(M::KendallsShapeSpace, Y, p, X)
    return project!(get_embedding(M), Y, p, X)
end

@doc raw"""
    rand(::KendallsShapeSpace; vector_at=nothing)

When `vector_at` is `nothing`, return a random point `x` on the [`KendallsShapeSpace`](@ref)
manifold `M` by generating a random point in the embedding.

When `vector_at` is not `nothing`, return a random vector from the tangent space
with mean zero and standard deviation `σ`.
"""
rand(::KendallsShapeSpace; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::KendallsShapeSpace,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)),
    )
    rand!(rng, get_embedding(M), pX; vector_at = vector_at, σ = σ)
    return pX
end

function Base.show(io::IO, ::KendallsShapeSpace{TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "KendallsShapeSpace($n, $k)")
end
function Base.show(io::IO, M::KendallsShapeSpace{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "KendallsShapeSpace($n, $k; parameter=:field)")
end

using Manifolds, LinearAlgebra, PGFPlotsX, Colors

out_file = joinpath(
    @__DIR__,
    "..",
    "docs",
    "src",
    "assets",
    "images",
    "retraction_illustration.png",
)
n = 100

line_width = 1 / 2
light_color = colorant"#BBBBBB"
base_linewidth = line_width
point_color = colorant"#0077BB" #Blue
main_linewidth = 1.25
tangent_color = colorant"#33BBEE" #Cyan
tangent_linewidth = main_linewidth
geo_color = colorant"#009988" #teal
geo_linewidth = 1.25
geo_marker_size = 1.5
projection_color = colorant"#EE7733"
projection_color2 = colorant"#0077BB" #Blue
projection_color3 = colorant"#33BBEE" #Cyan
projection_marker_size = 1.5

C_to_2D(p) = [real(p), imag(p)]

M = Circle(ℂ)

p = (1 + 2im) / abs(1 + 2im)
X = imag(p) - real(p) * im
qE = exp(M, p, X)
qP = project(M, p + X)

circle = [[sin(φ), cos(φ)] for φ in range(0, 2π, length = n)]
tp = @pgf Axis(
    {
        axis_lines = "none",
        axis_equal,
        xmin = -1.7,
        xmax = 1.7,
        ymin = -0.25,
        ymax = 1.4,
        scale = 1.6,
    }
)

plain_opts = @pgf {"no markers", color = light_color, line_width = base_linewidth}

push!(tp, Plot(plain_opts, Coordinates(Tuple.(circle))))
plaint_opts_a = @pgf {"only marks", mark_size = geo_marker_size / 2, color = light_color}
push!(tp, Plot(plaint_opts_a, Coordinates(Tuple.([[0.0, 0.0]]))))

tangent_line = [C_to_2D(p - 0.8 * X), C_to_2D(p + 1.3 * X)]
push!(tp, Plot(plain_opts, Coordinates(Tuple.(tangent_line))))

tangent_opts =
    @pgf {"no markers", "->", color = tangent_color, line_width = tangent_linewidth}
tangent_vec = [C_to_2D(p), C_to_2D(p + X)]
push!(tp, Plot(tangent_opts, Coordinates(Tuple.(tangent_vec))))

geo_opts = @pgf {"no markers", "-", color = geo_color, line_width = geo_linewidth}
geo_pts = C_to_2D.(shortest_geodesic(M, p, qE, range(0, 1, length = n)))
push!(tp, Plot(geo_opts, Coordinates(Tuple.(geo_pts))))
geo_opts2 = @pgf {"only marks", mark_size = geo_marker_size, color = geo_color}
push!(tp, Plot(geo_opts2, Coordinates(Tuple.([C_to_2D(p), C_to_2D(qE)]))))

projection_opts = @pgf {
    "no markers",
    "densely dotted",
    color = projection_color,
    line_width = base_linewidth,
}
projection_line = [C_to_2D(p + X), C_to_2D(qP)]
push!(tp, Plot(projection_opts, Coordinates(Tuple.(projection_line))))
projection_opts_a =
    @pgf {"only marks", mark_size = projection_marker_size, color = projection_color}
push!(tp, Plot(projection_opts_a, Coordinates(Tuple.([C_to_2D(qP)]))))

push!(
    tp,
    raw"\node[label ={[label distance=.05cm]above:{\color{gray}$p$}}] at (axis cs:" *
        "$(real(p)),$(imag(p))) {};",
)
push!(
    tp,
    raw"\node[label ={[label distance=.1cm]above:{\color{gray}$X\in T_p\mathcal C$}}] at (axis cs:" *
        "$(real(p + X / 2)),$(imag(p + X / 2))) {};",
)
push!(
    tp,
    raw"\node[label ={[label distance=.05cm]left:{\color{gray}$q'=\mathrm{retr}^{\mathrm{proj}}_pX=\mathrm{proj}_{\mathcal C}(p+X)$}}] at (axis cs:" *
        "$(real(qP)),$(imag(qP))) {};",
)
push!(
    tp,
    raw"\node[label ={[label distance=.05cm]left:{\color{gray}$q=\exp_pX$}}] at (axis cs:" *
        "$(real(qE)),$(imag(qE))) {};",
)

push!(tp, raw"\node at (axis cs: 0,-.6) {\color{gray}$\mathcal C$};")

pgfsave(out_file, tp; dpi = 1200)

include("../header.jl")

@testset "Hamiltonian matrices" begin
    M = HamiltonianMatrices(4)
    Mf = HamiltonianMatrices(4; parameter = :field)
    # A has to be of the Form JS, S symmetric
    p =
        SymplecticElement(1.0) * [
        1.0 2.0 0.0 0.0
        2.0 3.0 0.0 0.0
        0.0 0.0 1.0 0.0
        0.0 0.0 0.0 4.0
    ]
    q =
        SymplecticElement(1.0) * [
        4.0 3.0 0.0 0.0
        3.0 2.0 0.0 0.0
        0.0 0.0 4.0 0.0
        0.0 0.0 0.0 1.0
    ]
    @testset "Hamiltonian" begin
        @test is_hamiltonian(p)
        pH = Hamiltonian(p)
        @test is_hamiltonian(pH)
        @test Hamiltonian(pH) === pH
        @test startswith("$(pH)", "Hamiltonian([")
        @test size(pH) == size(p)
        @test (pH^+).value == symplectic_inverse(p)
        @test symplectic_inverse(pH).value == symplectic_inverse(p)
        qH = Hamiltonian(q)
        pqH = pH * qH
        @test pqH isa Hamiltonian
        @test pqH.value == p * q
        pqH2 = pH + qH
        @test pqH2 isa Hamiltonian
        @test pqH2.value == p + q
        pqH3 = pH - qH
        @test pqH3 isa Hamiltonian
        @test pqH3.value == p - q
        @test_throws DomainError is_point(M, ones(4, 4), true)
        @test_throws DomainError is_vector(M, p, ones(4, 4), true, true)
    end
    @testset "Basics" begin
        @test repr(M) == "HamiltonianMatrices(4, ℝ)"
        @test repr(Mf) == "HamiltonianMatrices(4, ℝ; parameter=:field)"
        @test is_point(M, p)
        @test is_point(M, Hamiltonian(p))
        @test is_vector(M, p, p)
        @test get_embedding(M) == Euclidean(4, 4; field = ℝ)
        @test get_embedding(Mf) == Euclidean(4, 4; field = ℝ, parameter = :field)
        @test embed(M, p) == p
        @test embed(M, p, p) == p
        @test is_flat(M)
        Random.seed!(42)
        is_point(M, rand(M))
    end
end

include("../header.jl")

@testset "Positive Numbers" begin
    M = PositiveNumbers()
    @testset "Positive Numbers Basics" begin
        @test repr(M) == "PositiveNumbers()"
        @test repr(PositiveVectors(2)) == "PositiveVectors(2)"
        @test repr(PositiveMatrices(2, 3)) == "PositiveMatrices(2, 3)"
        @test repr(PositiveArrays(2, 3, 4)) == "PositiveArrays(2, 3, 4)"
        @test representation_size(M) == ()
        @test manifold_dimension(M) == 1
        @test !is_flat(M)
        @test !is_point(M, -1.0)
        @test_throws DomainError is_point(M, -1.0; error = :error)
        @test is_vector(M, 1.0, 0.0)
        @test vector_transport_to(M, 1.0, 3.0, 2.0, ParallelTransport()) == 6.0
        @test retract(M, 1.0, 1.0) == exp(M, 1.0, 1.0)
        @test isinf(injectivity_radius(M))
        @test isinf(injectivity_radius(M, -2.0))
        @test isinf(injectivity_radius(M, -2.0, ExponentialRetraction()))
        @test isinf(injectivity_radius(M, ExponentialRetraction()))
        @test project(M, 1.5, 1.0) == 1.0
        @test embed(M, 1.0) == 1.0
        @test zero_vector(M, 1.0) == 0.0
        X = similar([1.0])
        zero_vector!(M, X, 1.0)
        @test X == [0.0]
        @test get_coordinates(M, 2.0, 1.0, DefaultOrthonormalBasis()) == 0.5
        @test get_vector(M, 2.0, 0.5, DefaultOrthonormalBasis()) == 1.0

        @test change_metric(M, EuclideanMetric(), 2, 3) == 3 * 2
        @test change_representer(M, EuclideanMetric(), 2, 3) == 3 * 2^2
        N = PositiveVectors(2)
        @test change_metric(M, EuclideanMetric(), [1, 2], [3, 4]) == [3, 4 * 2]
        @test change_representer(M, EuclideanMetric(), [1, 2], [3, 4]) == [3, 4 * 2^2]
        @test get_coordinates(N, [2.0, 4.0], [1.0, 10.0], DefaultOrthonormalBasis()) ==
            [0.5, 2.5]
        @test get_vector(N, [2.0, 4.0], [0.5, 2.5], DefaultOrthonormalBasis()) ==
            [1.0, 10.0]
        tmp = zeros(2)
        get_coordinates!(N, tmp, [2.0, 4.0], [1.0, 10.0], DefaultOrthonormalBasis())
        @test tmp == [0.5, 2.5]
        get_vector!(N, tmp, [2.0, 4.0], [0.5, 2.5], DefaultOrthonormalBasis())
        @test tmp == [1.0, 10.0]
    end
    types = [Float64]
    for T in types
        @testset "Type $T" begin
            pts = convert.(Ref(T), [1.0, 4.0, 2.0])
            Manifolds.test_manifold(
                M,
                pts,
                test_vector_spaces = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                is_mutating = false,
                test_rand_point = true,
                test_rand_tvector = true,
            )
        end
    end
    @testset "Power of Positive Numbers" begin
        M2 = PositiveVectors(2)
        for T in types
            pts2 = [convert.(Ref(T), v) for v in [[1.0, 1.1], [3.0, 3.3], [2.0, 2.2]]]
            Manifolds.test_manifold(
                M2,
                pts2,
                test_vector_spaces = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
            )
        end
    end
    @testset "Weingarten & Hessian" begin
        M = PositiveNumbers()
        p = 1.0
        G = 2.0
        H = 3.0
        X = 4.0
        rH = riemannian_Hessian(M, p, G, H, X)
        @test rH == p * H * p + X * G * p
    end

    @testset "Manifold volume" begin
        M5 = PositiveVectors(3)
        @test isinf(manifold_volume(M))
        @test isinf(manifold_volume(M5))
        @test volume_density(M, 0.5, 2.0) ≈ exp(4.0)
        @test volume_density(M5, [0.5, 1.0, 2.0], [1.0, -1.0, 2.0]) ≈ exp(2.0)
    end
    @testset "Inplace random values" begin
        p = fill(NaN)
        X = fill(NaN)
        rand!(M, p)
        @test is_point(M, p)
        rand!(M, X; vector_at = p)
        @test is_vector(M, p, X)
    end

    @testset "field parameter" begin
        M1 = PositiveVectors(3; parameter = :field)
        @test repr(M1) == "PositiveVectors(3; parameter=:field)"
        M2 = PositiveMatrices(3, 4; parameter = :field)
        @test repr(M2) == "PositiveMatrices(3, 4; parameter=:field)"
        M3 = PositiveArrays(3, 4, 5; parameter = :field)
        @test repr(M3) == "PositiveArrays(3, 4, 5; parameter=:field)"
    end
end

include("../header.jl")

@testset "Symmetric Positive Definite Matrices" begin
    M1 = SymmetricPositiveDefinite(3)
    @test repr(M1) == "SymmetricPositiveDefinite(3)"
    M2 = MetricManifold(SymmetricPositiveDefinite(3), Manifolds.AffineInvariantMetric())
    M3 = MetricManifold(SymmetricPositiveDefinite(3), Manifolds.LogCholeskyMetric())
    M4 = MetricManifold(SymmetricPositiveDefinite(3), Manifolds.LogEuclideanMetric())
    M5 = MetricManifold(SymmetricPositiveDefinite(3), Manifolds.BuresWassersteinMetric())
    M6 = MetricManifold(
        SymmetricPositiveDefinite(3),
        Manifolds.GeneralizedBuresWassersteinMetric(
            [2.0 1.0 0.0; 1.0 2.0 1.0; 0.0 1.0 2.0],
        ),
    )

    @test !is_flat(M4)
    @test injectivity_radius(M1) == Inf
    @test injectivity_radius(M1, one(zeros(3, 3))) == Inf
    @test injectivity_radius(M1, ExponentialRetraction()) == Inf
    @test injectivity_radius(M1, one(zeros(3, 3)), ExponentialRetraction()) == Inf
    @test zero_vector(M1, one(zeros(3, 3))) == zero_vector(M2, one(zeros(3, 3)))
    @test zero_vector(M1, one(zeros(3, 3))) == zero_vector(M3, one(zeros(3, 3)))
    metrics = [M1, M2, M3, M5, M6]
    types = [Matrix{Float64}, SPDPoint]

    for M in metrics
        basis_types = if (M == M1 || M == M2 || M == M3)
            (DefaultOrthonormalBasis(),)
        else
            ()
        end
        @testset "$(typeof(M))" begin
            @test representation_size(M) == (3, 3)
            if M === M3
                @test is_flat(M)
            else
                @test !is_flat(M)
            end
            for T in types
                exp_log_atol_multiplier = 8.0
                if T <: MMatrix{3, 3, Float64}
                    # eigendecomposition of 3x3 SPD matrices from StaticArrays is not very accurate
                    exp_log_atol_multiplier = 5.0e7
                end
                if M == M6
                    # we have to raise this slightly for the nondiagonal case.
                    exp_log_atol_multiplier = 5.0e1
                end
                if T == SPDPoint && (M != M1 && M != M2)
                    # SPDPoint only meant for Affine metric
                    continue
                end
                if M == M3 && T <: MMatrix
                    # Cholesky or something does not work in vector_transport yet for MMatrix
                    continue
                end
                A(α) = [1.0 0.0 0.0; 0.0 cos(α) sin(α); 0.0 -sin(α) cos(α)]
                ptsF = [#
                    [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1],
                    [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1],
                    A(π / 6) * [1.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1] * transpose(A(π / 6)),
                ]
                pts = [convert(T, a) for a in ptsF]
                Manifolds.test_manifold(
                    M,
                    pts;
                    vector_transport_methods = typeof(M) == SymmetricPositiveDefinite{3} ?
                        [ParallelTransport()] : [],
                    exp_log_atol_multiplier = exp_log_atol_multiplier,
                    basis_types_vecs = basis_types,
                    basis_types_to_from = basis_types,
                    is_tangent_atol_multiplier = 1,
                    test_inplace = true,
                    test_rand_point = M === M1,
                    test_rand_tvector = M === M1,
                    test_default_vector_transport = !(M === M5 || M === M6),
                )
            end
            @testset "Test Error cases in is_point and is_vector" begin
                pt1f = zeros(2, 3) # wrong size
                pt2f = [1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 1.0] # not positive Definite
                pt3f = [2.0 0.0 1.0; 0.0 1.0 0.0; 0.0 0.0 4.0] # not symmetric
                pt4 = [2.0 1.0 0.0; 1.0 2.0 0.0; 0.0 0.0 4.0]
                @test !is_point(M, pt1f)
                @test !is_point(M, pt2f)
                @test !is_point(M, pt3f)
                @test is_point(M, pt4)
                @test !is_vector(M, pt4, pt1f)
                @test is_vector(M, pt4, pt2f)
                @test !is_vector(M, pt4, pt3f)
            end
        end
    end
    p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]
    q = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
    @testset "Convert Eucl/Emb to (Generalised) BW" begin
        Z = ones(3, 3)
        em = EuclideanMetric()
        x = 2 .* (Z * p + p * Z)
        X = change_representer(M5, em, p, Z)
        @test isapprox(x, X)
        y = 2 .* (Z * p * M6.metric.M + M6.metric.M * p' * Z)
        Y = change_representer(M6, em, p, Z)
        @test isapprox(y, Y)
    end
    @testset "Convert SPD to Cholesky" begin
        v = log(M1, p, q)
        (l, w) = Manifolds.spd_to_cholesky(p, v)
        (xs, vs) = Manifolds.cholesky_to_spd(l, w)
        @test isapprox(xs, p)
        @test isapprox(vs, v)
    end
    @testset "Preliminary tests for LogEuclidean" begin
        @test representation_size(M4) == (3, 3)
        @test isapprox(distance(M4, p, q), sqrt(2) * log(2))
        @test manifold_dimension(M4) == manifold_dimension(M1)
    end
    @testset "Test for tangent ONB on AffineInvariantMetric" begin
        v = log(M2, p, q)
        donb = get_basis(base_manifold(M2), p, DiagonalizingOrthonormalBasis(v))
        Xs = get_vectors(base_manifold(M2), p, donb)
        k = donb.data.eigenvalues
        @test isapprox(0.0, first(k))
        for i in 1:length(Xs)
            @test isapprox(1.0, norm(M2, p, Xs[i]))
            for j in (i + 1):length(Xs)
                @test isapprox(0.0, inner(M2, p, Xs[i], Xs[j]))
            end
        end
        d2onb = get_basis(M2, p, DiagonalizingOrthonormalBasis(v))
        @test donb.data.eigenvalues == d2onb.data.eigenvalues
        @test get_vectors(base_manifold(M2), p, donb) == get_vectors(M2, p, d2onb)
    end
    @testset "Vector transport with Schild and Pole ladder" begin
        A(α) = [1.0 0.0 0.0; 0.0 cos(α) sin(α); 0.0 -sin(α) cos(α)]
        M = SymmetricPositiveDefinite(3)
        p1 = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]
        p2 = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
        p3 = A(π / 6) * [1.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1] * transpose(A(π / 6))
        embed(M, p1) == p1
        X1 = log(M, p1, p3)
        Y1 = vector_transport_to(M, p1, X1, p2)
        @test is_vector(M, p2, Y1)
        Y2 = vector_transport_to(M, p1, X1, p2, PoleLadderTransport())
        @test is_vector(M, p2, Y2, atol = 10^-16)
        Y3 = vector_transport_to(M, p1, X1, p2, SchildsLadderTransport())
        @test is_vector(M, p2, Y3)
        @test isapprox(M, p2, Y1, Y2) # pole is exact on SPDs, i.e. identical to parallel transport
        @test norm(M, p1, X1) ≈ norm(M, p2, Y1) # parallel transport is length preserving
        # test isometry
        X2 = log(M, p1, p2)
        Y4 = vector_transport_to(M, p1, X2, p2)
        @test norm(M, p1, X2) ≈ norm(M, p2, Y4)
        @test is_vector(M, p2, Y4)
        Y5 = vector_transport_to(M, p1, X2, p2, PoleLadderTransport())
        @test inner(M, p1, X1, X2) ≈ inner(M, p2, Y1, Y4) # parallel transport isometric
        @test inner(M, p1, X1, X2) ≈ inner(M, p2, Y2, Y5) # pole ladder transport isometric
    end
    @testset "Metric change for Linear Affine Metric" begin
        X = log(M1, p, q)
        Y = change_metric(M1, EuclideanMetric(), p, X)
        @test Y == p * X
        Z = change_representer(M1, EuclideanMetric(), p, X)
        @test Z == p * X * p
    end
    @testset "Projection on Tangent space" begin
        p = Matrix{Float64}(I, 3, 3)
        X = [1.0 2.0 1.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
        Y = project(M1, p, X)
        @test is_vector(M1, p, Y)
    end
    @testset "Tangent ONB" begin
        q = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
        b = DefaultOrthonormalBasis()
        B = get_basis(M1, q, b)
        for i in 1:length(B.data)
            @test norm(M1, q, B.data[i]) ≈ 1
            for j in (i + 1):length(B.data)
                @test inner(M1, q, B.data[i], B.data[j]) ≈ 0
            end
        end
        X = [1.0 1.0 0.5; 1.0 1.0 0.0; 0.5 0.0 1.0]
        c = get_coordinates(M1, q, X, b)
        X2 = get_vector(M1, q, c, b)
        @test isapprox(M1, q, X, X2)
    end
    @testset "rand()" begin
        p = rand(M1)
        @test is_point(M1, p)
        @test is_vector(M1, p, rand(M1; vector_at = p, tangent_distr = :Rician))
        @test is_vector(
            M1,
            p,
            rand(MersenneTwister(123), M1; vector_at = p, tangent_distr = :Rician),
        )
    end
    @testset "metric" begin
        p = [
            1.3996531703810995 -0.050757455076129054 0.012468338878281887
            -0.050757455076129054 1.4934536968479577 -0.1322157270710227
            0.012468338878281887 -0.1322157270710227 1.1406534894519493
        ]
        X1 = [
            -0.040154529852424355 0.0940975617218614 -0.14399681300759132
            0.0940975617218614 -0.07959493647453719 0.039521032486382335
            -0.14399681300759132 0.039521032486382335 -0.08077209831531029
        ]
        X2 = [
            0.22320202697960773 0.1294383854675894 -0.15402580371166136
            0.1294383854675894 0.23251725583184363 0.13919342694607098
            -0.15402580371166136 0.139193426946071 0.4493904218883048
        ]
        X3 = [
            0.14955817329734716 0.04874731541620811 0.16142208646317371
            0.048747315416208095 0.4135413163173373 0.0813738001379617
            0.16142208646317371 0.0813738001379617 0.5381987409318881
        ]
        X_rt = [
            0.0026845159609378074 0.0008609241226852796 0.003549384063443887
            0.0008609241226852785 -0.0010229969873821812 -0.0014137071858029112
            0.003549384063443888 -0.0014137071858029105 -0.0011418891263384548
        ]

        @test isapprox(M1, p, riemann_tensor(M1, p, X1, X2, X3), X_rt)
    end
    @testset "SPDPoint functions" begin
        p = SPDPoint(2 * Matrix{Float64}(I, 3, 3))
        p2 = copy(p)
        @test SPDPoint(p2) === p2
        @test p2.eigen == p.eigen
        pS = SPDPoint(
            2 * Matrix{Float64}(I, 3, 3);
            store_p = false,
            store_sqrt = false,
            store_sqrt_inv = false,
        )
        m = missing
        s = "$(typeof(pS))\np:\n $m\np^{1/2}:\n $m\np^{-1/2}:\n $m"
        @test sprint(show, "text/plain", pS) == s
        pF = SPDPoint(Matrix{Float64}(I, 3, 3))
        copyto!(pF, pS) # fill values in F
        @test pF == p
        pF2 = SPDPoint(Matrix{Float64}(I, 3, 3))
        copyto!(pF2, pF) # copy alues in F
        @test !ismissing(pF2.p)
        @test !ismissing(pF2.sqrt)
        @test !ismissing(pF2.sqrt_inv)
        pF3 = SPDPoint(
            Matrix{Float64}(I, 3, 3);
            store_p = false,
            store_sqrt = false,
            store_sqrt_inv = false,
        )
        copyto!(pF3, pF2) # do not fill values from F
        @test ismissing(pF3.p)
        @test ismissing(pF3.sqrt)
        @test ismissing(pF3.sqrt_inv)
        @test isapprox(Manifolds.spd_sqrt(pS), pF.sqrt) # recreate
        @test isapprox(Manifolds.spd_sqrt_inv(pF), pF.sqrt_inv) #identity
        pF4 = SPDPoint(2 * Matrix{Float64}(I, 3, 3); store_sqrt_inv = false)
        pF5 = SPDPoint(2 * Matrix{Float64}(I, 3, 3); store_sqrt = false)
        ssi = (pF.sqrt, pF.sqrt_inv)
        @test Manifolds.spd_sqrt_and_sqrt_inv(pF4) == ssi # comp sqrt inv
        @test Manifolds.spd_sqrt_and_sqrt_inv(pF5) == ssi # comp sqrt
        @test Manifolds.spd_sqrt_and_sqrt_inv(pS) == ssi # com both
        M = SymmetricPositiveDefinite(3)
        @test isapprox(exp!(M, pS, p, zero_vector(M, p)), p)
        @test ismissing(pS.sqrt)
        @test ismissing(pS.sqrt_inv)
        @test allocate_result(M1, zero_vector, p) isa Matrix
        c1 = ManifoldsBase.allocate_coordinates(M, p, Float64, 6)
        c2 = ManifoldsBase.allocate_coordinates(M, embed(M, p), Float64, 6)
        @test typeof(c1) == typeof(c2)
        @test length(c1) == length(c2)
    end

    @testset "test BigFloat" begin
        M = SymmetricPositiveDefinite(2)
        p1 = BigFloat[
            1.6590891025248637458133771360735408961772918701171875 -2.708777790960681386422947980463504791259765625e-7
            -2.708777790960681386422947980463504791259765625e-7 1.6590893171834280028775765458703972399234771728515625
        ]
        @test is_point(M, p1)
    end

    @testset "Riemannian Hessian Conversion" begin
        M = SymmetricPositiveDefinite(2)
        p = [2.0 1.0; 1.0 1.0]
        G = [1.0 0.0; 1.0 0.1]
        H = [2.0 1.0; 0.0 0.0]
        X = [0.0 3.0; 3.0 0.0]
        Y = X * 1 / 2 * (G' + G) * p
        Y = 1 / 2 * p * (H' + H) * p + 1 / 2 * (Y' + Y)
        @test riemannian_Hessian(M, p, G, H, X) == Y
    end

    @testset "Volume density" begin
        M = SymmetricPositiveDefinite(3)
        @test manifold_volume(M) == Inf
        p = [
            1.680908185710701 -0.030208936760309613 -0.284402826783584
            -0.030208936760309613 1.7199740873691465 -0.0066638025832747305
            -0.284402826783584 -0.0066638025832747305 1.6842441059901379
        ]
        X = [
            -1.3447374559982306 0.2591587910302816 0.9739140395169474
            0.2591587910302816 0.3649975914025044 -0.2888865063584093
            0.9739140395169474 -0.2888865063584093 -0.9564259306801289
        ]
        @test volume_density(M, p, X) ≈ 5.141867280770719
    end
    @testset "field parameter" begin
        M = SymmetricPositiveDefinite(3; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test repr(M) == "SymmetricPositiveDefinite(3; parameter=:field)"
        @test Manifolds.get_parameter_type(M) === :field
    end

    @testset "Curvature" begin
        @test sectional_curvature_min(SymmetricPositiveDefinite(1)) == 0.0
        @test sectional_curvature_min(SymmetricPositiveDefinite(3)) == -0.25
        @test sectional_curvature_max(SymmetricPositiveDefinite(3)) == 0.0
    end
end

using LinearAlgebra, Manifolds, ManifoldsBase, Test

@testset "Heisenberg matrices" begin
    M = HeisenbergMatrices(1)

    p1 = [1.0 2.0 3.0; 0.0 1.0 -1.0; 0.0 0.0 1.0]
    p2 = [1.0 4.0 -3.0; 0.0 1.0 3.0; 0.0 0.0 1.0]
    p3 = [1.0 -2.0 1.0; 0.0 1.0 1.1; 0.0 0.0 1.0]

    X1 = [0.0 2.0 3.0; 0.0 0.0 -1.0; 0.0 0.0 0.0]
    X2 = [0.0 4.0 -3.0; 0.0 0.0 3.0; 0.0 0.0 0.0]
    X3 = [0.0 -2.0 1.0; 0.0 0.0 1.1; 0.0 0.0 0.0]

    N1 = [1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0]

    q1 = [0.0 2.0 3.0; 0.0 1.0 -1.0; 0.0 0.0 1.0]
    q2 = [1.0 2.0 3.0; 0.0 1.0 -1.0; 1.0 0.0 1.0]
    q3 = [1.0 2.0 3.0; 0.0 1.0 -1.0; 0.0 0.0 2.0]
    q4 = [1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 1.0 1.0] #sum last row nonzero (excl last)
    q5 = [1.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 1.0] # bottom right not I

    Y1 = [1.0 2.0 3.0; 0.0 0.0 -1.0; 0.0 0.0 0.0]
    Y2 = [0.0 2.0 3.0; 1.0 0.0 -1.0; 0.0 0.0 0.0]
    Y3 = [0.0 2.0 3.0; 0.0 0.0 -1.0; 0.0 0.0 2.0]

    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                embed,
                get_embedding, get_coordinates, get_vector,
                injectivity_radius,
                is_flat, is_point, is_vector,
                parallel_transport_to,
                rand, repr, representation_size,
                Weingarten,
            ],
            :Bases => [DefaultOrthonormalBasis()],
            :Coordinates => [[2.0, -1.0, 3.0]], #X1 in DefaultONB
            :InvalidPoints => [q1, q2, q3, q4, q5],
            :InvalidVectors => [Y1, Y2, Y3],
            :NormalVectors => [N1],
            :Points => [p1, p2, p3],
            :Vectors => [X1, X2, X3],
            :VectorTransportMethods => [ParallelTransport()],
        ),
        Dict(
            get_embedding => Euclidean(3, 3),
            injectivity_radius => Inf,
            is_flat => true,
            manifold_dimension => 3,
            repr => "HeisenbergMatrices(1)",
            representation_size => (3, 3),
            Weingarten => zeros(3, 3),
        ),
    )

    Mf = HeisenbergMatrices(1; parameter = :field)
    Manifolds.Test.test_manifold(
        Mf,
        Dict(:Functions => [get_embedding, repr]),
        Dict(get_embedding => Euclidean(3, 3; parameter = :field), repr => "HeisenbergMatrices(1; parameter=:field)")
    )
end

@doc raw"""
    SkewHermitianMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  ``\operatorname{SkewHerm}(n)`` consisting of the real- or
complex-valued skew-hermitian matrices of size ``n×n``, i.e. the set

````math
\operatorname{SkewHerm}(n) = \bigl\{p  ∈ 𝔽^{n×n}\ \big|\ p^{\mathrm{H}} = -p \bigr\},
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transpose,
and the field ``𝔽 ∈ \{ ℝ, ℂ, ℍ\}``.

Though it is slightly redundant, usually the matrices are stored as ``n×n`` arrays.

Note that in this representation, the real-valued part of the diagonal must be zero,
which is also reflected in the
[`manifold_dimension`](@ref manifold_dimension(::SkewHermitianMatrices)).

# Constructor

    SkewHermitianMatrices(n::Int, field::AbstractNumbers=ℝ; parameter::Symbol=:type)

Generate the manifold of ``n×n`` skew-hermitian matrices.
"""
struct SkewHermitianMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SkewHermitianMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return SkewHermitianMatrices{field, typeof(size)}(size)
end

@doc raw"""
    SkewSymmetricMatrices{T}

Generate the manifold of ``n×n`` real skew-symmetric matrices.
This is equivalent to [`SkewHermitianMatrices(n, ℝ)`](@ref).

# Constructor

    SkewSymmetricMatrices(n::Int)
"""
const SkewSymmetricMatrices{T} = SkewHermitianMatrices{ℝ, T}

function SkewSymmetricMatrices(n::Int; parameter::Symbol = :type)
    return SkewHermitianMatrices(n; parameter = parameter)
end

function allocation_promotion_function(
        ::SkewHermitianMatrices{ℂ},
        ::typeof(get_vector),
        args::Tuple,
    )
    return complex
end

@doc raw"""
    check_point(M::SkewHermitianMatrices, p; kwargs...)

Check whether `p` is a valid manifold point on the [`SkewHermitianMatrices`](@ref) `M`, i.e.
whether `p` is a skew-hermitian matrix of size `(n,n)` with values from the corresponding
[`AbstractNumbers`](@extref ManifoldsBase number-system) `𝔽`.

The tolerance for the skew-symmetry of `p` can be set using `kwargs...`.
"""
function check_point(M::SkewHermitianMatrices{𝔽}, p; kwargs...) where {𝔽}
    if !isapprox(p, -p'; kwargs...)
        return DomainError(
            norm(p + p'),
            "The point $(p) does not lie on $M, since it is not skew-hermitian.",
        )
    end
    return nothing
end

"""
    check_vector(M::SkewHermitianMatrices, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`SkewHermitianMatrices`](@ref) `M`, i.e. `X` must be a skew-hermitian matrix of size `(n,n)`
and its values have to be from the correct [`AbstractNumbers`](@extref ManifoldsBase number-system).
The tolerance for the skew-symmetry of `p` and `X` can be set using `kwargs...`.
"""
function check_vector(M::SkewHermitianMatrices, p, X; kwargs...)
    return check_point(M, X; kwargs...)  # manifold is its own tangent space
end

function get_basis(M::SkewHermitianMatrices, p, B::DiagonalizingOrthonormalBasis)
    Ξ = get_basis(M, p, DefaultOrthonormalBasis()).data
    κ = zeros(real(eltype(p)), manifold_dimension(M))
    return CachedBasis(B, κ, Ξ)
end

function get_coordinates_orthonormal!(M::SkewSymmetricMatrices, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(Y) == (dim,)
    @assert size(X) == (N, N)
    @assert dim == div(N * (N - 1), 2)
    k = 1
    for i in 1:N, j in (i + 1):N
        @inbounds Y[k] = X[i, j] * sqrt(2)
        k += 1
    end
    return Y
end
function get_coordinates_orthonormal!(
        M::SkewHermitianMatrices{ℂ},
        Y,
        p,
        X,
        ::ComplexNumbers,
    )
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(Y) == (dim,)
    @assert size(X) == (N, N)
    @assert dim == N^2
    k = 1
    for i in 1:N, j in i:N
        if i == j # real-part zero on the diagonal -> just one basis vector per diag entry
            @inbounds Y[k] = imag(X[i, j])
            k += 1
        else
            @inbounds Y[k] = real(X[i, j]) * sqrt(2)
            @inbounds Y[k + 1] = imag(X[i, j]) * sqrt(2)
            k += 2
        end
    end
    return Y
end

function get_embedding(::SkewHermitianMatrices{𝔽, TypeParameter{Tuple{N}}}) where {N, 𝔽}
    return Euclidean(N, N; field = 𝔽)
end
function get_embedding(M::SkewHermitianMatrices{𝔽, Tuple{Int}}) where {𝔽}
    N = get_parameter(M.size)[1]
    return Euclidean(N, N; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SkewHermitianMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

function get_vector_orthonormal!(M::SkewSymmetricMatrices, Y, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(X) == (dim,)
    @assert size(Y) == (N, N)
    k = 1
    for i in 1:N
        Y[i, i] = convert(eltype(p), 0.0)
    end
    for i in 1:N, j in (i + 1):N
        @inbounds Y[i, j] = X[k] / sqrt(2)
        @inbounds Y[j, i] = -X[k] / sqrt(2)
        k += 1
    end
    return Y
end
function get_vector_orthonormal!(
        M::SkewHermitianMatrices{ℂ},
        Y,
        p,
        X,
        ::ComplexNumbers,
    )
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(X) == (dim,)
    @assert size(Y) == (N, N)
    k = 1
    for i in 1:N, j in i:N
        if i == j # real zero on the diag
            @inbounds Y[i, j] = X[k] * 1im
            k += 1
        else
            @inbounds Y[i, j] = (X[k] + X[k + 1] * 1im) / sqrt(2)
            k += 2
            @inbounds Y[j, i] = -conj(Y[i, j])
        end
    end
    return Y
end

"""
    is_flat(::SkewHermitianMatrices)

Return true. [`SkewHermitianMatrices`](@ref) is a flat manifold.
"""
is_flat(M::SkewHermitianMatrices) = true

@doc raw"""
    manifold_dimension(M::SkewHermitianMatrices)

Return the dimension of the [`SkewHermitianMatrices`](@ref) matrix `M` over the number
system `𝔽`, i.e.

````math
\dim \mathrm{SkewHerm}(n,ℝ) = \frac{n(n+1)}{2} \dim_ℝ 𝔽 - n,
````

where ``\dim_ℝ 𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of ``𝔽``. The first term corresponds to
only the upper triangular elements of the matrix being unique, and the second term
corresponds to the constraint that the real part of the diagonal be zero.
"""
function manifold_dimension(M::SkewHermitianMatrices{𝔽}) where {𝔽}
    N = get_parameter(M.size)[1]
    return div(N * (N + 1), 2) * real_dimension(𝔽) - N
end

function number_of_coordinates(M::SkewHermitianMatrices{ℂ}, ::AbstractBasis{ℂ})
    return manifold_dimension(M)
end

@doc raw"""
    project(M::SkewHermitianMatrices, p)

Projects `p` from the embedding onto the [`SkewHermitianMatrices`](@ref) `M`, i.e.

````math
\operatorname{proj}_{\operatorname{SkewHerm}(n)}(p) = \frac{1}{2} \bigl( p - p^{\mathrm{H}} \bigr),
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SkewHermitianMatrices, ::Any)

function project!(::SkewHermitianMatrices, q, p)
    q .= (p .- p') ./ 2
    return q
end

@doc raw"""
    project(M::SkewHermitianMatrices, p, X)

Project the matrix `X` onto the tangent space at `p` on the [`SkewHermitianMatrices`](@ref) `M`,

````math
\operatorname{proj}_p(X) = \frac{1}{2} \bigl( X - X^{\mathrm{H}} \bigr),
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::SkewHermitianMatrices, ::Any, ::Any)

project!(M::SkewHermitianMatrices, Y, p, X) = project!(M, Y, X)

function Random.rand!(
        rng::AbstractRNG,
        M::SkewHermitianMatrices,
        pX;
        σ::Real = one(real(eltype(pX))),
        kwargs...,
    )
    rand!(rng, pX)
    pX .= (σ / (2 * norm(pX))) .* (pX - pX')
    return pX
end

function representation_size(M::SkewHermitianMatrices)
    N = get_parameter(M.size)[1]
    return (N, N)
end

function Base.show(io::IO, ::SkewHermitianMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "SkewHermitianMatrices($(n), $(𝔽))")
end
function Base.show(io::IO, ::SkewSymmetricMatrices{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "SkewSymmetricMatrices($(n))")
end
function Base.show(io::IO, M::SkewHermitianMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "SkewHermitianMatrices($(n), $(𝔽); parameter=:field)")
end
function Base.show(io::IO, M::SkewSymmetricMatrices{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "SkewSymmetricMatrices($(n); parameter=:field)")
end

@doc raw"""
    Y = Weingarten(M::SkewSymmetricMatrices, p, X, V)
    Weingarten!(M::SkewSymmetricMatrices, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`SkewSymmetricMatrices`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::SkewSymmetricMatrices, p, X, V)

Weingarten!(::SkewSymmetricMatrices, Y, p, X, V) = fill!(Y, 0)

@doc raw"""
    CanonicalMetric <: AbstractMetric

The Canonical Metric refers to a metric for the [`Stiefel`](@ref)
manifold, see[EdelmanAriasSmith:1998](@cite).

"""
struct CanonicalMetric <: RiemannianMetric end

"""
    ApproximateLogarithmicMap <: ApproximateInverseRetraction

An approximate implementation of the logarithmic map, which is an [`inverse_retract`](@ref)ion.
See [`inverse_retract(::MetricManifold{ℝ,<:Stiefel{ℝ},CanonicalMetric}, ::Any, ::Any, ::ApproximateLogarithmicMap)`](@ref) for a use case.

# Fields

* `max_iterations` – maximal number of iterations used in the approximation
* `tolerance` – a tolerance used as a stopping criterion

"""
struct ApproximateLogarithmicMap{T} <: ApproximateInverseRetraction
    max_iterations::Int
    tolerance::T
end

function distance(M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric}, q, p)
    return norm(M, p, log(M, p, q))
end

@doc raw"""
    q = exp(M::MetricManifold{ℝ,<:Stiefel{ℝ},CanonicalMetric}, p, X)
    exp!(M::MetricManifold{ℝ,<:Stiefel{ℝ},CanonicalMetric}, q, p, X)

Compute the exponential map on the [`Stiefel`](@ref)`(n, k)` manifold with respect to the [`CanonicalMetric`](@ref).

First, decompose The tangent vector ``X`` into its horizontal and vertical component with
respect to ``p``, i.e.

```math
X = pp^{\mathrm{T}}X + (I_n-pp^{\mathrm{T}})X,
```
where ``I_n`` is the ``n×n`` identity matrix.
We introduce ``A=p^{\mathrm{T}}X`` and ``QR = (I_n-pp^{\mathrm{T}})X`` the `qr` decomposition
of the vertical component. Then using the matrix exponential ``\operatorname{Exp}`` we introduce ``B`` and ``C`` as

```math
\begin{pmatrix}
B\\C
\end{pmatrix}
\coloneqq
\operatorname{Exp}\left(
\begin{pmatrix}
A & -R^{\mathrm{T}}\\ R & 0
\end{pmatrix}
\right)
\begin{pmatrix}I_k\\0\end{pmatrix}
```

the exponential map reads

```math
q = \exp_p X = pC + QB.
```
For more details, see [EdelmanAriasSmith:1998](@cite)[Zimmermann:2017](@cite).
"""
exp(::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric}, ::Any...)

function exp!(M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric}, q, p, X)
    n, k = get_parameter(M.manifold.size)
    A = p' * X
    n == k && return mul!(q, p, exp(A))
    QR = qr(X - p * A)
    BC_ext = exp([A -QR.R'; QR.R 0 * I])
    @views begin # COV_EXCL_LINE
        mul!(q, p, BC_ext[1:k, 1:k])
        mul!(q, Matrix(QR.Q), BC_ext[(k + 1):(2 * k), 1:k], true, true)
    end
    return q
end

@doc raw"""
    inner(M::MetricManifold{ℝ, Stiefel{ℝ}, X, CanonicalMetric}, p, X, Y)

Compute the inner product on the [`Stiefel`](@ref) manifold with respect to the
[`CanonicalMetric`](@ref). The formula reads

```math
g_p(X,Y) = \operatorname{tr}\bigl( X^{\mathrm{T}}(I_n - \frac{1}{2}pp^{\mathrm{T}})Y \bigr).
```
"""
function inner(M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric}, p, X, Y)
    n, k = get_parameter(M.manifold.size)
    T = Base.promote_eltype(p, X, Y)
    if n == k
        return T(dot(X, Y)) / 2
    else
        return T(dot(X, Y)) - T(dot(p'X, p'Y)) / 2
    end
end

@doc raw"""
    X = inverse_retract(M::MetricManifold{ℝ, Stiefel{ℝ}, CanonicalMetric}, p, q, a::ApproximateLogarithmicMap)
    inverse_retract!(M::MetricManifold{ℝ, Stiefel{ℝ}, X, CanonicalMetric}, p, q, a::ApproximateLogarithmicMap)

Compute an approximation to the logarithmic map on the [`Stiefel`](@ref)`(n, k)` manifold with respect to the [`CanonicalMetric`](@ref)
using a matrix-algebraic based approach to an iterative inversion of the formula of the
[`exp`](@ref exp(::MetricManifold{ℝ, Stiefel{ℝ}, CanonicalMetric}, ::Any...)).

The algorithm is derived in [Zimmermann:2017](@cite) and it uses the `max_iterations` and the `tolerance` field
from the [`ApproximateLogarithmicMap`](@ref).
"""
inverse_retract(
    ::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric},
    ::Any,
    ::Any,
    ::ApproximateLogarithmicMap,
)

"""
    is_flat(MetricManifold{ℝ,<:Stiefel{ℝ},CanonicalMetric})

Return true if [`Stiefel`](@ref) `M` is one-dimensional, since only then, the manifold is flat.
"""
is_flat(M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric}) =
    manifold_dimension(M) == 1

function log(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric},
        p,
        q;
        maxiter::Int = 10000,
        tolerance = 1.0e-9,
    )
    X = allocate_result(M, log, p, q)
    inverse_retract!(M, X, p, q, ApproximateLogarithmicMap(maxiter, tolerance))
    return X
end

function log!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric},
        X,
        p,
        q;
        maxiter::Int = 10000,
        tolerance = 1.0e-9,
    )
    inverse_retract!(M, X, p, q, ApproximateLogarithmicMap(maxiter, tolerance))
    return X
end

function inverse_retract!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, CanonicalMetric},
        X,
        p,
        q,
        a::ApproximateLogarithmicMap,
    )
    n, k = get_parameter(M.manifold.size)
    qfact = stiefel_factorization(p, q)
    V = allocate(qfact.Z, Size(2k, 2k))
    LV = allocate(V)
    Zcompl = qr(qfact.Z).Q[1:(2k), (k + 1):(2k)]
    @views begin # COV_EXCL_LINE
        Vpcols = V[1:(2k), (k + 1):(2k)] #second half of the columns
        B = LV[(k + 1):(2k), 1:k]
        C = LV[(k + 1):(2k), (k + 1):(2k)]
        copyto!(V[1:(2k), 1:k], qfact.Z)
        F = svd(Zcompl[(k + 1):(2k), 1:k]) # preprocessing: Procrustes
    end
    new_Vpcols = allocate(Vpcols)
    mul!(new_Vpcols, Zcompl, F.U)
    mul!(Vpcols, new_Vpcols, F.V')
    S = allocate(B)
    for _ in 1:(a.max_iterations)
        log_safe!(LV, V)
        norm(C) ≤ a.tolerance && break
        copyto!(S, I)
        mul!(S, B, B', -1 // 12, 1 // 2)
        Γ = lyap(S, C)
        expΓ = exp(Γ)
        mul!(new_Vpcols, Vpcols, expΓ)
        copyto!(Vpcols, new_Vpcols)
    end
    @views mul!(X, qfact.U, LV[1:(2k), 1:k])
    return X
end

@doc raw"""
    Y = riemannian_Hessian(M::MetricManifold{ℝ, Stiefel, CanonicalMetric}, p, G, H, X)
    riemannian_Hessian!(M::MetricManifold{ℝ, Stiefel, CanonicalMetric}, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

Here, we adopt Eq. (5.6) [Nguyen:2023](@cite), for the [`CanonicalMetric`](@ref)
``α_0=1, α_1=\frac{1}{2}`` in their formula. The formula reads

```math
    \operatorname{Hess}f(p)[X]
    =
    \operatorname{proj}_{T_p\mathcal M}\Bigl(
        ∇^2f(p)[X] - \frac{1}{2} X \bigl( (∇f(p))^{\mathrm{H}}p + p^{\mathrm{H}}∇f(p)\bigr)
        - \frac{1}{2} \bigl( P ∇f(p) p^{\mathrm{H}} + p ∇f(p))^{\mathrm{H}} P)X
    \Bigr),
```
where ``P = I-pp^{\mathrm{H}}``.
"""
riemannian_Hessian(M::MetricManifold{𝔽, Stiefel, CanonicalMetric}, p, G, H, X) where {𝔽}

function riemannian_Hessian!(
        M::MetricManifold{𝔽, <:Stiefel{𝔽}, CanonicalMetric},
        Y,
        p,
        G,
        H,
        X,
    ) where {𝔽}
    Gp = symmetrize(G' * p)
    Z = symmetrize((I - p * p') * G * p')
    project!(M, Y, p, H - X * Gp - Z * X)
    return Y
end

"""
    FVectorvariate

Structure that subtypes `VariateForm`, indicating that a single sample
is a vector from a fiber of a vector bundle.
"""
struct FVectorvariate <: VariateForm end

"""
    FVectorSupport(space::AbstractManifold, VectorSpaceFiber)

Value support for vector bundle fiber-valued distributions (values from a fiber of a vector
bundle at a `point` from the given manifold).
For example used for tangent vector-valued distributions.
"""
struct FVectorSupport{TSpace <: VectorSpaceFiber} <: ValueSupport
    space::TSpace
end

"""
    FVectorDistribution{TSpace<:VectorSpaceFiber, T}

An abstract distribution for vector bundle fiber-valued distributions (values from a fiber
of a vector bundle at point `x` from the given manifold).
For example used for tangent vector-valued distributions.
"""
abstract type FVectorDistribution{TSpace <: VectorSpaceFiber} <:
Distribution{FVectorvariate, FVectorSupport{TSpace}} end

"""
    MPointvariate

Structure that subtypes `VariateForm`, indicating that a single sample
is a point on a manifold.
"""
struct MPointvariate <: VariateForm end

"""
    MPointSupport(M::AbstractManifold)

Value support for manifold-valued distributions (values from given
[`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`).
"""
struct MPointSupport{TM <: AbstractManifold} <: ValueSupport
    manifold::TM
end

"""
    MPointDistribution{TM<:AbstractManifold}

An abstract distribution for points on manifold of type `TM`.
"""
abstract type MPointDistribution{TM <: AbstractManifold} <:
Distribution{MPointvariate, MPointSupport{TM}} end

"""
    support(d::FVectorDistribution)

Get the object of type `FVectorSupport` for the distribution `d`.
"""
Distributions.support(::FVectorDistribution)

"""
    uniform_distribution(M::Grassmann{<:Any,ℝ}, p)

Uniform distribution on given (real-valued) [`Grassmann`](@ref) `M`.
Specifically, this is the normalized Haar measure on `M`.
Generated points will be of similar type as `p`.

The implementation is based on Section 2.5.1 in [Chikuse:2003](@cite);
see also Theorem 2.2.2(iii) in [Chikuse:2003](@cite).
"""
function uniform_distribution(M::Grassmann{ℝ}, p)
    n, k = get_parameter(M.size)
    μ = Distributions.Zeros(n, k)
    σ = one(eltype(p))
    Σ1 = Distributions.PDMats.ScalMat(n, σ)
    Σ2 = Distributions.PDMats.ScalMat(k, σ)
    d = MatrixNormal(μ, Σ1, Σ2)

    return ProjectedPointDistribution(M, d, (M, q, p) -> (q .= svd(p).U), p)
end

"""
    uniform_distribution(M::ProjectiveSpace{<:Any,ℝ}, p)

Uniform distribution on given [`ProjectiveSpace`](@ref) `M`. Generated points will be of
similar type as `p`.
"""
function uniform_distribution(M::ProjectiveSpace{ℝ}, p)
    d = Distributions.MvNormal(zero(p), 1.0 * I)
    return ProjectedPointDistribution(M, d, project!, p)
end

"""
    uniform_distribution(M::Stiefel{ℝ}, p)

Uniform distribution on given (real-valued) [`Stiefel`](@ref) `M`.
Specifically, this is the normalized Haar and Hausdorff measure on `M`.
Generated points will be of similar type as `p`.

The implementation is based on Section 2.5.1 in [Chikuse:2003](@cite);
see also Theorem 2.2.1(iii) in [Chikuse:2003](@cite).
"""
function uniform_distribution(M::Stiefel{ℝ}, p)
    n, k = get_parameter(M.size)
    μ = Distributions.Zeros(n, k)
    σ = one(eltype(p))
    Σ1 = Distributions.PDMats.ScalMat(n, σ)
    Σ2 = Distributions.PDMats.ScalMat(k, σ)
    d = MatrixNormal(μ, Σ1, Σ2)

    return ProjectedPointDistribution(M, d, project!, p)
end

"""
    uniform_distribution(M::Sphere{n,ℝ}, p) where {n}

Uniform distribution on given [`Sphere`](@ref) `M`. Generated points will be of
similar type as `p`.
"""
function uniform_distribution(M::Sphere{ℝ}, p)
    n = get_parameter(M.size)[1]
    d = Distributions.MvNormal(zero(p), 1.0 * I)
    return ProjectedPointDistribution(M, d, project!, p)
end

@doc raw"""
    MultinomialSymmetricPositiveDefinite <: AbstractMultinomialDoublyStochastic

The symmetric positive definite multinomial matrices manifold consists of all
symmetric ``n×n`` matrices with positive eigenvalues, and
positive entries such that each column sums to one, i.e.

````math
\begin{aligned}
\mathcal{SP}^+(n) \coloneqq \bigl\{
    p ∈ ℝ^{n×n}\ \big|\ &p_{i,j} > 0 \text{ for all } i=1,…,n, j=1,…,m,\\
& p^\mathrm{T} = p,\\
& p\mathbf{1}_n = \mathbf{1}_n\\
a^\mathrm{T}pa > 0 \text{ for all } a ∈ ℝ^{n}\backslash\{\mathbf{0}_n\}
\bigr\},
\end{aligned}
````

where ``\mathbf{1}_n`` and ``\mathbr{0}_n`` are the vectors of length ``n``
containing ones and zeros, respectively. More details about this manifold can be found in
[DouikHassibi:2019](@cite).

# Constructor

    MultinomialSymmetricPositiveDefinite(n)

Generate the manifold of matrices ``\mathbb R^{n×n}`` that are symmetric, positive definite, and doubly stochastic.
"""
struct MultinomialSymmetricPositiveDefinite{T} <: AbstractMultinomialDoublyStochastic
    size::T
end

function MultinomialSymmetricPositiveDefinite(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return MultinomialSymmetricPositiveDefinite{typeof(size)}(size)
end

function check_point(M::MultinomialSymmetricPositiveDefinite, p; kwargs...)
    # Multinomial checked first via embedding
    n = get_parameter(M.size)[1]
    s = check_point(SymmetricPositiveDefinite(n), p; kwargs...)
    !isnothing(s) &&
        return ManifoldDomainError("The point $(p) does not lie on the $(M).", s)
    return nothing
end

function check_vector(M::MultinomialSymmetricPositiveDefinite, p, X; kwargs...)
    # Multinomial checked first via embedding
    n = get_parameter(M.size)[1]
    s = check_vector(SymmetricPositiveDefinite(n), p, X; kwargs...)
    !isnothing(s) && return ManifoldDomainError(
        "The vector $(X) is not a tangent vector to $(p) on $(M)",
        s,
    )
    return nothing
end

function get_embedding(
        ::MultinomialSymmetricPositiveDefinite{TypeParameter{Tuple{n}}},
    ) where {n}
    return MultinomialMatrices(n, n)
end
function get_embedding(M::MultinomialSymmetricPositiveDefinite{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return MultinomialMatrices(n, n; parameter = :field)
end
function ManifoldsBase.get_embedding_type(::MultinomialSymmetricPositiveDefinite)
    return ManifoldsBase.EmbeddedManifoldType()
end

"""
    Random.rand!(
        rng::AbstractRNG,
        M::MultinomialSymmetricPositiveDefinite,
        p::AbstractMatrix,
    )

Generate a random point on [`MultinomialSymmetricPositiveDefinite`](@ref) manifold.
The steps are as follows:
1. Generate a random [totally positive matrix](https://en.wikipedia.org/wiki/Totally_positive_matrix)
    a. Construct a vector `L` of `n` random positive increasing real numbers.
    b. Construct the [Vandermonde matrix](https://en.wikipedia.org/wiki/Vandermonde_matrix)
       `V` based on the sequence `L`.
    c. Perform LU factorization of `V` in such way that both L and U components have
       positive elements.
    d. Convert the LU factorization into LDU factorization by taking the diagonal of U
       and dividing U by it, `V=LDU`.
    e. Construct a new matrix `R = UDL` which is totally positive.
2. Project the totally positive matrix `R` onto the manifold of [`MultinomialDoubleStochastic`](@ref)
   matrices.
3. Symmetrize the projected matrix and return the result.

This method roughly follows the procedure described in https://math.stackexchange.com/questions/2773460/how-to-generate-a-totally-positive-matrix-randomly-using-software-like-maple
"""
function Random.rand!(
        rng::AbstractRNG,
        M::MultinomialSymmetricPositiveDefinite,
        p::AbstractMatrix,
    )
    n = get_parameter(M.size)[1]
    is_spd = false
    while !is_spd
        L = sort(exp.(randn(rng, n)))
        V = reduce(hcat, map(xi -> [xi^k for k in 0:(n - 1)], L))'
        Vlu = lu(V, LinearAlgebra.RowNonZero())
        dm = Diagonal(Vlu.U)
        uutd = dm \ Vlu.U
        random_totally_positive = uutd * dm * Vlu.L
        MMDS = MultinomialDoubleStochastic(n)
        ds = project(MMDS, random_totally_positive; maxiter = 1000)
        p .= (ds .+ ds') ./ 2
        if eigmin(p) > 0
            is_spd = true
        end
    end
    return p
end

function Base.show(
        io::IO,
        ::MultinomialSymmetricPositiveDefinite{TypeParameter{Tuple{n}}},
    ) where {n}
    return print(io, "MultinomialSymmetricPositiveDefinite($(n))")
end
function Base.show(io::IO, M::MultinomialSymmetricPositiveDefinite{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "MultinomialSymmetricPositiveDefinite($(n); parameter=:field)")
end

@doc raw"""
    christoffel_symbols_first(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )

Compute the Christoffel symbols of the first kind in local coordinates of basis `B`.
The Christoffel symbols are (in Einstein summation convention)

````math
Γ_{ijk} = \frac{1}{2} \Bigl[g_{kj,i} + g_{ik,j} - g_{ij,k}\Bigr],
````

where ``g_{ij,k}=\frac{∂}{∂ p^k} g_{ij}`` is the coordinate
derivative of the local representation of the metric tensor. The dimensions of
the resulting multi-dimensional array are ordered ``(i,j,k)``.
"""
christoffel_symbols_first(::AbstractManifold, ::Any, B::AbstractBasis)
function christoffel_symbols_first(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    ∂g = local_metric_jacobian(M, p, B; backend = backend)
    n = size(∂g, 1)
    Γ = allocate(∂g, Size(n, n, n))
    @einsum Γ[i, j, k] = 1 / 2 * (∂g[k, j, i] + ∂g[i, k, j] - ∂g[i, j, k])
    return Γ
end
@trait_function christoffel_symbols_first(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

@doc raw"""
    christoffel_symbols_second(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )

Compute the Christoffel symbols of the second kind in local coordinates of basis `B`.
For affine connection manifold the Christoffel symbols need to be explicitly implemented
while, for a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) they are computed as (in Einstein summation convention)

````math
Γ^{l}_{ij} = g^{kl} Γ_{ijk},
````

where ``Γ_{ijk}`` are the Christoffel symbols of the first kind
(see [`christoffel_symbols_first`](@ref)), and ``g^{kl}`` is the inverse of the local
representation of the metric tensor. The dimensions of the resulting multi-dimensional array
are ordered ``(l,i,j)``.
"""
function christoffel_symbols_second(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    Ginv = inverse_local_metric(M, p, B)
    Γ₁ = christoffel_symbols_first(M, p, B; backend = backend)
    Γ₂ = allocate(Γ₁)
    @einsum Γ₂[l, i, j] = Ginv[k, l] * Γ₁[i, j, k]
    return Γ₂
end

@trait_function christoffel_symbols_second(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

@doc raw"""
    christoffel_symbols_second_jacobian(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )

Get partial derivatives of the Christoffel symbols of the second kind
for manifold `M` at `p` with respect to the coordinates of `B`, i.e.

```math
\frac{∂}{∂ p^l} Γ^{k}_{ij} = Γ^{k}_{ij,l}.
```

The dimensions of the resulting multi-dimensional array are ordered ``(i,j,k,l)``.
"""
christoffel_symbols_second_jacobian(::AbstractManifold, ::Any, B::AbstractBasis)
function christoffel_symbols_second_jacobian(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    n = size(p, 1)
    ∂Γ = reshape(
        _jacobian(q -> christoffel_symbols_second(M, q, B; backend = backend), p, backend),
        n,
        n,
        n,
        n,
    )
    return ∂Γ
end
@trait_function christoffel_symbols_second_jacobian(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

"""
    gaussian_curvature(M::AbstractManifold, p, B::AbstractBasis; backend::AbstractDiffBackend = default_differential_backend())

Compute the Gaussian curvature of the manifold `M` at the point `p` using basis `B`.
This is equal to half of the scalar Ricci curvature, see [`ricci_curvature`](@ref).
"""
gaussian_curvature(::AbstractManifold, ::Any, ::AbstractBasis)
function gaussian_curvature(M::AbstractManifold, p, B::AbstractBasis; kwargs...)
    return ricci_curvature(M, p, B; kwargs...) / 2
end
@trait_function gaussian_curvature(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

"""
    ricci_tensor(M::AbstractManifold, p, B::AbstractBasis; backend::AbstractDiffBackend = default_differential_backend())

Compute the Ricci tensor, also known as the Ricci curvature tensor,
of the manifold `M` at the point `p` using basis `B`,
see [`https://en.wikipedia.org/wiki/Ricci_curvature#Introduction_and_local_definition`](https://en.wikipedia.org/wiki/Ricci_curvature#Introduction_and_local_definition).
"""
ricci_tensor(::AbstractManifold, ::Any, ::AbstractBasis)
function ricci_tensor(M::AbstractManifold, p, B::AbstractBasis; kwargs...)
    R = riemann_tensor(M, p, B; kwargs...)
    n = size(R, 1)
    Ric = allocate(R, Size(n, n))
    @einsum Ric[i, j] = R[l, i, l, j]
    return Ric
end
@trait_function ricci_tensor(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

@doc raw"""
    riemann_tensor(M::AbstractManifold, p, B::AbstractBasis; backend::AbstractDiffBackend=default_differential_backend())

Compute the Riemann tensor ``R^l_{ijk}``, also known as the Riemann curvature
tensor, at the point `p` in local coordinates defined by `B`. The dimensions of the
resulting multi-dimensional array are ordered ``(l,i,j,k)``.

The function uses the coordinate expression involving the second Christoffel symbol,
see [`https://en.wikipedia.org/wiki/Riemann_curvature_tensor#Coordinate_expression`](https://en.wikipedia.org/wiki/Riemann_curvature_tensor#Coordinate_expression)
for details.

# See also

[`christoffel_symbols_second`](@ref), [`christoffel_symbols_second_jacobian`](@ref)
"""
riemann_tensor(::AbstractManifold, ::Any, ::AbstractBasis)
function riemann_tensor(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        backend::AbstractDiffBackend = default_differential_backend(),
    )
    n = size(p, 1)
    Γ = christoffel_symbols_second(M, p, B; backend = backend)
    ∂Γ = christoffel_symbols_second_jacobian(M, p, B; backend = backend) ./ n
    R = allocate(∂Γ, Size(n, n, n, n))
    @einsum R[l, i, j, k] =
        ∂Γ[l, i, k, j] - ∂Γ[l, i, j, k] + Γ[s, i, k] * Γ[l, s, j] - Γ[s, i, j] * Γ[l, s, k]
    return R
end
@trait_function riemann_tensor(
    M::AbstractDecoratorManifold,
    p,
    B::AbstractBasis;
    kwargs...,
)

function solve_exp_ode end

@doc raw"""
    solve_exp_ode(
        M::AbstractManifold,
        p,
        X,
        t::Number;
        B::AbstractBasis = DefaultOrthonormalBasis(),
        backend::AbstractDiffBackend = default_differential_backend(),
        solver = AutoVern9(Rodas5()),
        kwargs...,
    )

Approximate the exponential map on the manifold by evaluating the ODE describing the geodesic at 1,
assuming the default connection of the given manifold by solving the ordinary differential
equation

```math
\frac{d^2}{dt^2} p^k + Γ^k_{ij} \frac{d}{dt} p_i \frac{d}{dt} p_j = 0,
```

where ``Γ^k_{ij}`` are the Christoffel symbols of the second kind, and
the Einstein summation convention is assumed. The argument `solver` follows
the `OrdinaryDiffEq` conventions. `kwargs...` specify keyword
arguments that will be passed to `OrdinaryDiffEq.solve`.

Currently, the numerical integration is only accurate when using a single
coordinate chart that covers the entire manifold. This excludes coordinates
in an embedded space.

!!! note
    This function only works when
    [OrdinaryDiffEq.jl](https://github.com/JuliaDiffEq/OrdinaryDiffEq.jl) is loaded with
    ```julia
    using OrdinaryDiffEq
    ```
"""
solve_exp_ode(M::AbstractManifold, p, X, t::Number; kwargs...)

function check_point(M::Hyperbolic, p::PoincareHalfSpacePoint; kwargs...)
    if !(last(p.value) > 0)
        return DomainError(
            norm(p.value),
            "The point $(p) does not lie on $(M) since its last entry is nonpositive.",
        )
    end
end

function check_size(M::Hyperbolic, p::PoincareHalfSpacePoint)
    N = get_parameter(M.size)[1]
    if size(p.value, 1) != N
        !(norm(p.value) < 1)
        return DomainError(
            size(p.value, 1),
            "The point $p does not lie on $M since its length is not $N.",
        )
    end
end

function check_size(
        M::Hyperbolic,
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector;
        kwargs...,
    )
    N = get_parameter(M.size)[1]
    if size(X.value, 1) != N
        return DomainError(
            size(X.value, 1),
            "The tangent vector $X can not be a tangent vector for $M since its length is not $N.",
        )
    end
end

@doc raw"""
    convert(::Type{PoincareHalfSpacePoint}, p::PoincareBallPoint)

convert a point [`PoincareBallPoint`](@ref) `p` (from $ℝ^n$) from the
Poincaré ball model of the [`Hyperbolic`](@ref) manifold $\mathcal H^n$ to a [`PoincareHalfSpacePoint`](@ref) $π(p) ∈ ℝ^n$.
Denote by $\tilde p = (p_1,\ldots,p_{n-1})$. Then the isometry is defined by

````math
π(p) = \frac{1}{\lVert \tilde p \rVert^2 - (p_n-1)^2}
\begin{pmatrix}2p_1\\⋮\\2p_{n-1}\\1-\lVert p\rVert^2\end{pmatrix}.
````
"""
function convert(::Type{PoincareHalfSpacePoint}, p::PoincareBallPoint)
    return PoincareHalfSpacePoint(
        1 / (norm(p.value[1:(end - 1)])^2 + (last(p.value) - 1)^2) .*
            vcat(2 .* p.value[1:(end - 1)], 1 - norm(p.value)^2),
    )
end

@doc raw"""
    convert(::Type{PoincareHalfSpacePoint}, p::Hyperboloid)
    convert(::Type{PoincareHalfSpacePoint}, p)

convert a [`HyperboloidPoint`](@ref) or `Vector``p` (from $ℝ^{n+1}$) from the
Hyperboloid model of the [`Hyperbolic`](@ref) manifold $\mathcal H^n$ to a [`PoincareHalfSpacePoint`](@ref) $π(x) ∈ ℝ^{n}$.

This is done in two steps, namely transforming it to a Poincare ball point and from there further on to a PoincareHalfSpacePoint point.
"""
convert(::Type{PoincareHalfSpacePoint}, ::Any)
function convert(t::Type{PoincareHalfSpacePoint}, p::HyperboloidPoint)
    return convert(t, convert(PoincareBallPoint, p))
end
function convert(t::Type{PoincareHalfSpacePoint}, p::T) where {T <: AbstractVector}
    return convert(t, convert(PoincareBallPoint, p))
end

@doc raw"""
    convert(::Type{PoincareHalfSpaceTangentVector}, p::PoincareBallPoint, X::PoincareBallTangentVector)

convert a [`PoincareBallTangentVector`](@ref) `X` at `p` to a [`PoincareHalfSpacePoint`](@ref)
on the [`Hyperbolic`](@ref) manifold $\mathcal H^n$ by computing the push forward $π_*(p)[X]$ of
the isometry ``π`` that maps from the Poincaré ball to the Poincaré half space,
cf. [`convert(::Type{PoincareHalfSpacePoint}, ::PoincareBallPoint)`](@ref).

The formula reads

````math
π_*(p)[X] =
\frac{1}{\lVert \tilde p\rVert^2 + (1-p_n)^2}
\begin{pmatrix}
2X_1\\
⋮\\
2X_{n-1}\\
-2⟨X,p⟩
\end{pmatrix}
-
\frac{2}{(\lVert \tilde p\rVert^2 + (1-p_n)^2)^2}
\begin{pmatrix}
2p_1(⟨X,p⟩-X_n)\\
⋮\\
2p_{n-1}(⟨X,p⟩-X_n)\\
(\lVert p \rVert^2-1)(⟨X,p⟩-X_n)
\end{pmatrix}
````
where $\tilde p = \begin{pmatrix}p_1\\⋮\\p_{n-1}\end{pmatrix}$.
"""
function convert(
        ::Type{PoincareHalfSpaceTangentVector},
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
    )
    den = norm(p.value[1:(end - 1)])^2 + (last(p.value) - 1)^2
    scp = dot(p.value, X.value)
    c1 =
        (2 / den .* X.value[1:(end - 1)]) .-
        (4 * (scp - last(X.value)) / (den^2)) .* p.value[1:(end - 1)]
    c2 = -2 * scp / den - 2 * (1 - norm(p.value)^2) * (scp - last(X.value)) / (den^2)
    return PoincareHalfSpaceTangentVector(vcat(c1, c2))
end

@doc raw"""
    convert(::Type{PoincareHalfSpaceTangentVector}, p::HyperboloidPoint, ::HyperboloidTangentVector)
    convert(::Type{PoincareHalfSpaceTangentVector}, p::P, X::T) where {P<:AbstractVector, T<:AbstractVector}

convert a [`HyperboloidTangentVector`](@ref) `X` at `p` to a [`PoincareHalfSpaceTangentVector`](@ref)
on the [`Hyperbolic`](@ref) manifold $\mathcal H^n$ by computing the push forward $π_*(p)[X]$ of
the isometry ``π`` that maps from the Hyperboloid to the Poincaré half space,
cf. [`convert(::Type{PoincareHalfSpacePoint}, ::HyperboloidPoint)`](@ref).

This is done similarly to the approach there, i.e. by using the Poincaré ball model as
an intermediate step.
"""
convert(::Type{PoincareHalfSpaceTangentVector}, ::Any)
function convert(
        t::Type{PoincareHalfSpaceTangentVector},
        p::HyperboloidPoint,
        X::HyperboloidTangentVector,
    )
    return convert(t, convert(AbstractVector, p), convert(AbstractVector, X))
end
function convert(
        ::Type{PoincareHalfSpaceTangentVector},
        p::P,
        X::T,
    ) where {P <: AbstractVector, T <: AbstractVector}
    return convert(
        PoincareHalfSpaceTangentVector,
        convert(Tuple{PoincareBallPoint, PoincareBallTangentVector}, (p, X))...,
    )
end

@doc raw"""
    convert(
        ::Type{Tuple{PoincareHalfSpacePoint,PoincareHalfSpaceTangentVector}},
        (p,X)::Tuple{PoincareBallPoint,PoincareBallTangentVector}
    )

Convert a [`PoincareBallPoint`](@ref) `p` and a [`PoincareBallTangentVector`](@ref) `X`
to a [`PoincareHalfSpacePoint`](@ref) and a [`PoincareHalfSpaceTangentVector`](@ref) simultaneously,
see [`convert(::Type{PoincareHalfSpacePoint}, ::PoincareBallPoint)`](@ref) and
[`convert(::Type{PoincareHalfSpaceTangentVector}, ::PoincareBallPoint,::PoincareBallTangentVector)`](@ref)
for the formulae.
"""
function convert(
        ::Type{Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector}},
        (p, X)::Tuple{PoincareBallPoint, PoincareBallTangentVector},
    )
    return (
        convert(PoincareHalfSpacePoint, p),
        convert(PoincareHalfSpaceTangentVector, p, X),
    )
end

@doc raw"""
    convert(
        ::Type{Tuple{PoincareHalfSpacePoint,PoincareHalfSpaceTangentVector}},
        (p,X)::Tuple{HyperboloidPoint,HyperboloidTangentVector}
    )
    convert(
        ::Type{Tuple{PoincareHalfSpacePoint,PoincareHalfSpaceTangentVector}},
        (p, X)::Tuple{P,T},
    ) where {P<:AbstractVector, T <: AbstractVector}

Convert a [`HyperboloidPoint`](@ref) `p` and a [`HyperboloidTangentVector`](@ref) `X`
to a [`PoincareHalfSpacePoint`](@ref) and a [`PoincareHalfSpaceTangentVector`](@ref) simultaneously,
see [`convert(::Type{PoincareHalfSpacePoint}, ::HyperboloidPoint)`](@ref) and
[`convert(::Type{PoincareHalfSpaceTangentVector}, ::Tuple{HyperboloidPoint,HyperboloidTangentVector})`](@ref)
for the formulae.
"""
function convert(
        ::Type{Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector}},
        (p, X)::Tuple{HyperboloidPoint, HyperboloidTangentVector},
    )
    return (
        convert(PoincareHalfSpacePoint, p),
        convert(PoincareHalfSpaceTangentVector, p, X),
    )
end
function convert(
        ::Type{Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector}},
        (p, X)::Tuple{P, T},
    ) where {P <: AbstractVector, T <: AbstractVector}
    return (
        convert(PoincareHalfSpacePoint, p),
        convert(PoincareHalfSpaceTangentVector, p, X),
    )
end

@doc raw"""
    distance(::Hyperbolic, p::PoincareHalfSpacePoint, q::PoincareHalfSpacePoint)

Compute the distance on the [`Hyperbolic`](@ref) manifold $\mathcal H^n$ represented in the
Poincaré half space model. The formula reads

````math
d_{\mathcal H^n}(p,q) = \operatorname{acosh}\Bigl( 1 + \frac{\lVert p - q \rVert^2}{2 p_n q_n} \Bigr)
````
"""
function distance(::Hyperbolic, p::PoincareHalfSpacePoint, q::PoincareHalfSpacePoint)
    return acosh(1 + norm(p.value .- q.value)^2 / (2 * p.value[end] * q.value[end]))
end

embed(::Hyperbolic, p::PoincareHalfSpacePoint) = p.value
embed!(::Hyperbolic, q, p::PoincareHalfSpacePoint) = copyto!(q, p.value)
embed(::Hyperbolic, p::PoincareHalfSpacePoint, X::PoincareHalfSpaceTangentVector) = X.value
function embed!(
        ::Hyperbolic,
        Y,
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
    )
    return copyto!(Y, X.value)
end

function get_embedding(
        ::Hyperbolic{TypeParameter{Tuple{n}}}, ::Type{<:PoincareHalfSpacePoint},
    ) where {n}
    return Euclidean(n)
end
function get_embedding(M::Hyperbolic{Tuple{Int}}, ::Type{<:PoincareHalfSpacePoint})
    n = get_parameter(M.size)[1]
    return Euclidean(n; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Hyperbolic, ::Type{<:PoincareHalfSpacePoint})
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

@doc raw"""
    inner(
        ::Hyperbolic,
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
        Y::PoincareHalfSpaceTangentVector
    )

Compute the inner product in the Poincaré half space model. The formula reads
````math
g_p(X,Y) = \frac{⟨X,Y⟩}{p_n^2}.
````
"""
function inner(
        ::Hyperbolic,
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
        Y::PoincareHalfSpaceTangentVector,
    )
    return dot(X.value, Y.value) / last(p.value)^2
end

function norm(M::Hyperbolic, p::PoincareHalfSpacePoint, X::PoincareHalfSpaceTangentVector)
    return sqrt(inner(M, p, X, X))
end

@doc raw"""
    project(::Hyperbolic, ::PoincareHalfSpacePoint ::PoincareHalfSpaceTangentVector)

projection of tangent vectors in the Poincaré half space model is just the identity, since
the tangent space consists of all $ℝ^n$.
"""
project(::Hyperbolic, ::PoincareHalfSpacePoint::PoincareHalfSpaceTangentVector)

function ManifoldsBase.allocate_result_embedding(
        ::Hyperbolic,
        ::typeof(project),
        X::PoincareHalfSpaceTangentVector,
        ::PoincareHalfSpacePoint,
    )
    return PoincareHalfSpaceTangentVector(allocate(X.value))
end

function project!(
        ::Hyperbolic,
        Y::PoincareHalfSpaceTangentVector,
        ::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
    )
    return (Y.value .= X.value)
end

using ADTypes
using Distributions
using FiniteDifferences
using Manifolds, ManifoldsBase
using Test
using Random
using RecursiveArrayTools
using StaticArrays

using LinearAlgebra: I, dot, Diagonal, normalize
using StatsBase: AbstractWeights, pweights
import ManifoldsBase: default_retraction_method
using Manifolds: InducedBasis, connection, get_chart_index, induced_basis, mean!, median!

struct TestEuclidean{N} <: AbstractManifold{ℝ} end
struct TestEuclideanMetric <: AbstractMetric end
struct TestScaledEuclideanMetric <: AbstractMetric end
struct TestRetraction <: AbstractRetractionMethod end
struct TestConnection <: AbstractAffineConnection end

Manifolds.connection(::TestEuclidean) = TestConnection()
ManifoldsBase.default_retraction_method(::TestEuclidean) = TestRetraction()
function ManifoldsBase.default_retraction_method(
        ::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
    )
    return TestRetraction()
end

Manifolds.manifold_dimension(::TestEuclidean{N}) where {N} = N
function Manifolds.local_metric(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
        ::Any,
        ::InducedBasis,
    )
    return Diagonal(1.0:manifold_dimension(M))
end
function Manifolds.local_metric(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
        ::Any,
        ::T,
    ) where {T <: ManifoldsBase.AbstractOrthogonalBasis}
    return Diagonal(1.0:manifold_dimension(M))
end
function Manifolds.local_metric(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestScaledEuclideanMetric},
        ::Any,
        ::T,
    ) where {T <: ManifoldsBase.AbstractOrthogonalBasis}
    return 2 .* Diagonal(1.0:manifold_dimension(M))
end
function Manifolds.get_coordinates_orthogonal(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
        ::Any,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return 1 ./ [1.0:manifold_dimension(M)...] .* X
end
function Manifolds.get_coordinates_orthogonal!(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
        c,
        ::Any,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    c .= 1 ./ [1.0:manifold_dimension(M)...] .* X
    return c
end
function Manifolds.get_vector_orthonormal!(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestEuclideanMetric},
        X,
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    X .= [1.0:manifold_dimension(M)...] .* c
    return X
end
function Manifolds.get_coordinates_orthogonal!(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestScaledEuclideanMetric},
        c,
        ::Any,
        X,
    )
    c .= 1 ./ (2 .* [1.0:manifold_dimension(M)...]) .* X
    return c
end
function Manifolds.get_vector_orthogonal!(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestScaledEuclideanMetric},
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    return 2 .* [1.0:manifold_dimension(M)...] .* c
end
function Manifolds.get_vector_orthogonal!(
        M::MetricManifold{ℝ, <:TestEuclidean, <:TestScaledEuclideanMetric},
        X,
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    X .= 2 .* [1.0:manifold_dimension(M)...] .* c
    return X
end
struct TestSphere{N, T} <: AbstractManifold{ℝ}
    r::T
end

struct TestSphericalMetric <: AbstractMetric end

Manifolds.manifold_dimension(::TestSphere{N}) where {N} = N
function Manifolds.local_metric(
        M::MetricManifold{ℝ, <:TestSphere, <:TestSphericalMetric},
        p,
        ::InducedBasis,
    )
    r = base_manifold(M).r
    d = allocate(p)
    d[1] = r^2
    d[2] = d[1] * sin(p[1])^2
    return Diagonal(d)
end
sph_to_cart(θ, ϕ) = [cos(ϕ) * sin(θ), sin(ϕ) * sin(θ), cos(θ)]

struct BaseManifold{N} <: AbstractManifold{ℝ} end
struct BaseManifoldMetric{M} <: AbstractMetric end
struct DefaultBaseManifoldMetric <: AbstractMetric end
struct NotImplementedMetric <: AbstractMetric end

Manifolds.manifold_dimension(::BaseManifold{N}) where {N} = N
Manifolds.inner(::BaseManifold, p, X, Y) = 2 * dot(X, Y)
Manifolds.representation_size(::BaseManifold{N}) where {N} = (N,)
function Manifolds.rand!(rng::AbstractRNG, ::BaseManifold, p; kwargs...)
    return randn!(rng, p)
end
Manifolds.exp!(::BaseManifold, q, p, X) = q .= p + 2 * X
Manifolds.exp_fused!(::BaseManifold, q, p, X, t::Number) = q .= p + 2 * t * X
Manifolds.log!(::BaseManifold, Y, p, q) = Y .= (q - p) / 2
Manifolds.project!(::BaseManifold, Y, p, X) = Y .= 2 .* X
Manifolds.project!(::BaseManifold, q, p) = (q .= p)
Manifolds.injectivity_radius(::BaseManifold) = Inf
Manifolds.injectivity_radius(::BaseManifold, ::Any) = Inf
Manifolds.injectivity_radius(::BaseManifold, ::AbstractRetractionMethod) = Inf
Manifolds._injectivity_radius(::BaseManifold, ::ExponentialRetraction) = Inf
Manifolds.injectivity_radius(::BaseManifold, ::Any, ::AbstractRetractionMethod) = Inf
Manifolds._injectivity_radius(::BaseManifold, ::Any, ::ExponentialRetraction) = Inf
function Manifolds.local_metric(
        ::MetricManifold{ℝ, <:BaseManifold{N}, BaseManifoldMetric{N}},
        p,
        ::InducedBasis,
    ) where {N}
    return 2 * one(p * p')
end
function Manifolds.exp!(
        M::MetricManifold{ℝ, <:BaseManifold{N}, BaseManifoldMetric{N}},
        q,
        p,
        X,
    ) where {N}
    return exp!(base_manifold(M), q, p, X)
end
function Manifolds.exp_fused!(
        M::MetricManifold{ℝ, <:BaseManifold{N}, BaseManifoldMetric{N}},
        q,
        p,
        X,
        t::Number,
    ) where {N}
    return Manifolds.exp_fused!(base_manifold(M), q, p, X, t)
end
function Manifolds.parallel_transport_to!(::BaseManifold, Y, p, X, q)
    return (Y .= X)
end
function Manifolds.get_basis(
        ::BaseManifold{N},
        p,
        B::DefaultOrthonormalBasis{<:Any, ManifoldsBase.TangentSpaceType},
    ) where {N}
    return CachedBasis(B, [(Matrix{eltype(p)}(I, N, N)[:, i]) for i in 1:N])
end
function Manifolds.get_coordinates_orthonormal!(
        ::BaseManifold,
        Y,
        p,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return Y .= X
end
function Manifolds.get_vector_orthonormal!(
        ::BaseManifold,
        Y,
        p,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return Y .= X
end

Manifolds.metric(::BaseManifold) = DefaultBaseManifoldMetric()

const ProjectedPointDistribution =
    Base.get_extension(Manifolds, :ManifoldsDistributionsExt).ProjectedPointDistribution

function Manifolds.projected_distribution(M::BaseManifold, d)
    return ProjectedPointDistribution(M, d, project!, rand(d))
end
function Manifolds.projected_distribution(M::BaseManifold, d, p)
    return ProjectedPointDistribution(M, d, project!, p)
end

function Manifolds.flat!(
        ::BaseManifold,
        v::FVector{Manifolds.CotangentSpaceType},
        x,
        w::FVector{Manifolds.TangentSpaceType},
    )
    v.data .= 2 .* w.data
    return v
end
function Manifolds.sharp!(
        ::BaseManifold,
        v::FVector{Manifolds.TangentSpaceType},
        x,
        w::FVector{Manifolds.CotangentSpaceType},
    )
    v.data .= w.data ./ 2
    return v
end

# test for https://github.com/JuliaManifolds/Manifolds.jl/issues/539
struct Issue539Metric <: RiemannianMetric end
Manifolds.inner(::MetricManifold{ℝ, <:AbstractManifold{ℝ}, Issue539Metric}, p, X, Y) = 3

@testset "Metrics" begin
    # some tests failed due to insufficient accuracy for a particularly bad RNG state
    Random.seed!(42)
    @testset "Metric Basics" begin
        @test repr(MetricManifold(Euclidean(3), EuclideanMetric())) ===
            "MetricManifold(Euclidean(3; field=ℝ), EuclideanMetric())"
    end
    @testset "Connection Trait" begin
        E = Euclidean(3)
        M = ConnectionManifold(E, LeviCivitaConnection())
        @test is_default_connection(M)
        @test decorated_manifold(M) == E
        @test Manifolds.connection(M) == LeviCivitaConnection()
        @test is_default_connection(E, LeviCivitaConnection())
        # Defaults passthroguh for retr/inverse retr and vector transport
        @test default_retraction_method(M) == default_retraction_method(E)
        @test default_inverse_retraction_method(M) == default_inverse_retraction_method(E)
        @test default_vector_transport_method(M) == default_vector_transport_method(E)
        # same for point type added
        T = Vector{Float64}
        @test default_retraction_method(M, T) == default_retraction_method(E, T)
        @test default_inverse_retraction_method(M, T) == default_inverse_retraction_method(E, T)
        @test default_vector_transport_method(M, T) == default_vector_transport_method(E, T)
        @test !is_default_connection(TestEuclidean{3}(), LeviCivitaConnection())
        @test Manifolds.connection(TestEuclidean{3}()) == TestConnection()
    end

    @testset "solve_exp_ode error message" begin
        E = TestEuclidean{3}()
        g = TestEuclideanMetric()
        M = MetricManifold(E, g)
        default_retraction_method(::TestEuclidean) = TestRetraction()
        p = [1.0, 2.0, 3.0]
        X = [2.0, 3.0, 4.0]
        q = similar(X)
        @test_throws MethodError exp(M, p, X)
        @test_throws MethodError Manifolds.exp_fused(M, p, X, 1.0)
        @test_throws MethodError exp!(M, q, p, X)
        @test_throws MethodError Manifolds.exp_fused!(M, q, p, X, 1.0)

        N = ConnectionManifold(E, LeviCivitaConnection())
        @test_throws MethodError exp(N, p, X)
        @test_throws MethodError Manifolds.exp_fused(N, p, X, 1.0)
        @test_throws MethodError exp!(N, q, p, X)
        @test_throws MethodError Manifolds.exp_fused!(N, q, p, X, 1.0)
    end

    @testset "Local Metric Error message" begin
        M = MetricManifold(BaseManifold{2}(), NotImplementedMetric())
        A = Manifolds.get_default_atlas(M)
        p = [3, 4]
        i = get_chart_index(M, A, p)

        B = induced_basis(M, A, i, TangentSpaceType())
        @test_throws MethodError local_metric(M, p, B)
        @test_throws MethodError is_flat(M)

        X = [3, 4]
        Y = [3, 4]
        Z = [3, 4]
        @test_throws MethodError inner(M, p, X, Y)
        @test_throws MethodError Weingarten(M, p, X, Y)
        @test_throws MethodError Weingarten!(M, Z, p, X, Y)
    end
    @testset "scaled Euclidean metric" begin
        n = 3
        E = TestEuclidean{n}()
        g = TestEuclideanMetric()
        M = MetricManifold(E, g)
        A = Manifolds.get_default_atlas(M)
        @test repr(M) == "MetricManifold(TestEuclidean{3}(), TestEuclideanMetric())"

        @test TestEuclideanMetric()(E) === M
        @test TestEuclideanMetric(E) === M
        @test connection(M) === Manifolds.LeviCivitaConnection()

        G = Diagonal(1.0:n)
        invG = inv(G)
        @test manifold_dimension(M) == n
        @test base_manifold(M) === E
        @test metric(M) === g

        i_zeros = get_chart_index(M, A, zeros(3))
        B_i_zeros = induced_basis(M, A, i_zeros, TangentSpaceType())
        @test_throws MethodError local_metric_jacobian(E, zeros(3), B_i_zeros)
        @test_throws MethodError christoffel_symbols_second_jacobian(E, zeros(3), B_i_zeros)

        for vtype in (Vector, MVector{n})
            p, X, Y = vtype(randn(n)), vtype(randn(n)), vtype(randn(n))

            chart_p = get_chart_index(M, A, p)
            B_chart_p = induced_basis(M, A, chart_p, TangentSpaceType())

            @test check_point(M, p) == check_point(E, p)
            @test check_vector(M, p, X) == check_vector(E, p, X)

            @test local_metric(M, p, B_chart_p) ≈ G
            @test inverse_local_metric(M, p, B_chart_p) ≈ invG
            @test det_local_metric(M, p, B_chart_p) ≈ *(1.0:n...)
            @test log_local_metric_density(M, p, B_chart_p) ≈ sum(log.(1.0:n)) / 2

            fX = ManifoldsBase.TFVector(X, B_chart_p)
            fY = ManifoldsBase.TFVector(Y, B_chart_p)
            @test inner(M, p, fX, fY) ≈ dot(X, G * Y) atol = 1.0e-6
            @test norm(M, p, fX) ≈ sqrt(dot(X, G * X)) atol = 1.0e-6

            @test christoffel_symbols_first(M, p, B_chart_p) ≈ zeros(n, n, n) atol = 1.0e-6
            @test christoffel_symbols_second(M, p, B_chart_p) ≈ zeros(n, n, n) atol = 1.0e-6
            @test riemann_tensor(M, p, B_chart_p) ≈ zeros(n, n, n, n) atol = 1.0e-6
            @test ricci_tensor(M, p, B_chart_p) ≈ zeros(n, n) atol = 1.0e-6
            @test ricci_curvature(M, p, B_chart_p) ≈ 0 atol = 1.0e-6
            @test gaussian_curvature(M, p, B_chart_p) ≈ 0 atol = 1.0e-6
            @test einstein_tensor(M, p, B_chart_p) ≈ zeros(n, n) atol = 1.0e-6

            fdm = AutoFiniteDifferences(forward_fdm(2, 1))
            @test christoffel_symbols_first(M, p, B_chart_p; backend = fdm) ≈ zeros(n, n, n) atol =
                1.0e-6
            @test christoffel_symbols_second(M, p, B_chart_p; backend = fdm) ≈ zeros(n, n, n) atol =
                1.0e-6
            @test riemann_tensor(M, p, B_chart_p; backend = fdm) ≈ zeros(n, n, n, n) atol =
                1.0e-6
            @test ricci_tensor(M, p, B_chart_p; backend = fdm) ≈ zeros(n, n) atol = 1.0e-6
            @test ricci_curvature(M, p, B_chart_p; backend = fdm) ≈ 0 atol = 1.0e-6
            @test gaussian_curvature(M, p, B_chart_p; backend = fdm) ≈ 0 atol = 1.0e-6
            @test einstein_tensor(M, p, B_chart_p; backend = fdm) ≈ zeros(n, n) atol = 1.0e-6

            fd_diff = AutoFiniteDifferences(central_fdm(5, 1))
            @test christoffel_symbols_first(M, p, B_chart_p; backend = fd_diff) ≈
                zeros(n, n, n) atol = 1.0e-6
            @test christoffel_symbols_second(M, p, B_chart_p; backend = fd_diff) ≈
                zeros(n, n, n) atol = 1.0e-6
            @test riemann_tensor(M, p, B_chart_p; backend = fd_diff) ≈ zeros(n, n, n, n) atol =
                1.0e-6
            @test ricci_tensor(M, p, B_chart_p; backend = fd_diff) ≈ zeros(n, n) atol = 1.0e-6
            @test ricci_curvature(M, p, B_chart_p; backend = fd_diff) ≈ 0 atol = 1.0e-6
            @test gaussian_curvature(M, p, B_chart_p; backend = fd_diff) ≈ 0 atol = 1.0e-6
            @test einstein_tensor(M, p, B_chart_p; backend = fd_diff) ≈ zeros(n, n) atol =
                1.0e-6
        end
    end

    @testset "default_* functions" begin
        E = Euclidean(3)
        EM = MetricManifold(E, EuclideanMetric())
        @test default_retraction_method(EM) === default_retraction_method(E)
        @test default_inverse_retraction_method(EM) === default_inverse_retraction_method(E)
        @test default_vector_transport_method(EM) === default_vector_transport_method(E)
        EC = ConnectionManifold(E, TestConnection())
        @test default_retraction_method(EC) === default_retraction_method(E)
        @test default_inverse_retraction_method(EC) === default_inverse_retraction_method(E)
        @test default_vector_transport_method(EC) === default_vector_transport_method(E)
    end

    @testset "scaled Sphere metric" begin
        n = 2
        r = 10 * rand()
        θ, ϕ = π * rand(), 2π * rand()
        Sr = TestSphere{n, Float64}(r)
        S = Manifolds.Sphere(n)
        g = TestSphericalMetric()
        M = MetricManifold(Sr, g)
        A = Manifolds.get_default_atlas(M)

        @test manifold_dimension(M) == n
        @test base_manifold(M) === Sr
        @test metric(M) === g

        for vtype in (Vector, MVector{n})
            p = vtype([θ, ϕ])
            chart_p = get_chart_index(M, A, p)
            B_p = induced_basis(M, A, chart_p, TangentSpaceType())
            G = Diagonal(vtype([1, sin(θ)^2])) .* r^2
            invG = Diagonal(vtype([1, 1 / sin(θ)^2])) ./ r^2
            X, Y = normalize(randn(n)), normalize(randn(n))

            @test local_metric(M, p, B_p) ≈ G atol = 1.0e-6
            @test inverse_local_metric(M, p, B_p) ≈ invG atol = 1.0e-6
            @test det_local_metric(M, p, B_p) ≈ r^4 * sin(θ)^2 atol = 1.0e-6
            @test log_local_metric_density(M, p, B_p) ≈ 2 * log(r) + log(sin(θ)) atol = 1.0e-6
            fX = ManifoldsBase.TFVector(X, B_p)
            fY = ManifoldsBase.TFVector(Y, B_p)
            @test inner(M, p, fX, fY) ≈ dot(X, G * Y) atol = 1.0e-6
            @test norm(M, p, fX) ≈ sqrt(dot(X, G * X)) atol = 1.0e-6

            pcart = sph_to_cart(θ, ϕ)
            Xcart = [
                cos(ϕ) * cos(θ) -sin(ϕ) * sin(θ)
                sin(ϕ) * cos(θ) cos(ϕ) * sin(θ)
                -sin(θ) 0
            ] * X

            Γ₁ = christoffel_symbols_first(M, p, B_p)
            for i in 1:n, j in 1:n, k in 1:n
                if (i, j, k) == (1, 2, 2) || (i, j, k) == (2, 1, 2)
                    @test Γ₁[i, j, k] ≈ r^2 * cos(θ) * sin(θ) atol = 1.0e-6
                elseif (i, j, k) == (2, 2, 1)
                    @test Γ₁[i, j, k] ≈ -r^2 * cos(θ) * sin(θ) atol = 1.0e-6
                else
                    @test Γ₁[i, j, k] ≈ 0 atol = 1.0e-6
                end
            end

            Γ₂ = christoffel_symbols_second(M, p, B_p)
            for l in 1:n, i in 1:n, j in 1:n
                if (l, i, j) == (1, 2, 2)
                    @test Γ₂[l, i, j] ≈ -cos(θ) * sin(θ) atol = 1.0e-6
                elseif (l, i, j) == (2, 1, 2) || (l, i, j) == (2, 2, 1)
                    @test Γ₂[l, i, j] ≈ cot(θ) atol = 1.0e-6
                else
                    @test Γ₂[l, i, j] ≈ 0 atol = 1.0e-6
                end
            end

            R = riemann_tensor(M, p, B_p)
            for l in 1:n, i in 1:n, j in 1:n, k in 1:n
                if (l, i, j, k) == (2, 1, 1, 2)
                    @test R[l, i, j, k] ≈ -1 atol = 2.0e-6
                elseif (l, i, j, k) == (2, 1, 2, 1)
                    @test R[l, i, j, k] ≈ 1 atol = 2.0e-6
                elseif (l, i, j, k) == (1, 2, 1, 2)
                    @test R[l, i, j, k] ≈ sin(θ)^2 atol = 1.0e-6
                elseif (l, i, j, k) == (1, 2, 2, 1)
                    @test R[l, i, j, k] ≈ -sin(θ)^2 atol = 1.0e-6
                else
                    @test R[l, i, j, k] ≈ 0 atol = 1.0e-6
                end
            end

            @test ricci_tensor(M, p, B_p) ≈ G ./ r^2 atol = 2.0e-6
            @test ricci_curvature(M, p, B_p) ≈ 2 / r^2 atol = 2.0e-6
            @test gaussian_curvature(M, p, B_p) ≈ 1 / r^2 atol = 2.0e-6
            @test einstein_tensor(M, p, B_p) ≈
                ricci_tensor(M, p, B_p) - gaussian_curvature(M, p, B_p) .* G atol = 1.0e-6
        end
    end

    @testset "is_metric_function" begin
        for f in [flat, sharp, log, christoffel_symbols_first, christoffel_symbols_second, local_metric, local_metric_jacobian, christoffel_symbols_second_jacobian]
            @test Manifolds.is_metric_function(f)
        end
        for f in [manifold_dimension, get_parameters]
            @test !Manifolds.is_metric_function(f)
        end
    end

    @testset "Metric decorator" begin
        M = BaseManifold{3}()
        g = BaseManifoldMetric{3}()
        MM = MetricManifold(M, g)

        @test DefaultBaseManifoldMetric(BaseManifold{3}()) ===
            MetricManifold(BaseManifold{3}(), DefaultBaseManifoldMetric())
        MT = DefaultBaseManifoldMetric()
        @test MT(BaseManifold{3}()) ===
            MetricManifold(BaseManifold{3}(), DefaultBaseManifoldMetric())

        g2 = DefaultBaseManifoldMetric()
        MM2 = MetricManifold(M, g2)
        A = Manifolds.get_default_atlas(M)

        @test is_default_metric(MM) == is_default_metric(base_manifold(MM), metric(MM))
        @test is_default_metric(MM2) == is_default_metric(base_manifold(MM2), metric(MM2))
        @test is_default_metric(MM2)

        @test convert(typeof(MM2), M) == MM2
        @test_throws ErrorException convert(typeof(MM), M)
        p = [0.1, 0.2, 0.4]
        X = [0.5, 0.7, 0.11]
        Y = [0.13, 0.17, 0.19]
        q = allocate(p)

        @test is_point(MM, rand(MM))
        @test is_point(MM, rand(Xoshiro(), MM))
        @test is_vector(MM, p, rand(MM; vector_at = p))
        rand!(MM, q)
        @test is_point(MM, q)

        p2 = allocate(p)
        copyto!(MM, p2, p)
        p3 = allocate(p)
        copyto!(M, p3, p)
        @test p2 == p3
        X = zero_vector(MM, p)
        Y = allocate(X)
        copyto!(MM, Y, p, X)
        Y2 = allocate(X)
        copyto!(M, Y2, p, X)
        @test Y == Y2

        X = [0.5, 0.7, 0.11]

        chart_p = get_chart_index(M, A, p)
        B_p = induced_basis(M, A, chart_p, TangentSpaceType())
        fX = ManifoldsBase.TFVector(X, B_p)
        fY = ManifoldsBase.TFVector(Y, B_p)

        @test inner(M, p, X, Y) == 2 * dot(X, Y)
        @test inner(MM, p, fX, fY) === inner(M, p, X, Y)
        @test norm(MM, p, fX) === norm(M, p, X)
        @test exp(M, p, X) == p + 2 * X
        @test Manifolds.exp_fused(M, p, X, 0.5) == p + X
        @test exp(MM2, p, X) == exp(M, p, X)
        @test Manifolds.exp_fused(MM2, p, X, 0.5) == Manifolds.exp_fused(M, p, X, 0.5)
        @test exp!(MM, q, p, X) === exp!(M, q, p, X)
        @test Manifolds.exp_fused!(MM, q, p, X, 0.5) ===
            Manifolds.exp_fused!(M, q, p, X, 0.5)
        @test retract!(MM, q, p, X) === retract!(M, q, p, X)
        @test Manifolds.retract_fused!(MM, q, p, X, 1) ===
            Manifolds.retract_fused!(M, q, p, X, 1)
        @test Manifolds.retract_fused(MM, p, X, 1) ==
            Manifolds.retract_fused(M, p, X, 1)
        @test project!(MM, Y, p, X) === project!(M, Y, p, X)
        @test project!(MM, q, p) === project!(M, q, p)
        # without a definition for the metric from the embedding, no projection possible
        @test_throws MethodError log!(MM, Y, p, q) === project!(M, Y, p, q)
        @test_throws MethodError vector_transport_to!(MM, Y, p, X, q) ===
            vector_transport_to!(M, Y, p, X, q)
        # without DiffEq, these error
        @test_throws MethodError exp(MM, p, X, 1:3)
        # these always fall back anyways.
        @test zero_vector!(MM, X, p) === zero_vector!(M, X, p)

        @test injectivity_radius(MM, p) === injectivity_radius(M, p)
        @test injectivity_radius(MM) === injectivity_radius(M)
        @test injectivity_radius(MM, ProjectionRetraction()) ===
            injectivity_radius(M, ProjectionRetraction())
        @test injectivity_radius(MM, ExponentialRetraction()) ===
            injectivity_radius(M, ExponentialRetraction())
        @test injectivity_radius(MM) === injectivity_radius(M)

        @test is_point(MM, p) === is_point(M, p)
        @test is_vector(MM, p, X) === is_vector(M, p, X)

        A = Manifolds.get_default_atlas(MM2)
        chart_p = get_chart_index(MM2, A, p)
        B_p = induced_basis(MM2, A, chart_p, TangentSpaceType())
        @test_throws MethodError local_metric(MM2, p, B_p)
        @test_throws MethodError local_metric_jacobian(MM2, p, B_p)
        @test_throws MethodError christoffel_symbols_second_jacobian(MM2, p, B_p)
        # MM falls back to nondefault error
        if VERSION >= v"1.9"
            @test_throws MethodError Manifolds.projected_distribution(MM, 1, p)
            @test_throws MethodError Manifolds.projected_distribution(MM, 1)
        end

        @test inner(MM2, p, X, Y) === inner(M, p, X, Y)
        @test norm(MM2, p, X) === norm(M, p, X)
        @test distance(MM2, p, q) === distance(M, p, q)
        @test exp!(MM2, q, p, X) === exp!(M, q, p, X)
        @test exp(MM2, p, X) == exp(M, p, X)
        @test log!(MM2, X, p, q) === log!(M, X, p, q)
        @test log(MM2, p, q) == log(M, p, q)
        @test retract!(MM2, q, p, X) === retract!(M, q, p, X)
        @test Manifolds.retract_fused!(MM2, q, p, X, 1) ===
            Manifolds.retract_fused!(M, q, p, X, 1)

        @test project!(MM2, q, p) === project!(M, q, p)
        @test project!(MM2, Y, p, X) === project!(M, Y, p, X)
        @test parallel_transport_to(MM2, p, X, q) == parallel_transport_to(M, q, X, p)
        @test parallel_transport_to!(MM2, Y, p, X, q) ==
            parallel_transport_to!(M, Y, q, X, p)
        @test project!(MM2, Y, p, X) === project!(M, Y, p, X)
        @test vector_transport_to!(MM2, Y, p, X, q) == vector_transport_to!(M, Y, p, X, q)
        c = 2 * ones(3)
        m = ParallelTransport()
        @test zero_vector!(MM2, X, p) === zero_vector!(M, X, p)
        @test injectivity_radius(MM2, p) === injectivity_radius(M, p)
        @test injectivity_radius(MM2) === injectivity_radius(M)
        @test injectivity_radius(MM2, p, ExponentialRetraction()) ===
            injectivity_radius(M, p, ExponentialRetraction())
        @test injectivity_radius(MM2, ExponentialRetraction()) ===
            injectivity_radius(M, ExponentialRetraction())
        @test injectivity_radius(MM2, p, ProjectionRetraction()) ===
            injectivity_radius(M, p, ProjectionRetraction())
        @test injectivity_radius(MM2, ProjectionRetraction()) ===
            injectivity_radius(M, ProjectionRetraction())
        @test is_point(MM2, p) === is_point(M, p)
        @test is_vector(MM2, p, X) === is_vector(M, p, X)

        a = Manifolds.projected_distribution(
            M,
            Distributions.MvNormal(zero(zeros(3)), 1.0 * I),
        )
        b = Manifolds.projected_distribution(
            MM2,
            Distributions.MvNormal(zero(zeros(3)), 1.0 * I),
        )
        @test isapprox(Matrix(a.distribution.Σ), Matrix(b.distribution.Σ))
        @test isapprox(a.distribution.μ, b.distribution.μ)
        @test get_basis(M, p, DefaultOrthonormalBasis()).data ==
            get_basis(MM2, p, DefaultOrthonormalBasis()).data
        @test_throws MethodError get_basis(MM, p, DefaultOrthonormalBasis())

        fX = ManifoldsBase.TFVector(X, B_p)
        fY = ManifoldsBase.TFVector(Y, B_p)
        coX = flat(M, p, X)
        coY = flat(M, p, Y)
        cofX = flat(M, p, fX)
        cofY = flat(M, p, fY)
        @test coX(X) ≈ norm(M, p, X)^2
        @test coY(X) ≈ inner(M, p, X, Y)
        cotspace = CotangentSpace(M, p)
        cotspace2 = CotangentSpace(MM, p)
        @test coX.X ≈ X
        X0p = zero_vector(MM, p)
        @test inner(M, p, X, Y) ≈ inner(cotspace, X0p, coX, coY)
        @test inner(MM, p, fX, fY) ≈ inner(cotspace, X0p, coX, coY)

        @test inner(MM, p, fX, fY) ≈ inner(cotspace2, X0p, cofX, cofY)
        @test sharp(M, p, coX) ≈ X

        coMMfX = flat(MM, p, fX)
        coMMfY = flat(MM, p, fY)
        @test inner(MM, p, fX, fY) ≈ inner(cotspace2, X0p, coMMfX, coMMfY)
        @test isapprox(sharp(MM, p, coMMfX).data, fX.data)

        @testset "Mutating flat/sharp" begin
            cofX2 = allocate(cofX)
            flat!(M, cofX2, p, fX)
            @test isapprox(cofX2.data, cofX.data)

            fX2 = allocate(fX)
            sharp!(M, fX2, p, cofX2)
            @test isapprox(fX2.data, fX.data)

            cofX2 = allocate(cofX)
            flat!(MM, cofX2, p, fX)
            @test isapprox(cofX2.data, cofX.data)

            fX2 = allocate(fX)
            sharp!(MM, fX2, p, cofX2)
            @test isapprox(fX2.data, fX.data)

            cofX3a = flat(MM2, p, fX)
            cofX3b = allocate(cofX3a)
            flat!(MM2, cofX3b, p, fX)
            @test isapprox(cofX3a.data, cofX3b.data)

            fX3a = sharp(MM2, p, cofX)
            fX3b = allocate(fX3a)
            sharp!(MM2, fX3b, p, cofX)
            @test isapprox(fX3a.data, fX3b.data)
        end
    end

    @testset "change metric and representer" begin
        M = MetricManifold(TestEuclidean{2}(), TestEuclideanMetric())
        G = TestScaledEuclideanMetric()
        M2 = TestScaledEuclideanMetric(M)
        @test M2.manifold === M.manifold
        @test M2.metric == G
        p = ones(2)
        X = 2 * ones(2)
        @test change_metric(M, TestEuclideanMetric(), p, X) == X
        Y = change_metric(M, G, p, X)
        @test Y ≈ sqrt(2) .* X #scaled metric has a factor 2, removing introduces this factor
        @test change_representer(M, TestEuclideanMetric(), p, X) == X
        Y2 = change_representer(M, G, p, X)
        @test Y2 ≈ 2 .* X #scaled metric has a factor 2, removing introduces this factor
    end

    @testset "issue #539" begin
        M = Sphere(2)
        p = [0.49567358314486515, 0.3740229181343087, -0.7838460025302334]
        X = [-1.1552859627097727, 0.40665559717366767, -0.5365163797547751]
        MM = MetricManifold(M, Issue539Metric())
        @test norm(MM, p, X)^2 ≈ 3
        @test get_embedding(MM) === get_embedding(M)
        @test get_embedding(MM, Float64) === get_embedding(M, Float64)
    end
end

include("../header.jl")

@testset "Multinomial doubly stochastic Matrices" begin
    M = MultinomialDoubleStochastic(3)
    @test manifold_dimension(M) == 4
    @test repr(M) == "MultinomialDoubleStochastic(3)"
    p = ones(3, 3) ./ 3
    X = zeros(3, 3)
    @test is_point(M, p)
    @test is_vector(M, p, X)
    pf1 = [0.1 0.9 0.1; 0.1 0.9 0.1; 0.1 0.1 0.9] #not sum 1
    @test_throws ManifoldDomainError is_point(M, pf1; error = :error)
    pf2r = [0.1 0.9 0.1; 0.8 0.05 0.15; 0.1 0.05 0.75] # sum(pf2r,dims=2)[3] is 0.9
    @test_throws CompositeManifoldError is_point(M, pf2r; error = :error)
    @test_throws ManifoldDomainError is_point(M, pf2r'; error = :error)
    pf3 = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0] # contains nonpositive entries
    @test_throws ManifoldDomainError is_point(M, pf3; error = :error)
    Xf2c = [-0.1 0.0 0.1; -0.2 0.1 0.1; 0.2 -0.1 -0.1] #nonzero columns
    @test_throws ManifoldDomainError is_vector(M, p, Xf2c; error = :error)
    @test_throws CompositeManifoldError is_vector(M, p, Xf2c'; error = :error)
    @test representation_size(M) == (3, 3)
    @test !is_flat(M)
    pE = similar(p)
    embed!(M, pE, p)
    pE2 = embed(M, p)
    @test pE == p
    @test pE2 == p
    @test_throws DomainError project(M, -ones(3, 3))
    @test project(M, p) == p
    p2 = [0.1 0.2 0.7; 0.2 0.7 0.1; 0.7 0.1 0.2]
    p3 = [0.1 0.4 0.5; 0.4 0.5 0.1; 0.5 0.1 0.4]

    X2 = [-0.1 0.0 0.1; 0.0 0.2 -0.2; 0.1 -0.2 0.1]
    @test is_vector(
        M,
        p2,
        vector_transport_to(M, p, X2, p2, ProjectionTransport());
        atol = 10^-15,
    )
    X3 = [1.0 1.0 1.0; 0.0 0.0 0.0; 0.0 0.0 0.0]
    @test inner(M, p, X3, X3) == 9.0

    types = [Matrix{Float64}]

    for T in types
        pts = [convert(T, p), convert(T, p2), convert(T, p3)]
        @testset "Type $T" begin
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_exp_log = false,
                test_default_vector_transport = true,
                vector_transport_methods = [ProjectionTransport()],
                retraction_methods = [ProjectionRetraction()],
                default_inverse_retraction_method = nothing,
                default_retraction_method = ProjectionRetraction(),
                is_tangent_atol_multiplier = 20,
                is_point_atol_multiplier = 20,
                test_inplace = true,
            )
        end
    end
    @testset "field parameter" begin
        M = MultinomialDoubleStochastic(3; parameter = :field)
        @test repr(M) == "MultinomialDoubleStochastic(3; parameter=:field)"
        @test get_embedding(M) === MultinomialMatrices(3, 3; parameter = :field)
    end
    @testset "random" begin
        Random.seed!(42)
        p = rand(M)
        @test is_point(M, p)
        X = rand(M; vector_at = p)
        @test is_vector(M, p, X; atol = 1.0e-9)
    end
    @testset "Riemannian Gradient" begin
        M = MultinomialDoubleStochastic(3)
        p = ones(3, 3) ./ 3
        Y = [1.0 -1.0 0.0; 0.0 0.0 1.0; -1.0 1.0 1.1]
        G = project(M, p, p .* Y)
        X = riemannian_gradient(M, p, Y)
        @test isapprox(M, p, G, X)
    end
end

include("../header.jl")

@testset "ProjectiveSpace" begin
    @testset "Real" begin
        M = ProjectiveSpace(2)
        @testset "Basics" begin
            @test repr(M) == "ProjectiveSpace(2, ℝ)"
            @test representation_size(M) == (3,)
            @test manifold_dimension(M) == 2
            @test !is_flat(M)
            @test is_flat(ProjectiveSpace(1))
            @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0, 0.0, 0.0, 0.0], [0.0, 1.0, 0.0])
            @test_throws DomainError is_point(M, [2.0, 0.0, 0.0]; error = :error)
            @test !is_point(M, [2.0, 0.0, 0.0])
            @test !is_vector(M, [1.0, 0.0, 0.0], [1.0, 0.0, 0.0])
            @test_throws DomainError is_vector(
                M,
                [1.0, 0.0, 0.0],
                [1.0, 0.0, 0.0];
                error = :error,
            )
            @test injectivity_radius(M) == π / 2
            @test injectivity_radius(M, ExponentialRetraction()) == π / 2
            @test injectivity_radius(M, [1.0, 0.0, 0.0]) == π / 2
            @test injectivity_radius(M, [1.0, 0.0, 0.0], ExponentialRetraction()) == π / 2
        end
        types = [Vector{Float64}]
        basis_types = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))
        @testset "Type $T" for T in types
            x = [1.0, 0.0, 0.0]
            v = [0.0, 1.0, 0.0]
            y = exp(M, x, v)
            w = [0.0, 1.0, -1.0]
            z = exp(M, x, w)
            pts = convert.(T, [x, y, z])
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_point = true,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    ProjectionTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                point_distributions = [Manifolds.uniform_distribution(M, pts[1])],
                tvector_distributions = [
                    Manifolds.normal_tvector_distribution(M, pts[1], 1.0),
                ],
                basis_types_vecs = (
                    DiagonalizingOrthonormalBasis([0.0, 1.0, 2.0]),
                    basis_types...,
                ),
                basis_types_to_from = basis_types,
                retraction_methods = [
                    ProjectionRetraction(),
                    PolarRetraction(),
                    QRRetraction(),
                ],
                inverse_retraction_methods = [
                    ProjectionInverseRetraction(),
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                is_tangent_atol_multiplier = 2,
                test_inplace = true,
            )
        end

        @testset "retract/inverse_retract" begin
            x = [1.0, 0.0, 0.0]
            v = [0.0, 1.0, 0.0]
            y = retract(M, x, v, ProjectionRetraction())
            v2 = inverse_retract(M, x, y, ProjectionInverseRetraction())
            @test v ≈ v2
        end

        @testset "equivalence" begin
            x = [1.0, 0.0, 0.0]
            v = [0.0, 1.0, 0.0]
            @test isapprox(M, x, -x)
            @test isapprox(M, x, exp(M, x, π * v))
            @test log(M, x, -x) ≈ zero(v)
            @test isapprox(M, -x, vector_transport_to(M, x, v, -x), -v)
        end

        @testset "Distribution MVector tests" begin
            upd_mvector = Manifolds.uniform_distribution(M, @MVector [1.0, 0.0, 0.0])
            @test isa(rand(upd_mvector), MVector)

            gtpd_mvector =
                Manifolds.normal_tvector_distribution(M, (@MVector [1.0, 0.0, 0.0]), 1.0)
            @test isa(rand(gtpd_mvector), MVector)
        end
    end

    @testset "Complex" begin
        M = ProjectiveSpace(2, ℂ)
        @testset "Basics" begin
            @test repr(M) == "ProjectiveSpace(2, ℂ)"
            @test representation_size(M) == (3,)
            @test manifold_dimension(M) == 4
            @test !is_flat(M)
            @test Manifolds.allocation_promotion_function(M, exp!, (1,)) == complex
            @test !is_point(M, [1.0 + 0im, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0 + 0im, 0.0, 0.0, 0.0], [0.0 + 0im, 1.0, 0.0])
            @test_throws DomainError is_point(M, [1.0, im, 0.0]; error = :error)
            @test !is_point(M, [1.0, im, 0.0])
            @test !is_vector(M, [1.0 + 0im, 0.0, 0.0], [1.0 + 0im, 0.0, 0.0])
            @test !is_vector(M, [1.0 + 0im, 0.0, 0.0], [-0.5im, 0.0, 0.0])
            @test_throws DomainError is_vector(
                M,
                [1.0 + 0im, 0.0, 0.0],
                [1.0 + 0im, 0.0, 0.0];
                error = :error,
            )
            @test_throws DomainError is_vector(
                M,
                [1.0 + 0im, 0.0, 0.0],
                [-0.5im, 0.0, 0.0];
                error = :error,
            )
            @test injectivity_radius(M) == π / 2
            @test injectivity_radius(M, ExponentialRetraction()) == π / 2
            @test injectivity_radius(M, [1.0 + 0im, 0.0, 0.0]) == π / 2
            @test injectivity_radius(M, [1.0 + 0im, 0.0, 0.0], ExponentialRetraction()) ==
                π / 2
        end
        types = [Vector{ComplexF64}]
        @testset "Type $T" for T in types
            p1 = [0.5 + 0.5im, 0.5 + 0.5im, 0]
            X = [0.0, 0.0, 1.0 - im]
            p2 = im * exp(M, p1, X)
            Y = [0.5, -0.5, 0.5im]
            p3 = (sqrt(0.5) - sqrt(0.5) * im) * exp(M, p1, Y)
            pts = convert.(T, [p1, p2, p3])
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_point = true,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    ProjectionTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                basis_types_to_from = (DefaultOrthonormalBasis(ℂ),),
                retraction_methods = [
                    ProjectionRetraction(),
                    PolarRetraction(),
                    QRRetraction(),
                ],
                inverse_retraction_methods = [
                    ProjectionInverseRetraction(),
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                is_tangent_atol_multiplier = 2,
                exp_log_atol_multiplier = 10.0^3,
                retraction_atol_multiplier = 10.0,
            )
        end

        @testset "retract/inverse_retract" begin
            x = [0.5 + 0.5im, 0.5 + 0.5im, 0]
            v = [0.0, 0.0, 1.0 - im]
            y = retract(M, x, v, ProjectionRetraction())
            v2 = inverse_retract(M, x, y, ProjectionInverseRetraction())
            @test v ≈ v2
        end

        @testset "equivalence" begin
            x = [1.0 + 0im, 0.0, 0.0]
            v = [0.0, im, 0.0]
            s = sqrt(0.5) - sqrt(0.5) * im
            @test isapprox(M, x, s * x)
            @test isapprox(M, x, exp(M, x, π * v))
            @test log(M, x, s * x) ≈ zero(v)
            @test isapprox(M, s * x, vector_transport_to(M, x, v, s * x), s * v)
        end
    end

    @testset "Right Quaternion" begin
        M = ProjectiveSpace(2, ℍ)
        @testset "Basics" begin
            @test repr(M) == "ProjectiveSpace(2, ℍ)"
            @test representation_size(M) == (3,)
            @test manifold_dimension(M) == 8
            @test !is_flat(M)
            @test !is_point(M, quat([1.0, 0.0, 0.0, 0.0]))
            @test !is_vector(M, quat([1.0, 0.0, 0.0, 0.0]), quat([0.0, 1.0, 0.0]))
            @test_throws DomainError is_point(M, [1.0, quat(0, 1, 0, 0), 0.0]; error = :error)
            @test !is_point(M, [1.0, quat(0, 1, 0, 0), 0.0])
            @test !is_vector(M, quat([1.0, 0.0, 0.0]), quat([1.0, 0.0, 0.0]))
            @test !is_vector(M, quat([1.0, 0.0, 0.0]), [quat(0, -0.5, 0, 0), 0.0, 0.0])
            @test_throws DomainError is_vector(
                M,
                Quaternion[1.0, 0.0, 0.0],
                Quaternion[1.0, 0.0, 0.0];
                error = :error,
            )
            @test_throws DomainError is_vector(
                M,
                quat([1.0, 0.0, 0.0]),
                quat([-0.5, 0.0, 0.0]);
                error = :error,
            )
            @test injectivity_radius(M) == π / 2
            @test injectivity_radius(M, ExponentialRetraction()) == π / 2
            @test injectivity_radius(M, Quaternion[1.0, 0.0, 0.0]) == π / 2
            @test injectivity_radius(
                M,
                Quaternion[1.0, 0.0, 0.0],
                ExponentialRetraction(),
            ) == π / 2
        end
        types = [Vector{Quaternion{Float64}}]
        @testset "Type $T" for T in types
            x = [Quaternion(0.5, 0, 0, 0.5), Quaternion(0, 0, 0.5, 0.5), 0]
            v = [Quaternion(0), Quaternion(0), Quaternion(0.0, -0.5, -0.5, 0.0)]
            y = Quaternion(0, 0, 0, 1) * exp(M, x, v)
            w = [
                Quaternion(0.25, -0.25, 0.25, 0.25),
                Quaternion(0.25, 0.25, -0.25, -0.25),
                1,
            ]
            z = Quaternion(0.5, -0.5, 0.5, -0.5) * exp(M, x, w)
            pts = convert.(T, [x, y, z])
            Manifolds.test_manifold(
                M,
                pts,
                test_injectivity_radius = false,
                test_project_point = true,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    ProjectionTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                basis_types_to_from = (DefaultOrthonormalBasis(ℍ),),
                retraction_methods = [
                    ProjectionRetraction(),
                    PolarRetraction(),
                    QRRetraction(),
                ],
                inverse_retraction_methods = [
                    ProjectionInverseRetraction(),
                    PolarInverseRetraction(),
                    QRInverseRetraction(),
                ],
                is_tangent_atol_multiplier = 10,
                exp_log_atol_multiplier = 10.0^3,
                retraction_atol_multiplier = 10.0,
            )
        end

        @testset "retract/inverse_retract" begin
            x = [Quaternion(0.5, 0, 0, 0.5), Quaternion(0, 0, 0.5, 0.5), 0]
            v = [Quaternion(0), Quaternion(0), Quaternion(0.0, -0.5, -0.5, 0.0)]
            y = retract(M, x, v, ProjectionRetraction())
            v2 = inverse_retract(M, x, y, ProjectionInverseRetraction())
            @test v ≈ v2
        end

        @testset "equivalence" begin
            x = Quaternion[1.0, 0.0, 0.0]
            v = [0.0, quat(0, 1, 0, 0), 0.0]
            s = Quaternion(0.5, -0.5, 0.5, -0.5)
            @test isapprox(M, x, x * s)
            @test isapprox(M, x, exp(M, x, π * v))
            @test log(M, x, x * s) ≈ zero(v)
            @test isapprox(M, x * s, vector_transport_to(M, x, v, x * s), v * s)
        end
    end

    @testset "ArrayProjectiveSpace" begin
        M = ArrayProjectiveSpace(2, 2; field = ℝ)
        @test manifold_dimension(M) == 3
        @test repr(M) == "ArrayProjectiveSpace(2, 2; field=ℝ)"
        @test typeof(get_embedding(M)) === Euclidean{ℝ, TypeParameter{Tuple{2, 2}}}
        @test representation_size(M) == (2, 2)
        p = ones(2, 2)
        q = project(M, p)
        @test is_point(M, q)
        Y = [1.0 0.0; 0.0 1.1]
        X = project(M, q, Y)
        @test is_vector(M, q, X)

        M = ArrayProjectiveSpace(2, 2; field = ℂ)
        @test manifold_dimension(M) == 6
        @test repr(M) == "ArrayProjectiveSpace(2, 2; field=ℂ)"
        @test typeof(get_embedding(M)) === Euclidean{ℂ, TypeParameter{Tuple{2, 2}}}
        @test representation_size(M) == (2, 2)
    end

    @testset "small distance tests" begin
        @testset for fT in (Float32, Float64), T in (fT, Complex{fT}, Quaternion{fT})
            𝔽 = T isa Complex ? ℂ : (T isa Quaternion ? ℍ : ℝ)
            M = ProjectiveSpace(2, 𝔽)
            rT = real(T)
            atol = rtol = sqrt(eps(rT))
            @testset for t in (zero(rT), eps(rT)^(1 // 4) / 8, eps(rT)^(1 // 4)),
                    λ in (one(T), (T <: Real ? -one(T) : sign(randn(T))))

                p = project(M, randn(T, representation_size(M)))
                X = project(M, p, randn(T, representation_size(M)))
                X ./= norm(M, p, X)
                project!(M, X, p, X)
                @test distance(M, p, exp(M, p, t * X) * λ) ≈ t atol = atol rtol = rtol
                @test distance(M, p, exp(M, p, (π - t) * X) * λ) ≈ t atol = atol rtol = rtol
            end
        end
    end

    @testset "Volume" begin
        @test manifold_volume(ProjectiveSpace(0)) ≈ 1
        @test manifold_volume(ProjectiveSpace(1)) ≈ π
        @test manifold_volume(ProjectiveSpace(2)) ≈ 2 * π
        @test manifold_volume(ProjectiveSpace(3)) ≈ π * π
    end

    @testset "field parameter" begin
        M = ProjectiveSpace(2; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int}}
        @test repr(M) == "ProjectiveSpace(2, ℝ; parameter=:field)"
        @test repr(ArrayProjectiveSpace(2, 3; parameter = :field)) ==
            "ArrayProjectiveSpace(2, 3; field=ℝ, parameter=:field)"
    end
end

_unit_weights(n::Int) = StatsBase.UnitWeights{Float64}(n)

function Base.show(io::IO, method::GeodesicInterpolationWithinRadius)
    return print(io, "GeodesicInterpolationWithinRadius($(method.radius))")
end

"""
    Statistics.cov(
        M::AbstractManifold,
        x::AbstractVector;
        basis::AbstractBasis=DefaultOrthonormalBasis(),
        tangent_space_covariance_estimator::CovarianceEstimator=SimpleCovariance(;
            corrected=true,
        ),
        mean_estimation_method::AbstractApproximationMethod=GradientDescentEstimation(),
        inverse_retraction_method::AbstractInverseRetractionMethod=default_inverse_retraction_method(
            M, eltype(x),
        ),
    )

Estimate the covariance matrix of a set of points `x` on manifold `M`. Since the covariance matrix
on a manifold is a rank 2 tensor, the function returns its coefficients in basis induced by
the given tangent space basis. See Section 5 of [Pennec:2006](@cite) for details.

The mean is calculated using the specified `mean_estimation_method` using
[mean](@ref Statistics.mean(::AbstractManifold, ::AbstractVector, ::AbstractApproximationMethod),
and tangent vectors at this mean are calculated using the provided `inverse_retraction_method`.
Finally, the covariance matrix in the tangent plane is estimated using the Euclidean space
 estimator `tangent_space_covariance_estimator`. The type `CovarianceEstimator` is defined
 in [`StatsBase.jl`](https://juliastats.org/StatsBase.jl/stable/cov/#StatsBase.CovarianceEstimator)
 and examples of covariance estimation methods can be found in
 [`CovarianceEstimation.jl`](https://github.com/mateuszbaran/CovarianceEstimation.jl/).
"""
function Statistics.cov(
        M::AbstractManifold,
        x::AbstractVector;
        basis::AbstractBasis = DefaultOrthonormalBasis(),
        tangent_space_covariance_estimator::CovarianceEstimator = SimpleCovariance(;
            corrected = true,
        ),
        mean_estimation_method::AbstractApproximationMethod = default_approximation_method(
            M,
            cov,
        ),
        inverse_retraction_method::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
    )
    μ = mean(M, x, mean_estimation_method)
    Xs_at_μ = map(p -> inverse_retract(M, μ, p, inverse_retraction_method), x)
    Xcs = map(X -> get_coordinates(M, μ, X, basis), Xs_at_μ)
    return cov(
        tangent_space_covariance_estimator,
        reduce(hcat, Xcs);
        mean = zero(Xcs[1]),
        dims = 2,
    )
end

function default_approximation_method(
        ::StopForwardingType,
        ::AbstractDecoratorManifold,
        ::typeof(cov),
    )
    return GradientDescentEstimation()
end
function default_approximation_method(::AbstractManifold, ::typeof(cov))
    return GradientDescentEstimation()
end

@doc raw"""
    mean(M::AbstractManifold, x::AbstractVector[, w::AbstractWeights]; kwargs...)

Compute the (optionally weighted) Riemannian center of mass also known as
Karcher mean of the vector `x` of points on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`, defined
as the point that satisfies the minimizer
````math
\operatorname{argmin}_{y ∈ \mathcal M} \frac{1}{2 \sum_{i=1}^n w_i} \sum_{i=1}^n w_i\mathrm{d}_{\mathcal M}^2(y,x_i),
````
where ``\mathrm{d}_{\mathcal M}`` denotes the Riemannian [`distance`](@ref).

In the general case, the [`GradientDescentEstimation`](@extref `ManifoldsBase.GradientDescentEstimation`) is used to compute the mean.
    mean(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::AbstractApproximationMethod=default_approximation_method(M, mean);
        kwargs...,
    )

Compute the mean using the specified `method`.

    mean(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::GradientDescentEstimation;
        p0=x[1],
        stop_iter=100,
        retraction::AbstractRetractionMethod = default_retraction_method(M),
        inverse_retraction::AbstractInverseRetractionMethod = default_retraction_method(M, eltype(x)),
        kwargs...,
    )

Compute the mean using the gradient descent scheme [`GradientDescentEstimation`](@extref `ManifoldsBase.GradientDescentEstimation`).

Optionally, provide `p0`, the starting point (by default set to the first data
point). `stop_iter` denotes the maximal number of iterations to perform and the
`kwargs...` are passed to [`isapprox`](@extref `Base.isapprox-Tuple{AbstractManifold, Any, Any, Any}`) to stop, when the minimal change
between two iterates is small. For more stopping criteria check the
[`Manopt.jl`](https://manoptjl.org) package and use a solver therefrom.

Optionally, pass `retraction` and `inverse_retraction` method types to specify
the (inverse) retraction.

The Theory stems from [Karcher:1977](@cite) and is also described in [PennecArsigny:2012](@cite)
as the exponential barycenter.
The algorithm is further described in[AfsariTronVidal:2013](@cite).
"""
mean(::AbstractManifold, ::Any...)

#
# dispatch on method first to allow Euclidean defaults to hit
function Statistics.mean(M::AbstractManifold, x::AbstractVector, kwargs...)
    return mean(M, x, default_approximation_method(M, mean, eltype(x)); kwargs...)
end
function Statistics.mean(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractVector,
        kwargs...,
    )
    return mean(M, x, w, default_approximation_method(M, mean, eltype(x)); kwargs...)
end

function Statistics.mean(
        M::AbstractManifold,
        x::AbstractVector,
        method::AbstractApproximationMethod;
        kwargs...,
    )
    y = allocate_result(M, mean, x[1])
    return mean!(M, y, x, method; kwargs...)
end
function Statistics.mean(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractVector,
        method::AbstractApproximationMethod;
        kwargs...,
    )
    y = allocate_result(M, mean, x[1])
    return mean!(M, y, x, w, method; kwargs...)
end

@doc raw"""
    mean!(M::AbstractManifold, y, x::AbstractVector[, w::AbstractWeights]; kwargs...)
    mean!(
        M::AbstractManifold,
        y,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::AbstractApproximationMethod;
        kwargs...,
    )

Compute the [`mean`](@ref mean(::AbstractManifold, args...)) in-place in `y`.
"""
mean!(::AbstractManifold, ::Any...)

function Statistics.mean!(
        M::AbstractManifold,
        y,
        x::AbstractVector,
        method::AbstractApproximationMethod = default_approximation_method(M, mean);
        kwargs...,
    )
    w = _unit_weights(length(x))
    return mean!(M, y, x, w, method; kwargs...)
end
function Statistics.mean!(
        M::AbstractManifold,
        y,
        x::AbstractVector,
        w::AbstractVector,
        ::GradientDescentEstimation;
        p0 = x[1],
        stop_iter = 100,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
            ),
        )
    end
    copyto!(y, p0)
    yold = allocate_result(M, mean, y)
    v = zero_vector(M, y)
    vtmp = copy(v)
    α = w ./ cumsum(w)
    for _ in 1:stop_iter
        copyto!(yold, y)
        # Online weighted mean
        @inbounds inverse_retract!(M, v, yold, x[1], inverse_retraction)
        @inbounds for j in 2:n
            iszero(w[j]) && continue
            inverse_retract!(M, vtmp, yold, x[j], inverse_retraction)
            v .+= α[j] .* (vtmp .- v)
        end
        retract_fused!(M, y, yold, v, 0.5, retraction)
        isapprox(M, y, yold; kwargs...) && break
    end
    return y
end

"""
    mean(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::GeodesicInterpolation;
        shuffle_rng=nothing,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, eltype(x)),
        kwargs...,
    )

Estimate the Riemannian center of mass of `x` in an online fashion using
repeated weighted geodesic interpolation. See
[`GeodesicInterpolation`](@extref `ManifoldsBase.GeodesicInterpolation`) for details.

If `shuffle_rng` is provided, it is used to shuffle the order in which the
points are considered for computing the mean.

Optionally, pass `retraction` and `inverse_retraction` method types to specify
the (inverse) retraction.
"""
mean(::AbstractManifold, ::AbstractVector, ::AbstractVector, ::GeodesicInterpolation)

function Statistics.mean!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        w::AbstractVector,
        ::GeodesicInterpolation;
        shuffle_rng::Union{AbstractRNG, Nothing} = nothing,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    (length(w) != n) && throw(
        DimensionMismatch(
            "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
        ),
    )
    order = shuffle_rng === nothing ? (1:n) : shuffle(shuffle_rng, 1:n)
    @inbounds begin
        j = order[1]
        s = w[j]
        copyto!(q, x[j])
    end
    v = zero_vector(M, q)
    ytmp = allocate_result(M, mean, q)
    @inbounds for i in 2:n
        iszero(w[i]) && continue
        j = order[i]
        s += w[j]
        t = w[j] / s
        inverse_retract!(M, v, q, x[j], inverse_retraction)
        retract_fused!(M, ytmp, q, v, t, retraction)
        copyto!(q, ytmp)
    end
    return q
end

"""
    mean(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::GeodesicInterpolationWithinRadius;
        kwargs...,
    )

Estimate the Riemannian center of mass of `x` using
[`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).

See [`mean`](@ref mean(::AbstractManifold, ::AbstractVector, ::AbstractVector, ::GeodesicInterpolation))
for a description of `kwargs`.
"""
Statistics.mean(
    ::AbstractManifold,
    ::AbstractVector,
    ::AbstractVector,
    ::GeodesicInterpolationWithinRadius,
)

function Statistics.mean!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        w::AbstractVector,
        method::GeodesicInterpolationWithinRadius;
        shuffle_rng = nothing,
        kwargs...,
    )
    mean!(M, q, x, w, GeodesicInterpolation(); shuffle_rng = shuffle_rng, kwargs...)
    radius = method.radius
    injectivity_radius(M, q) ≤ radius && return q
    for i in eachindex(x)
        @inbounds if distance(M, q, x[i]) ≥ radius
            return mean!(M, q, x, w, GradientDescentEstimation(); p0 = q, kwargs...)
        end
    end
    return q
end
function Statistics.mean!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        w::AbstractVector,
        ::CyclicProximalPointEstimation;
        p0 = x[1],
        stop_iter = 1000000,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
            ),
        )
    end
    copyto!(q, p0)
    yold = allocate_result(M, mean, q)
    ytmp = copy(yold)
    X = zero_vector(M, q)
    wv = convert(AbstractVector, w) ./ sum(w)
    for i in 1:stop_iter
        λ = 0.5 / i
        copyto!(yold, q)
        for j in 1:n
            @inbounds t = (2 * λ * wv[j]) / (1 + 2 * λ * wv[j])
            @inbounds inverse_retract!(M, X, q, x[j], inverse_retraction)
            retract_fused!(M, ytmp, q, X, t, retraction)
            copyto!(q, ytmp)
        end
        isapprox(M, q, yold; kwargs...) && break
    end
    return q
end

"""
    mean(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::ExtrinsicEstimation;
        kwargs...,
    )

Estimate the Riemannian center of mass of `x` using
[`ExtrinsicEstimation`](@extref `ManifoldsBase.ExtrinsicEstimation`), i.e. by computing the mean in the embedding and projecting
the result back.

See [`mean`](@ref mean(::AbstractManifold, ::AbstractVector, ::AbstractVector, ::GeodesicInterpolation))
for a description of the remaining `kwargs`.
"""
Statistics.mean(
    ::AbstractManifold,
    ::AbstractVector,
    ::AbstractVector,
    ::ExtrinsicEstimation,
)

function Statistics.mean!(
        M::AbstractManifold,
        y,
        x::AbstractVector{P},
        w::AbstractVector,
        e::ExtrinsicEstimation;
        kwargs...,
    ) where {P}
    embedded_x = map(p -> embed(M, p), x)
    embedded_y = mean(get_embedding(M, P), embedded_x, w, e.extrinsic_estimation; kwargs...)
    project!(M, y, embedded_y)
    return y
end

function default_approximation_method(
        ::StopForwardingType,
        ::AbstractManifold,
        ::typeof(mean),
    )
    return GradientDescentEstimation()
end;
function default_approximation_method(::AbstractManifold, ::typeof(mean))
    return GradientDescentEstimation()
end;

@doc raw"""
    median(M::AbstractManifold, x::AbstractVector[, w::AbstractWeights]; kwargs...)
    median(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::AbstractApproximationMethod;
        kwargs...,
    )

Compute the (optionally weighted) Riemannian median of the vector `x` of points on the
[`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`, defined as the point that satisfies the minimizer
````math
\operatorname{argmin}_{y ∈ \mathcal M} \frac{1}{\sum_{i=1}^n w_i} \sum_{i=1}^n w_i\mathrm{d}_{\mathcal M}(y,x_i),
````
where ``\mathrm{d}_{\mathcal M}`` denotes the Riemannian [`distance`](@ref).
This function is nonsmooth (i.e nondifferentiable).

In the general case, the [`CyclicProximalPointEstimation`](@extref `ManifoldsBase.CyclicProximalPointEstimation`) is used to compute the
median. However, this default may be overloaded for specific manifolds.

Compute the median using the specified `method`.
"""
Statistics.median(::AbstractManifold, ::Any...)

function default_approximation_method(
        ::StopForwardingType,
        ::AbstractDecoratorManifold,
        ::typeof(median),
    )
    return CyclicProximalPointEstimation()
end
function default_approximation_method(::AbstractManifold, ::typeof(median))
    return CyclicProximalPointEstimation()
end

"""
    median(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::CyclicProximalPointEstimation;
        p0=x[1],
        stop_iter=1000000,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x),),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, eltype(x),),
        kwargs...,
    )

Compute the median using [`CyclicProximalPointEstimation`](@extref `ManifoldsBase.CyclicProximalPointEstimation`).

Optionally, provide `p0`, the starting point (by default set to the first
data point). `stop_iter` denotes the maximal number of iterations to perform
and the `kwargs...` are passed to [`isapprox`](@extref `Base.isapprox-Tuple{AbstractManifold, Any, Any, Any}`) to stop, when the minimal
change between two iterates is small. For more stopping criteria check the
[`Manopt.jl`](https://manoptjl.org) package and use a solver therefrom.

Optionally, pass `retraction` and `inverse_retraction` method types to specify
the (inverse) retraction.

The algorithm is further described in [Bacak:2014](@cite).


"""
Statistics.median(
    ::AbstractManifold,
    ::AbstractVector,
    ::AbstractVector,
    ::CyclicProximalPointEstimation,
)

"""
    median(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::ExtrinsicEstimation;
        kwargs...,
    )

Estimate the median of `x` using [`ExtrinsicEstimation`](@extref `ManifoldsBase.ExtrinsicEstimation`), i.e. by computing the median
in the embedding and projecting the result back.

See [`median`](@ref median(::AbstractManifold, ::AbstractVector, ::AbstractVector, ::CyclicProximalPointEstimation))
for a description of `kwargs`.
"""
Statistics.median(
    ::AbstractManifold,
    ::AbstractVector,
    ::AbstractVector,
    ::ExtrinsicEstimation,
)

@doc raw"""
    median(
        M::AbstractManifold,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::WeiszfeldEstimation;
        α = 1.0,
        p0=x[1],
        stop_iter=2000,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, eltype(x)),
        kwargs...,
    )

Compute the median using [`WeiszfeldEstimation`](@extref `ManifoldsBase.WeiszfeldEstimation`).

Optionally, provide `p0`, the starting point (by default set to the first
data point). `stop_iter` denotes the maximal number of iterations to perform
and the `kwargs...` are passed to [`isapprox`](@extref `Base.isapprox-Tuple{AbstractManifold, Any, Any, Any}`) to stop, when the minimal
change between two iterates is small. For more stopping criteria check the
[`Manopt.jl`](https://manoptjl.org) package and use a solver therefrom.

The parameter ``α\in (0,2]`` is a step size.

The algorithm is further described in [FletcherVenkatasubramanianJoshi:2008](@cite),
especially the update rule in Eq. (6), i.e. Let ``q_{k}`` denote the current
iterate, ``n`` the number of points ``x_1,\ldots,x_n``, and

```math
I_k = \bigl\{ i \in \{1,\ldots,n\} \big| x_i \neq q_k \bigr\}
```

all indices of points that are not equal to the current iterate. Then the update reads
``q_{k+1} = \exp_{q_k}(αX)``, where

```math
X = \frac{1}{s}\sum_{i\in I_k} \frac{w_i}{d_{\mathcal M}(q_k,x_i)}\log_{q_k}x_i
\quad
\text{ with }
\quad
s = \sum_{i\in I_k} \frac{w_i}{d_{\mathcal M}(q_k,x_i)},
```

and where ``\mathrm{d}_{\mathcal M}`` denotes the Riemannian [`distance`](@ref).

Optionally, pass `retraction` and `inverse_retraction` method types to specify
the (inverse) retraction, which by default use the exponential and logarithmic map,
respectively.
"""
Statistics.median(
    ::AbstractManifold,
    ::AbstractVector,
    ::AbstractVector,
    ::WeiszfeldEstimation,
)

#
# dispatch on the method first before allocating to allow Euclidean defaults to hit
function Statistics.median(M::AbstractManifold, x::AbstractVector; kwargs...)
    return median(M, x, default_approximation_method(M, median, eltype(x)))
end
function Statistics.median(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractVector;
        kwargs...,
    )
    return median(M, x, w, default_approximation_method(M, median, eltype(x)))
end

function Statistics.median(
        M::AbstractManifold,
        x::AbstractVector,
        method::AbstractApproximationMethod;
        kwargs...,
    )
    y = allocate_result(M, median, x[1])
    return median!(M, y, x, method; kwargs...)
end
function Statistics.median(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractVector,
        method::AbstractApproximationMethod;
        kwargs...,
    )
    y = allocate_result(M, median, x[1])
    return median!(M, y, x, w, method; kwargs...)
end

@doc raw"""
    median!(M::AbstractManifold, y, x::AbstractVector[, w::AbstractWeights]; kwargs...)
    median!(
        M::AbstractManifold,
        y,
        x::AbstractVector,
        [w::AbstractWeights,]
        method::AbstractApproximationMethod;
        kwargs...,
    )

computes the [`median`](@ref) in-place in `y`.
"""
median!(::AbstractManifold, ::Any...)
function Statistics.median!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        method::AbstractApproximationMethod = default_approximation_method(M, median, eltype(x));
        kwargs...,
    )
    w = _unit_weights(length(x))
    return median!(M, q, x, w, method; kwargs...)
end
function Statistics.median!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        w::AbstractVector,
        ::CyclicProximalPointEstimation;
        p0 = x[1],
        stop_iter = 1000000,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the median ($(n)).",
            ),
        )
    end
    copyto!(q, p0)
    yold = allocate_result(M, median, q)
    ytmp = copy(yold)
    v = zero_vector(M, q)
    wv = convert(AbstractVector, w) ./ sum(w)
    for i in 1:stop_iter
        λ = 0.5 / i
        copyto!(yold, q)
        for j in 1:n
            @inbounds t = min(λ * wv[j] / distance(M, q, x[j]), 1.0)
            @inbounds inverse_retract!(M, v, q, x[j], inverse_retraction)
            retract_fused!(M, ytmp, q, v, t, retraction)
            copyto!(q, ytmp)
        end
        isapprox(M, q, yold; kwargs...) && break
    end
    return q
end

function Statistics.median!(
        M::AbstractManifold,
        y,
        x::AbstractVector{P},
        w::AbstractVector,
        e::ExtrinsicEstimation;
        kwargs...,
    ) where {P}
    embedded_x = map(p -> embed(M, p), x)
    embedded_y = median(get_embedding(M, P), embedded_x, w, e.extrinsic_estimation; kwargs...)
    project!(M, y, embedded_y)
    return y
end

function Statistics.median!(
        M::AbstractManifold,
        q,
        x::AbstractVector,
        w::AbstractVector,
        ::WeiszfeldEstimation;
        p0 = x[1],
        stop_iter = 2000,
        α = 1.0,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the median ($(n)).",
            ),
        )
    end
    copyto!(q, p0)
    yold = allocate_result(M, median, q)
    ytmp = copy(yold)
    d = zeros(n)
    v = zero_vector(M, q)
    wv = convert(AbstractVector, w) ./ sum(w)
    for i in 1:stop_iter
        d .= [distance(M, q, xi) for xi in x] # compute distances
        # compute new weights / exclude points xi=q
        d .= [di > 0 ? wi / di : zero(typeof(wi / di)) for (di, wi) in zip(d, w)]
        copyto!(yold, q)
        zero_vector!(M, v, q)
        for j in 1:n
            @inbounds v .+= d[j] * inverse_retract(M, q, x[j], inverse_retraction)
        end
        retract_fused!(M, ytmp, q, v, α / sum(d), retraction)
        copyto!(q, ytmp)
        isapprox(M, q, yold; kwargs...) && break
    end
    return q
end

@doc raw"""
    var(M, x, m=mean(M, x); corrected=true)
    var(M, x, w::AbstractWeights, m=mean(M, x, w); corrected=false)

compute the (optionally weighted) variance of a `Vector` `x` of `n` data points
on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`, i.e.

````math
\frac{1}{c} \sum_{i=1}^n w_i d_{\mathcal M}^2 (x_i,m),
````
where `c` is a correction term, see
[Statistics.var](https://juliastats.org/StatsBase.jl/stable/scalarstats/#Statistics.var).
The mean of `x` can be specified as `m`, and the corrected variance
can be activated by setting `corrected=true`. All further `kwargs...` are passed
to the computation of the mean (if that is not provided).
"""
var(::AbstractManifold, ::Any)
function Statistics.var(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractWeights,
        m;
        corrected::Bool = false,
    )
    wv = convert(AbstractVector, w)
    s = sum(eachindex(x, w)) do i
        return @inbounds w[i] * distance(M, m, x[i])^2
    end
    c = StatsBase.varcorrection(w, corrected)
    return c * s
end
function Statistics.var(M::AbstractManifold, x::AbstractVector, m; corrected::Bool = true)
    n = length(x)
    w = _unit_weights(n)
    return var(M, x, w, m; corrected = corrected)
end
function Statistics.var(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractWeights;
        kwargs...,
    )
    return mean_and_var(M, x, w; kwargs...)[2]
end
function Statistics.var(M::AbstractManifold, x::AbstractVector; kwargs...)
    return mean_and_var(M, x; kwargs...)[2]
end

@doc raw"""
    std(M, x, m=mean(M, x); corrected=true, kwargs...)
    std(M, x, w::AbstractWeights, m=mean(M, x, w); corrected=false, kwargs...)

compute the optionally weighted standard deviation of a `Vector` `x` of `n` data
points on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M`, i.e.

````math
\sqrt{\frac{1}{c} \sum_{i=1}^n w_i d_{\mathcal M}^2 (x_i,m)},
````
where `c` is a correction term, see
[Statistics.std](https://juliastats.org/StatsBase.jl/stable/scalarstats/#Statistics.std).
The mean of `x` can be specified as `m`, and the corrected variance
can be activated by setting `corrected=true`.
"""
Statistics.std(M::AbstractManifold, args...; kwargs...) = sqrt(var(M, args...; kwargs...))

@doc raw"""
    mean_and_var(M::AbstractManifold, x::AbstractVector[, w::AbstractWeights]; kwargs...) -> (mean, var)

Compute the [`mean`](@ref mean(::AbstractManifold, args...)) and the [`var`](@ref)iance
simultaneously. See those functions for a description of the arguments.

    mean_and_var(
        M::AbstractManifold,
        x::AbstractVector
        [w::AbstractWeights,]
        method::AbstractApproximationMethod;
        kwargs...,
    ) -> (mean, var)

Use the `method` for simultaneously computing the mean and variance. To use
a mean-specific method, call [`mean`](@ref mean(::AbstractManifold, args...)) and then
[`var`](@ref).
"""
mean_and_var(M::AbstractManifold, ::Any...)
function StatsBase.mean_and_var(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractWeights,
        method::AbstractApproximationMethod = default_approximation_method(M, mean, eltype(x));
        corrected = false,
        kwargs...,
    )
    m = mean(M, x, w, method; kwargs...)
    v = var(M, x, w, m; corrected = corrected)
    return m, v
end
function StatsBase.mean_and_var(
        M::AbstractManifold,
        x::AbstractVector,
        method::AbstractApproximationMethod = default_approximation_method(
            M,
            mean_and_var,
            eltype(x),
        );
        corrected = true,
        kwargs...,
    )
    n = length(x)
    w = _unit_weights(n)
    return mean_and_var(M, x, w, method; corrected = corrected, kwargs...)
end
function default_approximation_method(
        ::StopForwardingType,
        M::AbstractDecoratorManifold,
        ::typeof(mean_and_var),
    )
    return default_approximation_method(M, mean)
end
function default_approximation_method(M::AbstractManifold, ::typeof(mean_and_var))
    return default_approximation_method(M, mean)
end

@doc raw"""
    mean_and_var(
        M::AbstractManifold,
        x::AbstractVector
        [w::AbstractWeights,]
        method::GeodesicInterpolation;
        shuffle_rng::Union{AbstractRNG,Nothing} = nothing,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, eltype(x)),
        kwargs...,
    ) -> (mean, var)

Use the repeated weighted geodesic interpolation to estimate the mean.
Simultaneously, use a Welford-like recursion to estimate the variance.

If `shuffle_rng` is provided, it is used to shuffle the order in which the
points are considered. Optionally, pass `retraction` and `inverse_retraction`
method types to specify the (inverse) retraction.

See [`GeodesicInterpolation`](@extref `ManifoldsBase.GeodesicInterpolation`) for details on the geodesic
interpolation method.

!!! note
    The Welford algorithm for the variance is experimental and is not guaranteed
    to give accurate results except on [`Euclidean`](@ref).
"""
function StatsBase.mean_and_var(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractWeights,
        ::GeodesicInterpolation;
        shuffle_rng::Union{AbstractRNG, Nothing} = nothing,
        corrected = false,
        retraction::AbstractRetractionMethod = default_retraction_method(M, eltype(x)),
        inverse_retraction::AbstractInverseRetractionMethod = default_inverse_retraction_method(
            M,
            eltype(x),
        ),
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
            ),
        )
    end
    order = shuffle_rng === nothing ? (1:n) : shuffle(shuffle_rng, 1:n)
    @inbounds begin
        j = order[1]
        s = w[j]
        y = copy(x[j])
    end
    v = zero_vector(M, y)
    M₂ = zero(number_eltype(v))
    ytmp = allocate_result(M, mean, y)
    @inbounds for i in 2:n
        j = order[i]
        snew = s + w[j]
        t = w[j] / snew
        inverse_retract!(M, v, y, x[j], inverse_retraction)
        retract_fused!(M, ytmp, y, v, t, retraction)
        d = norm(M, y, v)
        copyto!(y, ytmp)
        M₂ += t * s * d^2
        s = snew
    end
    c = StatsBase.varcorrection(w, corrected)
    σ² = c * M₂
    return y, σ²
end

"""
    mean_and_var(
        M::AbstractManifold,
        x::AbstractVector
        [w::AbstractWeights,]
        method::GeodesicInterpolationWithinRadius;
        kwargs...,
    ) -> (mean, var)

Use repeated weighted geodesic interpolation to estimate the mean.
Simultaneously, use a Welford-like recursion to estimate the variance.

See [`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`) and
[`mean_and_var`](@ref mean_and_var(::AbstractManifold, ::AbstractVector, ::AbstractWeights, ::GeodesicInterpolation))
for more information.
"""
function StatsBase.mean_and_var(
        M::AbstractManifold,
        x::AbstractVector,
        w::AbstractWeights,
        method::GeodesicInterpolationWithinRadius;
        shuffle_rng = nothing,
        corrected = false,
        kwargs...,
    )
    y, v = mean_and_var(
        M,
        x,
        w,
        GeodesicInterpolation();
        shuffle_rng = shuffle_rng,
        corrected = corrected,
        kwargs...,
    )
    radius = method.radius
    injectivity_radius(M, y) ≤ radius && return y, v
    for i in eachindex(x)
        @inbounds if distance(M, y, x[i]) ≥ radius
            mean!(M, y, x, w, GradientDescentEstimation(); p0 = y, kwargs...)
            v = var(M, x, w, y; corrected = corrected)
            return y, v
        end
    end
    return y, v
end

@doc raw"""
    mean_and_std(M::AbstractManifold, x::AbstractVector[, w::AbstractWeights]; kwargs...) -> (mean, std)

Compute the [`mean`](@ref mean(::AbstractManifold, args...)) and the standard deviation
[`std`](@ref) simultaneously.

    mean_and_std(
        M::AbstractManifold,
        x::AbstractVector
        [w::AbstractWeights,]
        method::AbstractApproximationMethod;
        kwargs...,
    ) -> (mean, var)

Use the `method` for simultaneously computing the mean and standard deviation.
To use a mean-specific method, call [`mean`](@ref mean(::AbstractManifold, args...)) and
then [`std`](@ref).
"""
function StatsBase.mean_and_std(M::AbstractManifold, args...; kwargs...)
    m, v = mean_and_var(M, args...; kwargs...)
    return m, sqrt(v)
end
function default_approximation_method(M::AbstractManifold, ::typeof(mean_and_std))
    return default_approximation_method(M, mean)
end

"""
    moment(M::AbstractManifold, x::AbstractVector, k::Int[, w::AbstractWeights], m=mean(M, x[, w]))

Compute the `k`th central moment of points in `x` on manifold `M`. Optionally
provide weights `w` and/or a precomputed
[`mean`](@ref mean(::AbstractManifold, args...)).
"""
function StatsBase.moment(
        M::AbstractManifold,
        x::AbstractVector,
        k::Int,
        w::AbstractWeights,
        m = mean(M, x, w),
    )
    s = sum(eachindex(x, w)) do i
        return @inbounds w[i] * distance(M, m, x[i])^k
    end
    return s / sum(w)
end
function StatsBase.moment(M::AbstractManifold, x::AbstractVector, k::Int, m = mean(M, x))
    w = _unit_weights(length(x))
    return moment(M, x, k, w, m)
end

"""
    skewness(M::AbstractManifold, x::AbstractVector, k::Int[, w::AbstractWeights], m=mean(M, x[, w]))

Compute the standardized skewness of points in `x` on manifold `M`. Optionally
provide weights `w` and/or a precomputed
[`mean`](@ref mean(::AbstractManifold, args...)) `m`.
"""
function StatsBase.skewness(M::AbstractManifold, x::AbstractVector, w::AbstractWeights)
    m, s = mean_and_std(M, x, w; corrected = false)
    return moment(M, x, 3, w, m) / s^3
end
function StatsBase.skewness(M::AbstractManifold, x::AbstractVector, w::AbstractWeights, m)
    return moment(M, x, 3, w, m) / std(M, x, w, m; corrected = false)^3
end
function StatsBase.skewness(M::AbstractManifold, x::AbstractVector, args...)
    w = _unit_weights(length(x))
    return skewness(M, x, w, args...)
end

"""
    kurtosis(M::AbstractManifold, x::AbstractVector, k::Int[, w::AbstractWeights], m=mean(M, x[, w]))

Compute the excess kurtosis of points in `x` on manifold `M`. Optionally
provide weights `w` and/or a precomputed
[`mean`](@ref mean(::AbstractManifold, args...)) `m`.
"""
function StatsBase.kurtosis(M::AbstractManifold, x::AbstractVector, w::AbstractWeights)
    m, v = mean_and_var(M, x, w; corrected = false)
    return moment(M, x, 4, w, m) / v^2 - 3
end
function StatsBase.kurtosis(M::AbstractManifold, x::AbstractVector, w::AbstractWeights, m)
    return moment(M, x, 4, w, m) / var(M, x, w, m; corrected = false)^2 - 3
end
function StatsBase.kurtosis(M::AbstractManifold, x::AbstractVector, args...)
    w = _unit_weights(length(x))
    return kurtosis(M, x, w, args...)
end

for mf in [mean, median, cov, var, mean_and_std, mean_and_var]
    @eval @trait_function default_approximation_method(
        M::AbstractDecoratorManifold,
        f::typeof($mf),
    )
    eval(
        quote
            function ManifoldsBase.get_forwarding_type_embedding(
                    ::ManifoldsBase.EmbeddedSubmanifoldType{ManifoldsBase.DirectEmbedding},
                    M::AbstractDecoratorManifold, ::typeof($mf),
                )
                return ManifoldsBase.EmbeddedForwardingType()
            end
            function ManifoldsBase.get_forwarding_type_embedding(
                    ::ManifoldsBase.EmbeddedSubmanifoldType{ManifoldsBase.IndirectEmbedding},
                    M::AbstractDecoratorManifold, ::typeof($mf),
                )
                return ManifoldsBase.EmbeddedForwardingType(ManifoldsBase.DirectEmbedding())
            end
        end,
    )
end

#
# decorate default method for a few functions
# TODO: Check how to “ask” the embedding for default approx methods, when it exists,
# for the functions [mean, median, cov, var, mean_and_std, mean_and_var]
@trait_function Statistics.mean(M::AbstractDecoratorManifold, x::AbstractVector)

@doc raw"""
    change_representer(M::Hyperbolic, ::EuclideanMetric, p::PoincareBallPoint, X::PoincareBallTangentVector)

Since in the metric we have the term `` α = \frac{2}{1-\sum_{i=1}^n p_i^2}`` per element,
the correction for the gradient reads `` Y = \frac{1}{α^2}X``.
"""
change_representer(
    ::Hyperbolic,
    ::EuclideanMetric,
    ::PoincareBallPoint,
    ::PoincareBallTangentVector,
)

function change_representer!(
        ::Hyperbolic,
        Y::PoincareBallTangentVector,
        ::EuclideanMetric,
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
    )
    α = 2 / (1 - norm(p.value)^2)
    Y.value .= X.value ./ α^2
    return Y
end

@doc raw"""
    change_metric(M::Hyperbolic, ::EuclideanMetric, p::PoincareBallPoint, X::PoincareBallTangentVector)

Since in the metric we always have the term `` α = \frac{2}{1-\sum_{i=1}^n p_i^2}`` per element,
the correction for the metric reads ``Z = \frac{1}{α}X``.
"""
change_metric(
    ::Hyperbolic,
    ::EuclideanMetric,
    ::PoincareBallPoint,
    ::PoincareBallTangentVector,
)

function change_metric!(
        ::Hyperbolic,
        Y::PoincareBallTangentVector,
        ::EuclideanMetric,
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
    )
    α = 2 / (1 - norm(p.value)^2)
    Y.value .= X.value ./ α
    return Y
end

function check_point(M::Hyperbolic, p::PoincareBallPoint; kwargs...)
    if !(norm(p.value) < 1)
        return DomainError(
            norm(p.value),
            "The point $(p) does not lie on $(M) since its norm is not less than 1.",
        )
    end
end

function check_size(M::Hyperbolic, p::PoincareBallPoint)
    N = get_parameter(M.size)[1]
    if size(p.value, 1) != N
        !(norm(p.value) < 1)
        return DomainError(
            size(p.value, 1),
            "The point $p does not lie on $M since its length is not $N.",
        )
    end
end

function check_size(
        M::Hyperbolic,
        p::PoincareBallPoint,
        X::PoincareBallTangentVector;
        kwargs...,
    )
    N = get_parameter(M.size)[1]
    if size(X.value, 1) != N
        return DomainError(
            size(X.value, 1),
            "The tangent vector $X can not be a tangent vector for $M since its length is not $N.",
        )
    end
end

@doc raw"""
    convert(::Type{PoincareBallPoint}, p::HyperboloidPoint)
    convert(::Type{PoincareBallPoint}, p::T) where {T<:AbstractVector}

convert a [`HyperboloidPoint`](@ref) ``p∈ℝ^{n+1}`` from the hyperboloid model of the [`Hyperbolic`](@ref)
manifold ``\mathcal H^n`` to a [`PoincareBallPoint`](@ref) ``π(p)∈ℝ^{n}`` in the Poincaré ball model.
The isometry is defined by

````math
π(p) = \frac{1}{1+p_{n+1}} \begin{pmatrix}p_1\\⋮\\p_n\end{pmatrix}
````

Note that this is also used, when `x` is a vector.
"""
convert(::Type{PoincareBallPoint}, ::Any)
function convert(t::Type{PoincareBallPoint}, p::HyperboloidPoint)
    return convert(t, p.value)
end
function convert(::Type{PoincareBallPoint}, p::T) where {T <: AbstractVector}
    return PoincareBallPoint(1 / (1 + last(p)) .* p[1:(end - 1)])
end

@doc raw"""
    convert(::Type{PoincareBallPoint}, p::PoincareHalfSpacePoint)

convert a point [`PoincareHalfSpacePoint`](@ref) `p` (from ``ℝ^n``) from the
Poincaré half plane model of the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` to a [`PoincareBallPoint`](@ref) ``π(p) ∈ ℝ^n``.
Denote by ``\tilde p = (p_1,\ldots,p_{d-1})^{\mathrm{T}}``. Then the isometry is defined by

````math
π(p) = \frac{1}{\lVert \tilde p \rVert^2 + (p_n+1)^2}
\begin{pmatrix}2p_1\\⋮\\2p_{n-1}\\\lVert p\rVert^2 - 1\end{pmatrix}.
````
"""
function convert(::Type{PoincareBallPoint}, p::PoincareHalfSpacePoint)
    return PoincareBallPoint(
        1 / (norm(p.value[1:(end - 1)])^2 + (last(p.value) + 1)^2) .*
            vcat(2 .* p.value[1:(end - 1)], norm(p.value)^2 - 1),
    )
end

@doc raw"""
    convert(::Type{PoincareBallTangentVector}, p::HyperboloidPoint, X::HyperboloidTangentVector)
    convert(::Type{PoincareBallTangentVector}, p::P, X::T) where {P<:AbstractVector, T<:AbstractVector}

convert a [`HyperboloidTangentVector`](@ref) `X` at `p` to a [`PoincareBallTangentVector`](@ref)
on the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` by computing the push forward ``π_*(p)[X]`` of
the isometry ``π`` that maps from the Hyperboloid to the Poincaré ball,
cf. [`convert(::Type{PoincareBallPoint}, ::HyperboloidPoint)`](@ref).

The formula reads

````math
π_*(p)[X] = \frac{1}{p_{n+1}+1}\Bigl(\tilde X - \frac{X_{n+1}}{p_{n+1}+1}\tilde p \Bigl),
````

where ``\tilde X = \begin{pmatrix}X_1\\⋮\\X_n\end{pmatrix}``
and ``\tilde p = \begin{pmatrix}p_1\\⋮\\p_n\end{pmatrix}``.
"""
convert(::Type{PoincareBallTangentVector}, ::Any)
function convert(
        t::Type{PoincareBallTangentVector},
        p::HyperboloidPoint,
        X::HyperboloidTangentVector,
    )
    return convert(t, convert(AbstractVector, p), convert(AbstractVector, p, X))
end
function convert(
        ::Type{PoincareBallTangentVector},
        p::P,
        X::T,
    ) where {P <: AbstractVector, T <: AbstractVector}
    return PoincareBallTangentVector(
        1 / (p[end] + 1) .* (X[1:(end - 1)] .- (X[end] / (p[end] + 1) .* p[1:(end - 1)])),
    )
end

@doc raw"""
    convert(
        ::Type{Tuple{PoincareBallPoint,PoincareBallTangentVector}},
        (p,X)::Tuple{HyperboloidPoint,HyperboloidTangentVector}
    )
    convert(
        ::Type{Tuple{PoincareBallPoint,PoincareBallTangentVector}},
        (p, X)::Tuple{P,T},
    ) where {P<:AbstractVector, T <: AbstractVector}

Convert a [`HyperboloidPoint`](@ref) `p` and a [`HyperboloidTangentVector`](@ref) `X`
to a [`PoincareBallPoint`](@ref) and a [`PoincareBallTangentVector`](@ref) simultaneously,
see [`convert(::Type{PoincareBallPoint}, ::HyperboloidPoint)`](@ref) and
[`convert(::Type{PoincareBallTangentVector}, ::HyperboloidPoint, ::HyperboloidTangentVector)`](@ref)
for the formulae.
"""
function convert(
        ::Type{Tuple{PoincareBallPoint, PoincareBallTangentVector}},
        (p, X)::Tuple{HyperboloidPoint, HyperboloidTangentVector},
    )
    return (convert(PoincareBallPoint, p), convert(PoincareBallTangentVector, p, X))
end
function convert(
        ::Type{Tuple{PoincareBallPoint, PoincareBallTangentVector}},
        (p, X)::Tuple{P, T},
    ) where {P <: AbstractVector, T <: AbstractVector}
    return (convert(PoincareBallPoint, p), convert(PoincareBallTangentVector, p, X))
end

@doc raw"""
    convert(
        ::Type{PoincareBallTangentVector},
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector
    )

convert a [`PoincareHalfSpaceTangentVector`](@ref) `X` at `p` to a [`PoincareBallTangentVector`](@ref)
on the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` by computing the push forward ``π_*(p)[X]`` of
the isometry ``π`` that maps from the Poincaré half space to the Poincaré ball,
cf. [`convert(::Type{PoincareBallPoint}, ::PoincareHalfSpacePoint)`](@ref).

The formula reads

````math
π_*(p)[X] =
\frac{1}{\lVert \tilde p\rVert^2 + (1+p_n)^2}
\begin{pmatrix}
2X_1\\
⋮\\
2X_{n-1}\\
2⟨X,p⟩
\end{pmatrix}
-
\frac{2}{(\lVert \tilde p\rVert^2 + (1+p_n)^2)^2}
\begin{pmatrix}
2p_1(⟨X,p⟩+X_n)\\
⋮\\
2p_{n-1}(⟨X,p⟩+X_n)\\
(\lVert p \rVert^2-1)(⟨X,p⟩+X_n)
\end{pmatrix}
````
where ``\tilde p = \begin{pmatrix}p_1\\⋮\\p_{n-1}\end{pmatrix}``.
"""
function convert(
        ::Type{PoincareBallTangentVector},
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
    )
    den = norm(p.value[1:(end - 1)])^2 + (last(p.value) + 1)^2
    scp = dot(p.value, X.value)
    c1 =
        (2 / den .* X.value[1:(end - 1)]) .-
        (4 * (scp + last(X.value)) / (den^2)) .* p.value[1:(end - 1)]
    c2 = 2 * scp / den - 2 * (norm(p.value)^2 - 1) * (scp + last(X.value)) / (den^2)
    return PoincareBallTangentVector(vcat(c1, c2))
end

@doc raw"""
    convert(
        ::Type{Tuple{PoincareBallPoint,PoincareBallTangentVector}},
        (p,X)::Tuple{HyperboloidPoint,HyperboloidTangentVector}
    )
    convert(
        ::Type{Tuple{PoincareBallPoint,PoincareBallTangentVector}},
        (p, X)::Tuple{T,T},
    ) where {T <: AbstractVector}

Convert a [`PoincareHalfSpacePoint`](@ref) `p` and a [`PoincareHalfSpaceTangentVector`](@ref) `X`
to a [`PoincareBallPoint`](@ref) and a [`PoincareBallTangentVector`](@ref) simultaneously,
see [`convert(::Type{PoincareBallPoint}, ::PoincareHalfSpacePoint)`](@ref) and
[`convert(::Type{PoincareBallTangentVector}, ::PoincareHalfSpacePoint, ::PoincareHalfSpaceTangentVector)`](@ref)
for the formulae.
"""
function convert(
        ::Type{Tuple{PoincareBallPoint, PoincareBallTangentVector}},
        (p, X)::Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector},
    )
    return (convert(PoincareBallPoint, p), convert(PoincareBallTangentVector, p, X))
end

@doc raw"""
    distance(::Hyperbolic, p::PoincareBallPoint, q::PoincareBallPoint)

Compute the distance on the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` represented in the
Poincaré ball model. The formula reads

````math
d_{\mathcal H^n}(p,q) =
\operatorname{acosh}\Bigl(
  1 + \frac{2\lVert p - q \rVert^2}{(1-\lVert p\rVert^2)(1-\lVert q\rVert^2)}
\Bigr)
````
"""
function distance(::Hyperbolic, p::PoincareBallPoint, q::PoincareBallPoint)
    return acosh(
        1 +
            2 * norm(p.value .- q.value)^2 / ((1 - norm(p.value)^2) * (1 - norm(q.value)^2)),
    )
end

embed(::Hyperbolic, p::PoincareBallPoint) = p.value
embed!(::Hyperbolic, q, p::PoincareBallPoint) = copyto!(q, p.value)
embed(::Hyperbolic, p::PoincareBallPoint, X::PoincareBallTangentVector) = X.value
function embed!(::Hyperbolic, Y, p::PoincareBallPoint, X::PoincareBallTangentVector)
    return copyto!(Y, X.value)
end

function get_embedding(::Hyperbolic{TypeParameter{Tuple{n}}}, ::Type{<:PoincareBallPoint}) where {n}
    return Euclidean(n)
end
function get_embedding(M::Hyperbolic{Tuple{Int}}, ::Type{<:PoincareBallPoint})
    n = get_parameter(M.size)[1]
    return Euclidean(n; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Hyperbolic, ::Type{<:PoincareBallPoint})
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

@doc raw"""
    inner(::Hyperbolic, p::PoincareBallPoint, X::PoincareBallTangentVector, Y::PoincareBallTangentVector)

Compute the inner product in the Poincaré ball model. The formula reads
````math
g_p(X,Y) = \frac{4}{(1-\lVert p \rVert^2)^2}  ⟨X, Y⟩ .
````
"""
function inner(
        ::Hyperbolic,
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
        Y::PoincareBallTangentVector,
    )
    return 4 / (1 - norm(p.value)^2)^2 * dot(X.value, Y.value)
end

function norm(M::Hyperbolic, p::PoincareBallPoint, X::PoincareBallTangentVector)
    return sqrt(inner(M, p, X, X))
end

@doc raw"""
    project(::Hyperbolic, ::PoincareBallPoint, ::PoincareBallTangentVector)

projection of tangent vectors in the Poincaré ball model is just the identity, since
the tangent space consists of all ``ℝ^n``.
"""
project(::Hyperbolic, ::PoincareBallPoint, ::PoincareBallTangentVector)

function ManifoldsBase.allocate_result_embedding(
        ::Hyperbolic,
        ::typeof(project),
        X::PoincareBallTangentVector,
        ::PoincareBallPoint,
    )
    return PoincareBallTangentVector(allocate(X.value))
end

function project!(
        ::Hyperbolic,
        Y::PoincareBallTangentVector,
        ::PoincareBallPoint,
        X::PoincareBallTangentVector,
    )
    return (Y.value .= X.value)
end

using StatsBase: AbstractWeights, pweights, SimpleCovariance
using Distributions, RecursiveArrayTools
using Random: GLOBAL_RNG, seed!
using Manifolds, ManifoldsBase, Test, Random, LinearAlgebra
import ManifoldsBase:
    manifold_dimension,
    exp!,
    log!,
    inner,
    zero_vector!,
    decorated_manifold,
    base_manifold,
    get_embedding
using Manifolds: normal_tvector_distribution
import Manifolds:
    cov, mean, mean!, median, median!, var, mean_and_var, default_approximation_method

struct TestStatsSphere{N} <: AbstractManifold{ℝ} end
TestStatsSphere(N) = TestStatsSphere{N}()
manifold_dimension(::TestStatsSphere{N}) where {N} = manifold_dimension(Sphere(N))
function exp!(::TestStatsSphere{N}, q, p, X; kwargs...) where {N}
    return exp!(Sphere(N), q, p, X; kwargs...)
end
function Manifolds.exp_fused!(::TestStatsSphere{N}, q, p, X, t::Number; kwargs...) where {N}
    return Manifolds.exp_fused!(Sphere(N), q, p, X, t; kwargs...)
end
function log!(::TestStatsSphere{N}, X, p, q; kwargs...) where {N}
    return log!(Sphere(N), X, p, q; kwargs...)
end
function inner(::TestStatsSphere{N}, p, X, Y; kwargs...) where {N}
    return inner(Sphere(N), p, X, Y; kwargs...)
end
function zero_vector!(::TestStatsSphere{N}, X, p; kwargs...) where {N}
    return zero_vector!(Sphere(N), X, p; kwargs...)
end

struct TestStatsEuclidean{N} <: AbstractManifold{ℝ} end
TestStatsEuclidean(N) = TestStatsEuclidean{N}()
manifold_dimension(::TestStatsEuclidean{N}) where {N} = manifold_dimension(Euclidean(N))
function exp!(::TestStatsEuclidean{N}, q, p, X; kwargs...) where {N}
    return exp!(Euclidean(N), q, p, X; kwargs...)
end
function Manifolds.exp_fused!(
        ::TestStatsEuclidean{N},
        q,
        p,
        X,
        t::Number;
        kwargs...,
    ) where {N}
    return Manifolds.exp_fused!(Euclidean(N), q, p, X, t; kwargs...)
end
function log!(::TestStatsEuclidean{N}, X, p, q; kwargs...) where {N}
    return log!(Euclidean(N), X, p, q; kwargs...)
end
function inner(::TestStatsEuclidean{N}, p, X, Y; kwargs...) where {N}
    return inner(Euclidean(N), p, X, Y; kwargs...)
end
function zero_vector!(::TestStatsEuclidean{N}, X, p; kwargs...) where {N}
    return zero_vector!(Euclidean(N), X, p; kwargs...)
end

struct TestStatsNotImplementedEmbeddedManifold <: AbstractDecoratorManifold{ℝ} end
decorated_manifold(::TestStatsNotImplementedEmbeddedManifold) = Sphere(2)
get_embedding(::TestStatsNotImplementedEmbeddedManifold) = Sphere(2)
base_manifold(::TestStatsNotImplementedEmbeddedManifold) = Sphere(2)

struct TestStatsNotImplementedManifold <: AbstractDecoratorManifold{ℝ} end

function test_mean(M, x, yexp = nothing, method...; kwargs...)
    @testset "mean unweighted" begin
        y = mean(M, x; kwargs...)
        @test is_point(M, y; atol = 10^-9)
        if yexp !== nothing
            @test isapprox(M, y, yexp; atol = 10^-7)
        end
        y2, _ = mean_and_var(M, x; kwargs...)
        @test isapprox(M, y2, y; atol = 10^-7)
        y3, _ = mean_and_std(M, x; kwargs...)
        @test isapprox(M, y3, y; atol = 10^-7)
    end

    @testset "mean weighted" begin
        n = length(x)
        w1 = pweights(ones(n) / n)
        w2 = pweights(ones(n))
        w3 = pweights(2 * ones(n))
        y = mean(M, x; kwargs...)
        for w in (w1, w2, w3)
            @test is_point(M, mean(M, x, w; kwargs...); atol = 10^-9)
            @test isapprox(M, mean(M, x, w; kwargs...), y)

            @test isapprox(M, mean_and_var(M, x, w; kwargs...)[1], y; atol = 10^-7)
            @test isapprox(M, mean_and_std(M, x, w; kwargs...)[1], y; atol = 10^-7)
        end
        @test_throws DimensionMismatch mean(M, x, pweights(ones(n + 1)); kwargs...)
        @test_throws DimensionMismatch mean!(
            M,
            y,
            x,
            pweights(ones(n + 1)),
            Manifolds.default_approximation_method(M, mean);
            kwargs...,
        )
    end
    return nothing
end

function test_median(
        M,
        x,
        yexp = nothing;
        method::Union{Nothing, AbstractApproximationMethod} = nothing,
        kwargs...,
    )
    @testset "median unweighted$(!isnothing(method) ? " ($method)" : "")" begin
        y = isnothing(method) ? median(M, x; kwargs...) : median(M, x, method; kwargs...)
        @test is_point(M, y; atol = 10^-9)
        if yexp !== nothing
            @test isapprox(M, y, yexp; atol = 5 * 10^-5)
        end
    end

    @testset "median weighted$(!isnothing(method) ? " ($method)" : "")" begin
        n = length(x)
        w1 = pweights(ones(n) / n)
        w2 = pweights(ones(n))
        w3 = pweights(2 * ones(n))
        y = median(M, x; kwargs...)
        for w in (w1, w2, w3)
            if isnothing(method)
                @test is_point(M, median(M, x, w; kwargs...); atol = 10^-9)
            else
                @test is_point(M, median(M, x, w, method; kwargs...); atol = 10^-9)
            end
            @test isapprox(M, median(M, x, w; kwargs...), y; atol = 10^-4)
        end
        if isnothing(method)
            @test_throws Exception median(M, x, pweights(ones(n + 1)); kwargs...)
        else
            @test_throws Exception median(M, x, pweights(ones(n + 1)), method; kwargs...)
        end
    end
    return nothing
end

function test_var(M, x, vexp = nothing; kwargs...)
    n = length(x)
    @testset "var unweighted" begin
        v = var(M, x; kwargs...)
        if vexp !== nothing
            @test v ≈ vexp
        end
        @test v ≈ var(M, x; corrected = true, kwargs...)
        _, v2 = mean_and_var(M, x; kwargs...)
        @test v2 ≈ v
        m = mean(M, x; kwargs...)
        @test var(M, x, m; kwargs...) ≈ var(M, x; kwargs...)
        @test var(M, x; corrected = false, kwargs...) ≈
            var(M, x, m; corrected = false, kwargs...)
        @test var(M, x; corrected = false, kwargs...) ≈ var(M, x; kwargs...) * (n - 1) / n
        @test var(M, x, m; corrected = false, kwargs...) ≈
            var(M, x, m; kwargs...) * (n - 1) / n
    end

    @testset "var weighted" begin
        n = length(x)
        w1 = pweights(ones(n) / n)
        w2 = pweights(ones(n))
        w3 = pweights(2 * ones(n))

        v = var(M, x; corrected = false, kwargs...)
        for w in (w1, w2, w3)
            @test var(M, x, w; kwargs...) ≈ v
            @test var(M, x, w; corrected = false, kwargs...) ≈ v
            @test mean_and_var(M, x, w; kwargs...)[2] ≈ var(M, x, w; kwargs...)
            m = mean(M, x, w; kwargs...)
            @test var(M, x, w, m; kwargs...) ≈ var(M, x, w; kwargs...)
            @test var(M, x, w; corrected = true, kwargs...) ≈
                var(M, x, w, m; corrected = true, kwargs...)
            @test var(M, x, w; corrected = true, kwargs...) ≈
                var(M, x, w; kwargs...) * n / (n - 1)
            @test var(M, x, w, m; corrected = true, kwargs...) ≈
                var(M, x, w, m; kwargs...) * n / (n - 1)
        end
        @test_throws DimensionMismatch var(M, x, pweights(ones(n + 1)); kwargs...)
        @test_throws DimensionMismatch mean_and_var(
            M,
            x,
            pweights(ones(n + 1)),
            GeodesicInterpolation();
            kwargs...,
        )
    end
    return nothing
end

function test_std(M, x, sexp = nothing; kwargs...)
    n = length(x)
    @testset "std unweighted" begin
        s = std(M, x; kwargs...)
        if sexp !== nothing
            @test s ≈ sexp
        end
        @test s ≈ std(M, x; corrected = true, kwargs...)
        @test s ≈ √var(M, x; corrected = true, kwargs...)
        _, s2 = mean_and_std(M, x; kwargs...)
        @test s2 ≈ s
        m = mean(M, x; kwargs...)
        @test std(M, x, m; kwargs...) ≈ std(M, x; kwargs...)
        @test std(M, x; corrected = false, kwargs...) ≈
            std(M, x, m; corrected = false, kwargs...)
        @test std(M, x; corrected = false, kwargs...) ≈
            std(M, x; kwargs...) * sqrt((n - 1) / n)
        @test std(M, x, m; corrected = false, kwargs...) ≈
            std(M, x, m; kwargs...) * sqrt((n - 1) / n)
    end

    @testset "std weighted" begin
        n = length(x)
        w1 = pweights(ones(n) / n)
        w2 = pweights(ones(n))
        w3 = pweights(2 * ones(n))

        s = std(M, x; corrected = false, kwargs...)
        for w in (w1, w2, w3)
            @test std(M, x, w; kwargs...) ≈ s
            @test std(M, x, w; corrected = false, kwargs...) ≈ s
            @test mean_and_std(M, x, w; kwargs...)[2] ≈ std(M, x, w; kwargs...)
            m = mean(M, x, w; kwargs...)
            @test std(M, x, w, m; kwargs...) ≈ std(M, x, w; kwargs...)
            @test std(M, x, w; corrected = true, kwargs...) ≈
                std(M, x, w, m; corrected = true, kwargs...)
            @test std(M, x, w; corrected = true, kwargs...) ≈
                std(M, x, w; kwargs...) * sqrt(n / (n - 1))
            @test std(M, x, w, m; corrected = true, kwargs...) ≈
                std(M, x, w, m; kwargs...) * sqrt(n / (n - 1))
        end
        @test_throws DimensionMismatch std(M, x, pweights(ones(n + 1)); kwargs...)
    end
    return nothing
end

function test_moments(M, x)
    n = length(x)
    @testset "moments unweighted" begin
        m = mean(M, x)
        for i in 1:5
            @test moment(M, x, i) ≈ mean(distance.(Ref(M), Ref(m), x) .^ i)
            @test moment(M, x, i, m) ≈ moment(M, x, i)
        end
        @test moment(M, x, 2) ≈ var(M, x; corrected = false)
        @test skewness(M, x) ≈ moment(M, x, 3) / moment(M, x, 2)^(3 / 2)
        @test kurtosis(M, x) ≈ moment(M, x, 4) / moment(M, x, 2)^2 - 3

        @test moment(M, x, 2, m) ≈ var(M, x; corrected = false)
        @test skewness(M, x, m) ≈ moment(M, x, 3) / moment(M, x, 2)^(3 / 2)
        @test kurtosis(M, x, m) ≈ moment(M, x, 4) / moment(M, x, 2)^2 - 3
    end

    @testset "moments weighted" begin
        n = length(x)
        w1 = pweights(ones(n) / n)
        w2 = pweights(ones(n))
        w3 = pweights(2 * ones(n))

        for w in (w1, w2, w3)
            m = mean(M, x, w)
            for i in 1:5
                @test moment(M, x, i, w) ≈ mean(distance.(Ref(M), Ref(m), x) .^ i, w)
                @test moment(M, x, i, w, m) ≈ moment(M, x, i, w)
            end
            @test moment(M, x, 2, w) ≈ var(M, x, w; corrected = false)
            @test skewness(M, x, w) ≈ moment(M, x, 3, w) / moment(M, x, 2, w)^(3 / 2)
            @test kurtosis(M, x, w) ≈ moment(M, x, 4, w) / moment(M, x, 2, w)^2 - 3

            @test moment(M, x, 2, w, m) ≈ var(M, x, w; corrected = false)
            @test skewness(M, x, w, m) ≈ moment(M, x, 3, w) / moment(M, x, 2, w)^(3 / 2)
            @test kurtosis(M, x, w, m) ≈ moment(M, x, 4, w) / moment(M, x, 2, w)^2 - 3
        end
        @test_throws DimensionMismatch moment(M, x, 3, pweights(ones(n + 1)))
        @test_throws DimensionMismatch skewness(M, x, pweights(ones(n + 1)))
        @test_throws DimensionMismatch kurtosis(M, x, pweights(ones(n + 1)))
    end
    return nothing
end

struct TestStatsOverload1 <: AbstractManifold{ℝ} end
struct TestStatsMethod1 <: AbstractApproximationMethod end

function mean!(
        ::TestStatsOverload1,
        y,
        ::AbstractVector,
        ::AbstractWeights,
        ::GradientDescentEstimation,
    )
    return fill!(y, 3)
end
function mean(
        ::TestStatsOverload1,
        ::AbstractVector,
        ::AbstractWeights,
        ::GradientDescentEstimation,
    )
    return fill(3, 1)
end

function median(
        ::TestStatsOverload1,
        ::AbstractVector,
        ::AbstractWeights,
        ::CyclicProximalPointEstimation,
    )
    return fill(3, 1)
end
function median!(
        ::TestStatsOverload1,
        y,
        ::AbstractVector,
        ::AbstractWeights,
        ::CyclicProximalPointEstimation,
    )
    return fill!(y, 3)
end

function var(::TestStatsOverload1, ::AbstractVector, ::AbstractWeights, m; corrected = false)
    return 4 + 5 * corrected
end
function mean_and_var(
        ::TestStatsOverload1,
        ::AbstractVector,
        ::AbstractWeights;
        corrected = false,
        kwargs...,
    )
    return [4.0], 4 + 5 * corrected
end
function mean_and_var(
        ::TestStatsOverload1,
        ::AbstractVector,
        ::AbstractWeights,
        ::TestStatsMethod1;
        corrected = false,
        kwargs...,
    )
    return [5.0], 9 + 7 * corrected
end

@testset "Statistics" begin
    @testset "defaults and overloads" begin
        w = pweights([2.0])
        x = [[0.0]]
        @testset "mean" begin
            M = TestStatsOverload1()
            y = similar(x[1])
            @test mean(M, x) == [3.0]
            @test mean!(M, y, x) == [3.0]
            @test mean(M, x, w) == [3.0]
            @test mean(M, x, w, GradientDescentEstimation()) == [3.0]
            @test mean!(M, y, x, w, GradientDescentEstimation()) == [3.0]
            @test mean(M, x, GradientDescentEstimation()) == [3.0]
            @test mean!(M, y, x, GradientDescentEstimation()) == [3.0]
        end

        @testset "median" begin
            M = TestStatsOverload1()
            @test median(M, x) == [3.0]
            @test median(M, x, w) == [3.0]
            @test median(M, x, w, CyclicProximalPointEstimation()) == [3.0]
            @test median(M, x, CyclicProximalPointEstimation()) == [3.0]
        end

        @testset "var" begin
            M = TestStatsOverload1()
            @test mean_and_var(M, x) == ([3.0], 9)
            @test mean_and_var(M, x, w) == ([4.0], 4)
            @test mean_and_std(M, x) == ([3.0], 3.0)
            @test mean_and_std(M, x, w) == ([4.0], 2.0)
            @test var(M, x) == 9
            @test var(M, x, 2) == 9
            @test var(M, x, w) == 4
            @test var(M, x, w, 2) == 4
            @test std(M, x) == 3.0
            @test std(M, x, 2) == 3.0
            @test std(M, x, w) == 2.0
            @test std(M, x, w, 2) == 2.0

            @test Manifolds.default_approximation_method(M, mean_and_std) ==
                Manifolds.default_approximation_method(M, mean)
            @test mean_and_var(M, x, TestStatsMethod1()) == ([5.0], 16)
            @test mean_and_var(M, x, w, TestStatsMethod1()) == ([5.0], 9)
            @test mean_and_std(M, x, TestStatsMethod1()) == ([5.0], 4.0)
            @test mean_and_std(M, x, w, TestStatsMethod1()) == ([5.0], 3.0)
        end
    end

    @testset "TestStatsSphere" begin
        M = TestStatsSphere(2)

        @testset "consistency" begin
            p = [0.0, 0.0, 1.0]
            n = 3
            x = [
                exp(M, p, π / 6 * [cos(α), sin(α), 0.0]) for
                    α in range(0, 2 * π - 2 * π / n, length = n)
            ]
            test_mean(M, x)
            test_median(M, x; atol = 1.0e-12)
            test_median(M, x; method = CyclicProximalPointEstimation(), atol = 1.0e-12)
            test_median(M, x; method = WeiszfeldEstimation())
            test_var(M, x)
            test_std(M, x)
            test_moments(M, x)
        end

        @testset "zero variance" begin
            x = fill([0.0, 0.0, 1.0], 5)
            test_mean(M, x, [0.0, 0.0, 1.0])
            test_median(M, x, [0.0, 0.0, 1.0]; atol = 10^-12)
            test_var(M, x, 0.0)
            test_std(M, x, 0.0)
        end

        @testset "three points" begin
            x = [[1.0, 0.0, 0.0], [1.0, 1.0, 0.0] / √2, [0.0, 1.0, 0.0]]
            θ = π / 4
            @test isapprox(M, mean(M, x), geodesic(M, x[1], x[3], θ))
            test_mean(M, x, [1.0, 1.0, 0.0] / √2)
            test_median(M, x, [1.0, 1.0, 0.0] / √2; atol = 10^-12)
            test_var(M, x, θ^2)
            test_std(M, x, θ)
            test_moments(M, x)
        end
    end

    @testset "TestStatsEuclidean{N}" begin
        @testset "N=1" begin
            M = TestStatsEuclidean(1)

            rng = MersenneTwister(42)
            x = [randn(rng, 1) for _ in 1:10]
            vx = vcat(x...)

            test_mean(M, x, mean(x))
            test_median(M, x; atol = 10^-12)
            test_var(M, x, var(vx))
            test_std(M, x, std(vx))
            test_moments(M, x)

            w = pweights(rand(rng, 10))
            @test mean(M, x, w) ≈ [mean(vx, w)]
            @test var(M, x, w) ≈ var(vx, w)
            @test std(M, x, w) ≈ std(vx, w)
        end

        @testset "N=5" begin
            M = TestStatsEuclidean(5)

            rng = MersenneTwister(42)
            x = [randn(rng, 5) for _ in 1:10]
            test_mean(M, x, mean(x))
            test_var(M, x, sum(var(x)))
            test_std(M, x, sqrt(sum(std(x) .^ 2)))
            test_moments(M, x)

            w = pweights(rand(rng, 10))
            ax = hcat(x...)
            @test mean(M, x, w) ≈ mean(ax, w; dims = 2)
            @test var(M, x, w) ≈ sum(var(ax, w, 2))
            @test std(M, x, w) ≈ sqrt(sum(std(ax, w, 2) .^ 2))
        end
    end

    @testset "Euclidean statistics" begin
        @testset "N=1" begin
            M = Euclidean()
            @testset "scalar" begin
                x = [1.0, 2.0, 3.0, 4.0]
                w = pweights(ones(length(x)) / length(x))
                @test mean(M, x) ≈ mean(x)
                @test mean(Euclidean(; parameter = :field), x) ≈ mean(x)
                @test mean(M, x, w) ≈ mean(x, w)
                @test median(M, x; rng = MersenneTwister(1212), atol = 10^-12) ≈ median(x)
                @test median(M, x, w; rng = MersenneTwister(1212), atol = 10^-12) ≈ median(x, w)
                @test var(M, x) ≈ var(x)
                @test var(M, x, w) ≈ var(x, w)
                @test std(M, x) ≈ std(x)
                @test std(M, x, w) ≈ std(x, w)

                test_mean(M, x)
                test_median(M, x; atol = 10^-12)
                test_var(M, x)
                test_std(M, x)
                test_moments(M, x)
            end

            @testset "vector" begin
                x = [fill(1.0), fill(2.0), fill(3.0), fill(4.0)]
                vx = vcat(x...)
                w = pweights(ones(length(x)) / length(x))
                @test mean(M, x) ≈ mean(x)
                @test mean(M, x, w) ≈ [mean(vx, w)]
                @test var(M, x) ≈ var(vx)
                @test var(M, x, w) ≈ var(vx, w)
                @test std(M, x) ≈ std(vx)
                @test std(M, x, w) ≈ std(vx, w)

                test_mean(M, x)
                test_median(M, x; atol = 10^-12)
                test_var(M, x)
                test_std(M, x)
                test_moments(M, x)
                y = copy(x[1])
                mean!(M, y, x)
                @test y == mean(x)
            end
        end
    end

    @testset "Forwarding" begin
        M = CenteredMatrices(3, 2)
        p1 = [1.0 2; 4 5; -5 -7]
        p2 = [3.0 1; 2 5; -5 -6]
        @test mean(M, [p1, p2]) == mean([p1, p2])

        for mf in [mean, median, cov, var, mean_and_std, mean_and_var]
            @test ManifoldsBase.get_forwarding_type_embedding(
                ManifoldsBase.EmbeddedSubmanifoldType{ManifoldsBase.DirectEmbedding}(),
                M, mf
            ) === ManifoldsBase.EmbeddedForwardingType()

            @test ManifoldsBase.get_forwarding_type_embedding(
                ManifoldsBase.EmbeddedSubmanifoldType{ManifoldsBase.IndirectEmbedding}(),
                M, mf
            ) === ManifoldsBase.EmbeddedForwardingType(ManifoldsBase.DirectEmbedding())
        end
    end

    @testset "GeodesicInterpolation" begin
        @testset "mean" begin
            rng = MersenneTwister(1212)
            @testset "exact for Euclidean" begin
                M = Euclidean(2, 2)
                x = [randn(rng, 2, 2) for _ in 1:10]
                w = pweights([rand(rng) for _ in 1:10])
                @test mean(M, x, GeodesicInterpolation()) ≈ mean(x)
                @test mean(M, x, w, GeodesicInterpolation()) ≈
                    mean(M, x, w, GradientDescentEstimation())
            end

            @testset "three points" begin
                S = Sphere(2)
                x = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [1.0, 1.0, 0.0] / √2]
                @test mean(S, [x[1], x[1]], GeodesicInterpolation()) ≈ x[1]
                @test mean(S, x[1:2], GeodesicInterpolation()) ≈ x[3]
                @test mean(S, x[1:2], pweights([1, 0]), GeodesicInterpolation()) ≈ x[1]
                @test mean(S, x[1:2], pweights([0, 1]), GeodesicInterpolation()) ≈ x[2]
                @test mean(S, x[1:2], pweights([1, 2]), GeodesicInterpolation()) ≈
                    shortest_geodesic(S, x[1], x[2], 2 / 3)
                m = mean(S, x, pweights([1, 2, 3]), GeodesicInterpolation())
                @test m ≈ shortest_geodesic(
                    S,
                    shortest_geodesic(S, x[1], x[2], 2 / 3),
                    x[3],
                    1 / 2,
                )
            end

            @testset "Zero weights" begin
                M = Sphere(2)
                a = sqrt(2)
                pV = [[0.0, 0.0, 1.0], [1 / a, 1 / a, 0], [-1 / a, 1 / a, 0.0]]
                for method in [GeodesicInterpolation(), GradientDescentEstimation()]
                    @testset "with $method" begin
                        m1 = mean(M, pV, [0.0, 0.5, 0.5], method)
                        g1 = shortest_geodesic(M, pV[2], pV[3], 0.5)
                        @test isapprox(M, m1, g1; atol = 1.0e-7)
                        m2 = mean(M, pV, [0.5, 0.0, 0.5], method)
                        @test isapprox(M, m2, shortest_geodesic(M, pV[1], pV[3], 0.5))
                        m3 = mean(M, pV, [0.5, 0.0, 0.0], method)
                        @test isapprox(M, m3, pV[1])
                        m4 = mean(M, pV, [0.0, 1.0, 0.0], method)
                        @test isapprox(M, m4, pV[2])
                        m5 = mean(M, pV, [0.0, 0.0, 1.0], method)
                        @test isapprox(M, m5, pV[3])
                    end
                end
            end

            @testset "resumable" begin
                S = Sphere(2)
                x = [normalize(randn(rng, 3)) for _ in 1:10]
                w = pweights([rand(rng) for _ in 1:10])
                ypart = mean(S, x[1:5], pweights(w[1:5]), GeodesicInterpolation())
                yfull = mean(S, x, w, GeodesicInterpolation())
                x2 = [[ypart]; x[6:end]]
                w2 = pweights([sum(w[1:5]); w[6:end]])
                @test mean(S, x2, w2, GeodesicInterpolation()) ≈ yfull
            end
        end

        @testset "welford" begin
            rng = MersenneTwister(56)

            @testset "exact for Euclidean" begin
                M = TestStatsEuclidean(4)
                x = [randn(rng, 4) for _ in 1:10]
                w = pweights([rand(rng) for _ in 1:10])
                m1, v1 = mean_and_var(M, x, GeodesicInterpolation())
                @test m1 ≈ mean(x)
                @test v1 ≈ sum(var(x))
                m2, v2 = mean_and_var(M, x, w, GeodesicInterpolation())
                @test m2 ≈ mean(M, x, w, GradientDescentEstimation())
                @test v2 ≈ var(M, x, w)
            end

            @testset "three points" begin
                S = Sphere(2)
                x = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [1.0, 1.0, 0.0] / √2]
                m1, v1 = mean_and_var(S, [x[1], x[1]], GeodesicInterpolation())
                @test m1 ≈ x[1]
                @test v1 ≈ 0 atol = 1.0e-6
                m2, v2 = mean_and_var(S, x[1:2], GeodesicInterpolation())
                @test m2 ≈ x[3]
                @test v2 ≈ (π / 4)^2 * 2 / (2 - 1)
                m3, v3 = mean_and_var(S, x[1:2], pweights([1, 0]), GeodesicInterpolation())
                @test m3 ≈ x[1]
                @test v3 ≈ 0 atol = 1.0e-6
                m4, v4 = mean_and_var(S, x[1:2], pweights([0, 1]), GeodesicInterpolation())
                @test m4 ≈ x[2]
                @test v4 ≈ 0 atol = 1.0e-6
                m5, v5 = mean_and_var(S, x, pweights([1, 2, 3]), GeodesicInterpolation())
                @test m5 ≈ shortest_geodesic(
                    S,
                    shortest_geodesic(S, x[1], x[2], 2 / 3),
                    x[3],
                    1 / 2,
                )
                @test v5 ≈ var(S, x, pweights([1, 2, 3]), m5)
            end

            @testset "within radius" begin
                rng = MersenneTwister(47)
                @test repr(GeodesicInterpolationWithinRadius(Inf)) ==
                    "GeodesicInterpolationWithinRadius(Inf)"
                @test_throws DomainError GeodesicInterpolationWithinRadius(-0.1)
                S = Sphere(2)
                x = [[1.0, 0, 0], [0, 1.0, 0]]
                m = mean(S, x, GeodesicInterpolation())
                mg = mean(S, x, GradientDescentEstimation(); p0 = m)
                vg = var(S, x, mg)

                @test mean(S, x, GeodesicInterpolationWithinRadius(Inf)) == m
                @test mean(S, x, GeodesicInterpolationWithinRadius(π)) == m
                @test mean(S, x, GeodesicInterpolationWithinRadius(π / 8)) != m
                @test mean(S, x, GeodesicInterpolationWithinRadius(π / 8)) == mg

                m, v = mean_and_var(S, x, GeodesicInterpolation())
                @test mean_and_var(S, x, GeodesicInterpolationWithinRadius(Inf)) == (m, v)
                @test mean_and_var(S, x, GeodesicInterpolationWithinRadius(π)) == (m, v)
                @test mean_and_var(S, x, GeodesicInterpolationWithinRadius(π / 8)) != (m, v)
                @test mean_and_var(S, x, GeodesicInterpolationWithinRadius(π / 8)) ==
                    (mg, vg)
                # Just below π, i.e. we check whether we recompute but we do not.
                @test mean_and_var(S, x, GeodesicInterpolationWithinRadius(9 * π / 10)) ==
                    (m, v)
            end
        end

        @testset "SymmetricPositiveDefinite default" begin
            rng = MersenneTwister(36)
            P1 = SymmetricPositiveDefinite(3)
            P2 = MetricManifold(P1, AffineInvariantMetric())
            @testset "$P" for P in [P1, P2]
                p0 = collect(exp(Symmetric(randn(rng, 3, 3) * 0.1)))
                x = [exp(P, p0, Symmetric(randn(rng, 3, 3) * 0.1)) for _ in 1:10]
                w = pweights([rand(rng) for _ in 1:length(x)])
                m = mean(P, x, w)
                mg = mean(P, x, w, GeodesicInterpolation())
                mf = mean(P, x, w, GradientDescentEstimation())
                @test m == mg
                @test m != mf
            end
            @test default_approximation_method(P2, cov) === GradientDescentEstimation()
        end

        @testset "Sphere default" begin
            rng = MersenneTwister(47)
            S = Sphere(2)
            p0 = [1.0, 0, 0]
            x = [normalize(randn(rng, 3)) for _ in 1:10]
            x = [x; -x]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(S, x, w)
            mg = mean(S, x, w, GeodesicInterpolation())
            mf = mean(S, x, w, GradientDescentEstimation(); p0 = mg)
            @test m != mg
            @test m == mf

            μ = randn(rng, 3) .* 10
            x = [normalize(randn(rng, 3) .+ μ) for _ in 1:10]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(S, x, w)
            mg = mean(S, x, w, GeodesicInterpolation())
            @test m == mg
        end

        @testset "ProjectiveSpace default" begin
            rng = MersenneTwister(47)
            M = ProjectiveSpace(2)
            p0 = [1.0, 0, 0]
            x = [normalize(randn(rng, 3)) for _ in 1:10]
            x = [x; -x]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(M, x, w)
            mg = mean(M, x, w, GeodesicInterpolation())
            mf = mean(M, x, w, GradientDescentEstimation(); p0 = mg)
            @test !isapprox(M, m, mg)
            @test isapprox(M, m, mf)

            μ = randn(rng, 3) .* 10
            x = [normalize(randn(rng, 3) .+ μ) for _ in 1:10]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(M, x, w)
            mg = mean(M, x, w, GeodesicInterpolation())
            @test m == mg
        end

        @testset "Rotations default" begin
            rng = MersenneTwister(47)
            R = Manifolds.Rotations(3)
            p0 = collect(Diagonal(ones(3)))
            X1 = hat(R, p0, [1.0, 0.0, 0.0])
            X2 = hat(R, p0, [0.0, 1.0, 0.0])
            x = [geodesic(R, p0, X1, π / 2 * (1:4)); geodesic(R, p0, X2, π / 2 * (1:4))]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(R, x, w)
            mg = mean(R, x, w, GeodesicInterpolationWithinRadius(π / (2 * √2)))
            mf = mean(R, x, w, GradientDescentEstimation(); p0 = mg)
            @test m == mg
            @test m != mf

            μ = project(R, randn(3, 3))
            d = Manifolds.normal_tvector_distribution(R, μ, 0.1)
            x = [exp(R, μ, rand(rng, d)) for _ in 1:10]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(R, x, w)
            mg = mean(R, x, w, GeodesicInterpolationWithinRadius(π / (2 * √2)))
            @test m == mg
        end

        @testset "Grassmann default" begin
            rng = MersenneTwister(47)
            G = Manifolds.Grassmann(3, 2)
            p0 = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            x = [exp(G, p0, project(G, p0, randn(rng, 3, 2) * 10)) for _ in 1:10]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(G, x, w)
            mg = mean(G, x, w, GeodesicInterpolation())
            mf = mean(G, x, w, GradientDescentEstimation(); p0 = mg)
            @test m != mg
            @test m == mf

            x = [exp(G, p0, project(G, p0, randn(rng, 3, 2) * 0.01)) for _ in 1:10]
            w = pweights([rand(rng) for _ in 1:length(x)])
            m = mean(G, x, w)
            mg = mean(G, x, w, GeodesicInterpolation())
            @test m == mg
        end
    end

    @testset "Extrinsic mean" begin
        rng = MersenneTwister(47)
        S = Sphere(2)
        x = [normalize(randn(rng, 3)) for _ in 1:10]
        w = pweights([rand(rng) for _ in 1:length(x)])
        m = normalize(mean(reduce(hcat, x), w; dims = 2)[:, 1])
        mg = mean(S, x, w, ExtrinsicEstimation(EfficientEstimator()))
        @test isapprox(S, m, mg)
    end

    @testset "Extrinsic median" begin
        rng = MersenneTwister(47)
        S = Sphere(2)
        x = [normalize(randn(rng, 3)) for _ in 1:10]
        w = pweights([rand(rng) for _ in 1:length(x)])
        m = normalize(median(Euclidean(3), x, w))
        mg = median(S, x, w, ExtrinsicEstimation(CyclicProximalPointEstimation()))
        @test isapprox(S, m, mg)
    end

    @testset "Covariance Default" begin
        @test default_approximation_method(TestStatsSphere{2}(), cov) ==
            GradientDescentEstimation()
    end

    @testset "Covariance matrix, Euclidean" begin
        rng = MersenneTwister(47)
        M = Euclidean(3)
        x = [randn(rng, 3) for _ in 1:10]
        @test isapprox(cov(M, x), cov(x))
        covest = SimpleCovariance(; corrected = false)
        @test isapprox(cov(M, x; tangent_space_covariance_estimator = covest), cov(covest, x))
    end

    @testset "Covariance matrix, sphere" begin
        rng = MersenneTwister(47)
        S = Sphere(2)
        x = [normalize(randn(rng, 3)) for _ in 1:10]
        covm = cov(S, x)
        @test size(covm) == (2, 2)
        @test isposdef(covm)
        @test issymmetric(covm)
    end

    @testset "Default Fallbacks for nonimplemented with stop forwarding" begin
        M = TestStatsNotImplementedManifold()
        a = GradientDescentEstimation()
        @test default_approximation_method(ManifoldsBase.StopForwardingType(), M, cov) === a
        @test default_approximation_method(ManifoldsBase.StopForwardingType(), M, mean) === a
        b = CyclicProximalPointEstimation()
        @test default_approximation_method(ManifoldsBase.StopForwardingType(), M, median) === b
        @test default_approximation_method(ManifoldsBase.StopForwardingType(), M, mean_and_var) === a
    end
end

using LinearAlgebra, Manifolds, Quaternions, Test, Random

@testset "Orthogonal Matrices" begin
    M = OrthogonalMatrices(3)
    α = 0.1
    p1 = [cos(α) sin(α) 0.0; -sin(α) cos(α) 0.0; 0.0 0.0 1.0]
    p2 = [-cos(α) sin(α) 0.0; -sin(α) cos(α) 0.0; 0.0 0.0 1.0]
    p3 = [1.0 0.0 0.0; 0.0 cos(α) sin(α); 0.0 -sin(α) cos(α)]
    pE = ones(3, 3)
    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                default_vector_transport_method,
                get_embedding,
                injectivity_radius, is_flat,
                rand, repr,
            ],
            :EmbeddedPoints => [p3],
            :Points => [p1, p2, p3],
            :RetractionMethods => [PolarRetraction()],
        ),
        Dict(
            default_vector_transport_method => ProjectionTransport(),
            get_embedding => Euclidean(3, 3),
            injectivity_radius => π * sqrt(2),
            (injectivity_radius, PolarRetraction()) => π / sqrt(2),
            is_flat => false,
            manifold_dimension => 3,
            repr => "OrthogonalMatrices(3)",
        )
    )

    @testset "volume" begin
        @test manifold_volume(OrthogonalMatrices(1)) ≈ 2
        @test manifold_volume(OrthogonalMatrices(2)) ≈ 4 * π * sqrt(2)
        @test manifold_volume(OrthogonalMatrices(3)) ≈ 16 * π^2 * sqrt(2)
        @test manifold_volume(OrthogonalMatrices(4)) ≈ 2 * (2 * π)^4 * sqrt(2)
        @test manifold_volume(OrthogonalMatrices(5)) ≈ 8 * (2 * π)^6 / 6 * sqrt(2)
    end

    @testset "Field parameter" begin
        @test get_embedding(OrthogonalMatrices(3; parameter = :field)) === Euclidean(3, 3; parameter = :field)
        @test repr(OrthogonalMatrices(3; parameter = :field)) ==
            "OrthogonalMatrices(3; parameter=:field)"
    end

    @testset "Selected methods on OrthogonalMatrices(1)" begin
        @test abs(rand(OrthogonalMatrices(1))[]) == 1
        @test abs(rand(MersenneTwister(), OrthogonalMatrices(1))[]) == 1
        @test injectivity_radius(OrthogonalMatrices(1; parameter = :field)) == 0.0
    end
end

@doc raw"""
    check_point(M::SymplecticGrassmann, p; kwargs...)

Check whether `p` is a valid point on the [`SymplecticGrassmann`](@ref),
``\operatorname{SpGr}(2n, 2k)`` manifold by verifying that it
is a valid representer of an equivalence class of the corersponding
[`SymplecticStiefel`](@ref) manifold.
"""
function check_point(M::SymplecticGrassmann, p; kwargs...)
    n, k = get_parameter(M.size)
    return check_point(SymplecticStiefel(2 * n, 2 * k), p; kwargs...)
end

@doc raw"""
    check_vector(M::SymplecticGrassmann, p, X; kwargs...)

Check whether `X` is a valid tangent vector at `p` on the [`SymplecticGrassmann`](@ref),
``\operatorname{SpGr}(2n, 2k)`` manifold by verifying that it
is a valid representer of an equivalence class of the corersponding
[`SymplecticStiefel`](@ref) manifolds tangent space at `p`.
"""
function check_vector(M::SymplecticGrassmann, p, X; kwargs...)
    n, k = get_parameter(M.size)
    return check_vector(SymplecticStiefel(2 * n, 2 * k), p, X; kwargs...)
end

embed(::SymplecticGrassmann, p) = p
embed(::SymplecticGrassmann, p, X) = X
embed!(::SymplecticGrassmann, q, p) = copyto!(q, p)
embed!(::SymplecticGrassmann, Y, p, X) = copyto!(Y, X)
embed!(::SymplecticGrassmann, q, p::StiefelPoint) = copyto!(q, p.value)
function embed!(::SymplecticGrassmann, Y, p::StiefelPoint, X::StiefelTangentVector)
    return copyto!(Y, X.value)
end
embed(::SymplecticGrassmann, p::StiefelPoint) = p.value
embed(::SymplecticGrassmann, p::StiefelPoint, X::StiefelTangentVector) = X.value

@doc raw"""
    exp(::SymplecticGrassmann, p, X)
    exp!(M::SymplecticGrassmann, q, p, X)

Compute the exponential mapping

```math
  \exp\colon T\mathrm{SpGr}(2n, 2k) → \mathrm{SpGr}(2n, 2k)
```

when representing points and tangent vectors as symplectic bases and their tangents, i.e.
on the [`SymplecticStiefel`](@ref) manifold. Then we can just pass this on to [`exp(::SymplecticStiefel, p, X)`](@ref).
"""
exp(::SymplecticGrassmann, p, X)

function exp!(M::SymplecticGrassmann, q, p, X)
    n, k = get_parameter(M.size)
    exp!(SymplecticStiefel(2 * n, 2 * k), q, p, X)
    return q
end

function get_embedding(::SymplecticGrassmann{ℝ, TypeParameter{Tuple{n, k}}}) where {n, k}
    return SymplecticStiefel(2n, 2k)
end
function get_embedding(M::SymplecticGrassmann{ℝ, Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return SymplecticStiefel(2n, 2k; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymplecticGrassmann{ℝ})
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    inner(::SymplecticGrassmann, p, X, Y)

Compute the Riemannian inner product ``g^{\mathrm{SpGr}}_p(X,Y)``
on the [`SymplecticGrassmann`](@ref) manifold `\mathrm{SpGr}``.

For the case where ``p`` is represented by a point on the [`SymplecticStiefel`](@ref) manifold
acting as a representant of its equivalence class ``[p] \in \mathrm{SpGr}``
and the tangent vectors ``X,Y \in \mathrm{Hor}_p^π\operatorname{SpSt}(2n,2k)``
are horizontal tangent vectors.

Then the inner product reads according to Proposition Lemma 4.8 [BendokatZimmermann:2021](@cite).

```math
g^{\mathrm{SpGr}}_p(X,Y) = \operatorname{tr}\bigl(
        (p^{\mathrm{T}}p)^{-1}X^{\mathrm{T}}(I_{2n} - pp^+)Y
    \bigr),
```

where ``I_{2n}`` denotes the identity matrix and ``(⋅)^+`` the [`symplectic_inverse`](@ref).
"""
function inner(M::SymplecticGrassmann, p, X, Y)
    n, k = get_parameter(M.size)
    J = SymplecticElement(p, X, Y) # in BZ21 also J
    # Procompute lu(p'p) since we solve a^{-1}* 3 times
    a = lu(p' * p) # note that p'p is symmetric, thus so is its inverse c=a^{-1}
    # we split the original trace into two one with I -> (X'Yc)
    # 1) we permute X' and Y c to c^{\mathrm{T}}Y^{\mathrm{T}}X = a\(Y'X) (avoids a large interims matrix)
    # 2) the second we compute as c (X'p)(p^+Y) since both brackets are the smaller matrices
    return tr(a \ (Y' * X)) - tr(
        a \ ((X' * p) * symplectic_inverse_times(SymplecticStiefel(2 * n, 2 * k), p, Y)),
    )
end

@doc raw"""
    inverse_retract(::SymplecticGrassmann, p, q, ::CayleyInverseRetraction)
    inverse_retract!(::SymplecticGrassmann, X, p, q, ::CayleyInverseRetraction)

Compute the Cayley Inverse Retraction on the Symplectic Grassmann manifold,
when the points are represented as symplectic bases, i.e. on the [`SymplecticStiefel`](@ref).

Here we can directly employ the `CaleyInverseRetraction` on the symplectic Stiefel manifold.
"""
inverse_retract(::SymplecticGrassmann, p, q, ::CayleyInverseRetraction)

function inverse_retract_cayley!(M::SymplecticGrassmann, X, p, q)
    n, k = get_parameter(M.size)
    return inverse_retract_cayley!(SymplecticStiefel(2 * n, 2 * k), X, p, q)
end

@doc raw"""
    retract(::SymplecticGrassmann, p, X, ::CayleyRetraction)
    retract!(::SymplecticGrassmann, q, p, X, ::CayleyRetraction)

Compute the Cayley retraction on the Symplectic Grassmann manifold,
when the points are represented as symplectic bases, i.e. on the [`SymplecticStiefel`](@ref).

Here we can directly employ the [`CaleyRetraction`](@extref `ManifoldsBase.CayleyRetraction`) on the symplectic Stiefel manifold.
"""
retract(::SymplecticGrassmann, p, X, ::CayleyRetraction)

function ManifoldsBase.retract_cayley!(M::SymplecticGrassmann, q, p, X)
    n, k = get_parameter(M.size)
    ManifoldsBase.retract_cayley!(SymplecticStiefel(2 * n, 2 * k), q, p, X)
    return q
end
function ManifoldsBase.retract_cayley_fused!(M::SymplecticGrassmann, q, p, X, t::Number)
    n, k = get_parameter(M.size)
    ManifoldsBase.retract_cayley_fused!(SymplecticStiefel(2 * n, 2 * k), q, p, X, t)
    return q
end

@doc raw"""
    riemannian_gradient(M::SymplecticGrassmann, p, Y)

Given a gradient ``Y = \operatorname{grad} \tilde f(p)`` in the embedding ``ℝ^{2n×2k}`` or at
least around the [`SymplecticGrassmann`](@ref) `M` where `p` (the embedding of) a point on `M`,
and the restriction ``\tilde f`` to the [`SymplecticStiefel`](@ref) be invariant for the equivalence classes.
In other words ``f(p) = f(qp)`` for ``q \in \mathrm{Sp}(2k, ℝ)``,
where ``\mathrm{Sp}(2k, ℝ)`` denotes the [`SymplecticMatrices`](@ref) manifold.
Then the Riemannian gradient ``X = \operatorname{grad} f(p)`` is given by

```math
  X = J_{2n}^THJ_{2k}p^{\mathrm{T}}p - J_{2n}^TpJ_{2k}H^{\mathrm{T}}p,
```

where ``J_{2n}`` denotes the [`SymplecticElement`](@ref), and
``H = (I_{2n} - pp^+)J_{2n}^{\mathrm{T}}YJ``.
"""
riemannian_gradient(M::SymplecticGrassmann, p, Y; kwargs...)

function riemannian_gradient!(M::SymplecticGrassmann, X, p, Y; kwargs...)
    n, k = get_parameter(M.size)
    J = SymplecticElement(p, X)
    # Since J' = -J We can write (J'YJ) = -J * (YJ)
    JTYJ = (-J * (Y * J))
    H = (I - p * symplectic_inverse(p)) * JTYJ
    X .= (-J * (H * J)) * (p' * p) .- JTYJ * (H' * p)
    return X
end

@doc raw"""
    SymplecticStiefel{𝔽, T} <: AbstractEmbeddedManifold{𝔽, DefaultIsometricEmbeddingType}

The symplectic Stiefel manifold consists of all
``2n×2k, n ≥ k`` matrices satisfying the requirement

````math
\mathrm{SpSt}(2n, 2k, ℝ)
    := \bigl\{ p ∈ ℝ^{2n×2k} \ \big| \ p^{\mathrm{T}}J_{2n}p = J_{2k} \bigr\},
````

where ``J_{2n}`` denotes the [`SymplecticElement`](@ref)

````math
J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}.
````

The symplectic Stiefel tangent space at ``p`` can be parametrized as [BendokatZimmermann:2021](@cite)

```math
\begin{align*}
    T_p\mathrm{SpSt}(2n, 2k)
    &= \{X ∈ ℝ^{2n×2k} ∣ p^{T}J_{2n}X + X^{T}J_{2n}p = 0 \}, \\
    &= \{X = pΩ + p^sB \mid
        Ω ∈ ℝ^{2k×2k}, Ω^+ = -Ω, \\
        &\quad\qquad p^s ∈ \mathrm{SpSt}(2n, 2(n- k)), B ∈ ℝ^{2(n-k)×2k}, \},
\end{align*}
```

where ``Ω ∈ \mathfrak{sp}(2n,F)`` is [`Hamiltonian`](@ref) and ``p^s`` means
the symplectic complement of ``p`` s.t. ``p^{+}p^{s} = 0``.
Here ``p^+`` denotes the [`symplectic_inverse`](@ref).

You can also use [`StiefelPoint`](@ref) and [`StiefelTangentVector`](@ref) with this manifold,
they are equivalent to using arrays.

# Constructor
    SymplecticStiefel(2n::Int, 2k::Int, field::AbstractNumbers=ℝ; parameter::Symbol=:type)

Generate the (real-valued) symplectic Stiefel manifold of ``2n×2k``
matrices which span a ``2k`` dimensional symplectic subspace of ``ℝ^{2n×2k}``.
The constructor for the [`SymplecticStiefel`](@ref) manifold accepts the even column
dimension ``2n`` and an even number of columns ``2k`` for
the real symplectic Stiefel manifold with elements ``p ∈ ℝ^{2n×2k}``.
"""
struct SymplecticStiefel{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SymplecticStiefel(two_n::Int, two_k::Int; parameter::Symbol = :type)
    two_n % 2 == 0 || throw(
        ArgumentError(
            "The first matrix size of the symplectic Stiefel manifold must be even, but was $(two_n).",
        ),
    )
    two_k % 2 == 0 || throw(
        ArgumentError(
            "The second matrix size of the symplectic Stiefel manifold must be even. but was $(two_k).",
        ),
    )
    size = wrap_type_parameter(parameter, (div(two_n, 2), div(two_k, 2)))
    return SymplecticStiefel{ℝ, typeof(size)}(size)
end

# Define Stiefel as the array fallback
ManifoldsBase.@default_manifold_fallbacks SymplecticStiefel{ℝ} StiefelPoint StiefelTangentVector value value

function ManifoldsBase.default_inverse_retraction_method(::SymplecticStiefel)
    return CayleyInverseRetraction()
end

ManifoldsBase.default_retraction_method(::SymplecticStiefel) = CayleyRetraction()

@doc raw"""
    canonical_project(::SymplecticStiefel, p_Sp)
    canonical_project!(::SymplecticStiefel, p, p_Sp)

Define the canonical projection from ``\mathrm{Sp}(2n, 2n)`` onto
``\mathrm{SpSt}(2n, 2k)``, by projecting onto the first ``k`` columns
and the ``n + 1``'th onto the ``n + k``'th columns [BendokatZimmermann:2021](@cite).

It is assumed that the point ``p`` is on ``\mathrm{Sp}(2n, 2n)``.
"""
function canonical_project(M::SymplecticStiefel, p_Sp)
    n, k = get_parameter(M.size)
    p_SpSt = similar(p_Sp, (2n, 2k))
    return canonical_project!(M, p_SpSt, p_Sp)
end

function canonical_project!(M::SymplecticStiefel, p, p_Sp)
    n, k = get_parameter(M.size)
    p[:, (1:k)] .= p_Sp[:, (1:k)]
    p[:, ((k + 1):(2k))] .= p_Sp[:, ((n + 1):(n + k))]
    return p
end

@doc raw"""
    check_point(M::SymplecticStiefel, p; kwargs...)

Check whether `p` is a valid point on the [`SymplecticStiefel`](@ref),
``\mathrm{SpSt}(2n, 2k)`` manifold, that is ``p^{+}p`` is the identity,
``(⋅)^+`` denotes the [`symplectic_inverse`](@ref).
"""
function check_point(M::SymplecticStiefel{ℝ}, p; kwargs...)
    # Perform check that the matrix lives on the real symplectic manifold:
    if !isapprox(inv(M, p) * p, I; kwargs...)
        return DomainError(
            norm(inv(M, p) * p - I),
            (
                "The point p does not lie on $(M) because its symplectic" *
                    " inverse composed with itself is not the identity."
            ),
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::SymplecticMatrices, p, X; kwargs...)

Checks whether `X` is a valid tangent vector at `p` on the [`SymplecticStiefel`](@ref),
``\mathrm{SpSt}(2n, 2k)`` manifold.

The check consists of verifying that ``H = p^{+}X ∈ 𝔤_{2k}``, where ``𝔤``
is the Lie Algebra of the symplectic group ``\mathrm{Sp}(2k)``, that is
the set of [`HamiltonianMatrices`])(@ref), where ``(⋅)^+`` denotes the [`symplectic_inverse`](@ref).
"""
check_vector(::SymplecticStiefel, ::Any...)

function check_vector(M::SymplecticStiefel{𝔽}, p, X::T; kwargs...) where {T, 𝔽}
    n, k = get_parameter(M.size)
    # From Bendokat-Zimmermann: T_pSpSt(2n, 2k) = \{p*H | H^{+} = -H  \}
    H = inv(M, p) * X  # ∈ ℝ^{2k×2k}, should be Hamiltonian.

    if !is_hamiltonian(H; kwargs...)
        return DomainError(
            norm(Matrix(Hamiltonian(H)^+) + H),
            (
                "The matrix X is not in the tangent space at point p of $M at $p, since p^{+}X is not a Hamiltonian matrix."
            ),
        )
    end
    return nothing
end

metric(::SymplecticStiefel) = RealSymplecticMetric()

@doc raw"""
    exp(::SymplecticStiefel, p, X)
    exp!(M::SymplecticStiefel, q, p, X)

Compute the exponential mapping
```math
  \exp\colon T\mathrm{SpSt}(2n, 2k) → \mathrm{SpSt}(2n, 2k)
```
at a point ``p ∈ \mathrm{SpSt}(2n, 2k)``
in the direction of ``X ∈ T_p\mathrm{SpSt}(2n, 2k)``.

The tangent vector ``X`` can be written in the form
``X = \bar{\Omega}p`` [BendokatZimmermann:2021](@cite), with

```math
  \bar{\Omega} = X (p^{\mathrm{T}}p)^{-1}p^{\mathrm{T}}
    + J_{2n}p(p^{\mathrm{T}}p)^{-1}X^{\mathrm{T}}(I_{2n}
    - J_{2n}^{\mathrm{T}}p(p^{\mathrm{T}}p)^{-1}p^{\mathrm{T}}J_{2n})J_{2n}
    ∈ ℝ^{2n×2n},
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

Using this expression for ``X``,
the exponential mapping can be computed as

````math
  \exp_p(X) = \operatorname{Exp}([\bar{\Omega} - \bar{\Omega}^{\mathrm{T}}])
                             \operatorname{Exp}(\bar{\Omega}^{\mathrm{T}})p,
````
where ``\operatorname{Exp}(⋅)`` denotes the matrix exponential.

Computing the above mapping directly however, requires taking matrix exponentials
of two ``2n×2n`` matrices, which is computationally expensive when ``n``
increases. Therefore we instead follow [BendokatZimmermann:2021](@cite) who express the above
exponential mapping in a way which only requires taking matrix exponentials
of an ``8k×8k`` matrix and a ``4k×4k`` matrix.

To this end, first define
```math
\bar{A} = J_{2k}p^{\mathrm{T}}X(p^{\mathrm{T}}p)^{-1}J_{2k} +
            (p^{\mathrm{T}}p)^{-1}X^{\mathrm{T}}(p - J_{2n}^{\mathrm{T}}p(p^{\mathrm{T}}p)^{-1}J_{2k}) ∈ ℝ^{2k×2k},
```

and

```math
\bar{H} = (I_{2n} - pp^+)J_{2n}X(p^{\mathrm{T}}p)^{-1}J_{2k} ∈ ℝ^{2n×2k}.
```

We then let ``\bar{\Delta} = p\bar{A} + \bar{H}``, and define the matrices

```math
    γ = \left[\left(I_{2n} - \frac{1}{2}pp^+\right)\bar{\Delta} \quad
              -p \right] ∈ ℝ^{2n×4k},
```
and
````math
    λ = \left[J_{2n}^{\mathrm{T}}pJ_{2k} \quad
        \left(\bar{\Delta}^+\left(I_{2n}
              - \frac{1}{2}pp^+\right)\right)^{\mathrm{T}}\right] ∈ ℝ^{2n×4k}.
````
With the above defined matrices it holds that ``\bar{\Omega} = λγ^{\mathrm{T}}``.
 As a last preliminary step, concatenate ``γ`` and ``λ`` to define the matrices
``Γ = [λ \quad -γ] ∈ ℝ^{2n×8k}`` and
``Λ = [γ \quad λ] ∈ ℝ^{2n×8k}``.

With these matrix constructions done, we can compute the
exponential mapping as
```math
  \exp_p(X) = Γ \operatorname{Exp}(ΛΓ^{\mathrm{T}})
    \begin{bmatrix} 0_{4k} \\ I_{4k} \end{bmatrix}
    \operatorname{Exp}(λγ^{\mathrm{T}})
    \begin{bmatrix} 0_{2k} \\ I_{2k} \end{bmatrix}.
```

which only requires computing the matrix exponentials of
``ΛΓ^{\mathrm{T}} ∈ ℝ^{8k×8k}`` and ``λγ^{\mathrm{T}} ∈ ℝ^{4k×4k}``.
"""
exp(::SymplecticStiefel, p, X)

function exp!(M::SymplecticStiefel, q, p, X)
    n, k = get_parameter(M.size)
    J = SymplecticElement(p, X)
    pT_p = lu(p' * p) # ∈ ℝ^{2k×2k}

    C = pT_p \ X' # ∈ ℝ^{2k×2n}

    # Construct A-bar:
    # First A-term: J * (p^{\mathrm{T}} * C^{\mathrm{T}}) * J
    A_bar = rmul!(lmul!(J, (p' * C')), J)
    A_bar .+= C * p

    # Second A-term, use C-memory:
    rmul!(C, J') # C*J^{\mathrm{T}} -> C
    C_JT = C

    # Subtract C*J^{\mathrm{T}}*p*(pT_p)^{-1}*J:
    # A_bar is "star-skew symmetric" (A^+ = -A).
    A_bar .-= rmul!((C_JT * p) / pT_p, J)

    # Construct H_bar:
    # First H-term: J * (C_JT * J)' * J -> J * C' * J = J * (X / pT_p) * J
    H_bar = rmul!(lmul!(J, rmul!(C_JT, J)'), J)
    # Subtract second H-term:
    H_bar .-= p * symplectic_inverse_times(M, p, H_bar)

    # Construct Δ_bar in H_bar-memory:
    H_bar .+= p * A_bar

    # Rename H_bar -> Δ_bar.
    Δ_bar = H_bar

    γ_1 = Δ_bar - (1 / 2) .* p * symplectic_inverse_times(M, p, Δ_bar)
    γ = [γ_1 -p] # ∈ ℝ^{2n×4k}

    Δ_bar_star = rmul!(J' * Δ_bar', J)
    λ_1 = lmul!(J', p * J)
    λ_2 = (Δ_bar_star .- (1 / 2) .* (Δ_bar_star * p) * λ_1')'
    λ = [λ_1 λ_2] # ∈ ℝ^{2n×4k}

    Γ = [λ -γ] # ∈ ℝ^{2n×8k}
    Λ = [γ λ] # ∈ ℝ^{2n×8k}

    # At last compute the (8k×8k) and (4k×4k) matrix exponentials:
    q .= Γ * (exp(Λ' * Γ)[:, (4k + 1):end]) * (exp(λ' * γ)[:, (2k + 1):end])
    return q
end

function get_embedding(::SymplecticStiefel{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return Euclidean(2 * n, 2 * k; field = 𝔽)
end
function get_embedding(M::SymplecticStiefel{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return Euclidean(2 * n, 2 * k; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymplecticStiefel)
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    get_total_space(::SymplecticStiefel)

Return the total space of the [`SymplecticStiefel`](@ref) manifold, which is the corresponding [`SymplecticMatrices`](@ref) manifold.
"""
function get_total_space(::SymplecticStiefel{ℝ, TypeParameter{Tuple{n, k}}}) where {n, k}
    return SymplecticMatrices(2 * n)
end
function get_total_space(M::SymplecticStiefel{ℝ, Tuple{Int, Int}})
    n, _ = get_parameter(M.size)
    return SymplecticMatrices(2 * n; parameter = :field)
end

@doc raw"""
    inner(M::SymplecticStiefel, p, X. Y)

Compute the Riemannian inner product ``g^{\mathrm{SpSt}}`` at
``p ∈ \mathrm{SpSt}`` of tangent vectors ``Y, X ∈ T_p\mathrm{SpSt}``.
Given by Proposition 3.10 in [BendokatZimmermann:2021](@cite).
```math
g^{\mathrm{SpSt}}_p(X, Y)
  = \operatorname{tr}\Bigl(
    X^{\mathrm{T}}\bigl(
      I_{2n} - \frac{1}{2}J_{2n}^{\mathrm{T}} p(p^{\mathrm{T}}p)^{-1}p^{\mathrm{T}}J_{2n}
    \bigr) Y (p^{\mathrm{T}}p)^{-1}\Bigr).
```
"""
function inner(::SymplecticStiefel, p, X, Y)
    J = SymplecticElement(p, X, Y) # in BZ21 also J
    # Procompute lu(p'p) since we solve a^{-1}* 3 times
    a = lu(p' * p) # note that p'p is symmetric, thus so is its inverse c=a^{-1}
    b = J' * p
    # we split the original trace into two one with I->(X'Yc)
    # and the other with 1/2 X'b c b' Y c
    # 1) we permute X' and Y c to c^{\mathrm{T}}Y^{\mathrm{T}}X = a\(Y'X) (avoids a large interims matrix)
    # 2) we permute Y c up front, the center term is symmetric, so we get cY'b c b' X
    # and (b'X) again avoids a large interims matrix, so does Y'b.
    return tr(a \ (Y' * X)) - (1 / 2) * tr(a \ ((Y' * b) * (a \ (b' * X))))
end

@doc raw"""
    inv(::SymplecticStiefel, A)
    inv!(::SymplecticStiefel, q, p)

Compute the symplectic inverse ``A^+`` of matrix ``A ∈ ℝ^{2n×2k}``.
Given a matrix
````math
A ∈ ℝ^{2n×2k},\quad
A =
\begin{bmatrix}
A_{1, 1} & A_{1, 2} \\
A_{2, 1} & A_{2, 2}
\end{bmatrix}, \quad A_{i, j} ∈ ℝ^{2n×2k}
````

the symplectic inverse is defined as:

```math
A^{+} := J_{2k}^{\mathrm{T}} A^{\mathrm{T}} J_{2n},
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).

The symplectic inverse of a matrix A can be expressed explicitly as:
```math
A^{+} =
  \begin{bmatrix}
    A_{2, 2}^{\mathrm{T}} & -A_{1, 2}^{\mathrm{T}} \\[1.2mm]
   -A_{2, 1}^{\mathrm{T}} &  A_{1, 1}^{\mathrm{T}}
  \end{bmatrix}.
```
"""
function Base.inv(M::SymplecticStiefel, p)
    q = similar(p')
    return inv!(M, q, p)
end

function inv!(M::SymplecticStiefel, q, p)
    n, k = get_parameter(M.size)
    checkbounds(q, 1:(2k), 1:(2n))
    checkbounds(p, 1:(2n), 1:(2k))
    @inbounds for i in 1:k, j in 1:n
        q[i, j] = p[j + n, i + k]
    end
    @inbounds for i in 1:k, j in 1:n
        q[i, j + n] = -p[j, i + k]
    end
    @inbounds for i in 1:k, j in 1:n
        q[i + k, j] = -p[j + n, i]
    end
    @inbounds for i in 1:k, j in 1:n
        q[i + k, j + n] = p[j, i]
    end
    return q
end

@doc raw"""
    inverse_retract(::SymplecticStiefel, p, q, ::CayleyInverseRetraction)
    inverse_retract!(::SymplecticStiefel, X, p, q, ::CayleyInverseRetraction)

Compute the Cayley Inverse Retraction ``X = \mathcal{L}_p^{\mathrm{SpSt}}(q)``
such that the Cayley Retraction from ``p`` along ``X`` lands at ``q``, i.e.
``\mathcal{R}_p(X) = q`` [BendokatZimmermann:2021](@cite).

For ``p, q ∈ \mathrm{SpSt}(2n, 2k, ℝ)`` we can define the
inverse cayley retraction as long as the following matrices exist.
````math
    U = (I + p^+ q)^{-1} ∈ ℝ^{2k×2k},
    \quad
    V = (I + q^+ p)^{-1} ∈ ℝ^{2k×2k},
````

where ``(⋅)^+`` denotes the [`symplectic_inverse`](@ref).

THen the inverse retraction reads
````math
\mathcal{L}_p^{\mathrm{Sp}}(q) = 2p\bigl(V - U\bigr) + 2\bigl((p + q)U - p\bigr) ∈ T_p\mathrm{Sp}(2n).
````
"""
inverse_retract(::SymplecticStiefel, p, q, ::CayleyInverseRetraction)

function inverse_retract_cayley!(M::SymplecticStiefel, X, p, q)
    U_inv = lu!(add_scaled_I!(symplectic_inverse_times(M, p, q), 1))
    V_inv = lu!(add_scaled_I!(symplectic_inverse_times(M, q, p), 1))

    X .= 2 .* ((p / V_inv .- p / U_inv) .+ ((p + q) / U_inv) .- p)
    return X
end

"""
    is_flat(::SymplecticStiefel)

Return false. [`SymplecticStiefel`](@ref) is not a flat manifold.
"""
is_flat(M::SymplecticStiefel) = false

@doc raw"""
    manifold_dimension(::SymplecticStiefel)

Returns the dimension of the symplectic Stiefel manifold embedded in ``ℝ^{2n×2k}``,
i.e. [BendokatZimmermann:2021](@cite)
````math
    \operatorname{dim}(\mathrm{SpSt}(2n, 2k)) = (4n - 2k + 1)k.
````
"""
function manifold_dimension(M::SymplecticStiefel)
    n, k = get_parameter(M.size)
    return (4n - 2k + 1) * k
end

@doc raw"""
    project(::SymplecticStiefel, p, A)
    project!(::SymplecticStiefel, Y, p, A)

Given a point ``p ∈ \mathrm{SpSt}(2n, 2k)``,
project an element ``A ∈ ℝ^{2n×2k}`` onto
the tangent space ``T_p\mathrm{SpSt}(2n, 2k)`` relative to
the euclidean metric of the embedding ``ℝ^{2n×2k}``.

That is, we find the element ``X ∈ T_p\mathrm{SpSt}(2n, 2k)``
which solves the constrained optimization problem

````math
    \displaystyle\operatorname{min}_{X ∈ ℝ^{2n×2k}} \frac{1}{2}||X - A||^2, \quad
    \text{s.t.}\;
    h(X) := X^{\mathrm{T}} J p + p^{\mathrm{T}} J X = 0,
````
where ``h : ℝ^{2n×2k} → \operatorname{skew}(2k)`` defines
the restriction of ``X`` onto the tangent space ``T_p\mathrm{SpSt}(2n, 2k)``.
"""
project(::SymplecticStiefel, p, A)

function project!(::SymplecticStiefel, Y, p, A)
    J = SymplecticElement(Y, p, A)
    Jp = J * p

    function h(X)
        XTJp = X' * Jp
        return XTJp .- XTJp'
    end

    # Solve for Λ (Lagrange mutliplier):
    pT_p = p' * p  # (2k×2k)
    Λ = sylvester(pT_p, pT_p, h(A) ./ 2)

    Y[:, :] = A .- Jp * (Λ .- Λ')
    return Y
end

@doc raw"""
    rand(M::SymplecticStiefel; vector_at=nothing, σ = 1.0)

Generate a random point ``p ∈ \mathrm{SpSt}(2n, 2k)`` or
a random tangent vector ``X ∈ T_p\mathrm{SpSt}(2n, 2k)``
if `vector_at` is set to a point ``p ∈ \mathrm{Sp}(2n)``.

A random point on ``\mathrm{SpSt}(2n, 2k)`` is found by first generating a
random point on the symplectic manifold ``\mathrm{Sp}(2n)``,
and then projecting onto the Symplectic Stiefel manifold using the
[`canonical_project`](@ref) ``π_{\mathrm{SpSt}(2n, 2k)}``.
That is, ``p = π_{\mathrm{SpSt}(2n, 2k)}(p_{\mathrm{Sp}})``.

To generate a random tangent vector in ``T_p\mathrm{SpSt}(2n, 2k)``
this code exploits the second tangent vector space parametrization of
[`SymplecticStiefel`](@ref), that any ``X ∈ T_p\mathrm{SpSt}(2n, 2k)``
can be written as ``X = pΩ_X + p^sB_X``.
To generate random tangent vectors at ``p`` then, this function sets ``B_X = 0``
and generates a random Hamiltonian matrix ``Ω_X ∈ \mathfrak{sp}(2n,F)`` with
Frobenius norm of `σ` before returning ``X = pΩ_X``.
"""
rand(M::SymplecticStiefel; σ::Real = 1.0, kwargs...)

function Random.rand!(
        rng::AbstractRNG,
        M::SymplecticStiefel,
        pX;
        vector_at = nothing,
        σ::Real = 1.0,
    )
    n, k = get_parameter(M.size)
    if vector_at === nothing
        canonical_project!(M, pX, rand(rng, SymplecticMatrices(2n); σ = σ))
        return pX
    else
        return random_vector!(rng, M, pX, vector_at; σ = σ)
    end
end

function random_vector!(rng, M::SymplecticStiefel, X, p; σ = 1.0)
    k = get_parameter(M.size)[2]
    Ω = @view(X[1:(2k), 1:(2k)]) # use this memory
    rand!(rng, HamiltonianMatrices(2k), Ω; σ = σ)
    X .= p * Ω
    return X
end

@doc raw"""
    retract(::SymplecticStiefel, p, X, ::CayleyRetraction)
    retract!(::SymplecticStiefel, q, p, X, ::CayleyRetraction)

Compute the Cayley retraction on the Symplectic Stiefel manifold,
from `p` along `X` (computed inplace of `q`).

Given a point ``p ∈ \mathrm{SpSt}(2n, 2k)``, every tangent vector
``X ∈ T_p\mathrm{SpSt}(2n, 2k)`` is of the form
``X = \tilde{\Omega}p``, with
````math
    \tilde{\Omega} = \left(I_{2n} - \frac{1}{2}pp^+\right)Xp^+ -
                     pX^+\left(I_{2n} - \frac{1}{2}pp^+\right) ∈ ℝ^{2n×2n},
````
as shown in Proposition 3.5 of [BendokatZimmermann:2021](@cite).
Using this representation of ``X``, the Cayley retraction
on ``\mathrm{SpSt}(2n, 2k)`` is defined pointwise as
````math
    \mathcal{R}_p(X) = \operatorname{cay}\left(\frac{1}{2}\tilde{\Omega}\right)p.
````
The operator ``\operatorname{cay}(A) = (I - A)^{-1}(I + A)`` is the Cayley transform.

However, the computation of an ``2n×2n`` matrix inverse in the expression
above can be reduced down to inverting a ``2k×2k`` matrix due to Proposition
5.2 of [BendokatZimmermann:2021](@cite).

Let ``A = p^+X`` and ``H = X - pA``. Then an equivalent expression for the Cayley
retraction defined pointwise above is

```math
  \mathcal{R}_p(X) = -p + (H + 2p)(H^+H/4 - A/2 + I_{2k})^{-1}.
```

This expression can be computed in place of `q`.
"""
retract(::SymplecticStiefel, p, X, ::CayleyRetraction)

function ManifoldsBase.retract_cayley!(M::SymplecticStiefel, q, p, X)
    # Define intermediate matrices for later use:
    A = symplectic_inverse_times(M, p, X)
    H = X .- p * A  # Allocates (2n×2k).
    # A = I - A/2 + H^{+}H/4:
    A .= (symplectic_inverse_times(M, H, H) ./ 4) .- (A ./ 2)
    Manifolds.add_scaled_I!(A, 1.0)
    # Reuse 'H' memory:
    H .= H .+ 2 .* p
    r = lu!(A)
    q .= (-).(p) .+ rdiv!(H, r)
    return q
end

@doc raw"""
    X = riemannian_gradient(::SymplecticStiefel, f, p, Y; embedding_metric::EuclideanMetric=EuclideanMetric())
    riemannian_gradient!(::SymplecticStiefel, f, X, p, Y; embedding_metric::EuclideanMetric=EuclideanMetric())

Compute the riemannian gradient `X` of `f` on [`SymplecticStiefel`](@ref)  at a point `p`,
provided that the gradient of the function ``\tilde f``, which is `f` continued into the embedding
is given by `Y`. The metric in the embedding is the Euclidean metric.

The manifold gradient `X` is computed from `Y` as

```math
    X = Yp^{\mathrm{T}}p + J_{2n}pY^{\mathrm{T}}J_{2n}p,
```

where ``J_{2n} = \begin{bmatrix} 0_n & I_n \\ -I_n & 0_n \end{bmatrix}`` denotes the [`SymplecticElement`](@ref).


"""
function riemannian_gradient(::SymplecticStiefel, p, Y)
    Jp = SymplecticElement(p, Y) * p
    return Y * (p' * p) .+ Jp * (Y' * Jp)
end

function riemannian_gradient!(
        ::SymplecticStiefel,
        X,
        p,
        Y;
        embedding_metric::EuclideanMetric = EuclideanMetric(),
    )
    Jp = SymplecticElement(p, Y) * p
    X .= Y * (p' * p) .+ Jp * (Y' * Jp)
    return X
end

function Base.show(io::IO, ::SymplecticStiefel{ℝ, TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "SymplecticStiefel($(2n), $(2k))")
end
function Base.show(io::IO, M::SymplecticStiefel{ℝ, Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "SymplecticStiefel($(2n), $(2k); parameter=:field)")
end

@doc raw"""
    symplectic_inverse_times(::SymplecticStiefel, p, q)
    symplectic_inverse_times!(::SymplecticStiefel, A, p, q)

Directly compute the symplectic inverse of ``p ∈ \mathrm{SpSt}(2n, 2k)``,
multiplied with ``q ∈ \mathrm{SpSt}(2n, 2k)``.
That is, this function efficiently computes
``p^+q = (J_{2k}p^{\mathrm{T}}J_{2n})q ∈ ℝ^{2k×2k}``,
where ``J_{2n}, J_{2k}`` are the [`SymplecticElement`](@ref)
of sizes ``2n×2n`` and ``2k×2k`` respectively.

This function performs this common operation without allocating more than
a ``2k×2k`` matrix to store the result in, or in the case of the in-place
function, without allocating memory at all.
"""
function symplectic_inverse_times(M::SymplecticStiefel, p, q)
    n, k = get_parameter(M.size)
    A = similar(p, (2k, 2k))
    return symplectic_inverse_times!(M, A, p, q)
end

function symplectic_inverse_times!(M::SymplecticStiefel, A, p, q)
    n, k = get_parameter(M.size)
    # we write p = [p1 p2; p3 p4] (and q, too), then
    p1 = @view(p[1:n, 1:k])
    p2 = @view(p[1:n, (k + 1):(2k)])
    p3 = @view(p[(n + 1):(2n), 1:k])
    p4 = @view(p[(n + 1):(2n), (k + 1):(2k)])
    q1 = @view(q[1:n, 1:k])
    q2 = @view(q[1:n, (k + 1):(2k)])
    q3 = @view(q[(n + 1):(2n), 1:k])
    q4 = @view(q[(n + 1):(2n), (k + 1):(2k)])
    A1 = @view(A[1:k, 1:k])
    A2 = @view(A[1:k, (k + 1):(2k)])
    A3 = @view(A[(k + 1):(2k), 1:k])
    A4 = @view(A[(k + 1):(2k), (k + 1):(2k)])
    mul!(A1, p4', q1)           # A1  = p4'q1
    mul!(A1, p2', q3, -1, 1)    # A1 -= p2'p3
    mul!(A2, p4', q2)           # A2  = p4'q2
    mul!(A2, p2', q4, -1, 1)    # A2 -= p2'q4
    mul!(A3, p1', q3)           # A3  = p1'q3
    mul!(A3, p3', q1, -1, 1)    # A3 -= p3'q1
    mul!(A4, p1', q4)           # A4  = p1'q4
    mul!(A4, p3', q2, -1, 1)    #A4  -= p3'q2
    return A
end

@doc raw"""
    exp(M::Stiefel, p, X)

Compute the exponential map on the [`Stiefel`](@ref)`{n,k,𝔽}`() manifold `M`
emanating from `p` in tangent direction `X`.

````math
\exp_p X = \begin{pmatrix}
   p\\X
 \end{pmatrix}
 \operatorname{Exp}
 \left(
 \begin{pmatrix} p^{\mathrm{H}}X & - X^{\mathrm{H}}X\\
 I_n & p^{\mathrm{H}}X\end{pmatrix}
 \right)
\begin{pmatrix}  \exp( -p^{\mathrm{H}}X) \\ 0_n\end{pmatrix},
````

where ``\operatorname{Exp}`` denotes matrix exponential,
``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or Hermitian, and ``I_k`` and
``0_k`` are the identity matrix and the zero matrix of dimension ``k×k``, respectively.
"""
exp(::Stiefel, ::Any...)

function exp!(M::Stiefel, q, p, X)
    n, k = get_parameter(M.size)
    A = p' * X
    B = exp([A -X' * X; I A])
    @views begin # COV_EXCL_LINE
        r = p * B[1:k, 1:k]
        mul!(r, X, B[(k + 1):(2 * k), 1:k], true, true)
    end
    mul!(q, r, exp(-A))
    return q
end

@doc raw"""
    get_basis(M::Stiefel{ℝ}, p, B::DefaultOrthonormalBasis)

Create the default basis using the parametrization for any ``X ∈ T_p\mathcal M``.
Set ``p_\bot \in ℝ^{n×(n-k)}`` the matrix such that the ``n×n`` matrix of the common
columns ``[p\ p_\bot]`` is an ONB.
For any skew symmetric matrix ``a ∈ ℝ^{k×k}`` and any ``b ∈ ℝ^{(n-k)×k}`` the matrix

````math
X = pa + p_\bot b ∈ T_p\mathcal M
````

and we can use the ``\frac{1}{2}k(k-1) + (n-k)k = nk-\frac{1}{2}k(k+1)`` entries
of ``a`` and ``b`` to specify a basis for the tangent space.
using unit vectors for constructing both
the upper matrix of ``a`` to build a skew symmetric matrix and the matrix b, the default
basis is constructed.

Since ``[p\ p_⊥]`` is an automorphism on ``ℝ^{n×p}`` the elements of ``a`` and ``b`` are
orthonormal coordinates for the tangent space. To be precise exactly one element in the upper
triangular entries of ``a`` is set to ``1`` its symmetric entry to ``-1`` and we normalize with
the factor ``\frac{1}{\sqrt{2}}`` and for ``b`` one can just use unit vectors reshaped to a matrix
to obtain orthonormal set of parameters.
"""
get_basis(M::Stiefel{ℝ}, p, B::DefaultOrthonormalBasis{ℝ, TangentSpaceType})

function _get_basis(
        M::Stiefel{ℝ},
        p,
        B::DefaultOrthonormalBasis{ℝ, TangentSpaceType};
        kwargs...,
    )
    return CachedBasis(B, get_vectors(M, p, B))
end

function get_coordinates_orthonormal!(M::Stiefel{ℝ}, c, p, X, N::RealNumbers)
    V = get_vectors(M, p, DefaultOrthonormalBasis(N))
    c .= inner.(Ref(M), Ref(p), V, Ref(X))
    return c
end

function get_vector_orthonormal!(M::Stiefel{ℝ}, X, p, c, N::RealNumbers)
    V = get_vectors(M, p, DefaultOrthonormalBasis(N))
    zero_vector!(M, X, p)
    length(c) < length(V) && error(
        "Coordinate vector too short. Expected $(length(V)), but only got $(length(c)) entries.",
    )
    @inbounds for i in 1:length(V)
        X .+= c[i] .* V[i]
    end
    return X
end

function get_vectors(M::Stiefel{ℝ}, p, ::DefaultOrthonormalBasis{ℝ, TangentSpaceType})
    n, k = get_parameter(M.size)
    p⊥ = nullspace([p zeros(n, n - k)])
    an = div(k * (k - 1), 2)
    bn = (n - k) * k
    V = vcat(
        [p * vec2skew(1 / sqrt(2) .* _euclidean_unit_vector(an, i), k) for i in 1:an],
        [p⊥ * reshape(_euclidean_unit_vector(bn, j), (n - k, k)) for j in 1:bn],
    )
    return V
end

_euclidean_unit_vector(n, i) = [k == i ? 1.0 : 0.0 for k in 1:n]

@doc raw"""
    injectivity_radius(M::Stiefel)

Return the injectivity radius for the [`Stiefel`](@ref) manifold `M`,
which is globally ``π`` [ZimmermannStoye:2024](@cite).
"""
injectivity_radius(::Stiefel) = π

@doc raw"""
    inverse_retract(M::Stiefel, p, q, method::ProjectionInverseRetraction)

Compute a projection-based inverse retraction.

The inverse retraction is computed by projecting the logarithm map in the embedding to the
tangent space at ``p``.
"""
inverse_retract(::Stiefel, ::Any, ::Any, ::ProjectionInverseRetraction)

function inverse_retract_project!(M::Stiefel, X, p, q)
    X .= q .- p
    project!(M, X, p, X)
    return X
end

function log!(M::Stiefel{ℝ}, X, p, q)
    MM = MetricManifold(M, StiefelSubmersionMetric(-1 // 2))
    log!(MM, X, p, q)
    return X
end

@doc raw"""
    project(M::Stiefel, p)

Projects `p` from the embedding onto the [`Stiefel`](@ref) `M`, i.e. compute `q`
as the polar decomposition of ``p`` such that ``q^{\mathrm{H}}q`` is the identity,
where ``⋅^{\mathrm{H}}`` denotes the hermitian, i.e. complex conjugate transposed.
"""
project(::Stiefel, ::Any, ::Any)

function project!(::Stiefel, q, p)
    s = svd(p)
    mul!(q, s.U, s.Vt)
    return q
end

@doc raw"""
    project(M::Stiefel, p, X)

Project `X` onto the tangent space of `p` to the [`Stiefel`](@ref) manifold `M`.
The formula reads

````math
\operatorname{proj}_{T_p\mathcal M}(X) = X - p \operatorname{Sym}(p^{\mathrm{H}}X),
````

where ``\operatorname{Sym}(q)`` is the symmetrization of ``q``, e.g. by
``\operatorname{Sym}(q) = \frac{q^{\mathrm{H}}+q}{2}``.
"""
project(::Stiefel, ::Any...)

function project!(::Stiefel, Y, p, X)
    A = p' * X
    T = eltype(Y)
    copyto!(Y, X)
    mul!(Y, p, A + A', T(-0.5), true)
    return Y
end

"""
    retract(M::Stiefel, p, X, method::ProjectionRetraction)

Compute a projection-based retraction.

The retraction is computed by projecting the exponential map in the embedding to `M`.
"""
retract(::Stiefel, ::Any, ::Any, ::ProjectionRetraction)

function ManifoldsBase.retract_project!(M::Stiefel, q, p, X)
    return ManifoldsBase.retract_project_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_project_fused!(M::Stiefel, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

@doc raw"""
    Y = riemannian_Hessian(M::Stiefel, p, G, H, X)
    riemannian_Hessian!(M::Stiefel, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

Here, we adopt Eq. (5.6) [Nguyen:2023](@cite), where we use for the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
``α_0=α_1=1`` in their formula. Then the formula reads

```math
    \operatorname{Hess}f(p)[X]
    =
    \operatorname{proj}_{T_p\mathcal M}\Bigl(
        ∇^2f(p)[X] - \frac{1}{2} X \bigl((∇f(p))^{\mathrm{H}}p + p^{\mathrm{H}}∇f(p)\bigr)
    \Bigr).
```

Compared to Eq. (5.6) also the metric conversion simplifies to the identity.
"""
riemannian_Hessian(M::Stiefel, p, G, H, X)

function riemannian_Hessian!(M::Stiefel, Y, p, G, H, X)
    Z = symmetrize(G' * p)
    project!(M, Y, p, H - X * Z)
    return Y
end

function vector_transport_to!(M::Stiefel, Y, ::Any, X, q, ::ProjectionTransport)
    return project!(M, Y, q, X)
end

@doc raw"""
    Weingarten(M::Stiefel, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Stiefel`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

The formula is due to [AbsilMahonyTrumpf:2013](@cite) given by

```math
\mathcal W_p(X,V) = -Xp^{\mathrm{H}}V - \frac{1}{2}p\bigl(X^\mathrm{H}V + V^{\mathrm{H}}X\bigr)
```
"""
Weingarten(::Stiefel, p, X, V)

function Weingarten!(::Stiefel, Y, p, X, V)
    Z = symmetrize(X' * V)
    Y .= -X * p' * V .- p * Z
    return Y
end

@doc raw"""
    check_point(M::SymplecticGrassmann, p::ProjectorPoint; kwargs...)

Check whether `p` is a valid point on the [`SymplecticGrassmann`](@ref),
``\operatorname{SpGr}(2n, 2k)``, that is a proper symplectic projection:

* ``p^2 = p``, that is ``p`` is a projection
* ``\operatorname{rank}(p) = 2k``, that is, the supspace projected onto is of right dimension
* ``p^+ = p`` the projection is symplectic.
"""
function check_point(M::SymplecticGrassmann, p::ProjectorPoint; kwargs...)
    n, k = get_parameter(M.size)
    c = p.value * p.value
    if !isapprox(c, p.value; kwargs...)
        return DomainError(
            norm(c - p.value),
            "The poin $(p) is not equal to its square $c, so it does not lie on $M.",
        )
    end
    if !isapprox(p.value, symplectic_inverse(p.value); kwargs...)
        return DomainError(
            norm(p.value - symplectic_inverse(p.value)),
            "The point $(p) is not equal to its symplectic inverse p^+, so it does not lie on $M.",
        )
    end
    k2 = rank(p.value; kwargs...)
    if k2 != 2 * k
        return DomainError(
            k2,
            "The point $(p) is a projector of rank $k2 and not of rank $(2 * k), so it does not lie on $(M).",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::SymplecticGrassmann, p::ProjectorPoint, X::ProjectorTangentVector; kwargs...)

Check whether `X` is a valid tangent vector at `p` on the [`SymplecticGrassmann`](@ref),
``\operatorname{SpGr}(2n, 2k)`` manifold by verifying that it

* ``X^+ = X``
* ``X = Xp + pX``

For details see Proposition 4.2 in [BendokatZimmermann:2021](@cite) and the definition of ``\mathfrak{sp}_P(2n)`` before,
especially the ``\bar{Ω}``, which is the representation for ``X`` used here.
"""
function check_vector(
        M::SymplecticGrassmann,
        p::ProjectorPoint,
        X::ProjectorTangentVector;
        kwargs...,
    )
    n, k = get_parameter(M.size)
    if !isapprox((Hamiltonian(X.value)^+).value, X.value; kwargs...)
        return DomainError(
            norm((Hamiltonian(X.value)^+).value - X.value),
            (
                "The matrix X is not in the tangent space at $p of $M, since X is not equal to ist symplectic inverse."
            ),
        )
    end
    XppX = X.value * p.value .+ p.value * X.value
    if !isapprox(X.value, XppX; kwargs...)
        return DomainError(
            norm(XppX - X.value),
            (
                "The matrix X is not in the tangent space at $p of $M, since X is not equal to Xp + pX."
            ),
        )
    end
    return nothing
end

embed!(::SymplecticGrassmann, q, p::ProjectorPoint) = copyto!(q, p.value)
function embed!(::SymplecticGrassmann, Y, p::ProjectorPoint, X::ProjectorTangentVector)
    return copyto!(Y, X.value)
end
embed(::SymplecticGrassmann, p::ProjectorPoint) = p.value
embed(::SymplecticGrassmann, p::ProjectorPoint, X::ProjectorTangentVector) = X.value

function get_embedding(
        ::SymplecticGrassmann{ℝ, TypeParameter{Tuple{n, k}}},
        ::Type{<:ProjectorPoint},
    ) where {n, k}
    return Euclidean(2n, 2n)
end
function get_embedding(M::SymplecticGrassmann{ℝ, Tuple{Int, Int}}, ::Type{<:ProjectorPoint})
    n, _ = get_parameter(M.size)
    return Euclidean(2n, 2n; parameter = :field)
end
function ManifoldsBase.get_embedding_type(::SymplecticGrassmann{ℝ}, ::Type{<:ProjectorPoint})
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

@doc raw"""
    ProjectorPoint <: AbstractManifoldPoint

A type to represent points on a manifold [`Grassmann`](@ref) that are orthogonal projectors,
i.e. a matrix ``p ∈ \mathbb F^{n,n}`` projecting onto a ``k``-dimensional subspace.
"""
struct ProjectorPoint{T <: AbstractMatrix} <: AbstractManifoldPoint
    value::T
end

@doc raw"""
    ProjectorTangentVector <: AbstractTangentVector

A type to represent tangent vectors to points on a [`Grassmann`](@ref) manifold that are orthogonal projectors.
"""
struct ProjectorTangentVector{T <: AbstractMatrix} <: AbstractTangentVector
    value::T
end

ManifoldsBase.@manifold_vector_forwards ProjectorTangentVector value
ManifoldsBase.@manifold_element_forwards ProjectorPoint value

@doc raw"""
    check_point(::Grassmann, p::ProjectorPoint; kwargs...)

Check whether an orthogonal projector is a point from the [`Grassmann`](@ref)`(n,k)` manifold,
i.e. the [`ProjectorPoint`](@ref) ``p ∈ \mathbb F^{n×n}``, ``\mathbb F ∈ \{\mathbb R, \mathbb C\}``
has to fulfill ``p^{\mathrm{T}} = p``, ``p^2=p``, and ``\operatorname{rank} p = k`.
"""
function check_point(M::Grassmann, p::ProjectorPoint; kwargs...)
    n, k = get_parameter(M.size)
    c = p.value * p.value
    if !isapprox(c, p.value; kwargs...)
        return DomainError(
            norm(c - p.value),
            "The point $(p) is not equal to its square $c, so it does not lie on $M.",
        )
    end
    if !isapprox(p.value, transpose(p.value); kwargs...)
        return DomainError(
            norm(p.value - transpose(p.value)),
            "The point $(p) is not equal to its transpose, so it does not lie on $M.",
        )
    end
    k2 = rank(p.value; kwargs...)
    if k2 != k
        return DomainError(
            k2,
            "The point $(p) is a projector of rank $k2 and not of rank $k, so it does not lie on $(M).",
        )
    end
    return nothing
end

@doc raw"""
    check_size(M::Grassmann, p::ProjectorPoint; kwargs...)

Check that the [`ProjectorPoint`](@ref) is of correct size, i.e. from ``\mathbb F^{n×n}``
"""
function check_size(M::Grassmann, p::ProjectorPoint; kwargs...)
    return check_size(get_embedding(M, typeof(p)), p.value; kwargs...)
end

@doc raw"""
    check_vector(::Grassmann, p::ProjectorPoint, X::ProjectorTangentVector; kwargs...)

Check whether the [`ProjectorTangentVector`](@ref) `X` is from the tangent space ``T_p\operatorname{Gr}(n,k) ``
at the [`ProjectorPoint`](@ref) `p` on the [`Grassmann`](@ref) manifold ``\operatorname{Gr}(n,k)``.
This means that `X` has to be symmetric and that

```math
Xp + pX = X
```

must hold, where the `kwargs` can be used to check both for symmetrix of ``X```
and this equality up to a certain tolerance.
"""
function check_vector(M::Grassmann, p::ProjectorPoint, X::ProjectorTangentVector; kwargs...)
    if !isapprox(X.value, X.value'; kwargs...)
        return DomainError(
            norm(X.value - X.value'),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not symmetric.",
        )
    end
    if !isapprox(X.value * p.value + p.value * X.value, X.value; kwargs...)
        return DomainError(
            norm(X.value * p.value + p.value * X.value - X.value),
            "The matrix $(X) does not lie in the tangent space of $(p) on $(M), since X*p + p*X is not equal to X.",
        )
    end
    return nothing
end

embed!(::Grassmann, q, p::ProjectorPoint) = copyto!(q, p.value)
embed!(::Grassmann, Y, p, X::ProjectorTangentVector) = copyto!(Y, X.value)
embed(::Grassmann, p::ProjectorPoint) = p.value
embed(::Grassmann, p, X::ProjectorTangentVector) = X.value

@doc raw"""
    get_embedding(M::Grassmann, ::Type{<:ProjectorPoint})

Return the embedding of the [`ProjectorPoint`](@ref) representation of the [`Grassmann`](@ref)
manifold, i.e. the Euclidean space ``\mathbb F^{n×n}``.
"""
function get_embedding(
        ::Grassmann{𝔽, TypeParameter{Tuple{n, k}}}, ::Type{<:ProjectorPoint},
    ) where {n, k, 𝔽}
    return Euclidean(n, n; field = 𝔽)
end
function get_embedding(
        M::Grassmann{𝔽, Tuple{Int, Int}}, ::Type{<:ProjectorPoint},
    ) where {𝔽}
    n, k = get_parameter(M.size)
    return Euclidean(n, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_forwarding_type(::Grassmann, f, ::Type{<:ProjectorPoint})
    return ManifoldsBase.EmbeddedForwardingType()
end

@doc raw"""
    representation_size(M::Grassmann, p::ProjectorPoint)

Return the representation size or matrix dimension of a point on the [`Grassmann`](@ref)
`M` when using [`ProjectorPoint`](@ref)s, i.e. ``(n,n)``.
"""
function representation_size(M::Grassmann, ::ProjectorPoint)
    n, k = get_parameter(M.size)
    return (n, n)
end

@doc raw"""
    canonical_project!(M::Grassmann, q::ProjectorPoint, p)

Compute the canonical projection ``π(p)`` from the [`Stiefel`](@ref) manifold onto the [`Grassmann`](@ref)
manifold when represented as [`ProjectorPoint`](@ref), i.e.

```math
    π^{\mathrm{SG}}(p) = pp^{\mathrm{T}}
```
"""
function canonical_project!(::Grassmann, q::ProjectorPoint, p)
    q.value .= p * p'
    return q
end
function canonical_project!(M::Grassmann, q::ProjectorPoint, p::StiefelPoint)
    return canonical_project!(M, q, p.value)
end
function allocate_result(M::Grassmann, ::typeof(canonical_project), p::StiefelPoint)
    n, k = get_parameter(M.size)
    return ProjectorPoint(allocate(p.value, (n, n)))
end

@doc raw"""
    diff_canonical_project!(M::Grassmann, q::ProjectorPoint, p)

Compute the differential of canonical projection ``π(p)`` from the [`Stiefel`](@ref) manifold onto the [`Grassmann`](@ref)
manifold when represented as [`ProjectorPoint`](@ref), i.e.

```math
    Dπ^{\mathrm{SG}}(p)[X] = Xp^{\mathrm{T}} + pX^{\mathrm{T}}
```
"""
function diff_canonical_project!(::Grassmann, Y::ProjectorTangentVector, p, X)
    Xpt = X * p'
    Y.value .= Xpt .+ Xpt'
    return Y
end
function diff_canonical_project!(
        M::Grassmann,
        Y::ProjectorTangentVector,
        p::StiefelPoint,
        X::StiefelTangentVector,
    )
    diff_canonical_project!(M, Y, p.value, X.value)
    return Y
end

@doc raw"""
    exp(M::Grassmann, p::ProjectorPoint, X::ProjectorTangentVector)

Compute the exponential map on the [`Grassmann`](@ref) as

```math
    \exp_pX = \operatorname{Exp}([X,p])p\operatorname{Exp}(-[X,p]),
```
where ``\operatorname{Exp}`` denotes the matrix exponential and ``[A,B] = AB-BA`` denotes the matrix commutator.

For details, see Proposition 3.2 in [BendokatZimmermannAbsil:2020](@cite).
"""
exp(M::Grassmann, p::ProjectorPoint, X::ProjectorTangentVector)

function ManifoldsBase.get_forwarding_type(::Grassmann, ::typeof(exp), ::Type{<:ProjectorPoint})
    return ManifoldsBase.StopForwardingType()
end

function exp!(::Grassmann, q::ProjectorPoint, p::ProjectorPoint, X::ProjectorTangentVector)
    xppx = X.value * p.value - p.value * X.value
    exp_xppx = exp(xppx)
    q.value .= exp_xppx * p.value / exp_xppx
    return q
end
@doc raw"""
    horizontal_lift(N::Stiefel{n,k}, q, X::ProjectorTangentVector)

Compute the horizontal lift of `X` from the tangent space at ``p=π(q)``
on the [`Grassmann`](@ref) manifold, i.e.

```math
Y = Xq ∈ T_q\mathrm{St}(n,k)
```

"""
horizontal_lift(::Stiefel, q, X::ProjectorTangentVector)

horizontal_lift!(::Stiefel, Y, q, X::ProjectorTangentVector) = copyto!(Y, X.value * q)

@doc raw"""
    parallel_transport_direction(
        M::Grassmann,
        p::ProjectorPoint,
        X::ProjectorTangentVector,
        d::ProjectorTangentVector
    )

Compute the parallel transport of `X` from the tangent space at `p` into direction `d`,
i.e. to ``q=\exp_pd``. The formula is given in Proposition 3.5 of [BendokatZimmermannAbsil:2020](@cite) as

```math
\mathcal{P}_{q ← p}(X) = \operatorname{Exp}([d,p])X\operatorname{Exp}(-[d,p]),
```

where ``\operatorname{Exp}`` denotes the matrix exponential and ``[A,B] = AB-BA`` denotes the matrix commutator.
"""
function parallel_transport_direction(
        M::Grassmann,
        p::ProjectorPoint,
        X::ProjectorTangentVector,
        d::ProjectorTangentVector,
    )
    Y = allocate_result(M, vector_transport_direction, X, p, d)
    parallel_transport_direction!(M, Y, p, X, d)
    return Y
end

function parallel_transport_direction!(
        ::Grassmann,
        Y::ProjectorTangentVector,
        p::ProjectorPoint,
        X::ProjectorTangentVector,
        d::ProjectorTangentVector,
    )
    dppd = d.value * p.value - p.value * d.value
    exp_dppd = exp(dppd)
    Y.value .= exp_dppd * X.value / exp_dppd
    return Y
end

Base.show(io::IO, p::ProjectorPoint) = print(io, "ProjectorPoint($(p.value))")
function Base.show(io::IO, X::ProjectorTangentVector)
    return print(io, "ProjectorTangentVector($(X.value))")
end

using LinearAlgebra, Manifolds, ManifoldsBase, Random, Test


@testset "Matrices of Determinant 1" begin
    # Real case
    M = DeterminantOneMatrices(2)
    p = [1.0 0.0; 0.0 1.0]
    q = [10.0 0.0; 0.0 0.1]
    pf = [2.0 0.0; 0.0 1.0]
    qf = [1.0 0.0; 0.0 0.0]
    X = [0.0 0.23; -0.14 0.0]
    Y = [0.0 -0.5; 0.5 0.0]
    Xf = [1.0 1.1; 1.2 0.0]

    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [get_embedding, is_point, is_vector, manifold_dimension, project, embed, rand, repr],
            :Points => [p, q], :Vectors => [X, Y],
            :InvalidPoints => [pf, qf], :InvalidVectors => [Xf],
            :EmbeddedPoints => [pf], :EmbeddedVectors => [Xf],
        ),
        # Expectations
        Dict(
            :manifold_dimension => 3,
            repr => "DeterminantOneMatrices(2, ℝ)",
            get_embedding => Euclidean(2, 2),
        ),
    )
    # Complex case
    Mc = DeterminantOneMatrices(2, ℂ)
    pc = [1.0im 0.0; 0.0 -1.0im]
    qc = [10.0im 0.0; 0.0 -0.1im]
    Xc = [0.0 0.23im; -0.14 0.0]
    Yc = [0.0 -0.5im; 0.5im 0.0]
    pcf = [10.0 0.0; 0.0 0.0]
    qcf = [2.0 0.0; 0.0 1.0]
    Xf = [1.0 + 2.0im 1.1 + 0.1im; 1.2 0.0]

    Manifolds.Test.test_manifold(
        Mc,
        Dict(
            :Functions => [get_embedding, is_point, is_vector, manifold_dimension, rand],
            :Points => [pc, qc], :Vectors => [Xc, Yc],
            :InvalidPoints => [pcf, qcf], :InvalidVectors => [Xf],
            :EmbeddedPoints => [pcf], :EmbeddedVectors => [Xf],
        ),
        # Expectations
        Dict(
            :manifold_dimension => 7,
            repr => "DeterminantOneMatrices(2, ℂ)",
            get_embedding => Euclidean(2, 2; field = ℂ),
        ),
    )


    # Parameter
    Manifolds.Test.test_manifold(
        DeterminantOneMatrices(2; parameter = :field),
        Dict(
            :Functions => [get_embedding, is_point, is_vector, manifold_dimension, project, embed, rand, repr],
            :Points => [p, q], :Vectors => [X, Y],
            :InvalidPoints => [pf, qf], :InvalidVectors => [Xf],
            :EmbeddedPoints => [p], :EmbeddedVectors => [X],
        ),
        # Expectations
        Dict(
            :manifold_dimension => 3,
            repr => "DeterminantOneMatrices(2, ℝ; parameter=:field)",
            get_embedding => Euclidean(2, 2; parameter = :field),
        ),
    )

    @testset "rng test" begin
        M = DeterminantOneMatrices(2)
        pX = zeros(2, 2)
        Manifolds._ensure_nonzero_rng_determinant!(
            Random.default_rng(), get_embedding(M), pX,
        )
        @test abs(det(pX)) > 1.0e-8
    end
end

module ManifoldsBoundaryValueDiffEqExt

using Manifolds
using ManifoldsBase

using Manifolds: affine_connection
import Manifolds: solve_chart_log_bvp, estimate_distance_from_bvp

using BoundaryValueDiffEq

function chart_log_problem!(du, u, params, t)
    M, A, i = params
    mid = div(length(u), 2)
    a = u[1:mid]
    dx = u[(mid + 1):end]
    ddx = -affine_connection(M, A, i, a, dx, dx)
    du[1:mid] .= dx
    du[(mid + 1):end] .= ddx
    return du
end

"""
    solve_chart_log_bvp(
        M::AbstractManifold, a1, a2, A::AbstractAtlas, i;
        solver=MIRK4(), dt::Real=0.05, kwargs...
    )

Solve the BVP corresponding to geodesic calculation on [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`) M,
between points with parameters `a1` and `a2` in a chart `i` of an [`AbstractAtlas`](@ref) `A`
using solver `solver`. Geodesic γ is sampled at time interval `dt`, with γ(0) = a1 and
γ(1) = a2.
"""
function solve_chart_log_bvp(
        M::AbstractManifold, a1, a2, A::AbstractAtlas, i;
        solver = MIRK4(), dt::Real = 0.05, kwargs...
    )
    tspan = (0.0, 1.0)
    function bc1!(residual, u, p, t)
        mid = div(length(u[1]), 2)
        residual[1:mid] = u[1][1:mid] - a1
        residual[(mid + 1):end] = u[end][1:mid] - a2
        return residual
    end
    u0 = [vcat(a1, zero(a1)), vcat(a2, zero(a1))]
    bvp1 = BVProblem(chart_log_problem!, bc1!, u0, tspan, (M, A, i))
    sol1 = solve(bvp1, solver, dt = dt)
    return sol1
end

"""
    estimate_distance_from_bvp(
        M::AbstractManifold, a1, a2, A::AbstractAtlas, i;
        solver=MIRK4(), dt=0.05, kwargs...
    )

Estimate distance between points on [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`) M with parameters `a1` and
`a2` in chart `i` of [`AbstractAtlas`](@ref) `A` using solver `solver`, employing
[`solve_chart_log_bvp`](@ref) to solve the geodesic BVP.
"""
function estimate_distance_from_bvp(
        M::AbstractManifold, a1, a2, A::AbstractAtlas, i;
        solver = MIRK4(), dt = 0.05, kwargs...
    )
    sol = solve_chart_log_bvp(M, a1, a2, A, i; solver, dt, kwargs...)
    mid = length(a1)
    Xc = sol.u[1][(mid + 1):end]
    return norm(M, A, i, a1, Xc)
end

end

@doc raw"""
    Circle{𝔽} <: AbstractManifold{𝔽}

The circle ``𝕊^1`` is a manifold here represented by
real-valued points in ``[-π,π)`` or complex-valued points ``z ∈ ℂ`` of absolute value
``\lvert z\rvert = 1``.
# Constructor

    Circle(𝔽=ℝ)

Generate the `ℝ`-valued Circle represented by angles, which
alternatively can be set to use the [`AbstractNumbers`](@extref ManifoldsBase number-system) `𝔽=ℂ` to obtain the circle
represented by `ℂ`-valued circle of unit numbers.
"""
struct Circle{𝔽} <: AbstractManifold{𝔽} end

Circle(𝔽::AbstractNumbers = ℝ) = Circle{𝔽}()

function adjoint_Jacobi_field(::Circle{ℝ}, p, q, t, X, β::Tβ) where {Tβ}
    return X
end

@doc raw"""
    check_point(M::Circle, p)

Check whether `p` is a point on the [`Circle`](@ref) `M`.
For the real-valued case, `p` is an angle and hence it checks that ``p ∈ [-π,π)``.
for the complex-valued case, it is a unit number, ``p ∈ ℂ`` with ``\lvert p \rvert = 1``.
"""
check_point(::Circle, ::Any...)

function check_point(M::Circle{ℝ}, p; kwargs...)
    if !isapprox(sym_rem(p), p; kwargs...)
        return DomainError(
            p,
            "The point $(p) does not lie on $(M), since its is not in [-π,π).",
        )
    end
    return nothing
end
function check_point(M::Circle{ℂ}, p; kwargs...)
    if !isapprox(sum(abs.(p)), 1.0; kwargs...)
        return DomainError(
            sum(abs.(p)),
            "The point $(p) does not lie on the $(M) since its norm is not 1.",
        )
    end
    return nothing
end
check_size(::Circle, ::Number) = nothing
function check_size(M::Circle, p)
    (size(p) === () || size(p) === (1,)) && return nothing
    return DomainError(
        size(p),
        "The point $p can not belong to the $M, since it is not a number nor a vector of size (1,).",
    )
end
check_size(::Circle, ::Number, ::Number) = nothing
function check_size(M::Circle, p, X)
    (size(X) === () || size(X) === (1,)) && return nothing
    return DomainError(
        size(X),
        "The vector $X is not a tangent vector to $p on $M, since it is not a number nor a vector of size (1,).",
    )
end

"""
    check_vector(M::Circle, p, X; kwargs...)

Check whether `X` is a tangent vector in the tangent space of `p` on the
[`Circle`](@ref) `M`.
For the real-valued case represented by angles, all `X` are valid, since the tangent space is the whole real line.
For the complex-valued case `X` has to lie on the line parallel to the tangent line at `p`
in the complex plane, i.e. their inner product has to be zero.
"""
check_vector(::Circle{ℝ}, ::Any...; ::Any...)

function check_vector(M::Circle{ℝ}, p, X; kwargs...)
    return nothing
end
function check_vector(
        M::Circle{ℂ},
        p,
        X::T;
        atol::Real = sqrt(eps(real(float(number_eltype(T))))),
        kwargs...,
    ) where {T}
    if !isapprox(abs(complex_dot(p, X)), 0; atol = atol, kwargs...)
        return DomainError(
            abs(complex_dot(p, X)),
            "The value $(X) is not a tangent vector to $(p) on $(M), since it is not orthogonal in the embedding.",
        )
    end
    return nothing
end

@doc raw"""
    complex_dot(a, b)

Compute the inner product of two (complex) numbers with in the complex plane.
"""
complex_dot(a, b) = dot(map(real, a), map(real, b)) + dot(map(imag, a), map(imag, b))
complex_dot(a::Number, b::Number) = (real(a) * real(b) + imag(a) * imag(b))

function diagonalizing_projectors(M::Circle{ℝ}, p, X)
    sbv = sign(X[])
    proj = ProjectorOntoVector(M, p, @SVector [sbv == 0 ? one(sbv) : sbv])
    return ((zero(number_eltype(p)), proj),)
end

@doc raw"""
    distance(M::Circle, p, q)

Compute the distance on the [`Circle`](@ref) `M`, which is
the absolute value of the symmetric remainder of `p` and `q` for the real-valued
case and the angle between both complex numbers in the Gaussian plane for the
complex-valued case.
"""
distance(::Circle, ::Any...)
distance(::Circle{ℝ}, p::Real, q::Real) = abs(sym_rem(p - q))
distance(::Circle{ℝ}, p, q) = abs(sum(sym_rem.(p - q)))
function distance(::Circle{ℂ}, p, q)
    cosθ = complex_dot(p, q)
    T = float(real(Base.promote_eltype(p, q)))
    # abs and relative error of acos is less than sqrt(eps(T))
    -1 < cosθ < 1 - sqrt(eps(T)) / 8 && return acos(cosθ)
    # improved accuracy for q close to p or -p
    return 2 * abs(atan(norm(p - q), norm(p + q)))
end

@doc raw"""
    embed(M::Circle{ℂ}, p)

Embed a point `p` on the complex [`Circle`](@ref) `M` in the ambient space.
It returns `p`.
"""
embed(::Circle{ℂ}, p) = p

@doc raw"""
    embed(M::Circle{ℂ}, p, X)

Embed a tangent vector `X` at `p` on the complex [`Circle`](@ref) `M` in the ambient space.
It returns `X`.
"""
embed(::Circle{ℂ}, p, X) = X

@doc raw"""
    exp(M::Circle, p, X)

Compute the exponential map on the [`Circle`](@ref).
````math
\exp_p X = (p+X)_{2π},
````
where ``(⋅)_{2π}`` is the (symmetric) remainder with respect to division by ``2π``, i.e. in ``[-π,π)``.

For the complex-valued case, the same formula as for the [`Sphere`](@ref) ``𝕊^1`` is applied to values in the
complex plane.
"""
exp(::Circle, ::Any...)
Base.exp(::Circle{ℝ}, p::Real, X::Real) = sym_rem(p + X)
exp_fused(::Circle{ℝ}, p::Real, X::Real, t::Real) = sym_rem(p + t * X)
function Base.exp(M::Circle{ℂ}, p::Number, X::Number)
    θ = norm(M, p, X)
    return cos(θ) * p + usinc(θ) * X
end
function exp_fused(M::Circle{ℂ}, p::Number, X::Number, t::Number)
    θ = abs(t) * norm(M, p, X)
    return cos(θ) * p + usinc(θ) * t * X
end

exp!(::Circle{ℝ}, q, p, X) = (q .= sym_rem(p + X))
exp_fused!(::Circle{ℝ}, q, p, X, t::Number) = (q .= sym_rem(p[] + t * X[]))
function exp!(M::Circle{ℂ}, q, p, X)
    θ = norm(M, p, X)
    q .= cos(θ) * p + usinc(θ) * X
    return q
end
function exp_fused!(M::Circle{ℂ}, q, p, X, t::Number)
    θ = abs(t) * norm(M, p, X)
    q .= cos(θ) * p + usinc(θ) * t * X
    return q
end

function get_basis_diagonalizing(::Circle{ℝ}, p, B::DiagonalizingOrthonormalBasis)
    sbv = sign(B.frame_direction[])
    vs = @SVector [@SVector [sbv == 0 ? one(sbv) : sbv]]
    return CachedBasis(B, (@SVector [0]), vs)
end

get_coordinates_orthonormal(::Circle{ℝ}, p, X, ::RealNumbers) = @SVector [X[]]
get_coordinates_orthonormal(::Circle{ℝ}, p, X::AbstractArray, ::RealNumbers) = copy(vec(X))
get_coordinates_orthonormal!(::Circle{ℝ}, c, p, X, ::RealNumbers) = (c .= X)
function get_coordinates_diagonalizing(::Circle{ℝ}, p, X, B::DiagonalizingOrthonormalBasis)
    sbv = sign(B.frame_direction[])
    return X * (sbv == 0 ? one(sbv) : sbv)
end
function get_coordinates_diagonalizing!(
        M::Circle{ℝ},
        Y,
        p,
        X,
        B::DiagonalizingOrthonormalBasis,
    )
    Y[] = get_coordinates_diagonalizing(M, p, X, B)[]
    return Y
end

"""
    get_coordinates(M::Circle{ℂ}, p, X, B::DefaultOrthonormalBasis)

Return tangent vector coordinates in the Lie algebra of the [`Circle`](@ref).
"""
get_coordinates(::Circle{ℂ}, p, X, ::DefaultOrthonormalBasis{<:Any, TangentSpaceType})
function get_coordinates_orthonormal!(
        M::Circle{ℂ},
        Y,
        p,
        X,
        n::Union{RealNumbers, ComplexNumbers},
    )
    Y[] = get_coordinates_orthonormal(M, p, X, n)[]
    return Y
end
function get_coordinates_orthonormal(::Circle{ℂ}, p, X, ::Union{RealNumbers, ComplexNumbers})
    X, p = X[1], p[1]
    Xⁱ = imag(X) * real(p) - real(X) * imag(p)
    return @SVector [Xⁱ]
end

"""
    get_embedding(M::Circle{ℂ})

Get the ambient space of the complex [`Circle`](@ref) `M`, which is `ℂ`.
"""
ManifoldsBase.get_embedding(::Circle{ℂ}) = Euclidean(; field = ℂ)

get_vector_orthonormal(::Circle{ℝ}, p::StaticArray, c, ::RealNumbers) = Scalar(c[])
get_vector_orthonormal(::Circle{ℝ}, p, c, ::RealNumbers) = fill(c[])
# the method below is required for FD and AD differentiation in ManifoldDiff.jl
# if changed, make sure no tests in that repository get broken
get_vector_orthonormal(::Circle{ℝ}, p::AbstractVector, c, ::RealNumbers) = c
get_vector_orthonormal!(::Circle{ℝ}, X, p, c, ::RealNumbers) = (X .= c[])
function get_vector_diagonalizing!(M::Circle{ℝ}, X, p, c, B::DiagonalizingOrthonormalBasis)
    X[] = get_vector_diagonalizing(M, p, c, B)[]
    return X
end
function get_vector_diagonalizing(::Circle{ℝ}, p, c, B::DiagonalizingOrthonormalBasis)
    sbv = sign(B.frame_direction[])
    return c .* (sbv == 0 ? one(sbv) : sbv)
end
"""
    get_vector(M::Circle{ℂ}, p, X, B::DefaultOrthonormalBasis)

Return tangent vector from the coordinates in the Lie algebra of the [`Circle`](@ref).
"""
function get_vector_orthonormal(
        ::Circle{ℂ},
        p::StaticArray,
        c,
        ::Union{RealNumbers, ComplexNumbers},
    )
    return @SArray fill(1im * c[1] * p[1])
end
function get_vector_orthonormal(::Circle{ℂ}, p, c, ::Union{RealNumbers, ComplexNumbers})
    return fill(1im * c[1] * p[1])
end
function get_vector_orthonormal!(::Circle{ℂ}, X, p, c, ::Union{RealNumbers, ComplexNumbers})
    X .= 1im * c[1] * p[1]
    return X
end

@doc raw"""
    injectivity_radius(M::Circle[, p])

Return the injectivity radius on the [`Circle`](@ref) `M`, i.e. ``π``.
"""
injectivity_radius(::Circle) = π

@doc raw"""
    inner(M::Circle, p, X, Y)

Compute the inner product of the two tangent vectors `X,Y` from the tangent plane at `p` on
the [`Circle`](@ref) `M` using the restriction of the metric from the embedding,
i.e.

````math
g_p(X,Y) = X*Y
````

for the real case and

````math
g_p(X,Y) = Y^\mathrm{T}X
````

for the complex case interpreting complex numbers in the Gaussian plane.
"""
inner(::Circle, ::Any...)
@inline inner(::Circle{ℝ}, p, X, Y) = dot(X, Y)
@inline inner(::Circle{ℝ}, p::Real, X::Real, Y::Real) = X * Y
@inline inner(::Circle{ℂ}, p, X, Y) = complex_dot(X, Y)

# these methods make sure that we allow for checking mixed bare number and number wrapped in array
_isapprox(::Circle, x, y; kwargs...) = isapprox(x[], y[]; kwargs...)
_isapprox(::Circle, p, X, Y; kwargs...) = isapprox(X[], Y[]; kwargs...)

"""
    is_flat(::Circle)

Return true. [`Circle`](@ref) is a flat manifold.
"""
is_flat(M::Circle) = true

function jacobi_field(::Circle{ℝ}, p, q, t, X, β::Tβ) where {Tβ}
    return X
end

@doc raw"""
    log(M::Circle, p, q)

Compute the logarithmic map on the [`Circle`](@ref) `M`.
````math
\log_p q = (q-p)_{2π},
````
where ``(⋅)_{2π}`` is the (symmetric) remainder with respect to division by ``2π``, i.e. in ``[-π,π)``.

For the complex-valued case, the same formula as for the [`Sphere`](@ref) ``𝕊^1`` is applied to values in the
complex plane.
"""
log(::Circle, ::Any...)
Base.log(::Circle{ℝ}, p::Real, q::Real) = sym_rem(q - p)
function Base.log(M::Circle{ℂ}, p::Number, q::Number)
    cosθ = complex_dot(p, q)
    if cosθ ≈ -1  # appr. opposing points, return deterministic choice from set-valued log
        X = real(p) ≈ 1 ? 1im : 1 + 0im
        X = X - complex_dot(p, X) * p
        X *= π / norm(X)
    else
        cosθ = cosθ > 1 ? one(cosθ) : cosθ
        θ = acos(cosθ)
        X = (q - cosθ * p) / usinc(θ)
    end
    return project(M, p, X)
end

log!(::Circle{ℝ}, X, p, q) = (X .= sym_rem(q - p))
function log!(M::Circle{ℂ}, X, p, q)
    cosθ = complex_dot(p, q)
    if cosθ ≈ -1
        X .= sum(real.(p)) ≈ 1 ? 1.0im : 1.0 + 0.0im
        X .= X - complex_dot(p, X) * p
        X .*= π / norm(X)
    else
        cosθ = cosθ > 1 ? one(cosθ) : cosθ
        θ = acos(cosθ)
        X .= (q - cosθ * p) / usinc(θ)
    end
    return project!(M, X, p, X)
end

@doc raw"""
    manifold_dimension(M::Circle)

Return the dimension of the [`Circle`](@ref) `M`,
i.e. ``\dim(𝕊^1) = 1``.
"""
manifold_dimension(::Circle) = 1

@doc raw"""
    manifold_volume(M::Circle)

Return the volume of the [`Circle`](@ref) `M`, i.e. ``2π``.
"""
manifold_volume(::Circle) = 2 * π

@doc raw"""
    mean(M::Circle{ℝ}, x::AbstractVector[, w::AbstractWeights])

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` of points on
the [`Circle`](@ref) ``𝕊^1``, represented by real numbers, i.e. the angular mean
````math
\operatorname{atan}\Bigl( \sum_{i=1}^n w_i\sin(x_i),  \sum_{i=1}^n w_i\sin(x_i) \Bigr).
````
"""
mean(::Circle{ℝ}, ::Any)
function Statistics.mean(::Circle{ℝ}, x::AbstractVector{<:Real}; kwargs...)
    return atan(1 / length(x) * sum(sin, x), 1 / length(x) * sum(cos, x))
end
function Statistics.mean(
        ::Circle{ℝ},
        x::AbstractVector{<:Real},
        w::AbstractVector;
        kwargs...,
    )
    return atan(sum(w .* sin.(x)), sum(w .* cos.(x)))
end
@doc raw"""
    mean(M::Circle{ℂ}, x::AbstractVector[, w::AbstractWeights])

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` of points on
the [`Circle`](@ref) ``𝕊^1``, represented by complex numbers, i.e. embedded in the complex plane.
Comuting the sum
````math
s = \sum_{i=1}^n x_i
````
the mean is the angle of the complex number ``s``, so represented in the complex plane as
``\frac{s}{\lvert s \rvert}``, whenever ``s \neq 0``.

If the sum ``s=0``, the mean is not unique. For example for opposite points or equally spaced
angles.
"""
mean(::Circle{ℂ}, ::Any)
function Statistics.mean(M::Circle{ℂ}, x::AbstractVector{<:Complex}; kwargs...)
    s = sum(x)
    abs(s) == 0 && return error(
        "The mean for $(x) on $(M) is not defined/unique, since the sum of the complex numbers is zero",
    )
    return s / abs(s)
end
function Statistics.mean(
        M::Circle{ℂ},
        x::AbstractVector{<:Complex},
        w::AbstractVector;
        kwargs...,
    )
    s = sum(w .* x)
    abs(s) == 0 && error(
        "The mean for $(x) on $(M) is not defined/unique, since the sum of the complex numbers is zero",
    )
    return s /= abs(s)
end

mid_point(M::Circle{ℝ}, p1, p2) = exp(M, p1, 0.5 * log(M, p1, p2))
mid_point(::Circle{ℂ}, p1::Complex, p2::Complex) = exp(im * (angle(p1) + angle(p2)) / 2)
mid_point(M::Circle{ℂ}, p1::StaticArray, p2::StaticArray) = Scalar(mid_point(M, p1[], p2[]))

@inline LinearAlgebra.norm(::Circle, p, X) = sum(abs, X)

number_of_coordinates(::Circle, ::AbstractBasis) = 1

@doc raw"""
    project(M::Circle{ℂ}, p)

Project a point `p` onto the complex [`Circle`](@ref) `M`, i.e. the unit circle in the complex plane.
"""
project(::Circle, ::Any)
project(::Circle{ℂ}, p::Number) = p / abs(p)
project!(::Circle{ℂ}, q, p) = copyto!(q, p / sum(abs.(p)))

@doc raw"""
    project(M::Circle, p, X)

Project a value `X` onto the tangent space of the point `p` on the [`Circle`](@ref) `M`.

For the complex valued case `X` is projected onto the line in the complex plane
that is parallel to the tangent to `p` on the unit circle and contains `0`.
"""
project(::Circle, ::Any, ::Any)
project(::Circle{ℂ}, p::Number, X::Number) = X - complex_dot(p, X) * p
project!(::Circle{ℂ}, Y, p, X) = (Y .= X - complex_dot(p, X) * p)

@doc raw"""
    Random.rand(M::Circle{ℝ}; vector_at = nothing, σ::Real=1.0)

If `vector_at` is `nothing`, return a random point on the [`Circle`](@ref) ``\mathbb S^1``
by picking a random element from ``[-\pi,\pi)`` uniformly.

If `vector_at` is not `nothing`, return a random tangent vector from the tangent space of
the point `vector_at` on the [`Circle`](@ref) by using a normal distribution with
mean 0 and standard deviation `σ`.
"""
function Random.rand(M::Circle; vector_at = nothing, σ::Real = 1.0)
    return rand(Random.default_rng(), M; vector_at = vector_at, σ = σ)
end
function Random.rand(rng::AbstractRNG, ::Circle{ℝ}; vector_at = nothing, σ::Real = 1.0)
    if vector_at === nothing
        return sym_rem(rand(rng) * 2 * π)
    else
        return map(_ -> σ * randn(rng), vector_at)
    end
end
function Random.rand(rng::AbstractRNG, M::Circle{ℂ}; vector_at = nothing, σ::Real = 1.0)
    if vector_at === nothing
        return sign(randn(rng, ComplexF64))
    else
        # written like that to properly handle `vector_at` being a number or a one-element array
        return map(p -> project(M, p, σ * randn(rng, complex(typeof(p)))), vector_at)
    end
end

function Random.rand!(
        rng::AbstractRNG,
        M::Circle,
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
    )
    pX .= rand(rng, M; vector_at, σ)
    return pX
end

retract(M::Circle, p, q) = retract(M, p, q, ExponentialRetraction())
retract(M::Circle, p, q, m::ExponentialRetraction) = exp(M, p, q)

representation_size(::Circle) = ()

Base.show(io::IO, ::Circle{𝔽}) where {𝔽} = print(io, "Circle($(𝔽))")

@doc raw"""
    sym_rem(x,[T=π])

Compute symmetric remainder of `x` with respect to the interall 2*`T`, i.e.
`(x+T)%2T`, where the default for `T` is ``π``
"""
function sym_rem(x::N, T = π) where {N <: Number}
    return (x ≈ T ? convert(N, -T) : rem(x, convert(N, 2 * T), RoundNearest))
end
sym_rem(x, T = π) = map(sym_rem, x, Ref(T))

@doc raw"""
     parallel_transport_to(M::Circle, p, X, q)

Compute the parallel transport of `X` from the tangent space at `p` to the tangent space at
`q` on the [`Circle`](@ref) `M`.
For the real-valued case this results in the identity.
For the complex-valued case, the formula is the same as for the [`Sphere`](@ref)`(1)` in the
complex plane.
````math
\mathcal P_{q←p} X = X - \frac{⟨\log_p q,X⟩_p}{d^2_{ℂ}(p,q)}
\bigl(\log_p q + \log_q p \bigr),
````
where [`log`](@extref `Base.log-Tuple{AbstractManifold, Any, Any}`) denotes the logarithmic map on `M`.
"""
parallel_transport_to(::Circle, ::Any, ::Any, ::Any)

parallel_transport_to(::Circle{ℝ}, p::Real, X::Real, q::Real) = X
function parallel_transport_to(M::Circle{ℂ}, p::Number, X::Number, q::Number)
    X_pq = log(M, p, q)
    Xnorm = norm(M, p, X_pq)
    Y = X
    if Xnorm > 0
        factor = 2 * complex_dot(X, q) / (abs(p + q)^2)
        Y -= factor .* (p + q)
    end
    return Y
end

parallel_transport_to!(::Circle{ℝ}, Y, p, X, q) = (Y .= X[])
function parallel_transport_to!(M::Circle{ℂ}, Y, p, X, q)
    X_pq = log(M, p, q)
    Xnorm = norm(M, p, X_pq)
    Y .= X
    if Xnorm > 0
        factor = 2 * complex_dot(X, q) / (sum(abs.(p + q) .^ 2))
        Y .-= factor .* (p + q)
    end
    return Y
end

# dispatch before allocation
function _vector_transport_direction(M::Circle, p, X, d, ::ParallelTransport)
    return parallel_transport_to(M, p, X, exp(M, p, d))
end

"""
    volume_density(::Circle, p, X)

Return volume density of [`Circle`](@ref), i.e. 1.
"""
volume_density(::Circle, p, X) = one(eltype(X))

zero_vector(::Circle, p::T) where {T <: Number} = zero(p)
zero_vector!(::Circle, X, p) = fill!(X, 0)

using ManifoldDiff, Manifolds, Random, StaticArrays, Test

Test.@testset "The circle manifold" begin
    M = Circle()
    @test Manifolds.number_of_coordinates(M, DefaultOrthogonalBasis()) == 1
    p1 = π / 2
    p2 = -π / 2
    X1 = 1.0
    X2 = -1.0

    q1 = 9.0
    q2 = zeros(2, 2)
    Y1 = zeros(2, 2)

    expectations = Dict(
        manifold_dimension => 1,
        representation_size => (),
        repr => "Circle(ℝ)",
        manifold_volume => 2π,
    )
    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                exp,
                get_basis, get_coordinates, get_vector,
                is_flat, is_point, is_vector,
                log,
                manifold_dimension, manifold_volume, mid_point,
                parallel_transport_direction, parallel_transport_to,
                repr, representation_size,
            ],
            :Bases => [DefaultOrthonormalBasis(), DiagonalizingOrthonormalBasis(X1)],
            :Coordinates => [[π / 2], [-π / 2]],
            :InvalidPoints => [q1, q2],
            :InvalidVectors => [Y1],
            :Mutating => false,
            :Points => [p1, p2],
            :Vectors => [X1, X2],
            :VectorTransportMethods => [ParallelTransport(), SchildsLadderTransport(), PoleLadderTransport()],
        ),
        expectations,
    )
    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                distance,
                exp,
                get_basis, get_coordinates, get_vector,
                inner, is_flat, is_point, is_vector,
                log,
                manifold_dimension, manifold_volume, mid_point,
                repr, representation_size,
            ],
            :Bases => [DefaultOrthonormalBasis(), DiagonalizingOrthonormalBasis([X1])],
            :Coordinates => [[π / 2], [-π / 2]],
            :InvalidPoints => fill.([q1]),
            :Points => fill.([p1, p2]),
            :Vectors => fill.([X1, X2]),
            :VectorTransportMethods => [ParallelTransport(), SchildsLadderTransport(), PoleLadderTransport()],
        ),
        expectations,
    )

    Mc = Circle(ℂ)

    pc1 = 1.0im
    pc2 = 1.0
    Xc1 = 0.5
    Xc2 = 0.25

    qc1 = 1.0 + 1.0im
    Yc1 = 1.0im

    expectations = Dict(
        manifold_dimension => 1,
        representation_size => (),
        repr => "Circle(ℂ)",
        manifold_volume => 2π,
        get_embedding => Euclidean(; field = ℂ),
        :atols => Dict(parallel_transport_to => 1.0e-14),
    )
    Manifolds.Test.test_manifold(
        Mc,
        Dict(
            :Functions => [
                embed, exp,
                get_coordinates, get_embedding, get_vector,
                inner, injectivity_radius, is_flat, is_point, is_vector,
                manifold_dimension, manifold_volume, mid_point,
                project, parallel_transport_direction, parallel_transport_to,
                log,
                rand, repr, representation_size,
            ],
            :Bases => [DefaultOrthonormalBasis()],
            :Coordinates => [[π / 2], [-π / 2]],
            :EmbeddedPoints => [pc1],
            :EmbeddedVectors => [Xc1],
            :InvalidPoints => [qc1],
            :InvalidVectors => [Yc1],
            :Mutating => false,
            :Points => [pc1, pc2],
            :Vectors => [Xc1, Xc2],
        ),
        expectations
    )
    Manifolds.Test.test_manifold(
        Mc,
        Dict(
            :Functions => [
                exp,
                get_coordinates, get_vector,
                inner, injectivity_radius, is_flat, is_point, is_vector,
                manifold_dimension, manifold_volume, mid_point,
                parallel_transport_direction, parallel_transport_to, project,
                log,
                repr, representation_size,
            ],
            :Bases => [DefaultOrthonormalBasis()],
            :Coordinates => [[π / 2], [-π / 2]],
            :EmbeddedPoints => fill.([pc1]),
            :EmbeddedVectors => fill.([Xc1]),
            :InvalidPoints => fill.([qc1]),
            :InvalidVectors => fill.([Yc1]),
            :Points => fill.([pc1, pc2]),
            :Vectors => fill.([Xc1, Xc2]),
        ),
        expectations
    )

    Test.@testset "Edge cases" begin
        Test.@testset "Mean" begin
            M = Circle()
            @test mean(M, [-π / 2, 0.0, π]) ≈ -π / 2
            @test mean(M, [-π / 2, 0.0, π], [1.0, 1.0, 1.0]) == -π / 2
            Mc = Circle(ℂ)
            angles = map(pp -> exp(pp * im), [-π / 2, 0.0, π])
            @test mean(Mc, angles) ≈ exp(-π * im / 2)
            @test mean(Mc, angles, [1.0, 1.0, 1.0]) ≈ exp(-π * im / 2)

        end
        @testset "Mutating Rand for real Circle" begin
            M = Circle()
            p = fill(NaN)
            X = fill(NaN)
            rand!(M, p)
            @test is_point(M, p)
            rand!(M, X; vector_at = p)
            @test is_vector(M, p, X)

            rng = MersenneTwister()
            rand!(rng, M, p)
            @test is_point(M, p)
            rand!(rng, M, X; vector_at = p)
            @test is_vector(M, p, X)
        end
        @testset "Test sym_rem" begin
            M = Circle()
            p = 4.0 # not a point
            p = sym_rem(p) # modulo to a point
            @test is_point(M, p)
        end
        @testset "small and large distance tests" begin
            M = Circle(ℂ)
            p = -0.42681766710748265 + 0.9043377018818392im
            q = -0.42681766710748226 + 0.9043377018818393im
            @test isapprox(distance(Mc, p, q), 4.041272810440265e-16)
            @test isapprox(distance(Mc, p, -q), 3.1415926535897927; atol = eps())
        end
        @testset "Mixed array dimensions for exp and PT" begin
            # this is an issue on Julia 1.6 but not later releases
            M = Circle()
            p = fill(0.0)
            Manifolds.exp_fused!(M, p, p, [1.0], 2.0)
            @test p ≈ fill(2.0)
            parallel_transport_to!(M, p, p, [4.0], p)
            @test p ≈ fill(4.0)
        end
        Test.@testset "retract nonmutating defaults" begin
            M = Circle()
            p = π / 3
            X = 0.5
            d = -0.2
            q = retract(M, p, X)
            q2 = retract(M, p, X, ExponentialRetraction())
            @test q ≈ exp(M, p, X)
            @test q2 ≈ exp(M, p, X)
            @test vector_transport_direction(M, p, X, d, ParallelTransport()) == parallel_transport_to(M, p, X, d)
        end
        Test.@testset "ManifoldsDiff cases" begin
            M = Circle()
            @test ManifoldDiff.adjoint_Jacobi_field(
                M, 0.0, 1.0, 0.5, 2.0,
                ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
            ) === 2.0
            @test ManifoldDiff.diagonalizing_projectors(M, 0.0, 2.0) == ((0.0, ManifoldDiff.ProjectorOntoVector(M, 0.0, SA[1.0])),)
            @test ManifoldDiff.jacobi_field(
                M, 0.0, 1.0, 0.5, 2.0,
                ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
            ) === 2.0

            # volume
            @test manifold_volume(M) ≈ 2 * π
            @test volume_density(M, 0.0, 2.0) == 1.0
        end
        Test.@testset "Complex Circle log boundary case" begin
            Mc = Circle(ℂ)
            X = log(Mc, 1.0 + 0.0im, -1.0 + 0.0im)
            @test isapprox(X, π * 1.0im)
            X2 = log(Mc, fill(0 + 1.0im), fill(0.0 - 1.0im))
            @test isapprox(X2[], π)
            X3 = fill(0.0)
            log!(Mc, X3, fill(0 + 1.0im), fill(0.0 - 1.0im))
            @test isapprox(X3[], X2[])
        end
    end

    @testset "StaticArrays.jl and vector tests" begin
        Mc = Circle(ℂ)
        @test mid_point(Mc, Scalar(1.0 + 0.0im), Scalar(0.0 + 1.0im)) ≈ Scalar(sqrt(2) / 2 + sqrt(2) / 2 * 1im)
        X1 = get_vector(Mc, Scalar(1.0 + 0.0im), 2.0)
        @test X1 ≈ Scalar(2.0im)
        @test X1 isa Scalar{ComplexF64}

        M = Circle()
        @test get_vector(M, [1.0], [2.0]) == [2.0]
        @test get_vector(M, Scalar(1.0), SA[2.0]) isa SArray
    end
    @testset "Cotangent vectors" begin
        rrcv = Manifolds.RieszRepresenterCotangentVector(M, 0.0, 1.0)
        @test flat(M, 0.0, 1.0) == rrcv
        @test sharp(M, 0.0, rrcv) == 1.0
        B_cot = Manifolds.dual_basis(M, 0.0, DefaultOrthonormalBasis())
        @test get_coordinates(M, 0.0, rrcv, B_cot) ≈ @SVector [1.0]
        @test get_vector(M, 0.0, 1.0, B_cot) isa Manifolds.RieszRepresenterCotangentVector
        a = fill(NaN)
        get_coordinates!(M, a, 0.0, rrcv, B_cot)
        @test a[] ≈ 1.0
        rrcv2 = Manifolds.RieszRepresenterCotangentVector(M, fill(0.0), fill(-10.0))
        get_vector!(M, rrcv2, 0.0, 1.0, B_cot)
        @test isapprox(rrcv.X, rrcv2.X[])
    end
end

using Manifolds

using OrdinaryDiffEq
using DiffEqCallbacks
using Test
using Manifolds: TFVector
using RecursiveArrayTools
using BoundaryValueDiffEq
using Tullio: @einsum
using LinearAlgebra

@testset "Torus in ℝ³" begin
    M = Manifolds.EmbeddedTorus(3, 2)
    A = Manifolds.DefaultTorusAtlas()
    @test !is_flat(M)

    p0x = [0.5, -1.2]
    X_p0x = [-1.2, 0.4]
    Y_p0x = [-0.2, -0.3]
    p = [Manifolds._torus_param(M, p0x...)...]
    @test p ≈ [1.7230709564189848, -4.431999755591838, 0.958851077208406]
    i_p0x = Manifolds.get_chart_index(M, A, p)
    @test [i_p0x...] ≈ p0x
    B = induced_basis(M, A, i_p0x)
    X = get_vector(M, p, X_p0x, B)
    Y = get_vector(M, p, Y_p0x, B)
    @test get_coordinates(M, p, X, B) ≈ X_p0x
    Γ_X_Y = [-0.20602262287496229, -0.11547890480178581]
    @test affine_connection(M, A, i_p0x, p0x, X_p0x, Y_p0x) ≈ Γ_X_Y
    Z_p0x = similar(X_p0x)
    Manifolds.levi_civita_affine_connection!(M, Z_p0x, A, i_p0x, p0x, X_p0x, Y_p0x)
    @test Z_p0x ≈ Γ_X_Y
    css_ref = [0.0 0.0; 0.0 -0.37637884969165114;;; 0.0 1.5668024839360153; -0.37637884969165114 0.0]
    @test christoffel_symbols_second(M, A, i_p0x, p0x) ≈ css_ref
    g_i = local_metric(M, A, i_p0x, p0x)
    @einsum csf_ref[ii, j, k] := g_i[k, l] * css_ref[l, ii, j]
    @test christoffel_symbols_first(M, A, i_p0x, p0x) ≈ csf_ref

    RR = [0.0 0.0; 0.0 0.2648148288193222;;; 0.0 0.0; -0.2648148288193222 0.0;;;; 0.0 -1.1023800405286386; 0.0 0.0;;; 1.1023800405286386 0.0; 0.0 0.0]
    @test riemann_tensor(M, A, i_p0x, p0x) ≈ RR
    W_p0x = similar(X_p0x)
    @einsum W_p0x[i] = RR[i, j, k, l] * X_p0x[j] * Y_p0x[k] * X_p0x[l]
    @test riemann_tensor(M, A, i_p0x, p0x, X_p0x, Y_p0x, X_p0x) ≈ W_p0x

    Ric = ricci_tensor(M, A, i_p0x, p0x)
    Ric_ref = zeros(2, 2)
    @einsum Ric_ref[i, j] = RR[k, i, k, j]
    @test Ric ≈ Ric_ref
    @test ricci_curvature(M, A, i_p0x, p0x) ≈ sum(inverse_local_metric(M, A, i_p0x, p0x) .* Ric)
    @test Manifolds.kretschmann_scalar(M, A, i_p0x, p0x) ≈ 0.0005794816008357242

    einstein_tensor_ref = ricci_tensor(M, A, i_p0x, p0x) - local_metric(M, A, i_p0x, p0x) * ricci_curvature(M, A, i_p0x, p0x) / 2
    @test einstein_tensor(M, A, i_p0x, p0x) ≈ einstein_tensor_ref
    @test det_local_metric(M, A, i_p0x, p0x) ≈ det(local_metric(M, A, i_p0x, p0x))
    @test log_local_metric_density(M, A, i_p0x, p0x) ≈ log(sqrt(abs(det(local_metric(M, A, i_p0x, p0x)))))

    @testset "generic, default implementation" begin
        Z = similar(X)
        invoke(
            Manifolds.get_vector_induced_basis!,
            Tuple{AbstractManifold, Any, Any, Any, InducedBasis{ℝ, Manifolds.TangentSpaceType, <:AbstractAtlas}},
            M, Z, p, X_p0x, B
        )
        @test Z ≈ X
        invoke(
            Manifolds.get_coordinates_induced_basis!,
            Tuple{AbstractManifold, Any, Any, Any, InducedBasis{ℝ, Manifolds.TangentSpaceType, <:AbstractAtlas}},
            M, Z_p0x, p, X, B
        )
        @test Z_p0x ≈ X_p0x
    end

    @test norm(X) ≈ norm(M, A, (0.0, 0.0), p0x, X_p0x)

    @test Manifolds.aspect_ratio(M) == 3 / 2
    @test check_point(M, p) === nothing
    @test check_point(M, [0.0, 0.0, 0.0]) isa DomainError

    @test check_vector(M, p, X) === nothing
    @test check_vector(M, p, [1, 2, 3]) isa DomainError

    @test get_embedding(M) === Euclidean(3)
    @test Manifolds.inverse_chart_injectivity_radius(M, A, i_p0x) === π
    @test gaussian_curvature(M, p) ≈ 0.09227677052701619
    @test Manifolds.normal_vector(M, p) ≈
        [0.3179988464944819, -0.8179412488450798, 0.479425538604203]

    p_exp = Manifolds.solve_chart_parallel_transport_ode(
        M,
        [0.0, 0.0],
        X_p0x,
        A,
        i_p0x,
        [1.0, 2.0];
        final_time = 3.0,
    )
    pexp_3 = p_exp(3.0)
    @test isapprox(
        pexp_3[1],
        [2.701765894057119, 2.668437820810143, -1.8341712552932237];
        atol = 1.0e-5,
    )
    @test isapprox(
        pexp_3[2],
        [-0.41778834843865575, 2.935021992911625, 0.7673987137187901];
        atol = 1.0e-5,
    )
    @test isapprox(
        pexp_3[3],
        [7.661627684089519, 4.629037950515605, 3.7839234533367194];
        atol = 1.0e-4,
    )
    @test_throws DomainError p_exp(10.0)
    @test_throws DomainError p_exp(-1.0)
    @test p_exp([3.0]) == [pexp_3]

    p_exp = Manifolds.solve_chart_exp_ode(M, [0.0, 0.0], X_p0x, A, i_p0x; final_time = 3.0)
    pexp_3 = p_exp(3.0)
    @test isapprox(
        pexp_3[1],
        [2.701765894057119, 2.668437820810143, -1.8341712552932237],
        rtol = 1.0e-5,
    )
    @test isapprox(
        pexp_3[2],
        [-0.41778834843865575, 2.935021992911625, 0.7673987137187901],
        rtol = 1.0e-5,
    )
    @test_throws DomainError p_exp(10.0)
    @test_throws DomainError p_exp(-1.0)

    p_exp_switch = Manifolds.solve_chart_exp_ode(
        M,
        [0.0, 0.0],
        X_p0x,
        A,
        i_p0x;
        final_time = 3.0,
        check_chart_switch_kwargs = (; ϵ = 0.3),
    )
    p_exp_switch_3 = p_exp_switch(3.0)
    @test isapprox(
        p_exp_switch_3[1],
        [2.701765894057119, 2.668437820810143, -1.8341712552932237],
        rtol = 1.0e-5,
    )
    @test length(p_exp_switch.sols) < length(p_exp.sols)

    Manifolds.transition_map_diff(M, A, i_p0x, [0.0, 0.0], X_p0x, (-1.0, -0.3))

    a2 = [-0.5, 0.3]
    sol_log = Manifolds.solve_chart_log_bvp(M, p0x, a2, A, (0, 0))
    @test sol_log(0.0)[1:2] ≈ p0x
    @test sol_log(1.0)[1:2] ≈ a2 atol = 1.0e-7
    # a test randomly failed here on Julia 1.6 once for no clear reason?
    # so I bumped tolerance considerably
    bvp_atol = VERSION < v"1.7" ? 2.0e-3 : 1.0e-15
    @test isapprox(
        norm(M, A, (0, 0), p0x, sol_log(0.0)[3:4]),
        Manifolds.estimate_distance_from_bvp(M, p0x, a2, A, (0, 0));
        atol = bvp_atol,
    )

    @test Manifolds.IntegratorTerminatorNearChartBoundary().check_chart_switch_kwargs ===
        NamedTuple()
end

@doc raw"""
    Spectrahedron{T} <: AbstractDecoratorManifold{ℝ}

The Spectrahedron manifold, also known as the set of correlation matrices (symmetric
positive semidefinite matrices) of rank ``k`` with unit trace.

````math
\begin{aligned}
\mathcal S(n,k) =
\bigl\{p ∈ ℝ^{n×n}\ \big|\ &a^\mathrm{T}pa \geq 0 \text{ for all } a ∈ ℝ^{n},\\
&\operatorname{tr}(p) = \sum_{i=1}^n p_{ii} = 1,\\
&\text{and } p = qq^{\mathrm{T}} \text{ for } q \in  ℝ^{n×k}
\text{ with } \operatorname{rank}(p) = \operatorname{rank}(q) = k
\bigr\}.
\end{aligned}
````

This manifold is working solely on the matrices ``q``. Note that this ``q`` is not unique,
indeed for any orthogonal matrix ``A`` we have ``(qA)(qA)^{\mathrm{T}} = qq^{\mathrm{T}} = p``,
so the manifold implemented here is the quotient manifold. The unit trace translates to
unit Frobenius norm of ``q``.


The tangent space at ``p``, denoted ``T_p\mathcal E(n,k)``, is also represented by matrices
``Y\in ℝ^{n×k}`` and reads as

````math
T_p\mathcal S(n,k) = \bigl\{
X ∈ ℝ^{n×n}\,|\,X = qY^{\mathrm{T}} + Yq^{\mathrm{T}}
\text{ with } \operatorname{tr}(X) = \sum_{i=1}^{n}X_{ii} = 0
\bigr\}
````
endowed with the [`Euclidean`](@ref) metric from the embedding, i.e. from the ``ℝ^{n×k}``


This manifold was for example
investigated in [JourneeBachAbsilSepulchre:2010](@cite).

# Constructor

    Spectrahedron(n::Int, k::Int; parameter::Symbol=:type)

generates the manifold ``\mathcal S(n,k) \subset ℝ^{n×n}``.
"""
struct Spectrahedron{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function Spectrahedron(n::Int, k::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return Spectrahedron{typeof(size)}(size)
end

@doc raw"""
    check_point(M::Spectrahedron, q; kwargs...)

checks, whether `q` is a valid representation of a point ``p=qq^{\mathrm{T}}`` on the
[`Spectrahedron`](@ref) `M`, i.e. is a matrix
of size `(N,K)`, such that ``p`` is symmetric positive semidefinite and has unit trace,
i.e. ``q`` has to have unit frobenius norm.
Since by construction ``p`` is symmetric, this is not explicitly checked.
Since ``p`` is by construction positive semidefinite, this is not checked.
The tolerances for positive semidefiniteness and unit trace can be set using the `kwargs...`.
"""
function check_point(M::Spectrahedron, q; kwargs...)
    fro_n = norm(q)
    if !isapprox(fro_n, 1.0; kwargs...)
        return DomainError(
            fro_n,
            "The point $(q) does not represent a point p=qq^T on $(M) since q has not Frobenius norm 1 (and hence p not unit trace).",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::Spectrahedron, q, Y; kwargs...)

Check whether ``X = qY^{\mathrm{T}} + Yq^{\mathrm{T}}`` is a tangent vector to
``p=qq^{\mathrm{T}}`` on the [`Spectrahedron`](@ref) `M`,
i.e. atfer [`check_point`](@ref) of `q`, `Y` has to be of same dimension as `q`
and a ``X`` has to be a symmetric matrix with trace.
The tolerance for the base point check and zero diagonal can be set using the `kwargs...`.
Note that symmetry of ``X`` holds by construction and is not explicitly checked.
"""
function check_vector(
        M::Spectrahedron,
        q,
        Y::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    X = q * Y' + Y * q'
    n = tr(X)
    if !isapprox(n, 0; atol = atol, kwargs...)
        return DomainError(
            n,
            "The vector $(X) is not a tangent to a point on $(M) (represented py $(q) and $(Y), since its trace is nonzero.",
        )
    end
    return nothing
end

function get_embedding(::Spectrahedron{TypeParameter{Tuple{n, k}}}) where {n, k}
    return Euclidean(n, k)
end
function get_embedding(M::Spectrahedron{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return Euclidean(n, k; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Spectrahedron)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

"""
    is_flat(::Spectrahedron)

Return false. [`Spectrahedron`](@ref) is not a flat manifold.
"""
is_flat(M::Spectrahedron) = false

@doc raw"""
    manifold_dimension(M::Spectrahedron)

returns the dimension of
[`Spectrahedron`](@ref) `M```=\mathcal S(n,k), n,k ∈ ℕ``, i.e.
````math
\dim \mathcal S(n,k) = nk - 1 - \frac{k(k-1)}{2}.
````
"""
function manifold_dimension(M::Spectrahedron)
    N, K = get_parameter(M.size)
    return N * K - 1 - div(K * (K - 1), 2)
end

"""
    project(M::Spectrahedron, q)

project `q` onto the manifold [`Spectrahedron`](@ref) `M`, by normalizing w.r.t. the
Frobenius norm
"""
project(::Spectrahedron, ::Any)

project!(::Spectrahedron, r, q) = copyto!(r, q ./ norm(q))

"""
    project(M::Spectrahedron, q, Y)

Project `Y` onto the tangent space at `q`, i.e. row-wise onto the Spectrahedron manifold.
"""
project(::Spectrahedron, ::Any...)

function project!(::Spectrahedron, Z, q, Y)
    Y2 = Y - sum(q .* Y) * q
    Z .= Y2 - q * lyap(q' * q, -(q' * Y2 - Y2' * q))
    return Z
end

@doc raw"""
    retract(M::Spectrahedron, q, Y, ::ProjectionRetraction)

compute a projection based retraction by projecting ``q+Y`` back onto the manifold.
"""
retract(::Spectrahedron, ::Any, ::Any, ::ProjectionRetraction)

function ManifoldsBase.retract_project!(M::Spectrahedron, r, q, Y)
    return project!(M, r, q .+ Y)
end
function ManifoldsBase.retract_project_fused!(M::Spectrahedron, r, q, Y, t::Number)
    return project!(M, r, q .+ t .* Y)
end

@doc raw"""
    representation_size(M::Spectrahedron)

Return the size of an array representing an element on the
[`Spectrahedron`](@ref) manifold `M`, i.e. ``n×k``, the size of such factor of ``p=qq^{\mathrm{T}}``
on ``\mathcal M = \mathcal S(n,k)``.
"""
representation_size(M::Spectrahedron) = get_parameter(M.size)

function Base.show(io::IO, M::Spectrahedron{TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "Spectrahedron($n, $k)")
end
function Base.show(io::IO, M::Spectrahedron{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "Spectrahedron($n, $k; parameter=:field)")
end

"""
    vector_transport_to(M::Spectrahedron, p, X, q)

transport the tangent vector `X` at `p` to `q` by projecting it onto the tangent space
at `q`.
"""
vector_transport_to(::Spectrahedron, ::Any, ::Any, ::Any, ::ProjectionTransport)

function vector_transport_to_project!(M::Spectrahedron, Y, p, X, q)
    project!(M, Y, q, X)
    return Y
end

@doc raw"""
    zero_vector(M::Spectrahedron,p)

returns the zero tangent vector in the tangent space of the symmetric positive
definite matrix `p` on the [`Spectrahedron`](@ref) manifold `M`.
"""
zero_vector(::Spectrahedron, ::Any...)

zero_vector!(::Spectrahedron, X, ::Any) = fill!(X, 0)

using LinearAlgebra, Manifolds, Test, StaticArrays, Quaternions, Random, Distributions, RecursiveArrayTools
using ManifoldDiff


@testset "The Spheres" begin

    M = Sphere(2)
    p = [1.0, 0.0, 0.0]
    q = [1 / sqrt(2), 1 / sqrt(2), 0.0]
    X = [0.0, π / 4, 0.0]
    Y = [0.0, 0.0, π / 4]
    V = [2.0, 0.0, 0.0]  # normal vector at p
    ξ = Manifolds.RieszRepresenterCotangentVector(M, p, [0.0, π / 4, 0.0])  # covector at p

    @testset "Basics" begin
        @test base_manifold(M) === M
    end

    # TODO: test ProjectedOrthonormalBasis(:svd), DiagonalizingOrthonormalBasis

    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => Manifolds.Test.all_functions(),
            :InverseRetractionMethods => [LogarithmicInverseRetraction(), ProjectionInverseRetraction()],
            :Points => [p, q], :Vectors => [X, Y],
            :EmbeddedPoints => [p],
            :EmbeddedVectors => [X],
            :Coordinates => [[π / 2, 0.0]],
            :Bases => [DefaultOrthogonalBasis(), DefaultOrthonormalBasis()],
            :InvalidPoints => [2 * p],
            :InvalidVectors => [p],
            :NormalVectors => [V],
            :Covectors => [ξ],
            :RetractionMethods => [ExponentialRetraction(), ProjectionRetraction()],
            :VectorTransportMethods => [ParallelTransport(), SchildsLadderTransport(), PoleLadderTransport()]
        ),
        # Expectations
        Dict(
            :atol => 1.0e-7,
            default_inverse_retraction_method => LogarithmicInverseRetraction(),
            default_retraction_method => StabilizedRetraction(),
            default_vector_transport_method => ParallelTransport(),
            distance => π / 4,
            exp => q,
            get_embedding => Euclidean(3),
            (get_vectors, DefaultOrthonormalBasis()) => :Orthonormal,
            (get_vectors, DefaultOrthogonalBasis()) => :Orthogonal,
            injectivity_radius => π,
            (injectivity_radius, ProjectionRetraction()) => π / 2,
            is_default_metric => EuclideanMetric(),
            log => X, norm => π / 4,
            parallel_transport_to => parallel_transport_to(M, p, X, q),
            parallel_transport_direction => parallel_transport_to(M, p, X, q),
            manifold_dimension => 2,
            repr => "Sphere(2)",
            Weingarten => -X * (p'V), # or [ 0, -π/2, 0 ]
            :IsPointErrors => [DomainError]
        ),
    )

    @testset "Embedding test" begin
        p = [1.0, 0.0, 0.0]
        X = [0.0, 1.0, 1.0]
        @test embed(M, p) == p
        q = similar(p)
        embed!(M, q, p)
        @test q == p
        @test embed(M, p, X) == X
        Y = similar(X)
        embed!(M, Y, p, X)
        @test Y == X
    end

    Manifolds.test_atlases(M, [p, q], (RetractionAtlas(), Manifolds.StereographicAtlas()))

    @testset "Complex Sphere" begin
        M = Sphere(2, ℂ)

        p = [1.0, 1.0im, 1.0]
        q = project(M, p)
        Y = [2.0, 1.0im, 20.0]
        X = project(M, q, Y)

        Manifolds.Test.test_manifold(
            M,
            Dict(:Functions => [repr, get_embedding], :Points => [q], :Vectors => [X]),
            # Expectations
            Dict(
                repr => "Sphere(2, ℂ)",
                get_embedding => Euclidean(3; field = ℂ)
            ),
        )

        # testing that the random point is actually a complex number with non-zero imaginary part
        Random.seed!(42)
        r = rand(M)
        @test is_point(M, r)
        @test norm(imag.(r)) != 0
    end

    @testset "Quaternion Sphere" begin
        M = Sphere(2, ℍ)
        p = [Quaternion(1.0), Quaternion(0, 1.0, 0, 0), Quaternion(0.0, 0.0, -1.0, 0.0)]
        q = project(M, p)

        Y = [Quaternion(2.0), Quaternion(0, 1.0, 0, 0), Quaternion(0.0, 0.0, 20.0, 0.0)]
        X = project(M, q, Y)

        Manifolds.Test.test_manifold(
            M,
            Dict(
                :Functions => [repr, get_embedding, project],
                :Points => [p],
                :EmbeddedPoints => [p],
                :Vectors => [X],
                :EmbeddedVectors => [X],
            ),
            # Expectations
            Dict(
                :atol => 1.0e-14, repr => "Sphere(2, ℍ)",
                get_embedding => Euclidean(3; field = ℍ)
            ),
        )
    end

    Manifolds.Test.test_manifold(
        Sphere(2; parameter = :field),
        Dict(
            :Functions => [get_embedding, repr],
            :Points => [p],
        ),
        # Expectations
        Dict(
            repr => "Sphere(2; parameter=:field)",
            get_embedding => Euclidean(3; parameter = :field),
        ),
    )

    @testset "Array Sphere" begin
        M = ArraySphere(2, 2; field = ℝ)
        @test representation_size(M) == (2, 2)
        p = ones(2, 2)
        q = project(M, p)
        @test is_point(M, q)
        Y = [1.0 0.0; 0.0 1.1]
        X = project(M, q, Y)
        @test is_vector(M, q, X)

        Manifolds.Test.test_manifold(
            M,
            Dict(:Functions => [repr, get_embedding], :Points => [q], :Vectors => [X]),
            # Expectations
            Dict(repr => "ArraySphere(2, 2)", get_embedding => Euclidean(2, 2)),
        )
    end


    Manifolds.Test.test_manifold(
        ArraySphere(2, 2; field = ℂ),
        Dict(:Functions => [repr, get_embedding]),
        # Expectations
        Dict(repr => "ArraySphere(2, 2; field=ℂ)", get_embedding => Euclidean(2, 2; field = ℂ)),
    )

    Manifolds.Test.test_manifold(
        ArraySphere(2, 2; parameter = :field),
        Dict(:Functions => [repr]),
        # Expectations
        Dict(repr => "ArraySphere(2, 2; parameter=:field)"),
    )

    @testset "Specific Tests and boundary cases" begin
        M = Sphere(2)
        @testset "small and large distance tests" begin
            p = [-0.18337624444127734, 0.8345313166281056, 0.5195484910396462]
            q = [-0.18337624444127681, 0.8345313166281058, 0.5195484910396464]
            @test isapprox(distance(M, p, q), 5.828670879282073e-16)
            @test isapprox(distance(M, p, -q), 3.1415926535897927; atol = eps())
        end

        @testset "DefaultOrthonormalBasis edge cases" begin
            B = DefaultOrthonormalBasis(ℝ)
            n = manifold_dimension(M)
            p = [1; zeros(n)]
            for i in 1:n  # p'x ± 1
                vcoord = [j == i for j in 1:n]
                v = [0; vcoord]
                @test get_coordinates(M, p, v, B) ≈ vcoord
                @test get_vector(M, p, vcoord, B) ≈ v
                @test get_coordinates(M, -p, v, B) ≈ vcoord
                @test get_vector(M, -p, vcoord, B) ≈ v
            end
            p = [0; 1; zeros(n - 1)] # p'x = 0
            for i in 1:n
                vcoord = [j == i for j in 1:n]
                v = get_vector(M, p, vcoord, B)
                @test is_vector(M, p, v)
                @test get_coordinates(M, p, v, B) ≈ vcoord
            end
        end

        @testset "log edge case" begin
            n = manifold_dimension(M)
            x = normalize(randn(n + 1))
            v = log(M, x, -x)
            @test norm(v) ≈ π
            @test isapprox(dot(x, v), 0; atol = 1.0e-12)
            vexp = normalize(project(M, x, [1, zeros(n)...]))
            @test v ≈ π * vexp

            x = [1, zeros(n)...]
            v = log(M, x, -x)
            @test norm(v) ≈ π
            @test isapprox(dot(x, v), 0; atol = 1.0e-12)
            vexp = normalize(project(M, x, [0, 1, zeros(n - 1)...]))
            @test v ≈ π * vexp
        end

        @testset "StereographicAtlas" begin
            M = Sphere(2)
            A = Manifolds.StereographicAtlas()
            p = [1 / sqrt(3), 1 / sqrt(3), 1 / sqrt(3)]
            for k in [1, -1]
                p *= k
                i = Manifolds.get_chart_index(M, A, p)
                @test i === (p[1] < 0 ? :south : :north)
                a = get_parameters(M, A, i, p)
                q = get_point(M, A, i, a)
                @test isapprox(M, p, q)

                p2 = [1 / sqrt(2), 1 / sqrt(2), 0]; p3 = [0, 1 / sqrt(2), 1 / sqrt(2)]
                X2 = log(M, p, p2); X3 = log(M, p, p3)
                B = induced_basis(M, A, i, Manifolds.TangentSpaceType())

                X2B = get_coordinates(M, p, X2, B)
                X3B = get_coordinates(M, p, X3, B)

                @test inner(M, p, X2, X3) ≈ dot(X2B, local_metric(M, p, B) * X3B)

                X2back = get_vector(M, p, X2B, B)
                X3back = get_vector(M, p, X3B, B)
                @test isapprox(M, p, X2, X2back)
                @test isapprox(M, p, X3, X3back)

                @testset "transition_map" begin
                    other_chart = i === :south ? :north : :south
                    a_other = Manifolds.transition_map(M, A, i, other_chart, a)
                    @test isapprox(M, p, get_point(M, A, other_chart, a_other))

                    a_other2 = allocate(a_other)
                    Manifolds.transition_map!(M, a_other2, A, i, A, other_chart, a)
                    @test isapprox(M, p, get_point(M, A, other_chart, a_other2))

                    a_other2 = allocate(a_other)
                    Manifolds.transition_map!(M, a_other2, A, i, other_chart, a)
                    @test isapprox(M, p, get_point(M, A, other_chart, a_other2))
                end
            end
            # TODO: test RetractionAtlas somewhere
        end

        @testset "sectional curvature" begin
            M = Sphere(2; parameter = :field)
            K = Manifolds.sectional_curvature_matrix(
                M,
                [1.0, 0.0, 0.0],
                DefaultOrthonormalBasis(),
            )
            @test isapprox(K, [0 1; 1 0])
            @test isapprox(
                Manifolds.estimated_sectional_curvature_matrix(
                    M,
                    [1.0, 0.0, 0.0],
                    DefaultOrthonormalBasis(),
                ),
                [0.0 1.0; 1.0 0.0],
                atol = 0.15,
            )
        end

        @testset "Local Metric" begin
            p = [1.0, 0.0, 0.0]
            for M in [Sphere(2), Sphere(2; parameter = :field)]
                @test local_metric(M, p, DefaultOrthonormalBasis()) == Diagonal([1.0, 1.0])
            end
        end

        @testset "Volume density" begin
            M = Sphere(2)
            p = [1.0, 0.0, 0.0]
            @test manifold_volume(Sphere(0)) ≈ 2
            @test manifold_volume(Sphere(1)) ≈ 2 * π
            @test manifold_volume(Sphere(2)) ≈ 4 * π
            @test manifold_volume(Sphere(3)) ≈ 2 * π * π
            @test volume_density(M, p, [0.0, 0.5, 0.5]) ≈ 0.9187253698655684
        end

        @testset "ManifoldDiff" begin
            # ManifoldDiff
            M = Sphere(2)
            p = [1.0, 0.0, 0.0]
            X = [0.0, 2.0, -1.0]
            dpX = ManifoldDiff.diagonalizing_projectors(M, p, X)
            @test dpX[1][1] == 0.0
            @test dpX[1][2].X == normalize(X)
            @test dpX[2][1] == 1.0
            @test dpX[2][2].X == normalize(X)
        end

        @testset "other metric" begin
            M = Sphere(2)
            p = [0, 1, 0]
            X = [1, 0, 0]
            Y = [1, 0, 4]
            Z = [0, 0, 1]
            @test riemann_tensor(M, p, X, Y, Z) == [4, 0, 0]
            @test sectional_curvature(M, p, X, Y) == 1.0
            @test sectional_curvature_max(M) == 1.0
            @test sectional_curvature_min(M) == 1.0
            M1 = Sphere(1)
            @test sectional_curvature(M1, p, X, Y) == 0.0
            @test sectional_curvature_max(M1) == 0.0
            @test sectional_curvature_min(M1) == 0.0
        end

        @testset "Distributions" begin
            sphere = Sphere(2)
            haar_measure = Manifolds.uniform_distribution(sphere)
            pts = rand(haar_measure, 5)
            @test all(p -> is_point(sphere, p), pts)

            usd_mvector = Manifolds.uniform_distribution(M, @MVector [1.0, 0.0, 0.0])
            @test isa(rand(usd_mvector), MVector)

            gtsd_mvector =
                Manifolds.normal_tvector_distribution(M, (@MVector [1.0, 0.0, 0.0]), 1.0)
            @test isa(rand(gtsd_mvector), MVector)
        end
    end
end

using PkgBenchmark

#--track-allocation=all
config =
    BenchmarkConfig(id = nothing, juliacmd = `julia -O3`, env = Dict("JULIA_NUM_THREADS" => 4))

results = benchmarkpkg("Manifolds", config)
export_markdown("benchmark/results.md", results)

@doc raw"""
    GraphManifoldType

This type represents the type of data on the graph that the [`GraphManifold`](@ref)
represents.
"""
abstract type GraphManifoldType end

@doc raw"""
    EdgeManifoldManifold <: GraphManifoldType

A type for a [`GraphManifold`](@ref) where the data is given on the edges.
"""
struct EdgeManifold <: GraphManifoldType end

@doc raw"""
    VectexGraphManifold <: GraphManifoldType

A type for a [`GraphManifold`](@ref) where the data is given on the vertices.
"""
struct VertexManifold <: GraphManifoldType end

@doc raw"""
    GraphManifold{𝔽, G, M, T} <: AbstractPowerManifold{𝔽,M,NestedPowerRepresentation}

Build a manifold, that is a [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `M` either on
the edges or vertices of a graph `G` depending on the [`GraphManifoldType`](@ref) `T`.

# Fields
* `G` is an `AbstractSimpleGraph`
* `M` is a `AbstractManifold`
"""
struct GraphManifold{𝔽, G <: AbstractGraph, TM, T <: GraphManifoldType} <:
    AbstractPowerManifold{𝔽, TM, NestedPowerRepresentation}
    graph::G
    manifold::TM
end

function GraphManifold(
        g::G,
        M::TM,
        ::VertexManifold,
    ) where {G <: AbstractGraph, 𝔽, TM <: AbstractManifold{<:𝔽}}
    return GraphManifold{𝔽, G, TM, VertexManifold}(g, M)
end
function GraphManifold(
        g::G,
        M::TM,
        ::EdgeManifold,
    ) where {G <: AbstractGraph, 𝔽, TM <: AbstractManifold{<:𝔽}}
    return GraphManifold{𝔽, G, TM, EdgeManifold}(g, M)
end

const EdgeGraphManifold{𝔽} =
    GraphManifold{𝔽, <:AbstractGraph, <:AbstractManifold{𝔽}, EdgeManifold}
const VertexGraphManifold{𝔽} =
    GraphManifold{𝔽, <:AbstractGraph, <:AbstractManifold{𝔽}, VertexManifold}

@doc raw"""
    check_point(M::GraphManifold, p)

Check whether `p` is a valid point on the [`GraphManifold`](@ref), i.e. its length equals the number of vertices
(for [`VertexManifold`](@ref)s) or the number of edges (for [`EdgeManifold`](@ref)s) and that each element of `p`
passes the [`check_point`](@ref) test for the base manifold `M.manifold`.
"""
check_point(::GraphManifold, ::Any...)
function check_point(M::VertexGraphManifold, p; kwargs...)
    PM = PowerManifold(M.manifold, NestedPowerRepresentation(), nv(M.graph))
    return check_point(PM, p; kwargs...)
end
function check_point(M::EdgeGraphManifold, p; kwargs...)
    PM = PowerManifold(M.manifold, NestedPowerRepresentation(), ne(M.graph))
    return check_point(PM, p; kwargs...)
end

@doc raw"""
    check_vector(M::GraphManifold, p, X; kwargs...)

Check whether `p` is a valid point on the [`GraphManifold`](@ref), and
`X` it from its tangent space, i.e. its
length equals the number of vertices (for [`VertexManifold`](@ref)s) or
the number of edges (for [`EdgeManifold`](@ref)s) and that each element of `X`
together with its corresponding entry of `p` passes the
[`check_vector`](@ref) test for the base manifold `M.manifold`.
"""
check_vector(::GraphManifold, ::Any...)
function check_vector(M::VertexGraphManifold, p, X; kwargs...)
    PM = PowerManifold(M.manifold, NestedPowerRepresentation(), nv(M.graph))
    return check_vector(PM, p, X; kwargs...)
end
function check_vector(M::EdgeGraphManifold, p, X; kwargs...)
    PM = PowerManifold(M.manifold, NestedPowerRepresentation(), ne(M.graph))
    return check_vector(PM, p, X; kwargs...)
end

get_iterator(M::EdgeGraphManifold) = 1:ne(M.graph)
get_iterator(M::VertexGraphManifold) = 1:nv(M.graph)

@doc raw"""
    incident_log(M::GraphManifold, x)

Return the tangent vector on the (vertex) [`GraphManifold`](@ref), where at
each node the sum of the [`log`](@extref `Base.log-Tuple{AbstractManifold, Any, Any}`)s to incident nodes is computed.
For a `SimpleGraph`, an egde is interpreted as double edge in the corresponding
SimpleDiGraph

If the internal graph is a `SimpleWeightedGraph` the weighted sum of the
tangent vectors is computed.
"""
function incident_log(M::VertexGraphManifold, p)
    v = zero_vector(M, p)
    return incident_log!(M, v, p)
end

function incident_log!(M::VertexGraphManifold, X, p)
    rep_size = representation_size(M.manifold)
    for e in edges(M.graph)
        vw = _write(M, rep_size, X, src(e))
        X[src(e)] +=
            log(M.manifold, _read(M, rep_size, p, src(e)), _read(M, rep_size, p, dst(e)))
        if !is_directed(M.graph)
            X[dst(e)] += log(
                M.manifold,
                _read(M, rep_size, p, dst(e)),
                _read(M, rep_size, p, src(e)),
            )
        end
    end
    return X
end
function incident_log!(
        M::GraphManifold{𝔽, <:AbstractSimpleWeightedGraph, <:AbstractManifold{𝔽}, VertexManifold},
        X,
        p,
    ) where {𝔽}
    rep_size = representation_size(M.manifold)
    for e in edges(M.graph)
        X[src(e)] += (
            get_weight(M.graph, src(e), dst(e)) * log(
                M.manifold,
                _read(M, rep_size, p, src(e)),
                _read(M, rep_size, p, dst(e)),
            )
        )
        if !is_directed(M.graph)
            X[dst(e)] += (
                get_weight(M.graph, dst(e), src(e)) * log(
                    M.manifold,
                    _read(M, rep_size, p, dst(e)),
                    _read(M, rep_size, p, src(e)),
                )
            )
        end
    end
    return X
end

@doc raw"""
    manifold_dimension(N::GraphManifold{G,𝔽,M,VertexManifold})

returns the manifold dimension of the [`GraphManifold`](@ref) `N` on the vertices of
a graph $G=(V,E)$, i.e.
````math
\dim(\mathcal N) = \lvert V \rvert \dim(\mathcal M),
````
where $\mathcal M$ is the manifold of the data on the nodes.
"""
function manifold_dimension(M::VertexGraphManifold)
    return manifold_dimension(M.manifold) * nv(M.graph)
end
@doc raw"""
    manifold_dimension(N::GraphManifold{G,𝔽,M,EdgeManifold})

returns the manifold dimension of the [`GraphManifold`](@ref) `N` on the edges of
a graph $G=(V,E)$, i.e.
````math
\dim(\mathcal N) = \lvert E \rvert \dim(\mathcal M),
````
where $\mathcal M$ is the manifold of the data on the edges.
"""
function manifold_dimension(M::EdgeGraphManifold)
    return manifold_dimension(M.manifold) * ne(M.graph)
end

power_dimensions(M::EdgeGraphManifold) = (ne(M.graph),)
power_dimensions(M::VertexGraphManifold) = (nv(M.graph),)

function _show_graph_manifold(io::IO, M; man_desc = "", pre = "")
    println(io, "GraphManifold\nGraph:")
    sg = sprint(show, "text/plain", M.graph, context = io, sizehint = 0)
    sg = replace(sg, '\n' => "\n$(pre)")
    println(io, pre, sg)
    println(io, "AbstractManifold$(man_desc):")
    sm = sprint(show, "text/plain", M.manifold, context = io, sizehint = 0)
    sm = replace(sm, '\n' => "\n$(pre)")
    print(io, pre, sm)
    return nothing
end

function Base.show(io::IO, mime::MIME"text/plain", M::EdgeGraphManifold)
    return _show_graph_manifold(io, M; man_desc = " on edges", pre = " ")
end
function Base.show(io::IO, mime::MIME"text/plain", M::VertexGraphManifold)
    return _show_graph_manifold(io, M; man_desc = " on vertices", pre = " ")
end

@doc raw"""
    const UnitaryMatrices{𝔽, T} = GeneralUnitaryMatrices{𝔽, T, AbsoluteDeterminantOneMatrixType}

The manifold ``U(n,𝔽)`` of ``n×n`` complex matrices (when 𝔽=ℂ) or quaternionic matrices
(when 𝔽=ℍ) such that

```math
    p^{\mathrm{H}}p = \mathrm{I}_n,
```

where ``p^{\mathrm{H}}`` is the conjugate transpose of ``p`` and ``\mathrm{I}_n`` is the ``n×n`` identity matrix.
Such matrices `p` have a property that ``\lVert \det(p) \rVert = 1``.

The tangent spaces are given by

```math
    T_pU(n) \coloneqq \bigl\{
    X \big| pY \text{ where } Y \text{ is skew symmetric, i. e. } Y = -Y^{\mathrm{H}}
    \bigr\}
```

But note that tangent vectors are represented in the Lie algebra, i.e. just using ``Y`` in
the representation above.
If you prefer the representation as `X` you can use the [`Stiefel`](@ref)`(n, n, ℂ)` manifold.

# Constructor

    UnitaryMatrices(n, 𝔽::AbstractNumbers=ℂ)

see also [`OrthogonalMatrices`](@ref) for the real valued case.
"""
const UnitaryMatrices{𝔽, T} = GeneralUnitaryMatrices{𝔽, T, AbsoluteDeterminantOneMatrixType}

function UnitaryMatrices(n::Int, 𝔽::AbstractNumbers = ℂ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return UnitaryMatrices{𝔽, typeof(size)}(size)
end

check_size(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p::Number) = nothing
check_size(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X::Number) = nothing

embed(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p::Number) = SMatrix{1, 1}(p)

embed(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X::Number) = SMatrix{1, 1}(X)

function exp(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X::Number)
    return p * exp(X)
end
function exp_fused(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X::Number, t::Real)
    return p * exp(t * X)
end

function get_coordinates_orthonormal(
        ::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}},
        p,
        X::Quaternions.Quaternion,
        ::RealNumbers,
    )
    return @SVector [X.v1, X.v2, X.v3]
end

function get_vector_orthonormal(
        ::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}},
        p::Quaternions.Quaternion,
        c,
        ::RealNumbers,
    )
    i = firstindex(c)
    return Quaternions.quat(0, c[i], c[i + 1], c[i + 2])
end

injectivity_radius(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}) = π

function _isapprox(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, x, y; kwargs...)
    return isapprox(x[], y[]; kwargs...)
end
function _isapprox(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X, Y; kwargs...)
    return isapprox(X[], Y[]; kwargs...)
end

function log(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p::Number, q::Number)
    return log(conj(p) * q)
end

@doc raw"""
    manifold_dimension(M::UnitaryMatrices{n,ℂ}) where {n}

Return the dimension of the manifold unitary matrices.
```math
\dim_{\mathrm{U}(n)} = n^2.
```
"""
function manifold_dimension(M::UnitaryMatrices{ℂ})
    n = get_parameter(M.size)[1]
    return n^2
end
@doc raw"""
    manifold_dimension(M::UnitaryMatrices{<:Any,ℍ})

Return the dimension of the manifold unitary matrices.
```math
\dim_{\mathrm{U}(n, ℍ)} = n(2n+1).
```
"""
function manifold_dimension(M::UnitaryMatrices{ℍ})
    n = get_parameter(M.size)[1]
    return n * (2n + 1)
end

number_of_coordinates(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, ::AbstractBasis{ℍ}) = 3

project(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p) = sign(p)

project(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p, X) = (X - conj(X)) / 2

function Random.rand(M::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}; vector_at = nothing)
    if vector_at === nothing
        return sign(rand(Quaternions.QuaternionF64))
    else
        project(M, vector_at, rand(Quaternions.QuaternionF64))
    end
end
function Random.rand(
        rng::AbstractRNG,
        M::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}};
        vector_at = nothing,
    )
    if vector_at === nothing
        return sign(rand(rng, Quaternions.QuaternionF64))
    else
        project(M, vector_at, rand(rng, Quaternions.QuaternionF64))
    end
end

@doc raw"""
    rand(::Unitary; vector_at=nothing, σ::Real=1.0)

Generate a random point on the [`UnitaryMatrices`](@ref) manifold,
if `vector_at` is nothing, by computing the QR decomposition of
an ``n×n`` matrix.

Generate a tangent vector at `vector_at` by projecting a normally
distributed matrix onto the tangent space.
"""
rand(::UnitaryMatrices; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::UnitaryMatrices,
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
    )
    n = get_parameter(M.size)[1]
    if vector_at === nothing
        A = σ * randn(rng, eltype(pX), n, n)
        pX .= Matrix(qr(A).Q)
    else
        Z = σ * randn(rng, eltype(pX), size(pX))
        project!(M, pX, vector_at, Z)
    end
    return pX
end

function Base.show(io::IO, ::UnitaryMatrices{ℂ, TypeParameter{Tuple{n}}}) where {n}
    return print(io, "UnitaryMatrices($(n))")
end
function Base.show(io::IO, M::UnitaryMatrices{ℂ, Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "UnitaryMatrices($n; parameter=:field)")
end
function Base.show(io::IO, ::UnitaryMatrices{ℍ, TypeParameter{Tuple{n}}}) where {n}
    return print(io, "UnitaryMatrices($(n), ℍ)")
end
function Base.show(io::IO, M::UnitaryMatrices{ℍ, Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "UnitaryMatrices($n, ℍ; parameter=:field)")
end

@doc raw"""
    riemannian_Hessian(M::UnitaryMatrices, p, G, H, X)

The Riemannian Hessian can be computed by adopting Eq. (5.6) [Nguyen:2023](@cite),
so very similar to the complex Stiefel manifold.
The only difference is, that here the tangent vectors are stored
in the Lie algebra, i.e. the update direction is actually ``pX`` instead of just ``X`` (in Stiefel).
and that means the inverse has to be applied to the (Euclidean) Hessian
to map it into the Lie algebra.
"""
riemannian_Hessian(M::UnitaryMatrices, p, G, H, X)
function riemannian_Hessian!(M::UnitaryMatrices, Y, p, G, H, X)
    symmetrize!(Y, G' * p)
    project!(M, Y, p, p' * H - X * Y)
    return Y
end

@doc raw"""
    Weingarten(M::UnitaryMatrices, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Stiefel`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

The formula is due to [AbsilMahonyTrumpf:2013](@cite) given by

```math
\mathcal W_p(X,V) = -\frac{1}{2}p\bigl(V^{\mathrm{H}}X - X^\mathrm{H}V\bigr).
```
"""
Weingarten(::UnitaryMatrices, p, X, V)

function Weingarten!(::UnitaryMatrices, Y, p, X, V)
    Y .= V' * X
    Y .= -p * 1 / 2 * (Y - Y')
    return Y
end

zero_vector(::UnitaryMatrices{ℍ, TypeParameter{Tuple{1}}}, p) = zero(p)

using Manifolds, Test

@testset "Test Notation" begin
    M = Sphere(2)
    p1 = [1.0, 0.0, 0.0]
    @test (p1 ∈ M) == is_point(M, p1)
    @test (2 * p1 ∈ M) == is_point(M, 2 * p1)
    X1 = [0.0, 1.0, 0.0]
    X2 = [1.0, 0.0, 0.0]
    TpM = TangentSpace(M, p1)
    @test (X1 ∈ TpM) == is_vector(M, p1, X1)
    @test (X2 ∈ TpM) == is_vector(M, p1, X2)
end

@doc raw"""
    GeneralizedBurresWassertseinMetric{T<:AbstractMatrix} <: AbstractMetric

The generalized Bures Wasserstein metric for symmetric positive definite matrices, see [HanMishraJawanpuriaGao:2021](@cite).

This metric internally stores the symmetric positive definite matrix ``M`` to generalise the metric,
where the name also follows the mentioned preprint.
"""
struct GeneralizedBuresWassersteinMetric{T <: AbstractMatrix} <: RiemannianMetric
    M::T
    GeneralizedBuresWassersteinMetric(MM::TT) where {TT <: AbstractMatrix} = new{TT}(MM)
end

@doc raw"""
    change_representer(M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,<:GeneralizedBuresWassersteinMetric}, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal M`` representing a linear function on the tangent
space at `p` with respect to the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
`g_E`, this is turned into the representer with respect to the (default) metric,
the [`GeneralizedBuresWassersteinMetric`](@ref) on the [`SymmetricPositiveDefinite`](@ref) `M`.

To be precise we are looking for ``Z∈T_p\mathcal P(n)`` such that for all ``Y∈T_p\mathcal P(n)``
it holds

```math
⟨X,Y⟩ = \operatorname{tr}(XY) = ⟨Z,Y⟩_{\mathrm{BW}}
```
for all ``Y`` and hence we get ``Z = 2pXM + 2MXp``.
"""
change_representer(
    ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
    ::EuclideanMetric,
    p,
    X,
)

function change_representer!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
        Y,
        ::EuclideanMetric,
        p,
        X,
    )
    Y .= 2 .* (p * X * M.metric.M + M.metric.M * X * p)
    return Y
end

@doc raw"""
    distance(::MetricManifold{SymmetricPositiveDefinite,GeneralizedBuresWassersteinMetric}, p, q)

Compute the distance with respect to the [`BuresWassersteinMetric`](@ref) on [`SymmetricPositiveDefinite`](@ref) matrices, i.e.

```math
d(p,q) = \operatorname{tr}(M^{-1}p) + \operatorname{tr}(M^{-1}q)
       - 2\operatorname{tr}\bigl( (p^{\frac{1}{2}}M^{-1}qM^{-1}p^{\frac{1}{2}} \bigr)^{\frac{1}{2}},
```
"""
function distance(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
        p,
        q,
    )
    luM = lu(M.metric.M)
    luMp = luM \ p
    luMq = luM \ q
    return sqrt(tr(luMp) + tr(luMq) - 2 * tr(sqrt(luMq * luMp)))
end

@doc raw"""
    exp(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,<:GeneralizedBuresWassersteinMetric}, p, X)

Compute the exponential map on [`SymmetricPositiveDefinite`](@ref) with respect to
the [`GeneralizedBuresWassersteinMetric`](@ref) given by

```math
    \exp_p(X) = p+X+\mathcal ML_{p,M}(X)pML_{p,M}(X)
```

where ``q=L_{M,p}(X)`` denotes the generalized Lyapunov operator, i.e. it solves ``pqM + Mqp = X``.
"""
exp(
    ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
    p,
    X,
)

function exp!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
        q,
        p,
        X,
    )
    m = M.metric.M
    Y = lyapc(p, m, -X) #lyap solves qpM + Mpq - X =0
    q .= p .+ X .+ m * Y * p * Y * m
    # symmetrizing for better accuracy
    copyto!(q, (q .+ q') ./ 2)
    return q
end

@doc raw"""
    inner(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,<:GeneralizedBuresWassersteinMetric}, p, X, Y)

Compute the inner product [`SymmetricPositiveDefinite`](@ref) with respect to
the [`GeneralizedBuresWassersteinMetric`](@ref) given by

```math
    ⟨X,Y⟩ = \frac{1}{2}\operatorname{tr}(L_{p,M}(X)Y)
```

where ``q=L_{M,p}(X)`` denotes the generalized Lyapunov operator, i.e. it solves ``pqM + Mqp = X``.
"""
function inner(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
        p,
        X,
        Y,
    )
    return dot(lyapc(p, M.metric.M, -X), Y) / 2
end

"""
    is_flat(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,<:GeneralizedBuresWassersteinMetric})

Return false. [`SymmetricPositiveDefinite`](@ref) with [`GeneralizedBuresWassersteinMetric`](@ref)
is not a flat manifold.
"""
function is_flat(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
    )
    return false
end

@doc raw"""
    log(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,<:GeneralizedBuresWassersteinMetric}, p, q)

Compute the logarithmic map on [`SymmetricPositiveDefinite`](@ref) with respect to
the [`BuresWassersteinMetric`](@ref) given by

```math
    \log_p(q) = M(M^{-1}pM^{-1}q)^{\frac{1}{2}} + (qM^{-1}pM^{-1})^{\frac{1}{2}}M - 2 p.
```
"""
log(
    ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
    p,
    q,
)

function log!(
        M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, <:GeneralizedBuresWassersteinMetric},
        X,
        p,
        q,
    )
    m = M.metric.M
    lum = lu(m)
    lum_p_lum = lum \ p / lum
    X .= real.(Symmetric(m * sqrt(lum_p_lum * q) + sqrt(q * lum_p_lum) * m) - 2 * p)
    return X
end

#
# Default implementation for the matrix type, i.e. as congruence class Stiefel matrices
#
"""
    StiefelPoint <: AbstractManifoldPoint

A point on a [`Stiefel`](@ref) manifold.
This point is mainly used for representing points on the [`Grassmann`](@ref) where this
is also the default representation and hence equivalent to using `AbstractMatrices` thereon.
they can also used be used as points on Stiefel.
"""
struct StiefelPoint{T <: AbstractMatrix} <: AbstractManifoldPoint
    value::T
end

"""
    StiefelTangentVector <: AbstractTangentVector

A tangent vector on the [`Grassmann`](@ref) manifold represented by a tangent vector from
the tangent space of a corresponding point from the [`Stiefel`](@ref) manifold,
see [`StiefelPoint`](@ref).
This is the default representation so is can be used interchangeably with just abstract matrices.
"""
struct StiefelTangentVector{T <: AbstractMatrix} <: AbstractTangentVector
    value::T
end

ManifoldsBase.@manifold_element_forwards StiefelPoint value
ManifoldsBase.@manifold_vector_forwards StiefelTangentVector value
ManifoldsBase.@default_manifold_fallbacks Stiefel StiefelPoint StiefelTangentVector value value
ManifoldsBase.@default_manifold_fallbacks (Stiefel{ℝ}) StiefelPoint StiefelTangentVector value value
ManifoldsBase.@default_manifold_fallbacks Grassmann StiefelPoint StiefelTangentVector value value

function default_vector_transport_method(::Grassmann, ::Type{<:AbstractArray})
    return ParallelTransport()
end
default_vector_transport_method(::Grassmann, ::Type{<:StiefelPoint}) = ParallelTransport()

@doc raw"""
    distance(M::Grassmann, p, q)

Compute the Riemannian distance on [`Grassmann`](@ref) manifold `M```= \mathrm{Gr}(n,k)``.

The distance is given by

````math
d_{\mathrm{Gr}(n,k)}(p,q) = \operatorname{norm}(\log_p(q)).
````
"""
function distance(::Grassmann, p, q)
    z = p' * q
    S = svd(q / z - p).S
    return norm(map(atan, S))
end

embed(::Grassmann, p) = p
embed(::Grassmann, p, X) = X
embed!(::Grassmann, q, p) = copyto!(q, p)
embed!(::Grassmann, Y, p, X) = copyto!(Y, X)
embed!(::Grassmann, q, p::StiefelPoint) = copyto!(q, p.value)
embed!(::Grassmann, Y, p::StiefelPoint, X::StiefelTangentVector) = copyto!(Y, X.value)
embed(::Grassmann, p::StiefelPoint) = p.value
embed(::Grassmann, p::StiefelPoint, X::StiefelTangentVector) = X.value
embed!(::Stiefel, q, p::StiefelPoint) = copyto!(q, p.value)
embed!(::Stiefel, Y, p::StiefelPoint, X::StiefelTangentVector) = copyto!(Y, X.value)
embed(::Stiefel, p::StiefelPoint) = p.value
embed(::Stiefel, p::StiefelPoint, X::StiefelTangentVector) = X.value

@doc raw"""
    exp(M::Grassmann, p, X)

Compute the exponential map on the [`Grassmann`](@ref) `M` ``= \mathrm{Gr}(n,k)`` starting in
`p` with tangent vector (direction) `X`. Let ``X = USV`` denote the SVD decomposition of ``X``.
Then the exponential map is written using

````math
z = p V\cos(S)V^\mathrm{H} + U\sin(S)V^\mathrm{H},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian and the
cosine and sine are applied element wise to the diagonal entries of ``S``. A final QR
decomposition ``z=QR`` is performed for numerical stability reasons, yielding the result as

````math
\exp_p X = Q.
````
"""
exp(::Grassmann, ::Any, ::Any)

function exp!(M::Grassmann, q, p, X)
    norm(M, p, X) ≈ 0 && return copyto!(q, p)
    d = svd(X)
    z = (p * (d.V .* cos.(d.S')) + d.U .* sin.(d.S')) * d.Vt
    return copyto!(q, Array(qr(z).Q))
end

function get_embedding(::Grassmann{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return Stiefel(n, k, 𝔽)
end
function get_embedding(M::Grassmann{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return Stiefel(n, k, 𝔽; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Grassmann)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

function ManifoldsBase.get_forwarding_type(::Grassmann, f, ::Type{<:StiefelPoint})
    return ManifoldsBase.EmbeddedForwardingType()
end
function ManifoldsBase.get_forwarding_type(::Stiefel, f, ::Type{<:StiefelPoint})
    return ManifoldsBase.EmbeddedForwardingType()
end

@doc raw"""
    inner(M::Grassmann, p, X, Y)

Compute the inner product for two tangent vectors `X`, `Y` from the tangent space
of `p` on the [`Grassmann`](@ref) manifold `M`. The formula reads

````math
g_p(X,Y) = \operatorname{tr}(X^{\mathrm{H}}Y),
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
inner(::Grassmann, p, X, Y) = dot(X, Y)

@doc raw"""
    inverse_retract(M::Grassmann, p, q, ::PolarInverseRetraction)

Compute the inverse retraction for the [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`), on the
[`Grassmann`](@ref) manifold `M`, i.e.,

````math
\operatorname{retr}_p^{-1}q = q*(p^\mathrm{H}q)^{-1} - p,
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
inverse_retract(::Grassmann, ::Any, ::Any, ::PolarInverseRetraction)

function inverse_retract_polar!(::Grassmann, X, p, q)
    X .= q / (p' * q) .- p
    return X
end

@doc raw"""
    inverse_retract(M, p, q, ::QRInverseRetraction)

Compute the inverse retraction for the [`QRRetraction`](@extref `ManifoldsBase.QRRetraction`), on the
[`Grassmann`](@ref) manifold `M`, i.e.,

````math
\operatorname{retr}_p^{-1}q = q(p^\mathrm{H}q)^{-1} - p,
````
where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
inverse_retract(::Grassmann, ::Any, ::Any, ::QRInverseRetraction)

function inverse_retract_qr!(::Grassmann, X, p, q)
    X .= q / (p' * q) .- p
    return X
end

@doc raw"""
    log(M::Grassmann, p, q)

Compute the logarithmic map on the [`Grassmann`](@ref) `M` `` = \mathcal M=\mathrm{Gr}(n,k)``,
i.e. the tangent vector `X` whose corresponding [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) starting from `p`
reaches `q` after time 1 on `M`. The formula reads

````math
\log_p q = V⋅ \operatorname{atan}(S) ⋅ U^\mathrm{H},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
The matrices ``U`` and ``V`` are the unitary matrices, and ``S`` is the diagonal matrix
containing the singular values of the SVD-decomposition

````math
USV = (q^\mathrm{H}p)^{-1} ( q^\mathrm{H} - q^\mathrm{H}pp^\mathrm{H}).
````

In this formula the ``\operatorname{atan}`` is meant elementwise.
"""
log(::Grassmann, ::Any...)

function log!(M::Grassmann, X, p, q)
    inverse_retract_polar!(M, X, p, q)
    d = svd(X)
    mul!(X, d.U, atan.(d.S) .* d.Vt)
    return X
end

@doc raw"""
    parallel_transport_direction(M::Grassmann, p, X, Y)

Compute the parallel transport of ``X \in   T_p\mathcal M`` along the
geodesic starting in direction ``\dot γ (0) = Y``.

 Let ``Y = USV`` denote the SVD decomposition of ``Y``.
Then the parallel transport is given by the formula according to Equation (8.5) (p. 171) [AbsilMahonySepulchre:2008](@cite) as

```math
\mathcal P_{p,Y} X = -pV \sin(S)U^{\mathrm{T}}X + U\cos(S)U^{\mathrm{T}}X + (I-UU^{\mathrm{T}})X
```

where the sine and cosine applied to the diagonal matrix ``S`` are meant to be elementwise
"""
parallel_transport_direction(M::Grassmann, p, X, Y)

# Hook into default since here we have direction first
function parallel_transport_direction(M::Grassmann, p, X, Y)
    Z = zero_vector(M, exp(M, p, X))
    return parallel_transport_direction!(M, Z, p, X, Y)
end

function parallel_transport_direction!(M::Grassmann, Z, p, X, Y)
    d = svd(Y)
    return copyto!(
        M,
        Z,
        p,
        (-p * d.V .* sin.(d.S') + d.U .* cos.(d.S')) * (d.U' * X) + (I - d.U * d.U') * X,
    )
end

@doc raw"""
    parallel_transport_to(M::Grassmann, p, X, q)

Compute the parallel transport of ``X ∈  T_p\mathcal M`` along the
geodesic connecting ``p`` to ``q``.

This method uses the [logarithmic map](@ref log(::Grassmann, ::Any...)) and the [parallel transport in that direction](@ref parallel_transport_direction(M::Grassmann, p, X, Y)).
"""
parallel_transport_to(M::Grassmann, p, X, q)

function parallel_transport_to!(M::Grassmann, Z, p, X, q)
    Y = log(M, p, q)
    return parallel_transport_direction!(M, Z, p, X, Y)
end

@doc raw"""
    project(M::Grassmann, p)

Project `p` from the embedding onto the [`Grassmann`](@ref) `M`, i.e. compute `q`
as the polar decomposition of ``p`` such that ``q^{\mathrm{H}}q`` is the identity,
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
project(::Grassmann, ::Any)

function project!(::Grassmann, q, p)
    s = svd(p)
    mul!(q, s.U, s.Vt)
    return q
end

@doc raw"""
    project(M::Grassmann, p, X)

Project the `n`-by-`k` `X` onto the tangent space of `p` on the [`Grassmann`](@ref) `M`,
which is computed by

````math
\operatorname{proj_p}(X) = X - pp^{\mathrm{H}}X,
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
project(::Grassmann, ::Any...)

function project!(::Grassmann, Y, p, X)
    copyto!(Y, X)
    mul!(Y, p, p' * X, -1, 1)
    return Y
end

@doc raw"""
    rand(M::Grassmann; σ::Real=1.0, vector_at=nothing)

When `vector_at` is `nothing`, return a random point `p` on [`Grassmann`](@ref) manifold `M`
by generating a random (Gaussian) matrix with standard deviation `σ` in matching
size, which is orthonormal.

When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_p\mathrm{Gr}(n,k)`` with mean zero and standard deviation `σ` by projecting a random
Matrix onto the tangent space at `vector_at`.
"""
rand(M::Grassmann; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::Grassmann{𝔽},
        pX;
        σ::Real = one(real(eltype(pX))),
        vector_at = nothing,
    ) where {𝔽}
    if vector_at === nothing
        n, k = get_parameter(M.size)
        V = σ * randn(rng, 𝔽 === ℝ ? Float64 : ComplexF64, (n, k))
        pX .= qr(V).Q[:, 1:k]
    else
        Z = σ * randn(rng, eltype(pX), size(pX))
        project!(M, pX, vector_at, Z)
        pX ./= norm(pX)
    end
    return pX
end

@doc raw"""
    representation_size(M::Grassmann)

Return the representation size or matrix dimension of a point on the [`Grassmann`](@ref)
`M`, i.e. ``(n,k)`` for both the real-valued and the complex value case.
"""
representation_size(M::Grassmann) = get_parameter(M.size)

@doc raw"""
    retract(M::Grassmann, p, X, ::PolarRetraction)

Compute the SVD-based retraction [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`Grassmann`](@ref) `M`. With ``USV = p + X`` the retraction reads
````math
\operatorname{retr}_p X = UV^\mathrm{H},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
retract(::Grassmann, ::Any, ::Any, ::PolarRetraction)

function ManifoldsBase.retract_polar!(M::Grassmann, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_polar_fused!(M::Grassmann, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

@doc raw"""
    retract(M::Grassmann, p, X, ::QRRetraction )

Compute the QR-based retraction [`QRRetraction`](@extref `ManifoldsBase.QRRetraction`) on the
[`Grassmann`](@ref) `M`. With ``QR = p + X`` the retraction reads
````math
\operatorname{retr}_p X = QD,
````
where D is a ``m×n`` matrix with
````math
D = \operatorname{diag}\left( \operatorname{sgn}\left(R_{ii}+\frac{1}{2}\right)_{i=1}^n \right).
````
"""
retract(::Grassmann, ::Any, ::Any, ::QRRetraction)

function ManifoldsBase.retract_qr!(M::Grassmann, q, p, X)
    return ManifoldsBase.retract_qr_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_qr_fused!(::Grassmann, q, p, X, t::Number)
    q .= p .+ t .* X
    qrfac = qr(q)
    d = diag(qrfac.R)
    q .= Array(qrfac.Q) .* sign.(transpose(d) .+ 1 // 2)
    return q
end

@doc raw"""
    riemannian_Hessian(M::Grassmann, p, G, H, X)

The Riemannian Hessian can be computed by adopting Eq. (6.6) [Nguyen:2023](@cite),
where we use for the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`) ``α_0=α_1=1`` in their formula.
Let ``\nabla f(p)`` denote the Euclidean gradient `G`,
``\nabla^2 f(p)[X]`` the Euclidean Hessian `H`. Then the formula reads

```math
    \operatorname{Hess}f(p)[X]
    =
    \operatorname{proj}_{T_p\mathcal M}\Bigl(
        ∇^2f(p)[X] - X p^{\mathrm{H}}∇f(p)
    \Bigr).
```

Compared to Eq. (5.6) also the metric conversion simplifies to the identity.
"""
riemannian_Hessian(M::Grassmann, p, G, H, X)

function riemannian_Hessian!(M::Grassmann, Y, p, G, H, X)
    project!(M, Y, p, H - X * p' * G)
    return Y
end

@doc raw"""
    riemann_tensor(::Grassmann{<:Any,ℝ}, p, X, Y, Z)

Compute the value of Riemann tensor on the real [`Grassmann`](@ref) manifold.
The formula reads [Rentmeesters:2011](@cite)

```math
R(X,Y)Z = (XY^\mathrm{T} - YX^\mathrm{T})Z + Z(Y^\mathrm{T}X - X^\mathrm{T}Y).
```
"""
riemann_tensor(::Grassmann{ℝ}, p, X, Y, Z)

function riemann_tensor!(::Grassmann{ℝ}, Xresult, p, X, Y, Z)
    XYᵀ = X * Y'
    YXᵀ = XYᵀ'
    YᵀX = Y' * X
    XᵀY = YᵀX'
    Xresult .= (XYᵀ - YXᵀ) * Z .- Z * (YᵀX - XᵀY)
    return Xresult
end

function Base.show(io::IO, ::Grassmann{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return print(io, "Grassmann($(n), $(k), $(𝔽))")
end
function Base.show(io::IO, M::Grassmann{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return print(io, "Grassmann($(n), $(k), $(𝔽); parameter=:field)")
end
Base.show(io::IO, p::StiefelPoint) = print(io, "StiefelPoint($(p.value))")
Base.show(io::IO, X::StiefelTangentVector) = print(io, "StiefelTangentVector($(X.value))")

# switch order and not dispatch on the _to variant
function vector_transport_direction(M::Grassmann, p, X, Y, ::ParallelTransport)
    return parallel_transport_direction(M, p, X, Y)
end
function vector_transport_direction!(M::Grassmann, Z, p, X, Y, ::ParallelTransport)
    return parallel_transport_direction!(M, Z, p, X, Y)
end

@doc raw"""
    vector_transport_to(M::Grassmann, p, X, q, ::ProjectionTransport)

compute the projection based transport on the [`Grassmann`](@ref) `M` by
interpreting `X` from the tangent space at `p` as a point in the embedding and
projecting it onto the tangent space at q.
"""
vector_transport_to(::Grassmann, ::Any, ::Any, ::Any, ::ProjectionTransport)

@doc raw"""
    zero_vector(M::Grassmann, p)

Return the zero tangent vector from the tangent space at `p` on the [`Grassmann`](@ref) `M`,
which is given by a zero matrix the same size as `p`.
"""
zero_vector(::Grassmann, ::Any...)

zero_vector!(::Grassmann, X, p) = fill!(X, 0)

@doc raw"""
    change_representer(M::Hyperbolic, ::EuclideanMetric, p, X)

Change the Eucliden representer `X` of a cotangent vector at point `p`.
We only have to correct for the metric, which means that the sign of the last entry changes, since
for the result ``Y``  we are looking for a tangent vector such that

```math
    g_p(Y,Z) = -y_{n+1}z_{n+1} + \sum_{i=1}^n y_iz_i = \sum_{i=1}^{n+1} z_ix_i
```

holds, which directly yields ``y_i=x_i`` for ``i=1,\ldots,n`` and ``y_{n+1}=-x_{n+1}``.
"""
change_representer(::Hyperbolic, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(M::Hyperbolic, Y, ::EuclideanMetric, p, X)
    copyto!(M, Y, p, X)
    Y[end] *= -1
    return Y
end

function change_metric!(::Hyperbolic, ::Any, ::EuclideanMetric, ::Any, ::Any)
    return error(
        "Changing metric from Euclidean to Hyperbolic is not possible (see Sylvester's law of inertia).",
    )
end

function check_point(M::Hyperbolic, p; kwargs...)
    if !isapprox(minkowski_metric(p, p), -1.0; kwargs...)
        return DomainError(
            minkowski_metric(p, p),
            "The point $(p) does not lie on $(M) since its Minkowski inner product is not -1.",
        )
    end
    return nothing
end

function check_vector(
        M::Hyperbolic,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(minkowski_metric(p, X), 0; atol = atol, kwargs...)
        return DomainError(
            abs(minkowski_metric(p, X)),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not orthogonal (with respect to the Minkowski inner product) in the embedding.",
        )
    end
    return nothing
end

function convert(::Type{HyperboloidTangentVector}, X::T) where {T <: AbstractVector}
    return HyperboloidTangentVector(X)
end
function convert(
        ::Type{HyperboloidTangentVector},
        p::P,
        X::T,
    ) where {P <: AbstractVector, T <: AbstractVector}
    return HyperboloidTangentVector(X)
end
convert(::Type{AbstractVector}, X::HyperboloidTangentVector) = X.value
function convert(
        ::Type{T},
        p::HyperboloidPoint,
        X::HyperboloidTangentVector,
    ) where {T <: AbstractVector}
    return X.value
end

function convert(::Type{HyperboloidPoint}, p::T) where {T <: AbstractVector}
    return HyperboloidPoint(p)
end
convert(::Type{AbstractVector}, p::HyperboloidPoint) = p.value

@doc raw"""
    convert(::Type{HyperboloidPoint}, p::PoincareBallPoint)
    convert(::Type{AbstractVector}, p::PoincareBallPoint)

convert a point [`PoincareBallPoint`](@ref) `x` (from ``ℝ^n``) from the
Poincaré ball model of the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` to a [`HyperboloidPoint`](@ref) ``π(p) ∈ ℝ^{n+1}``.
The isometry is defined by

````math
π(p) = \frac{1}{1-\lVert p \rVert^2}
\begin{pmatrix}2p_1\\⋮\\2p_n\\1+\lVert p \rVert^2\end{pmatrix}
````

Note that this is also used, when the type to convert to is a vector.
"""
function convert(::Type{HyperboloidPoint}, p::PoincareBallPoint)
    return HyperboloidPoint(convert(AbstractVector, p))
end
function convert(::Type{AbstractVector}, p::PoincareBallPoint)
    return 1 / (1 - norm(p.value)^2) .* vcat(2 .* p.value, 1 + norm(p.value)^2)
end

@doc raw"""
    convert(::Type{HyperboloidPoint}, p::PoincareHalfSpacePoint)
    convert(::Type{AbstractVector}, p::PoincareHalfSpacePoint)

convert a point [`PoincareHalfSpacePoint`](@ref) `p` (from ``ℝ^n``) from the
Poincaré half plane model of the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` to a [`HyperboloidPoint`](@ref) ``π(p) ∈ ℝ^{n+1}``.

This is done in two steps, namely transforming it to a Poincare ball point and from there further on to a Hyperboloid point.
"""
function convert(t::Type{HyperboloidPoint}, p::PoincareHalfSpacePoint)
    return convert(t, convert(PoincareBallPoint, p))
end
function convert(t::Type{AbstractVector}, p::PoincareHalfSpacePoint)
    return convert(t, convert(PoincareBallPoint, p))
end

@doc raw"""
    convert(::Type{HyperboloidTangentVector}, p::PoincareBallPoint, X::PoincareBallTangentVector)
    convert(::Type{AbstractVector}, p::PoincareBallPoint, X::PoincareBallTangentVector)

Convert the [`PoincareBallTangentVector`](@ref) `X` from the tangent space at `p` to a
[`HyperboloidTangentVector`](@ref) by computing the push forward of the isometric map, cf.
[`convert(::Type{HyperboloidPoint}, p::PoincareBallPoint)`](@ref).

The push forward ``π_*(p)`` maps from ``ℝ^n`` to a subspace of ``ℝ^{n+1}``, the formula reads

````math
π_*(p)[X] = \begin{pmatrix}
    \frac{2X_1}{1-\lVert p \rVert^2} + \frac{4}{(1-\lVert p \rVert^2)^2}⟨X,p⟩p_1\\
    ⋮\\
    \frac{2X_n}{1-\lVert p \rVert^2} + \frac{4}{(1-\lVert p \rVert^2)^2}⟨X,p⟩p_n\\
    \frac{4}{(1-\lVert p \rVert^2)^2}⟨X,p⟩
\end{pmatrix}.
````
"""
function convert(
        ::Type{HyperboloidTangentVector},
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
    )
    return HyperboloidTangentVector(convert(AbstractVector, p, X))
end
function convert(
        ::Type{T},
        p::PoincareBallPoint,
        X::PoincareBallTangentVector,
    ) where {T <: AbstractVector}
    t = (1 - norm(p.value)^2)
    den = 4 * dot(p.value, X.value) / (t^2)
    c1 = (2 / t) .* X.value + den .* p.value
    return vcat(c1, den)
end

@doc raw"""
    convert(
        ::Type{Tuple{HyperboloidPoint,HyperboloidTangentVector}}.
        (p,X)::Tuple{PoincareBallPoint,PoincareBallTangentVector}
    )
    convert(
        ::Type{Tuple{P,T}},
        (p, X)::Tuple{PoincareBallPoint,PoincareBallTangentVector},
    ) where {P<:AbstractVector, T <: AbstractVector}

Convert a [`PoincareBallPoint`](@ref) `p` and a [`PoincareBallTangentVector`](@ref) `X`
to a [`HyperboloidPoint`](@ref) and a [`HyperboloidTangentVector`](@ref) simultaneously,
see [`convert(::Type{HyperboloidPoint}, ::PoincareBallPoint)`](@ref) and
[`convert(::Type{HyperboloidTangentVector}, ::PoincareBallPoint, ::PoincareBallTangentVector)`](@ref)
for the formulae.
"""
function convert(
        ::Type{Tuple{HyperboloidPoint, HyperboloidTangentVector}},
        (p, X)::Tuple{PoincareBallPoint, PoincareBallTangentVector},
    )
    return (convert(HyperboloidPoint, p), convert(HyperboloidTangentVector, p, X))
end

@doc raw"""
    convert(::Type{HyperboloidTangentVector}, p::PoincareHalfSpacePoint, X::PoincareHalfSpaceTangentVector)
    convert(::Type{AbstractVector}, p::PoincareHalfSpacePoint, X::PoincareHalfSpaceTangentVector)

convert a point [`PoincareHalfSpaceTangentVector`](@ref) `X` (from ``ℝ^n``) at `p` from the
Poincaré half plane model of the [`Hyperbolic`](@ref) manifold ``\mathcal H^n`` to a
[`HyperboloidTangentVector`](@ref) ``π(p) ∈ ℝ^{n+1}``.

This is done in two steps, namely transforming it to a Poincare ball point and from there further on to a Hyperboloid point.
"""
function convert(
        t::Type{HyperboloidTangentVector},
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
    )
    return convert(
        t,
        convert(Tuple{PoincareBallPoint, PoincareBallTangentVector}, (p, X))...,
    )
end
function convert(
        t::Type{T},
        p::PoincareHalfSpacePoint,
        X::PoincareHalfSpaceTangentVector,
    ) where {T <: AbstractVector}
    return convert(
        t,
        convert(Tuple{PoincareBallPoint, PoincareBallTangentVector}, (p, X))...,
    )
end

@doc raw"""
    convert(
        ::Type{Tuple{HyperboloidPoint,HyperboloidTangentVector},
        (p,X)::Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector}
    )
    convert(
        ::Type{Tuple{T,T},
        (p,X)::Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector}
    ) where {T<:AbstractVector}

convert a point [`PoincareHalfSpaceTangentVector`](@ref) `X` (from ``ℝ^n``) at `p` from the
Poincaré half plane model of the [`Hyperbolic`](@ref) manifold ``\mathcal H^n``
to a tuple of a [`HyperboloidPoint`](@ref) and a [`HyperboloidTangentVector`](@ref) ``π(p) ∈ ℝ^{n+1}``
simultaneously.

This is done in two steps, namely transforming it to the Poincare ball model and from there
further on to a Hyperboloid.
"""
function convert(
        t::Type{Tuple{HyperboloidPoint, HyperboloidTangentVector}},
        (p, X)::Tuple{PoincareHalfSpacePoint, PoincareHalfSpaceTangentVector},
    )
    return convert(t, convert(Tuple{PoincareBallPoint, PoincareBallTangentVector}, (p, X)))
end

@doc raw"""
    distance(M::Hyperbolic, p, q)
    distance(M::Hyperbolic, p::HyperboloidPoint, q::HyperboloidPoint)

Compute the distance on the [`Hyperbolic`](@ref) `M`, which reads

````math
d_{\mathcal H^n}(p,q) = \operatorname{acosh}( - ⟨p, q⟩_{\mathrm{M}}),
````

where ``⟨⋅,⋅⟩_{\mathrm{M}}`` denotes the [`MinkowskiMetric`](@ref) on the embedding, the [`Lorentz`](@ref)ian manifold,
see for example the extended version [BergmannPerschSteidl:2015:1](@cite) of the paper [BergmannPerschSteidl:2016:1](@cite).
"""
function distance(::Hyperbolic, p, q)
    w = q - p
    m = sqrt(max(0.0, minkowski_metric(w, w)))
    return 2 * asinh(m / 2)
end

embed(M::Hyperbolic, p::HyperboloidPoint) = embed(M, p.value)
embed!(M::Hyperbolic, q, p::HyperboloidPoint) = embed!(M, q, p.value)
function embed(M::Hyperbolic, p::HyperboloidPoint, X::HyperboloidTangentVector)
    return embed(M, p.value, X.value)
end
function embed!(M::Hyperbolic, Y, p::HyperboloidPoint, X::HyperboloidTangentVector)
    return embed!(M, Y, p.value, X.value)
end

function exp_fused!(M::Hyperbolic, q, p, X, t::Number)
    return exp!(M, q, p, t * X)
end
function exp!(M::Hyperbolic, q, p, X)
    vn = sqrt(max(inner(M, p, X, X), 0.0))
    sn = vn == 0 ? one(vn) : sinh(vn) / vn
    q .= cosh(vn) .* p .+ sn .* X
    return q
end

# overwrite the default construction on level 2 (dispatching on basis)
# since this function should not call get_vector (that relies on get_basis itself on H2)
function _get_basis(
        M::Hyperbolic,
        p,
        B::DefaultOrthonormalBasis{ℝ, TangentSpaceType};
        kwargs...,
    )
    return get_basis_orthonormal(M, p, ℝ)
end

function get_basis_orthonormal(M::Hyperbolic, p, r::RealNumbers)
    n = get_parameter(M.size)[1]
    V = [
        _hyperbolize(M, p, [i == k ? one(eltype(p)) : zero(eltype(p)) for k in 1:n]) for
            i in 1:n
    ]
    return CachedBasis(DefaultOrthonormalBasis(r), gram_schmidt(M, p, V))
end

function get_basis_diagonalizing(M::Hyperbolic, p, B::DiagonalizingOrthonormalBasis)
    n = manifold_dimension(M)
    X = B.frame_direction
    V = [
        _hyperbolize(M, p, [i == k ? one(eltype(p)) : zero(eltype(p)) for k in 1:n]) for
            i in 1:n
    ]
    κ = -ones(n)
    if norm(M, p, X) != 0
        placed = false
        for i in 1:n
            if abs(inner(M, p, X, V[i])) ≈ norm(M, p, X) # is X a multiple of V[i]?
                V[i] .= V[1]
                V[1] .= X
                placed = true
                break
            end
        end
        if !placed
            V[1] .= X
        end
        κ[1] = 0.0
    end
    V = gram_schmidt(M, p, V; atol = 4 * eps(eltype(V[1])))
    return CachedBasis(B, DiagonalizingBasisData(B.frame_direction, κ, V))
end

@doc raw"""
    get_coordinates(M::Hyperbolic, p, X, ::DefaultOrthonormalBasis)

Compute the coordinates of the vector `X` with respect to the orthogonalized version of
the unit vectors from ``ℝ^n``, where ``n`` is the manifold dimension of the [`Hyperbolic`](@ref)
 `M`, putting them into the tangent space at `p` and orthonormalizing them.
"""
get_coordinates(M::Hyperbolic, p, X, ::DefaultOrthonormalBasis)

function get_coordinates_orthonormal(M::Hyperbolic, p, X, r::RealNumbers)
    return get_coordinates(M, p, X, get_basis_orthonormal(M, p, r))
end
function get_coordinates_orthonormal!(M::Hyperbolic, c, p, X, r::RealNumbers)
    c = get_coordinates!(M, c, p, X, get_basis_orthonormal(M, p, r))
    return c
end
function get_coordinates_diagonalizing!(
        M::Hyperbolic,
        c,
        p,
        X,
        B::DiagonalizingOrthonormalBasis,
    )
    c = get_coordinates!(M, c, p, X, get_basis_diagonalizing(M, p, B))
    return c
end

@doc raw"""
    get_vector(M::Hyperbolic, p, c, ::DefaultOrthonormalBasis)

Compute the vector from the coordinates with respect to the orthogonalized version of
the unit vectors from ``ℝ^n``, where ``n`` is the manifold dimension of the [`Hyperbolic`](@ref)
 `M`, putting them into the tangent space at `p` and orthonormalizing them.
"""
get_vector(M::Hyperbolic, p, c, ::DefaultOrthonormalBasis)

function get_vector_orthonormal!(M::Hyperbolic, X, p, c, r::RealNumbers)
    X = get_vector!(M, X, p, c, get_basis(M, p, DefaultOrthonormalBasis(r)))
    return X
end
function get_vector!(M::Hyperbolic, X, p, c, B::DiagonalizingOrthonormalBasis)
    X = get_vector!(M, X, p, c, get_basis(M, p, B))
    return X
end

@doc raw"""
    _hyperbolize(M, q)

Given the [`Hyperbolic`](@ref)`(n)` manifold using the hyperboloid model, a point from the
``q\in ℝ^n`` can be set onto the manifold by computing its last component such that for the
resulting `p` we have that its [`minkowski_metric`](@ref) is ``⟨p,p⟩_{\mathrm{M}} = - 1``,
i.e. ``p_{n+1} = \sqrt{\lVert q \rVert^2 - 1}``
"""
_hyperbolize(::Hyperbolic, q) = vcat(q, sqrt(norm(q)^2 + 1))

@doc raw"""
    _hyperbolize(M, p, Y)

Given the [`Hyperbolic`](@ref)`(n)` manifold using the hyperboloid model and a point `p`
thereon, we can put a vector ``Y\in ℝ^n``  into the tangent space by computing its last
component such that for the
resulting `p` we have that its [`minkowski_metric`](@ref) is ``⟨p,X⟩_{\mathrm{M}} = 0``,
i.e. ``X_{n+1} = \frac{⟨\tilde p, Y⟩}{p_{n+1}}``, where ``\tilde p = (p_1,\ldots,p_n)``.
"""
_hyperbolize(::Hyperbolic, p, Y) = vcat(Y, dot(p[1:(end - 1)], Y) / p[end])

@doc raw"""
    inner(M::Hyperbolic, p, X, Y)
    inner(M::Hyperbolic, p::HyperboloidPoint, X::HyperboloidTangentVector, Y::HyperboloidTangentVector)

Cmpute the inner product in the Hyperboloid model, i.e. the [`minkowski_metric`](@ref) in
the embedding. The formula reads

````math
g_p(X,Y) = ⟨X,Y⟩_{\mathrm{M}} = -X_{n}Y_{n} + \displaystyle\sum_{k=1}^{n-1} X_kY_k.
````
This employs the metric of the embedding, see [`Lorentz`](@ref) space,
see for example the extended version [BergmannPerschSteidl:2015:1](@cite) of the paper [BergmannPerschSteidl:2016:1](@cite).
"""
inner(M::Hyperbolic, p, X, Y)

function log!(M::Hyperbolic, X, p, q)
    d = distance(M, p, q)
    s = sinh(d)
    w = s == 0 ? one(s) : d / s
    project!(M, X, p, w .* q)
    return X
end

function minkowski_metric(a::HyperboloidPoint, b::HyperboloidPoint)
    return minkowski_metric(a.value, b.value)
end
function minkowski_metric(a::HyperboloidTangentVector, b::HyperboloidPoint)
    return minkowski_metric(a.value, b.value)
end
function minkowski_metric(a::HyperboloidPoint, b::HyperboloidTangentVector)
    return minkowski_metric(a.value, b.value)
end
function minkowski_metric(a::HyperboloidTangentVector, b::HyperboloidTangentVector)
    return minkowski_metric(a.value, b.value)
end

function project(::Hyperbolic, p::HyperboloidPoint, X)
    return HyperboloidTangentVector(X .+ minkowski_metric(p.value, X) .* p.value)
end

project!(::Hyperbolic, Y, p, X) = (Y .= X .+ minkowski_metric(p, X) .* p)
function project!(::Hyperbolic, Y::HyperboloidTangentVector, p::HyperboloidPoint, X)
    return (Y.value .= X .+ minkowski_metric(p.value, X) .* p.value)
end

@doc raw"""
    Random.rand!(rng, M::Hyperbolic, pX; vector_at = nothing, σ = one(eltype(pX)) / sqrt(manifold_dimension(M)))

Fill `pX` in-place with a random object on the Hyperbolic manifold `M` (hyperboloid model).

Behavior
- If `vector_at === nothing` (default) then `pX` is filled as a random point on the hyperboloid
  (an element of H^n in the hyperboloid embedding in ℝ^{n+1}). The routine samples a direction
  ``a ∼ N(0,I_n)`` in the first n coordinates and an offset `f = 1 + σ * |N(0,1)|` for the last
  coordinate, then sets the first ``n`` components to the vector
  ``a  \sqrt(f^2 - 1) / a)`` and the last component to `f`. The resulting vector satisfies
  the Minkowski normalization ⟨p,p⟩_M = -1.

- If `vector_at` is provided (a point on the manifold) then `pX` is filled with a random
  tangent vector at `vector_at`. A Euclidean Gaussian `Y = σ * randn(...)` is sampled and then
  projected to the tangent space at `vector_at`.

Arguments
- `rng::AbstractRNG` : random number generator used for sampling.
- `M::Hyperbolic` : the hyperbolic manifold instance (hyperboloid model).
- `pX` : the array or wrapped type to be written in-place (point or tangent vector).
- `vector_at` : optional point on `M` indicating the base point for tangent vector sampling.
- `σ::Real` : scale parameter (default = 1) controlling dispersion of the samples.

Returns
- `pX` (mutated) : the sampled point or tangent vector.
"""
function Random.rand!(
        rng::AbstractRNG,
        M::Hyperbolic,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)) / sqrt(manifold_dimension(M)),
    )
    N = get_parameter(M.size)[1]
    if vector_at === nothing
        a = randn(rng, N)
        f = 1 + σ * abs(randn(rng))
        pX[firstindex(pX):(end - 1)] .= a .* sqrt(f^2 - 1) / norm(a)
        pX[end] = f
    else
        Y = σ * randn(rng, eltype(vector_at), size(vector_at))
        project!(M, pX, vector_at, Y)
    end
    return pX
end

function parallel_transport_to!(::Hyperbolic, Y, p, X, q)
    return copyto!(
        Y,
        X .+ minkowski_metric(q, X) ./ (1 - minkowski_metric(p, q)) .* (p + q),
    )
end

@doc raw"""
    Y = riemannian_Hessian(M::Hyperbolic, p, G, H, X)
    riemannian_Hessian!(M::Hyperbolic, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

Let ``\mathbf{g} = \mathbf{g}^{-1} = \operatorname{diag}(1,...,1,-1)``.
Then using Remark 4.1 [Nguyen:2023](@cite) the formula reads

```math
\operatorname{Hess}f(p)[X]
=
\operatorname{proj}_{T_p\mathcal M}\bigl(
    \mathbf{g}^{-1}\nabla^2f(p)[X] + X⟨p,\mathbf{g}^{-1}∇f(p)⟩_p
\bigr).
```
"""
riemannian_Hessian(M::Hyperbolic, p, G, H, X)

function riemannian_Hessian!(M::Hyperbolic, Y, p, G, H, X)
    g = copy(G)
    g[end] *= -1 # = g^{-1}G
    h = copy(H)
    H[end] *= -1 # = g^{-1}H
    project!(M, Y, p, h .+ dot(p, g) .* X)
    return Y
end
@doc raw"""
    volume_density(M::Hyperbolic, p, X)

Compute volume density function of the hyperbolic manifold. The formula reads
``(\sinh(\lVert X\rVert)/\lVert X\rVert)^(n-1)`` where `n` is the dimension of `M`.
It is derived from Eq. (4.1) in[ChevallierLiLuDunson:2022](@cite).
"""
function volume_density(M::Hyperbolic, p, X)
    Xnorm = norm(X)
    if Xnorm == 0
        return one(eltype(X))
    else
        n = manifold_dimension(M) - 1
        return (sinh(Xnorm) / Xnorm)^n
    end
end

"""
    fiber_bundle_transport(M::AbstractManifold, fiber::FiberType)

Determine the vector transport used for [`exp`](@ref exp(::FiberBundle, ::Any...)) and
[`log`](@ref log(::FiberBundle, ::Any...)) maps on a vector bundle with fiber type
`fiber` and manifold `M`.
"""
fiber_bundle_transport(M::AbstractManifold, ::FiberType) =
    default_vector_transport_method(M)

"""
    VectorBundle{𝔽,TVS,TM,VTV} = FiberBundle{𝔽,TVS,TM,TVT} where {TVS<:VectorSpaceType}

Alias for [`FiberBundle`](@ref) when fiber type is a `TVS` of type
[`VectorSpaceType`](@extref `ManifoldsBase.VectorSpaceType`).

`VectorSpaceFiberType` is used to encode vector spaces as fiber types.
"""
const VectorBundle{𝔽, TVS, TM, TVT} = FiberBundle{
    𝔽,
    TVS,
    TM,
    TVT,
} where {
    TVS <: VectorSpaceType,
    TM <: AbstractManifold{𝔽},
    TVT <: FiberBundleProductVectorTransport,
}

"""
    TangentBundle{𝔽,M} = VectorBundle{𝔽,TangentSpaceType,M} where {𝔽,M<:AbstractManifold{𝔽}}

Tangent bundle for manifold of type `M`, as a manifold with the Sasaki metric [Sasaki:1958](@cite).

Exact retraction and inverse retraction can be approximated using [`FiberBundleProductRetraction`](@ref),
[`FiberBundleInverseProductRetraction`](@ref) and [`SasakiRetraction`](@extref `ManifoldsBase.SasakiRetraction`).
[`FiberBundleProductVectorTransport`](@ref) can be used as a vector transport.

# Constructors

    TangentBundle(M::AbstractManifold)
    TangentBundle(M::AbstractManifold, vtm::FiberBundleProductVectorTransport)
"""
const TangentBundle{𝔽, M} =
    VectorBundle{𝔽, TangentSpaceType, M} where {𝔽, M <: AbstractManifold{𝔽}}

TangentBundle(M::AbstractManifold) = FiberBundle(TangentSpaceType(), M)
function TangentBundle(M::AbstractManifold, vtm::FiberBundleProductVectorTransport)
    return FiberBundle(TangentSpaceType(), M, vtm)
end

const CotangentBundle{𝔽, M} =
    VectorBundle{𝔽, CotangentSpaceType, M} where {𝔽, M <: AbstractManifold{𝔽}}

CotangentBundle(M::AbstractManifold) = FiberBundle(CotangentSpaceType(), M)
function CotangentBundle(M::AbstractManifold, vtm::FiberBundleProductVectorTransport)
    return FiberBundle(CotangentSpaceType(), M, vtm)
end

function bundle_transport_to!(B::TangentBundle, Y, p, X, q)
    return vector_transport_to!(B.manifold, Y, p, X, q, B.vector_transport.method_vertical)
end

function bundle_transport_tangent_direction!(
        B::TangentBundle,
        Y,
        p,
        pf,
        X,
        d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(B.manifold),
    )
    return vector_transport_direction!(B.manifold, Y, p, X, d, m)
end

function bundle_transport_tangent_to!(
        B::TangentBundle,
        Y,
        p,
        pf,
        X,
        q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(B.manifold),
    )
    return vector_transport_to!(B.manifold, Y, p, X, q, m)
end

function default_inverse_retraction_method(::TangentBundle)
    return FiberBundleInverseProductRetraction()
end

function default_retraction_method(::TangentBundle)
    return FiberBundleProductRetraction()
end

function default_vector_transport_method(B::TangentBundle)
    default_vt_m = default_vector_transport_method(B.manifold)
    return FiberBundleProductVectorTransport(default_vt_m, default_vt_m)
end

"""
    injectivity_radius(M::TangentBundle)

Injectivity radius of [`TangentBundle`](@ref) manifold is infinite if the base manifold
is flat and 0 otherwise.
See [https://mathoverflow.net/questions/94322/injectivity-radius-of-the-sasaki-metric](https://mathoverflow.net/questions/94322/injectivity-radius-of-the-sasaki-metric).
"""
function injectivity_radius(M::TangentBundle)
    if is_flat(M.manifold)
        return Inf
    else
        return 0.0
    end
end

@doc raw"""
    inner(B::VectorBundle, p, X, Y)

Inner product of tangent vectors `X` and `Y` at point `p` from the
vector bundle `B` over manifold `B.fiber` (denoted ``\mathcal M``).

Notation:
  * The point ``p = (x_p, V_p)`` where ``x_p ∈ \mathcal M`` and ``V_p`` belongs to the
    fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
    canonical projection of that vector bundle ``B``.
  * The tangent vector ``v = (V_{X,M}, V_{X,F}) ∈ T_{x}B`` where
    ``V_{X,M}`` is a tangent vector from the tangent space ``T_{x_p}\mathcal M`` and
    ``V_{X,F}`` is a tangent vector from the tangent space ``T_{V_p}F`` (isomorphic to ``F``).
    Similarly for the other tangent vector ``w = (V_{Y,M}, V_{Y,F}) ∈ T_{x}B``.

The inner product is calculated as

``⟨X, Y⟩_p = ⟨V_{X,M}, V_{Y,M}⟩_{x_p} + ⟨V_{X,F}, V_{Y,F}⟩_{V_p}.``
"""
function inner(B::FiberBundle, p, X, Y)
    px, Vx = submanifold_components(B.manifold, p)
    VXM, VXF = submanifold_components(B.manifold, X)
    VYM, VYF = submanifold_components(B.manifold, Y)
    F = Fiber(B.manifold, px, B.type)
    # for tangent bundle Vx is discarded by the method of inner for TangentSpace
    # and px is actually used as the base point
    return inner(B.manifold, px, VXM, VYM) + inner(F, Vx, VXF, VYF)
end

function _inverse_retract(M::FiberBundle, p, q, ::FiberBundleInverseProductRetraction)
    return inverse_retract_product(M, p, q)
end

function _inverse_retract!(M::FiberBundle, X, p, q, ::FiberBundleInverseProductRetraction)
    return inverse_retract_product!(M, X, p, q)
end

"""
    inverse_retract(M::VectorBundle, p, q, ::FiberBundleInverseProductRetraction)

Compute the allocating variant of the [`FiberBundleInverseProductRetraction`](@ref),
which by default allocates and calls `inverse_retract_product!`.
"""
inverse_retract(::VectorBundle, p, q, ::FiberBundleInverseProductRetraction)

function inverse_retract_product(M::VectorBundle, p, q)
    X = allocate_result(M, inverse_retract, p, q)
    return inverse_retract_product!(M, X, p, q)
end

function inverse_retract_product!(B::VectorBundle, X, p, q)
    px, Vx = submanifold_components(B.manifold, p)
    py, Vy = submanifold_components(B.manifold, q)
    VXM, VXF = submanifold_components(B.manifold, X)
    log!(B.manifold, VXM, px, py)
    bundle_transport_to!(B, VXF, py, Vy, px)
    copyto!(VXF, VXF - Vx)
    return X
end

"""
    is_flat(::VectorBundle)

Return true if the underlying manifold of [`VectorBundle`](@ref) `M` is flat.
"""
is_flat(M::VectorBundle) = is_flat(M.manifold)

@doc raw"""
    project(B::VectorBundle, p)

Project the point `p` from the ambient space of the vector bundle `B`
over manifold `B.fiber` (denoted ``\mathcal M``) to the vector bundle.

Notation:
  * The point ``p = (x_p, V_p)`` where ``x_p`` belongs to the ambient space of ``\mathcal M``
    and ``V_p`` belongs to the ambient space of the
    fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
    canonical projection of that vector bundle ``B``.

The projection is calculated by projecting the point ``x_p`` to the manifold ``\mathcal M``
and then projecting the vector ``V_p`` to the tangent space ``T_{x_p}\mathcal M``.
"""
project(::VectorBundle, ::Any)

function project!(B::VectorBundle, q, p)
    px, pVx = submanifold_components(B.manifold, p)
    qx, qVx = submanifold_components(B.manifold, q)
    project!(B.manifold, qx, px)
    F = Fiber(B.manifold, qx, B.type)
    project!(F, qVx, pVx)
    return q
end

@doc raw"""
    project(B::VectorBundle, p, X)

Project the element `X` of the ambient space of the tangent space ``T_p B``
to the tangent space ``T_p B``.

Notation:
  * The point ``p = (x_p, V_p)`` where ``x_p ∈ \mathcal M`` and ``V_p`` belongs to the
    fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
    canonical projection of that vector bundle ``B``.
  * The vector ``x = (V_{X,M}, V_{X,F})`` where ``x_p`` belongs to the ambient space of
    ``T_{x_p}\mathcal M`` and ``V_{X,F}`` belongs to the ambient space of the
    fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
    canonical projection of that vector bundle ``B``.

The projection is calculated by projecting ``V_{X,M}`` to tangent space ``T_{x_p}\mathcal M``
and then projecting the vector ``V_{X,F}`` to the fiber ``F``.
"""
project(::VectorBundle, ::Any, ::Any)

function project!(B::VectorBundle, Y, p, X)
    px, Vx = submanifold_components(B.manifold, p)
    VXM, VXF = submanifold_components(B.manifold, X)
    VYM, VYF = submanifold_components(B.manifold, Y)
    F = Fiber(B.manifold, px, B.type)
    project!(B.manifold, VYM, px, VXM)
    project!(F, VYF, Vx, VXF)
    return Y
end

"""
    retract(M::VectorBundle, p, q, ::FiberBundleProductRetraction)

Compute the allocating variant of the [`FiberBundleProductRetraction`](@ref),
which by default allocates and calls `retract_product!`.
"""
retract(::VectorBundle, p, q, ::FiberBundleProductRetraction)

function ManifoldsBase._retract!(M::VectorBundle, q, p, X, ::FiberBundleProductRetraction)
    return retract_product!(M, q, p, X)
end

function retract_product!(M::VectorBundle, q, p, X)
    return retract_product_fused!(M, q, p, X, one(eltype(p)))
end

function ManifoldsBase._retract_fused(
        M::VectorBundle,
        p,
        X,
        t::Number,
        ::FiberBundleProductRetraction,
    )
    return retract_product_fused(M, p, X, t)
end

function ManifoldsBase._retract_fused!(
        M::VectorBundle,
        q,
        p,
        X,
        t::Number,
        ::FiberBundleProductRetraction,
    )
    return retract_product_fused!(M, q, p, X, t)
end

function retract_product_fused(M::VectorBundle, p, X, t::Number)
    q = allocate_result(M, retract, p, X)
    return retract_product_fused!(M, q, p, X, t)
end

function retract_product_fused!(B::VectorBundle, q, p, X, t::Number)
    tX = t * X
    xp, Xp = submanifold_components(B.manifold, p)
    xq, Xq = submanifold_components(B.manifold, q)
    VXM, VXF = submanifold_components(B.manifold, tX)
    # this temporary avoids overwriting `p` when `q` and `p` occupy the same memory
    xqt = exp(B.manifold, xp, VXM)
    vector_transport_direction!(
        B.manifold,
        Xq,
        xp,
        Xp + VXF,
        VXM,
        B.vector_transport.method_horizontal,
    )
    copyto!(B.manifold, xq, xqt)
    return q
end

function ManifoldsBase.retract_sasaki!(M::VectorBundle, q, p, X, m::SasakiRetraction)
    return ManifoldsBase.retract_sasaki_fused!(M, q, p, X, one(eltype(p)), m)
end
function ManifoldsBase.retract_sasaki_fused!(
        B::TangentBundle,
        q,
        p,
        X,
        t::Number,
        m::SasakiRetraction,
    )
    tX = t * X
    xp, Xp = submanifold_components(B.manifold, p)
    xq, Xq = submanifold_components(B.manifold, q)
    VXM, VXF = submanifold_components(B.manifold, tX)
    p_k = allocate(B.manifold, xp)
    copyto!(B.manifold, p_k, xp)
    X_k = allocate(B.manifold, Xp)
    copyto!(B.manifold, X_k, Xp)
    Y_k = allocate(B.manifold, VXM)
    copyto!(B.manifold, Y_k, VXM)
    Z_k = allocate(B.manifold, VXF)
    copyto!(B.manifold, Z_k, VXF)
    ϵ = 1 / m.L
    for k in 1:(m.L)
        p_kp1 = exp(B.manifold, p_k, ϵ * Y_k)
        X_kp1 = parallel_transport_to(B.manifold, p_k, X_k .+ ϵ .* Z_k, p_kp1)
        Y_kp1 = parallel_transport_to(
            B.manifold,
            p_k,
            Y_k .+ ϵ .* riemann_tensor(B.manifold, p_k, X_k, Z_k, Y_k),
            p_kp1,
        )
        Z_kp1 = parallel_transport_to(B.manifold, p_k, Z_k, p_kp1)
        copyto!(B.manifold, p_k, p_kp1)
        copyto!(B.manifold, X_k, p_kp1, X_kp1)
        copyto!(B.manifold, Y_k, p_kp1, Y_kp1)
        copyto!(B.manifold, Z_k, p_kp1, Z_kp1)
    end
    copyto!(B.manifold, xq, p_k)
    copyto!(B.manifold, Xq, xq, X_k)
    return q
end

Base.show(io::IO, vb::TangentBundle) = print(io, "TangentBundle($(vb.manifold))")

function vector_transport_direction(M::VectorBundle, p, X, d)
    return vector_transport_direction(M, p, X, d, M.vector_transport)
end

function vector_transport_direction!(M::VectorBundle, Y, p, X, d)
    return vector_transport_direction!(M, Y, p, X, d, M.vector_transport)
end

function _vector_transport_direction!(
        M::VectorBundle,
        Y,
        p,
        X,
        d,
        m::FiberBundleProductVectorTransport,
    )
    VYM, VYF = submanifold_components(M.manifold, Y)
    px, pVx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    dx, dVx = submanifold_components(M.manifold, d)
    return vector_transport_direction!(M.manifold, VYM, px, VXM, dx, m.method_horizontal),
        vector_transport_direction!(M.manifold, VYF, px, VXF, dx, m.method_vertical),
        return Y
end

@doc raw"""
    vector_transport_to(M::VectorBundle, p, X, q, m::FiberBundleProductVectorTransport)

Compute the vector transport the tangent vector `X`at `p` to `q` on the
[`VectorBundle`](@ref) `M` using the [`FiberBundleProductVectorTransport`](@ref) `m`.
"""
vector_transport_to(
    ::VectorBundle,
    ::Any,
    ::Any,
    ::Any,
    ::FiberBundleProductVectorTransport,
)

function vector_transport_to(M::VectorBundle, p, X, q)
    return vector_transport_to(M, p, X, q, M.vector_transport)
end

function vector_transport_to!(M::VectorBundle, Y, p, X, q)
    return vector_transport_to!(M, Y, p, X, q, M.vector_transport)
end
function vector_transport_to!(
        M::TangentBundle,
        Y,
        p,
        X,
        q,
        m::FiberBundleProductVectorTransport,
    )
    px, pVx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    VYM, VYF = submanifold_components(M.manifold, Y)
    qx, qVx = submanifold_components(M.manifold, q)
    vector_transport_to!(M.manifold, VYM, px, VXM, qx, m.method_horizontal)
    bundle_transport_tangent_to!(M, VYF, px, pVx, VXF, qx, m.method_vertical)
    return Y
end

Base.show(io::IO, vb::CotangentBundle) = print(io, "CotangentBundle($(vb.manifold))")

#!/usr/bin/env julia
#
#

if "--help" ∈ ARGS
    println(
        """
        docs/make.jl

        Render the `Manifolds.jl` documentation with optional arguments

        Arguments
        * `--exclude-tutorials` - exclude the tutorials from the menu of Documenter,
          This can be used if not all tutorials are rendered and you want to therefore exclude links
          to these, especially the corresponding menu. This option should not be set on CI.
          Locally this is also set if `--quarto` is not set and not all tutorials are rendered.
        * `--help`              - print this help and exit without rendering the documentation
        * `--prettyurls`        – toggle the pretty urls part to true, which is always set on CI
        * `--quarto`            – (re)run the Quarto notebooks from the `tutorials/` folder before
          generating the documentation. If they are generated once they are cached accordingly.
          Then you can spare time in the rendering by not passing this argument.
          If quarto is not run, some tutorials are generated as empty files, since they
          are referenced from within the documentation.
        """,
    )
    exit(0)
end

run_quarto = "--quarto" in ARGS
run_on_CI = (get(ENV, "CI", nothing) == "true")
tutorials_in_menu = !("--exclude-tutorials" ∈ ARGS)
#
#
# (a) setup the tutorials menu – check whether all files exist
tutorials_menu =
    "How to..." => [
    "🚀 Get Started with `Manifolds.jl`" => "tutorials/getstarted.md",
    "work in charts" => "tutorials/working-in-charts.md",
    "work with a metric defined in a chart" => "tutorials/work-with-a-metric-defined-in-a-chart.md",
    "perform Hand gesture analysis" => "tutorials/hand-gestures.md",
    "integrate on manifolds and handle probability densities" => "tutorials/integration.md",
    "explore curvature without coordinates" => "tutorials/exploring-curvature.md",
]
# Check whether all tutorials are rendered, issue a warning if not (and quarto if not set)
all_tutorials_exist = true
for (name, file) in tutorials_menu.second
    fn = joinpath(@__DIR__, "src/", file)
    if !isfile(fn) || filesize(fn) == 0 # nonexistent or empty file
        global all_tutorials_exist = false
        if !run_quarto
            @warn "Tutorial $name does not exist at $fn."
            if (!isfile(fn)) && (endswith(file, "getstarted.md"))
                @warn "Generating empty file, since this tutorial is linked to from the documentation."
                touch(fn)
            end
        end
    end
end
if !all_tutorials_exist && !run_quarto && !run_on_CI
    @warn """
        Not all tutorials exist. Run `make.jl --quarto` to generate them. For this run they are excluded from the menu.
    """
    tutorials_in_menu = false
end
if !tutorials_in_menu
    @warn """
    You are either explicitly or implicitly excluding the tutorials from the documentation.
    You will not be able to see their menu entries nor their rendered pages.
    """
    run_on_CI &&
        (@error "On CI, the tutorials have to be either rendered with Quarto or be cached.")
end
#
# (b) if docs is not the current active environment, switch to it
# (from https://github.com/JuliaIO/HDF5.jl/pull/1020/) 
if Base.active_project() != joinpath(@__DIR__, "Project.toml")
    using Pkg
    Pkg.activate(@__DIR__)
    Pkg.instantiate()
end

# (c) If quarto is set, or we are on CI, run quarto
if run_quarto || run_on_CI
    @info "Rendering Quarto"
    tutorials_folder = (@__DIR__) * "/../tutorials"
    # instantiate the tutorials environment if necessary
    Pkg.activate(tutorials_folder)
    # For a breaking release -> also set the tutorials folder to the most recent version
    Pkg.instantiate()
    Pkg.activate(@__DIR__) # but return to the docs one before
    run(`quarto render $(tutorials_folder)`)
end

# (d) load necessary packages for the docs
using Plots, RecipesBase, Manifolds, ManifoldsBase, Documenter, PythonPlot
using DocumenterCitations, DocumenterInterLinks
# required for loading methods that handle differential equation solving
using OrdinaryDiffEq, BoundaryValueDiffEq, DiffEqCallbacks
using NLsolve
# required for loading the manifold tests functions
using Test, FiniteDifferences
ENV["GKSwstype"] = "100"

# (e) add CONTRIBUTING.md and NEWS.md to docs

function add_links(line::String, url::String = "https://github.com/JuliaManifolds/Manifolds.jl")
    # replace issues (#XXXX) -> ([#XXXX](url/issue/XXXX))
    while (m = match(r"\(\#([0-9]+)\)", line)) !== nothing
        id = m.captures[1]
        line = replace(line, m.match => "([#$id]($url/issues/$id))")
    end
    # replace ## [X.Y.Z] -> with a link to the release [X.Y.Z](url/releases/tag/vX.Y.Z)
    while (m = match(r"\#\# \[([0-9]+.[0-9]+.[0-9]+)\] (.*)", line)) !== nothing
        tag = m.captures[1]
        date = m.captures[2]
        line = replace(line, m.match => "## [$tag]($url/releases/tag/v$tag) ($date)")
    end
    return line
end

generated_path = joinpath(@__DIR__, "src", "misc")
base_url = "https://github.com/JuliaManifolds/Manifolds.jl/blob/master/"
isdir(generated_path) || mkdir(generated_path)
for fname in ["CONTRIBUTING.md", "NEWS.md"]
    open(joinpath(generated_path, fname), "w") do io
        # Point to source license file
        println(
            io,
            """
            ```@meta
            EditURL = "$(base_url)$(fname)"
            ```
            """,
        )
        # Write the contents out below the meta block
        for line in eachline(joinpath(dirname(@__DIR__), fname))
            println(io, add_links(line))
        end
    end
end

# (f) final step: render the docs
bib = CitationBibliography(joinpath(@__DIR__, "src", "references.bib"); style = :alpha)
links = InterLinks(
    "ManifoldsBase" => ("https://juliamanifolds.github.io/ManifoldsBase.jl/stable/"),
)

modules = [
    Manifolds,
    Base.get_extension(Manifolds, :ManifoldsBoundaryValueDiffEqExt),
    Base.get_extension(Manifolds, :ManifoldsNLsolveExt),
    Base.get_extension(Manifolds, :ManifoldsOrdinaryDiffEqDiffEqCallbacksExt),
    Base.get_extension(Manifolds, :ManifoldsOrdinaryDiffEqExt),
    Base.get_extension(Manifolds, :ManifoldsRecipesBaseExt),
    Base.get_extension(Manifolds, :ManifoldsTestExt),
    Manifolds.Test,
]

if modules isa Vector{Union{Nothing, Module}}
    error("At least one module has not been properly loaded: ", modules)
end

makedocs(;
    format = Documenter.HTML(
        prettyurls = (get(ENV, "CI", nothing) == "true") || ("--prettyurls" ∈ ARGS),
        assets = ["assets/favicon.ico", "assets/citations.css", "assets/link-icons.css"],
        search_size_threshold_warn = 1000 * 2^10, # raise slightly from 500 to 1 MiB
        size_threshold_warn = 200 * 2^10, # raise slightly from 100 to 200 KiB
        size_threshold = 300 * 2^10,      # raise slightly 200 to 300 KiB
    ),
    modules = modules,
    authors = "Seth Axen, Mateusz Baran, Ronny Bergmann, and contributors.",
    sitename = "Manifolds.jl",
    pages = [
        "Home" => "index.md",
        (tutorials_in_menu ? [tutorials_menu] : [])...,
        "Manifolds" => [
            "Basic manifolds" => [
                "Centered matrices" => "manifolds/centeredmatrices.md",
                "Cholesky space" => "manifolds/choleskyspace.md",
                "Circle" => "manifolds/circle.md",
                "Determinant one matrices" => "manifolds/determinantone.md",
                "Elliptope" => "manifolds/elliptope.md",
                "Essential manifold" => "manifolds/essentialmanifold.md",
                "Euclidean" => "manifolds/euclidean.md",
                "Fixed-rank matrices" => "manifolds/fixedrankmatrices.md",
                "Flag" => "manifolds/flag.md",
                "Generalized Stiefel" => "manifolds/generalizedstiefel.md",
                "Generalized Grassmann" => "manifolds/generalizedgrassmann.md",
                "Grassmann" => "manifolds/grassmann.md",
                "Hamiltonian" => "manifolds/hamiltonian.md",
                "Heisenberg matrices" => "manifolds/heisenberg.md",
                "Hyperbolic space" => "manifolds/hyperbolic.md",
                "Hyperrectangle" => "manifolds/hyperrectangle.md",
                "Invertible matrices" => "manifolds/invertible.md",
                "Lorentzian manifold" => "manifolds/lorentz.md",
                "Multinomial doubly stochastic matrices" => "manifolds/multinomialdoublystochastic.md",
                "Multinomial matrices" => "manifolds/multinomial.md",
                "Multinomial symmetric matrices" => "manifolds/multinomialsymmetric.md",
                "Multinomial symmetric positive definite matrices" => "manifolds/multinomialsymmetricpositivedefinite.md",
                "Oblique manifold" => "manifolds/oblique.md",
                "Probability simplex" => "manifolds/probabilitysimplex.md",
                "Positive numbers" => "manifolds/positivenumbers.md",
                "Projective space" => "manifolds/projectivespace.md",
                "Orthogonal and Unitary Matrices" => "manifolds/generalunitary.md",
                "Rotations" => "manifolds/rotations.md",
                "Segre" => "manifolds/segre.md",
                "Shape spaces" => "manifolds/shapespace.md",
                "Skew-Hermitian matrices" => "manifolds/skewhermitian.md",
                "Spectrahedron" => "manifolds/spectrahedron.md",
                "Sphere" => "manifolds/sphere.md",
                "Stiefel" => "manifolds/stiefel.md",
                "Symmetric matrices" => "manifolds/symmetric.md",
                "Symmetric positive definite" => "manifolds/symmetricpositivedefinite.md",
                "SPD, fixed determinant" => "manifolds/spdfixeddeterminant.md",
                "Symmetric positive semidefinite fixed rank" => "manifolds/symmetricpsdfixedrank.md",
                "Symplectic Grassmann" => "manifolds/symplecticgrassmann.md",
                "Symplectic matrices" => "manifolds/symplectic.md",
                "Symplectic Stiefel" => "manifolds/symplecticstiefel.md",
                "Torus" => "manifolds/torus.md",
                "Tucker" => "manifolds/tucker.md",
                "Unit-norm symmetric matrices" => "manifolds/spheresymmetricmatrices.md",
            ],
            "Combined manifolds" => [
                "Fiber bundle" => "manifolds/fiber_bundle.md",
                "Graph manifold" => "manifolds/graph.md",
                "Power manifold" => "manifolds/power.md",
                "Product manifold" => "manifolds/product.md",
                "Vector bundle" => "manifolds/vector_bundle.md",
            ],
            "Manifold decorators" => [
                "Connection manifold" => "manifolds/connection.md",
                "Metric manifold" => "manifolds/metric.md",
            ],
        ],
        "Features on Manifolds" => [
            "Atlases and charts" => "features/atlases.md",
            "Differentiation" => "features/differentiation.md",
            "Distributions" => "features/distributions.md",
            "Integration" => "features/integration.md",
            "Statistics" => "features/statistics.md",
            "Utilities" => "features/utilities.md",
        ],
        "Miscellanea" => [
            "About" => "misc/about.md",
            "Changelog" => "misc/NEWS.md",
            "Contributing" => "misc/CONTRIBUTING.md",
            "Internals" => "misc/internals.md",
            "Test suite" => "misc/testsuite.md",
            "Notation" => "misc/notation.md",
            "References" => "misc/references.md",
        ],
    ],
    plugins = [bib, links],
)
deploydocs(repo = "github.com/JuliaManifolds/Manifolds.jl.git", push_preview = true)
#back to main env
Pkg.activate()

@doc raw"""
    const SpecialUnitaryMatrices{T} = GeneralUnitaryMatrices{ℂ, T, DeterminantOneMatrixType}

The manifold ``SU(n)`` of ``n×n`` complex matrices such that

```math
    p^{\mathrm{H}}p = \mathrm{I}_n \text{ and } \det(p) = 1,
```

where ``p^{\mathrm{H}}`` is the conjugate transpose of ``p`` and ``\mathrm{I}_n`` is the ``n×n`` identity matrix.

The tangent spaces are given by

```math
    T_pU(n) \coloneqq \bigl\{
    X \big| pY \text{ where } Y \text{ is skew symmetric and traceless, i. e. } Y = -Y^{\mathrm{H}} \text{ and } \operatorname{tr}(Y) = 0
    \bigr\}
```

But note that tangent vectors are represented in the Lie algebra, i.e. just using ``Y`` in
the representation above.

# Constructor

    SpecialUnitaryMatrices(n; parameter::Symbol = :type)

see also [`Rotations`](@ref) for the real valued case.
"""
const SpecialUnitaryMatrices{T} = GeneralUnitaryMatrices{ℂ, T, DeterminantOneMatrixType}

function SpecialUnitaryMatrices(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return SpecialUnitaryMatrices{typeof(size)}(size)
end

@doc raw"""
    manifold_dimension(M::SpecialUnitaryMatrices)

Return the dimension of the manifold of special unitary matrices.
```math
\dim_{\mathrm{SU}(n)} = n^2-1.
```
"""
function manifold_dimension(M::SpecialUnitaryMatrices)
    n = get_parameter(M.size)[1]
    return n^2 - 1
end

@doc raw"""
    manifold_volume(::SpecialUnitaryMatrices)

Volume of the manifold of complex general unitary matrices of determinant one. The formula
reads [BoyaSudarshanTilma:2003](@cite)

```math
\sqrt{n 2^{n-1}} π^{(n-1)(n+2)/2} \prod_{k=1}^{n-1}\frac{1}{k!}.
```
"""
function manifold_volume(M::SpecialUnitaryMatrices)
    n = get_parameter(M.size)[1]
    vol = sqrt(n * 2^(n - 1)) * π^(((n - 1) * (n + 2)) // 2)
    kf = 1
    for k in 1:(n - 1)
        kf *= k
        vol /= kf
    end
    return vol
end

@doc raw"""
    injectivity_radius(G::SpecialUnitaryMatrices)

Return the injectivity radius for general complex unitary matrix manifolds, where the determinant is ``+1``,
which is[^1]

```math
    \operatorname{inj}_{\mathrm{SU}(n)} = π \sqrt{2}.
```
[^1]
    > For a derivation of the injectivity radius, see [sethaxen.com/blog/2023/02/the-injectivity-radii-of-the-unitary-groups/](https://sethaxen.com/blog/2023/02/the-injectivity-radii-of-the-unitary-groups/).
"""
function injectivity_radius(::SpecialUnitaryMatrices)
    return π * sqrt(2.0)
end

"""
    TensorProductType(spaces::VectorSpaceType...)

Vector space type corresponding to the tensor product of given vector space
types.
"""
struct TensorProductType{TS <: Tuple} <: VectorSpaceType
    spaces::TS
end

TensorProductType(spaces::VectorSpaceType...) = TensorProductType{typeof(spaces)}(spaces)

function inner(B::CotangentSpace, p, X, Y)
    return inner(
        B.manifold,
        B.point,
        sharp(B.manifold, B.point, X),
        sharp(B.manifold, B.point, Y),
    )
end

function Base.show(io::IO, tpt::TensorProductType)
    return print(io, "TensorProductType(", join(tpt.spaces, ", "), ")")
end

function vector_space_dimension(M::AbstractManifold, V::TensorProductType)
    dim = 1
    for space in V.spaces
        dim *= fiber_dimension(M, space)
    end
    return dim
end

@doc """
    AbstractMatrixType

A plain type to distinguish different types of matrices, for example [`DeterminantOneMatrixType`](@ref)
and [`AbsoluteDeterminantOneMatrixType`](@ref).
"""
abstract type AbstractMatrixType end

@doc """
    DeterminantOneMatrixType <: AbstractMatrixType

A type to indicate that we require special (orthogonal / unitary) matrices, i.e. of determinant 1.
"""
struct DeterminantOneMatrixType <: AbstractMatrixType end

@doc """
    AbsoluteDeterminantOneMatrixType <: AbstractMatrixType

A type to indicate that we require (orthogonal / unitary) matrices with normed determinant,
i.e. that the absolute value of the determinant is 1.
"""
struct AbsoluteDeterminantOneMatrixType <: AbstractMatrixType end

@doc raw"""
    GeneralUnitaryMatrices{𝔽, T, S<:AbstractMatrixType} <: AbstractDecoratorManifold

A common parametric type for matrices with a unitary property of size ``n×n`` over the field ``𝔽``
which additionally have the `AbstractMatrixType`, e.g. are [`DeterminantOneMatrixType`](@ref).
"""
struct GeneralUnitaryMatrices{𝔽, T, S <: AbstractMatrixType} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function GeneralUnitaryMatrices(
        n::Int,
        field,
        matrix_type::Type{<:AbstractMatrixType};
        parameter::Symbol = :type,
    )
    size = wrap_type_parameter(parameter, (n,))
    return GeneralUnitaryMatrices{field, typeof(size), matrix_type}(size)
end

@doc raw"""
    check_point(M::UnitaryMatrices, p; kwargs...)
    check_point(M::OrthogonalMatrices, p; kwargs...)
    check_point(M::GeneralUnitaryMatrices, p; kwargs...)

Check whether `p` is a valid point on the [`UnitaryMatrices`](@ref) or [`OrthogonalMatrices`] `M`,
i.e. that ``p`` has a determinant of absolute value one.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(
        M::GeneralUnitaryMatrices{𝔽, <:Any, AbsoluteDeterminantOneMatrixType},
        p;
        kwargs...,
    ) where {𝔽}
    if !isapprox(abs(det(p)), one(eltype(p)); kwargs...)
        return DomainError(
            abs(det(p)),
            "The absolute value of the determinant of $p has to be 1 but it is $(abs(det(p)))",
        )
    end
    if !isapprox(p' * p, one(p); kwargs...)
        return DomainError(
            norm(p' * p - one(p)),
            "$p must be orthogonal but it's not at kwargs $kwargs",
        )
    end
    return nothing
end

@doc raw"""
    check_point(M::Rotations, p; kwargs...)

Check whether `p` is a valid point on the [`UnitaryMatrices`](@ref) `M`,
i.e. that ``p`` has a determinant of absolute value one, i.e. that ``p^{\mathrm{H}}p = \mathrm{I}_n``

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(
        M::GeneralUnitaryMatrices{𝔽, <:Any, DeterminantOneMatrixType},
        p;
        kwargs...,
    ) where {𝔽}
    if !isapprox(det(p), one(eltype(p)); kwargs...)
        return DomainError(det(p), "The determinant of $p has to be +1 but it is $(det(p))")
    end
    if !isapprox(p' * p, one(p); kwargs...)
        return DomainError(
            norm(p' * p - one(p)),
            "$p must be orthogonal but it's not at kwargs $kwargs",
        )
    end
    return nothing
end

function check_size(M::GeneralUnitaryMatrices, p)
    n = get_parameter(M.size)[1]
    m = size(p)
    if length(m) != 2
        return DomainError(
            size(p),
            "The point $p is not a matrix (expected a length of size to be 2, got $(length(size(p))))",
        )
    end
    if m != (n, n)
        return DomainError(
            size(p),
            "The point $p is not a matrix of size $((n, n)), but $(size(p)).",
        )
    end
    return nothing
end
function check_size(M::GeneralUnitaryMatrices, p, X)
    n = get_parameter(M.size)[1]
    m = size(X)
    if length(size(X)) != 2
        return DomainError(
            size(X),
            "The tangent vector $X is not a matrix (expected a length of size to be 2, got $(length(size(X))))",
        )
    end
    if m != (n, n)
        return DomainError(
            size(X),
            "The tangent vector $X is not a matrix of size $((n, n)), but $(size(X)).",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::UnitaryMatrices, p, X; kwargs... )
    check_vector(M::OrthogonalMatrices, p, X; kwargs... )
    check_vector(M::Rotations, p, X; kwargs... )
    check_vector(M::GeneralUnitaryMatrices, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`UnitaryMatrices`](@ref)
space `M`, i.e. after [`check_point`](@ref)`(M,p)`, `X` has to be skew symmetric (Hermitian)
and orthogonal to `p`.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(M::GeneralUnitaryMatrices{𝔽}, p, X; kwargs...) where {𝔽}
    n = get_parameter(M.size)[1]
    return check_point(SkewHermitianMatrices(n, 𝔽), X; kwargs...)
end

@doc raw"""
    cos_angles_4d_rotation_matrix(R)

4D rotations can be described by two orthogonal planes that are unchanged by
the action of the rotation (vectors within a plane rotate only within the
plane). The cosines of the two angles ``α,β`` of rotation about these planes may be
obtained from the distinct real parts of the eigenvalues of the rotation
matrix. This function computes these more efficiently by solving the system

```math
\begin{aligned}
\cos α + \cos β &= \frac{1}{2} \operatorname{tr}(R)\\
\cos α \cos β &= \frac{1}{8} \operatorname{tr}(R)^2
                 - \frac{1}{16} \operatorname{tr}((R - R^T)^2) - 1.
\end{aligned}
```

By convention, the returned values are sorted in decreasing order.
See also [`angles_4d_skew_sym_matrix`](@ref).
"""
function cos_angles_4d_rotation_matrix(R)
    a = tr(R)
    b = sqrt(clamp(2 * dot(transpose(R), R) - a^2 + 8, 0, Inf))
    return ((a + b) / 4, (a - b) / 4)
end

decorated_manifold(M::GeneralUnitaryMatrices) = get_embedding(M)

function default_approximation_method(::GeneralUnitaryMatrices{ℝ}, ::typeof(mean))
    return GeodesicInterpolationWithinRadius(π / 2 / √2)
end

default_vector_transport_method(::GeneralUnitaryMatrices) = ProjectionTransport()

embed(::GeneralUnitaryMatrices, p) = p

@doc raw"""
    embed(M::GeneralUnitaryMatrices, p, X)

Embed the tangent vector `X` at point `p` in `M` from
its Lie algebra representation (set of skew matrices) into the
Riemannian submanifold representation

The formula reads
```math
X_{\text{embedded}} = p * X
```
"""
embed(::GeneralUnitaryMatrices, p, X)

function embed!(::GeneralUnitaryMatrices, Y, p, X)
    return mul!(Y, p, X)
end

@doc raw"""
    exp(M::Rotations, p, X)
    exp(M::OrthogonalMatrices, p, X)
    exp(M::UnitaryMatrices, p, X)

Compute the exponential map, that is, since ``X`` is represented in the Lie algebra,

```math
exp_p(X) = p\mathrm{e}^X
```

For different sizes, like ``n=2,3,4``, there are specialized implementations.

The algorithm used is a more numerically stable form of those proposed in
[GallierXu:2002](@cite) and [AndricaRohan:2013](@cite).
"""
exp(::GeneralUnitaryMatrices, p, X)

function exp!(M::GeneralUnitaryMatrices, q, p, X)
    return copyto!(M, q, p * exp(X))
end
function ManifoldsBase.exp_fused!(M::GeneralUnitaryMatrices, q, p, X, t::Number)
    return copyto!(M, q, p * exp(t * X))
end

function exp(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, p::SMatrix, X::SMatrix)
    θ = get_coordinates(M, p, X, DefaultOrthogonalBasis())[1]
    sinθ, cosθ = sincos(θ)
    return p * SA[cosθ -sinθ; sinθ cosθ]
end
function ManifoldsBase.exp_fused(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        p::SMatrix,
        X::SMatrix,
        t::Real,
    )
    return exp(M, p, t * X)
end
function exp(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, p::SMatrix, X::SMatrix)
    θ = norm(M, p, X) / sqrt(2)
    if θ ≈ 0
        a = 1 - θ^2 / 6
        b = θ / 2
    else
        a = sin(θ) / θ
        b = (1 - cos(θ)) / θ^2
    end
    pinvq = I + a .* X .+ b .* (X^2)
    return p * pinvq
end
function exp!(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, q, p, X)
    @assert size(q) == (2, 2)
    θ = get_coordinates(M, p, X, DefaultOrthogonalBasis())[1]
    sinθ, cosθ = sincos(θ)
    return copyto!(q, p * SA[cosθ -sinθ; sinθ cosθ])
end
function ManifoldsBase.exp_fused!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        q,
        p,
        X,
        t::Real,
    )
    @assert size(q) == (2, 2)
    θ = get_coordinates(M, p, X, DefaultOrthogonalBasis())[1]
    sinθ, cosθ = sincos(t * θ)
    return copyto!(q, p * SA[cosθ -sinθ; sinθ cosθ])
end
function exp!(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, q, p, X)
    return exp_fused!(M, q, p, X, one(eltype(X)))
end
function ManifoldsBase.exp_fused!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}},
        q,
        p,
        X,
        t::Real,
    )
    θ = abs(t) * norm(M, p, X) / sqrt(2)
    if θ ≈ 0
        a = 1 - θ^2 / 6
        b = θ / 2
    else
        a = sin(θ) / θ
        b = (1 - cos(θ)) / θ^2
    end
    pinvq = I + a .* t .* X .+ b .* t^2 .* (X^2)
    return copyto!(q, p * pinvq)
end
function ManifoldsBase.exp_fused!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{4}}},
        q,
        p,
        X,
        t::Real,
    )
    return exp!(M, q, p, t * X)
end
function exp!(::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{4}}}, q, p, X)
    T = eltype(X)
    α, β = angles_4d_skew_sym_matrix(X)
    sinα, cosα = sincos(α)
    sinβ, cosβ = sincos(β)
    α² = α^2
    β² = β^2
    Δ = β² - α²
    if !isapprox(Δ, 0; atol = 1.0e-6)  # Case α > β ≥ 0
        sincα = sinα / α
        sincβ = β == 0 ? one(T) : sinβ / β
        a₀ = (β² * cosα - α² * cosβ) / Δ
        a₁ = (β² * sincα - α² * sincβ) / Δ
        a₂ = (cosα - cosβ) / Δ
        a₃ = (sincα - sincβ) / Δ
    elseif α == 0 # Case α = β = 0
        a₀ = one(T)
        a₁ = one(T)
        a₂ = T(1 / 2)
        a₃ = T(1 / 6)
    else  # Case α ⪆ β ≥ 0, α ≠ 0
        sincα = sinα / α
        r = β / α
        c = 1 / (1 + r)
        d = α * (α - β) / 2
        if α < 1.0e-2
            e = @evalpoly(α², T(1 / 3), T(-1 / 30), T(1 / 840), T(-1 / 45360))
        else
            e = (sincα - cosα) / α²
        end
        a₀ = (α * sinα + (1 + r - d) * cosα) * c
        a₁ = ((3 - d) * sincα - (2 - r) * cosα) * c
        a₂ = (sincα - (1 - r) / 2 * cosα) * c
        a₃ = (e + (1 - r) * (e - sincα / 2)) * c
    end

    X² = X * X
    X³ = X² * X
    pinvq = a₀ * I + a₁ .* X .+ a₂ .* X² .+ a₃ .* X³
    return copyto!(q, p * pinvq)
end

@doc raw"""
    get_coordinates(M::Rotations, p, X)
    get_coordinates(M::OrthogonalMatrices, p, X)
    get_coordinates(M::UnitaryMatrices, p, X)

Extract the unique tangent vector components ``X^i`` at point `p` on [`Rotations`](@ref)
``\mathrm{SO}(n)`` from the matrix representation `X` of the tangent
vector.

The basis on the Lie algebra ``𝔰𝔬(n)`` is chosen such that
for ``\mathrm{SO}(2)``, ``X^1 = θ = X_{21}`` is the angle of rotation, and
for ``\mathrm{SO}(3)``, ``(X^1, X^2, X^3) = (X_{32}, X_{13}, X_{21}) = θ u`` is the
angular velocity and axis-angle representation, where ``u`` is the unit vector
along the axis of rotation.

For ``\mathrm{SO}(n)`` where ``n ≥ 4``, the additional elements of ``X^i`` are
``X^{j (j - 3)/2 + k + 1} = X_{jk}``, for ``j ∈ [4,n], k ∈ [1,j)``.
"""
get_coordinates(::GeneralUnitaryMatrices{ℝ}, ::Any...)
function get_coordinates(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        p,
        X,
        ::DefaultOrthogonalBasis{ℝ, TangentSpaceType},
    )
    return [X[2]]
end
function get_coordinates(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        p::SMatrix, X::SMatrix, ::DefaultOrthogonalBasis{ℝ, TangentSpaceType},
    )
    return SA[X[2]]
end

function get_coordinates(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}},
        p::SMatrix, X::SMatrix, ::DefaultOrthogonalBasis{ℝ, TangentSpaceType},
    )
    return SA[X[3, 2], X[1, 3], X[2, 1]]
end
function get_coordinates_orthogonal(M::GeneralUnitaryMatrices{ℝ}, p, X, N)
    Y = allocate_result(M, get_coordinates, p, X, DefaultOrthogonalBasis(N))
    return get_coordinates_orthogonal!(M, Y, p, X, N)
end

function get_coordinates_orthogonal!(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{1}}}, c, p, X, ::RealNumbers,
    )
    return c
end
function get_coordinates_orthogonal!(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, c, p, X, ::RealNumbers,
    )
    c[1] = X[2]
    return c
end
function get_coordinates_orthogonal!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{n}}}, c, p, X, ::RealNumbers,
    ) where {n}
    @assert length(c) == manifold_dimension(M)
    @assert size(X) == (n, n)
    @inbounds begin
        c[1] = X[3, 2]
        c[2] = X[1, 3]
        c[3] = X[2, 1]
        k = 4
        for i in 4:n, j in 1:(i - 1)
            c[k] = X[i, j]
            k += 1
        end
    end
    return c
end
function get_coordinates_orthogonal!(
        M::GeneralUnitaryMatrices{ℝ, Tuple{Int}},
        c, p, X, ::RealNumbers,
    )
    n = get_parameter(M.size)[1]
    @assert length(c) == manifold_dimension(M)
    @assert size(X) == (n, n)
    if n == 2
        c[1] = X[2]
    elseif n > 2
        @inbounds begin
            c[1] = X[3, 2]
            c[2] = X[1, 3]
            c[3] = X[2, 1]
            k = 4
            for i in 4:n, j in 1:(i - 1)
                c[k] = X[i, j]
                k += 1
            end
        end
    end
    return c
end
function get_coordinates_orthonormal!(
        M::GeneralUnitaryMatrices{ℝ}, c, p, X, num::RealNumbers,
    )
    T = Base.promote_eltype(p, X)
    get_coordinates_orthogonal!(M, c, p, X, num)
    c .*= sqrt(T(2))
    return c
end

@doc raw"""
    get_embedding(M::OrthogonalMatrices)
    get_embedding(M::Rotations)
    get_embedding(M::UnitaryMatrices)

Return the embedding, i.e. The ``\mathbb F^{n×n}``, where ``\mathbb F = \mathbb R`` for the
first two and ``\mathbb F = \mathbb C`` for the unitary matrices.
"""
function get_embedding(::GeneralUnitaryMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return Euclidean(n, n; field = 𝔽)
end
function get_embedding(M::GeneralUnitaryMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return Euclidean(n, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::GeneralUnitaryMatrices)
    return ManifoldsBase.EmbeddedManifoldType()
end
function ManifoldsBase.get_embedding_type(
        ::GeneralUnitaryMatrices,
        ::Type{<:Quaternions.Quaternion},
    )
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end
@doc raw"""
    get_vector(M::OrthogonalMatrices, p, Xⁱ, B::DefaultOrthogonalBasis)
    get_vector(M::Rotations, p, Xⁱ, B::DefaultOrthogonalBasis)

Convert the unique tangent vector components `Xⁱ` at point `p` on [`Rotations`](@ref)
or [`OrthogonalMatrices`](@ref)
to the matrix representation ``X`` of the tangent vector. See
[`get_coordinates`](@ref get_coordinates(::GeneralUnitaryMatrices, ::Any...)) for the conventions used.
"""
get_vector(::GeneralUnitaryMatrices{ℝ}, ::Any...)

function get_vector_orthogonal(M::GeneralUnitaryMatrices{ℝ}, p, c, N::RealNumbers)
    Y = allocate_result(M, get_vector, p, c)
    return get_vector_orthogonal!(M, Y, p, c, N)
end

function get_vector_orthogonal(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        p::SMatrix,
        Xⁱ,
        ::RealNumbers,
    )
    return @SMatrix [0 -Xⁱ[]; Xⁱ[] 0]
end
function get_vector_orthogonal(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, p::SMatrix, c, ::RealNumbers,
    )
    return @SMatrix [0 -c[3] c[2]; c[3] 0 -c[1]; -c[2] c[1] 0]
end

function get_vector_orthogonal!(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{1}}},
        X, p, c::AbstractVector, ::RealNumbers,
    )
    return X .= 0
end
function get_vector_orthogonal!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        X, p, c::AbstractVector, N::RealNumbers,
    )
    return get_vector_orthogonal!(M, X, p, c[1], N)
end
function get_vector_orthogonal!(
        ::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}},
        X, p, c::Real, ::RealNumbers,
    )
    @assert length(X) == 4
    @inbounds begin
        X[1] = 0
        X[2] = c
        X[3] = -c
        X[4] = 0
    end
    return X
end
function get_vector_orthogonal!(
        M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{n}}},
        X, p, c::AbstractVector, ::RealNumbers,
    ) where {n}
    @assert size(X) == (n, n)
    @assert length(c) == manifold_dimension(M)
    @assert n > 2
    @inbounds begin
        X[1, 1] = 0
        X[1, 2] = -c[3]
        X[1, 3] = c[2]
        X[2, 1] = c[3]
        X[2, 2] = 0
        X[2, 3] = -c[1]
        X[3, 1] = -c[2]
        X[3, 2] = c[1]
        X[3, 3] = 0
        k = 4
        for i in 4:n
            for j in 1:(i - 1)
                X[i, j] = c[k]
                X[j, i] = -c[k]
                k += 1
            end
            X[i, i] = 0
        end
    end
    return X
end
function get_vector_orthogonal!(
        M::GeneralUnitaryMatrices{ℝ, Tuple{Int}},
        X,
        p,
        Xⁱ,
        ::RealNumbers,
    )
    n = get_parameter(M.size)[1]
    @assert size(X) == (n, n)
    @assert length(Xⁱ) == manifold_dimension(M)
    if n == 1
        X .= 0
    elseif n == 2
        @inbounds begin
            X[1] = 0
            X[2] = Xⁱ[1]
            X[3] = -Xⁱ[1]
            X[4] = 0
        end
    else
        @inbounds begin
            X[1, 1] = 0
            X[1, 2] = -Xⁱ[3]
            X[1, 3] = Xⁱ[2]
            X[2, 1] = Xⁱ[3]
            X[2, 2] = 0
            X[2, 3] = -Xⁱ[1]
            X[3, 1] = -Xⁱ[2]
            X[3, 2] = Xⁱ[1]
            X[3, 3] = 0
            k = 4
            for i in 4:n
                for j in 1:(i - 1)
                    X[i, j] = Xⁱ[k]
                    X[j, i] = -Xⁱ[k]
                    k += 1
                end
                X[i, i] = 0
            end
        end
    end
    return X
end
function get_vector_orthonormal(M::GeneralUnitaryMatrices{ℝ}, p, Xⁱ, N::RealNumbers)
    return get_vector_orthogonal(M, p, Xⁱ, N) ./ sqrt(eltype(Xⁱ)(2))
end

function get_vector_orthonormal!(
        M::GeneralUnitaryMatrices{ℝ},
        X,
        p,
        Xⁱ::AbstractVector,
        N::RealNumbers,
    )
    T = Base.promote_eltype(p, X)
    get_vector_orthogonal!(M, X, p, Xⁱ, N)
    X ./= sqrt(T(2))
    return X
end

@doc raw"""
    injectivity_radius(G::GeneraliUnitaryMatrices)

Return the injectivity radius for general unitary matrix manifolds, which is[^1]

````math
    \operatorname{inj}_{\mathrm{U}(n)} = π.
````
"""
injectivity_radius(::GeneralUnitaryMatrices) = π

@doc raw"""
    injectivity_radius(G::SpecialOrthogonal)
    injectivity_radius(G::Orthogonal)
    injectivity_radius(M::Rotations)
    injectivity_radius(M::Rotations, ::ExponentialRetraction)

Return the radius of injectivity on the [`Rotations`](@ref) manifold `M`, which is ``π\sqrt{2}``.
[^1]

[^1]:
    > For a derivation of the injectivity radius, see [sethaxen.com/blog/2023/02/the-injectivity-radii-of-the-unitary-groups/](https://sethaxen.com/blog/2023/02/the-injectivity-radii-of-the-unitary-groups/).
"""
function injectivity_radius(::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{n}}}) where {n}
    return π * sqrt(2.0)
end
function injectivity_radius(M::GeneralUnitaryMatrices{ℝ, Tuple{Int}})
    n = get_parameter(M.size)[1]
    return n == 1 ? 0.0 : π * sqrt(2.0)
end
injectivity_radius(::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{1}}}) = 0.0

# Resolve ambiguity on Rotations and Orthogonal
function _injectivity_radius(M::GeneralUnitaryMatrices{ℝ}, ::ExponentialRetraction)
    n = get_parameter(M.size)[1]
    return n == 1 ? 0.0 : π * sqrt(2.0)
end
function _injectivity_radius(M::GeneralUnitaryMatrices{ℝ}, ::PolarRetraction)
    n = get_parameter(M.size)[1]
    return n == 1 ? 0.0 : π / sqrt(2.0)
end

inner(::GeneralUnitaryMatrices, p, X, Y) = dot(X, Y)

"""
    is_flat(M::GeneralUnitaryMatrices)

Return true if [`GeneralUnitaryMatrices`](@ref) `M` is SO(2) or U(1) and false otherwise.
"""
is_flat(M::GeneralUnitaryMatrices) = false
is_flat(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}) = true
is_flat(M::GeneralUnitaryMatrices{ℂ, TypeParameter{Tuple{1}}}) = true
function is_flat(M::GeneralUnitaryMatrices{ℝ, Tuple{Int64}})
    return M.size[1] == 2
end
function is_flat(M::GeneralUnitaryMatrices{ℂ, Tuple{Int64}})
    return M.size[1] == 1
end

@doc raw"""
    log(M::Rotations, p, X)
    log(M::OrthogonalMatrices, p, X)
    log(M::UnitaryMatrices, p, X)

Compute the logarithmic map, that is, since the resulting ``X`` is represented in the Lie algebra,

```math
\log_p q = \log(p^{\mathrm{H}}q)
```

which is projected onto the skew symmetric matrices for numerical stability.
"""
log(::GeneralUnitaryMatrices, p, q)

@doc raw"""
    log(M::Rotations, p, q)

Compute the logarithmic map on the [`Rotations`](@ref) manifold
`M` which is given by

```math
\log_p q = \log(p^{\mathrm{T}}q)
```

where ``\log`` denotes the matrix logarithm. For numerical stability,
the result is projected onto the set of skew symmetric matrices.

For antipodal rotations the function returns deterministically one of the tangent vectors
that point at `q`.
"""
log(::GeneralUnitaryMatrices{ℝ}, ::Any...)
function ManifoldsBase.log(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, p, q)
    U = transpose(p) * q
    @assert size(U) == (2, 2)
    @inbounds θ = atan(U[2], U[1])
    return get_vector(M, p, θ, DefaultOrthogonalBasis())
end

function log(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, p::SMatrix, q::SMatrix)
    U = transpose(p) * q
    cosθ = (tr(U) - 1) / 2
    if cosθ ≈ -1
        eig = eigen_safe(U)
        ival = findfirst(λ -> isapprox(λ, 1), eig.values)
        inds = SVector{3}(1:3)
        #TODO this is to stop convert error of ax as a complex number
        ax::Vector{Float64} = eig.vectors[inds, ival]
        return get_vector(M, p, π * ax, DefaultOrthogonalBasis())
    end
    X = U ./ usinc_from_cos(cosθ)
    return (X .- X') ./ 2
end
function log!(M::GeneralUnitaryMatrices{ℝ}, X, p, q)
    U = transpose(p) * q
    X .= real(log_safe(U))
    n = get_parameter(M.size)[1]
    return project!(SkewSymmetricMatrices(n), X, p, X)
end
function log!(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, X, p, q)
    U = transpose(p) * q
    @assert size(U) == (2, 2)
    @inbounds θ = atan(U[2], U[1])
    return get_vector!(M, X, p, θ, DefaultOrthogonalBasis())
end
function log!(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, X, p, q)
    U = transpose(p) * q
    cosθ = (tr(U) - 1) / 2
    if cosθ ≈ -1
        eig = eigen_safe(U)
        ival = findfirst(λ -> isapprox(λ, 1), eig.values)
        inds = SVector{3}(1:3)
        ax = eig.vectors[inds, ival]
        return get_vector!(M, X, p, π * ax, DefaultOrthogonalBasis())
    end
    X .= U ./ usinc_from_cos(cosθ)
    return project!(SkewSymmetricMatrices(3), X, p, X)
end
function log!(::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{4}}}, X, p, q)
    U = transpose(p) * q
    cosα, cosβ = Manifolds.cos_angles_4d_rotation_matrix(U)
    α = acos(clamp(cosα, -1, 1))
    β = acos(clamp(cosβ, -1, 1))
    if α ≈ 0 && β ≈ π
        A² = Symmetric((U - I) ./ 2)
        P = eigvecs(A²)
        E = similar(U)
        fill!(E, 0)
        @inbounds begin
            E[2, 1] = -β
            E[1, 2] = β
        end
        copyto!(X, P * E * transpose(P))
    else
        det(U) < 0 && throw(
            DomainError(
                "The logarithm is not defined for $p and $q with a negative determinant of p'q) ($(det(U)) < 0).",
            ),
        )
        copyto!(X, real(Manifolds.log_safe(U)))
    end
    return project!(SkewSymmetricMatrices(4), X, p, X)
end

function log!(M::GeneralUnitaryMatrices{𝔽}, X, p, q) where {𝔽}
    log_safe!(X, adjoint(p) * q)
    n = get_parameter(M.size)[1]
    project!(SkewHermitianMatrices(n, 𝔽), X, X)
    return X
end

norm(::GeneralUnitaryMatrices, p, X) = norm(X)

@doc raw"""
    manifold_dimension(M::Rotations)
    manifold_dimension(M::OrthogonalMatrices)

Return the dimension of the manifold orthogonal matrices and of the manifold of rotations
```math
\dim_{\mathrm{O}(n)} = \dim_{\mathrm{SO}(n)} = \frac{n(n-1)}{2}.
```
"""
function manifold_dimension(M::GeneralUnitaryMatrices{ℝ})
    n = get_parameter(M.size)[1]
    return div(n * (n - 1), 2)
end

@doc raw"""
    manifold_volume(::GeneralUnitaryMatrices{ℝ,<:Any,AbsoluteDeterminantOneMatrixType})

Volume of the manifold of real orthogonal matrices of absolute determinant one. The
formula reads [BoyaSudarshanTilma:2003](@cite):

```math
\begin{cases}
\frac{2^{k}(2\pi)^{k^2}}{\prod_{s=1}^{k-1} (2s)!} & \text{ if } n = 2k \\

\frac{2^{k+1}(2\pi)^{k(k+1)}}{\prod_{s=1}^{k-1} (2s+1)!} & \text{ if } n = 2k+1
\end{cases}
```
"""
function manifold_volume(
        M::GeneralUnitaryMatrices{ℝ, <:Any, AbsoluteDeterminantOneMatrixType},
    )
    n = get_parameter(M.size)[1]
    return 2 * manifold_volume(GeneralUnitaryMatrices(n, ℝ, DeterminantOneMatrixType))
end
@doc raw"""
    manifold_volume(::GeneralUnitaryMatrices{ℝ,<:Any,DeterminantOneMatrixType})

Volume of the manifold of real orthogonal matrices of determinant one. The
formula reads [BoyaSudarshanTilma:2003](@cite):

```math
\begin{cases}
2 & \text{ if } n = 0 \\
\frac{2^{k-1/2}(2\pi)^{k^2}}{\prod_{s=1}^{k-1} (2s)!} & \text{ if } n = 2k+2 \\
\frac{2^{k+1/2}(2\pi)^{k(k+1)}}{\prod_{s=1}^{k-1} (2s+1)!} & \text{ if } n = 2k+1
\end{cases}
```

It differs from the paper by a factor of `sqrt(2)` due to a different choice of
normalization.
"""
function manifold_volume(M::GeneralUnitaryMatrices{ℝ, <:Any, DeterminantOneMatrixType})
    n = get_parameter(M.size)[1]
    vol = 1.0
    if n % 2 == 0
        k = div(n, 2)
        vol *= 2^(k - 1) * (2π)^(k^2)
        for s in 1:(k - 1)
            vol /= factorial(2 * s)
        end
    else
        k = div(n - 1, 2)
        vol *= 2^k * (2π)^(k * (k + 1))
        for s in 1:(k - 1)
            vol /= factorial(2 * s + 1)
        end
    end
    if n > 1
        vol *= sqrt(2)
    end
    return vol
end
@doc raw"""
    manifold_volume(::GeneralUnitaryMatrices{ℂ,<:Any,AbsoluteDeterminantOneMatrixType})

Volume of the manifold of complex general unitary matrices of absolute determinant one. The
formula reads [BoyaSudarshanTilma:2003](@cite)

```math
\sqrt{n 2^{n+1}} π^{n(n+1)/2} \prod_{k=1}^{n-1}\frac{1}{k!}.
```
"""
function manifold_volume(
        M::GeneralUnitaryMatrices{ℂ, <:Any, AbsoluteDeterminantOneMatrixType},
    )
    n = get_parameter(M.size)[1]
    vol = sqrt(n * 2^(n + 1)) * π^(((n + 1) * n) // 2)
    kf = 1
    for k in 1:(n - 1)
        kf *= k
        vol /= kf
    end
    return vol
end

"""
    mean(
        M::Rotations,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolationWithinRadius(π/2/√2);
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).
"""
mean(::GeneralUnitaryMatrices{ℝ}, ::Any)

@doc raw"""
     project(G::UnitaryMatrices, p)
     project(G::OrthogonalMatrices, p)

Project the point ``p ∈ 𝔽^{n×n}`` to the nearest point in
``\mathrm{U}(n,𝔽)=``[`UnitaryMatrices(n,𝔽)`](@ref) under the Frobenius norm.
If ``p = U S V^\mathrm{H}`` is the singular value decomposition of ``p``, then the projection
is

````math
  \operatorname{proj}_{\mathrm{U}(n,𝔽)} \colon p ↦ U V^\mathrm{H}.
````
"""
project(::GeneralUnitaryMatrices{𝔽, <:Any, AbsoluteDeterminantOneMatrixType}, p) where {𝔽}

function project!(
        ::GeneralUnitaryMatrices{𝔽, <:Any, AbsoluteDeterminantOneMatrixType},
        q,
        p,
    ) where {𝔽}
    F = svd(p)
    mul!(q, F.U, F.Vt)
    return q
end

@doc raw"""
    project(M::OrthogonalMatrices, p, X)
    project(M::Rotations, p, X)
    project(M::UnitaryMatrices, p, X)

Orthogonally project the tangent vector ``X ∈ 𝔽^{n×n}``, ``\mathbb F ∈ \{\mathbb R, \mathbb C\}``
to the tangent space of `M` at `p`,
and change the representer to use the corresponding Lie algebra, i.e. we compute

```math
    \operatorname{proj}_p(X) = \frac{p^{\mathrm{H}} X - (p^{\mathrm{H}} X)^{\mathrm{H}}}{2}.
```
"""
project(::GeneralUnitaryMatrices, p, X)

function project!(M::GeneralUnitaryMatrices{𝔽}, Y, p, X) where {𝔽}
    n = get_parameter(M.size)[1]
    project!(SkewHermitianMatrices(n, 𝔽), Y, p \ X)
    return Y
end

@doc raw"""
    retract(M::Rotations, p, X, ::PolarRetraction)
    retract(M::OrthogonalMatrices, p, X, ::PolarRetraction)

Compute the SVD-based retraction on the [`Rotations`](@ref) and [`OrthogonalMatrices`](@ref) `M` from `p` in direction `X`
(as an element of the Lie group) and is a second-order approximation of the exponential map.
Let

````math
USV = p + pX
````

be the singular value decomposition, then the formula reads

````math
\operatorname{retr}_p X = UV^\mathrm{T}.
````
"""
retract(::GeneralUnitaryMatrices, ::Any, ::Any, ::PolarRetraction)

@doc raw"""
    retract(M::Rotations, p, X, ::QRRetraction)
    retract(M::OrthogonalMatrices, p. X, ::QRRetraction)

Compute the QR-based retraction on the [`Rotations`](@ref) and [`OrthogonalMatrices`](@ref) `M` from `p` in direction `X`
(as an element of the Lie group), which is a first-order approximation of the exponential map.

This is also the default retraction on these manifolds.
"""
retract(::GeneralUnitaryMatrices, ::Any, ::Any, ::QRRetraction)

function ManifoldsBase.retract_qr!(M::GeneralUnitaryMatrices, q, p, X)
    return ManifoldsBase.retract_qr_fused!(M, q, p, X, one(eltype(p)))
end

function ManifoldsBase.retract_qr_fused!(
        ::GeneralUnitaryMatrices,
        q::AbstractArray{T},
        p,
        X,
        t::Number,
    ) where {T}
    A = p + p * (t * X)
    qr_decomp = qr(A)
    d = diag(qr_decomp.R)
    D = Diagonal(sign.(d .+ convert(T, 0.5)))
    return copyto!(q, qr_decomp.Q * D)
end

function ManifoldsBase.retract_polar!(M::GeneralUnitaryMatrices, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end

function ManifoldsBase.retract_polar_fused!(M::GeneralUnitaryMatrices, q, p, X, t::Number)
    A = p + p * (t * X)
    return project!(M, q, A; check_det = false)
end

@doc raw"""
    riemann_tensor(::GeneralUnitaryMatrices, p, X, Y, Z)

Compute the value of Riemann tensor on the [`GeneralUnitaryMatrices`](@ref) manifold.
The formula reads [Rentmeesters:2011](@cite)

```math
R(X,Y)Z=\frac{1}{4}[Z, [X, Y]].
```
"""
riemann_tensor(::GeneralUnitaryMatrices, p, X, Y, Z)

function riemann_tensor!(::GeneralUnitaryMatrices, Xresult, p, X, Y, Z)
    Xtmp = X * Y - Y * X
    Xresult .= 1 // 4 .* (Z * Xtmp .- Xtmp * Z)
    return Xresult
end

@doc raw"""
    volume_density(M::GeneralUnitaryMatrices{<:Any,ℝ}, p, X)

Compute volume density function of a sphere, i.e. determinant of the differential of
exponential map `exp(M, p, X)`. It is derived from Eq. (4.1) and Corollary 4.4
in [ChevallierLiLuDunson:2022](@cite). See also Theorem 4.1 in [FalorsideHaanDavidsonForre:2019](@cite),
(note that it uses a different convention).
"""
function volume_density(M::GeneralUnitaryMatrices{ℝ}, p, X)
    dens = one(eltype(X))
    B = get_basis(M, p, DefaultOrthonormalBasis())
    Ys = get_vectors(M, p, B)
    Z = similar(X)
    op_coeffs = similar(X, manifold_dimension(M), manifold_dimension(M))
    for k in 1:manifold_dimension(M)
        Y = Ys[k]
        Z .= X * Y .- Y * X
        get_coordinates!(M, view(op_coeffs, :, k), p, Z, DefaultOrthonormalBasis())
    end
    for ev in eigvals(op_coeffs)
        if abs(ev) > eps(eltype(X))
            cm = (1 - exp(-ev)) / ev
            dens *= real(cm)
        end
    end

    return dens
end

@doc raw"""
    volume_density(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, p, X)

Compute the volume density on O(3)/SO(3). The formula reads [FalorsideHaanDavidsonForre:2019](@cite)

```math
\frac{1-1\cos(\sqrt{2}\lVert X \rVert)}{\lVert X \rVert^2}.
```
"""
function volume_density(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{3}}}, p, X)
    nX = norm(M, p, X)
    if nX > eps(eltype(X))
        return (1 - 1 * cos(sqrt(2) * nX)) / nX^2
    else
        return one(nX)
    end
end

@doc raw"""
    volume_density(M::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, p, X)

Volume density on O(2)/SO(2) is equal to 1.
"""
function volume_density(::GeneralUnitaryMatrices{ℝ, TypeParameter{Tuple{2}}}, p, X)
    return one(eltype(X))
end

@doc raw"""
    BurresWassertseinMetric <: AbstractMetric

The Bures Wasserstein metric for symmetric positive definite matrices [MalagoMontruccioPistone:2018](@cite)
"""
struct BuresWassersteinMetric <: RiemannianMetric end

@doc raw"""
    change_representer(M::MetricManifold{ℝ,<:SymmetricPositiveDefinite,BuresWassersteinMetric}, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal M`` representing a linear function on the tangent
space at `p` with respect to the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
`g_E`, this is turned into the representer with respect to the (default) metric,
the [`BuresWassersteinMetric`](@ref) on the [`SymmetricPositiveDefinite`](@ref) `M`.

To be precise we are looking for ``Z∈T_p\mathcal P(n)`` such that for all ``Y∈T_p\mathcal P(n)```
it holds

```math
⟨X,Y⟩ = \operatorname{tr}(XY) = ⟨Z,Y⟩_{\mathrm{BW}}
```
for all ``Y`` and hence we get
``Z``= 2(A+A^{\mathrm{T}})`` with ``A=Xp``.
"""
change_representer(
    ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
    ::EuclideanMetric,
    p,
    X,
)

function change_representer!(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
        Y,
        ::EuclideanMetric,
        p,
        X,
    )
    A = X * p
    Y .= 2 .* (A .+ A')
    return Y
end

@doc raw"""
    distance(::MetricManifold{SymmetricPositiveDefinite,BuresWassersteinMetric}, p, q)

Compute the distance with respect to the [`BuresWassersteinMetric`](@ref) on [`SymmetricPositiveDefinite`](@ref) matrices, i.e.

```math
d(p,q) =
    \operatorname{tr}(p) + \operatorname{tr}(q) - 2\operatorname{tr}\Bigl( (p^{\frac{1}{2}}qp^{\frac{1}{2}} \bigr)^\frac{1}{2} \Bigr),
```

where the last trace can be simplified (by rotating the matrix products in the trace) to ``\operatorname{tr}(pq)``.
"""
function distance(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
        p,
        q,
    )
    return sqrt(tr(p) + tr(q) - 2 * tr(sqrt(p * q)))
end

@doc raw"""
    exp(::MetricManifold{ℝ,SymmetricPositiveDefinite,BuresWassersteinMetric}, p, X)

Compute the exponential map on [`SymmetricPositiveDefinite`](@ref) with respect to
the [`BuresWassersteinMetric`](@ref) given by

```math
    \exp_p(X) = p+X+L_p(X)pL_p(X)
```

where ``q=L_p(X)`` denotes the Lyapunov operator, i.e. it solves ``pq + qp = X``.
"""
exp(::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric}, p, X)

function exp!(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
        q,
        p,
        X,
    )
    Y = lyap(p, -X) #lyap solves qp+pq-X=0
    q .= p .+ X .+ Y * p * Y
    return q
end

@doc raw"""
    inner(::MetricManifold{ℝ,SymmetricPositiveDefinite,BuresWassersteinMetric}, p, X, Y)

Compute the inner product [`SymmetricPositiveDefinite`](@ref) with respect to
the [`BuresWassersteinMetric`](@ref) given by

```math
    ⟨X,Y⟩ = \frac{1}{2}\operatorname{tr}(L_p(X)Y)
```

where ``q=L_p(X)`` denotes the Lyapunov operator, i.e. it solves ``pq + qp = X``.
"""
function inner(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
        p,
        X,
        Y,
    )
    return 1 / 2 * dot(lyap(p, -X), Y)
end

"""
    is_flat(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,BuresWassersteinMetric})

Return false. [`SymmetricPositiveDefinite`](@ref) with [`BuresWassersteinMetric`](@ref)
is not a flat manifold.
"""
is_flat(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric}) = false

@doc raw"""
    log(::MetricManifold{SymmetricPositiveDefinite,BuresWassersteinMetric}, p, q)

Compute the logarithmic map on [`SymmetricPositiveDefinite`](@ref) with respect to
the [`BuresWassersteinMetric`](@ref) given by

```math
    \log_p(q) = (pq)^{\frac{1}{2}} + (qp)^{\frac{1}{2}} - 2 p
```

where ``q=L_p(X)`` denotes the Lyapunov operator, i.e. it solves ``pq + qp = X``.
"""
log(::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric}, p, q)

function log!(
        ::MetricManifold{ℝ, <:SymmetricPositiveDefinite, BuresWassersteinMetric},
        X,
        p,
        q,
    )
    X .= sqrt(Symmetric(p * q)) + sqrt(Symmetric(q * p)) - 2 * p
    return X
end

include("../header.jl")

@testset "Generalized Grassmann" begin
    @testset "Real" begin
        B = [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0]
        M = GeneralizedGrassmann(3, 2, B)
        p = [1.0 0.0; 0.0 0.5; 0.0 0.0]
        X = zeros(3, 2)
        X[1, :] .= 1.0
        @testset "Basics" begin
            @test repr(M) ==
                "GeneralizedGrassmann(3, 2, [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0], ℝ)"
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 2
            @test base_manifold(M) === M
            @test !is_flat(M)
            @test_throws ManifoldDomainError is_point(M, [1.0, 0.0, 0.0, 0.0]; error = :error)
            @test_throws ManifoldDomainError is_point(
                M,
                1im * [1.0 0.0; 0.0 1.0; 0.0 0.0];
                error = :error,
            )
            @test_throws ManifoldDomainError is_point(M, 2 * p; error = :error)
            @test !is_vector(M, p, [0.0, 0.0, 1.0, 0.0])
            @test_throws ManifoldDomainError is_vector(
                M,
                p,
                [0.0, 0.0, 1.0, 0.0];
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(
                M,
                p,
                1 * im * zero_vector(M, p);
                error = :error,
            )
            @test_throws ManifoldDomainError is_vector(M, p, X; error = :error)
            @test injectivity_radius(M) == π / 2
            @test injectivity_radius(M, ExponentialRetraction()) == π / 2
            @test injectivity_radius(M, p) == π / 2
            @test injectivity_radius(M, p, ExponentialRetraction()) == π / 2
            @test mean(M, [p, p, p]) == p
            Random.seed!(42)
            @test is_point(M, rand(M))
            @test is_vector(M, p, rand(M; vector_at = p))
        end
        @testset "Embedding and Projection" begin
            q = similar(p)
            p2 = embed(M, p)
            @test p2 == p
            embed!(M, q, p)
            @test q == p2
            a = [1.0 0.0; 0.0 2.0; 0.0 0.0]
            @test !is_point(M, a)
            b = similar(a)
            c = project(M, a)
            @test c == p
            project!(M, b, a)
            @test b == p
            X = [0.0 0.0; 0.0 0.0; -1.0 1.0]
            Y = similar(X)
            Z = embed(M, p, X)
            embed!(M, Y, p, X)
            @test Y == X
            @test Z == X
        end
        @testset "gradient and metric conversion" begin
            L = cholesky(B).L
            X = [0.0 0.0; 0.0 0.0; 1.0 -1.0]
            Y = change_metric(M, EuclideanMetric(), p, X)
            @test Y == L \ X
            Z = change_representer(M, EuclideanMetric(), p, X)
            @test Z == B \ X
        end
        types = [Matrix{Float64}]
        X = [0.0 0.0; 1.0 0.0; 0.0 2.0]
        Y = [0.0 0.0; -1.0 0.0; 0.0 2.0]
        @test inner(M, p, X, Y) == 0
        q = retract(M, p, X)
        r = retract(M, p, Y)
        @test is_point(M, q)
        @test is_point(M, r)
        @test retract(M, p, X) == exp(M, p, X)

        a = project(M, p + X)
        c = retract(M, p, X, ProjectionRetraction())
        d = retract(M, p, X, PolarRetraction())
        @test a == c
        @test c == d
        e = similar(a)
        retract!(M, e, p, X)
        @test e == exp(M, p, X)
        @test vector_transport_to(M, p, X, q, ProjectionTransport()) == project(M, q, X)
        @testset "Type $T" for T in types
            pts = convert.(T, [p, q, r])
            @test !is_point(M, 2 * p)
            @test_throws ManifoldDomainError !is_point(M, 2 * r; error = :error)
            @test !is_vector(M, p, q)
            @test_throws ManifoldDomainError is_vector(M, p, q; error = :error)
            Manifolds.test_manifold(
                M,
                pts,
                test_exp_log = false,
                default_inverse_retraction_method = LogarithmicInverseRetraction(),
                default_retraction_method = ExponentialRetraction(),
                test_injectivity_radius = false,
                test_is_tangent = true,
                test_project_tangent = true,
                test_default_vector_transport = false,
                projection_atol_multiplier = 15.0,
                retraction_atol_multiplier = 10.0,
                is_point_atol_multiplier = 10.0,
                is_tangent_atol_multiplier = 4 * 10.0^2,
                retraction_methods = [PolarRetraction(), ProjectionRetraction()],
                mid_point12 = nothing,
                test_inplace = true,
            )
        end
    end

    @testset "Complex" begin
        B = [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0]
        M = GeneralizedGrassmann(3, 2, B, ℂ)
        @testset "Basics" begin
            @test repr(M) ==
                "GeneralizedGrassmann(3, 2, [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0], ℂ)"
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 4
            @test !is_flat(M)
            @test !is_point(M, [1.0, 0.0, 0.0, 0.0])
            @test !is_vector(M, [1.0 0.0; 0.0 1.0; 0.0 0.0], [0.0, 0.0, 1.0, 0.0])
            x = [1.0 0.0; 0.0 0.5; 0.0 0.0]

            x = [1im 0.0; 0.0 0.5im; 0.0 0.0]
            @test is_point(M, x)
            @test !is_point(M, 2 * x)
        end
    end

    @testset "Quaternion" begin
        B = [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0]
        M = GeneralizedGrassmann(3, 2, B, ℍ)
        @test repr(M) ==
            "GeneralizedGrassmann(3, 2, [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0], ℍ)"
        @testset "Basics" begin
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 8
            @test !is_flat(M)
        end
    end

    @testset "small distance tests" begin
        n, k = 3, 2
        B = [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0]
        @testset for fT in (Float32, Float64), T in (fT, Complex{fT})
            𝔽 = T isa Complex ? ℂ : ℝ
            M = GeneralizedGrassmann(n, k, B, 𝔽)
            rT = real(T)
            atol = eps(rT)^(1 // 4)
            rtol = eps(rT)
            @testset for t in (zero(rT), eps(rT)^(1 // 4) / 8, eps(rT)^(1 // 4))
                p = project(M, randn(T, representation_size(M)))
                X = project(M, p, randn(T, representation_size(M)))
                X ./= norm(M, p, X)
                project!(M, X, p, X)
                @test distance(M, p, exp(M, p, t * X)) ≈ t atol = atol rtol = rtol
            end
        end
    end
    @testset "field parameter" begin
        B = [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0]
        M = GeneralizedGrassmann(3, 2, B; parameter = :field)
        @test repr(M) ==
            "GeneralizedGrassmann(3, 2, [1.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 1.0], ℝ; parameter=:field)"
        @test typeof(get_embedding(M)) ===
            GeneralizedStiefel{ℝ, Tuple{Int64, Int64}, Matrix{Float64}}
    end
end

@doc raw"""
    ProbabilitySimplex{T,boundary} <: AbstractDecoratorManifold{𝔽}

The (relative interior of) the probability simplex is the set
````math
Δ^n := \biggl\{ p ∈ ℝ^{n+1}\ \big|\ p_i > 0 \text{ for all } i=1,…,n+1,
\text{ and } ⟨\mathbb{1},p⟩ = \sum_{i=1}^{n+1} p_i = 1\biggr\},
````
where $\mathbb{1}=(1,…,1)^{\mathrm{T}}∈ ℝ^{n+1}$ denotes the vector containing only ones.

If `boundary` is set to `:open`, then the object represents an open simplex. Otherwise,
that is when `boundary` is set to `:closed`, the boundary is also included:
````math
\hat{Δ}^n := \biggl\{ p ∈ ℝ^{n+1}\ \big|\ p_i \geq 0 \text{ for all } i=1,…,n+1,
\text{ and } ⟨\mathbb{1},p⟩ = \sum_{i=1}^{n+1} p_i = 1\biggr\},
````

This set is also called the unit simplex or standard simplex.

The tangent space is given by
````math
T_pΔ^n = \biggl\{ X ∈ ℝ^{n+1}\ \big|\ ⟨\mathbb{1},X⟩ = \sum_{i=1}^{n+1} X_i = 0 \biggr\}
````

The manifold is implemented assuming the Fisher-Rao metric for the multinomial distribution,
which is equivalent to the induced metric from isometrically embedding the probability
simplex in the ``n``-sphere of radius 2.
The corresponding diffeomorphism $\varphi: \mathbb Δ^n → \mathcal N$,
where $\mathcal N \subset 2𝕊^n$ is given by $\varphi(p) = 2\sqrt{p}$.

This implementation follows the notation in [AastroemPetraSchmitzerSchnoerr:2017](@cite).

# Constructor

    ProbabilitySimplex(n::Int; boundary::Symbol=:open)
"""
struct ProbabilitySimplex{T, boundary} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function ProbabilitySimplex(n::Int; boundary::Symbol = :open, parameter::Symbol = :type)
    if boundary !== :open && boundary !== :closed
        throw(
            ArgumentError(
                "boundary can only be set to :open or :closed; received $boundary",
            ),
        )
    end
    size = wrap_type_parameter(parameter, (n,))
    return ProbabilitySimplex{typeof(size), boundary}(size)
end

"""
    FisherRaoMetric <: AbstractMetric

The Fisher-Rao metric or Fisher information metric is a particular Riemannian metric which
can be defined on a smooth statistical manifold, i.e., a smooth manifold whose points are
probability measures defined on a common probability space.

See for example the [`ProbabilitySimplex`](@ref).
"""
struct FisherRaoMetric <: AbstractMetric end

@doc raw"""
    change_representer(M::ProbabilitySimplex, ::EuclideanMetric, p, X)

Given a tangent vector with respect to the metric from the embedding, the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`),
the representer of a linear functional on the tangent space is adapted as ``Z = p .* X .- p .* dot(p, X)``.
The first part “compensates” for the division by ``p`` in the Riemannian metric on the [`ProbabilitySimplex`](@ref)
and the second part performs appropriate projection to keep the vector tangent.

For details see Proposition 2.3 in [AastroemPetraSchmitzerSchnoerr:2017](@cite).
"""
change_representer(::ProbabilitySimplex, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(::ProbabilitySimplex, Y, ::EuclideanMetric, p, X)
    return Y .= p .* X .- p .* dot(p, X)
end

@doc raw"""
    change_metric(M::ProbabilitySimplex, ::EuclideanMetric, p, X)

To change the metric, we are looking for a function ``c\colon T_pΔ^n → T_pΔ^n`` such that for all ``X,Y ∈ T_pΔ^n``
This can be achieved by rewriting representer change in matrix form as `(Diagonal(p) - p * p') * X`
and taking square root of the matrix
"""
change_metric(::ProbabilitySimplex, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(::ProbabilitySimplex, Y, ::EuclideanMetric, p, X)
    return Y .= sqrt(Diagonal(p) - p * p') * X
end

"""
    check_point(M::ProbabilitySimplex, p; kwargs...)

Check whether `p` is a valid point on the [`ProbabilitySimplex`](@ref) `M`, i.e. is a point in
the embedding with positive entries that sum to one
The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(M::ProbabilitySimplex{<:Any, boundary}, p; kwargs...) where {boundary}
    if boundary === :closed && minimum(p) < 0
        return DomainError(
            minimum(p),
            "The point $(p) does not lie on the $(M) since it has negative entries.",
        )
    end
    if boundary === :open && minimum(p) <= 0
        return DomainError(
            minimum(p),
            "The point $(p) does not lie on the $(M) since it has nonpositive entries.",
        )
    end
    if !isapprox(sum(p), 1.0; kwargs...)
        return DomainError(
            sum(p),
            "The point $(p) does not lie on the $(M) since its sum is not 1.",
        )
    end
    return nothing
end

"""
    check_vector(M::ProbabilitySimplex, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`ProbabilitySimplex`](@ref) `M`, i.e.
after [`check_point`](@ref check_point(::ProbabilitySimplex, ::Any))`(M,p)`,
`X` has to be of same dimension as `p` and its elements have to sum to one.
The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(
        M::ProbabilitySimplex,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(sum(X), 0.0; atol = atol, kwargs...)
        return DomainError(
            sum(X),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since its elements do not sum up to 0.",
        )
    end
    return nothing
end

metric(::ProbabilitySimplex) = FisherRaoMetric()

@doc raw"""
    distance(M, p, q)

Compute the distance between two points on the [`ProbabilitySimplex`](@ref) `M`.
The formula reads
````math
d_{Δ^n}(p,q) = 2\arccos \biggl( \sum_{i=1}^{n+1} \sqrt{p_i q_i} \biggr)
````
"""
function distance(::ProbabilitySimplex, p, q)
    sumsqrt = zero(Base.promote_eltype(p, q))
    @inbounds for i in eachindex(p, q)
        sumsqrt += sqrt(p[i] * q[i])
    end
    return 2 * acos(sumsqrt)
end

embed(::ProbabilitySimplex, p) = p
embed(::ProbabilitySimplex, p, X) = X

@doc raw"""
    exp(M::ProbabilitySimplex, p, X)

Compute the exponential map on the probability simplex.

````math
\exp_pX = \frac{1}{2}\Bigl(p+\frac{X_p^2}{\lVert X_p \rVert^2}\Bigr)
+ \frac{1}{2}\Bigl(p - \frac{X_p^2}{\lVert X_p \rVert^2}\Bigr)\cos(\lVert X_p\rVert)
+ \frac{1}{\lVert X_p \rVert}\sqrt{p}\sin(\lVert X_p\rVert),
````

where $X_p = \frac{X}{\sqrt{p}}$, with its division meant elementwise, as well as for the
operations $X_p^2$ and $\sqrt{p}$.
"""
exp(::ProbabilitySimplex, ::Any...)

function exp!(::ProbabilitySimplex, q, p, X)
    s = sqrt.(p)
    Xs = X ./ s ./ 2
    θ = norm(Xs)
    q .= (cos(θ) .* s .+ usinc(θ) .* Xs) .^ 2
    return q
end

function get_coordinates_orthonormal!(M::ProbabilitySimplex, Xc, p, X, R::RealNumbers)
    n = get_parameter(M.size)[1]
    get_coordinates_orthonormal!(
        Sphere(n),
        Xc,
        simplex_to_amplitude(M, p),
        simplex_to_amplitude_diff(M, p, X),
        R,
    )
    return Xc
end

function get_embedding(::ProbabilitySimplex{TypeParameter{Tuple{n}}}) where {n}
    return Euclidean(n + 1)
end
function get_embedding(M::ProbabilitySimplex{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return Euclidean(n + 1; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::ProbabilitySimplex)
    return ManifoldsBase.EmbeddedManifoldType()
end

function get_vector_orthonormal!(M::ProbabilitySimplex, Y, p, Xc, R::RealNumbers)
    n = get_parameter(M.size)[1]
    ps = simplex_to_amplitude(M, p)
    X = get_vector_orthonormal(Sphere(n), ps, Xc, R)
    return amplitude_to_simplex_diff!(M, Y, ps, X)
end

@doc raw"""
    injectivity_radius(M::ProbabilitySimplex, p)

Compute the injectivity radius on the [`ProbabilitySimplex`](@ref) `M` at the point `p`,
i.e. the distance radius to a point near/on the boundary, that could be reached by following the
geodesic.
"""
function injectivity_radius(::ProbabilitySimplex, p)
    i = argmin(p)
    s = sum(p) - p[i]
    return 2 * acos(sqrt(s))
end
function injectivity_radius(M::ProbabilitySimplex, p, ::AbstractRetractionMethod)
    return injectivity_radius(M, p)
end
injectivity_radius(M::ProbabilitySimplex) = 0
injectivity_radius(M::ProbabilitySimplex, ::AbstractRetractionMethod) = 0

@doc raw"""
    inner(M::ProbabilitySimplex, p, X, Y)

Compute the inner product of two tangent vectors `X`, `Y` from the tangent space $T_pΔ^n$ at
`p`. The formula reads
````math
g_p(X,Y) = \sum_{i=1}^{n+1}\frac{X_iY_i}{p_i}
````
When `M` includes boundary, we can just skip coordinates where ``p_i`` is equal to 0, see
Proposition 2.1 in [AyJostLeSchwachhoefer:2017](@cite).
"""
function inner(::ProbabilitySimplex{<:Any, boundary}, p, X, Y) where {boundary}
    d = zero(Base.promote_eltype(p, X, Y))
    if boundary === :closed
        @inbounds for i in eachindex(p, X, Y)
            if p[i] > 0
                d += X[i] * Y[i] / p[i]
            end
        end
    else
        @inbounds for i in eachindex(p, X, Y)
            d += X[i] * Y[i] / p[i]
        end
    end
    return d
end

@doc raw"""
    inverse_retract(M::ProbabilitySimplex, p, q, ::SoftmaxInverseRetraction)

Compute a first order approximation by projection. The formula reads
````math
\operatorname{retr}^{-1}_p q = \bigl( I_{n+1} - \frac{1}{n}\mathbb{1}^{n+1,n+1} \bigr)(\log(q)-\log(p))
````
where $\mathbb{1}^{m,n}$ is the size `(m,n)` matrix containing ones, and $\log$ is applied elementwise.
"""
inverse_retract(::ProbabilitySimplex, ::Any, ::Any, ::SoftmaxInverseRetraction)

function inverse_retract_softmax!(::ProbabilitySimplex, X, p, q)
    X .= log.(q) .- log.(p)
    meanlogdiff = mean(X)
    X .-= meanlogdiff
    return X
end

"""
    is_flat(::ProbabilitySimplex)

Return false. [`ProbabilitySimplex`](@ref) is not a flat manifold.
"""
is_flat(M::ProbabilitySimplex) = false

@doc raw"""
    log(M::ProbabilitySimplex, p, q)

Compute the logarithmic map of `p` and `q` on the [`ProbabilitySimplex`](@ref) `M`.

````math
\log_pq = \frac{d_{Δ^n}(p,q)}{\sqrt{1-⟨\sqrt{p},\sqrt{q}⟩}}(\sqrt{pq} - ⟨\sqrt{p},\sqrt{q}⟩p),
````

where $pq$ and $\sqrt{p}$ is meant elementwise.
"""
log(::ProbabilitySimplex, ::Any...)

function log!(::ProbabilitySimplex, X, p, q)
    if p ≈ q
        fill!(X, 0)
    else
        z = sqrt.(p .* q)
        s = sum(z)
        X .= 2 * acos(s) / sqrt(1 - s^2) .* (z .- s .* p)
    end
    return X
end

@doc raw"""
    manifold_dimension(M::ProbabilitySimplex)

Returns the manifold dimension of the probability simplex in $ℝ^{n+1}$, i.e.
````math
    \dim_{Δ^n} = n.
````
"""
manifold_dimension(M::ProbabilitySimplex) = get_parameter(M.size)[1]

@doc raw"""
    manifold_volume(::ProbabilitySimplex)

Return the volume of the [`ProbabilitySimplex`](@ref), i.e. volume of the `n`-dimensional
[`Sphere`](@ref) divided by ``2^{n+1}``, corresponding to the volume of its positive
orthant.
"""
function manifold_volume(M::ProbabilitySimplex)
    n = get_parameter(M.size)[1]
    return manifold_volume(Sphere(n)) / 2^(n + 1)
end

@doc raw"""
    mean(
        M::ProbabilitySimplex,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolation();
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolation`](@extref `ManifoldsBase.GeodesicInterpolation`).
"""
mean(::ProbabilitySimplex, ::Any...)

default_approximation_method(::ProbabilitySimplex, ::typeof(mean)) = GeodesicInterpolation()

function parallel_transport_to!(M::ProbabilitySimplex, Y, p, X, q)
    n = get_parameter(M.size)[1]
    q_s = simplex_to_amplitude(M, q)
    Ys = parallel_transport_to(
        Sphere(n),
        simplex_to_amplitude(M, p),
        simplex_to_amplitude_diff(M, p, X),
        q_s,
    )
    return amplitude_to_simplex_diff!(M, Y, q_s, Ys)
end

@doc raw"""
    rand(::ProbabilitySimplex; vector_at=nothing, σ::Real=1.0)


When `vector_at` is `nothing`, return a random (uniform over the Fisher-Rao metric; that is, uniform with respect to the `n`-sphere whose positive orthant is mapped to the simplex).
point `x` on the [`ProbabilitySimplex`](@ref) manifold `M` according to the isometric embedding into
the `n`-sphere by normalizing the vector length of a sample from a multivariate Gaussian. See [Marsaglia:1972](@cite).

When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_{p}\mathrm{\Delta}^n``by shifting a multivariate Gaussian with standard deviation `σ`
to have a zero component sum.
"""
rand(::ProbabilitySimplex; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::ProbabilitySimplex,
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if isnothing(vector_at)
        Random.randn!(rng, pX)
        LinearAlgebra.normalize!(pX, 2)
        pX .= abs2.(pX)
    else
        Random.randn!(rng, pX)
        pX .= (pX .- mean(pX)) .* σ
        change_metric!(M, pX, EuclideanMetric(), vector_at, pX)
    end
    return pX
end

@doc raw"""
    project(M::ProbabilitySimplex, p, Y)

Project `Y` from the embedding onto the tangent space at `p` on
the [`ProbabilitySimplex`](@ref) `M`. The formula reads

````math
\operatorname{proj}_{Δ^n}(p,Y) = Y - \bar{Y}
```
where ``\bar{Y}`` denotes mean of ``Y``.
"""
project(::ProbabilitySimplex, ::Any, ::Any)

function project!(::ProbabilitySimplex, X, p, Y)
    X .= Y .- mean(Y)
    return X
end

@doc raw"""
    project(M::ProbabilitySimplex, p)

project `p` from the embedding onto the [`ProbabilitySimplex`](@ref) `M`.
The formula reads

````math
\operatorname{proj}_{Δ^n}(p) = \frac{1}{⟨\mathbb 1,p⟩}p,
````
where ``\mathbb 1 ∈ ℝ`` denotes the vector of ones.
Not that this projection is only well-defined if ``p`` has positive entries.
"""
project(::ProbabilitySimplex, ::Any)

function project!(::ProbabilitySimplex, q, p)
    if any(x -> x <= 0, p)
        throw(
            DomainError(
                p,
                "All coordinates of point from the embedding, that should be projected, must be positive, otherwise the projection is not well defined.",
            ),
        )
    end
    q .= p ./ sum(p)
    return q
end

@doc raw"""
    representation_size(::ProbabilitySimplex)

Return the representation size of points in the ``n``-dimensional probability simplex,
i.e. an array size of `(n+1,)`.
"""
function representation_size(M::ProbabilitySimplex)
    n = get_parameter(M.size)[1]
    return (n + 1,)
end

@doc raw"""
    retract(M::ProbabilitySimplex, p, X, ::SoftmaxRetraction)

Compute a first order approximation by applying the softmax function. The formula reads

````math
\operatorname{retr}_p X = \frac{p\mathrm{e}^X}{⟨p,\mathrm{e}^X⟩},
````

where multiplication, exponentiation and division are meant elementwise.
"""
retract(::ProbabilitySimplex, ::Any, ::Any, ::SoftmaxRetraction)

function ManifoldsBase.retract_softmax!(M::ProbabilitySimplex, q, p, X)
    return ManifoldsBase.retract_softmax_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_softmax_fused!(::ProbabilitySimplex, q, p, X, t::Number)
    s = zero(eltype(q))
    @inbounds for i in eachindex(q, p, X)
        q[i] = p[i] * exp(t * X[i])
        s += q[i]
    end
    q ./= s
    return q
end

@doc raw"""
    X = riemannian_gradient(M::ProbabilitySimplex, p, Y)
    riemannian_gradient!(M::ProbabilitySimplex, X, p, Y)

Given a gradient ``Y = \operatorname{grad} \tilde f(p)`` in the embedding ``ℝ^{n+1}`` of the
[`ProbabilitySimplex`](@ref) ``Δ^n``, this function computes the Riemannian gradient
``X = \operatorname{grad} f(p)`` where ``f`` is the function ``\tilde f`` restricted to the manifold.

The formula reads

```math
    X = p ⊙ Y - ⟨p, Y⟩p,
```
where ``⊙`` denotes the emelementwise product.
"""
riemannian_gradient(M::ProbabilitySimplex, p, Y; kwargs...)

function riemannian_gradient!(M::ProbabilitySimplex, X, p, Y; kwargs...)
    X .= p .* Y - dot(p, Y) .* p
    return X
end

@doc raw"""
    riemann_tensor(::ProbabilitySimplex, p, X, Y, Z)

Compute the Riemann tensor ``R(X,Y)Z`` at point `p` on [`ProbabilitySimplex`](@ref) `M`.
It is computed using isometry with positive orthant of a sphere.
"""
riemann_tensor(::ProbabilitySimplex, p, X, Y, Z)

function riemann_tensor!(M::ProbabilitySimplex, Xresult, p, X, Y, Z)
    n = get_parameter(M.size)[1]
    pe = simplex_to_amplitude(M, p)
    Xrs = riemann_tensor(
        Sphere(n),
        pe,
        simplex_to_amplitude_diff(M, p, X),
        simplex_to_amplitude_diff(M, p, Y),
        simplex_to_amplitude_diff(M, p, Z),
    )
    amplitude_to_simplex_diff!(M, Xresult, pe, Xrs)
    return Xresult
end

function Base.show(
        io::IO,
        ::ProbabilitySimplex{TypeParameter{Tuple{n}}, boundary},
    ) where {n, boundary}
    return print(io, "ProbabilitySimplex($(n); boundary=:$boundary)")
end
function Base.show(io::IO, M::ProbabilitySimplex{Tuple{Int}, boundary}) where {boundary}
    n = get_parameter(M.size)[1]
    return print(io, "ProbabilitySimplex($(n); boundary=:$boundary, parameter=:field)")
end

@doc raw"""
    volume_density(M::ProbabilitySimplex, p, X)

Compute the volume density at point `p` on [`ProbabilitySimplex`](@ref) `M` for tangent
vector `X`. It is computed using isometry with positive orthant of a sphere.
"""
function volume_density(M::ProbabilitySimplex, p, X)
    n = get_parameter(M.size)[1]
    pe = simplex_to_amplitude(M, p)
    return volume_density(Sphere(n), pe, simplex_to_amplitude_diff(M, p, X))
end

@doc raw"""
    zero_vector(M::ProbabilitySimplex, p)

Return the zero tangent vector in the tangent space of the point `p`  from the
[`ProbabilitySimplex`](@ref) `M`, i.e. its representation by the zero vector in the embedding.
"""
zero_vector(::ProbabilitySimplex, ::Any)

zero_vector!(::ProbabilitySimplex, X, p) = fill!(X, 0)

@doc raw"""
    simplex_to_amplitude(M::ProbabilitySimplex, p)

Convert point `p` on [`ProbabilitySimplex`](@ref Manifolds.ProbabilitySimplex) to (real) probability amplitude. The
formula reads ``(\sqrt{p_1}, \sqrt{p_2}, …, \sqrt{p_{N+1}})``. This is an isometry from the
interior of the probability simplex to the interior of the positive orthant of a sphere.
"""
function simplex_to_amplitude(M::ProbabilitySimplex, p)
    return simplex_to_amplitude!(M, similar(p), p)
end

function simplex_to_amplitude!(::ProbabilitySimplex, q, p)
    q .= sqrt.(p)
    return q
end

@doc raw"""
    amplitude_to_simplex(M::ProbabilitySimplex, p)

Convert point (real) probability amplitude `p` on to a point on [`ProbabilitySimplex`](@ref Manifolds.ProbabilitySimplex).
The formula reads ``(p_1^2, p_2^2, …, p_{N+1}^2)``. This is an isometry from the interior of
the positive orthant of a sphere to interior of the probability simplex.
"""
function amplitude_to_simplex(M::ProbabilitySimplex, p)
    return amplitude_to_simplex!(M, similar(p), p)
end

function amplitude_to_simplex!(::ProbabilitySimplex, q, p)
    q .= p .^ 2
    return q
end

@doc raw"""
    simplex_to_amplitude_diff(M::ProbabilitySimplex, p, X)

Compute differential of [`simplex_to_amplitude`](@ref Manifolds.simplex_to_amplitude) of a point on `p` one
[`ProbabilitySimplex`](@ref) at tangent vector `X` from the tangent space at `p` from
a sphere.
"""
function simplex_to_amplitude_diff(M::ProbabilitySimplex, p, X)
    return simplex_to_amplitude_diff!(M, similar(X), p, X)
end

function simplex_to_amplitude_diff!(::ProbabilitySimplex, Y, p, X)
    Y .= X ./ sqrt.(p)
    return Y
end

@doc raw"""
    amplitude_to_simplex_diff(M::ProbabilitySimplex, p, X)

Compute differential of [`amplitude_to_simplex`](@ref Manifolds.amplitude_to_simplex) of a point `p` on
[`ProbabilitySimplex`](@ref) at tangent vector `X` from the tangent space at `p` from
a sphere.
"""
function amplitude_to_simplex_diff(M::ProbabilitySimplex, p, X)
    return amplitude_to_simplex_diff!(M, similar(X), p, X)
end

function amplitude_to_simplex_diff!(::ProbabilitySimplex, Y, p, X)
    Y .= p .* X
    return Y
end

function adjoint_Jacobi_field(
        M::ProductManifold,
        p::ArrayPartition,
        q::ArrayPartition,
        t,
        X::ArrayPartition,
        β::Tβ,
    ) where {Tβ}
    return ArrayPartition(
        map(
            adjoint_Jacobi_field,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
            ntuple(_ -> t, length(M.manifolds)),
            submanifold_components(M, X),
            ntuple(_ -> β, length(M.manifolds)),
        )...,
    )
end

function jacobi_field(
        M::ProductManifold,
        p::ArrayPartition,
        q::ArrayPartition,
        t,
        X::ArrayPartition,
        β::Tβ,
    ) where {Tβ}
    return ArrayPartition(
        map(
            jacobi_field,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
            ntuple(_ -> t, length(M.manifolds)),
            submanifold_components(M, X),
            ntuple(_ -> β, length(M.manifolds)),
        )...,
    )
end

function riemannian_gradient(M::ProductManifold, p::ArrayPartition, X::ArrayPartition)
    return ArrayPartition(
        map(
            riemannian_gradient,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
        ),
    )
end

# TODO: Remove as soon as all manifolds moved to the new test suite.
using Manifolds
using ManifoldsBase
using ManifoldsBase: number_of_coordinates, TypeParameter

using ManifoldDiff

using LinearAlgebra
using Distributions
using DoubleFloats
using Quaternions
using Random
using StaticArrays
using RecursiveArrayTools
using Statistics
using StatsBase
using Test
using Graphs
using SimpleWeightedGraphs

"""
    AbstractProjectiveSpace{𝔽} <: AbstractDecoratorManifold{𝔽}

An abstract type to represent a projective space over `𝔽` that is represented isometrically
in the embedding.
"""
abstract type AbstractProjectiveSpace{𝔽} <: AbstractDecoratorManifold{𝔽} end

@doc raw"""
    ProjectiveSpace{𝔽, n} <: AbstractProjectiveSpace{𝔽}

The projective space ``𝔽ℙ^n`` is the manifold of all lines in ``𝔽^{n+1}``.
The default representation is in the embedding, i.e. as unit norm vectors in
``𝔽^{n+1}``:
````math
𝔽ℙ^n := \bigl\{ [p] ⊂ 𝔽^{n+1} \ \big|\ \lVert p \rVert = 1, λ ∈ 𝔽, |λ| = 1, p ∼ p λ \bigr\},
````
where ``[p]`` is an equivalence class of points ``p``, and ``∼`` indicates equivalence.
For example, the real projective space ``ℝℙ^n`` is represented as the unit sphere ``𝕊^n``, where
antipodal points are considered equivalent.

The tangent space at point ``p`` is given by

````math
T_p 𝔽ℙ^{n} := \bigl\{ X ∈ 𝔽^{n+1}\ \big|\ ⟨p,X⟩ = 0 \bigr \},
````
where ``⟨⋅,⋅⟩`` denotes the inner product in the embedding ``𝔽^{n+1}``.

When ``𝔽 = ℍ``, this implementation of ``ℍℙ^n`` is the right-quaternionic projective
space.

# Constructor

    ProjectiveSpace(n[, field=ℝ])

Generate the projective space ``𝔽ℙ^{n} ⊂ 𝔽^{n+1}``, defaulting to the real projective space
``ℝℙ^n``, where `field` can also be used to generate the complex- and right-quaternionic
projective spaces.
"""
struct ProjectiveSpace{𝔽, T} <: AbstractProjectiveSpace{𝔽}
    size::T
end
function ProjectiveSpace(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return ProjectiveSpace{field, typeof(size)}(size)
end

@doc raw"""
    ArrayProjectiveSpace{𝔽, T<:Tuple} <: AbstractProjectiveSpace{𝔽}

The projective space ``𝔽ℙ^{n₁,n₂,…,nᵢ}`` is the manifold of all lines in ``𝔽^{n₁,n₂,…,nᵢ}``.
The default representation is in the embedding, i.e. as unit (Frobenius) norm matrices in
``𝔽^{n₁,n₂,…,nᵢ}``:

````math
𝔽ℙ^{n_1, n_2, …, n_i} := \bigl\{ [p] ⊂ 𝔽^{n_1, n_2, …, n_i} \ \big|\ \lVert p \rVert_{\mathrm{F}} = 1, λ ∈ 𝔽, |λ| = 1, p ∼ p λ \bigr\}.
````
where ``[p]`` is an equivalence class of points ``p``, ``∼`` indicates equivalence, and
``\lVert ⋅ \rVert_{\mathrm{F}}`` is the Frobenius norm.
Note that unlike [`ProjectiveSpace`](@ref), the argument for `ArrayProjectiveSpace`
is given by the size of the embedding.
This means that [`ProjectiveSpace(2)`](@ref) and `ArrayProjectiveSpace(3)` are the same
manifold.
Additionally, `ArrayProjectiveSpace(n,1;field=𝔽)` and [`Grassmann(n,1;field=𝔽)`](@ref) are
the same.

The tangent space at point ``p`` is given by

````math
T_p 𝔽ℙ^{n_1, n_2, …, n_i} := \bigl\{ X ∈ 𝔽^{n_1, n_2, …, n_i}\ |\ ⟨p,X⟩_{\mathrm{F}} = 0 \bigr \},
````

where ``⟨⋅,⋅⟩_{\mathrm{F}}`` denotes the (Frobenius) inner product in the embedding
``𝔽^{n_1, n_2, …, n_i}``.

# Constructor

    ArrayProjectiveSpace(n₁,n₂,...,nᵢ; field=ℝ)

Generate the projective space ``𝔽ℙ^{n_1, n_2, …, n_i}``, defaulting to the real projective
space, where `field` can also be used to generate the complex- and right-quaternionic
projective spaces.
"""
struct ArrayProjectiveSpace{𝔽, T} <: AbstractProjectiveSpace{𝔽}
    size::T
end
function ArrayProjectiveSpace(
        n::Vararg{Int, I};
        field::AbstractNumbers = ℝ,
        parameter::Symbol = :type,
    ) where {I}
    size = wrap_type_parameter(parameter, n)
    return ArrayProjectiveSpace{field, typeof(size)}(size)
end

function allocation_promotion_function(::AbstractProjectiveSpace{ℂ}, f, args::Tuple)
    return complex
end

@doc raw"""
    check_point(M::AbstractProjectiveSpace, p; kwargs...)

Check whether `p` is a valid point on the [`AbstractProjectiveSpace`](@ref) `M`, i.e.
that it has the same size as elements of the embedding and has unit Frobenius norm.
The tolerance for the norm check can be set using the `kwargs...`.
"""
function check_point(M::AbstractProjectiveSpace, p; kwargs...)
    if !isapprox(norm(p), 1; kwargs...)
        return DomainError(
            norm(p),
            "The point $(p) does not lie on the $(M) since its norm is not 1.",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::AbstractProjectiveSpace, p, X; kwargs... )

Check whether `X` is a tangent vector in the tangent space of `p` on the
[`AbstractProjectiveSpace`](@ref) `M`, i.e. that `X` has the same size as elements of the
tangent space of the embedding and that the Frobenius inner product
``⟨p, X⟩_{\mathrm{F}} = 0``.
"""
function check_vector(
        M::AbstractProjectiveSpace,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    if !isapprox(dot(p, X), 0; atol = atol, kwargs...)
        return DomainError(
            dot(p, X),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not" *
                " orthogonal in the embedding.",
        )
    end
    return nothing
end

function decorated_manifold(M::AbstractProjectiveSpace{𝔽}) where {𝔽}
    return Euclidean(representation_size(M)...; field = 𝔽)
end
function decorated_manifold(M::ProjectiveSpace{𝔽, <:Tuple}) where {𝔽}
    return Euclidean(representation_size(M)...; field = 𝔽, parameter = :field)
end

get_embedding(M::AbstractProjectiveSpace) = decorated_manifold(M)

function ManifoldsBase.get_embedding_type(::AbstractProjectiveSpace)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

embed(::AbstractProjectiveSpace, p) = p
embed(::AbstractProjectiveSpace, p, X) = X

@doc raw"""
    distance(M::AbstractProjectiveSpace, p, q)

Compute the Riemannian distance on [`AbstractProjectiveSpace`](@ref) `M```=𝔽ℙ^n`` between
points `p` and `q`, i.e.
````math
d_{𝔽ℙ^n}(p, q) = \arccos\bigl| ⟨p, q⟩_{\mathrm{F}} \bigr|.
````

Note that this definition is similar to that of the [`AbstractSphere`](@ref).
However, the absolute value ensures that all equivalent `p` and `q` have the same pairwise
distance.
"""
function distance(::AbstractProjectiveSpace, p, q)
    z = dot(p, q)
    cosθ = abs(z)
    T = float(real(Base.promote_eltype(p, q)))
    # abs and relative error of acos is less than sqrt(eps(T))
    cosθ < 1 - sqrt(eps(T)) / 8 && return acos(cosθ)
    # improved accuracy for q close to p or -p
    λ = sign(z)
    return 2 * abs(atan(norm(p .* λ .- q), norm(p .* λ .+ q)))
end

function exp!(M::AbstractProjectiveSpace, q, p, X)
    θ = norm(M, p, X)
    q .= cos(θ) .* p .+ usinc(θ) .* X
    return q
end

function get_basis(M::ProjectiveSpace{ℝ}, p, B::DiagonalizingOrthonormalBasis{ℝ})
    n = get_parameter(M.size)[1]
    return get_basis(Sphere(n), p, B)
end

@doc raw"""
    get_coordinates(M::AbstractProjectiveSpace, p, X, B::DefaultOrthonormalBasis{ℝ})

Represent the tangent vector ``X`` at point ``p`` from the [`AbstractProjectiveSpace`](@ref)
``M = 𝔽ℙ^n`` in an orthonormal basis by unitarily transforming the hyperplane containing ``X``,
whose normal is ``p``, to the hyperplane whose normal is the ``x``-axis.

Given ``q = p \overline{λ} + x``, where
``λ = \frac{⟨x, p⟩_{\mathrm{F}}}{|⟨x, p⟩_{\mathrm{F}}|}``, ``⟨⋅, ⋅⟩_{\mathrm{F}}`` denotes the
Frobenius inner product, and ``\overline{⋅}`` denotes complex or quaternionic conjugation, the
formula for ``Y`` is
````math
\begin{pmatrix}0 \\ Y\end{pmatrix} = \left(X - q\frac{2 ⟨q, X⟩_{\mathrm{F}}}{⟨q, q⟩_{\mathrm{F}}}\right)\overline{λ}.
````
"""
get_coordinates(::AbstractProjectiveSpace{ℝ}, p, X, ::DefaultOrthonormalBasis)

function _gc_impl!(c, p, X, n::Int)
    z = p[1]
    cosθ = abs(z)
    λ = nzsign(z, cosθ)
    pend, Xend = view(p, 2:(n + 1)), view(X, 2:(n + 1))
    factor = λ' * X[1] / (1 + cosθ)
    c .= (Xend .- pend .* factor) .* λ'
    return c
end
function get_coordinates_orthonormal!(M::AbstractProjectiveSpace{ℝ}, c, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    return _gc_impl!(c, p, X, n)
end
function get_coordinates_orthonormal!(
        M::AbstractProjectiveSpace{ℂ},
        c,
        p,
        X,
        ::ComplexNumbers,
    )
    n = div(manifold_dimension(M), 2)
    return _gc_impl!(c, p, X, n)
end
function get_coordinates_orthonormal!(
        M::AbstractProjectiveSpace{ℍ},
        c,
        p,
        X,
        ::QuaternionNumbers,
    )
    n = div(manifold_dimension(M), 4)
    return _gc_impl!(c, p, X, n)
end

@doc raw"""
    get_vector(M::AbstractProjectiveSpace, p, X, B::DefaultOrthonormalBasis{ℝ})

Convert a one-dimensional vector of coefficients ``X`` in the basis `B` of the tangent space
at ``p`` on the [`AbstractProjectiveSpace`](@ref) ``M=𝔽ℙ^n`` to a tangent vector ``Y`` at ``p`` by
unitarily transforming the hyperplane containing ``X``, whose normal is the ``x``-axis, to the
hyperplane whose normal is ``p``.

Given ``q = p \overline{λ} + x``, where
``λ = \frac{⟨x, p⟩_{\mathrm{F}}}{|⟨x, p⟩_{\mathrm{F}}|}``, ``⟨⋅, ⋅⟩_{\mathrm{F}}`` denotes the
Frobenius inner product, and ``\overline{⋅}`` denotes complex or quaternionic conjugation, the
formula for ``Y`` is
````math
Y = \left(X - q\frac{2 \left\langle q, \begin{pmatrix}0 \\ X\end{pmatrix}\right\rangle_{\mathrm{F}}}{⟨q, q⟩_{\mathrm{F}}}\right) λ.
````
"""
get_vector(::AbstractProjectiveSpace, p, X, ::DefaultOrthonormalBasis{ℝ})

function _gv_impl!(Y, p, X, n::Int)
    z = p[1]
    cosθ = abs(z)
    λ = nzsign(z, cosθ)
    pend = view(p, 2:(n + 1))
    pX = dot(pend, X)
    Y[1] = -λ * pX * λ
    Y[2:(n + 1)] .= (X .- pend .* (pX / (1 + cosθ))) .* λ
    return Y
end
function get_vector_orthonormal!(M::AbstractProjectiveSpace{ℝ}, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    return _gv_impl!(Y, p, X, n)
end
function get_vector_orthonormal!(M::AbstractProjectiveSpace{ℂ}, Y, p, X, ::ComplexNumbers)
    n = div(manifold_dimension(M), 2)
    return _gv_impl!(Y, p, X, n)
end
function get_vector_orthonormal!(
        M::AbstractProjectiveSpace{ℍ},
        Y,
        p,
        X,
        ::QuaternionNumbers,
    )
    n = div(manifold_dimension(M), 4)
    return _gv_impl!(Y, p, X, n)
end

injectivity_radius(::AbstractProjectiveSpace) = π / 2
injectivity_radius(::AbstractProjectiveSpace, p) = π / 2
injectivity_radius(::AbstractProjectiveSpace, ::AbstractRetractionMethod) = π / 2
injectivity_radius(::AbstractProjectiveSpace, p, ::AbstractRetractionMethod) = π / 2

@doc raw"""
    inverse_retract(M::AbstractProjectiveSpace, p, q, method::ProjectionInverseRetraction)
    inverse_retract(M::AbstractProjectiveSpace, p, q, method::PolarInverseRetraction)
    inverse_retract(M::AbstractProjectiveSpace, p, q, method::QRInverseRetraction)

Compute the equivalent inverse retraction [`ProjectionInverseRetraction`](@extref `ManifoldsBase.ProjectionInverseRetraction`),
[`PolarInverseRetraction`](@extref `ManifoldsBase.QRInverseRetraction`) on the
[`AbstractProjectiveSpace`](@ref) manifold `M```=𝔽ℙ^n``, i.e.
````math
\operatorname{retr}_p^{-1} q = q \frac{1}{⟨p, q⟩_{\mathrm{F}}} - p,
````
where ``⟨⋅, ⋅⟩_{\mathrm{F}}`` is the Frobenius inner product.

Note that this inverse retraction is equivalent to the three corresponding inverse
retractions on [`Grassmann(n+1,1,𝔽)`](@ref), where the three inverse retractions in this
case coincide.
For ``ℝℙ^n``, it is the same as the `ProjectionInverseRetraction` on the real
[`Sphere`](@ref).
"""
inverse_retract(
    ::AbstractProjectiveSpace,
    p,
    q,
    ::Union{ProjectionInverseRetraction, PolarInverseRetraction, QRInverseRetraction},
)

function inverse_retract_qr!(::AbstractProjectiveSpace, X, p, q)
    X .= q ./ dot(p, q) .- p
    return X
end
function inverse_retract_polar!(::AbstractProjectiveSpace, X, p, q)
    X .= q ./ dot(p, q) .- p
    return X
end
function inverse_retract_project!(::AbstractProjectiveSpace, X, p, q)
    X .= q ./ dot(p, q) .- p
    return X
end

@doc raw"""
    isapprox(M::AbstractProjectiveSpace, p, q; kwargs...)

Check that points `p` and `q` on the [`AbstractProjectiveSpace`](@ref) `M```=𝔽ℙ^n`` are
members of the same equivalence class, i.e. that ``p = q λ`` for some element ``λ ∈ 𝔽`` with
unit absolute value, that is, ``|λ| = 1``.
This is equivalent to the Riemannian
[`distance`](@ref distance(::AbstractProjectiveSpace, p, q)) being 0.
"""
function _isapprox(::AbstractProjectiveSpace, p, q; kwargs...)
    return isapprox(abs(dot(p, q)), 1; kwargs...)
end

"""
    is_flat(M::AbstractProjectiveSpace)

Return true if [`AbstractProjectiveSpace`](@ref) is of dimension 1 and false otherwise.
"""
is_flat(M::AbstractProjectiveSpace) = manifold_dimension(M) == 1

@doc raw"""
    log(M::AbstractProjectiveSpace, p, q)

Compute the logarithmic map on [`AbstractProjectiveSpace`](@ref) `M``` = 𝔽ℙ^n``,
i.e. the tangent vector whose corresponding [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) starting from `p`
reaches `q` after time 1 on `M`. The formula reads

````math
\log_p q = (q λ - \cos θ p) \frac{θ}{\sin θ},
````
where ``θ = \arccos|⟨q, p⟩_{\mathrm{F}}|`` is the
[`distance`](@ref distance(::AbstractProjectiveSpace, p, q)) between ``p`` and ``q``,
``⟨⋅, ⋅⟩_{\mathrm{F}}`` is the Frobenius inner product, and
``λ = \frac{⟨q, p⟩_{\mathrm{F}}}{|⟨q, p⟩_{\mathrm{F}}|} ∈ 𝔽`` is the unit scalar that
minimizes ``d_{𝔽^{n+1}}(p - q λ)``.
That is, ``q λ`` is the member of the equivalence class ``[q]`` that is closest to ``p`` in the
embedding.
As a result, ``\exp_p \circ \log_p \colon q ↦ q λ``.

The logarithmic maps for the real [`AbstractSphere`](@ref) ``𝕊^n`` and the real projective
space ``ℝℙ^n`` are identical when ``p`` and ``q`` are in the same hemisphere.
"""
log(::AbstractProjectiveSpace, p, q)

function log!(M::AbstractProjectiveSpace, X, p, q)
    z = dot(q, p)
    cosθ = abs(z)
    λ = nzsign(z, cosθ)
    X .= (q .* λ .- cosθ .* p) ./ usinc_from_cos(cosθ)
    return project!(M, X, p, X)
end

@doc raw"""
    manifold_dimension(M::AbstractProjectiveSpace{𝔽}) where {𝔽}

Return the real dimension of the [`AbstractProjectiveSpace`](@ref) `M`, respectively i.e.
the real dimension of the embedding minus the real dimension of the field `𝔽`.
"""
function manifold_dimension(M::AbstractProjectiveSpace{𝔽}) where {𝔽}
    return manifold_dimension(get_embedding(M)) - real_dimension(𝔽)
end

@doc raw"""
    manifold_volume(M::AbstractProjectiveSpace{ℝ})

Volume of the ``n``-dimensional [`AbstractProjectiveSpace`](@ref) `M`. The formula reads:

````math
\frac{\pi^{(n+1)/2}}{Γ((n+1)/2)},
````

where ``Γ`` denotes the [Gamma function](https://en.wikipedia.org/wiki/Gamma_function).
For details see [BoyaSudarshanTilma:2003](@cite).
"""
function manifold_volume(M::AbstractProjectiveSpace{ℝ})
    n = manifold_dimension(M) + 1
    return pi^(n / 2) / gamma(n / 2)
end

"""
    mean(
        M::AbstractProjectiveSpace,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolationWithinRadius(π/4);
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of points in vector `x`
using [`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).
"""
mean(::AbstractProjectiveSpace, ::Any...)

function default_approximation_method(::AbstractProjectiveSpace, ::typeof(mean))
    return GeodesicInterpolationWithinRadius(π / 4)
end

function mid_point!(M::ProjectiveSpace, q, p1, p2)
    z = dot(p2, p1)
    λ = nzsign(z)
    q .= p1 .+ p2 .* λ
    project!(M, q, q)
    return q
end

@doc raw"""
    project(M::AbstractProjectiveSpace, p)

Orthogonally project the point `p` from the embedding onto the
[`AbstractProjectiveSpace`](@ref) `M`:
````math
\operatorname{proj}(p) = \frac{p}{\lVert p \rVert}_{\mathrm{F}},
````
where ``\lVert ⋅ \rVert_{\mathrm{F}}`` denotes the Frobenius norm.
This is identical to projection onto the [`AbstractSphere`](@ref).
"""
project(::AbstractProjectiveSpace, ::Any)

project!(::AbstractProjectiveSpace, q, p) = (q .= p ./ norm(p))

@doc raw"""
    project(M::AbstractProjectiveSpace, p, X)

Orthogonally project the point `X` onto the tangent space at `p` on the
[`AbstractProjectiveSpace`](@ref) `M`:

````math
\operatorname{proj}_p (X) = X - p⟨p, X⟩_{\mathrm{F}},
````
where ``⟨⋅, ⋅⟩_{\mathrm{F}}`` denotes the Frobenius inner product.
For the real [`AbstractSphere`](@ref) and `AbstractProjectiveSpace`, this projection is the
same.
"""
project(::AbstractProjectiveSpace, ::Any, ::Any)

project!(::AbstractProjectiveSpace, Y, p, X) = (Y .= X .- p .* dot(p, X))

@doc raw"""
    representation_size(M::AbstractProjectiveSpace)

Return the size points on the [`AbstractProjectiveSpace`](@ref) `M` are represented as,
i.e., the representation size of the embedding.
"""
function representation_size(M::ArrayProjectiveSpace)
    return get_parameter(M.size)
end
function representation_size(M::ProjectiveSpace)
    n = get_parameter(M.size)[1]
    return (n + 1,)
end

@doc raw"""
    retract(M::AbstractProjectiveSpace, p, X, method::ProjectionRetraction)
    retract(M::AbstractProjectiveSpace, p, X, method::PolarRetraction)
    retract(M::AbstractProjectiveSpace, p, X, method::QRRetraction)

Compute the equivalent retraction [`ProjectionRetraction`](@extref `ManifoldsBase.PolarRetraction`),
and [`QRRetraction`](@extref `ManifoldsBase.QRRetraction`) on the [`AbstractProjectiveSpace`](@ref) manifold `M```=𝔽ℙ^n``,
i.e.
````math
\operatorname{retr}_p X = \operatorname{proj}_p(p + X).
````

Note that this retraction is equivalent to the three corresponding retractions on
[`Grassmann(n+1,1,𝔽)`](@ref), where in this case they coincide.
For ``ℝℙ^n``, it is the same as the `ProjectionRetraction` on the real [`Sphere`](@ref).
"""
retract(
    ::AbstractProjectiveSpace,
    p,
    X,
    ::Union{ProjectionRetraction, PolarRetraction, QRRetraction},
)

function ManifoldsBase.retract_polar!(M::AbstractProjectiveSpace, q, p, X)
    q .= p .+ X
    return project!(M, q, q)
end
function ManifoldsBase.retract_polar_fused!(M::AbstractProjectiveSpace, q, p, X, t::Number)
    q .= p .+ t .* X
    return project!(M, q, q)
end

function ManifoldsBase.retract_project!(M::AbstractProjectiveSpace, q, p, X)
    q .= p .+ X
    return project!(M, q, q)
end

function ManifoldsBase.retract_project_fused!(
        M::AbstractProjectiveSpace,
        q,
        p,
        X,
        t::Number,
    )
    q .= p .+ t .* X
    return project!(M, q, q)
end

function ManifoldsBase.retract_qr!(M::AbstractProjectiveSpace, q, p, X)
    q .= p .+ X
    return project!(M, q, q)
end
function ManifoldsBase.retract_qr_fused!(M::AbstractProjectiveSpace, q, p, X, t::Number)
    q .= p .+ t .* X
    return project!(M, q, q)
end

function Base.show(io::IO, ::ProjectiveSpace{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "ProjectiveSpace($(n), $(𝔽))")
end
function Base.show(io::IO, M::ProjectiveSpace{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "ProjectiveSpace($(n), $(𝔽); parameter=:field)")
end
function Base.show(io::IO, ::ArrayProjectiveSpace{𝔽, TypeParameter{tn}}) where {tn <: Tuple, 𝔽}
    return print(io, "ArrayProjectiveSpace($(join(tn.parameters, ", ")); field=$(𝔽))")
end
function Base.show(io::IO, M::ArrayProjectiveSpace{𝔽, <:Tuple}) where {𝔽}
    n = M.size
    return print(io, "ArrayProjectiveSpace($(join(n, ", ")); field=$(𝔽), parameter=:field)")
end

@doc raw"""
    parallel_transport_to(M::AbstractProjectiveSpace, p, X, q)

Parallel transport a vector `X` from the tangent space at a point `p` on the
[`AbstractProjectiveSpace`](@ref) `M```=𝔽ℙ^n`` to the tangent space at another point `q`.

This implementation proceeds by transporting ``X`` to ``T_{q λ} M`` using the same approach as
[`parallel_transport_direction`](@ref parallel_transport_direction(::AbstractProjectiveSpace, p, X, d)),
where ``λ = \frac{⟨q, p⟩_{\mathrm{F}}}{|⟨q, p⟩_{\mathrm{F}}|} ∈ 𝔽`` is the unit scalar that
takes ``q`` to the member ``q λ`` of its equivalence class ``[q]`` closest to ``p`` in the
embedding.
It then maps the transported vector from ``T_{q λ} M`` to ``T_{q} M``.
The resulting transport to ``T_{q} M`` is
````math
\mathcal{P}_{q ← p}(X) = \left(X - \left(p \frac{\sin θ}{θ} + d \frac{1 - \cos θ}{θ^2}\right) ⟨d, X⟩_p\right) \overline{λ},
````
where ``d = \log_p q`` is the direction of the transport, ``θ = \lVert d \rVert_p`` is the
[`distance`](@ref distance(::AbstractProjectiveSpace, p, q)) between ``p`` and ``q``, and
``\overline{⋅}`` denotes complex or quaternionic conjugation.
"""
parallel_transport_to(::AbstractProjectiveSpace, ::Any, ::Any, ::Any)

function parallel_transport_to!(::AbstractProjectiveSpace, Y, p, X, q)
    z = dot(q, p)
    λ = nzsign(z)
    m = p .+ q .* λ # un-normalized midpoint
    mnorm2 = real(dot(m, m))
    factor = λ' * dot(q, X) * (2 / mnorm2) # λ' * dot(q, X) ≡ dot(q * λ, X)
    # multiply by λ' to bring from T_{\exp_p(\log_p q)} M to T_q M
    # this ensures that subsequent functions like `exp(M, q, Y)` do the right thing
    Y .= (X .- m .* factor) .* λ'
    return Y
end
function vector_transport_to_project!(M::AbstractProjectiveSpace, Y, p, X, q)
    project!(M, Y, q, X)
    return Y
end

@doc raw"""
    parallel_transport_direction(M::AbstractProjectiveSpace, p, X, d)

Parallel transport a vector `X` from the tangent space at a point `p` on the
[`AbstractProjectiveSpace`](@ref) `M` along the [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) in the direction
indicated by the tangent vector `d`, i.e.

````math
\mathcal{P}_{\exp_p (d) ← p}(X) = X - \left(p \frac{\sin θ}{θ} + d \frac{1 - \cos θ}{θ^2}\right) ⟨d, X⟩_p,
````

where ``θ = \lVert d \rVert``, and ``⟨⋅, ⋅⟩_p`` is the [`inner`](@ref) product at the point ``p``.
For the real projective space, this is equivalent to the same vector transport on the real
[`AbstractSphere`](@ref).
"""
parallel_transport_direction(::AbstractProjectiveSpace, ::Any, ::Any, ::Any)

function parallel_transport_direction!(M::AbstractProjectiveSpace, Y, p, X, d)
    θ = norm(M, p, d)
    cosθ = cos(θ)
    dX = inner(M, p, d, X)
    α = usinc(θ) * dX
    β = ifelse(iszero(θ), zero(cosθ), (1 - cosθ) / θ^2) * dX
    Y .= X .- p .* α .- d .* β
    return Y
end

include("../header.jl")

using Quaternions

@testset "Orthogonal Matrices" begin
    M = OrthogonalMatrices(3)
    @test repr(M) == "OrthogonalMatrices(3)"
    @test repr(OrthogonalMatrices(3; parameter = :field)) ==
        "OrthogonalMatrices(3; parameter=:field)"
    @test injectivity_radius(M, PolarRetraction()) == π / sqrt(2.0)
    @test manifold_dimension(M) == 3
    @test injectivity_radius(M) == π * sqrt(2.0)
    @test injectivity_radius(OrthogonalMatrices(3; parameter = :field)) == π * sqrt(2.0)
    @test injectivity_radius(OrthogonalMatrices(1; parameter = :field)) == 0.0
    @test !is_flat(M)
    p = project(M, ones(3, 3))
    @test is_point(M, p; error = :error)
    @test is_point(M, rand(M); error = :error)
    @test abs(rand(OrthogonalMatrices(1))[]) == 1
    @test is_vector(M, p, rand(M; vector_at = p))
    @test is_point(M, rand(MersenneTwister(), M); error = :error)
    @test abs(rand(MersenneTwister(), OrthogonalMatrices(1))[]) == 1
    @test is_vector(M, p, rand(MersenneTwister(), M; vector_at = p))
    @test default_vector_transport_method(M) === ProjectionTransport()

    @test get_embedding(M) === Euclidean(3, 3)
    @test get_embedding(OrthogonalMatrices(3; parameter = :field)) === Euclidean(3, 3; parameter = :field)

    @test manifold_volume(OrthogonalMatrices(1)) ≈ 2
    @test manifold_volume(OrthogonalMatrices(2)) ≈ 4 * π * sqrt(2)
    @test manifold_volume(OrthogonalMatrices(3)) ≈ 16 * π^2 * sqrt(2)
    @test manifold_volume(OrthogonalMatrices(4)) ≈ 2 * (2 * π)^4 * sqrt(2)
    @test manifold_volume(OrthogonalMatrices(5)) ≈ 8 * (2 * π)^6 / 6 * sqrt(2)
end

@testset "Unitary Matrices" begin
    M = UnitaryMatrices(2)
    @test repr(M) == "UnitaryMatrices(2)"
    @test repr(UnitaryMatrices(2; parameter = :field)) ==
        "UnitaryMatrices(2; parameter=:field)"
    @test manifold_dimension(M) == 4
    @test !is_flat(M)
    @test injectivity_radius(M) == π

    # wrong length of size
    @test_throws DomainError is_point(M, zeros(1); error = :error)
    @test_throws DomainError is_point(M, zeros(3, 3); error = :error)
    pF = 1 / 2 .* [1im 1im; -1im 1im]
    @test_throws DomainError is_point(M, pF; error = :error)
    # Determinant not one
    pF2 = [1im 1.0; 0.0 -1im]
    @test_throws DomainError is_point(M, pF2; error = :error)
    p = [1im 0.0; 0.0 1im]
    @test is_point(M, p; error = :error)

    @test_throws DomainError is_vector(M, p, zeros(1); error = :error)
    @test_throws DomainError is_vector(M, p, zeros(3, 3); error = :error)
    # not skew
    @test_throws DomainError is_vector(M, p, ones(2, 2); error = :error)
    X = [0.0 1.0; -1.0 0.0]
    @test is_vector(M, p, X; error = :error)

    q = project(M, ones(2, 2))
    @test is_point(M, q; error = :error)
    q2 = project(M, 1im * ones(2, 2))
    @test is_point(M, q2; error = :error)

    r = exp(M, p, X)
    X2 = log(M, p, r)
    @test isapprox(M, p, X, X2)
    r1 = Manifolds.exp_fused(M, p, X, 1.0)
    @test isapprox(M, r, r1; atol = 1.0e-10)

    @testset "Projection" begin
        M = UnitaryMatrices(2)
        pE = [2im 0.0; 0.0 2im]
        p = project(M, pE)
        @test is_point(M, p; error = :error)
        pE[2, 1] = 1.0
        X = project(M, p, pE)
        @test is_vector(M, p, X; error = :error)
    end
    @testset "Random" begin
        M = UnitaryMatrices(2)
        Random.seed!(23)
        p = rand(M)
        @test is_point(M, p; error = :error)
        @test is_vector(M, p, rand(M; vector_at = p); error = :error)
    end
    @testset "Riemannian Hessian" begin
        p = Matrix{Float64}(I, 2, 2)
        X = [0.0 3.0; -3.0 0.0]
        V = [1.0 0.0; 1.0 0.0]
        @test Weingarten(M, p, X, V) == -1 / 2 * p * (V' * X - X' * V)
        G = [0.0 1.0; 0.0 0.0]
        H = [0.0 0.0; 2.0 0.0]
        @test riemannian_Hessian(M, p, G, H, X) == [0.0 -1.0; 1.0 0.0]
    end
    @test !is_flat(M)
    @test is_flat(UnitaryMatrices(1))
    @test is_flat(UnitaryMatrices(1; parameter = :field))

    @testset "manifold_volume" begin
        @test manifold_volume(UnitaryMatrices(1)) ≈ 2 * π
        @test manifold_volume(UnitaryMatrices(2)) ≈ 4 * π^3
        @test manifold_volume(UnitaryMatrices(3)) ≈ sqrt(3) * 2 * π^6
        @test manifold_volume(UnitaryMatrices(4)) ≈ sqrt(2) * 8 * π^10 / 12
    end
end

@testset "Special unitary matrices" begin
    @test manifold_volume(SpecialUnitaryMatrices(1)) ≈ 1
    @test manifold_volume(SpecialUnitaryMatrices(2)) ≈ 2 * π^2
    @test manifold_volume(SpecialUnitaryMatrices(3)) ≈ sqrt(3) * π^5
    @test manifold_volume(SpecialUnitaryMatrices(4)) ≈ sqrt(2) * 4 * π^9 / 12

    @test manifold_dimension(SpecialUnitaryMatrices(2)) == 3
    @test manifold_dimension(SpecialUnitaryMatrices(3)) == 8
    @test manifold_dimension(SpecialUnitaryMatrices(4)) == 15

    @test injectivity_radius(SpecialUnitaryMatrices(2)) == π * sqrt(2)
    @test injectivity_radius(SpecialUnitaryMatrices(3)) == π * sqrt(2)
    @test injectivity_radius(SpecialUnitaryMatrices(4)) == π * sqrt(2)
end

@testset "Quaternionic Unitary Matrices" begin
    M = UnitaryMatrices(1, ℍ)
    @test repr(M) == "UnitaryMatrices(1, ℍ)"
    @test repr(UnitaryMatrices(1, ℍ; parameter = :field)) ==
        "UnitaryMatrices(1, ℍ; parameter=:field)"
    @test manifold_dimension(M) == 3
    @test injectivity_radius(M) == π
    @test !is_flat(M)
    @testset "rand" begin
        p = rand(M)
        @test is_point(M, p)
        X = rand(M; vector_at = p)
        @test is_vector(M, p, X)
        p = rand(MersenneTwister(), M)
        @test is_point(M, p)
        X = rand(MersenneTwister(), M; vector_at = p)
        @test is_vector(M, p, X)
    end
    @testset "Exp/Log and issapprox" begin
        p = QuaternionF64(1.0, 0.0, 0.0, 0.0)
        X = QuaternionF64(0.1, 0.2, 0.2, 0.3)
        q = exp(M, p, X)
        q2 = Manifolds.exp_fused(M, p, X, 1.0)
        @test isapprox(M, q, q2)
        X2 = log(M, p, q)
        @test isapprox(M, p, X, X2)
    end

    # wrong length of size
    @test_throws DomainError is_point(M, zeros(2, 2); error = :error)

    # Determinant not one
    pF2 = [quat(0, 1, 0, 0) 1.0; 0.0 -quat(0, 1, 0, 0)]
    @test_throws DomainError is_point(M, pF2; error = :error)
    p = QuaternionF64(
        0.4815296357756736,
        0.6041613272484806,
        -0.2322369798903669,
        0.5909181717450419,
    )

    @test is_point(M, fill(p, 1, 1))
    @test is_point(M, p)

    @test_throws DomainError is_vector(M, p, zeros(2, 2); error = :error)
    # not skew
    @test_throws DomainError is_vector(M, p, Quaternion(1, 0, 0, 0); error = :error)
    X = Quaternion(0.0, 0, 0, 1)
    @test is_vector(M, p, X)

    pu = QuaternionF64(
        -0.2178344173900564,
        -0.4072721993877449,
        -2.2484219560115712,
        -0.4718862793239344,
    )
    q = project(M, pu)
    @test is_point(M, q)
    @test isapprox(q, sign(pu))

    @test get_coordinates(M, p, Quaternion(0, 1, 2, 3), DefaultOrthonormalBasis(ℝ)) ==
        SA[1, 2, 3]
    @test get_vector(M, p, SA[1, 2, 3], DefaultOrthonormalBasis(ℝ)) ==
        Quaternion(0, 1, 2, 3)
    @test number_of_coordinates(M, DefaultOrthonormalBasis(ℍ)) == 3

    @test get_basis(M, p, DefaultOrthonormalBasis(ℝ)).data == [
        Quaternion(0.0, 1.0, 0.0, 0.0),
        Quaternion(0.0, 0.0, 1.0, 0.0),
        Quaternion(0.0, 0.0, 0.0, 1.0),
    ]
end

@testset "SO(4) and O(4) exp/log edge cases" begin
    Xs = [
        [0, 0, π, 0, 0, π],  # θ = (π, π)
        [0, 0, π, 0, 0, 0],  # θ = (π, 0)
        [0, 0, π / 2, 0, 0, π],  # θ = (π, π/2)
        [0, 0, π, 0, 0, 0] ./ 2,  # θ = (π/2, 0)
        [0, 0, π, 0, 0, π] ./ 2,  # θ = (π/2, π/2)
        [0, 0, 0, 0, 0, 0],  # θ = (0, 0)
        [0, 0, 1, 0, 0, 1] .* 1.0e-100, # α = β ≈ 0
        [0, 0, 1, 0, 0, 1] .* 1.0e-6, # α = β ⩰ 0
        [0, 0, 10, 0, 0, 1] .* 1.0e-6, # α ⪆ β ⩰ 0
        [0, 0, π / 4, 0, 0, π / 4 - 1.0e-6], # α ⪆ β > 0
    ]
    Ms = [Rotations(4), OrthogonalMatrices(4)]
    E = diagm(ones(4))
    for Xf in Xs
        for M in Ms
            @testset "for $Xf on $M" begin
                X = get_vector(M, E, Xf, DefaultOrthogonalBasis())
                p = exp(X)
                @test p ≈ exp(M, E, X)
                p3 = exp(M, E, log(M, E, p))
                # broken for 9 of the 10
                @test isapprox(M, p, p3; atol = 1.0e-4)
            end
        end
    end
    R1 = diagm([-1.0, -1.0, 1.0, 1.0])
    X1a = log(Rotations(4), E, R1)
    @test is_vector(Rotations(4), E, X1a)
    @test X1a[1, 2] ≈ π

    R2 = diagm([-1.0, 1.0, -1.0, 1.0])
    X2a = log(Rotations(4), E, R2)
    @test is_vector(Rotations(4), E, X2a)
    @test X2a[1, 3] ≈ π

    R3 = diagm([1.0, -1.0, -1.0, 1.0])
    X3a = log(Rotations(4), E, R3)
    @test is_vector(Rotations(4), E, X3a)
    @test X3a[2, 3] ≈ π
end

@doc raw"""
    FixedRankMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The manifold of ``m×n`` real-valued or complex-valued matrices of fixed rank ``k``, i.e.
````math
\bigl\{ p ∈ 𝔽^{m×n}\ \big|\ \operatorname{rank}(p) = k\bigr\},
````
where ``𝔽 ∈ \{ℝ,ℂ\}`` and the rank is the number of linearly independent columns of a matrix.

# Representation with 3 matrix factors

A point ``p ∈ \mathcal M`` can be stored using unitary matrices ``U ∈ 𝔽^{m×k}``, ``V ∈ 𝔽^{n×k}`` as well as the ``k``
singular values of ``p = U_p S V_p^\mathrm{H}``, where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or
Hermitian. In other words, ``U`` and ``V`` are from the manifolds [`Stiefel`](@ref)`(m,k,𝔽)` and [`Stiefel`](@ref)`(n,k,𝔽)`,
respectively; see [`SVDMPoint`](@ref) for details.

The tangent space ``T_p \mathcal M`` at a point ``p ∈ \mathcal M`` with ``p=U_p S V_p^\mathrm{H}``
is given by
````math
T_p\mathcal M = \bigl\{ U_p M V_p^\mathrm{H} + U_X V_p^\mathrm{H} + U_p V_X^\mathrm{H} :
    M  ∈ 𝔽^{k×k},
    U_X  ∈ 𝔽^{m×k},
    V_X  ∈ 𝔽^{n×k}
    \text{ s.t. }
    U_p^\mathrm{H}U_X = 0_k,
    V_p^\mathrm{H}V_X = 0_k
\bigr\},
````
where ``0_k`` is the ``k×k`` zero matrix. See [`UMVTangentVector`](@ref) for details.

The (default) metric of this manifold is obtained by restricting the metric
on ``ℝ^{m×n}`` to the tangent bundle [Vandereycken:2013](@cite).

# Constructor
    FixedRankMatrices(m, n, k[, field=ℝ])

Generate the manifold of `m`-by-`n` (`field`-valued) matrices of rank `k`.
"""
struct FixedRankMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function FixedRankMatrices(
        m::Int,
        n::Int,
        k::Int,
        field::AbstractNumbers = ℝ;
        parameter::Symbol = :type,
    )
    size = wrap_type_parameter(parameter, (m, n, k))
    return FixedRankMatrices{field, typeof(size)}(size)
end

@doc raw"""
    SVDMPoint <: AbstractManifoldPoint

A point on a certain manifold, where the data is stored in a svd like fashion,
i.e. in the form ``USV^\mathrm{H}``, where this structure stores ``U``, ``S`` and
``V^\mathrm{H}``. The storage might also be shortened to just ``k`` singular values
and accordingly shortened ``U`` (columns) and ``V^\mathrm{H}`` (rows).

# Constructors
* `SVDMPoint(A)` for a matrix `A`, stores its svd factors (i.e. implicitly ``k=\min\{m,n\}``)
* `SVDMPoint(S)` for an `SVD` object, stores its svd factors (i.e. implicitly ``k=\min\{m,n\}``)
* `SVDMPoint(U,S,Vt)` for the svd factors to initialize the `SVDMPoint`` (i.e. implicitly ``k=\min\{m,n\}``)
* `SVDMPoint(A,k)` for a matrix `A`, stores its svd factors shortened to the
  best rank ``k`` approximation
* `SVDMPoint(S,k)` for an `SVD` object, stores its svd factors shortened to the
  best rank ``k`` approximation
* `SVDMPoint(U,S,Vt,k)` for the svd factors to initialize the `SVDMPoint`,
  stores its svd factors shortened to the best rank ``k`` approximation
"""
struct SVDMPoint{TU <: AbstractMatrix, TS <: AbstractVector, TVt <: AbstractMatrix} <:
    AbstractManifoldPoint
    U::TU
    S::TS
    Vt::TVt
end
SVDMPoint(A::AbstractMatrix) = SVDMPoint(svd(A))
SVDMPoint(S::SVD) = SVDMPoint(S.U, S.S, S.Vt)
SVDMPoint(A::Matrix, k::Int) = SVDMPoint(svd(A), k)
SVDMPoint(S::SVD, k::Int) = SVDMPoint(S.U, S.S, S.Vt, k)
SVDMPoint(U, S, Vt, k::Int) = SVDMPoint(U[:, 1:k], S[1:k], Vt[1:k, :])
Base.:(==)(x::SVDMPoint, y::SVDMPoint) = (x.U == y.U) && (x.S == y.S) && (x.Vt == y.Vt)
Base.eltype(p::SVDMPoint) = Base.eltype(p.S)

@doc raw"""
    UMVTangentVector <: AbstractTangentVector

A tangent vector that can be described as a product ``U_p M V_p^\mathrm{H} + U_X V_p^\mathrm{H} + U_p V_X^\mathrm{H}``,
where ``X = U_X S V_X^\mathrm{H}`` is its base point, see for example [`FixedRankMatrices`](@ref).

The base point ``p`` is required for example embedding this point, but it is not stored.
The fields of thie tangent vector are `U` for ``U_X``, `M` and `Vt` to store ``V_X^\mathrm{H}``

# Constructors
* `UMVTangentVector(U,M,Vt)` store umv factors to initialize the `UMVTangentVector`
* `UMVTangentVector(U,M,Vt,k)` store the umv factors after shortening them down to
  inner dimensions `k`.
"""
struct UMVTangentVector{TU <: AbstractMatrix, TM <: AbstractMatrix, TVt <: AbstractMatrix} <:
    AbstractTangentVector
    U::TU
    M::TM
    Vt::TVt
end

UMVTangentVector(U, M, Vt, k::Int) = UMVTangentVector(U[:, 1:k], M[1:k, 1:k], Vt[1:k, :])

# here the division in M corrects for the first factor in UMV + x.U*Vt + U*x.Vt, where x is the base point to v.
Base.:*(v::UMVTangentVector, s::Number) = UMVTangentVector(v.U * s, v.M * s, v.Vt * s)
Base.:*(s::Number, v::UMVTangentVector) = UMVTangentVector(s * v.U, s * v.M, s * v.Vt)
Base.:/(v::UMVTangentVector, s::Number) = UMVTangentVector(v.U / s, v.M / s, v.Vt / s)
Base.:\(s::Number, v::UMVTangentVector) = UMVTangentVector(s \ v.U, s \ v.M, s \ v.Vt)
function Base.:+(v::UMVTangentVector, w::UMVTangentVector)
    return UMVTangentVector(v.U + w.U, v.M + w.M, v.Vt + w.Vt)
end
function Base.:-(v::UMVTangentVector, w::UMVTangentVector)
    return UMVTangentVector(v.U - w.U, v.M - w.M, v.Vt - w.Vt)
end
Base.:-(v::UMVTangentVector) = UMVTangentVector(-v.U, -v.M, -v.Vt)
Base.:+(v::UMVTangentVector) = UMVTangentVector(v.U, v.M, v.Vt)
function Base.:(==)(v::UMVTangentVector, w::UMVTangentVector)
    return (v.U == w.U) && (v.M == w.M) && (v.Vt == w.Vt)
end

# Move to Base when name is established – i.e. used in more than one manifold
# |/---
"""
    OrthographicRetraction <: AbstractRetractionMethod

Retractions that are related to orthographic projections, which was first
used in [AbsilMalick:2012](@cite).
"""
struct OrthographicRetraction <: AbstractRetractionMethod end

"""
    OrthographicInverseRetraction <: AbstractInverseRetractionMethod

Retractions that are related to orthographic projections, which was first
used in [AbsilMalick:2012](@cite).
"""
struct OrthographicInverseRetraction <: AbstractInverseRetractionMethod end

# Layer II
function _inverse_retract!(
        M::AbstractManifold,
        X,
        p,
        q,
        ::OrthographicInverseRetraction;
        kwargs...,
    )
    return inverse_retract_orthographic!(M, X, p, q; kwargs...)
end

# Layer III
"""
    inverse_retract_orthographic!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`OrthographicInverseRetraction`](@ref).
"""
inverse_retract_orthographic!(M::AbstractManifold, X, p, q)

## Layer II
function ManifoldsBase._retract_fused!(
        M::AbstractManifold,
        q,
        p,
        X,
        t::Number,
        ::OrthographicRetraction;
        kwargs...,
    )
    return retract_orthographic_fused!(M, q, p, X, t; kwargs...)
end
function ManifoldsBase._retract!(
        M::AbstractManifold,
        q,
        p,
        X,
        ::OrthographicRetraction;
        kwargs...,
    )
    return retract_orthographic!(M, q, p, X; kwargs...)
end
## Layer III

"""
    retract_orthographic!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`OrthographicRetraction`](@ref).
"""
retract_orthographic!(M::AbstractManifold, q, p, X)

# \|---

allocate(p::SVDMPoint) = SVDMPoint(allocate(p.U), allocate(p.S), allocate(p.Vt))
function allocate(p::SVDMPoint, ::Type{T}) where {T}
    return SVDMPoint(allocate(p.U, T), allocate(p.S, T), allocate(p.Vt, T))
end
function allocate(X::UMVTangentVector)
    return UMVTangentVector(allocate(X.U), allocate(X.M), allocate(X.Vt))
end
function allocate(X::UMVTangentVector, ::Type{T}) where {T}
    return UMVTangentVector(allocate(X.U, T), allocate(X.M, T), allocate(X.Vt, T))
end

function allocate_result(M::FixedRankMatrices, ::typeof(inverse_retract), p, q)
    return zero_vector(M, p)
end
function allocate_result_embedding(M::FixedRankMatrices, ::typeof(project), X, p, vals...)
    m, n, k = get_parameter(M.size)
    # vals are p and X, so we can use their fields to set up those of the UMVTangentVector
    return UMVTangentVector(allocate(p.U, m, k), allocate(p.S, k, k), allocate(p.Vt, k, n))
end

Base.copy(v::UMVTangentVector) = UMVTangentVector(copy(v.U), copy(v.M), copy(v.Vt))

# Tuple-like broadcasting of UMVTangentVector

function Broadcast.BroadcastStyle(::Type{<:UMVTangentVector})
    return Broadcast.Style{UMVTangentVector}()
end
function Broadcast.BroadcastStyle(
        ::Broadcast.AbstractArrayStyle{0},
        b::Broadcast.Style{UMVTangentVector},
    )
    return b
end

function Broadcast.instantiate(
        bc::Broadcast.Broadcasted{Broadcast.Style{UMVTangentVector}, Nothing},
    )
    return bc
end
function Broadcast.instantiate(bc::Broadcast.Broadcasted{Broadcast.Style{UMVTangentVector}})
    Broadcast.check_broadcast_axes(bc.axes, bc.args...)
    return bc
end

Broadcast.broadcastable(v::UMVTangentVector) = v

@inline function Base.copy(bc::Broadcast.Broadcasted{Broadcast.Style{UMVTangentVector}})
    return UMVTangentVector(
        @inbounds(Broadcast._broadcast_getindex(bc, Val(:U))),                  # COV_EXCL_LINE
        @inbounds(Broadcast._broadcast_getindex(bc, Val(:M))),                  # COV_EXCL_LINE
        @inbounds(Broadcast._broadcast_getindex(bc, Val(:Vt))),                 # COV_EXCL_LINE
    )
end

Base.@propagate_inbounds function Broadcast._broadcast_getindex(
        v::UMVTangentVector,
        ::Val{I},
    ) where {I}
    return getfield(v, I)
end

Base.axes(::UMVTangentVector) = ()

@inline function Base.copyto!(
        dest::UMVTangentVector,
        bc::Broadcast.Broadcasted{Broadcast.Style{UMVTangentVector}},
    )
    # Performance optimization: broadcast!(identity, dest, A) is equivalent to copyto!(dest, A) if indices match
    if bc.f === identity && bc.args isa Tuple{UMVTangentVector} # only a single input argument to broadcast!
        A = bc.args[1]
        return copyto!(dest, A)
    end
    bc′ = Broadcast.preprocess(dest, bc)
    copyto!(dest.U, Broadcast._broadcast_getindex(bc′, Val(:U)))
    copyto!(dest.M, Broadcast._broadcast_getindex(bc′, Val(:M)))
    copyto!(dest.Vt, Broadcast._broadcast_getindex(bc′, Val(:Vt)))
    return dest
end

@doc raw"""
    check_point(M::FixedRankMatrices, p; kwargs...)

Check whether the matrix or [`SVDMPoint`](@ref) `x` ids a valid point on the
[`FixedRankMatrices`](@ref) `M`, i.e. is an `m`-by`n` matrix of
rank `k`. For the [`SVDMPoint`](@ref) the internal representation also has to have the right
shape, i.e. `p.U` and `p.Vt` have to be unitary. The keyword arguments are passed to the
`rank` function that verifies the rank of `p`.
"""
function check_point(M::FixedRankMatrices, p; kwargs...)
    m, n, k = get_parameter(M.size)
    r = rank(p; kwargs...)
    s = "The point $(p) does not lie on $(M), "
    if r > k
        return DomainError(r, string(s, "since its rank is too large ($(r))."))
    end
    return nothing
end
function check_point(M::FixedRankMatrices, p::SVDMPoint; kwargs...)
    m, n, k = get_parameter(M.size)
    s = "The point $(p) does not lie on $(M), "
    if !isapprox(p.U' * p.U, one(zeros(k, k)); kwargs...)
        return DomainError(
            norm(p.U' * p.U - one(zeros(k, k))),
            string(s, " since U is not orthonormal/unitary."),
        )
    end
    if !isapprox(p.Vt * p.Vt', one(zeros(k, k)); kwargs...)
        return DomainError(
            norm(p.Vt * p.Vt' - one(zeros(k, k))),
            string(s, " since V is not orthonormal/unitary."),
        )
    end
    return nothing
end

function check_size(M::FixedRankMatrices, p::SVDMPoint)
    m, n, k = get_parameter(M.size)
    if (size(p.U) != (m, k)) || (length(p.S) != k) || (size(p.Vt) != (k, n))
        return DomainError(
            [size(p.U)..., length(p.S), size(p.Vt)...],
            "The point $(p) does not lie on $(M) since the dimensions do not fit (expected $(n)x$(m) rank $(k) got $(size(p.U, 1))x$(size(p.Vt, 2)) rank $(size(p.S, 1)).",
        )
    end
end
function check_size(M::FixedRankMatrices, p)
    m, n, k = get_parameter(M.size)
    pS = svd(p)
    if (size(pS.U) != (m, k)) || (length(pS.S) != k) || (size(pS.Vt) != (k, n))
        return DomainError(
            [size(pS.U)..., length(pS.S), size(pS.Vt)...],
            "The point $(p) does not lie on $(M) since the dimensions do not fit (expected $(n)x$(m) rank $(k) got $(size(pS.U, 1))x$(size(pS.Vt, 2)) rank $(size(pS.S, 1)).",
        )
    end
end
function check_size(M::FixedRankMatrices, p, X::UMVTangentVector)
    m, n, k = get_parameter(M.size)
    if (size(X.U) != (m, k)) || (size(X.Vt) != (k, n)) || (size(X.M) != (k, k))
        return DomainError(
            cat(size(X.U), size(X.M), size(X.Vt), dims = 1),
            "The tangent vector $(X) is not a tangent vector to $(p) on $(M), since matrix dimensions do not agree (expected $(m)x$(k), $(k)x$(k), $(k)x$(n)).",
        )
    end
end

@doc raw"""
    check_vector(M:FixedRankMatrices, p, X; kwargs...)

Check whether the tangent [`UMVTangentVector`](@ref) `X` is from the tangent space of the [`SVDMPoint`](@ref) `p` on the
[`FixedRankMatrices`](@ref) `M`, i.e. that `v.U` and `v.Vt` are (columnwise) orthogonal to `x.U` and `x.Vt`,
respectively, and its dimensions are consistent with `p` and `X.M`, i.e. correspond to `m`-by-`n` matrices of rank `k`.
"""
function check_vector(
        M::FixedRankMatrices,
        p::SVDMPoint,
        X::UMVTangentVector;
        atol::Real = sqrt(prod(representation_size(M)) * eps(float(eltype(p.U)))),
        kwargs...,
    )
    m, n, k = get_parameter(M.size)
    if !isapprox(X.U' * p.U, zeros(k, k); atol = atol, kwargs...)
        return DomainError(
            norm(X.U' * p.U - zeros(k, k)),
            "The tangent vector $(X) is not a tangent vector to $(p) on $(M) since v.U'x.U is not zero. ",
        )
    end
    if !isapprox(X.Vt * p.Vt', zeros(k, k); atol = atol, kwargs...)
        return DomainError(
            norm(X.Vt * p.Vt - zeros(k, k)),
            "The tangent vector $(X) is not a tangent vector to $(p) on $(M) since v.V'x.V is not zero.",
        )
    end
    return nothing
end

function Base.copyto!(p::SVDMPoint, q::SVDMPoint)
    copyto!(p.U, q.U)
    copyto!(p.S, q.S)
    copyto!(p.Vt, q.Vt)
    return p
end
function Base.copyto!(X::UMVTangentVector, Y::UMVTangentVector)
    copyto!(X.U, Y.U)
    copyto!(X.M, Y.M)
    copyto!(X.Vt, Y.Vt)
    return X
end

"""
    default_inverse_retraction_method(M::FixedRankMatrices)

Return [`PolarInverseRetraction`](@extref `ManifoldsBase.PolarInverseRetraction`)
as the default inverse retraction for the [`FixedRankMatrices`](@ref) manifold.
"""
default_inverse_retraction_method(::FixedRankMatrices) = PolarInverseRetraction()

metric(::FixedRankMatrices) = EuclideanMetric()

"""
    default_retraction_method(M::FixedRankMatrices)

Return [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`)
as the default retraction for the [`FixedRankMatrices`](@ref) manifold.
"""
default_retraction_method(::FixedRankMatrices) = PolarRetraction()

"""
    default_vector_transport_method(M::FixedRankMatrices)

Return the [`ProjectionTransport`](@extref `ManifoldsBase.ProjectionTransport`)
as the default vector transport method for the [`FixedRankMatrices`](@ref) manifold.
"""
default_vector_transport_method(::FixedRankMatrices) = ProjectionTransport()

@doc raw"""
    embed(::FixedRankMatrices, p::SVDMPoint)

Embed the point `p` from its `SVDMPoint` representation into the set of ``m×n`` matrices
by computing ``USV^{\mathrm{H}}``.
"""
function embed(::FixedRankMatrices, p::SVDMPoint)
    return p.U * Diagonal(p.S) * p.Vt
end

function embed!(::FixedRankMatrices, q, p::SVDMPoint)
    return mul!(q, p.U * Diagonal(p.S), p.Vt)
end

@doc raw"""
    embed(M::FixedRankMatrices, p, X)

Embed the tangent vector `X` at point `p` in `M` from
its [`UMVTangentVector`](@ref) representation  into the set of ``m×n`` matrices.

The formula reads
```math
U_pMV_p^{\mathrm{H}} + U_XV_p^{\mathrm{H}} + U_pV_X^{\mathrm{H}}
```
"""
function embed(::FixedRankMatrices, p::SVDMPoint, X::UMVTangentVector)
    return (p.U * X.M .+ X.U) * p.Vt + p.U * X.Vt
end

function embed!(::FixedRankMatrices, Y, p::SVDMPoint, X::UMVTangentVector)
    tmp = p.U * X.M
    tmp .+= X.U
    mul!(Y, tmp, p.Vt)
    return mul!(Y, p.U, X.Vt, true, true)
end

function get_embedding(::FixedRankMatrices{𝔽, TypeParameter{Tuple{m, n, k}}}) where {m, n, k, 𝔽}
    return Euclidean(m, n; field = 𝔽)
end
function get_embedding(M::FixedRankMatrices{𝔽, Tuple{Int, Int, Int}}) where {𝔽}
    m, n, k = get_parameter(M.size)
    return Euclidean(m, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::FixedRankMatrices)
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

"""
    injectivity_radius(::FixedRankMatrices)

Return the incjectivity radius of the manifold of [`FixedRankMatrices`](@ref), i.e. 0.
See [HosseiniUschmajew:2017](@cite).
"""
function injectivity_radius(::FixedRankMatrices)
    return 0.0
end

@doc raw"""
    inner(M::FixedRankMatrices, p::SVDMPoint, X::UMVTangentVector, Y::UMVTangentVector)

Compute the inner product of `X` and `Y` in the tangent space of `p` on the [`FixedRankMatrices`](@ref) `M`,
which is inherited from the embedding, i.e. can be computed using `dot` on the elements (`U`, `Vt`, `M`) of `X` and `Y`.
"""
function inner(::FixedRankMatrices, x::SVDMPoint, v::UMVTangentVector, w::UMVTangentVector)
    return dot(v.U, w.U) + dot(v.M, w.M) + dot(v.Vt, w.Vt)
end

@doc raw"""
    inverse_retract(M, p, q, ::OrthographicInverseRetraction)

Compute the orthographic inverse retraction [`FixedRankMatrices`](@ref) `M` by computing

```math
    X = P_{T_{p}M}(q - p) = qVV^\mathrm{T} + UU^{\mathrm{T}}q - UU^{\mathrm{T}}qVV^{\mathrm{T}} - p,
```
where ``p`` is a [`SVDMPoint`](@ref)`(U,S,Vt)` and ``P_{T_{p}M}`` is the [`project`](@ref)ion
onto the tangent space at ``p``.

For more details, see [AbsilOseledets:2014](@cite).
"""
inverse_retract(::FixedRankMatrices, ::Any, ::Any, ::OrthographicInverseRetraction)

function inverse_retract_orthographic!(
        M::FixedRankMatrices,
        X::UMVTangentVector,
        p::SVDMPoint,
        q::SVDMPoint,
    )
    project!(M, X, p, embed(M, q) - embed(M, p))
    return X
end

function _isapprox(::FixedRankMatrices, p::SVDMPoint, q::SVDMPoint; kwargs...)
    return isapprox(p.U * Diagonal(p.S) * p.Vt, q.U * Diagonal(q.S) * q.Vt; kwargs...)
end
function _isapprox(
        ::FixedRankMatrices,
        p::SVDMPoint,
        X::UMVTangentVector,
        Y::UMVTangentVector;
        kwargs...,
    )
    return isapprox(
        p.U * X.M * p.Vt + X.U * p.Vt + p.U * X.Vt,
        p.U * Y.M * p.Vt + Y.U * p.Vt + p.U * Y.Vt;
        kwargs...,
    )
end

"""
    is_flat(::FixedRankMatrices)

Return false. [`FixedRankMatrices`](@ref) is not a flat manifold.
"""
is_flat(M::FixedRankMatrices) = false

function number_eltype(p::SVDMPoint)
    return typeof(one(eltype(p.U)) + one(eltype(p.S)) + one(eltype(p.Vt)))
end
function number_eltype(X::UMVTangentVector)
    return typeof(one(eltype(X.U)) + one(eltype(X.M)) + one(eltype(X.Vt)))
end

@doc raw"""
    manifold_dimension(M::FixedRankMatrices)

Return the manifold dimension for the `𝔽`-valued [`FixedRankMatrices`](@ref) `M`
of dimension `m`x`n` of rank `k`, namely

````math
\dim(\mathcal M) = k(m + n - k) \dim_ℝ 𝔽,
````

where ``\dim_ℝ 𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of `𝔽`.
"""
function manifold_dimension(M::FixedRankMatrices{𝔽}) where {𝔽}
    m, n, k = get_parameter(M.size)
    return (m + n - k) * k * real_dimension(𝔽)
end

function Base.one(p::SVDMPoint)
    m = size(p.U, 1)
    n = size(p.Vt, 2)
    k = length(p.S)
    return SVDMPoint(one(zeros(m, m))[:, 1:k], one.(p.S), one(zeros(n, n))[1:k, :], k)
end

@doc raw"""
    project(M, p, A)

Project the matrix ``A ∈ ℝ^{m,n}`` or from the embedding the tangent space at ``p`` on the [`FixedRankMatrices`](@ref) `M`,
further decomposing the result into ``X=UMV^\mathrm{H}``, i.e. a [`UMVTangentVector`](@ref).
"""
project(::FixedRankMatrices, ::Any, ::Any)

function project!(::FixedRankMatrices, Y::UMVTangentVector, p::SVDMPoint, A::AbstractMatrix)
    av = A * (p.Vt')
    uTav = p.U' * av
    aTu = A' * p.U
    Y.M .= uTav
    Y.U .= A * p.Vt' - p.U * uTav
    Y.Vt .= (aTu - p.Vt' * uTav')'
    return Y
end

@doc raw"""
    Random.rand(M::FixedRankMatrices; vector_at=nothing, kwargs...)

If `vector_at` is `nothing`, return a random point on the [`FixedRankMatrices`](@ref)
manifold. The orthogonal matrices are sampled from the [`Stiefel`](@ref) manifold
and the singular values are sampled uniformly at random.

If `vector_at` is not `nothing`, generate a random tangent vector in the tangent space of
the point `vector_at` on the `FixedRankMatrices` manifold `M`.
"""
function Random.rand(M::FixedRankMatrices; vector_at = nothing, kwargs...)
    return rand(Random.default_rng(), M; vector_at = vector_at, kwargs...)
end
function Random.rand(rng::AbstractRNG, M::FixedRankMatrices; vector_at = nothing, kwargs...)
    m, n, k = get_parameter(M.size)
    if vector_at === nothing
        p = SVDMPoint(
            Matrix{Float64}(undef, m, k),
            Vector{Float64}(undef, k),
            Matrix{Float64}(undef, k, n),
        )
        return rand!(rng, M, p; kwargs...)
    else
        X = UMVTangentVector(
            Matrix{Float64}(undef, m, k),
            Matrix{Float64}(undef, k, k),
            Matrix{Float64}(undef, k, n),
        )
        return rand!(rng, M, X; vector_at, kwargs...)
    end
end

function Random.rand!(
        rng::AbstractRNG,
        M::FixedRankMatrices,
        pX;
        vector_at = nothing,
        kwargs...,
    )
    m, n, k = get_parameter(M.size)
    if vector_at === nothing
        U = rand(rng, Stiefel(m, k); kwargs...)
        S = sort(rand(rng, k); rev = true)
        V = rand(rng, Stiefel(n, k); kwargs...)
        copyto!(pX, SVDMPoint(U, S, V'))
    else
        Up = randn(rng, m, k)
        Vp = randn(rng, n, k)
        A = randn(rng, k, k)
        copyto!(
            pX,
            UMVTangentVector(
                Up - vector_at.U * vector_at.U' * Up,
                A,
                Vp' - Vp' * vector_at.Vt' * vector_at.Vt,
            ),
        )
    end
    return pX
end

@doc raw"""
    representation_size(M::FixedRankMatrices)

Return the element size of a point on the [`FixedRankMatrices`](@ref) `M`, i.e.
the size of matrices on this manifold ``(m,n)``.
"""
function representation_size(M::FixedRankMatrices)
    m, n, k = get_parameter(M.size)
    return (m, n)
end

@doc raw"""
    retract(M::FixedRankMatrices, p, X, ::OrthographicRetraction)

Compute the OrthographicRetraction on the [`FixedRankMatrices`](@ref) `M` by finding
the nearest point to ``p + X`` in

```math
    p + X + N_{p}\mathcal M \cap \mathcal M
```

where ``N_{p}\mathcal M `` is the Normal Space of ``T_{p}\mathcal M ``.

If ``X`` is sufficiently small, then the nearest such point is unique and can be expressed by

```math
    q = (U(S + M) + U_{p})(S + M)^{-1}((S + M)V^{\mathrm{T}} + V^{\mathrm{T}}_{p}),
```

where ``p`` is a [`SVDMPoint`](@ref)`(U,S,Vt)` and ``X`` is an [`UMVTangentVector`](@ref)`(Up,M,Vtp)`.

For more details, see [AbsilOseledets:2014](@cite).
"""
retract(::FixedRankMatrices, ::Any, ::Any, ::OrthographicRetraction)

function retract_orthographic!(
        M::FixedRankMatrices,
        q::SVDMPoint,
        p::SVDMPoint,
        X::UMVTangentVector,
    )
    return retract_orthographic_fused!(M, q, p, X, one(eltype(p)))
end

function retract_orthographic_fused!(
        M::FixedRankMatrices,
        q::SVDMPoint,
        p::SVDMPoint,
        X::UMVTangentVector,
        t::Number,
    )
    m, n, k = get_parameter(M.size)
    tX = t * X
    QU, RU = qr(p.U * (diagm(p.S) + tX.M) + tX.U)
    QV, RV = qr(p.Vt' * (diagm(p.S) + tX.M') + tX.Vt')

    Uk, Sk, Vtk = svd(RU * inv(diagm(p.S) + tX.M) * RV')

    mul!(q.U, QU[:, 1:k], Uk)
    q.S .= Sk[1:k]
    mul!(q.Vt, Vtk, QV[:, 1:k]')

    return q
end

@doc raw"""
    retract(M, p, X, ::PolarRetraction)

Compute an SVD-based retraction on the [`FixedRankMatrices`](@ref) `M` by computing
````math
    q = U_kS_kV_k^\mathrm{H},
````
where ``U_k S_k V_k^\mathrm{H}`` is the shortened singular value decomposition ``USV^\mathrm{H}=p+X``,
in the sense that ``S_k`` is the diagonal matrix of size ``k×k`` with the ``k`` largest
singular values and ``U`` and ``V`` are shortened accordingly.
"""
retract(::FixedRankMatrices, ::Any, ::Any, ::PolarRetraction)

function retract_polar!(
        M::FixedRankMatrices,
        q::SVDMPoint,
        p::SVDMPoint,
        X::UMVTangentVector,
    )
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p.S)))
end

function ManifoldsBase.retract_polar_fused!(
        M::FixedRankMatrices,
        q::SVDMPoint,
        p::SVDMPoint,
        X::UMVTangentVector,
        t::Number,
    )
    m, n, k = get_parameter(M.size)
    tX = t * X
    QU, RU = qr([p.U tX.U])
    QV, RV = qr([p.Vt' tX.Vt'])

    # Compute T = svd(RU * [diagm(p.S) + X.M I; I zeros(k, k)] * RV')
    @views begin # COV_EXCL_LINE
        RU11 = RU[:, 1:k]
        RU12 = RU[:, (k + 1):(2 * k)]
        RV11 = RV[:, 1:k]
        RV12 = RV[:, (k + 1):(2 * k)]
    end
    tmp = RU11 .* p.S' .+ RU12
    mul!(tmp, RU11, tX.M, true, true)
    tmp2 = tmp * RV11'
    mul!(tmp2, RU11, RV12', true, true)
    T = svd(tmp2)

    mul!(q.U, QU, @view(T.U[:, 1:k]))
    q.S .= @view(T.S[1:k])
    copyto!(q.Vt, @view(T.Vt[1:k, :]) * QV')

    return q
end

@doc raw"""
    Y = riemannian_Hessian(M::FixedRankMatrices, p, G, H, X)
    riemannian_Hessian!(M::FixedRankMatrices, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

The Riemannian Hessian can be computed as stated in Remark 4.1 [Nguyen:2023](@cite)
or Section 2.3 [Vandereycken:2013](@cite), that B. Vandereycken adopted for [Manopt (Matlab)](https://www.manopt.org/reference/manopt/manifolds/fixedrank/fixedrankembeddedfactory.html).
"""
riemannian_Hessian(M::FixedRankMatrices, p, G, H, X)

function riemannian_Hessian!(M::FixedRankMatrices, Y, p, G, H, X)
    project!(M, Y, p, H)
    T1 = (G * X.Vt) / Diagonal(p.S)
    Y.U .+= T1 .- p.U * (p.U' * T1)
    T2 = (G' * X.U) / Diagonal(p.S)
    Y.Vt .+= T2 .- p.Vt' * (p.Vt * T2)
    return Y
end

function Base.show(
        io::IO,
        ::FixedRankMatrices{𝔽, TypeParameter{Tuple{m, n, k}}},
    ) where {m, n, k, 𝔽}
    return print(io, "FixedRankMatrices($(m), $(n), $(k), $(𝔽))")
end
function Base.show(io::IO, M::FixedRankMatrices{𝔽, Tuple{Int, Int, Int}}) where {𝔽}
    m, n, k = get_parameter(M.size)
    return print(io, "FixedRankMatrices($(m), $(n), $(k), $(𝔽); parameter=:field)")
end
function Base.show(io::IO, ::MIME"text/plain", p::SVDMPoint)
    pre = " "
    summary(io, p)
    println(io, "\nU factor:")
    su = sprint(show, "text/plain", p.U; context = io, sizehint = 0)
    su = replace(su, '\n' => "\n$(pre)")
    println(io, pre, su)
    println(io, "singular values:")
    ss = sprint(show, "text/plain", p.S; context = io, sizehint = 0)
    ss = replace(ss, '\n' => "\n$(pre)")
    println(io, pre, ss)
    println(io, "Vt factor:")
    sv = sprint(show, "text/plain", p.Vt; context = io, sizehint = 0)
    sv = replace(sv, '\n' => "\n$(pre)")
    return print(io, pre, sv)
end
function Base.show(io::IO, ::MIME"text/plain", X::UMVTangentVector)
    pre = " "
    summary(io, X)
    println(io, "\nU factor:")
    su = sprint(show, "text/plain", X.U; context = io, sizehint = 0)
    su = replace(su, '\n' => "\n$(pre)")
    println(io, pre, su)
    println(io, "M factor:")
    sm = sprint(show, "text/plain", X.M; context = io, sizehint = 0)
    sm = replace(sm, '\n' => "\n$(pre)")
    println(io, pre, sm)
    println(io, "Vt factor:")
    sv = sprint(show, "text/plain", X.Vt; context = io, sizehint = 0)
    sv = replace(sv, '\n' => "\n$(pre)")
    return print(io, pre, sv)
end

@doc raw"""
    vector_transport_to(M::FixedRankMatrices, p, X, q, ::ProjectionTransport)

Compute the vector transport of the tangent vector `X` at `p` to `q`,
using the [`project`](@ref project(::FixedRankMatrices, ::Any...))
of `X` to `q`.
"""
vector_transport_to!(::FixedRankMatrices, ::Any, ::Any, ::Any, ::ProjectionTransport)

function vector_transport_to_project!(M::FixedRankMatrices, Y, p, X, q)
    return project!(M, Y, q, embed(M, p, X))
end

@doc raw"""
    zero_vector(M::FixedRankMatrices, p::SVDMPoint)

Return a [`UMVTangentVector`](@ref) representing the zero tangent vector in the tangent space of
`p` on the [`FixedRankMatrices`](@ref) `M`, for example all three elements of the resulting
structure are zero matrices.
"""
function zero_vector(M::FixedRankMatrices, p::SVDMPoint)
    m, n, k = get_parameter(M.size)
    v = UMVTangentVector(
        zeros(eltype(p.U), m, k),
        zeros(eltype(p.S), k, k),
        zeros(eltype(p.Vt), k, n),
    )
    return v
end

function zero_vector!(::FixedRankMatrices, X::UMVTangentVector, p::SVDMPoint)
    X.U .= zero(eltype(X.U))
    X.M .= zero(eltype(X.M))
    X.Vt .= zero(eltype(X.Vt))
    return X
end

@doc raw"""
    EmbeddedTorus{TR<:Real} <: AbstractDecoratorManifold{ℝ}

Surface in ℝ³ described by parametric equations:
```math
x(θ, φ) = (R + r\cos θ)\cos φ \\
y(θ, φ) = (R + r\cos θ)\sin φ \\
z(θ, φ) = r\sin θ
```
for θ, φ in $[-π, π)$. It is assumed that $R > r > 0$.

Alternative names include anchor ring, donut and doughnut.

# Constructor

    EmbeddedTorus(R, r)
"""
struct EmbeddedTorus{TR <: Real} <: AbstractDecoratorManifold{ℝ}
    R::TR
    r::TR
end

aspect_ratio(M::EmbeddedTorus) = M.R / M.r

@doc raw"""
    check_point(M::EmbeddedTorus, p; kwargs...)

Check whether `p` is a valid point on the [`EmbeddedTorus`](@ref) `M`.
The tolerance for the last test can be set using the `kwargs...`.

The method checks if ``(p_1^2 + p_2^2 + p_3^2 + R^2 - r^2)^2``
is approximately equal to ``4R^2(p_1^2 + p_2^2)``.
"""
function check_point(M::EmbeddedTorus, p; kwargs...)
    A = (dot(p, p) + M.R^2 - M.r^2)^2
    B = 4 * M.R^2 * (p[1]^2 + p[2]^2)
    if !isapprox(A, B; kwargs...)
        return DomainError(A - B, "The point $(p) does not lie on the $(M).")
    end
    return nothing
end

@doc raw"""
    check_vector(M::EmbeddedTorus, p, X; atol=eps(eltype(p)), kwargs...)

Check whether `X` is a valid vector tangent to `p` on the [`EmbeddedTorus`](@ref) `M`.
The method checks if the vector `X` is orthogonal to the vector normal to the torus,
see [`normal_vector`](@ref). Absolute tolerance can be set using `atol`.
"""
function check_vector(M::EmbeddedTorus, p, X; atol::Real = eps(float(eltype(p))), kwargs...)
    dot_nX = dot(normal_vector(M, p), X)
    if !isapprox(dot_nX, 0; atol = atol, kwargs...)
        return DomainError(dot_nX, "The vector $(X) is not tangent to $(p) from $(M).")
    end
    return nothing
end

function get_embedding(::EmbeddedTorus)
    return Euclidean(3)
end

"""
    is_flat(::EmbeddedTorus)

Return false. [`EmbeddedTorus`](@ref) is not a flat manifold.
"""
is_flat(M::EmbeddedTorus) = false

@doc raw"""
    manifold_dimension(M::EmbeddedTorus)

Return the dimension of the [`EmbeddedTorus`](@ref) `M` that is 2.
"""
manifold_dimension(::EmbeddedTorus) = 2

representation_size(::EmbeddedTorus) = (3,)

@doc raw"""
    DefaultTorusAtlas()

Atlas for torus with charts indexed by two angles numbers $θ₀, φ₀ ∈ [-π, π)$. Inverse of
a chart $(θ₀, φ₀)$ is given by

```math
x(θ, φ) = (R + r\cos(θ + θ₀))\cos(φ + φ₀) \\
y(θ, φ) = (R + r\cos(θ + θ₀))\sin(φ + φ₀) \\
z(θ, φ) = r\sin(θ + θ₀)
```
"""
struct DefaultTorusAtlas <: AbstractAtlas{ℝ} end

"""
    affine_connection(M::EmbeddedTorus, A::DefaultTorusAtlas, i, a, Xc, Yc)

Affine connection on [`EmbeddedTorus`](@ref) `M`.
"""
affine_connection(M::EmbeddedTorus, A::DefaultTorusAtlas, i, a, Xc, Yc)

function affine_connection!(M::EmbeddedTorus, Zc, ::DefaultTorusAtlas, i, a, Xc, Yc)
    # as in https://www.cefns.nau.edu/~schulz/torus.pdf
    θ = a[1] .+ i[1]
    sinθ, cosθ = sincos(θ)
    Γ¹₂₂ = (M.R + M.r * cosθ) * sinθ / M.r
    Γ²₁₂ = -M.r * sinθ / (M.R + M.r * cosθ)

    Zc[1] = Xc[2] * Γ¹₂₂ * Yc[2]
    Zc[2] = Γ²₁₂ * (Xc[1] * Yc[2] + Xc[2] * Yc[1])
    return Zc
end

"""
    check_chart_switch(::EmbeddedTorus, A::DefaultTorusAtlas, i, a; ϵ = pi/3)

Return true if parameters `a` lie closer than `ϵ` to chart boundary.
"""
function check_chart_switch(::EmbeddedTorus, A::DefaultTorusAtlas, i, a; ϵ = pi / 3)
    return abs(i[1] - a[1]) > (pi - ϵ) || abs(i[2] - a[2]) > (pi - ϵ)
end

"""
    gaussian_curvature(M::EmbeddedTorus, p)

Gaussian curvature at point `p` from [`EmbeddedTorus`](@ref) `M`.
"""
function gaussian_curvature(M::EmbeddedTorus, p)
    θ, φ = _torus_theta_phi(M, p)
    return cos(θ) / (M.r * (M.R + M.r * cos(θ)))
end

"""
    inner(M::EmbeddedTorus, ::DefaultTorusAtlas, i, a, Xc, Yc)

Inner product on [`EmbeddedTorus`](@ref) in chart `i` in the [`DefaultTorusAtlas`](@ref).
between vectors with coordinates `Xc` and `Yc` tangent at point with parameters `a`.
Vector coordinates must be given in the induced basis.
"""
function inner(M::EmbeddedTorus, ::DefaultTorusAtlas, i, a, Xc, Yc)
    diag_1 = M.r^2
    diag_2 = (M.R + M.r * cos(a[1] + i[1]))^2
    return Xc[1] * diag_1 * Yc[1] + Xc[2] * diag_2 * Yc[2]
end

"""
    inverse_chart_injectivity_radius(M::AbstractManifold, A::AbstractAtlas, i)

Injectivity radius of `get_point` for chart `i` from the [`DefaultTorusAtlas`](@ref) `A` of the [`EmbeddedTorus`](@ref).
"""
function inverse_chart_injectivity_radius(::EmbeddedTorus, ::DefaultTorusAtlas, i)
    return π
end

function _torus_theta_phi(M::EmbeddedTorus, p)
    φ = atan(p[2], p[1])
    sinφ, cosφ = sincos(φ)
    rsinθ = p[3]
    if p[1]^2 > p[2]^2
        rcosθ = p[1] / cosφ - M.R
    else
        rcosθ = p[2] / sinφ - M.R
    end
    return (atan(rsinθ, rcosθ), φ)
end

function _torus_param(M::EmbeddedTorus, θ, φ)
    sinθ, cosθ = sincos(θ)
    sinφ, cosφ = sincos(φ)
    return ((M.R + M.r * cosθ) * cosφ, (M.R + M.r * cosθ) * sinφ, M.r * sinθ)
end

"""
    normal_vector(M::EmbeddedTorus, p)

Outward-pointing normal vector on the [`EmbeddedTorus`](@ref) at the point `p`.
"""
function normal_vector(M::EmbeddedTorus, p)
    θ, φ = _torus_theta_phi(M, p)
    t = @SVector [-sin(φ), cos(φ), 0]
    s = @SVector [cos(φ) * (-sin(θ)), sin(φ) * (-sin(θ)), cos(θ)]
    return normalize(cross(t, s))
end

function get_chart_index(M::EmbeddedTorus, ::DefaultTorusAtlas, p)
    return _torus_theta_phi(M, p)
end
function get_chart_index(::EmbeddedTorus, ::DefaultTorusAtlas, i, a)
    return (a[1], a[2])
end

function get_parameters!(M::EmbeddedTorus, x, ::DefaultTorusAtlas, i::NTuple{2}, p)
    x .= _torus_theta_phi(M, p) .- i
    return x
end

function get_point!(M::EmbeddedTorus, p, ::DefaultTorusAtlas, i, x)
    p .= _torus_param(M, (x .+ i)...)
    return p
end

function get_coordinates_induced_basis!(
        M::EmbeddedTorus,
        Y,
        p,
        X,
        B::InducedBasis{ℝ, TangentSpaceType, DefaultTorusAtlas},
    )
    θ, φ = get_parameters(M, B.A, B.i, p)

    sinθ, cosθ = sincos(θ + B.i[1])
    sinφ, cosφ = sincos(φ + B.i[2])

    A = @SMatrix [
        (-M.r * sinθ * cosφ) (-M.R * sinφ - M.r * cosθ * sinφ)
        (-M.r * sinθ * sinφ) (M.R * cosφ + M.r * cosθ * cosφ)
        (M.r * cosθ) 0
    ]
    Y .= A \ SVector{3}(X)
    return Y
end

function get_vector_induced_basis!(
        M::EmbeddedTorus,
        Y,
        p,
        X,
        B::InducedBasis{ℝ, TangentSpaceType, DefaultTorusAtlas},
    )
    θ, φ = get_parameters(M, B.A, B.i, p)
    dθ, dφ = X
    sinθ, cosθ = sincos(θ + B.i[1])
    sinφ, cosφ = sincos(φ + B.i[2])
    Y[1] = -M.r * sinθ * cosφ * dθ - (M.R + M.r * cosθ) * sinφ * dφ
    Y[2] = -M.r * sinθ * sinφ * dθ + (M.R + M.r * cosθ) * cosφ * dφ
    Y[3] = M.r * cosθ * dθ
    return Y
end

@doc raw"""
    EssentialManifold <: AbstractPowerManifold{ℝ}

The essential manifold is the space of the essential matrices which is represented as
a quotient space of the [`Rotations`](@ref) manifold product ``\mathrm{SO}(3)^2``.

Let ``R_x(θ), R_y(θ), R_x(θ) \in ℝ^{x×3}`` denote the rotation around the ``z``,
``y``, and ``x`` axis in ``ℝ^3``, respectively, and further the groups

```math
H_z = \bigl\{(R_z(θ),R_z(θ))\ \big|\ θ ∈ [-π,π) \bigr\}
```

and

```math
H_π = \bigl\{ (I,I), (R_x(π), R_x(π)), (I,R_z(π)), (R_x(π), R_y(π))  \bigr\}
```

acting elementwise on the left from ``\mathrm{SO}(3)^2`` (component wise).

Then the unsigned Essential manifold ``\mathcal{M}_{\text{E}}`` can be identified
with the quotient space

````math
\mathcal{M}_{\text{E}} := (\text{SO}(3)×\text{SO}(3))/(H_z × H_π),
````

and for the signed Essential manifold ``\mathcal{M}_{\text{Ǝ}}``, the quotient reads

````math
\mathcal{M}_{\text{Ǝ}} := (\text{SO}(3)×\text{SO}(3))/(H_z).
````

An essential matrix is defined as

````math
E = (R'_1)^T [T'_2 - T'_1]_{×} R'_2,
````

where the poses of two cameras ``(R_i', T_i'), i=1,2``, are contained in the space of
rigid body transformations ``SE(3)`` and the operator ``[⋅]_{×}\colon ℝ^3 → \operatorname{SkewSym}(3)``
denotes the matrix representation of the cross product operator. For more details see [TronDaniilidis:2017](@cite).

# Constructor
    EssentialManifold(is_signed=true)

Generate the manifold of essential matrices, either the signed (`is_signed=true`) or
unsigned (`is_signed=false`) variant.

"""
struct EssentialManifold <: AbstractPowerManifold{ℝ, Rotations{TypeParameter{Tuple{3}}}, NestedPowerRepresentation}
    is_signed::Bool
    manifold::Rotations{TypeParameter{Tuple{3}}}
end

function EssentialManifold(is_signed::Bool = true)
    return EssentialManifold(is_signed, Rotations(3; parameter = :type))
end

@doc raw"""
    check_point(M::EssentialManifold, p; kwargs...)

Check whether the matrix is a valid point on the [`EssentialManifold`](@ref) `M`,
i.e. a 2-element array containing SO(3) matrices.
"""
function check_point(M::EssentialManifold, p; kwargs...)
    return check_point(
        PowerManifold(M.manifold, NestedPowerRepresentation(), 2),
        p;
        kwargs...,
    )
end

"""
    check_vector(M::EssentialManifold, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the [`EssentialManifold`](@ref) `M`,
i.e. `X` has to be a 2-element array of `3`-by-`3` skew-symmetric matrices.
"""
function check_vector(M::EssentialManifold, p, X; kwargs...)
    return check_vector(
        PowerManifold(M.manifold, NestedPowerRepresentation(), 2),
        p,
        X;
        kwargs...,
    )
end

@doc raw"""
    distance(M::EssentialManifold, p, q)

Compute the Riemannian distance between the two points `p` and `q` on the [`EssentialManifold`](@ref). This is done by
computing the distance of the equivalence classes ``[p]`` and ``[q]`` of the points
``p=(R_{p_1},R_{p_2}), q=(R_{q_1},R_{q_2}) ∈ SO(3)^2``, respectively. Two points in ``SO(3)^2`` are equivalent iff their
corresponding essential matrices, given by
````math
E = R_1^T [e_z]_{×}R_2,
````
are equal (up to a sign flip). Using the logarithmic map, the distance is given by
````math
\text{dist}([p],[q]) = \| \text{log}_{[p]} [q] \| = \| \log_p (S_z(t_{\text{opt}})q) \|,
````
where ``S_z ∈ H_z = \{(R_z(θ),R_z(θ))\colon θ \in [-π,π) \}`` in which ``R_z(θ)`` is the rotation around the z axis with angle
``θ`` and ``t_{\text{opt}}`` is the minimizer of the cost function
````math
f(t) = f_1 + f_2, \quad f_i = \frac{1}{2} θ^2_i(t), \quad θ_i(t)=d(R_{p_i},R_z(t)R_{b_i}) \text{ for } i=1,2,
````
where ``d(⋅,⋅)`` is the distance function in ``SO(3)`` [TronDaniilidis:2017](@cite).
"""
distance(M::EssentialManifold, p, q) = norm(M, p, log(M, p, q))

@doc raw"""
    exp(M::EssentialManifold, p, X)

Compute the exponential map on the [`EssentialManifold`](@ref) from `p` into direction
`X`, i.e.
````math
\text{exp}_p(X) =\text{exp}_g( \tilde X),  \quad g \in \text(SO)(3)^2,
````
where ``\tilde X`` is the horizontal lift of ``X``[TronDaniilidis:2017](@cite).
"""
exp(::EssentialManifold, ::Any...)

get_iterator(::EssentialManifold) = Base.OneTo(2)

function _isapprox(
        M::EssentialManifold,
        p,
        q::T;
        atol::Real = eps(real(float(number_eltype(number_eltype(T))))),
        kwargs...,
    ) where {T}
    return isapprox(distance(M, p, q), 0.0; atol = atol, kwargs...)
end

"""
    is_flat(::EssentialManifold)

Return false. [`EssentialManifold`](@ref) is not a flat manifold.
"""
is_flat(M::EssentialManifold) = false

@doc raw"""
    log(M::EssentialManifold, p, q)

Compute the logarithmic map on the [`EssentialManifold`](@ref) `M`, i.e. the tangent vector,
whose geodesic starting from `p` reaches `q` after time 1. Here, ``p=(R_{p_1},R_{p_2})`` and
``q=(R_{q_1},R_{q_2})`` are elements of ``SO(3)^2``. We use that any essential matrix can, up to
scale, be decomposed to
````math
E = R_1^T [e_z]_{×}R_2,
````
where ``(R_1,R_2)∈SO(3)^2``. Two points in ``SO(3)^2`` are equivalent iff their corresponding
essential matrices are equal (up to a sign flip).
To compute the logarithm, we first move `q` to another representative of its equivalence class.
For this, we find ``t= t_{\text{opt}}`` for which the function
````math
f(t) = f_1 + f_2, \quad f_i = \frac{1}{2} θ^2_i(t), \quad θ_i(t)=d(R_{p_i},R_z(t)R_{b_i}) \text{ for } i=1,2,
````
where ``d(⋅,⋅)`` is the distance function in ``SO(3)``, is minimized. Further, the group ``H_z`` acting
on the left on ``SO(3)^2`` is defined as
````math
H_z = \{(R_z(θ),R_z(θ))\colon θ \in [-π,π) \},
````
where ``R_z(θ)`` is the rotation around the z axis with angle ``θ``. Points in ``H_z`` are denoted by
``S_z``. Then, the logarithm is defined
as
````math
\log_p (S_z(t_{\text{opt}})q) = [\text{Log}(R_{p_i}^T R_z(t_{\text{opt}})R_{b_i})]_{i=1,2},
````
where ``\text{Log}`` is the [`logarithm`](@ref log(::Rotations, ::Any...)) on ``SO(3)``. For more
details see [TronDaniilidis:2017](@cite).
"""
log(M::EssentialManifold, ::Any, ::Any)

function log!(M::EssentialManifold, X, p, q)
    # compute the closest representative of q
    t = 0
    f_min = Inf
    q2 = copy(M, q)

    if !M.is_signed
        q2min = copy(M, q)
        for k in 1:4
            #flip sign in q to get another member of its equivalence class
            if k == 2
                q2[1][2:3, :] = -q[1][2:3, :]
                q2[2][[1 3], :] = -q[2][[1 3], :]
            elseif k == 3
                q2[2][1:2, :] = -q[2][1:2, :]
            elseif k == 4
                q2[1][2:3, :] = -q[1][2:3, :]
                q2[2][2:3, :] = -q[2][2:3, :]
            end
            t_temp, f_temp = dist_min_angle_pair(p, q2)
            if f_temp < f_min
                q2min = copy(M, q2)
                f_min = f_temp
                t = t_temp
            end
        end
        q2 = q2min
    else
        t, _ = dist_min_angle_pair(p, q2)
    end
    Rz = [cos(t) -sin(t) 0; sin(t) cos(t) 0; 0 0 1]
    representative_q = zeros(size(q2))
    representative_q = [Rz * q2[1], Rz * q2[2]]

    # use the logarithmic map in SO(3)^2 and the corresponding geodesic between p and representative_q to compute the solution
    log!.(Ref(M.manifold), X, p, representative_q)
    return X
end

@doc raw"""
    dist_min_angle_pair(p, q)

This function computes the global minimizer of the function
````math
f(t) = f_1 + f_2, \quad f_i = \frac{1}{2} θ^2_i(t), \quad θ_i(t)=d(R_{p_i},R_z(t)R_{b_i}) \text{ for } i=1,2,
````
for the given values. This is done by finding the discontinuity points ``t_{d_i}, i=1,2`` of its derivative
and using Newton's method to minimize the function over the intervals ``[t_{d_1},t_{d_2}]`` and ``[t_{d_2},t_{d_1}+2π]``
separately. Then, the minimizer for which ``f`` is minimal is chosen and given back together with the minimal value.
For more details see Algorithm 1 in [TronDaniilidis:2017](@cite).
"""
function dist_min_angle_pair(p, q)
    #compute rotations
    q211 = q[1] * p[1]'
    q212 = q[2] * p[2]'

    #compute values from Proposition 9
    t_break1, c1, m1, Φ1 = dist_min_angle_pair_discontinuity_distance(q211)
    t_break2, c2, m2, Φ2 = dist_min_angle_pair_discontinuity_distance(q212)

    #check if cost is constant
    tol_m_zero = 5 * eps(eltype(q211)) # i.e. promoted from p and q
    tol_break = sqrt(eps(eltype(q211)))
    if (abs(m1) < tol_m_zero) && (abs(m2) < tol_m_zero)
        t_min = 0
        f_min = 2 * pi^2
    else
        if abs(mod(t_break1 - t_break2 + pi, 2 * pi) - pi) < tol_break
            t_min = t_break1 + pi
            f_min = 0
        else
            t_search1 = t_break1
            t_search2 = t_break2
            if t_search1 > t_search2
                t_search1 = t_search1 - 2 * pi
            end

            #compute derivatives of each term at discontinuity points
            df1_break1 = dist_min_angle_pair_compute_df_break(t_break1, q211)
            df2_break2 = dist_min_angle_pair_compute_df_break(t_break2, q212)

            #compute derivative of each term at other's discontinuity
            θ1_break2 = acos(clamp((m1 * sin(t_break2 + Φ1) + c1 - 1) / 2, -1.0, 1.0))
            df1_break2 = -θ1_break2 * (m1 * cos(t_break2 + Φ1)) / (2 * sin(θ1_break2))
            θ2_break1 = acos(clamp((m2 * sin(t_break1 + Φ2) + c2 - 1) / 2, -1.0, 1.0))
            df2_break1 = -θ2_break1 * (m2 * cos(t_break1 + Φ2)) / (2 * sin(θ2_break1))

            #compute left and right derivatives of sum of the two terms
            df_break1n = df1_break1 + df2_break1
            df_break1p = -df1_break1 + df2_break1
            df_break2n = df2_break2 + df1_break2
            df_break2p = -df2_break2 + df1_break2

            f_min = Inf
            if sign(df_break1p) != sign(df_break2n)
                #parabolic prediction of min
                t_min0 =
                    t_search1 -
                    df_break1p * (t_search2 - t_search1) / (df_break2n - df_break1p)
                #use Newton's search to find t_min
                t_min, f_min = dist_min_angle_pair_df_newton(
                    m1,
                    Φ1,
                    c1,
                    m2,
                    Φ2,
                    c2,
                    t_min0,
                    t_search1,
                    t_search2,
                )
            end
            t_search1 = t_search1 + 2 * pi
            if sign(df_break2p) != sign(df_break1n)
                #parabolic prediction of min
                t_min0 =
                    t_search2 -
                    df_break2p * (t_search1 - t_search2) / (df_break1n - df_break2p)
                #use Newton's search to find t_min
                t_min2, f_min2 = dist_min_angle_pair_df_newton(
                    m1,
                    Φ1,
                    c1,
                    m2,
                    Φ2,
                    c2,
                    t_min0,
                    t_search2,
                    t_search1,
                )
                #choose t with lower function values
                if f_min2 < f_min
                    t_min = t_min2
                    f_min = f_min2
                end
            end
        end
    end
    return t_min, f_min
end

@doc raw"""
    dist_min_angle_pair_discontinuity_distance(q)

This function computes the point ``t_{\text{di}}`` for which the first derivative of
````math
f(t) = f_1 + f_2, \quad f_i = \frac{1}{2} θ^2_i(t), \quad θ_i(t)=d(R_{p_i},R_z(t)R_{b_i}) \text{ for } i=1,2,
````
does not exist. This is the case for ``\sin(θ_i(t_{\text{di}})) = 0``. For more details see Proposition 9
and its proof, as well as Lemma 1 in [TronDaniilidis:2017](@cite).
"""
function dist_min_angle_pair_discontinuity_distance(q)
    c1 = q[1, 1] + q[2, 2]
    c2 = q[1, 2] - q[2, 1]
    c3 = q[3, 3]

    m = norm([c1 c2])
    Φ = atan(c1, c2)

    t_break = -0.5 * pi - Φ
    return t_break, c3, m, Φ
end

@doc raw"""
    dist_min_angle_pair_compute_df_break(t_break, q)

This function computes the derivatives of each term ``f_i, i=1,2,`` at discontinuity point `t_break`. For more details see [TronDaniilidis:2017](@cite).
"""
function dist_min_angle_pair_compute_df_break(t_break, q)
    c = cos(t_break)
    s = sin(t_break)

    q1_r_break_q1 = [c -s 0; s c 0; 0 0 1] * q
    F = svd(q1_r_break_q1 + I(3))
    df_break = pi * abs(F.U[3, 1])
    return df_break
end

@doc raw"""
    dist_min_angle_pair_df_newton(m1, Φ1, c1, m2, Φ2, c2, t_min, t_low, t_high)

This function computes the minimizer of the function
````math
f(t) = f_1 + f_2, \quad f_i = \frac{1}{2} θ^2_i(t), \quad θ_i(t)=d(R_{p_i},R_z(t)R_{b_i}) \text{ for } i=1,2,
````
in the interval ``[```t_low`, `t_high```]`` using Newton's method. For more details see [TronDaniilidis:2017](@cite).
"""
function dist_min_angle_pair_df_newton(m1, Φ1, c1, m2, Φ2, c2, t_min, t_low, t_high)
    tol_dist = sqrt(eps(eltype(t_min)))
    θ1 = zero(t_min)
    θ2 = zero(t_min)
    for i in 1:100
        #compute auxiliary values
        mc1 = m1 * cos(t_min + Φ1)
        mc2 = m2 * cos(t_min + Φ2)

        #compute θi, i=1,2
        θ1 = acos(clamp(((m1 * sin(t_min + Φ1) + c1 - 1) / 2), -1, 1))
        θ2 = acos(clamp(((m2 * sin(t_min + Φ2) + c2 - 1) / 2), -1, 1))

        #compute the first derivatives di, i=1,2
        s1 = 2 * sin(θ1)
        s2 = 2 * sin(θ2)
        d1 = (-θ1 * mc1) / s1
        d2 = (-θ2 * mc2) / s2
        d = d1 + d2

        #compute the second derivatives ddi, i=1,2
        eztuSq1 = (mc1 / s1)^2
        eztuSq2 = (mc2 / s2)^2
        dd1 = eztuSq1 + θ1 / 2 * cot(θ1 / 2) * (1 - eztuSq1)
        dd2 = eztuSq2 + θ2 / 2 * cot(θ2 / 2) * (1 - eztuSq2)
        dd = dd1 + dd2

        #compute the new t_min
        t_old = t_min
        t_min = clamp(t_old - d / dd, t_low + tol_dist, t_high - tol_dist)
        if abs(t_min - t_old) < tol_dist
            break
        end
    end
    f_min = θ1^2 + θ2^2
    return t_min, f_min
end

@doc raw"""
    manifold_dimension(M::EssentialManifold{is_signed, ℝ})

Return the manifold dimension of the [`EssentialManifold`](@ref), which is `5`[TronDaniilidis:2017](@cite).
"""
function manifold_dimension(::EssentialManifold)
    return 5
end

function power_dimensions(::EssentialManifold)
    return (2,)
end

@doc raw"""
    project(M::EssentialManifold, p, X)

Project the matrix `X` onto the tangent space
````math
T_{p} \text{SO}(3)^2 = T_{\text{vp}}\text{SO}(3)^2 ⊕ T_{\text{hp}}\text{SO}(3)^2,
````
by first computing its projection onto the vertical space ``T_{\text{vp}}\text{SO}(3)^2`` using [`vert_proj`](@ref).
Then the orthogonal projection of `X` onto the horizontal space ``T_{\text{hp}}\text{SO}(3)^2`` is defined as
````math
\Pi_h(X) = X - \frac{\text{vert\_proj}_p(X)}{2} \begin{bmatrix} R_1^T e_z \\ R_2^T e_z \end{bmatrix},
````
with ``R_i = R_0 R'_i, i=1,2,`` where ``R'_i`` is part of the pose of camera ``i`` ``g_i = (R'_i,T'_i) ∈ \text{SE}(3)``
and ``R_0 ∈ \text{SO}(3)`` such that ``R_0(T'_2-T'_1) = e_z``.
"""
project(::EssentialManifold, ::Any, ::Any)

function project!(M::EssentialManifold, Y, p, X)
    X_proj = [pe' * Xe for (pe, Xe) in zip(p, X)]
    X_proj .= [0.5 * (Xe - Xe') for Xe in X_proj]
    # projection on the vertical component
    s = vert_proj(M, p, X_proj)
    # orthogonal projection
    copyto!(
        Y,
        [
            Xe - (s / 2) * get_vector(M.manifold, pe, pe[3, :], DefaultOrthogonalBasis())
                for (Xe, pe) in zip(X_proj, p)
        ],
    )
    return Y
end

function Base.show(io::IO, M::EssentialManifold)
    return print(io, "EssentialManifold($(M.is_signed))")
end

function parallel_transport_direction(M::EssentialManifold, p, X, d)
    return parallel_transport_to(M, p, X, exp(M, p, d))
end
function parallel_transport_direction!(M::EssentialManifold, Y, p, X, d)
    parallel_transport_to!(M, Y, p, X, exp(M, p, d))
    return Y
end

@doc raw"""
    parallel_transport_to(M::EssentialManifold, p, X, q)

Compute the vector transport of the tangent vector `X` at `p` to `q` on the
[`EssentialManifold`](@ref) `M` using left translation of the ambient group.
"""
function parallel_transport_to(::EssentialManifold, p, X, q)
    # group operation in the ambient group
    pq = [qe' * pe for (pe, qe) in zip(p, q)]
    # left translation
    return [pqe * Xe * pqe' for (pqe, Xe) in zip(pq, X)]
end
function parallel_transport_to!(::EssentialManifold, Y, p, X, q)
    # group operation in the ambient group
    pq = [qe' * pe for (pe, qe) in zip(p, q)]
    # left translation
    copyto!(Y, [pqe * Xe * pqe' for (pqe, Xe) in zip(pq, X)])
    return Y
end

@doc raw"""
    vert_proj(M::EssentialManifold, p, X)

Project `X` onto the vertical space ``T_{\text{vp}}\text{SO}(3)^2`` with
````math
\text{vert\_proj}_p(X) = e_z^T(R_1 X_1 + R_2 X_2),
````
where ``e_z`` is the third unit vector, ``X_i ∈ T_{p}\text{SO}(3)`` for ``i=1,2,`` and it holds ``R_i = R_0 R'_i, i=1,2,`` where ``R'_i`` is part of the
pose of camera ``i`` ``g_i = (R_i,T'_i) ∈ \text{SE}(3)`` and ``R_0 ∈ \text{SO}(3)`` such that ``R_0(T'_2-T'_1) = e_z`` [TronDaniilidis:2017](@cite).
"""
function vert_proj(M::EssentialManifold, p, X)
    return sum(vert_proj.(Ref(M.manifold), p, X))
end
function vert_proj(M::Rotations{TypeParameter{Tuple{3}}}, p, X)
    return (p[3, :]' * get_coordinates(M, p, X, DefaultOrthogonalBasis()))
end

@doc raw"""
    GeneralizedStiefel{𝔽,T,B} <: AbstractDecoratorManifold{𝔽}

The Generalized Stiefel manifold consists of all ``n×k``, ``n\geq k`` orthonormal
matrices w.r.t. an arbitrary scalar product with symmetric positive definite matrix
``B\in R^{n×n}``, i.e.

````math
\operatorname{St}(n,k,B) = \bigl\{ p \in \mathbb F^{n×k}\ \big|\ p^{\mathrm{H}} B p = I_k \bigr\},
````

where ``𝔽 ∈ \{ℝ, ℂ\}``,
``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or Hermitian, and
``I_k \in \mathbb R^{k×k}`` denotes the ``k×k`` identity matrix.


In the case ``B=I_k`` one gets the usual [`Stiefel`](@ref) manifold.

The tangent space at a point ``p\in\mathcal M=\operatorname{St}(n,k,B)`` is given by

````math
T_p\mathcal M = \{ X \in 𝔽^{n×k} : p^{\mathrm{H}}BX + X^{\mathrm{H}}Bp=0_n\},
````
where ``0_k`` is the ``k×k`` zero matrix.

This manifold is modeled as an embedded manifold to the [`Euclidean`](@ref), i.e.
several functions like the [`zero_vector`](@ref) are inherited from the embedding.

The manifold is named after
[Eduard L. Stiefel](https://en.wikipedia.org/wiki/Eduard_Stiefel) (1909–1978).

# Constructor
    GeneralizedStiefel(n, k, B=I_n, F=ℝ)

Generate the (real-valued) Generalized Stiefel manifold of ``n×k`` dimensional
orthonormal matrices with scalar product `B`.
"""
struct GeneralizedStiefel{𝔽, T, TB <: AbstractMatrix} <: AbstractDecoratorManifold{𝔽}
    size::T
    B::TB
end

function GeneralizedStiefel(
        n::Int,
        k::Int,
        B::AbstractMatrix = Matrix{Float64}(I, n, n),
        𝔽::AbstractNumbers = ℝ;
        parameter::Symbol = :type,
    )
    size = wrap_type_parameter(parameter, (n, k))
    return GeneralizedStiefel{𝔽, typeof(size), typeof(B)}(size, B)
end

@doc raw"""
    check_point(M::GeneralizedStiefel, p; kwargs...)

Check whether `p` is a valid point on the [`GeneralizedStiefel`](@ref) `M`=``\operatorname{St}(n,k,B)``,
i.e. that it has the right [`AbstractNumbers`](@extref ManifoldsBase number-system) type and ``x^{\mathrm{H}}Bx``
is (approximately) the identity, where ``⋅^{\mathrm{H}}`` is the complex conjugate
transpose. The settings for approximately can be set with `kwargs...`.
"""
function check_point(M::GeneralizedStiefel, p; kwargs...)
    c = p' * M.B * p
    if !isapprox(c, one(c); kwargs...)
        return DomainError(
            norm(c - one(c)),
            "The point $(p) does not lie on $(M), because x'Bx is not the unit matrix.",
        )
    end
    return nothing
end

# overwrite passing to embedding
function check_size(M::GeneralizedStiefel, p::P) where {P}
    return check_size(get_embedding(M, P), p) #avoid embed, since it uses copyto!
end
function check_size(M::GeneralizedStiefel, p::P, X) where {P}
    return check_size(get_embedding(M, P), p, X) #avoid embed, since it uses copyto!
end

@doc raw"""
    check_vector(M::GeneralizedStiefel, p, X; kwargs...)

Check whether `X` is a valid tangent vector at `p` on the [`GeneralizedStiefel`](@ref)
`M`=``\operatorname{St}(n,k,B)``, i.e. the [`AbstractNumbers`](@extref ManifoldsBase number-system) fits,
`p` is a valid point on `M` and
it (approximately) holds that ``p^{\mathrm{H}}BX + \overline{X^{\mathrm{H}}Bp} = 0``, where
`kwargs...` is passed to the `isapprox`.
"""
function check_vector(M::GeneralizedStiefel, p, X; kwargs...)
    if !isapprox(p' * M.B * X, -conj(X' * M.B * p); kwargs...)
        return DomainError(
            norm(p' * M.B * X + conj(X' * M.B * p)),
            "The matrix $(X) does not lie in the tangent space of $(p) on $(M), since x'Bv + v'Bx is not the zero matrix.",
        )
    end
    return nothing
end

function get_embedding(::GeneralizedStiefel{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return Euclidean(n, k; field = 𝔽)
end
function get_embedding(M::GeneralizedStiefel{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return Euclidean(n, k; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::GeneralizedStiefel)
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    inner(M::GeneralizedStiefel, p, X, Y)

Compute the inner product for two tangent vectors `X`, `Y` from the tangent space of `p`
on the [`GeneralizedStiefel`](@ref) manifold `M`. The formula reads

````math
(X, Y)_p = \operatorname{trace}(v^{\mathrm{H}}Bw),
````
i.e. the metric induced by the scalar product `B` from the embedding, restricted to the
tangent space.
"""
inner(M::GeneralizedStiefel, p, X, Y) = dot(X, M.B, Y)

"""
    is_flat(M::GeneralizedStiefel)

Return true if [`GeneralizedStiefel`](@ref) `M` is one-dimensional.
"""
is_flat(M::GeneralizedStiefel) = manifold_dimension(M) == 1

@doc raw"""
    manifold_dimension(M::GeneralizedStiefel)

Return the dimension of the [`GeneralizedStiefel`](@ref) manifold `M`=``\operatorname{St}(n,k,B,𝔽)``.
The dimension is given by

````math
\begin{aligned}
\dim \mathrm{St}(n, k, B, ℝ) &= nk - \frac{1}{2}k(k+1) \\
\dim \mathrm{St}(n, k, B, ℂ) &= 2nk - k^2\\
\dim \mathrm{St}(n, k, B, ℍ) &= 4nk - k(2k-1)
\end{aligned}
````
"""
function manifold_dimension(M::GeneralizedStiefel{ℝ})
    n, k = get_parameter(M.size)
    return n * k - div(k * (k + 1), 2)
end
function manifold_dimension(M::GeneralizedStiefel{ℂ})
    n, k = get_parameter(M.size)
    return 2 * n * k - k * k
end
function manifold_dimension(M::GeneralizedStiefel{ℍ})
    n, k = get_parameter(M.size)
    return 4 * n * k - k * (2k - 1)
end

@doc raw"""
    project(M::GeneralizedStiefel, p)

Project `p` from the embedding onto the [`GeneralizedStiefel`](@ref) `M`, i.e. compute `q`
as the polar decomposition of ``p`` such that ``q^{\mathrm{H}}Bq`` is the identity,
where ``⋅^{\mathrm{H}}`` denotes the hermitian, i.e. complex conjugate transposed.
"""
project(::GeneralizedStiefel, ::Any)

function project!(M::GeneralizedStiefel, q, p)
    s = svd(p)
    e = eigen(s.U' * M.B * s.U)
    qsinv = e.vectors ./ sqrt.(transpose(e.values))
    q .= s.U * qsinv * e.vectors' * s.V'
    return q
end

@doc raw"""
    project(M:GeneralizedStiefel, p, X)

Project `X` onto the tangent space of `p` to the [`GeneralizedStiefel`](@ref) manifold `M`.
The formula reads

````math
\operatorname{proj}_{\operatorname{St}(n,k)}(p,X) = X - p\operatorname{Sym}(p^{\mathrm{H}}BX),
````

where ``\operatorname{Sym}(y)`` is the symmetrization of ``y``, e.g. by
``\operatorname{Sym}(y) = \frac{y^{\mathrm{H}}+y}{2}``.
"""
project(::GeneralizedStiefel, ::Any, ::Any)

function project!(M::GeneralizedStiefel, Y, p, X)
    A = p' * M.B' * X
    copyto!(Y, X)
    mul!(Y, p, Hermitian((A .+ A') ./ 2), -1, 1)
    return Y
end

@doc raw"""
    rand(::GeneralizedStiefel; vector_at=nothing, σ::Real=1.0)

When `vector_at` is `nothing`, return a random (Gaussian) point `p` on the [`GeneralizedStiefel`](@ref)
manifold `M` by generating a (Gaussian) matrix with standard deviation `σ` and return the
(generalized) orthogonalized version, i.e. return the projection onto the manifold of the
Q component of the QR decomposition of the random matrix of size ``n×k``.

When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_{vector\_at}\mathrm{St}(n,k)`` with mean zero and standard deviation `σ` by projecting a
random Matrix onto the tangent vector at `vector_at`.
"""
rand(::GeneralizedStiefel; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::GeneralizedStiefel{ℝ},
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
    )
    n, k = get_parameter(M.size)
    if vector_at === nothing
        A = σ * randn(rng, eltype(pX), n, k)
        project!(M, pX, Matrix(qr(A).Q))
    else
        Z = σ * randn(rng, eltype(pX), size(pX))
        project!(M, pX, vector_at, Z)
        normalize!(pX)
    end
    return pX
end

@doc raw"""
    retract(M::GeneralizedStiefel, p, X)
    retract(M::GeneralizedStiefel, p, X, ::PolarRetraction)
    retract(M::GeneralizedStiefel, p, X, ::ProjectionRetraction)

Compute the SVD-based retraction [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`GeneralizedStiefel`](@ref) manifold `M`, which in this case is the same as
the projection based retraction employing the exponential map in the embedding
and projecting the result back to the manifold.

The default retraction for this manifold is the [`ProjectionRetraction`](@extref `ManifoldsBase.ProjectionRetraction`).
"""
retract(::GeneralizedStiefel, ::Any...)

default_retraction_method(::GeneralizedStiefel) = ProjectionRetraction()

function ManifoldsBase.retract_polar!(M::GeneralizedStiefel, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_polar_fused!(M::GeneralizedStiefel, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

function ManifoldsBase.retract_project!(M::GeneralizedStiefel, q, p, X)
    return ManifoldsBase.retract_project_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_project_fused!(M::GeneralizedStiefel, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

function Base.show(io::IO, M::GeneralizedStiefel{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return print(io, "GeneralizedStiefel($(n), $(k), $(M.B), $(𝔽))")
end
function Base.show(io::IO, M::GeneralizedStiefel{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return print(io, "GeneralizedStiefel($(n), $(k), $(M.B), $(𝔽); parameter=:field)")
end

@doc raw"""
    Oblique{𝔽, T, S} <: AbstractPowerManifold{𝔽}

The oblique manifold ``\mathcal{OB}(n,m)`` is the set of 𝔽-valued matrices with unit norm
column endowed with the metric from the embedding. This yields exactly the same metric as
considering the product metric of the unit norm vectors, i.e. [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of the
``(n-1)``-dimensional [`Sphere`](@ref).

The [`Sphere`](@ref) is stored internally within `M.manifold`, such that all functions of
[`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  can be used directly.

# Constructor

    Oblique(n::Int, m::Int, field::AbstractNumbers=ℝ; parameter::Symbol=:type)

Generate the manifold of matrices ``\mathbb R^{n×m}`` such that the ``m`` columns are unit
vectors, i.e. from the [`Sphere`](@ref)`(n-1)`.
"""
struct Oblique{𝔽, T, S} <: AbstractPowerManifold{𝔽, Sphere{𝔽, S}, ArrayPowerRepresentation}
    size::T
    manifold::Sphere{𝔽, S}
end

function Oblique(n::Int, m::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    sphere = Sphere(n - 1, field; parameter = parameter)
    size = wrap_type_parameter(parameter, (n, m))
    return Oblique{field, typeof(size), typeof(sphere).parameters[2]}(size, sphere)
end

function Base.:^(::Sphere{𝔽, TypeParameter{Tuple{N}}}, m::Int) where {N, 𝔽}
    return Oblique(N + 1, m, 𝔽)
end
function Base.:^(M::Sphere{𝔽, Tuple{Int}}, m::Int) where {𝔽}
    N = M.size[1]
    return Oblique(N + 1, m, 𝔽; parameter = :field)
end

@doc raw"""
    check_point(M::Oblique, p)

Checks whether `p` is a valid point on the [`Oblique`](@ref)`{m,n}` `M`, i.e. is a matrix
of `m` unit columns from ``\mathbb R^{n}``, i.e. each column is a point from
[`Sphere`](@ref)`(n-1)`.
"""
check_point(::Oblique, ::Any)
function check_point(M::Oblique, p; kwargs...)
    n, m = get_parameter(M.size)
    return check_point(PowerManifold(M.manifold, m), p; kwargs...)
end
@doc raw"""
    check_vector(M::Oblique p, X; kwargs...)

Checks whether `X` is a valid tangent vector to `p` on the [`Oblique`](@ref) `M`.
This means, that `p` is valid, that `X` is of correct dimension and columnswise
a tangent vector to the columns of `p` on the [`Sphere`](@ref).
"""
function check_vector(M::Oblique, p, X; kwargs...)
    n, m = get_parameter(M.size)
    return check_vector(PowerManifold(M.manifold, m), p, X; kwargs...)
end

get_iterator(M::Oblique) = Base.OneTo(get_parameter(M.size)[2])

function manifold_dimension(M::Oblique{𝔽}) where {𝔽}
    n, m = get_parameter(M.size)
    return (n * real_dimension(𝔽) - 1) * m
end
power_dimensions(M::Oblique) = get_parameter(M.size)[2]

representation_size(M::Oblique) = get_parameter(M.size)

@doc raw"""
    parallel_transport_to(M::Oblique, p, X, q)

Compute the parallel transport on the [`Oblique`](@ref) manifold by
doing a column wise parallel transport on the [`Sphere`](@ref)

"""
parallel_transport_to(::Oblique, p, X, q)

function Base.show(io::IO, ::Oblique{𝔽, TypeParameter{Tuple{n, m}}}) where {n, m, 𝔽}
    return print(io, "Oblique($(n), $(m); field=$(𝔽))")
end
function Base.show(io::IO, M::Oblique{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, m = get_parameter(M.size)
    return print(io, "Oblique($(n), $(m); field=$(𝔽), parameter=:field)")
end

@doc raw"""
     OrthogonalMatrices{n} = GeneralUnitaryMatrices{ℝ, n, AbsoluteDeterminantOneMatrixType}

The manifold of (real) orthogonal ``n×n`` matrices ``\mathrm{O}(n)``. They are precisely the ``n×n`` real matrices ``M`` that satisfy

```math
    M^{T}M=MM^{T}= \mathrm{I}_n,
```
where ``M^{T}`` is the transpose of ``M`` and ``\mathrm{I}_n`` is the ``n×n`` identity matrix. Thus, their columns and rows represent ``n`` pairwise orthonormal vectors. Such matrices ``M`` have the property that ``\lVert \det(M) \rVert = 1``.

This is the same manifold as the [`Stiefel`](@ref)`(n, n, ℂ)` manifold.

# Constructor

    OrthogonalMatrices(n)
"""
const OrthogonalMatrices{n} = GeneralUnitaryMatrices{ℝ, n, AbsoluteDeterminantOneMatrixType}

function OrthogonalMatrices(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return OrthogonalMatrices{typeof(size)}(size)
end

function Random.rand!(
        rng::AbstractRNG,
        M::OrthogonalMatrices,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)),
    )
    if vector_at === nothing
        # Special case: Rotations(1) is just zero-dimensional
        (manifold_dimension(M) == 0) && return fill!(pX, rand(rng, (-1, 1)))
        A = randn(rng, representation_size(M))
        s = diag(sign.(qr(A).R))
        D = Diagonal(s)
        pX .= qr(A).Q * D
    else
        # Special case: Rotations(1) is just zero-dimensional
        (manifold_dimension(M) == 0) && return fill!(pX, 0)
        A = σ .* randn(rng, representation_size(M))
        pX .= triu(A, 1) .- transpose(triu(A, 1))
        normalize!(pX)
    end
    return pX
end

function Base.show(io::IO, ::OrthogonalMatrices{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "OrthogonalMatrices($(n))")
end
function Base.show(io::IO, M::OrthogonalMatrices{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "OrthogonalMatrices($n; parameter=:field)")
end

include("../header.jl")

@testset "Oblique manifold" begin
    M = Oblique(3, 2)
    @testset "Oblique manifold Basics" begin
        @test Sphere(2)^3 === Oblique(3, 3)
        @test Sphere(2)^(3,) === PowerManifold(Sphere(2), 3)
        @test ^(Sphere(2), 2) === Oblique(3, 2)
        @test typeof(^(Sphere(2), 2)) ==
            Oblique{ℝ, TypeParameter{Tuple{3, 2}}, TypeParameter{Tuple{2}}}
        @test repr(M) == "Oblique(3, 2; field=ℝ)"
        @test representation_size(M) == (3, 2)
        @test manifold_dimension(M) == 4
        @test !is_flat(M)
        p = [2, 0, 0]
        p2 = [p p]
        @test !is_point(M, p)
        @test_throws DomainError is_point(M, p; error = :error)
        @test !is_point(M, p2)
        @test_throws CompositeManifoldError is_point(M, p2; error = :error)
        @test !is_vector(M, p2, 0.0)
        @test_throws CompositeManifoldError{ComponentManifoldError{Int64, DomainError}} is_vector(
            M,
            p2,
            [0.0, 0.0, 0.0];
            error = :error,
        )
        @test !is_vector(M, p2, [0.0, 0.0, 0.0])
        @test_throws DomainError is_vector(M, p, [0.0, 0.0, 0.0]; error = :error) # p wrong
        @test injectivity_radius(M) ≈ π
        x = [1.0 0.0 0.0; 1.0 0.0 0.0]'
        @test_throws DomainError is_vector(M, x, [0.0, 0.0, 0.0]; error = :error) # tangent wrong
        y = [1.0 0.0 0.0; 1 / sqrt(2) 1 / sqrt(2) 0.0]'
        z = [1 / sqrt(2) 1 / sqrt(2) 0.0; 1.0 0.0 0.0]'
        basis_types = (DefaultOrthonormalBasis(),)
        transports = [ParallelTransport()]
        Manifolds.test_manifold(
            M,
            [x, y, z],
            test_vector_spaces = true,
            test_project_tangent = false,
            test_musical_isomorphisms = true,
            test_default_vector_transport = true,
            vector_transport_methods = transports,
            basis_types_to_from = basis_types,
            exp_log_atol_multiplier = 1,
            is_tangent_atol_multiplier = 1,
            test_inplace = true,
        )
    end
    @testset "field parameter" begin
        @test typeof(^(Sphere(2; parameter = :field), 2)) ==
            Oblique{ℝ, Tuple{Int, Int}, Tuple{Int}}

        M = Oblique(3, 2; parameter = :field)
        @test repr(M) == "Oblique(3, 2; field=ℝ, parameter=:field)"
    end
end

@doc raw"""
    DeterminantOneMatrices{𝔽,T} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)
consisting of the real- or complex-valued (invertible) matrices od determinant one,
that is the set

```math
\bigl\{p  ∈ 𝔽^{n×n}\ \big|\ \det(p) = 1 \bigr\},
```
where the field ``𝔽 ∈ \{ ℝ, ℂ\}``.

Note that this is a subset of [`InvertibleMatrices`](@ref),
and a superset of any of the [`GeneralUnitaryMatrices`](@ref)

The tangent space at any point `p` is the set of matrices with trace 0.

# Constructor

    DeterminantOneMatrices(n::Int, field::AbstractNumbers=ℝ)

Generate the manifold of ``n×n`` matrices of determinant one.
"""
struct DeterminantOneMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function DeterminantOneMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return DeterminantOneMatrices{field, typeof(size)}(size)
end

@doc raw"""
    check_point(M::DeterminantOneMatrices{n,𝔽}, p; kwargs...)

Check whether `p` is a valid manifold point on the [`DeterminantOneMatrices`](@ref) `M`, i.e.
whether `p` has a determinant of ``1``.

The check is performed with `isapprox` and all keyword arguments are passed to this
"""
function check_point(M::DeterminantOneMatrices, p; kwargs...)
    if !isapprox(det(p), 1; kwargs...)
        return DomainError(
            det(p),
            "The point $(p) does not lie on $(M), since its determinant is $(det(p)) and not 1.",
        )
    end
    return nothing
end

"""
    check_vector(M::DeterminantOneMatrices{n,𝔽}, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`DeterminantOneMatrices`](@ref) `M`, which are all matrices of size ``n×n``
with trace 0.
"""
function check_vector(M::DeterminantOneMatrices, p, X; kwargs...)
    if !isapprox(tr(X), 0; kwargs...)
        return DomainError(
            tr(X),
            "The tangent vector $(X) does not lie in the Tangent space at $(p) of $(M), since its trace is $(tr(X)) and not zero.",
        )
    end
    return nothing
end

embed(::DeterminantOneMatrices, p) = p
embed(::DeterminantOneMatrices, p, X) = X

function get_embedding(::DeterminantOneMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return Euclidean(n, n; field = 𝔽)
end
function get_embedding(M::DeterminantOneMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return Euclidean(n, n; field = 𝔽, parameter = :field)
end
function ManifoldsBase.get_embedding_type(::DeterminantOneMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

@doc raw"""
    manifold_dimension(M::DeterminantOneMatrices{n,𝔽})

Return the dimension of the [`DeterminantOneMatrices`](@ref) matrix `M` over the number system
`𝔽`, which is one dimension less than its embedding, the [`Euclidean`](@ref)`(n, n; field=𝔽)`.
"""
function manifold_dimension(M::DeterminantOneMatrices{<:Any, 𝔽}) where {𝔽}
    return manifold_dimension(get_embedding(M)) - 1
end

@doc raw"""
    project(G::DeterminantOneMatrices, p)
    project!(G::DeterminantOneMatrices, q, p)

Project ``p ∈ \mathrm{GL}(n, 𝔽)`` to the [`DeterminantOneMatrices`](@ref)
using the singular value decomposition of ``p = U S V^\mathrm{H}``.

The formula for the projection is

````math
\operatorname{proj}(p) = U S D V^\mathrm{H},
````
where

````math
D_{ij} = δ_{ij} \begin{cases}
    1            & \text{ if } i ≠ n \\
    \det(p)^{-1} & \text{ if } i = n
\end{cases}.
````

The operation can be done in-place of `q`.
"""
project(::DeterminantOneMatrices, p)

function project!(M::DeterminantOneMatrices, q, p)
    n = get_parameter(M.size)[1]
    detp = det(p)
    isapprox(detp, 1) && return copyto!(q, p)
    F = svd(p)
    q .= F.U .* F.S'
    q[:, n] ./= detp
    mul!_safe(q, q, F.Vt)
    return q
end

@doc raw"""
    project(G::DeterminantOneMatrices, p, X)
    project!(G::DeterminantOneMatrices, Y, p, X)

Orthogonally project ``X ∈ 𝔽^{n×n}`` onto the tangent space of ``p`` to the
[`DeterminantOneMatrices`](@ref).

This first changes the representation from `X` to the trace-zero component, i.e.
computes `Y = p \ X` and then subtracts `c = tr(Y) / n` from all diagonal entries.
"""
project(::DeterminantOneMatrices, p, X)

function project!(G::DeterminantOneMatrices, Y, p, X)
    n = get_parameter(G.size)[1]
    Y .= p \ X
    c = tr(Y) / n
    Y[diagind(n, n)] .-= c
    return Y
end

@doc raw"""
    Random.rand(M::DeterminantOneMatrices; vector_at=nothing, kwargs...)

If `vector_at` is `nothing`, return a random point on the [`DeterminantOneMatrices`](@ref)
manifold `M` by using `rand` in the embedding.

If `vector_at` is not `nothing`, return a random tangent vector from the tangent space of
the point `vector_at` on the [`DeterminantOneMatrices`](@ref) by using by using `rand` in the
embedding.
"""
rand(M::DeterminantOneMatrices; kwargs...)

function Random.rand!(M::DeterminantOneMatrices, pX; kwargs...)
    return rand!(Random.default_rng(), M, pX; kwargs...)
end
function Random.rand!(
        rng::AbstractRNG,
        M::DeterminantOneMatrices,
        pX;
        vector_at = nothing,
        kwargs...,
    )
    rand!(rng, get_embedding(M), pX; kwargs...)
    if vector_at === nothing # for points ensure invertibility
        n = size(pX)[1]
        _ensure_nonzero_rng_determinant!(rng, get_embedding(M), pX; kwargs...)
        det_pX = det(pX)
        pX[1, :] ./= sign(det_pX)
        pX ./= abs(det_pX)^(1 / n)
    else # tangent vectors: trace 0
        pX[diagind(pX)] .= 0
    end
    return pX
end

function Base.show(io::IO, ::DeterminantOneMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "DeterminantOneMatrices($(n), $(𝔽))")
end
function Base.show(io::IO, M::DeterminantOneMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "DeterminantOneMatrices($(n), $(𝔽); parameter=:field)")
end

using LinearAlgebra, Manifolds, Quaternions, Test, ManifoldsBase, StaticArrays

@testset "Unitary Matrices" begin
    M = UnitaryMatrices(2)
    p1 = [1im 0.0; 0.0 1im]
    X1 = [0.0 1.0; -1.0 0.0]
    p2 = project(M, ones(2, 2))
    p3 = project(M, 1im * ones(2, 2))

    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                default_vector_transport_method,
                get_embedding,
                is_flat,
                project,
                rand, repr,
                # Weingarten, # TODO: V is not normal?!
                riemannian_Hessian,
            ],
            :EmbeddedPoints => [ones(2, 2), 1im .* ones(2, 2), [2im 0.0; 0.0 2im]],
            :EmbeddedVectors => [[2im 0.0; 1.0 2im]],
            :NormalVectors => [[1.0 0.0; 1.0 0.0]],
            :Points => [p1],
            :Vectors => [X1],
            :Bases => [DefaultOrthonormalBasis()],
            :InvalidPoints => [zeros(1), zeros(3, 3), 1 / 2 .* [1im 1im; -1im 1im], [1im 1.0; 0.0 -1im]],
            :InvalidVectors => [zeros(1), zeros(3, 3), ones(2, 2)],
            :RetractionMethods => [PolarRetraction()],
        ),
        Dict(
            default_vector_transport_method => ProjectionTransport(),
            get_embedding => Euclidean(2, 2; field = ℂ),
            is_flat => false,
            manifold_dimension => 4,
            repr => "UnitaryMatrices(2)",
            injectivity_radius => π,
        )
    )

    @testset "Field parameter" begin
        MF = UnitaryMatrices(2; parameter = :field)
        @test repr(MF) ==
            "UnitaryMatrices(2; parameter=:field)"

        @test get_embedding(MF) === Euclidean(2, 2; field = ℂ, parameter = :field)
    end

    @testset "Fused exp" begin
        r = exp(M, p1, X1)
        X2 = log(M, p1, r)
        @test isapprox(M, p1, X1, X2)
        r1 = Manifolds.exp_fused(M, p1, X1, 1.0)
        @test isapprox(M, r, r1; atol = 1.0e-10)
    end

    @testset "Orthonormal coordinates (U(3))" begin
        M3 = UnitaryMatrices(3)
        p3 = Matrix{ComplexF64}(I, 3, 3)
        c3 = collect(1.0:9.0)

        X3 = zeros(ComplexF64, 3, 3)
        ManifoldsBase.get_vector_orthonormal!(M3, X3, p3, c3, ℝ)
        @test is_vector(M3, p3, X3; error = :error)

        c3r = zeros(9)
        ManifoldsBase.get_coordinates_orthonormal!(M3, c3r, p3, X3, ℝ)
        @test c3r ≈ c3

        @test get_vector(M3, p3, c3, DefaultOrthonormalBasis(ℝ)) ≈ X3
        @test get_coordinates(M3, p3, X3, DefaultOrthonormalBasis(ℝ)) ≈ c3
    end

    @testset "Projection with points outside of the manifold" begin
        M = UnitaryMatrices(2)
        pE = [2im 0.0; 0.0 2im]
        p = project(M, pE)
        @test is_point(M, p; error = :error)
        pE[2, 1] = 1.0
        X = project(M, p, pE)
        @test is_vector(M, p, X; error = :error)
    end

    @testset "gradient and metric conversion" begin
        Xm = change_metric(M, EuclideanMetric(), p1, X1)
        @test Xm == X1
        Xr = change_representer(M, EuclideanMetric(), p1, X1)
        @test Xr == X1
    end

    @testset "Riemannian Hessian" begin
        p = Matrix{Float64}(I, 2, 2)
        X = [0.0 3.0; -3.0 0.0]
        V = [1.0 0.0; 1.0 0.0]
        @test Weingarten(M, p, X, V) == -1 / 2 * p * (V' * X - X' * V)
        G = [0.0 1.0; 0.0 0.0]
        H = [0.0 0.0; 2.0 0.0]
        @test riemannian_Hessian(M, p, G, H, X) == [0.0 -1.0; 1.0 0.0]
    end

    @test is_flat(UnitaryMatrices(1))
    @test is_flat(UnitaryMatrices(1; parameter = :field))

    @testset "manifold_volume" begin
        @test manifold_volume(UnitaryMatrices(1)) ≈ 2 * π
        @test manifold_volume(UnitaryMatrices(2)) ≈ 4 * π^3
        @test manifold_volume(UnitaryMatrices(3)) ≈ sqrt(3) * 2 * π^6
        @test manifold_volume(UnitaryMatrices(4)) ≈ sqrt(2) * 8 * π^10 / 12
    end

    @testset "Polar retraction" begin
        # Test that check_det is not passed to project in UnitaryMatrices
        M = UnitaryMatrices(8)
        t = 0.3
        p = rand(M)
        X = 0.25 .* rand(M; vector_at = p)
        q = similar(p)

        ManifoldsBase.retract_fused!(M, q, p, X, t, PolarRetraction())
        @test is_point(M, q)
    end

end

@testset "Quaternionic unitary matrices" begin
    MH = UnitaryMatrices(1, ℍ)
    pH = QuaternionF64(1.0, 0.0, 0.0, 0.0)
    pH2 = QuaternionF64(0.0, 1.0, 0.0, 0.0)
    XH = QuaternionF64(0.0, 0.2, 0.2, 0.3)
    pHF = [quat(0, 1, 0, 0) 1.0; 0.0 -quat(0, 1, 0, 0)]
    PHE = QuaternionF64(-0.2178344173900564, -0.4072721993877449, -2.2484219560115712, -0.4718862793239344)
    Manifolds.Test.test_manifold(
        MH,
        Dict(
            :Functions => [
                default_vector_transport_method,
                exp,
                get_embedding,
                injectivity_radius, is_flat,
                log,
                project,
                rand, repr,
            ],
            :EmbeddedPoints => [PHE],
            :Points => [pH, pH2],
            :Vectors => [XH],
            :InvalidPoints => [pHF, zeros(2, 2)],
            :InvalidVectors => [Quaternion(1, 0, 0, 0), zeros(2, 2)],
            :Mutating => false,
        ),
        Dict(
            default_vector_transport_method => ProjectionTransport(),
            get_embedding => Euclidean(1, 1; field = ℍ),
            is_flat => false,
            manifold_dimension => 3,
            repr => "UnitaryMatrices(1, ℍ)",
            injectivity_radius => π,
        )
    )

    @testset "Field parameter" begin
        MHF = UnitaryMatrices(1, ℍ; parameter = :field)
        @test repr(MHF) ==
            "UnitaryMatrices(1, ℍ; parameter=:field)"

        @test get_embedding(MHF) === Euclidean(1, 1; field = ℍ, parameter = :field)
    end

    @testset "Fused exp" begin
        p = QuaternionF64(1.0, 0.0, 0.0, 0.0)
        X = QuaternionF64(0.1, 0.2, 0.2, 0.3)
        q = exp(MH, p, X)
        q2 = Manifolds.exp_fused(MH, p, X, 1.0)
        @test isapprox(MH, q, q2)
        # test that log also works fine
        X2 = log(MH, p, q)
        @test isapprox(MH, p, X, X2)
    end

    @testset "Matrix point" begin
        p = QuaternionF64(
            0.4815296357756736,
            0.6041613272484806,
            -0.2322369798903669,
            0.5909181717450419,
        )

        @test is_point(MH, fill(p, 1, 1))
        @test is_point(MH, p)
    end

    @testset "Functions with specific expectation" begin
        p = QuaternionF64(
            0.4815296357756736,
            0.6041613272484806,
            -0.2322369798903669,
            0.5909181717450419,
        )
        pu = QuaternionF64(
            -0.2178344173900564,
            -0.4072721993877449,
            -2.2484219560115712,
            -0.4718862793239344,
        )
        q = project(MH, pu)
        @test is_point(MH, q)
        @test isapprox(q, sign(pu))

        @test get_coordinates(MH, p, Quaternion(0, 1, 2, 3), DefaultOrthonormalBasis(ℝ)) ==
            SA[1, 2, 3]
        @test get_vector(MH, p, SA[1, 2, 3], DefaultOrthonormalBasis(ℝ)) ==
            Quaternion(0, 1, 2, 3)
        @test number_of_coordinates(MH, DefaultOrthonormalBasis(ℍ)) == 3

        @test get_basis(MH, p, DefaultOrthonormalBasis(ℝ)).data == [
            Quaternion(0.0, 1.0, 0.0, 0.0),
            Quaternion(0.0, 0.0, 1.0, 0.0),
            Quaternion(0.0, 0.0, 0.0, 1.0),
        ]
    end
end

@doc raw"""
    Elliptope{T} <: AbstractDecoratorManifold{ℝ}

The Elliptope manifold, also known as the set of correlation matrices, consists of all
symmetric positive semidefinite matrices of rank ``k`` with unit diagonal, i.e.,

````math
\begin{aligned}
\mathcal E(n,k) =
\bigl\{p ∈ ℝ^{n×n}\ \big|\ &a^\mathrm{T}pa \geq 0 \text{ for all } a ∈ ℝ^{n},\\
&p_{ii} = 1 \text{ for all } i=1,\ldots,n,\\
&\text{and } p = qq^{\mathrm{T}} \text{ for } q \in  ℝ^{n×k} \text{ with } \operatorname{rank}(p) = \operatorname{rank}(q) = k
\bigr\}.
\end{aligned}
````

And this manifold is working solely on the matrices ``q``. Note that this ``q`` is not unique,
indeed for any orthogonal matrix ``A`` we have ``(qA)(qA)^{\mathrm{T}} = qq^{\mathrm{T}} = p``,
so the manifold implemented here is the quotient manifold. The unit diagonal translates to
unit norm columns of ``q``.

The tangent space at ``p``, denoted ``T_p\mathcal E(n,k)``, is also represented by matrices
``Y\in ℝ^{n×k}`` and reads as

````math
T_p\mathcal E(n,k) = \bigl\{
X ∈ ℝ^{n×n}\,|\,X = qY^{\mathrm{T}} + Yq^{\mathrm{T}} \text{ with } X_{ii} = 0 \text{ for } i=1,\ldots,n
\bigr\}
````
endowed with the [`Euclidean`](@ref) metric from the embedding, i.e. from the ``ℝ^{n×k}``


This manifold was for example
investigated in[JourneeBachAbsilSepulchre:2010](@cite).

# Constructor

    Elliptope(n::Int, k::Int; parameter::Symbol=:type)

generates the manifold ``\mathcal E(n,k) \subset ℝ^{n×n}``.

`parameter`: whether a type parameter should be used to store `n` and `k`. By default size
is stored in type. Value can either be `:field` or `:type`.
"""
struct Elliptope{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function Elliptope(n::Int, k::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return Elliptope{typeof(size)}(size)
end

@doc raw"""
    check_point(M::Elliptope, q; kwargs...)

checks, whether `q` is a valid representation of a point ``p=qq^{\mathrm{T}}`` on the
[`Elliptope`](@ref) `M`, i.e. is a matrix
of size `(N,K)`, such that ``p`` is symmetric positive semidefinite and has unit trace.
Since by construction ``p`` is symmetric, this is not explicitly checked.
Since ``p`` is by construction positive semidefinite, this is not checked.
The tolerances for positive semidefiniteness and unit trace can be set using the `kwargs...`.
"""
function check_point(M::Elliptope, q; kwargs...)
    row_norms_sq = sum(abs2, q; dims = 2)
    if !all(isapprox.(row_norms_sq, 1.0; kwargs...))
        return DomainError(
            row_norms_sq,
            "The point $(q) does not represent a point p=qq^T on $(M) diagonal is not only ones.",
        )
    end
    return nothing
end

@doc raw"""
    check_vector(M::Elliptope, q, Y; kwargs... )

Check whether ``X = qY^{\mathrm{T}} + Yq^{\mathrm{T}}`` is a tangent vector to
``p=qq^{\mathrm{T}}`` on the [`Elliptope`](@ref) `M`,
i.e. `Y` has to be of same dimension as `q` and a ``X`` has to be a symmetric matrix with
zero diagonal.

The tolerance for the base point check and zero diagonal can be set using the `kwargs...`.
Note that symmetric of ``X`` holds by construction an is not explicitly checked.
"""
function check_vector(
        M::Elliptope,
        q,
        Y::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    X = q * Y' + Y * q'
    n = diag(X)
    if !all(isapprox.(n, 0.0; atol = atol, kwargs...))
        return DomainError(
            n,
            "The vector $(X) is not a tangent to a point on $(M) (represented py $(q) and $(Y), since its diagonal is nonzero.",
        )
    end
    return nothing
end

function get_embedding(::Elliptope{TypeParameter{Tuple{n, k}}}) where {n, k}
    return Euclidean(n, k)
end
function get_embedding(M::Elliptope{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return Euclidean(n, k; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::Elliptope)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

"""
    is_flat(::Elliptope)

Return false. [`Elliptope`](@ref) is not a flat manifold.
"""
is_flat(M::Elliptope) = false

@doc raw"""
    manifold_dimension(M::Elliptope)

returns the dimension of
[`Elliptope`](@ref) `M` ``=\mathcal E(n,k), n,k ∈ ℕ``, i.e.
````math
\dim \mathcal E(n,k) = n(k-1) - \frac{k(k-1)}{2}.
````
"""
function manifold_dimension(M::Elliptope)
    N, K = get_parameter(M.size)
    return N * (K - 1) - div(K * (K - 1), 2)
end

"""
    project(M::Elliptope, q)

project `q` onto the manifold [`Elliptope`](@ref) `M`, by normalizing the rows of `q`.
"""
project(::Elliptope, ::Any)

project!(::Elliptope, r, q) = copyto!(r, q ./ (sqrt.(sum(abs2, q, dims = 2))))
project(::Elliptope, q) = q ./ (sqrt.(sum(abs2, q, dims = 2)))

"""
    project(M::Elliptope, q, Y)

Project `Y` onto the tangent space at `q`, i.e. row-wise onto the oblique manifold.
"""
project(::Elliptope, ::Any...)

function project!(::Elliptope, Z, q, Y)
    Y2 = (Y' - q' .* sum(q' .* Y', dims = 1))'
    Z .= Y2 - q * lyap(q' * q, q' * Y2 - Y2' * q)
    return Z
end

@doc raw"""
    retract(M::Elliptope, q, Y, ::ProjectionRetraction)

compute a projection based retraction by projecting ``q+Y`` back onto the manifold.
"""
retract(::Elliptope, ::Any, ::Any, ::ProjectionRetraction)

function retract_project!(M::Elliptope, r, q, Y)
    return ManifoldsBase.retract_project_fused!(M, r, q, Y, one(eltype(q)))
end

function ManifoldsBase.retract_project_fused!(M::Elliptope, r, q, Y, t::Number)
    r .= q .+ t .* Y
    project!(M, r, r)
    return r
end

@doc raw"""
    representation_size(M::Elliptope)

Return the size of an array representing an element on the
[`Elliptope`](@ref) manifold `M`, i.e. ``n×k``, the size of such factor of ``p=qq^{\mathrm{T}}``
on ``\mathcal M = \mathcal E(n,k)``.
"""
representation_size(M::Elliptope) = get_parameter(M.size)

function Base.show(io::IO, ::Elliptope{TypeParameter{Tuple{n, k}}}) where {n, k}
    return print(io, "Elliptope($(n), $(k))")
end
function Base.show(io::IO, M::Elliptope{Tuple{Int, Int}})
    n, k = get_parameter(M.size)
    return print(io, "Elliptope($(n), $(k); parameter=:field)")
end

"""
    vector_transport_to(M::Elliptope, p, X, q)

transport the tangent vector `X` at `p` to `q` by projecting it onto the tangent space
at `q`.
"""
vector_transport_to(::Elliptope, ::Any, ::Any, ::Any, ::ProjectionTransport)
vector_transport_to_project!(M::Elliptope, Y, p, X, q) = project!(M, Y, q, X)

@doc raw"""
    zero_vector(M::Elliptope,p)

returns the zero tangent vector in the tangent space of the symmetric positive
definite matrix `p` on the [`Elliptope`](@ref) manifold `M`.
"""
zero_vector(::Elliptope, ::Any...)

zero_vector!(::Elliptope, X, ::Any) = fill!(X, 0)

@doc raw"""
    Hyperrectangle{T} <: AbstractManifold{ℝ}

Hyperrectangle, also known as orthotope or box. This is a manifold with corners [Joyce:2010](@cite)
with the standard Euclidean metric.

# Constructor

    Hyperrectangle(lb::AbstractArray, ub::AbstractArray)

Generate the hyperrectangle of arrays such that each element of the array is between lower
and upper bound with the same index.
"""
struct Hyperrectangle{T <: AbstractArray} <: AbstractDecoratorManifold{ℝ}
    lb::T
    ub::T
    function Hyperrectangle(lb::T, ub::T) where {T <: AbstractArray}
        for i in eachindex(lb, ub)
            if lb[i] > ub[i]
                throw(
                    ArgumentError(
                        "Lower bound at index $i ($(lb[i])) is greater than the upper bound ($(ub[i]))",
                    ),
                )
            end
        end
        return new{T}(lb, ub)
    end
end

function check_point(M::Hyperrectangle, p)
    if !(eltype(p) <: Real)
        return DomainError(
            eltype(p),
            "The matrix $(p) is not a real-valued matrix, so it does not lie on $(M).",
        )
    end
    for i in eachindex(M.lb, M.ub, p)
        if !(p[i] >= M.lb[i])
            return DomainError(
                p[i],
                "At index $i the point has coordinate $(p[i]), is not at or above the lower bound of $(M.lb[i])",
            )
        end
        if !(p[i] <= M.ub[i])
            return DomainError(
                p[i],
                "At index $i the point has coordinate $(p[i]), is not at or below the upper bound of $(M.ub[i])",
            )
        end
    end
    return nothing
end

function check_vector(M::Hyperrectangle, p, X; kwargs...)
    if !(eltype(X) <: Real)
        return DomainError(
            eltype(X),
            "The matrix $(X) is not a real-valued matrix, so it can not be a tangent vector to $(p) on $(M).",
        )
    end
    return nothing
end

default_approximation_method(::Hyperrectangle, ::typeof(mean)) = EfficientEstimator()
metric(::Hyperrectangle) = EuclideanMetric()
"""
    default_retraction_method(M::Hyperrectangle)

Return [`ProjectionRetraction`](@extref `ManifoldsBase.ProjectionRetraction`) as the default
retraction for the [`Hyperrectangle`](@ref) manifold.
"""
default_retraction_method(::Hyperrectangle) = ProjectionRetraction()

"""
    distance(M::Hyperrectangle, p, q, r::Real=2)

Compute the euclidean distance between two points on the [`Hyperrectangle`](@ref)
manifold `M`, i.e. for vectors it's just the norm of the difference, for matrices
and higher order arrays, the matrix and tensor Frobenius norm, respectively.
Specifying further an `r≠2`, distance based on other norms, like the 1-norm or the ∞-norm
can also be computed.
"""
Base.@propagate_inbounds function distance(M::Hyperrectangle, p, q)
    # Inspired by euclidean distance calculation in Distances.jl
    # Much faster for large p, q than a naive implementation
    @boundscheck if axes(p) != axes(q)
        throw(DimensionMismatch("At last one of $p and $q does not belong to $M"))
    end
    s = zero(eltype(p))
    @inbounds begin
        @simd for I in eachindex(p, q)
            p_i = p[I]
            q_i = q[I]
            s += abs2(p_i - q_i)
        end # COV_EXCL_LINE
    end
    return sqrt(s)
end
distance(::Hyperrectangle, p, q, r::Real) = norm(p - q, r)
distance(::Hyperrectangle, p::Number, q::Number) = abs(p - q)


"""
    embed(M::Hyperrectangle, p)

Embed the point `p` in `M`. Equivalent to an identity map.
"""
embed(::Hyperrectangle, p) = p

"""
    embed(M::Hyperrectangle, p, X)

Embed the tangent vector `X` at point `p` in `M`. Equivalent to an identity map.
"""
embed(::Hyperrectangle, p, X) = X

@doc raw"""
    exp(M::Hyperrectangle, p, X)

Compute the exponential map on the [`Hyperrectangle`](@ref) manifold `M` from `p` in direction
`X`, which in this case is just
````math
\exp_p X = p + X.
````
"""
Base.exp(::Hyperrectangle, p, X) = p + X
exp_fused(::Hyperrectangle, p, X, t::Number) = p .+ t .* X

exp!(::Hyperrectangle, q, p, X) = (q .= p .+ X)
exp_fused!(::Hyperrectangle, q, p, X, t::Number) = (q .= p .+ t .* X)

function get_coordinates_orthonormal(::Hyperrectangle, p, X, ::RealNumbers)
    return vec(X)
end

function get_coordinates_orthonormal!(::Hyperrectangle, c, p, X, ::RealNumbers)
    copyto!(c, vec(X))
    return c
end

function get_vector_orthonormal(::Hyperrectangle{<:AbstractVector}, ::Any, c, ::RealNumbers)
    # this method is defined just to skip a reshape
    return c
end

function get_vector_orthonormal!(
        ::Hyperrectangle{<:AbstractVector},
        Y,
        ::Any,
        c,
        ::RealNumbers,
    )
    # this method is defined just to skip a reshape
    copyto!(Y, c)
    return Y
end
function get_vector_orthonormal!(M::Hyperrectangle, Y, ::Any, c, ::RealNumbers)
    S = representation_size(M)
    copyto!(Y, reshape(c, S))
    return Y
end

has_components(::Hyperrectangle) = true

@doc raw"""
    injectivity_radius(M::Hyperrectangle, p)

Return the injectivity radius on the [`Hyperrectangle`](@ref) `M` at point `p`, which is
the distance to the nearest boundary the point is not on.
"""
function injectivity_radius(M::Hyperrectangle, p)
    ir = Inf
    for i in eachindex(M.lb, p)
        dist_ub = M.ub[i] - p[i]
        if dist_ub > 0
            ir = min(ir, dist_ub)
        end
        dist_lb = p[i] - M.lb[i]
        if dist_lb > 0
            ir = min(ir, dist_lb)
        end
    end
    return ir
end
injectivity_radius(M::Hyperrectangle) = 0.0
injectivity_radius(M::Hyperrectangle, ::AbstractRetractionMethod) = 0.0
injectivity_radius(M::Hyperrectangle, p, ::ProjectionRetraction) = injectivity_radius(M, p)
injectivity_radius(M::Hyperrectangle, p, ::ExponentialRetraction) = injectivity_radius(M, p)

@doc raw"""
    inner(M::Hyperrectangle, p, X, Y)

Compute the inner product on the [`Hyperrectangle`](@ref) `M`, which is just
the inner product on the real-valued vector space of arrays (or tensors)
of size ``n_1 × n_2  ×  …  × n_i``, i.e.

````math
g_p(X,Y) = \sum_{k ∈ I} X_{k} Y_{k},
````

where ``I`` is the set of vectors ``k ∈ ℕ^i``, such that for all

``i ≤ j ≤ i`` it holds ``1 ≤ k_j ≤ n_j``.

For the special case of ``i ≤ 2``, i.e. matrices and vectors, this simplifies to

````math
g_p(X,Y) = \operatorname{tr}(X^{\mathrm{T}}Y),
````

where ``⋅^{\mathrm{T}}`` denotes transposition.
"""
@inline inner(::Hyperrectangle, p, X, Y) = dot(X, Y)
"""
    is_flat(::Hyperrectangle)

Return true. [`Hyperrectangle`](@ref) is a flat manifold.
"""
is_flat(M::Hyperrectangle) = true

@doc raw"""
    log(M::Hyperrectangle, p, q)

Compute the logarithmic map on the [`Hyperrectangle`](@ref) `M` from `p` to `q`,
which in this case is just
````math
\log_p q = q-p.
````
"""
Base.log(::Hyperrectangle, ::Any...)
Base.log(::Hyperrectangle, p, q) = q .- p

log!(::Hyperrectangle, X, p, q) = (X .= q .- p)

_product_of_dimensions(M::Hyperrectangle) = prod(size(M.lb))

"""
    manifold_dimension(M::Hyperrectangle)

Return the manifold dimension of the [`Hyperrectangle`](@ref) `M`, i.e. the product of all array
dimensions.
"""
function manifold_dimension(M::Hyperrectangle)
    return _product_of_dimensions(M)
end

"""
    manifold_volume(::Hyperrectangle)

Return volume of the [`Hyperrectangle`](@ref) manifold, i.e. infinity.
"""
function manifold_volume(M::Hyperrectangle)
    vol = one(eltype(M.lb))
    for i in eachindex(M.lb, M.ub)
        vol *= M.ub[i] - M.lb[i]
    end
    return vol
end

#
# When Statistics / Statsbase.mean! is consistent with mean, we can pass this on to them as well
function Statistics.mean!(
        ::Hyperrectangle,
        y,
        x::AbstractVector,
        ::EfficientEstimator;
        kwargs...,
    )
    n = length(x)
    copyto!(y, first(x))
    @inbounds for j in 2:n
        y .+= x[j]
    end
    y ./= n
    return y
end
function Statistics.mean!(
        ::Hyperrectangle,
        y,
        x::AbstractVector,
        w::AbstractWeights,
        ::EfficientEstimator;
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
            ),
        )
    end
    copyto!(y, first(x))
    y .*= first(w)
    @inbounds for j in 2:n
        iszero(w[j]) && continue
        y .+= w[j] .* x[j]
    end
    y ./= sum(w)
    return y
end

mid_point(::Hyperrectangle, p1, p2) = (p1 .+ p2) ./ 2

function mid_point!(::Hyperrectangle, q, p1, p2)
    q .= (p1 .+ p2) ./ 2
    return q
end

@doc raw"""
    norm(M::Hyperrectangle, p, X, r::Real = 2)

Compute the norm of a tangent vector `X` at `p` on the [`Hyperrectangle`](@ref)
`M`, i.e. since every tangent space can be identified with `M` itself
in this case, just the (Frobenius) norm of `X`.
Specifying `r` allows to compute other norms as well.
"""
LinearAlgebra.norm(::Hyperrectangle, ::Any, X, r::Real = 2) = norm(X, r)

"""
    parallel_transport_direction(M::Hyperrectangle, p, X, d)

the parallel transport on [`Hyperrectangle`](@ref) is the identity, i.e. returns `X`.
"""
parallel_transport_direction(::Hyperrectangle, ::Any, X, ::Any) = X
parallel_transport_direction!(::Hyperrectangle, Y, ::Any, X, ::Any) = copyto!(Y, X)

"""
    parallel_transport_to(M::Hyperrectangle, p, X, q)

the parallel transport on [`Hyperrectangle`](@ref) is the identity, i.e. returns `X`.
"""
parallel_transport_to(::Hyperrectangle, ::Any, X, ::Any) = X
parallel_transport_to!(::Hyperrectangle, Y, ::Any, X, ::Any) = copyto!(Y, X)

@doc raw"""
    project(M::Hyperrectangle, p)

Project an arbitrary point `p` onto the [`Hyperrectangle`](@ref) manifold `M`, which
is of course just the identity map.
"""
project(::Hyperrectangle, ::Any)

function project!(M::Hyperrectangle, q, p)
    copyto!(q, p)
    for i in eachindex(M.lb, q)
        q[i] = clamp(q[i], M.lb[i], M.ub[i])
    end
    return q
end

"""
    project(M::Hyperrectangle, p, X)

Project an arbitrary vector `X` into the tangent space of a point `p` on the
[`Hyperrectangle`](@ref) `M`. For coordinates `i` at which `p[i]` is equal to the
lower bound of `M`, `X[i]` is upper-bounded at 0. `M`. For coordinates `i` at which `p[i]`
is equal to the upper bound of `M`, `X[i]` is lower-bounded at 0. Otherwise, `X` is
not changed.
"""
project(::Hyperrectangle, ::Any, ::Any)

function project!(M::Hyperrectangle, Y, p, X)
    copyto!(Y, X)
    for i in eachindex(M.lb, Y)
        if M.ub[i] == p[i]
            Y[i] = min(Y[i], 0)
        elseif M.lb[i] == p[i]
            Y[i] = max(Y[i], 0)
        end
    end
    return Y
end

function Random.rand!(
        rng::AbstractRNG,
        M::Hyperrectangle,
        pX;
        σ = one(eltype(pX)),
        vector_at = nothing,
    )
    if vector_at === nothing
        for i in eachindex(M.ub)
            lbi = M.lb[i]
            ubi = M.ub[i]
            if isfinite(lbi)
                if isfinite(ubi)
                    pX[i] = lbi + rand(rng, eltype(M.lb)) * (ubi - lbi)
                else
                    pX[i] = lbi + abs(randn(rng, eltype(M.lb))) * σ
                end
            else
                if isfinite(ubi)
                    pX[i] = ubi - abs(randn(rng, eltype(M.lb))) * σ
                else
                    pX[i] = randn(rng) * σ
                end
            end
        end
    else
        pX .= randn(rng, eltype(pX), size(pX)) .* σ
        project!(M, pX, vector_at, pX)
    end
    return pX
end

"""
    representation_size(M::Hyperrectangle)

Return the array dimensions required to represent an element on the
[`Hyperrectangle`](@ref) `M`, i.e. the vector of all array dimensions.
"""
representation_size(M::Hyperrectangle) = size(M.lb)

function ManifoldsBase.retract_project!(M::Hyperrectangle, r, q, Y)
    r .= q .+ Y
    project(M, r, r)
    return r
end
function ManifoldsBase.retract_project_fused!(M::Hyperrectangle, r, q, Y, t::Number)
    r .= q .+ t .* Y
    project!(M, r, r)
    return r
end

@doc raw"""
    riemann_tensor(M::Hyperrectangle, p, X, Y, Z)

Compute the Riemann tensor ``R(X,Y)Z`` at point `p` on [`Hyperrectangle`](@ref) manifold `M`.
Its value is always the zero tangent vector.
"""
riemann_tensor(M::Hyperrectangle, p, X, Y, Z)

function riemann_tensor!(::Hyperrectangle, Xresult, p, X, Y, Z)
    return fill!(Xresult, 0)
end

@doc raw"""
    sectional_curvature(::Hyperrectangle, p, X, Y)

Sectional curvature of [`Hyperrectangle`](@ref) manifold `M` is 0.
"""
function sectional_curvature(::Hyperrectangle, p, X, Y)
    return 0.0
end

@doc raw"""
    sectional_curvature_max(::Hyperrectangle)

Sectional curvature of [`Hyperrectangle`](@ref) manifold `M` is 0.
"""
function sectional_curvature_max(::Hyperrectangle)
    return 0.0
end

@doc raw"""
    sectional_curvature_min(M::Hyperrectangle)

Sectional curvature of [`Hyperrectangle`](@ref) manifold `M` is 0.
"""
function sectional_curvature_min(::Hyperrectangle)
    return 0.0
end

function Base.show(io::IO, M::Hyperrectangle)
    return print(io, "Hyperrectangle($(M.lb), $(M.ub))")
end

function vector_transport_direction(
        M::Hyperrectangle,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return X
end
function vector_transport_direction!(
        M::Hyperrectangle,
        Y,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return copyto!(Y, X)
end
"""
    vector_transport_to(M::Hyperrectangle, p, X, q, ::AbstractVectorTransportMethod)

Transport the vector `X` from the tangent space at `p` to the tangent space at `q`
on the [`Hyperrectangle`](@ref) `M`, which simplifies to the identity.
"""
vector_transport_to(::Hyperrectangle, ::Any, ::Any, ::Any, ::AbstractVectorTransportMethod)
function vector_transport_to(
        M::Hyperrectangle,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return X
end

function vector_transport_to!(
        M::Hyperrectangle,
        Y,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return copyto!(Y, X)
end

Statistics.var(::Hyperrectangle, x::AbstractVector; kwargs...) = sum(var(x; kwargs...))

@doc raw"""
    volume_density(M::Hyperrectangle, p, X)

Return volume density function of [`Hyperrectangle`](@ref) manifold `M`, i.e. 1.
"""
function volume_density(::Hyperrectangle, p, X)
    return one(eltype(X))
end

@doc raw"""
    Y = Weingarten(M::Hyperrectangle, p, X, V)
    Weingarten!(M::Hyperrectangle, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Hyperrectangle`](@ref) `M` with
respect to the tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::Hyperrectangle, p, X, V)

Weingarten!(::Hyperrectangle, Y, p, X, V) = fill!(Y, 0)

"""
    zero_vector(M::Hyperrectangle, p)

Return the zero vector in the tangent space of `p` on the [`Hyperrectangle`](@ref)
`M`, which here is just a zero filled array the same size as `p`.
"""
zero_vector(::Hyperrectangle, ::Any...)

zero_vector!(::Hyperrectangle, X, ::Any) = fill!(X, 0)

function change_metric!(M::AbstractManifold, Y, G::AbstractMetric, p, X)
    metric(M) === G && return copyto!(M, Y, p, X) # no metric change
    # TODO: For local metric, inverse_local metric, det_local_metric: Introduce a default basis?
    B = DefaultOrthogonalBasis()
    G1 = local_metric(M, p, B)
    G2 = local_metric(G(M), p, B)
    x = get_coordinates(M, p, X, B)
    C1 = cholesky(G1).L
    C2 = cholesky(G2).L
    z = (C1 \ C2)'x
    return get_vector!(M, Y, p, z, B)
end

function change_representer!(M::AbstractManifold, Y, G::AbstractMetric, p, X)
    (metric(M) == G) && return copyto!(M, Y, p, X) # no metric change
    # TODO: For local metric, inverse_local metric, det_local_metric: Introduce a default basis?
    B = DefaultOrthogonalBasis()
    G1 = local_metric(M, p, B)
    G2 = local_metric(G(M), p, B)
    x = get_coordinates(M, p, X, B)
    z = (G1 \ G2)'x
    return get_vector!(M, Y, p, z, B)
end

@doc raw"""
    flat(N::MetricManifold{M,G}, p, X::TFVector)

Compute the musical isomorphism to transform the tangent vector `X` from the
[`AbstractManifold`](https://juliamanifolds.github.io/Manifolds.jl/latest/interface.html#ManifoldsBase.AbstractManifold) `M` equipped with
[`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`) `G` to a cotangent by
computing

````math
X^♭= G_p X,
````
where ``G_p`` is the local matrix representation of `G`, see [`local_metric`](@ref)
"""
flat(::MetricManifold, ::Any, ::TFVector)

function flat!(M::AbstractManifold, ξ::CoTFVector, p, X::TFVector)
    (metric(M.manifold) == M.metric) && (return flat!(M.manifold, ξ, p, X))
    g = local_metric(M, p, ξ.basis)
    copyto!(ξ.data, g * X.data)
    return ξ
end

function inner(M::MetricManifold, p, X::TFVector, Y::TFVector)
    X.basis === Y.basis ||
        error("calculating inner product of vectors from different bases is not supported")
    return dot(X.data, local_metric(M, p, X.basis) * Y.data)
end

@doc raw"""
    sharp(N::MetricManifold{M,G}, p, ξ::CoTFVector)

Compute the musical isomorphism to transform the cotangent vector `ξ` from the
[`AbstractManifold`](https://juliamanifolds.github.io/Manifolds.jl/latest/interface.html#ManifoldsBase.AbstractManifold) `M` equipped with
[`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`) `G` to a tangent by
computing

````math
ξ^♯ = G_p^{-1} ξ,
````
where ``G_p`` is the local matrix representation of `G`, i.e. one employs
[`inverse_local_metric`](@ref) here to obtain ``G_p^{-1}``.
"""
sharp(::MetricManifold, ::Any, ::CoTFVector)

function sharp!(M::MetricManifold, X::TFVector, p, ξ::CoTFVector)
    (metric(M.manifold) == M.metric) && (return sharp!(M.manifold, X, p, ξ))
    Ginv = inverse_local_metric(M, p, X.basis)
    copyto!(X.data, Ginv * ξ.data)
    return X
end

include("../header.jl")

@testset "Torus" begin
    M = Torus(2)
    @testset "Torus Basics" begin
        @test Circle()^3 === Torus(3)
        @test Circle()^(3,) === PowerManifold(Circle(), 3)
        @test ^(Circle(), 2) === Torus(2)
        @test typeof(^(Circle(), 2)) == Torus{2}
        @test repr(M) == "Torus(2)"
        @test representation_size(M) == (2,)
        @test manifold_dimension(M) == 2
        @test is_flat(M)
        @test !is_point(M, 9.0)
        @test_throws DomainError is_point(M, 9.0; error = :error)
        @test !is_point(M, [9.0; 9.0])
        @test_throws CompositeManifoldError is_point(M, [9.0 9.0]; error = :error)
        @test_throws CompositeManifoldError is_point(M, [9.0, 9.0]; error = :error)
        @test !is_vector(M, [9.0; 9.0], 0.0)
        @test_throws DomainError is_vector(M, 9.0, 0.0; error = :error) # point false and checked
        @test !is_vector(M, [9.0; 9.0], [0.0; 0.0])
        @test_throws DomainError is_vector(M, [0.0, 0.0], 0.0; error = :error)
        @test injectivity_radius(M) ≈ π
        x = [1.0, 2.0]
        y = [-1.0, 2.0]
        z = [0.0, 0.0]
        basis_types = (DefaultOrthonormalBasis(),)
        Manifolds.test_manifold(
            M,
            [x, y, z],
            test_vector_spaces = true,
            test_project_tangent = false,
            test_musical_isomorphisms = true,
            test_default_vector_transport = false,
            basis_types_to_from = basis_types,
            is_tangent_atol_multiplier = 1,
            test_inplace = true,
        )
    end
end

include("../header.jl")

@testset "KendallsPreShapeSpace" begin
    M = KendallsPreShapeSpace(2, 3)
    @test repr(M) == "KendallsPreShapeSpace(2, 3)"
    @test representation_size(M) === (2, 3)
    @test manifold_dimension(M) == 3
    @test injectivity_radius(M) == pi

    p1 = [
        0.4385117672460505 -0.6877826444042382 0.24927087715818771
        -0.3830259932279294 0.35347460720654283 0.029551386021386548
    ]
    p2 = [
        -0.42693314765896473 -0.3268567431952937 0.7537898908542584
        0.3054740561061169 -0.18962848284149897 -0.11584557326461796
    ]
    p3 = [
        0.3248027612629014 0.440253011955812 -0.7650557732187135
        0.26502337825226757 -0.06175142812400016 -0.20327195012826738
    ]
    @test_throws DomainError is_point(M, [1 0 1; 1 -1 0] / 2; error = :error)
    @test_throws DomainError is_vector(
        M,
        [-1 0 1.0; 0 0 0] / sqrt(2),
        [1.0 0 1; 1 -1 0];
        error = :error,
    )
    Manifolds.test_manifold(
        M,
        [p1, p2, p3];
        is_point_atol_multiplier = 1,
        is_tangent_atol_multiplier = 1,
        exp_log_atol_multiplier = 5,
        test_project_point = true,
        test_project_tangent = true,
        test_rand_point = true,
        test_rand_tvector = true,
        rand_tvector_atol_multiplier = 5,
    )
    @testset "field parameter" begin
        M = KendallsPreShapeSpace(2, 3; parameter = :field)
        @test repr(M) == "KendallsPreShapeSpace(2, 3; parameter=:field)"
        @test get_embedding(M) === ArraySphere(2, 3; field = ℝ, parameter = :field)
    end
end

@testset "KendallsShapeSpace" begin
    M = KendallsShapeSpace(2, 3)
    @test repr(M) == "KendallsShapeSpace(2, 3)"
    @test get_total_space(M) == KendallsPreShapeSpace(2, 3)
    @test manifold_dimension(M) == 2
    @test !is_flat(M)
    p1 = [
        0.4385117672460505 -0.6877826444042382 0.24927087715818771
        -0.3830259932279294 0.35347460720654283 0.029551386021386548
    ]
    p2 = [
        -0.42693314765896473 -0.3268567431952937 0.7537898908542584
        0.3054740561061169 -0.18962848284149897 -0.11584557326461796
    ]
    p3 = [
        0.3248027612629014 0.440253011955812 -0.7650557732187135
        0.26502337825226757 -0.06175142812400016 -0.20327195012826738
    ]
    X1 = [
        0.6090792159558263 -0.02523987621672985 -0.5838393397390964
        0.4317628895706799 0.12108361184633629 -0.5528465014170161
    ]
    X1h = [
        0.5218590427922166 0.05525104866717821 -0.5771100914593948
        0.3319078589730016 0.2777009756923593 -0.6096088346653609
    ]
    X1v = [
        0.08722017316360964 -0.08049092488390806 -0.006729248279701561
        0.09985503059767825 -0.156617363846023 0.05676233324834479
    ]
    @testset "tangent vector components" begin
        @test isapprox(M, p1, horizontal_component(M, p1, X1), X1h)
        @test isapprox(M, p1, vertical_component(M, p1, X1), X1v)
        Y = similar(X1)
        vertical_component!(M, Y, p1, X1)
        @test isapprox(M, p1, Y, X1v)
        @test norm(M, p1, X1v) < 1.0e-16
        @test abs(norm(M, p1, X1) - norm(M, p1, X1h)) < 1.0e-16
    end

    @test_throws ManifoldDomainError is_point(M, [1 0 1; 1 -1 0]; error = :error)
    @test_throws ManifoldDomainError is_vector(M, p1, [1 0 1; 1 -1 0]; error = :error)

    @testset "exp/distance/norm" begin
        q1 = exp(M, p1, X1)
        @test distance(M, p1, q1) ≈ norm(M, p1, X1)
    end

    Manifolds.test_manifold(
        M,
        [p1, p2, p3];
        is_point_atol_multiplier = 1,
        is_tangent_atol_multiplier = 1,
        exp_log_atol_multiplier = 2.0e8,
        projection_atol_multiplier = 2,
        test_injectivity_radius = false,
        test_project_point = true,
        test_project_tangent = true,
        test_rand_point = true,
        test_rand_tvector = true,
        rand_tvector_atol_multiplier = 5,
    )
    @testset "degenerate cases" begin
        Md3_2 = KendallsShapeSpace(3, 2)
        Md2_1 = KendallsShapeSpace(2, 1)
        @test manifold_dimension(Md3_2) == 0
        @test manifold_dimension(Md2_1) == 0
    end
    @testset "field parameter" begin
        M = KendallsShapeSpace(2, 3; parameter = :field)
        @test repr(M) == "KendallsShapeSpace(2, 3; parameter=:field)"
        @test get_embedding(M) === KendallsPreShapeSpace(2, 3; parameter = :field)
        @test get_total_space(M) === KendallsPreShapeSpace(2, 3; parameter = :field)
    end
end

@doc raw"""
    InvertibleMatrices{𝔽,T} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)
consisting of the real- or complex-valued invertible matrices, that is the set

```math
\bigl\{p  ∈ 𝔽^{n×n}\ \big|\ \det(p) \neq 0 \bigr\},
```
where the field ``𝔽 ∈ \{ ℝ, ℂ\}``.

# Constructor

    InvertibleMatrices(n::Int, field::AbstractNumbers=ℝ)

Generate the manifold of ``n×n`` invertible matrices.
"""
struct InvertibleMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function InvertibleMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return InvertibleMatrices{field, typeof(size)}(size)
end

@doc raw"""
    check_point(M::InvertibleMatrices{n,𝔽}, p; kwargs...)

Check whether `p` is a valid manifold point on the [`InvertibleMatrices`](@ref) `M`, i.e.
whether `p` is an invertible matrix of size `(n,n)` with values from the corresponding
[`AbstractNumbers`](@extref ManifoldsBase number-system) `𝔽`.
"""
function check_point(M::InvertibleMatrices, p; kwargs...)
    if det(p) == 0
        return DomainError(
            det(p),
            "The point $(p) does not lie on $(M), since its determinant is zero and hence it is not invertible.",
        )
    end
    return nothing
end

"""
    check_vector(M::InvertibleMatrices{n,𝔽}, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`InvertibleMatrices`](@ref) `M`, which are all matrices of size ``n×n``
its values have to be from the correct [`AbstractNumbers`](@extref ManifoldsBase number-system).
"""
function check_vector(M::InvertibleMatrices, p, X; kwargs...)
    return nothing
end

embed(::InvertibleMatrices, p) = p
embed(::InvertibleMatrices, p, X) = X

function get_coordinates(
        ::InvertibleMatrices{ℝ, <:Any},
        p,
        X,
        ::DefaultOrthonormalBasis{ℝ, TangentSpaceType},
    )
    return vec(X)
end

function get_coordinates!(
        ::InvertibleMatrices{ℝ, <:Any},
        Xⁱ,
        p,
        X,
        ::DefaultOrthonormalBasis{ℝ, TangentSpaceType},
    )
    return copyto!(Xⁱ, X)
end

function get_embedding(::InvertibleMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return Euclidean(n, n; field = 𝔽)
end
function get_embedding(M::InvertibleMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return Euclidean(n, n; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::InvertibleMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

function get_vector(
        M::InvertibleMatrices{ℝ, <:Any},
        p,
        Xⁱ,
        ::DefaultOrthonormalBasis{ℝ, TangentSpaceType},
    )
    n = get_parameter(M.size)[1]
    return reshape(Xⁱ, n, n)
end

function get_vector!(
        ::InvertibleMatrices{ℝ, <:Any},
        X,
        p,
        Xⁱ,
        ::DefaultOrthonormalBasis{ℝ, TangentSpaceType},
    )
    return copyto!(X, Xⁱ)
end

"""
    is_flat(::InvertibleMatrices)

Return true. [`InvertibleMatrices`](@ref) is a flat manifold.
"""
is_flat(M::InvertibleMatrices) = true

@doc raw"""
    manifold_dimension(M::InvertibleMatrices{n,𝔽})

Return the dimension of the [`InvertibleMatrices`](@ref) matrix `M` over the number system
`𝔽`, which is the same dimension as its embedding, the [`Euclidean`](@ref)`(n, n; field=𝔽)`.
"""
function manifold_dimension(M::InvertibleMatrices{<:Any, 𝔽}) where {𝔽}
    return manifold_dimension(get_embedding(M))
end

@doc raw"""
    Random.rand(M::InvertibleMatrices; vector_at=nothing, kwargs...)

If `vector_at` is `nothing`, return a random point on the [`InvertibleMatrices`](@ref)
manifold `M` by using `rand` in the embedding.

If `vector_at` is not `nothing`, return a random tangent vector from the tangent space of
the point `vector_at` on the [`InvertibleMatrices`](@ref) by using by using `rand` in the
embedding.
"""
rand(M::InvertibleMatrices; kwargs...)

function Random.rand!(
        rng::AbstractRNG,
        M::InvertibleMatrices,
        pX;
        vector_at = nothing,
        kwargs...,
    )
    rand!(rng, get_embedding(M), pX; kwargs...)
    if vector_at === nothing # for points ensure invertibility
        _ensure_nonzero_rng_determinant!(rng, get_embedding(M), pX; kwargs...)
    end
    return pX
end

function Base.show(io::IO, ::InvertibleMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "InvertibleMatrices($(n), $(𝔽))")
end
function Base.show(io::IO, M::InvertibleMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "InvertibleMatrices($(n), $(𝔽); parameter=:field)")
end

@doc raw"""
    Y = Weingarten(M::InvertibleMatrices, p, X, V)
    Weingarten!(M::InvertibleMatrices, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`InvertibleMatrices`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::InvertibleMatrices, p, X, V)

Weingarten!(::InvertibleMatrices, Y, p, X, V) = fill!(Y, 0)

module ManifoldsRecursiveArrayToolsExt

using Manifolds
using RecursiveArrayTools: ArrayPartition
using StaticArrays
using LinearAlgebra

using Base.Iterators: repeated

using Manifolds:
    FiberBundleBasisData,
    FiberBundleProductVectorTransport,
    PowerManifoldNestedReplacing,
    TypeParameter

using Manifolds: bundle_transport_tangent_direction, bundle_transport_tangent_to

import Manifolds:
    adjoint_Jacobi_field,
    allocate,
    allocate_result,
    get_coordinates,
    get_vector,
    get_vectors,
    hat,
    isapprox,
    jacobi_field,
    project,
    riemannian_gradient,
    _vector_transport_direction,
    _vector_transport_to,
    vee

function allocate(
        ::PowerManifoldNestedReplacing,
        x::AbstractArray{<:ArrayPartition{T, <:NTuple{N, SArray}}},
    ) where {T, N}
    return similar(x)
end

include("bundles_rat.jl")
include("ProductManifoldRAT.jl")

end

@doc raw"""
    SymmetricPositiveDefinite{T} <: AbstractDecoratorManifold{ℝ}

The manifold of symmetric positive definite matrices, i.e.

````math
\mathcal P(n) =
\bigl\{
p ∈ ℝ^{n×n}\ \big|\ a^\mathrm{T}pa > 0 \text{ for all } a ∈ ℝ^{n}\backslash\{0\}
\bigr\}
````

The tangent space at ``T_p\mathcal P(n)`` reads

```math
    T_p\mathcal P(n) =
    \bigl\{
        X \in \mathbb R^{n×n} \big|\ X=X^\mathrm{T}
    \bigr\},
```
i.e. the set of symmetric matrices,

# Constructor

    SymmetricPositiveDefinite(n; parameter::Symbol=:type)

generates the manifold ``\mathcal P(n) \subset ℝ^{n×n}``
"""
struct SymmetricPositiveDefinite{T} <: AbstractDecoratorManifold{ℝ}
    size::T
end

function SymmetricPositiveDefinite(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return SymmetricPositiveDefinite{typeof(size)}(size)
end

@doc raw"""
    SPDPoint <: AbstractManifoldsPoint

Store the result of `eigen(p)` of an SPD matrix and (optionally) ``p^{1/2}`` and ``p^{-1/2}``
to avoid their repeated computations.

This result only has the result of `eigen` as a mandatory storage, the other three
can be stored. If they are not stored they are computed and returned (but then still not stored)
when required.

# Constructor

    SPDPoint(p::AbstractMatrix; store_p=true, store_sqrt=true, store_sqrt_inv=true)

Create an SPD point using an symmetric positive defincite matrix `p`, where you can optionally store `p`, `sqrt` and `sqrt_inv`
"""
struct SPDPoint{
        P <: Union{AbstractMatrix, Missing},
        Q <: Union{AbstractMatrix, Missing},
        R <: Union{AbstractMatrix, Missing},
        E <: Eigen,
    } <: AbstractManifoldPoint
    p::P
    eigen::E
    sqrt::Q
    sqrt_inv::R
end
SPDPoint(p::SPDPoint) = p
function SPDPoint(p::AbstractMatrix; store_p = true, store_sqrt = true, store_sqrt_inv = true)
    e = eigen(Symmetric(p))
    U = e.vectors
    S = max.(e.values, floatmin(eltype(e.values)))
    if store_sqrt
        s_sqrt = Diagonal(sqrt.(S))
        p_sqrt = U * s_sqrt * transpose(U)
    else
        p_sqrt = missing
    end
    if store_sqrt_inv
        s_sqrt_inv = Diagonal(1 ./ sqrt.(S))
        p_sqrt_inv = U * s_sqrt_inv * transpose(U)
    else
        p_sqrt_inv = missing
    end
    if store_p
        q = p
    else
        q = missing
    end
    return SPDPoint{typeof(q), typeof(p_sqrt), typeof(p_sqrt_inv), typeof(e)}(
        q,
        e,
        p_sqrt,
        p_sqrt_inv,
    )
end
convert(::Type{SPDPoint}, p::AbstractMatrix) = SPDPoint(p)

function Base.:(==)(p::SPDPoint, q::SPDPoint)
    return p.eigen == q.eigen
end

function allocate(p::SPDPoint)
    return SPDPoint(
        ismissing(p.p) ? missing : allocate(p.p),
        Eigen(allocate(p.eigen.values), allocate(p.eigen.vectors)),
        ismissing(p.sqrt) ? missing : allocate(p.sqrt),
        ismissing(p.sqrt_inv) ? missing : allocate(p.sqrt_inv),
    )
end
function allocate(p::SPDPoint, ::Type{T}) where {T}
    return SPDPoint(
        ismissing(p.p) ? missing : allocate(p.p, T),
        Eigen(allocate(p.eigen.values, T), allocate(p.eigen.vectors, T)),
        ismissing(p.sqrt) ? missing : allocate(p.sqrt, T),
        ismissing(p.sqrt_inv) ? missing : allocate(p.sqrt_inv, T),
    )
end

function allocate_result(M::SymmetricPositiveDefinite, ::typeof(zero_vector), p::SPDPoint)
    return allocate_result(M, zero_vector, convert(AbstractMatrix, p))
end
function allocate_coordinates(M::SymmetricPositiveDefinite, p::SPDPoint, T, n::Int)
    return allocate_coordinates(M, convert(AbstractMatrix, p), T, n)
end
function allocate_result(M::SymmetricPositiveDefinite, ::typeof(get_vector), p::SPDPoint, c)
    return allocate_result(M, get_vector, convert(AbstractMatrix, p), c)
end

@doc raw"""
    check_point(M::SymmetricPositiveDefinite, p; kwargs...)

checks, whether `p` is a valid point on the [`SymmetricPositiveDefinite`](@ref) `M`, i.e. is a matrix
of size `(N,N)`, symmetric and positive definite.
The tolerance for the second to last test can be set using the `kwargs...`.
"""
function check_point(M::SymmetricPositiveDefinite, p; kwargs...)
    if !isapprox(norm(p - transpose(p)), 0.0; kwargs...)
        return DomainError(
            norm(p - transpose(p)),
            "The point $(p) does not lie on $(M) since its not a symmetric matrix:",
        )
    end
    if !isposdef(p)
        return DomainError(
            eigvals(p),
            "The point $p does not lie on $(M) since its not a positive definite matrix.",
        )
    end
    return nothing
end
function check_point(M::SymmetricPositiveDefinite, p::SPDPoint; kwargs...)
    return check_point(M, convert(AbstractMatrix, p); kwargs...)
end

"""
    check_vector(M::SymmetricPositiveDefinite, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`SymmetricPositiveDefinite`](@ref) `M`,
i.e. atfer [`check_point`](@ref)`(M,p)`, `X` has to be of same dimension as `p`
and a symmetric matrix, i.e. this stores tangent vectors as elements of the corresponding
Lie group.
The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(M::SymmetricPositiveDefinite, p, X; kwargs...)
    if !isapprox(X, transpose(X); kwargs...)
        return DomainError(
            X,
            "The vector $(X) is not a tangent to a point on $(M) (represented as an element of the Lie algebra) since its not symmetric.",
        )
    end
    return nothing
end
function check_vector(M::SymmetricPositiveDefinite, p::SPDPoint, X; kwargs...)
    return check_vector(M, convert(AbstractMatrix, p), X; kwargs...)
end

function check_size(M::SymmetricPositiveDefinite, p::SPDPoint; kwargs...)
    return check_size(M, convert(AbstractMatrix, p); kwargs...)
end
function check_size(M::SymmetricPositiveDefinite, p::SPDPoint, X; kwargs...)
    return check_size(M, convert(AbstractMatrix, p), X; kwargs...)
end

function Base.copy(p::SPDPoint)
    return SPDPoint(
        ismissing(p.p) ? missing : copy(p.p),
        Eigen(copy(p.eigen.values), copy(p.eigen.vectors)),
        ismissing(p.sqrt) ? missing : copy(p.sqrt),
        ismissing(p.sqrt_inv) ? missing : copy(p.sqrt_inv),
    )
end

#
# Lazy copyto, only copy if both are not missing,
# create from `p` if it is a nonmissing field in q.
#
function copyto!(q::SPDPoint, p::SPDPoint)
    if !ismissing(q.p) # we have to fill the Fields
        if !ismissing(p.p)
            !ismissing(q.p) && copyto!(q.p, p.p)
        else # otherwise compute and copy
            copyto!(q.p, convert(AbstractMatrix, p))
        end
    end
    copyto!(q.eigen.values, p.eigen.values)
    copyto!(q.eigen.vectors, p.eigen.vectors)
    if !ismissing(q.sqrt)
        if !ismissing(p.sqrt)
            copyto!(q.sqrt, p.sqrt)
        else # otherwise compute and copy
            copyto!(q.sqrt, spd_sqrt(p))
        end
    end
    if !ismissing(q.sqrt_inv)
        if !ismissing(p.sqrt_inv)
            copyto!(q.sqrt_inv, p.sqrt_inv)
        else # otherwise compute and copy
            copyto!(q.sqrt_inv, spd_sqrt_inv(p))
        end
    end
    return q
end

metric(::SymmetricPositiveDefinite) = AffineInvariantMetric()

embed(::SymmetricPositiveDefinite, p) = p
embed(::SymmetricPositiveDefinite, p::SPDPoint) = convert(AbstractMatrix, p)
embed(::SymmetricPositiveDefinite, p, X) = X

function get_embedding(::SymmetricPositiveDefinite{TypeParameter{Tuple{n}}}) where {n}
    return Euclidean(n, n; field = ℝ)
end
function get_embedding(M::SymmetricPositiveDefinite{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return Euclidean(n, n; field = ℝ, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymmetricPositiveDefinite, ::Type{<:SPDPoint})
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end
function ManifoldsBase.get_embedding_type(::SymmetricPositiveDefinite)
    return ManifoldsBase.EmbeddedManifoldType()
end

get_parameter_type(::SymmetricPositiveDefinite{<:TypeParameter}) = :type
get_parameter_type(::SymmetricPositiveDefinite{Tuple{Int}}) = :field

@doc raw"""
    injectivity_radius(M::SymmetricPositiveDefinite[, p])
    injectivity_radius(M::MetricManifold{SymmetricPositiveDefinite,AffineInvariantMetric}[, p])
    injectivity_radius(M::MetricManifold{SymmetricPositiveDefinite,LogCholeskyMetric}[, p])

Return the injectivity radius of the [`SymmetricPositiveDefinite`](@ref).
Since `M` is a Hadamard manifold with respect to the [`AffineInvariantMetric`](@ref) and the
[`LogCholeskyMetric`](@ref), the injectivity radius is globally ``∞``.
"""
injectivity_radius(::SymmetricPositiveDefinite) = Inf
injectivity_radius(::SymmetricPositiveDefinite, p) = Inf
injectivity_radius(::SymmetricPositiveDefinite, ::AbstractRetractionMethod) = Inf
injectivity_radius(::SymmetricPositiveDefinite, p, ::AbstractRetractionMethod) = Inf

function isapprox(p::SPDPoint, q::SPDPoint; kwargs...)
    return isapprox(convert(AbstractMatrix, p), convert(AbstractMatrix, q); kwargs...)
end

"""
    is_flat(::SymmetricPositiveDefinite)

Return false. [`SymmetricPositiveDefinite`](@ref) is not a flat manifold.
"""
is_flat(M::SymmetricPositiveDefinite) = false

@doc raw"""
    manifold_dimension(M::SymmetricPositiveDefinite)

returns the dimension of
[`SymmetricPositiveDefinite`](@ref) `M` ``=\mathcal P(n), n ∈ ℕ``, i.e.
````math
\dim \mathcal P(n) = \frac{n(n+1)}{2}.
````
"""
function manifold_dimension(M::SymmetricPositiveDefinite)
    n = get_parameter(M.size)[1]
    return div(n * (n + 1), 2)
end

"""
    mean(
        M::SymmetricPositiveDefinite,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolation();
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolation`](@extref `ManifoldsBase.GeodesicInterpolation`).
"""
mean(::SymmetricPositiveDefinite, ::Any)

function default_approximation_method(::SymmetricPositiveDefinite, ::typeof(mean))
    return GeodesicInterpolation()
end

@doc raw"""
    convert(::Type{AbstractMatrix}, p::SPDPoint)

return the point `p` as a matrix.
The matrix is either stored within the [`SPDPoint`](@ref) or reconstructed from `p.eigen`.
"""
convert(::Type{AbstractMatrix}, p::SPDPoint) = p.p
function convert(::Type{AbstractMatrix}, p::SPDPoint{Missing})
    return (p.eigen.vectors * Diagonal(p.eigen.values) * p.eigen.vectors')
end

@doc raw"""
    spd_sqrt(p::AbstractMatrix)
    spd_sqrt(p::SPDPoint)

return ``p^{\frac{1}{2}}`` by either computing it (if it is missing or for the `AbstractMatrix`)
or returning the stored value from within the [`SPDPoint`](@ref).

This method assumes that `p` represents an spd matrix.
"""
spd_sqrt(p)

function spd_sqrt(p::AbstractMatrix)
    e = eigen(Symmetric(p))
    U = e.vectors
    S = max.(e.values, floatmin(eltype(e.values)))
    Ssqrt = Diagonal(sqrt.(S))
    return Symmetric(U * Ssqrt * transpose(U))
end
spd_sqrt(p::SPDPoint) = Symmetric(p.sqrt)
function spd_sqrt(p::SPDPoint{P, Missing}) where {P <: Union{AbstractMatrix, Missing}}
    U = p.eigen.vectors
    S = max.(p.eigen.values, floatmin(eltype(p.eigen.values)))
    Ssqrt = Diagonal(sqrt.(S))
    return Symmetric(U * Ssqrt * transpose(U))
end

@doc raw"""
    spd_sqrt_inv(p::SPDPoint)

return ``p^{-\frac{1}{2}}`` by either computing it (if it is missing or for the `AbstractMatrix`)
or returning the stored value from within the [`SPDPoint`](@ref).

This method assumes that `p` represents an spd matrix.
"""
spd_sqrt_inv(p::SPDPoint) = Symmetric(p.sqrt_inv)
function spd_sqrt_inv(
        p::SPDPoint{P, Q, Missing},
    ) where {P <: Union{AbstractMatrix, Missing}, Q <: Union{AbstractMatrix, Missing}}
    U = p.eigen.vectors
    S = max.(p.eigen.values, floatmin(eltype(p.eigen.values)))
    SsqrtInv = Diagonal(1 ./ sqrt.(S))
    return Symmetric(U * SsqrtInv * transpose(U))
end

@doc raw"""
    spd_sqrt_and_sqrt_inv(p::AbstractMatrix)
    spd_sqrt_and_sqrt_inv(p::SPDPoint)

return ``p^{\frac{1}{2}}`` and ``p^{-\frac{1}{2}}`` by either computing them (if they are missing or for the `AbstractMatrix`)
or returning their stored value from within the [`SPDPoint`](@ref).

Compared to calling single methods [`spd_sqrt`](@ref Manifolds.spd_sqrt) and [`spd_sqrt_inv`](@ref Manifolds.spd_sqrt_inv) this method
only computes the eigenvectors once for the case of the `AbstractMatrix` or if both are missing.

This method assumes that `p` represents an spd matrix.
"""
spd_sqrt_and_sqrt_inv(p)

function spd_sqrt_and_sqrt_inv(p::AbstractMatrix)
    e = eigen(Symmetric(p))
    U = e.vectors
    S = max.(e.values, floatmin(eltype(e.values)))
    Ssqrt = Diagonal(sqrt.(S))
    SsqrtInv = Diagonal(1 ./ sqrt.(S))
    return (Symmetric(U * Ssqrt * transpose(U)), Symmetric(U * SsqrtInv * transpose(U)))
end
function spd_sqrt_and_sqrt_inv(p::SPDPoint{P}) where {P <: Union{Missing, AbstractMatrix}}
    return (Symmetric(p.sqrt), Symmetric(p.sqrt_inv))
end
function spd_sqrt_and_sqrt_inv(
        p::SPDPoint{P, Q, Missing},
    ) where {P <: Union{Missing, AbstractMatrix}, Q <: AbstractMatrix}
    return (Symmetric(p.sqrt), spd_sqrt_inv(p))
end
function spd_sqrt_and_sqrt_inv(
        p::SPDPoint{P, Missing, R},
    ) where {P <: Union{Missing, AbstractMatrix}, R <: AbstractMatrix}
    return (spd_sqrt(p), Symmetric(p.sqrt_inv))
end
function spd_sqrt_and_sqrt_inv(
        p::SPDPoint{P, Missing, Missing},
    ) where {P <: Union{Missing, AbstractMatrix}}
    S = max.(p.eigen.values, floatmin(eltype(p.eigen.values)))
    U = p.eigen.vectors
    Ssqrt = Diagonal(sqrt.(S))
    SsqrtInv = Diagonal(1 ./ sqrt.(S))
    return (Symmetric(U * Ssqrt * transpose(U)), Symmetric(U * SsqrtInv * transpose(U)))
end

Base.eltype(p::SPDPoint) = eltype(p.eigen)

@doc raw"""
    project(M::SymmetricPositiveDefinite, p, X)

project a matrix from the embedding onto the tangent space ``T_p\mathcal P(n)`` of the
[`SymmetricPositiveDefinite`](@ref) matrices, i.e. the set of symmetric matrices.
"""
project(::SymmetricPositiveDefinite, p, X)

project!(::SymmetricPositiveDefinite, Y, p, X) = (Y .= Symmetric((X + X') / 2))

@doc raw"""
    rand(M::SymmetricPositiveDefinite; σ::Real=1)

Generate a random symmetric positive definite matrix on the
`SymmetricPositiveDefinite` manifold `M`.
"""
rand(M::SymmetricPositiveDefinite; σ::Real = 1)

function allocate_result(M::SymmetricPositiveDefinite, ::typeof(Random.rand), p::SPDPoint)
    return zero_vector(M, p)
end

function Random.rand!(
        rng::AbstractRNG,
        M::SymmetricPositiveDefinite,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)) /
            (vector_at === nothing ? 1 : norm(convert(AbstractMatrix, vector_at))),
        tangent_distr = :Gaussian,
    )
    N = get_parameter(M.size)[1]
    if vector_at === nothing
        D = Diagonal(1 .+ rand(rng, N)) # random diagonal matrix
        s = qr(σ * randn(rng, N, N)) # random q
        if pX isa SPDPoint
            pX.eigen.values .= D.diag
            pX.eigen.vectors .= s.Q
            !ismissing(pX.p) && pX.p .= Symmetric(s.Q * D * transpose(s.Q))
            !ismissing(pX.sqrt) && pX.sqrt .= sqrt.(D.diag)
            !ismissing(pX.sqrt_inv) && pX.sqrt_inv .= inv.(sqrt.(D.diag))
        else
            pX .= Symmetric(s.Q * D * transpose(s.Q))
        end
    elseif tangent_distr === :Gaussian
        # generate ONB in TxM
        vector_at_matrix = convert(AbstractMatrix, vector_at)
        I = one(vector_at_matrix)
        B = get_basis(M, vector_at, DiagonalizingOrthonormalBasis(I))
        Ξ = get_vectors(M, vector_at, B)
        Ξx =
            vector_transport_to.(
            Ref(M),
            Ref(I),
            Ξ,
            Ref(vector_at_matrix),
            Ref(ParallelTransport()),
        )
        pX .= sum(σ * randn(rng, length(Ξx)) .* Ξx)
    elseif tangent_distr === :Rician
        C = cholesky(Hermitian(vector_at))
        R = C.L + sqrt(σ) * triu(randn(rng, size(vector_at, 1), size(vector_at, 2)), 0)
        pX .= R * R'
    end
    return pX
end

@doc raw"""
    representation_size(M::SymmetricPositiveDefinite)

Return the size of an array representing an element on the
[`SymmetricPositiveDefinite`](@ref) manifold `M`, i.e. ``n×n``, the size of such a
symmetric positive definite matrix on ``\mathcal M = \mathcal P(n)``.
"""
function representation_size(M::SymmetricPositiveDefinite)
    N = get_parameter(M.size)[1]
    return (N, N)
end

function Base.show(io::IO, ::SymmetricPositiveDefinite{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "SymmetricPositiveDefinite($(n))")
end
function Base.show(io::IO, M::SymmetricPositiveDefinite{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "SymmetricPositiveDefinite($(n); parameter=:field)")
end

function Base.show(io::IO, ::MIME"text/plain", p::SPDPoint)
    pre = " "
    summary(io, p)
    println(io, "\np:")
    sp = sprint(show, "text/plain", p.p; context = io, sizehint = 0)
    sp = replace(sp, '\n' => "\n$(pre)")
    println(io, pre, sp)
    println(io, "p^{1/2}:")
    sps = sprint(show, "text/plain", p.sqrt; context = io, sizehint = 0)
    sps = replace(sps, '\n' => "\n$(pre)")
    println(io, pre, sps)
    println(io, "p^{-1/2}:")
    spi = sprint(show, "text/plain", p.sqrt_inv; context = io, sizehint = 0)
    spi = replace(spi, '\n' => "\n$(pre)")
    return print(io, pre, spi)
end

@doc raw"""
    zero_vector(M::SymmetricPositiveDefinite, p)

returns the zero tangent vector in the tangent space of the symmetric positive
definite matrix `p` on the [`SymmetricPositiveDefinite`](@ref) manifold `M`.
"""
zero_vector(::SymmetricPositiveDefinite, ::Any)

function zero_vector(M::SymmetricPositiveDefinite, p::SPDPoint)
    return zero_vector(M, convert(AbstractMatrix, p))
end

zero_vector!(::SymmetricPositiveDefinite, X, ::Any) = fill!(X, 0)

using Manifolds
using ManifoldsBase
using ManifoldDiff

using LinearAlgebra
using Distributions
using DoubleFloats
using Quaternions
using Random
using StaticArrays
using RecursiveArrayTools
using Statistics
using StatsBase
using Test
using Graphs
using SimpleWeightedGraphs

"""
    has_type_in_signature(sig, T::Type)

Test whether the signature `sig` has an argument of type `T` as one of its parameters.
"""
function has_type_in_signature(sig, T::Type)
    return any(
        map(Base.unwrap_unionall(sig.sig).parameters) do x
            xw = Base.rewrap_unionall(x, sig.sig)
            return (xw isa Type ? xw : xw.T) <: T
        end
    )
end

@testset "Ambiguities" begin
    if VERSION.prerelease == () && !Sys.iswindows() && VERSION < v"1.11.0"
        mbs = Test.detect_ambiguities(ManifoldsBase)
        # Interims solution until we follow what was proposed in
        # https://discourse.julialang.org/t/avoid-ambiguities-with-individual-number-element-identity/62465/2
        MBS_LIMIT = 41
        println("Number of ManifoldsBase.jl ambiguities: $(length(mbs))")
        @test length(mbs) <= MBS_LIMIT
        if length(mbs) > MBS_LIMIT
            for amb in mbs
                println(amb)
                println()
            end
        end
        ms = Test.detect_ambiguities(Manifolds)
        # Interims solution until we follow what was proposed in
        # https://discourse.julialang.org/t/avoid-ambiguities-with-individual-number-element-identity/62465/2
        MS_LIMIT = 46
        println("Number of Manifolds.jl ambiguities: $(length(ms))")
        if length(ms) > MS_LIMIT
            for amb in ms
                println(amb)
                println()
            end
        end
        @test length(ms) <= MS_LIMIT
        # this test takes way too long to perform regularly
        # @test length(our_base_ambiguities()) <= 4
    else
        @info "Skipping Ambiguity tests for pre-release versions"
    end
end

@doc raw"""
    usinc(θ::Real)

Unnormalized version of `sinc` function, i.e. ``\operatorname{usinc}(θ) = \frac{\sin(θ)}{θ}``.
This is equivalent to `sinc(θ/π)`.

Note that ForwardDiff.jl would return wrong answer at θ=0 if a simple equality was used.
"""
@inline usinc(θ::Real) = abs(θ) < eps(typeof(θ)) ? one(θ) : isinf(θ) ? zero(θ) : sin(θ) / θ

@doc raw"""
    usinc_from_cos(x::Real)

Unnormalized version of `sinc` function, i.e. ``\operatorname{usinc}(θ) = \frac{\sin(θ)}{θ}``,
computed from ``x = cos(θ)``.
"""
@inline function usinc_from_cos(x::Real)
    return if x >= 1
        one(x)
    elseif x <= -1
        zero(x)
    else
        sqrt(1 - x^2) / acos(x)
    end
end

@doc raw"""
    nzsign(z[, absz])

Compute a modified `sign(z)` that is always nonzero, i.e. where
````math
\operatorname(nzsign)(z) = \begin{cases}
    1 & \text{if } z = 0\\
    \frac{z}{|z|} & \text{otherwise}
\end{cases}
````

Note that the condition `absz == 0` would be incorrectly handled by ForwardDiff.jl.
"""
@inline function nzsign(z, absz = abs(z))
    psignz = z / absz
    return ifelse(absz < eps(typeof(absz))^2, one(psignz), psignz)
end

allocate(p, s::Size{S}) where {S} = similar(p, S...)
allocate(p::StaticArray, s::Size{S}) where {S} = similar(p, maybesize(s))
allocate(p, ::Type{T}, s::Size{S}) where {S, T} = similar(p, T, S...)
allocate(p::StaticArray, ::Type{T}, s::Size{S}) where {S, T} = similar(p, T, maybesize(s))

quat_promote(T::Type{<:Number}) = typeof(Quaternions.quat(zero(T)))

allocation_promotion_function(::AbstractManifold{ℍ}, f, args::Tuple) = quat_promote

"""
    eigen_safe(x)

Compute the eigendecomposition of `x`. If `x` is a `StaticMatrix`, it is
converted to a `Matrix` before the decomposition.
"""
@inline eigen_safe(x; kwargs...) = eigen(x; kwargs...)
@inline function eigen_safe(x::StaticMatrix; kwargs...)
    s = size(x)
    E = eigen!(Matrix(parent(x)); kwargs...)
    return Eigen(SizedVector{s[1]}(E.values), SizedMatrix{s...}(E.vectors))
end

"""
    log_safe(x)

Compute the matrix logarithm of `x`. If `x` is a `StaticMatrix`, it is
converted to a `Matrix` before computing the log.
"""
@inline log_safe(x) = log(x)
@inline function log_safe(x::StaticMatrix)
    s = Size(x)
    return SizedMatrix{s[1], s[2]}(log(Matrix(parent(x))))
end

# NOTE: workaround until https://github.com/JuliaLang/julia/pull/39973 or similar is merged
"""
    log_safe!(y, x)

Compute the matrix logarithm of `x`. If the eltype of `y` is real, then the imaginary part
of `x` is ignored, and a `DomainError` is raised if `real(x)` has no real logarithm.
"""
function log_safe!(Y, A)
    if eltype(Y) <: Real
        if ishermitian(A)
            eigenF = eigen(Symmetric(real(A)))
            i = findfirst(≤(0), eigenF.values)
            if i !== nothing
                throw(
                    DomainError(
                        eigenF.values[i],
                        "All eigenvalues must be positive to compute a real logarithm.",
                    ),
                )
            end
            mul!(Y, eigenF.vectors .* log.(eigenF.values'), eigenF.vectors')
        elseif istriu(A)
            i = findfirst(≤(0), @view(A[diagind(A)]))
            if i !== nothing
                throw(
                    DomainError(
                        A[i, i],
                        "All eigenvalues must be positive to compute a real logarithm.",
                    ),
                )
            end
            copyto!(Y, real(log(UpperTriangular(A))))
        else
            schurF = schur(convert(Matrix, real(A)))
            i = findfirst(x -> isreal(x) && real(x) ≤ 0, schurF.values)
            if i !== nothing
                throw(
                    DomainError(
                        schurF.values[i],
                        "All eigenvalues must be positive to compute a real logarithm.",
                    ),
                )
            end
            if istriu(schurF.T)
                mul!(Y, schurF.Z, real(log(UpperTriangular(schurF.T))) * schurF.Z')
            else
                schurS = schur(complex(schurF.T))
                Y .= real.(schurS.Z * log(UpperTriangular(schurS.T)) * schurS.Z')
                mul!(Y, schurF.Z * Y, schurF.Z')
            end
        end
    else
        copyto!(Y, log_safe(A))
    end
    return Y
end

"""
    mul!_safe(Y, A, B) -> Y

Call `mul!` safely, that is, `A` and/or `B` are permitted to alias with `Y`.
"""
mul!_safe(Y, A, B) = (Y === A || Y === B) ? copyto!(Y, A * B) : mul!(Y, A, B)

@doc raw"""
    realify(X::AbstractMatrix{T𝔽}, 𝔽::AbstractNumbers) -> Y::AbstractMatrix{<:Real}

Given a matrix ``X ∈ 𝔽^{n×n}``, compute ``Y ∈ ℝ^{m×m}``, where ``m = n \operatorname{dim}_𝔽``,
and ``\operatorname{dim}_𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of the number field ``𝔽``, using
the map ``ϕ \colon X ↦ Y``, that preserves the matrix product, so that for all
``C,D ∈ 𝔽^{n×n}``,
````math
ϕ(C) ϕ(D) = ϕ(CD).
````
See [`realify!`](@ref) for an in-place version, and [`unrealify!`](@ref) to compute the
inverse of ``ϕ``.
"""
function realify(X, 𝔽)
    n = LinearAlgebra.checksquare(X)
    nℝ = real_dimension(𝔽) * n
    Y = allocate(X, real(eltype(X)), nℝ, nℝ)
    return realify!(Y, X, 𝔽, n)
end
realify(X, ::typeof(ℝ)) = X

"""
    realify!(Y::AbstractMatrix{<:Real}, X::AbstractMatrix{T𝔽}, 𝔽::AbstractNumbers)

In-place version of [`realify`](@ref).
"""
realify!(Y, X, 𝔽)

@doc raw"""
    realify!(Y::AbstractMatrix{<:Real}, X::AbstractMatrix{<:Complex}, ::typeof(ℂ))

Given a complex matrix ``X = A + iB ∈ ℂ^{n×n}``, compute its realified matrix
``Y ∈ ℝ^{2n×2n}``, written
where
````math
Y = \begin{pmatrix}A & -B \\ B & A \end{pmatrix}.
````
"""
function realify!(Y, X, ::typeof(ℂ), n = LinearAlgebra.checksquare(X))
    for i in 1:n, j in 1:n
        Xr, Xi = reim(X[i, j])
        Y[i, j] = Y[n + i, n + j] = Xr
        Y[n + i, j] = Xi
        Y[i, n + j] = -Xi
    end
    return Y
end

@doc raw"""
    unrealify!(X::AbstractMatrix{T𝔽}, Y::AbstractMatrix{<:Real}, 𝔽::AbstractNumbers[, n])

Given a real matrix ``Y ∈ ℝ^{m×m}``, where ``m = n \operatorname{dim}_𝔽``, and
``\operatorname{dim}_𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of the number field ``𝔽``, compute
in-place its equivalent matrix ``X ∈ 𝔽^{n×n}``. Note that this function does not check that
``Y`` has a valid structure to be un-realified.

See [`realify!`](@ref) for the inverse of this function.
"""
unrealify!(X, Y, 𝔽)

function unrealify!(X, Y, ::typeof(ℂ), n = LinearAlgebra.checksquare(X))
    for i in 1:n, j in 1:n
        X[i, j] = complex((Y[i, j] + Y[n + i, n + j]) / 2, (Y[n + i, j] - Y[i, n + j]) / 2)
    end
    return X
end
unrealify!(Y, X, ::typeof(ℝ), args...) = copyto!(Y, X)

@generated maybesize(s::Size{S}) where {S} = prod(S) > 100 ? S : :(s)

@doc raw"""
    symmetrize!(Y, X)

Given a square matrix `X` compute `1/2 .* (X' + X)` in place of `Y`.
"""
function symmetrize!(Y, X)
    Y .= (X' .+ X) ./ 2
    return Y
end

@doc raw"""
    symmetrize(X)

Given a square matrix `X` compute `1/2 .* (X' + X)`.
"""
function symmetrize(X)
    return (X' .+ X) ./ 2
end

@doc raw"""
    vec2skew!(X, v, k)

Create a skew symmetric matrix in-place in `X` of size ``k×k`` from a vector `v`,
for example for `v=[1,2,3]` and `k=3` this
yields
````julia
[  0  1  2;
  -1  0  3;
  -2 -3  0
]
````
"""
function vec2skew!(X, v)
    k = size(X)[1]
    size(X)[2] != k && error("X is of wrong size, expected ($k,$k) got $(size(X)).")
    n = div(k * (k - 1), 2)
    length(v) < n && error("The vector $(v) is too short, expected $(n) got $(length(v)).")
    m = 0
    X .= [i < j ? (m += 1; v[m]) : zero(eltype(v)) for i in 1:k, j in 1:k]
    X .= X - X'
    return X
end
function vec2skew(v, k)
    X = similar(v, k, k)
    vec2skew!(X, v)
    return X
end

@doc raw"""
    isnormal(x; kwargs...) -> Bool

Check if the matrix or number `x` is normal, that is, if it commutes with its adjoint:
````math
x x^\mathrm{H} = x^\mathrm{H} x.
````
By default, this is an equality check. Provide `kwargs` for `isapprox` to perform an
approximate check.
"""
function isnormal(x; kwargs...)
    (isdiag(x) || ishermitian(x)) && return true
    isempty(kwargs) && return x * x' == x' * x
    return isapprox(x * x', x' * x; kwargs...)
end
isnormal(::LinearAlgebra.RealHermSymComplexHerm; kwargs...) = true

_eps_safe(::Type{T}) where {T <: Integer} = zero(T)
_eps_safe(::Type{T}) where {T <: Real} = eps(T)
_eps_safe(::Type{T}) where {T <: Number} = eps(real(T))

max_eps(xs...) = maximum(_eps_safe ∘ eltype, xs)

"""
    sectional_curvature_matrix(M::AbstractManifold, p, B::AbstractBasis)

Compute the matrix of sectional curvatures of manifold `M` at point `p`.
Entry `(i, j)` corresponds to sectional curvature of the surface spanned by vectors
`i`  and `j` from basis `B`.
"""
function sectional_curvature_matrix(M::AbstractManifold, p, B::AbstractBasis)
    V = get_vectors(M, p, get_basis(M, p, B))
    N = length(V)
    result = zeros(N, N)
    for (i, e_i) in enumerate(V)
        for (j, e_j) in enumerate(V)
            if i < j
                result[i, j] = sectional_curvature(M, p, e_i, e_j)
                result[j, i] = result[i, j]
            end
        end
    end
    return result
end

@doc raw"""
    estimated_sectional_curvature(M::AbstractManifold, p, X, Y; r::Real=1e-3, N::Int=10000)

Approximate sectional curvature of manifold `M` in the plane spanned by vectors `X` and `Y`
from tangent space at `p` using a circle on `M` of radius `r` divided into `N` segments.

The approximation is derived from the [Bertrand–Diguet–Puiseux theorem](https://en.wikipedia.org/wiki/Bertrand%E2%80%93Diguet%E2%80%93Puiseux_theorem)
which states that
````math
\kappa_p(X, Y) = \lim_{r \to 0^+} 3\frac{2\pi r-C(r)}{\pi r^3},
````
where ``C(r)`` is the circumference of the circle of radius ``r`` around `p` in submanifold
of `M` spanned by `X` and `Y`. The circumference calculation method has a tendency to
return curvature values larger than the exact ones.
"""
function estimated_sectional_curvature(
        M::AbstractManifold,
        p,
        X,
        Y;
        r::Real = 1.0e-3,
        N::Int = 10000,
    )
    circumference = 0.0
    p_i = similar(p)
    p_ip1 = similar(p)
    for i in 1:N
        θ_i = 2π * (i - 1) / N
        θ_ip1 = 2π * (i) / N
        exp!(M, p_i, p, r .* (sin(θ_i) .* X .+ cos(θ_i) .* Y))
        exp!(M, p_ip1, p, r .* (sin(θ_ip1) .* X .+ cos(θ_ip1) .* Y))

        circumference += distance(M, p_i, p_ip1)
    end
    return 3 * (2π * r - circumference) / (π * r^3)
end

"""
    estimated_sectional_curvature_matrix(M::AbstractManifold, p, B::AbstractBasis; r::Real=1e-3, N::Int=10000)

Estimate the matrix of sectional curvatures of manifold `M` at point `p` using
`estimated_sectional_curvature`. Entry `(i, j)`` corresponds to sectional curvature of the
surface spanned by vectors `i`  and `j` from basis `B`.
"""
function estimated_sectional_curvature_matrix(
        M::AbstractManifold,
        p,
        B::AbstractBasis;
        r::Real = 1.0e-3,
        N_pts::Int = 10000,
    )
    V = get_vectors(M, p, get_basis(M, p, B))
    N = length(V)
    result = zeros(N, N)
    for (i, e_i) in enumerate(V)
        for (j, e_j) in enumerate(V)
            if i < j
                result[i, j] = estimated_sectional_curvature(M, p, e_i, e_j; r = r, N = N_pts)
                result[j, i] = result[i, j]
            end
        end
    end
    return result
end

function _ensure_nonzero_rng_determinant!(
        rng,
        M::AbstractManifold,
        pX;
        atol::Real = sqrt(eps(real(eltype(pX)))),
        kwargs...,
    )
    while abs(det(pX)) < atol
        rand!(rng, M, pX; kwargs...)
    end
    return
end

include("../header.jl")

@testset "Hyperrectangle" begin
    M = Hyperrectangle([-1.0, 2.0, -3.0], [1.0, 4.0, 9.0])
    @test repr(M) == "Hyperrectangle([-1.0, 2.0, -3.0], [1.0, 4.0, 9.0])"

    @test_throws ArgumentError Hyperrectangle([1.0, 2.0], [-1.0, 5.0])

    @test is_flat(M)
    @test metric(M) == EuclideanMetric()
    p = zeros(3)
    @test project!(M, p, p) == p
    @test embed!(M, p, p) == p
    X = zeros(3)
    X[1] = 1.0
    Y = similar(X)
    project!(M, Y, p, X)
    @test Y == X
    @test embed(M, p, X) == X

    @test_throws DomainError is_point(M, [1.0im, 0.0, 0.0]; error = :error)
    @test_throws DomainError is_point(M, [NaN, 3.0, 0.0]; error = :error)
    @test_throws DomainError is_point(M, [10.0, 3.0, 0.0]; error = :error)
    @test_throws DomainError is_vector(M, [1.0, 2.0, 0.0], [1.0im, 0.0, 0.0]; error = :error)
    @test_throws DomainError is_vector(M, [1], [1.0, 1.0, 0.0]; error = :error)
    @test_throws DomainError is_vector(M, [0.0, 0.0, 0.0], [1.0]; error = :error)
    @test_throws DomainError is_vector(M, [0.0, 0.0, 0.0], [1.0, 0.0, 1.0im]; error = :error)

    @testset "projections" begin
        @test project(M, [4.0, -2.0, 3.0]) ≈ [1.0, 2.0, 3.0]
        @test project(M, [1.0, 2.0, 3.0], [2.0, -0.5, -10.0]) ≈ [0.0, 0.0, -10.0]
    end

    @testset "injectivity_radius" begin
        @test injectivity_radius(M) == 0.0
        @test injectivity_radius(M, ExponentialRetraction()) == 0.0
        @test injectivity_radius(M, [0.0, 2.5, 1.0]) == 0.5
        @test injectivity_radius(M, [0.0, 2.5, 1.0], ExponentialRetraction()) == 0.5
        @test injectivity_radius(M, [0.0, 2.5, 1.0], ProjectionRetraction()) == 0.5
        @test injectivity_radius(M, [0.0, 2.0, 1.0]) == 1.0
        @test injectivity_radius(M, [0.5, 4.0, 1.0]) == 0.5

        M2 = Hyperrectangle([-1.0, 2.0, -3.0], [1.0, 2.0, 9.0])
        @test injectivity_radius(M2, [0.0, 2.0, 1.0]) == 1.0
    end

    basis_types = (DefaultOrthonormalBasis(),)
    pts = [[1.0, 2.0, 0.0], [0.0, 3.0, 0.0], [0.0, 3.5, 1.0]]

    Manifolds.test_manifold(
        M,
        pts,
        test_injectivity_radius = false,
        parallel_transport = true,
        test_project_point = true,
        test_project_tangent = true,
        test_default_vector_transport = true,
        vector_transport_methods = [ParallelTransport()],
        retraction_methods = [ProjectionRetraction()],
        test_mutating_rand = true,
        basis_types_vecs = basis_types,
        basis_types_to_from = basis_types,
        test_inplace = true,
        test_rand_point = true,
        test_rand_tvector = true,
    )
    @testset "Array Hyperrectangle" begin
        MA = Hyperrectangle([-1.0 2.0 3.0; 2.0 5.0 10.0], [10.0 12.0 13.0; 12.0 15.0 20.0])
        pts_a = [
            [2.0 2.0 3.0; 2.0 6.0 10.0],
            [-1.0 5.0 3.0; 4.0 5.0 10.0],
            [-1.0 2.0 5.0; 6.0 6.0 15.0],
        ]
        Manifolds.test_manifold(
            MA,
            pts_a,
            test_injectivity_radius = false,
            test_project_point = true,
            test_project_tangent = true,
            test_default_vector_transport = true,
            vector_transport_methods = [ParallelTransport()],
            test_mutating_rand = true,
            basis_types_vecs = basis_types,
            basis_types_to_from = basis_types,
            test_inplace = true,
            test_rand_point = true,
            test_rand_tvector = true,
        )
    end

    @testset "Hyperrectangle(1)" begin
        M = Hyperrectangle([0.0], [5.0])
        @test distance(M, 2.0, 4.0) == 2.0
    end

    @testset "errors" begin
        M = Hyperrectangle([-1.0, 2.0, -3.0, 0.0], [1.0, 4.0, 9.0, 3.0])
        @test_throws DimensionMismatch distance(M, [1, 2, 3, 4], [1 2; 3 4])
    end

    @testset "Weingarten & Hessian" begin
        M = Hyperrectangle([-1.0, -1.0], [10.0, 10.0])
        p = [1.0, 2.0]
        G = [3.0, 4.0]
        H = [5.0, 6.0]
        X = [7.0, 8.0]
        rH = riemannian_Hessian(M, p, G, H, X)
        @test rH == H
    end
    @testset "Volume" begin
        M = Hyperrectangle([-1.0, 2.0, -3.0], [1.0, 4.0, 9.0])
        @test manifold_volume(M) == 48.0
        p = zeros(3)
        X = zeros(3)
        @test volume_density(M, p, X) == 1.0
    end

    @testset "statistics" begin
        @test default_approximation_method(M, mean) === EfficientEstimator()
        @test mean(M, pts) ≈ [1 / 3, 17 / 6, 1 / 3]
        @test mean(M, pts, pweights(ones(3) / 3)) ≈ [1 / 3, 17 / 6, 1 / 3]
        @test_throws DimensionMismatch mean(M, pts, pweights(ones(4) / 4))
        @test var(M, pts) ≈ 1.25
    end

    @testset "Euclidean metric tests" begin
        @test riemann_tensor(
            M,
            pts[1],
            pts[2] - pts[1],
            pts[3] - pts[1],
            (pts[3] - pts[1]) / 2,
        ) == [0.0, 0.0, 0.0]
        @test sectional_curvature(M, p, [1.0, 0.0], [0.0, 1.0]) == 0.0
        @test sectional_curvature_max(M) == 0.0
        @test sectional_curvature_min(M) == 0.0
    end

    @testset "rand special cases" begin
        M = Hyperrectangle([-1.0, -1.0, -Inf, -Inf], [1.0, Inf, 1.0, Inf])
        p = rand(M)
        @test is_point(M, p)
    end

    @testset "has_components and r-norms" begin
        M = Hyperrectangle([-1.0, -1.0], [10.0, 10.0])
        @test has_components(M)
        p = [1.0, 2.0]
        q = [1.0, 2.0]
        X = [4.0, 5.0]
        for r in [1, 2, Inf]
            @test norm(M, p, X, r) ≈ norm(X, r)
            @test distance(M, p, q, r) ≈ norm(p - q, r)
        end
    end
end

@doc raw"""
    Grassmann{T,𝔽} <: AbstractDecoratorManifold{𝔽}

The Grassmann manifold ``\mathrm{Gr}(n,k)`` consists of all subspaces spanned by ``k`` linear independent
vectors ``𝔽^n``, where ``𝔽  ∈ \{ℝ, ℂ\}`` is either the real- (or complex-) valued vectors.
This yields all ``k``-dimensional subspaces of ``ℝ^n`` for the real-valued case and all ``2k``-dimensional subspaces
of ``ℂ^n`` for the second.

The manifold can be represented as

````math
\mathrm{Gr}(n,k) := \bigl\{ \operatorname{span}(p) : p ∈ 𝔽^{n×k}, p^\mathrm{H}p = I_k\},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or Hermitian and
``I_k`` is the ``k×k`` identity matrix. This means, that the columns of ``p``
form an unitary basis of the subspace, that is a point on
``\operatorname{Gr}(n,k)``, and hence the subspace can actually be represented by
a whole equivalence class of representers.
Another interpretation is, that

````math
\mathrm{Gr}(n,k) = \mathrm{St}(n,k) / \operatorname{O}(k),
````

i.e the Grassmann manifold is the quotient of the [`Stiefel`](@ref) manifold and
the orthogonal group ``\operatorname{O}(k)`` of orthogonal ``k×k`` matrices.
Note that it doesn't matter whether we start from the Euclidean or canonical metric
on the Stiefel manifold, the resulting quotient metric on Grassmann is the same.

The tangent space at a point (subspace) ``p`` is given by

````math
T_p\mathrm{Gr}(n,k) = \bigl\{
X ∈ 𝔽^{n×k} :
X^{\mathrm{H}}p + p^{\mathrm{H}}X = 0_{k} \bigr\},
````

where ``0_k`` is the ``k×k`` zero matrix.

Note that a point ``p ∈ \operatorname{Gr}(n,k)`` might be represented by
different matrices (i.e. matrices with unitary column vectors that span
the same subspace). Different representations of ``p`` also lead to different
representation matrices for the tangent space ``T_p\mathrm{Gr}(n,k)``

For a representation of points as orthogonal projectors. Here

```math
\operatorname{Gr}(n,k) := \bigl\{ p \in \mathbb R^{n×n} : p = p^˜\mathrm{T}, p^2 = p, \operatorname{rank}(p) = k\},
```

with tangent space

```math
T_p\mathrm{Gr}(n,k) = \bigl\{
X ∈ \mathbb R^{n×n} : X=X^{\mathrm{T}} \text{ and } X = pX+Xp \bigr\},
```

see also [`ProjectorPoint`](@ref) and [`ProjectorTangentVector`](@ref).

The manifold is named after
[Hermann G. Graßmann](https://en.wikipedia.org/wiki/Hermann_Grassmann) (1809-1877).

A good overview can be found in[BendokatZimmermannAbsil:2020](@cite).

# Constructor

    Grassmann(n, k, field=ℝ, parameter::Symbol=:type)

Generate the Grassmann manifold ``\operatorname{Gr}(n,k)``, where the real-valued
case `field=ℝ` is the default.
"""
struct Grassmann{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

#
# Generic functions independent of the representation of points
#
function Grassmann(n::Int, k::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, k))
    return Grassmann{field, typeof(size)}(size)
end

function allocation_promotion_function(::Grassmann{ℂ}, f, args::Tuple)
    return complex
end

@doc raw"""
    change_representer(M::Grassmann, ::EuclideanMetric, p, X)

Change `X` to the corresponding representer of a cotangent vector at `p`.
Since the [`Grassmann`](@ref) manifold `M` is isometrically embedded, this is the identity.
"""
change_representer(::Grassmann, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(M::Grassmann, Y, ::EuclideanMetric, p, X)
    copyto!(M, Y, p, X)
    return Y
end

@doc raw"""
    change_metric(M::Grassmann, ::EuclideanMetric, p, X)

Change `X` to the corresponding vector with respect to the metric of the [`Grassmann`](@ref) `M`,
which is just the identity, since the manifold is isometrically embedded.
"""
change_metric(M::Grassmann, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(::Grassmann, Y, ::EuclideanMetric, p, X)
    copyto!(Y, X)
    return Y
end

@doc raw"""
    injectivity_radius(M::Grassmann)
    injectivity_radius(M::Grassmann, p)

Return the injectivity radius on the [`Grassmann`](@ref) `M`, which is ``\frac{π}{2}``.
"""
injectivity_radius(::Grassmann) = π / 2
injectivity_radius(::Grassmann, p) = π / 2
injectivity_radius(::Grassmann, ::AbstractRetractionMethod) = π / 2
injectivity_radius(::Grassmann, p, ::AbstractRetractionMethod) = π / 2

function _isapprox(M::Grassmann, p, X, Y; atol = sqrt(max_eps(X, Y)), kwargs...)
    return isapprox(norm(M, p, X - Y), 0; atol = atol, kwargs...)
end
function _isapprox(M::Grassmann, p, q; atol = sqrt(max_eps(p, q)), kwargs...)
    return isapprox(distance(M, p, q), 0; atol = atol, kwargs...)
end

"""
    is_flat(M::Grassmann)

Return true if [`Grassmann`](@ref) `M` is one-dimensional.
"""
is_flat(M::Grassmann) = manifold_dimension(M) == 1

@doc raw"""
    manifold_dimension(M::Grassmann)

Return the dimension of the [`Grassmann`](@ref)`(n,k,𝔽)` manifold `M`, i.e.

````math
\dim \operatorname{Gr}(n,k) = k(n-k) \dim_ℝ 𝔽,
````

where ``\dim_ℝ 𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of `𝔽`.
"""
function manifold_dimension(M::Grassmann{𝔽}) where {𝔽}
    n, k = get_parameter(M.size)
    return k * (n - k) * real_dimension(𝔽)
end

"""
    mean(
        M::Grassmann,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolationWithinRadius(π/4);
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).
"""
mean(::Grassmann, ::Any...)

function default_approximation_method(::Grassmann, ::typeof(mean))
    return GeodesicInterpolationWithinRadius(π / 4)
end

@doc raw"""
    get_total_space(::Grassmann)

Return the total space of the [`Grassmann`](@ref) manifold, which is the corresponding Stiefel manifold,
independent of whether the points are represented already in the total space or as [`ProjectorPoint`](@ref)s.
"""
function get_total_space(::Grassmann{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return Stiefel(n, k, 𝔽)
end
function get_total_space(M::Grassmann{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return Stiefel(n, k, 𝔽; parameter = :field)
end

#
# Representer specific implementations in their corresponding subfiles
#
include("GrassmannStiefel.jl")
include("GrassmannProjector.jl")

#
# Quotient structure Stiefel and Projectors
#
#
# Conversions
#
@doc raw"""
    convert(::Type{ProjectorPoint}, p::AbstractMatrix)

Convert a point `p` on [`Stiefel`](@ref) that also represents a point (i.e. subspace) on [`Grassmann`](@ref)
to a projector representation of said subspace, i.e. compute the [`canonical_project!`](@ref)
for

```math
  π^{\mathrm{SG}}(p) = pp^{\mathrm{T}}.
```
"""
convert(::Type{ProjectorPoint}, p::AbstractMatrix) = ProjectorPoint(p * p')
@doc raw"""
    convert(::Type{ProjectorPoint}, ::Stiefelpoint)

Convert a point `p` on [`Stiefel`](@ref) that also represents a point (i.e. subspace) on [`Grassmann`](@ref)
to a projector representation of said subspace, i.e. compute the [`canonical_project!`](@ref)
for

```math
  π^{\mathrm{SG}}(p) = pp^{\mathrm{T}}.
```
"""
convert(::Type{ProjectorPoint}, p::StiefelPoint) = ProjectorPoint(p.value * p.value')

"""
    default_retraction_method(M::Grassmann)
    default_retraction_method(M::Grassmann, ::Type{StiefelPoint})
    default_retraction_method(M::Grassmann, ::Type{ProjectorPoint})

Return `ExponentialRetraction` as the default on the [`Grassmann`](@ref) manifold
for both representations.
"""
default_retraction_method(::Grassmann) = ExponentialRetraction()

"""
    default_vector_transport_method(M::Grassmann)

Return the default vector transport method for the [`Grassmann`](@ref) manifold,
which is `ParallelTransport``()`.
"""
default_vector_transport_method(::Grassmann) = ParallelTransport()

using Test
using Manifolds
using RecursiveArrayTools

@testset "Multitangent bundle" begin
    M = Sphere(2)
    m_prod_retr = Manifolds.FiberBundleProductRetraction()
    m_prod_invretr = Manifolds.FiberBundleInverseProductRetraction()
    m_sasaki = SasakiRetraction(5)

    @testset "Nice access to vector bundle components" begin
        TB = Manifolds.MultitangentBundle{2}(M)
        p = ArrayPartition(
            [1.0, 0.0, 0.0],
            ArrayPartition([0.0, 2.0, 4.0], [0.0, -1.0, 0.0]),
        )
        @test p[TB, :point] === p.x[1]
        p[TB, :point] = [0.0, 1.0, 0.0]
        @test p.x[1] == [0.0, 1.0, 0.0]
        @test_throws DomainError p[TB, :error]
        @test_throws DomainError p[TB, :error] = [1, 2, 3]

        @test view(p, TB, :point) === p.x[1]
        view(p, TB, :point) .= [2.0, 3.0, 5.0]
        @test p.x[1] == [2.0, 3.0, 5.0]
        @test_throws DomainError view(p, TB, :error)
    end

    p = [1.0, 0.0, 0.0]
    TB = Manifolds.MultitangentBundle{2}(M)
    # @test sprint(show, TB) == "TangentBundle(Sphere(2, ℝ))"
    @test base_manifold(TB) == M
    @test manifold_dimension(TB) == 3 * manifold_dimension(M)
    @test representation_size(TB) === nothing
    @test default_inverse_retraction_method(TB) === m_prod_invretr
    @test default_retraction_method(TB) == m_prod_retr
    @test default_vector_transport_method(TB) isa
        Manifolds.FiberBundleProductVectorTransport

    @testset "Type" begin
        pts_tb = [
            ArrayPartition(
                [1.0, 0.0, 0.0],
                ArrayPartition([0.0, -1.0, -1.0], [0.0, -1.0, -1.0]),
            ),
            ArrayPartition(
                [0.0, 1.0, 0.0],
                ArrayPartition([2.0, 0.0, 1.0], [-1.0, 0.0, -2.0]),
            ),
            ArrayPartition(
                [1.0, 0.0, 0.0],
                ArrayPartition([0.0, 2.0, -1.0], [0.0, -2.0, -1.0]),
            ),
        ]

        for pt in pts_tb
            @test bundle_projection(TB, pt) ≈ pt.x[1]
        end
        X12_prod = inverse_retract(TB, pts_tb[1], pts_tb[2], m_prod_invretr)
        X13_prod = inverse_retract(TB, pts_tb[1], pts_tb[3], m_prod_invretr)
        basis_types =
            (DefaultOrthonormalBasis(), get_basis(TB, pts_tb[1], DefaultOrthonormalBasis()))
        Manifolds.test_manifold(
            TB,
            pts_tb,
            default_inverse_retraction_method = m_prod_invretr,
            default_retraction_method = m_prod_retr,
            inverse_retraction_methods = [m_prod_invretr],
            retraction_methods = [m_prod_retr],
            test_exp_log = false,
            test_injectivity_radius = false,
            test_tangent_vector_broadcasting = false,
            test_default_vector_transport = true,
            vector_transport_methods = [],
            basis_types_vecs = basis_types,
            projection_atol_multiplier = 4,
            test_inplace = true,
            test_representation_size = false,
            test_rand_point = true,
            test_rand_tvector = true,
        )

        Xir = allocate(pts_tb[1])
        inverse_retract!(TB, Xir, pts_tb[1], pts_tb[2], m_prod_invretr)
        @test isapprox(TB, pts_tb[1], Xir, X12_prod)
        @test isapprox(
            norm(TB.fiber, pts_tb[1][TB, :point], pts_tb[1][TB, :vector]),
            sqrt(
                inner(
                    TB.fiber,
                    pts_tb[1][TB, :point],
                    pts_tb[1][TB, :vector],
                    pts_tb[1][TB, :vector],
                ),
            ),
        )
        @test isapprox(
            distance(
                TB.fiber,
                pts_tb[1][TB, :point],
                pts_tb[1][TB, :vector],
                ArrayPartition([0.0, 2.0, 3.0], [0.0, 2.0, 2.0]),
            ),
            9.273618495495704,
        )
        Xir2 = allocate(pts_tb[1])
        vector_transport_to!(
            TB,
            Xir2,
            pts_tb[1],
            Xir,
            pts_tb[2],
            Manifolds.FiberBundleProductVectorTransport(),
        )
        @test is_vector(TB, pts_tb[2], Xir2)
    end

    @test base_manifold(TangentBundle(M)) == M
end

@doc raw"""
    GeneralizedGrassmann{𝔽,T,TB<:AbstractMatrix} <: AbstractDecoratorManifold{𝔽}

The generalized Grassmann manifold ``\operatorname{Gr}(n,k,B)`` consists of all subspaces
spanned by ``k`` linear independent vectors ``𝔽^n``, where ``𝔽  ∈ \{ℝ, ℂ\}`` is either the real- (or complex-) valued vectors.
This yields all ``k``-dimensional subspaces of ``ℝ^n`` for the real-valued case and all ``2k``-dimensional subspaces
of ``ℂ^n`` for the second.

The manifold can be represented as

````math
\operatorname{Gr}(n, k, B) := \bigl\{ \operatorname{span}(p)\ \big|\ p ∈ 𝔽^{n×k}, p^\mathrm{H}Bp = I_k\},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate (or Hermitian) transpose and
``I_k`` is the ``k×k`` identity matrix. This means, that the columns of ``p``
form an unitary basis of the subspace with respect to the scaled inner product, that is a
point on ``\operatorname{Gr}(n,k,B)``, and hence the subspace can actually be represented by
a whole equivalence class of representers. For ``B=I_n`` this simplifies to the [`Grassmann`](@ref) manifold.

The tangent space at a point (subspace) ``p`` is given by

````math
T_x\mathrm{Gr}(n,k,B) = \bigl\{
X ∈ 𝔽^{n×k} :
X^{\mathrm{H}}Bp + p^{\mathrm{H}}BX = 0_{k} \bigr\},
````

where ``0_{k}`` denotes the ``k×k`` zero matrix.

Note that a point ``p ∈ \operatorname{Gr}(n,k,B)`` might be represented by
different matrices (i.e. matrices with ``B``-unitary column vectors that span
the same subspace). Different representations of ``p`` also lead to different
representation matrices for the tangent space ``T_p\mathrm{Gr}(n,k,B)``

The manifold is named after
[Hermann G. Graßmann](https://en.wikipedia.org/wiki/Hermann_Grassmann) (1809-1877).

# Constructor

    GeneralizedGrassmann(n, k, B=I_n, field=ℝ)

Generate the (real-valued) Generalized Grassmann manifold of ``n×k`` dimensional
orthonormal matrices with scalar product `B`.
"""
struct GeneralizedGrassmann{𝔽, T, TB <: AbstractMatrix} <: AbstractDecoratorManifold{𝔽}
    size::T
    B::TB
end

function GeneralizedGrassmann(
        n::Int,
        k::Int,
        B::AbstractMatrix = Matrix{Float64}(I, n, n),
        𝔽::AbstractNumbers = ℝ;
        parameter::Symbol = :type,
    )
    size = wrap_type_parameter(parameter, (n, k))
    return GeneralizedGrassmann{𝔽, typeof(size), typeof(B)}(size, B)
end

@doc raw"""
    change_representer(M::GeneralizedGrassmann, ::EuclideanMetric, p, X)

Change `X` to the corresponding representer of a cotangent vector at `p` with respect to the scaled metric
of the [`GeneralizedGrassmann`](@ref) `M`, i.e, since

```math
g_p(X,Y) = \operatorname{tr}(Y^{\mathrm{H}}BZ) = \operatorname{tr}(X^{\mathrm{H}}Z) = ⟨X,Z⟩
```

has to hold for all ``Z``, where the repreenter `X` is given, the resulting representer with
respect to the metric on the [`GeneralizedGrassmann`](@ref) is given by ``Y = B^{-1}X``.
"""
change_representer(::GeneralizedGrassmann, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(M::GeneralizedGrassmann, Y, ::EuclideanMetric, p, X)
    return copyto!(M, Y, p, M.B \ X)
end

@doc raw"""
    change_metric(M::GeneralizedGrassmann, ::EuclideanMetric, p X)

Change `X` to the corresponding vector with respect to the metric of the [`GeneralizedGrassmann`](@ref) `M`,
i.e. let ``B=LL'`` be the Cholesky decomposition of the matrix `M.B`, then the corresponding vector is ``L\X``.
"""
change_metric(M::GeneralizedGrassmann, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(M::GeneralizedGrassmann, Y, ::EuclideanMetric, p, X)
    C2 = cholesky(M.B).L
    copyto!(Y, X)
    ldiv!(C2, Y)
    return Y
end

@doc raw"""
    check_point(M::GeneralizedGrassmann, p)

Check whether `p` is representing a point on the [`GeneralizedGrassmann`](@ref) `M`, i.e. its
a `n`-by-`k` matrix of unitary column vectors with respect to the B inner product and
of correct `eltype` with respect to `𝔽`.
"""
function check_point(M::GeneralizedGrassmann, p; kwargs...)
    return nothing # everything already checked in the embedding (generalized Stiefel)
end

@doc raw"""
    check_vector(M::GeneralizedGrassmann, p, X; kwargs...)

Check whether `X` is a tangent vector in the tangent space of `p` on
the [`GeneralizedGrassmann`](@ref) `M`, i.e. that `X` is of size and type as well as that

````math
    p^{\mathrm{H}}BX + \overline{X^{\mathrm{H}}Bp} = 0_k,
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transpose or Hermitian,
``\overline{⋅}`` the (elementwise) complex conjugate, and ``0_k`` denotes the ``k×k`` zero natrix.
"""
function check_vector(M::GeneralizedGrassmann, p, X; kwargs...)
    return nothing # everything already checked in the embedding (generalized Stiefel)
end

@doc raw"""
    distance(M::GeneralizedGrassmann, p, q)

Compute the Riemannian distance on [`GeneralizedGrassmann`](@ref)
manifold `M```= \mathrm{Gr}(n,k,B)``.

The distance is given by
````math
d_{\mathrm{Gr}(n,k,B)}(p,q) = \operatorname{norm}(\log_p(q)).
````
"""
function distance(M::GeneralizedGrassmann, p, q)
    z = p' * M.B' * q
    X = allocate_result(M, log, p, q)
    X .= q / z .- p
    d = svd(X)
    X .= d.U .* atan.(d.S')
    return norm(M, p, X)
end

embed(::GeneralizedGrassmann, p) = p
embed(::GeneralizedGrassmann, p, X) = X

@doc raw"""
    exp(M::GeneralizedGrassmann, p, X)

Compute the exponential map on the [`GeneralizedGrassmann`](@ref) `M` ``= \mathrm{Gr}(n,k,B)``
starting in `p` with tangent vector (direction) `X`. Let ``X^{\mathrm{H}}BX = USV`` denote the
SVD decomposition of ``X^{\mathrm{H}}BX``. Then the exponential map is written using

````math
\exp_p X = p V\cos(S)V^\mathrm{H} + U\sin(S)V^\mathrm{H},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian and the
cosine and sine are applied element wise to the diagonal entries of ``S``.
"""
exp(::GeneralizedGrassmann, ::Any...)

function exp!(M::GeneralizedGrassmann, q, p, X)
    norm(M, p, X) ≈ 0 && return copyto!(q, p)
    d = svd(X' * M.B * X)
    V = d.Vt
    S = abs.(sqrt.(d.S))
    mul!(q, p * (V .* cos.(S')) + X * (V .* usinc.(S')), V)
    project!(M, q, q)
    return q
end

@doc raw"""
    injectivity_radius(M::GeneralizedGrassmann)
    injectivity_radius(M::GeneralizedGrassmann, p)

Return the injectivity radius on the [`GeneralizedGrassmann`](@ref) `M`,
which is ``\frac{π}{2}``.
"""
injectivity_radius(::GeneralizedGrassmann) = π / 2
injectivity_radius(::GeneralizedGrassmann, p) = π / 2
injectivity_radius(::GeneralizedGrassmann, ::AbstractRetractionMethod) = π / 2
injectivity_radius(::GeneralizedGrassmann, p, ::AbstractRetractionMethod) = π / 2

"""
    is_flat(M::GeneralizedGrassmann)

Return true if [`GeneralizedGrassmann`](@ref) `M` is one-dimensional.
"""
is_flat(M::GeneralizedGrassmann) = manifold_dimension(M) == 1

function get_embedding(M::GeneralizedGrassmann{𝔽, TypeParameter{Tuple{n, k}}}) where {n, k, 𝔽}
    return GeneralizedStiefel(n, k, M.B, 𝔽)
end
function get_embedding(M::GeneralizedGrassmann{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return GeneralizedStiefel(n, k, M.B, 𝔽; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::GeneralizedGrassmann)
    return ManifoldsBase.EmbeddedManifoldType()
end

@doc raw"""
    inner(M::GeneralizedGrassmann, p, X, Y)

Compute the inner product for two tangent vectors `X`, `Y` from the tangent space
of `p` on the [`GeneralizedGrassmann`](@ref) manifold `M`. The formula reads

````math
g_p(X,Y) = \operatorname{tr}(X^{\mathrm{H}}BY),
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
"""
inner(M::GeneralizedGrassmann, p, X, Y) = dot(X, M.B, Y)

function _isapprox(M::GeneralizedGrassmann, p, X, Y; atol = sqrt(max_eps(X, Y)), kwargs...)
    return isapprox(norm(M, p, X - Y), 0; atol = atol, kwargs...)
end
function _isapprox(M::GeneralizedGrassmann, p, q; atol = sqrt(max_eps(p, q)), kwargs...)
    return isapprox(distance(M, p, q), 0; atol = atol, kwargs...)
end

@doc raw"""
    log(M::GeneralizedGrassmann, p, q)

Compute the logarithmic map on the [`GeneralizedGrassmann`](@ref) `M` `` = \mathcal M=\mathrm{Gr}(n,k,B)``,
i.e. the tangent vector `X` whose corresponding [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) starting from `p`
reaches `q` after time 1 on `M`. The formula reads

````math
\log_p q = V⋅ \operatorname{atan}(S) ⋅ U^\mathrm{H},
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian.
The matrices ``U`` and ``V`` are the unitary matrices, and ``S`` is the diagonal matrix
containing the singular values of the SVD-decomposition

````math
USV = (q^\mathrm{H}Bp)^{-1} ( q^\mathrm{H} - q^\mathrm{H}Bpp^\mathrm{H}).
````

In this formula the ``\operatorname{atan}`` is meant elementwise.
"""
log(::GeneralizedGrassmann, ::Any...)

function log!(M::GeneralizedGrassmann, X, p, q)
    z = p' * M.B' * q
    X .= q / z .- p
    d = svd(X)
    return mul!(X, d.U, atan.(d.S) .* d.Vt)
end

@doc raw"""
    manifold_dimension(M::GeneralizedGrassmann)

Return the dimension of the [`GeneralizedGrassmann(n,k,𝔽)`](@ref) manifold `M`, i.e.

````math
\dim \operatorname{Gr}(n,k,B) = k(n-k) \dim_ℝ 𝔽,
````

where ``\dim_ℝ 𝔽`` is the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of `𝔽`.
"""
function manifold_dimension(M::GeneralizedGrassmann{𝔽}) where {𝔽}
    n, k = get_parameter(M.size)
    return k * (n - k) * real_dimension(𝔽)
end

"""
    mean(
        M::GeneralizedGrassmann,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolationWithinRadius(π/4);
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).
"""
mean(::GeneralizedGrassmann, ::Any...)

function default_approximation_method(::GeneralizedGrassmann, ::typeof(mean))
    return GeodesicInterpolationWithinRadius(π / 4)
end

@doc raw"""
    project(M::GeneralizedGrassmann, p)

Project `p` from the embedding onto the [`GeneralizedGrassmann`](@ref) `M`, i.e. compute `q`
as the polar decomposition of ``p`` such that ``q^{\mathrm{H}}Bq`` is the identity,
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transpose.
"""
project(::GeneralizedGrassmann, ::Any)

function project!(M::GeneralizedGrassmann, q, p)
    s = svd(p)
    e = eigen(s.U' * M.B * s.U)
    qsinv = e.vectors ./ sqrt.(transpose(e.values))
    q .= s.U * qsinv * e.vectors' * s.V'
    return q
end

@doc raw"""
    project(M::GeneralizedGrassmann, p, X)

Project the `n`-by-`k` `X` onto the tangent space of `p` on the
[`GeneralizedGrassmann`](@ref) `M`, which is computed by

````math
\operatorname{proj_p}(X) = X - pp^{\mathrm{H}}B^\mathrm{T}X,
````

where ``⋅^{\mathrm{H}}`` denotes the complex conjugate transposed or Hermitian
and ``⋅^{\mathrm{T}}`` the transpose.
"""
project(::GeneralizedGrassmann, ::Any, ::Any)

function project!(M::GeneralizedGrassmann, Y, p, X)
    A = p' * M.B' * X
    copyto!(Y, X)
    mul!(Y, p, Hermitian((A .+ A') ./ 2), -1, 1)
    return Y
end

@doc raw"""
    rand(::GeneralizedGrassmann; vector_at=nothing, σ::Real=1.0)

When `vector_at` is `nothing`, return a random (Gaussian) point `p` on the [`GeneralizedGrassmann`](@ref)
manifold `M` by generating a (Gaussian) matrix with standard deviation `σ` and return the
(generalized) orthogonalized version, i.e. return the projection onto the manifold of the
Q component of the QR decomposition of the random matrix of size ``n×k``.

When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_{vector\_at}\mathrm{St}(n,k)`` with mean zero and standard deviation `σ` by projecting a
random Matrix onto the tangent vector at `vector_at`.
"""
rand(::GeneralizedGrassmann; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::GeneralizedGrassmann{ℝ},
        pX;
        vector_at = nothing,
        σ::Real = one(real(eltype(pX))),
    )
    n, k = get_parameter(M.size)
    if vector_at === nothing
        A = σ * randn(rng, eltype(pX), n, k)
        project!(M, pX, Matrix(qr(A).Q))
    else
        Z = σ * randn(rng, eltype(pX), size(pX))
        project!(M, pX, vector_at, Z)
        normalize!(pX)
    end
    return pX
end

@doc raw"""
    representation_size(M::GeneralizedGrassmann)

Return the representation size or matrix dimension of a point on the [`GeneralizedGrassmann`](@ref)
`M`, i.e. ``(n,k)`` for both the real-valued and the complex value case.
"""
representation_size(M::GeneralizedGrassmann) = get_parameter(M.size)

@doc raw"""
    retract(M::GeneralizedGrassmann, p, X, ::PolarRetraction)

Compute the SVD-based retraction [`PolarRetraction`](@extref `ManifoldsBase.PolarRetraction`) on the
[`GeneralizedGrassmann`](@ref) `M`, by
[`project`](@ref project(M::GeneralizedGrassmann, p))ing ``p + X`` onto `M`.
"""
retract(::GeneralizedGrassmann, ::Any, ::Any, ::PolarRetraction)

function ManifoldsBase.retract_polar!(M::GeneralizedGrassmann, q, p, X)
    return ManifoldsBase.retract_polar_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_polar_fused!(M::GeneralizedGrassmann, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

function ManifoldsBase.retract_project!(M::GeneralizedGrassmann, q, p, X)
    return ManifoldsBase.retract_project_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_project_fused!(M::GeneralizedGrassmann, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end

function Base.show(
        io::IO,
        M::GeneralizedGrassmann{𝔽, TypeParameter{Tuple{n, k}}},
    ) where {n, k, 𝔽}
    return print(io, "GeneralizedGrassmann($(n), $(k), $(M.B), $(𝔽))")
end
function Base.show(io::IO, M::GeneralizedGrassmann{𝔽, Tuple{Int, Int}}) where {𝔽}
    n, k = get_parameter(M.size)
    return print(io, "GeneralizedGrassmann($(n), $(k), $(M.B), $(𝔽); parameter=:field)")
end

@doc raw"""
    zero_vector(M::GeneralizedGrassmann, p)

Return the zero tangent vector from the tangent space at `p` on the
[`GeneralizedGrassmann`](@ref) `M`, which is given by a zero matrix the same size as `p`.
"""
zero_vector(::GeneralizedGrassmann, ::Any...)

zero_vector!(::GeneralizedGrassmann, X, p) = fill!(X, 0)

using Manifolds, Test
using RecipesBase, Plots, Colors

@testset "Recipes Test" begin
    references_folder = joinpath(@__DIR__, "assets")
    @testset "2D Recipes in GR" begin
        ENV["GKSwstype"] = "100"
        gr()
        #        function Hyp2PB_plot()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareBallPoint), p)
        #            return
        plot(M, p2)
        #        end
        #       @plottest Hyp2PB_plot joinpath(references_folder, "Hyp2PBPlot.png") false

        #       function Hyp2PB_plot_geo()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareBallPoint), p)
        #           return
        plot(M, p2; geodesic_interpolation = 80)
        #        end
        #       @plottest Hyp2PB_plot_geo joinpath(references_folder, "Hyp2PBPlotGeo.png") false

        #        function Hyp2PB_quiver()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareBallPoint), p)
        X = [log(M, p2[2], p2[1]), log(M, p2[1], p2[3])]
        #           return
        plot(M, [p2[2], p2[1]], X)
        #        end
        #        @plottest Hyp2PB_quiver joinpath(references_folder, "Hyp2PBQuiver.png") false

        #        function Hyp2PH_plot()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareHalfSpacePoint), p)
        #            return
        plot(M, p2)
        @test plot(M) != nothing
        #        end
        #        @plottest Hyp2PH_plot joinpath(references_folder, "Hyp2PHPlot.png") false

        #        function Hyp2PH_plot_geo()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareHalfSpacePoint), p)
        #            return
        plot(M, p2; geodesic_interpolation = 80)
        #        end
        #        @plottest Hyp2PH_plot_geo joinpath(references_folder, "Hyp2PHPlotGeo.png") false

        #        function Hyp2PH_quiver()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 0.0], [0.0, 1.0]])
        p2 = convert.(Ref(PoincareHalfSpacePoint), p)
        X = [log(M, p2[2], p2[1]), log(M, p2[1], p2[3])]
        #            return
        plot(M, [p2[2], p2[1]], X)
        #        end
        #        @plottest Hyp2PH_quiver joinpath(references_folder, "Hyp2PHQuiver.png") false
    end
    @testset "3D Recipes in GR" begin
        ENV["GKSwstype"] = "100"
        gr()
        #        function Hyp2_plot()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        #            return
        plot(M, p)
        #        end
        #        @plottest Hyp2_plot joinpath(references_folder, "Hyp2Plot.png") false

        #        function Hyp2_surfplot()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        #    return
        plot(M, p; surface = true)
        #end
        #@plottest Hyp2_surfplot joinpath(references_folder, "Hyp2SurfPlot.png") false

        #        function Hyp2_plot_geo()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 1.0]])
        #            return
        plot(M, p; geodesic_interpolation = 80)
        #        end
        #@plottest Hyp2_plot_geo joinpath(references_folder, "Hyp2PlotGeo.png") false

        #        function Hyp2_quiver()
        M = Hyperbolic(2)
        p = Manifolds._hyperbolize.(Ref(M), [[1.0, 0.0], [0.0, 0.0], [0.0, 1.0]])
        X = [log(M, p[2], p[1]), log(M, p[1], p[3])]
        #           return
        plot(M, [p[2], p[1]], X)
        #        end
        #        @plottest Hyp2_quiver joinpath(references_folder, "Hyp2Quiver.png") false
    end
    @testset "3D Recipes in pythonplot" begin
        pythonplot()
        #        function Sphere2_plot()
        M = Sphere(2)
        pts = [[1.0, 0.0, 0.0], [0.0, -1.0, 0.0], [0.0, 0.0, 1.0], [1.0, 0.0, 0.0]]
        #           return
        plot(M, pts; wireframe_color = colorant"#CCCCCC", markersize = 10)
        #        end
        #        @plottest Sphere2_plot joinpath(references_folder, "Sphere2Plot.png") false

        #        function Sphere2_surfplot()
        M = Sphere(2)
        pts = [[1.0, 0.0, 0.0], [0.0, -1.0, 0.0], [0.0, 0.0, 1.0], [1.0, 0.0, 0.0]]
        #            return
        plot(M, pts; surface = true, wireframe_color = colorant"#CCCCCC", markersize = 10)
        #        end
        #        @plottest Sphere2_surfplot joinpath(references_folder, "Sphere2SurfPlot.png") false

        #        function Sphere2_plot_geo()
        M = Sphere(2)
        pts = [[1.0, 0.0, 0.0], [0.0, -1.0, 0.0], [0.0, 0.0, 1.0], [1.0, 0.0, 0.0]]
        #           return
        Plots.plot(M, pts; wireframe_color = colorant"#CCCCCC", geodesic_interpolation = 80)
        #        end
        #        @plottest Sphere2_plot_geo joinpath(references_folder, "Sphere2PlotGeo.png") false

        #        function Sphere2_quiver()
        pythonplot()
        M = Sphere(2)
        pts2 = [[1.0, 0.0, 0.0], [0.0, -1.0, 0.0], [0.0, 0.0, 1.0]]
        p3 = 1 / sqrt(3) .* [1.0, -1.0, 1.0]
        vecs = log.(Ref(M), pts2, Ref(p3))
        #           return
        plot(M, pts2, vecs; wireframe_color = colorant"#CCCCCC", linewidth = 1.5)
        #        end
        #        @plottest Sphere2_quiver joinpath(references_folder, "Sphere2Quiver.png") false
    end
end

using Manifolds
using Random: MersenneTwister, rand!
using Test: Test
using Manifolds: RieszRepresenterCotangentVector, get_chart_index

"""
    Manifolds.find_eps(x...)

Find an appropriate tolerance for given points or tangent vectors, or their types.

!!! note
    This function is soon deprecated and will be replaced by a more systematic way in `Manifolds.Test`
"""
Manifolds.find_eps(x...) = Manifolds.find_eps(Base.promote_type(map(number_eltype, x)...))
Manifolds.find_eps(x::Type{TN}) where {TN <: Number} = eps(real(TN))
Manifolds.find_eps(x) = Manifolds.find_eps(number_eltype(x))

"""
    Manifolds.test_manifold(M::AbstractManifold, pts::AbstractVector; kwargs...)

Test general properties of manifold `M`, given at least three different points
that lie on it (contained in `pts`).

!!! note

    This is an old an soon deprecated interface, the new one is `Manifolds.Test.test_manifold`.

# Arguments
- `basis_has_specialized_diagonalizing_get = false`: if true, assumes that
    `DiagonalizingOrthonormalBasis` given in `basis_types` has
    [`get_coordinates`](@ref) and [`get_vector`](@ref) that work without caching.
- `basis_types_to_from = ()`: basis types that will be tested based on
    [`get_coordinates`](@ref) and [`get_vector`](@ref).
- `basis_types_vecs = ()` : basis types that will be tested based on `get_vectors`
- `default_inverse_retraction_method = ManifoldsBase.LogarithmicInverseRetraction()`:
    default method for inverse retractions (`log`.
- `default_retraction_method = ManifoldsBase.ExponentialRetraction()`: default method for
    retractions (`exp`).
- `exp_log_atol_multiplier = 0`: change absolute tolerance of exp/log tests
    (0 use default, i.e. deactivate atol and use rtol).
- `exp_log_rtol_multiplier = 1`: change the relative tolerance of exp/log tests
    (1 use default). This is deactivated if the `exp_log_atol_multiplier` is nonzero.
- `expected_dimension_type = Integer`: expected type of value returned by
    `manifold_dimension`.
- `inverse_retraction_methods = []`: inverse retraction methods that will be tested.
- `is_mutating = true`: whether mutating variants of functions should be tested.
- `is_point_atol_multiplier = 0`: determines atol of `is_point` checks.
- `is_tangent_atol_multiplier = 0`: determines atol of `is_vector` checks.
- `has_get_embedding = false`: whether the manifold has a specialized
    [`get_embedding`](@ref)`(M, p)` method (to test mutating `embed!`). This is experimental.
- `mid_point12 = test_exp_log ? shortest_geodesic(M, pts[1], pts[2], 0.5) : nothing`: if not `nothing`, then check
    that `mid_point(M, pts[1], pts[2])` is approximately equal to `mid_point12`. This is
    by default set to `nothing` if `text_exp_log` is set to false.
- `point_distributions = []` : point distributions to test.
- `rand_tvector_atol_multiplier = 0` : chage absolute tolerance in testing random vectors
    (0 use default, i.e. deactivate atol and use rtol) random tangent vectors are tangent
    vectors.
- `retraction_atol_multiplier = 0`: change absolute tolerance of (inverse) retraction tests
    (0 use default, i.e. deactivate atol and use rtol).
- `retraction_rtol_multiplier = 1`: change the relative tolerance of (inverse) retraction
    tests (1 use default). This is deactivated if the `exp_log_atol_multiplier` is nonzero.
- `retraction_methods = []`: retraction methods that will be tested.
- `test_atlases = []`: Vector or tuple of atlases that should be tested.
- `test_exp_log = true`: if true, check that [`exp`](@ref) is the inverse of [`log`](@extref `Base.log-Tuple{AbstractManifold, Any, Any}`).
- `test_injectivity_radius = true`: whether implementation of [`injectivity_radius`](@ref)
    should be tested.
- `test_inplace = false` : if true check if inplace variants work if they are activated,
   e.g. check that `exp!(M, p, p, X)` work if `test_exp_log = true`.
   This in general requires `is_mutating` to be true.
- `test_is_tangent`: if true check that the `default_inverse_retraction_method`
    actually returns valid tangent vectors.
- `test_musical_isomorphisms = false` : test musical isomorphisms.
- `test_mutating_rand = false` : test the mutating random function for points on manifolds.
- `test_project_point = false`: test projections onto the manifold.
- `test_project_tangent = false` : test projections on tangent spaces.
- `test_representation_size = true` : test representation size of points/tvectprs.
- `test_tangent_vector_broadcasting = true` : test boradcasting operators on TangentSpace.
- `test_vector_spaces = true` : test Vector bundle of this manifold.
- `test_default_vector_transport = false` : test the default vector transport (usually
   parallel transport).
- `tvector_distributions = []` : tangent vector distributions to test.
- `vector_transport_methods = []`: vector transport methods that should be tested.
- `vector_transport_inverse_retractions = [default_inverse_retraction_method for _ in 1:length(vector_transport_methods)]``
  inverse retractions to use with the vector transport method (especially the differentiated ones)
- `vector_transport_to = [ true for _ in 1:length(vector_transport_methods)]`: whether
   to check the `to` variant of vector transport
- `vector_transport_direction = [ true for _ in 1:length(vector_transport_methods)]`: whether
   to check the `direction` variant of vector transport

!!! note
    This function is soon deprecated and will be replaced by a more systematic way in `Manifolds.Test`
"""
function Manifolds.test_manifold(
        M::AbstractManifold, pts::AbstractVector;
        basis_has_specialized_diagonalizing_get = false,
        basis_types_to_from = (),
        basis_types_vecs = (),
        default_inverse_retraction_method = LogarithmicInverseRetraction(),
        default_retraction_method = ExponentialRetraction(),
        exp_log_atol_multiplier = 0,
        exp_log_rtol_multiplier = 1,
        expected_dimension_type = Integer,
        inverse_retraction_methods = [],
        is_mutating = true,
        is_point_atol_multiplier = 0,
        is_tangent_atol_multiplier = 0,
        musical_isomorphism_bases = [],
        point_distributions = [],
        projection_atol_multiplier = 0,
        rand_tvector_atol_multiplier = 0,
        retraction_atol_multiplier = 0,
        retraction_methods = [],
        retraction_rtol_multiplier = 1,
        test_atlases = (),
        test_exp_log = true,
        test_is_tangent = true,
        test_injectivity_radius = true,
        test_inplace = false,
        has_get_embedding = false,
        test_musical_isomorphisms = false,
        test_mutating_rand = false,
        parallel_transport = false,
        parallel_transport_to = parallel_transport,
        parallel_transport_direction = parallel_transport,
        test_inner = true,
        test_norm = true,
        test_project_point = false,
        test_project_tangent = false,
        test_rand_point = false,
        test_rand_tvector = false,
        test_representation_size = true,
        test_riesz_representer = false,
        test_tangent_vector_broadcasting = true,
        test_default_vector_transport = false,
        test_vector_spaces = true,
        tvector_distributions = [],
        vector_transport_methods = [],
        vector_transport_inverse_retractions = [
            default_inverse_retraction_method for _ in 1:length(vector_transport_methods)
        ],
        vector_transport_retractions = [
            default_retraction_method for _ in 1:length(vector_transport_methods)
        ],
        test_vector_transport_to = [true for _ in 1:length(vector_transport_methods)],
        test_vector_transport_direction = [true for _ in 1:length(vector_transport_methods)],
        mid_point12 = test_exp_log ? shortest_geodesic(M, pts[1], pts[2], 0.5) : nothing,
    )
    @warn "This is the old test suite for Manifolds.jl. Consider switching to `Manifolds.Test.test_manifold` for $M as well."
    length(pts) ≥ 3 || error("Not enough points (at least three expected)")
    isapprox(M, pts[1], pts[2]) && error("Points 1 and 2 are equal")
    isapprox(M, pts[1], pts[3]) && error("Points 1 and 3 are equal")

    # get a default tangent vector for every of the three tangent spaces
    n = length(pts)
    if default_inverse_retraction_method === nothing
        tv = [zero_vector(M, pts[i]) for i in 1:n] # no other available
    else
        tv = [
            inverse_retract(
                    M, pts[i], pts[((i + 1) % n) + 1], default_inverse_retraction_method
                ) for i in 1:n
        ]
    end
    Test.@testset "dimension" begin # COV_EXCL_LINE
        Test.@test isa(manifold_dimension(M), expected_dimension_type)
        Test.@test manifold_dimension(M) ≥ 0
    end

    test_representation_size && Test.@testset "representation" begin
        function test_repr(repr)
            Test.@test isa(repr, Tuple)
            for rs in repr
                Test.@test rs > 0
            end
            return nothing
        end

        test_repr(Manifolds.representation_size(M))
    end

    test_injectivity_radius && Test.@testset "injectivity radius" begin
        Test.@test injectivity_radius(M, pts[1]) > 0
        Test.@test injectivity_radius(M, pts[1]) ≥ injectivity_radius(M)
        for rm in retraction_methods
            Test.@test injectivity_radius(M, rm) > 0
            Test.@test injectivity_radius(M, pts[1], rm) ≥ injectivity_radius(M, rm)
            Test.@test injectivity_radius(M, pts[1], rm) ≤ injectivity_radius(M, pts[1])
        end
    end

    Test.@testset "is_point" begin # COV_EXCL_LINE
        for pt in pts
            atol = is_point_atol_multiplier * Manifolds.find_eps(pt)
            Test.@test is_point(M, pt; atol = atol)
            Test.@test check_point(M, pt; atol = atol) === nothing
        end
    end

    test_is_tangent && Test.@testset "is_vector" begin
        for (p, X) in zip(pts, tv)
            atol = is_tangent_atol_multiplier * Manifolds.find_eps(p)
            Test.@test is_vector(M, p, X; atol = atol, error = :error)
            Test.@test check_vector(M, p, X; atol = atol) === nothing
        end
    end

    test_exp_log && Test.@testset "log/exp tests" begin
        epsp1p2 = Manifolds.find_eps(pts[1], pts[2])
        atolp1p2 = exp_log_atol_multiplier * epsp1p2
        rtolp1p2 =
            exp_log_atol_multiplier == 0.0 ? sqrt(epsp1p2) * exp_log_rtol_multiplier : 0
        X1 = log(M, pts[1], pts[2])
        X2 = log(M, pts[2], pts[1])
        Test.@test isapprox(M, pts[2], exp(M, pts[1], X1); atol = atolp1p2, rtol = rtolp1p2)
        Test.@test isapprox(
            M, pts[1], Manifolds.exp_fused(M, pts[1], X1, 0);
            atol = atolp1p2, rtol = rtolp1p2
        )
        Test.@test isapprox(
            M, pts[2], Manifolds.exp_fused(M, pts[1], X1, 1);
            atol = atolp1p2, rtol = rtolp1p2
        )
        if is_mutating
            q2 = allocate(pts[1])
            exp!(M, q2, pts[1], X1)
            Test.@test isapprox(M, pts[2], q2; atol = atolp1p2, rtol = rtolp1p2)
            Manifolds.exp_fused!(M, q2, pts[1], X1, 0)
            Test.@test isapprox(M, pts[1], q2; atol = atolp1p2, rtol = rtolp1p2)
        end
        Test.@test is_point(M, exp(M, pts[1], X1); atol = atolp1p2, rtol = rtolp1p2)
        Test.@test isapprox(
            M, pts[1], Manifolds.exp_fused(M, pts[1], X1, 0);
            atol = atolp1p2, rtol = rtolp1p2
        )
        for p in pts
            epsx = Manifolds.find_eps(p)
            Test.@test isapprox(
                M, p, zero_vector(M, p), log(M, p, p);
                atol = epsx * exp_log_atol_multiplier,
                rtol = exp_log_atol_multiplier == 0.0 ? sqrt(epsx) * exp_log_rtol_multiplier : 0
            )
            Test.@test isapprox(
                M, p, zero_vector(M, p), inverse_retract(M, p, p);
                atol = epsx * exp_log_atol_multiplier,
                rtol = exp_log_atol_multiplier == 0.0 ? sqrt(epsx) * exp_log_rtol_multiplier : 0.0,
            )
        end
        atolp1 = exp_log_atol_multiplier * Manifolds.find_eps(pts[1])
        if is_mutating
            zero_vector!(M, X1, pts[1])
        else
            X1 = zero_vector(M, pts[1])
        end
        Test.@test isapprox(M, pts[1], X1, zero_vector(M, pts[1]); atol = atolp1)
        if is_mutating
            log!(M, X1, pts[1], pts[2])
        else
            X1 = log(M, pts[1], pts[2])
        end

        Test.@test isapprox(M, Manifolds.exp_fused(M, pts[1], X1, 1), pts[2]; atol = atolp1)
        Test.@test isapprox(M, Manifolds.exp_fused(M, pts[1], X1, 0), pts[1]; atol = atolp1)

        if test_norm
            Test.@test distance(M, pts[1], pts[2]) ≈ norm(M, pts[1], X1)
        end

        if test_inner
            X3 = log(M, pts[1], pts[3])
            Test.@test inner(M, pts[1], X1, X3) ≈ conj(inner(M, pts[1], X3, X1))
            Test.@test inner(M, pts[1], X1, X1) ≈ real(inner(M, pts[1], X1, X1))

            Test.@test norm(M, pts[1], X1) ≈ sqrt(inner(M, pts[1], X1, X1))
        end
        if test_norm
            Test.@test norm(M, pts[1], X1) isa Real
        end

        (test_inplace && is_mutating) && Test.@testset "inplace test for exp!" begin
            p = copy(M, pts[1])
            X = copy(M, pts[1], X1)
            q = exp(M, p, X)
            exp!(M, p, p, X)
            Test.@test isapprox(M, p, q)
            # This test is not reasonable for `log!(M, X, p, q)`,
            # since X is of different type/concept than p,q
        end
    end

    parallel_transport && Manifolds.test_parallel_transport(
        M, pts;
        to = parallel_transport_to, direction = parallel_transport_direction, mutating = is_mutating,
    )

    Test.@testset "(inverse &) retraction tests" begin # COV_EXCL_LINE
        for (p, X) in zip(pts, tv)
            epsx = Manifolds.find_eps(p)
            point_atol = is_point_atol_multiplier * Manifolds.find_eps(p)
            for retr_method in retraction_methods
                Test.@test is_point(M, retract(M, p, X, retr_method); atol = point_atol)
                Test.@test isapprox(
                    M, p, Manifolds.retract_fused(M, p, X, 0, retr_method);
                    atol = epsx * retraction_atol_multiplier,
                    rtol = retraction_atol_multiplier == 0 ? sqrt(epsx) * retraction_rtol_multiplier : 0
                )
                if is_mutating
                    new_pt = allocate(p)
                    retract!(M, new_pt, p, X, retr_method)
                else
                    new_pt = retract(M, p, X, retr_method)
                end
                Test.@test is_point(M, new_pt; atol = point_atol)
                (test_inplace && is_mutating) &&
                    Test.@testset "inplace test for retract!" begin # COV_EXCL_LINE
                    p2 = copy(M, p)
                    X2 = copy(M, p, X)
                    q = retract(M, p2, X2, retr_method)
                    retract!(M, p2, p2, X, retr_method)
                    Test.@test isapprox(M, p2, q; atol = point_atol)
                    # This test is not reasonable for `inverse_retract!(M, X, p, q, m)`,
                    # since X is of different type/concept than p,q

                end
            end
        end
        for p in pts
            epsx = Manifolds.find_eps(p)
            for inv_retr_method in inverse_retraction_methods
                X = inverse_retract(M, p, p, inv_retr_method)
                Test.@test isapprox(
                    M, p, zero_vector(M, p), X;
                    atol = epsx * retraction_atol_multiplier,
                    rtol = retraction_atol_multiplier == 0 ? sqrt(epsx) * retraction_rtol_multiplier : 0
                )
                if (test_inplace && is_mutating)
                    Y = copy(M, p, X)
                    inverse_retract!(M, Y, p, p, inv_retr_method)
                    Test.@test isapprox(
                        M, p, zero_vector(M, p), Y;
                        atol = epsx * retraction_atol_multiplier,
                        rtol = retraction_atol_multiplier == 0 ? sqrt(epsx) * retraction_rtol_multiplier : 0
                    )
                end
            end
        end
    end

    test_riesz_representer && Test.@testset "RieszRepresenterCotangentVector" begin
        rrcv = flat(M, pts[1], tv[1])
        Test.@test rrcv isa RieszRepresenterCotangentVector
        Test.@test rrcv.p === pts[1]
        Test.@test rrcv.X === tv[1]
        basis = dual_basis(M, pts[1], basis_types_to_from[1])
        coords = get_coordinates(M, pts[1], rrcv, basis)
        rrcv2 = get_vector(M, pts[1], coords, basis)
        Test.@test isapprox(M, pts[1], rrcv.X, rrcv2.X)
    end

    test_vector_spaces && Test.@testset "vector spaces tests" begin
        for p in pts
            X = zero_vector(M, p)
            mts = TangentSpace(M, p)
            Test.@test isapprox(M, p, X, zero_vector(mts, X))
            if is_mutating
                zero_vector!(mts, X, X)
                Test.@test isapprox(M, p, X, zero_vector(M, p))
            end
        end
    end

    Test.@testset "basic linear algebra in tangent space" begin # COV_EXCL_LINE
        for (p, X) in zip(pts, tv)
            Test.@test isapprox(M, p, 0 * X, zero_vector(M, p); atol = Manifolds.find_eps(pts[1]))
            Test.@test isapprox(M, p, 2 * X, X + X)
            Test.@test isapprox(M, p, 0 * X, X - X)
            Test.@test isapprox(M, p, (-1) * X, -X)
        end
    end

    test_tangent_vector_broadcasting &&
        Test.@testset "broadcasted linear algebra in tangent space" begin # COV_EXCL_LINE
        for (p, X) in zip(pts, tv)
            Test.@test isapprox(M, p, 3 * X, 2 .* X .+ X)
            Test.@test isapprox(M, p, -X, X .- 2 .* X)
            Test.@test isapprox(M, p, -X, .-X)
            if (isa(X, AbstractArray))
                Y = allocate(X)
                Y .= 2 .* X .+ X
            else
                Y = 2 * X + X
            end
            Test.@test isapprox(M, p, Y, 3 * X)
        end
    end

    test_project_tangent && Test.@testset "project tangent test" begin
        for (p, X) in zip(pts, tv)
            atol = Manifolds.find_eps(p) * projection_atol_multiplier
            X_emb = embed(M, p, X)
            p_emb = embed(M, p)
            Test.@test isapprox(M, p, X, project(M, p, X_emb); atol = atol)
            if is_mutating
                X2 = allocate(X)
                project!(M, X2, p, X_emb)
            else
                X2 = project(M, p, X_emb)
            end
            Test.@test isapprox(M, p, X2, X; atol = atol)
        end
    end

    test_project_point && Test.@testset "project point test" begin
        for p in pts
            atol = Manifolds.find_eps(p) * projection_atol_multiplier
            p_emb = embed(M, p)
            Test.@test isapprox(M, p, project(M, p_emb); atol = atol)
            if is_mutating
                p2 = allocate(p)
                project!(M, p2, p_emb)
            end
            Test.@test isapprox(M, p2, p; atol = atol)
        end
    end

    !(
        default_retraction_method === nothing ||
            default_inverse_retraction_method === nothing
    ) && Test.@testset "vector transport" begin # COV_EXCL_LINE
        tvatol = is_tangent_atol_multiplier * Manifolds.find_eps(pts[1])
        X1 = inverse_retract(M, pts[1], pts[2], default_inverse_retraction_method)
        X2 = inverse_retract(M, pts[1], pts[3], default_inverse_retraction_method)
        pts32 = retract(M, pts[1], X2, default_retraction_method)
        test_default_vector_transport && Test.@testset "default vector transport" begin
            v1t1 = vector_transport_to(M, pts[1], X1, pts32)
            v1t2 = vector_transport_direction(M, pts[1], X1, X2)
            Test.@test is_vector(M, pts32, v1t1; atol = tvatol, error = :warn)
            Test.@test is_vector(M, pts32, v1t2; atol = tvatol, error = :warn)
            Test.@test isapprox(M, pts32, v1t1, v1t2)
            Test.@test isapprox(M, pts[1], vector_transport_to(M, pts[1], X1, pts[1]), X1)

            is_mutating && Test.@testset "mutating variants" begin
                v1t1_m = allocate(v1t1)
                v1t2_m = allocate(v1t2)
                vector_transport_to!(M, v1t1_m, pts[1], X1, pts32)
                vector_transport_direction!(M, v1t2_m, pts[1], X1, X2)
                Test.@test isapprox(M, pts32, v1t1, v1t1_m)
                Test.@test isapprox(M, pts32, v1t2, v1t2_m)
            end
        end

        for (vtm, test_to, test_dir, rtr_m, irtr_m) in zip(
                vector_transport_methods,
                test_vector_transport_to,
                test_vector_transport_direction,
                vector_transport_retractions,
                vector_transport_inverse_retractions,
            )
            Test.@testset "vector transport method $(vtm)" begin # COV_EXCL_LINE
                tvatol = is_tangent_atol_multiplier * Manifolds.find_eps(pts[1])
                X1 = inverse_retract(M, pts[1], pts[2], irtr_m)
                X2 = inverse_retract(M, pts[1], pts[3], irtr_m)
                pts32 = retract(M, pts[1], X2, rtr_m)
                test_to && (v1t1 = vector_transport_to(M, pts[1], X1, pts32, vtm))
                test_dir && (v1t2 = vector_transport_direction(M, pts[1], X1, X2, vtm))
                test_to &&
                    Test.@test is_vector(M, pts32, v1t1; atol = tvatol, error = :warn)
                test_dir &&
                    Test.@test is_vector(M, pts32, v1t2; atol = tvatol, error = :warn)
                test_to && Test.@test isapprox(
                    M, pts[1], vector_transport_to(M, pts[1], X1, pts[1], vtm), X1;
                    atol = tvatol
                )
                test_dir && Test.@test isapprox(
                    M, pts[1], vector_transport_direction(M, pts[1], X1, zero_vector(M, pts[1]), vtm), X1;
                    atol = tvatol
                )

                is_mutating && Test.@testset "mutating variants" begin
                    if test_to
                        v1t1_m = allocate(v1t1)
                        vector_transport_to!(M, v1t1_m, pts[1], X1, pts32, vtm)
                        Test.@test isapprox(M, pts32, v1t1, v1t1_m; atol = tvatol)
                        test_inplace &&
                            Test.@testset "inplace test for vector_transport_to!" begin # COV_EXCL_LINE
                            X1a = copy(M, pts[1], X1)
                            Xt = vector_transport_to(M, pts[1], X1, pts32, vtm)
                            vector_transport_to!(M, X1a, pts[1], X1a, pts32, vtm)
                            Test.@test isapprox(M, pts[1], X1a, Xt; atol = tvatol)
                        end
                    end
                    if test_dir
                        v1t2_m = allocate(v1t2)
                        vector_transport_direction!(M, v1t2_m, pts[1], X1, X2, vtm)
                        Test.@test isapprox(M, pts32, v1t2, v1t2_m; atol = tvatol)
                        test_inplace && Test.@testset "inplace test for vector_transport_direction!" begin
                            X1a = copy(M, pts[1], X1)
                            X2a = copy(M, pts[1], X2)
                            Xt = vector_transport_direction(M, pts[1], X1, X2, vtm)
                            vector_transport_direction!(M, X1a, pts[1], X1a, X2, vtm)
                            vector_transport_direction!(M, X2a, pts[1], X1, X2a, vtm)
                            Test.@test isapprox(M, pts[1], X1a, Xt; atol = tvatol)
                            Test.@test isapprox(M, pts[1], X2a, Xt; atol = tvatol)
                        end
                    end
                end
            end
        end
    end

    for btype in basis_types_vecs
        Test.@testset "Basis support for $(btype)" begin # COV_EXCL_LINE
            p = pts[1]
            b = get_basis(M, p, btype)
            Test.@test isa(b, CachedBasis)
            bvectors = get_vectors(M, p, b)
            N = length(bvectors)

            # test orthonormality
            for i in 1:N
                Test.@test norm(M, p, bvectors[i]) ≈ 1
                for j in (i + 1):N
                    Test.@test real(inner(M, p, bvectors[i], bvectors[j])) ≈ 0 atol =
                        sqrt(Manifolds.find_eps(p))
                end
            end
            if isa(btype, ProjectedOrthonormalBasis)
                # check projection idempotency
                for i in 1:N
                    Test.@test norm(M, p, bvectors[i]) ≈ 1
                    for j in (i + 1):N
                        Test.@test real(inner(M, p, bvectors[i], bvectors[j])) ≈ 0 atol =
                            sqrt(Manifolds.find_eps(p))
                    end
                end
                # check projection idempotency
                for i in 1:N
                    Test.@test isapprox(M, p, embed_project(M, p, bvectors[i]), bvectors[i])
                end
            end
            if !isa(btype, ProjectedOrthonormalBasis) && (
                    basis_has_specialized_diagonalizing_get ||
                        !isa(btype, DiagonalizingOrthonormalBasis)
                )
                X1 = inverse_retract(M, p, pts[2], default_inverse_retraction_method)
                Xb = get_coordinates(M, p, X1, btype)

                Test.@test get_coordinates(M, p, X1, b) ≈ Xb
                Test.@test isapprox(
                    M, p, get_vector(M, p, Xb, b), get_vector(M, p, Xb, btype)
                )
            end
        end
    end

    for btype in (basis_types_to_from..., basis_types_vecs...)
        p = pts[1]
        N = number_of_coordinates(M, btype)
        if !isa(btype, ProjectedOrthonormalBasis) && (
                basis_has_specialized_diagonalizing_get ||
                    !isa(btype, DiagonalizingOrthonormalBasis)
            )
            X1 = inverse_retract(M, p, pts[2], default_inverse_retraction_method)

            Xb = get_coordinates(M, p, X1, btype)
            #Test.@test isa(Xb, AbstractVector{<:Real})
            Test.@test length(Xb) == N
            Xbi = get_vector(M, p, Xb, btype)
            Test.@test isapprox(M, p, X1, Xbi)

            Xs = [[ifelse(i == j, 1, 0) for j in 1:N] for i in 1:N]
            Xs_invs = [get_vector(M, p, Xu, btype) for Xu in Xs]
            # check orthonormality of inverse representation
            for i in 1:N
                Test.@test norm(M, p, Xs_invs[i]) ≈ 1 atol = sqrt(Manifolds.find_eps(p))
                for j in (i + 1):N
                    Test.@test real(inner(M, p, Xs_invs[i], Xs_invs[j])) ≈ 0 atol =
                        sqrt(Manifolds.find_eps(p))
                end
            end

            if is_mutating
                Xb_s = allocate(Xb)
                Test.@test get_coordinates!(M, Xb_s, p, X1, btype) === Xb_s
                Test.@test isapprox(Xb_s, Xb; atol = Manifolds.find_eps(p))

                Xbi_s = allocate(Xbi)
                Test.@test get_vector!(M, Xbi_s, p, Xb, btype) === Xbi_s
                Test.@test isapprox(M, p, X1, Xbi_s)
            end
        end
    end

    mid_point12 !== nothing && Test.@testset "midpoint" begin
        epsp1p2 = Manifolds.find_eps(pts[1], pts[2])
        atolp1p2 = exp_log_atol_multiplier * epsp1p2
        rtolp1p2 =
            exp_log_atol_multiplier == 0.0 ? sqrt(epsp1p2) * exp_log_rtol_multiplier : 0
        mp = mid_point(M, pts[1], pts[2])
        Test.@test isapprox(M, mp, mid_point12; atol = atolp1p2, rtol = rtolp1p2)
        if is_mutating
            mpm = allocate(mp)
            mid_point!(M, mpm, pts[1], pts[2])
            Test.@test isapprox(M, mpm, mid_point12; atol = atolp1p2, rtol = rtolp1p2)
            test_inplace && Test.@testset "inplace test for midpoint!" begin
                p1 = copy(M, pts[1])
                p2 = copy(M, pts[2])
                p3 = mid_point(M, pts[1], pts[2])
                mid_point!(M, p1, p1, pts[2])
                mid_point!(M, p2, pts[1], p2)
                Test.@test isapprox(M, p3, p1)
                Test.@test isapprox(M, p3, p2)
            end
        end
    end

    test_musical_isomorphisms && Test.@testset "Musical isomorphisms" begin
        if default_inverse_retraction_method !== nothing
            tv_m = inverse_retract(M, pts[1], pts[2], default_inverse_retraction_method)
        else
            tv_m = zero_vector(M, pts[1])
        end
        ctv_m = flat(M, pts[1], tv_m)
        Test.@test ctv_m(tv_m) ≈ norm(M, pts[1], tv_m)^2
        tv_m_back = sharp(M, pts[1], ctv_m)
        Test.@test isapprox(M, pts[1], tv_m, tv_m_back)

        if is_mutating
            ctv_m_s = allocate(ctv_m)
            flat!(M, ctv_m_s, pts[1], tv_m)
            Test.@test ctv_m_s(tv_m) ≈ ctv_m(tv_m)
            tv_m_s_back = allocate(tv_m_back)
            sharp!(M, tv_m_s_back, pts[1], ctv_m_s)
            Test.@test isapprox(M, pts[1], tv_m, tv_m_s_back)
        end

        for basis in musical_isomorphism_bases
            tv_m_f = ManifoldsBase.TFVector(get_coordinates(M, pts[1], tv_m, basis), basis)
            ctv_m_f = flat(M, pts[1], tv_m_f)
            Test.@test isa(ctv_m_f, CoTFVector)
            tv_m_f_back = sharp(M, pts[1], ctv_m_f)
            Test.@test isapprox(tv_m_f.data, tv_m_f_back.data)
        end
    end

    Test.@testset "number_eltype" begin # COV_EXCL_LINE
        for (p, X) in zip(pts, tv)
            Test.@test number_eltype(X) == number_eltype(p)
            p = retract(M, p, X, default_retraction_method)
            Test.@test number_eltype(p) == number_eltype(p)
        end
    end

    is_mutating && Test.@testset "copyto!" begin
        for (p, X) in zip(pts, tv)
            p2 = allocate(p)
            copyto!(p2, p)
            Test.@test isapprox(M, p2, p)

            X2 = allocate(X)
            if default_inverse_retraction_method === nothing
                X3 = zero_vector(M, p)
                copyto!(X2, X3)
                Test.@test isapprox(M, p, X2, zero_vector(M, p))
            else
                q = retract(M, p, X, default_retraction_method)
                X3 = inverse_retract(M, p, q, default_inverse_retraction_method)
                copyto!(X2, X3)
                Test.@test isapprox(
                    M, p, X2, inverse_retract(M, p, q, default_inverse_retraction_method)
                )
            end
        end
    end

    is_mutating && Test.@testset "point distributions" begin
        for p in pts
            prand = allocate(p)
            for pd in point_distributions
                for _ in 1:10
                    Test.@test is_point(M, rand(pd))
                    if test_mutating_rand
                        rand!(pd, prand)
                        Test.@test is_point(M, prand)
                    end
                end
            end
        end
    end

    test_rand_point && Test.@testset "Base.rand point generation" begin
        rng_a = MersenneTwister(123)
        rng_b = MersenneTwister(123)
        Test.@test is_point(M, rand(M); error = :error)
        # ensure that the RNG source is actually used
        Test.@test rand(rng_a, M) == rand(rng_b, M)
        # generation of multiple points
        Test.@test all(p -> is_point(M, p; error = :error), rand(M, 3))
        Test.@test all(p -> is_point(M, p; error = :error), rand(rng_a, M, 3))

        if test_inplace && is_mutating
            rng_a = MersenneTwister(123)
            rng_b = MersenneTwister(123)

            p = allocate(pts[1])
            rand!(M, p)
            Test.@test is_point(M, p; error = :error)
            p = allocate(pts[1])
            rand!(rng_a, M, p)
            Test.@test is_point(M, p; error = :error)
            # ensure that the RNG source is actually used
            q = allocate(pts[1])
            rand!(rng_b, M, q)
            Test.@test p == q
        end
    end

    test_rand_tvector && Test.@testset "Base.rand tangent vector generation" begin
        p = pts[1]
        rng_a = MersenneTwister(123)
        rng_b = MersenneTwister(123)
        randX = rand(M; vector_at = p)
        atol = rand_tvector_atol_multiplier * Manifolds.find_eps(randX)
        Test.@test is_vector(M, p, randX, true; atol = atol)
        # ensure that the RNG source is actually used
        Test.@test rand(rng_a, M; vector_at = p) == rand(rng_b, M; vector_at = p)
        # generation of multiple tangent vectors
        Test.@test all(X -> is_vector(M, p, X, true; atol = atol), rand(M, 3; vector_at = p))
        Test.@test all(
            X -> is_vector(M, p, X, true; atol = atol), rand(rng_a, M, 3; vector_at = p)
        )

        if test_inplace && is_mutating
            rng_a = MersenneTwister(123)
            rng_b = MersenneTwister(123)

            X = allocate(tv[1])
            rand!(M, X; vector_at = p)
            Test.@test is_vector(M, p, X, true; atol = atol)
            X = allocate(tv[1])
            rand!(rng_a, M, X; vector_at = p)
            Test.@test is_point(M, p; error = :error)
            # ensure that the RNG source is actually used
            Y = allocate(tv[1])
            rand!(rng_b, M, Y; vector_at = p)
            Test.@test X == Y
        end
    end

    Test.@testset "tangent vector distributions" begin # COV_EXCL_LINE
        for tvd in tvector_distributions
            p = tvd.type.point
            for _ in 1:5
                randtv = rand(tvd)
                atol = rand_tvector_atol_multiplier * Manifolds.find_eps(randtv)
                Test.@test is_vector(M, p, randtv, true; atol = atol)
                if test_mutating_rand
                    X = allocate(randtv)
                    rand!(tvd, X)
                    Test.@test is_vector(M, p, X, true; atol = atol)
                end
            end
        end
    end
    return nothing
end

"""
    Manifolds.test_parallel_transport(M,P; to=true, direction=true)

Generic tests for parallel transport on `M`given at least two pointsin `P`.

The single functions to transport `to` (a point) or (in a) `direction`
are sub-tests that can be activated by the keywords arguments

!!! note
    This function is soon deprecated and will be replaced by a more systematic way in `Manifolds.Test`
"""
function Manifolds.test_parallel_transport(
        M::AbstractManifold, P,
        Ξ = inverse_retract.(
            Ref(M), P[1:(end - 1)], P[2:end], Ref(default_inverse_retraction_method(M))
        );
        to = true, direction = true, mutating = true,
    )
    length(P) < 2 &&
        error("The Parallel Transport test set requires at least 2 points in P")
    return Test.@testset "Test Parallel Transport" begin # COV_EXCL_LINE
        Test.@testset "To (a point)" begin # COV_EXCL_LINE
            # even with to =false this displays no tests
            if to
                for i in 1:(length(P) - 1)
                    p = P[i]
                    q = P[i + 1]
                    X = Ξ[i]
                    Y1 = parallel_transport_to(M, p, X, q)
                    if mutating
                        Y2 = similar(X)
                        parallel_transport_to!(M, Y2, p, X, q)
                        # test that mutating and allocating to the same
                        Test.@test isapprox(M, q, Y1, Y2)
                        parallel_transport_to!(M, Y2, q, Y1, p)
                        # Test that transporting there and back again yields the identity
                        Test.@test isapprox(M, q, X, Y2)
                        parallel_transport_to!(M, Y1, q, Y1, p)
                        # Test that inplace does not have side effects
                    end
                    Test.@test isapprox(M, q, X, Y1)
                end
            end
        end
        Test.@testset "(Tangent Vector) Direction" begin # COV_EXCL_LINE
            if direction
                for i in 1:(length(P) - 1)
                    p = P[i]
                    X = Ξ[i]
                    Y1 = parallel_transport_direction(M, p, X, X)
                    q = exp(M, p, X)
                    if mutating
                        Y2 = similar(X)
                        parallel_transport_direction!(M, Y2, p, X, X)
                        # test that mutating and allocating to the same
                        Test.@test isapprox(M, q, Y1, Y2)
                    end
                    # Test that Y is a tangent vector at q
                    Test.@test is_vector(M, p, Y1; error = :error)
                end
            end
        end
    end
end

function Manifolds.test_atlases(M::AbstractManifold, pts, test_atlases; is_mutating::Bool = true)
    return Test.@testset "atlases" begin # COV_EXCL_LINE
        if !isempty(test_atlases)
            Test.@test get_default_atlas(M) isa AbstractAtlas{ℝ}
        end
        for A in test_atlases
            i = get_chart_index(M, A, pts[1])
            a = get_parameters(M, A, i, pts[1])
            Test.@test isa(a, AbstractVector)
            Test.@test length(a) == manifold_dimension(M)
            Test.@test isapprox(M, pts[1], get_point(M, A, i, a))
            if is_mutating
                get_parameters!(M, a, A, i, pts[2])
                Test.@test a ≈ get_parameters(M, A, i, pts[2])

                q = allocate(pts[1])
                get_point!(M, q, A, i, a)
                Test.@test isapprox(M, pts[2], q)
            end
        end
    end
end

using Manifolds, Test, LinearAlgebra

@testset "Cholesky Space" begin
    M = CholeskySpace(3)

    A(α) = [1.0 0.0 0.0; 0.0 cos(α) sin(α); 0.0 -sin(α) cos(α)]

    p1 = cholesky([1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]).L
    p2 = cholesky([2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]).L
    p3 = cholesky(A(π / 6) * [1.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1] * transpose(A(π / 6))).L

    # Tangent vectors are symmetric matrices
    X1 = [3.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1.0]
    X2 = [1.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 3.0]

    q1 = zeros(2, 3) # wrong size
    q2 = [1.0 0.0 0.0; 0.0 -1.0 0.0; 0.0 0.0 1.0] # nonpos diag
    q3 = [2.0 0.0 1.0; 0.0 1.0 0.0; 0.0 0.0 4.0] # no lower and nonsym

    Y = [0.0 1.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0] # not symmetric
    Manifolds.Test.test_manifold(
        M,
        Dict(
            :Functions => [
                default_vector_transport_method, distance, exp,
                inner, is_flat, is_point, is_vector,
                get_coordinates, get_vector,
                log, manifold_dimension,
                parallel_transport_to, rand, repr, representation_size,
                zero_vector,
            ],
            :Bases => [DefaultOrthonormalBasis()],
            :Coordinates => [[1.0, 0.0, 0.0, 0.0, 0.0, 0.0]],
            :Points => [p1, p2, p3],
            :Vectors => [X1, X2],
            :InvalidPoints => [q1, q2, q3],
            :InvalidVectors => [Y],
            :VectorTransportMethods => [
                ParallelTransport(),
                SchildsLadderTransport(),
                PoleLadderTransport(),
            ],
        ),
        Dict(
            default_vector_transport_method => ParallelTransport(),
            is_flat => true,
            manifold_dimension => 6,
            repr => "CholeskySpace(3)",
            representation_size => (3, 3),
        )
    )

    M = CholeskySpace(3; parameter = :field)
    Manifolds.Test.test_manifold(
        M,
        Dict(:Functions => [repr]),
        Dict(repr => "CholeskySpace(3; parameter=:field)")
    )
end

@doc raw"""
    PositiveNumbers <: AbstractManifold{ℝ}

The hyperbolic manifold of positive numbers $H^1$ is a the hyperbolic manifold represented
by just positive numbers.

# Constructor

    PositiveNumbers()

Generate the `ℝ`-valued hyperbolic model represented by positive positive numbers.
To use this with arrays (1-element arrays),
please use [`SymmetricPositiveDefinite`](@ref)`(1)`.
"""
struct PositiveNumbers <: AbstractManifold{ℝ} end

"""
    PositiveVectors(n::Integer; parameter::Symbol=:type)

Generate the manifold of vectors with positive entries.
This manifold is modeled as a [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of [`PositiveNumbers`](@ref).

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in a type parameter. Value can either be `:field` or `:type`.
"""
PositiveVectors(n::Integer; parameter::Symbol = :type) =
    PowerManifold(PositiveNumbers(), n; parameter = parameter)

"""
    PositiveMatrices(m::Integer, n::Integer; parameter::Symbol=:type)

Generate the manifold of matrices with positive entries.
This manifold is modeled as a [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of [`PositiveNumbers`](@ref).

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in a type parameter. Value can either be `:field` or `:type`.
"""
PositiveMatrices(n::Integer, m::Integer; parameter::Symbol = :type) =
    PowerManifold(PositiveNumbers(), n, m; parameter = parameter)

"""
    PositiveArrays(n₁, n₂, ..., nᵢ; parameter::Symbol=:type)

Generate the manifold of `i`-dimensional arrays with positive entries.
This manifold is modeled as a [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of [`PositiveNumbers`](@ref).

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in a type parameter. Value can either be `:field` or `:type`.
"""
PositiveArrays(n::Vararg{Int, I}; parameter::Symbol = :type) where {I} =
    PowerManifold(PositiveNumbers(), n...; parameter = parameter)

@doc raw"""
    change_representer(M::PositiveNumbers, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal M`` representing a linear function with respect
to the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`) `g_E`, this function changes the representer into the one
with respect to the positivity metric representation of
[`PositiveNumbers`](@ref) `M`.

For all tangent vectors ``Y`` the result ``Z`` has to fulfill

```math
    ⟨X,Y⟩ = XY = \frac{ZY}{p^2} = g_p(YZ)
```

and hence ``Z = p^2X``

"""
change_representer(::PositiveNumbers, ::EuclideanMetric, ::Any, ::Any)
change_representer(::PositiveNumbers, ::EuclideanMetric, p::Real, X::Real) = p * X * p

function change_representer!(::PositiveNumbers, Y, ::EuclideanMetric, p, X)
    Y .= p .* X .* p
    return Y
end

@doc raw"""
    change_metric(M::PositiveNumbers, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal M`` representing a linear function with respect to
the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`) `g_E`,
this function changes the representer into the one with respect to the positivity metric
of [`PositiveNumbers`](@ref) `M`.

For all ``Z,Y`` we are looking for the function ``c`` on the tangent space at ``p`` such that

```math
    ⟨Z,Y⟩ = XY = \frac{c(Z)c(Y)}{p^2} = g_p(c(Y),c(Z))
```

and hence ``C(X) = pX``.
"""
change_metric(::PositiveNumbers, ::EuclideanMetric, ::Any, ::Any)
change_metric(::PositiveNumbers, ::EuclideanMetric, p::Real, X::Real) = p * X

function change_metric!(::PositiveNumbers, Y, ::EuclideanMetric, p, X)
    Y .= p .* X
    return Y
end

@doc raw"""
    check_point(M::PositiveNumbers, p)

Check whether `p` is a point on the [`PositiveNumbers`](@ref) `M`, i.e. $p>0$.
"""
function check_point(M::PositiveNumbers, p; kwargs...)
    if any(p .<= 0.0)
        return DomainError(
            p,
            "The point $(p) does not lie on $(M), since it is nonpositive.",
        )
    end
    return nothing
end

"""
    check_vector(M::PositiveNumbers, p, X; kwargs...)

Check whether `X` is a tangent vector in the tangent space of `p` on the
[`PositiveNumbers`](@ref) `M`.
For the real-valued case represented by positive numbers, all `X` are valid, since the tangent space is the whole real line.
For the complex-valued case `X` [...]

"""
function check_vector(M::PositiveNumbers, p, X; kwargs...)
    return nothing
end

@doc raw"""
    distance(M::PositiveNumbers, p, q)

Compute the distance on the [`PositiveNumbers`](@ref) `M`, which is

````math
d(p,q) = \Bigl\lvert \log \frac{p}{q} \Bigr\rvert = \lvert \log p - \log q\rvert.
````
"""
distance(::PositiveNumbers, ::Any, ::Any)

distance(::PositiveNumbers, p::Real, q::Real) = abs(log(p / q))

embed(::PositiveNumbers, p) = p
embed(::PositiveNumbers, p, X) = X

@doc raw"""
    exp(M::PositiveNumbers, p, X)

Compute the exponential map on the [`PositiveNumbers`](@ref) `M`.
```math
\exp_p X = p\operatorname{exp}(X/p).
```
"""
Base.exp(::PositiveNumbers, ::Any, ::Any)

Base.exp(::PositiveNumbers, p::Real, X::Real) = p * exp(X / p)
exp_fused(::PositiveNumbers, p::Real, X::Real, t::Real) = p * exp(t * X / p)

exp!(::PositiveNumbers, q, p, X) = (q .= p .* exp.(X ./ p))

"""
    get_coordinates(::PositiveNumbers, p, X, ::DefaultOrthonormalBasis{ℝ})

Compute the coordinate of vector `X` which is tangent to `p` on the
[`PositiveNumbers`](@ref PositiveNumbers) manifold. The formula is ``X / p``.
"""
get_coordinates(::PositiveNumbers, p, X, ::DefaultOrthonormalBasis{ℝ})

get_coordinates_orthonormal(::PositiveNumbers, p, X, ::RealNumbers) = X / p

function get_coordinates_orthonormal!(::PositiveNumbers, c, p, X, ::RealNumbers)
    c .= X / p
    return c
end

"""
    get_vector(::PositiveNumbers, p, c, ::DefaultOrthonormalBasis{ℝ})

Compute the vector with coordinate `c` which is tangent to `p` on the
[`PositiveNumbers`](@ref PositiveNumbers) manifold. The formula is ``p * c``.
"""
get_vector(::PositiveNumbers, p, c, ::DefaultOrthonormalBasis{ℝ})

get_vector_orthonormal(::PositiveNumbers, p, c, ::RealNumbers) = p * c[]

function get_vector_orthonormal!(::PositiveNumbers, X, p, c, ::RealNumbers)
    X .= c[] * p
    return X
end

@doc raw"""
    injectivity_radius(M::PositiveNumbers[, p])

Return the injectivity radius on the [`PositiveNumbers`](@ref) `M`, i.e. $\infty$.
"""
injectivity_radius(::PositiveNumbers) = Inf

@doc raw"""
    inner(M::PositiveNumbers, p, X, Y)

Compute the inner product of the two tangent vectors `X,Y` from the tangent plane at `p` on
the [`PositiveNumbers`](@ref) `M`, i.e.

````math
g_p(X,Y) = \frac{XY}{p^2}.
````
"""
inner(::PositiveNumbers, ::Any...)
@inline inner(::PositiveNumbers, p::Real, X::Real, Y::Real) = X * Y / p^2
function inverse_retract(M::PositiveNumbers, x, y)
    return inverse_retract(M, x, y, LogarithmicInverseRetraction())
end
function inverse_retract(M::PositiveNumbers, x, y, ::LogarithmicInverseRetraction)
    return log(M, x, y)
end

"""
    is_flat(::PositiveNumbers)

Return false. [`PositiveNumbers`](@ref) is not a flat manifold.
"""
is_flat(M::PositiveNumbers) = false

@doc raw"""
    log(M::PositiveNumbers, p, q)

Compute the logarithmic map on the [`PositiveNumbers`](@ref) `M`.
````math
\log_p q = p\log\frac{q}{p}.
````
"""
Base.log(::PositiveNumbers, ::Any, ::Any)
Base.log(::PositiveNumbers, p::Real, q::Real) = p * log(q / p)

log!(::PositiveNumbers, X, p, q) = (X .= p .* log.(q ./ p))

@doc raw"""
    manifold_dimension(M::PositiveNumbers)

Return the dimension of the [`PositiveNumbers`](@ref) `M`,
i.e. of the 1-dimensional hyperbolic space,

````math
\dim(H^1) = 1
````
"""
manifold_dimension(::PositiveNumbers) = 1

@doc raw"""
    manifold_volume(M::PositiveNumbers)

Return volume of [`PositiveNumbers`](@ref) `M`, i.e. `Inf`.
"""
function manifold_volume(::PositiveNumbers)
    return Inf
end

mid_point(M::PositiveNumbers, p1, p2) = exp(M, p1, log(M, p1, p2) / 2)

@inline LinearAlgebra.norm(::PositiveNumbers, p, X) = sum(abs.(X ./ p))

@doc raw"""
    project(M::PositiveNumbers, p, X)

Project a value `X` onto the tangent space of the point `p` on the [`PositiveNumbers`](@ref) `M`,
which is just the identity.
"""
project(::PositiveNumbers, ::Any, ::Any)
project(::PositiveNumbers, ::Real, X::Real) = X

project!(::PositiveNumbers, Y, p, X) = (Y .= X)

retract(M::PositiveNumbers, p, q) = retract(M, p, q, ExponentialRetraction())
retract(M::PositiveNumbers, p, q, ::ExponentialRetraction) = exp(M, p, q)

representation_size(::PositiveNumbers) = ()

Base.show(io::IO, ::PositiveNumbers) = print(io, "PositiveNumbers()")

function Base.show(
        io::IO,
        M::PowerManifold{ℝ, PositiveNumbers, TSize, ArrayPowerRepresentation},
    ) where {TSize <: TypeParameter}
    s = get_parameter(M.size)
    (length(s) == 1) && return print(io, "PositiveVectors($(s[1]))")
    (length(s) == 2) && return print(io, "PositiveMatrices($(s[1]), $(s[2]))")
    return print(io, "PositiveArrays($(join(s, ", ")))")
end
function Base.show(
        io::IO,
        M::PowerManifold{ℝ, PositiveNumbers, TSize, ArrayPowerRepresentation},
    ) where {TSize <: Tuple}
    s = get_parameter(M.size)
    (length(s) == 1) && return print(io, "PositiveVectors($(s[1]); parameter=:field)")
    (length(s) == 2) &&
        return print(io, "PositiveMatrices($(s[1]), $(s[2]); parameter=:field)")
    return print(io, "PositiveArrays($(join(s, ", ")); parameter=:field)")
end

@doc raw"""
    parallel_transport_to(M::PositiveNumbers, p, X, q)

Compute the parallel transport of `X` from the tangent space at `p` to the tangent space at
`q` on the [`PositiveNumbers`](@ref) `M`.

````math
\mathcal P_{q\gets p}(X) = X⋅\frac{q}{p}.
````
"""
parallel_transport_to(::PositiveNumbers, ::Any, ::Any, ::Any)
function parallel_transport_to(::PositiveNumbers, p::Real, X::Real, q::Real)
    return X * q / p
end

function parallel_transport_to!(::PositiveNumbers, Y, p, X, q)
    return (Y .= X .* q ./ p)
end

function Random.rand(M::PositiveNumbers; kwargs...)
    return rand(Random.default_rng(), M; kwargs...)
end

function Random.rand(rng::AbstractRNG, ::PositiveNumbers; σ = 1.0, vector_at = nothing)
    if vector_at === nothing
        pX = exp(randn(rng) * σ)
    else
        pX = vector_at * randn(rng) * σ
    end
    return pX
end

function Random.rand!(
        rng::AbstractRNG,
        ::PositiveNumbers,
        pX;
        σ = one(eltype(pX)),
        vector_at = nothing,
    )
    if vector_at === nothing
        pX .= exp(randn(rng) * σ)
    else
        pX .= vector_at * randn(rng) * σ
    end
    return pX
end

@doc raw"""
    riemannian_Hessian(M::SymmetricPositiveDefinite, p, G, H, X)

The Riemannian Hessian can be computed as stated in Eq. (7.3) [Nguyen:2023](@cite).
Let ``\nabla f(p)`` denote the Euclidean gradient `G`,
``\nabla^2 f(p)[X]`` the Euclidean Hessian `H`.
Then the formula reads

```math
    \operatorname{Hess}f(p)[X] = p\bigl(∇^2 f(p)[X]\bigr)p + X\bigl(∇f(p)\bigr)p
```
"""
riemannian_Hessian(::PositiveNumbers, p, G, H, X) = p * H * p + X * G * p

function vector_transport_direction(
        M::PositiveNumbers,
        p,
        X,
        Y,
        m::AbstractVectorTransportMethod,
    )
    q = exp(M, p, Y)
    return vector_transport_to(M, p, X, q, m)
end

@doc raw"""
    volume_density(M::PositiveNumbers, p, X)

Compute volume density function of [`PositiveNumbers`](@ref). The formula reads
```math
\theta_p(X) = \exp(X / p)
```
"""
function volume_density(::PositiveNumbers, p, X)
    return exp(X / p)
end

zero_vector(::PositiveNumbers, p::Real) = zero(p)
zero_vector!(::PositiveNumbers, X, p) = fill!(X, 0)

@doc raw"""
    MultinomialSymmetric{T} <: AbstractMultinomialDoublyStochastic

The multinomial symmetric matrices manifold consists of all symmetric ``n×n`` matrices with
positive entries such that each column sums to one, i.e.

````math
\begin{aligned}
\mathcal{SP}(n) \coloneqq \bigl\{p ∈ ℝ^{n×n}\ \big|\ &p_{i,j} > 0 \text{ for all } i=1,…,n, j=1,…,m,\\
& p^\mathrm{T} = p,\\
& p\mathbf{1}_n = \mathbf{1}_n
\bigr\},
\end{aligned}
````

where ``\mathbf{1}_n`` is the vector of length ``n`` containing ones.

It is modeled as [`IsometricallyEmbeddedManifoldType`](@extref `ManifoldsBase.IsometricallyEmbeddedManifoldType`).
via the [`AbstractMultinomialDoublyStochastic`](@ref) type, since it shares a few functions
also with [`AbstractMultinomialDoublyStochastic`](@ref), most and foremost projection of
a point from the embedding onto the manifold.

The tangent space can be written as

````math
T_p\mathcal{SP}(n) \coloneqq \bigl\{
X ∈ ℝ^{n×n}\ \big|\ X = X^{\mathrm{T}} \text{ and }
X\mathbf{1}_n = \mathbf{0}_n
\bigr\},
````

where ``\mathbf{0}_n`` is the vector of length ``n`` containing zeros.

More details can be found in Section IV [DouikHassibi:2019](@cite).

# Constructor

    MultinomialSymmetric(n)

Generate the manifold of matrices ``ℝ^{n×n}`` that are doubly stochastic and symmetric.
"""
struct MultinomialSymmetric{T} <: AbstractMultinomialDoublyStochastic
    size::T
end

function MultinomialSymmetric(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return MultinomialSymmetric{typeof(size)}(size)
end

@doc raw"""
    check_point(M::MultinomialSymmetric, p)

Checks whether `p` is a valid point on the [`MultinomialSymmetric`](@ref)`(m,n)` `M`,
i.e. is a symmetric matrix with positive entries whose rows sum to one.
"""
function check_point(M::MultinomialSymmetric, p; kwargs...)
    n = get_parameter(M.size)[1]
    s = check_point(SymmetricMatrices(n, ℝ), p; kwargs...)
    !isnothing(s) && return s
    s2 = check_point(MultinomialMatrices(n, n), p; kwargs...)
    return s2
end
@doc raw"""
    check_vector(M::MultinomialSymmetric p, X; kwargs...)

Checks whether `X` is a valid tangent vector to `p` on the [`MultinomialSymmetric`](@ref) `M`.
This means, that `p` is valid, that `X` is of correct dimension, symmetric, and sums to zero
along any row.
"""
function check_vector(M::MultinomialSymmetric, p, X; kwargs...)
    n = get_parameter(M.size)[1]
    s = check_vector(SymmetricMatrices(n, ℝ), p, X; kwargs...)
    !isnothing(s) && return s
    s2 = check_vector(MultinomialMatrices(n, n), p, X)
    return s2
end

embed!(::MultinomialSymmetric, q, p) = copyto!(q, p)
embed!(::MultinomialSymmetric, Y, ::Any, X) = copyto!(Y, X)

function get_embedding(::MultinomialSymmetric{TypeParameter{Tuple{n}}}) where {n}
    return MultinomialMatrices(n, n)
end
function get_embedding(M::MultinomialSymmetric{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return MultinomialMatrices(n, n; parameter = :field)
end

function ManifoldsBase.get_embedding_type(::MultinomialSymmetric)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

"""
    is_flat(::MultinomialSymmetric)

Return false. [`MultinomialSymmetric`](@ref) is not a flat manifold.
"""
is_flat(M::MultinomialSymmetric) = false

@doc raw"""
    manifold_dimension(M::MultinomialSymmetric)

returns the dimension of the [`MultinomialSymmetric`](@ref) manifold
namely
````math
\operatorname{dim}_{\mathcal{SP}(n)} = \frac{n(n-1)}{2}.
````
"""
function manifold_dimension(M::MultinomialSymmetric)
    n = get_parameter(M.size)[1]
    return div(n * (n - 1), 2)
end

@doc raw"""
    project(M::MultinomialSymmetric, p, Y)

Project `Y` onto the tangent space at `p` on the [`MultinomialSymmetric`](@ref) `M`, return the result in `X`.

The formula from [DouikHassibi:2019](@cite), Sec. VI reads

````math
    \operatorname{proj}_p(Y) = Y - (α\mathbf{1}_n^{\mathrm{T}} + \mathbf{1}_n α^{\mathrm{T}}) ⊙ p,
````
where ``⊙`` denotes the Hadamard or elementwise product and ``\mathbb{1}_n`` is the vector of length ``n`` containing ones.
The two vector ``α ∈ ℝ^{n×n}`` is given by solving
````math
    (I_n+p)α =  Y\mathbf{1},
````
where ``I_n`` is teh ``n×n`` unit matrix and ``\mathbf{1}_n`` is the vector of length ``n`` containing ones.
"""
project(::MultinomialSymmetric, ::Any, ::Any)

function project!(M::MultinomialSymmetric, X, p, Y)
    n = get_parameter(M.size)[1]
    α = (I + p) \ sum(Y, dims = 2) # Formula (49) from 1802.02628
    return X .= Y .- (repeat(α, 1, n) .+ repeat(α', n, 1)) .* p
end

@doc raw"""
    rand(::MultinomialSymmetric; vector_at=nothing, σ::Real=1.0, kwargs...)

Generate random points on the [`MultinomialSymmetric`](@ref) manifold
or tangent vectors at the point `vector_at` if that is not `nothing`.

Let ``n×n`` denote the matrix dimension of the [`MultinomialSymmetric`](@ref).

When `vector_at` is nothing, this is done by generating a random matrix `rand(n, n)`
with positive entries and projecting it onto the manifold. The `kwargs...` are
passed to this projection.

When `vector_at` is not `nothing`, a random matrix in the ambient space is generated
and projected onto the tangent space
"""
rand(::MultinomialSymmetric; σ::Real = 1.0)

function Random.rand!(
        rng::AbstractRNG,
        M::MultinomialSymmetric,
        pX;
        vector_at = nothing,
        kwargs...,
    )
    n = get_parameter(M.size)[1]
    rand!(rng, SymmetricMatrices(n), pX; kwargs...)
    if vector_at === nothing
        project!(M, pX, pX)
    else
        project!(M, pX, vector_at, pX)
    end
    return pX
end

function representation_size(M::MultinomialSymmetric)
    n = get_parameter(M.size)[1]
    return (n, n)
end

@doc raw"""
    retract(M::MultinomialSymmetric, p, X, ::ProjectionRetraction)

compute a projection based retraction by projecting ``p⊙\exp(X⨸p)`` back onto the manifold,
where ``⊙,⨸`` are elementwise multiplication and division, respectively. Similarly, ``\exp``
refers to the elementwise exponentiation.
"""
retract(::MultinomialSymmetric, ::Any, ::Any, ::ProjectionRetraction)

function ManifoldsBase.retract_project!(M::MultinomialSymmetric, q, p, X)
    return project!(M, q, p .* exp.(X ./ p))
end
function ManifoldsBase.retract_project_fused!(M::MultinomialSymmetric, q, p, X, t::Number)
    return project!(M, q, p .* exp.(t .* X ./ p))
end

@doc raw"""
    Y = riemannian_Hessian(M::MultinomialSymmetric, p, G, H, X)
    riemannian_Hessian!(M::MultinomialSymmetric, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

The Riemannian Hessian can be computed as stated in Corollary 3 [DouikHassibi:2019](@cite).
"""
riemannian_Hessian(M::MultinomialSymmetric, p, G, H, X)

function riemannian_Hessian!(M::MultinomialSymmetric, Y, p, G, H, X)
    # The notation here is the same as in (53) DouikHassibi:2019
    # with the small change their X is our p their ξ_X is our X , Hessf is H, Gradf is G
    n = get_parameter(M.size)[1]
    ov = ones(n) # \bf 1
    I_p = lu(I + p)
    γ = G .* p
    α = I_p \ (γ * ov)
    α_sq = (repeat(α, 1, n) .+ repeat(α', n, 1))
    δ = γ .- α_sq .* p
    γ_dot = H .* p + G .* X
    α_dot = (I_p \ γ_dot .- (I_p \ X) * (I_p \ γ)) * ov
    δ_dot = γ_dot .- (repeat(α_dot, 1, n) .+ repeat(α_dot', n, 1)) .* p .- α_sq .* X
    project!(M, Y, p, δ_dot .- 0.5 * ((δ .* X) ./ p))
    return Y
end

function Base.show(io::IO, ::MultinomialSymmetric{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "MultinomialSymmetric($(n))")
end
function Base.show(io::IO, M::MultinomialSymmetric{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "MultinomialSymmetric($(n); parameter=:field)")
end

include("../header.jl")

@testset "Rotations" begin
    M = Rotations(2)
    @test repr(M) == "Rotations(2)"
    @test representation_size(M) == (2, 2)
    @test is_flat(M)
    @test injectivity_radius(M) == π * sqrt(2.0)
    @test injectivity_radius(M, [1.0 0.0; 0.0 1.0]) == π * sqrt(2.0)
    @test injectivity_radius(M, ExponentialRetraction()) == π * sqrt(2.0)
    @test injectivity_radius(M, [1.0 0.0; 0.0 1.0], ExponentialRetraction()) ==
        π * sqrt(2.0)
    @test injectivity_radius(M, PolarRetraction()) ≈ π / sqrt(2)
    @test injectivity_radius(M, [1.0 0.0; 0.0 1.0], PolarRetraction()) ≈ π / sqrt(2)
    @test get_embedding(M) == Euclidean(2, 2)
    types = [Matrix{Float64}, SMatrix{2, 2, Float64, 4}]
    retraction_methods = [PolarRetraction(), QRRetraction()]
    @test default_vector_transport_method(M) === ParallelTransport()

    inverse_retraction_methods = [PolarInverseRetraction(), QRInverseRetraction()]

    basis_types = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))

    @testset "vee/hat" begin
        M = Rotations(2)
        Xf = [1.23]
        p = Matrix{Float64}(I, 2, 2)
        X = hat(M, p, Xf)
        @test isa(X, AbstractMatrix)
        @test norm(M, p, X) / sqrt(2) ≈ norm(Xf)
        @test vee(M, p, X) == Xf

        X = project(M, p, randn(2, 2))
        Xf = vee(M, p, X)
        @test isa(Xf, AbstractVector)
        @test hat(M, p, Xf) == X
    end

    for T in types
        angles = (0.0, π / 2, 2π / 3, π / 4)
        pts = [convert(T, [cos(ϕ) -sin(ϕ); sin(ϕ) cos(ϕ)]) for ϕ in angles]
        point_distributions =
            (T <: SMatrix) ? [] : [Manifolds.normal_rotation_distribution(M, pts[1], 1.0)]
        tvector_distributions =
            (T <: SMatrix) ? [] : [Manifolds.normal_tvector_distribution(M, pts[1], 1.0)]
        Manifolds.test_manifold(
            M,
            pts;
            is_mutating = !(T <: SMatrix),
            test_injectivity_radius = false,
            test_project_tangent = true,
            test_musical_isomorphisms = true,
            test_default_vector_transport = true,
            retraction_methods = retraction_methods,
            inverse_retraction_methods = inverse_retraction_methods,
            point_distributions,
            tvector_distributions,
            basis_types_to_from = basis_types,
            test_inplace = true,
            test_rand_point = true,
            retraction_atol_multiplier = 2,
            exp_log_atol_multiplier = 10,
        )

        @testset "log edge cases" begin
            X = Manifolds.hat(M, pts[1], [Float64(π)])
            p = exp(M, pts[1], X)
            @test isapprox(p, exp(M, pts[1], log(M, pts[1], p)))
        end

        X = log(M, pts[1], pts[2])
        @test norm(M, pts[1], X) ≈ (angles[2] - angles[1]) * sqrt(2)

        # check that exp! does not have a side effect
        q = allocate(pts[1])
        copyto!(M, q, pts[1])
        q2 = exp(M, pts[1], X)
        exp!(M, q, q, X)
        @test norm(q - q2) ≈ 0

        X14_polar = inverse_retract(M, pts[1], pts[4], PolarInverseRetraction())
        p4_polar = retract(M, pts[1], X14_polar, PolarRetraction())
        @test isapprox(M, pts[4], p4_polar)

        X14_qr = inverse_retract(M, pts[1], pts[4], QRInverseRetraction())
        p4_qr = retract(M, pts[1], X14_qr, QRRetraction())
        @test isapprox(M, pts[4], p4_qr)
    end

    @testset "Distribution tests" begin
        usd_mmatrix =
            Manifolds.normal_rotation_distribution(M, (@MMatrix [1.0 0.0; 0.0 1.0]), 1.0)
        @test isa(rand(usd_mmatrix), MMatrix)

        usd1_mmatrix =
            Manifolds.normal_rotation_distribution(Rotations(1), (@MMatrix [1.0]), 1.0)
        @test isa(rand(usd1_mmatrix), MMatrix)
        @test rand(usd1_mmatrix) == @MMatrix [1.0]

        gtsd_mvector =
            Manifolds.normal_tvector_distribution(M, (@MMatrix [1.0 0.0; 0.0 1.0]), 1.0)
        @test isa(rand(gtsd_mvector), MMatrix)

        Test.@test Distributions.support(usd_mmatrix).manifold == M
    end

    Random.seed!(42)
    for n in (3, 4, 5)
        @testset "Rotations: SO($n)" begin
            SOn = Rotations(n)
            @test !is_flat(SOn)
            ptd = Manifolds.normal_rotation_distribution(SOn, Matrix(1.0I, n, n), 1.0)
            tvd = Manifolds.normal_tvector_distribution(SOn, Matrix(1.0I, n, n), 1.0)
            pts = [rand(ptd) for _ in 1:3]
            diag_basis_1 = if n == 3
                DiagonalizingOrthonormalBasis(
                    [
                        0.0 0.24800271831269094 0.30019597622794186
                        -0.24800271831269094 0.0 -0.5902347224334308
                        -0.30019597622794186 0.5902347224334308 0.0
                    ],
                )
            else
                DiagonalizingOrthonormalBasis(rand(SOn; vector_at = pts[1]))
            end
            diag_basis_2 = DiagonalizingOrthonormalBasis(
                hat(SOn, pts[1], [1.0, zeros(manifold_dimension(SOn) - 1)...]),
            )
            Manifolds.test_manifold(
                SOn,
                pts;
                test_injectivity_radius = false,
                test_musical_isomorphisms = true,
                test_mutating_rand = true,
                test_default_vector_transport = true,
                retraction_methods = retraction_methods,
                inverse_retraction_methods = inverse_retraction_methods,
                point_distributions = [ptd],
                tvector_distributions = [tvd],
                basis_types_to_from = basis_types,
                basis_types_vecs = (diag_basis_1, diag_basis_2),
                exp_log_atol_multiplier = 250,
                retraction_atol_multiplier = 12,
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
            )

            @testset "vee/hat" begin
                p = Matrix(1.0I, n, n)
                Xf = randn(manifold_dimension(SOn))
                X = Manifolds.hat(SOn, p, Xf)
                @test isa(X, AbstractMatrix)
                @test norm(SOn, p, X) / sqrt(2) ≈ norm(Xf)
                @test Manifolds.vee(SOn, p, X) == Xf

                X = project(SOn, p, randn(n, n))
                Xf = Manifolds.vee(SOn, p, X)
                @test isa(Xf, AbstractVector)
                @test Manifolds.hat(SOn, p, Xf) ≈ X
            end
            X = Matrix(
                Manifolds.hat(SOn, pts[1], π * normalize(randn(manifold_dimension(SOn)))),
            )
            p = exp(SOn, pts[1], X)
            X2 = log(SOn, pts[1], p)
            @test distance(SOn, p, exp(SOn, pts[1], X2)) < 25 * eps()
            p2 = ManifoldsBase.exp_fused(SOn, pts[1], X, 1.0)
            X3 = log(SOn, pts[1], p)
            @test distance(SOn, p, exp(SOn, pts[1], X3)) < 25 * eps()

            @testset "gradient and metric conversion" begin
                Y = change_metric(M, EuclideanMetric(), p, X)
                @test Y == X
                Z = change_representer(M, EuclideanMetric(), p, X)
                @test Z == X
            end
        end
    end
    @testset "Test AbstractManifold Point and Tangent Vector checks" begin
        M = Rotations(2)
        for p in [1, [2.0 0.0; 0.0 1.0], [1.0 0.5; 0.0 1.0]]
            @test_throws DomainError is_point(M, p; error = :error)
            @test !is_point(M, p)
        end
        p = one(zeros(2, 2))
        @test is_point(M, p)
        @test is_point(M, p; error = :error)
        for X in [1, [0.0 1.0; 0.0 0.0]]
            @test_throws DomainError is_vector(M, p, X; error = :error)
            @test !is_vector(M, p, X)
        end
        X = [0.0 1.0; -1.0 0.0]
        @test is_vector(M, p, X)
        @test is_vector(M, p, X; error = :error)
    end
    @testset "Project point" begin
        M = Rotations(2)
        p = Matrix{Float64}(I, 2, 2)
        p1 = project(M, p)
        @test is_point(M, p1; error = :error)

        M = Rotations(3)
        p = collect(reshape(1.0:9.0, (3, 3)))
        p2 = project(M, p)
        @test is_point(M, p2; error = :error)

        rng = MersenneTwister(44)
        x3 = project(M, randn(rng, 3, 3))
        @test is_point(M, x3; error = :error)
    end
    @testset "Convert from Lie algebra representation of tangents to Riemannian submanifold representation" begin
        M = Rotations(3)
        p = project(M, collect(reshape(1.0:9.0, (3, 3))))
        x = [[0, -1, 3] [1, 0, 2] [-3, -2, 0]]
        @test is_vector(M, p, x; error = :error)
        @test embed(M, p, x) == p * x
        Y = zeros((3, 3))
        embed!(M, Y, p, x)
        @test Y == p * x
        @test Y ≈ p * (p'Y - Y'p) / 2
    end
    @testset "Edge cases of Rotations" begin
        @test_throws OutOfInjectivityRadiusError inverse_retract(
            Rotations(2),
            [1.0 0.0; 0.0 1.0],
            [1.0 0.0; 0.0 -1.0],
            PolarInverseRetraction(),
        )
    end

    @testset "Rotations(1)" begin
        M = Rotations(1)
        p = fill(1.0, 1, 1)
        X = get_vector(M, p, Float64[], DefaultOrthonormalBasis())
        @test X isa Matrix{Float64}
        @test X == fill(0.0, 1, 1)
        Xc = get_coordinates(M, p, X, DefaultOrthonormalBasis())
        @test length(Xc) == 0
        @test Xc isa Vector{Float64}

        @test injectivity_radius(M) == 0.0
        @test injectivity_radius(M, p) == 0.0
        @test injectivity_radius(M, ExponentialRetraction()) == 0.0
        @test injectivity_radius(M, p, ExponentialRetraction()) == 0.0
        @test injectivity_radius(M, PolarRetraction()) == 0.0
        @test injectivity_radius(M, p, PolarRetraction()) == 0.0
    end
    @testset "Riemannian Hessian" begin
        M = Rotations(2)
        p = Matrix{Float64}(I, 2, 2)
        X = [0.0 3.0; -3.0 0.0]
        V = [1.0 0.0; 1.0 0.0]
        @test Weingarten(M, p, X, V) == -1 / 2 * p * (V' * X - X' * V)
        G = [0.0 1.0; 0.0 0.0]
        H = [0.0 0.0; 2.0 0.0]
        @test riemannian_Hessian(M, p, G, H, X) == [0.0 -1.0; 1.0 0.0]
    end

    @testset "riemann_tensor" begin
        M = Rotations(3)
        p = [
            -0.5908399013383766 -0.6241917041179139 0.5111681988316876
            -0.7261666986267721 0.13535732881097293 -0.6740625485388226
            0.35155388888753836 -0.7694563730631729 -0.5332417398896261
        ]
        X = [
            0.0 -0.30777760628130063 0.5499897386953444
            0.30777760628130063 0.0 -0.32059980100053004
            -0.5499897386953444 0.32059980100053004 0.0
        ]
        Y = [
            0.0 -0.4821890003925358 -0.3513148535122392
            0.4821890003925358 0.0 0.37956770358148356
            0.3513148535122392 -0.37956770358148356 0.0
        ]
        Z = [
            0.0 0.3980141785048982 0.09735377380829331
            -0.3980141785048982 0.0 -0.576287216962475
            -0.09735377380829331 0.576287216962475 0.0
        ]
        @test riemann_tensor(M, p, X, Y, Z) ≈ [
            0.0 0.04818900625787811 -0.050996416671166
            -0.04818900625787811 0.0 0.024666891276861697
            0.050996416671166 -0.024666891276861697 0.0
        ]
    end

    @testset "sectional curvature" begin
        @test sectional_curvature_min(Rotations(3)) == 0.0
        @test sectional_curvature_max(Rotations(1)) == 0.0
        @test sectional_curvature_max(Rotations(2)) == 0.0
        @test sectional_curvature_max(Rotations(3)) == 1 / 8
        @test sectional_curvature_max(Rotations(4)) == 1 / 4
    end

    @testset "field parameter" begin
        M = Rotations(2; parameter = :field)
        @test is_flat(M)
        @test repr(M) == "Rotations(2; parameter=:field)"

        M = Rotations(1; parameter = :field)
        p = fill(1.0, 1, 1)
        X = get_vector(M, p, Float64[], DefaultOrthonormalBasis())
        @test X isa Matrix{Float64}
        @test X == fill(0.0, 1, 1)
    end

    @testset "Specializations" begin
        M = Rotations(2)
        p = Matrix{Float64}(I, 2, 2)
        X = [0.0 3.0; -3.0 0.0]
        @test parallel_transport_direction(M, p, X, X) === X

        M = Rotations(3)
        p = @SMatrix [
            -0.5908399013383766 -0.6241917041179139 0.5111681988316876
            -0.7261666986267721 0.13535732881097293 -0.6740625485388226
            0.35155388888753836 -0.7694563730631729 -0.5332417398896261
        ]
        X = @SMatrix [
            0.0 -0.30777760628130063 0.5499897386953444
            0.30777760628130063 0.0 -0.32059980100053004
            -0.5499897386953444 0.32059980100053004 0.0
        ]
        d = @SMatrix [
            0.0 -0.4821890003925358 -0.3513148535122392
            0.4821890003925358 0.0 0.37956770358148356
            0.3513148535122392 -0.37956770358148356 0.0
        ]
        @test parallel_transport_direction(M, p, X, d) ≈ [
            0.0 -0.3258778314599828 0.3903114578816008
            0.32587783145998306 0.0 -0.49138641089195584
            -0.3903114578816011 0.4913864108919558 0.0
        ]
    end
    @testset "Jacobians" begin
        M = Rotations(2)
        p = [
            0.38024046142595025 0.9248876642568981
            -0.9248876642568981 0.38024046142595014
        ]
        X = [
            0.0 0.40294834454872025
            -0.40294834454872025 0.0
        ]
        @test ManifoldDiff.jacobian_exp_argument(M, p, X) == @SMatrix [1]
        J = fill(0.0, 1, 1)
        ManifoldDiff.jacobian_exp_argument!(M, J, p, X)
        @test J == @SMatrix [1]

        M = Rotations(3)
        p = [
            0.8795914880107569 -0.39921238866388364 -0.2587436626398777
            0.4643792859455722 0.6024065774550045 0.6491981163124461
            -0.10329904648012433 -0.6911843344406933 0.7152576618394751
        ]
        X = [
            0.0 -0.5656000980668913 0.7650118907017176
            0.5656000980668913 0.0 0.9710556005789448
            -0.7650118907017176 -0.9710556005789448 0.0
        ]
        Jref = [
            0.8624842949736633 0.12898141742603422 -0.41055104894342076
            -0.3547043184601566 0.8081393303537744 -0.3494729262397322
            0.24366619850830287 0.4809472670341492 0.7678272125532423
        ]
        @test ManifoldDiff.jacobian_exp_argument(M, p, X) ≈ Jref
        J = fill(0.0, 3, 3)
        ManifoldDiff.jacobian_exp_argument!(M, J, p, X)
        @test J ≈ Jref
    end

    @testset "manifold_volume and volume_density" begin
        @test manifold_volume(Rotations(1)) ≈ 1
        @test manifold_volume(Rotations(2)) ≈ 2 * π * sqrt(2)
        @test manifold_volume(Rotations(3)) ≈ 8 * π^2 * sqrt(2)
        @test manifold_volume(Rotations(4)) ≈ (2 * π)^4 * sqrt(2)
        @test manifold_volume(Rotations(5)) ≈ 4 * (2 * π)^6 / 6 * sqrt(2)

        M = Rotations(3)
        p = [
            -0.5908399013383766 -0.6241917041179139 0.5111681988316876
            -0.7261666986267721 0.13535732881097293 -0.6740625485388226
            0.35155388888753836 -0.7694563730631729 -0.5332417398896261
        ]
        X = [
            0.0 -0.30777760628130063 0.5499897386953444
            0.30777760628130063 0.0 -0.32059980100053004
            -0.5499897386953444 0.32059980100053004 0.0
        ]
        @test volume_density(M, p, X) ≈ 0.8440563052346255
        @test volume_density(M, p, zero(X)) ≈ 1.0

        M = Rotations(4)
        p = [
            -0.09091199873970474 -0.5676546886791307 -0.006808638869334249 0.8182034009599919
            -0.8001176365300662 0.3161567169523502 -0.4938592872334223 0.12633171594159726
            -0.5890394255366699 -0.2597679221590146 0.7267279425385695 -0.23962403743004465
            -0.0676707570677516 -0.7143764493344514 -0.4774129704812182 -0.5071132150619608
        ]
        X = [
            0.0 0.2554704296965055 0.26356215573144676 -0.4070678736115306
            -0.2554704296965055 0.0 -0.04594199053786204 -0.10586374034761421
            -0.26356215573144676 0.04594199053786204 0.0 0.43156436122007846
            0.4070678736115306 0.10586374034761421 -0.43156436122007846 0.0
        ]
        @test volume_density(M, p, X) ≈ 0.710713830700454
    end
end

using Manifolds, LinearAlgebra, PGFPlotsX, Colors, Distributions, Contour, Random

#
# Settings
#
dark_mode = false

line_offset_brightness = 0.25
patch_opacity = 1.0
geo_opacity = dark_mode ? 0.66 : 0.5
geo_line_width = 35
mesh_line_width = 5
mesh_opacity = dark_mode ? 0.5 : 0.7
logo_colors = [(77, 100, 174), (57, 151, 79), (202, 60, 50), (146, 89, 163)] # Julia colors

rgb_logo_colors = map(x -> RGB(x ./ 255...), logo_colors)
rgb_logo_colors_bright =
    map(x -> RGB((1 + line_offset_brightness) .* x ./ 255...), logo_colors)
rgb_logo_colors_dark =
    map(x -> RGB((1 - line_offset_brightness) .* x ./ 255...), logo_colors)

out_file_prefix = dark_mode ? "logo-dark" : "logo"
out_file_ext = ".svg"

#
# Helping functions
#
polar_to_cart(r, θ) = (r * cos(θ), r * sin(θ))

cart_to_polar(x, y) = (hypot(x, y), atan(y, x))

normal_coord_to_vector(M, x, rθ, B) = get_vector(M, x, collect(polar_to_cart(rθ...)), B)

normal_coord_to_point(M, x, rθ, B) = exp(M, x, normal_coord_to_vector(M, x, rθ, B))

function plot_normal_coord!(ax, M, x, B, rs, θs; ncirc = 9, options = Dict(), kwargs...)
    for r in rs[2:(end - 1)]
        push!(
            ax,
            Plot3(
                options,
                Coordinates(map(θ -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), θs)),
            ),
        )
    end
    for θ in range(0, 2π; length = ncirc)
        push!(
            ax,
            Plot3(
                options,
                Coordinates(map(r -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), rs)),
            ),
        )
    end
    return ax
end

function plot_patch!(ax, M, x, B, r, θs; options = Dict())
    push!(
        ax,
        Plot3(
            options,
            Coordinates(map(θ -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), θs)),
        ),
    )
    return ax
end

function plot_geodesic!(ax, M, x, y; n = 100, options = Dict())
    γ = shortest_geodesic(M, x, y)
    T = range(0, 1; length = n)
    push!(ax, Plot3(options, Coordinates(Tuple.(γ(T)))))
    return ax
end

#
# Prepare document
#
resize!(PGFPlotsX.CUSTOM_PREAMBLE, 0)
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pgfplotsset{scale=6.0}")
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\usetikzlibrary{arrows.meta}")
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pgfplotsset{roundcaps/.style={line cap=round}}")
push!(
    PGFPlotsX.CUSTOM_PREAMBLE,
    raw"\pgfplotsset{meshlinestyle/.style={dash pattern=on 0pt off 2.5\pgflinewidth, line cap=round}}",
)
if dark_mode
    push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pagecolor{black}")
end
S = Sphere(2)

center = normalize([1, 1, 1])
x, y, z = eachrow(Matrix{Float64}(I, 3, 3))
γ1 = shortest_geodesic(S, center, z)
γ2 = shortest_geodesic(S, center, x)
γ3 = shortest_geodesic(S, center, y)
p1 = γ1(1)
p2 = γ2(1)
p3 = γ3(1)

#
# Setup Axes
if dark_mode
    tp = @pgf Axis(
        {
            axis_lines = "none",
            axis_equal,
            view = "{135}{35}",
            zmin = -0.05,
            zmax = 1.0,
            xmin = 0.0,
            xmax = 1.0,
            ymin = 0.0,
            ymax = 1.0,
        }
    )
else
    tp = @pgf Axis(
        {
            axis_lines = "none",
            axis_equal,
            view = "{135}{35}",
            zmin = -0.05,
            zmax = 1.0,
            xmin = 0.0,
            xmax = 1.0,
            ymin = 0.0,
            ymax = 1.0,
        }
    )
end
rs = range(0, π / 5; length = 6)
θs = range(0, 2π; length = 100)

#
# Plot manifold patches
patch_colors = rgb_logo_colors[2:end]
patch_colors_line = dark_mode ? rgb_logo_colors_bright[2:end] : rgb_logo_colors_dark[2:end]
base_points = [p1, p2, p3]
basis_vectors = [log(S, p1, p2), log(S, p2, p1), log(S, p3, p1)]
for i in eachindex(base_points)
    x = base_points[i]
    B = DiagonalizingOrthonormalBasis(basis_vectors[i])
    basis = get_basis(S, x, B)
    optionsP = @pgf {fill = patch_colors[i], draw = "none", opacity = patch_opacity}
    plot_patch!(tp, S, x, basis, π / 5, θs; options = optionsP)
    optionsL = @pgf {
        meshlinestyle,
        color = dark_mode ? "white" : "black",
        line_width = mesh_line_width,
        opacity = mesh_opacity,
    }
    plot_normal_coord!(tp, S, x, basis, rs, θs; options = optionsL)
end

#
# Plot geodesics
options = @pgf {
    opacity = geo_opacity,
    no_markers,
    roundcaps,
    line_width = geo_line_width,
    color = dark_mode ? "white" : "black",
}
plot_geodesic!(tp, S, base_points[1], base_points[2]; options = options)
plot_geodesic!(tp, S, base_points[1], base_points[3]; options = options)
plot_geodesic!(tp, S, base_points[2], base_points[3]; options = options)

#
# Export Logo.
out_file = "$(out_file_prefix)$(out_file_ext)"
pgfsave(out_file, tp)

exp!(::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric}, q, p, X) = (q .= p .+ X)
function exp_fused!(
        ::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric},
        q,
        p,
        X,
        t::Number,
    )
    return (q .= p .+ t .* X)
end

@doc raw"""
    manifold_volume(::MetricManifold{ℝ,<:ProbabilitySimplex{n},<:EuclideanMetric})) where {n}

Return the volume of the [`ProbabilitySimplex`](@ref) with the Euclidean metric.
The formula reads ``\frac{\sqrt{n+1}}{n!}``
"""
function manifold_volume(M::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric})
    n = get_parameter(M.manifold.size)[1]
    return sqrt(n + 1) / factorial(n)
end

function project!(::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric}, X, p, Y)
    X .= Y .- mean(Y)
    return X
end

@doc raw"""
    rand(::MetricManifold{ℝ,<:ProbabilitySimplex,<:EuclideanMetric}; vector_at=nothing, σ::Real=1.0)

When `vector_at` is `nothing`, return a random (uniform) point `x` on the [`ProbabilitySimplex`](@ref) with the Euclidean metric
manifold `M` by normalizing independent exponential draws to unit sum, see [Devroye:1986](@cite), Theorems 2.1 and 2.2 on p. 207 and 208, respectively.
When `vector_at` is not `nothing`, return a (Gaussian) random vector from the tangent space
``T_{p}\mathrm{\Delta}^n``by shifting a multivariate Gaussian with standard deviation `σ`
to have a zero component sum.
"""
rand(::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric}; σ::Real = 1.0)
function Random.rand(
        M::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric};
        vector_at = nothing,
        kwargs...,
    )
    if vector_at === nothing
        pX = allocate_result(M, rand)
    else
        pX = allocate_result(M, rand, vector_at)
    end
    rand!(M, pX; vector_at = vector_at, kwargs...)
    return pX
end
function Random.rand(
        rng::AbstractRNG,
        M::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric};
        vector_at = nothing,
        kwargs...,
    )
    if vector_at === nothing
        pX = allocate_result(M, rand)
    else
        pX = allocate_result(M, rand, vector_at)
    end
    rand!(rng, M, pX; vector_at = vector_at, kwargs...)
    return pX
end

function Random.rand!(
        rng::AbstractRNG,
        ::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric},
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if isnothing(vector_at)
        Random.randexp!(rng, pX)
        LinearAlgebra.normalize!(pX, 1)
    else
        Random.randn!(rng, pX)
        pX .= (pX .- mean(pX)) .* σ
    end
    return pX
end

function Random.rand!(
        M::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric},
        pX;
        kwargs...,
    )
    return rand!(Random.default_rng(), M, pX; kwargs...)
end

@doc raw"""
    volume_density(::MetricManifold{ℝ,<:ProbabilitySimplex,<:EuclideanMetric}, p, X)

Compute the volume density at point `p` on [`ProbabilitySimplex`](@ref) `M` for tangent
vector `X`. It is equal to 1.
"""
function volume_density(::MetricManifold{ℝ, <:ProbabilitySimplex, <:EuclideanMetric}, p, X)
    return one(eltype(X))
end

@doc raw"""
    Torus{N} <: AbstractPowerManifold

The n-dimensional torus is the ``n``-dimensional product of the [`Circle`](@ref).

The [`Circle`](@ref) is stored internally within `M.manifold`, such that all functions of
[`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  can be used directly.
"""
struct Torus{N} <: AbstractPowerManifold{ℝ, Circle{ℝ}, ArrayPowerRepresentation}
    manifold::Circle{ℝ}
end

Torus(n::Int) = Torus{n}(Circle())

Base.:^(M::Circle, n::Int) = Torus{n}(M)

@doc raw"""
    check_point(M::Torus{n},p)

Checks whether `p` is a valid point on the [`Torus`](@ref) `M`, i.e. each of
its entries is a valid point on the [`Circle`](@ref) and the length of `x` is `n`.
"""
check_point(::Torus, ::Any)
function check_point(M::Torus{N}, p; kwargs...) where {N}
    return check_point(PowerManifold(M.manifold, N), p; kwargs...)
end
@doc raw"""
    check_vector(M::Torus{n}, p, X; kwargs...)

Checks whether `X` is a valid tangent vector to `p` on the [`Torus`](@ref) `M`.
This means, that `p` is valid, that `X` is of correct dimension and elementwise
a tangent vector to the elements of `p` on the [`Circle`](@ref).
"""
function check_vector(M::Torus{N}, p, X; kwargs...) where {N}
    return check_vector(PowerManifold(M.manifold, N), p, X; kwargs...)
end

get_iterator(::Torus{N}) where {N} = 1:N

manifold_dimension(::Torus{N}) where {N} = N

power_dimensions(::Torus{N}) where {N} = (N,)

representation_size(::Torus{N}) where {N} = (N,)

Base.show(io::IO, ::Torus{N}) where {N} = print(io, "Torus($(N))")

#
# This file requires Symplectic to be defined, since it need the symplectic inverse A^+
# This type is used in the Symplectic Grassmann
@doc raw"""
    Hamiltonian{T,S<:AbstractMatrix{<:T}} <: AbstractMatrix{T}

A type to store a Hamiltonian matrix, that is a square matrix for which ``A^+ = -A`` where

```math
A^+ = J_{2n}A^{\mathrm{T}}J_{2n}, \qquad J_{2n} \begin{pmatrix} 0 & I_n\\-I_n & 0 \end{pmatrix},
```

and ``I_n`` denotes the ``n×n``
"""
struct Hamiltonian{T, S <: AbstractMatrix{<:T}} <: AbstractMatrix{T}
    value::S
    function Hamiltonian(A::S) where {T, S <: AbstractMatrix{<:T}}
        n = div(size(A, 1), 2)
        @assert size(A, 1) == 2 * n "The first dimension of A ($(size(A, 1))) is not even"
        @assert size(A, 2) == 2 * n "The matrix A is of size ($(size(A))), which is not square."
        return new{T, S}(A)
    end
end
# Avoid double wrapping / unwrap if that happened
Hamiltonian(A::Hamiltonian) = Hamiltonian(A.value)
# Conversion
function Base.Matrix(A::Hamiltonian)
    return Matrix(A.value)
end

Base.:*(H::Hamiltonian, K::Hamiltonian) = Hamiltonian(H.value * K.value)
Base.:+(H::Hamiltonian, K::Hamiltonian) = Hamiltonian(H.value .+ K.value)
Base.:-(H::Hamiltonian, K::Hamiltonian) = Hamiltonian(H.value .- K.value)

function show(io::IO, A::Hamiltonian)
    return print(io, "Hamiltonian($(A.value))")
end
size(A::Hamiltonian) = size(A.value)

@doc raw"""
    HamiltonianMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)
consisting of (real-valued) hamiltonian matrices of size ``n×n``, i.e. the set

````math
\mathfrak{sp}(2n,𝔽) = \bigl\{p  ∈ 𝔽^{2n×2n}\ \big|\ p^+ = p \bigr\},
````
where ``⋅^{+}`` denotes the [`symplectic_inverse`](@ref), and ``𝔽 ∈ \{ ℝ, ℂ\}``.

Though it is slightly redundant, usually the matrices are stored as ``2n×2n`` arrays.

The symbol ``\mathfak{sp}`` refers to the main usage within `Manifolds.jl` that is the
Lie algebra to the [`SymplecticMatrices`](@ref) interpreted as a Lie group with the
matrix multiplication as group operation.

# Constructor

    HamiltonianMatrices(2n::Int, field::AbstractNumbers=ℝ)

Generate the manifold of ``2n×2n`` Hamiltonian matrices.
"""
struct HamiltonianMatrices{𝔽, T} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function HamiltonianMatrices(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    n % 2 == 0 || throw(ArgumentError("The dimension of the symplectic manifold
                        embedding space must be even. Was odd, n % 2 == $(n % 2)."))
    size = wrap_type_parameter(parameter, (div(n, 2),))
    return HamiltonianMatrices{field, typeof(size)}(size)
end

ManifoldsBase.@default_manifold_fallbacks HamiltonianMatrices Hamiltonian Hamiltonian value value

@doc raw"""
    ^(A::Hamiltonian, ::typeof(+))

Compute the [`symplectic_inverse`](@ref) of a Hamiltonian (A)
"""
function ^(A::Hamiltonian, ::typeof(+))
    return Hamiltonian(symplectic_inverse(A.value))
end
function symplectic_inverse(A::Hamiltonian)
    return Hamiltonian(symplectic_inverse(A.value))
end

@doc raw"""
    check_point(M::HamiltonianMatrices, p; kwargs...)

Check whether `p` is a valid manifold point on the [`HamiltonianMatrices`](@ref) `M`, i.e.
whether `p` [`is_hamiltonian`](@ref).

The tolerance for the test of `p` can be set using `kwargs...`.
"""
function check_point(M::HamiltonianMatrices, p; kwargs...)
    if !is_hamiltonian(p; kwargs...)
        return DomainError(
            norm((Hamiltonian(p)^+).value + p),
            "The point $(p) does not lie on $M, since it is not hamiltonian.",
        )
    end
    return nothing
end

"""
    check_vector(M::HamiltonianMatrices, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`HamiltonianMatrices`](@ref) `M`, i.e. `X` has to be a Hamiltonian matrix
The tolerance for [`is_hamiltonian`](@ref) `X` can be set using `kwargs...`.
"""
function check_vector(M::HamiltonianMatrices, p, X; kwargs...)
    if !is_hamiltonian(X; kwargs...)
        return DomainError(
            norm((Hamiltonian(X)^+).value + X),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not hamiltonian.",
        )
    end
    return nothing
end

embed(::HamiltonianMatrices, p) = p
embed(::HamiltonianMatrices, p, X) = X

function get_embedding(::HamiltonianMatrices{𝔽, TypeParameter{Tuple{N}}}) where {N, 𝔽}
    return Euclidean(2 * N, 2 * N; field = 𝔽)
end
function get_embedding(M::HamiltonianMatrices{𝔽, Tuple{Int}}) where {𝔽}
    N = get_parameter(M.size)[1]
    return Euclidean(2 * N, 2 * N; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::HamiltonianMatrices)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

"""
    is_flat(::HamiltonianMatrices)

Return true. [`HamiltonianMatrices`](@ref) is a flat manifold.
"""
is_flat(M::HamiltonianMatrices) = true

@doc raw"""
    is_hamiltonian(A::AbstractMatrix; kwargs...)

Test whether a matrix `A` is hamiltonian.
The test consists of verifying whether

```math
A^+ = -A
```
where ``A^+`` denotes the [`symplectic_inverse`](@ref) of `A`.

The passed keyword arguments are passed on to `isapprox`
check within
"""
function is_hamiltonian(A::AbstractMatrix; kwargs...)
    return isapprox(symplectic_inverse(A), -A; kwargs...)
end
function is_hamiltonian(A::Hamiltonian; kwargs...)
    return isapprox((A^+).value, -A.value; kwargs...)
end

function Base.show(io::IO, ::HamiltonianMatrices{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "HamiltonianMatrices($(2n), $(𝔽))")
end
function Base.show(io::IO, M::HamiltonianMatrices{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "HamiltonianMatrices($(2n), $(𝔽); parameter=:field)")
end

@doc raw"""
    pX = rand(M::HamiltonianMatrices; σ::Real=1.0, vector_at=nothing)
    rand!(M::HamiltonianMatrices, pX; σ::Real=1.0, vector_at=nothing)

Generate a random Hamiltonian matrix. Since these are a submanifold of ``ℝ^{2n×2n}``,
the same method applies for points and tangent vectors.
This can also be done in-place of `pX`.

The construction is based on generating one normally-distributed
``n×n`` matrix ``A`` and two symmetric ``n×n`` matrices ``B, C`` which are then stacked:

```math
p = \begin{pmatrix} A & B\\ C & -A^{\mathrm{T}} \end{pmatrix}
```

"""
rand(M::HamiltonianMatrices; σ::Real = 1.0)

function rand!(
        rng::AbstractRNG,
        M::HamiltonianMatrices{ℝ},
        pX;
        σ::Real = one(real(eltype(pX))),
        vector_at = nothing,
    )
    n = get_parameter(M.size)[1]
    p1 = @view(pX[1:n, 1:n])
    p2 = @view(pX[1:n, (n + 1):(2n)])
    p3 = @view(pX[(n + 1):(2n), 1:n])
    p4 = @view(pX[(n + 1):(2n), (n + 1):(2n)])
    randn!(rng, p1)
    p4 .= -p1'
    randn!(rng, p2)
    randn!(rng, p3)
    p2 .= (1 / 2) .* (p2 .+ p2')
    p3 .= (1 / 2) .* (p2 .+ p2')
    pX .*= σ
    return pX
end

### A Pluto.jl notebook ###
# v0.19.13

using Markdown
using InteractiveUtils

# This Pluto notebook uses @bind for interactivity. When running this notebook outside of Pluto, the following 'mock version' of @bind gives bound variables a default value (instead of an error).
macro bind(def, element)
    return quote
        local iv = try
            Base.loaded_modules[Base.PkgId(Base.UUID("6e696c72-6542-2067-7265-42206c756150"), "AbstractPlutoDingetjes")].Bonds.initial_value
        catch
            b -> missing
        end
        local el = $(esc(element))
        global $(esc(def)) = Core.applicable(Base.get, el) ? Base.get(el) : iv(el)
        el
    end
end

# ╔═╡ 04e7ac42-4b1b-11ed-1cb3-e76ac86d4203
using Manifolds, RecursiveArrayTools, OrdinaryDiffEq,
    DiffEqCallbacks, BoundaryValueDiffEq, PlutoUI

# ╔═╡ 8159d5bc-2c3f-4657-80c4-661e9162b79d
md"""
# Working in Charts: the embedded Torus

There are two conceptually different approaches to working on a manifold: working in charts and chart-free representations.

The first one, widespread in differential geometry textbooks, is based on defining an atlas on the manifold and performing computations in selected charts. This approach, while generic, is not ideally suitable in all circumstances. For example, working in charts that do not cover the entire manifold causes issues with having to switch charts when operating on a manifold.

The second one is beneficial if there exists a representation of points and tangent vectors for a manifold which allows for efficient closed-form formulas for standard functions like the exponential map or Riemannian distance in this representation. These computations are then chart-free. `Manifolds.jl` supports both approaches, although the chart-free approach is the main focus of the library.

In this tutorial we focus on chart-based computation.
"""

# ╔═╡ b85a56ad-3b74-402d-8fbe-9f0d130253e6
md"""
The manifold we consider is the `M` is the torus in form of the [`EmbeddedTorus`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/torus.html#Manifolds.EmbeddedTorus), that is the representation defined as a surface of revolution of a circle of radius 2 around a circle of radius 3.
The atlas we will perform computations in is its [`DefaultTorusAtlas`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/torus.html#Manifolds.DefaultTorusAtlas) `A`, consisting of a family of charts indexed by two angles, that specify the base point of the chart.

We will draw geodesics time between `0` and `t_end`, and then sample the solution at multiples of `dt` and draw a line connecting sampled points.
"""

# ╔═╡ 27038d25-32b3-433d-ad47-f7ae330fef1c
M = Manifolds.EmbeddedTorus(3, 2)

# ╔═╡ e0c54d00-c698-4ea6-a710-37fc284ed83e
A = Manifolds.DefaultTorusAtlas()

# ╔═╡ f0d60996-ae46-4bfa-8408-b6e28cba1f6b
md"""
## Setup

We will first set up our plot with an empty torus.
`param_points` are points on the surface of the torus that will be used for basic surface shape in Makie.jl.
The torus will be colored according to its Gaussian curvature stored in `gcs`. We later want to have a color scale that has negative curvature blue, zero curvature white and positive curvature red so `gcs_mm` is the largest absolute value of the curvature that will be needed to properly set range of curvature values.
"""

# ╔═╡ 96fcb06e-2517-4c5b-b350-375d1ecb3258
md"""
 In the documentation this tutorial represents a static situation (loading precomputed images). In the Pluto notebook, you can set interactive to true to change the points and tangent vectors in the following example.
"""

# ╔═╡ 87272f4b-f898-4edb-8842-0464ffc4bf01
interactive = false;

# ╔═╡ 0fe4dd5d-9838-4236-8ef9-bfe9afb76ac7
md"""
We also cache the images to reduce the documentation generation time.
If you activate `rendering` the images are saved in non-interactive mode.
"""

# ╔═╡ 9efc27d4-caa0-4e9c-85e6-e9dbdbafbb9c
begin
    localpath = join(splitpath(@__FILE__)[1:(end - 1)], "/") # files folder
    image_prefix = localpath * "/working-in-charts"
    @info image_prefix
    render_images = false
end;

# ╔═╡ 40487cc6-707f-4ca3-b735-6d5f50b07f74
# Only load Makie if necessary
if (interactive || render_images)
    using GLMakie, Makie
    GLMakie.activate!()
end

# ╔═╡ f2276b50-49f4-478f-9a96-0e374a37fe2f
"""
	torus_figure()

This function generates a simple plot of a torus and returns the new figure containing the plot.
"""
function torus_figure()
    fig = Figure(resolution = (1400, 1000), fontsize = 16)
    ax = LScene(fig[1, 1], show_axis = true)
    ϴs, φs = LinRange(-π, π, 50), LinRange(-π, π, 50)
    param_points = [Manifolds._torus_param(M, θ, φ) for θ in ϴs, φ in φs]
    X1, Y1, Z1 = [[p[i] for p in param_points] for i in 1:3]
    gcs = [gaussian_curvature(M, p) for p in param_points]
    gcs_mm = max(abs(minimum(gcs)), abs(maximum(gcs)))
    pltobj = surface!(
        ax,
        X1,
        Y1,
        Z1;
        shading = true,
        ambient = Vec3f(0.65, 0.65, 0.65),
        backlight = 1.0f0,
        color = gcs,
        colormap = Reverse(:RdBu),
        colorrange = (-gcs_mm, gcs_mm),
        transparency = true,
    )
    wireframe!(ax, X1, Y1, Z1; transparency = true, color = :gray, linewidth = 0.5)
    zoom!(ax.scene, cameracontrols(ax.scene), 0.98)
    Colorbar(fig[1, 2], pltobj, height = Relative(0.5), label = "Gaussian curvature")
    return ax, fig
end

# ╔═╡ c18609fe-b510-447f-9d2a-d1e6eb1da3c2
md"""
## (Interactive) Values for the geodesic.

`solve_for` is a helper function that solves a parallel transport along geodesic problem on the torus `M`.
`p0x` is the (ϴ, φ) parametrization of the point from which we will transport the vector.
We first calculate the coordinates in the embedding of `p0x` and store it as `p`, and then get the initial chart from atlas `A` appropriate for starting working at point `p`.
The vector we transport has coordinates `Y_transp` in the induced tangent space basis of chart `i_p0x`.
The function returns the full solution to the parallel transport problem, containing the sequence of charts that was used and solutions of differential equations computed using `OrdinaryDiffEq`.

`bvp_i` is needed later for a different purpose, it is the chart index we will use for solving the logarithmic map boundary value problem in.

Next we solve the vector transport problem `solve_for([θₚ, φₚ], [θₓ, φₓ], [θy, φy])`, sample the result at the selected time steps and store the result in `geo`. The solution includes the geodesic which we extract and convert to a sequence of points digestible by `Makie.jl`, `geo_ps`.
`[θₚ, φₚ]` is the parametrization in chart (0, 0) of the starting point of the geodesic.
The direction of the geodesic is determined by `[θₓ, φₓ]`, coordinates of the tangent vector at the starting point expressed in the induced basis of chart `i_p0x` (which depends on the initial point).
Finally, `[θy, φy]` are the coordinates of the tangent vector that will be transported along the geodesic, which are also expressed in same basis as `[θₓ, φₓ]`.

We won't draw the transported vector at every point as there would be too many arrows, which is why we select every 100th point only for that purpose with `pt_indices`. Then, `geo_ps_pt` contains points at which the transported vector is tangent to and `geo_Ys` the transported vector at that point, represented in the embedding.

The logarithmic map will be solved between points with parametrization `bvp_a1` and `bvp_a2` in chart `bvp_i`.
The result is assigned to variable `bvp_sol` and then sampled with time step 0.05. The result of this sampling is converted from parameters in chart `bvp_i` to point in the embedding and stored in `geo_r`.
"""

# ╔═╡ 2532be0e-6d48-4775-b78f-e48f04e5c3a3
function solve_for(p0x, X_p0x, Y_transp, T)
    p = [Manifolds._torus_param(M, p0x...)...]
    i_p0x = Manifolds.get_chart_index(M, A, p)
    p_exp = Manifolds.solve_chart_parallel_transport_ode(
        M,
        [0.0, 0.0],
        X_p0x,
        A,
        i_p0x,
        Y_transp;
        final_time = T,
    )
    return p_exp
end;

# ╔═╡ 9ee3fbaf-a579-480e-ae33-9d6eb8b07fbc
md"""
### Solving parallel Transport ODE
"""

# ╔═╡ 34cd1003-3790-4db1-bcf8-2e98cf9b98b6
if interactive
    md"""
    We have to determine the 

    * ``t_\mathrm{end}`` $(@bind t_end PlutoUI.Slider(range(0,100,1001), default=2, show_value=true))
    * ``\mathrm{d}t`` $(@bind dt PlutoUI.Slider(range(1e-3,0.5,500), default=1e-1, show_value=true))
    """
else
    t_end = 2.0
    dt = 1.0e-1
    md"""
    We set the ``t_\mathrm{end}`` to $(t_end) and ``\mathrm{d}t`` to $(dt)
    """
end

# ╔═╡ 6db745f9-afa4-4b5a-8871-b58585165c9e
md" And we parametrise the start point and direction"

# ╔═╡ fea185a1-bfae-4bd8-9b2a-f889e54f3f70
if interactive
    md"""
    * start point θₚ $(@bind θₚ PlutoUI.Slider(range(-π,π,200), default=π/10, show_value=false)) | φₚ $(@bind φₚ PlutoUI.Slider(range(-π,π,200), default=-π/4))
    * start direction θₓ $(@bind θₓ PlutoUI.Slider(range(-π,π,200), default=π/2)) | φₓ $(@bind φₓ PlutoUI.Slider(range(-π,π,200), default=0.7))
    * a tangent vector θy $(@bind θy PlutoUI.Slider(range(-π,π,200), default=0.2)) | φy $(@bind φy PlutoUI.Slider(range(-π,π,200), default=-0.1)) to be transported
    """
else
    θₚ = π / 10
    φₚ = -π / 4
    θₓ = π / 2
    φₓ = 0.7
    θy = 0.2
    φy = -0.1
    #
    s = "( $(θₚ), $(φₚ))"
    s2 = "( $(θₓ), $(φₓ))"
    s3 = "$(θy), $(φy))"
    md"""
    We set the start point to
    * (θₚ, φₚ) = $(s)
    * (θₓ, φₓ) = $(s2)
    * (θy, φy) = $(s3).
    """
end

# ╔═╡ c1660206-d21a-4812-9dd3-bda91b633c0b
begin
    geo = solve_for([θₚ, φₚ], [θₓ, φₓ], [θy, φy], t_end)(0.0:dt:t_end)
    geo_ps = [Point3f(s[1]) for s in geo]
    pt_indices = 1:div(length(geo), 10):length(geo)
    geo_ps_pt = [Point3f(s[1]) for s in geo[pt_indices]]
    geo_Ys = [Point3f(s[3]) for s in geo[pt_indices]]
end;

# ╔═╡ a30fa94f-5669-4265-a541-03d16dbd5745
begin
    if render_images || interactive # generate images in these two cases
        ax1, fig1 = torus_figure()
        arrows!(ax1, geo_ps_pt, geo_Ys, linewidth = 0.05, color = :blue)
        lines!(geo_ps; linewidth = 4.0, color = :green)
        (!interactive) && Makie.save(image_prefix * "working-in-charts-transport.png", fig1)
        fig1
    else
        PlutoUI.LocalResource(image_prefix * "/working-in-charts-transport.png")
    end
end

# ╔═╡ a941fd19-faf5-49d0-8f68-ae2fbe45130d
md" ### Solving the logarithmic map ODE"

# ╔═╡ 922461b0-55a0-447b-b59d-cfff7b448858
if interactive

    md"""
    We set
    * start point θ₁ $(@bind θ₁ PlutoUI.Slider(range(-π,π,200), default=π/2)) |  φ₁ $(@bind φ₁ PlutoUI.Slider(range(-π,π,200), default=-1.0))
    * end point θ₂ $(@bind θ₂ PlutoUI.Slider(range(-π,π,200), default=-π/8)) | φ₂ $(@bind φ₂ PlutoUI.Slider(range(-π,π,200), default=π/2))
    """
else
    θ₁ = π / 2
    φ₁ = -1.0
    θ₂ = -π / 8
    φ₂ = π / 2
    s4 = "($(θ₁), $(φ₁))"
    s5 = "($(θ₂), $(φ₂))"
    md"""
    We set
    * (θ₁, φ₁) = $(s4)
    * (θ₂, φ₂) = $(s5)
    """
end

# ╔═╡ 2abef887-32a8-40ba-89e1-b6adbfe9174f
begin
    bvp_i = (0, 0)
    bvp_a1 = [θ₁, φ₁]
    bvp_a2 = [θ₂, φ₂]
    bvp_sol = Manifolds.solve_chart_log_bvp(M, bvp_a1, bvp_a2, A, bvp_i)
    geo_r = [Point3f(get_point(M, A, bvp_i, p[1:2])) for p in bvp_sol(0.0:0.05:1.0)]
end;

# ╔═╡ eea2fbc7-1ba8-49f8-916c-743984abe15d
begin
    if render_images || interactive # generate images in these two cases
        ax2, fig2 = torus_figure()
        lines!(geo_r; linewidth = 4.0, color = :green)
        (!interactive) && Makie.save(image_prefix * "/working-in-charts-geodesic.png", fig2)
        fig2
    else
        PlutoUI.LocalResource(image_prefix * "/working-in-charts-geodesic.png")
    end
end

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
BoundaryValueDiffEq = "764a87c0-6b3e-53db-9096-fe964310641d"
DiffEqCallbacks = "459566f4-90b8-5000-8ac3-15dfb0a30def"
GLMakie = "e9467ef8-e4e7-5192-8a1a-b1aee30e663a"
Makie = "ee78f7c6-11fb-53f2-987a-cfe4a2b5a57a"
Manifolds = "1cead3c2-87b3-11e9-0ccd-23c62b72b94e"
OrdinaryDiffEq = "1dea7af3-3e70-54e6-95c3-0bf5283fa5ed"
PlutoUI = "7f904dfe-b85e-4ff6-b463-dae2292396a8"
RecursiveArrayTools = "731186ca-8d62-57ce-b412-fbd966d074cd"

[compat]
BoundaryValueDiffEq = "~2.9.0"
DiffEqCallbacks = "~2.24.2"
GLMakie = "~0.7.0"
Makie = "~0.18.0"
Manifolds = "~0.8.33"
OrdinaryDiffEq = "~6.28.1"
PlutoUI = "~0.7.44"
RecursiveArrayTools = "~2.32.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.8.1"
manifest_format = "2.0"
project_hash = "968389e9aae83329e6c849c6f597f8623f3782d7"

[[deps.AbstractFFTs]]
deps = ["ChainRulesCore", "LinearAlgebra"]
git-tree-sha1 = "69f7020bd72f069c219b5e8c236c1fa90d2cb409"
uuid = "621f4979-c628-5d54-868e-fcf4e3e8185c"
version = "1.2.1"

[[deps.AbstractPlutoDingetjes]]
deps = ["Pkg"]
git-tree-sha1 = "8eaf9f1b4921132a4cff3f36a1d9ba923b14a481"
uuid = "6e696c72-6542-2067-7265-42206c756150"
version = "1.1.4"

[[deps.AbstractTrees]]
git-tree-sha1 = "5c0b629df8a5566a06f5fef5100b53ea56e465a0"
uuid = "1520ce14-60c1-5f80-bbc7-55ef81b5835c"
version = "0.4.2"

[[deps.Adapt]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "195c5505521008abea5aee4f96930717958eac6f"
uuid = "79e6a3ab-5dfb-504d-930d-738a2a938a0e"
version = "3.4.0"

[[deps.Animations]]
deps = ["Colors"]
git-tree-sha1 = "e81c509d2c8e49592413bfb0bb3b08150056c79d"
uuid = "27a7e980-b3e6-11e9-2bcd-0b925532e340"
version = "0.4.1"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.ArnoldiMethod]]
deps = ["LinearAlgebra", "Random", "StaticArrays"]
git-tree-sha1 = "62e51b39331de8911e4a7ff6f5aaf38a5f4cc0ae"
uuid = "ec485272-7323-5ecc-a04f-4719b315124d"
version = "0.2.0"

[[deps.ArrayInterface]]
deps = ["ArrayInterfaceCore", "Compat", "IfElse", "LinearAlgebra", "Static"]
git-tree-sha1 = "d6173480145eb632d6571c148d94b9d3d773820e"
uuid = "4fba245c-0d91-5ea0-9b3e-6abc04ee57a9"
version = "6.0.23"

[[deps.ArrayInterfaceCore]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "e9f7992287edfc27b3cbe0046c544bace004ca5b"
uuid = "30b0a656-2188-435a-8636-2ec0e6a096e2"
version = "0.1.22"

[[deps.ArrayInterfaceGPUArrays]]
deps = ["Adapt", "ArrayInterfaceCore", "GPUArraysCore", "LinearAlgebra"]
git-tree-sha1 = "fc114f550b93d4c79632c2ada2924635aabfa5ed"
uuid = "6ba088a2-8465-4c0a-af30-387133b534db"
version = "0.2.2"

[[deps.ArrayInterfaceOffsetArrays]]
deps = ["ArrayInterface", "OffsetArrays", "Static"]
git-tree-sha1 = "c49f6bad95a30defff7c637731f00934c7289c50"
uuid = "015c0d05-e682-4f19-8f0a-679ce4c54826"
version = "0.1.6"

[[deps.ArrayInterfaceStaticArrays]]
deps = ["Adapt", "ArrayInterface", "ArrayInterfaceStaticArraysCore", "LinearAlgebra", "Static", "StaticArrays"]
git-tree-sha1 = "efb000a9f643f018d5154e56814e338b5746c560"
uuid = "b0d46f97-bff5-4637-a19a-dd75974142cd"
version = "0.1.4"

[[deps.ArrayInterfaceStaticArraysCore]]
deps = ["Adapt", "ArrayInterfaceCore", "LinearAlgebra", "StaticArraysCore"]
git-tree-sha1 = "93c8ba53d8d26e124a5a8d4ec914c3a16e6a0970"
uuid = "dd5226c6-a4d4-4bc7-8575-46859f9c95b9"
version = "0.1.3"

[[deps.ArrayLayouts]]
deps = ["FillArrays", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "9a8017694c92ca097b23b3b43806be560af4c2ce"
uuid = "4c555306-a7a7-4459-81d9-ec55ddd5c99a"
version = "0.8.12"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.Automa]]
deps = ["Printf", "ScanByte", "TranscodingStreams"]
git-tree-sha1 = "d50976f217489ce799e366d9561d56a98a30d7fe"
uuid = "67c07d97-cdcb-5c2c-af73-a7f9c32a568b"
version = "0.8.2"

[[deps.AxisAlgorithms]]
deps = ["LinearAlgebra", "Random", "SparseArrays", "WoodburyMatrices"]
git-tree-sha1 = "66771c8d21c8ff5e3a93379480a2307ac36863f7"
uuid = "13072b0f-2c55-5437-9ae7-d433b7a33950"
version = "1.0.1"

[[deps.BandedMatrices]]
deps = ["ArrayLayouts", "FillArrays", "LinearAlgebra", "Random", "SparseArrays"]
git-tree-sha1 = "d37d493a1fc680257f424e656da06f4704c4444b"
uuid = "aae01518-5342-5314-be14-df237901396f"
version = "0.17.7"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.BitTwiddlingConvenienceFunctions]]
deps = ["Static"]
git-tree-sha1 = "eaee37f76339077f86679787a71990c4e465477f"
uuid = "62783981-4cbd-42fc-bca8-16325de8dc4b"
version = "0.1.4"

[[deps.BoundaryValueDiffEq]]
deps = ["BandedMatrices", "DiffEqBase", "FiniteDiff", "ForwardDiff", "LinearAlgebra", "NLsolve", "Reexport", "SciMLBase", "SparseArrays"]
git-tree-sha1 = "2f80b70bd3ddd9aa3ec2d77604c1121bd115650e"
uuid = "764a87c0-6b3e-53db-9096-fe964310641d"
version = "2.9.0"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "19a35467a82e236ff51bc17a3a44b69ef35185a2"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+0"

[[deps.CEnum]]
git-tree-sha1 = "eb4cb44a499229b3b8426dcfb5dd85333951ff90"
uuid = "fa961155-64e5-5f13-b03f-caf6b980ea82"
version = "0.4.2"

[[deps.CPUSummary]]
deps = ["CpuId", "IfElse", "Static"]
git-tree-sha1 = "9bdd5aceea9fa109073ace6b430a24839d79315e"
uuid = "2a0fbf3d-bb9c-48f3-b0a9-814d99fd7ab9"
version = "0.1.27"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "4b859a208b2397a7a623a03449e4636bdb17bcf2"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.16.1+1"

[[deps.Calculus]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f641eb0a4f00c343bbc32346e1217b86f3ce9dad"
uuid = "49dc2e85-a5d0-5ad3-a950-438e2897f1b9"
version = "0.5.1"

[[deps.ChainRulesCore]]
deps = ["Compat", "LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "e7ff6cadf743c098e08fca25c91103ee4303c9bb"
uuid = "d360d2e6-b24c-11e9-a2a3-2a2ae2dbcce4"
version = "1.15.6"

[[deps.ChangesOfVariables]]
deps = ["ChainRulesCore", "LinearAlgebra", "Test"]
git-tree-sha1 = "38f7a08f19d8810338d4f5085211c7dfa5d5bdd8"
uuid = "9e997f8a-9a97-42d5-a9f1-ce6bfc15e2c0"
version = "0.1.4"

[[deps.CloseOpenIntervals]]
deps = ["ArrayInterface", "Static"]
git-tree-sha1 = "5522c338564580adf5d58d91e43a55db0fa5fb39"
uuid = "fb6a15b2-703c-40df-9091-08a04967cfa9"
version = "0.1.10"

[[deps.ColorBrewer]]
deps = ["Colors", "JSON", "Test"]
git-tree-sha1 = "61c5334f33d91e570e1d0c3eb5465835242582c4"
uuid = "a2cac450-b92f-5266-8821-25eda20663c8"
version = "0.4.0"

[[deps.ColorSchemes]]
deps = ["ColorTypes", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Random"]
git-tree-sha1 = "1fd869cc3875b57347f7027521f561cf46d1fcd8"
uuid = "35d6a980-a343-548e-a6ea-1d62b119f2f4"
version = "3.19.0"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "eb7f0f8307f71fac7c606984ea5fb2817275d6e4"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.4"

[[deps.ColorVectorSpace]]
deps = ["ColorTypes", "FixedPointNumbers", "LinearAlgebra", "SpecialFunctions", "Statistics", "TensorCore"]
git-tree-sha1 = "d08c20eef1f2cbc6e60fd3612ac4340b89fea322"
uuid = "c3611d14-8923-5661-9e6a-0046d554d3a4"
version = "0.9.9"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "417b0ed7b8b838aa6ca0a87aadf1bb9eb111ce40"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.8"

[[deps.CommonSolve]]
git-tree-sha1 = "332a332c97c7071600984b3c31d9067e1a4e6e25"
uuid = "38540f10-b2f7-11e9-35d8-d573e4eb0ff2"
version = "0.2.1"

[[deps.CommonSubexpressions]]
deps = ["MacroTools", "Test"]
git-tree-sha1 = "7b8a93dba8af7e3b42fecabf646260105ac373f7"
uuid = "bbf7d656-a473-5ed7-a52c-81e309532950"
version = "0.3.0"

[[deps.Compat]]
deps = ["Dates", "LinearAlgebra", "UUIDs"]
git-tree-sha1 = "3ca828fe1b75fa84b021a7860bd039eaea84d2f2"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.3.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "0.5.2+0"

[[deps.ConstructionBase]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "fb21ddd70a051d882a1686a5a550990bbe371a95"
uuid = "187b0558-2788-49d3-abe0-74a17ed4e7c9"
version = "1.4.1"

[[deps.Contour]]
git-tree-sha1 = "d05d9e7b7aedff4e5b51a029dced05cfb6125781"
uuid = "d38c429a-6771-53c6-b99e-75d170b6e991"
version = "0.6.2"

[[deps.CovarianceEstimation]]
deps = ["LinearAlgebra", "Statistics", "StatsBase"]
git-tree-sha1 = "3c8de95b4e932d76ec8960e12d681eba580e9674"
uuid = "587fd27a-f159-11e8-2dae-1979310e6154"
version = "0.2.8"

[[deps.CpuId]]
deps = ["Markdown"]
git-tree-sha1 = "fcbb72b032692610bfbdb15018ac16a36cf2e406"
uuid = "adafc99b-e345-5852-983c-f28acb93d879"
version = "0.3.1"

[[deps.DataAPI]]
git-tree-sha1 = "46d2680e618f8abd007bce0c3026cb0c4a8f2032"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.12.0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DensityInterface]]
deps = ["InverseFunctions", "Test"]
git-tree-sha1 = "80c3e8639e3353e5d2912fb3a1916b8455e2494b"
uuid = "b429d917-457f-4dbc-8f4c-0cc954292b1d"
version = "0.4.0"

[[deps.DiffEqBase]]
deps = ["ArrayInterfaceCore", "ChainRulesCore", "DataStructures", "Distributions", "DocStringExtensions", "FastBroadcast", "ForwardDiff", "FunctionWrappers", "FunctionWrappersWrappers", "LinearAlgebra", "Logging", "MuladdMacro", "NonlinearSolve", "Parameters", "Printf", "RecursiveArrayTools", "Reexport", "Requires", "SciMLBase", "Setfield", "SparseArrays", "Static", "StaticArrays", "Statistics", "Tricks", "ZygoteRules"]
git-tree-sha1 = "c272e6fb3c3558d807886d5247ed2a0b9c6f3823"
uuid = "2b5f629d-d688-5b77-993f-72d75c75574e"
version = "6.105.1"

[[deps.DiffEqCallbacks]]
deps = ["DataStructures", "DiffEqBase", "ForwardDiff", "LinearAlgebra", "Markdown", "NLsolve", "Parameters", "RecipesBase", "RecursiveArrayTools", "SciMLBase", "StaticArrays"]
git-tree-sha1 = "16cecaff5228c6cb22cda8e81aa96442395cdfc5"
uuid = "459566f4-90b8-5000-8ac3-15dfb0a30def"
version = "2.24.2"

[[deps.DiffResults]]
deps = ["StaticArraysCore"]
git-tree-sha1 = "782dd5f4561f5d267313f23853baaaa4c52ea621"
uuid = "163ba53b-c6d8-5494-b064-1a9d43ac40c5"
version = "1.1.0"

[[deps.DiffRules]]
deps = ["IrrationalConstants", "LogExpFunctions", "NaNMath", "Random", "SpecialFunctions"]
git-tree-sha1 = "8b7a4d23e22f5d44883671da70865ca98f2ebf9d"
uuid = "b552c78f-8df3-52c6-915a-8e097449b14b"
version = "1.12.0"

[[deps.Distances]]
deps = ["LinearAlgebra", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "3258d0659f812acde79e8a74b11f17ac06d0ca04"
uuid = "b4f34e82-e78d-54a5-968a-f98e89d6e8f7"
version = "0.10.7"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.Distributions]]
deps = ["ChainRulesCore", "DensityInterface", "FillArrays", "LinearAlgebra", "PDMats", "Printf", "QuadGK", "Random", "SparseArrays", "SpecialFunctions", "Statistics", "StatsBase", "StatsFuns", "Test"]
git-tree-sha1 = "04db820ebcfc1e053bd8cbb8d8bccf0ff3ead3f7"
uuid = "31c24e10-a181-5473-b8eb-7969acd0382f"
version = "0.25.76"

[[deps.DocStringExtensions]]
deps = ["LibGit2"]
git-tree-sha1 = "5158c2b41018c5f7eb1470d558127ac274eca0c9"
uuid = "ffbed154-4ef7-542d-bbb7-c09d3a79fcae"
version = "0.9.1"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.DualNumbers]]
deps = ["Calculus", "NaNMath", "SpecialFunctions"]
git-tree-sha1 = "5837a837389fccf076445fce071c8ddaea35a566"
uuid = "fa6b7ba4-c1ee-5f82-b5fc-ecf0adba8f74"
version = "0.6.8"

[[deps.EarCut_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e3290f2d49e661fbd94046d7e3726ffcb2d41053"
uuid = "5ae413db-bbd1-5e63-b57d-d24a61df00f5"
version = "2.2.4+0"

[[deps.Einsum]]
deps = ["Compat"]
git-tree-sha1 = "4a6b3eee0161c89700b6c1949feae8b851da5494"
uuid = "b7d42ee7-0b51-5a75-98ca-779d3107e4c0"
version = "0.4.1"

[[deps.EnumX]]
git-tree-sha1 = "e5333cd1e1c713ee21d07b6ed8b0d8853fabe650"
uuid = "4e289a0a-7415-4d19-859d-a7e5c4648b56"
version = "1.0.3"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bad72f730e9e91c08d9427d5e8db95478a3c323d"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.4.8+0"

[[deps.ExponentialUtilities]]
deps = ["ArrayInterfaceCore", "GPUArraysCore", "GenericSchur", "LinearAlgebra", "Printf", "SparseArrays", "libblastrampoline_jll"]
git-tree-sha1 = "b19c3f5001b11b71d0f970f354677d604f3a1a97"
uuid = "d4d017d3-3776-5f7e-afef-a10c40355c18"
version = "1.19.0"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.Extents]]
git-tree-sha1 = "5e1e4c53fa39afe63a7d356e30452249365fba99"
uuid = "411431e0-e8b7-467b-b5e0-f676ba4f2910"
version = "0.1.1"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Pkg", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "74faea50c1d007c85837327f6775bea60b5492dd"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.2+2"

[[deps.FFTW]]
deps = ["AbstractFFTs", "FFTW_jll", "LinearAlgebra", "MKL_jll", "Preferences", "Reexport"]
git-tree-sha1 = "90630efff0894f8142308e334473eba54c433549"
uuid = "7a1cc6ca-52ef-59f5-83cd-3a7055c09341"
version = "1.5.0"

[[deps.FFTW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c6033cc3892d0ef5bb9cd29b7f2f0331ea5184ea"
uuid = "f5851436-0d7a-5f13-b9de-f02708fd171a"
version = "3.3.10+0"

[[deps.FastBroadcast]]
deps = ["ArrayInterface", "ArrayInterfaceCore", "LinearAlgebra", "Polyester", "Static", "StrideArraysCore"]
git-tree-sha1 = "21cdeff41e5a1822c2acd7fc7934c5f450588e00"
uuid = "7034ab61-46d4-4ed7-9d0f-46aef9175898"
version = "0.2.1"

[[deps.FastClosures]]
git-tree-sha1 = "acebe244d53ee1b461970f8910c235b259e772ef"
uuid = "9aa1b823-49e4-5ca5-8b0f-3971ec8bab6a"
version = "0.3.2"

[[deps.FastLapackInterface]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "14a6f7a21125f715d935fe8f83560ee833f7d79d"
uuid = "29a986be-02c6-4525-aec4-84b980013641"
version = "1.2.7"

[[deps.FileIO]]
deps = ["Pkg", "Requires", "UUIDs"]
git-tree-sha1 = "7be5f99f7d15578798f338f5433b6c432ea8037b"
uuid = "5789e2e9-d7fb-5bc7-8068-2c6fae9b9549"
version = "1.16.0"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FillArrays]]
deps = ["LinearAlgebra", "Random", "SparseArrays", "Statistics"]
git-tree-sha1 = "802bfc139833d2ba893dd9e62ba1767c88d708ae"
uuid = "1a297f60-69ca-5386-bcde-b61e274b549b"
version = "0.13.5"

[[deps.FiniteDiff]]
deps = ["ArrayInterfaceCore", "LinearAlgebra", "Requires", "Setfield", "SparseArrays", "StaticArrays"]
git-tree-sha1 = "5a2cff9b6b77b33b89f3d97a4d367747adce647e"
uuid = "6a86dc24-6348-571c-b903-95158fe2bd41"
version = "2.15.0"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.ForwardDiff]]
deps = ["CommonSubexpressions", "DiffResults", "DiffRules", "LinearAlgebra", "LogExpFunctions", "NaNMath", "Preferences", "Printf", "Random", "SpecialFunctions", "StaticArrays"]
git-tree-sha1 = "187198a4ed8ccd7b5d99c41b69c679269ea2b2d4"
uuid = "f6369f11-7733-5829-9624-2563aa707210"
version = "0.10.32"

[[deps.FreeType]]
deps = ["CEnum", "FreeType2_jll"]
git-tree-sha1 = "cabd77ab6a6fdff49bfd24af2ebe76e6e018a2b4"
uuid = "b38be410-82b0-50bf-ab77-7b57e271db43"
version = "4.0.0"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "87eb71354d8ec1a96d4a7636bd57a7347dde3ef9"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.10.4+0"

[[deps.FreeTypeAbstraction]]
deps = ["ColorVectorSpace", "Colors", "FreeType", "GeometryBasics"]
git-tree-sha1 = "38a92e40157100e796690421e34a11c107205c86"
uuid = "663a7486-cb36-511b-a19d-713bb74d65c9"
version = "0.10.0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.FunctionWrappers]]
git-tree-sha1 = "d62485945ce5ae9c0c48f124a84998d755bae00e"
uuid = "069b7b12-0de2-55c6-9aab-29f3d0a68a2e"
version = "1.1.3"

[[deps.FunctionWrappersWrappers]]
deps = ["FunctionWrappers"]
git-tree-sha1 = "a5e6e7f12607e90d71b09e6ce2c965e41b337968"
uuid = "77dc65aa-8811-40c2-897b-53d922fa7daf"
version = "0.1.1"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.GLFW]]
deps = ["GLFW_jll"]
git-tree-sha1 = "35dbc482f0967d8dceaa7ce007d16f9064072166"
uuid = "f7f18e0c-5ee9-5ccd-a5bf-e8befd85ed98"
version = "3.4.1"

[[deps.GLFW_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libglvnd_jll", "Pkg", "Xorg_libXcursor_jll", "Xorg_libXi_jll", "Xorg_libXinerama_jll", "Xorg_libXrandr_jll"]
git-tree-sha1 = "d972031d28c8c8d9d7b41a536ad7bb0c2579caca"
uuid = "0656b61e-2033-5cc2-a64a-77c0f6c09b89"
version = "3.3.8+0"

[[deps.GLMakie]]
deps = ["ColorTypes", "Colors", "FileIO", "FixedPointNumbers", "FreeTypeAbstraction", "GLFW", "GeometryBasics", "LinearAlgebra", "Makie", "Markdown", "MeshIO", "ModernGL", "Observables", "Printf", "Serialization", "ShaderAbstractions", "SnoopPrecompile", "StaticArrays"]
git-tree-sha1 = "88313da2862d1737d0cd6fcb84ec5553f33e15e2"
uuid = "e9467ef8-e4e7-5192-8a1a-b1aee30e663a"
version = "0.7.0"

[[deps.GPUArraysCore]]
deps = ["Adapt"]
git-tree-sha1 = "6872f5ec8fd1a38880f027a26739d42dcda6691f"
uuid = "46192b85-c4d5-4398-a991-12ede77f4527"
version = "0.1.2"

[[deps.GenericSchur]]
deps = ["LinearAlgebra", "Printf"]
git-tree-sha1 = "fb69b2a645fa69ba5f474af09221b9308b160ce6"
uuid = "c145ed77-6b09-5dd9-b285-bf645a82121e"
version = "0.5.3"

[[deps.GeoInterface]]
deps = ["Extents"]
git-tree-sha1 = "fb28b5dc239d0174d7297310ef7b84a11804dfab"
uuid = "cf35fbd7-0cd7-5166-be24-54bfbe79505f"
version = "1.0.1"

[[deps.GeometryBasics]]
deps = ["EarCut_jll", "GeoInterface", "IterTools", "LinearAlgebra", "StaticArrays", "StructArrays", "Tables"]
git-tree-sha1 = "12a584db96f1d460421d5fb8860822971cdb8455"
uuid = "5c1252a2-5f33-56bf-86c9-59e7332b4326"
version = "0.4.4"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "fb83fbe02fe57f2c068013aa94bcdf6760d3a7a7"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.74.0+1"

[[deps.Graphics]]
deps = ["Colors", "LinearAlgebra", "NaNMath"]
git-tree-sha1 = "d61890399bc535850c4bf08e4e0d3a7ad0f21cbd"
uuid = "a2bd30eb-e257-5431-a919-1863eab51364"
version = "1.1.2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.Graphs]]
deps = ["ArnoldiMethod", "Compat", "DataStructures", "Distributed", "Inflate", "LinearAlgebra", "Random", "SharedArrays", "SimpleTraits", "SparseArrays", "Statistics"]
git-tree-sha1 = "ba2d094a88b6b287bd25cfa86f301e7693ffae2f"
uuid = "86223c79-3864-5bf0-83f7-82e725a168b6"
version = "1.7.4"

[[deps.GridLayoutBase]]
deps = ["GeometryBasics", "InteractiveUtils", "Observables"]
git-tree-sha1 = "678d136003ed5bceaab05cf64519e3f956ffa4ba"
uuid = "3955a311-db13-416c-9275-1d80ed98e5e9"
version = "0.9.1"

[[deps.Grisu]]
git-tree-sha1 = "53bb909d1151e57e2484c3d1b53e19552b887fb2"
uuid = "42e2da0e-8278-4e71-bc24-59509adca0fe"
version = "1.0.2"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.HostCPUFeatures]]
deps = ["BitTwiddlingConvenienceFunctions", "IfElse", "Libdl", "Static"]
git-tree-sha1 = "b7b88a4716ac33fe31d6556c02fc60017594343c"
uuid = "3e5b6fbb-0976-4d2c-9146-d79de83f2fb0"
version = "0.1.8"

[[deps.HybridArrays]]
deps = ["LinearAlgebra", "Requires", "StaticArrays"]
git-tree-sha1 = "0de633a951f8b5bd32febc373588517aa9f2f482"
uuid = "1baab800-613f-4b0a-84e4-9cd3431bfbb9"
version = "0.4.13"

[[deps.HypergeometricFunctions]]
deps = ["DualNumbers", "LinearAlgebra", "OpenLibm_jll", "SpecialFunctions", "Test"]
git-tree-sha1 = "709d864e3ed6e3545230601f94e11ebc65994641"
uuid = "34004b35-14d8-5ef3-9330-4cdb6864b03a"
version = "0.3.11"

[[deps.Hyperscript]]
deps = ["Test"]
git-tree-sha1 = "8d511d5b81240fc8e6802386302675bdf47737b9"
uuid = "47d2ed2b-36de-50cf-bf87-49c2cf4b8b91"
version = "0.0.4"

[[deps.HypertextLiteral]]
deps = ["Tricks"]
git-tree-sha1 = "c47c5fa4c5308f27ccaac35504858d8914e102f9"
uuid = "ac1192a8-f4b3-4bfe-ba22-af5b92cd3ab2"
version = "0.9.4"

[[deps.IOCapture]]
deps = ["Logging", "Random"]
git-tree-sha1 = "f7be53659ab06ddc986428d3a9dcc95f6fa6705a"
uuid = "b5f81e59-6552-4d32-b1f0-c071b021bf89"
version = "0.2.2"

[[deps.IfElse]]
git-tree-sha1 = "debdd00ffef04665ccbb3e150747a77560e8fad1"
uuid = "615f187c-cbe4-4ef1-ba3b-2fcf58d6d173"
version = "0.1.1"

[[deps.ImageCore]]
deps = ["AbstractFFTs", "ColorVectorSpace", "Colors", "FixedPointNumbers", "Graphics", "MappedArrays", "MosaicViews", "OffsetArrays", "PaddedViews", "Reexport"]
git-tree-sha1 = "acf614720ef026d38400b3817614c45882d75500"
uuid = "a09fc81d-aa75-5fe9-8630-4744c3626534"
version = "0.9.4"

[[deps.ImageIO]]
deps = ["FileIO", "IndirectArrays", "JpegTurbo", "LazyModules", "Netpbm", "OpenEXR", "PNGFiles", "QOI", "Sixel", "TiffImages", "UUIDs"]
git-tree-sha1 = "342f789fd041a55166764c351da1710db97ce0e0"
uuid = "82e4d734-157c-48bb-816b-45c225c6df19"
version = "0.6.6"

[[deps.Imath_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "87f7662e03a649cffa2e05bf19c303e168732d3e"
uuid = "905a6f67-0a94-5f89-b386-d35d92009cd1"
version = "3.1.2+0"

[[deps.IndirectArrays]]
git-tree-sha1 = "012e604e1c7458645cb8b436f8fba789a51b257f"
uuid = "9b13fd28-a010-5f03-acff-a1bbcff69959"
version = "1.0.0"

[[deps.Inflate]]
git-tree-sha1 = "5cd07aab533df5170988219191dfad0519391428"
uuid = "d25df0c9-e2be-5dd7-82c8-3ad0b3e990b9"
version = "0.1.3"

[[deps.IntelOpenMP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "d979e54b71da82f3a65b62553da4fc3d18c9004c"
uuid = "1d5cc7b8-4909-519e-a0f8-d0f5ad9712d0"
version = "2018.0.3+2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.Interpolations]]
deps = ["Adapt", "AxisAlgorithms", "ChainRulesCore", "LinearAlgebra", "OffsetArrays", "Random", "Ratios", "Requires", "SharedArrays", "SparseArrays", "StaticArrays", "WoodburyMatrices"]
git-tree-sha1 = "842dd89a6cb75e02e85fdd75c760cdc43f5d6863"
uuid = "a98d9a8b-a2ab-59e6-89dd-64a1c18fca59"
version = "0.14.6"

[[deps.IntervalSets]]
deps = ["Dates", "Random", "Statistics"]
git-tree-sha1 = "3f91cd3f56ea48d4d2a75c2a65455c5fc74fa347"
uuid = "8197267c-284f-5f27-9208-e0e47529a953"
version = "0.7.3"

[[deps.InverseFunctions]]
deps = ["Test"]
git-tree-sha1 = "49510dfcb407e572524ba94aeae2fced1f3feb0f"
uuid = "3587e190-3f89-42d0-90ee-14403ec27112"
version = "0.1.8"

[[deps.IrrationalConstants]]
git-tree-sha1 = "7fd44fd4ff43fc60815f8e764c0f352b83c49151"
uuid = "92d709cd-6900-40b7-9082-c6be49f344b6"
version = "0.1.1"

[[deps.Isoband]]
deps = ["isoband_jll"]
git-tree-sha1 = "f9b6d97355599074dc867318950adaa6f9946137"
uuid = "f1662d9f-8043-43de-a69a-05efc1cc6ff4"
version = "0.1.1"

[[deps.IterTools]]
git-tree-sha1 = "fa6287a4469f5e048d763df38279ee729fbd44e5"
uuid = "c8e1da08-722c-5040-9ed9-7db0dc04731e"
version = "1.4.0"

[[deps.IterativeSolvers]]
deps = ["LinearAlgebra", "Printf", "Random", "RecipesBase", "SparseArrays"]
git-tree-sha1 = "1169632f425f79429f245113b775a0e3d121457c"
uuid = "42fd0dbc-a981-5370-80f2-aaf504508153"
version = "0.9.2"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JLLWrappers]]
deps = ["Preferences"]
git-tree-sha1 = "abc9885a7ca2052a736a600f7fa66209f96506e1"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.4.1"

[[deps.JSON]]
deps = ["Dates", "Mmap", "Parsers", "Unicode"]
git-tree-sha1 = "3c837543ddb02250ef42f4738347454f95079d4e"
uuid = "682c06a0-de6a-54ab-a142-c8b1cf79cde6"
version = "0.21.3"

[[deps.JpegTurbo]]
deps = ["CEnum", "FileIO", "ImageCore", "JpegTurbo_jll", "TOML"]
git-tree-sha1 = "a77b273f1ddec645d1b7c4fd5fb98c8f90ad10a5"
uuid = "b835a17e-a41a-41e7-81f0-2f016b05efe0"
version = "0.1.1"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b53380851c6e6664204efb2e62cd24fa5c47e4ba"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "2.1.2+0"

[[deps.KLU]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse_jll"]
git-tree-sha1 = "cae5e3dfd89b209e01bcd65b3a25e74462c67ee0"
uuid = "ef3ab10e-7fda-4108-b977-705223b18434"
version = "0.3.0"

[[deps.KernelDensity]]
deps = ["Distributions", "DocStringExtensions", "FFTW", "Interpolations", "StatsBase"]
git-tree-sha1 = "9816b296736292a80b9a3200eb7fbb57aaa3917a"
uuid = "5ab0869b-81aa-558d-bb23-cbf5423bbe9b"
version = "0.6.5"

[[deps.Kronecker]]
deps = ["LinearAlgebra", "NamedDims", "SparseArrays", "StatsBase"]
git-tree-sha1 = "78d9909daf659c901ae6c7b9de7861ba45a743f4"
uuid = "2c470bb0-bcc8-11e8-3dad-c9649493f05e"
version = "0.5.3"

[[deps.Krylov]]
deps = ["LinearAlgebra", "Printf", "SparseArrays"]
git-tree-sha1 = "92256444f81fb094ff5aa742ed10835a621aef75"
uuid = "ba0b0d4f-ebba-5204-a429-3ac8c609bfb7"
version = "0.8.4"

[[deps.KrylovKit]]
deps = ["LinearAlgebra", "Printf"]
git-tree-sha1 = "49b0c1dd5c292870577b8f58c51072bd558febb9"
uuid = "0b1a1467-8014-51b9-945f-bf0ae24f4b77"
version = "0.5.4"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LaTeXStrings]]
git-tree-sha1 = "f2355693d6778a178ade15952b7ac47a4ff97996"
uuid = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
version = "1.3.0"

[[deps.LayoutPointers]]
deps = ["ArrayInterface", "ArrayInterfaceOffsetArrays", "ArrayInterfaceStaticArrays", "LinearAlgebra", "ManualMemory", "SIMDTypes", "Static"]
git-tree-sha1 = "73e2e40eb02d6ccd191a8a9f8cee20db8d5df010"
uuid = "10f19ff3-798f-405d-979b-55457f8fc047"
version = "0.1.11"

[[deps.LazyArtifacts]]
deps = ["Artifacts", "Pkg"]
uuid = "4af54fe1-eca0-43a8-85a7-787d91b784e3"

[[deps.LazyModules]]
git-tree-sha1 = "a560dd966b386ac9ae60bdd3a3d3a326062d3c3e"
uuid = "8cdb02fc-e678-4876-92c5-9defec4f444e"
version = "0.3.1"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.3"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "7.84.0+0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.10.2+0"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll", "Pkg"]
git-tree-sha1 = "64613c82a59c120435c067c2b809fc61cf5166ae"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.7+0"

[[deps.Libglvnd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll", "Xorg_libXext_jll"]
git-tree-sha1 = "7739f837d6447403596a75d19ed01fd08d6f56bf"
uuid = "7e76a0d4-f3c7-5321-8279-8d96eeed0f29"
version = "1.3.0+3"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "42b62845d70a619f063a7da093d995ec8e15e778"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.16.1+1"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9c30530bf0effd46e15e0fdcf2b8636e78cbbd73"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.35.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "7f3efec06033682db852f8b3bc3c1d2b0a0ab066"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.36.0+0"

[[deps.LineSearches]]
deps = ["LinearAlgebra", "NLSolversBase", "NaNMath", "Parameters", "Printf"]
git-tree-sha1 = "7bbea35cec17305fc70a0e5b4641477dc0789d9d"
uuid = "d3d80556-e9d4-5f37-9878-2ab0fcc64255"
version = "7.2.0"

[[deps.LinearAlgebra]]
deps = ["Libdl", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.LinearMaps]]
deps = ["LinearAlgebra", "SparseArrays", "Statistics"]
git-tree-sha1 = "d1b46faefb7c2f48fdec69e6f3cc34857769bc15"
uuid = "7a12625a-238d-50fd-b39a-03d52299707e"
version = "3.8.0"

[[deps.LinearSolve]]
deps = ["ArrayInterfaceCore", "DocStringExtensions", "FastLapackInterface", "GPUArraysCore", "IterativeSolvers", "KLU", "Krylov", "KrylovKit", "LinearAlgebra", "RecursiveFactorization", "Reexport", "SciMLBase", "Setfield", "SnoopPrecompile", "SparseArrays", "SuiteSparse", "UnPack"]
git-tree-sha1 = "70db49cbaec1cdf4def39c4ac51a3abe56b2e421"
uuid = "7ed4a6bd-45f5-4d41-b270-4a48e9bafcae"
version = "1.27.0"

[[deps.LogExpFunctions]]
deps = ["ChainRulesCore", "ChangesOfVariables", "DocStringExtensions", "InverseFunctions", "IrrationalConstants", "LinearAlgebra"]
git-tree-sha1 = "94d9c52ca447e23eac0c0f074effbcd38830deb5"
uuid = "2ab3a3ac-af41-5b50-aa03-7779005ae688"
version = "0.3.18"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.LoopVectorization]]
deps = ["ArrayInterface", "ArrayInterfaceCore", "ArrayInterfaceOffsetArrays", "ArrayInterfaceStaticArrays", "CPUSummary", "ChainRulesCore", "CloseOpenIntervals", "DocStringExtensions", "ForwardDiff", "HostCPUFeatures", "IfElse", "LayoutPointers", "LinearAlgebra", "OffsetArrays", "PolyesterWeave", "SIMDDualNumbers", "SIMDTypes", "SLEEFPirates", "SnoopPrecompile", "SpecialFunctions", "Static", "ThreadingUtilities", "UnPack", "VectorizationBase"]
git-tree-sha1 = "4fd7d87ed1d95320c2a3da0d1738dae54441c0b1"
uuid = "bdcacae8-1622-11e9-2a5c-532679323890"
version = "0.12.135"

[[deps.MIMEs]]
git-tree-sha1 = "65f28ad4b594aebe22157d6fac869786a255b7eb"
uuid = "6c6e2e6c-3030-632d-7369-2d6c69616d65"
version = "0.1.4"

[[deps.MKL_jll]]
deps = ["Artifacts", "IntelOpenMP_jll", "JLLWrappers", "LazyArtifacts", "Libdl", "Pkg"]
git-tree-sha1 = "2ce8695e1e699b68702c03402672a69f54b8aca9"
uuid = "856f044c-d86e-5d09-b602-aeab76dc8ba7"
version = "2022.2.0+0"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "42324d08725e200c23d4dfb549e0d5d89dede2d2"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.10"

[[deps.Makie]]
deps = ["Animations", "Base64", "ColorBrewer", "ColorSchemes", "ColorTypes", "Colors", "Contour", "Distributions", "DocStringExtensions", "FFMPEG", "FileIO", "FixedPointNumbers", "Formatting", "FreeType", "FreeTypeAbstraction", "GeometryBasics", "GridLayoutBase", "ImageIO", "InteractiveUtils", "IntervalSets", "Isoband", "KernelDensity", "LaTeXStrings", "LinearAlgebra", "MakieCore", "Markdown", "Match", "MathTeXEngine", "MiniQhull", "Observables", "OffsetArrays", "Packing", "PlotUtils", "PolygonOps", "Printf", "Random", "RelocatableFolders", "Serialization", "Showoff", "SignedDistanceFields", "SnoopPrecompile", "SparseArrays", "Statistics", "StatsBase", "StatsFuns", "StructArrays", "TriplotBase", "UnicodeFun"]
git-tree-sha1 = "51e40869d076fbff25ab61d0aa3e198d80176c75"
uuid = "ee78f7c6-11fb-53f2-987a-cfe4a2b5a57a"
version = "0.18.0"

[[deps.MakieCore]]
deps = ["Observables"]
git-tree-sha1 = "b87650f61f85fc2d4fb5923a479dbf05ba65ae4d"
uuid = "20f20a25-4f0e-4fdf-b5d1-57303727442b"
version = "0.5.0"

[[deps.Manifolds]]
deps = ["Colors", "Distributions", "Einsum", "Graphs", "HybridArrays", "Kronecker", "LinearAlgebra", "ManifoldsBase", "Markdown", "MatrixEquations", "Quaternions", "Random", "RecipesBase", "RecursiveArrayTools", "Requires", "SimpleWeightedGraphs", "SpecialFunctions", "StaticArrays", "Statistics", "StatsBase"]
git-tree-sha1 = "d569c649333e42aa8e2bb40a050b7fd842ec255e"
uuid = "1cead3c2-87b3-11e9-0ccd-23c62b72b94e"
version = "0.8.35"

[[deps.ManifoldsBase]]
deps = ["LinearAlgebra", "Markdown"]
git-tree-sha1 = "9e2772a950c5b5a6ac47fd2480b8b47be66b93cd"
uuid = "3362f125-f0bb-47a3-aa74-596ffd7ef2fb"
version = "0.13.22"

[[deps.ManualMemory]]
git-tree-sha1 = "bcaef4fc7a0cfe2cba636d84cda54b5e4e4ca3cd"
uuid = "d125e4d3-2237-4719-b19c-fa641b8a4667"
version = "0.1.8"

[[deps.MappedArrays]]
git-tree-sha1 = "e8b359ef06ec72e8c030463fe02efe5527ee5142"
uuid = "dbb5928d-eab1-5f90-85c2-b9b0edb7c900"
version = "0.4.1"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.Match]]
git-tree-sha1 = "1d9bc5c1a6e7ee24effb93f175c9342f9154d97f"
uuid = "7eb4fadd-790c-5f42-8a69-bfa0b872bfbf"
version = "1.2.0"

[[deps.MathTeXEngine]]
deps = ["AbstractTrees", "Automa", "DataStructures", "FreeTypeAbstraction", "GeometryBasics", "LaTeXStrings", "REPL", "RelocatableFolders", "Test", "UnicodeFun"]
git-tree-sha1 = "7f837e1884f1ef84984c919fc7a00638cff1e6d1"
uuid = "0a4f8689-d25c-4efe-a92b-7142dfc1aa53"
version = "0.5.3"

[[deps.MatrixEquations]]
deps = ["LinearAlgebra", "LinearMaps"]
git-tree-sha1 = "3b284e9c98f645232f9cf07d4118093801729d43"
uuid = "99c1a7ee-ab34-5fd5-8076-27c950a045f4"
version = "2.2.2"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.0+0"

[[deps.MeshIO]]
deps = ["ColorTypes", "FileIO", "GeometryBasics", "Printf"]
git-tree-sha1 = "8be09d84a2d597c7c0c34d7d604c039c9763e48c"
uuid = "7269a6da-0436-5bbc-96c2-40638cbb6118"
version = "0.4.10"

[[deps.MiniQhull]]
deps = ["QhullMiniWrapper_jll"]
git-tree-sha1 = "9dc837d180ee49eeb7c8b77bb1c860452634b0d1"
uuid = "978d7f02-9e05-4691-894f-ae31a51d76ca"
version = "0.4.0"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "bf210ce90b6c9eed32d25dbcae1ebc565df2687f"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.0.2"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.ModernGL]]
deps = ["Libdl"]
git-tree-sha1 = "713fd24142921db94e5f7d7961f9ee033c6573d5"
uuid = "66fc600b-dfda-50eb-8b99-91cfa97b1301"
version = "1.1.5"

[[deps.MosaicViews]]
deps = ["MappedArrays", "OffsetArrays", "PaddedViews", "StackViews"]
git-tree-sha1 = "b34e3bc3ca7c94914418637cb10cc4d1d80d877d"
uuid = "e94cdb99-869f-56ef-bcf0-1ae2bcbe0389"
version = "0.3.3"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2022.2.1"

[[deps.MuladdMacro]]
git-tree-sha1 = "c6190f9a7fc5d9d5915ab29f2134421b12d24a68"
uuid = "46d2c3a1-f734-5fdb-9937-b9b9aeba4221"
version = "0.2.2"

[[deps.NLSolversBase]]
deps = ["DiffResults", "Distributed", "FiniteDiff", "ForwardDiff"]
git-tree-sha1 = "50310f934e55e5ca3912fb941dec199b49ca9b68"
uuid = "d41bc354-129a-5804-8e4c-c37616107c6c"
version = "7.8.2"

[[deps.NLsolve]]
deps = ["Distances", "LineSearches", "LinearAlgebra", "NLSolversBase", "Printf", "Reexport"]
git-tree-sha1 = "019f12e9a1a7880459d0173c182e6a99365d7ac1"
uuid = "2774e3e8-f4cf-5e23-947b-6d7e65073b56"
version = "4.5.1"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "a7c3d1da1189a1c2fe843a3bfa04d18d20eb3211"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.1"

[[deps.NamedDims]]
deps = ["AbstractFFTs", "ChainRulesCore", "CovarianceEstimation", "LinearAlgebra", "Pkg", "Requires", "Statistics"]
git-tree-sha1 = "cb8ebcee2b4e07b72befb9def593baef8aa12f07"
uuid = "356022a1-0364-5f58-8944-0da4b18d706f"
version = "0.2.50"

[[deps.Netpbm]]
deps = ["FileIO", "ImageCore"]
git-tree-sha1 = "18efc06f6ec36a8b801b23f076e3c6ac7c3bf153"
uuid = "f09324ee-3d7c-5217-9330-fc30815ba969"
version = "1.0.2"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.NonlinearSolve]]
deps = ["ArrayInterfaceCore", "FiniteDiff", "ForwardDiff", "IterativeSolvers", "LinearAlgebra", "RecursiveArrayTools", "RecursiveFactorization", "Reexport", "SciMLBase", "Setfield", "StaticArrays", "UnPack"]
git-tree-sha1 = "a754a21521c0ab48d37f44bbac1eefd1387bdcfc"
uuid = "8913a72c-1f9b-4ce2-8d82-65094dcecaec"
version = "0.3.22"

[[deps.Observables]]
git-tree-sha1 = "5a9ea4b9430d511980c01e9f7173739595bbd335"
uuid = "510215fc-4207-5dde-b226-833fc4488ee2"
version = "0.5.2"

[[deps.OffsetArrays]]
deps = ["Adapt"]
git-tree-sha1 = "f71d8950b724e9ff6110fc948dff5a329f901d64"
uuid = "6fe1bfb0-de20-5000-8ca7-80f57d26f881"
version = "1.12.8"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.20+0"

[[deps.OpenEXR]]
deps = ["Colors", "FileIO", "OpenEXR_jll"]
git-tree-sha1 = "327f53360fdb54df7ecd01e96ef1983536d1e633"
uuid = "52e1d378-f018-4a11-a4be-720524705ac7"
version = "0.3.2"

[[deps.OpenEXR_jll]]
deps = ["Artifacts", "Imath_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "923319661e9a22712f24596ce81c54fc0366f304"
uuid = "18a262bb-aa17-5467-a713-aee519bc75cb"
version = "3.1.1+0"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+0"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e60321e3f2616584ff98f0a4f18d98ae6f89bbb3"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "1.1.17+0"

[[deps.OpenSpecFun_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "13652491f6856acfd2db29360e1bbcd4565d04f1"
uuid = "efe28fd5-8261-553b-a9e1-b2916fc3738e"
version = "0.5.5+0"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.OrdinaryDiffEq]]
deps = ["Adapt", "ArrayInterface", "ArrayInterfaceGPUArrays", "ArrayInterfaceStaticArrays", "DataStructures", "DiffEqBase", "DocStringExtensions", "ExponentialUtilities", "FastBroadcast", "FastClosures", "FiniteDiff", "ForwardDiff", "FunctionWrappersWrappers", "LinearAlgebra", "LinearSolve", "Logging", "LoopVectorization", "MacroTools", "MuladdMacro", "NLsolve", "NonlinearSolve", "Polyester", "PreallocationTools", "Preferences", "RecursiveArrayTools", "Reexport", "SciMLBase", "SnoopPrecompile", "SparseArrays", "SparseDiffTools", "StaticArrays", "UnPack"]
git-tree-sha1 = "33a819c1355faeccc68d57a3c7d7c871680d49f2"
uuid = "1dea7af3-3e70-54e6-95c3-0bf5283fa5ed"
version = "6.28.1"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.40.0+0"

[[deps.PDMats]]
deps = ["LinearAlgebra", "SparseArrays", "SuiteSparse"]
git-tree-sha1 = "cf494dca75a69712a72b80bc48f59dcf3dea63ec"
uuid = "90014a1f-27ba-587c-ab20-58faa44d9150"
version = "0.11.16"

[[deps.PNGFiles]]
deps = ["Base64", "CEnum", "ImageCore", "IndirectArrays", "OffsetArrays", "libpng_jll"]
git-tree-sha1 = "f809158b27eba0c18c269cf2a2be6ed751d3e81d"
uuid = "f57f5aa1-a3ce-4bc8-8ab9-96f992907883"
version = "0.3.17"

[[deps.Packing]]
deps = ["GeometryBasics"]
git-tree-sha1 = "1155f6f937fa2b94104162f01fa400e192e4272f"
uuid = "19eb6ba3-879d-56ad-ad62-d5c202156566"
version = "0.4.2"

[[deps.PaddedViews]]
deps = ["OffsetArrays"]
git-tree-sha1 = "03a7a85b76381a3d04c7a1656039197e70eda03d"
uuid = "5432bcbf-9aad-5242-b902-cca2824c8663"
version = "0.5.11"

[[deps.Parameters]]
deps = ["OrderedCollections", "UnPack"]
git-tree-sha1 = "34c0e9ad262e5f7fc75b10a9952ca7692cfc5fbe"
uuid = "d96e819e-fc66-5662-9728-84c9c7592b0a"
version = "0.12.3"

[[deps.Parsers]]
deps = ["Dates"]
git-tree-sha1 = "6c01a9b494f6d2a9fc180a08b182fcb06f0958a0"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.4.2"

[[deps.Pixman_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "b4f5d02549a10e20780a24fce72bea96b6329e29"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.40.1+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.8.0"

[[deps.PkgVersion]]
deps = ["Pkg"]
git-tree-sha1 = "f6cf8e7944e50901594838951729a1861e668cb8"
uuid = "eebad327-c553-4316-9ea0-9fa01ccd7688"
version = "0.3.2"

[[deps.PlotUtils]]
deps = ["ColorSchemes", "Colors", "Dates", "Printf", "Random", "Reexport", "SnoopPrecompile", "Statistics"]
git-tree-sha1 = "21303256d239f6b484977314674aef4bb1fe4420"
uuid = "995b91a9-d308-5afd-9ec6-746e21dbc043"
version = "1.3.1"

[[deps.PlutoUI]]
deps = ["AbstractPlutoDingetjes", "Base64", "ColorTypes", "Dates", "FixedPointNumbers", "Hyperscript", "HypertextLiteral", "IOCapture", "InteractiveUtils", "JSON", "Logging", "MIMEs", "Markdown", "Random", "Reexport", "URIs", "UUIDs"]
git-tree-sha1 = "47a31ed1dd7d30173cb78f5066860eea2d4eaf7b"
uuid = "7f904dfe-b85e-4ff6-b463-dae2292396a8"
version = "0.7.46"

[[deps.Polyester]]
deps = ["ArrayInterface", "BitTwiddlingConvenienceFunctions", "CPUSummary", "IfElse", "ManualMemory", "PolyesterWeave", "Requires", "Static", "StrideArraysCore", "ThreadingUtilities"]
git-tree-sha1 = "cb2ede4b9cc432c1cba4d4452a62ae1d2a4141bb"
uuid = "f517fe37-dbe3-4b94-8317-1923a5111588"
version = "0.6.16"

[[deps.PolyesterWeave]]
deps = ["BitTwiddlingConvenienceFunctions", "CPUSummary", "IfElse", "Static", "ThreadingUtilities"]
git-tree-sha1 = "b42fb2292fbbaed36f25d33a15c8cc0b4f287fcf"
uuid = "1d0040c9-8b98-4ee7-8388-3f51789ca0ad"
version = "0.1.10"

[[deps.PolygonOps]]
git-tree-sha1 = "77b3d3605fc1cd0b42d95eba87dfcd2bf67d5ff6"
uuid = "647866c9-e3ac-4575-94e7-e3d426903924"
version = "0.1.2"

[[deps.PreallocationTools]]
deps = ["Adapt", "ArrayInterfaceCore", "ForwardDiff"]
git-tree-sha1 = "3953d18698157e1d27a51678c89c88d53e071a42"
uuid = "d236fae5-4411-538c-8e31-a6e3d9e00b46"
version = "0.4.4"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "47e5f437cc0e7ef2ce8406ce1e7e24d44915f88d"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.3.0"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.ProgressMeter]]
deps = ["Distributed", "Printf"]
git-tree-sha1 = "d7a7aef8f8f2d537104f170139553b14dfe39fe9"
uuid = "92933f4c-e287-5a05-a399-4b506db050ca"
version = "1.7.2"

[[deps.QOI]]
deps = ["ColorTypes", "FileIO", "FixedPointNumbers"]
git-tree-sha1 = "18e8f4d1426e965c7b532ddd260599e1510d26ce"
uuid = "4b34888f-f399-49d4-9bb3-47ed5cae4e65"
version = "1.0.0"

[[deps.QhullMiniWrapper_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Qhull_jll"]
git-tree-sha1 = "607cf73c03f8a9f83b36db0b86a3a9c14179621f"
uuid = "460c41e3-6112-5d7f-b78c-b6823adb3f2d"
version = "1.0.0+1"

[[deps.Qhull_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "695c3049ad94fa38b7f1e8243cdcee27ecad0867"
uuid = "784f63db-0788-585a-bace-daefebcd302b"
version = "8.0.1000+0"

[[deps.QuadGK]]
deps = ["DataStructures", "LinearAlgebra"]
git-tree-sha1 = "3c009334f45dfd546a16a57960a821a1a023d241"
uuid = "1fd47b50-473d-5c70-9696-f719f8f3bcdc"
version = "2.5.0"

[[deps.Quaternions]]
deps = ["LinearAlgebra", "Random"]
git-tree-sha1 = "fd78cbfa5f5be5f81a482908f8ccfad611dca9a9"
uuid = "94ee1d12-ae83-5a48-8b1c-48b8ff168ae0"
version = "0.6.0"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.Ratios]]
deps = ["Requires"]
git-tree-sha1 = "dc84268fe0e3335a62e315a3a7cf2afa7178a734"
uuid = "c84ed2f1-dad5-54f0-aa8e-dbefe2724439"
version = "0.4.3"

[[deps.RecipesBase]]
deps = ["SnoopPrecompile"]
git-tree-sha1 = "d12e612bba40d189cead6ff857ddb67bd2e6a387"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.3.1"

[[deps.RecursiveArrayTools]]
deps = ["Adapt", "ArrayInterfaceCore", "ArrayInterfaceStaticArraysCore", "ChainRulesCore", "DocStringExtensions", "FillArrays", "GPUArraysCore", "IteratorInterfaceExtensions", "LinearAlgebra", "RecipesBase", "StaticArraysCore", "Statistics", "Tables", "ZygoteRules"]
git-tree-sha1 = "3004608dc42101a944e44c1c68b599fa7c669080"
uuid = "731186ca-8d62-57ce-b412-fbd966d074cd"
version = "2.32.0"

[[deps.RecursiveFactorization]]
deps = ["LinearAlgebra", "LoopVectorization", "Polyester", "SnoopPrecompile", "StrideArraysCore", "TriangularSolve"]
git-tree-sha1 = "0a2dfb3358fcde3676beb75405e782faa8c9aded"
uuid = "f2c3362d-daeb-58d1-803e-2bc74f2840b4"
version = "0.2.12"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.RelocatableFolders]]
deps = ["SHA", "Scratch"]
git-tree-sha1 = "90bc7a7c96410424509e4263e277e43250c05691"
uuid = "05181044-ff0b-4ac5-8273-598c1e38db00"
version = "1.0.0"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Rmath]]
deps = ["Random", "Rmath_jll"]
git-tree-sha1 = "bf3188feca147ce108c76ad82c2792c57abe7b1f"
uuid = "79098fc4-a85e-5d69-aa6a-4863f24498fa"
version = "0.7.0"

[[deps.Rmath_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "68db32dff12bb6127bac73c209881191bf0efbb7"
uuid = "f50d1b31-88e8-58de-be2c-1cc44531875f"
version = "0.3.0+0"

[[deps.RuntimeGeneratedFunctions]]
deps = ["ExprTools", "SHA", "Serialization"]
git-tree-sha1 = "cdc1e4278e91a6ad530770ebb327f9ed83cf10c4"
uuid = "7e49a35a-f44a-4d26-94aa-eba1b4ca6b47"
version = "0.5.3"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.SIMD]]
git-tree-sha1 = "7dbc15af7ed5f751a82bf3ed37757adf76c32402"
uuid = "fdea26ae-647d-5447-a871-4b548cad5224"
version = "3.4.1"

[[deps.SIMDDualNumbers]]
deps = ["ForwardDiff", "IfElse", "SLEEFPirates", "VectorizationBase"]
git-tree-sha1 = "dd4195d308df24f33fb10dde7c22103ba88887fa"
uuid = "3cdde19b-5bb0-4aaf-8931-af3e248e098b"
version = "0.1.1"

[[deps.SIMDTypes]]
git-tree-sha1 = "330289636fb8107c5f32088d2741e9fd7a061a5c"
uuid = "94e857df-77ce-4151-89e5-788b33177be4"
version = "0.1.0"

[[deps.SLEEFPirates]]
deps = ["IfElse", "Static", "VectorizationBase"]
git-tree-sha1 = "938c9ecffb28338a6b8b970bda0f3806a65e7906"
uuid = "476501e8-09a2-5ece-8869-fb82de89a1fa"
version = "0.6.36"

[[deps.ScanByte]]
deps = ["Libdl", "SIMD"]
git-tree-sha1 = "2436b15f376005e8790e318329560dcc67188e84"
uuid = "7b38b023-a4d7-4c5e-8d43-3f3097f304eb"
version = "0.3.3"

[[deps.SciMLBase]]
deps = ["ArrayInterfaceCore", "CommonSolve", "ConstructionBase", "Distributed", "DocStringExtensions", "EnumX", "FunctionWrappersWrappers", "IteratorInterfaceExtensions", "LinearAlgebra", "Logging", "Markdown", "Preferences", "RecipesBase", "RecursiveArrayTools", "RuntimeGeneratedFunctions", "StaticArraysCore", "Statistics", "Tables"]
git-tree-sha1 = "d41daf11db3383bd979ba00e1590d2f4297ace61"
uuid = "0bca4576-84f4-4d90-8ffe-ffa030f20462"
version = "1.63.0"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "f94f779c94e58bf9ea243e77a37e16d9de9126bd"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.1"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.Setfield]]
deps = ["ConstructionBase", "Future", "MacroTools", "StaticArraysCore"]
git-tree-sha1 = "e2cc6d8c88613c05e1defb55170bf5ff211fbeac"
uuid = "efcf1570-3423-57d1-acb7-fd33fddbac46"
version = "1.1.1"

[[deps.ShaderAbstractions]]
deps = ["ColorTypes", "FixedPointNumbers", "GeometryBasics", "LinearAlgebra", "Observables", "StaticArrays", "StructArrays", "Tables"]
git-tree-sha1 = "6b5bba824b515ec026064d1e7f5d61432e954b71"
uuid = "65257c39-d410-5151-9873-9b3e5be5013e"
version = "0.2.9"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Showoff]]
deps = ["Dates", "Grisu"]
git-tree-sha1 = "91eddf657aca81df9ae6ceb20b959ae5653ad1de"
uuid = "992d4aef-0814-514b-bc4d-f2e9a6c4116f"
version = "1.0.3"

[[deps.SignedDistanceFields]]
deps = ["Random", "Statistics", "Test"]
git-tree-sha1 = "d263a08ec505853a5ff1c1ebde2070419e3f28e9"
uuid = "73760f76-fbc4-59ce-8f25-708e95d2df96"
version = "0.4.0"

[[deps.SimpleTraits]]
deps = ["InteractiveUtils", "MacroTools"]
git-tree-sha1 = "5d7e3f4e11935503d3ecaf7186eac40602e7d231"
uuid = "699a6c99-e7fa-54fc-8d76-47d257e15c1d"
version = "0.9.4"

[[deps.SimpleWeightedGraphs]]
deps = ["Graphs", "LinearAlgebra", "Markdown", "SparseArrays", "Test"]
git-tree-sha1 = "a6f404cc44d3d3b28c793ec0eb59af709d827e4e"
uuid = "47aef6b3-ad0c-573a-a1e2-d07658019622"
version = "1.2.1"

[[deps.Sixel]]
deps = ["Dates", "FileIO", "ImageCore", "IndirectArrays", "OffsetArrays", "REPL", "libsixel_jll"]
git-tree-sha1 = "8fb59825be681d451c246a795117f317ecbcaa28"
uuid = "45858cf5-a6b0-47a3-bbea-62219f50df47"
version = "0.1.2"

[[deps.SnoopPrecompile]]
git-tree-sha1 = "f604441450a3c0569830946e5b33b78c928e1a85"
uuid = "66db9d55-30c0-4569-8b51-7e840670fc0c"
version = "1.0.1"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "b3363d7460f7d098ca0912c69b082f75625d7508"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.0.1"

[[deps.SparseArrays]]
deps = ["LinearAlgebra", "Random"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.SparseDiffTools]]
deps = ["Adapt", "ArrayInterfaceCore", "ArrayInterfaceStaticArrays", "Compat", "DataStructures", "FiniteDiff", "ForwardDiff", "Graphs", "LinearAlgebra", "Requires", "SparseArrays", "StaticArrays", "VertexSafeGraphs"]
git-tree-sha1 = "a434a4a3a5757440cb3b6500eb9690ff5a516cf6"
uuid = "47a9eef4-7e08-11e9-0b38-333d64bd3804"
version = "1.27.0"

[[deps.SpecialFunctions]]
deps = ["ChainRulesCore", "IrrationalConstants", "LogExpFunctions", "OpenLibm_jll", "OpenSpecFun_jll"]
git-tree-sha1 = "d75bda01f8c31ebb72df80a46c88b25d1c79c56d"
uuid = "276daf66-3868-5448-9aa4-cd146d93841b"
version = "2.1.7"

[[deps.StackViews]]
deps = ["OffsetArrays"]
git-tree-sha1 = "46e589465204cd0c08b4bd97385e4fa79a0c770c"
uuid = "cae243ae-269e-4f55-b966-ac2d0dc13c15"
version = "0.1.1"

[[deps.Static]]
deps = ["IfElse"]
git-tree-sha1 = "de4f0a4f049a4c87e4948c04acff37baf1be01a6"
uuid = "aedffcd0-7271-4cad-89d0-dc628f76c6d3"
version = "0.7.7"

[[deps.StaticArrays]]
deps = ["LinearAlgebra", "Random", "StaticArraysCore", "Statistics"]
git-tree-sha1 = "f86b3a049e5d05227b10e15dbb315c5b90f14988"
uuid = "90137ffa-7385-5640-81b9-e52037218182"
version = "1.5.9"

[[deps.StaticArraysCore]]
git-tree-sha1 = "6b7ba252635a5eff6a0b0664a41ee140a1c9e72a"
uuid = "1e83bf80-4336-4d27-bf5d-d5a4f845583c"
version = "1.4.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"

[[deps.StatsAPI]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "f9af7f195fb13589dd2e2d57fdb401717d2eb1f6"
uuid = "82ae8749-77ed-4fe6-ae5f-f523153014b0"
version = "1.5.0"

[[deps.StatsBase]]
deps = ["DataAPI", "DataStructures", "LinearAlgebra", "LogExpFunctions", "Missings", "Printf", "Random", "SortingAlgorithms", "SparseArrays", "Statistics", "StatsAPI"]
git-tree-sha1 = "d1bf48bfcc554a3761a133fe3a9bb01488e06916"
uuid = "2913bbd2-ae8a-5f71-8c99-4fb6c76f3a91"
version = "0.33.21"

[[deps.StatsFuns]]
deps = ["ChainRulesCore", "HypergeometricFunctions", "InverseFunctions", "IrrationalConstants", "LogExpFunctions", "Reexport", "Rmath", "SpecialFunctions"]
git-tree-sha1 = "5783b877201a82fc0014cbf381e7e6eb130473a4"
uuid = "4c63d2b9-4356-54db-8cca-17b64c39e42c"
version = "1.0.1"

[[deps.StrideArraysCore]]
deps = ["ArrayInterface", "CloseOpenIntervals", "IfElse", "LayoutPointers", "ManualMemory", "SIMDTypes", "Static", "ThreadingUtilities"]
git-tree-sha1 = "ac730bd978bf35f9fe45daa0bd1f51e493e97eb4"
uuid = "7792a7ef-975c-4747-a70f-980b88e8d1da"
version = "0.3.15"

[[deps.StructArrays]]
deps = ["Adapt", "DataAPI", "StaticArraysCore", "Tables"]
git-tree-sha1 = "13237798b407150a6d2e2bce5d793d7d9576e99e"
uuid = "09ab397b-f2b6-538f-b94a-2f83cf4a842a"
version = "0.6.13"

[[deps.SuiteSparse]]
deps = ["Libdl", "LinearAlgebra", "Serialization", "SparseArrays"]
uuid = "4607b0f0-06f3-5cda-b6b1-a6196a1729e9"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "Pkg", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "5.10.1+0"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.0"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "c79322d36826aa2f4fd8ecfa96ddb47b174ac78d"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.10.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.TensorCore]]
deps = ["LinearAlgebra"]
git-tree-sha1 = "1feb45f88d133a655e001435632f019a9a1bcdb6"
uuid = "62fd8b95-f654-4bbd-a8a5-9c27f68ccd50"
version = "0.1.1"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.ThreadingUtilities]]
deps = ["ManualMemory"]
git-tree-sha1 = "f8629df51cab659d70d2e5618a430b4d3f37f2c3"
uuid = "8290d209-cae3-49c0-8002-c8c24d57dab5"
version = "0.5.0"

[[deps.TiffImages]]
deps = ["ColorTypes", "DataStructures", "DocStringExtensions", "FileIO", "FixedPointNumbers", "IndirectArrays", "Inflate", "Mmap", "OffsetArrays", "PkgVersion", "ProgressMeter", "UUIDs"]
git-tree-sha1 = "70e6d2da9210371c927176cb7a56d41ef1260db7"
uuid = "731e570b-9d59-4bfa-96dc-6df516fadf69"
version = "0.6.1"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "8a75929dcd3c38611db2f8d08546decb514fcadf"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.9"

[[deps.TriangularSolve]]
deps = ["CloseOpenIntervals", "IfElse", "LayoutPointers", "LinearAlgebra", "LoopVectorization", "Polyester", "SnoopPrecompile", "Static", "VectorizationBase"]
git-tree-sha1 = "fdddcf6b2c7751cd97de69c18157aacc18fbc660"
uuid = "d5829a12-d9aa-46ab-831f-fb7c9ab06edf"
version = "0.1.14"

[[deps.Tricks]]
git-tree-sha1 = "6bac775f2d42a611cdfcd1fb217ee719630c4175"
uuid = "410a4b4d-49e4-4fbc-ab6d-cb71b17b3775"
version = "0.1.6"

[[deps.TriplotBase]]
git-tree-sha1 = "4d4ed7f294cda19382ff7de4c137d24d16adc89b"
uuid = "981d1d27-644d-49a2-9326-4793e63143c3"
version = "0.1.0"

[[deps.URIs]]
git-tree-sha1 = "e59ecc5a41b000fa94423a578d29290c7266fc10"
uuid = "5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4"
version = "1.4.0"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.UnPack]]
git-tree-sha1 = "387c1f73762231e86e0c9c5443ce3b4a0a9a0c2b"
uuid = "3a884ed6-31ef-47d7-9d2a-63182c4928ed"
version = "1.0.2"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnicodeFun]]
deps = ["REPL"]
git-tree-sha1 = "53915e50200959667e78a92a418594b428dffddf"
uuid = "1cfade01-22cf-5700-b092-accc4b62d6e1"
version = "0.4.1"

[[deps.VectorizationBase]]
deps = ["ArrayInterface", "CPUSummary", "HostCPUFeatures", "IfElse", "LayoutPointers", "Libdl", "LinearAlgebra", "SIMDTypes", "Static"]
git-tree-sha1 = "866e77ea9c675306652f5b5b9010ccbccc684c79"
uuid = "3d5dd08c-fd9d-11e8-17fa-ed2836048c2f"
version = "0.21.53"

[[deps.VertexSafeGraphs]]
deps = ["Graphs"]
git-tree-sha1 = "8351f8d73d7e880bfc042a8b6922684ebeafb35c"
uuid = "19fa3120-7c27-5ec5-8db8-b0b0aa330d6f"
version = "0.2.0"

[[deps.WoodburyMatrices]]
deps = ["LinearAlgebra", "SparseArrays"]
git-tree-sha1 = "de67fa59e33ad156a590055375a30b23c40299d3"
uuid = "efce3f68-66dc-5838-9240-27a6d6f5f9b6"
version = "0.5.5"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "58443b63fb7e465a8a7210828c91c08b92132dff"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.9.14+0"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "5be649d550f3f4b95308bf0183b82e2582876527"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.6.9+4"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4e490d5c960c314f33885790ed410ff3a94ce67e"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.9+4"

[[deps.Xorg_libXcursor_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXfixes_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "12e0eb3bc634fa2080c1c37fccf56f7c22989afd"
uuid = "935fb764-8cf2-53bf-bb30-45bb1f8bf724"
version = "1.2.0+4"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fe47bd2247248125c428978740e18a681372dd4"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.3+4"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXfixes_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "0e0dc7431e7a0587559f9294aeec269471c991a4"
uuid = "d091e8ba-531a-589c-9de9-94069b037ed8"
version = "5.0.3+4"

[[deps.Xorg_libXi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXfixes_jll"]
git-tree-sha1 = "89b52bc2160aadc84d707093930ef0bffa641246"
uuid = "a51aa0fd-4e3c-5386-b890-e753decda492"
version = "1.7.10+4"

[[deps.Xorg_libXinerama_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll"]
git-tree-sha1 = "26be8b1c342929259317d8b9f7b53bf2bb73b123"
uuid = "d1454406-59df-5ea1-beac-c340f2130bc3"
version = "1.1.4+4"

[[deps.Xorg_libXrandr_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libXext_jll", "Xorg_libXrender_jll"]
git-tree-sha1 = "34cea83cb726fb58f325887bf0612c6b3fb17631"
uuid = "ec84b674-ba8e-5d96-8ba1-2a689ba10484"
version = "1.5.2+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "6783737e45d3c59a4a4c4091f5f88cdcf0908cbb"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.0+3"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "daf17f441228e7a3833846cd048892861cff16d6"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.13.0+3"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "79c31e7844f6ecf779705fbc12146eb190b7d845"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.4.0+3"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.12+3"

[[deps.ZygoteRules]]
deps = ["MacroTools"]
git-tree-sha1 = "8c1a8e4dfacb1fd631745552c8db35d0deb09ea0"
uuid = "700de1a5-db45-46bc-99cf-38207098b444"
version = "0.2.2"

[[deps.isoband_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51b5eeb3f98367157a7a12a1fb0aa5328946c03c"
uuid = "9a68df92-36a6-505f-a73e-abb412b6bfb4"
version = "0.2.3+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl", "OpenBLAS_jll"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.1.1+0"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "94d180a6d2b5e55e447e2d27a29ed04fe79eb30c"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.38+0"

[[deps.libsixel_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Pkg", "libpng_jll"]
git-tree-sha1 = "d4f63314c8aa1e48cd22aa0c17ed76cd1ae48c3c"
uuid = "075b6546-f08a-558a-be8f-8157d0f608a5"
version = "1.10.3+0"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.48.0+0"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+0"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"
"""

# ╔═╡ Cell order:
# ╠═04e7ac42-4b1b-11ed-1cb3-e76ac86d4203
# ╟─8159d5bc-2c3f-4657-80c4-661e9162b79d
# ╟─b85a56ad-3b74-402d-8fbe-9f0d130253e6
# ╠═27038d25-32b3-433d-ad47-f7ae330fef1c
# ╠═e0c54d00-c698-4ea6-a710-37fc284ed83e
# ╟─f0d60996-ae46-4bfa-8408-b6e28cba1f6b
# ╟─96fcb06e-2517-4c5b-b350-375d1ecb3258
# ╠═87272f4b-f898-4edb-8842-0464ffc4bf01
# ╟─0fe4dd5d-9838-4236-8ef9-bfe9afb76ac7
# ╠═9efc27d4-caa0-4e9c-85e6-e9dbdbafbb9c
# ╠═40487cc6-707f-4ca3-b735-6d5f50b07f74
# ╠═f2276b50-49f4-478f-9a96-0e374a37fe2f
# ╟─c18609fe-b510-447f-9d2a-d1e6eb1da3c2
# ╠═2532be0e-6d48-4775-b78f-e48f04e5c3a3
# ╟─9ee3fbaf-a579-480e-ae33-9d6eb8b07fbc
# ╟─34cd1003-3790-4db1-bcf8-2e98cf9b98b6
# ╟─6db745f9-afa4-4b5a-8871-b58585165c9e
# ╟─fea185a1-bfae-4bd8-9b2a-f889e54f3f70
# ╠═c1660206-d21a-4812-9dd3-bda91b633c0b
# ╠═a30fa94f-5669-4265-a541-03d16dbd5745
# ╟─a941fd19-faf5-49d0-8f68-ae2fbe45130d
# ╟─922461b0-55a0-447b-b59d-cfff7b448858
# ╠═2abef887-32a8-40ba-89e1-b6adbfe9174f
# ╠═eea2fbc7-1ba8-49f8-916c-743984abe15d
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

include("../header.jl")
using FiniteDifferences
using Manifolds: RiemannianProjectionBackend
using ManifoldDiff

function Ω(::SymplecticStiefel, p, X)
    Q = SymplecticElement(X, p)
    pT_p = lu(p' * p)

    inv_pTp_pT = pT_p \ p'
    X_inv_pTp_pT = X * inv_pTp_pT

    Ω = Q * (X_inv_pTp_pT') * (I - Q' * p * inv_pTp_pT * Q) * Q
    Ω .+= X_inv_pTp_pT
    return Ω
end

function exp_naiive!(M::SymplecticStiefel, q, p, X)
    Ω_X = Ω(M, p, X)
    q .= exp(Ω_X - Ω_X') * exp(Array(Ω_X')) * p
    return q
end

@testset "SymplecticStiefel" begin
    M = SymplecticStiefel(6, 4)

    p_6_4 = [
        0.0 0.0 -5.0 -1.0
        0.0 0.0 9.0 -2.0
        0.0 0.0 -2.0 1.0
        -2.0 -9.0 -3.0 6.0
        -3.0 -13.0 -21.0 9.0
        -8.0 -36.0 18.0 -6.0
    ]
    q_6_4 = [
        0.0 0.0 -3.0 1.0
        0.0 0.0 8.0 -3.0
        0.0 0.0 -2.0 1.0
        -1.0 -4.0 -6.0 3.0
        -1.0 -3.0 -21.0 9.0
        -2.0 -6.0 18.0 -6.0
    ]
    X1 = [
        0.0 0.0 4.25 4.25
        0.0 0.0 0.125 0.125
        0.0 0.0 -1.125 -1.125
        3.625 18.125 -10.875 -10.875
        5.0 25.0 -9.0 -9.0
        13.5 67.5 4.5 4.5
    ]
    X2 = [
        -0.0264806 0.00416977 0.01130802 0.01015956
        0.01718954 -0.00680433 0.02364406 -0.00083272
        0.00050392 0.00191916 -0.01035902 -0.00079734
        0.01811917 -0.02307032 -0.04297277 -0.05409099
        -0.02529516 0.00959934 -0.08594555 -0.06117803
        -0.02823014 0.00029946 -0.04196034 -0.04145413
    ]

    points = [
        [
            0 0 2 6
            0 0 1 -4
            0 0 0 1
            -1 0 -7 1
            1 0 -4 -24
            10 -1 4 -4
        ],
        [
            0 0 5 8
            0 0 -2 -6
            0 0 0 1
            1 0 -4 3
            3 0 -19 -34
            10 -1 1 -6
        ],
        [
            5 -3 0 0
            11 -6 0 0
            -2 1 0 0
            8 -5 -3 -3
            0 0 2 1
            5 -3 3 -2
        ],
        [
            1 -1 0 0
            3 -2 0 0
            0 0 0 0
            2 -2 -2 -3
            0 0 1 1
            1 -1 1 -2
        ],
        [
            0 0 0 0
            0 0 -1 0
            0 0 4 -1
            -1 -10 -5 2
            1 4 -2 0
            0 1 -16 4
        ],
        [
            0 0 0 0
            0 0 -1 0
            0 0 4 -1
            0 -6 -5 2
            1 4 -2 0
            0 1 -16 4
        ],
    ]

    close_points = [
        [
            -2 1 -2 -14
            1 0 1 11
            1 0 4 9
            0 0 0 1
            0 0 0 -1
            0 0 1 3
        ],
        [
            -3 1 -2 -10
            1 0 1 7
            1 0 4 10
            0 0 0 1
            0 0 0 0
            0 0 1 3
        ],
        [
            -2 1 -6 -26
            1 0 5 23
            3 -1 2 3
            0 0 1 4
            0 0 0 -1
            0 0 1 3
        ],
    ]

    @testset "Basics" begin
        @test_throws ArgumentError SymplecticStiefel(5, 4)
        @test_throws ArgumentError SymplecticStiefel(6, 3)
        @test repr(M) == "SymplecticStiefel(6, 4)"
        @test representation_size(M) == (6, 4)
        @test base_manifold(M) === M
        @test get_total_space(M) == SymplecticMatrices(6)
        @test !is_flat(M)

        @test is_point(M, p_6_4)
        @test_throws DomainError is_point(M, 2 * p_6_4; error = :error)

        @test is_vector(M, p_6_4, X1; atol = 1.0e-12)
        @test is_vector(M, p_6_4, X2; atol = 1.0e-6)
        @test_throws DomainError is_vector(M, p_6_4, X2; error = :error, atol = 1.0e-12)
        @test is_vector(M, p_6_4, X1 + X2; atol = 1.0e-6)
        @test_throws DomainError is_vector(M, p_6_4, X1 + p_6_4; error = :error)
    end
    @testset "Symplectic Inverse" begin
        I_2k = Array(I, 4, 4)
        @test Manifolds.symplectic_inverse_times(M, p_6_4, p_6_4) == I_2k
        @test Manifolds.symplectic_inverse_times!(M, zeros(4, 4), p_6_4, p_6_4) == I_2k
        @test inv(M, p_6_4) * p_6_4 == I_2k
        @test inv!(M, copy(p_6_4'), p_6_4) * p_6_4 == I_2k
    end
    @testset "Embedding" begin
        x = [
            1 1 -9 7
            -1 -1 -13 11
            7 8 -22 19
            0 0 7 -6
            0 0 -1 1
            0 0 -1 1
        ]
        y = similar(x)
        z = embed(M, x)
        @test z == x

        Y = similar(X1)
        embed!(M, Y, p_6_4, X1)
        @test Y == X1
    end
    @testset "Retractions and Exponential Mapping" begin
        @test isapprox(retract(M, p_6_4, X1), q_6_4; atol = 1.0e-12)
        @test isapprox(retract(M, p_6_4, X1, CayleyRetraction()), q_6_4; atol = 1.0e-12)

        X_inv_cayley_retraction = inverse_retract(M, p_6_4, q_6_4)
        X_inv_cayley_retraction_2 =
            inverse_retract(M, p_6_4, q_6_4, CayleyInverseRetraction())
        @test isapprox(X_inv_cayley_retraction, X_inv_cayley_retraction_2; atol = 1.0e-16)
        @test isapprox(X_inv_cayley_retraction, X1; atol = 1.0e-12)
    end
    @testset "Riemannian Metric" begin
        X1_norm = 37.85466645
        @test isapprox(norm(M, p_6_4, X1), X1_norm; atol = 1.0e-8)
        @test isapprox(norm(M, p_6_4, X1), √inner(M, p_6_4, X1, X1); atol = 1.0e-8)

        X2_norm = 1.0
        @test isapprox(norm(M, p_6_4, X2), X2_norm; atol = 1.0e-6)
        @test isapprox(norm(M, p_6_4, X2), √inner(M, p_6_4, X2, X2); atol = 1.0e-6)

        # Project Project matrix A ∈ ℝ^{6×4} onto (T_pSpSt):
        A_6_4 = Array{Float64}(
            [
                -7 2 12 0
                4 0 1 -2
                -1 -1 4 0
                -18 4 -1 5
                7 0 -2 11
                2 2 -2 9
            ]
        )
        A_6_4_proj = similar(A_6_4)
        Manifolds.project!(M, A_6_4_proj, p_6_4, A_6_4)
        @test is_vector(M, p_6_4, A_6_4_proj; error = :error, atol = 2.0e-12)

        @test metric(M) == RealSymplecticMetric()
    end
    @testset "Generate random points/tangent vectors" begin
        M_big = SymplecticStiefel(20, 10)
        Random.seed!(49)
        p_big = rand(M_big)
        @test is_point(M_big, p_big; error = :error, atol = 1.0e-9)
        X_big = rand(M_big; vector_at = p_big)
        @test is_vector(M_big, p_big, X_big; error = :error, atol = 1.0e-9)
    end
    @testset "test_manifold(SymplecticMatrices(6), ...)" begin
        types = [Matrix{Float64}]
        for type in types
            @testset "Type $(type)" begin
                @testset "CayleyRetraction" begin
                    Manifolds.test_manifold(
                        M,
                        convert.(type, points);
                        retraction_methods = [CayleyRetraction()],
                        default_retraction_method = CayleyRetraction(),
                        default_inverse_retraction_method = CayleyInverseRetraction(),
                        test_inplace = true,
                        is_point_atol_multiplier = 1.0e4,
                        is_tangent_atol_multiplier = 1.0e3,
                        retraction_atol_multiplier = 1.0e1,
                        test_project_tangent = (type != MMatrix{6, 4, Float64, 24}),
                        test_injectivity_radius = false,
                        test_exp_log = false,
                        test_representation_size = true,
                    )
                end

                @testset "ExponentialRetraction" begin
                    Manifolds.test_manifold(
                        M,
                        convert.(type, close_points);
                        retraction_methods = [ExponentialRetraction()],
                        default_retraction_method = ExponentialRetraction(),
                        default_inverse_retraction_method = CayleyInverseRetraction(),
                        test_inplace = true,
                        is_point_atol_multiplier = 1.0e11,
                        is_tangent_atol_multiplier = 1.0e2,
                        retraction_atol_multiplier = 1.0e4,
                        test_project_tangent = (type != MMatrix{6, 4, Float64, 24}),
                        test_injectivity_radius = false,
                        test_exp_log = false,
                        test_representation_size = true,
                    )
                end
            end
        end # for
    end
    @testset "Canonical project" begin
        E = SymplecticMatrices(6)
        p = [
            1.0 1.0 3.0 0.0 0.0 0.0
            -1.0 -2.0 -4.0 0.0 0.0 0.0
            3.0 0.0 7.0 0.0 0.0 0.0
            3.0 4 10.0 14.0 5.0 -6.0
            -5.0 -9.0 -19.0 7.0 2.0 -3.0
            0.0 0.0 0.0 -2.0 -1.0 1.0
        ]
        @test is_point(E, p)
        M = SymplecticStiefel(6, 4)
        q = canonical_project(M, p)
        @test is_point(M, q)
        q2 = similar(q)
        canonical_project!(M, q2, p)
        @test isapprox(M, q, q2)
    end
    @testset "Gradient Computations" begin
        Q_grad = SymplecticElement(points[1])
        function test_f(p)
            k = size(p)[2]
            return tr(p[1:k, 1:k])
        end
        function analytical_grad_f(p)
            n, k = size(p)
            euc_grad_f = [Array(I, k, k); zeros((n - k), k)]
            return Q_grad * p * (euc_grad_f') * Q_grad * p + euc_grad_f * p' * p
        end
        p_grad = convert(Array{Float64}, points[1])
        fd_diff = RiemannianProjectionBackend(AutoFiniteDifferences(central_fdm(5, 1)))

        @test isapprox(
            Manifolds.gradient(M, test_f, p_grad, fd_diff),
            analytical_grad_f(p_grad);
            atol = 1.0e-9,
        )

        grad_f_p = similar(p_grad)
        Manifolds.gradient!(M, test_f, grad_f_p, p_grad, fd_diff)
        @test isapprox(grad_f_p, analytical_grad_f(p_grad); atol = 1.0e-9)
    end
    @testset "field parameter" begin
        M = SymplecticStiefel(6, 4; parameter = :field)
        @test typeof(get_embedding(M)) === Euclidean{ℝ, Tuple{Int, Int}}
        @test typeof(get_total_space(M)) === SymplecticMatrices{ℝ, Tuple{Int}}
        @test repr(M) == "SymplecticStiefel(6, 4; parameter=:field)"
    end
end

@doc raw"""
    MultinomialMatrices{n,m} <: AbstractPowerManifold{ℝ}

The multinomial manifold consists of `m` column vectors, where each column is of length
`n` and unit norm, i.e.

````math
\mathcal{MN}(n,m) \coloneqq \bigl\{
    p ∈ ℝ^{n×m}\ \big|\ p_{i,j} > 0 \text{ for all } i=1,…,n, j=1,…,m
    \text{ and } p^{\mathrm{T}}\mathbb{1}_m = \mathbb{1}_n\bigr\},
````

where ``\mathbb{1}_k`` is the vector of length ``k`` containing ones.

This yields exactly the same metric as
considering the product metric of the probablity vectors, i.e. [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) of the
``(n-1)``-dimensional [`ProbabilitySimplex`](@ref).

The [`ProbabilitySimplex`](@ref) is stored internally within `M.manifold`, such that all functions of
[`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  can be used directly.

# Constructor

    MultinomialMatrices(n::Int, m::Int; parameter::Symbol=:type)

Generate the manifold of matrices ``ℝ^{n×m}`` such that the ``m`` columns are
discrete probability distributions, i.e. sum up to one.

`parameter`: whether a type parameter should be used to store `n` and `m`. By default size
is stored in type. Value can either be `:field` or `:type`.
"""
struct MultinomialMatrices{T, TPM <: ProbabilitySimplex} <:
    AbstractPowerManifold{ℝ, TPM, ArrayPowerRepresentation}
    size::T
    manifold::TPM
end

function MultinomialMatrices(n::Int, m::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n, m))
    MPS = ProbabilitySimplex(n - 1; parameter = parameter)
    return MultinomialMatrices{typeof(size), typeof(MPS)}(size, MPS)
end

function Base.:^(::ProbabilitySimplex{TypeParameter{Tuple{N}}}, m::Int) where {N}
    return MultinomialMatrices(N + 1, m)
end
function Base.:^(M::ProbabilitySimplex{Tuple{Int}}, m::Int)
    n = get_parameter(M.size)[1]
    return MultinomialMatrices(n + 1, m; parameter = :field)
end

@doc raw"""
    check_point(M::MultinomialMatrices, p)

Checks whether `p` is a valid point on the [`MultinomialMatrices`](@ref)`(m,n)` `M`, i.e. is a matrix
of `m` discrete probability distributions as columns from ``ℝ^n``, i.e. each column is a point from
[`ProbabilitySimplex`](@ref)`(n-1)`.
"""
check_point(::MultinomialMatrices, ::Any)
function check_point(M::MultinomialMatrices, p; kwargs...)
    n, m = get_parameter(M.size)
    return check_point(PowerManifold(M.manifold, m), p; kwargs...)
end

@doc raw"""
    check_vector(M::MultinomialMatrices p, X; kwargs...)

Checks whether `X` is a valid tangent vector to `p` on the [`MultinomialMatrices`](@ref) `M`.
This means, that `p` is valid, that `X` is of correct dimension and columnswise
a tangent vector to the columns of `p` on the [`ProbabilitySimplex`](@ref).
"""
function check_vector(M::MultinomialMatrices, p, X; kwargs...)
    n, m = get_parameter(M.size)
    return check_vector(PowerManifold(M.manifold, m), p, X; kwargs...)
end

function get_iterator(M::MultinomialMatrices)
    n, m = get_parameter(M.size)
    return Base.OneTo(m)
end

function manifold_dimension(M::MultinomialMatrices)
    n, m = get_parameter(M.size)
    return (n - 1) * m
end
function power_dimensions(M::MultinomialMatrices)
    n, m = get_parameter(M.size)
    return (m,)
end

@doc raw"""
    riemannian_gradient(M::MultinomialMatrices, p, Y; kwargs...)

Let ``Y`` denote the Euclidean gradient of a function ``\tilde f`` defined in the
embedding neighborhood of `M`, then the Riemannian gradient is given by
Equation 5 of [DouikHassibi:2019](@cite) as

```math
  \operatorname{grad} f(p) = \proj_{T_p\mathcal M}(Y⊙p)
```

where ``⊙`` denotes the Hadamard or elementwise product.

"""
riemannian_gradient(M::MultinomialMatrices, p, Y; kwargs...)

function riemannian_gradient!(M::MultinomialMatrices, X, p, Y; kwargs...)
    X .= p .* Y
    project!(M, X, p, X)
    return X
end

representation_size(M::MultinomialMatrices) = get_parameter(M.size)

function Base.show(io::IO, ::MultinomialMatrices{TypeParameter{Tuple{n, m}}}) where {n, m}
    return print(io, "MultinomialMatrices($(n), $(m))")
end
function Base.show(io::IO, M::MultinomialMatrices{Tuple{Int, Int}})
    n, m = get_parameter(M.size)
    return print(io, "MultinomialMatrices($(n), $(m); parameter=:field)")
end

"""
    RieszRepresenterCotangentVector(M::AbstractManifold, p, X)

Cotangent vector in Riesz representer form on manifold `M` at point `p` with Riesz
representer `X`.
"""
struct RieszRepresenterCotangentVector{TM <: AbstractManifold, TP, TX}
    manifold::TM
    p::TP
    X::TX
end

function allocate(ξ::RieszRepresenterCotangentVector)
    return RieszRepresenterCotangentVector(ξ.manifold, copy(ξ.manifold, ξ.p), allocate(ξ.X))
end

function (ξ::RieszRepresenterCotangentVector)(Y)
    return inner(ξ.manifold, ξ.p, ξ.X, Y)
end

function Base.copy(M::AbstractManifold, p, ξ::RieszRepresenterCotangentVector)
    return RieszRepresenterCotangentVector(ξ.manifold, copy(ξ.manifold, ξ.p), copy(ξ.manifold, ξ.X))
end

@trait_function flat!(M::AbstractDecoratorManifold, ξ::CoTFVector, p, X::TFVector)

@doc raw"""
    flat(M::AbstractManifold, p, X)

Compute the flat isomorphism (one of the musical isomorphisms) of tangent vector `X`
from the vector space of type `M` at point `p` from the underlying `AbstractManifold`.

The function can be used for example to transform vectors
from the tangent bundle to vectors from the cotangent bundle
``♭ : T\mathcal M → T^{*}\mathcal M``
"""
flat(M::AbstractManifold, p, X) = RieszRepresenterCotangentVector(M, p, X)
function flat(M::AbstractManifold, p, X::TFVector{<:Any, <:AbstractBasis})
    return CoTFVector(X.data, dual_basis(M, p, X.basis))
end

is_metric_function(::typeof(flat)) = true

function flat!(::AbstractManifold, ξ::RieszRepresenterCotangentVector, p, X)
    # TODO: maybe assert that ξ.p is equal to p? Allowing for varying p in ξ leads to
    # issues with power manifold.
    copyto!(ξ.X, X)
    return ξ
end

function get_coordinates(
        M::AbstractManifold,
        p,
        ξ::RieszRepresenterCotangentVector,
        ::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    return get_coordinates(M, p, ξ.X, DefaultOrthonormalBasis{𝔽}())
end
for TM in filter(x -> x != AbstractManifold, Manifolds.METAMANIFOLDS)
    eval(
        quote
            @invoke_maker 1 AbstractManifold get_coordinates(
                M::$TM,
                p,
                ξ::RieszRepresenterCotangentVector,
                b::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
            ) where {𝔽}
        end,
    )
end
# define also for all decorators and explicit definiting subtypes

function get_coordinates!(
        M::AbstractManifold,
        v,
        p,
        ξ::RieszRepresenterCotangentVector,
        ::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    get_coordinates!(M, v, p, ξ.X, DefaultOrthonormalBasis{𝔽}())
    return v
end
for TM in filter(x -> x != AbstractManifold, Manifolds.METAMANIFOLDS)
    eval(
        quote
            @invoke_maker 1 AbstractManifold get_coordinates!(
                M::$TM,
                v,
                p,
                ξ::RieszRepresenterCotangentVector,
                b::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
            ) where {𝔽}
        end,
    )
end

function get_vector(
        M::AbstractManifold,
        p,
        v,
        ::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    X = get_vector(M, p, v, DefaultOrthonormalBasis{𝔽}())
    return RieszRepresenterCotangentVector(M, p, X)
end
for TM in filter(x -> x != AbstractManifold, Manifolds.METAMANIFOLDS)
    eval(
        quote
            @invoke_maker 1 AbstractManifold get_vector(
                M::$TM,
                p,
                v,
                b::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
            ) where {𝔽}
        end,
    )
end

function get_vector!(
        M::AbstractManifold,
        ξr::RieszRepresenterCotangentVector,
        p,
        v,
        ::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    get_vector!(M, ξr.X, p, v, DefaultOrthonormalBasis{𝔽}())
    return ξr
end
for TM in filter(x -> x != AbstractManifold, Manifolds.METAMANIFOLDS)
    eval(
        quote
            @invoke_maker 1 AbstractManifold get_vector!(
                M::$TM,
                ξr::RieszRepresenterCotangentVector,
                p,
                v,
                b::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
            ) where {𝔽}
        end,
    )
end

@doc raw"""
    sharp(M::AbstractManifold, p, ξ)

Compute the sharp isomorphism (one of the musical isomorphisms) of vector `ξ`
from the vector space `M` at point `p` from the underlying `AbstractManifold`.

The function can be used for example to transform vectors
from the cotangent bundle to vectors from the tangent bundle
``♯ : T^{*}\mathcal M → T\mathcal M``
"""
sharp(::AbstractManifold, p, ξ)

@trait_function sharp(M::AbstractDecoratorManifold, X::TFVector, p, ξ::CoTFVector)

sharp(::AbstractManifold, p, ξ::RieszRepresenterCotangentVector) = ξ.X
function sharp(M::AbstractManifold, p, X::CoTFVector{<:Any, <:AbstractBasis})
    return TFVector(X.data, dual_basis(M, p, X.basis))
end

is_metric_function(::typeof(sharp)) = true

@trait_function sharp!(M::AbstractDecoratorManifold, X::TFVector, p, ξ::CoTFVector)

function sharp!(::AbstractManifold, X, p, ξ::RieszRepresenterCotangentVector)
    copyto!(X, ξ.X)
    return X
end

function Base.isapprox(M::AbstractManifold, ξ1::RieszRepresenterCotangentVector, ξ2::RieszRepresenterCotangentVector; kwargs...)
    return isapprox(M, ξ1.p, ξ2.p; kwargs...) && isapprox(M, ξ1.p, ξ1.X, ξ2.X; kwargs...)
end

using Manifolds, Test, Random, StaticArrays, Quaternions, LinearAlgebra

@testset "utils test" begin
    Random.seed!(42)
    @testset "usinc_from_cos" begin
        @test Manifolds.usinc_from_cos(-1) == 0
        @test Manifolds.usinc_from_cos(-1.0) == 0.0
    end
    @testset "log_safe!" begin
        n = 8
        Q = qr(randn(n, n)).Q
        A1 = Matrix(Hermitian(Q * Diagonal(rand(n)) * Q'))
        @test exp(Manifolds.log_safe!(similar(A1), A1)) ≈ A1 atol = 1.0e-6
        A1_fail = Matrix(Hermitian(Q * Diagonal([-1; rand(n - 1)]) * Q'))
        @test_throws DomainError Manifolds.log_safe!(similar(A1_fail), A1_fail)

        T = triu!(randn(n, n))
        T[diagind(T)] .= rand.()
        @test exp(Manifolds.log_safe!(similar(T), T)) ≈ T atol = 1.0e-6
        T_fail = copy(T)
        T_fail[1] = -1
        @test_throws DomainError Manifolds.log_safe!(similar(T_fail), T_fail)

        A2 = Q * T * Q'
        @test exp(Manifolds.log_safe!(similar(A2), A2)) ≈ A2 atol = 1.0e-6
        A2_fail = Q * T_fail * Q'
        @test_throws DomainError Manifolds.log_safe!(similar(A2_fail), A2_fail)

        A3 = exp(SizedMatrix{n, n}(randn(n, n)))
        @test A3 isa SizedMatrix
        @test exp(Manifolds.log_safe!(similar(A3), A3)) ≈ A3 atol = 1.0e-6
        @test exp(Manifolds.log_safe(A3)) ≈ A3 atol = 1.0e-6

        A3_fail = Float64[1 2; 3 1]
        @test_throws DomainError Manifolds.log_safe!(similar(A3_fail), A3_fail)

        A4 = randn(ComplexF64, n, n)
        @test exp(Manifolds.log_safe!(similar(A4), A4)) ≈ A4 atol = 1.0e-6
    end
    @testset "isnormal" begin
        @test !Manifolds.isnormal([1.0 2.0; 3.0 4.0])
        @test !Manifolds.isnormal(complex.(reshape(1:4, 2, 2), reshape(5:8, 2, 2)))

        # diagonal
        @test Manifolds.isnormal(diagm(randn(5)))
        @test Manifolds.isnormal(diagm(randn(ComplexF64, 5)))
        @test Manifolds.isnormal(Diagonal(randn(5)))
        @test Manifolds.isnormal(Diagonal(randn(ComplexF64, 5)))

        # symmetric/hermitian
        @test Manifolds.isnormal(Symmetric(randn(3, 3)))
        @test Manifolds.isnormal(Hermitian(randn(3, 3)))
        @test Manifolds.isnormal(Hermitian(randn(ComplexF64, 3, 3)))
        x = Matrix(Symmetric(randn(3, 3)))
        x[3, 1] += eps()
        @test !Manifolds.isnormal(x)
        @test Manifolds.isnormal(x; atol = sqrt(eps()))

        # skew-symmetric/skew-hermitian
        skew(x) = x - x'
        @test Manifolds.isnormal(skew(randn(3, 3)))
        @test Manifolds.isnormal(skew(randn(ComplexF64, 3, 3)))

        # orthogonal/unitary
        @test Manifolds.isnormal(Matrix(qr(randn(3, 3)).Q); atol = sqrt(eps()))
        @test Manifolds.isnormal(
            Matrix(qr(randn(ComplexF64, 3, 3)).Q);
            atol = sqrt(eps()),
        )
    end
    @testset "realify/unrealify!" begin
        # round trip real
        x = randn(3, 3)
        @test Manifolds.realify(x, ℝ) === x
        @test Manifolds.unrealify!(similar(x), x, ℝ) == x

        # round trip complex
        x2 = randn(ComplexF64, 3, 3)
        x2r = Manifolds.realify(x2, ℂ)
        @test eltype(x2r) <: Real
        @test size(x2r) == (6, 6)
        x2c = Manifolds.unrealify!(similar(x2), x2r, ℂ)
        @test x2c ≈ x2

        # matrix multiplication is preserved
        x3 = randn(ComplexF64, 3, 3)
        x3r = Manifolds.realify(x3, ℂ)
        @test x2 * x3 ≈ Manifolds.unrealify!(similar(x2), x2r * x3r, ℂ)
    end
    @testset "allocation" begin
        @test allocate([1 2; 3 4], Float64, Size(3, 3)) isa Matrix{Float64}
        @test allocate(SA[1 2; 3 4], Float64, Size(3, 3)) isa MMatrix{3, 3, Float64}
        @test allocate(SA[1 2; 3 4], Size(3, 3)) isa MMatrix{3, 3, Int}
        @test Manifolds.quat_promote(Float64) === Quaternions.QuaternionF64
        @test Manifolds.quat_promote(Float32) === Quaternions.QuaternionF32
        @test Manifolds.quat_promote(QuaternionF64) === Quaternions.QuaternionF64
        @test Manifolds.quat_promote(QuaternionF32) === Quaternions.QuaternionF32
    end
    @testset "eigen_safe" begin
        @test Manifolds.eigen_safe(SA[1.0 0.0; 0.0 1.0]) isa
            Eigen{Float64, Float64, <:SizedMatrix{2, 2}, <:SizedVector{2}}
    end
    @testset "max_eps" begin
        x64 = randn(Float64, 2)
        x32 = randn(Float32, 2)
        z32 = randn(ComplexF32, 2)
        xi = rand(0:1, 2)
        @test Manifolds.max_eps(x64, x64) == eps()
        @test Manifolds.max_eps(x64, x32) == eps(Float32)
        @test Manifolds.max_eps(x32, x64) == eps(Float32)
        @test Manifolds.max_eps(xi, xi) == 0
        @test Manifolds.max_eps(xi, x64) == eps()
        @test Manifolds.max_eps(xi, x32) == eps(Float32)
        @test Manifolds.max_eps(xi, z32) == eps(Float32)
        @test Manifolds.max_eps(xi, x64, x32, z32) == eps(Float32)
    end
    @testset "Manifolds.Test selfconsistentcy" begin
        v = 1.0
        e = Manifolds.Test.Expect(v)
        # Expect does not double wrap
        @test e === Manifolds.Test.Expect(e)
        @test Manifolds.Test.expect(e) == v
        @test Manifolds.Test.expect(v) == v
        @test_throws ErrorException Manifolds.Test.expect(Manifolds.Test.NoExpectation())
    end
end

module ManifoldsRecipesBaseExt

using Manifolds
using Manifolds: TypeParameter

using Colors: RGBA
using RecipesBase: @recipe, @series

#
# Defaults
#
CIRCLE_DEFAULT_PLOT_POINTS = 720
WIREFRAME_DEFAULT = 32
SURFACE_RESOLUTION_DEFAULT = 32
#
# Plotting Recipe – Poincaré Ball
#
@recipe function f(                                                             # COV_EXCL_LINE
        M::Hyperbolic{TypeParameter{Tuple{2}}}, pts::AbstractVector{P}, vecs::Union{AbstractVector{T}, Nothing} = nothing;
        circle_points = CIRCLE_DEFAULT_PLOT_POINTS,
        geodesic_interpolation = -1,
        hyperbolic_border_color = RGBA(0.0, 0.0, 0.0, 1.0),
    ) where {P <: PoincareBallPoint, T <: PoincareBallTangentVector}
    @series begin
        φr = range(0, stop = 2 * π, length = circle_points)
        x = [cos(φ) for φ in φr]
        y = [sin(φ) for φ in φr]
        seriestype := :path
        seriescolor := hyperbolic_border_color
        label := ""
        x, y
    end
    show_axis --> false
    framestyle -> :none
    axis --> false
    xlims --> (-1.01, 1.01)
    ylims --> (-1.01, 1.01)
    grid --> false
    aspect_ratio --> :equal
    tickfontcolor --> RGBA(1.0, 1.0, 1.0, 1.0)
    x = []
    y = []
    if vecs === nothing
        if geodesic_interpolation < 0
            seriestype --> :scatter
            x = [p.value[1] for p in pts]
            y = [p.value[2] for p in pts]
        else
            lpts = empty(pts)
            for i in 1:(length(pts) - 1)
                # push interims points on geodesics between two points.
                push!(
                    lpts,
                    shortest_geodesic(
                        M, pts[i], pts[i + 1],
                        collect(range(0, 1, length = geodesic_interpolation + 2))[1:(end - 1)], # omit end point
                    )...
                )
            end
            push!(lpts, last(pts)) # add last end point
            # split into x, y and plot as curve
            seriestype --> :path
            x = [p.value[1] for p in lpts]
            y = [p.value[2] for p in lpts]
        end
    else
        seriestype := :quiver
        quiver := ([v.value[1] for v in vecs], [v.value[2] for v in vecs])
        x = [p.value[1] for p in pts]
        y = [p.value[2] for p in pts]
    end
    return x, y
end
#
# Plotting Recipe – Poincaré Half plane
#
@recipe function f(                                                             # COV_EXCL_LINE
        M::Hyperbolic{TypeParameter{Tuple{2}}}, pts::AbstractVector{P}, vecs::Union{AbstractVector{T}, Nothing} = nothing;
        geodesic_interpolation = -1
    ) where {P <: PoincareHalfSpacePoint, T <: PoincareHalfSpaceTangentVector}
    aspect_ratio --> :equal
    framestyle --> :origin
    x = []
    y = []
    if vecs === nothing
        if geodesic_interpolation < 0
            seriestype --> :scatter
            x = [p.value[1] for p in pts]
            y = [p.value[2] for p in pts]
        else
            lpts = empty(pts)
            for i in 1:(length(pts) - 1)
                # push interims points on geodesics between two points.
                push!(
                    lpts,
                    shortest_geodesic(
                        M, pts[i], pts[i + 1],
                        collect(range(0, 1, length = geodesic_interpolation + 2))[1:(end - 1)], # omit end point
                    )...
                )
            end
            push!(lpts, last(pts)) # add last end point
            # split into x, y, z and plot as curve
            seriestype --> :path
            x = [p.value[1] for p in lpts]
            y = [p.value[2] for p in lpts]
        end
    else
        quiver := ([v.value[1] for v in vecs], [v.value[2] for v in vecs])
        seriestype := :quiver
        x = [p.value[1] for p in pts]
        y = [p.value[2] for p in pts]
    end
    return x, y
end
#
# Plotting Recipe – Hyperboloid
#
@recipe function f(                                                             # COV_EXCL_LINE
        M::Hyperbolic{TypeParameter{Tuple{2}}},
        pts::Union{AbstractVector{P}, Nothing} = nothing,
        vecs::Union{AbstractVector{T}, Nothing} = nothing;
        geodesic_interpolation = -1,
        wireframe = true,
        wires = WIREFRAME_DEFAULT,
        wires_x = wires,
        wires_y = wires,
        wireframe_color = RGBA(0.0, 0.0, 0.0, 1.0),
        surface = false,
        surface_resolution = SURFACE_RESOLUTION_DEFAULT,
        surface_resolution_x = surface_resolution,
        surface_resolution_y = surface_resolution,
        surface_color = RGBA(0.9, 0.9, 0.9, 0.8),
    ) where {P, T}
    px = isnothing(pts) ? [-2.0, 2.0] : [p[1] for p in pts]
    py = isnothing(pts) ? [-2.0, 2.0] : [p[2] for p in pts]
    # part I: wire
    if wireframe
        x = range(min(px...), max(px...), length = wires_x)
        y = range(min(py...), max(py...), length = wires_y)
        z = sqrt.(1 .+ (x .^ 2)' .+ y .^ 2)
        @series begin
            seriestype := :wireframe
            seriescolor := wireframe_color
            x, y, z
        end
    end
    # part II: solid hyperboloid
    if surface
        x = range(min(px...), max(px...), length = surface_resolution_x)
        y = range(min(py...), max(py...), length = surface_resolution_y)
        z = sqrt.(1 .+ (x .^ 2)' .+ y .^ 2)
        @series begin
            seriestype := :surface
            seriescolor := surface_color
            x, y, z
        end
    end
    show_axis --> false
    framestyle -> :none
    axis --> false
    xlims --> (min(px...), max(px...))
    ylims --> (min(py...), max(py...))
    grid --> false
    colorbar --> false
    tickfontcolor --> RGBA(1.0, 1.0, 1.0, 1.0)
    #
    # just pts given -> plot points
    x = []
    y = []
    z = []
    if pts !== nothing
        if vecs === nothing
            if geodesic_interpolation < 0
                seriestype --> :scatter
                x = [p[1] for p in pts]
                y = [p[2] for p in pts]
                z = [p[3] for p in pts]
            else
                lpts = empty(pts)
                for i in 1:(length(pts) - 1)
                    # push interims points on geodesics between two points.
                    push!(
                        lpts,
                        shortest_geodesic(
                            M, pts[i], pts[i + 1],
                            collect(range(0, 1, length = geodesic_interpolation + 2))[1:(end - 1)], # omit end point
                        )...
                    )
                end
                push!(lpts, last(pts)) # add last end point
                # split into x, y and plot as curve
                seriestype --> :path
                x = [p[1] for p in lpts]
                y = [p[2] for p in lpts]
                z = [p[3] for p in lpts]
            end
        else
            seriestype := :quiver
            quiver := ([v[1] for v in vecs], [v[2] for v in vecs], [v[3] for v in vecs])
            x = [p[1] for p in pts]
            y = [p[2] for p in pts]
            z = [p[3] for p in pts]
        end
        return x, y, z
    else
        return nothing
    end
end
#
# Plotting Recipe – Sphere
#
@recipe function f(                                                             # COV_EXCL_LINE
        M::Sphere{ℝ, TypeParameter{Tuple{2}}},
        pts::Union{AbstractVector{P}, Nothing} = nothing,
        vecs::Union{AbstractVector{T}, Nothing} = nothing;
        geodesic_interpolation = -1,
        wireframe = true,
        wires = WIREFRAME_DEFAULT,
        wires_lat = wires,
        wires_lon = wires,
        wireframe_color = RGBA(0.0, 0.0, 0.0, 1.0),
        surface = false,
        surface_resolution = SURFACE_RESOLUTION_DEFAULT,
        surface_resolution_lat = surface_resolution,
        surface_resolution_lon = surface_resolution,
        surface_color = RGBA(0.9, 0.9, 0.9, 0.8),
    ) where {P, T}
    # part I: wire
    if wireframe
        u = range(0, 2π, length = wires_lon + 1)
        v = range(0, π, length = wires_lat + 1)
        x = cos.(u) * sin.(v)'
        y = sin.(u) * sin.(v)'
        z = repeat(cos.(v)', outer = [wires_lon + 1, 1])
        @series begin
            seriestype := :wireframe
            seriescolor := wireframe_color
            return x, y, z
        end
    end
    # part II: solid sphere
    if surface
        u = range(0, 2π, length = surface_resolution_lon + 1)
        v = range(0, π, length = surface_resolution_lat + 1)
        x = cos.(u) * sin.(v)'
        y = sin.(u) * sin.(v)'
        z = repeat(cos.(v)', outer = [wires_lon + 1, 1])
        @series begin
            seriestype := :surface
            seriescolor := surface_color
            return x, y, z
        end
    end
    show_axis --> false
    framestyle -> :none
    axis --> false
    xlims --> (-1.05, 1.05)
    ylims --> (-1.05, 1.05)
    zlims --> (-1.05, 1.05)
    grid --> false
    colorbar --> false
    tickfontcolor --> RGBA(1.0, 1.0, 1.0, 1.0)
    x = []
    y = []
    z = []
    if pts !== nothing
        if vecs === nothing #plot points/geodesics
            if geodesic_interpolation < 0
                seriestype --> :scatter
                x = [p[1] for p in pts]
                y = [p[2] for p in pts]
                z = [p[3] for p in pts]
            else
                lpts = empty(pts)
                for i in 1:(length(pts) - 1)
                    # push interims points on geodesics between two points.
                    push!(
                        lpts,
                        shortest_geodesic(
                            M, pts[i], pts[i + 1],
                            collect(range(0, 1, length = geodesic_interpolation + 2))[1:(end - 1)], # omit end point
                        )...
                    )
                end
                push!(lpts, last(pts)) # add last end point
                # split into x, y and plot as curve
                seriestype --> :path
                x = [p[1] for p in lpts]
                y = [p[2] for p in lpts]
                z = [p[3] for p in lpts]
            end
        else
            seriestype := :quiver
            quiver := ([v[1] for v in vecs], [v[2] for v in vecs], [v[3] for v in vecs])
            x = [p[1] for p in pts]
            y = [p[2] for p in pts]
            z = [p[3] for p in pts]
        end
    end
    return x, y, z
end

end

@doc raw"""
    CholeskySpace{T} <: AbstractManifold{ℝ}

The manifold of lower triangular matrices with positive diagonal and
a metric based on the Cholesky decomposition. The formulae for this manifold
are for example summarized in Table 1 of [Lin:2019](@cite).

# Constructor

    CholeskySpace(n; parameter::Symbol=:type)

Generate the manifold of ``n×n`` lower triangular matrices with positive diagonal.
"""
struct CholeskySpace{T} <: AbstractManifold{ℝ}
    size::T
end

function CholeskySpace(n::Int; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return CholeskySpace{typeof(size)}(size)
end

@doc raw"""
    check_point(M::CholeskySpace, p; kwargs...)

Check whether the matrix `p` lies on the [`CholeskySpace`](@ref) `M`, i.e.
it's size fits the manifold, it is a lower triangular matrix and has positive
entries on the diagonal.
The tolerance for the tests can be set using the `kwargs...`.
"""
function check_point(
        M::CholeskySpace,
        p::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    cks = check_size(M, p)
    cks === nothing || return cks
    if !isapprox(norm(strictlyUpperTriangular(p)), 0.0; atol = atol, kwargs...)
        return DomainError(
            norm(UpperTriangular(p) - Diagonal(p)),
            "The point $(p) does not lie on $(M), since it strictly upper triangular nonzero entries",
        )
    end
    if any(diag(p) .<= 0)
        return DomainError(
            min(diag(p)...),
            "The point $(p) does not lie on $(M), since it hast nonpositive entries on the diagonal",
        )
    end
    return nothing
end

"""
    check_vector(M::CholeskySpace, p, X; kwargs... )

Check whether `v` is a tangent vector to `p` on the [`CholeskySpace`](@ref) `M`, i.e.
after [`check_point`](@ref)`(M,p)`, `X` has to have the same dimension as `p`
and a symmetric matrix.
The tolerance for the tests can be set using the `kwargs...`.
"""
function check_vector(
        M::CholeskySpace,
        p,
        X;
        atol::Real = sqrt(prod(representation_size(M)) * eps(float(eltype(p)))),
        kwargs...,
    )
    if !isapprox(norm(strictlyUpperTriangular(X)), 0.0; atol = atol, kwargs...)
        return DomainError(
            norm(UpperTriangular(X) - Diagonal(X)),
            "The matrix $(X) is not a tangent vector at $(p) (represented as an element of the Lie algebra) since it is not lower triangular.",
        )
    end
    return nothing
end

@doc raw"""
    distance(M::CholeskySpace, p, q)

Compute the Riemannian distance on the [`CholeskySpace`](@ref) `M` between two
matrices `p`, `q` that are lower triangular with positive diagonal. The formula
reads

````math
d_{\mathcal M}(p,q) = \sqrt{\sum_{i>j} (p_{ij}-q_{ij})^2 +
\sum_{j=1}^m (\log p_{jj} - \log q_{jj})^2
}
````
"""
function distance(::CholeskySpace, p, q)
    return sqrt(
        sum((strictlyLowerTriangular(p) - strictlyLowerTriangular(q)) .^ 2) +
            sum((log.(diag(p)) - log.(diag(q))) .^ 2),
    )
end

@doc raw"""
    exp(M::CholeskySpace, p, X)

Compute the exponential map on the [`CholeskySpace`](@ref) `M` emanating from the lower
triangular matrix with positive diagonal `p` towards the lower triangular matrix `X`
The formula reads

````math
\exp_p X = ⌊ p ⌋ + ⌊ X ⌋ + \operatorname{diag}(p)
\operatorname{diag}(p)\exp\bigl( \operatorname{diag}(X)\operatorname{diag}(p)^{-1}\bigr),
````

where ``⌊⋅⌋`` denotes the strictly lower triangular matrix,
and ``\operatorname{diag}`` extracts the diagonal matrix.
"""
exp(::CholeskySpace, ::Any...)

function exp!(::CholeskySpace, q, p, X)
    q .= (
        strictlyLowerTriangular(p) +
            strictlyLowerTriangular(X) +
            Diagonal(diag(p)) * Diagonal(exp.(diag(X) ./ diag(p)))
    )
    return q
end

function get_coordinates_orthonormal!(M::CholeskySpace, Xⁱ, p, X, ::RealNumbers)
    n = get_parameter(M.size)[1]
    view(Xⁱ, 1:n) .= diag(X)
    xi_ind = n + 1
    for i in 1:n
        for j in (i + 1):n
            Xⁱ[xi_ind] = X[j, i]
            xi_ind += 1
        end
    end
    return Xⁱ
end

function get_vector_orthonormal!(M::CholeskySpace, X, p, Xⁱ, ::RealNumbers)
    n = get_parameter(M.size)[1]
    fill!(X, 0)
    view(X, diagind(X)) .= view(Xⁱ, 1:n) .* diag(p)
    xi_ind = n + 1
    for i in 1:n
        for j in (i + 1):n
            X[j, i] = Xⁱ[xi_ind]
            xi_ind += 1
        end
    end
    return X
end

@doc raw"""
    inner(M::CholeskySpace, p, X, Y)

Compute the inner product on the [`CholeskySpace`](@ref) `M` at the
lower triangular matrix with positive diagonal `p` and the two tangent vectors
`X`,`Y`, i.e they are both lower triangular matrices with arbitrary diagonal.
The formula reads

````math
g_p(X,Y) = \sum_{i>j} X_{ij}Y_{ij} + \sum_{j=1}^m X_{ii}Y_{ii}p_{ii}^{-2}
````
"""
function inner(::CholeskySpace, p, X, Y)
    return (
        sum(strictlyLowerTriangular(X) .* strictlyLowerTriangular(Y)) +
            sum(diag(X) .* diag(Y) ./ (diag(p) .^ 2))
    )
end

"""
    is_flat(::CholeskySpace)

Return true. [`CholeskySpace`](@ref) is a flat manifold. See Proposition 8 of [Lin:2019](@cite).
"""
is_flat(M::CholeskySpace) = true

@doc raw"""
    log(M::CholeskySpace, X, p, q)

Compute the logarithmic map on the [`CholeskySpace`](@ref) `M` for the geodesic emanating
from the lower triangular matrix with positive diagonal `p` towards `q`.
The formula reads

````math
\log_p q = ⌊ p ⌋ - ⌊ q ⌋ + \operatorname{diag}(p)\log\bigl(\operatorname{diag}(q)\operatorname{diag}(p)^{-1}\bigr),
````

where ``⌊⋅⌋`` denotes the strictly lower triangular matrix,
and ``\operatorname{diag}`` extracts the diagonal matrix.
"""
log(::Cholesky, ::Any...)

function log!(::CholeskySpace, X, p, q)
    return copyto!(
        X,
        strictlyLowerTriangular(q) - strictlyLowerTriangular(p) +
            Diagonal(diag(p) .* log.(diag(q) ./ diag(p))),
    )
end

@doc raw"""
    manifold_dimension(M::CholeskySpace)

Return the manifold dimension for the [`CholeskySpace`](@ref) `M`, i.e.

````math
    \dim(\mathcal M) = \frac{N(N+1)}{2}.
````
"""
function manifold_dimension(M::CholeskySpace)
    N = get_parameter(M.size)[1]
    return div(N * (N + 1), 2)
end

@doc raw"""
    representation_size(M::CholeskySpace)

Return the representation size for the [`CholeskySpace`](@ref)`{N}` `M`, i.e. `(N,N)`.
"""
function representation_size(M::CholeskySpace)
    N = get_parameter(M.size)[1]
    return (N, N)
end

function Base.show(io::IO, ::CholeskySpace{TypeParameter{Tuple{n}}}) where {n}
    return print(io, "CholeskySpace($(n))")
end
function Base.show(io::IO, M::CholeskySpace{Tuple{Int}})
    n = get_parameter(M.size)[1]
    return print(io, "CholeskySpace($(n); parameter=:field)")
end

# two small helpers for strictly lower and upper triangulars
strictlyLowerTriangular(p) = LowerTriangular(p) - Diagonal(diag(p))

strictlyUpperTriangular(p) = UpperTriangular(p) - Diagonal(diag(p))

@doc raw"""
    parallel_transport_to(M::CholeskySpace, p, X, q)

Parallely transport the tangent vector `X` at `p` along the geodesic to `q`
on the [`CholeskySpace`](@ref) manifold `M`. The formula reads

````math
\mathcal P_{q←p}(X) = ⌊ X ⌋
+ \operatorname{diag}(q)\operatorname{diag}(p)^{-1}\operatorname{diag}(X),
````

where ``⌊⋅⌋`` denotes the strictly lower triangular matrix,
and ``\operatorname{diag}`` extracts the diagonal matrix.
"""
parallel_transport_to(::CholeskySpace, ::Any, ::Any, ::Any)

function parallel_transport_to!(::CholeskySpace, Y, p, X, q)
    return copyto!(Y, strictlyLowerTriangular(p) + Diagonal(diag(q) .* diag(X) ./ diag(p)))
end

function Random.rand!(
        rng::AbstractRNG,
        M::CholeskySpace,
        pX;
        vector_at = nothing,
        σ::Real = one(eltype(pX)) /
            (vector_at === nothing ? 1 : norm(convert(AbstractMatrix, vector_at))),
        tangent_distr = :Gaussian,
    )
    N = get_parameter(M.size)[1]
    if vector_at === nothing
        p_spd = rand(
            rng,
            SymmetricPositiveDefinite(N; parameter = :field);
            σ = σ,
            tangent_distr = tangent_distr,
        )
        pX .= cholesky(p_spd).L
    else
        p_spd = vector_at * vector_at'
        X_spd = rand(
            rng,
            SymmetricPositiveDefinite(N; parameter = :field);
            vector_at = p_spd,
            σ = σ,
            tangent_distr = tangent_distr,
        )
        pX .= spd_to_cholesky(p_spd, X_spd)[2]
    end
    return pX
end

@doc raw"""
    zero_vector(M::CholeskySpace, p)

Return the zero tangent vector on the [`CholeskySpace`](@ref) `M` at `p`.
"""
zero_vector(::CholeskySpace, ::Any...)

zero_vector!(M::CholeskySpace, X, p) = fill!(X, 0)

module ManifoldsHybridArraysExt

using Manifolds
using ManifoldsBase

using Manifolds: PowerManifoldMultidimensional
using Manifolds: rep_size_to_colons

using HybridArrays

import Manifolds: _read

Base.@propagate_inbounds @inline function _read(
        ::PowerManifoldMultidimensional, rep_size::Tuple, x::HybridArray, i::Tuple
    )
    return x[rep_size_to_colons(rep_size)..., i...]
end
Base.@propagate_inbounds @inline function _read(
        ::PowerManifoldMultidimensional, rep_size::Tuple{}, x::HybridArray, i::NTuple{N, Int}
    ) where {N}
    # disambiguation
    return x[i...]
end

end

@inline function allocate_result(M::FiberBundle, f::TF) where {TF}
    p = allocate_result(M.manifold, f)
    X = allocate_result(Fiber(M.manifold, p, M.type), f)
    return ArrayPartition(p, X)
end

"""
    getindex(p::ArrayPartition, M::FiberBundle, s::Symbol)
    p[M::FiberBundle, s]

Access the element(s) at index `s` of a point `p` on a [`FiberBundle`](@ref) `M` by
using the symbols `:point` and `:vector` or `:fiber` for the base and vector or fiber
component, respectively.
"""
@inline function Base.getindex(p::ArrayPartition, M::FiberBundle, s::Symbol)
    (s === :point) && return p.x[1]
    (s === :vector || s === :fiber) && return p.x[2]
    return throw(DomainError(s, "unknown component $s on $M."))
end

function get_vector(M::FiberBundle, p::ArrayPartition, c::AbstractVector, B::AbstractBasis)
    n = manifold_dimension(M.manifold)
    xp1, xp2 = submanifold_components(M, p)
    F = Fiber(M.manifold, xp1, M.type)
    return ArrayPartition(
        get_vector(M.manifold, xp1, c[1:n], B),
        get_vector(F, xp2, c[(n + 1):end], B),
    )
end
function get_vector(
        M::FiberBundle, p::ArrayPartition, c::AbstractVector,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:FiberBundleBasisData},
    ) where {𝔽}
    n = manifold_dimension(M.manifold)
    xp1, xp2 = submanifold_components(M, p)
    F = Fiber(M.manifold, xp1, M.type)
    return ArrayPartition(
        get_vector(M.manifold, xp1, c[1:n], B.data.base_basis),
        get_vector(F, xp2, c[(n + 1):end], B.data.fiber_basis),
    )
end

function get_vectors(
        M::FiberBundle, p::ArrayPartition,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:FiberBundleBasisData},
    ) where {𝔽}
    xp1, xp2 = submanifold_components(M, p)
    zero_m = zero_vector(M.manifold, xp1)
    F = Fiber(M.manifold, xp1, M.type)
    zero_f = zero_vector(F, xp1)
    vs = typeof(ArrayPartition(zero_m, zero_f))[]
    for bv in get_vectors(M.manifold, xp1, B.data.base_basis)
        push!(vs, ArrayPartition(bv, zero_f))
    end
    for bv in get_vectors(F, xp2, B.data.fiber_basis)
        push!(vs, ArrayPartition(zero_m, bv))
    end
    return vs
end

"""
    setindex!(p::ArrayPartition, val, M::FiberBundle, s::Symbol)
    p[M::VectorBundle, s] = val

Set the element(s) at index `s` of a point `p` on a [`FiberBundle`](@ref) `M` to `val` by
using the symbols `:point` and `:fiber` or `:vector` for the base and fiber or vector
component, respectively.

!!! note

    The *content* of element of `p` is replaced, not the element itself.
"""
@inline function Base.setindex!(x::ArrayPartition, val, M::FiberBundle, s::Symbol)
    if s === :point
        return copyto!(x.x[1], val)
    elseif s === :vector || s === :fiber
        return copyto!(x.x[2], val)
    else
        throw(DomainError(s, "unknown component $s on $M."))
    end
end

function _vector_transport_direction(
        M::VectorBundle, p::ArrayPartition, X, d, m::FiberBundleProductVectorTransport,
    )
    px, pVx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    dx, dVx = submanifold_components(M.manifold, d)
    return ArrayPartition(
        vector_transport_direction(M.manifold, px, VXM, dx, m.method_horizontal),
        bundle_transport_tangent_direction(M, px, pVx, VXF, dx, m.method_vertical),
    )
end

function _vector_transport_to(
        M::VectorBundle, p::ArrayPartition, X, q, m::FiberBundleProductVectorTransport,
    )
    px, pVx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    qx, qVx = submanifold_components(M.manifold, q)
    return ArrayPartition(
        vector_transport_to(M.manifold, px, VXM, qx, m.method_horizontal),
        bundle_transport_tangent_to(M, px, pVx, VXF, qx, m.method_vertical),
    )
end

@inline function Base.view(x::ArrayPartition, M::FiberBundle, s::Symbol)
    (s === :point) && return x.x[1]
    (s === :vector || s === :fiber) && return x.x[2]
    throw(DomainError(s, "unknown component $s on $M."))
end

@doc raw"""
    StiefelSubmersionMetric{T<:Real} <: RiemannianMetric

The submersion (or normal) metric family on the [`Stiefel`](@ref) manifold.

The family, with a single real parameter ``α>-1``, has two special cases:
- ``α = -\frac{1}{2}``: [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
- ``α = 0``: [`CanonicalMetric`](@ref)

The family was described in [HueperMarkinaSilvaLeite:2021](@cite). This implementation follows the
description in [ZimmermannHueper:2022](@cite).

# Constructor

    StiefelSubmersionMetric(α)

Construct the submersion metric on the Stiefel manifold with the parameter ``α``.
"""
struct StiefelSubmersionMetric{T <: Real} <: RiemannianMetric
    α::T
    StiefelSubmersionMetric(α::T) where {T <: Real} = new{T}(α)
end

@doc raw"""
    q = exp(M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, p, X)
    exp!(M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, q, p, X)

Compute the exponential map on the [`Stiefel(n,k)`](@ref) manifold with respect to the
[`StiefelSubmersionMetric`](@ref).

The exponential map is given by
````math
\exp_p X = \operatorname{Exp}\bigl(
    -\frac{2α+1}{α+1} p p^\mathrm{T} X p^\mathrm{T} +
    X p^\mathrm{T} - p X^\mathrm{T}
\bigr) p \operatorname{Exp}\bigl(\frac{\alpha}{\alpha+1} p^\mathrm{T} X\bigr)
````
This implementation is based on [ZimmermannHueper:2022](@cite).

For ``k < \frac{n}{2}`` the exponential is computed more efficiently using
[`StiefelFactorization`](@ref).
"""
exp(::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, ::Any...)

function exp!(M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, q, p, X)
    n, k = get_parameter(M.manifold.size)
    α = metric(M).α
    T = Base.promote_eltype(q, p, X)
    if k ≤ div(n, 2)
        Xfact = stiefel_factorization(p, X)
        pfact = similar(Xfact, eltype(p))
        copyto!(pfact, p)
        qfact = similar(Xfact, eltype(q))
        exp!(M, qfact, pfact, Xfact)
        copyto!(q, qfact)
    elseif n == k
        A = allocate(q, T)
        C = allocate(q, T)
        mul!(A, p', X, α / (α + 1), false)
        mul!(C, X, p', inv(α + 1), false)
        expC = exp(C)
        tmp = mul!(C, p, exp(A))
        mul!(q, expC, tmp)
    else  # n/2 < k < n
        # eq. 8
        A = p' * X
        C = allocate(q, T, Size(n, n))
        tmp = allocate(q, T)
        mul!(C, X, p')
        C .-= C'
        mul!(tmp, p, A)
        mul!(C, tmp, p', -(2α + 1) / (α + 1), true)
        rmul!(A, α / (α + 1))
        mul!(tmp, p, exp(A))
        mul!(q, exp(C), tmp)
    end
    return q
end

@doc raw"""
    inner(M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, p, X, Y)

Compute the inner product on the [`Stiefel`](@ref) manifold with respect to the
[`StiefelSubmersionMetric`](@ref). The formula reads
```math
g_p(X,Y) = \operatorname{tr}\bigl( X^{\mathrm{T}}(I_n - \frac{2α+1}{2(α+1)}pp^{\mathrm{T}})Y \bigr),
```
where ``α`` is the parameter of the metric.
"""
function inner(M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, p, X, Y)
    n, k = get_parameter(M.manifold.size)
    α = metric(M).α
    T = typeof(one(Base.promote_eltype(p, X, Y, α)))
    if n == k
        return T(dot(X, Y)) / (2 * (α + 1))
    elseif α == -1 // 2
        return T(dot(X, Y))
    else
        return dot(X, Y) - (T(dot(p'X, p'Y)) * (2α + 1)) / (2 * (α + 1))
    end
end

@doc doc"""
    inverse_retract(
        M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, p, q,
        method::ShootingInverseRetraction,
    )

Compute the inverse retraction using [`ShootingInverseRetraction`](@extref `ManifoldsBase.ShootingInverseRetraction`).

In general the retraction is computed using the generic shooting method.

    inverse_retract(
        M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, p, q,
        method::ShootingInverseRetraction{
            ExponentialRetraction,
            ProjectionInverseRetraction,
            <:Union{ProjectionTransport,ScaledVectorTransport{ProjectionTransport}},
        },
    )

Compute the inverse retraction using [`ShootingInverseRetraction`](@extref `ManifoldsBase.ShootingInverseRetraction`) more efficiently.

For ``k < \frac{n}{2}`` the retraction is computed more efficiently using
[`StiefelFactorization`](@ref).
"""
inverse_retract(
    ::MetricManifold{ℝ, <:Stiefel, <:StiefelSubmersionMetric},
    ::Any,
    ::Any,
    ::ShootingInverseRetraction,
)

function inverse_retract_shooting!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric},
        X::AbstractMatrix,
        p::AbstractMatrix,
        q::AbstractMatrix,
        method::ShootingInverseRetraction{
            ExponentialRetraction,
            ProjectionInverseRetraction,
            <:Union{ProjectionTransport, ScaledVectorTransport{ProjectionTransport}},
        },
    )
    n, k = get_parameter(M.manifold.size)
    if k > div(n, 2)
        # fall back to default method
        invoke(
            inverse_retract_shooting!,
            Tuple{
                MetricManifold{ℝ, typeof(M.manifold)},
                typeof(X),
                typeof(p),
                typeof(q),
                typeof(method),
            },
            M,
            X,
            p,
            q,
            method,
        )
    else
        qfact = stiefel_factorization(p, q)
        pfact = similar(qfact, eltype(p))
        copyto!(pfact, p)
        Xfact = similar(qfact, eltype(X))
        inverse_retract_shooting!(M, Xfact, pfact, qfact, method)
        copyto!(X, Xfact)
    end
    return X
end

@doc raw"""
    log(M::MetricManifold{ℝ,<:Stiefel{ℝ},<:StiefelSubmersionMetric}, p, q; kwargs...)

Compute the logarithmic map on the [`Stiefel(n,k)`](@ref) manifold with respect to the [`StiefelSubmersionMetric`](@ref).

The logarithmic map is computed using [`ShootingInverseRetraction`](@extref `ManifoldsBase.ShootingInverseRetraction`). For
``k ≤ \lfloor\frac{n}{2}\rfloor``, this is sped up using the ``k``-shooting method of [ZimmermannHueper:2022](@cite).
Keyword arguments are forwarded to `ShootingInverseRetraction`; see
that documentation for details. Their defaults are:
- `num_transport_points=4`
- `tolerance=sqrt(eps())`
- `max_iterations=1_000`
"""
function log(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, p, q;
        tolerance = sqrt(eps(float(real(Base.promote_eltype(p, q))))),
        max_iterations = 1_000,
        num_transport_points = 4,
    )
    X = allocate_result(M, log, p, q)
    log!(
        M, X, p, q;
        tolerance = tolerance,
        max_iterations = max_iterations,
        num_transport_points = num_transport_points,
    )
    return X
end
function log!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric},
        X,
        p,
        q;
        tolerance = sqrt(eps(float(real(eltype(X))))),
        max_iterations = 1_000,
        num_transport_points = 4,
    )
    retraction = ExponentialRetraction()
    initial_inverse_retraction = ProjectionInverseRetraction()
    vector_transport = ScaledVectorTransport(ProjectionTransport())
    inverse_retraction = ShootingInverseRetraction(
        retraction,
        initial_inverse_retraction,
        vector_transport,
        num_transport_points,
        tolerance,
        max_iterations,
    )
    return inverse_retract!(M, X, p, q, inverse_retraction)
end

@doc raw"""
    Y = riemannian_Hessian(M::MetricManifold{ℝ,<:Stiefel{ℝ},StiefelSubmersionMetric}, p, G, H, X)
    riemannian_Hessian!(MetricManifold{ℝ,<:Stiefel{ℝ},StiefelSubmersionMetric}, Y, p, G, H, X)

Compute the Riemannian Hessian ``\operatorname{Hess} f(p)[X]`` given the
Euclidean gradient ``∇ f(\tilde p)`` in `G` and the Euclidean Hessian ``∇^2 f(\tilde p)[\tilde X]`` in `H`,
where ``\tilde p, \tilde X`` are the representations of ``p,X`` in the embedding,.

Here, we adopt Eq. (5.6) [Nguyen:2023](@cite), for the [`CanonicalMetric`](@extref `ManifoldsBase.EuclideanMetric`)
``α_0=1, α_1=\frac{1}{2}`` in their formula. The formula reads

```math
    \operatorname{Hess}f(p)[X]
    =
    \operatorname{proj}_{T_p\mathcal M}\Bigl(
        ∇^2f(p)[X] - \frac{1}{2} X \bigl( (∇f(p))^{\mathrm{H}}p + p^{\mathrm{H}}∇f(p)\bigr)
        - \frac{2α+1}{2(α+1)} \bigl( P ∇f(p) p^{\mathrm{H}} + p ∇f(p))^{\mathrm{H}} P)X
    \Bigr),
```
where ``P = I-pp^{\mathrm{H}}``.

Compared to Eq. (5.6) we have that their ``α_0 = 1``and ``\alpha_1 =  \frac{2α+1}{2(α+1)} + 1``.
"""
riemannian_Hessian(
    M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, p, G, H, X,
)

function riemannian_Hessian!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric}, Y, p, G, H, X,
    )
    α = metric(M).α
    Gp = symmetrize(G' * p)
    Z = symmetrize((I - p * p') * G * p')
    project!(M, Y, p, H - X * Gp - (2 * α + 1) / (α + 1) * Z * X)
    return Y
end

# StiefelFactorization code
# Note: intended only for internal use

@doc raw"""
    StiefelFactorization{UT,XT} <: AbstractManifoldPoint

Represent points (and vectors) on `Stiefel(n, k)` with ``2k×k`` factors [ZimmermannHueper:2022](@cite).

Given a point ``p ∈ \mathrm{St}(n, k)`` and another matrix ``B ∈ ℝ^{n×k}`` for
``k ≤ \lfloor\frac{n}{2}\rfloor`` the factorization is
````math
\begin{aligned}
B &= UZ\\
U &= \begin{bmatrix}p & Q\end{bmatrix} ∈ \mathrm{St}(n, 2k)\\
Z &= \begin{bmatrix}Z_1 \\ Z_2\end{bmatrix}, \quad Z_1,Z_2 ∈ ℝ^{k×k}.
\end{aligned}
````
If ``B ∈ \mathrm{St}(n, k)``, then ``Z ∈ \mathrm{St}(2k, k)``.
Note that not every matrix ``B`` can be factorized in this way.

For a fixed ``U``, if ``r ∈ \mathrm{St}(n, k)`` has the factor ``Z_r ∈ \mathrm{St}(2k, k)``,
then ``X_r ∈ T_r \mathrm{St}(n, k)`` has the factor
``Z_{X_r} ∈ T_{Z_r} \mathrm{St}(2k, k)``.

``Q`` is determined by choice of a second matrix ``A ∈ ℝ^{n×k}`` with the decomposition
````math
\begin{aligned}
A &= UZ\\
Z_1 &= p^\mathrm{T} A \\
Q Z_2 &= (I - p p^\mathrm{T}) A,
\end{aligned}
````
where here ``Q Z_2`` is the any decomposition that produces ``Q ∈ \mathrm{St}(n, k)``, for
which we choose the QR decomposition.

This factorization is useful because it is closed under addition, subtraction, scaling,
projection, and the Riemannian exponential and logarithm under the
[`StiefelSubmersionMetric`](@ref). That is, if all matrices involved are factorized to have
the same ``U``, then all of these operations and any algorithm that depends only on them can
be performed in terms of the ``2k×k`` matrices ``Z``. For ``n ≫ k``, this can be much more
efficient than working with the full matrices.

!!! warning
    This type is intended strictly for internal use and should not be directly used.
"""
struct StiefelFactorization{UT, ZT} <: AbstractManifoldPoint
    U::UT
    Z::ZT
end
"""
    stiefel_factorization(p, x) -> StiefelFactorization

Compute the [`StiefelFactorization`](@ref) of ``x`` relative to the point ``p``.
"""
function stiefel_factorization(p, x)
    n, k = size(p)
    T = Base.promote_eltype(p, x)
    U = allocate(p, T, Size(n, 2k))
    Z = allocate(p, T, Size(2k, k))
    xfact = StiefelFactorization(U, Z)
    @views begin # COV_EXCL_LINE
        U1 = U[1:n, 1:k]
        U2 = U[1:n, (k + 1):(2k)]
        Z1 = Z[1:k, 1:k]
        Z2 = Z[(k + 1):(2k), 1:k]
    end
    if p ≈ x
        copyto!(U1, p)
        copyto!(U2, qr(U1).Q[1:n, (k + 1):(2k)])
        copyto!(xfact, x)
    else
        copyto!(U1, x)
        mul!(Z1, p', x)
        mul!(U1, p, Z1, -1, true)
        Q, N = qr(U1)
        copyto!(Z2, N)
        copyto!(U1, p)
        copyto!(U2, Matrix(Q))
    end
    return xfact
end
function Base.eltype(F::StiefelFactorization)
    return Base.promote_eltype(F.U, F.Z)
end
Base.size(F::StiefelFactorization) = (size(F.U, 1), size(F.Z, 2))
function Base.similar(F::StiefelFactorization, ::Type{T} = eltype(F), sz = size(F)) where {T}
    size(F) == sz || throw(DimensionMismatch("size of factorization must be preserved"))
    return StiefelFactorization(convert(AbstractArray{T}, F.U), similar(F.Z, T))
end
function Base.copyto!(A::StiefelFactorization, B::StiefelFactorization)
    copyto!(A.Z, B.Z)
    return A
end
function Base.copyto!(A::AbstractMatrix{<:Real}, B::StiefelFactorization)
    mul!(A, B.U, B.Z)
    return A
end
function Base.copyto!(A::StiefelFactorization, B::AbstractMatrix{<:Real})
    mul!(A.Z, A.U', B)
    return A
end
LinearAlgebra.dot(A::StiefelFactorization, B::StiefelFactorization) = dot(A.Z, B.Z)
function Broadcast.BroadcastStyle(::Type{<:StiefelFactorization})
    return Broadcast.Style{StiefelFactorization}()
end
function Broadcast.BroadcastStyle(
        ::Broadcast.AbstractArrayStyle{0},
        b::Broadcast.Style{<:StiefelFactorization},
    )
    return b
end
Broadcast.broadcastable(v::StiefelFactorization) = v
function Base.copyto!(
        dest::StiefelFactorization,
        bc::Broadcast.Broadcasted{Broadcast.Style{StiefelFactorization}},
    )
    bc.args isa Tuple{Vararg{Union{Manifolds.StiefelFactorization, Real}}} ||
        throw(ArgumentError("Not implemented"))
    bc.f ∈ (identity, *, +, -, /) || throw(ArgumentError("Not implemented"))
    Zargs = map(x -> x isa Manifolds.StiefelFactorization ? x.Z : x, bc.args)
    broadcast!(bc.f, dest.Z, Zargs...)
    return dest
end
function project!(M::Stiefel{ℝ}, q::StiefelFactorization, p::StiefelFactorization)
    n, k = get_parameter(M.size)
    project!(Stiefel(2k, k), q.Z, p.Z)
    return q
end
function project!(
        M::Stiefel{ℝ}, Y::StiefelFactorization, p::StiefelFactorization, X::StiefelFactorization,
    )
    n, k = get_parameter(M.size)
    project!(Stiefel(2k, k), Y.Z, p.Z, X.Z)
    return Y
end
function inner(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric},
        p::StiefelFactorization,
        X::StiefelFactorization,
        Y::StiefelFactorization,
    )
    n, k = get_parameter(M.manifold.size)
    Msub = MetricManifold(Stiefel(2k, k), metric(M))
    return inner(Msub, p.Z, X.Z, Y.Z)
end
function exp!(
        M::MetricManifold{ℝ, <:Stiefel{ℝ}, <:StiefelSubmersionMetric},
        q::StiefelFactorization,
        ::StiefelFactorization,
        X::StiefelFactorization,
    )
    n, k = get_parameter(M.manifold.size)
    α = metric(M).α
    @views begin # COV_EXCL_LINE
        ZM = X.Z[1:k, 1:k]
        ZN = X.Z[(k + 1):(2k), 1:k]
        qM = q.Z[1:k, 1:k]
    end
    qM .= ZM .* (α / (α + 1))
    D = exp(qM)
    C = allocate(D, Size(2k, 2k))
    @views begin # COV_EXCL_LINE
        C[1:k, 1:k] .= ZM ./ (α + 1)
        C[1:k, (k + 1):(2k)] .= -ZN'
        C[(k + 1):(2k), 1:k] .= ZN
        fill!(C[(k + 1):(2k), (k + 1):(2k)], false)
        mul!(q.Z, exp(C)[1:(2k), 1:k], D)
    end
    return q
end
function Base.:*(t::Number, sf::StiefelFactorization)
    return StiefelFactorization(sf.U, t * sf.Z)
end

using Manifolds, LinearAlgebra, PGFPlotsX, Colors

out_file = joinpath(
    @__DIR__,
    "..",
    "docs",
    "src",
    "assets",
    "images",
    "projection_illustration.png",
)
n = 100

line_width = 1 / 2
light_color = colorant"#BBBBBB"
base_linewidth = line_width
point_color = colorant"#0077BB" #Blue
main_linewidth = 1.25
tangent_color = colorant"#33BBEE" #Cyan
tangent_linewidth = main_linewidth
geo_color = colorant"#009988" #teal
geo_linewidth = 1.25
geo_marker_size = 1.5
projection_color = colorant"#EE7733"
projection_color2 = colorant"#0077BB" #Blue
projection_color3 = colorant"#33BBEE" #Cyan
projection_marker_size = 1.5

C_to_2D(p) = [real(p), imag(p)]

M = Circle(ℂ)

p = (-2 + 1im) / abs(-2 + 1im)
X = (imag(p) - real(p) * im)
q = -1.3 + 1.5im

s1 = project(M, q)
s2 = project(M, p, q)

circle = [[sin(φ), cos(φ)] for φ in range(0, 2π, length = n)]
tp = @pgf Axis(
    {
        axis_lines = "none",
        axis_equal,
        xmin = -1.7,
        xmax = 1.7,
        ymin = -0.25,
        ymax = 1.4,
        scale = 1.6,
    }
)

plain_opts = @pgf {"no markers", color = light_color, line_width = base_linewidth}

push!(tp, Plot(plain_opts, Coordinates(Tuple.(circle))))
plaint_opts_a = @pgf {"only marks", mark_size = geo_marker_size / 2, color = light_color}
push!(tp, Plot(plaint_opts_a, Coordinates(Tuple.([[0.0, 0.0]]))))

tangent_line2 = [C_to_2D(p - 0.8 * X), C_to_2D(p + 1.1 * X)]
push!(tp, Plot(plain_opts, Coordinates(Tuple.(tangent_line2))))

projection_opts2 = @pgf {
    "no markers",
    "densely dotted",
    mark_size = projection_marker_size,
    color = projection_color2,
}
projection_line2 = [C_to_2D(q), C_to_2D(s1)]
push!(tp, Plot(projection_opts2, Coordinates(Tuple.(projection_line2))))
projection_opts2_a =
    @pgf {"only marks", mark_size = projection_marker_size, color = projection_color2}
push!(tp, Plot(projection_opts2_a, Coordinates(Tuple.([C_to_2D(s1)]))))

geo_opts2 = @pgf {"only marks", mark_size = geo_marker_size, color = geo_color}
push!(tp, Plot(geo_opts2, Coordinates(Tuple.(C_to_2D.([p, q])))))

projection_opts3 = @pgf {
    "no markers",
    "densely dotted",
    mark_size = projection_marker_size,
    color = projection_color3,
}
projection_line3 = [C_to_2D(q), C_to_2D(p + s2)]
push!(tp, Plot(projection_opts3, Coordinates(Tuple.(projection_line3))))
projection_opts3_a =
    @pgf {"only marks", mark_size = projection_marker_size, color = projection_color3}
push!(tp, Plot(projection_opts3_a, Coordinates(Tuple.([C_to_2D(p + s2)]))))

push!(
    tp,
    raw"\node[label ={[label distance=.05cm]below:{\color{gray}$q$}}] at (axis cs:" *
        "$(real(q)),$(imag(q))) {};",
)
push!(
    tp,
    raw"\node[label ={[label distance=.05cm]left:{\color{gray}$p$}}] at (axis cs:" *
        "$(real(p)),$(imag(p))) {};",
)
# push!(tp, raw"\node[label ={[label distance=.05cm]right:{$s_1=\mathrm{proj}_{\mathcal C}(q_2)=$\texttt{project(M,q2)}}}] at (axis cs:"*"$(real(s1)),$(imag(s1))) {};")
push!(
    tp,
    raw"\node[label ={[label distance=.05cm]right:{\color{gray}$s_1=$\texttt{project(M,q)$\in\mathcal C$}}}] at (axis cs:" *
        "$(real(s1)),$(imag(s1))) {};",
)
push!(
    tp,
    raw"\node[label ={[label distance=.05cm]0:{\color{gray}$s_2=$\texttt{project(M,p,q)}$\in T_{p}\mathcal C$}}] at (axis cs:" *
        "$(real(p + s2)),$(imag(p + s2))) {};",
)
push!(tp, raw"\node at (axis cs: 0,-.6) {\color{gray}$\mathcal C$};")

pgfsave(out_file, tp, dpi = 1200)

"""
    AbstractSphere{𝔽} <: AbstractDecoratorManifold{𝔽}

An abstract type to represent a unit sphere that is represented isometrically in the embedding.
"""
abstract type AbstractSphere{𝔽} <: AbstractDecoratorManifold{𝔽} end

@doc raw"""
    Sphere{𝔽, T} <: AbstractSphere{𝔽}

The (unit) sphere manifold ``𝕊^{n}`` is the set of all unit norm vectors in ``𝔽^{n+1}``.
The sphere is represented in the embedding, i.e.

````math
𝕊^{n} := \bigl\{ p \in 𝔽^{n+1}\ \big|\ \lVert p \rVert = 1 \bigr\}
````

where ``𝔽\in\{ℝ,ℂ,ℍ\}``. Note that compared to the [`ArraySphere`](@ref), here the
argument `n` of the manifold is the dimension of the manifold, i.e. ``𝕊^{n} ⊂ 𝔽^{n+1}``, ``n\in ℕ``.

The tangent space at point ``p`` is given by

````math
T_p𝕊^{n} := \bigl\{ X ∈ 𝔽^{n+1}\ |\ \Re(⟨p,X⟩) = 0 \bigr \},
````

where ``𝔽\in\{ℝ,ℂ,ℍ\}`` and ``⟨⋅,⋅⟩`` denotes the inner product in the
embedding ``𝔽^{n+1}``.

For ``𝔽=ℂ``, the manifold is the complex sphere, written ``ℂ𝕊^n``, embedded in ``ℂ^{n+1}``.
``ℂ𝕊^n`` is the complexification of the real sphere ``𝕊^{2n+1}``.
Likewise, the quaternionic sphere ``ℍ𝕊^n`` is the quaternionification of the real sphere
``𝕊^{4n+3}``.
Consequently, ``ℂ𝕊^0`` is equivalent to ``𝕊^1`` and [`Circle`](@ref), while ``ℂ𝕊^1`` and ``ℍ𝕊^0``
are equivalent to ``𝕊^3``, though with different default representations.

This manifold is modeled as a special case of the more general case, i.e. as an embedded
manifold to the [`Euclidean`](@ref), and several functions like the [`inner`](@ref inner(::Euclidean, ::Any...)) product
and the [`zero_vector`](@ref zero_vector(::Euclidean, ::Any...)) are inherited from the embedding.

# Constructor

    Sphere(n[, field=ℝ])

Generate the (real-valued) sphere ``𝕊^{n} ⊂ ℝ^{n+1}``, where `field` can also be used to
generate the complex- and quaternionic-valued sphere.
"""
struct Sphere{𝔽, T} <: AbstractSphere{𝔽}
    size::T
end
function Sphere(n::Int, field::AbstractNumbers = ℝ; parameter::Symbol = :type)
    size = wrap_type_parameter(parameter, (n,))
    return Sphere{field, typeof(size)}(size)
end

@doc raw"""
    ArraySphere{𝔽, T} <: AbstractSphere{𝔽}

The (unit) sphere manifold ``𝕊^{n₁,n₂,...,nᵢ}`` is the set of all unit (Frobenius) norm elements of
``𝔽^{n₁,n₂,...,nᵢ}``, where ``𝔽\in\{ℝ,ℂ,ℍ\}. The generalized sphere is
represented in the embedding, and supports arbitrary sized arrays or in other words arbitrary
tensors of unit norm. The set formally reads

````math
𝕊^{n_1, n_2, …, n_i} := \bigl\{ p \in 𝔽^{n_1, n_2, …, n_i}\ \big|\ \lVert p \rVert = 1 \bigr\}
````

where ``𝔽∈\{ℝ,ℂ,ℍ\}``. Setting ``i=1`` and ``𝔽=ℝ``  this  simplifies to unit vectors in ``ℝ^n``, see
[`Sphere`](@ref) for this special case. Note that compared to this classical case,
the argument for the generalized case here is given by the dimension of the embedding.
This means that `Sphere(2)` and `ArraySphere(3)` are the same manifold.

The tangent space at point ``p`` is given by

````math
T_p 𝕊^{n_1, n_2, …, n_i} := \bigl\{ X ∈ 𝔽^{n_1, n_2, …, n_i}\ |\ \Re(⟨p,X⟩) = 0 \bigr \},
````

where ``𝔽∈\{ℝ,ℂ,ℍ\}`` and ``⟨⋅,⋅⟩`` denotes the (Frobenius) inner product in the
embedding ``𝔽^{n_1, n_2, …, n_i}``.

This manifold is modelled as an embedded manifold to the [`Euclidean`](@ref), i.e.
several functions like the [`inner`](@ref inner(::Euclidean, ::Any...)) product and the
[`zero_vector`](@ref zero_vector(::Euclidean, ::Any...)) are inherited from the embedding.

# Constructor

    ArraySphere(n₁,n₂,...,nᵢ; field=ℝ, parameter::Symbol=:type)

Generate sphere in ``𝔽^{n_1, n_2, …, n_i}``, where ``𝔽`` defaults to the real-valued case ``ℝ``.
"""
struct ArraySphere{𝔽, T} <: AbstractSphere{𝔽}
    size::T
end
function ArraySphere(
        n::Vararg{Int, I};
        field::AbstractNumbers = ℝ,
        parameter::Symbol = :type,
    ) where {I}
    size = wrap_type_parameter(parameter, n)
    return ArraySphere{field, typeof(size)}(size)
end

"""
    check_point(M::AbstractSphere, p; kwargs...)

Check whether `p` is a valid point on the [`AbstractSphere`](@ref) `M`, i.e. is a point in
the embedding of unit length.
The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(M::AbstractSphere, p; kwargs...)
    if !isapprox(norm(p), 1.0; kwargs...)
        return DomainError(
            norm(p),
            "The point $(p) does not lie on the $(M) since its norm is not 1.",
        )
    end
    return nothing
end

"""
    check_vector(M::AbstractSphere, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`AbstractSphere`](@ref) `M`, i.e.
after [`check_point`](@ref)`(M,p)`, `X` has to be of same dimension as `p`
and orthogonal to `p`.
The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(
        M::AbstractSphere,
        p,
        X::T;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    absdot = abs(real(dot(p, X)))
    if !isapprox(absdot, 0; atol = atol, kwargs...)
        return DomainError(
            absdot,
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not orthogonal in the embedding (tolerance: $atol).",
        )
    end
    return nothing
end

metric(::AbstractSphere) = EuclideanMetric()

function diagonalizing_projectors(M::AbstractSphere{ℝ}, p, X)
    X_norm = norm(M, p, X)
    X_normed = X / X_norm
    return (
        (zero(number_eltype(p)), ProjectorOntoVector(M, p, X_normed)),
        (one(number_eltype(p)), CoprojectorOntoVector(M, p, X_normed)),
    )
end

@doc raw"""
    distance(M::AbstractSphere, p, q)

Compute the geodesic distance between `p` and `q` on the [`AbstractSphere`](@ref) `M`.
The formula is given by the (shorter) great arc length on the (or a) great circle
both `p` and `q` lie on.

````math
d_{𝕊}(p,q) = \arccos(\Re(⟨p,q⟩)).
````
"""
function distance(::AbstractSphere, p, q)
    cosθ = real(dot(p, q))
    T = float(real(Base.promote_eltype(p, q)))
    # abs and relative error of acos is less than sqrt(eps(T))
    -1 < cosθ < 1 - sqrt(eps(T)) / 8 && return acos(cosθ)
    # improved accuracy for q close to p or -p
    return 2 * abs(atan(norm(p - q), norm(p + q)))
end

embed(::AbstractSphere, p) = copy(p)
embed(::AbstractSphere, p, X) = copy(X)

@doc raw"""
    exp(M::AbstractSphere, p, X)

Compute the exponential map from `p` in the tangent direction `X` on the [`AbstractSphere`](@ref)
`M` by following the great arc emanating from `p` in direction `X`.

````math
\exp_p X = \cos(\lVert X \rVert_p)p + \sin(\lVert X \rVert_p)\frac{X}{\lVert X \rVert_p},
````
where ``\lVert X \rVert_p`` is the [`norm`](@ref norm(::AbstractSphere,p,X)) on the
tangent space at `p` of the [`AbstractSphere`](@ref) `M`.
"""
exp(::AbstractSphere, ::Any...)

function exp!(M::AbstractSphere, q, p, X)
    θ = norm(M, p, X)
    q .= cos(θ) .* p .+ usinc(θ) .* X
    return q
end
function exp_fused!(M::AbstractSphere, q, p, X, t::Number)
    θ = abs(t) * norm(M, p, X)
    q .= cos(θ) .* p .+ usinc(θ) .* t .* X
    return q
end

function get_basis_diagonalizing(M::Sphere{ℝ}, p, B::DiagonalizingOrthonormalBasis{ℝ})
    n = get_parameter(M.size)[1]
    A = zeros(n + 1, n + 1)
    A[1, :] = transpose(p)
    A[2, :] = transpose(B.frame_direction)
    V = nullspace(A)
    κ = ones(n)
    if !iszero(B.frame_direction)
        # if we have a nonzero direction for the geodesic, add it and it gets curvature zero from the tensor
        V = hcat(B.frame_direction / norm(M, p, B.frame_direction), V)
        κ[1] = 0 # no curvature along the geodesic direction, if x!=y
    end
    T = typeof(similar(B.frame_direction))
    Ξ = [convert(T, V[:, i]) for i in 1:n]
    return CachedBasis(B, κ, Ξ)
end

@doc raw"""
    get_coordinates(M::AbstractSphere{ℝ}, p, X, B::DefaultOrthonormalBasis)

Represent the tangent vector `X` at point `p` from the [`AbstractSphere`](@ref) `M` in
an orthonormal basis by rotating the hyperplane containing `X` to a hyperplane whose
normal is the ``x``-axis.

Given ``q = p λ + x``, where ``λ = \operatorname{sgn}(⟨x, p⟩)``, and ``⟨⋅, ⋅⟩_{\mathrm{F}}``
denotes the Frobenius inner product, the formula for ``Y`` is
````math
\begin{pmatrix}0 \\ Y\end{pmatrix} = X - q\frac{2 ⟨q, X⟩_{\mathrm{F}}}{⟨q, q⟩_{\mathrm{F}}}.
````
"""
get_coordinates(::AbstractSphere{ℝ}, p, X, ::DefaultOrthonormalBasis)

function get_coordinates_orthonormal!(M::AbstractSphere{ℝ}, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend, Xend = view(p, 2:(n + 1)), view(X, 2:(n + 1))
    factor = λ * X[1] / (1 + cosθ)
    Y .= Xend .- pend .* factor
    return Y
end

function get_embedding(M::AbstractSphere{𝔽}) where {𝔽}
    return Euclidean(representation_size(M)...; field = 𝔽)
end
function get_embedding(M::Sphere{𝔽, <:Tuple}) where {𝔽}
    return Euclidean(representation_size(M)...; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::AbstractSphere)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

@doc raw"""
    get_vector(M::AbstractSphere{ℝ}, p, X, B::DefaultOrthonormalBasis)

Convert a one-dimensional vector of coefficients `X` in the basis `B` of the tangent space
at `p` on the [`AbstractSphere`](@ref) `M` to a tangent vector `Y` at `p` by rotating the
hyperplane containing `X`, whose normal is the ``x``-axis, to the hyperplane whose normal is
`p`.

Given ``q = p λ + x``, where ``λ = \operatorname{sgn}(⟨x, p⟩)``, and ``⟨⋅, ⋅⟩_{\mathrm{F}}``
denotes the Frobenius inner product, the formula for ``Y`` is
````math
Y = X - q\frac{2 \left\langle q, \begin{pmatrix}0 \\ X\end{pmatrix}\right\rangle_{\mathrm{F}}}{⟨q, q⟩_{\mathrm{F}}}.
````
"""
get_vector(::AbstractSphere{ℝ}, p, X, ::DefaultOrthonormalBasis)

function get_vector_orthonormal!(M::AbstractSphere{ℝ}, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend = view(p, 2:(n + 1))
    pX = dot(pend, X)
    factor = pX / (1 + cosθ)
    Y[1] = -λ * pX
    Y[2:(n + 1)] .= X .- pend .* factor
    return Y
end

_doc_injectivity_radius_sphere = raw"""
    injectivity_radius(M::AbstractSphere[, p, ::ExponentialRetraction])

Return the injectivity radius for the [`AbstractSphere`](@ref) `M`, which is globally ``π``.
"""
@doc "$(_doc_injectivity_radius_sphere)"
injectivity_radius(::AbstractSphere) = π
@doc "$(_doc_injectivity_radius_sphere)"
injectivity_radius(::AbstractSphere, p) = π
#avoid falling back but use the ones below

_doc_injectivity_radius_sphere_projection = raw"""
    injectivity_radius(M::Sphere, ::ProjectionRetraction)
    injectivity_radius(M::Sphere, p, ::ProjectionRetraction)

Return the injectivity radius for the [`ProjectionRetraction`](@extref `ManifoldsBase.ProjectionRetraction`) on the
[`AbstractSphere`](@ref), which is globally ``$(_tex(:frac, "π", "2"))``.
"""

@doc "$(_doc_injectivity_radius_sphere_projection)"
injectivity_radius(::AbstractSphere, ::ProjectionRetraction)

@doc "$(_doc_injectivity_radius_sphere_projection)"
injectivity_radius(::AbstractSphere, p, ::ProjectionRetraction)

# Resolve ambiguities
function injectivity_radius(M::AbstractSphere, m::AbstractRetractionMethod)
    return _injectivity_radius(M, m)
end
function injectivity_radius(M::AbstractSphere, p, m::AbstractRetractionMethod)
    return _injectivity_radius(M, p, m)
end
_injectivity_radius(::AbstractSphere, ::ExponentialRetraction) = π
_injectivity_radius(::AbstractSphere, ::ProjectionRetraction) = π / 2

@doc raw"""
    inverse_retract(M::AbstractSphere, p, q, ::ProjectionInverseRetraction)

Compute the inverse of the projection based retraction on the [`AbstractSphere`](@ref) `M`,
i.e. rearranging ``p+X = q\lVert p+X\rVert_2`` yields
since ``\Re(⟨p,X⟩) = 0`` and when ``d_{𝕊^2}(p,q) ≤ \frac{π}{2}`` that

````math
\operatorname{retr}_p^{-1}(q) = \frac{q}{\Re(⟨p, q⟩)} - p.
````
"""
inverse_retract(::AbstractSphere, ::Any, ::Any, ::ProjectionInverseRetraction)

function inverse_retract_project!(::AbstractSphere, X, p, q)
    return (X .= q ./ real(dot(p, q)) .- p)
end

"""
    is_flat(M::AbstractSphere)

Return true if [`AbstractSphere`](@ref) is of dimension 1 and false otherwise.
"""
is_flat(M::AbstractSphere) = manifold_dimension(M) == 1

@doc raw"""
    local_metric(M::Sphere{n}, p, ::DefaultOrthonormalBasis)

return the local representation of the metric in a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`), namely
the diagonal matrix of size ``n×n`` with ones on the diagonal, since the metric is obtained
from the embedding by restriction to the tangent space ``T_p\mathcal M`` at ``p``.
"""
function local_metric(M::Sphere{ℝ, Tuple{Int}}, p, ::DefaultOrthonormalBasis)
    n = get_parameter(M.size)[1]
    return Diagonal(ones(eltype(p), n))
end
function local_metric(
        ::Sphere{ℝ, TypeParameter{Tuple{n}}},
        p,
        B::DefaultOrthonormalBasis,
    ) where {n}
    return Diagonal(ones(SVector{n, eltype(p)}))
end

@doc raw"""
    log(M::AbstractSphere, p, q)

Compute the logarithmic map on the [`AbstractSphere`](@ref) `M`, i.e. the tangent vector,
whose geodesic starting from `p` reaches `q` after time 1.
The formula reads for ``x ≠ -y``

````math
\log_p q = d_{𝕊}(p,q) \frac{q-\Re(⟨p,q⟩) p}{\lVert q-\Re(⟨p,q⟩) p \rVert_2},
````

and a deterministic choice from the set of tangent vectors is returned if ``x=-y``, i.e. for
opposite points.
"""
log(::AbstractSphere, ::Any...)

function log!(M::AbstractSphere, X, p, q)
    cosθ = clamp(real(dot(p, q)), -1, 1)
    if cosθ ≈ -1 # appr. opposing points, return deterministic choice from set-valued log
        fill!(X, zero(eltype(X)))
        if p[1] ≈ 1
            X[2] = 1
        else
            X[1] = 1
        end
        copyto!(X, X .- real(dot(p, X)) .* p)
        X .*= π / norm(X)
    else
        θ = acos(cosθ)
        X .= (q .- cosθ .* p) ./ usinc(θ)
    end
    return project!(M, X, p, X)
end

@doc raw"""
    manifold_dimension(M::AbstractSphere)

Return the dimension of the [`AbstractSphere`](@ref) `M`, respectively i.e. the
dimension of the embedding -1.
"""
manifold_dimension(M::AbstractSphere) = manifold_dimension(get_embedding(M)) - 1

@doc raw"""
    manifold_volume(M::AbstractSphere{ℝ})

Volume of the ``n``-dimensional [`Sphere`](@ref) `M`. The formula reads

````math
\operatorname{Vol}(𝕊^{n}) = \frac{2\pi^{(n+1)/2}}{Γ((n+1)/2)},
````

where ``Γ`` denotes the [Gamma function](https://en.wikipedia.org/wiki/Gamma_function).
"""
function manifold_volume(M::AbstractSphere{ℝ})
    n = manifold_dimension(M) + 1
    return 2 * pi^(n / 2) / gamma(n / 2)
end

"""
    mean(
        S::AbstractSphere,
        x::AbstractVector,
        [w::AbstractWeights,]
        method = GeodesicInterpolationWithinRadius(π/2);
        kwargs...,
    )

Compute the Riemannian [`mean`](@ref mean(M::AbstractManifold, args...)) of `x` using
[`GeodesicInterpolationWithinRadius`](@extref `ManifoldsBase.GeodesicInterpolationWithinRadius`).
"""
mean(::AbstractSphere, ::Any...)

function default_approximation_method(::AbstractSphere, ::typeof(mean))
    return GeodesicInterpolationWithinRadius(π / 2)
end

"""
    default_retraction_method(M::AbstractSphere)

The default retraction on the sphere is usually the exponential map. Howeverm since that map
tends to be very sensitive to also only slight errors in tangent vectors (not being tangent),
we use a stabilized version as default that projects onto the sphere afterwards, see
[`StabilizedRetraction`](@extref `ManifoldsBase.StabilizedRetraction`).
"""
default_retraction_method(::AbstractSphere) = StabilizedRetraction(ExponentialRetraction())

function mid_point!(S::Sphere, q, p1, p2)
    q .= p1 .+ p2
    project!(S, q, q)
    return q
end

@doc raw"""
    project(M::AbstractSphere, p)

Project the point `p` from the embedding onto the [`Sphere`](@ref) `M`.

````math
\operatorname{proj}(p) = \frac{p}{\lVert p \rVert},
````
where ``\lVert⋅\rVert`` denotes the usual 2-norm for vectors if ``m=1`` and the Frobenius
norm for the case ``m>1``.
"""
project(::AbstractSphere, ::Any)

project!(::AbstractSphere, q, p) = (q .= p ./ norm(p))

@doc raw"""
    project(M::AbstractSphere, p, X)

Project the point `X` onto the tangent space at `p` on the [`Sphere`](@ref) `M`.

````math
\operatorname{proj}_{p}(X) = X - \Re(⟨p, X⟩)p
````
"""
project(::AbstractSphere, ::Any, ::Any)

project!(::AbstractSphere, Y, p, X) = (Y .= X .- real(dot(p, X)) .* p)

function Random.rand!(
        rng::AbstractRNG,
        M::AbstractSphere,
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if vector_at === nothing
        project!(M, pX, randn(rng, eltype(pX), representation_size(M)))
    else
        n = σ * randn(rng, eltype(pX), size(pX)) # Gaussian in embedding
        project!(M, pX, vector_at, n) #project to TpM (keeps Gaussianness)
    end
    return pX
end

@doc raw"""
    representation_size(M::AbstractSphere)

Return the size points on the [`AbstractSphere`](@ref) `M` are represented as, i.e., the
representation size of the embedding.
"""
function representation_size(M::ArraySphere)
    return get_parameter(M.size)
end
function representation_size(M::Sphere)
    n = get_parameter(M.size)[1]
    return (n + 1,)
end

@doc raw"""
    retract(M::AbstractSphere, p, X, ::ProjectionRetraction)

Compute the retraction that is based on projection, i.e.

````math
\operatorname{retr}_p(X) = \frac{p+X}{\lVert p+X \rVert_2}
````
"""
retract(::AbstractSphere, ::Any, ::Any, ::ProjectionRetraction)

function ManifoldsBase.retract_project!(M::AbstractSphere, q, p, X)
    q .= p .+ X
    return project!(M, q, q)
end
function ManifoldsBase.retract_project_fused!(M::AbstractSphere, q, p, X, t::Number)
    q .= p .+ t .* X
    return project!(M, q, q)
end

function Base.show(io::IO, ::Sphere{𝔽, TypeParameter{Tuple{n}}}) where {n, 𝔽}
    return print(io, "Sphere($(n)$(𝔽 == ManifoldsBase.ℝ ? "" : ", $𝔽"))")
end
function Base.show(io::IO, M::Sphere{𝔽, Tuple{Int}}) where {𝔽}
    n = get_parameter(M.size)[1]
    return print(io, "Sphere($(n)$(𝔽 == ManifoldsBase.ℝ ? "" : ", $𝔽"); parameter=:field)")
end
function Base.show(io::IO, ::ArraySphere{𝔽, TypeParameter{tn}}) where {tn, 𝔽}
    return print(io, "ArraySphere($(join(tn.parameters, ", "))$(𝔽 == ManifoldsBase.ℝ ? "" : "; field=$(𝔽)"))")
end
function Base.show(io::IO, M::ArraySphere{𝔽, <:Tuple}) where {𝔽}
    n = M.size
    return print(io, "ArraySphere($(join(n, ", "));$(𝔽 == ManifoldsBase.ℝ ? "" : " field=$(𝔽),") parameter=:field)")
end

@doc raw"""
    parallel_transport_to(M::AbstractSphere, p, X, q)

Compute the parallel transport on the [`Sphere`](@ref) of the tangent vector `X` at `p`
to `q`, provided, the [`geodesic`](@extref `ManifoldsBase.geodesic-Tuple{AbstractManifold, Any, Any}`) between `p` and `q` is unique. The formula reads

````math
P_{p←q}(X) = X - \frac{\Re(⟨\log_p q,X⟩_p)}{d^2_𝕊(p,q)}
\bigl(\log_p q + \log_q p \bigr).
````
"""
parallel_transport_to(::AbstractSphere, ::Any, ::Any, ::Any, ::Any)

function parallel_transport_to!(::AbstractSphere, Y, p, X, q)
    m = p .+ q
    mnorm2 = real(dot(m, m))
    factor = 2 * real(dot(X, q)) / mnorm2
    Y .= X .- m .* factor
    return Y
end

@doc raw"""
    riemann_tensor(M::AbstractSphere{ℝ}, p, X, Y, Z)

Compute the Riemann tensor ``R(X,Y)Z`` at point `p` on [`AbstractSphere`](@ref) `M`.
The formula reads [MuralidharanFlecther:2012](@cite) (though note that a different convention is
used in that paper than in Manifolds.jl):

````math
R(X,Y)Z = \langle Z, Y \rangle X - \langle Z, X \rangle Y
````
"""
riemann_tensor(M::AbstractSphere{ℝ}, p, X, Y, Z)

function riemann_tensor!(M::AbstractSphere{ℝ}, Xresult, p, X, Y, Z)
    innerZX = inner(M, p, Z, X)
    innerZY = inner(M, p, Z, Y)
    Xresult .= innerZY .* X .- innerZX .* Y
    return Xresult
end

@doc raw"""
    sectional_curvature(::AbstractSphere, p, X, Y)

Sectional curvature of [`AbstractSphere`](@ref) `M` is 1 if dimension is greater than 1
and 0 otherwise.
"""
function sectional_curvature(M::AbstractSphere, p, X, Y)
    return manifold_dimension(M) > 1 ? 1.0 : 0.0
end

@doc raw"""
    sectional_curvature_max(::AbstractSphere)

Sectional curvature of [`AbstractSphere`](@ref) `M` is 1 if dimension is greater than 1
and 0 otherwise.
"""
function sectional_curvature_max(M::AbstractSphere)
    return manifold_dimension(M) > 1 ? 1.0 : 0.0
end

@doc raw"""
    sectional_curvature_min(M::AbstractSphere)

Sectional curvature of [`AbstractSphere`](@ref) `M` is 1 if dimension is greater than 1
and 0 otherwise.
"""
function sectional_curvature_min(M::AbstractSphere)
    return manifold_dimension(M) > 1 ? 1.0 : 0.0
end

@doc raw"""
    volume_density(M::AbstractSphere{ℝ}, p, X)

Compute volume density function of a sphere, i.e. determinant of the differential of
exponential map `exp(M, p, X)`. The formula reads ``(\sin(\lVert X\rVert)/\lVert X\rVert)^(n-1)``
where `n` is the dimension of `M`. It is derived from Eq. (4.1) in [ChevallierLiLuDunson:2022](@cite).
"""
function volume_density(M::AbstractSphere{ℝ}, p, X)
    Xnorm = norm(X)
    n = manifold_dimension(M) - 1
    return usinc(Xnorm)^n
end

@doc raw"""
    Y = Weingarten(M::Sphere, p, X, V)
    Weingarten!(M::Sphere, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Sphere`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

The formula is due to [AbsilMahonyTrumpf:2013](@cite) given by

```math
\mathcal W_p(X,V) = -Xp^{\mathrm{T}}V
```
"""
Weingarten(::Sphere, p, X, V)

function Weingarten!(::Sphere, Y, p, X, V)
    Y .= -dot(p, V) .* X
    return Y
end

"""
    StereographicAtlas()

The stereographic atlas of ``S^n`` with two charts: one with the singular
point (-1, 0, ..., 0) (called `:north`) and one with the singular
point (1, 0, ..., 0) (called `:south`).
"""
struct StereographicAtlas <: AbstractAtlas{ℝ} end

function get_chart_index(::Sphere{ℝ}, ::StereographicAtlas, p)
    if p[1] < 0
        return :south
    else
        return :north
    end
end

function get_parameters!(::Sphere{ℝ}, x, ::StereographicAtlas, i::Symbol, p)
    if i === :north
        return x .= p[2:end] ./ (1 + p[1])
    else
        return x .= p[2:end] ./ (1 - p[1])
    end
end

function get_point!(::Sphere{ℝ}, p, ::StereographicAtlas, i::Symbol, x)
    xnorm2 = dot(x, x)
    if i === :north
        p[1] = (1 - xnorm2) / (xnorm2 + 1)
    else
        p[1] = (xnorm2 - 1) / (xnorm2 + 1)
    end
    p[2:end] .= 2 * x / (xnorm2 + 1)
    return p
end

function get_coordinates_induced_basis!(
        M::Sphere{ℝ},
        Y,
        p,
        X,
        B::InducedBasis{ℝ, TangentSpaceType, <:StereographicAtlas},
    )
    n = get_parameter(M.size)[1]
    if B.i === :north
        for i in 1:n
            Y[i] = X[i + 1] / (1 + p[1]) - X[1] * p[i + 1] / (1 + p[1])^2
        end
    else
        for i in 1:n
            Y[i] = X[i + 1] / (-1 + p[1]) - X[1] * p[i + 1] / (-1 + p[1])^2
        end
    end
    return Y
end

function get_vector_induced_basis!(
        M::Sphere{ℝ},
        Y,
        p,
        X,
        B::InducedBasis{ℝ, TangentSpaceType, <:StereographicAtlas},
    )
    n = get_parameter(M.size)[1]
    a = get_parameters(M, B.A, B.i, p)
    mult = inv(1 + dot(a, a))^2

    Y[1] = 0
    for j in 1:n
        Y[1] -= 4 * a[j] * mult * X[j]
    end
    for i in 2:(n + 1)
        Y[i] = 0
        for j in 1:n
            if i == j + 1
                Y[i] += 2 * (1 + dot(a, a) - 2 * a[i - 1]^2) * mult * X[j]
            else
                Y[i] -= 4 * a[i - 1] * a[j] * mult * X[j]
            end
        end
        if B.i === :south
            Y[i] *= -1
        end
    end
    return Y
end

function local_metric(
        M::Sphere{ℝ},
        p,
        B::InducedBasis{ℝ, TangentSpaceType, StereographicAtlas, Symbol},
    )
    a = get_parameters(M, B.A, B.i, p)
    return (4 / (1 + dot(a, a))^2) * I
end

include("../header.jl")

@testset "MultinomialMatrices manifold" begin
    M = MultinomialMatrices(3, 2)
    @testset "MultinomialMatrices manifold Basics" begin
        @test ProbabilitySimplex(2)^3 === MultinomialMatrices(3, 3)
        @test ProbabilitySimplex(2)^(3,) === PowerManifold(ProbabilitySimplex(2), 3)
        @test ^(ProbabilitySimplex(2), 2) === MultinomialMatrices(3, 2)
        @test typeof(^(ProbabilitySimplex(2), 2)) == MultinomialMatrices{
            TypeParameter{Tuple{3, 2}},
            ProbabilitySimplex{TypeParameter{Tuple{2}}, :open},
        }
        @test repr(M) == "MultinomialMatrices(3, 2)"
        @test representation_size(M) == (3, 2)
        @test manifold_dimension(M) == 4
        @test !is_flat(M)
        @test Manifolds.get_iterator(ProbabilitySimplex(3)^4) === Base.OneTo(4)
        p = [2, 0, 0]
        p2 = [p p]
        @test !is_point(M, p)
        @test_throws DomainError is_point(M, p; error = :error)
        @test !is_point(M, p2)
        @test_throws CompositeManifoldError is_point(M, p2; error = :error)
        @test !is_vector(M, p2, 0.0)
        @test_throws CompositeManifoldError{ComponentManifoldError{Int64, DomainError}} is_vector(
            M,
            p2,
            [-1.0, 0.0, 0.0];
            error = :error,
        )
        @test !is_vector(M, p2, [-1.0, 0.0, 0.0])
        @test_throws DomainError is_vector(M, p, [-1.0, 0.0, 0.0]; error = :error)
        @test injectivity_radius(M) ≈ 0
        x = [0.5 0.4 0.1; 0.5 0.4 0.1]'
        @test_throws DomainError is_vector(M, x, [0.0, 0.0, 0.0]; error = :error) # tangent wrong
        y = [0.6 0.3 0.1; 0.4 0.5 0.1]'
        z = [0.3 0.6 0.1; 0.6 0.3 0.1]'
        Manifolds.test_manifold(
            M,
            [x, y, z],
            test_injectivity_radius = false,
            test_vector_spaces = true,
            test_project_tangent = false,
            test_musical_isomorphisms = true,
            test_default_vector_transport = false,
            is_tangent_atol_multiplier = 5.0,
            test_inplace = true,
        )
    end
    @testset "field parameter" begin
        M = ProbabilitySimplex(2; parameter = :field)
        @test typeof(^(M, 2)) ==
            MultinomialMatrices{Tuple{Int64, Int64}, ProbabilitySimplex{Tuple{Int64}, :open}}

        M = MultinomialMatrices(3, 2; parameter = :field)
        @test repr(M) == "MultinomialMatrices(3, 2; parameter=:field)"
    end
    @testset "Riemannian Gradient" begin
        M = MultinomialMatrices(3, 2)
        p = [0.5 0.4 0.1; 0.5 0.4 0.1]'
        Y = [1.0 -1.0; 0.0 0.0; -1.0 1.0]
        G = project(M, p, p .* Y)
        X = riemannian_gradient(M, p, Y)
        @test isapprox(M, p, G, X)
    end
end

## product manifold

"""
    ProductPointDistribution(M::ProductManifold, distributions)

Product distribution on manifold `M`, combined from `distributions`.
"""
struct ProductPointDistribution{
        TM <: ProductManifold,
        TD <: (NTuple{N, Distribution} where {N}),
    } <: MPointDistribution{TM}
    manifold::TM
    distributions::TD
end

function ProductPointDistribution(M::ProductManifold, distributions::MPointDistribution...)
    return ProductPointDistribution{typeof(M), typeof(distributions)}(M, distributions)
end
function ProductPointDistribution(distributions::MPointDistribution...)
    M = ProductManifold(map(d -> support(d).manifold, distributions)...)
    return ProductPointDistribution(M, distributions...)
end

"""
    ProductFVectorDistribution([type::VectorSpaceFiber], [x], distrs...)

Generates a random vector at point `x` from vector space (a fiber of a tangent
bundle) of type `type` using the product distribution of given distributions.

Vector space type and `x` can be automatically inferred from distributions `distrs`.
"""
struct ProductFVectorDistribution{
        TSpace <: VectorSpaceFiber{<:Any, <:ProductManifold},
        TD <: (NTuple{N, Distribution} where {N}),
    } <: FVectorDistribution{TSpace}
    type::TSpace
    distributions::TD
end

function ProductFVectorDistribution(distributions::FVectorDistribution...)
    M = ProductManifold(map(d -> support(d).space.manifold, distributions)...)
    fiber_type = support(distributions[1]).space.fiber_type
    !all(d -> support(d).space.fiber_type == fiber_type, distributions) && error(
        "Not all distributions have support in vector spaces of the same type, which is currently not supported",
    )
    # Probably worth considering sum spaces in the future?
    p = ArrayPartition(map(d -> support(d).space.point, distributions)...)
    return ProductFVectorDistribution(Fiber(M, p, fiber_type), distributions)
end

function Random.rand(rng::AbstractRNG, d::ProductFVectorDistribution)
    return ArrayPartition(map(d -> rand(rng, d), d.distributions)...)
end
function Random.rand(rng::AbstractRNG, d::ProductPointDistribution)
    return ArrayPartition(map(d -> rand(rng, d), d.distributions)...)
end

function Distributions._rand!(
        rng::AbstractRNG,
        d::ProductFVectorDistribution,
        X::ArrayPartition,
    )
    map(
        (t1, t2) -> Distributions._rand!(rng, t1, t2),
        d.distributions,
        submanifold_components(d.type.manifold, X),
    )
    return X
end
function Distributions._rand!(
        rng::AbstractRNG,
        d::ProductPointDistribution,
        p::ArrayPartition,
    )
    map(
        (t1, t2) -> Distributions._rand!(rng, t1, t2),
        d.distributions,
        submanifold_components(d.manifold, p),
    )
    return p
end

Distributions.support(d::ProductPointDistribution) = MPointSupport(d.manifold)
function Distributions.support(tvd::ProductFVectorDistribution)
    return FVectorSupport(tvd.type)
end

function uniform_distribution(M::ProductManifold)
    return ProductPointDistribution(M, map(uniform_distribution, M.manifolds))
end
function uniform_distribution(M::ProductManifold, p)
    return ProductPointDistribution(
        M,
        map(uniform_distribution, M.manifolds, submanifold_components(M, p)),
    )
end

## power manifold

"""
    PowerPointDistribution(M::AbstractPowerManifold, distribution)

Power distribution on manifold `M`, based on `distribution`.
"""
struct PowerPointDistribution{TM <: AbstractPowerManifold, TD <: MPointDistribution, TX} <:
    MPointDistribution{TM}
    manifold::TM
    distribution::TD
    point::TX
end

"""
    PowerFVectorDistribution([type::VectorSpaceFiber], [x], distr)

Generates a random vector at a `point` from vector space (a fiber of a tangent
bundle) of type `type` using the power distribution of `distr`.

Vector space type and `point` can be automatically inferred from distribution `distr`.
"""
struct PowerFVectorDistribution{TSpace <: VectorSpaceFiber, TD <: FVectorDistribution} <:
    FVectorDistribution{TSpace}
    type::TSpace
    distribution::TD
end

function Random.rand(rng::AbstractRNG, d::PowerFVectorDistribution)
    fv = zero_vector(d.type.manifold, d.type.point)
    Distributions._rand!(rng, d, fv)
    return fv
end
function Random.rand(rng::AbstractRNG, d::PowerPointDistribution)
    x = allocate_result(d.manifold, rand, d.point)
    Distributions._rand!(rng, d, x)
    return x
end

function Distributions._rand!(
        rng::AbstractRNG,
        d::PowerFVectorDistribution,
        v::AbstractArray,
    )
    PM = d.type.manifold
    rep_size = representation_size(PM.manifold)
    for i in get_iterator(d.type.manifold)
        copyto!(d.distribution.type.point, _read(PM, rep_size, d.type.point, i))
        Distributions._rand!(rng, d.distribution, _read(PM, rep_size, v, i))
    end
    return v
end
function Distributions._rand!(rng::AbstractRNG, d::PowerPointDistribution, x::AbstractArray)
    M = d.manifold
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Distributions._rand!(rng, d.distribution, _write(M, rep_size, x, i))
    end
    return x
end

Distributions.support(tvd::PowerFVectorDistribution) = FVectorSupport(tvd.type)
Distributions.support(d::PowerPointDistribution) = MPointSupport(d.manifold)

# Rotations

"""
    NormalRotationDistribution(M::Rotations, d::Distribution, x::TResult)

Distribution that returns a random point on the manifold [`Rotations`](@ref)
`M`. Random point is generated using base distribution `d` and the type
of the result is adjusted to `TResult`.

See [`normal_rotation_distribution`](@ref) for details.
"""
struct NormalRotationDistribution{TResult, TM <: Rotations, TD <: Distribution} <:
    MPointDistribution{TM}
    manifold::TM
    distr::TD
end

function NormalRotationDistribution(
        M::Rotations,
        d::Distribution,
        x::TResult,
    ) where {TResult}
    return NormalRotationDistribution{TResult, typeof(M), typeof(d)}(M, d)
end

function normal_rotation_distribution(M::Rotations, p, σ::Real)
    n = get_parameter(M.size)[1]
    d = Distributions.MvNormal(zeros(n * n), σ * I)
    return NormalRotationDistribution(M, d, p)
end

function _fix_random_rotation(A::AbstractMatrix)
    s = diag(sign.(qr(A).R))
    D = Diagonal(s)
    C = qr(A).Q * D
    if det(C) < 0
        C[:, [1, 2]] = C[:, [2, 1]]
    end
    return C
end

function Random.rand(
        rng::AbstractRNG,
        d::NormalRotationDistribution{TResult, <:Rotations},
    ) where {TResult}
    n = get_parameter(d.manifold.size)[1]
    return if n == 1
        convert(TResult, ones(1, 1))
    else
        A = reshape(rand(rng, d.distr), (n, n))
        convert(TResult, _fix_random_rotation(A))
    end
end

function Distributions._rand!(
        rng::AbstractRNG,
        d::NormalRotationDistribution,
        x::AbstractArray{<:Real},
    )
    return copyto!(x, rand(rng, d))
end

Distributions.support(d::NormalRotationDistribution) = MPointSupport(d.manifold)

module ManifoldsDistributionsExt

using Manifolds
using Distributions
using Random
using LinearAlgebra

import Manifolds:
    normal_rotation_distribution,
    normal_tvector_distribution,
    projected_distribution,
    uniform_distribution

using Manifolds: get_iterator, get_parameter, _read, _write

using RecursiveArrayTools: ArrayPartition

include("distributions.jl")
include("distributions_for_manifolds.jl")
include("projected_distribution.jl")

end

@doc raw"""
    AffineInvariantMetric <: AbstractMetric

The linear affine metric is the metric for symmetric positive definite matrices, that employs
matrix logarithms and exponentials, which yields a linear and affine metric.
"""
struct AffineInvariantMetric <: RiemannianMetric end

@doc raw"""
    change_representer(M::SymmetricPositiveDefinite, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal M`` representing a linear function on the tangent
space at `p` with respect to the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
`g_E`, this is turned into the representer with respect to the (default) metric,
the [`AffineInvariantMetric`](@ref) on the [`SymmetricPositiveDefinite`](@ref) `M`.

To be precise we are looking for ``Z∈T_p\mathcal P(n)`` such that for all ``Y∈T_p\mathcal P(n)```
it holds

```math
⟨X,Y⟩ = \operatorname{tr}(XY) = \operatorname{tr}(p^{-1}Zp^{-1}Y) = g_p(Z,Y)
```

and hence ``Z = pXp``.
"""
change_representer(::SymmetricPositiveDefinite, ::EuclideanMetric, ::Any, ::Any)

function change_representer!(::SymmetricPositiveDefinite, Y, ::EuclideanMetric, p, X)
    Y .= p * X * p
    return Y
end

@doc raw"""
    change_metric(M::SymmetricPositiveDefinite, E::EuclideanMetric, p, X)

Given a tangent vector ``X ∈ T_p\mathcal P(n)`` with respect to the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`)
`g_E`, this function changes into the [`AffineInvariantMetric`](@ref) (default) metric on the
[`SymmetricPositiveDefinite`](@ref) `M`.

To be precise we are looking for ``c\colon T_p\mathcal P(n) → T_p\mathcal P(n) ``
such that for all ``Y,Z ∈ T_p\mathcal P(n)``` it holds

```math
⟨Y,Z⟩ = \operatorname{tr}(YZ) = \operatorname{tr}(p^{-1}c(Y)p^{-1}c(Z)) = g_p(c(Z),c(Y))
```

and hence ``c(X) = pX`` is computed.
"""
change_metric(::SymmetricPositiveDefinite, ::EuclideanMetric, ::Any, ::Any)

function change_metric!(::SymmetricPositiveDefinite, Y, ::EuclideanMetric, p, X)
    Y .= p * X
    return Y
end

@doc raw"""
    distance(M::SymmetricPositiveDefinite, p, q)
    distance(M::MetricManifold{SymmetricPositiveDefinite,AffineInvariantMetric}, p, q)

Compute the distance on the [`SymmetricPositiveDefinite`](@ref) manifold between `p` and `q`,
as a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with [`AffineInvariantMetric`](@ref). The formula reads

```math
d_{\mathcal P(n)}(p,q)
= \lVert \operatorname{Log}(p^{-\frac{1}{2}}qp^{-\frac{1}{2}})\rVert_{\mathrm{F}}.,
```
where ``\operatorname{Log}`` denotes the matrix logarithm and
``\lVert⋅\rVert_{\mathrm{F}}`` denotes the matrix Frobenius norm.
"""
function distance(::SymmetricPositiveDefinite, p, q)
    # avoid numerical instabilities in cholesky
    norm(p - q) < eps(eltype(p + q)) && return zero(eltype(p + q))
    cq = cholesky(Symmetric(q)) # to avoid numerical inaccuracies
    s = eigvals(Symmetric(cq.L \ p / cq.U))
    return any(s .<= eps()) ? zero(eltype(p)) : sqrt(sum(abs.(log.(s)) .^ 2))
end
function distance(M::SymmetricPositiveDefinite, p::SPDPoint, q::SPDPoint)
    return distance(M, convert(AbstractMatrix, p), convert(AbstractMatrix, q))
end

@doc raw"""
    exp(M::SymmetricPositiveDefinite, p, X)
    exp(M::MetricManifold{<:SymmetricPositiveDefinite,AffineInvariantMetric}, p, X)

Compute the exponential map from `p` with tangent vector `X` on the
[`SymmetricPositiveDefinite`](@ref) `M` with its default [`MetricManifold`](@extref ManifoldsBase.MetricManifold) having the
[`AffineInvariantMetric`](@ref). The formula reads

```math
\exp_p X = p^{\frac{1}{2}}\operatorname{Exp}(p^{-\frac{1}{2}} X p^{-\frac{1}{2}})p^{\frac{1}{2}},
```

where ``\operatorname{Exp}`` denotes to the matrix exponential.
"""
exp(::SymmetricPositiveDefinite, ::Any...)

function exp(::SymmetricPositiveDefinite, p::SPDPoint, X)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * X * p_sqrt_inv)
    eig1 = eigen(T) # numerical stabilization
    Se = Diagonal(exp.(eig1.values))
    Ue = eig1.vectors
    pUe = p_sqrt * Ue
    q = SPDPoint(
        pUe * Se * transpose(pUe),
        store_p = !ismissing(p.p),
        store_sqrt = !ismissing(p.sqrt),
        store_sqrt_inv = !ismissing(p.sqrt_inv),
    )
    return q
end

function exp_fused!(M::SymmetricPositiveDefinite, q, p, X, t::Number)
    return exp!(M, q, p, t * X)
end
function exp!(::SymmetricPositiveDefinite, q, p, X)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * X * p_sqrt_inv)
    eig1 = eigen(T) # numerical stabilization
    Se = Diagonal(exp.(eig1.values))
    Ue = eig1.vectors
    pUe = p_sqrt * Ue
    return copyto!(q, pUe * Se * transpose(pUe))
end
function exp!(::SymmetricPositiveDefinite, q::SPDPoint, p, X)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * X * p_sqrt_inv)
    eig1 = eigen(T) # numerical stabilization
    Se = Diagonal(exp.(eig1.values))
    Ue = eig1.vectors
    pUe = p_sqrt * Ue
    Q = pUe * Se * transpose(pUe)
    !ismissing(q.p) && copyto!(q.p, Q)
    Q_e = eigen(Q)
    copyto!(q.eigen.values, Q_e.values)
    copyto!(q.eigen.vectors, Q_e.vectors)
    if !ismissing(q.sqrt) && !ismissing(q.sqrt_inv)
        copyto!.([q.sqrt, q.sqrt_inv], spd_sqrt_and_sqrt_inv(Q))
    else
        !ismissing(q.sqrt) && copyto!(q.sqrt, spd_sqrt(Q))
        !ismissing(q.sqrt_inv) && copyto!(q.sqrt_inv, spd_sqrt_inv(Q))
    end
    return q
end

@doc raw"""
    [Ξ,κ] = get_basis_diagonalizing(M::SymmetricPositiveDefinite, p, B::DiagonalizingOrthonormalBasis)
    [Ξ,κ] = get_basis_diagonalizing(M::MetricManifold{<:SymmetricPositiveDefinite,AffineInvariantMetric}, p, B::DiagonalizingOrthonormalBasis)

Return a orthonormal basis `Ξ` as a vector of tangent vectors (of length
[`manifold_dimension`](@ref) of `M`) in the tangent space of `p` on the
[`MetricManifold`](@extref ManifoldsBase.MetricManifold) of [`SymmetricPositiveDefinite`](@ref) manifold `M` with
[`AffineInvariantMetric`](@ref) that diagonalizes the curvature tensor ``R(u,v)w``
with eigenvalues `κ` and where the direction `B.frame_direction` ``V`` has curvature `0`.

The construction is based on an ONB for the symmetric matrices similar to [`get_basis(::SymmetricPositiveDefinite, p, ::DefaultOrthonormalBasis`](@ref  get_basis(M::SymmetricPositiveDefinite,p,B::DefaultOrthonormalBasis{<:Any,ManifoldsBase.TangentSpaceType}))
just that the ONB here is build from the eigen vectors of ``p^{\frac{1}{2}}Vp^{\frac{1}{2}}``.
"""
function get_basis_diagonalizing(
        M::SymmetricPositiveDefinite,
        p,
        B::DiagonalizingOrthonormalBasis,
    )
    N = get_parameter(M.size)[1]
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    eigv = eigen(Symmetric(p_sqrt_inv * B.frame_direction * p_sqrt_inv))
    V = eigv.vectors
    Ξ = [
        (i == j ? 1 / 2 : 1 / sqrt(2)) *
            p_sqrt *
            (V[:, i] * transpose(V[:, j]) + V[:, j] * transpose(V[:, i])) *
            p_sqrt for i in 1:N for j in i:N
    ]
    λ = eigv.values
    κ = [-1 / 4 * (λ[i] - λ[j])^2 for i in 1:N for j in i:N]
    return CachedBasis(B, κ, Ξ)
end

@doc raw"""
    [Ξ,κ] = get_basis(M::SymmetricPositiveDefinite, p, B::DefaultOrthonormalBasis)
    [Ξ,κ] = get_basis(M::MetricManifold{<:SymmetricPositiveDefinite,AffineInvariantMetric}, p, B::DefaultOrthonormalBasis)

Return a default ONB for the tangent space ``T_p\mathcal P(n)`` of the [`SymmetricPositiveDefinite`](@ref) with respect to the [`AffineInvariantMetric`](@ref).

```math
    g_p(X,Y) = \operatorname{tr}(p^{-1} X p^{-1} Y),
```

The basis constructed here is based on the ONB for symmetric matrices constructed as follows.
Let

```math
\Delta_{i,j} = (a_{k,l})_{k,l=1}^n \quad \text{ with }
a_{k,l} =
\begin{cases}
  1 & \mbox{ for } k=l \text{ if } i=j\\
  \frac{1}{\sqrt{2}} & \mbox{ for } k=i, l=j \text{ or } k=j, l=i\\
  0 & \text{ else.}
\end{cases}
```

which forms an ONB for the space of symmetric matrices.

We then form the ONB by
```math
   \Xi_{i,j} = p^{\frac{1}{2}}\Delta_{i,j}p^{\frac{1}{2}},\qquad i=1,\ldots,n, j=i,\ldots,n.
```
"""
get_basis(::SymmetricPositiveDefinite, p, B::DefaultOrthonormalBasis)

function get_basis_orthonormal(M::SymmetricPositiveDefinite, p, Ns::RealNumbers)
    N = get_parameter(M.size)[1]
    p_sqrt = spd_sqrt(p)
    Ξ = [similar(convert(AbstractMatrix, p)) for _ in 1:manifold_dimension(M)]
    k = 1
    for i in 1:N, j in i:N
        fill!(Ξ[k], zero(eltype(Ξ[k])))
        s = i == j ? 1 / 2 : 1 / sqrt(2)
        @inbounds Ξ[k][i, j] += 1
        @inbounds Ξ[k][j, i] += 1
        @inbounds Ξ[k] .= s * p_sqrt * Ξ[k] * p_sqrt
        k += 1
    end
    return CachedBasis(DefaultOrthonormalBasis(Ns), Ξ)
end

@doc raw"""
    get_coordinates(::SymmetricPositiveDefinite, p, X, ::DefaultOrthonormalBasis)

Using the basis from [`get_basis`](@ref get_basis(M::SymmetricPositiveDefinite,p,B::DefaultOrthonormalBasis{<:Any,ManifoldsBase.TangentSpaceType}))
the coordinates with respect to this ONB can be simplified to

```math
   c_k = \mathrm{tr}(p^{-\frac{1}{2}}\Delta_{i,j} X)
```
where ``k`` is trhe linearized index of the ``i=1,\ldots,n, j=i,\ldots,n``.
"""
get_coordinates(::SymmetricPositiveDefinite, c, p, X, ::DefaultOrthonormalBasis)

function get_coordinates_orthonormal!(M::SymmetricPositiveDefinite, c, p, X, ::RealNumbers)
    N = get_parameter(M.size)[1]
    dim = manifold_dimension(M)
    @assert size(c) == (dim,)
    @assert size(X) == (N, N)
    @assert dim == div(N * (N + 1), 2)
    p_sqrt = spd_sqrt(p)
    pM = convert(AbstractMatrix, p)
    k = 1
    V = similar(pM)
    fill!(V, zero(eltype(V)))
    F = cholesky(Symmetric(pM))
    for i in 1:N, j in i:N
        s = i == j ? 1 / 2 : 1 / sqrt(2)
        @inbounds V[i, j] += 1
        @inbounds V[j, i] += 1
        Yij = p_sqrt * V * p_sqrt
        @inbounds c[k] = s * dot(F \ Symmetric(X), (Symmetric(Yij) / F))
        k += 1
        @inbounds V[i, j] = 0
        @inbounds V[j, i] = 0
    end
    return c
end

@doc raw"""
    get_vector(::SymmetricPositiveDefinite, p, c, ::DefaultOrthonormalBasis)

Using the basis from [`get_basis`](@ref  get_basis(M::SymmetricPositiveDefinite,p,B::DefaultOrthonormalBasis{<:Any,ManifoldsBase.TangentSpaceType}))
the vector reconstruction with respect to this ONB can be simplified to

```math
   X = p^{\frac{1}{2}} \Biggl( \sum_{i=1,j=i}^n c_k \Delta_{i,j} \Biggr) p^{\frac{1}{2}}
```
where ``k`` is the linearized index of the ``i=1,\ldots,n, j=i,\ldots,n``.
"""
get_vector(::SymmetricPositiveDefinite, X, p, c, ::DefaultOrthonormalBasis)

function get_vector_orthonormal!(M::SymmetricPositiveDefinite, X, p, c, ::RealNumbers)
    N = get_parameter(M.size)[1]
    @assert size(c) == (div(N * (N + 1), 2),)
    @assert size(X) == (N, N)
    p_sqrt = spd_sqrt(p)
    X .= 0
    k = 1
    V = similar(convert(AbstractMatrix, p))
    fill!(V, zero(eltype(V)))
    for i in 1:N, j in i:N
        s = i == j ? 1 / 2 : 1 / sqrt(2)
        @inbounds V[i, j] += 1
        @inbounds V[j, i] += 1
        Vij = p_sqrt * V * p_sqrt
        @. X += (s * c[k]) * Vij
        k += 1
        @inbounds V[i, j] = 0
        @inbounds V[j, i] = 0
    end
    return X
end

@doc raw"""
    inner(M::SymmetricPositiveDefinite, p, X, Y)
    inner(M::MetricManifold{SymmetricPositiveDefinite,AffineInvariantMetric}, p, X, Y)

Compute the inner product of `X`, `Y` in the tangent space of `p` on
the [`SymmetricPositiveDefinite`](@ref) manifold `M`, as
a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with [`AffineInvariantMetric`](@ref). The formula reads

````math
g_p(X,Y) = \operatorname{tr}(p^{-1} X p^{-1} Y),
````
"""
function inner(::SymmetricPositiveDefinite, p, X, Y)
    F = cholesky(Symmetric(convert(AbstractMatrix, p)))
    return dot((F \ Symmetric(X)), (Symmetric(Y) / F))
end

"""
    is_flat(::MetricManifold{ℝ,<:SymmetricPositiveDefinite,AffineInvariantMetric})

Return false. [`SymmetricPositiveDefinite`](@ref) with [`AffineInvariantMetric`](@ref)
is not a flat manifold.
"""
is_flat(M::MetricManifold{ℝ, <:SymmetricPositiveDefinite, AffineInvariantMetric}) = false

@doc raw"""
    log(M::SymmetricPositiveDefinite, p, q)
    log(M::MetricManifold{SymmetricPositiveDefinite,AffineInvariantMetric}, p, q)

Compute the logarithmic map from `p` to `q` on the [`SymmetricPositiveDefinite`](@ref)
as a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with [`AffineInvariantMetric`](@ref). The formula reads

```math
\log_p q =
p^{\frac{1}{2}}\operatorname{Log}(p^{-\frac{1}{2}}qp^{-\frac{1}{2}})p^{\frac{1}{2}},
```
where ``\operatorname{Log}`` denotes to the matrix logarithm.
"""
log(::SymmetricPositiveDefinite, ::Any...)

function allocate_result(
        M::SymmetricPositiveDefinite,
        ::typeof(log),
        q::SPDPoint,
        p::SPDPoint,
    )
    return allocate_result(M, log, convert(AbstractMatrix, q), convert(AbstractMatrix, p))
end

function log!(::SymmetricPositiveDefinite, X, p, q)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * convert(AbstractMatrix, q) * p_sqrt_inv)
    e2 = eigen(T)
    Se = Diagonal(log.(max.(e2.values, eps())))
    pUe = p_sqrt * e2.vectors
    return mul!(X, pUe, Se * transpose(pUe))
end

"""
    manifold_volume(::SymmetricPositiveDefinite)

Return volume of the [`SymmetricPositiveDefinite`](@ref) manifold, i.e. infinity.
"""
manifold_volume(::SymmetricPositiveDefinite) = Inf

@doc raw"""
    parallel_transport_to(M::SymmetricPositiveDefinite, p, X, q)
    parallel_transport_to(M::MetricManifold{SymmetricPositiveDefinite,AffineInvariantMetric}, p, X, y)

Compute the parallel transport of `X` from the tangent space at `p` to the
tangent space at `q` on the [`SymmetricPositiveDefinite`](@ref) as a
[`MetricManifold`](@extref ManifoldsBase.MetricManifold) with the [`AffineInvariantMetric`](@ref).
The formula reads

```math
\mathcal P_{q←p}X = p^{\frac{1}{2}}
\operatorname{Exp}\bigl(
\frac{1}{2}p^{-\frac{1}{2}}\log_p(q)p^{-\frac{1}{2}}
\bigr)
p^{-\frac{1}{2}}X p^{-\frac{1}{2}}
\operatorname{Exp}\bigl(
\frac{1}{2}p^{-\frac{1}{2}}\log_p(q)p^{-\frac{1}{2}}
\bigr)
p^{\frac{1}{2}},
```

where ``\operatorname{Exp}`` denotes the matrix exponential
and `log` the logarithmic map on [`SymmetricPositiveDefinite`](@ref)
(again with respect to the [`AffineInvariantMetric`](@ref)).
"""
parallel_transport_to(::SymmetricPositiveDefinite, ::Any, ::Any, ::Any)

function parallel_transport_to!(M::SymmetricPositiveDefinite, Y, p, X, q)
    distance(M, p, q) < 2 * eps(eltype(p)) && copyto!(Y, X)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    tv = Symmetric(p_sqrt_inv * X * p_sqrt_inv) # p^(-1/2)Xp^{-1/2}
    ty = Symmetric(p_sqrt_inv * convert(AbstractMatrix, q) * p_sqrt_inv) # p^(-1/2)qp^(-1/2)
    e2 = eigen(ty)
    Se = Diagonal(log.(max.(e2.values, floatmin(eltype(e2.values)))))
    Ue = e2.vectors
    logty = Symmetric(Ue * Se * transpose(Ue)) # nearly log_pq without the outer p^1/2
    e3 = eigen(logty) # since they cancel with the pInvSqrt in the next line
    Sf = Diagonal(exp.(e3.values / 2)) # Uf * Sf * Uf' is the Exp
    Uf = e3.vectors
    pUe = p_sqrt * Uf * Sf * transpose(Uf) # factors left of tv (and transposed right)
    vtp = Symmetric(pUe * tv * transpose(pUe)) # so this is the documented formula
    return copyto!(Y, vtp)
end

@doc raw"""
    riemannian_Hessian(M::SymmetricPositiveDefinite, p, G, H, X)

The Riemannian Hessian can be computed as stated in Eq. (7.3) [Nguyen:2023](@cite).
Let ``\nabla f(p)`` denote the Euclidean gradient `G`,
``\nabla^2 f(p)[X]`` the Euclidean Hessian `H`, and
``\operatorname{sym}(X) = \frac{1}{2}\bigl(X^{\mathrm{T}}+X\bigr)``
the symmetrization operator. Then the formula reads

```math
    \operatorname{Hess}f(p)[X]
    =
    p\operatorname{sym}(∇^2 f(p)[X])p
    + \operatorname{sym}\bigl( X\operatorname{sym}\bigl(∇ f(p)\bigr)p)
```
"""
riemannian_Hessian(M::SymmetricPositiveDefinite, p, G, H, X)

function riemannian_Hessian!(::SymmetricPositiveDefinite, Y, p, G, H, X)
    symmetrize!(Y, G)
    symmetrize!(Y, X * Y * p)
    Z = symmetrize(H)
    Y .+= p * Z * p
    return Y
end

@doc raw"""
    riemann_tensor(::SymmetricPositiveDefinite, p, X, Y, Z)

Compute the value of Riemann tensor on the [`SymmetricPositiveDefinite`](@ref) manifold.
The formula reads [Rentmeesters:2011](@cite) ``R(X,Y)Z=p^{1/2}R(X_I, Y_I)Z_Ip^{1/2}``, where
``R_I(X_I, Y_I)Z_I=\frac{1}{4}[Z_I, [X_I, Y_I]]``,  ``X_I=p^{-1/2}Xp^{-1/2}``,
``Y_I=p^{-1/2}Yp^{-1/2}`` and ``Z_I=p^{-1/2}Zp^{-1/2}``.
"""
riemann_tensor(::SymmetricPositiveDefinite, p, X, Y, Z)

function riemann_tensor!(::SymmetricPositiveDefinite, Xresult, p, X, Y, Z)
    ps = sqrt(p)
    ips = inv(ps)
    XI = ips * X * ips
    YI = ips * Y * ips
    ZI = ips * Z * ips
    Xtmp = XI * YI - YI * XI
    Xresult .= ps * (1 // 4 .* (ZI * Xtmp .- Xtmp * ZI)) * ps
    return Xresult
end

"""
    sectional_curvature_min(M::SymmetricPositiveDefinite)

Return minimum sectional curvature of [`SymmetricPositiveDefinite`](@ref) manifold,
that is 0 for SPD(1) and SPD(2) and -0.25 otherwise.
"""
function sectional_curvature_min(M::SymmetricPositiveDefinite)
    if manifold_dimension(M) < 2
        return 0.0
    else
        return -0.25
    end
end

"""
    sectional_curvature_max(M::SymmetricPositiveDefinite)

Return minimum sectional curvature of [`SymmetricPositiveDefinite`](@ref) manifold,
that is 0.
"""
function sectional_curvature_max(::SymmetricPositiveDefinite)
    return 0.0
end

"""
    volume_density(::SymmetricPositiveDefinite, p, X)

Compute the volume density of the [`SymmetricPositiveDefinite`](@ref) manifold at `p`
in direction `X`. See [ChevallierKalungaAngulo:2017](@cite), Section 6.2 for details.
Note that metric in Manifolds.jl has a different scaling factor than the reference.
"""
function volume_density(::SymmetricPositiveDefinite, p, X)
    eig = eigvals(X)
    dens = 1.0
    for i in 1:length(eig)
        for j in (i + 1):length(eig)
            absdiff = abs(eig[i] - eig[j])
            if absdiff > eps(absdiff)
                dens *= sinh(absdiff) / absdiff
            end
        end
    end
    return dens
end

include("../header.jl")

@testset "Probability simplex" begin
    M = ProbabilitySimplex(2)
    M_euc = MetricManifold(M, EuclideanMetric())

    @test M^4 == MultinomialMatrices(3, 4)
    p = [0.1, 0.7, 0.2]
    q = [0.3, 0.6, 0.1]
    X = zeros(3)
    Y = [-0.1, 0.05, 0.05]
    @test repr(M) == "ProbabilitySimplex(2; boundary=:open)"
    @test is_point(M, p)
    @test_throws DomainError is_point(M, p .+ 1; error = :error)
    @test_throws ManifoldDomainError is_point(M, [0]; error = :error)
    @test_throws DomainError is_point(M, -ones(3); error = :error)
    @test manifold_dimension(M) == 2
    @test !is_flat(M)
    @test is_vector(M, p, X)
    @test is_vector(M, p, Y)
    @test_throws ManifoldDomainError is_vector(M, p .+ 1, X; error = :error)
    @test_throws ManifoldDomainError is_vector(M, p, zeros(4); error = :error)
    @test_throws DomainError is_vector(M, p, Y .+ 1; error = :error)

    @test injectivity_radius(M, p) == injectivity_radius(M, p, ExponentialRetraction())
    @test injectivity_radius(M, p, SoftmaxRetraction()) == injectivity_radius(M, p)
    @test injectivity_radius(M, ExponentialRetraction()) == 0
    @test injectivity_radius(M) == 0
    @test injectivity_radius(M, SoftmaxRetraction()) == 0

    pE = similar(p)
    embed!(M, pE, p)
    @test pE == p
    XE = similar(X)
    embed!(M, XE, p, X)
    @test XE == X

    @test mean(M, [p, q]) == shortest_geodesic(M, p, q)(0.5)

    types = [Vector{Float64}]

    basis_types = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))
    for T in types
        @testset "Type $T" begin
            pts = [
                convert(T, [0.5, 0.3, 0.2]),
                convert(T, [0.4, 0.4, 0.2]),
                convert(T, [0.3, 0.5, 0.2]),
            ]
            Manifolds.test_manifold(
                M,
                pts,
                basis_types_to_from = (DefaultOrthonormalBasis(),),
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                is_tangent_atol_multiplier = 5.0,
                inverse_retraction_methods = [SoftmaxInverseRetraction()],
                retraction_methods = [SoftmaxRetraction()],
                test_inplace = true,
                vector_transport_methods = [ParallelTransport()],
                test_rand_point = true,
                test_rand_tvector = true,
                rand_tvector_atol_multiplier = 20.0,
            )
            X = similar(pts[1])
            @test exp!(M_euc, X, pts[1], [0.0, 0.1, -0.1]) ≈ [0.5, 0.4, 0.1]
            @test ManifoldsBase.exp_fused!(M_euc, X, pts[1], [0.0, 0.1, -0.1], 1.0) ≈
                [0.5, 0.4, 0.1]
            Manifolds.test_manifold(
                M_euc,
                pts,
                test_exp_log = false,
                test_injectivity_radius = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                is_tangent_atol_multiplier = 40.0,
                default_inverse_retraction_method = nothing,
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
                rand_tvector_atol_multiplier = 40.0,
            )
        end
    end

    @testset "Projection testing" begin
        p = [1 / 2, 1 / 3, 1 / 6]
        q = [0.2, 0.3, 0.5]
        X = log(M, p, q)
        X2 = X .+ 10
        Y = project(M, p, X2)
        @test isapprox(M, p, X, Y)

        # Check adaption of metric and representer
        Y1 = change_metric(M, EuclideanMetric(), p, X)
        @test Y1 ≈ [-0.17062114054478128, 0.04002429219016789, 0.13059684835461377]
        Y2 = change_representer(M, EuclideanMetric(), p, X)
        @test Y2 ≈ [-0.10040964054128285, 0.03818665287320871, 0.06222298766807415]

        X = log(M, q, p)
        X2 = X + [1, 2, 3]
        Y = project(M, q, X2)
        @test is_vector(M, q, Y; atol = 1.0e-15)

        @test_throws DomainError project(M, [1, -1, 2])
        @test isapprox(M, [0.6, 0.2, 0.2], project(M, [0.3, 0.1, 0.1]))
    end

    @testset "Gradient conversion" begin
        M = ProbabilitySimplex(4) # n=5
        # For f(p) = \sum_i 1/n log(p_i) we know the Euclidean gradient
        grad_f_eucl(p) = [1 / (5 * pi) for pi in p]
        # but we can also easily derive the Riemannian one
        grad_f(M, p) = 1 / 5 .- p
        #We take some point
        p = [0.1, 0.2, 0.4, 0.2, 0.1]
        Y = grad_f_eucl(p)
        X = grad_f(M, p)
        @test isapprox(M, p, X, riemannian_gradient(M, p, Y))
        Z = zero_vector(M, p)
        riemannian_gradient!(M, Z, p, Y)
        @test X == Z
    end

    @testset "Simplex with boundary" begin
        Mb = ProbabilitySimplex(2; boundary = :closed)
        p = [0, 0.5, 0.5]
        X = [0, 1, -1]
        Y = [0, 2, -2]
        @test is_point(Mb, p)
        @test_throws DomainError is_point(Mb, p .- 1; error = :error)
        @test inner(Mb, p, X, Y) == 8

        @test_throws ArgumentError ProbabilitySimplex(2; boundary = :tomato)
    end

    @testset "Probability amplitudes" begin
        M = ProbabilitySimplex(2)
        p = [0.1, 0.7, 0.2]
        Y = [-0.1, 0.05, 0.05]
        @test Manifolds.simplex_to_amplitude(M, p) ≈
            [0.31622776601683794, 0.8366600265340756, 0.4472135954999579]
        @test Manifolds.amplitude_to_simplex(
            M,
            [0.31622776601683794, 0.8366600265340756, 0.4472135954999579],
        ) ≈ p
        @test Manifolds.simplex_to_amplitude_diff(M, p, Y) ≈
            [-0.31622776601683794, 0.05976143046671968, 0.1118033988749895]
        @test Manifolds.amplitude_to_simplex_diff(M, p, Y) ≈ [-0.01, 0.035, 0.01]
    end

    @testset "other metric" begin
        p = [0.1, 0.7, 0.2]
        X = [-0.1, 0.05, 0.05]
        Y = [0.05, 0.05, -0.1]
        Z = [-0.1, 0.15, -0.05]
        @test riemann_tensor(M, p, X, Y, Z) ≈
            [-0.0034821428571428577, -0.005625, 0.009107142857142857]
    end

    @testset "Volume density" begin
        @test manifold_volume(M) ≈ pi / 2
        @test volume_density(M, p, Y) ≈ 0.986956111346216
        @test manifold_volume(M_euc) ≈ sqrt(3) / 2
        @test volume_density(M_euc, p, Y) ≈ 1.0
    end

    @testset "field parameter" begin
        M = ProbabilitySimplex(2; parameter = :field)
        @test repr(M) == "ProbabilitySimplex(2; boundary=:open, parameter=:field)"
        @test get_embedding(M) === Euclidean(3; parameter = :field)
    end
end

using Manifolds, ManifoldsBase, Test, StaticArrays

# This file tests a few generic functions for general unitary matricesd
# independent of their matrix type, so we check that with a dummy type

Test.@testset "GeneralUnitaryMatrices" begin
    M2 = Manifolds.GeneralUnitaryMatrices(2, ℝ, Manifolds.Test.DummyMatrixType)
    M2f = Manifolds.GeneralUnitaryMatrices(2, ℝ, Manifolds.Test.DummyMatrixType; parameter = :field)
    @testset "Basics" begin
        @test base_manifold(M2) === get_embedding(M2)
    end
    p2 = [1.0 0.0; 0.0 1.0]
    X2 = [0.0 -1.0; 1.0 0.0]
    p2S = @SMatrix [1.0 0.0; 0.0 1.0]
    X2S = @SMatrix [0.0 -1.0; 1.0 0.0]
    c2 = [1.0]
    b = DefaultOrthogonalBasis()

    for M in [M2, M2f], (p, X) in zip([p2, p2S], [X2, X2S])
        Manifolds.Test.test_manifold(
            M,
            Dict(
                :Functions => [get_coordinates, get_vector], :Bases => [b],
                :Points => [p], :Vectors => [X], :Coordinates => [c2],
            ),
            Dict((get_coordinates, b) => c2, (get_vector, c2, b) => X)
        )
    end


    M3 = Manifolds.GeneralUnitaryMatrices(3, ℝ, Manifolds.Test.DummyMatrixType)
    M3f = Manifolds.GeneralUnitaryMatrices(3, ℝ, Manifolds.Test.DummyMatrixType; parameter = :field)

    p3 = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    X3 = [0.0 -1.0 0.0; 1.0 0.0 0.0; 0.0 0.0 0.0]
    p3S = @SMatrix [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
    X3S = @SMatrix [0.0 -1.0 0.0; 1.0 0.0 0.0; 0.0 0.0 0.0]
    c3 = [0.0, 0.0, 1.0]

    for M in [M3f, M3], (p, X) in zip([p3, p3S], [X3, X3S])
        Manifolds.Test.test_manifold(
            M,
            Dict(
                :Functions => [get_coordinates, get_vector], :Bases => [b],
                :Points => [p], :Vectors => [X], :Coordinates => [c3],
            ),
            Dict((get_coordinates, b) => c3, (get_vector, c3, b) => X)
        )
    end
    @testset "Stattic Array & Edge cases" begin
        Z = @SMatrix [0.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0]
        q = exp(M3, p3S, Z)
        @test q == p3S
        q3S = @SMatrix [-1.0 0.0 0.0; 0.0 -1.0 0.0; 0.0 0.0 1.0]
        X = log(M3, p3S, q3S)
        X3S = @SMatrix [0.0 -π 0.0; π 0.0 0.0; 0.0 0.0 0.0]
        @test isapprox(M3, X, X3S)
    end


    M4 = Manifolds.GeneralUnitaryMatrices(4, ℝ, Manifolds.Test.DummyMatrixType)
    M4f = Manifolds.GeneralUnitaryMatrices(4, ℝ, Manifolds.Test.DummyMatrixType; parameter = :field)

    p4 = [1.0 0.0 0.0 0.0; 0.0 1.0 0.0 0.0; 0.0 0.0 1.0 0.0; 0.0 0.0 0.0 1.0]
    X4 = [0.0 -1.0 0.0 0.0; 1.0 0.0 0.0 0.0; 0.0 0.0 0.0 0.0; 0.0 0.0 0.0 0.0]
    c4 = [0.0, 0.0, 1.0, 0.0, 0.0, 0.0]
    for M in [M4, M4f]
        Manifolds.Test.test_manifold(
            M,
            Dict(
                :Functions => [get_coordinates, get_vector], :Bases => [b],
                :Points => [p4], :Vectors => [X4], :Coordinates => [c4],
            ),
            Dict((get_coordinates, b) => c4, (get_vector, c4, b) => X4)
        )
    end
end

"""
    AbstractAtlas{𝔽}

An abstract class for atlases with charts that have values in the vector space `𝔽ⁿ`
for some value of `n`. `𝔽` is a number system determined by an [`AbstractNumbers`](@extref ManifoldsBase number-system)
object.
"""
abstract type AbstractAtlas{𝔽} end

@doc raw"""
    RetractionAtlas{
        𝔽,
        TRetr<:AbstractRetractionMethod,
        TInvRetr<:AbstractInverseRetractionMethod,
        TBasis<:AbstractBasis,
    } <: AbstractAtlas{𝔽}

An atlas indexed by points on a manifold, ``\mathcal M = I`` and parameters (local coordinates)
are given in ``T_p\mathcal M``.
This means that a chart ``φ_p = \mathrm{cord}\circ\mathrm{retr}_p^{-1}`` is only locally
defined (around ``p``), where ``\mathrm{cord}`` is the decomposition of the tangent vector
into coordinates with respect to the given basis of the tangent space, cf. [`get_coordinates`](@ref).
The parametrization is given by ``φ_p^{-1}=\mathrm{retr}_p\circ\mathrm{vec}``,
where ``\mathrm{vec}`` turns the basis coordinates into a tangent vector, cf. [`get_vector`](@ref).

In short: The coordinates with respect to a basis are used together with a retraction as a parametrization.

# See also

[`AbstractAtlas`](@ref), [`AbstractInverseRetractionMethod`](@extref `ManifoldsBase.AbstractInverseRetractionMethod`),
[`AbstractRetractionMethod`](@extref `ManifoldsBase.AbstractRetractionMethod`), [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`)
"""
struct RetractionAtlas{
        𝔽,
        TRetr <: AbstractRetractionMethod,
        TInvRetr <: AbstractInverseRetractionMethod,
        TBasis <: AbstractBasis{<:Any, TangentSpaceType},
    } <: AbstractAtlas{𝔽}
    retr::TRetr
    invretr::TInvRetr
    basis::TBasis
end

function RetractionAtlas(
        retr::AbstractRetractionMethod,
        invretr::AbstractInverseRetractionMethod,
    )
    basis = DefaultOrthonormalBasis()
    return RetractionAtlas{ℝ, typeof(retr), typeof(invretr), typeof(basis)}(
        retr,
        invretr,
        basis,
    )
end
RetractionAtlas() = RetractionAtlas(ExponentialRetraction(), LogarithmicInverseRetraction())

"""
    affine_connection(M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc)

Calculate affine connection on manifold `M` at point with parameters `a` in chart `i` of
[`AbstractAtlas`](@ref) `A` of vectors with coefficients `Xc` and `Yc` in induced basis.
"""
function affine_connection(M::AbstractManifold, A, i, a, Xc, Yc)
    Zc = similar(Xc, Base.promote_type(eltype(Xc), eltype(Yc), eltype(a)))
    return affine_connection!(M, Zc, A, i, a, Xc, Yc)
end

"""
    affine_connection!(M::AbstractManifold, Zc, A::AbstractAtlas, i, a, Xc, Yc)

Calculate affine connection on manifold `M` at point with parameters `a` in chart `i` of an
an [`AbstractAtlas`](@ref) `A` of vectors with coefficients `Zc` and `Yc` in induced basis and save the result
in `Zc`.
"""
affine_connection!(M::AbstractManifold, Zc, A::AbstractAtlas, i, a, Xc, Yc)

"""
    christoffel_symbols_second(M::AbstractManifold, A::AbstractAtlas, i, a)

Compute values of the Christoffel symbol of the second kind in chart `i` of atlas `A`
at point with parameters `a`.
"""
function christoffel_symbols_second(M::AbstractManifold, A::AbstractAtlas, i, a; kwargs...)
    n = length(a)
    Γ = zeros(eltype(a), n, n, n)
    return christoffel_symbols_second!(M, Γ, A, i, a; kwargs...)
end

function christoffel_symbols_second!(
        M::AbstractManifold, Γ, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    # number of coordinates
    n = length(a)

    ginv = inverse_local_metric(M, A, i, a)
    T = eltype(ginv)

    # Precompute all directional derivatives ∂_i g_jl
    e = [zeros(T, n) for _ in 1:n]  # Basis vectors
    for k in 1:n
        e[k][k] = 1
    end

    dg = zeros(T, n, n, n)  # Tensor to store ∂_i g_jl
    for i in 1:n, j in 1:n, l in 1:n
        dg[i, j, l] = DI.derivative(
            t -> inner(M, A, i, a .+ t .* e[i], e[j], e[l]),
            backend,
            0.0,
        )
    end

    # Compute Christoffel symbols Γ^k_ij = 1/2 g^kl ( ∂_i g_jl + ∂_j g_il - ∂_l g_ij )
    for i in 1:n, j in 1:n, k in 1:n
        Γ[k, i, j] = sum(
            ginv[k, l] * (dg[i, j, l] + dg[j, i, l] - dg[l, i, j]) for l in 1:n
        ) / 2
    end
    return Γ
end

"""
    christoffel_symbols_first(M::AbstractManifold, A::AbstractAtlas, i, a; backend::AbstractADType = AutoForwardDiff())

Compute the Christoffel symbols of the first kind ``Γ_{i j k}`` in chart `i` of
[`AbstractAtlas`] `A` at coordinates `a`.

The symbols are obtained by lowering the first index of the second-kind Christoffel
symbols:

````math
    Γ_{i j k} = g_{k l} Γ^l_{i j}
````

# Arguments

- `M::AbstractManifold` : manifold
- `A::AbstractAtlas`   : atlas providing charts / induced basis
- `i`                  : chart index in `A`
- `a`                  : coordinates of the point in chart `i` (length `n`)

# Keyword arguments

- `backend::AbstractADType` : automatic-differentiation backend (default `AutoForwardDiff()`).
                              It is passed to [`christoffel_symbols_second`](@ref) in the
                              default implementation to compute the Christoffel symbol of
                              the second kind.

Returns an ``n×n×n`` array with ordering ``(i, j, k)``.
"""
function christoffel_symbols_first(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    n = length(a)
    T = eltype(a)
    Γ = zeros(T, n, n, n)
    return christoffel_symbols_first!(M, Γ, A, i, a; backend = backend)
end

function christoffel_symbols_first!(
        M::AbstractManifold, Γ, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    # Compute second-kind symbols and lower the first index: Γ_{i j k} = g_{k l} Γ^l_{i j}
    Γ2 = christoffel_symbols_second(M, A, i, a; backend = backend)
    g = local_metric(M, A, i, a)
    n = length(a)
    T = eltype(Γ2)
    fill!(Γ, zero(T))
    for ii in 1:n, j in 1:n, k in 1:n
        s = zero(T)
        for l in 1:n
            s += g[k, l] * Γ2[l, ii, j]
        end
        Γ[ii, j, k] = s
    end
    return Γ
end

@doc raw"""
    det_local_metric(M::AbstractManifold, A::AbstractAtlas, i, a)

Return the determinant of local matrix representation of the metric tensor at the point
with parametrization `a` in chart `i` of [`AbstractAtlas`](@ref) `A`.

See also [`local_metric`](@ref)
"""
function det_local_metric(M::AbstractManifold, A::AbstractAtlas, i, a)
    return det(local_metric(M, A, i, a))
end

"""
    einstein_tensor(M::AbstractManifold, A::AbstractAtlas, i, a; backend::AbstractADType = AutoForwardDiff())

Compute the Einstein tensor of the manifold `M` at the point specified by coordinates `a`
in chart `i` of atlas `A`.

The Einstein tensor is defined as

````math
    G_{ij} = Ric_{ij} - 1/2 g_{ij} R
````

where `Ric` is the Ricci tensor, `g` the local metric and `R` the scalar curvature.
They are computed using, respectively, [`ricci_tensor`](@ref), [`local_metric`](@ref) and
[`ricci_curvature`](@ref).
"""
function einstein_tensor(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    n = length(a)
    T = eltype(a)
    G = zeros(T, n, n)
    return einstein_tensor!(M, G, A, i, a; backend = backend)
end

function einstein_tensor!(
        M::AbstractManifold, G::AbstractMatrix, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    # compute Ricci tensor and scalar curvature
    ricci_tensor!(M, G, A, i, a; backend = backend)
    R = ricci_curvature(M, A, i, a; backend = backend)

    g = local_metric(M, A, i, a)
    G .-= g .* (R / 2)

    return G
end

"""
    get_default_atlas(::AbstractManifold)

Determine the default real-valued atlas for the given manifold.
"""
function get_default_atlas(::AbstractManifold)
    return RetractionAtlas()
end

@doc raw"""
    get_parameters(M::AbstractManifold, A::AbstractAtlas, i, p)

Calculate parameters (local coordinates) of point `p` on manifold `M` in chart from an [`AbstractAtlas`](@ref)
`A` at index `i`.
This function is hence an implementation of the chart ``φ_i(p), i\in I``.
The parameters are in the number system determined by `A`.
If the point ``p\notin U_i`` is not in the domain of the chart, this method should throw an error.

# See also

[`get_point`](@ref), [`get_chart_index`](@ref)

"""
get_parameters(::AbstractManifold, ::AbstractAtlas, ::Any, ::Any)

function get_parameters(M::AbstractManifold, A::AbstractAtlas, i, p)
    a = allocate_result(M, get_parameters, p)
    get_parameters!(M, a, A, i, p)
    return a
end

function allocate_result(M::AbstractManifold, f::typeof(get_parameters), p)
    T = allocate_result_type(M, f, (p,))
    return allocate(p, T, manifold_dimension(M))
end
# disambiguation
@invoke_maker 1 AbstractManifold allocate_result(
    M::AbstractDecoratorManifold,
    f::typeof(get_parameters),
    p,
)

"""
    check_chart_switch(M::AbstractManifold, A::AbstractAtlas, i, a)

Determine whether chart should be switched when an operation in chart `i` from an [`AbstractAtlas`](@ref) `A`
reaches parameters `a` in that chart.

By default `false` is returned.
"""
check_chart_switch(M::AbstractManifold, A::AbstractAtlas, i, a) = false

function get_parameters!(M::AbstractManifold, a, A::RetractionAtlas, i, p)
    return get_coordinates!(M, a, i, inverse_retract(M, i, p, A.invretr), A.basis)
end

function get_parameters(M::AbstractManifold, A::RetractionAtlas, i, p)
    return get_coordinates(M, i, inverse_retract(M, i, p, A.invretr), A.basis)
end

@doc raw"""
    get_point(M::AbstractManifold, A::AbstractAtlas, i, a)

Calculate point at parameters (local coordinates) `a` on manifold `M` in chart from
an [`AbstractAtlas`](@ref) `A` at index `i`.
This function is hence an implementation of the inverse ``φ_i^{-1}(a), i\in I`` of a chart, also called a parametrization.

# See also

[`get_parameters`](@ref), [`get_chart_index`](@ref)
"""
get_point(::AbstractManifold, ::AbstractAtlas, ::Any, ::Any)

function get_point(M::AbstractManifold, A::AbstractAtlas, i, a)
    p = allocate_result(M, get_point, a)
    get_point!(M, p, A, i, a)
    return p
end

function allocate_result(M::AbstractManifold, f::typeof(get_point), a)
    T = allocate_result_type(M, f, (a,))
    return allocate(a, T, representation_size(M)...)
end
# disambiguation
@invoke_maker 1 AbstractManifold allocate_result(
    M::AbstractDecoratorManifold,
    f::typeof(get_point),
    a,
)

function get_point(M::AbstractManifold, A::RetractionAtlas, i, a)
    return retract(M, i, get_vector(M, i, a, A.basis), A.retr)
end

function get_point!(M::AbstractManifold, p, A::RetractionAtlas, i, a)
    return retract!(M, p, i, get_vector(M, i, a, A.basis), A.retr)
end

"""
    get_chart_index(M::AbstractManifold, A::AbstractAtlas, p)

Select a chart from an [`AbstractAtlas`](@ref) `A` for manifold `M` that is suitable for
representing the neighborhood of point `p`. This selection should be deterministic, although
different charts may be selected for arbitrarily close but distinct points.

# See also

[`get_default_atlas`](@ref)
"""
get_chart_index(::AbstractManifold, ::AbstractAtlas, ::Any)

get_chart_index(::AbstractManifold, ::RetractionAtlas, p) = p

"""
    get_chart_index(M::AbstractManifold, A::AbstractAtlas, i, a)

Select a chart from an [`AbstractAtlas`](@ref) `A` for manifold `M` that is suitable for
representing the neighborhood of point with parametrization `a` in chart `i`. This selection
should be deterministic, although different charts may be selected for arbitrarily close but
distinct points.

# See also

[`get_default_atlas`](@ref)
"""
get_chart_index(::AbstractManifold, ::AbstractAtlas, ::Any, ::Any)

"""
    inner(M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc)

Calculate inner product on manifold `M` at point with parameters `a` in chart `i` of an
atlas `A` of vectors with coefficients `Xc` and `Yc` in induced basis.
"""
inner(M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc)

"""
    local_metric(M::AbstractManifold, A::AbstractAtlas{ℝ}, i, a)

Compute the local metric tensor on the manifold `M` at the point with parameters `a` in chart `i` 
of an [`AbstractAtlas`](@ref) `A`. The local metric tensor is represented as a matrix, where 
each entry corresponds to the inner product of basis vectors in the tangent space at the point
with given parameters.

In contrast, `local_metric(M::AbstractManifold, p, ::InducedBasis)` requires passing a point
instead of its parameters in a chart.

# Arguments

- `M::AbstractManifold`: The manifold on which the metric is computed.
- `A::AbstractAtlas{ℝ}`: The atlas defining the charts and coordinate systems on the manifold.
- `i`: The index of the chart in the atlas.
- `a`: The parameters of the point in the chart.

# Returns

A matrix representing the local metric tensor at the point with given parameters.

# See also

[`inverse_local_metric`](@ref), [`inner`](@ref)
"""
function local_metric(M::AbstractManifold, A::AbstractAtlas{ℝ}, i, a)
    n = length(a)
    g = zeros(eltype(a), n, n)
    return local_metric!(M, g, A, i, a)
end
function local_metric!(M::AbstractManifold, g::AbstractMatrix{T}, A::AbstractAtlas{ℝ}, i, a) where {T}
    n = length(a)

    e_p = zeros(T, n)
    e_q = zeros(T, n)
    for p in 1:n, q in 1:n
        e_p[p] = 1
        e_q[q] = 1
        g[p, q] = inner(M, A, i, a, e_p, e_q)
        e_p[p] = 0
        e_q[q] = 0
    end
    return g
end

@doc raw"""
    log_local_metric_density(M::AbstractManifold, A::AbstractAtlas, i, a)

Return the natural logarithm of the metric density ``ρ`` of `M` at the point with
parametrization `a` in chart `i` of [`AbstractAtlas`](@ref) `A`, which is given by
````math
ρ = \log \sqrt{\lvert \det g_{ij} \rvert}
````
for the metric tensor expressed in the same chart.

# See also

[`local_metric`](@ref), [`det_local_metric`](@ref)
"""
function log_local_metric_density(M::AbstractManifold, A::AbstractAtlas, i, a)
    return log(abs(det_local_metric(M, A, i, a))) / 2
end

"""
    inverse_local_metric(M::AbstractManifold, A::AbstractAtlas{ℝ}, i, a)

Compute the inverse of the local metric tensor on the manifold `M` at the point with parameters `a` 
in chart `i` of an [`AbstractAtlas`](@ref) `A`. The inverse local metric tensor is represented as a matrix, 
where each entry corresponds to the inverse of the inner product of basis vectors in the tangent space 
at the point with given parameters.

In contrast, `inverse_local_metric(M::AbstractManifold, p, ::InducedBasis)` requires passing
a point instead of its parameters in a chart.

# Arguments

- `M::AbstractManifold`: The manifold on which the metric is computed.
- `A::AbstractAtlas{ℝ}`: The atlas defining the charts and coordinate systems on the manifold.
- `i`: The index of the chart in the atlas.
- `a`: The parameters of the point in the chart.

# Returns

A matrix representing the inverse of the local metric tensor at the point with given parameters.

# See also

[`local_metric`](@ref), [`inner`](@ref)
"""
function inverse_local_metric(M::AbstractManifold, A::AbstractAtlas{ℝ}, i, a)
    n = length(a)
    ginv = zeros(eltype(a), n, n)
    return inverse_local_metric!(M, ginv, A, i, a)
end
function inverse_local_metric!(M::AbstractManifold, ginv::AbstractMatrix{T}, A::AbstractAtlas{ℝ}, i, a) where {T}
    # inverse metric
    ginv .= inv(local_metric(M, A, i, a))
    return ginv
end

"""
    norm(M::AbstractManifold, A::AbstractAtlas, i, a, Xc)

Calculate norm on manifold `M` at point with parameters `a` in chart `i` of an
[`AbstractAtlas`](@ref) `A` of vector with coefficients `Xc` in induced basis.
"""
norm(M::AbstractManifold, A::AbstractAtlas, i, a, Xc) = sqrt(inner(M, A, i, a, Xc, Xc))

@doc raw"""
    transition_map(M::AbstractManifold, A_from::AbstractAtlas, i_from, A_to::AbstractAtlas, i_to, a)
    transition_map(M::AbstractManifold, A::AbstractAtlas, i_from, i_to, a)

Given coordinates `a` in chart `(A_from, i_from)` of a point on manifold `M`, returns
coordinates of that point in chart `(A_to, i_to)`. If `A_from` and `A_to` are equal, `A_to`
can be omitted.

Mathematically this function is the transition map or change of charts, but it
might even be between two atlases ``A_{\text{from}} = \{(U_i,φ_i)\}_{i\in I} `` and ``A_{\text{to}} = \{(V_j,\psi_j)\}_{j\in J}``,
and hence ``I, J`` are their index sets.
We have ``i_{\text{from}}\in I``, ``i_{\text{to}}\in J``.

This method then computes
```math
\bigl(\psi_{i_{\text{to}}}\circ φ_{i_{\text{from}}}^{-1}\bigr)(a)
```

Note that, similarly to [`get_parameters`](@ref), this method should fail the same way if ``V_{i_{\text{to}}}\cap U_{i_{\text{from}}}=\emptyset``.

# See also

[`AbstractAtlas`](@ref), [`get_parameters`](@ref), [`get_point`](@ref)
"""
function transition_map(
        M::AbstractManifold,
        A_from::AbstractAtlas,
        i_from,
        A_to::AbstractAtlas,
        i_to,
        a,
    )
    return get_parameters(M, A_to, i_to, get_point(M, A_from, i_from, a))
end

function transition_map(M::AbstractManifold, A::AbstractAtlas, i_from, i_to, a)
    return transition_map(M, A, i_from, A, i_to, a)
end

function transition_map!(
        M::AbstractManifold,
        y,
        A_from::AbstractAtlas,
        i_from,
        A_to::AbstractAtlas,
        i_to,
        a,
    )
    return get_parameters!(M, y, A_to, i_to, get_point(M, A_from, i_from, a))
end

function transition_map!(M::AbstractManifold, y, A::AbstractAtlas, i_from, i_to, a)
    return transition_map!(M, y, A, i_from, A, i_to, a)
end

"""
    transition_map_diff(M::AbstractManifold, A::AbstractAtlas, i_from, a, c, i_to)

Compute differential of transition map from chart `i_from` to chart `i_to` from an
[`AbstractAtlas`](@ref) `A` on manifold `M` at point with parameters `a` on tangent vector
with coordinates `c` in the induced basis.
"""
function transition_map_diff(M::AbstractManifold, A::AbstractAtlas, i_from, a, c, i_to)
    old_B = induced_basis(M, A, i_from)
    new_B = induced_basis(M, A, i_to)
    p_final = get_point(M, A, i_from, a)
    return change_basis(M, p_final, c, old_B, new_B)
end

"""
    transition_map_diff!(M::AbstractManifold, c_out, A::AbstractAtlas, i_from, a, c, i_to)

Compute [`transition_map_diff`](@ref) on given arguments and save the result in `c_out`.
"""
function transition_map_diff!(
        M::AbstractManifold,
        c_out,
        A::AbstractAtlas,
        i_from,
        a,
        c_in,
        i_to,
    )
    old_B = induced_basis(M, A, i_from)
    new_B = induced_basis(M, A, i_to)
    p_final = get_point(M, A, i_from, a)
    return change_basis!(M, c_out, p_final, c_in, old_B, new_B)
end

"""
    induced_basis(M::AbstractManifold, A::AbstractAtlas, i, VST::VectorSpaceType)

Basis of vector space of type `VST` at point `p` from manifold `M` induced by
chart (`A`, `i`).

# See also

[`VectorSpaceType`](@extref `ManifoldsBase.VectorSpaceType`), [`AbstractAtlas`](@ref)
"""
induced_basis(M::AbstractManifold, A::AbstractAtlas, i, VST::VectorSpaceType)

@doc raw"""
    InducedBasis(vs::VectorSpaceType, A::AbstractAtlas, i)

The basis induced by chart with index `i` from an [`AbstractAtlas`](@ref) `A` of vector
space of type `vs`.

For the `vs` a [`TangentSpace`](@extref `ManifoldsBase.TangentSpace`)
this works as  follows:

Let ``n`` denote the dimension of the manifold ``\mathcal M``.

Let the parameter ``a=φ_i(p) ∈ \mathbb R^n`` and ``j∈\{1,…,n\}``.
We can look at the ``j``th parameter curve ``b_j(t) = a + te_j``, where ``e_j`` denotes the ``j``th unit vector.
Using the parametrisation we obtain a curve ``c_j(t) = φ_i^{-1}(b_j(t))`` which fulfills ``c(0) = p``.

Now taking the derivative(s) with respect to ``t`` (and evaluate at ``t=0``),
we obtain a tangent vector for each ``j`` corresponding to an equivalence class of curves (having the same derivative) as

```math
X_j = [c_j] = \frac{\mathrm{d}}{\mathrm{d}t} c_i(t) \Bigl|_{t=0}
```

and the set ``\{X_1,\ldots,X_n\}`` is the chart-induced basis of ``T_p\mathcal M``.

# See also

[`VectorSpaceType`](@extref `ManifoldsBase.VectorSpaceType`), [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`)
"""
struct InducedBasis{𝔽, VST <: VectorSpaceType, TA <: AbstractAtlas, TI} <: AbstractBasis{𝔽, VST}
    vs::VST
    A::TA
    i::TI
end

"""
    induced_basis(::AbstractManifold, A::AbstractAtlas, i, VST::VectorSpaceType = TangentSpaceType())

Get the basis induced by chart with index `i` from an [`AbstractAtlas`](@ref) `A` of vector
space of type `vs`. Returns an object of type [`InducedBasis`](@ref).

# See also

[`VectorSpaceType`](@extref `ManifoldsBase.VectorSpaceType`), [`AbstractBasis`](@extref `ManifoldsBase.AbstractBasis`)
"""
function induced_basis(
        ::AbstractManifold{𝔽},
        A::AbstractAtlas,
        i,
        VST::VectorSpaceType = TangentSpaceType(),
    ) where {𝔽}
    return InducedBasis{𝔽, typeof(VST), typeof(A), typeof(i)}(VST, A, i)
end

"""
    inverse_chart_injectivity_radius(M::AbstractManifold, A::AbstractAtlas, i)

Injectivity radius of `get_point` for chart `i` from an [`AbstractAtlas`](@ref) `A` of a manifold `M`.
"""
inverse_chart_injectivity_radius(M::AbstractManifold, A::AbstractAtlas, i)

function dual_basis(
        M::AbstractManifold{𝔽},
        ::Any,
        B::InducedBasis{𝔽, TangentSpaceType},
    ) where {𝔽}
    return induced_basis(M, B.A, B.i, CotangentSpaceType())
end
function dual_basis(
        M::AbstractManifold{𝔽},
        ::Any,
        B::InducedBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    return induced_basis(M, B.A, B.i, TangentSpaceType())
end

function ManifoldsBase._get_coordinates(M::AbstractManifold, p, X, B::InducedBasis; kwargs...)
    return get_coordinates_induced_basis(M, p, X, B; kwargs...)
end
function get_coordinates_induced_basis(M::AbstractManifold, p, X, B::InducedBasis; kwargs...)
    Y = allocate_result(M, get_coordinates, p, X, B)
    return get_coordinates_induced_basis!(M, Y, p, X, B; kwargs...)
end

function ManifoldsBase._get_coordinates!(M::AbstractManifold, Y, p, X, B::InducedBasis; kwargs...)
    return get_coordinates_induced_basis!(M, Y, p, X, B; kwargs...)
end
function get_coordinates_induced_basis! end

function ManifoldsBase._get_vector(M::AbstractManifold, p, c, B::InducedBasis; kwargs...)
    return get_vector_induced_basis(M, p, c, B; kwargs...)
end
function get_vector_induced_basis(M::AbstractManifold, p, c, B::InducedBasis; kwargs...)
    Y = allocate_result(M, get_vector, p, c)
    return get_vector!(M, Y, p, c, B; kwargs...)
end

function ManifoldsBase._get_vector!(M::AbstractManifold, Y, p, c, B::InducedBasis; kwargs...)
    return get_vector_induced_basis!(M, Y, p, c, B; kwargs...)
end
function get_vector_induced_basis! end

"""
    kretschmann_scalar(M::AbstractManifold, A::AbstractAtlas, i, a; backend::AbstractADType = AutoForwardDiff())

Compute the Kretschmann scalar ``K = R_{abcd} R^{abcd}`` at the point given by coordinates `a`
in chart `i` of atlas `A` on manifold `M`.

This implementation uses the Riemann tensor in the form ``R^u_{ijk}`` (returned by `riemann_tensor`)
and the inverse local metric `g^{ij}` (returned by `inverse_local_metric`) to form the full
contraction:

````math
    K = g^{u v} g^{i p} g^{j q} g^{k r} R^u_{i j k} R^v_{p q r}
````

# Arguments

- `M::AbstractManifold` : manifold
- `A::AbstractAtlas`   : atlas providing charts / induced basis
- `i`                  : chart index in `A`
- `a`                  : coordinates of the point in chart `i` (length `n`)
- `backend::AbstractADType` : automatic-differentiation backend (default `AutoForwardDiff()`)

# Returns

Scalar (same element type as `a`) equal to the Kretschmann scalar at the point
"""
function kretschmann_scalar(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff(),
    )
    n = length(a)
    T = eltype(a)
    R = riemann_tensor(M, A, i, a; backend = backend)   # R[u, ii, j, k] == R^u_{ijk}
    ginv = inverse_local_metric(M, A, i, a)             # g^{ij}

    K = zero(T)
    for u in 1:n, ii in 1:n, j in 1:n, k in 1:n
        Ruijk = R[u, ii, j, k]
        if iszero(Ruijk)
            continue
        end
        for v in 1:n, p in 1:n, q in 1:n, r in 1:n
            K += ginv[u, v] * ginv[ii, p] * ginv[j, q] * ginv[k, r] * Ruijk * R[v, p, q, r]
        end
    end
    return K
end

"""
    local_metric(M::AbstractManifold, p, B::InducedBasis)

Compute the local metric tensor for vectors expressed in terms of coordinates
in basis `B` on manifold `M`. The point `p` is not checked.
"""
local_metric(::AbstractManifold, ::Any, ::InducedBasis)

"""
    levi_civita_affine_connection!(M::AbstractManifold, Zc, A::AbstractAtlas, i, a, Xc, Yc; backend::AbstractADType = AutoForwardDiff())

Compute the Levi-Civita affine connection on the manifold `M` at a point with parameters `a`
in chart `i` of an  [`AbstractAtlas`](@ref) `A`. The connection is calculated for vectors
with coefficients `Xc` and `Yc` in the induced basis, and the result is stored in `Zc`.

The Levi-Civita connection is computed using the metric tensor (`inner` called in a chart)
of the manifold, ensuring that the connection is torsion-free and compatible with the metric.
The computation involves the Christoffel symbols of the second kind, which are derived from
the metric tensor and its derivatives using automatic differentiation. Note that this
computation is relatively slow. Where performance matters, it should be replaced with
custom-derived formulas.

# Arguments

- `M::AbstractManifold`: The manifold on which the Levi-Civita connection is computed.
- `Zc`: The output vector where the result of the connection is stored.
- `A::AbstractAtlas`: The atlas defining the charts and coordinate systems on the manifold.
- `i`: The index of the chart in the atlas.
- `a`: The parameters (local coordinates) of the point in the chart.
- `Xc`: The coefficients of the first vector in the induced basis.
- `Yc`: The coefficients of the second vector in the induced basis.

# Keyword arguments

- `backend::AbstractADType`: The automatic differentiation backend used for computing derivatives (default: `AutoForwardDiff()`).

# Returns

The result is stored in `Zc`, which represents the Levi-Civita connection in the induced basis.

# Notes

- The computation involves the inverse of the local metric tensor, which is used to raise indices.
- The directional derivatives of the metric tensor are computed using the specified automatic differentiation backend.
- The function assumes that the input vectors `Xc` and `Yc` are expressed in the induced basis of the chart.

# See also

[`affine_connection!`](@ref), [`local_metric`](@ref), [`inner`](@ref)
"""
function levi_civita_affine_connection!(
        M::AbstractManifold, Zc, A::AbstractAtlas, i, a, Xc, Yc;
        backend::AbstractADType = AutoForwardDiff()
    )
    # number of coordinates
    n = length(a)

    ginv = inverse_local_metric(M, A, i, a)
    T = eltype(ginv)

    # helper: directional derivative at a in direction dir of the scalar function
    # f_dir(V1, V2) = d/dt|0 inner(M, A, i, a + t*dir, V1, V2)
    function directional_derivative_scalar(dir, V1, V2)
        f(t) = real(inner(M, A, i, a .+ (t .* dir), V1, V2))
        return DI.derivative(f, backend, 0.0)
    end

    # compute S_k = 1/2 ( X[g(Y, e_k)] + Y[g(X, e_k)] - e_k[g(X,Y)] )
    S = zeros(T, n)
    e_k = zeros(T, n)
    for k in 1:n
        e_k[k] = 1
        term1 = directional_derivative_scalar(Xc, Yc, e_k)
        term2 = directional_derivative_scalar(Yc, Xc, e_k)
        term3 = directional_derivative_scalar(e_k, Xc, Yc)
        S[k] = (term1 + term2 - term3) / 2
        e_k[k] = 0
    end

    # raise index: (∇_X Y)^l = g^{l k} S_k
    Zc .= ginv * S

    return Zc
end

"""
    get_coordinates_induced_basis!(M::AbstractManifold, c, p, X, B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas};
        backend::AbstractADType = AutoForwardDiff())

Compute the coordinates of a tangent vector `X` at a point `p` on the manifold `M` in the induced basis `B` 
and store the result in `c`. This function uses automatic differentiation to compute the coordinates.

# Arguments

- `M::AbstractManifold`: The manifold on which the computation is performed.
- `c`: The output array where the coordinates of the tangent vector will be stored.
- `p`: The point on the manifold where the tangent vector `X` is located.
- `X`: The tangent vector at `p` whose coordinates are to be computed.
- `B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas}`: The induced basis in which the coordinates are expressed.

# Keyword arguments

- `backend::AbstractADType`: The automatic differentiation backend used for computing derivatives (default: `AutoForwardDiff()`).

# Returns

The result is stored in `c`, which contains the coordinates of the tangent vector `X` in the induced basis `B`.

# Notes

- This function computes the coordinates by differentiating the chart map at the given point `p` in the direction of `X`.
- The computation relies on automatic differentiation.

# See also

[`InducedBasis`](@ref), [`AbstractAtlas`](@ref)
"""
function get_coordinates_induced_basis!(
        M::AbstractManifold,
        c,
        p,
        X,
        B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas};
        backend::AbstractADType = AutoForwardDiff(),
    )
    DI.derivative!(t -> get_parameters(M, B.A, B.i, p .+ t .* X), c, backend, zero(eltype(c)))
    return c
end

"""
    get_vector_induced_basis!(M::AbstractManifold, Y, p, Xc, B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas};
        backend::AbstractADType = AutoForwardDiff())

Compute the tangent vector `Y` at a point `p` on the manifold `M` corresponding to the coordinates `Xc` 
in the induced basis `B` and store the result in `Y`. This function uses automatic differentiation 
to compute the tangent vector.

# Arguments

- `M::AbstractManifold`: The manifold on which the computation is performed.
- `Y`: The output tangent vector at `p` corresponding to the coordinates `Xc` in the induced basis.
- `p`: The point on the manifold where the tangent vector is located.
- `Xc`: The coordinates of the tangent vector in the induced basis `B`.
- `B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas}`: The induced basis in which the coordinates `Xc` are expressed.

# Keyword arguments

- `backend::AbstractADType`: The automatic differentiation backend used for computing derivatives (default: `AutoForwardDiff()`).

# Returns

The result is stored in `Y`, which represents the tangent vector at `p` corresponding to the coordinates `Xc` 
in the induced basis `B`.

# Notes

- This function computes the tangent vector by differentiating the chart map at the given point `p` 
  in the direction of the coordinates `Xc`.
- The computation relies on automatic differentiation.

# See also

[`InducedBasis`](@ref), [`AbstractAtlas`](@ref)
"""
function get_vector_induced_basis!(
        M::AbstractManifold,
        Y,
        p,
        Xc,
        B::InducedBasis{ℝ, TangentSpaceType, <:AbstractAtlas};
        backend::AbstractADType = AutoForwardDiff(),
    )
    p_i = get_parameters(M, B.A, B.i, p)
    DI.derivative!(t -> get_point(M, B.A, B.i, p_i .+ t .* Xc), Y, backend, zero(eltype(p_i)))
    return Y
end

"""
    ricci_curvature(M::AbstractManifold, A::AbstractAtlas, i, a; backend=AutoForwardDiff())

Compute the scalar Ricci curvature (Ricci scalar) of the manifold `M` at the point
given by coordinates `a` in chart `i` of atlas `A`.

The scalar curvature is the trace of the Ricci tensor with respect to the inverse
local metric:
````math
    R = g^{ij} R_{ij}
````math

# Arguments

- `M::AbstractManifold` : manifold
- `A::AbstractAtlas`   : atlas providing charts / induced basis
- `i`                  : chart index in `A`
- `a`                  : coordinates of the point in chart `i` (length `n`)
- `backend::AbstractADType` : automatic-differentiation backend (default `AutoForwardDiff()`)

# Returns

- scalar (same element type as `a`) equal to the Ricci scalar at the point
"""
function ricci_curvature(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff(),
    )
    Ginv = inverse_local_metric(M, A, i, a)
    Ric = ricci_tensor(M, A, i, a; backend = backend)
    S = sum(Ginv .* Ric)
    return S
end

"""
    ricci_tensor(M::AbstractManifold, A::AbstractAtlas, i, a; backend::AbstractADType=AutoForwardDiff())

Compute the Ricci tensor of the manifold `M` at the point specified by coordinates `a`
in chart `i` of atlas `A`.

The Ricci tensor is the contraction of the Riemann tensor:

````math
    Ric_{p q} = R^u_{p u q}
````

# Arguments

- `M::AbstractManifold` : manifold
- `A::AbstractAtlas`   : atlas providing charts / induced basis
- `i`                  : chart index in `A`
- `a`                  : coordinates of the point in chart `i` (length `n`)
- `backend::AbstractADType` : automatic-differentiation backend (default `AutoForwardDiff()`)

# Returns

- `n×n` matrix with components `Ric[p, q]` (same element type as `a`)

# See also

- [`riemann_tensor`](@ref)
"""
function ricci_tensor(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    n = length(a)
    T = eltype(a)
    Ric = zeros(T, n, n)
    return ricci_tensor!(M, Ric, A, i, a; backend = backend)
end

function ricci_tensor!(
        M::AbstractManifold, Ric, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    # compute full Riemann tensor and contract: Ric_{ij} = R^u_{i u j}
    R = riemann_tensor(M, A, i, a; backend = backend)
    n = length(a)
    fill!(Ric, zero(eltype(R)))
    for p in 1:n, q in 1:n
        s = zero(eltype(R))
        for u in 1:n
            s += R[u, p, u, q]
        end
        Ric[p, q] = s
    end
    return Ric
end

"""
    riemann_tensor(M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()

Compute the Riemann curvature tensor of manifold `M` at the point given by parameters `a` in
chart `i` of atlas `A`.

Returns a 4-dimensional array `R` of size (n,n,n,n) with components `R[u,i,j,k] = R^u_{ijk}`,
where the first index is the contravariant (upper) index and the remaining three are covariant
(lower) indices. The components satisfy, for coordinate vector fields e_i:

````math
    R^u_{ijk} e_u = (∇_{e_i} ∇_{e_j} - ∇_{e_j} ∇_{e_i} - ∇_{[e_i,e_j]}) e_k
````

# Arguments

- `M::AbstractManifold`: manifold
- `A::AbstractAtlas`: atlas used for coordinates/induced basis
- `i`: chart index in `A`
- `a`: coordinates of the point in chart `i` (length `n`)
- `backend::AbstractADType` : automatic-differentiation backend (default `AutoForwardDiff()`)

# Notes

- The default implementation computes connection coefficients via `affine_connection`
  and their directional derivatives (using automatic differentiation), so it can be
  expensive. Manifold-specific overrides yielding closed-form curvature are recommended
  for performance-critical code.
- Use `riemann_tensor!(M, Wc, A, i, a, Xc, Yc, Zc)` to compute the action `R(X,Y)Z` on
  coordinate vectors `Xc`, `Yc`, `Zc` without constructing the full 4-tensor.

# See also

[`affine_connection`](@ref)
"""
function riemann_tensor(
        M::AbstractManifold, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    n = length(a)
    T = eltype(a)
    R = zeros(T, n, n, n, n) # R[u, i, j, k]
    return riemann_tensor!(M, R, A, i, a; backend = backend)
end

function riemann_tensor!(
        M::AbstractManifold, R, A::AbstractAtlas, i, a;
        backend::AbstractADType = AutoForwardDiff()
    )
    n = length(a)
    T = eltype(a)

    # basis vectors for directional derivatives
    e = [zeros(T, n) for _ in 1:n]
    for k in 1:n
        e[k][k] = 1
    end

    # Compute connection coefficients Γ^u_{ii j} by applying affine_connection to basis vectors
    Γ = zeros(T, n, n, n) # Γ[u, i, j]
    for ii in 1:n, j in 1:n
        affine_connection!(M, view(Γ, :, ii, j), A, i, a, e[ii], e[j])
    end

    # directional derivatives ∂_p Γ^u_{ij}
    dΓ = zeros(T, n, n, n, n) # dΓ[p, u, ii, j]
    for p in 1:n, ii in 1:n, j in 1:n
        DI.derivative!(
            t -> affine_connection(M, A, i, a .+ t .* e[p], e[ii], e[j]),
            view(dΓ, p, :, ii, j),
            backend,
            0.0,
        )
    end

    # Compute R^u_{ii j k} = ∂_i Γ^u_{j k} - ∂_j Γ^u_{ii k}
    #                     + Σ_m ( Γ^m_{j k} Γ^u_{ii m} - Γ^m_{ii k} Γ^u_{j m} )

    for u in 1:n, ii in 1:n, j in 1:n, k in 1:n
        R[u, ii, j, k] = dΓ[ii, u, j, k] - dΓ[j, u, ii, k]
        for m in 1:n
            R[u, ii, j, k] += Γ[m, j, k] * Γ[u, ii, m] - Γ[m, ii, k] * Γ[u, j, m]
        end
    end
    return R
end

"""
    riemann_tensor(M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc, Zc;
                   backend::AbstractADType = AutoForwardDiff())

Compute the action of the Riemann curvature tensor `R` on tangent vectors with coordinates
`Xc`, `Yc` and `Zc` at the point specified by parameters `a` in chart `i` of atlas `A` on
manifold `M`.

This function returns the vector `W (in induced-chart coordinates) given by
``(R(X, Y) Z)``, i.e. the result of applying the curvature operator to `Zc`.

# Arguments
- `M::AbstractManifold` : manifold
- `A::AbstractAtlas`   : atlas providing charts / induced basis
- `i`                  : chart index in `A`
- `a`                  : coordinates of the point in chart `i` (length `n`)
- `Xc, Yc, Zc`         : coordinates of tangent vectors X, Y, Z in the chart-induced basis

# Keyword arguments
- `backend::AbstractADType = AutoForwardDiff()` : AD backend used when numerical derivatives are required

# Returns
- A vector (same shape/type as `Xc`) containing coordinates of ``(R(X, Y) Z)`` in the induced basis.

# Notes
- The default implementation builds the full 4-index Riemann tensor using the
  chart affine connection and its derivatives, then contracts with `Xc`, `Yc`, `Zc`.
  This is convenient but can be expensive; prefer manifold-specific overrides
  that compute R(X,Y)Z directly for performance-critical code.
- Inputs are expected to be expressed in the chart-induced basis associated with `A` and `i`.
- The function uses automatic differentiation (via `backend`) when computing
  directional derivatives of connection coefficients.

# See also
- `riemann_tensor(M, A, i, a)` which returns the full 4-tensor
- []`affine_connection`](@ref) used to obtain connection coefficients (see [`levi_civita_affine_connection!`](@ref) for a generic implementation)
"""
function riemann_tensor(
        M::AbstractManifold, A::AbstractAtlas, i, a, Xc, Yc, Zc;
        backend::AbstractADType = AutoForwardDiff()
    )
    Wc = similar(Xc)
    return riemann_tensor!(M, Wc, A, i, a, Xc, Yc, Zc; backend = backend)
end

function riemann_tensor!(
        M::AbstractManifold, Wc, A::AbstractAtlas, i, a, Xc, Yc, Zc;
        backend::AbstractADType = AutoForwardDiff()
    )
    # number of coordinates
    n = length(a)

    # Get the tensor
    R = riemann_tensor(M, A, i, a; backend = backend)

    # Apply to vectors: (R(X,Y)Z)^u = Σ_{i,j,k} R^u_{i j k} X^i Y^j Z^k
    fill!(Wc, 0)
    for u in 1:n
        for i in 1:n, j in 1:n, k in 1:n
            Wc[u] += R[u, i, j, k] * Xc[i] * Yc[j] * Zc[k]
        end
    end

    return Wc
end

for mf in [
        christoffel_symbols_first,
        christoffel_symbols_second,
        det_local_metric,
        einstein_tensor,
        flat!,
        gaussian_curvature,
        inverse_local_metric,
        local_metric,
        log_local_metric_density,
        mean,
        mean!,
        median,
        median!,
        ricci_curvature,
        ricci_tensor,
        riemann_tensor,
        riemannian_gradient,
        riemannian_gradient!,
        riemannian_Hessian,
        riemannian_Hessian!,
        sharp!,
    ]
    @eval is_metric_function(::typeof($mf)) = true
end

@doc raw"""
    Euclidean{T,𝔽} <: AbstractManifold{𝔽}

Euclidean vector space.

# Constructor

    Euclidean(n)

Generate the ``n``-dimensional vector space ``ℝ^n``.

    Euclidean(n₁,n₂,...,nᵢ; field=ℝ, parameter::Symbol = :field)
    𝔽^(n₁,n₂,...,nᵢ) = Euclidean(n₁,n₂,...,nᵢ; field=𝔽)

Generate the vector space of ``k = n_1 ⋅ n_2 ⋅ … ⋅ n_i`` values, i.e. the
manifold ``𝔽^{n_1, n_2, …, n_i}``, ``𝔽\in\{ℝ,ℂ\}``, whose
elements are interpreted as ``n_1 × n_2 × … × n_i`` arrays.
For ``i=2`` we obtain a matrix space.
The default `field=ℝ` can also be set to `field=ℂ`.
The dimension of this space is ``k \dim_ℝ 𝔽``, where ``\dim_ℝ 𝔽`` is the
[`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of the field ``𝔽``.

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in type. Value can either be `:field` or `:type`.

    Euclidean(; field=ℝ)

Generate the 1D Euclidean manifold for an `ℝ`-, `ℂ`-valued  real- or complex-valued immutable
values (in contrast to 1-element arrays from the constructor above).
"""
struct Euclidean{𝔽, T} <: AbstractDecoratorManifold{𝔽} where {T}
    size::T
end

function Euclidean(
        n::Vararg{Int, I};
        field::AbstractNumbers = ℝ,
        parameter::Symbol = :type,
    ) where {I}
    size = wrap_type_parameter(parameter, n)
    return Euclidean{field, typeof(size)}(size)
end

function adjoint_Jacobi_field(::Euclidean{𝔽, Tuple{}}, p, q, t, X, β::Tβ) where {𝔽, Tβ}
    return X
end
function adjoint_Jacobi_field(
        ::Euclidean{𝔽, TypeParameter{Tuple{}}},
        p,
        q,
        t,
        X,
        β::Tβ,
    ) where {𝔽, Tβ}
    return X
end

Base.:^(𝔽::AbstractNumbers, n) = Euclidean(n...; field = 𝔽)

Base.:^(M::Euclidean, n::Int) = ^(M, (n,))
function Base.:^(M::Euclidean{𝔽, <:Tuple}, n::NTuple{N, Int}) where {𝔽, N}
    size = get_parameter(M.size)
    return Euclidean(size..., n...; field = 𝔽, parameter = :field)
end
function Base.:^(M::Euclidean{𝔽, <:TypeParameter}, n::NTuple{N, Int}) where {𝔽, N}
    size = get_parameter(M.size)
    return Euclidean(size..., n...; field = 𝔽, parameter = :type)
end

function allocation_promotion_function(
        ::Euclidean{ℂ},
        ::Union{typeof(get_vector), typeof(get_coordinates)},
        ::Tuple,
    )
    return complex
end

function check_point(M::Euclidean{𝔽, N}, p; kwargs...) where {𝔽, N}
    if (𝔽 === ℝ) && !(eltype(p) <: Real)
        return DomainError(
            eltype(p),
            "The matrix $(p) is not a real-valued matrix, so it does not lie on $(M).",
        )
    end
    if (𝔽 === ℂ) && !(eltype(p) <: Real) && !(eltype(p) <: Complex)
        return DomainError(
            eltype(p),
            "The matrix $(p) is neither a real- nor complex-valued matrix, so it does not lie on $(M).",
        )
    end
    return nothing
end

function check_vector(M::Euclidean{𝔽, N}, p, X; kwargs...) where {𝔽, N}
    if (𝔽 === ℝ) && !(eltype(X) <: Real)
        return DomainError(
            eltype(X),
            "The matrix $(X) is not a real-valued matrix, so it can not be a tangent vector to $(p) on $(M).",
        )
    end
    if (𝔽 === ℂ) && !(eltype(X) <: Real) && !(eltype(X) <: Complex)
        return DomainError(
            eltype(X),
            "The matrix $(X) is neither a real- nor complex-valued matrix, so it can not be a tangent vector to $(p) on $(M).",
        )
    end
    return nothing
end

connection(::Euclidean) = LeviCivitaConnection()

default_approximation_method(::Euclidean, ::typeof(mean)) = EfficientEstimator()

function default_approximation_method(::Euclidean, ::typeof(median), ::Type{<:Number})
    return EfficientEstimator()
end

function det_local_metric(
        ::MetricManifold{𝔽, <:AbstractManifold, EuclideanMetric},
        p,
        ::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return one(eltype(p))
end

function diagonalizing_projectors(::Euclidean, p, X)
    return ((zero(number_eltype(p)), IdentityProjector()),)
end

"""
    distance(M::Euclidean, p, q, r::Real=2)

Compute the Euclidean distance between two points on the [`Euclidean`](@ref)
manifold `M`, i.e. for vectors it's just the norm of the difference, for matrices
and higher order arrays, the matrix and tensor Frobenius norm, respectively.
Specifying further an `r≠2`, other norms, like the 1-norm or the ∞-norm can also be computed.
"""
Base.@propagate_inbounds function distance(M::Euclidean, p, q)
    # Inspired by euclidean distance calculation in Distances.jl
    # Much faster for large p, q than a naive implementation
    @boundscheck if axes(p) != axes(q)
        throw(DimensionMismatch("At last one of $p and $q does not belong to $M"))
    end
    s = zero(eltype(p))
    @inbounds begin # COV_EXCL_LINE
        @simd for I in eachindex(p, q) # COV_EXCL_LINE
            p_i = p[I]
            q_i = q[I]
            s += abs2(p_i - q_i)
        end # COV_EXCL_LINE
    end # COV_EXCL_LINE
    return sqrt(s)
end
distance(M::Euclidean, p, q, r::Real) = norm(p - q, r)
distance(::Euclidean{𝔽, TypeParameter{Tuple{1}}}, p::Number, q::Number) where {𝔽} = abs(p - q)
distance(::Euclidean{𝔽, TypeParameter{Tuple{}}}, p::Number, q::Number) where {𝔽} = abs(p - q)
distance(::Euclidean{𝔽, Tuple{Int}}, p::Number, q::Number) where {𝔽} = abs(p - q) # for 1-dimensional Euclidean
distance(::Euclidean{𝔽, Tuple{}}, p::Number, q::Number) where {𝔽} = abs(p - q)

"""
    embed(M::Euclidean, p)

Embed the point `p` in `M`. Equivalent to an identity map.
"""
embed(::Euclidean, p) = p

"""
    embed(M::Euclidean, p, X)

Embed the tangent vector `X` at point `p` in `M`. Equivalent to an identity map.
"""
embed(::Euclidean, p, X) = X

function embed!(
        ::EmbeddedManifold{𝔽, Euclidean{𝔽, nL}, Euclidean{𝔽2, mL}},
        q,
        p,
    ) where {𝔽, 𝔽2, nL, mL}
    n = size(p)
    ln = length(n)
    m = size(q)
    lm = length(m)
    (length(n) > length(m)) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) is longer than embedding dimension $(m).",
        ),
    )
    any(n .> m[1:ln]) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) has entry larger than embedding dimensions ($(m)).",
        ),
    )
    # put p into q
    fill!(q, 0)
    # fill „top left edge“ of q with p.
    q[map(ind_n -> Base.OneTo(ind_n), n)..., ntuple(_ -> 1, lm - ln)...] .= p
    return q
end

@doc raw"""
    exp(M::Euclidean, p, X)

Compute the exponential map on the [`Euclidean`](@ref) manifold `M` from `p` in direction
`X`, which in this case is just
````math
\exp_p X = p + X.
````
"""
Base.exp(::Euclidean, p, X) = p + X
exp_fused(::Euclidean, p, X, t::Number) = p .+ t .* X

exp!(::Euclidean, q, p, X) = (q .= p .+ X)
exp_fused!(::Euclidean, q, p, X, t::Number) = (q .= p .+ t .* X)
exp_fused!(::Euclidean{𝔽, TypeParameter{Tuple{}}}, q, p, X, t::Number) where {𝔽} = (q .= p[] + t * X[])
exp_fused!(::Euclidean{𝔽, Tuple{}}, q, p, X, t::Number) where {𝔽} = (q .= p[] + t * X[])

function get_basis_diagonalizing(
        M::Euclidean,
        p,
        B::DiagonalizingOrthonormalBasis{𝔽},
    ) where {𝔽}
    vecs = get_vectors(M, p, get_basis(M, p, DefaultOrthonormalBasis(𝔽)))
    eigenvalues = zeros(real(eltype(p)), manifold_dimension(M))
    return CachedBasis(B, DiagonalizingBasisData(B.frame_direction, eigenvalues, vecs))
end

function get_coordinates_orthonormal(::Euclidean{ℝ}, p, X, ::RealNumbers)
    return vec(X)
end
function get_coordinates_orthonormal(::Euclidean{ℂ}, p, X, ::ComplexNumbers)
    return vec(X)
end

function get_coordinates_orthonormal!(::Euclidean{ℝ}, c, p, X, ::RealNumbers)
    copyto!(c, vec(X))
    return c
end
function get_coordinates_orthonormal!(::Euclidean{ℂ}, c, p, X, ::ComplexNumbers)
    copyto!(c, vec(X))
    return c
end

function get_coordinates_induced_basis!(
        M::Euclidean,
        c,
        p,
        X,
        ::InducedBasis{ℝ, TangentSpaceType, <:RetractionAtlas},
    )
    copyto!(c, vec(X))
    return c
end

function get_coordinates_orthonormal!(::Euclidean{ℂ}, c, ::Any, X, ::RealNumbers)
    Xvec = vec(X)
    d = div(length(c), 2)
    view(c, 1:d) .= real.(Xvec)
    view(c, (d + 1):(2d)) .= imag.(Xvec)
    return c
end

function get_coordinates_diagonalizing!(
        ::Euclidean{ℂ},
        c,
        ::Any,
        X,
        ::DiagonalizingOrthonormalBasis{ℝ},
    )
    Xvec = vec(X)
    d = div(length(c), 2)
    view(c, 1:d) .= real.(Xvec)
    view(c, (d + 1):(2d)) .= imag.(Xvec)
    return c
end
function get_coordinates_diagonalizing!(
        ::Euclidean{𝔽},
        c,
        p,
        X,
        ::DiagonalizingOrthonormalBasis{𝔽},
    ) where {𝔽}
    copyto!(c, vec(X))
    return c
end

function get_vector_orthonormal(M::Euclidean{ℝ}, ::Any, c, ::RealNumbers)
    S = representation_size(M)
    return reshape(c, S)
end
function get_vector_orthonormal(M::Euclidean{ℂ}, ::Any, c, ::ComplexNumbers)
    S = representation_size(M)
    return reshape(c, S)
end
function get_vector_orthonormal(
        ::Euclidean{ℝ, TypeParameter{Tuple{N}}},
        ::Any,
        c,
        ::RealNumbers,
    ) where {N}
    # this method is defined just to skip a reshape
    return c
end
function get_vector_orthonormal(::Euclidean{ℝ, Tuple{Int}}, ::Any, c, ::RealNumbers)
    # this method is defined just to skip a reshape
    return c
end
function get_vector_orthonormal(
        ::Euclidean{ℝ, <:TypeParameter},
        ::SArray{S},
        c,
        ::RealNumbers,
    ) where {S}
    return SArray{S}(c)
end
function get_vector_orthonormal(
        ::Euclidean{ℝ, TypeParameter{Tuple{N}}},
        ::SArray{S},
        c,
        ::RealNumbers,
    ) where {N, S}
    # probably doesn't need rewrapping in SArray
    return c
end
function get_vector_orthonormal(
        ::Euclidean{ℝ, TypeParameter{Tuple{N}}},
        ::SizedArray{S},
        c,
        ::RealNumbers,
    ) where {N, S}
    # probably doesn't need rewrapping in SizedArray
    return c
end

function get_vector_orthonormal!(
        ::Euclidean{ℝ, TypeParameter{Tuple{N}}},
        Y,
        ::Any,
        c,
        ::RealNumbers,
    ) where {N}
    # this method is defined just to skip a reshape
    copyto!(Y, c)
    return Y
end
function get_vector_orthonormal!(M::Euclidean{ℝ}, Y, ::Any, c, ::RealNumbers)
    S = representation_size(M)
    copyto!(Y, reshape(c, S))
    return Y
end
function get_vector_orthonormal!(M::Euclidean{ℂ}, Y, ::Any, c, ::ComplexNumbers)
    S = representation_size(M)
    copyto!(Y, reshape(c, S))
    return Y
end
function get_vector_diagonalizing!(
        M::Euclidean,
        Y,
        ::Any,
        c,
        B::DiagonalizingOrthonormalBasis,
    )
    S = representation_size(M)
    copyto!(Y, reshape(c, S))
    return Y
end
function get_vector_induced_basis!(M::Euclidean, Y, ::Any, c, B::InducedBasis{ℝ, TangentSpaceType, <:RetractionAtlas})
    S = representation_size(M)
    copyto!(Y, reshape(c, S))
    return Y
end
function get_vector_orthonormal!(M::Euclidean{ℂ}, Y, ::Any, c, ::RealNumbers)
    S = representation_size(M)
    N = div(length(c), 2)
    copyto!(Y, reshape(c[1:N] .+ im .* c[(N + 1):end], S))
    return Y
end
function get_vector_diagonalizing!(
        M::Euclidean{ℂ},
        Y,
        ::Any,
        c,
        ::DiagonalizingOrthonormalBasis{ℝ},
    )
    S = representation_size(M)
    N = div(length(c), 2)
    copyto!(Y, reshape(c[1:N] .+ im .* c[(N + 1):end], S))
    return Y
end

has_components(::Euclidean) = true

@doc raw"""
    injectivity_radius(M::Euclidean)

Return the injectivity radius on the [`Euclidean`](@ref) `M`, which is ``∞``.
"""
injectivity_radius(::Euclidean) = Inf

@doc raw"""
    inner(M::Euclidean, p, X, Y)

Compute the inner product on the [`Euclidean`](@ref) `M`, which is just
the inner product on the real-valued or complex valued vector space
of arrays (or tensors) of size ``n_1 × n_2  ×  …  × n_i``, i.e.

````math
g_p(X,Y) = \sum_{k ∈ I} \overline{X}_{k} Y_{k},
````

where ``I`` is the set of vectors ``k ∈ ℕ^i``, such that for all

``i ≤ j ≤ i`` it holds ``1 ≤ k_j ≤ n_j`` and ``\overline{⋅}`` denotes the complex conjugate.

For the special case of ``i ≤ 2``, i.e. matrices and vectors, this simplifies to

````math
g_p(X,Y) = \operatorname{tr}(X^{\mathrm{H}}Y),
````

where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transposed.
"""
inner(::Euclidean, ::Any...)
@inline inner(::Euclidean, p, X, Y) = dot(X, Y)
@inline function inner(
        ::MetricManifold{𝔽, <:AbstractManifold, EuclideanMetric},
        p,
        X,
        Y,
    ) where {𝔽}
    return dot(X, Y)
end

function inverse_local_metric(
        M::MetricManifold{𝔽, <:AbstractManifold, EuclideanMetric},
        p,
        B::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return local_metric(M, p, B)
end
function inverse_local_metric(
        M::Euclidean,
        p,
        B::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return local_metric(M, p, B)
end

"""
    is_flat(::Euclidean)

Return true. [`Euclidean`](@ref) is a flat manifold.
"""
is_flat(M::Euclidean) = true

function jacobi_field(::Euclidean{𝔽, TypeParameter{Tuple{}}}, p, q, t, X, β::Tβ) where {𝔽, Tβ}
    return X
end
function jacobi_field(::Euclidean{𝔽, Tuple{}}, p, q, t, X, β::Tβ) where {𝔽, Tβ}
    return X
end

function local_metric(
        ::MetricManifold{𝔽, <:AbstractManifold, EuclideanMetric},
        p,
        B::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return Diagonal(ones(SVector{size(p, 1), eltype(p)}))
end
function local_metric(
        ::Euclidean,
        p,
        B::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return Diagonal(ones(SVector{size(p, 1), eltype(p)}))
end

@doc raw"""
    log(M::Euclidean, p, q)

Compute the logarithmic map on the [`Euclidean`](@ref) `M` from `p` to `q`,
which in this case is just
````math
\log_p q = q-p.
````
"""
Base.log(::Euclidean, ::Any...)
Base.log(::Euclidean{𝔽, TypeParameter{Tuple{}}}, p::Number, q::Number) where {𝔽} = q - p
Base.log(::Euclidean, p, q) = q .- p

log!(::Euclidean, X, p, q) = (X .= q .- p)

function log_local_metric_density(
        ::MetricManifold{𝔽, <:AbstractManifold, EuclideanMetric},
        p,
        ::InducedBasis{𝔽, TangentSpaceType, <:RetractionAtlas},
    ) where {𝔽}
    return zero(eltype(p))
end

_product_of_dimensions(M::Euclidean) = prod(get_parameter(M.size))

"""
    manifold_dimension(M::Euclidean)

Return the manifold dimension of the [`Euclidean`](@ref) `M`, i.e.
the product of all array dimensions and the [`real_dimension`](@extref `ManifoldsBase.real_dimension-Tuple{ManifoldsBase.AbstractNumbers}`) of the
underlying number system.
"""
function manifold_dimension(M::Euclidean{𝔽}) where {𝔽}
    return _product_of_dimensions(M) * real_dimension(𝔽)
end
manifold_dimension(::Euclidean{𝔽, TypeParameter{Tuple{}}}) where {𝔽} = real_dimension(𝔽)

"""
    manifold_volume(::Euclidean)

Return volume of the [`Euclidean`](@ref) manifold, i.e. infinity.
"""
manifold_volume(::Euclidean) = Inf

function Statistics.mean(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector,
        ::EfficientEstimator;
        kwargs...,
    ) where {𝔽}
    return mean(x)
end
function Statistics.mean(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector,
        w::AbstractWeights,
        ::EfficientEstimator;
        kwargs...,
    ) where {𝔽}
    return mean(x, w)
end
#
# When Statistics / Statsbase.mean! is consistent with mean, we can pass this on to them as well
function Statistics.mean!(
        ::Euclidean,
        y,
        x::AbstractVector,
        ::EfficientEstimator;
        kwargs...,
    )
    n = length(x)
    copyto!(y, first(x))
    @inbounds for j in 2:n
        y .+= x[j]
    end
    y ./= n
    return y
end
function Statistics.mean!(
        ::Euclidean,
        y,
        x::AbstractVector,
        w::AbstractWeights,
        ::EfficientEstimator;
        kwargs...,
    )
    n = length(x)
    if length(w) != n
        throw(
            DimensionMismatch(
                "The number of weights ($(length(w))) does not match the number of points for the mean ($(n)).",
            ),
        )
    end
    copyto!(y, first(x))
    y .*= first(w)
    @inbounds for j in 2:n
        iszero(w[j]) && continue
        y .+= w[j] .* x[j]
    end
    y ./= sum(w)
    return y
end

function StatsBase.mean_and_var(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector{<:Number};
        kwargs...,
    ) where {𝔽}
    m, v = mean_and_var(x; kwargs...)
    return m, sum(v)
end
function StatsBase.mean_and_var(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector{<:Number},
        w::AbstractWeights;
        corrected = false,
        kwargs...,
    ) where {𝔽}
    m, v = mean_and_var(x, w; corrected = corrected, kwargs...)
    return m, sum(v)
end

function Statistics.median(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector{<:Number},
        ::EfficientEstimator;
        kwargs...,
    ) where {𝔽}
    return median(x)
end
function Statistics.median(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        x::AbstractVector{<:Number},
        w::AbstractWeights,
        ::EfficientEstimator;
        kwargs...,
    ) where {𝔽}
    return median(x, w)
end

metric(::Euclidean) = EuclideanMetric()

mid_point(::Euclidean, p1, p2) = (p1 .+ p2) ./ 2
function mid_point(
        ::Union{Euclidean{𝔽, TypeParameter{Tuple{}}}, Euclidean{𝔽, Tuple{}}},
        p1::Number,
        p2::Number,
    ) where {𝔽}
    return (p1 + p2) / 2
end

function mid_point!(::Euclidean, q, p1, p2)
    q .= (p1 .+ p2) ./ 2
    return q
end

@doc raw"""
    norm(M::Euclidean, p, X, r::Real=2)

Compute the norm of a tangent vector `X` at `p` on the [`Euclidean`](@ref)
`M`, i.e. since every tangent space can be identified with `M` itself
in this case, just the (Frobenius) norm of `X`. Specifying `r`, other norms are available as well
"""
LinearAlgebra.norm(::Euclidean, ::Any, X, r::Real = 2) = norm(X, r)
function LinearAlgebra.norm(
        ::MetricManifold{ℝ, <:AbstractManifold, EuclideanMetric},
        p,
        X,
        r::Real = 2,
    )
    return norm(X, r)
end

function project!(
        ::EmbeddedManifold{𝔽, Euclidean{𝔽, nL}, Euclidean{𝔽2, mL}},
        q,
        p,
    ) where {nL, mL, 𝔽, 𝔽2}
    n = size(p)
    ln = length(n)
    m = size(q)
    lm = length(m)
    (length(n) < length(m)) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) is longer than embedding dimension $(m).",
        ),
    )
    any(n .< m[1:ln]) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) has entry larger than embedding dimensions ($(m)).",
        ),
    )
    #  fill q with the „top left edge“ of p.
    q .= p[map(i -> Base.OneTo(i), m)..., ntuple(_ -> 1, lm - ln)...]
    return q
end

"""
    parallel_transport_direction(M::Euclidean, p, X, d)

the parallel transport on [`Euclidean`](@ref) is the identity, i.e. returns `X`.
"""
parallel_transport_direction(::Euclidean, ::Any, X, ::Any) = X
parallel_transport_direction!(::Euclidean, Y, ::Any, X, ::Any) = copyto!(Y, X)

"""
    parallel_transport_to(M::Euclidean, p, X, q)

the parallel transport on [`Euclidean`](@ref) is the identity, i.e. returns `X`.
"""
parallel_transport_to(::Euclidean, ::Any, X, ::Any) = X
parallel_transport_to!(::Euclidean, Y, ::Any, X, ::Any) = copyto!(Y, X)
function parallel_transport_to!(::Euclidean{𝔽, TypeParameter{Tuple{}}}, Y, ::Any, X, ::Any) where {𝔽}
    return copyto!(Y, X[])
end
parallel_transport_to!(::Euclidean{𝔽, Tuple{}}, Y, ::Any, X, ::Any) where {𝔽} = copyto!(Y, X[])

@doc raw"""
    project(M::Euclidean, p)

Project an arbitrary point `p` onto the [`Euclidean`](@ref) manifold `M`, which
is of course just the identity map.
"""
project(::Euclidean, ::Any)
project(::Euclidean{𝔽, TypeParameter{Tuple{}}}, p::Number) where {𝔽} = p
project(::Euclidean{𝔽, Tuple{}}, p::Number) where {𝔽} = p

project!(::Euclidean, q, p) = copyto!(q, p)

"""
    project(M::Euclidean, p, X)

Project an arbitrary vector `X` into the tangent space of a point `p` on the
[`Euclidean`](@ref) `M`, which is just the identity, since any tangent
space of `M` can be identified with all of `M`.
"""
project(::Euclidean, ::Any, ::Any)
project(::Euclidean{𝔽, TypeParameter{Tuple{}}}, ::Number, X::Number) where {𝔽} = X
project(::Euclidean{𝔽, Tuple{}}, ::Number, X::Number) where {𝔽} = X

project!(::Euclidean, Y, p, X) = copyto!(Y, X)

function Random.rand!(
        rng::AbstractRNG, ::Euclidean, pX;
        σ = one(eltype(pX)),
        vector_at = nothing,
    )
    pX .= randn(rng, eltype(pX), size(pX)) .* σ
    return pX
end

"""
    representation_size(M::Euclidean)

Return the array dimensions required to represent an element on the
[`Euclidean`](@ref) `M`, i.e. the vector of all array dimensions.
"""
representation_size(M::Euclidean) = get_parameter(M.size)

function retract(M::Euclidean{𝔽, TypeParameter{Tuple{}}}, p::Number, q::Number) where {𝔽}
    return retract(M, p, q, ExponentialRetraction())
end
function retract(
        M::Euclidean{𝔽, TypeParameter{Tuple{}}},
        p::Number, q::Number, ::ExponentialRetraction,
    ) where {𝔽}
    return exp(M, p, q)
end

@doc raw"""
    riemann_tensor(M::Euclidean, p, X, Y, Z)

Compute the Riemann tensor ``R(X,Y)Z`` at point `p` on [`Euclidean`](@ref) manifold `M`.
Its value is always the zero tangent vector.
"""
riemann_tensor(M::Euclidean, p, X, Y, Z)

function riemann_tensor!(::Euclidean, Xresult, p, X, Y, Z)
    return fill!(Xresult, 0)
end

@doc raw"""
    sectional_curvature(::Euclidean, p, X, Y)

Sectional curvature of [`Euclidean`](@ref) manifold `M` is 0.
"""
function sectional_curvature(::Euclidean, p, X, Y)
    return 0.0
end

@doc raw"""
    sectional_curvature_max(::Euclidean)

Sectional curvature of [`Euclidean`](@ref) manifold `M` is 0.
"""
function sectional_curvature_max(::Euclidean)
    return 0.0
end

@doc raw"""
    sectional_curvature_min(M::Euclidean)

Sectional curvature of [`Euclidean`](@ref) manifold `M` is 0.
"""
function sectional_curvature_min(::Euclidean)
    return 0.0
end

function Base.show(io::IO, M::Euclidean{𝔽, N}) where {N <: Tuple, 𝔽}
    size = get_parameter(M.size)
    return print(io, "Euclidean($(join(size, ", ")); field=$(𝔽), parameter=:field)")
end
function Base.show(io::IO, M::Euclidean{𝔽, N}) where {N <: TypeParameter, 𝔽}
    size = get_parameter(M.size)
    return print(io, "Euclidean($(join(size, ", ")); field=$(𝔽))")
end
#
# Vector Transport
#
# The following functions are defined on layer 1 already, since
# a) its independent of the transport or retraction method
# b) no ambiguities occur
# c) Euclidean is so basic, that these are plain defaults
#
function vector_transport_direction(
        M::Euclidean,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return X
end
function vector_transport_direction!(
        M::Euclidean,
        Y,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return copyto!(Y, X)
end
"""
    vector_transport_to(M::Euclidean, p, X, q, ::AbstractVectorTransportMethod)

Transport the vector `X` from the tangent space at `p` to the tangent space at `q`
on the [`Euclidean`](@ref) `M`, which simplifies to the identity.
"""
vector_transport_to(::Euclidean, ::Any, ::Any, ::Any, ::AbstractVectorTransportMethod)
function vector_transport_to(
        M::Euclidean,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return X
end

function vector_transport_to!(
        M::Euclidean,
        Y,
        p,
        X,
        ::Any,
        ::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
        ::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return copyto!(Y, X)
end

Statistics.var(::Euclidean, x::AbstractVector; kwargs...) = sum(var(x; kwargs...))
function Statistics.var(::Euclidean, x::AbstractVector{<:Number}, m::Number; kwargs...)
    return sum(var(x; mean = m, kwargs...))
end

@doc raw"""
    volume_density(M::Euclidean, p, X)

Return volume density function of [`Euclidean`](@ref) manifold `M`, i.e. 1.
"""
function volume_density(::Euclidean, p, X)
    return one(eltype(X))
end

@doc raw"""
    Y = Weingarten(M::Euclidean, p, X, V)
    Weingarten!(M::Euclidean, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p`` at `p` on the [`Euclidean`](@ref) `M` with respect to the
tangent vector ``X \in T_p\mathcal M`` and the normal vector ``V \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::Euclidean, p, X, V)

Weingarten!(::Euclidean, Y, p, X, V) = fill!(Y, 0)

"""
    zero_vector(M::Euclidean, p)

Return the zero vector in the tangent space of `p` on the [`Euclidean`](@ref)
`M`, which here is just a zero filled array the same size as `p`.
"""
zero_vector(::Euclidean, ::Any...)
zero_vector(::Euclidean{𝔽, TypeParameter{Tuple{}}}, p::Number) where {𝔽} = zero(p)
zero_vector(::Euclidean{𝔽, Tuple{}}, p::Number) where {𝔽} = zero(p)

zero_vector!(::Euclidean, X, ::Any) = fill!(X, 0)

@doc raw"""
    LorentzMetric <: AbstractMetric

Abstract type for Lorentz metrics, which have a single time dimension. These
metrics assume the spacelike convention with the time dimension being last,
giving the signature $(++...+-)$.
"""
abstract type LorentzMetric <: AbstractMetric end

@doc raw"""
    MinkowskiMetric <: LorentzMetric

As a special metric of signature  $(++...+-)$, i.e. a [`LorentzMetric`](@ref),
see [`minkowski_metric`](@ref) for the formula.
"""
struct MinkowskiMetric <: LorentzMetric end

@doc raw"""
    Lorentz{T} = MetricManifold{Euclidean{T,ℝ},LorentzMetric}

The Lorentz manifold (or Lorentzian) is a pseudo-Riemannian manifold.

# Constructor

    Lorentz(n[, metric=MinkowskiMetric()])

Generate the Lorentz manifold of dimension `n` with the [`LorentzMetric`](@ref) `m`,
which is by default set to the [`MinkowskiMetric`](@ref).
"""
const Lorentz = MetricManifold{ℝ, Euclidean{ℝ, T}, <:LorentzMetric} where {T}

function Lorentz(n::Int, m::LorentzMetric = MinkowskiMetric(); parameter::Symbol = :type)
    E = Euclidean(n; parameter = parameter)
    return Lorentz(E, m)
end
function Lorentz(E::Euclidean{𝔽, T}, m::LorentzMetric = MinkowskiMetric()) where {𝔽, T}
    return Lorentz{T, typeof(m)}(E, m)
end

function local_metric(M::Lorentz{<:Any, MinkowskiMetric}, p)
    n = get_parameter(M.manifold.size)[1]
    return Diagonal([ones(n - 1)..., -1])
end

function inner(::Lorentz{<:Any, MinkowskiMetric}, p, X, Y)
    return minkowski_metric(X, Y)
end
@doc raw"""
    minkowski_metric(a, b)

Compute the minkowski metric on $\mathbb R^n$ is given by
````math
⟨a,b⟩_{\mathrm{M}} = -a_{n}b_{n} +
\displaystyle\sum_{k=1}^{n-1} a_kb_k.
````
"""
function minkowski_metric(a, b)
    a_part = @view a[1:(end - 1)]
    b_part = @view b[1:(end - 1)]
    return -a[end] * b[end] + dot(a_part, b_part)
end
function minkowski_metric(a::StaticVector{N}, b::StaticVector{N}) where {N}
    return -a[N] * b[N] + dot(a[SOneTo(N - 1)], b[SOneTo(N - 1)])
end

"""
    IntegratorTerminatorNearChartBoundary{TKwargs}

An object for determining the point at which integration of a differential equation
in a chart on a manifold should be terminated for the purpose of switching a chart.

The value stored in `check_chart_switch_kwargs` will be passed as keyword arguments
to  [`check_chart_switch`](@ref). By default an empty tuple is stored.
"""
struct IntegratorTerminatorNearChartBoundary{TKwargs}
    check_chart_switch_kwargs::TKwargs
end

function IntegratorTerminatorNearChartBoundary()
    return IntegratorTerminatorNearChartBoundary(NamedTuple())
end

@doc raw"""
    FiberBundleProductVectorTransport{
        TMP<:AbstractVectorTransportMethod,
        TMV<:AbstractVectorTransportMethod,
    } <: AbstractVectorTransportMethod

Vector transport type on [`FiberBundle`](@ref).

# Fields

* `method_horizontal` – vector transport method of the horizontal part (related to manifold M)
* `method_vertical` – vector transport method of the vertical part (related to fibers).

The vector transport is derived as a product manifold-style vector transport.
The considered product manifold is the product between the manifold ``\mathcal M``
and the space corresponding to the fiber.

# Constructor

    FiberBundleProductVectorTransport(
        M::AbstractManifold=DefaultManifold();
        vector_transport_method_horizontal::AbstractVectorTransportMethod = default_vector_transport_method(M),
        vector_transport_method_vertical::AbstractVectorTransportMethod = default_vector_transport_method(M),
    )

Construct the `FiberBundleProductVectorTransport` using the [`default_vector_transport_method`](@ref),
which uses [`ParallelTransport`](@extref `ManifoldsBase.ParallelTransport`)
if no manifold is provided.
"""
struct FiberBundleProductVectorTransport{
        TMP <: AbstractVectorTransportMethod,
        TMV <: AbstractVectorTransportMethod,
    } <: AbstractVectorTransportMethod
    method_horizontal::TMP
    method_vertical::TMV
end
function FiberBundleProductVectorTransport(
        M::AbstractManifold = ManifoldsBase.DefaultManifold(),
        fiber::FiberType = TangentSpaceType();
        vector_transport_method_horizontal::AbstractVectorTransportMethod = default_vector_transport_method(
            M,
        ),
        vector_transport_method_vertical::AbstractVectorTransportMethod = fiber_bundle_transport(
            M,
            fiber,
        ),
    )
    return FiberBundleProductVectorTransport(
        vector_transport_method_horizontal,
        vector_transport_method_vertical,
    )
end

"""
    FiberBundle{𝔽,TVS<:FiberType,TM<:AbstractManifold{𝔽},TVT<:FiberBundleProductVectorTransport} <: AbstractManifold{𝔽}

Fiber bundle on a [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)
`M` of type [`FiberType`](@extref `ManifoldsBase.FiberType`).
Examples include vector bundles, principal bundles or unit tangent bundles, see also [Fiber Bundle](https://en.wikipedia.org/wiki/Fiber_bundle).

# Fields
* `manifold` – the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)
               manifold the Fiber bundle is defined on,
* `type`     – representing the type of fiber we use.

# Constructor

    FiberBundle(M::AbstractManifold, type::FiberType)
"""
struct FiberBundle{
        𝔽,
        TF <: FiberType,
        TM <: AbstractManifold{𝔽},
        TVT <: FiberBundleProductVectorTransport,
    } <: AbstractManifold{𝔽}
    type::TF
    manifold::TM
    vector_transport::TVT
end

function FiberBundle(fiber::FiberType, M::AbstractManifold)
    vtmm = vector_bundle_transport(fiber, M)
    vtbm = FiberBundleProductVectorTransport(vtmm, vtmm)
    return FiberBundle(fiber, M, vtbm)
end

@doc raw"""
    struct FiberBundleInverseProductRetraction <: AbstractInverseRetractionMethod end

Inverse retraction of the point `y` at point `p` from vector bundle `B` over manifold
`B.fiber` (denoted ``\mathcal M``). The inverse retraction is derived as a product manifold-style
approximation to the logarithmic map in the Sasaki metric. The considered product manifold
is the product between the manifold ``\mathcal M`` and the topological vector space isometric
to the fiber.

## Notation
The point ``p = (x_p, V_p)`` where ``x_p ∈ \mathcal M`` and ``V_p`` belongs to
the fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the canonical
projection of that vector bundle ``B``. Similarly, ``q = (x_q, V_q)``.

The inverse retraction is calculated as

```math
\operatorname{retr}^{-1}_p q = (\operatorname{retr}^{-1}_{x_p}(x_q), V_{\operatorname{retr}^{-1}} - V_p)
```

where ``V_{\operatorname{retr}^{-1}}`` is the result of vector transport of ``V_q`` to the point ``x_p``.
The difference ``V_{\operatorname{retr}^{-1}} - V_p`` corresponds to the logarithmic map in
the vector space ``F``.

See also [`FiberBundleProductRetraction`](@ref).
"""
struct FiberBundleInverseProductRetraction <: AbstractInverseRetractionMethod end

@doc raw"""
    struct FiberBundleProductRetraction <: AbstractRetractionMethod end

Product retraction map of tangent vector ``X`` at point ``p`` from vector bundle `B` over
manifold `B.fiber` (denoted ``\mathcal M``). The retraction is derived as a product manifold-style
approximation to the exponential map in the Sasaki metric. The considered product manifold
is the product between the manifold ``\mathcal M`` and the topological vector space isometric
to the fiber.

## Notation:
* The point ``p = (x_p, V_p)`` where ``x_p ∈ \mathcal M`` and ``V_p`` belongs to the
  fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
  canonical projection of that vector bundle ``B``.
* The tangent vector ``X = (V_{X,M}, V_{X,F}) ∈ T_pB`` where
  ``V_{X,M}`` is a tangent vector from the tangent space ``T_{x_p}\mathcal M`` and
  ``V_{X,F}`` is a tangent vector from the tangent space ``T_{V_p}F`` (isomorphic to ``F``).

The retraction is calculated as

```math
\operatorname{retr}_p(X) = (\exp_{x_p}(V_{X,M}), V_{\exp})
````

where ``V_{\exp}`` is the result of vector transport of ``V_p + V_{X,F}``
to the point ``\exp_{x_p}(V_{X,M})``.
The sum ``V_p + V_{X,F}`` corresponds to the exponential map in the vector space ``F``.

See also [`FiberBundleInverseProductRetraction`](@ref).
"""
struct FiberBundleProductRetraction <: AbstractRetractionMethod end

vector_bundle_transport(::FiberType, M::AbstractManifold) = ParallelTransport()

struct FiberBundleBasisData{BBasis <: CachedBasis, TBasis <: CachedBasis}
    base_basis::BBasis
    fiber_basis::TBasis
end

"""
    base_manifold(B::FiberBundle)

Return the manifold the [`FiberBundle`](@ref)s is build on.
"""
base_manifold(B::FiberBundle) = base_manifold(B.manifold)

@doc raw"""
    bundle_transport_to(B::FiberBundle, p, X, q)

Given a fiber bundle ``B=F \mathcal M``, points ``p, q\in\mathcal M``, an element ``X`` of
the fiber over ``p``, transport ``X`` to fiber over ``q``.

Exact meaning of the operation depends on the fiber bundle, or may even be undefined.
Some fiber bundles may declare a default local section around each point crossing `X`,
represented by this function.
"""
function bundle_transport_to(B::FiberBundle, p, X, q)
    Y = allocate(X)
    return bundle_transport_to!(B, Y, p, X, q)
end

@doc raw"""
    bundle_transport_tangent_direction(B::FiberBundle, p, pf, X, d)

Compute parallel transport of vertical vector `X` according to Ehresmann connection on
[`FiberBundle`](@ref) `B`, in direction ``d\in T_p \mathcal M``. ``X`` is an element of the
vertical bundle ``VF\mathcal M`` at `pf` from tangent to fiber ``\pi^{-1}({p})``,
``p\in \mathcal M``.
"""
function bundle_transport_tangent_direction(
        B::FiberBundle,
        p,
        pf,
        X,
        d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(B.manifold),
    )
    Y = allocate(X)
    return bundle_transport_tangent_direction!(B, Y, p, pf, X, d, m)
end

@doc raw"""
    bundle_transport_tangent_to(B::FiberBundle, p, pf, X, q)

Compute parallel transport of vertical vector `X` according to Ehresmann connection on
[`FiberBundle`](@ref) `B`, to point ``q\in \mathcal M``. ``X`` is an element of the vertical
bundle ``VF\mathcal M`` at `pf` from tangent to fiber ``\pi^{-1}({p})``,
``p\in \mathcal M``.
"""
function bundle_transport_tangent_to(
        B::FiberBundle,
        p,
        pf,
        X,
        q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(B.manifold),
    )
    Y = allocate(X)
    return bundle_transport_tangent_to!(B, Y, p, pf, X, q, m)
end

"""
    bundle_projection(B::FiberBundle, p)

Projection of point `p` from the bundle `M` to the base manifold.
Returns the point on the base manifold `B.manifold` at which the vector part
of `p` is attached.
"""
bundle_projection(B::FiberBundle, p) = submanifold_component(B.manifold, p, Val(1))

function get_basis(M::FiberBundle, p, B::AbstractBasis)
    xp1, xp2 = submanifold_components(M, p)
    base_basis = get_basis(M.manifold, xp1, B)
    F = Fiber(M.manifold, xp1, M.type)
    fiber_basis = get_basis(F, xp2, B)
    return CachedBasis(B, FiberBundleBasisData(base_basis, fiber_basis))
end
function get_basis(M::FiberBundle, p, B::CachedBasis)
    return invoke(get_basis, Tuple{AbstractManifold, Any, CachedBasis}, M, p, B)
end

function get_coordinates(M::FiberBundle, p, X, B::AbstractBasis)
    px, Vx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    F = Fiber(M.manifold, px, M.type)
    return vcat(get_coordinates(M.manifold, px, VXM, B), get_coordinates(F, Vx, VXF, B))
end

function get_coordinates!(M::FiberBundle, Y, p, X, B::AbstractBasis)
    px, Vx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    n = manifold_dimension(M.manifold)
    get_coordinates!(M.manifold, view(Y, 1:n), px, VXM, B)
    F = Fiber(M.manifold, px, M.type)
    get_coordinates!(F, view(Y, (n + 1):length(Y)), Vx, VXF, B)
    return Y
end

function get_coordinates(
        M::FiberBundle,
        p,
        X,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:FiberBundleBasisData},
    ) where {𝔽}
    px, Vx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    F = Fiber(M.manifold, px, M.type)
    return vcat(
        get_coordinates(M.manifold, px, VXM, B.data.base_basis),
        get_coordinates(F, Vx, VXF, B.data.fiber_basis),
    )
end

function get_coordinates!(
        M::FiberBundle,
        Y,
        p,
        X,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:FiberBundleBasisData},
    ) where {𝔽}
    px, Vx = submanifold_components(M.manifold, p)
    VXM, VXF = submanifold_components(M.manifold, X)
    n = manifold_dimension(M.manifold)
    F = Fiber(M.manifold, px, M.type)
    get_coordinates!(M.manifold, view(Y, 1:n), px, VXM, B.data.base_basis)
    get_coordinates!(F, view(Y, (n + 1):length(Y)), Vx, VXF, B.data.fiber_basis)
    return Y
end

function get_vector!(M::FiberBundle, Y, p, X, B::AbstractBasis)
    n = manifold_dimension(M.manifold)
    xp1, xp2 = submanifold_components(M, p)
    Yp1, Yp2 = submanifold_components(M, Y)
    F = Fiber(M.manifold, xp1, M.type)
    get_vector!(M.manifold, Yp1, xp1, X[1:n], B)
    get_vector!(F, Yp2, xp2, X[(n + 1):end], B)
    return Y
end

function get_vector!(
        M::FiberBundle,
        Y,
        p,
        X,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:FiberBundleBasisData},
    ) where {𝔽}
    n = manifold_dimension(M.manifold)
    xp1, xp2 = submanifold_components(M, p)
    Yp1, Yp2 = submanifold_components(M, Y)
    F = Fiber(M.manifold, xp1, M.type)
    get_vector!(M.manifold, Yp1, xp1, X[1:n], B.data.base_basis)
    get_vector!(F, Yp2, xp2, X[(n + 1):end], B.data.fiber_basis)
    return Y
end

function _isapprox(B::FiberBundle, p, q; kwargs...)
    xp, Vp = submanifold_components(B.manifold, p)
    xq, Vq = submanifold_components(B.manifold, q)
    return isapprox(B.manifold, xp, xq; kwargs...) &&
        isapprox(Fiber(B.manifold, xp, B.type), Vp, Vq; kwargs...)
end
function _isapprox(B::FiberBundle, p, X, Y; kwargs...)
    px, Vx = submanifold_components(B.manifold, p)
    VXM, VXF = submanifold_components(B.manifold, X)
    VYM, VYF = submanifold_components(B.manifold, Y)
    return isapprox(B.manifold, VXM, VYM; kwargs...) &&
        isapprox(Fiber(B.manifold, px, B.type), Vx, VXF, VYF; kwargs...)
end

function manifold_dimension(B::FiberBundle)
    return manifold_dimension(B.manifold) + fiber_dimension(B.manifold, B.type)
end

function Random.rand!(M::FiberBundle, pX; vector_at = nothing)
    return rand!(Random.default_rng(), M, pX; vector_at = vector_at)
end
function Random.rand!(rng::AbstractRNG, M::FiberBundle, pX; vector_at = nothing)
    pXM, pXF = submanifold_components(M.manifold, pX)
    if vector_at === nothing
        rand!(rng, M.manifold, pXM)
        rand!(rng, Fiber(M.manifold, pXM, M.type), pXF)
    else
        vector_atM, vector_atF = submanifold_components(M.manifold, vector_at)
        rand!(rng, M.manifold, pXM; vector_at = vector_atM)
        rand!(rng, Fiber(M.manifold, pXM, M.type), pXF; vector_at = vector_atF)
    end
    return pX
end

@doc raw"""
    zero_vector(B::FiberBundle, p)

Zero tangent vector at point `p` from the fiber bundle `B`
over manifold `B.fiber` (denoted ``\mathcal M``). The zero vector belongs to the space ``T_{p}B``

Notation:
  * The point ``p = (x_p, V_p)`` where ``x_p ∈ \mathcal M`` and ``V_p`` belongs to the
    fiber ``F=π^{-1}(\{x_p\})`` of the vector bundle ``B`` where ``π`` is the
    canonical projection of that vector bundle ``B``.

The zero vector is calculated as

``\mathbf{0}_{p} = (\mathbf{0}_{x_p}, \mathbf{0}_F)``

where ``\mathbf{0}_{x_p}`` is the zero tangent vector from ``T_{x_p}\mathcal M`` and
``\mathbf{0}_F`` is the zero element of the vector space ``F``.
"""
zero_vector(::FiberBundle, ::Any...)

function zero_vector!(B::FiberBundle, X, p)
    xp, Vp = submanifold_components(B.manifold, p)
    VXM, VXF = submanifold_components(B.manifold, X)
    F = Fiber(B.manifold, xp, B.type)
    zero_vector!(B.manifold, VXM, xp)
    zero_vector!(F, VXF, Vp)
    return X
end

function Base.show(io::IO, B::FiberBundle)
    return print(io, "FiberBundle($(B.type), $(B.manifold), $(B.vector_transport))")
end

"""
    ProjectedPointDistribution(M::AbstractManifold, d, proj!, p)

Generates a random point in ambient space of `M` and projects it to `M`
using function `proj!`. Generated arrays are of type `TResult`, which can be
specified by providing the `p` argument.
"""
struct ProjectedPointDistribution{TResult, TM <: AbstractManifold, TD <: Distribution, TProj} <:
    MPointDistribution{TM}
    manifold::TM
    distribution::TD
    proj!::TProj
end

function ProjectedPointDistribution(
        M::AbstractManifold,
        d::Distribution,
        proj!,
        ::TResult,
    ) where {TResult}
    return ProjectedPointDistribution{TResult, typeof(M), typeof(d), typeof(proj!)}(
        M,
        d,
        proj!,
    )
end

"""
    projected_distribution(M::AbstractManifold, d, [p=rand(d)])

Wrap the standard distribution `d` into a manifold-valued distribution. Generated
points will be of similar type to `p`. By default, the type is not changed.
"""
function projected_distribution(M::AbstractManifold, d, p = rand(d))
    return ProjectedPointDistribution(M, d, project!, p)
end

function Random.rand(
        rng::AbstractRNG,
        d::ProjectedPointDistribution{TResult},
    ) where {TResult}
    p = convert(TResult, rand(rng, d.distribution))
    return d.proj!(d.manifold, p, p)
end

function Random.rand(
        rng::AbstractRNG,
        d::ProjectedPointDistribution{TResult},
        n::Int,
    ) where {TResult}
    ps = [convert(TResult, rand(rng, d.distribution)) for _ in 1:n]
    map(p -> d.proj!(d.manifold, p, p), ps)
    return ps
end

function Distributions._rand!(
        rng::AbstractRNG,
        d::ProjectedPointDistribution,
        p::AbstractArray{<:Number},
    )
    Distributions._rand!(rng, d.distribution, p)
    return d.proj!(d.manifold, p, p)
end

Distributions.support(d::ProjectedPointDistribution) = MPointSupport(d.manifold)

"""
    ProjectedFVectorDistribution(type::VectorSpaceFiber, p, d, project!)

Generates a random vector from ambient space of manifold `type.manifold`
at point `p` and projects it to vector space of type `type` using function
`project!`, see [`project`](@ref) for documentation.
Generated arrays are of type `TResult`.
"""
struct ProjectedFVectorDistribution{
        TResult,
        TSpace <: VectorSpaceFiber,
        TD <: Distribution,
        TProj,
    } <: FVectorDistribution{TSpace}
    type::TSpace
    distribution::TD
    project!::TProj
end

function ProjectedFVectorDistribution(
        type::VectorSpaceFiber,
        d::Distribution,
        project!,
        ::TResult,
    ) where {TResult}
    return ProjectedFVectorDistribution{TResult, typeof(type), typeof(d), typeof(project!)}(
        type,
        d,
        project!,
    )
end

function Random.rand(
        rng::AbstractRNG,
        d::ProjectedFVectorDistribution{TResult},
    ) where {TResult}
    X = convert(TResult, reshape(rand(rng, d.distribution), size(d.type.point)))
    return d.project!(d.type.manifold, X, d.type.point, X)
end

function Distributions._rand!(
        rng::AbstractRNG,
        d::ProjectedFVectorDistribution,
        X::AbstractArray{<:Number},
    )
    # calling _rand!(rng, d.d, v) doesn't work for all arrays types
    return copyto!(X, rand(rng, d))
end

"""
    normal_tvector_distribution(M::Euclidean, p, σ)

Normal distribution in ambient space with standard deviation `σ`
projected to tangent space at `p`.
"""
function normal_tvector_distribution(M::AbstractManifold, p, σ)
    d = Distributions.MvNormal(zero(vec(p)), σ * I)
    return ProjectedFVectorDistribution(TangentSpace(M, p), d, project!, p)
end

function Distributions.support(tvd::ProjectedFVectorDistribution)
    return FVectorSupport(tvd.type)
end

include("../header.jl")

using HybridArrays, Random
using StaticArrays: Dynamic
using RecursiveArrayTools

Random.seed!(42)

struct TestExponentialAtlas <: Manifolds.AbstractAtlas{ℝ} end

function Manifolds.get_point!(M::AbstractManifold, p, ::TestExponentialAtlas, i, a)
    return exp!(M, p, i, get_vector(M, i, a, DefaultOrthonormalBasis()))
end

function Manifolds.get_parameters!(M::AbstractManifold, a, ::TestExponentialAtlas, i, p)
    return get_coordinates!(M, a, i, log(M, i, p), DefaultOrthonormalBasis())
end

@testset "Power manifold" begin
    Ms = Sphere(2)
    Ms1 = PowerManifold(Ms, 5)
    @test power_dimensions(Ms1) == (5,)
    @test manifold_dimension(Ms1) == 10
    @test injectivity_radius(Ms1) == π
    Ms2 = PowerManifold(Ms, 5, 7)
    @test power_dimensions(Ms2) == (5, 7)
    @test manifold_dimension(Ms2) == 70
    Ms2n = PowerManifold(Ms1, NestedPowerRepresentation(), 7)
    @test power_dimensions(Ms2n) == (7,)
    @test manifold_dimension(Ms2n) == 70

    Mr = Rotations(3; parameter = :type)
    Mr1 = PowerManifold(Mr, 5)
    Mrn1 = PowerManifold(Mr, Manifolds.NestedPowerRepresentation(), 5)
    @test PowerManifold(PowerManifold(Mr, 2), 3) == PowerManifold(Mr, 2, 3)
    @test PowerManifold(Torus(2), 3) isa PowerManifold{ℝ, Torus{2}}
    @test PowerManifold(Mrn1, 3) ==
        PowerManifold(Mr, Manifolds.NestedPowerRepresentation(), 5, 3)
    @test PowerManifold(Mrn1, Manifolds.ArrayPowerRepresentation(), 3) ==
        PowerManifold(Mr, Manifolds.ArrayPowerRepresentation(), 5, 3)
    @test manifold_dimension(Mr1) == 15
    @test manifold_dimension(Mrn1) == 15
    Mr2 = PowerManifold(Mr, 5, 7)
    Mrn2 = PowerManifold(Mr, Manifolds.NestedPowerRepresentation(), 5, 7)
    @test manifold_dimension(Mr2) == 105
    @test manifold_dimension(Mrn2) == 105

    @test repr(Ms1) == "PowerManifold(Sphere(2), 5)"
    @test repr(Mrn1) == "PowerManifold(Rotations(3), NestedPowerRepresentation(), 5)"

    @test Manifolds.allocation_promotion_function(Ms, exp, ([1],)) ==
        Manifolds.allocation_promotion_function(Ms1, exp, (1,))

    @test Ms^5 === Oblique(3, 5)
    @test Ms^(5,) === Ms1
    @test Mr^(5, 7) === Mr2

    types_s2 = [Array{Float64, 3}, HybridArray{Tuple{3, Dynamic(), Dynamic()}, Float64, 3}]

    types_rn1 = [Vector{Matrix{Float64}}]

    types_r2 = [Array{Float64, 4}, HybridArray{Tuple{3, 3, Dynamic(), Dynamic()}, Float64, 4}]
    types_rn2 = [Matrix{Matrix{Float64}}]

    retraction_methods = [ManifoldsBase.ExponentialRetraction()]
    inverse_retraction_methods = [ManifoldsBase.LogarithmicInverseRetraction()]

    sphere_dist = Manifolds.uniform_distribution(Ms, @SVector [1.0, 0.0, 0.0])

    point_distributions_Mrn1 = []
    tvector_distributions_Mrn1 = []
    point_distributions_Mr2 = []
    tvector_distributions_Mr2 = []
    point_distributions_Mrn2 = []
    tvector_distributions_Mrn2 = []
    point_distributions_Ms2 = []
    tvector_distributions_Ms2 = []
    if VERSION >= v"1.9"
        PowerPointDistribution =
            Base.get_extension(Manifolds, :ManifoldsDistributionsExt).PowerPointDistribution

        PowerFVectorDistribution =
            Base.get_extension(
            Manifolds,
            :ManifoldsDistributionsExt,
        ).PowerFVectorDistribution
        power_s1_pt_dist = PowerPointDistribution(Ms1, sphere_dist, randn(Float64, 3, 5))
        power_s2_pt_dist = PowerPointDistribution(Ms2, sphere_dist, randn(Float64, 3, 5, 7))
        push!(point_distributions_Ms2, power_s2_pt_dist)

        sphere_tv_dist =
            Manifolds.normal_tvector_distribution(Ms, (@MVector [1.0, 0.0, 0.0]), 1.0)
        power_s1_tv_dist = PowerFVectorDistribution(
            TangentSpace(Ms1, rand(power_s1_pt_dist)),
            sphere_tv_dist,
        )
        power_s2_tv_dist = PowerFVectorDistribution(
            TangentSpace(Ms2, rand(power_s2_pt_dist)),
            sphere_tv_dist,
        )
        push!(tvector_distributions_Ms2, power_s2_tv_dist)

        id_rot = @SMatrix [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
        rotations_dist = Manifolds.normal_rotation_distribution(Mr, id_rot, 1.0)
        power_r1_pt_dist =
            PowerPointDistribution(Mr1, rotations_dist, randn(Float64, 3, 3, 5))
        power_rn1_pt_dist = PowerPointDistribution(
            Mrn1,
            rotations_dist,
            [randn(Float64, 3, 3) for i in 1:5],
        )
        push!(point_distributions_Mrn1, power_rn1_pt_dist)
        power_r2_pt_dist =
            PowerPointDistribution(Mr2, rotations_dist, randn(Float64, 3, 3, 5, 7))
        power_rn2_pt_dist = PowerPointDistribution(
            Mrn2,
            rotations_dist,
            [randn(Float64, 3, 3) for i in 1:5, j in 1:7],
        )
        push!(point_distributions_Mr2, power_r2_pt_dist)
        rotations_tv_dist = Manifolds.normal_tvector_distribution(Mr, MMatrix(id_rot), 1.0)
        power_r1_tv_dist = PowerFVectorDistribution(
            TangentSpace(Mr1, rand(power_r1_pt_dist)),
            rotations_tv_dist,
        )
        power_rn1_tv_dist = PowerFVectorDistribution(
            TangentSpace(Mrn1, rand(power_rn1_pt_dist)),
            rotations_tv_dist,
        )
        push!(tvector_distributions_Mrn1, power_rn1_tv_dist)
        power_r2_tv_dist = PowerFVectorDistribution(
            TangentSpace(Mr2, rand(power_r2_pt_dist)),
            rotations_tv_dist,
        )
        power_rn2_tv_dist = PowerFVectorDistribution(
            TangentSpace(Mrn2, rand(power_rn2_pt_dist)),
            rotations_tv_dist,
        )
        push!(tvector_distributions_Mrn2, power_rn2_tv_dist)

        MPointSupport =
            Base.get_extension(Manifolds, :ManifoldsDistributionsExt).MPointSupport
        FVectorSupport =
            Base.get_extension(Manifolds, :ManifoldsDistributionsExt).FVectorSupport

        Test.@test Distributions.support(power_s1_pt_dist) isa MPointSupport
        Test.@test Distributions.support(power_s1_tv_dist) isa FVectorSupport
    end

    @testset "get_component, set_component!, getindex and setindex!" begin
        p1 = randn(3, 5)
        @test get_component(Ms1, p1, 1) == p1[:, 1]
        @test p1[Ms1, 1] == p1[:, 1]
        @test p1[Ms1, 1] isa Vector
        p2 = [10.0, 11.0, 12.0]
        set_component!(Ms1, p1, p2, 2)
        @test get_component(Ms1, p1, 2) == p2
        p1[Ms1, 2] = 2 * p2
        @test p1[Ms1, 2] == 2 * p2
        p1[Ms1, 2] += p2
        @test p1[Ms1, 2] ≈ 3 * p2
        p1[Ms1, 2] .+= p2
        @test p1[Ms1, 2] ≈ 4 * p2
        @test view(p1, Ms1, 1) == p1[Ms1, 1]
        @test view(p1, Ms1, 1) isa SubArray

        Msn1 = PowerManifold(Ms, Manifolds.NestedPowerRepresentation(), 5)
        pn1 = [randn(3) for _ in 1:5]
        @test get_component(Msn1, pn1, 1) == pn1[1]
        @test pn1[Msn1, 1] == pn1[1]
        @test pn1[Msn1, 1] isa Vector
        set_component!(Msn1, pn1, p2, 2)
        @test get_component(Msn1, pn1, 2) == p2
        pn1[Msn1, 2] = 2 * p2
        @test pn1[Msn1, 2] == 2 * p2
        pn1[Msn1, 2] += p2
        @test pn1[Msn1, 2] ≈ 3 * p2
        pn1[Msn1, 2] .+= p2
        @test pn1[Msn1, 2] ≈ 4 * p2
        @test view(pn1, Msn1, 1) == pn1[Msn1, 1]
        @test view(pn1, Msn1, 1) isa SubArray
    end

    @testset "ComponenException" begin
        M = PowerManifold(Sphere(2), NestedPowerRepresentation(), 2)
        p = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0]]
        X = [[0.0, 0.0, 0.0], [0.0, 1.0, 0.0]]
        @test_throws ComponentManifoldError is_point(M, X; error = :error)
        @test_throws ComponentManifoldError is_vector(M, p, X; error = :error)
    end

    @testset "power vector transport" begin
        m = ParallelTransport()
        p = repeat([1.0, 0.0, 0.0], 1, 5)
        q = repeat([0.0, 1.0, 0.0], 1, 5)
        X = log(Ms1, p, q)
        Y = vector_transport_to(Ms1, p, X, q, m)
        Z = -log(Ms1, q, p)
        @test isapprox(Ms1, q, Y, Z)
    end
    trim(s::String) = s[1:min(length(s), 20)]

    basis_types = (DefaultOrthonormalBasis(), ProjectedOrthonormalBasis(:svd))
    for T in types_s2
        @testset "Type $(trim(string(T)))..." begin
            pts2 = [convert(T, rand(Ms2)) for _ in 1:3]
            Manifolds.test_manifold(
                Ms2,
                pts2;
                test_musical_isomorphisms = true,
                test_injectivity_radius = false,
                retraction_methods = retraction_methods,
                inverse_retraction_methods = inverse_retraction_methods,
                point_distributions = point_distributions_Ms2,
                tvector_distributions = tvector_distributions_Ms2,
                rand_tvector_atol_multiplier = 6.0,
                retraction_atol_multiplier = 12,
                is_tangent_atol_multiplier = 12.0,
                exp_log_atol_multiplier = 3 * prod(power_dimensions(Ms2)),
                test_inplace = true,
            )
        end
    end

    for T in types_rn1
        @testset "Type $(trim(string(T)))..." begin
            pts1 = [convert(T, rand(Mrn1)) for _ in 1:3]
            Manifolds.test_manifold(
                Mrn1,
                pts1;
                test_injectivity_radius = false,
                test_musical_isomorphisms = true,
                retraction_methods = retraction_methods,
                inverse_retraction_methods = inverse_retraction_methods,
                point_distributions = point_distributions_Mrn1,
                tvector_distributions = tvector_distributions_Mrn1,
                basis_types_to_from = basis_types,
                rand_tvector_atol_multiplier = 500.0,
                retraction_atol_multiplier = 12,
                is_tangent_atol_multiplier = 12.0,
                exp_log_atol_multiplier = 4.0e2 * prod(power_dimensions(Mrn1)),
                test_inplace = true,
                test_rand_point = true,
                test_rand_tvector = true,
            )
        end
    end
    for T in types_r2
        @testset "Type $(trim(string(T)))..." begin
            pts2 = [convert(T, rand(Mr2)) for _ in 1:3]
            Manifolds.test_manifold(
                Mr2,
                pts2;
                test_injectivity_radius = false,
                test_musical_isomorphisms = true,
                retraction_methods = retraction_methods,
                inverse_retraction_methods = inverse_retraction_methods,
                point_distributions = point_distributions_Mr2,
                tvector_distributions = tvector_distributions_Mr2,
                rand_tvector_atol_multiplier = 8.0,
                retraction_atol_multiplier = 12,
                is_tangent_atol_multiplier = 12.0,
                exp_log_atol_multiplier = 4.0e3 * prod(power_dimensions(Mr2)),
                test_inplace = true,
            )
        end
    end
    for T in types_rn2
        @testset "Type $(trim(string(T)))..." begin
            pts2 = [convert(T, rand(Mrn2)) for _ in 1:3]
            Manifolds.test_manifold(
                Mrn2,
                pts2;
                test_injectivity_radius = false,
                test_musical_isomorphisms = true,
                retraction_methods = retraction_methods,
                inverse_retraction_methods = inverse_retraction_methods,
                point_distributions = point_distributions_Mrn2,
                tvector_distributions = tvector_distributions_Mrn2,
                rand_tvector_atol_multiplier = 8.0,
                retraction_atol_multiplier = 12,
                is_tangent_atol_multiplier = 12.0,
                exp_log_atol_multiplier = 4.0e3 * prod(power_dimensions(Mrn2)),
                test_inplace = true,
            )
        end
    end

    @testset "Power manifold of Circle" begin
        pts_t = [[0.0, 1.0, 2.0], [1.0, 1.0, 2.4], [0.0, 2.0, 1.0]]
        MT = PowerManifold(Circle(), 3)
        @test representation_size(MT) == (3,)
        @test pts_t[2][MT, 3] == 2.4
        Manifolds.test_manifold(
            MT,
            pts_t;
            test_injectivity_radius = false,
            test_musical_isomorphisms = true,
            retraction_methods = retraction_methods,
            inverse_retraction_methods = inverse_retraction_methods,
            rand_tvector_atol_multiplier = 5.0,
            retraction_atol_multiplier = 12,
            is_tangent_atol_multiplier = 12.0,
            exp_log_atol_multiplier = 1.0,
            test_inplace = true,
            test_rand_point = true,
            test_rand_tvector = true,
        )

        ph = HybridVector{3}(pts_t[1])
        @test Manifolds._read(MT, (), ph, 3) == 2.0
    end

    @testset "Basis printing" begin
        p = hcat([[1.0, 0.0, 0.0] for i in 1:5]...)
        Bc = get_basis(Ms1, p, DefaultOrthonormalBasis())
        @test sprint(show, "text/plain", Bc) == """
            DefaultOrthonormalBasis(ℝ) for a power manifold
            Basis for component (1,):
            $(sprint(show, "text/plain", Bc.data.bases[1]))
            Basis for component (2,):
            $(sprint(show, "text/plain", Bc.data.bases[2]))
            Basis for component (3,):
            $(sprint(show, "text/plain", Bc.data.bases[3]))
            Basis for component (4,):
            $(sprint(show, "text/plain", Bc.data.bases[4]))
            Basis for component (5,):
            $(sprint(show, "text/plain", Bc.data.bases[5]))
            """
    end

    @testset "Atlas & Induced Basis" begin
        M = PowerManifold(Euclidean(2), NestedPowerRepresentation(), 2)
        p = [zeros(2), ones(2)]
        X = [ones(2), 2 .* ones(2)]
        A = RetractionAtlas()
        a = get_parameters(M, A, p, p)
        p2 = get_point(M, A, p, a)
        @test all(p2 .== p)
        A2 = TestExponentialAtlas()
        a2 = get_parameters(M, A2, p, p)
        @test isapprox(a, a2)
        @test_throws ErrorException get_point(M, A2, p, a2)
    end

    @testset "metric conversion" begin
        M = SymmetricPositiveDefinite(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        e = EuclideanMetric()
        p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]
        q = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
        P = [p, q]
        X = [log(M, p, q), log(M, q, p)]
        Y = change_metric(N, e, P, X)
        Yc = [change_metric(M, e, p, log(M, p, q)), change_metric(M, e, q, log(M, q, p))]
        @test norm(N, P, Y .- Yc) ≈ 0
        Z = change_representer(N, e, P, X)
        Zc = [
            change_representer(M, e, p, log(M, p, q)),
            change_representer(M, e, q, log(M, q, p)),
        ]
        @test norm(N, P, Z .- Zc) ≈ 0
    end

    @testset "Hessian conversion" begin
        M = Sphere(2)
        N = PowerManifold(M, 2)
        p = [1.0 0.0; 0.0 0.0; 1.0 0.0]
        q = 1 / sqrt(2) * [1.0 0.0; 1.0 1.0; 0.0 1.0]
        q = 1 / sqrt(2) * [0.0 1.0; 1.0 1.0; 1.0 0.0]
        r = 1 / sqrt(3) * [1.0 1.0; 1.0 1.0; 1.0 1.0]
        X = log(M, p, q)
        Y = log(M, p, r)
        Z = -X
        H1 = riemannian_Hessian(N, p, Y, Z, X)
        H2 = cat(
            [riemannian_Hessian(M, p[:, i], Y[:, i], Z[:, i], X[:, i]) for i in 1:2]...,
            dims = 2,
        )
        @test H1 == H2
        V = [0.2 0.0; 0.0 0.0; 0.0 0.3]
        W1 = Weingarten(N, p, X, V)
        W2 = cat([Weingarten(M, p[:, i], X[:, i], V[:, i]) for i in 1:2]..., dims = 2)
        @test W1 == W2
    end

    @testset "Nested replacing RNG" begin
        M = PowerManifold(Ms, NestedReplacingPowerRepresentation(), 2)
        @test is_point(M, rand(M))
        @test is_point(M, rand(MersenneTwister(123), M))
        @test rand(MersenneTwister(123), M) == rand(MersenneTwister(123), M)
        p = rand(M)
        @test is_vector(M, p, rand(M; vector_at = p); atol = 1.0e-15)
        @test is_vector(M, p, rand(MersenneTwister(123), M; vector_at = p); atol = 1.0e-15)
        @test rand(MersenneTwister(123), M; vector_at = p) ==
            rand(MersenneTwister(123), M; vector_at = p)
    end

    @testset "Nested replacing allocation" begin
        Msr = PowerManifold(Ms, NestedReplacingPowerRepresentation(), 2)
        p1 = [SVector{3}(1.0, 0.0, 0.0), SVector{3}(1.0, 0.0, 0.0)]
        @test allocate(Msr, p1) isa Vector{SVector{3, Float64}}

        SE2 = Euclidean(2) × Rotations(2)
        PSE2 = PowerManifold(SE2, NestedReplacingPowerRepresentation(), 2)
        pse = ArrayPartition(
            SA[1.0, 2.0],
            SA[
                0.5403023058681398 -0.8414709848078965
                0.8414709848078965 0.5403023058681398
            ],
        )
        p2 = [pse, pse]
        @test allocate(PSE2, p2) isa Vector{
            ArrayPartition{Float64, Tuple{SVector{2, Float64}, SMatrix{2, 2, Float64, 4}}},
        }

        pse_ap = ArrayPartition(
            SA[1.0, 2.0],
            SA[
                0.5403023058681398 -0.8414709848078965
                0.8414709848078965 0.5403023058681398
            ],
        )
        p2_ap = [pse_ap, pse_ap]
        @test allocate(PSE2, p2_ap) isa Vector{
            ArrayPartition{Float64, Tuple{SVector{2, Float64}, SMatrix{2, 2, Float64, 4}}},
        }
    end

    @testset "Manifold volume" begin
        @test manifold_volume(Ms1) ≈ manifold_volume(Ms)^5
        p = repeat([1.0, 0.0, 0.0], 1, 5)
        X = repeat([0.0, 1.0, 0.0], 1, 5)
        @test volume_density(Ms1, p, X) ≈ volume_density(Ms, p[:, 1], X[:, 1])^5
    end

    @testset "Static type parameter" begin
        Ms1s = PowerManifold(Ms, 5; parameter = :type)
        @test sprint(show, "text/plain", Ms1s) ==
            "PowerManifold(Sphere(2), 5, parameter=:type)"
    end
end

@doc raw"""
    check_vector(M::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector; kwargs... )

Check whether `X` is a tangent vector to point `p` on the [`Flag`](@ref) manifold `M`
``\operatorname{Flag}(n_1, n_2, ..., n_d; N)`` in the orthogonal matrix representation,
i.e. that `X` is block-skew-symmetric with zero diagonal:
````math
X = \begin{bmatrix}
0                     & B_{1,2}               & ⋯ & B_{1,d+1} \\
-B_{1,2}^\mathrm{T}   & 0                     & ⋯ & B_{2,d+1} \\
\vdots                & \vdots                & ⋱ & \vdots    \\
-B_{1,d+1}^\mathrm{T} & -B_{2,d+1}^\mathrm{T} & ⋯ & 0
\end{bmatrix}
````
where ``B_{i,j} ∈ ℝ^{(n_i - n_{i-1}) × (n_j - n_{j-1})}``, for  ``1 ≤ i < j ≤ d+1``.
"""
function check_vector(
        M::Flag{<:Any, dp1},
        p::OrthogonalPoint,
        X::OrthogonalTangentVector;
        kwargs...,
    ) where {dp1}
    for i in 1:dp1
        for j in i:dp1
            if i == j
                Bi = _extract_flag(M, X.value, i)
                if !iszero(Bi)
                    return DomainError(
                        norm(Bi),
                        "All diagonal blocks of matrix X must be zero; block $i has norm $(norm(Bi)).",
                    )
                end
            else
                Bij = _extract_flag(M, X.value, i, j)
                Bji = _extract_flag(M, X.value, j, i)
                Bdiff = Bij + Bji'
                if !iszero(Bdiff)
                    return DomainError(
                        norm(Bdiff),
                        "Matrix X must be block skew-symmetric; block ($i, $j) violates this with norm of sum equal to $(norm(Bdiff)).",
                    )
                end
            end
        end
    end
    return nothing
end

embed(::Flag, p::OrthogonalPoint) = p.value
embed!(::Flag, q, p::OrthogonalPoint) = copyto!(q, p.value)
embed(::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector) = X.value
function embed!(::Flag, Y, p::OrthogonalPoint, X::OrthogonalTangentVector)
    return copyto!(Y, X.value)
end

"""
    get_embedding(M::Flag, p::OrthogonalPoint)

Get embedding of [`Flag`](@ref) manifold `M`, i.e. the manifold [`OrthogonalMatrices`](@ref).
"""
function get_embedding(::Flag{TypeParameter{Tuple{N}}}, ::Type{<:OrthogonalPoint}) where {N}
    return OrthogonalMatrices(N)
end
function get_embedding(M::Flag{Tuple{Int}}, ::Type{<:OrthogonalPoint})
    return OrthogonalMatrices(M.size[1]; parameter = :field)
end
function ManifoldsBase.get_embedding_type(::Flag, ::Type{<:OrthogonalPoint})
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

function _extract_flag(M::Flag, p::AbstractMatrix, i::Int)
    range = (M.subspace_dimensions[i - 1] + 1):M.subspace_dimensions[i]
    return view(p, range, range)
end

function _extract_flag(M::Flag, p::AbstractMatrix, i::Int, j::Int)
    range_i = (M.subspace_dimensions[i - 1] + 1):M.subspace_dimensions[i]
    range_j = (M.subspace_dimensions[j - 1] + 1):M.subspace_dimensions[j]
    return view(p, range_i, range_j)
end

function inner(
        ::Flag,
        p::OrthogonalPoint,
        X::OrthogonalTangentVector,
        Y::OrthogonalTangentVector,
    )
    return dot(X.value, Y.value) / 2
end

function project!(
        M::Flag{<:Any, dp1},
        Y::OrthogonalTangentVector,
        ::OrthogonalPoint,
        X::OrthogonalTangentVector,
    ) where {dp1}
    N = get_parameter(M.size)[1]
    project!(SkewHermitianMatrices(N), Y.value, X.value)
    for i in 1:dp1
        Bi = _extract_flag(M, Y.value, i)
        fill!(Bi, 0)
    end
    return Y
end

@doc raw"""
    project(M::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector)

Project vector `X` to tangent space at point `p` from [`Flag`](@ref) manifold `M`
``\operatorname{Flag}(n_1, n_2, ..., n_d; N)``, in the orthogonal matrix representation.
It works by first projecting `X` to the space of [`SkewHermitianMatrices`](@ref) and then
setting diagonal blocks to 0:
````math
X = \begin{bmatrix}
0                     & B_{1,2}               & ⋯ & B_{1,d+1} \\
-B_{1,2}^\mathrm{T}   & 0                     & ⋯ & B_{2,d+1} \\
\vdots                & \vdots                & ⋱ & \vdots    \\
-B_{1,d+1}^\mathrm{T} & -B_{2,d+1}^\mathrm{T} & ⋯ & 0
\end{bmatrix}
````
where ``B_{i,j} ∈ ℝ^{(n_i - n_{i-1}) × (n_j - n_{j-1})}``, for  ``1 ≤ i < j ≤ d+1``.
"""
function project(
        M::Flag{<:Any, dp1},
        ::OrthogonalPoint,
        X::OrthogonalTangentVector,
    ) where {dp1}
    N = get_parameter(M.size)[1]
    Y = project(SkewHermitianMatrices(N), X.value)
    for i in 1:dp1
        Bi = _extract_flag(M, Y, i)
        fill!(Bi, 0)
    end
    return OrthogonalTangentVector(Y)
end

function Random.rand!(
        rng::AbstractRNG,
        M::Flag{<:Any, dp1},
        pX::Union{OrthogonalPoint, OrthogonalTangentVector};
        vector_at = nothing,
    ) where {dp1}
    if vector_at === nothing
        N = get_parameter(M.size)[1]
        RN = Rotations(N)
        rand!(rng, RN, pX.value)
    else
        for i in 1:dp1
            for j in i:dp1
                Bij = _extract_flag(M, pX.value, i, j)
                if i == j
                    fill!(Bij, 0)
                else
                    Bij .= randn(rng, size(Bij))
                    Bji = _extract_flag(M, pX.value, j, i)
                    Bji .= -Bij'
                end
            end
        end
    end
    return pX
end

@doc raw"""
    retract(M::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector, ::QRRetraction)

Compute the QR retraction on the [`Flag`](@ref) in the orthogonal matrix representation
as the first order approximation to the exponential map. Similar to QR retraction for
[`GeneralUnitaryMatrices`].
"""
retract(M::Flag, p::OrthogonalPoint, X::OrthogonalTangentVector, ::QRRetraction)

function ManifoldsBase.retract_qr!(
        M::Flag,
        q::OrthogonalPoint,
        p::OrthogonalPoint,
        X::OrthogonalTangentVector,
    )
    return ManifoldsBase.retract_qr_fused!(M, q, p, X, one(eltype(p)))
end
function ManifoldsBase.retract_qr_fused!(
        ::Flag,
        q::OrthogonalPoint{<:AbstractMatrix{T}},
        p::OrthogonalPoint,
        X::OrthogonalTangentVector,
        t::Number,
    ) where {T}
    A = p.value + p.value * (t * X.value)
    qr_decomp = qr(A)
    d = diag(qr_decomp.R)
    D = Diagonal(sign.(d .+ convert(T, 0.5)))
    copyto!(q.value, qr_decomp.Q * D)
    return q
end

using Distributions, LinearAlgebra, Manifolds, RecursiveArrayTools, StaticArrays, Test

@testset "The Stiefel manifolds" begin
    @testset "Real Stiefel Manifold" begin
        M = Stiefel(3, 2)
        p = [1.0 0.0; 0.0 1.0; 0.0 0.0]
        q = 1 ./ sqrt(2) .* [ 1.0 -1.0; 1.0 1.0; 0.0 0.0]
        r = 1 ./ sqrt(2) .* [ 0.0 0.0; 1.0 -1.0; 1.0 1.0]
        X = [0.0 0.0; 0.0 0.0; -0.1 0.2]
        X2 = [0.0 1.0; -1.0 0.0; 0.0 0.0]
        Y = [0.0 0.0; 0.0 0.0; -0.3 0.4]
        Z = [0.5 -0.6; 0.0 0.0; 0.0 0.0]
        # Invalids
        pf = [1.0, 0.0, 0.0, 0.0]
        Xf = [0.0, 0.0, 1.0, 0.0]
        # Embedded
        ep = [1.0 0.0; 0.0 2.0; 0.0 0.0]
        Manifolds.Test.test_manifold(
            M,
            Dict(
                :Bases => [DefaultOrthogonalBasis(), DefaultOrthonormalBasis()],
                :EmbeddedPoints => [ep],
                :Functions => [
                    copy, copyto!, default_inverse_retraction_method, default_retraction_method,
                    default_vector_transport_method, distance, embed, embed_project, exp,
                    geodesic, get_basis, get_coordinates, get_embedding, get_vector, get_vectors,
                    injectivity_radius,
                    inner, inverse_retract, is_default_metric, is_flat, is_point, is_vector, log,
                    manifold_dimension, mid_point, norm, project, rand, repr, representation_size, retract,
                    shortest_geodesic, vector_transport_direction, vector_transport_to, zero_vector,
                ],
                :InvalidPoints => [pf],
                :InvalidVectors => [Xf],
                # ProjectionRetraction and its inverse are tested separately for now since they do not seem inverses
                :InverseRetractionMethods => [missing, missing, PolarInverseRetraction(), PolarLightInverseRetraction(), ProjectionInverseRetraction(), missing, QRInverseRetraction()],
                :Points => [p, q, r],
                :Vectors => [X, Y, Z],
                :SecondVector => X2,
                :RetractionMethods => [CayleyRetraction(), PadeRetraction(2), PolarRetraction(), PolarLightRetraction(), missing, ProjectionRetraction(), QRRetraction()],
                :VectorTransportMethods => [
                    DifferentiatedRetractionVectorTransport(PolarRetraction()),
                    DifferentiatedRetractionVectorTransport(QRRetraction()),
                    ProjectionTransport(),
                ],
            ),
            # Expectations
            Dict(
                :atol => 1.0e-12,
                default_inverse_retraction_method => PolarInverseRetraction(),
                default_retraction_method => PolarRetraction(),
                default_vector_transport_method => DifferentiatedRetractionVectorTransport(PolarRetraction()),
                injectivity_radius => π,
                manifold_dimension => 3,
                repr => "Stiefel(3, 2, ℝ)",
            )
        )
        @testset "Padé & Caley retractions and Caley based transport (direction only)" begin
            rca = CayleyRetraction()
            @test rca == PadeRetraction(1)
            @test repr(rca) == "CayleyRetraction()"
            qca = retract(M, p, X, rca)
            @test is_point(M, qca; error = :error)
            Yca = vector_transport_direction(
                M, p, X, X, DifferentiatedRetractionVectorTransport(CayleyRetraction()),
            )
            @test is_vector(M, qca, Yca; atol = 10^-15, error = :error)
            Zca = zero_vector(M, p)
            vector_transport_direction!(
                M, Zca, p, X, X, DifferentiatedRetractionVectorTransport(CayleyRetraction()),
            )
            @test is_vector(M, qca, Yca; atol = 10^-15)
            @test isapprox(M, qca, Yca, Zca)
            rpa = PadeRetraction(2)
            @test repr(rpa) == "PadeRetraction(2)"
            qpa = retract(M, p, X, rpa)
            @test is_point(M, qpa; error = :error)
        end


        @testset "Distribution tests" begin
            usd_mmatrix = Manifolds.uniform_distribution(M, @MMatrix [1.0 0.0; 0.0 1.0; 0.0 0.0])
            @test isa(rand(usd_mmatrix), MMatrix)
        end
        @testset "Basics" begin
            @test base_manifold(M) === M
        end
        @testset "gradient and metric conversion" begin
            Xm = change_metric(M, EuclideanMetric(), p, X)
            @test Xm == X
            Xr = change_representer(M, EuclideanMetric(), p, X)
            @test Xr == X
            # In this case it stays as is
            @test riemannian_Hessian(M, p, Xm, Xr, X) == Xr
            V = [1.0 1.0; 0.0 0.0; 0.0 0.0] # From T\bot_pM.
            @test Weingarten(M, p, X, V) == [0.0 0.0; 0.0 0.0; 0.1 0.1]
        end
        @testset "Different Metrics" begin
            @testset "StiefelSubmersionMetric" begin
                @testset "StiefelFactorization" begin
                    n = 6
                    @testset for k in [2, 3]
                        Ml = MetricManifold(Stiefel(n, k), StiefelSubmersionMetric(rand()))
                        pl = project(Ml, randn(representation_size(Ml)))
                        Xl = project(Ml, pl, randn(representation_size(Ml)))
                        Xl /= norm(Ml, pl, Xl)
                        ql = exp(Ml, pl, Xl)
                        qfact = Manifolds.stiefel_factorization(pl, ql)
                        @testset "basic properties" begin
                            @test qfact isa Manifolds.StiefelFactorization
                            @test qfact.U[1:n, 1:k] ≈ pl
                            @test qfact.U'qfact.U ≈ I
                            @test qfact.U * qfact.Z ≈ ql
                            @test is_point(Stiefel(2k, k), qfact.Z)

                            Xfact = Manifolds.stiefel_factorization(pl, Xl)
                            @test Xfact isa Manifolds.StiefelFactorization
                            @test Xfact.U[1:n, 1:k] ≈ pl
                            @test Xfact.U'Xfact.U ≈ I
                            @test Xfact.U * Xfact.Z ≈ Xl
                            @test is_vector(Rotations(k), I(k), Xfact.Z[1:k, 1:k])

                            pfact2 = Manifolds.stiefel_factorization(pl, pl)
                            @test pfact2 isa Manifolds.StiefelFactorization
                            @test pfact2.U[1:n, 1:k] ≈ pl
                            @test pfact2.U'pfact2.U ≈ I
                            @test pfact2.Z ≈ [I(k); zeros(k, k)] atol = 1.0e-6
                        end
                        @testset "basic functions" begin
                            @test size(qfact) == (n, k)
                            @test eltype(qfact) === eltype(ql)
                        end
                        @testset "similar" begin
                            qfact2 = similar(qfact)
                            @test qfact2.U === qfact.U
                            @test size(qfact2.Z) == size(qfact.Z)
                            @test eltype(qfact2.Z) === eltype(qfact.Z)

                            qfact3 = similar(qfact, Float32)
                            @test eltype(qfact3) === Float32
                            @test eltype(qfact3.U) === Float32
                            @test eltype(qfact3.Z) === Float32
                            @test qfact3.U ≈ qfact.U
                            @test size(qfact3.Z) == size(qfact.Z)

                            qfact4 = similar(qfact, Float32, (n, k))
                            @test eltype(qfact4) === Float32
                            @test eltype(qfact4.U) === Float32
                            @test eltype(qfact4.Z) === Float32
                            @test qfact4.U ≈ qfact.U
                            @test size(qfact4.Z) == size(qfact.Z)

                            @test_throws Exception similar(qfact, Float32, (n, k + 1))
                        end
                        @testset "copyto!" begin
                            qfact2 = similar(qfact)
                            copyto!(qfact2, qfact)
                            @test qfact2.U === qfact.U
                            @test qfact2.Z ≈ qfact.Z

                            q2 = similar(ql)
                            copyto!(q2, qfact)
                            @test q2 ≈ ql

                            qfact3 = similar(qfact)
                            copyto!(qfact3, ql)
                            @test qfact3.U === qfact.U
                            @test qfact3.Z ≈ qfact.Z
                        end
                        @testset "dot" begin
                            Afact = similar(qfact)
                            Afact.Z .= randn.()
                            A = copyto!(similar(ql), Afact)
                            Bfact = similar(qfact)
                            Bfact.Z .= randn.()
                            B = copyto!(similar(ql), Bfact)
                            @test dot(Afact, Bfact) ≈ dot(A, B)
                        end
                        @testset "broadcast!" begin
                            rfact = similar(qfact)
                            @testset for f in [*, +, -]
                                rfact .= f.(qfact, 2.5)
                                @test rfact.U === qfact.U
                                @test rfact.Z ≈ f.(qfact.Z, 2.5)
                            end
                        end
                        @testset "project" begin
                            rfact = similar(qfact)
                            rfact.Z .= randn.()
                            r = copyto!(similar(ql), rfact)
                            rfactproj = project(Ml, rfact)
                            @test rfactproj isa Manifolds.StiefelFactorization
                            @test copyto!(similar(r), rfactproj) ≈ project(Ml, r)

                            Yfact = similar(qfact)
                            Yfact.Z .= randn.()
                            Y = copyto!(similar(ql), Yfact)
                            Yfactproj = project(Ml, rfact, Yfact)
                            @test Yfactproj isa Manifolds.StiefelFactorization
                            @test copyto!(similar(Y), Yfactproj) ≈ project(Ml, r, Y)
                        end
                        @testset "inner" begin
                            rfact = similar(qfact)
                            rfact.Z .= randn.()
                            rfact = project(Ml, rfact)

                            Yfact = similar(qfact)
                            Yfact.Z .= randn.()
                            Yfact = project(Ml, rfact, Yfact)

                            Zfact = similar(qfact)
                            Zfact.Z .= randn.()
                            Zfact = project(Ml, rfact, Zfact)

                            r, Z, Y = map(x -> copyto!(similar(ql), x), (rfact, Zfact, Yfact))
                            @test inner(Ml, rfact, Yfact, Zfact) ≈ inner(Ml, r, Y, Z)
                        end
                        @testset "exp" begin
                            pfact = copyto!(similar(qfact), pl)
                            Xfact = copyto!(similar(qfact), Xl)
                            rfact = exp(Ml, pfact, Xfact)
                            r = exp(Ml, pl, Xl)
                            @test rfact isa Manifolds.StiefelFactorization
                            @test copyto!(similar(r), rfact) ≈ r
                        end
                    end
                end
                g = StiefelSubmersionMetric(1)
                @test g isa StiefelSubmersionMetric{Int}
                @testset for Ml in [Stiefel(3, 3), Stiefel(4, 3), Stiefel(4, 2)]
                    Mcan = MetricManifold(Ml, CanonicalMetric())
                    Meu = MetricManifold(Ml, EuclideanMetric())
                    @testset "α=$α" for (α, Mcomp) in [(0, Mcan), (-1 // 2, Meu)]
                        pl = project(Ml, randn(representation_size(Ml)))
                        Xl = project(Ml, pl, randn(representation_size(Ml)))
                        Xl ./= norm(Mcomp, pl, Xl)
                        Yl = project(Ml, pl, randn(representation_size(Ml)))
                        MMl = MetricManifold(Ml, StiefelSubmersionMetric(α))
                        @test inner(MMl, pl, Xl, Yl) ≈ inner(Mcomp, pl, Xl, Yl)
                        ql = exp(Mcomp, pl, Xl)
                        @test isapprox(MMl, ql, exp(Mcomp, pl, Xl); error = :error)
                        if Mcomp === Mcan
                            @test !is_flat(Mcomp)
                            Zl1 = log(Mcomp, pl, ql)
                            isapprox(MMl, pl, log(MMl, pl, ql), Zl1)
                            Zl2 = similar(Zl1)
                            log!(Mcomp, Zl2, pl, ql)
                            isapprox(MMl, pl, log(MMl, pl, ql), Zl1)
                            @test distance(Mcomp, pl, ql) ≈ norm(Mcomp, pl, Zl2)
                        end
                        @test isapprox(MMl, exp(MMl, pl, 0 * Xl), pl; error = :error)
                        @test isapprox(MMl, pl, log(MMl, pl, pl), zero_vector(MMl, pl); error = :error, atol = 1.0e-6)
                    end
                    @testset "α=$α" for α in [-0.75, -0.25, 0.5]
                        MMl = MetricManifold(Ml, StiefelSubmersionMetric(α))
                        pl = project(MMl, randn(representation_size(Ml)))
                        Xl = project(MMl, pl, randn(representation_size(Ml)))
                        Xl ./= norm(MMl, pl, Xl)
                        ql = exp(MMl, pl, Xl)
                        @test is_point(MMl, ql; error = :error)
                        @test isapprox(MMl, pl, log(MMl, pl, ql), Xl; error = :error)
                        @test isapprox(MMl, exp(MMl, pl, 0 * Xl), pl; error = :error)
                        @test isapprox(MMl, pl, log(MMl, pl, pl), zero_vector(MMl, pl); error = :error, atol = 1.0e-6)
                    end
                end
                @testset "Hessian Conversion" begin
                    M1 = MetricManifold(M, StiefelSubmersionMetric(-0.5))
                    M2 = MetricManifold(M, EuclideanMetric())
                    M3 = MetricManifold(M, StiefelSubmersionMetric(0.0))
                    M4 = MetricManifold(M, CanonicalMetric())
                    pH = [1.0 0.0; 0.0 1.0; 0.0 0.0]
                    XH = [0.0 0.0; 0.0 0.0; 1.0 1.0]
                    YH = [0.0 0.0; 0.0 0.0; -1.0 1.0]
                    ZH = [0.0 0.0; 0.0 0.0; -1.0 -1.0]
                    rH = riemannian_Hessian(M, pH, YH, ZH, XH)
                    @test riemannian_Hessian(M1, pH, YH, ZH, XH) == rH #Special case of submersion metric
                    @test riemannian_Hessian(M2, pH, YH, ZH, XH) == rH # metric is default
                    @test riemannian_Hessian(M3, pH, YH, ZH, XH) == riemannian_Hessian(M4, pH, YH, ZH, XH)
                    VH = [0.0 -1.0; 1.0 0.0; 0.0 0.0]
                    WH = zero_vector(M, pH)
                    Weingarten!(M, WH, pH, XH, VH)
                    WHb = zero_vector(M, pH)
                    Weingarten!(M2, WHb, pH, XH, VH)
                    @test WH == WHb
                end
            end
        end
        @testset "field parameter" begin
            Mf = Stiefel(3, 2; parameter = :field)
            @test typeof(get_embedding(Mf)) === Euclidean{ℝ, Tuple{Int, Int}}
            @test repr(Mf) == "Stiefel(3, 2, ℝ; parameter=:field)"
        end
        @testset "Stiefel(2, 1) StaticArray inverse QR retraction cases" begin
            M21 = Stiefel(2, 1)
            p21 = SMatrix{2, 1}([0.0, 1.0])
            X21 = inverse_retract(
                M21, p21, SMatrix{2, 1}([sqrt(2), sqrt(2)]),
                QRInverseRetraction(),
            )
            @test isapprox(M21, p21, X21, SMatrix{2, 1}([1.0, 0.0]))
        end
        @testset "Stiefel(3, 2) StaticArray inverse QR retraction cases" begin
            pS = SMatrix{3, 2}(p)
            qS = SMatrix{3, 2}(q)
            XS = inverse_retract(
                M, pS, qS, QRInverseRetraction(),
            )
            q32 = Manifolds.retract(M, pS, XS, QRRetraction())
            @test isapprox(M, qS, q32)
            @test isapprox(M, pS, XS, SMatrix{3, 2}([0.0 -1.0; 1.0 0.0; 0.0 0.0]))
        end
        @testset "Stiefel(4,3) StaticArray inverse QR retraction cases" begin
            M43 = Stiefel(4, 3)
            p43 = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0; 0.0 0.0 0.0]
            X43 = [0.0 0.0 0.0; 0.0 0.0 0.0; 0.0 0.0 0.0; 1.0 1.0 1.0]
            q43 = retract(M43, p43, X43, QRRetraction())
            Y243 = inverse_retract(
                M43,
                SMatrix{4, 3}(p43),
                SMatrix{4, 3}(q43),
                QRInverseRetraction(),
            )
            Z243 = inverse_retract(M43, p43, q43, QRInverseRetraction())
            @test isapprox(M43, p43, Y243, Z243)
            @test isapprox(M43, p43, Y243, X43)
            p243 = [1.0 0.0; 0.0 1.0; 0.0 0.0]
            q243 = exp(M, p243, [0.0 0.0; 0.0 0.0; 1.0 1.0])

            Y243 = inverse_retract(
                M,
                SMatrix{3, 2}(p243),
                SMatrix{3, 2}(q243),
                QRInverseRetraction(),
            )
            Z243 = inverse_retract(M, p243, q243, QRInverseRetraction())
            @test isapprox(M43, p243, Y243, Z243)
        end
    end
    @testset "Complex Stiefel Manifold" begin
        Mc = Stiefel(3, 2, ℂ)
        pc = [0.5 + 0.5im 0.5 + 0.5im; 0.5 + 0.5im -0.5 - 0.5im; 0.0 0.0]
        Xc = [0.0 0.0; 0.0 0.0; 0.1 -0.1]
        qc = exp(Mc, pc, Xc)
        rc = exp(Mc, pc, Xc)
        Yc = inverse_retract(Mc, qc, pc, PolarInverseRetraction())
        Zc = inverse_retract(Mc, rc, pc, PolarInverseRetraction())
        # Invalid ones
        pcf = [1.0, 0.0, 0.0, 0.0]
        Xcf = [0.0, 0.0, 1.0, 0.0]
        # Embedded
        ep = [1.0 0.0; 0.0 2.0; 0.0 0.0]
        Manifolds.Test.test_manifold(
            Mc,
            Dict(
                :EmbeddedPoints => [ep],
                :Functions => [
                    copy, copyto!, default_inverse_retraction_method, default_retraction_method,
                    default_vector_transport_method, embed, exp,
                    geodesic, get_basis, get_coordinates, get_embedding, get_vector, get_vectors,
                    injectivity_radius,
                    inner, inverse_retract, is_default_metric, is_flat, is_point, is_vector,
                    manifold_dimension, norm, project, repr, representation_size, retract,
                    vector_transport_direction, vector_transport_to, zero_vector,
                ],
                :InvalidPoints => [pcf, 2 .* pc],
                :InvalidVectors => [Xcf],
                :InverseRetractionMethods => [PolarInverseRetraction(), QRInverseRetraction()],
                :Points => [pc, qc, rc],
                :Vectors => [Xc, Yc, Zc],
                :RetractionMethod => [PolarRetraction(), QRRetraction()],
                :VectorTransportMethods => [
                    DifferentiatedRetractionVectorTransport(PolarRetraction()),
                ],
            ),
            # Expectations
            Dict(
                :atol => 1.0e-12,
                default_inverse_retraction_method => PolarInverseRetraction(),
                default_retraction_method => PolarRetraction(),
                default_vector_transport_method => DifferentiatedRetractionVectorTransport(PolarRetraction()),
                injectivity_radius => π,
                manifold_dimension => 3,
                repr => "Stiefel(3, 2, ℂ)",
                representation_size => (3, 2),
                manifold_dimension => 8,
                is_flat => false,
            )
        )
        @testset "Allocation Promotion" begin
            @test Manifolds.allocation_promotion_function(Mc, get_vector, ()) === complex
        end
    end
    @testset "Quaternion Stiefel" begin
        M = Stiefel(3, 2, ℍ)
        @testset "Basics" begin
            @test representation_size(M) == (3, 2)
            @test manifold_dimension(M) == 18
        end
    end

    @testset "Bug #871" begin
        M = Stiefel(3, 1)
        p = [-0.4760758523674722; 0.3378785657033835; -0.8119050792000313;;]
        Xs = get_vectors(M, p, DefaultOrthonormalBasis())
        for X in Xs
            @test is_vector(M, p, X; atol = 1.0e-12)
        end
    end
end

include("../header.jl")

using Manifolds: TFVector, CoTFVector

@testset "Circle" begin
    M = Circle()
    @testset "Real Circle Basics" begin
        @test repr(M) == "Circle(ℝ)"
        @test representation_size(M) == ()
        @test manifold_dimension(M) == 1
        @test is_flat(M)
        @test !is_point(M, 9.0)
        @test !is_point(M, zeros(3, 3))
        @test Manifolds.check_size(M, [9.0]) === nothing
        @test Manifolds.check_size(M, [1.0], [-2.0]) === nothing
        @test_throws DomainError is_point(M, 9.0; error = :error)
        @test_throws DomainError is_point(M, zeros(3, 3); error = :error)
        @test !is_vector(M, 9.0, 0.0)
        @test !is_vector(M, zeros(3, 3), zeros(3, 3))
        @test_throws DomainError is_vector(M, 9.0, 0.0; error = :error)
        @test_throws DomainError is_vector(M, zeros(3, 3), zeros(3, 3); error = :error)
        @test_throws DomainError is_vector(M, 0.0, zeros(3, 3); error = :error)
        @test is_vector(M, 0.0, 0.0)
        @test get_coordinates(M, Ref(0.0), Ref(2.0), DefaultOrthonormalBasis())[] ≈ 2.0
        @test get_coordinates(
            M,
            Ref(0.0),
            Ref(2.0),
            DiagonalizingOrthonormalBasis(Ref(1.0)),
        )[] ≈ 2.0
        @test get_coordinates(
            M,
            Ref(0.0),
            Ref(-2.0),
            DiagonalizingOrthonormalBasis(Ref(1.0)),
        )[] ≈ -2.0
        @test get_coordinates(
            M,
            Ref(0.0),
            Ref(2.0),
            DiagonalizingOrthonormalBasis(Ref(-1.0)),
        )[] ≈ -2.0
        @test get_coordinates(
            M,
            Ref(0.0),
            Ref(-2.0),
            DiagonalizingOrthonormalBasis(Ref(-1.0)),
        )[] ≈ 2.0
        y = [0.0]
        get_coordinates!(M, y, Ref(0.0), Ref(2.0), DiagonalizingOrthonormalBasis(Ref(1.0)))
        @test y ≈ [2.0]
        @test get_vector(M, Ref(0.0), [2.0], DefaultOrthonormalBasis())[] ≈ 2.0
        @test get_vector(M, [0.0], [2.0], DefaultOrthonormalBasis())[] ≈ 2.0
        @test get_vector(M, Ref(0.0), [2.0], DiagonalizingOrthonormalBasis(Ref(1.0)))[] ≈
            2.0
        @test get_vector(M, Ref(0.0), [-2.0], DiagonalizingOrthonormalBasis(Ref(1.0)))[] ≈
            -2.0
        @test get_vector(M, Ref(0.0), [2.0], DiagonalizingOrthonormalBasis(Ref(-1.0)))[] ≈
            -2.0
        @test get_vector(M, Ref(0.0), [-2.0], DiagonalizingOrthonormalBasis(Ref(-1.0)))[] ≈
            2.0
        @test number_of_coordinates(M, DiagonalizingOrthonormalBasis(Ref(-1.0))) == 1
        @test number_of_coordinates(M, DefaultOrthonormalBasis()) == 1
        rrcv = Manifolds.RieszRepresenterCotangentVector(M, 0.0, 1.0)
        @test flat(M, 0.0, 1.0) == rrcv
        @test sharp(M, 0.0, rrcv) == 1.0
        B_cot = Manifolds.dual_basis(M, 0.0, DefaultOrthonormalBasis())
        @test get_coordinates(M, 0.0, rrcv, B_cot) ≈ @SVector [1.0]
        @test get_vector(M, 0.0, 1.0, B_cot) isa Manifolds.RieszRepresenterCotangentVector
        a = fill(NaN)
        get_coordinates!(M, a, 0.0, rrcv, B_cot)
        @test a[] ≈ 1.0
        rrcv2 = Manifolds.RieszRepresenterCotangentVector(M, fill(0.0), fill(-10.0))
        get_vector!(M, rrcv2, 0.0, 1.0, B_cot)
        @test isapprox(rrcv.X, rrcv2.X[])
        @test vector_transport_to(M, 0.0, 1.0, 1.0, ParallelTransport()) == 1.0
        @test retract(M, 0.0, 1.0) == exp(M, 0.0, 1.0)
        @test injectivity_radius(M) ≈ π
        @test injectivity_radius(M, Ref(-2.0)) ≈ π
        @test injectivity_radius(M, Ref(-2.0), ExponentialRetraction()) ≈ π
        @test injectivity_radius(M, ExponentialRetraction()) ≈ π
        @test mean(M, [-π / 2, 0.0, π]) ≈ -π / 2
        @test mean(M, [-π / 2, 0.0, π], [1.0, 1.0, 1.0]) == -π / 2
        z = project(M, 1.5 * π)
        z2 = fill(0.0)
        project!(M, z2, 1.5 * π)
        @test z2[1] == z
        @test project(M, z) == z
        @test project(M, 1.0, 2.0) == 2.0

        # isapprox for 1-element vectors
        @test isapprox(M, [1.0], [1.0])
        @test isapprox(M, [0.0], [1.0], [1.0])

        # ManifoldDiff
        @test ManifoldDiff.adjoint_Jacobi_field(
            M,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0
        @test ManifoldDiff.diagonalizing_projectors(M, 0.0, 2.0) ==
            ((0.0, ManifoldDiff.ProjectorOntoVector(M, 0.0, SA[1.0])),)
        @test ManifoldDiff.jacobi_field(
            M,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0

        # volume
        @test manifold_volume(M) ≈ 2 * π
        @test volume_density(M, 0.0, 2.0) == 1.0
    end
    types = [Float64]

    basis_types = (DefaultOrthonormalBasis(),)
    basis_types_real = (
        DefaultOrthonormalBasis(),
        DiagonalizingOrthonormalBasis(Ref(-1.0)),
        DiagonalizingOrthonormalBasis(Ref(1.0)),
    )
    for T in types
        @testset "Type $T" begin
            pts = convert.(Ref(T), [-π / 4, 0.0, π / 4])
            Manifolds.test_manifold(
                M,
                pts,
                test_vector_spaces = false,
                test_project_point = true,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                is_mutating = false,
                test_rand_point = true,
                test_rand_tvector = true,
                rand_tvector_atol_multiplier = 2.0,
            )
            ptsS = map(p -> (@SArray fill(p)), pts)
            Manifolds.test_manifold(
                M,
                ptsS,
                test_project_point = true,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                vector_transport_methods = [
                    ParallelTransport(),
                    SchildsLadderTransport(),
                    PoleLadderTransport(),
                ],
                basis_types_vecs = basis_types_real,
                basis_types_to_from = basis_types_real,
                test_rand_point = true,
                test_rand_tvector = true,
                rand_tvector_atol_multiplier = 2.0,
            )
        end
    end
    @testset "Mutating Rand for real Circle" begin
        p = fill(NaN)
        X = fill(NaN)
        rand!(M, p)
        @test is_point(M, p)
        rand!(M, X; vector_at = p)
        @test is_vector(M, p, X)

        rng = MersenneTwister()
        rand!(rng, M, p)
        @test is_point(M, p)
        rand!(rng, M, X; vector_at = p)
        @test is_vector(M, p, X)
    end
    @testset "Test sym_rem" begin
        p = 4.0 # not a point
        p = sym_rem(p) # modulo to a point
        @test is_point(M, p)
    end
    Mc = Circle(ℂ)
    @testset "Complex Circle Basics" begin
        @test repr(Mc) == "Circle(ℂ)"
        @test representation_size(Mc) == ()
        @test manifold_dimension(Mc) == 1
        @test is_flat(Mc)
        @test is_vector(Mc, 1im, 0.0)
        @test is_point(Mc, 1im)
        @test !is_point(Mc, 1 + 1im)
        @test_throws DomainError is_point(Mc, 1 + 1im; error = :error)
        @test !is_vector(Mc, 1 + 1im, 0.0)
        @test_throws DomainError is_vector(Mc, 1 + 1im, 0.0; error = :error)
        @test !is_vector(Mc, 1im, 2im)
        @test_throws DomainError is_vector(Mc, 1im, 2im; error = :error)
        rrcv = Manifolds.RieszRepresenterCotangentVector(Mc, 0.0 + 0.0im, 1.0im)
        @test flat(Mc, 0.0 + 0.0im, 1.0im) == rrcv
        @test sharp(Mc, 0.0 + 0.0im, rrcv) == 1.0im
        @test norm(Mc, 1.0, log(Mc, 1.0, -1.0)) ≈ π
        @test is_vector(Mc, 1.0, log(Mc, 1.0, -1.0))
        X = @MArray fill(0.0 + 0.0im)
        p = @SArray fill(1.0 + 0.0im)
        log!(Mc, X, p, @SArray fill(-1.0 + 0.0im))
        @test norm(Mc, (@SArray fill(1.0)), X) ≈ π
        @test is_vector(Mc, p, X)
        @test project(Mc, 1.0) == 1.0
        @test project(Mc, 1 / sqrt(2.0) + 1 / sqrt(2.0) * im) ≈
            1 / sqrt(2.0) + 1 / sqrt(2.0) * im
        p = @MArray fill(1.0 + 0.0im)
        project!(Mc, p, p)
        @test p == @MArray fill(1.0 + 0.0im)
        p .*= 2
        project!(Mc, p, p)
        @test p == @MArray fill(1.0 + 0.0im)

        @test get_vector(Mc, fill(1.0 + 0.0im), [1.0]) isa Array{ComplexF64, 0}

        angles = map(pp -> exp(pp * im), [-π / 2, 0.0, π])
        @test mean(Mc, angles) ≈ exp(-π * im / 2)
        @test mean(Mc, angles, [1.0, 1.0, 1.0]) ≈ exp(-π * im / 2)
        @test_throws ErrorException mean(Mc, [-1.0 + 0im, 1.0 + 0im])
        @test_throws ErrorException mean(Mc, [-1.0 + 0im, 1.0 + 0im], [1.0, 1.0])

        # volume
        @test manifold_volume(Mc) ≈ 2 * π
        @test volume_density(Mc, 1.0 + 0.0im, 2im) == 1.0
    end
    types = [Complex{Float64}]

    @testset "small and large distance tests" begin
        p = -0.42681766710748265 + 0.9043377018818392im
        q = -0.42681766710748226 + 0.9043377018818393im
        @test isapprox(distance(Mc, p, q), 4.041272810440265e-16)
        @test isapprox(distance(Mc, p, -q), 3.1415926535897927; atol = eps())
    end

    for T in types
        @testset "Type $T" begin
            a = 1 / sqrt(2.0)
            pts = convert.(Ref(T), [a - a * im, 1 + 0im, a + a * im])
            Manifolds.test_manifold(
                Mc,
                pts,
                test_vector_spaces = false,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                is_mutating = false,
                exp_log_atol_multiplier = 2.0,
                is_tangent_atol_multiplier = 2.0,
                rand_tvector_atol_multiplier = 4.0,
                test_rand_point = true,
                test_rand_tvector = true,
            )
            ptsS = map(p -> (@SArray fill(p)), pts)
            Manifolds.test_manifold(
                Mc,
                ptsS,
                test_project_tangent = true,
                test_musical_isomorphisms = true,
                test_default_vector_transport = true,
                exp_log_atol_multiplier = 2.0,
                is_tangent_atol_multiplier = 2.0,
                rand_tvector_atol_multiplier = 4.0,
                basis_types_vecs = basis_types,
                basis_types_to_from = basis_types,
                test_rand_point = true,
                test_rand_tvector = true,
            )
        end
    end
    @testset "Mixed array dimensions for exp and PT" begin
        # this is an issue on Julia 1.6 but not later releases
        M = Circle()
        p = fill(0.0)
        Manifolds.exp_fused!(M, p, p, [1.0], 2.0)
        @test p ≈ fill(2.0)
        parallel_transport_to!(M, p, p, [4.0], p)
        @test p ≈ fill(4.0)
    end
end

using NLsolve
using LinearAlgebra

include("header.jl")

Random.seed!(10)

@testset "approximate inverse retractions" begin
    @testset "NLSolveInverseRetraction" begin
        @testset "constructor" begin
            X = randn(3)

            @test NLSolveInverseRetraction <: ApproximateInverseRetraction
            m1 = NLSolveInverseRetraction(ExponentialRetraction())
            @test m1.retraction === ExponentialRetraction()
            @test m1.X0 === nothing
            @test !m1.project_tangent
            @test !m1.project_point
            @test isempty(m1.nlsolve_kwargs)

            m2 = NLSolveInverseRetraction(
                PolarRetraction(),
                [1.0, 2.0, 3.0];
                project_tangent = true,
                project_point = true,
                autodiff = :forward,
            )
            @test m2.retraction === PolarRetraction()
            @test m2.X0 == [1.0, 2.0, 3.0]
            @test m2.project_tangent
            @test m2.project_point
            @test (; m2.nlsolve_kwargs...) == (; autodiff = :forward)
        end
        @testset "Euclidean" begin
            M = Euclidean(3)
            p = [1.0, 2.0, 3.0]
            q = [4.0, 5.0, 6.0]
            retr_method = ExponentialRetraction()
            inv_retr_method = NLSolveInverseRetraction(retr_method)
            X = inverse_retract(M, p, q, inv_retr_method)
            @test is_vector(M, p, X)
            @test X isa Vector{Float64}
            @test X ≈ q - p
        end
        @testset "Power" begin
            M = PowerManifold(Euclidean(2), NestedPowerRepresentation(), 2)
            p = [[1.0, 2.0], [3.0, 4.0]]
            q = [[5.0, 6.0], [7.0, 8.0]]
            retr_method = ExponentialRetraction()
            inv_retr_method = NLSolveInverseRetraction(retr_method)
            X = inverse_retract(M, p, q, inv_retr_method)
            @test is_vector(M, p, X)
            @test X isa Vector{Vector{Float64}}
            @test X ≈ q - p
        end
        @testset "Sphere" begin
            M = Sphere(2)
            p = [1.0, 0.0, 0.0]
            q = [1 / sqrt(2), 1 / sqrt(2), 0.0]
            X_exp = inverse_retract(M, p, q, ProjectionInverseRetraction())
            # vector must be nonzero to converge
            X0 = randn(3) .* eps()
            inv_retr_method =
                NLSolveInverseRetraction(ProjectionRetraction(), X0; project_point = true)
            X = inverse_retract(M, p, q, inv_retr_method)
            @test is_vector(M, p, X; atol = 1.0e-9)
            @test X ≈ X_exp atol = 1.0e-8
            @test_throws OutOfInjectivityRadiusError inverse_retract(
                M,
                p,
                -p,
                inv_retr_method,
            )
        end
    end
end

include("../header.jl")

using Manifolds: induced_basis
using FiniteDifferences

@testset "Euclidean" begin
    for param in [:field, :type]
        E = Euclidean(3, parameter = param)
        Ec = Euclidean(3; field = ℂ, parameter = param)
        EM = Manifolds.MetricManifold(E, Manifolds.EuclideanMetric())
        EH = Euclidean(2, 3; field = ℍ, parameter = param)
        if param === :type
            @test repr(E) == "Euclidean(3; field=ℝ)"
            @test repr(Ec) == "Euclidean(3; field=ℂ)"
            @test repr(EH) == "Euclidean(2, 3; field=ℍ)"
        else
            @test repr(E) == "Euclidean(3; field=ℝ, parameter=:field)"
            @test repr(Ec) == "Euclidean(3; field=ℂ, parameter=:field)"
            @test repr(EH) == "Euclidean(2, 3; field=ℍ, parameter=:field)"
        end

        @test Manifolds.allocation_promotion_function(Ec, get_vector, ()) === complex
        @test is_flat(E)
        @test is_flat(Ec)
        p = zeros(3)
        A = Manifolds.RetractionAtlas()
        B = induced_basis(EM, A, p, TangentSpaceType())
        @test det_local_metric(EM, p, B) == one(eltype(p))
        for M in [E, Ec, EH]
            @test has_components(M)
            p = [1.0, 2.0, 3.0]
            q = [1.0, 2.0, 3.0]
            X = [4.0, 5.0, 6.0]
            for r in [1, 2, Inf]
                @test norm(M, p, X, r) ≈ norm(X, r)
                @test distance(M, p, q, r) ≈ norm(p - q, r)
            end
        end
        @test log_local_metric_density(EM, p, B) == zero(eltype(p))
        @test project!(E, p, p) == p
        @test embed!(E, p, p) == p
        @test manifold_dimension(Ec) == 2 * manifold_dimension(E)
        X = zeros(3)
        X[1] = 1.0
        Y = similar(X)
        project!(E, Y, p, X)
        @test Y == X
        @test embed(E, p, X) == X

        # temp: explicit test for induced basis
        B = induced_basis(E, RetractionAtlas(), 0, ManifoldsBase.TangentSpaceType())
        @test get_coordinates(E, p, X, B) == X
        get_coordinates!(E, Y, p, X, B)
        @test Y == X
        @test get_vector(E, p, Y, B) == X
        Y2 = similar(X)
        get_vector!(E, Y2, p, Y, B)
        @test Y2 == X

        # real manifold does not allow complex values
        @test_throws DomainError is_point(Ec, [:a, :b, :b]; error = :error)
        @test_throws DomainError is_point(E, [1.0, 1.0im, 0.0], error = :error)
        @test_throws DomainError is_point(E, [1]; error = :error)
        @test_throws DomainError is_vector(Ec, [:a, :b, :b], [1.0, 1.0, 0.0]; error = :error)
        @test_throws DomainError is_vector(
            E,
            [1.0, 1.0im, 0.0],
            [1.0, 1.0, 0.0];
            error = :error,
        ) # real manifold does not allow complex values
        @test_throws DomainError is_vector(E, [1], [1.0, 1.0, 0.0]; error = :error)
        @test_throws DomainError is_vector(E, [0.0, 0.0, 0.0], [1.0]; error = :error)
        @test_throws DomainError is_vector(
            E,
            [0.0, 0.0, 0.0],
            [1.0, 0.0, 1.0im];
            error = :error,
        )
        @test_throws DomainError is_vector(Ec, [0.0, 0.0, 0.0], [:a, :b, :c]; error = :error)

        @test E^2 === Euclidean(3, 2, parameter = param)
        @test ^(E, 2) === Euclidean(3, 2, parameter = param)
        @test E^(2,) === Euclidean(3, 2, parameter = param)
        @test Ec^(4, 5) === Euclidean(3, 4, 5; field = ℂ, parameter = param)

        manifolds = [E, EM, Ec]
        types = [Vector{Float64}]

        types_complex = [Vector{ComplexF64}]

        for M in manifolds
            basis_types = if M == E
                (
                    DefaultOrthonormalBasis(),
                    ProjectedOrthonormalBasis(:svd),
                    DiagonalizingOrthonormalBasis([1.0, 2.0, 3.0]),
                )
            elseif M == Ec
                (
                    DefaultOrthonormalBasis(),
                    DefaultOrthonormalBasis(ℂ),
                    DiagonalizingOrthonormalBasis([1.0, 2.0, 3.0]),
                    DiagonalizingOrthonormalBasis([1.0, 2.0, 3.0], ℂ),
                )
            else
                ()
            end
            for T in types
                @testset "$M Type $T" begin
                    pts = [
                        convert(T, [1.0, 0.0, 0.0]),
                        convert(T, [0.0, 1.0, 0.0]),
                        convert(T, [0.0, 0.0, 1.0]),
                    ]
                    Manifolds.test_manifold(
                        M,
                        pts,
                        test_project_point = true,
                        test_project_tangent = true,
                        test_musical_isomorphisms = true,
                        test_default_vector_transport = true,
                        vector_transport_methods = [
                            ParallelTransport(),
                            SchildsLadderTransport(),
                            PoleLadderTransport(),
                        ],
                        test_mutating_rand = isa(T, Vector),
                        point_distributions = [
                            Manifolds.projected_distribution(
                                M,
                                Distributions.MvNormal(zero(pts[1]), 1.0 * I),
                            ),
                        ],
                        tvector_distributions = [
                            Manifolds.normal_tvector_distribution(M, pts[1], 1.0 * I),
                        ],
                        basis_types_vecs = basis_types,
                        basis_types_to_from = basis_types,
                        basis_has_specialized_diagonalizing_get = true,
                        test_inplace = true,
                        test_rand_point = M === E,
                        test_rand_tvector = M === E,
                    )
                end
            end
        end
        for T in types_complex
            @testset "Complex Euclidean, type $T" begin
                pts = [
                    convert(T, [1.0im, -1.0im, 1.0]),
                    convert(T, [0.0, 1.0, 1.0im]),
                    convert(T, [0.0, 0.0, 1.0]),
                ]
                Manifolds.test_manifold(
                    Ec,
                    pts,
                    test_project_tangent = true,
                    test_musical_isomorphisms = true,
                    test_default_vector_transport = true,
                    parallel_transport = true,
                )
            end
        end
    end
    E = Euclidean(3)
    Ec = Euclidean(3; field = ℂ)

    number_types = [Float64, ComplexF64]
    @testset "(Nonmutating) Real and Complex Numbers" begin
        RM = Euclidean()
        CM = Euclidean(; field = ℂ)
        for T in number_types
            @testset "Type $T" begin
                M = (T <: Complex) ? CM : RM
                pts = convert.(Ref(T), [1.0, 4.0, 2.0])
                @test embed(M, pts[1]) == pts[1]
                @test project(M, pts[1]) == pts[1]
                @test retract(M, pts[1], pts[2]) == exp(M, pts[1], pts[2])
                Manifolds.test_manifold(
                    M,
                    pts,
                    test_vector_spaces = false,
                    test_project_tangent = true,
                    test_musical_isomorphisms = true,
                    test_default_vector_transport = true,
                    is_mutating = false,
                )
            end
        end
    end

    @testset "hat/vee" begin
        E = Euclidean(3, 2)
        p = collect(reshape(1.0:6.0, (3, 2)))
        X = collect(reshape(7.0:12.0, (3, 2)))
        @test hat(E, p, vec(X)) ≈ X
        Y = allocate(X)
        @test hat!(E, Y, p, vec(X)) === Y
        @test Y ≈ X
        @test vee(E, p, X) ≈ vec(X)
        Y = allocate(vec(X))
        @test vee!(E, Y, p, X) === Y
        @test Y ≈ vec(X)
    end

    @testset "Number systems power" begin
        @test ℝ^2 === Euclidean(2)
        @test ℝ^(2, 3) === Euclidean(2, 3)

        @test ℂ^2 === Euclidean(2; field = ℂ)
        @test ℂ^(2, 3) === Euclidean(2, 3; field = ℂ)

        @test ℍ^2 === Euclidean(2; field = ℍ)
        @test ℍ^(2, 3) === Euclidean(2, 3; field = ℍ)
    end

    @testset "Embeddings into larger Euclidean Manifolds" begin
        M = Euclidean(3, 3)
        N = Euclidean(4, 4)
        O = EmbeddedManifold(M, N)
        # first test with same length of sizes
        p = ones(3, 3)
        q = zeros(4, 4)
        qT = zeros(4, 4)
        qT[1:3, 1:3] .= 1.0
        embed!(O, q, p)
        @test norm(qT - q) == 0
        qM = embed(O, p)
        @test norm(project(O, qM) - p) == 0
        @test norm(qT - qM) == 0
        # test with different sizes, check that it only fills first element
        q2 = zeros(4, 4, 3)
        q2T = zeros(4, 4, 3)
        q2T[1:3, 1:3, 1] .= 1.0
        embed!(O, q2, p)
        @test norm(q2T - q2) == 0
        O2 = EmbeddedManifold(M, Euclidean(4, 4, 3))
        q2M = embed(O2, p)
        @test norm(q2T - q2M) == 0
        # wrong size error checks
        @test_throws DomainError embed!(O, zeros(3, 3), zeros(3, 3, 5))
        @test_throws DomainError embed!(O, zeros(3, 3), zeros(4, 4))
        @test_throws DomainError project!(O, zeros(3, 3, 5), zeros(3, 3))
        @test_throws DomainError project!(O, zeros(4, 4), zeros(3, 3))
    end

    @testset "Embedding Real into Complex" begin
        M = Euclidean(3, 3)
        N = Euclidean(3, 4; field = ℂ)
        O = EmbeddedManifold(M, N)
        p = ones(3, 3)
        qT = zeros(ComplexF64, 3, 4)
        qT[1:3, 1:3] .= 1.0
        q = embed(O, p)
        @test is_point(N, q)
        @test q == qT
        q2 = zeros(ComplexF64, 3, 4)
        embed!(O, q2, p)
        @test q2 == qT
    end

    @testset "Euclidean metric tests" begin
        M = Euclidean(2)
        p = zeros(2)
        A = Manifolds.get_default_atlas(M)
        i = Manifolds.get_chart_index(M, A, p)
        B = Manifolds.induced_basis(M, A, i, TangentSpaceType())
        C1 = christoffel_symbols_first(M, p, B)
        @test size(C1) == (2, 2, 2)
        @test norm(C1) ≈ 0.0 atol = 1.0e-13
        C2 = christoffel_symbols_second(M, p, B)
        @test size(C2) == (2, 2, 2)
        @test norm(C2) ≈ 0.0 atol = 1.0e-13
        C2j = christoffel_symbols_second_jacobian(M, p, B)
        @test size(C2j) == (2, 2, 2, 2)
        @test norm(C2j) ≈ 0.0 atol = 1.0e-16
        @test norm(einstein_tensor(M, p, B)) < eps()^2
        @test ricci_curvature(M, p, B) ≈ 0 atol = 1.0e-16
        RC = ricci_tensor(M, p, B)
        @test size(RC) == (2, 2)
        @test norm(RC) ≈ 0.0 atol = 1.0e-16
        @test local_metric(M, p, B) == Diagonal(ones(2))
        @test inverse_local_metric(M, p, B) == Diagonal(ones(2))
        @test det_local_metric(M, p, B) == 1
        RT = riemann_tensor(M, p, B)
        @test size(RT) == (2, 2, 2, 2)
        @test norm(RT) ≈ 0.0 atol = 1.0e-16

        @test !Manifolds.check_chart_switch(M, A, i, p)

        @test riemann_tensor(M, p, [1, 2], [1, 3], [1, 4]) == [0, 0]
        @test sectional_curvature(M, p, [1.0, 0.0], [0.0, 1.0]) == 0.0
        @test sectional_curvature_max(M) == 0.0
        @test sectional_curvature_min(M) == 0.0
    end
    @testset "Induced Basis and local metric for EuclideanMetric" begin
        struct DefaultManifold <: AbstractManifold{ℝ} end
        p = zeros(3)
        M = DefaultManifold()
        TpM = TangentSpace(M, p)
        B = induced_basis(M, Manifolds.get_default_atlas(M), p, TangentSpaceType())
        MM = MetricManifold(M, EuclideanMetric())
        @test local_metric(MM, p, B) == Diagonal(ones(3))
        @test inverse_local_metric(MM, p, B) == Diagonal(ones(3))
        @test det_local_metric(MM, p, B) == 1.0
        DB1 = dual_basis(MM, p, B)
        @test DB1 isa InducedBasis
        @test DB1.vs isa ManifoldsBase.CotangentSpaceType
        DB2 = induced_basis(M, Manifolds.get_default_atlas(M), p, CotangentSpaceType())
        @test DB2 isa InducedBasis
        @test DB2.vs isa ManifoldsBase.CotangentSpaceType
        DDB = dual_basis(MM, p, DB2)
        @test DDB isa InducedBasis
        @test DDB.vs isa ManifoldsBase.TangentSpaceType
    end
    @testset "RNG point with σ" begin
        Random.seed!(42)
        @test is_point(E, rand(E; σ = 10.0))
        @test is_point(E, rand(MersenneTwister(123), E; σ = 10.0))
        pc = rand(Ec)
        @test is_point(Ec, pc)
        @test norm(imag.(pc)) != 0
    end

    @testset "StaticArrays specializations" begin
        M1 = Euclidean(3)
        @test get_vector(
            M1,
            SA[1.0, 2.0, 3.0],
            SA[-1.0, -2.0, -3.0],
            DefaultOrthonormalBasis(),
        ) === SA[-1.0, -2.0, -3.0]

        c_sv = SizedVector{3}([-1.0, -2.0, -3.0])
        @test get_vector(M1, SA[1.0, 2.0, 3.0], c_sv, DefaultOrthonormalBasis()) === c_sv

        M2 = Euclidean(2, 2)
        @test get_vector(
            M2,
            SA[1.0 2.0; 3.0 4.0],
            SA[-1.0, -2.0, -3.0, -4.0],
            DefaultOrthonormalBasis(),
        ) === SA[-1.0 -3.0; -2.0 -4.0]

        @test get_vector(
            M2,
            SizedMatrix{2, 2}([1.0 2.0; 3.0 4.0]),
            SizedMatrix{2, 2}([-1.0, -2.0, -3.0, -4.0]),
            DefaultOrthonormalBasis(),
        ) == SA[-1.0 -3.0; -2.0 -4.0]

        M1c = Euclidean(3, field = ℂ)
        get_vector(
            M1c,
            SizedVector{3}([1.0im, 2.0, 4.0im]),
            SizedVector{3}([-1.0, -3.0, -4.0im]),
            DefaultOrthonormalBasis(ℂ),
        ) == SA[-1.0, -3.0, -4.0im]
    end

    @testset "Euclidean(1)" begin
        M = Euclidean(1)
        @test distance(M, 2.0, 4.0) == 2.0
    end

    @testset "errors" begin
        M = Euclidean(4)
        @test_throws DimensionMismatch distance(M, [1, 2, 3, 4], [1 2; 3 4])
    end

    @testset "ManifoldDiff" begin
        # ManifoldDiff
        M0 = Euclidean()
        @test ManifoldDiff.adjoint_Jacobi_field(
            M0,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0
        @test ManifoldDiff.diagonalizing_projectors(M0, 0.0, 2.0) ==
            ((0.0, ManifoldDiff.IdentityProjector()),)
        @test ManifoldDiff.jacobi_field(
            M0,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0
    end

    @testset "Weingarten & Hessian" begin
        M = Euclidean(2)
        p = [1.0, 2.0]
        G = [3.0, 4.0]
        H = [5.0, 6.0]
        X = [7.0, 8.0]
        rH = riemannian_Hessian(M, p, G, H, X)
        @test rH == H
    end
    @testset "Volume" begin
        E = Euclidean(3)
        @test manifold_volume(E) == Inf
        p = zeros(3)
        X = zeros(3)
        @test volume_density(E, p, X) == 1.0
    end

    @testset "field parameter" begin
        Ms = Euclidean(1; parameter = :field)
        M0s = Euclidean(; parameter = :field)

        @test distance(Ms, 2.0, 4.0) == 2.0
        @test distance(M0s, 2.0, 4.0) == 2.0
        @test log(M0s, 2.0, 4.0) == 2.0
        @test manifold_dimension(M0s) == 1
        @test project(M0s, 4.0) == 4.0
        @test project(M0s, 2.0, 4.0) == 4.0
        @test retract(M0s, 2.0, 4.0) == 6.0
        @test retract(M0s, 2.0, 4.0, ExponentialRetraction()) == 6.0

        @test ManifoldDiff.adjoint_Jacobi_field(
            M0s,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0
        @test ManifoldDiff.diagonalizing_projectors(M0s, 0.0, 2.0) ==
            ((0.0, ManifoldDiff.IdentityProjector()),)
        @test ManifoldDiff.jacobi_field(
            M0s,
            0.0,
            1.0,
            0.5,
            2.0,
            ManifoldDiff.βdifferential_shortest_geodesic_startpoint,
        ) === 2.0
    end

    @testset "Mixed array dimensions for exp and PT" begin
        # this is an issue on Julia 1.6 but not later releases
        for M in [Euclidean(), Euclidean(; parameter = :field)]
            p = fill(0.0)
            Manifolds.exp_fused!(M, p, p, [1.0], 2.0)
            @test p ≈ fill(2.0)
            parallel_transport_to!(M, p, p, [4.0], p)
            @test p ≈ fill(4.0)
        end
    end
end

@doc raw"""
    SymmetricPositiveSemidefiniteFixedRank{T,𝔽} <: AbstractDecoratorManifold{𝔽}

The [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  `` \operatorname{SPS}_k(n)`` consisting of the real- or complex-valued
symmetric positive semidefinite matrices of size ``n×n`` and rank ``k``, i.e. the set

````math
\operatorname{SPS}_k(n) = \bigl\{
p  ∈ 𝔽^{n×n}\ \big|\ p^{\mathrm{H}} = p,
apa^{\mathrm{H}} \geq 0 \text{ for all } a ∈ 𝔽
\text{ and } \operatorname{rank}(p) = k\bigr\},
````
where ``⋅^{\mathrm{H}}`` denotes the Hermitian, i.e. complex conjugate transpose,
and the field ``𝔽 ∈ \{ ℝ, ℂ\}``.
We sometimes ``\operatorname{SPS}_{k,𝔽}(n)``, when distinguishing the real- and complex-valued
manifold is important.

An element is represented by ``q ∈ 𝔽^{n×k}`` from the factorization ``p = qq^{\mathrm{H}}``.
Note that since for any unitary (orthogonal) ``A ∈ 𝔽^{n×n}`` we have
``(Aq)(Aq)^{\mathrm{H}} = qq^{\mathrm{H}} = p``, the representation is not unique, or in
other words, the manifold is a quotient manifold of ``𝔽^{n×k}``.

The tangent space at ``p``, ``T_p\operatorname{SPS}_k(n)``, is also represented
by matrices ``Y ∈ 𝔽^{n×k}`` and reads as

````math
T_p\operatorname{SPS}_k(n) = \bigl\{
X ∈ 𝔽^{n×n}\,|\,X = qY^{\mathrm{H}} + Yq^{\mathrm{H}}
\text{ i.e. } X = X^{\mathrm{H}}
\bigr\}.
````

Note that the metric used yields a non-complete manifold.
The metric was used in [JourneeBachAbsilSepulchre:2010](@cite)[MassartAbsil:2020](@cite).

# Constructor

    SymmetricPositiveSemidefiniteFixedRank(n::Int, k::Int, field::AbstractNumbers=ℝ; parameter::Symbol=:type)

Generate the manifold of ``n×n`` symmetric positive semidefinite matrices of rank ``k``
over the `field` of real numbers `ℝ` or complex numbers `ℂ`.
"""
struct SymmetricPositiveSemidefiniteFixedRank{T, 𝔽} <: AbstractDecoratorManifold{𝔽}
    size::T
end

function SymmetricPositiveSemidefiniteFixedRank(
        n::Int,
        k::Int,
        field::AbstractNumbers = ℝ;
        parameter::Symbol = :type,
    )
    size = wrap_type_parameter(parameter, (n, k))
    return SymmetricPositiveSemidefiniteFixedRank{typeof(size), field}(size)
end

@doc raw"""
    check_point(M::SymmetricPositiveSemidefiniteFixedRank, q; kwargs...)

Check whether `q` is a valid manifold point on the [`SymmetricPositiveSemidefiniteFixedRank`](@ref) `M`, i.e.
whether `p=q*q'` is a symmetric matrix of size `(n,n)` with values from the corresponding
[`AbstractNumbers`](@extref ManifoldsBase number-system) `𝔽`.
The symmetry of `p` is not explicitly checked since by using `q` p is symmetric by construction.
The tolerance for the symmetry of `p` can and the rank of `q*q'` be set using `kwargs...`.
"""
function check_point(M::SymmetricPositiveSemidefiniteFixedRank, q; kwargs...)
    n, k = get_parameter(M.size)
    p = q * q'
    r = rank(p * p'; kwargs...)
    if r < k
        return DomainError(
            r,
            "The point $(p) does not lie on $M, since its rank is less than $(k).",
        )
    end
    return nothing
end

"""
    check_vector(M::SymmetricPositiveSemidefiniteFixedRank, p, X; kwargs... )

Check whether `X` is a tangent vector to manifold point `p` on the
[`SymmetricPositiveSemidefiniteFixedRank`](@ref) `M`, i.e. `X` has to be a symmetric matrix of size `(n,n)`
and its values have to be from the correct [`AbstractNumbers`](@extref ManifoldsBase number-system).

Due to the reduced representation this is fulfilled as soon as the matrix is of correct size.
"""
check_vector(M::SymmetricPositiveSemidefiniteFixedRank, q, Y; kwargs...)

function get_embedding(
        ::SymmetricPositiveSemidefiniteFixedRank{TypeParameter{Tuple{n, k}}, 𝔽},
    ) where {n, k, 𝔽}
    return Euclidean(n, k; field = 𝔽)
end
function get_embedding(
        M::SymmetricPositiveSemidefiniteFixedRank{Tuple{Int, Int}, 𝔽},
    ) where {𝔽}
    n, k = get_parameter(M.size)
    return Euclidean(n, k; field = 𝔽, parameter = :field)
end

function ManifoldsBase.get_embedding_type(::SymmetricPositiveSemidefiniteFixedRank)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType()
end

@doc raw"""
    distance(M::SymmetricPositiveSemidefiniteFixedRank, p, q)

Compute the distance between two points `p`, `q` on the
[`SymmetricPositiveSemidefiniteFixedRank`](@ref), which is the Frobenius norm of ``Y`` which
minimizes ``\lVert p - qY\rVert`` with respect to ``Y``.
"""
distance(M::SymmetricPositiveSemidefiniteFixedRank, p, q) = norm(M, p, log(M, p, q))

@doc raw"""
    exp(M::SymmetricPositiveSemidefiniteFixedRank, q, Y)

Compute the exponential map on the [`SymmetricPositiveSemidefiniteFixedRank`](@ref),
which just reads

````math
    \exp_q Y = q+Y.
````
!!! note

    Since the manifold is represented in the embedding and is a quotient manifold,
    the exponential and logarithmic map are a bijection only with respect to the equivalence
    classes. Computing
    ````math
        q_2 = \exp_p(\log_pq)
    ````
    might yield a matrix ``q_2\neq q``, but they represent the same point on the quotient
    manifold, i.e. ``d_{\operatorname{SPS}_k(n)}(q_2,q) = 0``.
"""
exp(::SymmetricPositiveSemidefiniteFixedRank, ::Any, ::Any)

function exp!(::SymmetricPositiveSemidefiniteFixedRank, q2, q, Y)
    q2 .= q .+ Y
    return q2
end

@doc raw"""
    isapprox(M::SymmetricPositiveSemidefiniteFixedRank, p, q; kwargs...)

test, whether two points `p`, `q` are (approximately) nearly the same.
Since this is a quotient manifold in the embedding, the test is performed by checking
their distance, if they are not the same, i.e. that ``d_{\mathcal M}(p,q) \approx 0``, where
the comparison is performed with the classical `isapprox`.
The `kwargs...` are passed on to this accordingly.
"""
function _isapprox(
        M::SymmetricPositiveSemidefiniteFixedRank,
        p::T,
        q;
        atol::Real = sqrt(prod(representation_size(M))) * eps(real(float(number_eltype(T)))),
        kwargs...,
    ) where {T}
    return isapprox(norm(p - q), 0; atol = atol, kwargs...) ||
        isapprox(distance(M, p, q), 0; atol = atol, kwargs...)
end

"""
    is_flat(::SymmetricPositiveSemidefiniteFixedRank)

Return false. [`SymmetricPositiveSemidefiniteFixedRank`](@ref) is not a flat manifold. See Theorem A.18 in [MassartAbsil:2020](@cite).
"""
is_flat(M::SymmetricPositiveSemidefiniteFixedRank) = false

@doc raw"""
    log(M::SymmetricPositiveSemidefiniteFixedRank, q, p)

Compute the logarithmic map on the [`SymmetricPositiveSemidefiniteFixedRank`](@ref) manifold
by minimizing ``\lVert p - qY\rVert`` with respect to ``Y``.

!!! note

    Since the manifold is represented in the embedding and is a quotient manifold,
    the exponential and logarithmic map are a bijection only with respect to the equivalence
    classes. Computing
    ````math
        q_2 = \exp_p(\log_pq)
    ````
    might yield a matrix ``q_2≠q``, but they represent the same point on the quotient
    manifold, i.e. ``d_{\operatorname{SPS}_k(n)}(q_2,q) = 0``.
"""
log(::SymmetricPositiveSemidefiniteFixedRank, q, p)

function log!(::SymmetricPositiveSemidefiniteFixedRank, Z, q, p)
    s = svd(q' * p)
    return Z .= p * (s.V * s.U') - q
end

@doc raw"""
    manifold_dimension(M::SymmetricPositiveSemidefiniteFixedRank)

Return the dimension of the [`SymmetricPositiveSemidefiniteFixedRank`](@ref) matrix `M` over the number system
`𝔽`, i.e.

````math
\begin{aligned}
\dim \operatorname{SPS}_{k,ℝ}(n) &= kn - \frac{k(k-1)}{2},\\
\dim \operatorname{SPS}_{k,ℂ}(n) &= 2kn - k^2,
\end{aligned}
````

where the last ``k^2`` is due to the zero imaginary part for Hermitian matrices diagonal
"""
manifold_dimension(::SymmetricPositiveSemidefiniteFixedRank)

function manifold_dimension(M::SymmetricPositiveSemidefiniteFixedRank{<:Any, ℝ})
    n, k = get_parameter(M.size)
    return k * n - div(k * (k - 1), 2)
end
function manifold_dimension(M::SymmetricPositiveSemidefiniteFixedRank{<:Any, ℂ})
    n, k = get_parameter(M.size)
    return 2 * k * n - k * k
end

function project!(::SymmetricPositiveSemidefiniteFixedRank, Z, q, Y)
    Z .= Y - q * lyap(q' * q, q' * Y - Y' * q)
    return Z
end

function Base.show(
        io::IO,
        ::SymmetricPositiveSemidefiniteFixedRank{TypeParameter{Tuple{n, k}}, 𝔽},
    ) where {n, k, 𝔽}
    return print(io, "SymmetricPositiveSemidefiniteFixedRank($(n), $(k), $(𝔽))")
end
function Base.show(
        io::IO,
        M::SymmetricPositiveSemidefiniteFixedRank{Tuple{Int, Int}, 𝔽},
    ) where {𝔽}
    n, k = get_parameter(M.size)
    return print(
        io,
        "SymmetricPositiveSemidefiniteFixedRank($(n), $(k), $(𝔽); parameter=:field)",
    )
end

"""
    vector_transport_to(M::SymmetricPositiveSemidefiniteFixedRank, p, X, q)

transport the tangent vector `X` at `p` to `q` by projecting it onto the tangent space
at `q`.
"""
vector_transport_to(
    ::SymmetricPositiveSemidefiniteFixedRank,
    ::Any,
    ::Any,
    ::Any,
    ::ProjectionTransport,
)

function vector_transport_to_project!(M::SymmetricPositiveSemidefiniteFixedRank, Y, p, X, q)
    project!(M, Y, q, X)
    return Y
end

@doc raw"""
     zero_vector(M::SymmetricPositiveSemidefiniteFixedRank, p)

returns the zero tangent vector in the tangent space of the symmetric positive
definite matrix `p` on the [`SymmetricPositiveSemidefiniteFixedRank`](@ref) manifold `M`.
"""
zero_vector(::SymmetricPositiveSemidefiniteFixedRank, ::Any...)

function zero_vector!(::SymmetricPositiveSemidefiniteFixedRank, v, ::Any)
    return fill!(v, 0)
end

# [Hyperbolic space](@id HyperbolicSpace)

The hyperbolic space can be represented in three different models.

* [Hyperboloid](@ref hyperboloid_model) which is the default model, i.e. is used when using arbitrary array types for points and tangent vectors
* [Poincaré ball](@ref poincare_ball) with separate types for points and tangent vectors and a [visualization](@ref poincare_ball_plot) for the two-dimensional case
* [Poincaré half space](@ref poincare_halfspace) with separate types for points and tangent vectors and a [visualization](@ref poincare_half_plane_plot) for the two-dimensional cae.

In the following the common functions are collected.

A function in this general section uses vectors interpreted as if in the [hyperboloid model](@ref hyperboloid_model),
and other representations usually just convert to this representation to use these general functions.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Hyperbolic.jl"]
Order = [:type, :function]
```

## [hyperboloid model](@id hyperboloid_model)

```@autodocs
Modules = [Manifolds]
Private = false
Pages = ["manifolds/HyperbolicHyperboloid.jl"]
Order = [:type, :function]
```

### [Visualization of the Hyperboloid](@id hyperboloid_plot)

For the case of [`Hyperbolic`](@ref)`(2)` there is plotting available based on a [PlottingRecipe](https://docs.juliaplots.org/latest/recipes/). You can easily plot points, connecting geodesics as well as tangent vectors.

!!! note
    The recipes are only loaded if [Plots.jl](http://docs.juliaplots.org/latest/) or
    [RecipesBase.jl](http://juliaplots.org/RecipesBase.jl/stable/) is loaded.

If we consider a set of points, we can first plot these and their connecting
geodesics using the `geodesic_interpolation` for the points. This variable specifies with how many points a geodesic between two successive points is sampled (per default it's `-1`, which deactivates geodesics) and the line style is set to be a path.

In general you can plot the surface of the hyperboloid either as wireframe (`wireframe=true`) additionally specifying `wires` (or `wires_x` and `wires_y`) to change the density of wires and a `wireframe_color`. The same holds for the plot as a `surface` (which is `false` by default) and its `surface_resolution` (or `surface_resolution_x` or `surface_resolution_y`) and a `surface_color`.

```@example hyperboloid
using Manifolds, Plots
M = Hyperbolic(2)
pts =  [ [0.85*cos(φ), 0.85*sin(φ), sqrt(0.85^2+1)] for φ ∈ range(0,2π,length=11) ]
scene = plot(M, pts; geodesic_interpolation=100)
```

To just plot the points atop, we can just omit the `geodesic_interpolation` parameter to obtain a scatter plot. Note that we avoid redrawing the wireframe in the following `plot!` calls.

```@example hyperboloid
plot!(scene, M, pts; wireframe=false)
```

We can further generate tangent vectors in these spaces and use a plot for there. Keep in mind that a tangent vector in plotting always requires its base point.

```@example hyperboloid
pts2 = [ [0.45 .*cos(φ + 6π/11), 0.45 .*sin(φ + 6π/11), sqrt(0.45^2+1) ] for φ ∈ range(0,2π,length=11)]
vecs = log.(Ref(M),pts,pts2)
plot!(scene, M, pts, vecs; wireframe=false)
```

Just to illustrate, for the first point the tangent vector is pointing along the following geodesic

```@example hyperboloid
plot!(scene, M, [pts[1], pts2[1]]; geodesic_interpolation=100, wireframe=false)
```

### Internal functions

The following functions are available for internal use to construct points in the hyperboloid model

```@autodocs
Modules = [Manifolds]
Public = false
Pages = ["manifolds/HyperbolicHyperboloid.jl"]
Order = [:type, :function]
```

## [Poincaré ball model](@id poincare_ball)

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/HyperbolicPoincareBall.jl"]
Order = [:type, :function]
```

### [Visualization of the Poincaré ball](@id poincare_ball_plot)

For the case of [`Hyperbolic`](@ref)`(2)` there is a plotting available based on a [PlottingRecipe](https://docs.juliaplots.org/latest/recipes/) you can easily plot points, connecting geodesics as well as tangent vectors.

!!! note
    The recipes are only loaded if [Plots.jl](http://docs.juliaplots.org/latest/) or
    [RecipesBase.jl](http://juliaplots.org/RecipesBase.jl/stable/) is loaded.

If we consider a set of points, we can first plot these and their connecting
geodesics using the `geodesic_interpolation` For the points. This variable specifies with how many points a geodesic between two successive points is sampled (per default it's `-1`, which deactivates geodesics) and the line style is set to be a path.
Another keyword argument added is the border of the Poincaré disc, namely
`circle_points = 720` resolution of the drawn boundary (every hlaf angle) as well as its color, `hyperbolic_border_color = RGBA(0.0, 0.0, 0.0, 1.0)`.

```@example poincareball
using Manifolds, Plots
M = Hyperbolic(2)
pts = PoincareBallPoint.( [0.85 .* [cos(φ), sin(φ)] for φ ∈ range(0,2π,length=11)])
scene = plot(M, pts, geodesic_interpolation = 100)
```

To just plot the points atop, we can just omit the `geodesic_interpolation` parameter to obtain a scatter plot

```@example poincareball
plot!(scene, M, pts)
```

We can further generate tangent vectors in these spaces and use a plot for there. Keep in mind, that a tangent vector in plotting always requires its base point

```@example poincareball
pts2 = PoincareBallPoint.( [0.45 .* [cos(φ + 6π/11), sin(φ + 6π/11)] for φ ∈ range(0,2π,length=11)])
vecs = log.(Ref(M),pts,pts2)
plot!(scene, M, pts,vecs)
```

Just to illustrate, for the first point the tangent vector is pointing along the following geodesic

```@example poincareball
plot!(scene, M, [pts[1], pts2[1]], geodesic_interpolation=100)
```

## [Poincaré half space model](@id poincare_halfspace)

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/HyperbolicPoincareHalfspace.jl"]
Order = [:type, :function]
```

### [Visualization on the Poincaré half plane](@id poincare_half_plane_plot)

For the case of [`Hyperbolic`](@ref)`(2)` there is a plotting available based on a [PlottingRecipe](https://docs.juliaplots.org/latest/recipes/) you can easily plot points, connecting geodesics as well as tangent vectors.

!!! note
    The recipes are only loaded if [Plots.jl](http://docs.juliaplots.org/latest/) or
    [RecipesBase.jl](http://juliaplots.org/RecipesBase.jl/stable/) is loaded.

We again have two different recipes, one for points, one for tangent vectors, where the first one again can be equipped with geodesics between the points.
In the following example we generate 7 points on an ellipse in the [Hyperboloid model](#hyperboloid-model).

```@example poincarehalfplane
using Manifolds, Plots
M = Hyperbolic(2)
pre_pts = [2.0 .* [5.0*cos(φ), sin(φ)] for φ ∈ range(0,2π,length=7)]
pts = convert.(
    Ref(PoincareHalfSpacePoint),
    Manifolds._hyperbolize.(Ref(M), pre_pts)
)
scene = plot(M, pts, geodesic_interpolation = 100)
```

To just plot the points atop, we can just omit the `geodesic_interpolation` parameter to obtain a scatter plot

```@example poincarehalfplane
plot!(scene, M, pts)
```

We can further generate tangent vectors in these spaces and use a plot for there. Keep in mind, that a tangent vector in plotting always requires its base point.
Here we would like to look at the tangent vectors pointing to the `origin`

```@example poincarehalfplane
origin = PoincareHalfSpacePoint([0.0,1.0])
vecs = [log(M,p,origin) for p ∈ pts]
scene = plot!(scene, M, pts, vecs)
```

And we can again look at the corresponding geodesics, for example

```@example poincarehalfplane
plot!(scene, M, [pts[1], origin], geodesic_interpolation=100)
plot!(scene, M, [pts[2], origin], geodesic_interpolation=100)
```

## Literature

```@bibliography
Pages = ["hyperbolic.md"]
Canonical=false
```

# Manifolds

```@docs
Manifolds.Manifolds
```

The implemented manifolds are accompanied by their mathematical formulae.

The manifolds are implemented using the interface for manifolds given in [`ManifoldsBase.jl`](@extref ManifoldsBase :doc:`index`).
You can use that interface to implement your own software on manifolds, such that all manifolds
based on that interface can be used within your code.

For more information, see the [About](misc/about.md) section.

## Getting started

To install the package just type

```julia
using Pkg; Pkg.add("Manifolds")
```

Then you can directly start, for example to stop half way from the north pole on the [`Sphere`](@ref) to a point on the the equator, you can generate the [`shortest_geodesic`](@extref `ManifoldsBase.shortest_geodesic-Tuple{AbstractManifold, Any, Any}`).
It internally employs [`log`](@ref log(::Sphere,::Any,::Any)) and [`exp`](@ref exp(::Sphere,::Any,::Any)).

```@example
using Manifolds
M = Sphere(2)
γ = shortest_geodesic(M, [0., 0., 1.], [0., 1., 0.])
γ(0.5)
```

## Citation

If you use `Manifolds.jl` in your work, please cite the following

```biblatex
@online{2106.08777,
    Author = {Seth D. Axen and Mateusz Baran and Ronny Bergmann and Krzysztof Rzecki},
    Title = {Manifolds.jl: An Extensible Julia Framework for Data Analysis on Manifolds},
    Year = {2021},
    Eprint = {2106.08777},
    Eprinttype = {arXiv},
}
```

To refer to a specific version, it is recommended to cite, for example,

```biblatex
@software{manifoldsjl-zenodo-mostrecent,
  Author = {Seth D. Axen and Mateusz Baran and Ronny Bergmann},
  Title = {Manifolds.jl},
  Doi = {10.5281/ZENODO.4292129},
  Url = {https://zenodo.org/record/4292129},
  Publisher = {Zenodo},
  Year = {2021},
  Copyright = {MIT License}
}
```

for the most recent version or a corresponding version specific DOI, see [the list of all versions](https://zenodo.org/search?page=1&size=20&q=conceptrecid:%224292129%22&sort=-version&all_versions=True).
Note that both citations are in [BibLaTeX](https://ctan.org/pkg/biblatex) format.

# Cholesky space

The Cholesky space is a Riemannian manifold on the lower triangular matrices.
Its metric is based on the cholesky decomposition.
The [`CholeskySpace`](@ref) is used to define the [`LogCholeskyMetric`](@ref) on the manifold of  [`SymmetricPositiveDefinite`](@ref) matrices.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/CholeskySpace.jl"]
Order = [:type]
```

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/CholeskySpace.jl"]
Order = [:function]
```

## Literature

# The Segre manifold

```@docs
Segre
```

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Segre.jl"]
Order = [:function]
```

## [A warped metric](@id segre-warped-metric-sec)

```@docs
WarpedMetric
```

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SegreWarpedMetric.jl"]
Order = [:function]
```


## Literature

```@bibliography
Pages = ["segre.md"]
Canonical=false
```

# A Test suite

The submodule `Manifolds.Test` provides functions to test mathematical properties
of functions defined for a manifold according to the API from `ManifoldsBase.jl`.

```@docs
Manifolds.Test
```

The main function is

```@docs
Manifolds.Test.test_manifold
```

## Functions for individual tests

```@docs
Manifolds.Test.test_copy
Manifolds.Test.test_copyto
Manifolds.Test.test_default_retraction
Manifolds.Test.test_default_inverse_retraction
Manifolds.Test.test_default_vector_transport_method
Manifolds.Test.test_distance
Manifolds.Test.test_exp
Manifolds.Test.test_embed
Manifolds.Test.test_embed_project
Manifolds.Test.test_flat
Manifolds.Test.test_injectivity_radius
Manifolds.Test.test_inner
Manifolds.Test.test_inverse_retract
Manifolds.Test.test_is_default_metric
Manifolds.Test.test_is_flat
Manifolds.Test.test_is_point
Manifolds.Test.test_is_vector
Manifolds.Test.test_geodesic
Manifolds.Test.test_get_basis
Manifolds.Test.test_get_coordinates
Manifolds.Test.test_get_embedding
Manifolds.Test.test_get_vector
Manifolds.Test.test_get_vectors
Manifolds.Test.test_log
Manifolds.Test.test_manifold_dimension
Manifolds.Test.test_manifold_volume
Manifolds.Test.test_mid_point
Manifolds.Test.test_norm
Manifolds.Test.test_parallel_transport
Manifolds.Test.test_project
Manifolds.Test.test_rand
Manifolds.Test.test_repr
Manifolds.Test.test_representation_size
Manifolds.Test.test_retract
Manifolds.Test.test_sectional_curvature
Manifolds.Test.test_sharp
Manifolds.Test.test_shortest_geodesic
Manifolds.Test.test_vector_transport
Manifolds.Test.test_volume_density
Manifolds.Test.test_Weingarten
Manifolds.Test.test_zero_vector
```

## Internals to handle expectations

```@docs
Manifolds.Test.AbstractExpectation
Manifolds.Test.Expect
Manifolds.Test.NoExpectation
Manifolds.Test.expect
Manifolds.Test.isexpected
```

## Former tests

```@docs
Manifolds.find_eps
Manifolds.test_manifold
Manifolds.test_parallel_transport
```

# Differentiation

Documentation for `Manifolds.jl`'s methods and types for finite differences and automatic differentiation.

## Differentiation backends

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/differentiation.jl"]
Order = [:type, :function, :constant]
```

Further differentiation backends and features are available in [`ManifoldDiff.jl`](https://github.com/JuliaManifolds/ManifoldDiff.jl).

### FiniteDifferenes.jl

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/finite_differences.jl"]
Order = [:type, :function, :constant]
```

## Riemannian differentiation backends

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/riemannian_diff.jl"]
Order = [:type, :function, :constant]
```

```@autodocs
Modules = [Manifolds]
Pages = ["differentiation/embedded_diff.jl"]
Order = [:type, :function, :constant]
```

---
title: Working with a metric defined in a chart
---

In this tutorial we will learn how to use charts to solve a basic problems when the metric is defined using `inner` product.

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
using Markdown
```


We start by loading the necessary libraries.

```{julia}
#| output: false
using Manifolds, RecursiveArrayTools, OrdinaryDiffEq, DiffEqCallbacks, CairoMakie

```


We will work with the exterior of a [Schwarzschild black hole](https://en.wikipedia.org/wiki/Schwarzschild_metric) with Schwarzschild radius $r_s$. It is a 4-dimensional manifold represented using vectors of length 4.

```{julia}
struct BlackHoleOutside <: AbstractManifold{ℝ}
    rₛ::Float64
end

struct SchwarzschildAtlas <: AbstractAtlas{ℝ} end

Manifolds.manifold_dimension(::BlackHoleOutside) = 4
Manifolds.representation_size(::BlackHoleOutside) = (4,)

```

To work with this manifold, we need to define a metric. However, we first need to introduce an atlas. For this example let's use an atlas with one chart defined by [Schwarzschild coordinates](https://en.wikipedia.org/wiki/Schwarzschild_coordinates). We also indicate that we will use the Levi-Civita affine connection.

```{julia}
struct SchwarzschildAtlas <: AbstractAtlas{ℝ} end

function Manifolds.get_parameters!(M::BlackHoleOutside, x, ::SchwarzschildAtlas, i, p)
    x[1] = p[1] # t
    r = norm(p[2:4])
    x[2] = r
    x[3] = acos(p[4] / r) # θ
    x[4] = atan(p[3], p[2]) # ϕ
    return x
end

function Manifolds.get_point!(M::BlackHoleOutside, p, ::SchwarzschildAtlas, i, x)
    p[1] = x[1]
    p[2] = x[2] * sin(x[3]) * cos(x[4])
    p[3] = x[2] * sin(x[3]) * sin(x[4])
    p[4] = x[2] * cos(x[3])
    return p
end

function Manifolds.affine_connection!(M::BlackHoleOutside, Zc, A::SchwarzschildAtlas, i, a, Xc, Yc)
    return Manifolds.levi_civita_affine_connection!(M, Zc, A, i, a, Xc, Yc)
end

```

Since we use only one chart, we can switch off chart switching functionality:

```{julia}
Manifolds.check_chart_switch(::BlackHoleOutside, A::SchwarzschildAtlas, i, a) = false
Manifolds.get_chart_index(::BlackHoleOutside, ::SchwarzschildAtlas, p) = nothing
Manifolds.get_chart_index(::BlackHoleOutside, ::SchwarzschildAtlas, i, a) = nothing
```


The metric implemented below is the Schwarzschild metric (signature +, −, −, −, and geometric units $c = G = 1$). In Schwarzschild coordinates at $a=(t, r, \theta, \varphi)$ the inner product of two tangent vectors at point with parameters $a$ with coordinates $X_c$, $Y_c$ is

```math
g_a(X_c, Y_c) = X_c^{\top}\operatorname{diag}\!\left(1-\frac{r_s}{r},\; -\frac{1}{1-r_s/r},\; -r^2,\; -r^2\sin^2\theta\right) Y_c.
```

where $r_s$ is the Schwarzschild radius and the coordinates of two tangent vectors are given in the basis ∂/∂t, ∂/∂r, ∂/∂θ, ∂/∂φ.
The method `inner` in this tutorial computes the inner product of two tangent vectors expressed in the chart coordinate basis.

```{julia}
function Manifolds.inner(M::BlackHoleOutside, ::SchwarzschildAtlas, i, a, Xc, Yc)
    t, r, θ, ϕ = a
    r_block = (1 - M.rₛ / r)
    return Xc[1] * r_block * Yc[1] - Xc[2] * Yc[2] / r_block - r^2 * (Xc[3] * Yc[3] + (sin(θ)^2) * Xc[4] * Yc[4])
end
```

And this is enough to compute geodesics:

```{julia}
M = BlackHoleOutside(1.0)
p0 = [0.0, 10.0, 0.0, 0.0]

A = SchwarzschildAtlas()
i = nothing

X0 =  [1.0, 0.0, 0.18, 0.0]
a_p0 = get_parameters(M, A, i, p0)
B = induced_basis(M, A, a_p0)
c_X0 = get_coordinates(M, p0, X0, B)
final_time = 5000.0
sol = Manifolds.solve_chart_exp_ode(M, a_p0, c_X0, A, i; final_time=final_time, solver=Tsit5())

sampled_solution = sol(range(0.0, final_time; length=20000));
```

We can also calculate the [Kretschmann scalar](https://en.wikipedia.org/wiki/Kretschmann_scalar) and display the trajectory. Value of the Kretschmann scalar corresponds to background color.

```{julia}
x_min = -12.0
x_max = 12.0
y_min = -12.0
y_max = 12.0

# sampling Kretschmann scalar
ks_samples = 300
ks_x = range(x_min, x_max; length=ks_samples)
ks_y = range(y_min, y_max; length=ks_samples)
function get_ks(a_x, a_y)
    if a_x^2 + a_y^2 > M.rₛ^2
        return Manifolds.kretschmann_scalar(M, A, i, get_parameters(M, A, i, [0.0, a_x, a_y, 0.0]))
    else
        # the curvature gets very high inside, so we skip computing it
        return 0.0
    end
end

ks_vals = [log.(get_ks(a_x, a_y)) for a_x in ks_x, a_y in ks_y]

# plotting
x_values = [s[1][2] for s in sampled_solution]
y_values = [s[1][3] for s in sampled_solution]

fig = Figure(; size=(800, 800))
ax = Axis(fig[1, 1]; title="2D Plot of Sampled Solution", xlabel="x", ylabel="y", aspect = AxisAspect(1))

xlims!(ax, x_min, x_max)
ylims!(ax, y_min, y_max)
hm = heatmap!(ax, ks_x, ks_y, ks_vals; colormap=:viridis)

Colorbar(fig[:, end+1], hm, label="log(Kretschmann scalar)")

begin
    # filled polygon representing the black hole
    θ = range(0, 2π, length=400)
    xs = cos.(θ) .* M.rₛ
    ys = sin.(θ) .* M.rₛ
    poly!(ax, xs, ys, color = :black)
end

lines!(ax, x_values, y_values, color=:white, label="trajectory")

axislegend(ax)
fig
```

Below is a pre-recorded animation:

![](black_hole_orbit.mp4)

# [Symmetric positive definite matrices](@id SymmetricPositiveDefiniteSection)

```@docs
SymmetricPositiveDefinite
```

This manifold can -- for example -- be illustrated as ellipsoids:  since the eigenvalues are all positive they can be taken as lengths of the axes of an ellipsoids while the directions are given by the eigenvectors.

![An example set of data](../assets/images/SPDSignal.png)

The manifold can be equipped with different metrics

## Common and metric independent functions

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/SymmetricPositiveDefinite.jl"]
Order = [:function]
Public=true
Private=false
Filter = t -> t !== mean
```

## Default metric: the affine invariant metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteAffineInvariant.jl"]
Order = [:type]
```

This metric is also the default metric, i.e. any call of the following functions with `P=SymmetricPositiveDefinite(3)` will result in `MetricManifold(P,AffineInvariantMetric())`and hence yield the formulae described in this section.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteAffineInvariant.jl"]
Order = [:function]
```

## [Bures-Wasserstein metric](@id BuresWassersteinMetricSection)

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteBuresWasserstein.jl"]
Order = [:type, :function]
```

## Generalized Bures-Wasserstein metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteGeneralizedBuresWasserstein.jl"]
Order = [:type, :function]
```

## Log-Euclidean metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteLogEuclidean.jl"]
Order = [:type, :function]
```

## Log-Cholesky metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymmetricPositiveDefiniteLogCholesky.jl"]
Order = [:type, :function]
```

## Statistics

```@autodocs
Modules = [Manifolds]
Pages   = ["SymmetricPositiveDefinite.jl"]
Order = [:function]
Filter = t -> t === mean
```

## Efficient representation

When a point `p` is used in several occasions, it might be beneficial to store the eigenvalues
and vectors of `p` and optionally its square root and the inverse of the square root.
The [`SPDPoint`](@ref) can be used for exactly that.

```@docs
SPDPoint
```

and there are three internal functions to be able to use [`SPDPoint`](@ref) interchangeably
with the default representation as a matrix.

```@docs
Manifolds.spd_sqrt
Manifolds.spd_sqrt_inv
Manifolds.spd_sqrt_and_sqrt_inv
```

## Literature

# Contributing to `Manifolds.jl`

First, thanks for taking the time to contribute.
Any contribution is appreciated and welcome.

The following is a set of guidelines to [`Manifolds.jl`](https://juliamanifolds.github.io/Manifolds.jl/).

#### Table of contents

* [Contributing to `Manifolds.jl`](#contributing-to-manifoldsjl)
  * [Table of Contents](#table-of-contents)
  * [How to ask a question](#how-to-ask-a-question)
  * [How to file an issue](#How-to-file-an-issue)
  * [How to contribute](#How-to-contribute)
    * [Add a missing method](#add-a-missing-method)
    * [Provide a new manifold](#provide-a-new-manifold)
  * [Code style](#Code-style)

## How to ask a question

You can most easily reach the developers in the Julia Slack channel [#manifolds](https://julialang.slack.com/archives/CP4QF0K5Z).
You can apply for the Julia Slack workspace [here](https://julialang.org/slack/) if you haven't joined yet.
You can also ask your question on [discourse.julialang.org](https://discourse.julialang.org).

## How to file an issue

If you found a bug or want to propose a feature, issues are tracked within the [GitHub repository](https://github.com/JuliaManifolds/Manifolds.jl/issues).

## How to contribute

### Overview of resources

* [`ManifoldsBase.jl`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/) documents the [main design principles](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/design/) for Riemannian manifolds in the [`JuliaManifolds`](https://github.com/JuliaManifolds) ecosystem
* The [main set of functions](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions/) serves as a guide, showing which functions the Library of manifolds in `Manifolds.jl` provides.
* A [tutorial on how to define a manifold](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/tutorials/define-a-manifold/) serves as a starting point on how to introduce a new manifold
* The [changelog](https://juliamanifolds.github.io/Manifolds.jl/stable/misc/NEWS.html) documents all additions and changes. The corresponding file to edit is the [NEWS.md](https://github.com/JuliaManifolds/Manifolds.jl/blob/master/NEWS.md)
* This file `CONTRIBUTING.md`  provides a technical introduction to contributing to `Manifolds.jl`

### Add a missing method

Within `Manifolds.jl`, there might be manifolds, that are only partially define the list of methods from the interface given in [`ManifoldsBase.jl`](https://juliamanifolds.github.io/ManifoldsBase.jl/).
If you notice a missing method but are aware of an algorithm or theory about it,
contributing the method is welcome.
Even just the smallest function is a good contribution.

### Provide a new manifold

A main contribution you can provide is another manifold that is not yet included in the
package.
A manifold is a concrete subtype of [`AbstractManifold`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/types.html#ManifoldsBase.AbstractManifold) from [`ManifoldsBase.jl`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/types.html#The-Manifold-interface).
A [tutorial on how to define a manifold](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/tutorials/implement-a-manifold/) helps to get started on a new manifold.
Every new manifold is welcome, even if you only add a few functions,
for example when your use case for now does not require more features.

One important detail is that the interface provides an in-place as well as a non-mutating variant
See for example [exp!](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#ManifoldsBase.exp!-Tuple{AbstractManifold, Any, Any, Any}) and [exp](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#Base.exp-Tuple{AbstractManifold, Any, Any}).
The non-mutating one, `exp`, always falls back to allocating the according memory,
here a point on the manifold, to then call the in-place variant.
This way it suffices to provide the in-place variant, `exp!`.
The allocating variant only needs to defined if a more efficient version
than the default is available.

Note that since the first argument is _always_ the [`AbstractManifold`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/types.html#ManifoldsBase.AbstractManifold), the mutated argument is always the second one in the signature.
In the example there are `exp(M, p, X)` for the exponential map that allocates
its result `q`, and `exp!(M, q, p, X)` for the in-place one, which computes and returns the `q`.

Since a user probably looks for the documentation on the allocating variant,
we recommend to attach the documentation string to this variant, mentioning all
possible function signatures including the mutating one.
You can best achieve this by adding a documentation string to the method with a general signature with the first argument being your manifold:

```julia
struct MyManifold <: AbstractManifold end

@doc """
    exp(M::MyManifold, p, X)
    exp!(M::MyManifold, q, p, X)

Describe the function, its input and output as well as a mathematical formula.
"""
exp(::MyManifold, ::Any, ::Any)
```

You can also save the string to a variable, for example `_doc_myM_exp` and attach it to both functions

## Code style

Please follow the [documentation guidelines](https://docs.julialang.org/en/v1/manual/documentation/) from the Julia documentation and use [Runic.jl](https://github.com/fredrikekre/Runic.jl) for code formatting.

Please consider a few internal conventions:


* Please include a description of the manifold and a reference to the general theory in the `struct` of your manifold that inherits from `AbstractManifold`'.
* Include the mathematical formulae for any implemented function if a closed form exists.
* Within the source code of one manifold, the `struct` the manifold should be the first element of the file.
* an alphabetical order of functions in every file is preferable.
* The preceding implies that the mutating variant of a function follows the non-mutating variant.
* There should be no dangling `=` signs.
* Always add a newline between things of different types (`struct`/method/const).
* Always add a newline between methods for different functions (including allocating and in-place variants).
* Prefer to have no newline between methods for the same function; when reasonable, merge the documentation string.
* Always document all input variables and keyword arguments
* if possible provide both mathematical formulae and literature references using [DocumenterCitations.jl](https://juliadocs.org/DocumenterCitations.jl/stable/) and BibTeX where possible
* All `import`/`using`/`include` should be in the main module file.

# Shape spaces

Shape spaces are spaces of ``k`` points in ``ℝ^n`` up to simultaneous action of a group on all points.
The most commonly encountered are Kendall's pre-shape and shape spaces.
In the case of the Kendall's pre-shape spaces the action is translation and scaling.
In the case of the Kendall's shape spaces the action is translation, scaling and rotation.

```@example
using Manifolds, Plots

M = KendallsShapeSpace(2, 3)
# two random point on the shape space
p = [
    0.4385117672460505 -0.6877826444042382 0.24927087715818771
    -0.3830259932279294 0.35347460720654283 0.029551386021386548
]
q = [
    -0.42693314765896473 -0.3268567431952937 0.7537898908542584
    0.3054740561061169 -0.18962848284149897 -0.11584557326461796
]
# let's plot them as triples of points on a plane
fig = scatter(p[1,:], p[2,:], label="p", aspect_ratio=:equal)
scatter!(fig, q[1,:], q[2,:], label="q")
```

A more extensive usage example is available in the `hand_gestures.jl` tutorial.

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/KendallsPreShapeSpace.jl"]
Order = [:type]
```

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/KendallsShapeSpace.jl"]
Order = [:type]
```

## Provided functions

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/KendallsPreShapeSpace.jl"]
Order = [:function]
```

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/KendallsShapeSpace.jl"]
Order = [:function]
```

## Literature

```@bibliography
Pages = ["shapespace.md"]
Canonical=false
```

# Orthogonal and Unitary matrices

Both [`OrthogonalMatrices`](@ref) and [`UnitaryMatrices`](@ref) have similar formulae and implementations, as are [`Rotations`](@ref), as well as unitary matrices with determinant equal to one. These share a [common implementation](@ref Manifolds.GeneralUnitaryMatrices).

## Orthogonal matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Orthogonal.jl"]
Order = [:constant, :type, :function]
```

## Unitary matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Unitary.jl"]
Order = [:constant, :type, :function]
```

## Special Unitary matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SpecialUnitary.jl"]
Order = [:constant, :type, :function]
```

## [Common functions](@id generalunitarymatrices)

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/GeneralUnitaryMatrices.jl"]
Order = [:constant, :type, :function]
```
## Footnotes and References

# Graph manifold

For a given graph ``G(V,E)`` implemented using [`Graphs.jl`](https://juliagraphs.github.io/Graphs.jl/latest/), the [`GraphManifold`](@ref) models a [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) either on the nodes or edges of the graph, depending on the [`GraphManifoldType`](@ref).
i.e., it's either a ``\mathcal M^{\lvert V \rvert}`` for the case of a vertex manifold or a ``\mathcal M^{\lvert E \rvert}`` for the case of a edge manifold.

## Example

To make a graph manifold over ``ℝ^2`` with three vertices and two edges, one can use

```@example
using Manifolds
using Graphs
M = Euclidean(2)
p = [[1., 4.], [2., 5.], [3., 6.]]
q = [[4., 5.], [6., 7.], [8., 9.]]
x = [[6., 5.], [4., 3.], [2., 8.]]
G = SimpleGraph(3)
add_edge!(G, 1, 2)
add_edge!(G, 2, 3)
N = GraphManifold(G, M, VertexManifold())
```

It supports all [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  operations (it is based on [`NestedPowerRepresentation`](@extref `ManifoldsBase.NestedPowerRepresentation`)) and furthermore it is possible to compute a graph logarithm:

```@setup graph-1
using Manifolds
using Graphs
M = Euclidean(2)
p = [[1., 4.], [2., 5.], [3., 6.]]
q = [[4., 5.], [6., 7.], [8., 9.]]
x = [[6., 5.], [4., 3.], [2., 8.]]
G = SimpleGraph(3)
add_edge!(G, 1, 2)
add_edge!(G, 2, 3)
N = GraphManifold(G, M, VertexManifold())
```
```@example graph-1
incident_log(N, p)
```

## Types and functions

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/GraphManifold.jl"]
Order = [:type, :function]
```

# (Real) Symplectic Grassmann

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymplecticGrassmann.jl"]
Order = [:type, :function]
```

## The (default) symplectic Stiefel representation

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymplecticGrassmannStiefel.jl"]
Order = [:type, :function]
```

## The symplectic projector representation

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymplecticGrassmannProjector.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["symplecticgrassmann.md"]
Canonical=false
```

# [Atlases and charts](@id atlases_and_charts)

Atlases on an ``n``-dimensional manifold ``\mathcal M``are collections of charts ``\mathcal A = \{(U_i, φ_i) \colon i \in I\}``, where ``I`` is a (finite or infinite) index family, such that ``U_i \subseteq \mathcal M`` is an open set and each chart ``φ_i: U_i → ℝ^n`` is a homeomorphism. This means, that ``φ_i`` is bijective – sometimes also called one-to-one and onto - and continuous, and its inverse ``φ_i^{-1}`` is continuous as well.
The inverse ``φ_i^{-1}`` is called (local) parametrization.
The resulting _parameters_ ``a=φ(p)`` of ``p`` (with respect to the chart ``φ``) are in the literature also called “(local) coordinates”. To distinguish the parameter ``a`` from  [`get_coordinates`](@ref) in a basis, we use the terminology parameter in this package.

For an atlas ``\mathcal A`` we further require that

```math
\displaystyle\bigcup_{i\in I} U_i = \mathcal M.
```

We say that ``φ_i`` is a chart about ``p``, if ``p\in U_i``.
An atlas provides a connection between a manifold and the Euclidean space ``ℝ^n``, since
locally, a chart about ``p`` can be used to identify its neighborhood (as long as you stay in ``U_i``) with a subset of a Euclidean space.
Most manifolds we consider are smooth, i.e. any change of charts ``φ_i \circ φ_j^{-1}: ℝ^n → ℝ^n``, where ``i,j\in I``, is a smooth function. These changes of charts are also called transition maps.

Most operations on manifolds in `Manifolds.jl` avoid operating in a chart through appropriate embeddings and formulas derived for particular manifolds, though atlases provide the most general way of working with manifolds.
Compared to these approaches, using an atlas is often more technical and time-consuming.
They are extensively used in metric-related functions on [`MetricManifold`](@extref ManifoldsBase.MetricManifold)s.

Atlases are represented by objects of subtypes of [`AbstractAtlas`](@ref Main.Manifolds.AbstractAtlas).
There are no type restrictions for indices of charts in atlases.

Operations using atlases and charts are available through the following functions:

* [`get_chart_index`](@ref Main.Manifolds.get_chart_index) can be used to select an appropriate chart for the neighborhood of a given point ``p``. This function should work deterministically, i.e. for a fixed ``p`` always return the same chart.
* [`get_parameters`](@ref Main.Manifolds.get_parameters) converts a point to its parameters with respect to the chart in a chart.
* [`get_point`](@ref Main.Manifolds.get_point) converts parameters (local coordinates) in a chart to the point that corresponds to them.
* [`induced_basis`](@ref Main.Manifolds.induced_basis) returns a basis of a given vector space at a point induced by a chart ``φ``.
* [`transition_map`](@ref Main.Manifolds.transition_map) converts coordinates of a point between two charts, e.g. computes ``φ_i\circ φ_j^{-1}: ℝ^n → ℝ^n``, ``i,j\in I``.

While an atlas could store charts as explicit functions, it is favourable, that the [`get_parameters`] actually implements a chart ``φ``, [`get_point`](@ref) its inverse, the prametrization ``φ^{-1}``.

```@autodocs
Modules = [Manifolds,ManifoldsBase]
Pages = ["atlases.jl"]
Order = [:type, :function]
```

## Cotangent space and musical isomorphisms

Related to atlases, there is also support for the cotangent space and coefficients of cotangent vectors in bases of the cotangent space.

Functions [`sharp`](@ref) and [`flat`](@ref) implement musical isomorphisms for arbitrary vector bundles.

```@autodocs
Modules = [Manifolds,ManifoldsBase]
Pages = ["cotangent_space.jl"]
Order = [:type, :function]
```

## Computations in charts

```@docs
Manifolds.IntegratorTerminatorNearChartBoundary
Manifolds.estimate_distance_from_bvp
Manifolds.solve_chart_exp_ode
Manifolds.solve_chart_log_bvp
Manifolds.solve_chart_parallel_transport_ode
```

# (Real) Symplectic Stiefel

The [`SymplecticStiefel`](@ref) manifold, denoted ``\operatorname{SpSt}(2n, 2k)``,
represents canonical symplectic bases of ``2k`` dimensonal symplectic subspaces of ``ℝ^{2n×2n}``.
This means that the columns of each element ``p \in \operatorname{SpSt}(2n, 2k) \subset ℝ^{2n×2k}``
constitute a canonical symplectic basis of ``\operatorname{span}(p)``.
The canonical symplectic form is a non-degenerate, bilinear, and skew symmetric map
``\omega_{2k}\colon 𝔽^{2k}×𝔽^{2k} → 𝔽``, given by
``\omega_{2k}(x, y) = x^T Q_{2k} y`` for elements ``x, y \in 𝔽^{2k}``, with

````math
    Q_{2k} =
    \begin{bmatrix}
     0_k  &  I_k \\
    -I_k  &  0_k
    \end{bmatrix}.
````

Specifically given an element ``p \in \operatorname{SpSt}(2n, 2k)`` we require that

````math
    \omega_{2n} (p x, p y) = x^T(p^TQ_{2n}p)y = x^TQ_{2k}y = \omega_{2k}(x, y) \;\forall\; x, y \in 𝔽^{2k},
````

leading to the requirement on ``p`` that ``p^TQ_{2n}p = Q_{2k}``.
In the case that ``k = n``, this manifold reduces to the [`SymplecticMatrices`](@ref) manifold, which is also known as the symplectic group.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SymplecticStiefel.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["symplecticstiefel.md"]
Canonical=false
```

---
title: 🚀 Get Started with `Manifolds.jl`
---

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
Pkg.develop(path="../") # a trick to work on the local dev version
using Markdown
```

This is a short overview of [`Manifolds.jl`](https://juliamanifolds.github.io/Manifolds.jl/) and how to get started working with your first Manifold.
we first need to install the package, using for example

```{julia}
#| eval: false
using Pkg; Pkg.add("Manifolds")
```

Then you can load the package with

```{julia}
using Manifolds
```

## Using the Library of Manifolds

`Manifolds.jl` is first of all a library of manifolds, see the list in the menu [here](https://juliamanifolds.github.io/Manifolds.jl/latest/) under “basic manifolds”.

Let's look at three examples together with the first few functions on manifolds.

#### 1. [The Euclidean space](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/euclidean.html)

The Euclidean Space ``[Euclidean](@ref EuclideanSection)``{=commonmark} brings us (back) into linear case of vectors, so in terms of manifolds, this is a very simple one. It is often useful to compare to classical algorithms, or implementations.

```{julia}
M₁ = Euclidean(3)
```

Since a manifold is a type in Julia, we write it in CamelCase. Its parameters are first a dimension or size parameter of the manifold, sometimes optional is a field the manifold is defined over.

For example the above definition is the same as the real-valued case

```{julia}
M₁ === Euclidean(3, field=ℝ)
```

But we even introduced a short hand notation, since ℝ is also just a symbol/variable to use"

```{julia}
M₁ === ℝ^3
```

And similarly here are two ways to create the manifold of vectors of length two with complex entries – or mathematically the space $\mathbb C^2$

```{julia}
Euclidean(2, field=ℂ) === ℂ^2
```

The easiest to check is the dimension of a manifold. Here we have three “directions to walk into” at every point $p\in \mathbb R
^3$ so ``[`manifold_dimension`](@extref `ManifoldsBase.manifold_dimension-Tuple{AbstractManifold}`)``{=commonmark} is

```{julia}
manifold_dimension(M₁)
```

#### 2. ``[The hyperbolic space](@ref HyperbolicSpace)``{=commonmark}

The $d$-dimensional ``[hyperbolic space](@ref HyperbolicSpace)``{=commonmark} is usually represented in $\mathbb R^{d+1}$ as the set of points $p\in\mathbb R^3$ fulfilling

```math
p_1^2+p_2^2+⋅s+p_d^2-p_{d+1}^2 = -1.
```

We define the manifold using

```{julia}
M₂ = Hyperbolic(2)
```

And we can again just start with looking at the manifold dimension of `M₂`


```{julia}
manifold_dimension(M₂)
```

A next useful function is to check, whether some $p∈\mathbb R^3$ is a point on the manifold `M₂`. We can check

```{julia}
is_point(M₂, [0, 0, 1])
```

or

```{julia}
is_point(M₂, [1, 0, 1])
```

Keyword arguments are passed on to any numerical checks, for example an absolute tolerance when checking the above equality.

But in an interactive session an error message might be helpful. A positional (third) argument is present to activate this. Setting this parameter to true, we obtain an error message that gives insight into why the point is not a point on `M₂`.
Note that the `LoadError:` is due to quarto, on `REPL` you would just get the `DomainError`.

```{julia}
#| error: true
is_point(M₂, [0, 0, 1.001]; error=:error)
```

#### 3. ``[The sphere](@ref SphereSection)``{=commonmark}

``[The sphere](@ref SphereSection)``{=commonmark} $\mathbb S^d$ is the $d$-dimensional sphere represented in its embedded form, that is unit vectors $p \in \mathbb R^{d+1}$ with unit norm $\lVert p \rVert_2 = 1$.

```{julia}
M₃ = Sphere(2)
```

If we only have a point that is approximately on the manifold, we can allow for a tolerance. Usually these are the same values of `atol` and `rtol` allowed in `isapprox`,
i.e. we get

```{julia}
is_point(M₃, [0, 0, 1.001]; atol=1e-3)
```

Here we can show a last nice check: ``[`is_vector`](@extref `ManifoldsBase.is_vector-Tuple{AbstractManifold, Any, Any, Bool, Bool}`)``{=commonmark} to check whether a tangent vector `X` is a representation of a tangent vector $X∈T_p\mathcal M$ to a point `p` on the manifold.

This function has two positional arguments, the first to again indicate whether to throw an error, the second to disable the check that `p` is a valid point on the manifold. Usually this validity is essential for the tangent check, but if it was for example performed before, it can be turned off to spare time.

For example in our first example the point is not of unit norm

```{julia}
is_vector(M₃, [2, 0, 0], [0, 1, 1])
```

But the orthogonality of `p` and `X` is still valid, we can disable the point check,
but even setting the error to true we get here

```{julia}
is_vector(M₃, [2, 0, 0], [0, 1, 1], true, false)
```

But of course it is better to use a valid point in the first place

```{julia}
is_vector(M₃, [1, 0, 0], [0, 1, 1])
```

and for these we again get informative error messages

```{julia}
#| error: true
@expect_error is_vector(M₃, [1, 0, 0], [0.1, 1, 1]; error=:error) DomainError
```

To learn about how to define a manifold yourself check out the ``[How to define your own manifold](@extref ManifoldsBase :doc:`tutorials/implement-a-manifold`)``{=commonmark} tutorial of ``[`ManifoldsBase.jl`](@extref ManifoldsBase :doc:`index`)``{=commonmark}."

### Building more advanced manifolds

Based on these basic manifolds we can directly build more advanced manifolds.

The first one concerns vectors or matrices of data on a manifold, the ``[PowerManifold](@ref PowerManifoldSection)``{=commonmark}.

```{julia}
M₄ = M₂^2
```

Then points are represented by arrays, where the power manifold dimension is added in the end. In other words – for the hyperbolic manifold here, we have a matrix with 2 columns, where each column is a valid point on hyperbolic space.

```{julia}
p = [0 0; 0 1; 1 sqrt(2)]
```

```{julia}
[is_point(M₂, p[:, 1]), is_point(M₂, p[:, 2])]
```

But of course the method we used previously also works for power manifolds:

```{julia}
is_point(M₄, p)
```

Note that nested power manifolds are combined into one as in

```{julia}
M₄₂ = M₄^4
```

which represents $2×4$ – matrices of hyperbolic points represented in $3×2×4$ arrays.

We can – alternatively – use a power manifold with nested arrays

```{julia}
M₅ = PowerManifold(M₃, NestedPowerRepresentation(), 2)
```

which emphasizes that we have vectors of length 2 that contain points, so we store them that way.

```{julia}
p₂ = [[0.0, 0.0, 1.0], [0.0, 1.0, 0.0]]
```

To unify both representations, elements of the power manifold can also be accessed in the classical indexing fashion, if we start with the corresponding manifold first. This way one can implement algorithms also independent of which representation is used."

```{julia}
p[M₄, 1]
```

```{julia}
p₂[M₅, 2]
```

Another constructor is the ``[ProductManifold](@ref ProductManifoldSection)``{=commonmark} to combine different manifolds.
Here of course the order matters. First we construct these using $×$

```{julia}
M₆ = M₂ × M₃
```

Since now the representations might differ from element to element, we have to encapsulate these in their own type.

```{julia}
using RecursiveArrayTools: ArrayPartition
p₃ = ArrayPartition([0, 0, 1], [0, 1, 0])
```

Here `ArrayPartition` taken from [`RecursiveArrayTools.jl`](https://github.com/SciML/RecursiveArrayTools.jl) to store the point on the product manifold efficiently in one array, still allowing efficient access to the product elements.

```{julia}
is_point(M₆, p₃; error=:error)
```

But accessing single components still works the same."

```{julia}
p₃[M₆, 1]
```

Finally, also the ``[`TangentBundle`](@ref)``{=commonmark}, the manifold collecting all tangent spaces on a manifold is available as"

```{julia}
M₇ = TangentBundle(M₃)
```

## Implementing generic Functions

In this section we take a look how to implement generic functions on manifolds.

For our example here, we want to implement the so-called [Bézier curve](https://en.wikipedia.org
/wiki/Bézier_curve) using the so-called [de-Casteljau algorithm](https://en.wikipedia.org/wiki/De_Casteljau%27s_algorithm).
The linked algorithm can easily be generalised to manifolds by replacing lines with geodesics. This was for example used in [BergmannGousenbourger:2018](@cite) and the following example is an extended version of an example from [AxenBaranBergmannRzecki:2023](@cite).

The algorithm works recursively. For the case that we have a Bézier curve with just two points, the algorithm just evaluates the geodesic connecting both at some time point $t∈[0,1]$. The function to evaluate a shortest geodesic (it might not be unique, but then a deterministic choice is taken) between two points `p` and `q` on a manifold `M` ``[`shortest_geodesic(M, p, q, t)`](@extref `ManifoldsBase.shortest_geodesic-Tuple{AbstractManifold, Any, Any}`)``{=commonmark}.


```{julia}
function de_Casteljau(M::AbstractManifold, t, pts::NTuple{2})
    return shortest_geodesic(M, pts[1], pts[2], t)
end
```

```{julia}
function de_Casteljau(M::AbstractManifold, t, pts::NTuple)
    p = de_Casteljau(M, t, pts[1:(end - 1)])
    q = de_Casteljau(M, t, pts[2:end])
    return shortest_geodesic(M, p, q, t)
end
```

Which can now be used on any manifold where the shortest geodesic is implemented

Now on several manifolds the [exponential map](https://en.wikipedia.org/wiki/Exponential_map_(Riemannian_geometry)) and its (locally defined) inverse, the logarithmic map might not be available in an implementation. So one way to generalise this, is the use of a retraction (see  [AbsilMahonySepulchre:2008](@cite), Def. 4.1.1 for details) and its (local) inverse.

The function itself is quite similar to the exponential map, just that ``[`retract(M, p, X, m)`](@extref `ManifoldsBase.retract`)``{=commonmark} has one further parameter, the type of retraction to take, so `m` is a subtype of ``[`AbstractRetractionMethod`](@extref `ManifoldsBase.AbstractRetractionMethod`)``{=commoonmark} `m`, the same for the ``[`inverse_retract(M, p, q, n)`](@extref `ManifoldsBase.inverse_retract`)``{=commonmark} with an ``[`AbstractInverseRetractionMethod`](@extref `ManifoldsBase.AbstractInverseRetractionMethod`)``{=commonmark} `n`.

Thinking of a generic implementation, we would like to have a way to specify one, that is available. This can be done by using ``[`default_retraction_method`](@extref `ManifoldsBase.default_retraction_method-Tuple{AbstractManifold}`)``{=commonmark} and ``[`default_inverse_retraction_method`](@extref `ManifoldsBase.default_inverse_retraction_method-Tuple{AbstractManifold}`)``{=commonmark}, respectively. We implement


```{julia}
function generic_de_Casteljau(
    M::AbstractManifold,
    t,
    pts::NTuple{2};
    m::AbstractRetractionMethod=default_retraction_method(M),
    n::AbstractInverseRetractionMethod=default_inverse_retraction_method(M),
)
    X = inverse_retract(M, pts[1], pts[2], n)
    return retract(M, pts[1], X, t, m)
end
```

and for the recursion

```{julia}
function generic_de_Casteljau(
    M::AbstractManifold,
    t,
    pts::NTuple;
    m::AbstractRetractionMethod=default_retraction_method(M),
    n::AbstractInverseRetractionMethod=default_inverse_retraction_method(M),
)
    p = generic_de_Casteljau(M, t, pts[1:(end - 1)]; m=m, n=n)
    q = generic_de_Casteljau(M, t, pts[2:end]; m=m, n=n)
    X = inverse_retract(M, p, q, n)
    return retract(M, p, X, t, m)
end
```

Note that on a manifold `M` where the exponential map is implemented, the `default_retraction_method(M)` returns ``[`ExponentialRetraction`](@extref ManifoldsBase.ExponentialRetraction)``{=commonmark}, which yields that the `retract` function falls back to calling `exp`.

The same mechanism exists for ``[`parallel_transport_to(M, p, X, q)`](@extref `ManifoldsBase.parallel_transport_to-Tuple{AbstractManifold, Any, Any, Any}`)``{=commonmark} and the more general ``[`vector_transport_to(M, p, X, q, m)`](@extref `ManifoldsBase.vector_transport_to`)``{=commonmark} whose ``[`AbstractVectorTransportMethod`](@extref `ManifoldsBase.AbstractVectorTransportMethod`)``{=commonmark} `m` has a default defined by ``[`default_vector_transport_method(M)`](@extref `ManifoldsBase.default_vector_transport_method-Tuple{AbstractManifold}`)``{=commonmark}.

## Allocating and in-place computations

Memory allocation is a [critical performance issue](https://docs.julialang.org/en/v1/manual/performance-tips/#Measure-performance-with-[@time](@ref)-and-pay-attention-to-memory-allocation) when programming in Julia. To take this into account, `Manifolds.jl` provides special functions to reduce the amount of allocations.

We again look at the [exponential map](https://en.wikip edia.org/wiki/Exponential_map_(Riemannian_geometry)). On a manifold `M` the exponential map needs a point `p` (to start from) and a tangent vector `X`, which can be seen as direction to “walk into” as well as the length to walk into this direction. In `Manifolds.jl` the function can then be called with `q = exp(M, p, X)` (see ``[`exp(M, p, X)`](@extref `Base.exp-Tuple{AbstractManifold, Any, Any}`)``{=commonmark}). This function returns the resulting point `q`, which requires to allocate new memory.

To avoid this allocation, the function ``[`exp!(M, q, p, X)`](@extref `ManifoldsBase.exp!-Tuple{AbstractManifold, Any, Any, Any}`)``{=commonmark} can be called. Here `q` is allocated beforehand and is passed as the memory, where the result is returned in.
It might be used even for interims computations, as long as it does not introduce side effects. Thas means that even with `exp!(M, p, p, X)` the result is correct.

Let's look at an example.

We take another look at the [`Sphere`](@ref), but now a high-dimensional one.
We can also illustrate how to generate radnom points and tangent vectors.

```{julia}
#| output: false
M = Sphere(10000)
p₄ = rand(M)
X = rand(M; vector_at=p₄)
```

Looking at the allocations required we get

```{julia}
@allocated exp(M, p₄, X)
```

While if we have already allocated memory for the resulting point on the manifold,
for example

```{julia}
q₂ = zero(p₄);
```

There are no new memory allocations necessary if we use the in-place function."

```{julia}
@allocated exp!(M, q₂, p₄, X)
```


This methodology is used for all functions that compute a new point or tangent vector. By default all allocating functions allocate memory and call the in-place function.
This also means that if you implement a new manifold, you just have to implement the in-place version.

## Decorating a manifold

As you saw until now, an
``[`AbstractManifold`]@extref `ManifoldsBase.AbstractManifold`)``{=commonmark}
describes a Riemannian manifold.
For completeness, this also includes the chosen
[Riemannian metric tensor](https://en.wikipedia.org/wiki/Metric_tensor)
or inner product on the tangent spaces.

In `Manifolds.jl` these are assumed to be a “reasonable default”.
For example on the [`Sphere`](@ref)`(n)` we used above, the default metric is the one inherited from
restricting the inner product from the embedding space onto each tangent space.

Consider a manifold like

```{julia}
M₈ = SymmetricPositiveDefinite(3)
```

which is the manifold of $3×3$ matrices that are ``[symmetric and positive definite](@ref SymmetricPositiveDefiniteSection)``{=commonmark}.
which has a default as well, the affine invariant ``[`AffineInvariantMetric`](@ref)``{=commonmark}, but also has several different metrics.

To switch the metric, we use the idea of a [decorator pattern](https://en.wikipedia.org/wiki/Decorator_pattern) approach. Defining

```{julia}
M₈₂ = MetricManifold(M₈, BuresWassersteinMetric())
```

changes the manifold to use the ``[`BuresWassersteinMetric`](@ref BuresWassersteinMetricSection)``{=commonmark}.

This changes all functions that depend on the metric, most prominently the Riemannian matric, but also the exponential and logarithmic map and hence also geodesics.

All functions that are not dependent on a metric – for example the manifold dimension, the tests of points and vectors we already looked at, but also all retractions – stay unchanged.
This means that for example

```{julia}
[manifold_dimension(M₈₂), manifold_dimension(M₈)]
```

both calls the same underlying function. On the other hand with

```{julia}
p₅, X₅ = one(zeros(3, 3)), [1.0 0.0 1.0; 0.0 1.0 0.0; 1.0 0.0 1.0]
```


but for example the exponential map and the norm yield different results

```{julia}
[exp(M₈, p₅, X₅), exp(M₈₂, p₅, X₅)]
```

```{julia}
[norm(M₈, p₅, X₅), norm(M₈₂, p₅, X₅)]
```


Technically this done using the ``[`MetricManifold`](@extref ManifoldsBase.MetricManifold)``{=commonmark}.

The same approach is used for

* specifying a different ``[connection](@ref ConnectionSection)``{=commonmark}
* specifying a certain ``[embedding](@extref ManifoldsBase The-Manifold-decorator)``{=commonmark}s

Again, for all of these, the concrete types only have to be used if you want to do a second, different from the details, property, for example a second way to embed a manifold. If a manifold is (in its usual representation) an embedded manifold, this works with the default manifold type already, since then it is again set as the reasonable default.

## Literature

````{=commonmark}
```@bibliography
Pages = ["getstarted.md"]
Canonical=false
```
````

# Notation overview

Since manifolds include a reasonable amount of elements and functions, the following list tries to keep an overview of used notation throughout `Manifolds.jl`.
The order is alphabetical by name.
They might be used in a plain form within the code or when referring to that code.
This is for example the case with the calligraphic symbols.

Within the documented functions, the utf8 symbols are used whenever possible, as long as that renders correctly in ``\TeX`` within this documentation.

| Symbol | Description | Also used | Comment |
|:--:|:--------------- |:--:|:-- |
| ``\tau_p`` | action map by group element ``p`` | ``\mathrm{L}_p``, ``\mathrm{R}_p`` | either left or right |
| ``\operatorname{Ad}_p(X)`` | adjoint action of element ``p`` of a Lie group on the element ``X`` of the corresponding Lie algebra | | |
| ``×`` | Cartesian product of two manifolds | | see [`ProductManifold`](@extref `ManifoldsBase.ProductManifold`) |
| ``^{\wedge}`` | (n-ary) Cartesian power of a manifold | | see [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) |
| ``⋅^\mathrm{H}`` | conjugate/Hermitian transpose | | |
| ``a`` | coordinates of a point in a chart | | see [`get_parameters`](@ref) |
| ``\frac{\mathrm{D}}{\mathrm{d}t}`` | covariant derivative of a vector field ``X(t)`` | | |
| ``T^*_p \mathcal M`` | the cotangent space at ``p`` | | |
| ``ξ`` | a cotangent vector from ``T^*_p \mathcal M`` | ``ξ_1, ξ_2,… ,η,\zeta`` | sometimes written with base point ``ξ_p``. |
| ``\mathrm{d}\phi_p(q)`` | Differential of a map ``\phi: \mathcal M → \mathcal N`` with respect to ``p`` at a point ``q``. For functions of multiple variables, for example ``\phi(p, p_1)`` where ``p \in \mathcal M`` and ``p_1 \in \mathcal M_1``, variable ``p`` is explicitly stated to specify with respect to which argument the differential is calculated. | ``\mathrm{d}\phi_q``, ``(\mathrm{d}\phi)_q``, ``(\phi_*)_q``, ``D_p\phi(q)`` | pushes tangent vectors ``X \in T_q \mathcal M`` forward to ``\mathrm{d}\phi_p(q)[X] \in T_{\phi(q)} \mathcal N`` |
| ``n`` | dimension (of a manifold) | ``n_1,n_2,\ldots,m, \dim(\mathcal M)``| for the real dimension sometimes also ``\dim_{\mathbb R}(\mathcal M)``|
| ``d(⋅,⋅)`` | (Riemannian) distance | ``d_{\mathcal M}(⋅,⋅)`` | |
| ``\exp_p X`` | exponential map at ``p \in \mathcal M`` of a vector ``X \in T_p \mathcal M`` | ``\exp_p(X)`` | |
| ``F`` | a fiber | | see [`Fiber`](@extref `ManifoldsBase.Fiber`) |
| ``\mathbb F`` | a field, usually ``\mathbb F \in \{\mathbb R,\mathbb C, \mathbb H\}``, i.e. the real, complex, and quaternion numbers, respectively. | |field a manifold or a basis is based on |
| ``\gamma`` | a geodesic | ``\gamma_{p;q}``, ``\gamma_{p,X}`` | connecting two points ``p,q`` or starting in ``p`` with velocity ``X``. |
| ``\operatorname{grad} f(p)`` | (Riemannian) gradient of function ``f \colon \mathcal{M} → ℝ`` at ``p \in \mathcal{M}`` | | |
| ``\nabla f(p)`` | (Euclidean) gradient of function ``f \colon \mathcal{M} → ℝ`` at ``p \in \mathcal{M}`` but thought of as evaluated in the embedding | `G` | |
| ``\circ`` | a group operation | | |
| ``⋅^\mathrm{H}`` | Hermitian or conjugate transposed for both complex or quaternion matrices| | |
| ``\operatorname{Hess} f(p)`` | (Riemannian) Hessian of function ``f \colon T_p\mathcal{M} → T_p\mathcal M`` (i.e. the 1-1-tensor form) at ``p \in \mathcal{M}`` | | |
| ``\nabla^2 f(p)`` | (Euclidean) Hessian of function ``f`` in the embedding | `H` | |
| ``e`` | identity element of a group | | |
| ``I_k`` | identity matrix of size ``k×k`` | | |
| ``k`` | indices | ``i,j`` | |
| ``\langle⋅,⋅\rangle`` | inner product (in ``T_p \mathcal M``) | ``\langle⋅,⋅\rangle_p, g_p(⋅,⋅)`` | |
| ``\operatorname{retr}^{-1}_pq``|  an inverse retraction | | |
| ``\mathfrak g`` | a Lie algebra | | |
| ``\mathcal{G}`` | a (Lie) group | | |
| ``\log_p q`` | logarithmic map at ``p \in \mathcal M`` of a point ``q \in \mathcal M`` | ``\log_p(q)`` | |
| ``\mathcal M`` | a manifold | ``\mathcal M_1, \mathcal M_2,\ldots,\mathcal N`` | |
| ``N_p \mathcal M`` | the normal space of the tangent space ``T_p \mathcal M`` in some embedding ``\mathcal E`` that should be clear from context | | |
| ``V`` | a normal vector from ``N_p \mathcal M`` | ``W`` | |
| ``\operatorname{Exp}`` | the matrix exponential | | |
| ``\operatorname{Log}`` | the matrix logarithm | | |
| ``\mathcal P_{q\gets p}X`` | parallel transport | | of the vector ``X`` from ``T_p\mathcal M`` to ``T_q\mathcal M`` |
| ``\mathcal P_{p,Y}X`` | parallel transport in direction ``Y`` | | of the vector ``X`` from ``T_p\mathcal M`` to ``T_q\mathcal M``, ``q = \exp_pY`` |
| ``\mathcal P_{t_1\gets t_0}^cX`` | parallel transport along the curve ``c``| ``\mathcal P^cX=\mathcal P_{1\gets 0}^cX`` | of the vector ``X`` from ``p=c(0)`` to ``c(1)`` |
| ``p`` | a point on ``\mathcal M`` | ``p_1, p_2, \ldots,q`` | for 3 points one might use ``x,y,z`` |
| ``\operatorname{retr}_pX``|  a retraction | | |
| ``\kappa_p(X, Y)`` | sectional curvature | | |
| ``ξ`` | a set of tangent vectors | ``\{X_1,\ldots,X_n\}`` | |
| ``J_{2n} \in ℝ^{2n×2n}`` | the [`SymplecticElement`](@ref) | | |
| ``T_p \mathcal M`` | the tangent space at ``p`` | | |
| ``X`` | a tangent vector from ``T_p \mathcal M`` | ``X_1,X_2,\ldots,Y,Z`` | sometimes written with base point ``X_p`` |
| ``\operatorname{tr}`` | trace (of a matrix) | | |
| ``⋅^\mathrm{T}`` | transposed | | |
| ``e_i \in \mathbb R^n`` | the ``i``th unit vector | ``e_i^n`` | the space dimension (``n``) is omitted, when clear from context |
| ``B`` | a vector bundle | | |
| ``\mathcal T_{q\gets p}X`` | vector transport | | of the vector ``X`` from ``T_p\mathcal M`` to ``T_q\mathcal M`` |
| ``\mathcal T_{p,Y}X`` | vector transport in direction ``Y`` | | of the vector ``X`` from ``T_p\mathcal M`` to ``T_q\mathcal M``, where ``q`` is determined by ``Y``, for example using the exponential map or some retraction. |
| ``\operatorname{Vol}(\mathcal M)`` | volume of manifold ``\mathcal M`` | | |
| ``\theta_p(X)`` | volume density for vector ``X`` tangent at point ``p`` | | |
| ``\mathcal W`` | the Weingarten map ``\mathcal W: T_p\mathcal M × N_p\mathcal M → T_p\mathcal M`` | ``\mathcal W_p`` | the second notation to emphasize the dependency of the point ``p\in\mathcal M`` |
| ``0_k`` | the ``k×k`` zero matrix. | | |

## Comparison with notation commonly used in robotics

In robotics, a different notation is commonly used.
The table below shows a quick guide how to translate between them for people coming from robotics background.
We use [SolaDerayAtchuthan:2021](@cite) as the primary robotics source.

| Robotics concept | Manifolds.jl notation |
|:--|:--------------- |
| ``p \circ q`` | `compose(G, p, q)` |
| ``p^{-1}``|  `inv(G, p)` |
| ``\mathcal{E}`` | `Identity(G)` or `identity_element(G)` |
| group action ``p\cdot p_m`` | `apply(A, p, p_m)` |
| Lie group exponential ``\exp\colon \mathfrak{g} \to \mathcal{G}``, ``\exp(X)=p`` | `exp_lie(G, p)` |
| Lie group logarithm ``\log\colon \mathcal{G} \to \mathfrak{g}``, ``\log(p)=X`` | `log_lie(G, X)` |
| ``n``-D vector | `TranslationGroup(n)`;  its action is `TranslationAction(Euclidean(n), TranslationGroup(n))` |
| circle ``S^1`` | `CircleGroup()`; its action is `ComplexPlanarRotation` |
| rotation ``\mathrm{SO}(n)`` | `SpecialOrthogonal(n)`; its action is `RotationAction(Euclidean(n), SpecialOrthogonal(n))` |
| rigid motion ``\mathrm{SE}(n)`` | `SpecialEuclidean(n)`; its action is `RotationTranslationAction(Euclidean(n), SpecialEuclidean(n))` |
| unit quaternions ``S^3`` | `UnitaryMatrices(1, H)`; note that 3-sphere and the group of rotations (with its bi-invariant metric) are homeomorphic but not isomorphic |
| size (as in Table I) | related to `representation_size(G)` |
| dim (as in Table I) | `manifold_dimension(G)` |
| Lie algebra element with coordinates ``\tau^{\wedge}`` | `hat(G, Identity(G), tau)` |
| coordinates of an element of Lie algebra ``X^{\vee}`` | `vee(G, Identity(G), X)` |
| capital exponential map ``\operatorname{Exp}`` | `exp_lie(G, hat(G, Identity(G), tau))` |
| capital logarithmic map ``\operatorname{Log}`` | `vee(G, Identity(G), log_lie(G, p))` |
| right-``\oplus``, ``p \oplus \tau`` | `compose(G, exp_lie(G, hat(G, Identity(G), tau)))` |
| right-``\ominus``, ``p \ominus q`` | `vee(G, Identity(G), log_lie(G, compose(G, inv(G, q), p)))`|
| left-``\oplus``, ``\tau \oplus p`` | `compose(G, exp_lie(G, hat(G, Identity(G), tau)), p)` |
| left-``\ominus``, ``p \ominus q`` | `vee(G, Identity(G), log_lie(G, compose(G, p, inv(G, q))))` |
| adjoint ``\mathrm{Ad}_{p}(\tau^{\wedge})`` | `adjoint_action(G, p, hat(G, Identity(G), tau))` |
| adjoint matrix ``\mathrm{Ad}_{p}`` | `adjoint_matrix(G, p)` |
| Jacobian of group inversion and composition | these can be easily constructed from the adjoint matrix |
| left and right Jacobians of a function | In JuliaManifolds there is always one preferred way to store tangent vectors specified by each manifold, and so we follow the standard mathematical convention of having one Jacobian which follows the selected tangent vector storage convention. See for example `jacobian_exp_argument`, `jacobian_exp_basepoint`, `jacobian_log_argument`, `jacobian_log_basepoint` from `ManifoldDiff.jl`. |
| left and right Jacobians (of a group) ``\mathbf{J}_l, \mathbf{J}_r`` | `jacobian_exp_argument` for exponential coordinates. For other coordinate systems no replacement is available yet. |
| Jacobians of group actions | not available yet |

Be also careful that the meaning of ``\mathbf{x}`` is inconsistent in Table I from [SolaDerayAtchuthan:2021](@cite). It's a complex number for circle, quaternion for quaternion rotation and column vectors for other rows.

# Multinomial matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Multinomial.jl"]
Order = [:type]
```

## Functions

Most functions are directly implemented for an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  with [`ArrayPowerRepresentation`](@ref) except the following special cases:

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Multinomial.jl"]
Order = [:function]
```

# [Product manifold](@id ProductManifoldSection)

Product manifold ``\mathcal M = \mathcal{M}_1 × \mathcal{M}_2 × … × \mathcal{M}_n`` of manifolds ``\mathcal{M}_1, \mathcal{M}_2, …, \mathcal{M}_n``.
Points on the product manifold can be constructed using `ArrayPartition` (from `RecursiveArrayTools.jl`) with canonical projections ``Π_i : \mathcal{M} → \mathcal{M}_i`` for ``i ∈ 1, 2, …, n`` provided by [`submanifold_component`](@extref `ManifoldsBase.submanifold_component-Tuple`).

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/ProductManifold.jl"]
Order = [:type, :function]
```

# Literature

We are slowly moving to using [`DocumenterCitations.jl`](https://github.com/JuliaDocs/DocumenterCitations.jl/).
The goal is to have all references used / mentioned in the documentation of Manifolds.jl also listed here.
If you notice a reference still defined in a footnote, please change it into a BibTeX reference and [open a PR](https://github.com/JuliaManifolds/Manifolds.jl/compare)

Usually you will find a small reference section at the end of every documentation page that contains references for just that page.

```@bibliography
```

# [Tucker manifold](@id Tucker)


```@autodocs
Modules = [Manifolds]
Pages = ["Tucker.jl"]
Order = [:type]
```

## Functions
```@autodocs
Modules = [Manifolds]
Private = false
Public = true
Pages = ["Tucker.jl"]
Order = [:function]
```

## Internal Functions
```@autodocs
Modules = [Manifolds]
Private = true
Public = false
Pages = ["Tucker.jl"]
Order = [:function]
```

## Literature

```@bibliography
Pages = ["tucker.md"]
Canonical=false
```

# About `Manifolds.jl`

`Manifolds.jl` was started by [Seth Axen](https://github.com/sethaxen), [Mateusz Baran](https://github.com/mateuszbaran), [Ronny Bergmann](https://github.com/kellertuer), and [Antoine Levitt](https://github.com/antoine-levitt) in 2019, after a very fruitful discussion following the release of the first version of [`Manopt.jl`](https://manoptjl.org/). The goal of `Manifolds.jl` is to provide a library of manifolds in Julia. The manifolds are implemented using the [ManifoldsBase.jl](https://github.com/JuliaManifolds/ManifoldsBase.jl/) interface.

## Main developers

- [Mateusz Baran](https://github.com/mateuszbaran)
- [Ronny Bergmann](https://github.com/kellertuer)

## Former Main Developers

- [Seth Axen](https://github.com/sethaxen)

## Contributors
(in alphabetical order)

- [Nick Dewaele](https://github.com/Nikdwal) contributed the [Tucker manifold](../manifolds/tucker.md)
- [Renée Dornig](https://github.com/r-dornig) contributed the [centered  matrices](../manifolds/centeredmatrices.md) and the [essential manifold](../manifolds/essentialmanifold.md)
- [David Hong](https://github.com/dahong67) contributed uniform distributions on the Stiefel and Grassmann manifolds.
- [Simon Jacobsson](https://github.com/sjacobsson) contributed the [Segre manifold](../manifolds/segre.md) including its [warped metric](@ref segre-warped-metric-sec) thereon.
- [Johannes Voll Kolstø](https://github.com/johannvk) contributed the [symplectic manifold](../manifolds/symplectic.md), the [symplectic Stiefel manifold](../manifolds/symplecticstiefel.md)
- [Manuel Weiß](https://github.com/manuelweisser) contributed [symmetric matrices](../manifolds/symmetric.md)

as well as everyone else reporting, investigating, and fixing bugs or fixing typographical errors in the documentation, see the [GitHub contributors page](https://github.com/JuliaManifolds/Manifolds.jl/graphs/contributors).

Of course all further [contributions](CONTRIBUTING.md) are always welcome!

## Projects using `Manifolds.jl`

- [Caesar.jl](https://juliarobotics.org/Caesar.jl/latest/concepts/using_manifolds/) – Robust robotic localization and mapping
- [Flowfusion.jl](https://github.com/MurrellGroup/Flowfusion.jl) – training and sampling from diffusion and flow matching models
- [ManoptExamples.jl](https://github.com/JuliaManifolds/ManoptExamples.jl) – collecting examples of optimization problems on manifolds implemented using `Manifolds.jl` and [`Manopt.jl`](https://manoptjl.org/).

Do you use Manifolds.jl in you package? Let us know and open an [issue](https://github.com/JuliaManifolds/Manifolds.jl/issues/new/choose) or [pull request](https://github.com/JuliaManifolds/Manifolds.jl/compare) to add it to the list!

## License

[MIT License](https://github.com/JuliaManifolds/Manifolds.jl/blob/master/LICENSE)

# [Sphere and unit norm arrays](@id SphereSection)

```@docs
AbstractSphere
```

The classical sphere, i.e. unit norm (real- or complex-valued) vectors can be generated as usual: to create the 2-dimensional sphere (in ``ℝ^3``), use `Sphere(2)` and `Sphere(2,ℂ)`, respectively.

```@docs
Sphere
```

For the higher-dimensional arrays, for example unit (Frobenius) norm matrices, the manifold is generated using the size of the matrix.
To create the unit sphere of ``3×2`` real-valued matrices, write `ArraySphere(3,2)` and the complex case is done – as for the [`Euclidean`](@ref) case – with an keyword argument `ArraySphere(3,2; field=ℂ)`. This case also covers the classical sphere as a special case, but you specify the size of the vectors/embedding instead: The 2-sphere can here be generated `ArraySphere(3)`.

```@docs
ArraySphere
```

There is also one atlas available on the sphere.

```@docs
Manifolds.StereographicAtlas
```

## Functions on unit spheres
```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Sphere.jl"]
Order = [:function]
```

## Visualization of data on spheres

For the 2-sphere and the 1-sphere, i.e. data on the embedded Circle on the plane,
data can be visualized using [`ManifoldMakie.jl`](https://juliamanifolds.github.io/ManifoldMakie.jl/stable/), see [here](https://juliamanifolds.github.io/ManifoldMakie.jl/stable/sphere/).

`Manifold.jl` has a legacy extension to [`Plots.jl`](http://docs.juliaplots.org/latest/)
using the recipes for `seriestype` `wireframe` and `surface`.
Since the backends for [`Plots.jl`](http://docs.juliaplots.org/latest/) are not consistent, this only works some backends and for example not with their default backend [`GR.jl`](https://github.com/jheinen/GR.jl).

## Literature

```@bibliography
Pages = ["sphere.md"]
Canonical=false
```

# [Fixed-rank matrices](@id FixedRankMatrices)

```@autodocs
Modules = [Manifolds]
Pages = ["FixedRankMatrices.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["fixedrankmatrices.md"]
Canonical=false
```

# Utilities

## Ease of notation

The following terms introduce a nicer notation for some operations, for example using the ∈ operator, ``p ∈ \mathcal M`` to determine whether ``p`` is a point on the [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  ``\mathcal M``.

````@docs
in
````

## Public documentation

```@docs
sectional_curvature_matrix
```

### Specific exception types

For some manifolds it is useful to keep an extra index, at which point on the manifold, the error occurred as well as to collect all errors that occurred on a manifold. This page contains the manifold-specific error messages this package introduces.

```@autodocs
Modules = [Manifolds]
Pages = ["errors.jl"]
Order = [:type, :function]
```

# Distributions

The following functions and types provide support for manifold-valued and tangent space-valued distributions:

```@autodocs
Modules = [Manifolds]
Pages = ["distributions.jl"]
Order = [:type, :function]
```

```@autodocs
Modules = [Manifolds]
Pages = ["projected_distribution.jl"]
Order = [:type, :function]
```

# Rotations

The manifold ``\mathrm{SO}(n)`` of orthogonal matrices with determinant ``+1`` in ``ℝ^{n×n}``, i.e.

```math
\mathrm{SO}(n) = \bigl\{R ∈ ℝ^{n×n} \big| R R^{\mathrm{T}} =
R^{\mathrm{T}}R = I_n, \det(R) = 1 \bigr\}
```

The tangent space to a point ``p ∈ \mathrm{SO}(n)`` is given by

```math
T_p\mathrm{SO}(n) = \{X : X=pY,\qquad Y=-Y^{\mathrm{T}}\},
```

i.e. all vectors that are a product of a skew symmetric matrix multiplied with ``p``.

Since the orthogonal matrices ``\mathrm{SO}(n)`` are a Lie group, tangent vectors can also be
represented by elements of the corresponding Lie algebra, which is the tangent space at the identity element.
In the notation above, this means we just store the component ``Y`` of ``X``.

This convention allows for more efficient operations on tangent vectors.
Tangent spaces at different points are different vector spaces.

Let ``L_R: \mathrm{SO}(n) → \mathrm{SO}(n)`` where ``R ∈ \mathrm{SO}(n)`` be the left-multiplication by ``R``, that is ``L_R(S) = RS``.
The tangent space at rotation ``R``, ``T_R \mathrm{SO}(n)``, is related to the tangent space at the identity rotation ``I_n`` by the differential of ``L_R`` at identity, ``(\mathrm{d}L_R)_{I_n} : T_{I_n} \mathrm{SO}(n) → T_R \mathrm{SO}(n)``.
To convert the tangent vector representation at the identity rotation ``X ∈ T_{I_n} \mathrm{SO}(n)`` (i.e., the default) to the matrix representation of the corresponding tangent vector ``Y`` at a rotation ``R`` use the [`embed`](@ref embed(::Manifolds.Rotations, :Any...)) which implements the following multiplication: ``Y = RX ∈ T_R \mathrm{SO}(n)``.
You can compare the functions [`log`](@ref log(::Manifolds.Rotations, :Any...)) and [`exp`](@ref exp(::Manifolds.Rotations, ::Any, ::Any)) to see how it works in practice.

Several common functions are also implemented together with [orthogonal and unitary matrices](@ref generalunitarymatrices).

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Rotations.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["rotations.md"]
Canonical=false
```

# The probability simplex

```@autodocs
Modules = [Manifolds, Base]
Pages = ["manifolds/ProbabilitySimplex.jl"]
Order = [:type, :function]
Private=false
Public=true
```

## Euclidean metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/ProbabilitySimplexEuclideanMetric.jl"]
Order = [:type, :function]
Private=false
Public=true
```


## Real probability amplitudes

An isometric embedding of interior of [`ProbabilitySimplex`](@ref) in positive orthant of the
[`Sphere`](@ref) is established through functions [`simplex_to_amplitude`](@ref Manifolds.simplex_to_amplitude) and [`amplitude_to_simplex`](@ref Manifolds.amplitude_to_simplex). Some properties extend to the boundary but not all.

This embedding isometrically maps the Fisher-Rao metric on the open probability simplex to
the sphere of radius 1 with Euclidean metric. More details can be found in Section 2.2
of [AyJostLeSchwachhoefer:2017](@cite).

The name derives from the notion of probability amplitudes in quantum mechanics.
They are complex-valued and their squared norm corresponds to probability. This construction
restricted to real valued amplitudes results in this embedding.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/ProbabilitySimplex.jl"]
Order = [:type, :function]
Private=true
Public=false
```

## Literature

```@bibliography
Pages = ["probabilitysimplex.md"]
Canonical=false
```

# Internal documentation

This page documents the internal types and methods of `Manifolds.jl`'s that might be of use for writing your own manifold.

## Functions

```@docs
Manifolds.eigen_safe
Manifolds.estimated_sectional_curvature
Manifolds.estimated_sectional_curvature_matrix
Manifolds.get_parameter_type
Manifolds.isnormal
Manifolds.log_safe
Manifolds.log_safe!
Manifolds.mul!_safe
Manifolds.normal_tvector_distribution
Manifolds.nzsign
Manifolds.projected_distribution
Manifolds.realify
Manifolds.realify!
Manifolds.symmetrize
Manifolds.symmetrize!
Manifolds.unrealify!
Manifolds.usinc
Manifolds.usinc_from_cos
Manifolds.vec2skew!
```

## Types in Extensions

```@autodocs
Modules = [Base.get_extension(Manifolds, :ManifoldsOrdinaryDiffEqDiffEqCallbacksExt)]
Order = [:type, :function]
```

# [Euclidean space](@id EuclideanSection)

The Euclidean space ``ℝ^n`` is a simple model space, since it has curvature constantly zero everywhere; hence, nearly all operations simplify.
The easiest way to generate an Euclidean space is to use a field, i.e. [`AbstractNumbers`](@extref ManifoldsBase number-system), e.g. to create the ``ℝ^n`` or ``ℝ^{n×n}`` you can simply type `M = ℝ^n` or `ℝ^(n,n)`, respectively.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Euclidean.jl"]
Order = [:type,:function]
```

# Torus

The torus ``𝕋^d ≅ [-π,π)^d`` is modeled as an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  of the (real-valued) [`Circle`](@ref) and uses [`ArrayPowerRepresentation`](@ref).
Points on the torus are hence row vectors, ``x ∈ ℝ^{d}``.

## Example

The following code can be used to make a three-dimensional torus ``𝕋^3`` and compute a tangent vector:

```@example
using Manifolds
M = Torus(3)
p = [0.5, 0.0, 0.0]
q = [0.0, 0.5, 1.0]
X = log(M, p, q)
```

## Types and functions

Most functions are directly implemented for an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  with [`ArrayPowerRepresentation`](@ref) except the following special cases:

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Torus.jl"]
Order = [:type, :function]
```

## Embedded Torus

Two-dimensional torus embedded in ``ℝ^3``.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/EmbeddedTorus.jl"]
Order = [:type, :function]
```

# Positive Numbers

The manifold [`PositiveNumbers`](@ref) represents positive numbers with hyperbolic geometry. Additionally, there are also short forms for its corresponding `PowerManifold`s, i.e. [`PositiveVectors`](@ref), [`PositiveMatrices`](@ref), and [`PositiveArrays`](@ref).

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/PositiveNumbers.jl"]
Order = [:type, :function]
```

# [Fiber bundles](@id FiberBundleSection)

Fiber bundle ``E`` is a manifold that is built on top of another manifold ``\mathcal M`` (base space).
It is characterized by a continuous function ``Π : E → \mathcal M``. For each point ``p ∈ \mathcal M`` the preimage of ``p`` by ``Π``, ``Π^{-1}(\{p\})`` is called a fiber ``F``.
Bundle projection can be performed using function [`bundle_projection`](@ref).

`Manifolds.jl` primarily deals with the case of trivial bundles, where ``E`` can be topologically identified with a product ``M×F``.

[Vector bundles](@ref VectorBundleSection) is a special case of a fiber bundle. Other examples include unit tangent bundle. Note that in general fiber bundles don't have a canonical Riemannian structure but can at least be equipped with an [Ehresmann connection](https://en.wikipedia.org/wiki/Ehresmann_connection), providing notions of parallel transport and curvature.

## Documentation

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/Fiber.jl", "manifolds/FiberBundle.jl"]
Order = [:constant, :type, :function]
```

# Symplectic matrices

The [`SymplecticMatrices`](@ref) manifold, denoted ``\operatorname{Sp}(2n, 𝔽)``, is a closed, embedded, submanifold of
``𝔽^{2n×2n}`` that represents transformations into symplectic subspaces which keep the
canonical symplectic form over ``𝔽^{2n×2n}`` invariant under the standard embedding inner product.
The canonical symplectic form is a non-degenerate bilinear and skew symmetric map
``\omega\colon 𝔽 𝔽^{2n}×𝔽^{2n}
→ 𝔽``, given by
``\omega(x, y) = x^T Q_{2n} y`` for elements ``x, y \in 𝔽^{2n}``, with
````math
    Q_{2n} =
    \begin{bmatrix}
     0_n  &  I_n \\
    -I_n  &  0_n
    \end{bmatrix}.
````
That means that an element ``p \in \operatorname{Sp}(2n)`` must fulfill the requirement that
````math
    \omega (p x, p y) = x^T(p^TQp)y = x^TQy = \omega(x, y),
````
leading to the requirement on ``p`` that ``p^TQp = Q``.

The symplectic manifold also forms a group under matrix multiplication, called the ``\textit{symplectic group}``.
Since all the symplectic matrices necessarily have determinant one, the [symplectic group](https://en.wikipedia.org/wiki/Symplectic_group)
``\operatorname{Sp}(2n, 𝔽)`` is a subgroup of the special linear group, ``\operatorname{SL}(2n, 𝔽)``. When the underlying
field is either ``ℝ`` or ``ℂ`` the symplectic group with a manifold structure constitutes a Lie group, with the Lie
Algebra
````math
    \mathfrak{sp}(2n,F) = \{H \in 𝔽^{2n×2n} \;|\; Q H + H^{T} Q = 0\}.
````
This set is also known as the [Hamiltonian matrices](https://en.wikipedia.org/wiki/Hamiltonian_matrix), which have the
property that ``(QH)^T = QH`` and are commonly used in physics.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Symplectic.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["symplectic.md"]
Canonical=false
```

# Lorentzian Manifold

The [Lorentz manifold](https://en.wikipedia.org/wiki/Pseudo-Riemannian_manifold#Lorentzian_manifold) is a [pseudo-Riemannian manifold](https://en.wikipedia.org/wiki/Pseudo-Riemannian_manifold).
It is named after the Dutch physicist [Hendrik Lorentz](https://en.wikipedia.org/wiki/Hendrik_Lorentz) (1853–1928).
The default [`LorentzMetric`](@ref) is the [`MinkowskiMetric`](@ref) named after the German mathematician [Hermann Minkowski](https://en.wikipedia.org/wiki/Hermann_Minkowski) (1864–1909).

Within `Manifolds.jl` it is used as the embedding of the [`Hyperbolic`](@ref) space.

```@autodocs
Modules = [Manifolds]
Pages = ["Lorentz.jl"]
Order = [:type, :function]
```

# Metric manifold

A Riemannian manifold always consists of a [topological manifold](https://en.wikipedia.org/wiki/Topological_manifold) together with a smoothly varying metric tensor ``g``.
This metric tensor defines an inner product on each tangent space of the manifold.
In `Manifolds.jl`, a concrete implementation of an [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`) has an implicit metric, which we refer to as the default metric. For example on [`Euclidean`](@ref) space, this is the usual inner product.
For the [`Sphere`](@ref), this default metric is the metric induced by the embedding in the ambient Euclidean space, restricted to the tangent spaces of the sphere.

Such a default metric is usually not the only possible metric on a manifold.

The [`MetricManifold`](@extref ManifoldsBase.MetricManifold) decorator allows to introduce further metrics for a manifold by acting as a wrapper.
This allows to define further metrics for an existing manifold, while only having to implement functions that depend on the metric.
All functions that are independent of the metric are automatically forwarded to the underlying manifold.
When wrapping a manifold `M` with a [`MetricManifold`](@extref ManifoldsBase.MetricManifold) together with the default [`metric`](@extref ManifoldsBase.metric)`(M)`,
this wrapper acts completely transparent and passes all function calls to the underlying manifold `M`.

```@contents
Pages = ["metric.md"]
Depth = 2
```

## Deprecated methods, to be replaced by chart-based variants

Chart-based variants of deprecated functions are discussed in [the section about atlases](@ref atlases_and_charts).

```@docs
einstein_tensor(::AbstractManifold, ::Any, ::AbstractBasis)
ricci_curvature(::AbstractManifold, ::Any, ::AbstractBasis)
local_metric(::AbstractManifold, ::Any, ::AbstractBasis)
local_metric_jacobian(::AbstractManifold, ::Any, ::AbstractBasis)
inverse_local_metric(::AbstractManifold, ::Any, ::AbstractBasis)
log_local_metric_density(::AbstractManifold, ::Any, ::AbstractBasis)
det_local_metric(::AbstractManifold, ::Any, ::AbstractBasis)
```

## Types

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/MetricManifold.jl"]
Order = [:type]
```

## Implement Different Metrics on the same Manifold

In order to distinguish different metrics on one manifold, one can introduce two [`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`)s and use this type to dispatch on the metric, see [`SymmetricPositiveDefinite`](@ref).
To avoid overhead, one [`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`) can then be marked as being the default, i.e. the one that is used, when no [`MetricManifold`](@extref ManifoldsBase.MetricManifold) decorator is present.
This avoids reimplementation of the first existing metric, access to the metric-dependent functions that were implemented using the undecorated manifold, as well as the transparent fallback of the corresponding [`MetricManifold`](@extref ManifoldsBase.MetricManifold) with default metric to the undecorated implementations.
This does not cause any runtime overhead.
Introducing a default [`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`) serves a better readability of the code when working with different metrics.

## Implementation of Metrics

For the case that a [`local_metric`](@ref) is implemented as a bilinear form that is positive definite, the following further functions are provided, unless the corresponding [`AbstractMetric`](@extref `ManifoldsBase.AbstractMetric`) is marked as default – then the fallbacks mentioned in the last section are used for e.g. the exponential map.

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/MetricManifold.jl"]
Order = [:function]
```

## Metrics, charts and bases of vector spaces

Metric-related functions, similarly to connection-related functions, need to operate in a basis of a vector space, see [here](@ref connections_charts).

Metric-related functions can take bases of associated tangent spaces as arguments. For example [`local_metric`](@ref) can take the basis of the tangent space it is supposed to operate on instead of a custom basis of the space of symmetric bilinear operators.

# [Power manifold](@id PowerManifoldSection)

A power manifold is based on a [`AbstractManifold`](@extref `ManifoldsBase.AbstractManifold`)  ``\mathcal M`` to build a ``\mathcal M^{n_1×n_2 ×⋯×n_m}``.
In the case where ``m=1`` we can represent a manifold-valued vector of data of length ``n_1``, for example a time series.
The case where ``m=2`` is useful for representing manifold-valued matrices of data of size ``n_1×n_2``, for example certain types of images.

There are three available representations for points and vectors on a power manifold:

* [`ArrayPowerRepresentation`](@ref) (the default one), very efficient but only applicable when points on the underlying manifold are represented using plain `AbstractArray`s.
* [`NestedPowerRepresentation`](@extref `ManifoldsBase.NestedPowerRepresentation`), applicable to any manifold. It assumes that points on the underlying manifold are represented using mutable data types.
* [`NestedReplacingPowerRepresentation`](@extref `ManifoldsBase.NestedReplacingPowerRepresentation`), applicable to any manifold. It does not mutate points on the underlying manifold, replacing them instead when appropriate.

Below are some examples of usage of these representations.

## Example

There are two ways to store the data: in a multidimensional array or in a nested array.

Let's look at an example for both.
Let ``\mathcal M`` be `Sphere(2)` the 2-sphere and we want to look at vectors of length 4.

### `ArrayPowerRepresentation`

For the default, the [`ArrayPowerRepresentation`](@ref), we store the data in a multidimensional array,

```@example 1
using Manifolds
M = PowerManifold(Sphere(2), 4)
p = cat([1.0, 0.0, 0.0],
        [1/sqrt(2.0), 1/sqrt(2.0), 0.0],
        [1/sqrt(2.0), 0.0, 1/sqrt(2.0)],
        [0.0, 1.0, 0.0]
    ,dims=2)
```

which is a valid point i.e.

```@example 1
is_point(M, p)
```

This can also be used in combination with [HybridArrays.jl](https://github.com/mateuszbaran/HybridArrays.jl) and [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl), by setting

```@example 1
using HybridArrays, StaticArrays
q = HybridArray{Tuple{3,StaticArrays.Dynamic()},Float64,2}(p)
```

which is still a valid point on `M` and [`PowerManifold`](@extref `ManifoldsBase.PowerManifold`) works with these, too.

An advantage of this representation is that it is quite efficient, especially when a `HybridArray` (from the [HybridArrays.jl](https://github.com/mateuszbaran/HybridArrays.jl) package) is used to represent a point on the power manifold.
A disadvantage is not being able to easily identify parts of the multidimensional array that correspond to a single point on the base manifold.
Another problem is, that accessing a single point is ` p[:, 1]` which might be unintuitive.

### `NestedPowerRepresentation`

For the [`NestedPowerRepresentation`](@extref `ManifoldsBase.NestedPowerRepresentation`) we can now do

```@example 2
using Manifolds
M = PowerManifold(Sphere(2), NestedPowerRepresentation(), 4)
p = [ [1.0, 0.0, 0.0],
      [1/sqrt(2.0), 1/sqrt(2.0), 0.0],
      [1/sqrt(2.0), 0.0, 1/sqrt(2.0)],
      [0.0, 1.0, 0.0],
    ]
```

which is again a valid point so `is_point(M, p)` here also yields true.
A disadvantage might be that with nested arrays one loses a little bit of performance.
The data however is nicely encapsulated. Accessing the first data item is just `p[1]`.

For accessing points on power manifolds in both representations you can use [`get_component`](@extref `ManifoldsBase.get_component-Tuple{AbstractPowerManifold, Any, Vararg{Any}}`) and [`set_component!`](@extref `ManifoldsBase.set_component!-Tuple{AbstractPowerManifold, Any, Any, Vararg{Any}}`) functions.
They work work both point representations.

```@example 3
using Manifolds
M = PowerManifold(Sphere(2), NestedPowerRepresentation(), 4)
p = [ [1.0, 0.0, 0.0],
      [1/sqrt(2.0), 1/sqrt(2.0), 0.0],
      [1/sqrt(2.0), 0.0, 1/sqrt(2.0)],
      [0.0, 1.0, 0.0],
    ]
set_component!(M, p, [0.0, 0.0, 1.0], 4)
get_component(M, p, 4)
```

### `NestedReplacingPowerRepresentation`

The final representation is the [`NestedReplacingPowerRepresentation`](@extref `ManifoldsBase.NestedReplacingPowerRepresentation`). It is similar to the [`NestedPowerRepresentation`](@extref `ManifoldsBase.NestedPowerRepresentation`) but it does not perform in-place operations on the points on the underlying manifold.

## Types and Functions
```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/PowerManifold.jl"]
Order = [:type, :function]
```

---
title: Working in charts
---

In this tutorial we will learn how to use charts for basic geometric operations like exponential map, logarithmic map and parallel transport.

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
using Markdown
```


There are two conceptually different approaches to working on a manifold: working in charts and chart-free representations.

The first one, widespread in differential geometry textbooks, is based on defining an atlas on the manifold and performing computations in selected charts. This approach, while generic, is not ideally suitable in all circumstances. For example, working in charts that do not cover the entire manifold causes issues with having to switch charts when operating on a manifold.

The second one is beneficial if there exists a representation of points and tangent vectors for a manifold which allows for efficient closed-form formulas for standard functions like the exponential map or Riemannian distance in this representation. These computations are then chart-free. `Manifolds.jl` supports both approaches, although the chart-free approach is the main focus of the library.

In this tutorial we focus on chart-based computation.

```{julia}
#| output: false
using Manifolds, RecursiveArrayTools, OrdinaryDiffEq, DiffEqCallbacks, BoundaryValueDiffEq
```

The manifold we consider is the `M` is the torus in form of the [`EmbeddedTorus`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/torus.html#Manifolds.EmbeddedTorus), that is the representation defined as a surface of revolution of a circle of radius 2 around a circle of radius 3.
The atlas we will perform computations in is its [`DefaultTorusAtlas`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/torus.html#Manifolds.DefaultTorusAtlas) `A`, consisting of a family of charts indexed by two angles, that specify the base point of the chart.

We will draw geodesics time between `0` and `t_end`, and then sample the solution at multiples of `dt` and draw a line connecting sampled points.

```{julia}
M = Manifolds.EmbeddedTorus(3, 2)
A = Manifolds.DefaultTorusAtlas()
```

## Setup

We will first set up our plot with an empty torus.
`param_points` are points on the surface of the torus that will be used for basic surface shape in `Makie.jl`.
The torus will be colored according to its Gaussian curvature stored in `gcs`. We later want to have a color scale that has negative curvature blue, zero curvature white and positive curvature red so `gcs_mm` is the largest absolute value of the curvature that will be needed to properly set range of curvature values.

In the documentation this tutorial represents a static situation (without interactivity). `Makie.jl` rendering is turned off.

```{julia}
# using GLMakie, Makie
# GLMakie.activate!()

"""
	torus_figure()

This function generates a simple plot of a torus and returns the new figure containing the plot.
"""
function torus_figure()
    fig = Figure(resolution=(1400, 1000), fontsize=16)
    ax = LScene(fig[1, 1], show_axis=true)
    ϴs, φs = LinRange(-π, π, 50), LinRange(-π, π, 50)
    param_points = [Manifolds._torus_param(M, θ, φ) for θ in ϴs, φ in φs]
    X1, Y1, Z1 = [[p[i] for p in param_points] for i in 1:3]
    gcs = [gaussian_curvature(M, p) for p in param_points]
    gcs_mm = max(abs(minimum(gcs)), abs(maximum(gcs)))
    pltobj = surface!(
        ax,
        X1,
        Y1,
        Z1;
        shading=true,
        ambient=Vec3f(0.65, 0.65, 0.65),
        backlight=1.0f0,
        color=gcs,
        colormap=Reverse(:RdBu),
        colorrange=(-gcs_mm, gcs_mm),
        transparency=true,
    )
    wireframe!(ax, X1, Y1, Z1; transparency=true, color=:gray, linewidth=0.5)
    zoom!(ax.scene, cameracontrols(ax.scene), 0.98)
    Colorbar(fig[1, 2], pltobj, height=Relative(0.5), label="Gaussian curvature")
    return ax, fig
end
```


## Values for the geodesic

`solve_for` is a helper function that solves a parallel transport along geodesic problem on the torus `M`.
`p0x` is the $(\theta, \varphi)$ parametrization of the point from which we will transport the vector.
We first calculate the coordinates in the embedding of `p0x` and store it as `p`, and then get the initial chart from atlas `A` appropriate for starting working at point `p`.
The vector we transport has coordinates `Y_transp` in the induced tangent space basis of chart `i_p0x`.
The function returns the full solution to the parallel transport problem, containing the sequence of charts that was used and solutions of differential equations computed using `OrdinaryDiffEq`.

`bvp_i` is needed later for a different purpose, it is the chart index we will use for solving the logarithmic map boundary value problem in.

Next we solve the vector transport problem `solve_for([θₚ, φₚ], [θₓ, φₓ], [θy, φy])`, sample the result at the selected time steps and store the result in `geo`. The solution includes the geodesic which we extract and convert to a sequence of points digestible by `Makie.jl`, `geo_ps`.
`[θₚ, φₚ]` is the parametrization in chart (0, 0) of the starting point of the geodesic.
The direction of the geodesic is determined by `[θₓ, φₓ]`, coordinates of the tangent vector at the starting point expressed in the induced basis of chart `i_p0x` (which depends on the initial point).
Finally, `[θy, φy]` are the coordinates of the tangent vector that will be transported along the geodesic, which are also expressed in same basis as `[θₓ, φₓ]`.

We won't draw the transported vector at every point as there would be too many arrows, which is why we select every 100th point only for that purpose with `pt_indices`. Then, `geo_ps_pt` contains points at which the transported vector is tangent to and `geo_Ys` the transported vector at that point, represented in the embedding.

The logarithmic map will be solved between points with parametrization `bvp_a1` and `bvp_a2` in chart `bvp_i`.
The result is assigned to variable `bvp_sol` and then sampled with time step 0.05. The result of this sampling is converted from parameters in chart `bvp_i` to point in the embedding and stored in `geo_r`.


```{julia}
function solve_for(p0x, X_p0x, Y_transp, T)
    p = [Manifolds._torus_param(M, p0x...)...]
    i_p0x = Manifolds.get_chart_index(M, A, p)
    p_exp = Manifolds.solve_chart_parallel_transport_ode(
        M,
        [0.0, 0.0],
        X_p0x,
        A,
        i_p0x,
        Y_transp;
        final_time=T,
    )
    return p_exp
end;
```


### Solving parallel Transport ODE

We set the end time `t_end` and time step `dt`.

```{julia}
t_end = 2.0
dt = 1e-1
```

We also parametrise the start point and direction.

```{julia}
θₚ = π/10
φₚ = -π/4
θₓ = π/2
φₓ = 0.7
θy = 0.2
φy = -0.1

geo = solve_for([θₚ, φₚ], [θₓ, φₓ], [θy, φy], t_end)(0.0:dt:t_end);
# geo_ps = [Point3f(s[1]) for s in geo]
# pt_indices = 1:div(length(geo), 10):length(geo)
# geo_ps_pt = [Point3f(s[1]) for s in geo[pt_indices]]
# geo_Ys = [Point3f(s[3]) for s in geo[pt_indices]]

# ax1, fig1 = torus_figure()
# arrows!(ax1, geo_ps_pt, geo_Ys, linewidth=0.05, color=:blue)
# lines!(geo_ps; linewidth=4.0, color=:green)
# fig1
```

![fig-pt](working-in-charts/working-in-charts-transport.png)

### Solving the logarithmic map ODE

```{julia}
θ₁=π/2
φ₁=-1.0
θ₂=-π/8
φ₂=π/2

bvp_i = (0, 0)
bvp_a1 = [θ₁, φ₁]
bvp_a2 = [θ₂, φ₂]
bvp_sol = Manifolds.solve_chart_log_bvp(M, bvp_a1, bvp_a2, A, bvp_i);
# geo_r = [Point3f(get_point(M, A, bvp_i, p[1:2])) for p in bvp_sol(0.0:0.05:1.0)]

# ax2, fig2 = torus_figure()
# lines!(geo_r; linewidth=4.0, color=:green)
# fig2
```

![fig-geodesic](working-in-charts/working-in-charts-geodesic.png)

An interactive Pluto version of this tutorial is available in file [`tutorials/working-in-charts.jl`](https://github.com/JuliaManifolds/Manifolds.jl/blob/616855447996fb1ee7dfb2a779341b962a1323f8/tutorials/working-in-charts.jl).

# Grassmannian manifold

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Grassmann.jl"]
Order = [:type,:function]
```

## The Grassmanian represented as points on the [Stiefel](@ref) manifold

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/GrassmannStiefel.jl"]
Order = [:type,:function]
```

## The Grassmannian represented as projectors

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/GrassmannProjector.jl"]
Order = [:type,:function]
```

## Literature

```@bibliography
Pages = ["grassmann.md"]
Canonical=false
```

---
title: Accurcay tests on the Hyperboloid
---


```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local accuracy environment.
```

In this small note we compare different implementations of several functions on the [Hyperbolic]().
We compare the functions prior [PR #]() to vs those introduced therein.
We compare the previous version (always called `_1`) and the new version `_2`, where we leave out the manifold to indicate, that these are the local functions here.
We compare this to the one given in `Manifolds.jl` at time of writing (which is the first one), on `BigFloat` on several scales of magnitudes.

```{julia}
#| output: false
using Manifolds, Random, NamedColors, Plots
using Manifolds: minkowski_metric

paul_tol = load_paul_tol()
indigo = paul_tol["mutedindigo"]
teal = paul_tol["mutedteal"]
```

## Reference Data

We choose a “base point”, a direction and create tangent vectors and corresponding points in several magnitudes of distances
```{julia}
#| output: false
M = Hyperbolic(2)
p = [0.0, 0.0, 1.0]
pb = BigFloat.(p)
X = [1 / sqrt(2), 1 / sqrt(2), 0.0]
Xb = BigFloat.(X)
lengths = [10.0^k for k in -16:4]
Xbs = [s*Xb for s in lengths]
Xbns = [norm(M, p, X) for X in Xbs]
qbs = [exp(M, pb, Y) for Y in Xbs]
Xs = [Float64.(X) for X in Xbs]
qs = [Float64.(q) for q in qbs]
```

## Distance

We define

```{julia}
#| output: false
distance_1(p, q) = acosh(max(-minkowski_metric(p, q), 1.0))
function distance_2(p, q)
     w = q - p
     m = sqrt(max(0.0, minkowski_metric(w, w)))
     return 2 * asinh(m/2)
end
```

and compare

```{julia}
d_1 = [distance_1(p, q) for q in qs]
d_2 = [distance_2(p, q) for q in qs]
fig = plot(;
    legend=:topleft,
    xlabel=raw"lengths $s$ (log. scale)",
    ylabel=raw"Error to BigFloat (log. scale)",
    yaxis=:log,
    xaxis=:log,
    ylims=(1e-16, 1e2),
    xlims=(1e-17, 10^3),
)
plot!(fig, lengths, abs.(Xbns .- d_1), color=indigo, label="1 - acosh-based")
plot!(fig, lengths, abs.(Xbns .- d_2), color=teal, label="2 - asinh-based")
```

```{julia}
abs.(Xbns .- d_1)
```

```{julia}
abs.(Xbns .- d_2)
```

# Stiefel

## Common and metric independent functions

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Stiefel.jl"]
Order = [:type, :function]
```

## Default metric: the Euclidean metric

The [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`) is obtained from the embedding of the Stiefel manifold in ``ℝ^{n,k}``.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/StiefelEuclideanMetric.jl"]
Order = [:function]
```

## The canonical metric
Any ``X∈T_p\mathcal M``, ``p∈\mathcal M``, can be written as

```math
X = pA + (I_n-pp^{\mathrm{T}})B,
\quad
A ∈ ℝ^{p×p} \text{ skew-symmetric},
\quad
B ∈ ℝ^{n×p} \text{ arbitrary.}
```

In the [`EuclideanMetric`](@extref `ManifoldsBase.EuclideanMetric`), the elements from ``A`` are counted twice (i.e. weighted with a factor of 2).
The canonical metric avoids this.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/StiefelCanonicalMetric.jl"]
Order = [:type]
```

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/StiefelCanonicalMetric.jl"]
Order = [:function]
```

## The submersion or normal metric

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/StiefelSubmersionMetric.jl"]
Order = [:type, :function]
Public = true
Private = false
```

## Internal types and functions

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/StiefelSubmersionMetric.jl"]
Order = [:type, :function]
Public = false
Private = true
```

## Literature

```@bibliography
Pages = ["stiefel.md"]
Canonical=false
```

# Multinomial doubly stochastic matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/MultinomialDoublyStochastic.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["multinomialdoublystochastic.md"]
Canonical=false
```

# [Vector bundles](@id VectorBundleSection)

Vector bundle ``E`` is a special case of a [fiber bundle](@ref FiberBundleSection) where each fiber is a vector space.

Tangent bundle is a simple example of a vector bundle, where each fiber is the tangent space at the specified point ``p``.
An object representing a tangent bundle can be obtained using the constructor called `TangentBundle`.

There is also another type, [`VectorSpaceFiber`](@extref `ManifoldsBase.VectorSpaceFiber`), that represents a specific fiber at a given point.
This is also considered a manifold.

## FVector

For cases where confusion between different types of vectors is possible, the type [`FVector`](@extref `ManifoldsBase.FVector`) can be used to express which type of vector space the vector belongs to.
It is used for example in musical isomorphisms (the [`flat`](@ref) and [`sharp`](@ref) functions) that are used to go from a tangent space to cotangent space and vice versa.

## Documentation

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/VectorFiber.jl", "manifolds/VectorBundle.jl"]
Order = [:constant, :type, :function]
```

## Example

The following code defines a point on the tangent bundle of the sphere ``S^2`` and a tangent vector to that point.

```@example tangent-bundle
using Manifolds, RecursiveArrayTools
M = Sphere(2)
TB = TangentBundle(M)
p = ArrayPartition([1.0, 0.0, 0.0], [0.0, 1.0, 3.0])
X = ArrayPartition([0.0, 1.0, 0.0], [0.0, 0.0, -2.0])
```

An approximation of the exponential in the Sasaki metric using 1000 steps can be calculated as follows.

```@example tangent-bundle
q = retract(TB, p, X, SasakiRetraction(1000))
println("Approximation of the exponential map: ", q)
```

# Essential Manifold
The essential manifold is modeled as an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  of the ``3×3`` [`Rotations`](@ref) and uses [`NestedPowerRepresentation`](@extref `ManifoldsBase.NestedPowerRepresentation`).

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/EssentialManifold.jl"]
Order = [:type]
```

## Functions
```@autodocs
Modules = [Manifolds]
Private = false
Pages = ["manifolds/EssentialManifold.jl"]
Order = [:function]
```

## Internal Functions
```@autodocs
Modules = [Manifolds]
Public = false
Pages = ["manifolds/EssentialManifold.jl"]
Order = [:function]
```

## Literature

# [Symmetric positive definite matrices of fixed determinant](@id SPDFixedDeterminantSection)

```@docs
SPDFixedDeterminant
```

This manifold can is a submanifold of the [symmetric positive definite matrices](@ref SymmetricPositiveDefiniteSection) and hence inherits most properties therefrom.

The differences are the functions

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/SPDFixedDeterminant.jl"]
Order = [:function]
```

# Oblique manifold

The oblique manifold ``\mathcal{OB}(n,m)`` is modeled as an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  of the (real-valued) [`Sphere`](@ref) and uses [`ArrayPowerRepresentation`](@ref).
Points on the torus are hence matrices, ``x ∈ ℝ^{n,m}``.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Oblique.jl"]
Order = [:type]
```

## Functions

Most functions are directly implemented for an [`AbstractPowerManifold`](@extref `ManifoldsBase.AbstractPowerManifold`)  with [`ArrayPowerRepresentation`](@ref) except the following special cases:

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Oblique.jl"]
Order = [:function]
```

# [Connection manifold](@id ConnectionSection)

A connection manifold always consists of a [topological manifold](https://en.wikipedia.org/wiki/Topological_manifold) together with a [connection](https://en.wikipedia.org/wiki/Connection_(mathematics)) ``Γ``.

However, often there is an implicitly assumed (default) connection, like the [`LeviCivitaConnection`](@extref ManifoldsBase.LeviCivitaConnection) connection on a Riemannian manifold.
It is not necessary to use this decorator if you implement just one (or the first) connection.
If you later introduce a second, the old (first) connection can be used without an explicitly stated connection.

This manifold decorator serves two purposes:

1. to implement different connections (e.g. in closed form) for one `AbstractManifold`
2. to provide a way to compute geodesics on manifolds, where this [`AbstractAffineConnection`](@extref ManifoldsBase.AbstractAffineConnection) does not yield a closed formula.

```@contents
Pages = ["connection.md"]
Depth = 2
```

## Types

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/ConnectionManifold.jl"]
Order = [:type]
```

## Functions

```@autodocs
Modules = [Manifolds, ManifoldsBase]
Pages = ["manifolds/ConnectionManifold.jl"]
Order = [:function]
```

## [Charts and bases of vector spaces](@id connections_charts)

All connection-related functions take a basis of a vector space as one of the arguments. This is needed because generally there is no way to define these functions without referencing a basis. In some cases there is no need to be explicit about this basis, and then for example a [`DefaultOrthonormalBasis`](@extref `ManifoldsBase.DefaultOrthonormalBasis`) object can be used. In cases where being explicit about these bases is needed, for example when using multiple charts, a basis can be specified, for example using [`induced_basis`](@ref Main.Manifolds.induced_basis).

---
title: Hand gesture analysis
---

In this tutorial we will learn how to use Kendall's shape space to analyze hand gesture data.

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
using Markdown
```

Let's start by loading libraries required for our work.

```{julia}
using Manifolds, CSV, DataFrames, Plots, MultivariateStats
```

Our first function loads dataset of hand gestures, described [here](https://geomstats.github.io/notebooks/14_real_world_applications__hand_poses_analysis_in_kendall_shape_space.html).

```{julia}

function load_hands()
    hands_url = "https://raw.githubusercontent.com/geomstats/geomstats/master/geomstats/datasets/data/hands/hands.txt"
    hand_labels_url = "https://raw.githubusercontent.com/geomstats/geomstats/master/geomstats/datasets/data/hands/labels.txt"

    hands = Matrix(CSV.read(download(hands_url), DataFrame, header=false))
    hands = reshape(hands, size(hands, 1), 3, 22)
    hand_labels = CSV.read(download(hand_labels_url), DataFrame, header=false).Column1
    return hands, hand_labels
end
```

The following code plots a sample gesture as a 3D scatter plot of points.
```{julia}
hands, hand_labels = load_hands()
scatter3d(hands[1, 1, :], hands[1, 2, :], hands[1, 3, :])
```

Each gesture is represented by 22 landmarks in $ℝ³$, so we use the appropriate Kendall's shape space
```{julia}
Mshape = KendallsShapeSpace(3, 22)
```

Hands read from the dataset are projected to the shape space to remove translation
and scaling variability. Rotational variability is then handled using the quotient
structure of ``[`KendallsShapeSpace`](@ref)``{=commonmark}
```{julia}
#| output: false
hands_projected = [project(Mshape, hands[i, :, :]) for i in axes(hands, 1)]
```

In the next part let's do tangent space PCA. This starts with computing a mean point and computing
logithmic maps at mean to each point in the dataset.
```{julia}
#| output: false
mean_hand = mean(Mshape, hands_projected)
hand_logs = [log(Mshape, mean_hand, p) for p in hands_projected]
```

For a tangent PCA, we need coordinates in a basis.
Some libraries skip this step because the representation of tangent vectors
forms a linear subspace of an Euclidean space so PCA automatically detects
which directions have no variance but this is a more generic way to solve
this issue.
```{julia}
#| output: false
B = get_basis(Mshape, mean_hand, ProjectedOrthonormalBasis(:svd))
hand_log_coordinates = [get_coordinates(Mshape, mean_hand, X, B) for X in hand_logs]
```

This code prepares data for MultivariateStats -- `mean=0` is set because we've centered
the data geometrically to `mean_hand` in the code above.
```{julia}
red_coords = reduce(hcat, hand_log_coordinates)
fp = fit(PCA, red_coords; mean=0)
```

Now let's show explained variance of each principal component.
```{julia}
plot(principalvars(fp), title="explained variance", label="Tangent PCA")
```

The next plot shows how projections on the first two principal components look like.
```{julia}
fig = plot(; title="coordinates per gesture of the first two principal components")
for label_num in [0, 1]
    mask = hand_labels .== label_num
    cur_hand_logs = red_coords[:, mask]
    cur_t = MultivariateStats.transform(fp, cur_hand_logs)
    scatter!(fig, cur_t[1, :], cur_t[2, :], label="gesture " * string(label_num))
end
xlabel!(fig, "principal component 1")
ylabel!(fig, "principal component 2")
fig
```

The following heatmap displays pairwise distances between gestures.
We can use them for clustering, classification, etc.
```{julia}
hand_distances = [
    distance(Mshape, hands_projected[i], hands_projected[j]) for
    i in eachindex(hands_projected), j in eachindex(hands_projected)
]
heatmap(hand_distances, aspect_ratio=:equal)
```

# [Hyperrectangle](@id HyperrectangleSection)

Hyperrectangle is a manifold with corners [Joyce:2010](@cite), and also a subset of the real [Euclidean](@ref Main.Manifolds.Euclidean) manifold.
It is useful for box-constrained optimization, for example it is implicitly used in the classic L-BFGS-B algorithm.

!!! note
    This is a manifold with corners. Some parts of its interface specific to this property are experimental and may change without a breaking release.

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Hyperrectangle.jl"]
Order = [:type,:function]
```

## Literature

```@bibliography
Pages = ["hyperrectangle.md"]
Canonical=false
```

---
title: Exploring curvature without coordinates
---

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
Pkg.develop(PackageSpec(; path=(@__DIR__) * "/../"))
using Markdown
```

This part of documentation covers exploration of curvature of manifolds $\mathcal{M}$.
There are multiple ways to describe curvature: Christoffel symbols, Riemann tensor, Ricci tensor, sectional curvature, and many other.
They are usually considered only in coordinates but there is a way to demonstrate curvature in coordinate-free way.

## Sectional curvature matrix

Curvature of a manifold can be explored using the [`sectional_curvature_matrix`](@ref) function.
Note that Riemann tensor and sectional curvature are equivalently full specifications of curvature in a manifold, see [CheegerEbin:2008](@cite), Eq. (1.12).

Let's take the [`SymmetricPositiveDefinite`](@ref) manifold as our first example.
It has nonpositive sectional curvature:

```{julia}
using Manifolds
using LinearAlgebra
M = SymmetricPositiveDefinite(3)
p = rand(M)
cm = sectional_curvature_matrix(M, p, DefaultOrthonormalBasis())
```

We can verify that the curvature is consistent with an approximation based on the Bertrand–Diguet–Puiseux theorem, which relies only on an ONB, exponential map and distance calculation:
```{julia}
cm_bdp = Manifolds.estimated_sectional_curvature_matrix(M, p, DefaultOrthonormalBasis(); r=1e-3, N_pts=100000)
println(norm(cm - cm_bdp))
```

This approximation converges quite slowly with `N_pts` and is prone to numerical errors at low values of `r` and large values of `N_pts`.

You can also take the vectors from the basis and see what kind of planes they correspond to.
It may be easier to see for the identity matrix as the base point.
```{julia}
p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1.0]
V = get_vectors(M, p, get_basis(M, p, DefaultOrthonormalBasis()))
cm = sectional_curvature_matrix(M, p, DefaultOrthonormalBasis())
for X in V
    println(exp(M, p, X))
end
```

The flat planes correspond to directions where the matrix changes independently.
In other cases sectional curvature indicates hyperbolic characteristic of a submanifold.

Sectional curvature can be either larger or smaller than entries in the matrix on other planes.
Consider for example the manifold of rotation matrices in four dimensions, and a function that computes plane of maximum curvature using random search.

```{julia}
function max_curvature(M::AbstractManifold, p)
    mc = -Inf
    X = zero_vector(M, p)
    Y = zero_vector(M, p)
    for _ in 1:10000
        X_c = rand(M; vector_at=p)
        Y_c = rand(M; vector_at=p)
        sc = sectional_curvature(M, p, X_c, Y_c)
        if sc > mc
            mc = sc
            X .= X_c
            Y .= Y_c
        end
    end
    return mc, X, Y
end

M = Rotations(4)
p = Matrix(I(4) * 1.0)
println(sectional_curvature_matrix(M, p, DefaultOrthonormalBasis()))
mc, X, Y = max_curvature(M, p)
println(mc)
println(X)
println(Y)
```

In the planes corresponding to orthonormal basis, the maximum sectional curvature is 0.125 but the true upper bound is 0.25.

## Literature

```@bibliography
Pages = ["exploring-curvature.md"]
Canonical=false
```

# Multinomial symmetric positive definite matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/MultinomialSymmetricPositiveDefinite.jl"]
Order = [:type, :function]
```

## Literature

```@bibliography
Pages = ["multinomialsymmetricpositivedefinite.md"]
Canonical=false
```

---
title: Integration
---

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
Pkg.develop(PackageSpec(; path=(@__DIR__) * "/../"))
using Markdown
```

This part of documentation covers integration of scalar functions defined on manifolds $f \colon \mathcal{M} \to ℝ$:

```math
\int_{\mathcal M} f(p) \mathrm{d}p
```

The basic concepts are derived from geometric measure theory.
In principle, there are many ways in which a manifold can be equipped with a measure that can be later used to define an integral.
One of the most popular ways is based on pushing the Lebesgue measure on a tangent space through the exponential map.
Any other suitable atlas could be used, not just the one defined by normal coordinates, though each one requires different volume density corrections due to the Jacobian determinant of the pushforward.
`Manifolds.jl` provides the function [`volume_density`](@ref) that calculates that quantity, denoted $\theta_p(X)$.
See for example [LeBrignantPuechmorel:2019](@cite), Definition 11, for a precise description using Jacobi fields.

While many sources define volume density as a function of two points, `Manifolds.jl` decided to use the more general point-tangent vector formulation. The two-points variant can be implemented as
```{julia}
using Manifolds
volume_density_two_points(M::AbstractManifold, p, q) = volume_density(M, p, log(M, p, q))
```

The simplest way to of integrating a function on a compact manifold is through a [Monte Carlo integrator](https://en.wikipedia.org/wiki/Monte_Carlo_integration).
A simple variant can be implemented as follows (assuming uniform distribution of `rand`):

```{julia}
using LinearAlgebra, Distributions, SpecialFunctions
function simple_mc_integrate(M::AbstractManifold, f; N::Int = 1000)
    V = manifold_volume(M)
    sum = 0.0
    q = rand(M)
    for i in 1:N
        sum += f(M, q)
        rand!(M, q)
    end
    return V * sum/N
end
```

We used the function [`manifold_volume`](@ref) to get the volume of the set over which the integration is performed, as described in the linked Wikipedia article.

## Distributions

We will now try to verify that volume density correction correctly changes probability density of an exponential-wrapped normal distribution.
`pdf_tangent_space` (defined in the next code block) represents probability density of a normally distributed random variable $X_T$ in the tangent space $T_p \mathcal{M}$.
Its probability density (with respect to the Lebesgue measure of the tangent space) is $f_{X_T}\colon T_p \mathcal{M} \to ℝ$.

`pdf_manifold` (defined below) refers to the probability density of the distribution $X_M$ from the tangent space $T_p \mathcal{M}$ wrapped using exponential map on the manifold.
The formula for probability density with respect to pushforward measure of the Lebesgue measure in the tangent space reads
```math
f_{X_M}(q) = \sum_{X \in T_p\mathcal{M}, \exp_p(X)=q} \frac{f_{X_T}(X)}{\theta_p(X)}
```
[`volume_density`](@ref) function calculates the correction $\theta_p(X)$.


```{julia}
function pdf_tangent_space(M::AbstractManifold, p)
    return pdf(MvNormal(zeros(manifold_dimension(M)), 0.2*I), p)
end

function pdf_manifold(M::AbstractManifold, q)
    p = [1.0, 0.0, 0.0]
    X = log(M, p, q)
    Xc = get_coordinates(M, p, X, DefaultOrthonormalBasis())
    vd = abs(volume_density(M, p, X))
    if vd > eps()
        return pdf_tangent_space(M, Xc) / vd
    else
        return 0.0
    end
end

println(simple_mc_integrate(Sphere(2), pdf_manifold; N=1000000))
```

The function `simple_mc_integrate`, defined in the previous section, is used to verify that the density integrates to 1 over the manifold.

Note that our `pdf_manifold` implements a simplified version of $f_{X_M}$ which assumes that the probability mass of `pdf_tangent_space` outside of (local) injectivity radius at $p$ is negligible.
In such case there is only one non-zero summand in the formula for $f_{X_M}(q)$, namely $X=\log_p(q)$.
Otherwise we would have to consider other vectors $Y\in T_p \mathcal{M}$ such that $\exp_p(Y) = q$ in that sum.

Remarkably, exponential-wrapped distributions possess three important qualities [ChevallierLiLuDunson:2022](@cite):

* Densities of $X_M$ are explicit. There is no normalization constant that needs to be computed like in truncated distributions.
* Sampling from $X_M$ is easy. It suffices to get a sample from $X_T$ and pass it to the exponential map.
* If mean of $X_T$ is 0, then there is a simple correspondence between moments of $X_M$ and $X_T$, for example $p$ is the mean of $X_M$.

## Kernel density estimation

We can also make a Pelletier's isotropic kernel density estimator. Given points $p_1, p_2, \dots, p_n$ on $d$-dimensional manifold $\mathcal M$
the density at point $q$ is defined as
```math
f(q) = \frac{1}{n h^d} \sum_{i=1}^n \frac{1}{\theta_q(\log_q(p_i))}K\left( \frac{d(q, p_i)}{h} \right),
```

where $h$ is the bandwidth, a small positive number less than the injectivity radius of $\mathcal M$ and $K\colonℝ\toℝ$ is a kernel function.
Note that Pelletier's estimator can only use radially-symmetric kernels.
The radially symmetric multivariate Epanechnikov kernel used in the example below is described in [LangreneMarin:2019](@cite).

```{julia}
struct PelletierKDE{TM<:AbstractManifold,TPts<:AbstractVector}
    M::TM
    bandwidth::Float64
    pts::TPts
end

(kde::PelletierKDE)(::AbstractManifold, p) = kde(p)
function (kde::PelletierKDE)(p)
    n = length(kde.pts)
    d = manifold_dimension(kde.M)
    sum_kde = 0.0
    function epanechnikov_kernel(x)
        if x < 1
            return gamma(2+d/2) * (1-x^2)/(π^(d/2))
        else
            return 0.0
        end
    end
    for i in 1:n
        X = log(kde.M, p, kde.pts[i])
        Xn = norm(kde.M, p, X)
        sum_kde += epanechnikov_kernel(Xn / kde.bandwidth) / volume_density(kde.M, p, X)
    end
    sum_kde /= n * kde.bandwidth^d
    return sum_kde
end

M = Sphere(2)
pts = rand(M, 8)
kde = PelletierKDE(M, 0.7, pts)
println(simple_mc_integrate(Sphere(2), kde; N=1000000))
println(kde(rand(M)))
```


## Technical notes

This section contains a few technical notes that are relevant to the problem of integration on manifolds but can be freely skipped on the first read of the tutorial.

### Conflicting statements about volume of a manifold

[`manifold_volume`](@ref) and [`volume_density`](@ref) are closely related to each other, though very few sources explore this connection, and some even claiming a certain level of arbitrariness in defining `manifold_volume`.
Volume is sometimes considered arbitrary because Riemannian metrics on some spaces like the manifold of rotations are defined with arbitrary constants.
However, once a constant is picked (and it must be picked before any useful computation can be performed), all geometric operations must follow in a consistent way: inner products, exponential and logarithmic maps, volume densities, etc.
`Manifolds.jl` consistently picks such constants and provides a unified framework, though it sometimes results in picking a different constant than what is the most popular in some sub-communities.

### Haar measures

On Lie groups the situation regarding integration is more complicated.
Invariance under left or right group action is a desired property that leads one to consider Haar measures [Tornier:2020](@cite).
It is, however, unclear what are the practical benefits of considering Haar measures over the Lebesgue measure of the underlying manifold, which often turns out to be invariant anyway.

### Integration in charts

Integration through charts is an approach currently not supported by `Manifolds.jl`.
One has to define a suitable set of disjoint charts covering the entire manifold and use a method for multivariate Euclidean integration.
Note that ranges of parameters have to be adjusted for each manifold and scaling based on the metric needs to be applied.
See [BoyaSudarshanTilma:2003](@cite) for some considerations on symmetric spaces.


## References

## Literature

```@bibliography
Pages = ["integration.md"]
Canonical=false
```

# Flag manifold

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/Flag.jl"]
Order = [:type,:function]
```

## The flag manifold represented as points on the [Stiefel](@ref) manifold

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/FlagStiefel.jl"]
Order = [:type,:function]
```

## The flag manifold represented as orthogonal matrices

```@autodocs
Modules = [Manifolds]
Pages = ["manifolds/FlagOrthogonal.jl"]
Order = [:type,:function]
```
